/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","vs/base/common/extpath","fs","vs/base/common/arrays","vs/base/common/process","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/product/common/product","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryUtils","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],x=function(K){for(var e=[],y=0,L=K.length;y<L;y++)e[y]=Z[K[y]];return e};define(Z[102],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function y(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=y}),define(Z[47],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function y(E){return(n,f,w)=>{let t=null,P=null;if(typeof w.value=="function"?(t="value",P=w.value):typeof w.get=="function"&&(t="get",P=w.get),!P)throw new Error("not supported");w[t]=E(P,f)}}e.createDecorator=y;function L(E,n,f){let w=null,t=null;if(typeof f.value=="function"?(w="value",t=f.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(w="get",t=f.get),!t)throw new Error("not supported");const P=`$memoize$${n}`;f[w]=function(...b){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,b)}),this[P]}}e.memoize=L;function k(E,n,f){return y((w,t)=>{const P=`$debounce$${t}`,b=`$debounce$result$${t}`;return function(...v){this[b]||(this[b]=f?f():void 0),clearTimeout(this[P]),n&&(this[b]=n(this[b],...v),v=[this[b]]),this[P]=setTimeout(()=>{w.apply(this,v),this[b]=f?f():void 0},E)}})}e.debounce=k;function M(E,n,f){return y((w,t)=>{const P=`$throttle$timer$${t}`,b=`$throttle$result$${t}`,v=`$throttle$lastRun$${t}`,d=`$throttle$pending$${t}`;return function(...m){if(this[b]||(this[b]=f?f():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),n&&(this[b]=n(this[b],...m)),this[d])return;const I=this[v]+E;I<=Date.now()?(this[v]=Date.now(),w.apply(this,[this[b]]),this[b]=f?f():void 0):(this[d]=!0,this[P]=setTimeout(()=>{this[d]=!1,this[v]=Date.now(),w.apply(this,[this[b]]),this[b]=f?f():void 0},I-Date.now()))}})}e.throttle=M}),define(Z[17],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(a=>{a(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=y,e.errorHandler=new y;function L(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=L;function k(c){f(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function M(c){f(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=M;function E(c){if(c instanceof Error){let{name:i,message:a}=c;const r=c.stacktrace||c.stack;return{$isError:!0,name:i,message:a,stack:r}}return c}e.transformErrorForSerialization=E;const n="Canceled";function f(c){return c instanceof Error&&c.name===n&&c.message===n}e.isPromiseCanceledError=f;class w extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=w;function t(){const c=new Error(n);return c.name=c.message,c}e.canceled=t;function P(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=P;function b(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=b;function v(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function d(c){const i=new Error(`${c} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function m(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=m;class I extends Error{constructor(i){super("NotImplemented");i&&(this.message=i)}}e.NotImplementedError=I;class p extends Error{constructor(i){super("NotSupported");i&&(this.message=i)}}e.NotSupportedError=p;class u extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=u;function h(c){const i=c;return i instanceof Error&&Array.isArray(i.actions)}e.isErrorWithActions=h;function o(c,i=Object.create(null)){const a=new Error(c);return i.actions&&(a.actions=i.actions),a}e.createErrorWithActions=o}),define(Z[31],x([0,1,17]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(T,R=0){return T[T.length-(1+R)]}e.tail=L;function k(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=k;function M(T,R,O=(z,N)=>z===N){if(T===R)return!0;if(!T||!R||T.length!==R.length)return!1;for(let z=0,N=T.length;z<N;z++)if(!O(T[z],R[z]))return!1;return!0}e.equals=M;function E(T,R,O){let z=0,N=T.length-1;for(;z<=N;){const C=(z+N)/2|0,q=O(T[C],R);if(q<0)z=C+1;else if(q>0)N=C-1;else return C}return-(z+1)}e.binarySearch=E;function n(T,R){let O=0,z=T.length;if(z===0)return 0;for(;O<z;){const N=Math.floor((O+z)/2);R(T[N])?z=N:O=N+1}return O}e.findFirstInSorted=n;function f(T,R,O){if(T=T|0,T>=R.length)throw new TypeError("invalid index");let z=R[Math.floor(R.length*Math.random())],N=[],C=[],q=[];for(let Q of R){const ie=O(Q,z);ie<0?N.push(Q):ie>0?C.push(Q):q.push(Q)}return T<N.length?f(T,N,O):T<N.length+q.length?q[0]:f(T-(N.length+q.length),C,O)}e.quickSelect=f;function w(T,R){const O=[];let z;for(const N of T.slice(0).sort(R))!z||R(z[0],N)!==0?(z=[N],O.push(z)):z.push(N);return O}e.groupBy=w;function t(T,R,O){const z=[];function N(Q,ie,oe){if(ie===0&&oe.length===0)return;const ae=z[z.length-1];ae&&ae.start+ae.deleteCount===Q?(ae.deleteCount+=ie,ae.toInsert.push(...oe)):z.push({start:Q,deleteCount:ie,toInsert:oe})}let C=0,q=0;for(;;){if(C===T.length){N(C,0,R.slice(q));break}if(q===R.length){N(C,T.length-C,[]);break}const Q=T[C],ie=R[q],oe=O(Q,ie);oe===0?(C+=1,q+=1):oe<0?(N(C,1,[]),C+=1):oe>0&&(N(C,0,[ie]),q+=1)}return z}e.sortedDiff=t;function P(T,R,O){const z=t(T,R,O),N=[],C=[];for(const q of z)N.push(...T.slice(q.start,q.start+q.deleteCount)),C.push(...q.toInsert);return{removed:N,added:C}}e.delta=P;function b(T,R,O){if(O===0)return[];const z=T.slice(0,O).sort(R);return d(T,R,z,O,T.length),z}e.top=b;function v(T,R,O,z,N){return O===0?Promise.resolve([]):new Promise((C,q)=>{(async()=>{const Q=T.length,ie=T.slice(0,O).sort(R);for(let oe=O,ae=Math.min(O+z,Q);oe<Q;oe=ae,ae=Math.min(ae+z,Q)){if(oe>O&&await new Promise(ee=>setTimeout(ee)),N&&N.isCancellationRequested)throw(0,y.canceled)();d(T,R,ie,oe,ae)}return ie})().then(C,q)})}e.topAsync=v;function d(T,R,O,z,N){for(const C=O.length;z<N;z++){const q=T[z];if(R(q,O[C-1])<0){O.pop();const Q=n(O,ie=>R(q,ie)<0);O.splice(Q,0,q)}}}function m(T){return T.filter(R=>!!R)}e.coalesce=m;function I(T){let R=0;for(let O=0;O<T.length;O++)T[O]&&(T[R]=T[O],R+=1);T.length=R}e.coalesceInPlace=I;function p(T,R,O){T.splice(O,0,T.splice(R,1)[0])}e.move=p;function u(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=u;function h(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=h;function o(T,R){if(!R)return T.filter((z,N)=>T.indexOf(z)===N);const O=Object.create(null);return T.filter(z=>{const N=R(z);return O[N]?!1:(O[N]=!0,!0)})}e.distinct=o;function c(T){const R=new Set;return T.filter(O=>R.has(O)?!1:(R.add(O),!0))}e.distinctES6=c;function i(T){const R=Object.create(null);return O=>{const z=T(O);return R[z]?!1:(R[z]=!0,!0)}}e.uniqueFilter=i;function a(T,R){for(let O=T.length-1;O>=0;O--){const z=T[O];if(R(z))return O}return-1}e.lastIndex=a;function r(T,R){return T.length>0?T[0]:R}e.firstOrDefault=r;function s(T,R,O=(z,N)=>z===N){let z=0;for(let N=0,C=Math.min(T.length,R.length);N<C&&O(T[N],R[N]);N++)z++;return z}e.commonPrefixLength=s;function l(T){return[].concat(...T)}e.flatten=l;function g(T,R){let O=typeof R=="number"?T:0;typeof R=="number"?O=T:(O=0,R=T);const z=[];if(O<=R)for(let N=O;N<R;N++)z.push(N);else for(let N=O;N>R;N--)z.push(N);return z}e.range=g;function S(T,R,O){return T.reduce((z,N)=>(z[R(N)]=O?O(N):N,z),Object.create(null))}e.index=S;function D(T,R){return T.push(R),()=>A(T,R)}e.insert=D;function A(T,R){const O=T.indexOf(R);if(O>-1)return T.splice(O,1),R}e.remove=A;function F(T,R,O){const z=T.slice(0,R),N=T.slice(R);return z.concat(O,N)}e.arrayInsert=F;function U(T,R){let O;if(typeof R=="number"){let z=R;O=()=>{const N=Math.sin(z++)*179426549;return N-Math.floor(N)}}else O=Math.random;for(let z=T.length-1;z>0;z-=1){const N=Math.floor(O()*(z+1)),C=T[z];T[z]=T[N],T[N]=C}}e.shuffle=U;function X(T,R){const O=T.indexOf(R);O>-1&&(T.splice(O,1),T.unshift(R))}e.pushToStart=X;function ne(T,R){const O=T.indexOf(R);O>-1&&(T.splice(O,1),T.push(R))}e.pushToEnd=ne;function se(T,R){return Array.isArray(T)?T.map(R):R(T)}e.mapArrayOrNot=se;function G(T){return Array.isArray(T)?T:[T]}e.asArray=G;function J(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=J;function W(T,R){for(const O of T){const z=R(O);if(z!==void 0)return z}}e.mapFind=W;function V(T,R,O){const z=$(T,R),N=T.length,C=O.length;T.length=N+C;for(let q=N-1;q>=z;q--)T[q+C]=T[q];for(let q=0;q<C;q++)T[q+z]=O[q]}e.insertInto=V;function B(T,R,O,z){const N=$(T,R),C=T.splice(N,O);return V(T,N,z),C}e.splice=B;function $(T,R){return R<0?Math.max(R+T.length,0):Math.min(R,T.length)}function H(T,R){let O=Number.MAX_SAFE_INTEGER,z=0;return T.forEach((N,C)=>{const q=R(N);q<O&&(O=q,z=C)}),z}e.minIndex=H;function _(T,R){let O=Number.MIN_SAFE_INTEGER,z=0;return T.forEach((N,C)=>{const q=R(N);q>O&&(O=q,z=C)}),z}e.maxIndex=_;class j{constructor(R){this.items=R,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(R){let O=this.firstIdx;for(;O<this.items.length&&R(this.items[O]);)O++;const z=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,z}takeFromEndWhile(R){let O=this.lastIdx;for(;O>=0&&R(this.items[O]);)O--;const z=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,z}}e.ArrayQueue=j}),define(Z[43],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function y(L){const k=this;let M=!1,E;return function(){return M||(M=!0,E=L.apply(k,arguments)),E}}e.once=y}),define(Z[63],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(L){function k(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}L.is=k;const M=Object.freeze([]);function E(){return M}L.empty=E;function*n(c){yield c}L.single=n;function f(c){return c||M}L.from=f;function w(c){return!c||c[Symbol.iterator]().next().done===!0}L.isEmpty=w;function t(c){return c[Symbol.iterator]().next().value}L.first=t;function P(c,i){for(const a of c)if(i(a))return!0;return!1}L.some=P;function b(c,i){for(const a of c)if(i(a))return a}L.find=b;function*v(c,i){for(const a of c)i(a)&&(yield a)}L.filter=v;function*d(c,i){let a=0;for(const r of c)yield i(r,a++)}L.map=d;function*m(...c){for(const i of c)for(const a of i)yield a}L.concat=m;function*I(c){for(const i of c)for(const a of i)yield a}L.concatNested=I;function p(c,i,a){let r=a;for(const s of c)r=i(r,s);return r}L.reduce=p;function*u(c,i,a=c.length){for(i<0&&(i+=c.length),a<0?a+=c.length:a>c.length&&(a=c.length);i<a;i++)yield c[i]}L.slice=u;function h(c,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,c];const r=c[Symbol.iterator]();for(let s=0;s<i;s++){const l=r.next();if(l.done)return[a,L.empty()];a.push(l.value)}return[a,{[Symbol.iterator](){return r}}]}L.consume=h;function o(c,i,a=(r,s)=>r===s){const r=c[Symbol.iterator](),s=i[Symbol.iterator]();for(;;){const l=r.next(),g=s.next();if(l.done!==g.done)return!1;if(l.done)return!0;if(!a(l.value,g.value))return!1}}L.equals=o})(y=e.Iterable||(e.Iterable={}))}),define(Z[40],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(y=e.ScanError||(e.ScanError={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function E(i,a=!1){let r=0,s=i.length,l="",g=0,S=16,D=0;function A(J){let W=0,V=0;for(;W<J;){const B=i.charCodeAt(r);if(B>=48&&B<=57)V=V*16+B-48;else if(B>=65&&B<=70)V=V*16+B-65+10;else if(B>=97&&B<=102)V=V*16+B-97+10;else break;r++,W++}return W<J&&(V=-1),V}function F(J){r=J,l="",g=0,S=16,D=0}function U(){const J=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&w(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&w(i.charCodeAt(r)))for(r++;r<i.length&&w(i.charCodeAt(r));)r++;else return D=3,i.substring(J,r);let W=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&w(i.charCodeAt(r))){for(r++;r<i.length&&w(i.charCodeAt(r));)r++;W=r}else D=3;return i.substring(J,W)}function X(){let J="",W=r;for(;;){if(r>=s){J+=i.substring(W,r),D=2;break}const V=i.charCodeAt(r);if(V===34){J+=i.substring(W,r),r++;break}if(V===92){if(J+=i.substring(W,r),r++,r>=s){D=2;break}switch(i.charCodeAt(r++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:const $=A(4);$>=0?J+=String.fromCharCode($):D=4;break;default:D=5}W=r;continue}if(V>=0&&V<=31)if(f(V)){J+=i.substring(W,r),D=2;break}else D=6;r++}return J}function ne(){if(l="",D=0,g=r,r>=s)return g=s,S=17;let J=i.charCodeAt(r);if(n(J)){do r++,l+=String.fromCharCode(J),J=i.charCodeAt(r);while(n(J));return S=15}if(f(J))return r++,l+=String.fromCharCode(J),J===13&&i.charCodeAt(r)===10&&(r++,l+=`
`),S=14;switch(J){case 123:return r++,S=1;case 125:return r++,S=2;case 91:return r++,S=3;case 93:return r++,S=4;case 58:return r++,S=6;case 44:return r++,S=5;case 34:return r++,l=X(),S=10;case 47:const W=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<s&&!f(i.charCodeAt(r));)r++;return l=i.substring(W,r),S=12}if(i.charCodeAt(r+1)===42){r+=2;const V=s-1;let B=!1;for(;r<V;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,B=!0;break}r++}return B||(r++,D=1),l=i.substring(W,r),S=13}return l+=String.fromCharCode(J),r++,S=16;case 45:if(l+=String.fromCharCode(J),r++,r===s||!w(i.charCodeAt(r)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=U(),S=11;default:for(;r<s&&se(J);)r++,J=i.charCodeAt(r);if(g!==r){switch(l=i.substring(g,r),l){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return l+=String.fromCharCode(J),r++,S=16}}function se(J){if(n(J)||f(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let J;do J=ne();while(J>=12&&J<=15);return J}return{setPosition:F,getPosition:()=>r,scan:a?G:ne,getToken:()=>S,getTokenValue:()=>l,getTokenOffset:()=>g,getTokenLength:()=>r-g,getTokenError:()=>D}}e.createScanner=E;function n(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function P(i,a){const r=[],s=new Object;let l;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function D(A,F,U,X){g.value=A,g.offset=F,g.length=U,g.type=X,g.colonOffset=void 0,l=g}try{h(i,{onObjectBegin:(A,F)=>{if(a<=A)throw s;l=void 0,S=a>A,r.push("")},onObjectProperty:(A,F,U)=>{if(a<F||(D(A,F,U,"property"),r[r.length-1]=A,a<=F+U))throw s},onObjectEnd:(A,F)=>{if(a<=A)throw s;l=void 0,r.pop()},onArrayBegin:(A,F)=>{if(a<=A)throw s;l=void 0,r.push(0)},onArrayEnd:(A,F)=>{if(a<=A)throw s;l=void 0,r.pop()},onLiteralValue:(A,F,U)=>{if(a<F||(D(A,F,U,c(A)),a<=F+U))throw s},onSeparator:(A,F,U)=>{if(a<=F)throw s;if(A===":"&&l&&l.type==="property")l.colonOffset=F,S=!1,l=void 0;else if(A===","){const X=r[r.length-1];typeof X=="number"?r[r.length-1]=X+1:(S=!0,r[r.length-1]=""),l=void 0}}})}catch(A){if(A!==s)throw A}return{path:r,previousNode:l,isAtPropertyKey:S,matches:A=>{let F=0;for(let U=0;F<A.length&&U<r.length;U++)if(A[F]===r[U]||A[F]==="*")F++;else if(A[F]!=="**")return!1;return F===A.length}}}e.getLocation=P;function b(i,a=[],r=M.DEFAULT){let s=null,l=[];const g=[];function S(A){Array.isArray(l)?l.push(A):s!==null&&(l[s]=A)}return h(i,{onObjectBegin:()=>{const A={};S(A),g.push(l),l=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{l=g.pop()},onArrayBegin:()=>{const A=[];S(A),g.push(l),l=A,s=null},onArrayEnd:()=>{l=g.pop()},onLiteralValue:S,onError:(A,F,U)=>{a.push({error:A,offset:F,length:U})}},r),l[0]}e.parse=b;function v(i,a=[],r=M.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(A){s.type==="property"&&(s.length=A-s.offset,s=s.parent)}function g(A){return s.children.push(A),A}h(i,{onObjectBegin:A=>{s=g({type:"object",offset:A,length:-1,parent:s,children:[]})},onObjectProperty:(A,F,U)=>{s=g({type:"property",offset:F,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:A,offset:F,length:U,parent:s})},onObjectEnd:(A,F)=>{s.length=A+F-s.offset,s=s.parent,l(A+F)},onArrayBegin:(A,F)=>{s=g({type:"array",offset:A,length:-1,parent:s,children:[]})},onArrayEnd:(A,F)=>{s.length=A+F-s.offset,s=s.parent,l(A+F)},onLiteralValue:(A,F,U)=>{g({type:c(A),offset:F,length:U,parent:s,value:A}),l(F+U)},onSeparator:(A,F,U)=>{s.type==="property"&&(A===":"?s.colonOffset=F:A===","&&l(F))},onError:(A,F,U)=>{a.push({error:A,offset:F,length:U})}},r);const D=s.children[0];return D&&delete D.parent,D}e.parseTree=v;function d(i,a){if(!i)return;let r=i;for(let s of a)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const g of r.children)if(Array.isArray(g.children)&&g.children[0].value===s){r=g.children[1],l=!0;break}if(!l)return}else{const l=s;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=d;function m(i){if(!i.parent||!i.parent.children)return[];const a=m(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;a.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&a.push(r)}return a}e.getNodePath=m;function I(i){switch(i.type){case"array":return i.children.map(I);case"object":const a=Object.create(null);for(let r of i.children){const s=r.children[1];s&&(a[r.children[0].value]=I(s))}return a;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=I;function p(i,a,r=!1){return a>=i.offset&&a<i.offset+i.length||r&&a===i.offset+i.length}e.contains=p;function u(i,a,r=!1){if(p(i,a,r)){const s=i.children;if(Array.isArray(s))for(let l=0;l<s.length&&s[l].offset<=a;l++){const g=u(s[l],a,r);if(g)return g}return i}}e.findNodeAtOffset=u;function h(i,a,r=M.DEFAULT){const s=E(i,!1);function l(O){return O?()=>O(s.getTokenOffset(),s.getTokenLength()):()=>!0}function g(O){return O?z=>O(z,s.getTokenOffset(),s.getTokenLength()):()=>!0}const S=l(a.onObjectBegin),D=g(a.onObjectProperty),A=l(a.onObjectEnd),F=l(a.onArrayBegin),U=l(a.onArrayEnd),X=g(a.onLiteralValue),ne=g(a.onSeparator),se=l(a.onComment),G=g(a.onError),J=r&&r.disallowComments,W=r&&r.allowTrailingComma;function V(){for(;;){const O=s.scan();switch(s.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:J||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(O){case 12:case 13:J?B(10):se();break;case 16:B(1);break;case 15:case 14:break;default:return O}}}function B(O,z=[],N=[]){if(G(O),z.length+N.length>0){let C=s.getToken();for(;C!==17;){if(z.indexOf(C)!==-1){V();break}else if(N.indexOf(C)!==-1)break;C=V()}}}function $(O){const z=s.getTokenValue();return O?X(z):D(z),V(),!0}function H(){switch(s.getToken()){case 11:let O=0;try{O=JSON.parse(s.getTokenValue()),typeof O!="number"&&(B(2),O=0)}catch(z){B(2)}X(O);break;case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return V(),!0}function _(){return s.getToken()!==10?(B(3,[],[2,5]),!1):($(!1),s.getToken()===6?(ne(":"),V(),R()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function j(){S(),V();let O=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(O||B(4,[],[]),ne(","),V(),s.getToken()===2&&W)break}else O&&B(6,[],[]);_()||B(4,[],[2,5]),O=!0}return A(),s.getToken()!==2?B(7,[2],[]):V(),!0}function T(){F(),V();let O=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(O||B(4,[],[]),ne(","),V(),s.getToken()===4&&W)break}else O&&B(6,[],[]);R()||B(4,[],[4,5]),O=!0}return U(),s.getToken()!==4?B(8,[4],[]):V(),!0}function R(){switch(s.getToken()){case 3:return T();case 1:return j();case 10:return $(!0);default:return H()}}return V(),s.getToken()===17?r.allowEmptyContent?!0:(B(4,[],[]),!1):R()?(s.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=h;function o(i,a){let r=E(i),s=[],l,g=0,S;do switch(S=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:g!==S&&s.push(i.substring(g,S)),a!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,a)),g=r.getPosition();break}while(l!==17);return s.join("")}e.stripComments=o;function c(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Z[103],x([0,1,40]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(f,w,t){let P,b,v,d,m;if(w){for(d=w.offset,m=d+w.length,v=d;v>0&&!n(f,v-1);)v--;let g=m;for(;g<f.length&&!n(f,g);)g++;b=f.substring(v,g),P=M(b,t)}else b=f,P=0,v=0,d=0,m=f.length;const I=E(t,f);let p=!1,u=0,h;t.insertSpaces?h=k(" ",t.tabSize||4):h="	";const o=(0,y.createScanner)(b,!1);let c=!1;function i(){return I+k(h,P+u)}function a(){let g=o.scan();for(p=!1;g===15||g===14;)p=p||g===14,g=o.scan();return c=g===16||o.getTokenError()!==0,g}const r=[];function s(g,S,D){!c&&S<m&&D>d&&f.substring(S,D)!==g&&r.push({offset:S,length:D-S,content:g})}let l=a();if(l!==17){const g=o.getTokenOffset()+v,S=k(h,P);s(S,v,g)}for(;l!==17;){let g=o.getTokenOffset()+o.getTokenLength()+v,S=a(),D="";for(;!p&&(S===12||S===13);){const F=o.getTokenOffset()+v;s(" ",g,F),g=o.getTokenOffset()+o.getTokenLength()+v,D=S===12?i():"",S=a()}if(S===2)l!==1&&(u--,D=i());else if(S===4)l!==3&&(u--,D=i());else{switch(l){case 3:case 1:u++,D=i();break;case 5:case 12:D=i();break;case 13:p?D=i():D=" ";break;case 6:D=" ";break;case 10:if(S===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?D=" ":S!==5&&S!==17&&(c=!0);break;case 16:c=!0;break}p&&(S===12||S===13)&&(D=i())}const A=o.getTokenOffset()+v;s(D,g,A),l=S}return r}e.format=L;function k(f,w){let t="";for(let P=0;P<w;P++)t+=f;return t}function M(f,w){let t=0,P=0;const b=w.tabSize||4;for(;t<f.length;){const v=f.charAt(t);if(v===" ")P++;else if(v==="	")P+=b;else break;t++}return Math.floor(P/b)}function E(f,w){for(let t=0;t<w.length;t++){const P=w.charAt(t);if(P==="\r")return t+1<w.length&&w.charAt(t+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=E;function n(f,w){return`\r
`.indexOf(f.charAt(w))!==-1}e.isEOL=n}),define(Z[77],x([0,1,40,103]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(w,t,P){return M(w,t,void 0,P)}e.removeProperty=k;function M(w,t,P,b,v){const d=t.slice(),m=[],I=(0,y.parseTree)(w,m);let p,u;for(;d.length>0&&(u=d.pop(),p=(0,y.findNodeAtLocation)(I,d),p===void 0&&P!==void 0);)typeof u=="string"?P={[u]:P}:P=[P];if(p)if(p.type==="object"&&typeof u=="string"&&Array.isArray(p.children)){const h=(0,y.findNodeAtLocation)(p,[u]);if(h!==void 0)if(P===void 0){if(!h.parent)throw new Error("Malformed AST");const o=p.children.indexOf(h.parent);let c,i=h.parent.offset+h.parent.length;if(o>0){const a=p.children[o-1];c=a.offset+a.length}else c=p.offset+1,p.children.length>1&&(i=p.children[1].offset);return E(w,{offset:c,length:i-c,content:""},b)}else return E(w,{offset:h.offset,length:h.length,content:JSON.stringify(P)},b);else{if(P===void 0)return[];const o=`${JSON.stringify(u)}: ${JSON.stringify(P)}`,c=v?v(p.children.map(a=>a.children[0].value)):p.children.length;let i;if(c>0){const a=p.children[c-1];i={offset:a.offset+a.length,length:0,content:","+o}}else p.children.length===0?i={offset:p.offset+1,length:0,content:o}:i={offset:p.offset+1,length:0,content:o+","};return E(w,i,b)}}else if(p.type==="array"&&typeof u=="number"&&Array.isArray(p.children))if(P!==void 0){const h=`${JSON.stringify(P)}`;let o;if(p.children.length===0||u===0)o={offset:p.offset+1,length:0,content:p.children.length===0?h:h+","};else{const c=u===-1||u>p.children.length?p.children.length:u,i=p.children[c-1];o={offset:i.offset+i.length,length:0,content:","+h}}return E(w,o,b)}else{const h=u,o=p.children[h];let c;if(p.children.length===1)c={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===h){const i=p.children[h-1],a=i.offset+i.length,r=p.offset+p.length;c={offset:a,length:r-2-a,content:""}}else c={offset:o.offset,length:p.children[h+1].offset-o.offset,content:""};return E(w,c,b)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${p.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return E(w,{offset:I?I.offset:0,length:I?I.length:0,content:JSON.stringify(P)},b)}}e.setProperty=M;function E(w,t,P){let b=n(w,t),v=t.offset,d=t.offset+t.content.length;if(t.length===0||t.content.length===0){for(;v>0&&!(0,L.isEOL)(b,v-1);)v--;for(;d<b.length&&!(0,L.isEOL)(b,d);)d++}const m=(0,L.format)(b,{offset:v,length:d-v},P);for(let p=m.length-1;p>=0;p--){const u=m[p];b=n(b,u),v=Math.min(v,u.offset),d=Math.max(d,u.offset+u.length),d+=u.content.length-u.length}const I=w.length-(b.length-d)-v;return[{offset:v,length:I,content:b.substring(v,d)}]}e.withFormatting=E;function n(w,t){return w.substring(0,t.offset)+t.content+w.substring(t.offset+t.length)}e.applyEdit=n;function f(w,t){let P=t.slice(0).sort((v,d)=>{const m=v.offset-d.offset;return m===0?v.length-d.length:m}),b=w.length;for(let v=P.length-1;v>=0;v--){let d=P[v];if(d.offset+d.length<=b)w=n(w,d);else throw new Error("Overlapping edit");b=d.offset}return w}e.applyEdits=f}),define(Z[57],x([0,1,17]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(u){u[u.DependsOnKbLayout=-1]="DependsOnKbLayout",u[u.Unknown=0]="Unknown",u[u.Backspace=1]="Backspace",u[u.Tab=2]="Tab",u[u.Enter=3]="Enter",u[u.Shift=4]="Shift",u[u.Ctrl=5]="Ctrl",u[u.Alt=6]="Alt",u[u.PauseBreak=7]="PauseBreak",u[u.CapsLock=8]="CapsLock",u[u.Escape=9]="Escape",u[u.Space=10]="Space",u[u.PageUp=11]="PageUp",u[u.PageDown=12]="PageDown",u[u.End=13]="End",u[u.Home=14]="Home",u[u.LeftArrow=15]="LeftArrow",u[u.UpArrow=16]="UpArrow",u[u.RightArrow=17]="RightArrow",u[u.DownArrow=18]="DownArrow",u[u.Insert=19]="Insert",u[u.Delete=20]="Delete",u[u.KEY_0=21]="KEY_0",u[u.KEY_1=22]="KEY_1",u[u.KEY_2=23]="KEY_2",u[u.KEY_3=24]="KEY_3",u[u.KEY_4=25]="KEY_4",u[u.KEY_5=26]="KEY_5",u[u.KEY_6=27]="KEY_6",u[u.KEY_7=28]="KEY_7",u[u.KEY_8=29]="KEY_8",u[u.KEY_9=30]="KEY_9",u[u.KEY_A=31]="KEY_A",u[u.KEY_B=32]="KEY_B",u[u.KEY_C=33]="KEY_C",u[u.KEY_D=34]="KEY_D",u[u.KEY_E=35]="KEY_E",u[u.KEY_F=36]="KEY_F",u[u.KEY_G=37]="KEY_G",u[u.KEY_H=38]="KEY_H",u[u.KEY_I=39]="KEY_I",u[u.KEY_J=40]="KEY_J",u[u.KEY_K=41]="KEY_K",u[u.KEY_L=42]="KEY_L",u[u.KEY_M=43]="KEY_M",u[u.KEY_N=44]="KEY_N",u[u.KEY_O=45]="KEY_O",u[u.KEY_P=46]="KEY_P",u[u.KEY_Q=47]="KEY_Q",u[u.KEY_R=48]="KEY_R",u[u.KEY_S=49]="KEY_S",u[u.KEY_T=50]="KEY_T",u[u.KEY_U=51]="KEY_U",u[u.KEY_V=52]="KEY_V",u[u.KEY_W=53]="KEY_W",u[u.KEY_X=54]="KEY_X",u[u.KEY_Y=55]="KEY_Y",u[u.KEY_Z=56]="KEY_Z",u[u.Meta=57]="Meta",u[u.ContextMenu=58]="ContextMenu",u[u.F1=59]="F1",u[u.F2=60]="F2",u[u.F3=61]="F3",u[u.F4=62]="F4",u[u.F5=63]="F5",u[u.F6=64]="F6",u[u.F7=65]="F7",u[u.F8=66]="F8",u[u.F9=67]="F9",u[u.F10=68]="F10",u[u.F11=69]="F11",u[u.F12=70]="F12",u[u.F13=71]="F13",u[u.F14=72]="F14",u[u.F15=73]="F15",u[u.F16=74]="F16",u[u.F17=75]="F17",u[u.F18=76]="F18",u[u.F19=77]="F19",u[u.NumLock=78]="NumLock",u[u.ScrollLock=79]="ScrollLock",u[u.US_SEMICOLON=80]="US_SEMICOLON",u[u.US_EQUAL=81]="US_EQUAL",u[u.US_COMMA=82]="US_COMMA",u[u.US_MINUS=83]="US_MINUS",u[u.US_DOT=84]="US_DOT",u[u.US_SLASH=85]="US_SLASH",u[u.US_BACKTICK=86]="US_BACKTICK",u[u.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",u[u.US_BACKSLASH=88]="US_BACKSLASH",u[u.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",u[u.US_QUOTE=90]="US_QUOTE",u[u.OEM_8=91]="OEM_8",u[u.OEM_102=92]="OEM_102",u[u.NUMPAD_0=93]="NUMPAD_0",u[u.NUMPAD_1=94]="NUMPAD_1",u[u.NUMPAD_2=95]="NUMPAD_2",u[u.NUMPAD_3=96]="NUMPAD_3",u[u.NUMPAD_4=97]="NUMPAD_4",u[u.NUMPAD_5=98]="NUMPAD_5",u[u.NUMPAD_6=99]="NUMPAD_6",u[u.NUMPAD_7=100]="NUMPAD_7",u[u.NUMPAD_8=101]="NUMPAD_8",u[u.NUMPAD_9=102]="NUMPAD_9",u[u.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",u[u.NUMPAD_ADD=104]="NUMPAD_ADD",u[u.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",u[u.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",u[u.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",u[u.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",u[u.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",u[u.ABNT_C1=110]="ABNT_C1",u[u.ABNT_C2=111]="ABNT_C2",u[u.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class k{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,o){this._keyCodeToStr[h]=o,this._strToKeyCode[o.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const M=new k,E=new k,n=new k;(function(){function u(h,o,c=o,i=c){M.define(h,o),E.define(h,c),n.define(h,i)}u(0,"unknown"),u(1,"Backspace"),u(2,"Tab"),u(3,"Enter"),u(4,"Shift"),u(5,"Ctrl"),u(6,"Alt"),u(7,"PauseBreak"),u(8,"CapsLock"),u(9,"Escape"),u(10,"Space"),u(11,"PageUp"),u(12,"PageDown"),u(13,"End"),u(14,"Home"),u(15,"LeftArrow","Left"),u(16,"UpArrow","Up"),u(17,"RightArrow","Right"),u(18,"DownArrow","Down"),u(19,"Insert"),u(20,"Delete"),u(21,"0"),u(22,"1"),u(23,"2"),u(24,"3"),u(25,"4"),u(26,"5"),u(27,"6"),u(28,"7"),u(29,"8"),u(30,"9"),u(31,"A"),u(32,"B"),u(33,"C"),u(34,"D"),u(35,"E"),u(36,"F"),u(37,"G"),u(38,"H"),u(39,"I"),u(40,"J"),u(41,"K"),u(42,"L"),u(43,"M"),u(44,"N"),u(45,"O"),u(46,"P"),u(47,"Q"),u(48,"R"),u(49,"S"),u(50,"T"),u(51,"U"),u(52,"V"),u(53,"W"),u(54,"X"),u(55,"Y"),u(56,"Z"),u(57,"Meta"),u(58,"ContextMenu"),u(59,"F1"),u(60,"F2"),u(61,"F3"),u(62,"F4"),u(63,"F5"),u(64,"F6"),u(65,"F7"),u(66,"F8"),u(67,"F9"),u(68,"F10"),u(69,"F11"),u(70,"F12"),u(71,"F13"),u(72,"F14"),u(73,"F15"),u(74,"F16"),u(75,"F17"),u(76,"F18"),u(77,"F19"),u(78,"NumLock"),u(79,"ScrollLock"),u(80,";",";","OEM_1"),u(81,"=","=","OEM_PLUS"),u(82,",",",","OEM_COMMA"),u(83,"-","-","OEM_MINUS"),u(84,".",".","OEM_PERIOD"),u(85,"/","/","OEM_2"),u(86,"`","`","OEM_3"),u(110,"ABNT_C1"),u(111,"ABNT_C2"),u(87,"[","[","OEM_4"),u(88,"\\","\\","OEM_5"),u(89,"]","]","OEM_6"),u(90,"'","'","OEM_7"),u(91,"OEM_8"),u(92,"OEM_102"),u(93,"NumPad0"),u(94,"NumPad1"),u(95,"NumPad2"),u(96,"NumPad3"),u(97,"NumPad4"),u(98,"NumPad5"),u(99,"NumPad6"),u(100,"NumPad7"),u(101,"NumPad8"),u(102,"NumPad9"),u(103,"NumPad_Multiply"),u(104,"NumPad_Add"),u(105,"NumPad_Separator"),u(106,"NumPad_Subtract"),u(107,"NumPad_Decimal"),u(108,"NumPad_Divide")})();var f;(function(u){function h(r){return M.keyCodeToStr(r)}u.toString=h;function o(r){return M.strToKeyCode(r)}u.fromString=o;function c(r){return E.keyCodeToStr(r)}u.toUserSettingsUS=c;function i(r){return n.keyCodeToStr(r)}u.toUserSettingsGeneral=i;function a(r){return E.strToKeyCode(r)||n.strToKeyCode(r)}u.fromUserSettings=a})(f=e.KeyCodeUtils||(e.KeyCodeUtils={}));var w;(function(u){u[u.CtrlCmd=2048]="CtrlCmd",u[u.Shift=1024]="Shift",u[u.Alt=512]="Alt",u[u.WinCtrl=256]="WinCtrl",u[u.KeyCode=255]="KeyCode"})(w||(w={}));var t;(function(u){u[u.CtrlCmd=2048]="CtrlCmd",u[u.Shift=1024]="Shift",u[u.Alt=512]="Alt",u[u.WinCtrl=256]="WinCtrl"})(t=e.KeyMod||(e.KeyMod={}));function P(u,h){const o=(h&65535)<<16>>>0;return(u|o)>>>0}e.KeyChord=P;function b(u,h){if(u===0)return null;const o=(u&65535)>>>0,c=(u&4294901760)>>>16;return c!==0?new m([v(o,h),v(c,h)]):new m([v(o,h)])}e.createKeybinding=b;function v(u,h){const o=!!(u&2048),c=!!(u&256),i=h===2?c:o,a=!!(u&1024),r=!!(u&512),s=h===2?o:c,l=u&255;return new d(i,a,r,s,l)}e.createSimpleKeybinding=v;class d{constructor(h,o,c,i,a){this.ctrlKey=h,this.shiftKey=o,this.altKey=c,this.metaKey=i,this.keyCode=a}equals(h){return this.ctrlKey===h.ctrlKey&&this.shiftKey===h.shiftKey&&this.altKey===h.altKey&&this.metaKey===h.metaKey&&this.keyCode===h.keyCode}getHashCode(){const h=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",c=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`${h}${o}${c}${i}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class m{constructor(h){if(h.length===0)throw(0,y.illegalArgument)("parts");this.parts=h}getHashCode(){let h="";for(let o=0,c=this.parts.length;o<c;o++)o!==0&&(h+=";"),h+=this.parts[o].getHashCode();return h}equals(h){if(h===null||this.parts.length!==h.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(h.parts[o]))return!1;return!0}}e.ChordKeybinding=m;class I{constructor(h,o,c,i,a,r){this.ctrlKey=h,this.shiftKey=o,this.altKey=c,this.metaKey=i,this.keyLabel=a,this.keyAriaLabel=r}}e.ResolvedKeybindingPart=I;class p{}e.ResolvedKeybinding=p}),define(Z[2],x([0,1,43,63]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let M=null;function E(r){M=r}if(e.setDisposableTracker=E,k){const r="__is_disposable_tracked__";E(new class{trackDisposable(s){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[r]||console.log(l)},3e3)}setParent(s,l){if(s&&s!==u.None)try{s[r]=!0}catch{}}markAsDisposed(s){if(s&&s!==u.None)try{s[r]=!0}catch{}}markAsSingleton(s){}})}function n(r){return M?.trackDisposable(r),r}function f(r){M?.markAsDisposed(r)}function w(r,s){M?.setParent(r,s)}function t(r,s){if(!!M)for(const l of r)M.setParent(l,s)}function P(r){return M?.markAsSingleton(r),r}e.markAsSingleton=P;class b extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=b;function v(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=v;function d(r){if(L.Iterable.is(r)){let s=[];for(const l of r)if(l)try{l.dispose()}catch(g){s.push(g)}if(s.length===1)throw s[0];if(s.length>1)throw new b(s);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=d;function m(...r){const s=I(()=>d(r));return t(r,s),s}e.combinedDisposable=m;function I(r){const s=n({dispose:(0,y.once)(()=>{f(s),r()})});return s}e.toDisposable=I;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,n(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return w(s,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new p,n(this),w(this._store,this)}dispose(){f(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,n(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&w(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&w(s,null),s}}e.MutableDisposable=h;class o{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class c{constructor(){this.references=new Map}acquire(s,...l){let g=this.references.get(s);g||(g={counter:0,object:this.createReferencedObject(s,...l)},this.references.set(s,g));const{object:S}=g,D=(0,y.once)(()=>{--g.counter==0&&(this.destroyReferencedObject(s,g.object),this.references.delete(s))});return g.counter++,{object:S,dispose:D}}}e.ReferenceCollection=c;class i{constructor(s){this.referenceCollection=s}async acquire(s,...l){const g=this.referenceCollection.acquire(s,...l);try{return{object:await g.object,dispose:()=>g.dispose()}}catch(S){throw g.dispose(),S}}}e.AsyncReferenceCollection=i;class a{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=a}),define(Z[104],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class y{constructor(M){this.element=M,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class L{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){let M=this._first;for(;M!==y.Undefined;){const E=M.next;M.prev=y.Undefined,M.next=y.Undefined,M=E}this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,E){const n=new y(M);if(this._first===y.Undefined)this._first=n,this._last=n;else if(E){const w=this._last;this._last=n,n.prev=w,w.next=n}else{const w=this._first;this._first=n,n.next=w,w.prev=n}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(n))}}shift(){if(this._first!==y.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==y.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==y.Undefined&&M.next!==y.Undefined){const E=M.prev;E.next=M.next,M.next.prev=E}else M.prev===y.Undefined&&M.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):M.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):M.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==y.Undefined;)yield M.element,M=M.next}}e.LinkedList=L}),function(){function K(k){const M=[];typeof k=="number"&&M.push("code/timeOrigin",k);function E(f){M.push(f,Date.now())}function n(){const f=[];for(let w=0;w<M.length;w+=2)f.push({name:M[w],startTime:M[w+1]});return f}return{mark:E,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const E of performance.getEntriesByType("mark"))M.push({name:E.name,startTime:Math.round(k+E.startTime)});return M}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function y(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=y(L))}(),define(Z[3],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const y="en";let L=!1,k=!1,M=!1,E=!1,n=!1,f=!1,w=!1,t,P=y,b,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const m=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=m&&d?.sandboxed,typeof navigator=="object"&&!m)v=navigator.userAgent,L=v.indexOf("Windows")>=0,k=v.indexOf("Macintosh")>=0,w=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=v.indexOf("Linux")>=0,f=!0,t=navigator.language,P=t;else if(typeof d=="object"){L=d.platform==="win32",k=d.platform==="darwin",M=d.platform==="linux",E=M&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,t=y,P=y;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const s=JSON.parse(r),l=s.availableLanguages["*"];t=s.locale,P=l||y,b=s._translationsConfigFile}catch(s){}n=!0}else console.error("Unable to resolve platform.");var I;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function p(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let u=0;k?u=1:L?u=3:M&&(u=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=M,e.isLinuxSnap=E,e.isNative=n,e.isWeb=f,e.isIOS=w,e.platform=u,e.userAgent=v,e.language=P;var h;(function(r){function s(){return e.language}r.value=s;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=l;function g(){return e.language==="en"}r.isDefault=g})(h=e.Language||(e.Language={})),e.locale=t,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let D=0,A=l.length;D<A;D++){const F=l[D];if(F.id===S.data.vscodeSetImmediateId){l.splice(D,1),F.callback();return}}});let g=0;return S=>{const D=++g;l.push({id:D,callback:S}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const s=Promise.resolve();return l=>s.then(l)}();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||w?2:L?1:3;let c=!0,i=!1;function a(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,c=new Uint16Array(r.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=a}),define(Z[32],x([0,1,3]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof y.globals.vscode!="undefined"&&typeof y.globals.vscode.process!="undefined"){const k=y.globals.vscode.process;L={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()},nextTick(M){return(0,y.setImmediate)(M)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},get arch(){},nextTick(k){return(0,y.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(Z[8],x([0,1,32]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,M=90,E=122,n=46,f=47,w=92,t=58,P=63;class b extends Error{constructor(o,c,i){let a;typeof c=="string"&&c.indexOf("not ")===0?(a="must not be",c=c.replace(/^not /,"")):a="must be";const r=o.indexOf(".")!==-1?"property":"argument";let s=`The "${o}" ${r} ${a} of type ${c}`;s+=`. Received type ${typeof i}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function v(h,o){if(typeof h!="string")throw new b(o,"string",h)}function d(h){return h===f||h===w}function m(h){return h===f}function I(h){return h>=L&&h<=M||h>=k&&h<=E}function p(h,o,c,i){let a="",r=0,s=-1,l=0,g=0;for(let S=0;S<=h.length;++S){if(S<h.length)g=h.charCodeAt(S);else{if(i(g))break;g=f}if(i(g)){if(!(s===S-1||l===1))if(l===2){if(a.length<2||r!==2||a.charCodeAt(a.length-1)!==n||a.charCodeAt(a.length-2)!==n){if(a.length>2){const D=a.lastIndexOf(c);D===-1?(a="",r=0):(a=a.slice(0,D),r=a.length-1-a.lastIndexOf(c)),s=S,l=0;continue}else if(a.length!==0){a="",r=0,s=S,l=0;continue}}o&&(a+=a.length>0?`${c}..`:"..",r=2)}else a.length>0?a+=`${c}${h.slice(s+1,S)}`:a=h.slice(s+1,S),r=S-s-1;s=S,l=0}else g===n&&l!==-1?++l:l=-1}return a}function u(h,o){if(o===null||typeof o!="object")throw new b("pathObject","Object",o);const c=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return c?c===o.root?`${c}${i}`:`${c}${h}${i}`:i}e.win32={resolve(...h){let o="",c="",i=!1;for(let a=h.length-1;a>=-1;a--){let r;if(a>=0){if(r=h[a],v(r,"path"),r.length===0)continue}else o.length===0?r=y.cwd():(r=y.env[`=${o}`]||y.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===w)&&(r=`${o}\\`));const s=r.length;let l=0,g="",S=!1;const D=r.charCodeAt(0);if(s===1)d(D)&&(l=1,S=!0);else if(d(D))if(S=!0,d(r.charCodeAt(1))){let A=2,F=A;for(;A<s&&!d(r.charCodeAt(A));)A++;if(A<s&&A!==F){const U=r.slice(F,A);for(F=A;A<s&&d(r.charCodeAt(A));)A++;if(A<s&&A!==F){for(F=A;A<s&&!d(r.charCodeAt(A));)A++;(A===s||A!==F)&&(g=`\\\\${U}\\${r.slice(F,A)}`,l=A)}}}else l=1;else I(D)&&r.charCodeAt(1)===t&&(g=r.slice(0,2),l=2,s>2&&d(r.charCodeAt(2))&&(S=!0,l=3));if(g.length>0)if(o.length>0){if(g.toLowerCase()!==o.toLowerCase())continue}else o=g;if(i){if(o.length>0)break}else if(c=`${r.slice(l)}\\${c}`,i=S,S&&o.length>0)break}return c=p(c,!i,"\\",d),i?`${o}\\${c}`:`${o}${c}`||"."},normalize(h){v(h,"path");const o=h.length;if(o===0)return".";let c=0,i,a=!1;const r=h.charCodeAt(0);if(o===1)return m(r)?"\\":h;if(d(r))if(a=!0,d(h.charCodeAt(1))){let l=2,g=l;for(;l<o&&!d(h.charCodeAt(l));)l++;if(l<o&&l!==g){const S=h.slice(g,l);for(g=l;l<o&&d(h.charCodeAt(l));)l++;if(l<o&&l!==g){for(g=l;l<o&&!d(h.charCodeAt(l));)l++;if(l===o)return`\\\\${S}\\${h.slice(g)}\\`;l!==g&&(i=`\\\\${S}\\${h.slice(g,l)}`,c=l)}}}else c=1;else I(r)&&h.charCodeAt(1)===t&&(i=h.slice(0,2),c=2,o>2&&d(h.charCodeAt(2))&&(a=!0,c=3));let s=c<o?p(h.slice(c),!a,"\\",d):"";return s.length===0&&!a&&(s="."),s.length>0&&d(h.charCodeAt(o-1))&&(s+="\\"),i===void 0?a?`\\${s}`:s:a?`${i}\\${s}`:`${i}${s}`},isAbsolute(h){v(h,"path");const o=h.length;if(o===0)return!1;const c=h.charCodeAt(0);return d(c)||o>2&&I(c)&&h.charCodeAt(1)===t&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let o,c;for(let r=0;r<h.length;++r){const s=h[r];v(s,"path"),s.length>0&&(o===void 0?o=c=s:o+=`\\${s}`)}if(o===void 0)return".";let i=!0,a=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++a;const r=c.length;r>1&&d(c.charCodeAt(1))&&(++a,r>2&&(d(c.charCodeAt(2))?++a:i=!1))}if(i){for(;a<o.length&&d(o.charCodeAt(a));)a++;a>=2&&(o=`\\${o.slice(a)}`)}return e.win32.normalize(o)},relative(h,o){if(v(h,"from"),v(o,"to"),h===o)return"";const c=e.win32.resolve(h),i=e.win32.resolve(o);if(c===i||(h=c.toLowerCase(),o=i.toLowerCase(),h===o))return"";let a=0;for(;a<h.length&&h.charCodeAt(a)===w;)a++;let r=h.length;for(;r-1>a&&h.charCodeAt(r-1)===w;)r--;const s=r-a;let l=0;for(;l<o.length&&o.charCodeAt(l)===w;)l++;let g=o.length;for(;g-1>l&&o.charCodeAt(g-1)===w;)g--;const S=g-l,D=s<S?s:S;let A=-1,F=0;for(;F<D;F++){const X=h.charCodeAt(a+F);if(X!==o.charCodeAt(l+F))break;X===w&&(A=F)}if(F!==D){if(A===-1)return i}else{if(S>D){if(o.charCodeAt(l+F)===w)return i.slice(l+F+1);if(F===2)return i.slice(l+F)}s>D&&(h.charCodeAt(a+F)===w?A=F:F===2&&(A=3)),A===-1&&(A=0)}let U="";for(F=a+A+1;F<=r;++F)(F===r||h.charCodeAt(F)===w)&&(U+=U.length===0?"..":"\\..");return l+=A,U.length>0?`${U}${i.slice(l,g)}`:(i.charCodeAt(l)===w&&++l,i.slice(l,g))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const o=e.win32.resolve(h);if(o.length<=2)return h;if(o.charCodeAt(0)===w){if(o.charCodeAt(1)===w){const c=o.charCodeAt(2);if(c!==P&&c!==n)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(I(o.charCodeAt(0))&&o.charCodeAt(1)===t&&o.charCodeAt(2)===w)return`\\\\?\\${o}`;return h},dirname(h){v(h,"path");const o=h.length;if(o===0)return".";let c=-1,i=0;const a=h.charCodeAt(0);if(o===1)return d(a)?h:".";if(d(a)){if(c=i=1,d(h.charCodeAt(1))){let l=2,g=l;for(;l<o&&!d(h.charCodeAt(l));)l++;if(l<o&&l!==g){for(g=l;l<o&&d(h.charCodeAt(l));)l++;if(l<o&&l!==g){for(g=l;l<o&&!d(h.charCodeAt(l));)l++;if(l===o)return h;l!==g&&(c=i=l+1)}}}}else I(a)&&h.charCodeAt(1)===t&&(c=o>2&&d(h.charCodeAt(2))?3:2,i=c);let r=-1,s=!0;for(let l=o-1;l>=i;--l)if(d(h.charCodeAt(l))){if(!s){r=l;break}}else s=!1;if(r===-1){if(c===-1)return".";r=c}return h.slice(0,r)},basename(h,o){o!==void 0&&v(o,"ext"),v(h,"path");let c=0,i=-1,a=!0,r;if(h.length>=2&&I(h.charCodeAt(0))&&h.charCodeAt(1)===t&&(c=2),o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let s=o.length-1,l=-1;for(r=h.length-1;r>=c;--r){const g=h.charCodeAt(r);if(d(g)){if(!a){c=r+1;break}}else l===-1&&(a=!1,l=r+1),s>=0&&(g===o.charCodeAt(s)?--s==-1&&(i=r):(s=-1,i=l))}return c===i?i=l:i===-1&&(i=h.length),h.slice(c,i)}for(r=h.length-1;r>=c;--r)if(d(h.charCodeAt(r))){if(!a){c=r+1;break}}else i===-1&&(a=!1,i=r+1);return i===-1?"":h.slice(c,i)},extname(h){v(h,"path");let o=0,c=-1,i=0,a=-1,r=!0,s=0;h.length>=2&&h.charCodeAt(1)===t&&I(h.charCodeAt(0))&&(o=i=2);for(let l=h.length-1;l>=o;--l){const g=h.charCodeAt(l);if(d(g)){if(!r){i=l+1;break}continue}a===-1&&(r=!1,a=l+1),g===n?c===-1?c=l:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||a===-1||s===0||s===1&&c===a-1&&c===i+1?"":h.slice(c,a)},format:u.bind(null,"\\"),parse(h){v(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const c=h.length;let i=0,a=h.charCodeAt(0);if(c===1)return d(a)?(o.root=o.dir=h,o):(o.base=o.name=h,o);if(d(a)){if(i=1,d(h.charCodeAt(1))){let A=2,F=A;for(;A<c&&!d(h.charCodeAt(A));)A++;if(A<c&&A!==F){for(F=A;A<c&&d(h.charCodeAt(A));)A++;if(A<c&&A!==F){for(F=A;A<c&&!d(h.charCodeAt(A));)A++;A===c?i=A:A!==F&&(i=A+1)}}}}else if(I(a)&&h.charCodeAt(1)===t){if(c<=2)return o.root=o.dir=h,o;if(i=2,d(h.charCodeAt(2))){if(c===3)return o.root=o.dir=h,o;i=3}}i>0&&(o.root=h.slice(0,i));let r=-1,s=i,l=-1,g=!0,S=h.length-1,D=0;for(;S>=i;--S){if(a=h.charCodeAt(S),d(a)){if(!g){s=S+1;break}continue}l===-1&&(g=!1,l=S+1),a===n?r===-1?r=S:D!==1&&(D=1):r!==-1&&(D=-1)}return l!==-1&&(r===-1||D===0||D===1&&r===l-1&&r===s+1?o.base=o.name=h.slice(s,l):(o.name=h.slice(s,r),o.base=h.slice(s,l),o.ext=h.slice(r,l))),s>0&&s!==i?o.dir=h.slice(0,s-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let o="",c=!1;for(let i=h.length-1;i>=-1&&!c;i--){const a=i>=0?h[i]:y.cwd();v(a,"path"),a.length!==0&&(o=`${a}/${o}`,c=a.charCodeAt(0)===f)}return o=p(o,!c,"/",m),c?`/${o}`:o.length>0?o:"."},normalize(h){if(v(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===f,c=h.charCodeAt(h.length-1)===f;return h=p(h,!o,"/",m),h.length===0?o?"/":c?"./":".":(c&&(h+="/"),o?`/${h}`:h)},isAbsolute(h){return v(h,"path"),h.length>0&&h.charCodeAt(0)===f},join(...h){if(h.length===0)return".";let o;for(let c=0;c<h.length;++c){const i=h[c];v(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.posix.normalize(o)},relative(h,o){if(v(h,"from"),v(o,"to"),h===o||(h=e.posix.resolve(h),o=e.posix.resolve(o),h===o))return"";const c=1,i=h.length,a=i-c,r=1,s=o.length-r,l=a<s?a:s;let g=-1,S=0;for(;S<l;S++){const A=h.charCodeAt(c+S);if(A!==o.charCodeAt(r+S))break;A===f&&(g=S)}if(S===l)if(s>l){if(o.charCodeAt(r+S)===f)return o.slice(r+S+1);if(S===0)return o.slice(r+S)}else a>l&&(h.charCodeAt(c+S)===f?g=S:S===0&&(g=0));let D="";for(S=c+g+1;S<=i;++S)(S===i||h.charCodeAt(S)===f)&&(D+=D.length===0?"..":"/..");return`${D}${o.slice(r+g)}`},toNamespacedPath(h){return h},dirname(h){if(v(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===f;let c=-1,i=!0;for(let a=h.length-1;a>=1;--a)if(h.charCodeAt(a)===f){if(!i){c=a;break}}else i=!1;return c===-1?o?"/":".":o&&c===1?"//":h.slice(0,c)},basename(h,o){o!==void 0&&v(o,"ext"),v(h,"path");let c=0,i=-1,a=!0,r;if(o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let s=o.length-1,l=-1;for(r=h.length-1;r>=0;--r){const g=h.charCodeAt(r);if(g===f){if(!a){c=r+1;break}}else l===-1&&(a=!1,l=r+1),s>=0&&(g===o.charCodeAt(s)?--s==-1&&(i=r):(s=-1,i=l))}return c===i?i=l:i===-1&&(i=h.length),h.slice(c,i)}for(r=h.length-1;r>=0;--r)if(h.charCodeAt(r)===f){if(!a){c=r+1;break}}else i===-1&&(a=!1,i=r+1);return i===-1?"":h.slice(c,i)},extname(h){v(h,"path");let o=-1,c=0,i=-1,a=!0,r=0;for(let s=h.length-1;s>=0;--s){const l=h.charCodeAt(s);if(l===f){if(!a){c=s+1;break}continue}i===-1&&(a=!1,i=s+1),l===n?o===-1?o=s:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||i===-1||r===0||r===1&&o===i-1&&o===c+1?"":h.slice(o,i)},format:u.bind(null,"/"),parse(h){v(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const c=h.charCodeAt(0)===f;let i;c?(o.root="/",i=1):i=0;let a=-1,r=0,s=-1,l=!0,g=h.length-1,S=0;for(;g>=i;--g){const D=h.charCodeAt(g);if(D===f){if(!l){r=g+1;break}continue}s===-1&&(l=!1,s=g+1),D===n?a===-1?a=g:S!==1&&(S=1):a!==-1&&(S=-1)}if(s!==-1){const D=r===0&&c?1:r;a===-1||S===0||S===1&&a===s-1&&a===r+1?o.base=o.name=h.slice(D,s):(o.name=h.slice(D,a),o.base=h.slice(D,s),o.ext=h.slice(a,s))}return r>0?o.dir=h.slice(0,r-1):c&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=y.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y.platform==="win32"?e.win32.join:e.posix.join,e.resolve=y.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=y.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=y.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=y.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=y.platform==="win32"?e.win32.extname:e.posix.extname,e.format=y.platform==="win32"?e.win32.format:e.posix.format,e.parse=y.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=y.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=y.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[105],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var y;(function(M){M[M.stdout=0]="stdout",M[M.stderr=1]="stderr"})(y=e.Source||(e.Source={}));var L;(function(M){M[M.Success=0]="Success",M[M.Unknown=1]="Unknown",M[M.AccessDenied=2]="AccessDenied",M[M.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(M,...E){const n=E.reduce((t,P)=>(t[P]=!0,t),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(M).filter(t=>!n[t]).forEach(t=>{for(let P=0;P<f.length;P++)if(t.search(f[P])!==-1){delete M[t];break}})}e.sanitizeProcessEnvironment=k}),define(Z[78],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var y;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(y=e.ScanCode||(e.ScanCode={}));const L=[],k=Object.create(null),M=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>M[n]||0,toEnum:n=>k[n]||0,toString:n=>L[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class E{constructor(f,w,t,P,b){this.ctrlKey=f,this.shiftKey=w,this.altKey=t,this.metaKey=P,this.scanCode=b}equals(f){return this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.scanCode===f.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=E,function(){function n(f,w){L[f]=w,k[w]=f,M[w.toLowerCase()]=f}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let f=0;f<=193;f++)e.IMMUTABLE_CODE_TO_KEY_CODE[f]=-1;for(let f=0;f<=112;f++)e.IMMUTABLE_KEY_CODE_TO_CODE[f]=-1;function n(f,w){e.IMMUTABLE_CODE_TO_KEY_CODE[f]=w,w!==0&&w!==3&&w!==5&&w!==4&&w!==6&&w!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[w]=f)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(Z[106],x([0,1,57,78]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class k{static _readModifiers(E){E=E.toLowerCase().trim();let n=!1,f=!1,w=!1,t=!1,P;do P=!1,/^ctrl(\+|\-)/.test(E)&&(n=!0,E=E.substr("ctrl-".length),P=!0),/^shift(\+|\-)/.test(E)&&(f=!0,E=E.substr("shift-".length),P=!0),/^alt(\+|\-)/.test(E)&&(w=!0,E=E.substr("alt-".length),P=!0),/^meta(\+|\-)/.test(E)&&(t=!0,E=E.substr("meta-".length),P=!0),/^win(\+|\-)/.test(E)&&(t=!0,E=E.substr("win-".length),P=!0),/^cmd(\+|\-)/.test(E)&&(t=!0,E=E.substr("cmd-".length),P=!0);while(P);let b;const v=E.indexOf(" ");return v>0?(b=E.substring(0,v),E=E.substring(v)):(b=E,E=""),{remains:E,ctrl:n,shift:f,alt:w,meta:t,key:b}}static parseSimpleKeybinding(E){const n=this._readModifiers(E),f=y.KeyCodeUtils.fromUserSettings(n.key);return[new y.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,f),n.remains]}static parseKeybinding(E,n){if(!E)return null;const f=[];let w;do[w,E]=this.parseSimpleKeybinding(E),f.push(w);while(E.length>0);return new y.ChordKeybinding(f)}static parseSimpleUserBinding(E){const n=this._readModifiers(E),f=n.key.match(/^\[([^\]]+)\]$/);if(f){const t=f[1],P=L.ScanCodeUtils.lowerCaseToEnum(t);return[new L.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,P),n.remains]}const w=y.KeyCodeUtils.fromUserSettings(n.key);return[new y.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,w),n.remains]}static parseUserBinding(E){if(!E)return[];const n=[];let f;for(;E.length>0;)[f,E]=this.parseSimpleUserBinding(E),n.push(f);return n}}e.KeybindingParser=k}),define(Z[107],x([0,1,3]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=y.globals.performance&&typeof y.globals.performance.now=="function";class k{constructor(E){this._highResolution=L&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new k(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Z[4],x([0,1,17,43,2,104,107]),function(K,e,y,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(h){h.None=()=>k.Disposable.None;function o(J){return(W,V=null,B)=>{let $=!1,H;return H=J(_=>{if(!$)return H?H.dispose():$=!0,W.call(V,_)},null,B),$&&H.dispose(),H}}h.once=o;function c(J,W){return g((V,B=null,$)=>J(H=>V.call(B,W(H)),null,$))}h.map=c;function i(J,W){return g((V,B=null,$)=>J(H=>{W(H),V.call(B,H)},null,$))}h.forEach=i;function a(J,W){return g((V,B=null,$)=>J(H=>W(H)&&V.call(B,H),null,$))}h.filter=a;function r(J){return J}h.signal=r;function s(...J){return(W,V=null,B)=>(0,k.combinedDisposable)(...J.map($=>$(H=>W.call(V,H),null,B)))}h.any=s;function l(J,W,V){let B=V;return c(J,$=>(B=W(B,$),B))}h.reduce=l;function g(J){let W;const V=new b({onFirstListenerAdd(){W=J(V.fire,V)},onLastListenerRemove(){W.dispose()}});return V.event}function S(J,W,V=100,B=!1,$){let H,_,j,T=0;const R=new b({leakWarningThreshold:$,onFirstListenerAdd(){H=J(O=>{T++,_=W(_,O),B&&!j&&(R.fire(_),_=void 0),clearTimeout(j),j=setTimeout(()=>{const z=_;_=void 0,j=void 0,(!B||T>1)&&R.fire(z),T=0},V)})},onLastListenerRemove(){H.dispose()}});return R.event}h.debounce=S;function D(J,W=(V,B)=>V===B){let V=!0,B;return a(J,$=>{const H=V||!W($,B);return V=!1,B=$,H})}h.latch=D;function A(J,W){return[h.filter(J,W),h.filter(J,V=>!W(V))]}h.split=A;function F(J,W=!1,V=[]){let B=V.slice(),$=J(j=>{B?B.push(j):_.fire(j)});const H=()=>{B&&B.forEach(j=>_.fire(j)),B=null},_=new b({onFirstListenerAdd(){$||($=J(j=>_.fire(j)))},onFirstListenerDidAdd(){B&&(W?setTimeout(H):H())},onLastListenerRemove(){$&&$.dispose(),$=null}});return _.event}h.buffer=F;class U{constructor(W){this.event=W}map(W){return new U(c(this.event,W))}forEach(W){return new U(i(this.event,W))}filter(W){return new U(a(this.event,W))}reduce(W,V){return new U(l(this.event,W,V))}latch(){return new U(D(this.event))}debounce(W,V=100,B=!1,$){return new U(S(this.event,W,V,B,$))}on(W,V,B){return this.event(W,V,B)}once(W,V,B){return o(this.event)(W,V,B)}}function X(J){return new U(J)}h.chain=X;function ne(J,W,V=B=>B){const B=(...j)=>_.fire(V(...j)),$=()=>J.on(W,B),H=()=>J.removeListener(W,B),_=new b({onFirstListenerAdd:$,onLastListenerRemove:H});return _.event}h.fromNodeEventEmitter=ne;function se(J,W,V=B=>B){const B=(...j)=>_.fire(V(...j)),$=()=>J.addEventListener(W,B),H=()=>J.removeEventListener(W,B),_=new b({onFirstListenerAdd:$,onLastListenerRemove:H});return _.event}h.fromDOMEventEmitter=se;function G(J){return new Promise(W=>o(J)(W))}h.toPromise=G})(n=e.Event||(e.Event={}));class f{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${f._idPool++}`}start(o){this._stopWatch=new E.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let w=-1;function t(h){const o=w;return w=h,{dispose(){w=o}}}e.setGlobalLeakWarningThreshold=t;class P{constructor(o,c=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let c=w;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),c<=0||o<c)return;this._stacks||(this._stacks=new Map);const i=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(i)||0;if(this._stacks.set(i,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let r,s=0;for(const[l,g]of this._stacks)(!r||s<g)&&(r=l,s=g);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${s}):`),console.warn(r)}return()=>{const r=this._stacks.get(i)||0;this._stacks.set(i,r-1)}}}class b{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=w>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(o,c,i)=>{this._listeners||(this._listeners=new M.LinkedList);const a=this._listeners.isEmpty();a&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(c?[o,c]:o);a&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,c);const s=this._leakageMon?.check(this._listeners.size),l=(0,k.toDisposable)(()=>{s&&s(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return i instanceof k.DisposableStore?i.add(l):Array.isArray(i)&&i.push(l),l}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new M.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,i]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,i):c[0].call(c[1],i)}catch(a){(0,y.onUnexpectedError)(a)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=b;class v extends b{async fireAsync(o,c,i){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,o]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[a,r]=this._asyncDeliveryQueue.shift(),s=[],l={...r,waitUntil:g=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");i&&(g=i(g,typeof a=="function"?a:a[0])),s.push(g)}};try{typeof a=="function"?a.call(void 0,l):a[0].call(a[1],l)}catch(g){(0,y.onUnexpectedError)(g);continue}Object.freeze(s),await Promise.allSettled(s).then(g=>{for(const S of g)S.status==="rejected"&&(0,y.onUnexpectedError)(S.reason)})}}}}e.AsyncEmitter=v;class d extends b{constructor(o){super(o);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=d;class m extends d{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=m;class I{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const c={event:o,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const i=()=>{this.hasListeners&&this.unhook(c);const a=this.events.indexOf(c);this.events.splice(a,1)};return(0,k.toDisposable)((0,L.once)(i))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(c=>this.emitter.fire(c))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=I;class p{constructor(){this.buffers=[]}wrapEvent(o){return(c,i,a)=>o(r=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>c.call(i,r)):c.call(i,r)},void 0,a)}bufferEvents(o){const c=[];this.buffers.push(c);const i=o();return this.buffers.pop(),c.forEach(a=>a()),i}}e.EventBufferer=p;class u{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=k.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=u}),define(Z[24],x([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(n,f){const w=setTimeout(n.bind(f),0);return{dispose(){clearTimeout(w)}}});var k;(function(n){function f(w){return w===n.None||w===n.Cancelled||w instanceof M?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}n.isCancellationToken=f,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=k.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=E}),define(Z[108],x([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new y.Emitter}add(P){const b=this._icons.get(P.id);b?P.description?b.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function M(t,P){return new n(t,P)}e.registerCodicon=M;function E(t){return t?t.replace(/\$\((.*?)\)/g,(P,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=E;class n{constructor(P,b,v){this.id=P,this.definition=b,this.description=v,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function f(t,P){const b=["codicon","codicon-"+t];return P&&b.push("codicon-modifier-"+P),b}e.getClassNamesArray=f;var w;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function b(m){if(m instanceof n)return["codicon","codicon-"+m.id];const I=P.exec(m.id);if(!I)return b(n.error);let[,p,u]=I;const h=["codicon","codicon-"+p];return u&&h.push("codicon-modifier-"+u.substr(1)),h}t.asClassNameArray=b;function v(m){return b(m).join(" ")}t.asClassName=v;function d(m){return"."+b(m).join(".")}t.asCSSSelector=d})(w=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(Z[64],x([0,1,17,2]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=k;function M(h){const o=h;return o?k(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=M;function E(h,o){return new n(h,o)}e.newWriteableStream=E;class n{constructor(o,c){this.reducer=o,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(c=>c(o))}emitError(o){this.listeners.error.length===0?(0,y.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(c=>c(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,c){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(o,c){if(this.state.destroyed)return;let i;switch(o){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const a=i.indexOf(c);a>=0&&i.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(h,o){const c=[];let i;for(;(i=h.read())!==null;)c.push(i);return o(c)}e.consumeReadable=f;function w(h,o,c){const i=[];let a;for(;(a=h.read())!==null&&i.length<c;)i.push(a);return a===null&&i.length>0?o(i):{read:()=>{if(i.length>0)return i.shift();if(typeof a!="undefined"){const r=a;return a=void 0,r}return h.read()}}}e.peekReadable=w;function t(h,o){return new Promise((c,i)=>{const a=[];P(h,{onData:r=>{o&&a.push(r)},onError:r=>{o?i(r):c(void 0)},onEnd:()=>{c(o?o(a):void 0)}})})}e.consumeStream=t;function P(h,o){h.on("error",c=>o.onError(c)),h.on("end",()=>o.onEnd()),h.on("data",c=>o.onData(c))}e.listenStream=P;function b(h,o){return new Promise((c,i)=>{const a=new L.DisposableStore,r=[],s=S=>{if(r.push(S),r.length>o)return a.dispose(),h.pause(),c({stream:h,buffer:r,ended:!1})},l=S=>i(S),g=()=>c({stream:h,buffer:r,ended:!0});a.add((0,L.toDisposable)(()=>h.removeListener("error",l))),h.on("error",l),a.add((0,L.toDisposable)(()=>h.removeListener("end",g))),h.on("end",g),a.add((0,L.toDisposable)(()=>h.removeListener("data",s))),h.on("data",s)})}e.peekStream=b;function v(h,o){const c=E(o);return c.end(h),c}e.toStream=v;function d(){const h=E(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function m(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}e.toReadable=m;function I(h,o,c){const i=E(c);return P(h,{onData:a=>i.write(o.data(a)),onError:a=>i.error(o.error?o.error(a):a),onEnd:()=>i.end()}),i}e.transform=I;function p(h,o,c){let i=!1;return{read:()=>{const a=o.read();return i?a:(i=!0,a!==null?c([h,a]):h)}}}e.prefixedReadable=p;function u(h,o,c){let i=!1;const a=E(c);return P(o,{onData:r=>i?a.write(r):(i=!0,a.write(c([h,r]))),onError:r=>a.error(r),onEnd:()=>{i||(i=!0,a.write(h)),a.end()}}),a}e.prefixedStream=u}),define(Z[18],x([0,1,64]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let k,M;class E{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return L?new E(Buffer.allocUnsafe(s)):new E(new Uint8Array(s))}static wrap(s){return L&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new E(s)}static fromString(s,l){return!(l?.dontUseNodeBuffer||!1)&&L?new E(Buffer.from(s)):(k||(k=new TextEncoder),new E(k.encode(s)))}static concat(s,l){if(typeof l=="undefined"){l=0;for(let D=0,A=s.length;D<A;D++)l+=s[D].byteLength}const g=E.alloc(l);let S=0;for(let D=0,A=s.length;D<A;D++){const F=s[D];g.set(F,S),S+=F.byteLength}return g}toString(){return L?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(s,l){return new E(this.buffer.subarray(s,l))}set(s,l){s instanceof E?this.buffer.set(s.buffer,l):this.buffer.set(s,l)}readUInt32BE(s){return w(this.buffer,s)}writeUInt32BE(s,l){t(this.buffer,s,l)}readUInt32LE(s){return P(this.buffer,s)}writeUInt32LE(s,l){b(this.buffer,s,l)}readUInt8(s){return v(this.buffer,s)}writeUInt8(s,l){d(this.buffer,s,l)}}e.VSBuffer=E;function n(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0}e.readUInt16LE=n;function f(r,s,l){r[l+0]=s&255,s=s>>>8,r[l+1]=s&255}e.writeUInt16LE=f;function w(r,s){return r[s]*2**24+r[s+1]*2**16+r[s+2]*2**8+r[s+3]}e.readUInt32BE=w;function t(r,s,l){r[l+3]=s,s=s>>>8,r[l+2]=s,s=s>>>8,r[l+1]=s,s=s>>>8,r[l]=s}e.writeUInt32BE=t;function P(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0|r[s+2]<<16>>>0|r[s+3]<<24>>>0}e.readUInt32LE=P;function b(r,s,l){r[l+0]=s&255,s=s>>>8,r[l+1]=s&255,s=s>>>8,r[l+2]=s&255,s=s>>>8,r[l+3]=s&255}e.writeUInt32LE=b;function v(r,s){return r[s]}e.readUInt8=v;function d(r,s,l){r[l]=s}e.writeUInt8=d;function m(r){return y.consumeReadable(r,s=>E.concat(s))}e.readableToBuffer=m;function I(r){return y.toReadable(r)}e.bufferToReadable=I;function p(r){return y.consumeStream(r,s=>E.concat(s))}e.streamToBuffer=p;async function u(r){return r.ended?E.concat(r.buffer):E.concat([...r.buffer,await p(r.stream)])}e.bufferedStreamToBuffer=u;function h(r){return y.toStream(r,s=>E.concat(s))}e.bufferToStream=h;function o(r){return y.transform(r,{data:s=>typeof s=="string"?E.fromString(s):E.wrap(s)},s=>E.concat(s))}e.streamToBufferReadableStream=o;function c(r){return y.newWriteableStream(s=>E.concat(s),r)}e.newWriteableBufferStream=c;function i(r,s){return y.prefixedReadable(r,s,l=>E.concat(l))}e.prefixedBufferReadable=i;function a(r,s){return y.prefixedStream(r,s,l=>E.concat(l))}e.prefixedBufferStream=a}),define(Z[25],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function y(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=y;const L=/{(\d+)}/g;function k(Y,...re){return re.length===0?Y:Y.replace(L,function(ce,ge){const ye=parseInt(ge,10);return isNaN(ye)||ye<0||ye>=re.length?ce:re[ye]})}e.format=k;const M=/{([^}]+)}/g;function E(Y,re){return Y.replace(M,(ce,ge)=>re[ge]??ce)}e.format2=E;function n(Y){return Y.replace(/[<>&]/g,function(re){switch(re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return re}})}e.escape=n;function f(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function w(Y,re){let ce=0;const ge=re.charCodeAt(0);for(let ye=Y.length-1;ye>=0;ye--)Y.charCodeAt(ye)===ge&&ce++;return ce}e.count=w;function t(Y,re,ce="\u2026"){return Y.length<=re?Y:`${Y.substr(0,re)}${ce}`}e.truncate=t;function P(Y,re=" "){const ce=b(Y,re);return v(ce,re)}e.trim=P;function b(Y,re){if(!Y||!re)return Y;const ce=re.length;if(ce===0||Y.length===0)return Y;let ge=0;for(;Y.indexOf(re,ge)===ge;)ge=ge+ce;return Y.substring(ge)}e.ltrim=b;function v(Y,re){if(!Y||!re)return Y;const ce=re.length,ge=Y.length;if(ce===0||ge===0)return Y;let ye=ge,Me=-1;for(;Me=Y.lastIndexOf(re,ye-1),!(Me===-1||Me+ce!==ye);){if(Me===0)return"";ye=Me}return Y.substring(0,ye)}e.rtrim=v;function d(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function m(Y){return Y.replace(/\*/g,"")}e.stripWildcards=m;function I(Y,re,ce={}){if(!Y)throw new Error("Cannot create regex from empty string");re||(Y=f(Y)),ce.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ge="";return ce.global&&(ge+="g"),ce.matchCase||(ge+="i"),ce.multiline&&(ge+="m"),ce.unicode&&(ge+="u"),new RegExp(Y,ge)}e.createRegExp=I;function p(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function u(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function h(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=h;function o(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=o;function c(Y){for(let re=0,ce=Y.length;re<ce;re++){const ge=Y.charCodeAt(re);if(ge!==32&&ge!==9)return re}return-1}e.firstNonWhitespaceIndex=c;function i(Y,re=0,ce=Y.length){for(let ge=re;ge<ce;ge++){const ye=Y.charCodeAt(ge);if(ye!==32&&ye!==9)return Y.substring(re,ge)}return Y.substring(re,ce)}e.getLeadingWhitespace=i;function a(Y,re=Y.length-1){for(let ce=re;ce>=0;ce--){const ge=Y.charCodeAt(ce);if(ge!==32&&ge!==9)return ce}return-1}e.lastNonWhitespaceIndex=a;function r(Y,re){return Y<re?-1:Y>re?1:0}e.compare=r;function s(Y,re,ce=0,ge=Y.length,ye=0,Me=re.length){for(;ce<ge&&ye<Me;ce++,ye++){let Ce=Y.charCodeAt(ce),ze=re.charCodeAt(ye);if(Ce<ze)return-1;if(Ce>ze)return 1}const Fe=ge-ce,We=Me-ye;return Fe<We?-1:Fe>We?1:0}e.compareSubstring=s;function l(Y,re){return g(Y,re,0,Y.length,0,re.length)}e.compareIgnoreCase=l;function g(Y,re,ce=0,ge=Y.length,ye=0,Me=re.length){for(;ce<ge&&ye<Me;ce++,ye++){let Ce=Y.charCodeAt(ce),ze=re.charCodeAt(ye);if(Ce===ze)continue;const de=Ce-ze;if(!(de===32&&D(ze))&&!(de===-32&&D(Ce)))return S(Ce)&&S(ze)?de:s(Y.toLowerCase(),re.toLowerCase(),ce,ge,ye,Me)}const Fe=ge-ce,We=Me-ye;return Fe<We?-1:Fe>We?1:0}e.compareSubstringIgnoreCase=g;function S(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=S;function D(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=D;function A(Y){return S(Y)||D(Y)}function F(Y,re){return Y.length===re.length&&U(Y,re)}e.equalsIgnoreCase=F;function U(Y,re,ce=Y.length){for(let ge=0;ge<ce;ge++){const ye=Y.charCodeAt(ge),Me=re.charCodeAt(ge);if(ye!==Me){if(A(ye)&&A(Me)){const Fe=Math.abs(ye-Me);if(Fe!==0&&Fe!==32)return!1}else if(String.fromCharCode(ye).toLowerCase()!==String.fromCharCode(Me).toLowerCase())return!1}}return!0}function X(Y,re){const ce=re.length;return re.length>Y.length?!1:U(Y,re,ce)}e.startsWithIgnoreCase=X;function ne(Y,re){let ce,ge=Math.min(Y.length,re.length);for(ce=0;ce<ge;ce++)if(Y.charCodeAt(ce)!==re.charCodeAt(ce))return ce;return ge}e.commonPrefixLength=ne;function se(Y,re){let ce,ge=Math.min(Y.length,re.length);const ye=Y.length-1,Me=re.length-1;for(ce=0;ce<ge;ce++)if(Y.charCodeAt(ye-ce)!==re.charCodeAt(Me-ce))return ce;return ge}e.commonSuffixLength=se;function G(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=G;function J(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=J;function W(Y,re){return(Y-55296<<10)+(re-56320)+65536}e.computeCodePoint=W;function V(Y,re,ce){const ge=Y.charCodeAt(ce);if(G(ge)&&ce+1<re){const ye=Y.charCodeAt(ce+1);if(J(ye))return W(ge,ye)}return ge}e.getNextCodePoint=V;function B(Y,re){const ce=Y.charCodeAt(re-1);if(J(ce)&&re>1){const ge=Y.charCodeAt(re-2);if(G(ge))return W(ge,ce)}return ce}function $(Y,re){const ce=Be.getInstance(),ge=re,ye=Y.length,Me=V(Y,ye,re);re+=Me>=65536?2:1;let Fe=ce.getGraphemeBreakType(Me);for(;re<ye;){const We=V(Y,ye,re),Ce=ce.getGraphemeBreakType(We);if(Ue(Fe,Ce))break;re+=We>=65536?2:1,Fe=Ce}return re-ge}e.nextCharLength=$;function H(Y,re){const ce=Be.getInstance(),ge=re,ye=B(Y,re);re-=ye>=65536?2:1;let Me=ce.getGraphemeBreakType(ye);for(;re>0;){const Fe=B(Y,re),We=ce.getGraphemeBreakType(Fe);if(Ue(We,Me))break;re-=Fe>=65536?2:1,Me=We}return ge-re}e.prevCharLength=H;function _(Y,re){const ce=Be.getInstance(),ge=Y.length,ye=re,Me=V(Y,ge,re),Fe=ce.getGraphemeBreakType(Me);re+=Me>=65536?2:1;let We=Fe;for(;re<ge;){const ze=V(Y,ge,re),de=ce.getGraphemeBreakType(ze);if(Ue(We,de))break;re+=ze>=65536?2:1,We=de}const Ce=re;for(re=ye,We=Fe;re>0;){const ze=B(Y,re),de=ce.getGraphemeBreakType(ze);if(Ue(de,We))break;re-=ze>=65536?2:1,We=de}return[re,Ce]}function j(Y,re){return re>0&&J(Y.charCodeAt(re))?_(Y,re-1):_(Y,re)}e.getCharContainingOffset=j;const T=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function R(Y){return T.test(Y)}e.containsRTL=R;const O=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function z(Y){return O.test(Y)}e.containsEmoji=z;const N=/^[\t\n\r\x20-\x7E]*$/;function C(Y){return N.test(Y)}e.isBasicASCII=C,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function q(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=q;function Q(Y){for(let re=0,ce=Y.length;re<ce;re++)if(ie(Y.charCodeAt(re)))return!0;return!1}e.containsFullWidthCharacter=Q;function ie(Y){return Y=+Y,Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=ie;function oe(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=oe;function ae(Y,re){if(Y.length<re)return Y;const ce=/\b/g;let ge=0;for(;ce.test(Y)&&!(Y.length-ce.lastIndex<re);)ge=ce.lastIndex,ce.lastIndex+=1;return Y.substring(ge).replace(/^\s/,"")}e.lcut=ae;const ee=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function ue(Y){return Y&&(Y=Y.replace(ee,""),Y=Y.replace(le,""),Y=Y.replace(me,"")),Y}e.removeAnsiEscapeCodes=ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ve(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ve;function Pe(Y){return ve(Y)?Y.substr(1):Y}e.stripUTF8BOM=Pe;function we(Y,re){if(!Y||!re||Y.length<re.length)return!1;const ce=re.length,ge=Y.toLowerCase();let ye=0,Me=-1;for(;ye<ce;){const Fe=ge.indexOf(re[ye],Me+1);if(Fe<0)return!1;Me=Fe,ye++}return!0}e.fuzzyContains=we;function fe(Y,re=!1){return Y?(re&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=fe;function Ee(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Ee;function De(Y,re=1){if(re===0)return"";let ce=-1;do ce=Y.indexOf(`
`,ce+1),re--;while(re>0&&ce>=0);return ce===-1?Y:(Y[ce-1]==="\r"&&ce--,Y.substr(0,ce))}e.getNLines=De;function Re(Y){const re=90-65+1;return Y=Y%(2*re),Y<re?String.fromCharCode(97+Y):String.fromCharCode(65+Y-re)}e.singleLetterHash=Re;function Ne(Y){return Be.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=Ne;function Ue(Y,re){return Y===0?re!==5&&re!==7:Y===2&&re===3?!1:Y===4||Y===2||Y===3||re===4||re===2||re===3?!0:!(Y===8&&(re===8||re===9||re===11||re===12)||(Y===11||Y===9)&&(re===9||re===10)||(Y===12||Y===10)&&re===10||re===5||re===13||re===7||Y===1||Y===13&&re===14||Y===6&&re===6)}e.breakBetweenGraphemeBreakType=Ue;var Ge;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=st()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(re){if(re<32)return re===10?3:re===13?2:4;if(re<127)return 0;const ce=this._data,ge=ce.length/3;let ye=1;for(;ye<=ge;)if(re<ce[3*ye])ye=2*ye;else if(re>ce[3*ye+1])ye=2*ye+1;else return ce[3*ye+2];return 0}}Be._INSTANCE=null;function st(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ze(Y,re){if(Y===0)return 0;const ce=ot(Y,re);if(ce!==void 0)return ce;const ge=B(re,Y);return Y-=Ye(ge),Y}e.getLeftDeleteOffset=Ze;function ot(Y,re){let ce=B(re,Y);for(Y-=Ye(ce);ut(ce)||ce===65039||ce===8419;){if(Y===0)return;ce=B(re,Y),Y-=Ye(ce)}if(!!oe(ce)){if(Y>=0){const ge=B(re,Y);ge===8205&&(Y-=Ye(ge))}return Y}}function Ye(Y){return Y>=65536?2:1}function ut(Y){return 127995<=Y&&Y<=127999}var xe;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={}))}),define(Z[79],x([0,1,25]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(p){return k(p,0)}e.hash=L;function k(p,u){switch(typeof p){case"object":return p===null?M(349,u):Array.isArray(p)?f(p,u):w(p,u);case"string":return n(p,u);case"boolean":return E(p,u);case"number":return M(p,u);case"undefined":return M(937,u);default:return M(617,u)}}e.doHash=k;function M(p,u){return(u<<5)-u+p|0}function E(p,u){return M(p?433:863,u)}function n(p,u){u=M(149417,u);for(let h=0,o=p.length;h<o;h++)u=M(p.charCodeAt(h),u);return u}e.stringHash=n;function f(p,u){return u=M(104579,u),p.reduce((h,o)=>k(o,h),u)}function w(p,u){return u=M(181387,u),Object.keys(p).sort().reduce((h,o)=>(h=n(o,h),k(p[o],h)),u)}class t{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=k(u,this._value),this._value}}e.Hasher=t;var P;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function b(p,u,h=32){const o=h-u,c=~((1<<o)-1);return(p<<u|(c&p)>>>o)>>>0}function v(p,u=0,h=p.byteLength,o=0){for(let c=0;c<h;c++)p[u+c]=o}function d(p,u,h="0"){for(;p.length<u;)p=h+p;return p}function m(p,u=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((p>>>0).toString(16),u/4)}e.toHexString=m;class I{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const h=u.length;if(h===0)return;const o=this._buff;let c=this._buffLen,i=this._leftoverHighSurrogate,a,r;for(i!==0?(a=i,r=-1,i=0):(a=u.charCodeAt(0),r=0);;){let s=a;if(y.isHighSurrogate(a))if(r+1<h){const l=u.charCodeAt(r+1);y.isLowSurrogate(l)?(r++,s=y.computeCodePoint(a,l)):s=65533}else{i=a;break}else y.isLowSurrogate(a)&&(s=65533);if(c=this._push(o,c,s),r++,r<h)a=u.charCodeAt(r);else break}this._buffLen=c,this._leftoverHighSurrogate=i}_push(u,h,o){return o<128?u[h++]=o:o<2048?(u[h++]=192|(o&1984)>>>6,u[h++]=128|(o&63)>>>0):o<65536?(u[h++]=224|(o&61440)>>>12,u[h++]=128|(o&4032)>>>6,u[h++]=128|(o&63)>>>0):(u[h++]=240|(o&1835008)>>>18,u[h++]=128|(o&258048)>>>12,u[h++]=128|(o&4032)>>>6,u[h++]=128|(o&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=I._bigBlock32,h=this._buffDV;for(let S=0;S<64;S+=4)u.setUint32(S,h.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)u.setUint32(S,b(u.getUint32(S-12,!1)^u.getUint32(S-32,!1)^u.getUint32(S-56,!1)^u.getUint32(S-64,!1),1),!1);let o=this._h0,c=this._h1,i=this._h2,a=this._h3,r=this._h4,s,l,g;for(let S=0;S<80;S++)S<20?(s=c&i|~c&a,l=1518500249):S<40?(s=c^i^a,l=1859775393):S<60?(s=c&i|c&a|i&a,l=2400959708):(s=c^i^a,l=3395469782),g=b(o,5)+s+r+l+u.getUint32(S*4,!1)&4294967295,r=a,a=i,i=b(c,30),c=o,o=g;this._h0=this._h0+o&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=I,I._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[13],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function y(D){return Array.isArray(D)}e.isArray=y;function L(D){return typeof D=="string"}e.isString=L;function k(D){return Array.isArray(D)&&D.every(A=>L(A))}e.isStringArray=k;function M(D){return typeof D=="object"&&D!==null&&!Array.isArray(D)&&!(D instanceof RegExp)&&!(D instanceof Date)}e.isObject=M;function E(D){return typeof D=="number"&&!isNaN(D)}e.isNumber=E;function n(D){return!!D&&typeof D[Symbol.iterator]=="function"}e.isIterable=n;function f(D){return D===!0||D===!1}e.isBoolean=f;function w(D){return typeof D=="undefined"}e.isUndefined=w;function t(D){return!P(D)}e.isDefined=t;function P(D){return w(D)||D===null}e.isUndefinedOrNull=P;function b(D,A){if(!D)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}e.assertType=b;function v(D){if(P(D))throw new Error("Assertion Failed: argument is undefined or null");return D}e.assertIsDefined=v;function d(...D){const A=[];for(let F=0;F<D.length;F++){const U=D[F];if(P(U))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);A.push(U)}return A}e.assertAllDefined=d;const m=Object.prototype.hasOwnProperty;function I(D){if(!M(D))return!1;for(let A in D)if(m.call(D,A))return!1;return!0}e.isEmptyObject=I;function p(D){return typeof D=="function"}e.isFunction=p;function u(...D){return D.length>0&&D.every(p)}e.areFunctions=u;function h(D,A){const F=Math.min(D.length,A.length);for(let U=0;U<F;U++)o(D[U],A[U])}e.validateConstraints=h;function o(D,A){if(L(A)){if(typeof D!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(p(A)){try{if(D instanceof A)return}catch{}if(!P(D)&&D.constructor===A||A.length===1&&A.call(void 0,D)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function c(D){let A=[],F=Object.getPrototypeOf(D);for(;Object.prototype!==F;)A=A.concat(Object.getOwnPropertyNames(F)),F=Object.getPrototypeOf(F);return A}e.getAllPropertyNames=c;function i(D){const A=[];for(const F of c(D))typeof D[F]=="function"&&A.push(F);return A}e.getAllMethodNames=i;function a(D,A){const F=X=>function(){const ne=Array.prototype.slice.call(arguments,0);return A(X,ne)};let U={};for(const X of D)U[X]=F(X);return U}e.createProxyObject=a;function r(D){return D===null?void 0:D}e.withNullAsUndefined=r;function s(D){return typeof D=="undefined"?null:D}e.withUndefinedAsNull=s;function l(D){return class{constructor(){return new Proxy({},{get(A,F){if(A[F])return A[F];throw new Error(`Not Implemented: ${D}->${String(F)}`)}})}}}e.NotImplementedProxy=l;function g(D,A="Unreachable"){throw new Error(A)}e.assertNever=g;function S(D){return!!D&&typeof D.then=="function"&&typeof D.catch=="function"}e.isPromise=S}),define(Z[29],x([0,1,8,3,25,13]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(r){return r===47||r===92}e.isPathSeparator=E;function n(r){return r.replace(/[\\/]/g,y.posix.sep)}e.toSlashes=n;function f(r){return r.indexOf("/")===-1&&(r=n(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=f;function w(r,s=y.posix.sep){if(!r)return"";const l=r.length,g=r.charCodeAt(0);if(E(g)){if(E(r.charCodeAt(1))&&!E(r.charCodeAt(2))){let D=3;const A=D;for(;D<l&&!E(r.charCodeAt(D));D++);if(A!==D&&!E(r.charCodeAt(D+1))){for(D+=1;D<l;D++)if(E(r.charCodeAt(D)))return r.slice(0,D+1).replace(/[\\/]/g,s)}}return s}else if(p(g)&&r.charCodeAt(1)===58)return E(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let S=r.indexOf("://");if(S!==-1){for(S+=3;S<l;S++)if(E(r.charCodeAt(S)))return r.slice(0,S+1)}return""}e.getRoot=w;function t(r){if(!L.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let l=2;const g=l;for(;l<r.length&&(s=r.charCodeAt(l),s!==92);l++);return!(g===l||(s=r.charCodeAt(l+1),isNaN(s)||s===92))}e.isUNC=t;const P=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,s=L.isWindows){const l=s?P:b;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||s&&v.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function m(r,s,l){const g=r===s;return!l||g?g:!r||!s?!1:(0,k.equalsIgnoreCase)(r,s)}e.isEqual=m;function I(r,s,l,g=y.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let D=s.length;return s.charAt(s.length-1)===g&&D--,r.charAt(D)===g}return s.charAt(s.length-1)!==g&&(s+=g),r.indexOf(s)===0}e.isEqualOrParent=I;function p(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=p;function u(r,s){return L.isWindows&&r.endsWith(":")&&(r+=y.sep),(0,y.isAbsolute)(r)||(r=(0,y.join)(s,r)),r=(0,y.normalize)(r),L.isWindows?(r=(0,k.rtrim)(r,y.sep),r.endsWith(":")&&(r+=y.sep)):(r=(0,k.rtrim)(r,y.sep),r||(r=y.sep)),r}e.sanitizeFilePath=u;function h(r){const s=(0,y.normalize)(r);return L.isWindows?r.length>3?!1:o(s)&&(r.length===2||s.charCodeAt(2)===92):s===y.posix.sep}e.isRootOrDriveLetter=h;function o(r){return L.isWindows?p(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function c(r){return o(r)?r[0]:void 0}e.getDriveLetter=c;function i(r,s,l){return s.length>r.length?-1:r===s?0:(l&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=i;function a(r){const s=r.split(":");let l,g,S;if(s.forEach(D=>{const A=Number(D);(0,M.isNumber)(A)?g===void 0?g=A:S===void 0&&(S=A):l=l?[l,D].join(":"):D}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:g!==void 0?g:void 0,column:S!==void 0?S:g!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(Z[44],x([0,1,13]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const I=Array.isArray(m)?[]:{};return Object.keys(m).forEach(p=>{m[p]&&typeof m[p]=="object"?I[p]=L(m[p]):I[p]=m[p]}),I}e.deepClone=L;function k(m){if(!m||typeof m!="object")return m;const I=[m];for(;I.length>0;){const p=I.shift();Object.freeze(p);for(const u in p)if(M.call(p,u)){const h=p[u];typeof h=="object"&&!Object.isFrozen(h)&&I.push(h)}}return m}e.deepFreeze=k;const M=Object.prototype.hasOwnProperty;function E(m,I){return n(m,I,new Set)}e.cloneAndChange=E;function n(m,I,p){if((0,y.isUndefinedOrNull)(m))return m;const u=I(m);if(typeof u!="undefined")return u;if((0,y.isArray)(m)){const h=[];for(const o of m)h.push(n(o,I,p));return h}if((0,y.isObject)(m)){if(p.has(m))throw new Error("Cannot clone recursive data-structure");p.add(m);const h={};for(let o in m)M.call(m,o)&&(h[o]=n(m[o],I,p));return p.delete(m),h}return m}function f(m,I,p=!0){return(0,y.isObject)(m)?((0,y.isObject)(I)&&Object.keys(I).forEach(u=>{u in m?p&&((0,y.isObject)(m[u])&&(0,y.isObject)(I[u])?f(m[u],I[u],p):m[u]=I[u]):m[u]=I[u]}),m):I}e.mixin=f;function w(m,I){if(m===I)return!0;if(m==null||I===null||I===void 0||typeof m!=typeof I||typeof m!="object"||Array.isArray(m)!==Array.isArray(I))return!1;let p,u;if(Array.isArray(m)){if(m.length!==I.length)return!1;for(p=0;p<m.length;p++)if(!w(m[p],I[p]))return!1}else{const h=[];for(u in m)h.push(u);h.sort();const o=[];for(u in I)o.push(u);if(o.sort(),!w(h,o))return!1;for(p=0;p<h.length;p++)if(!w(m[h[p]],I[h[p]]))return!1}return!0}e.equals=w;function t(m){const I=new Set;return JSON.stringify(m,(p,u)=>{if((0,y.isObject)(u)||Array.isArray(u)){if(I.has(u))return"[Circular]";I.add(u)}return u})}e.safeStringify=t;function P(m,I,p){const u=I(m);return typeof u=="undefined"?p:u}e.getOrDefault=P;function b(m,I){const p=Object.create(null);return!m||!I||Object.keys(I).forEach(h=>{const o=m[h],c=I[h];w(o,c)||(p[h]=c)}),p}e.distinct=b;function v(m,I){const p=I.toLowerCase(),u=Object.keys(m).find(h=>h.toLowerCase()===p);return u?m[u]:m[I]}e.getCaseInsensitive=v;function d(m,I){const p=Object.create(null);for(const u of Object.keys(m))I(u,m[u])&&(p[u]=m[u]);return p}e.filter=d}),define(Z[7],x([0,1,8,3]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,M=/^\//,E=/^\/\//;function n(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!M.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(r,s){return!r&&!s?"file":r}function w(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==P&&(s=P+s):s=P;break}return s}const t="",P="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(s,l,g,S,D,A=!1){typeof s=="object"?(this.scheme=s.scheme||t,this.authority=s.authority||t,this.path=s.path||t,this.query=s.query||t,this.fragment=s.fragment||t):(this.scheme=f(s,A),this.authority=l||t,this.path=w(this.scheme,g||t),this.query=S||t,this.fragment=D||t,n(this,A))}static isUri(s){return s instanceof v?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return h(this,!1)}with(s){if(!s)return this;let{scheme:l,authority:g,path:S,query:D,fragment:A}=s;return l===void 0?l=this.scheme:l===null&&(l=t),g===void 0?g=this.authority:g===null&&(g=t),S===void 0?S=this.path:S===null&&(S=t),D===void 0?D=this.query:D===null&&(D=t),A===void 0?A=this.fragment:A===null&&(A=t),l===this.scheme&&g===this.authority&&S===this.path&&D===this.query&&A===this.fragment?this:new m(l,g,S,D,A)}static parse(s,l=!1){const g=b.exec(s);return g?new m(g[2]||t,a(g[4]||t),a(g[5]||t),a(g[7]||t),a(g[9]||t),l):new m(t,t,t,t,t)}static file(s){let l=t;if(L.isWindows&&(s=s.replace(/\\/g,P)),s[0]===P&&s[1]===P){const g=s.indexOf(P,2);g===-1?(l=s.substring(2),s=P):(l=s.substring(2,g),s=s.substring(g)||P)}return new m("file",l,s,t,t)}static from(s){const l=new m(s.scheme,s.authority,s.path,s.query,s.fragment);return n(l,!0),l}static joinPath(s,...l){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return L.isWindows&&s.scheme==="file"?g=v.file(y.win32.join(h(s,!0),...l)).path:g=y.posix.join(s.path,...l),s.with({path:g})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof v)return s;{const l=new m(s);return l._formatted=s.external,l._fsPath=s._sep===d?s.fsPath:null,l}}else return s}}e.URI=v;const d=L.isWindows?1:void 0;class m extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=d),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const I={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(r,s){let l,g=-1;for(let S=0;S<r.length;S++){const D=r.charCodeAt(S);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||s&&D===47)g!==-1&&(l+=encodeURIComponent(r.substring(g,S)),g=-1),l!==void 0&&(l+=r.charAt(S));else{l===void 0&&(l=r.substr(0,S));const A=I[D];A!==void 0?(g!==-1&&(l+=encodeURIComponent(r.substring(g,S)),g=-1),l+=A):g===-1&&(g=S)}}return g!==-1&&(l+=encodeURIComponent(r.substring(g))),l!==void 0?l:r}function u(r){let s;for(let l=0;l<r.length;l++){const g=r.charCodeAt(l);g===35||g===63?(s===void 0&&(s=r.substr(0,l)),s+=I[g]):s!==void 0&&(s+=r[l])}return s!==void 0?s:r}function h(r,s){let l;return r.authority&&r.path.length>1&&r.scheme==="file"?l=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?l=r.path.substr(1):l=r.path[1].toLowerCase()+r.path.substr(2):l=r.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=h;function o(r,s){const l=s?u:p;let g="",{scheme:S,authority:D,path:A,query:F,fragment:U}=r;if(S&&(g+=S,g+=":"),(D||S==="file")&&(g+=P,g+=P),D){let X=D.indexOf("@");if(X!==-1){const ne=D.substr(0,X);D=D.substr(X+1),X=ne.indexOf(":"),X===-1?g+=l(ne,!1):(g+=l(ne.substr(0,X),!1),g+=":",g+=l(ne.substr(X+1),!1)),g+="@"}D=D.toLowerCase(),X=D.indexOf(":"),X===-1?g+=l(D,!1):(g+=l(D.substr(0,X),!1),g+=D.substr(X))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const X=A.charCodeAt(1);X>=65&&X<=90&&(A=`/${String.fromCharCode(X+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const X=A.charCodeAt(0);X>=65&&X<=90&&(A=`${String.fromCharCode(X+32)}:${A.substr(2)}`)}g+=l(A,!0)}return F&&(g+="?",g+=l(F,!1)),U&&(g+="#",g+=s?U:p(U,!1)),g}function c(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+c(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(r){return r.match(i)?r.replace(i,s=>c(s)):r}}),define(Z[109],x([0,1,7]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(w){const t=w;return t&&typeof t.type=="string"&&typeof t.severity=="string"}e.isRemoteConsoleLog=L;function k(w){const t=[];let P;try{const b=JSON.parse(w.arguments),v=b[b.length-1];v&&v.__$stack&&(b.pop(),P=v.__$stack),t.push(...b)}catch(b){t.push("Unable to log remote console arguments",w.arguments)}return{args:t,stack:P}}e.parse=k;function M(w){if(typeof w!="string")return M(k(w).stack);const t=w;if(t){const P=E(t),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(b&&b.length===4)return{uri:y.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=M;function E(w){if(!w)return w;const t=w.indexOf(`
`);return t===-1?w:w.substring(0,t)}function n(w,t){const{args:P,stack:b}=k(w),v=typeof P[0]=="string"&&P.length===1;let d=E(b);d&&(d=`(${d.trim()})`);let m=[];if(typeof P[0]=="string"?d&&v?m=[`%c[${t}] %c${P[0]} %c${d}`,f("blue"),f(""),f("grey")]:m=[`%c[${t}] %c${P[0]}`,f("blue"),f(""),...P.slice(1)]:m=[`%c[${t}]%`,f("blue"),...P],d&&!v&&m.push(d),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,m)}e.log=n;function f(w){return`color: ${w}`}});var bt=this&&this.__classPrivateFieldSet||function(K,e,y,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!k:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(K,y):k?k.value=y:e.set(K,y),y},qe=this&&this.__classPrivateFieldGet||function(K,e,y,L){if(y==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?L:y==="a"?L.call(K):L?L.value:e.get(K)};define(Z[37],x([0,1,31,25,7]),function(K,e,y,L,k){"use strict";var M,E,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function f(a,r,s){let l=a.get(r);return l===void 0&&(l=s,a.set(r,l)),l}e.getOrSet=f;function w(a){const r=[];return a.forEach((s,l)=>{r.push(`${l} => ${s}`)}),`Map(${a.size}) {${r.join(", ")}}`}e.mapToString=w;function t(a){const r=[];return a.forEach(s=>{r.push(s)}),`Set(${a.size}) {${r.join(", ")}}`}e.setToString=t;class P{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),l=this._value.charCodeAt(this._pos);return s-l}value(){return this._value[this._pos]}}e.StringIterator=P;class b{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class v{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=v;var d;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(d||(d={}));class m{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class I{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class p{constructor(r){this._iter=r}static forUris(r=()=>!1){return new p(new m(r))}static forPaths(){return new p(new v)}static forStrings(){return new p(new P)}static forConfigKeys(){return new p(new b)}clear(){this._root=void 0}set(r,s){const l=this._iter.reset(r);let g;for(this._root||(this._root=new I,this._root.segment=l.value()),g=this._root;;){const D=l.cmp(g.segment);if(D>0)g.left||(g.left=new I,g.left.segment=l.value()),g=g.left;else if(D<0)g.right||(g.right=new I,g.right.segment=l.value()),g=g.right;else if(l.hasNext())l.next(),g.mid||(g.mid=new I,g.mid.segment=l.value()),g=g.mid;else break}const S=g.value;return g.value=s,g.key=r,S}fill(r,s){const l=s.slice(0);(0,y.shuffle)(l);for(let g of l)this.set(g,r)}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let l=this._root;for(;l;){const g=s.cmp(l.segment);if(g>0)l=l.left;else if(g<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else break}return l}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const l=this._iter.reset(r),g=[];let S=this._root;for(;S;){const D=l.cmp(S.segment);if(D>0)g.push([1,S]),S=S.left;else if(D<0)g.push([-1,S]),S=S.right;else if(l.hasNext())l.next(),g.push([0,S]),S=S.mid;else{for(s?(S.left=void 0,S.mid=void 0,S.right=void 0):S.value=void 0;g.length>0&&S.isEmpty();){let[A,F]=g.pop();switch(A){case 1:F.left=void 0;break;case 0:F.mid=void 0;break;case-1:F.right=void 0;break}S=F}break}}}findSubstr(r){const s=this._iter.reset(r);let l=this._root,g;for(;l;){const S=s.cmp(l.segment);if(S>0)l=l.left;else if(S<0)l=l.right;else if(s.hasNext())s.next(),g=l.value||g,l=l.mid;else break}return l&&l.value||g}findSuperstr(r){const s=this._iter.reset(r);let l=this._root;for(;l;){const g=s.cmp(l.segment);if(g>0)l=l.left;else if(g<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(r){for(const[s,l]of this)r(l,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const l=s.pop();l&&(l.value&&(yield[l.key,l.value]),l.left&&s.push(l.left),l.mid&&s.push(l.mid),l.right&&s.push(l.right))}}}e.TernarySearchTree=p;class u{constructor(r,s){this[M]="ResourceMap",r instanceof u?(this.map=new Map(r.map),this.toKey=s??u.defaultToKey):(this.map=new Map,this.toKey=r??u.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[l,g]of this.map)r(g,k.URI.parse(l),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield k.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[k.URI.parse(r[0]),r[1]]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[k.URI.parse(r[0]),r[1]]}}e.ResourceMap=u,u.defaultToKey=a=>a.toString();var h;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class o{constructor(){this[E]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const l=this._map.get(r);if(!!l)return s!==0&&this.touch(l,s),l.value}set(r,s,l=0){let g=this._map.get(r);if(g)g.value=s,l!==0&&this.touch(g,l);else{switch(g={key:r,value:s,next:void 0,previous:void 0},l){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(r,g),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const l=this._state;let g=this._head;for(;g;){if(s?r.bind(s)(g.value,g.key,this):r(g.value,g.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const r=this,s=this._state;let l=this._head;const g={[Symbol.iterator](){return g},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:l.key,done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return g}values(){const r=this,s=this._state;let l=this._head;const g={[Symbol.iterator](){return g},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:l.value,done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return g}entries(){const r=this,s=this._state;let l=this._head;const g={[Symbol.iterator](){return g},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:[l.key,l.value],done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return g}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,l=this.size;for(;s&&l>r;)this._map.delete(s.key),s=s.next,l--;this._head=s,this._size=l,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,l=r.previous;if(!s||!l)throw new Error("Invalid list");s.previous=l,l.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const l=r.next,g=r.previous;r===this._tail?(g.next=void 0,this._tail=g):(l.previous=g,g.next=l),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const l=r.next,g=r.previous;r===this._head?(l.previous=void 0,this._head=l):(l.previous=g,g.next=l),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,l)=>{r.push([l,s])}),r}fromJSON(r){this.clear();for(const[s,l]of r)this.set(s,l)}}e.LinkedMap=o;class c extends o{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class i{constructor(r){n.set(this,void 0),bt(this,n,r,"f")}get size(){return qe(this,n,"f").size}forEach(r,s){qe(this,n,"f").forEach(r,s)}get(r){return qe(this,n,"f").get(r)}has(r){return qe(this,n,"f").has(r)}entries(){return qe(this,n,"f").entries()}keys(){return qe(this,n,"f").keys()}values(){return qe(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return qe(this,n,"f").entries()}}e.ReadonlyMapView=i}),define(Z[110],x([0,1,18,25,7]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function M(t){return JSON.stringify(t,f)}e.stringify=M;function E(t){let P=JSON.parse(t);return P=w(P),P}e.parse=E;var n;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(n=e.MarshalledId||(e.MarshalledId={}));function f(t,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,L.regExpFlags)(P)}:P}function w(t,P=0){if(!t||P>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return k.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof y.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let b=0;b<t.length;++b)t[b]=w(t[b],P+1);else for(const b in t)Object.hasOwnProperty.call(t,b)&&(t[b]=w(t[b],P+1))}return t}e.revive=w}),define(Z[10],x([0,1,3,7]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,w,t){this._hosts[f]=w,this._ports[f]=t}setConnectionToken(f,w){this._connectionTokens[f]=w}rewrite(f){if(this._delegate)return this._delegate(f);const w=f.authority;let t=this._hosts[w];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const P=this._ports[w],b=this._connectionTokens[w];let v=`path=${encodeURIComponent(f.path)}`;return typeof b=="string"&&(v+=`&tkn=${encodeURIComponent(b)}`),L.URI.from({scheme:y.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${t}:${P}`,path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new M;class E{asBrowserUri(f,w){const t=this.toUri(f,w);return t.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===k.file&&(y.isNative||typeof y.globals.importScripts=="function"&&y.globals.origin===`${k.vscodeFileResource}://${E.FALLBACK_AUTHORITY}`)?t.with({scheme:k.vscodeFileResource,authority:t.authority||E.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(f,w){const t=this.toUri(f,w);return t.scheme===k.vscodeFileResource?t.with({scheme:k.file,authority:t.authority!==E.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(f,w){return L.URI.isUri(f)?f:L.URI.parse(w.toUrl(f))}}E.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new E}),define(Z[65],x([0,1,37]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new y.LRUCache(1e4);function k(w){return f(w,"NFC",L)}e.normalizeNFC=k;const M=new y.LRUCache(1e4);function E(w){return f(w,"NFD",M)}e.normalizeNFD=E;const n=/[^\u0000-\u0080]/;function f(w,t,P){if(!w)return w;const b=P.get(w);if(b)return b;let v;return n.test(w)?v=w.normalize(t):v=w,P.set(w,v),v}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(t){return E(t).replace(w,"")}}()}),define(Z[15],x([0,1,29,10,8,3,25,7]),function(K,e,y,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(v){return(0,n.uriToFsPath)(v,!0)}e.originalFSPath=f;class w{constructor(d){this._ignorePathCasing=d}compare(d,m,I=!1){return d===m?0:(0,E.compare)(this.getComparisonKey(d,I),this.getComparisonKey(m,I))}isEqual(d,m,I=!1){return d===m?!0:!d||!m?!1:this.getComparisonKey(d,I)===this.getComparisonKey(m,I)}getComparisonKey(d,m=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,m,I=!1){if(d.scheme===m.scheme){if(d.scheme===L.Schemas.file)return y.isEqualOrParent(f(d),f(m),this._ignorePathCasing(d))&&d.query===m.query&&(I||d.fragment===m.fragment);if((0,e.isEqualAuthority)(d.authority,m.authority))return y.isEqualOrParent(d.path,m.path,this._ignorePathCasing(d),"/")&&d.query===m.query&&(I||d.fragment===m.fragment)}return!1}joinPath(d,...m){return n.URI.joinPath(d,...m)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let m;return d.scheme===L.Schemas.file?m=n.URI.file(k.dirname(f(d))).path:(m=k.posix.dirname(d.path),d.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),m="/")),d.with({path:m})}normalizePath(d){if(!d.path.length)return d;let m;return d.scheme===L.Schemas.file?m=n.URI.file(k.normalize(f(d))).path:m=k.posix.normalize(d.path),d.with({path:m})}relativePath(d,m){if(d.scheme!==m.scheme||!(0,e.isEqualAuthority)(d.authority,m.authority))return;if(d.scheme===L.Schemas.file){const u=k.relative(f(d),f(m));return M.isWindows?y.toSlashes(u):u}let I=d.path||"/",p=m.path||"/";if(this._ignorePathCasing(d)){let u=0;for(const h=Math.min(I.length,p.length);u<h&&!(I.charCodeAt(u)!==p.charCodeAt(u)&&I.charAt(u).toLowerCase()!==p.charAt(u).toLowerCase());u++);I=p.substr(0,u)+I.substr(u)}return k.posix.relative(I,p)}resolvePath(d,m){if(d.scheme===L.Schemas.file){const I=n.URI.file(k.resolve(f(d),m));return d.with({authority:I.authority,path:I.path})}return m=y.toPosixPath(m),d.with({path:k.posix.resolve(d.path,m)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,m){return d===m||(0,E.equalsIgnoreCase)(d,m)}hasTrailingPathSeparator(d,m=k.sep){if(d.scheme===L.Schemas.file){const I=f(d);return I.length>y.getRoot(I).length&&I[I.length-1]===m}else{const I=d.path;return I.length>1&&I.charCodeAt(I.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,m=k.sep){return(0,e.hasTrailingPathSeparator)(d,m)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,m=k.sep){let I=!1;if(d.scheme===L.Schemas.file){const p=f(d);I=p!==void 0&&p.length===y.getRoot(p).length&&p[p.length-1]===m}else{m="/";const p=d.path;I=p.length===1&&p.charCodeAt(p.length-1)===47}return!I&&!(0,e.hasTrailingPathSeparator)(d,m)?d.with({path:d.path+"/"}):d}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(v=>v.scheme===L.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new w(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(v,d){const m=[];for(let I=0;I<v.length;I++){const p=d(v[I]);v.some((u,h)=>h===I?!1:(0,e.isEqualOrParent)(p,d(u)))||m.push(v[I])}return m}e.distinctParents=t;var P;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function d(m){const I=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(h=>{const[o,c]=h.split(":");o&&c&&I.set(o,c)});const u=m.path.substring(0,m.path.indexOf(";"));return u&&I.set(v.META_DATA_MIME,u),I}v.parseMetaData=d})(P=e.DataUri||(e.DataUri={}));function b(v,d,m){if(d){let I=v.path;return I&&I[0]!==k.posix.sep&&(I=k.posix.sep+I),v.with({scheme:m,authority:d,path:I})}return v.with({scheme:m})}e.toLocalResource=b}),define(Z[9],x([0,1,24,17,4,2,15]),function(K,e,y,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function n(B){return!!B&&typeof B.then=="function"}e.isThenable=n;function f(B){const $=new y.CancellationTokenSource,H=B($.token),_=new Promise((j,T)=>{const R=$.token.onCancellationRequested(()=>{R.dispose(),$.dispose(),T((0,L.canceled)())});Promise.resolve(H).then(O=>{R.dispose(),$.dispose(),j(O)},O=>{R.dispose(),$.dispose(),T(O)})});return new class{cancel(){$.cancel()}then(j,T){return _.then(j,T)}catch(j){return this.then(void 0,j)}finally(j){return _.finally(j)}}}e.createCancelablePromise=f;function w(B,$,H){return Promise.race([B,new Promise(_=>$.onCancellationRequested(()=>_(H)))])}e.raceCancellation=w;async function t(B){let $=-1;const H=B.map((j,T)=>j.then(R=>($=T,R))),_=await Promise.race(H);return B.forEach((j,T)=>{T!==$&&j.cancel()}),_}e.raceCancellablePromises=t;function P(B,$,H){let _;const j=setTimeout(()=>{_?.(void 0),H?.()},$);return Promise.race([B.finally(()=>clearTimeout(j)),new Promise(T=>_=T)])}e.raceTimeout=P;function b(B){return new Promise(($,H)=>{const _=B();n(_)?_.then($,H):$(_)})}e.asPromise=b;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const H=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(H,H).then(_)})}return new Promise((H,_)=>{this.queuedPromise.then(H,_)})}return this.activePromise=$(),new Promise((H,_)=>{this.activePromise.then(j=>{this.activePromise=null,H(j)},j=>{this.activePromise=null,_(j)})})}}e.Throttler=v;class d{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=d;class m{constructor(){this.promiseMap=new Map}queue($,H){const j=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get($)===j&&this.promiseMap.delete($)});return this.promiseMap.set($,j),j}}e.SequencerByKey=m;class I{constructor($){this.defaultDelay=$,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,H=this.defaultDelay){return this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,j)=>{this.doResolve=_,this.doReject=j}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},H),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=I;class p{constructor($){this.delayer=new I($),this.throttler=new v}trigger($,H){return this.delayer.trigger(()=>this.throttler.queue($),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class u{constructor(){this._isOpen=!1,this._promise=new Promise(($,H)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class h extends u{constructor($){super();this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function o(B,$){return $?new Promise((H,_)=>{const j=setTimeout(()=>{T.dispose(),H()},B),T=$.onCancellationRequested(()=>{clearTimeout(j),T.dispose(),_((0,L.canceled)())})}):f(H=>o(B,H))}e.timeout=o;function c(B,$=0){const H=setTimeout(B,$);return(0,M.toDisposable)(()=>clearTimeout(H))}e.disposableTimeout=c;function i(B){const $=[];let H=0;const _=B.length;function j(){return H<_?B[H++]():null}function T(R){R!=null&&$.push(R);const O=j();return O?O.then(T):Promise.resolve($)}return Promise.resolve(null).then(T)}e.sequence=i;function a(B,$=_=>!!_,H=null){let _=0;const j=B.length,T=()=>{if(_>=j)return Promise.resolve(H);const R=B[_++];return Promise.resolve(R()).then(z=>$(z)?Promise.resolve(z):T())};return T()}e.first=a;function r(B,$=_=>!!_,H=null){if(B.length===0)return Promise.resolve(H);let _=B.length;const j=()=>{_=-1;for(const T of B)T.cancel?.()};return new Promise((T,R)=>{for(const O of B)O.then(z=>{--_>=0&&$(z)?(j(),T(z)):_===0&&T(H)}).catch(z=>{--_>=0&&(j(),R(z))})})}e.firstParallel=r;class s{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue($){return this._size++,new Promise((H,_)=>{this.outstandingPromises.push({factory:$,c:H,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const H=$.factory();H.then($.c,$.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class l extends s{constructor(){super(1)}}e.Queue=l;class g{constructor(){this.queues=new Map}queueFor($,H=E.extUri){const _=H.getComparisonKey($);let j=this.queues.get(_);return j||(j=new l,k.Event.once(j.onFinished)(()=>{j?.dispose(),this.queues.delete(_)}),this.queues.set(_,j)),j}dispose(){this.queues.forEach($=>$.dispose()),this.queues.clear()}}e.ResourceQueue=g;class S{constructor($,H){this._token=-1,typeof $=="function"&&typeof H=="number"&&this.setIfNotSet($,H)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,H){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},H)}setIfNotSet($,H){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},H))}}e.TimeoutTimer=S;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet($,H){this.cancel(),this._token=setInterval(()=>{$()},H)}}e.IntervalTimer=D;class A{constructor($,H){this.timeoutToken=-1,this.runner=$,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class F{constructor($,H){H%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=H,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=F;class U extends A{constructor($,H){super($,H);this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner&&this.runner($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class X extends M.Disposable{constructor($,H,_,j){super();this.maxWorkChunkSize=$,this.maxPendingWork=H,this.throttleDelay=_,this.handler=j,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.maxPendingWork)return!1}else if(this.pending+$.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...$),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new A(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=X,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const B=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=$=>{const H=setTimeout(()=>$(B));let _=!1;return{dispose(){_||(_=!0,clearTimeout(H))}}}}else e.runWhenIdle=(B,$)=>{const H=requestIdleCallback(B,typeof $=="number"?{timeout:$}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(H))}}}}();class ne{constructor($){this._didRun=!1,this._executor=()=>{try{this._value=$()}catch(H){this._error=H}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ne;async function se(B,$,H){let _;for(let j=0;j<H;j++)try{return await B()}catch(T){_=T,await o($)}throw _}e.retry=se;class G{hasPending($){return this._pending?typeof $=="number"?this._pending.taskId===$:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending($,H,_){return this._pending={taskId:$,cancel:()=>_?.(),promise:H},H.then(()=>this.donePending($),()=>this.donePending($)),H}donePending($){this._pending&&$===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const $=this._next;this._next=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this._next)this._next.run=$;else{let H,_;const j=new Promise((T,R)=>{H=T,_=R});this._next={run:$,promise:j,promiseResolve:H,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=G;class J{constructor($){this.interval=$,this.lastIncrementTime=0,this.value=0}increment(){const $=Date.now();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=J;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise(($,H)=>{this.completeCallback=$,this.errorCallback=H})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete($){return new Promise(H=>{this.completeCallback($),this.resolved=!0,H()})}error($){return new Promise(H=>{this.errorCallback($),this.rejected=!0,H()})}cancel(){new Promise($=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,$()})}}e.DeferredPromise=W;var V;(function(B){async function $(H){let _;const j=await Promise.all(H.map(T=>T.then(R=>R,R=>{_||(_=R)})));if(typeof _!="undefined")throw _;return j}B.settled=$})(V=e.Promises||(e.Promises={}))}),define(Z[111],x([0,1,9,29,37,8,25]),function(K,e,y,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const f="**",w="/",t="[/\\\\]",P="[^/\\\\]",b=/\//g;function v(_){switch(_){case 0:return"";case 1:return`${P}*?`;default:return`(?:${t}|${P}+${t}|${t}${P}+)*?`}}function d(_,j){if(!_)return[];const T=[];let R=!1,O=!1,z="";for(const N of _){switch(N){case j:if(!R&&!O){T.push(z),z="";continue}break;case"{":R=!0;break;case"}":R=!1;break;case"[":O=!0;break;case"]":O=!1;break}z+=N}return z&&T.push(z),T}e.splitGlobAware=d;function m(_){if(!_)return"";let j="";const T=d(_,w);if(T.every(R=>R===f))j=".*";else{let R=!1;T.forEach((O,z)=>{if(O===f){R||(j+=v(2),R=!0);return}let N=!1,C="",q=!1,Q="";for(const ie of O){if(ie!=="}"&&N){C+=ie;continue}if(q&&(ie!=="]"||!Q)){let oe;ie==="-"?oe=ie:(ie==="^"||ie==="!")&&!Q?oe="^":ie===w?oe="":oe=E.escapeRegExpCharacters(ie),Q+=oe;continue}switch(ie){case"{":N=!0;continue;case"[":q=!0;continue;case"}":j+=`(?:${d(C,",").map(ee=>m(ee)).join("|")})`,N=!1,C="";break;case"]":j+="["+Q+"]",q=!1,Q="";break;case"?":j+=P;continue;case"*":j+=v(1);continue;default:j+=E.escapeRegExpCharacters(ie)}}z<T.length-1&&(T[z+1]!==f||z+2<T.length)&&(j+=t),R=!1})}return j}const I=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new k.LRUCache(1e4),a=function(){return!1},r=function(){return null};function s(_,j){if(!_)return r;let T;typeof _!="string"?T=_.pattern:T=_,T=T.trim();const R=`${T}_${!!j.trimForExclusions}`;let O=i.get(R);if(O)return l(O,_);let z;if(I.test(T)){const N=T.substr(4);O=function(C,q){return typeof C=="string"&&C.endsWith(N)?T:null}}else(z=p.exec(g(T,j)))?O=S(z[1],T):(j.trimForExclusions?h:u).test(T)?O=D(T,j):(z=o.exec(g(T,j)))?O=A(z[1].substr(1),T,!0):(z=c.exec(g(T,j)))?O=A(z[1],T,!1):O=F(T);return i.set(R,O),l(O,_)}function l(_,j){return typeof j=="string"?_:function(T,R){return L.isEqualOrParent(T,j.base)?_(M.relative(j.base,T),R):null}}function g(_,j){return j.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function S(_,j){const T=`/${_}`,R=`\\${_}`,O=function(N,C){return typeof N!="string"?null:C?C===_?j:null:N===_||N.endsWith(T)||N.endsWith(R)?j:null},z=[_];return O.basenames=z,O.patterns=[j],O.allBasenames=z,O}function D(_,j){const T=H(_.slice(1,-1).split(",").map(C=>s(C,j)).filter(C=>C!==r),_),R=T.length;if(!R)return r;if(R===1)return T[0];const O=function(C,q){for(let Q=0,ie=T.length;Q<ie;Q++)if(T[Q](C,q))return _;return null},z=T.find(C=>!!C.allBasenames);z&&(O.allBasenames=z.allBasenames);const N=T.reduce((C,q)=>q.allPaths?C.concat(q.allPaths):C,[]);return N.length&&(O.allPaths=N),O}function A(_,j,T){const R=M.sep===M.posix.sep,O=R?_:_.replace(b,M.sep),z=M.sep+O,N=M.posix.sep+_,C=T?function(q,Q){return typeof q=="string"&&(q===O||q.endsWith(z)||!R&&(q===_||q.endsWith(N)))?j:null}:function(q,Q){return typeof q=="string"&&(q===O||!R&&q===_)?j:null};return C.allPaths=[(T?"*/":"./")+_],C}function F(_){try{const j=new RegExp(`^${m(_)}$`);return function(T){return j.lastIndex=0,typeof T=="string"&&j.test(T)?_:null}}catch(j){return r}}function U(_,j,T){return!_||typeof j!="string"?!1:X(_)(j,void 0,T)}e.match=U;function X(_,j={}){if(!_)return a;if(typeof _=="string"||J(_)){const T=s(_,j);if(T===r)return a;const R=function(O,z){return!!T(O,z)};return T.allBasenames&&(R.allBasenames=T.allBasenames),T.allPaths&&(R.allPaths=T.allPaths),R}return B(_,j)}e.parse=X;function ne(_){if(!_)return;let j;return T=>(j||(j=(_()||Promise.resolve([])).then(R=>R?G(R):{})),j.then(R=>!!R[T]))}e.hasSiblingPromiseFn=ne;function se(_){if(!_)return;let j;return T=>{if(!j){const R=_();j=R?G(R):{}}return!!j[T]}}e.hasSiblingFn=se;function G(_){const j={};for(const T of _)j[T]=!0;return j}function J(_){const j=_;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=J;function W(_){return _.allBasenames||[]}e.getBasenameTerms=W;function V(_){return _.allPaths||[]}e.getPathTerms=V;function B(_,j){const T=H(Object.getOwnPropertyNames(_).map(C=>$(C,_[C],j)).filter(C=>C!==r)),R=T.length;if(!R)return r;if(!T.some(C=>!!C.requiresSiblings)){if(R===1)return T[0];const C=function(ie,oe){for(let ae=0,ee=T.length;ae<ee;ae++){const le=T[ae](ie,oe);if(le)return le}return null},q=T.find(ie=>!!ie.allBasenames);q&&(C.allBasenames=q.allBasenames);const Q=T.reduce((ie,oe)=>oe.allPaths?ie.concat(oe.allPaths):ie,[]);return Q.length&&(C.allPaths=Q),C}const O=function(C,q,Q){let ie;for(let oe=0,ae=T.length;oe<ae;oe++){const ee=T[oe];ee.requiresSiblings&&Q&&(q||(q=M.basename(C)),ie||(ie=q.substr(0,q.length-M.extname(C).length)));const le=ee(C,q,ie,Q);if(le)return le}return null},z=T.find(C=>!!C.allBasenames);z&&(O.allBasenames=z.allBasenames);const N=T.reduce((C,q)=>q.allPaths?C.concat(q.allPaths):C,[]);return N.length&&(O.allPaths=N),O}function $(_,j,T){if(j===!1)return r;const R=s(_,T);if(R===r)return r;if(typeof j=="boolean")return R;if(j){const O=j.when;if(typeof O=="string"){const z=(N,C,q,Q)=>{if(!Q||!R(N,C))return null;const ie=O.replace("$(basename)",q),oe=Q(ie);return(0,y.isThenable)(oe)?oe.then(ae=>ae?_:null):oe?_:null};return z.requiresSiblings=!0,z}}return R}function H(_,j){const T=_.filter(C=>!!C.basenames);if(T.length<2)return _;const R=T.reduce((C,q)=>{const Q=q.basenames;return Q?C.concat(Q):C},[]);let O;if(j){O=[];for(let C=0,q=R.length;C<q;C++)O.push(j)}else O=T.reduce((C,q)=>{const Q=q.patterns;return Q?C.concat(Q):C},[]);const z=function(C,q){if(typeof C!="string")return null;if(!q){let ie;for(ie=C.length;ie>0;ie--){const oe=C.charCodeAt(ie-1);if(oe===47||oe===92)break}q=C.substr(ie)}const Q=R.indexOf(q);return Q!==-1?O[Q]:null};z.basenames=R,z.patterns=O,z.allBasenames=R;const N=_.filter(C=>!C.basenames);return N.push(z),N}}),define(Z[33],x([0,1,29,10,8,3,15,25,7]),function(K,e,y,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function w(s,l,g){if(typeof s=="string"&&(s=f.URI.file(s)),g){const D=g.getWorkspaceFolder(s);if(D){const A=g.getWorkspace().folders.length>1;let F;if((0,E.isEqual)(D.uri,s)?F="":F=(0,E.relativePath)(D.uri,s),A){const U=D.name?D.name:(0,E.basename)(D.uri);F=F?U+" \u2022 "+F:U}return F}}if(s.scheme!==L.Schemas.file&&s.scheme!==L.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(s.fsPath))return(0,k.normalize)(P(s.fsPath));let S=(0,k.normalize)(s.fsPath);return!M.isWindows&&l?.userHome&&(S=v(S,l.userHome.fsPath)),S}e.getPathLabel=w;function t(s){if(!s)return;typeof s=="string"&&(s=f.URI.file(s));const l=(0,E.basename)(s)||(s.scheme===L.Schemas.file?s.fsPath:s.path);return M.isWindows&&(0,y.isRootOrDriveLetter)(l)?P(l):l}e.getBaseLabel=t;function P(s){return(0,y.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=P;let b=Object.create(null);function v(s,l){if(M.isWindows||!s||!l)return s;let g=b.original===l?b.normalized:void 0;return g||(g=`${(0,n.rtrim)(l,k.posix.sep)}${k.posix.sep}`,b={original:l,normalized:g}),(M.isLinux?s.startsWith(g):(0,n.startsWithIgnoreCase)(s,g))&&(s=`~/${s.substr(g.length)}`),s}e.tildify=v;function d(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=d;const m="\u2026",I="\\\\",p="~";function u(s,l=k.sep){const g=new Array(s.length);let S=!1;for(let D=0;D<s.length;D++){let A=s[D];if(A===""){g[D]=`.${l}`;continue}if(!A){g[D]=A;continue}S=!0;let F="";A.indexOf(I)===0?(F=A.substr(0,A.indexOf(I)+I.length),A=A.substr(A.indexOf(I)+I.length)):A.indexOf(l)===0?(F=A.substr(0,A.indexOf(l)+l.length),A=A.substr(A.indexOf(l)+l.length)):A.indexOf(p)===0&&(F=A.substr(0,A.indexOf(p)+p.length),A=A.substr(A.indexOf(p)+p.length));const U=A.split(l);for(let X=1;S&&X<=U.length;X++)for(let ne=U.length-X;S&&ne>=0;ne--){S=!1;let se=U.slice(ne,ne+X).join(l);for(let G=0;!S&&G<s.length;G++)if(G!==D&&s[G]&&s[G].indexOf(se)>-1){const J=ne+X===U.length,W=ne>0&&s[G].indexOf(l)>-1?l+se:se,V=s[G].endsWith(W);S=!J||V}if(!S){let G="";(U[0].endsWith(":")||F!=="")&&(ne===1&&(ne=0,X++,se=U[0]+l+se),ne>0&&(G=U[0]+l),G=F+G),ne>0&&(G=G+m+l),G=G+se,ne+X<U.length&&(G=G+l+m),g[D]=G}}S&&(g[D]=A)}return g}e.shorten=u;var h;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(s,l=Object.create(null)){const g=[];let S=!1,D="";for(const A of s)if(A==="$"||S&&A==="{")D&&g.push({value:D,type:h.TEXT}),D="",S=!0;else if(A==="}"&&S){const F=l[D];if(typeof F=="string")F.length&&g.push({value:F,type:h.VARIABLE});else if(F){const U=g[g.length-1];(!U||U.type!==h.SEPARATOR)&&g.push({value:F.label,type:h.SEPARATOR})}D="",S=!1}else D+=A;return D&&!S&&g.push({value:D,type:h.TEXT}),g.filter((A,F)=>{if(A.type===h.SEPARATOR){const U=g[F-1],X=g[F+1];return[U,X].every(ne=>ne&&(ne.type===h.VARIABLE||ne.type===h.TEXT)&&ne.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=o;function c(s,l){return M.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):s.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function i(s,l){return M.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,""):M.isWindows?s.replace(/&&|&/g,g=>g==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function a(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=a;function r(s){const l=s.indexOf("/")!==-1?k.posix:k.win32,g=l.basename(s),S=l.dirname(s);return g.length?{name:g,parentPath:S}:{name:S,parentPath:""}}e.splitName=r}),define(Z[28],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(f){return y.test(f)}e.isUUID=L;const k=new Uint8Array(16),M=[];for(let f=0;f<256;f++)M.push(f.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(f){for(let w=0;w<f.length;w++)f[w]=Math.floor(Math.random()*256);return f};function n(){E(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let f=0,w="";return w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w}e.generateUuid=n}),define(Z[112],x([0,1,58,30,43]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(E,n){if(await new Promise((t,P)=>{const b=L.createReadStream(E),v=y.createHash("sha1");b.pipe(v);const d=(0,k.once)((m,I)=>{b.removeAllListeners(),v.removeAllListeners(),m?P(m):t(I)});b.once("error",d),b.once("end",d),v.once("error",d),v.once("data",m=>d(void 0,m.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=M}),define(Z[80],x([0,1,239]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(M="utf8"){this.stringDecoder=new y.StringDecoder(M),this.remaining=null}write(M){const E=[],n=this.remaining?this.remaining+this.stringDecoder.write(M):this.stringDecoder.write(M);if(n.length<1)return E;let f=0,w,t=f;for(;t<n.length;)if(w=n.charCodeAt(t),w===13||w===10){if(E.push(n.substring(f,t)),t++,t<n.length){const P=w;w=n.charCodeAt(t),(P===13&&w===10||P===10&&w===13)&&t++}f=t}else t++;return this.remaining=f<n.length?n.substr(f):null,E}end(){return this.remaining}}e.LineDecoder=L}),define(Z[113],x([0,1,26]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(n){const f=n.replace(/\-/g,":").toLowerCase();return!L.has(f)}function M(){return new Promise(async(n,f)=>{const w=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await E())}catch(t){f(t)}finally{clearTimeout(w)}})}e.getMac=M;function E(){return new Promise((n,f)=>{try{const w=(0,y.networkInterfaces)();for(let t in w){const P=w[t];if(P){for(const{mac:b}of P)if(k(b))return n(b)}}f("Unable to retrieve mac address (unexpected format)")}catch(w){f(w)}})}}),define(Z[66],x([0,1,26,17,37,28,113]),function(K,e,y,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(t){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(t)}value(){if(this._value===void 0){let t=0,P=0;const b=(0,y.networkInterfaces)();for(let v in b){const d=b[v];if(d)for(const{mac:m,internal:I}of d)I||(P+=1,this._isVirtualMachineMacAddress(m.toUpperCase())&&(t+=1))}this._value=P>0?t/P:0}return this._value}};let n;async function f(){return n||(n=(async()=>await w()||M.generateUuid())()),n}e.getMachineId=f;async function w(){try{const t=await new Promise((b,v)=>{K(["crypto"],b,v)}),P=await(0,E.getMac)();return t.createHash("sha256").update(P,"utf8").digest("hex")}catch(t){L.onUnexpectedError(t);return}}}),define(Z[19],x([0,1,30,26,114,9,29,65,8,3,15,7,28]),function(K,e,y,L,k,M,E,n,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function d(W,V=v.UNLINK){if((0,E.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return V===v.UNLINK?I(W):m(W)}async function m(W){try{const V=(0,f.join)((0,L.tmpdir)(),(0,b.generateUuid)());try{await e.Promises.rename(W,V)}catch(B){return I(W)}I(V).catch(B=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function I(W){return e.Promises.rmdir(W,{recursive:!0,maxRetries:3})}function p(W){if((0,E.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");y.rmdirSync(W,{recursive:!0})}e.rimrafSync=p;async function u(W,V){return c(await(V?h(W):(0,k.promisify)(y.readdir)(W)))}async function h(W){try{return await(0,k.promisify)(y.readdir)(W,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const V=[],B=await u(W);for(const $ of B){let H=!1,_=!1,j=!1;try{const T=await e.Promises.lstat((0,f.join)(W,$));H=T.isFile(),_=T.isDirectory(),j=T.isSymbolicLink()}catch(T){console.warn("[node.js fs] unexpected error from lstat after readdir: ",T)}V.push({name:$,isFile:()=>H,isDirectory:()=>_,isSymbolicLink:()=>j})}return V}function o(W){return c(y.readdirSync(W))}e.readdirSync=o;function c(W){return W.map(V=>typeof V=="string"?w.isMacintosh?(0,n.normalizeNFC)(V):V:(V.name=w.isMacintosh?(0,n.normalizeNFC)(V.name):V.name,V))}async function i(W){const V=await u(W),B=[];for(const $ of V)await r.existsDirectory((0,f.join)(W,$))&&B.push($);return B}function a(W,V=1e3){return new Promise(B=>{let $=!1;const H=setInterval(()=>{$||($=!0,y.access(W,_=>{$=!1,_&&(clearInterval(H),B(void 0))}))},V)})}e.whenDeleted=a;var r;(function(W){async function V(H){let _;try{if(_=await e.Promises.lstat(H),!_.isSymbolicLink())return{stat:_}}catch(j){}try{return{stat:await e.Promises.stat(H),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(w.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(T){if(T.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw T}throw j}}W.stat=V;async function B(H){try{const{stat:_,symbolicLink:j}=await W.stat(H);return _.isFile()&&j?.dangling!==!0}catch(_){}return!1}W.existsFile=B;async function $(H){try{const{stat:_,symbolicLink:j}=await W.stat(H);return _.isDirectory()&&j?.dangling!==!0}catch(_){}return!1}W.existsDirectory=$})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new M.ResourceQueue;function l(W,V,B){return s.queueFor(P.URI.file(W),t.extUriBiasedIgnorePathCase).queue(()=>{const $=A(B);return new Promise((H,_)=>S(W,V,$,j=>j?_(j):H()))})}let g=!0;function S(W,V,B,$){if(!g)return y.writeFile(W,V,{mode:B.mode,flag:B.flag},$);y.open(W,B.flag,B.mode,(H,_)=>{if(H)return $(H);y.writeFile(_,V,j=>{if(j)return y.close(_,()=>$(j));y.fdatasync(_,T=>(T&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",T),g=!1),y.close(_,R=>$(R))))})})}function D(W,V,B){const $=A(B);if(!g)return y.writeFileSync(W,V,{mode:$.mode,flag:$.flag});const H=y.openSync(W,$.flag,$.mode);try{y.writeFileSync(H,V);try{y.fdatasyncSync(H)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),g=!1}}finally{y.closeSync(H)}}e.writeFileSync=D;function A(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function F(W,V){if(W===V)return;async function B($){try{const H=await e.Promises.lstat($);if(H.isDirectory()||H.isSymbolicLink())return;await e.Promises.utimes($,H.atime,new Date)}catch(H){}}try{await e.Promises.rename(W,V),await B(V)}catch($){if(W.toLowerCase()!==V.toLowerCase()&&$.code==="EXDEV"||W.endsWith("."))await U(W,V,{preserveSymlinks:!1}),await d(W,v.MOVE),await B(V);else throw $}}async function U(W,V,B){return ne(W,V,{root:{source:W,target:V},options:B,handledSourcePaths:new Set})}const X=511;async function ne(W,V,B){if(B.handledSourcePaths.has(W))return;B.handledSourcePaths.add(W);const{stat:$,symbolicLink:H}=await r.stat(W);if(H){if(B.options.preserveSymlinks)try{return await J(W,V,B)}catch(_){console.warn("[node.js fs] copy of symlink failed: ",_)}if(H.dangling)return}return $.isDirectory()?se(W,V,$.mode&X,B):G(W,V,$.mode&X)}async function se(W,V,B,$){await e.Promises.mkdir(V,{recursive:!0,mode:B});const H=await u(W);for(const _ of H)await ne((0,f.join)(W,_),(0,f.join)(V,_),$)}async function G(W,V,B){await e.Promises.copyFile(W,V),await e.Promises.chmod(V,B)}async function J(W,V,B){let $=await e.Promises.readlink(W);(0,E.isEqualOrParent)($,B.root.source,!w.isLinux)&&($=(0,f.join)(B.root.target,$.substr(B.root.source.length+1))),await e.Promises.symlink($,V)}e.Promises=new class{get access(){return(0,k.promisify)(y.access)}get stat(){return(0,k.promisify)(y.stat)}get lstat(){return(0,k.promisify)(y.lstat)}get utimes(){return(0,k.promisify)(y.utimes)}get read(){return(0,k.promisify)(y.read)}get readFile(){return(0,k.promisify)(y.readFile)}get write(){return(0,k.promisify)(y.write)}get appendFile(){return(0,k.promisify)(y.appendFile)}get fdatasync(){return(0,k.promisify)(y.fdatasync)}get truncate(){return(0,k.promisify)(y.truncate)}get rename(){return(0,k.promisify)(y.rename)}get copyFile(){return(0,k.promisify)(y.copyFile)}get open(){return(0,k.promisify)(y.open)}get close(){return(0,k.promisify)(y.close)}get symlink(){return(0,k.promisify)(y.symlink)}get readlink(){return(0,k.promisify)(y.readlink)}get chmod(){return(0,k.promisify)(y.chmod)}get mkdir(){return(0,k.promisify)(y.mkdir)}get unlink(){return(0,k.promisify)(y.unlink)}get rmdir(){return(0,k.promisify)(y.rmdir)}get realpath(){return(0,k.promisify)(y.realpath)}async exists(W){try{return await e.Promises.access(W),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return i}get writeFile(){return l}get rm(){return d}get move(){return F}get copy(){return U}}}),define(Z[81],x([0,1,30,8,25,19]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function E(t){const P=(0,L.dirname)(t);if(t===P)return t;const b=((0,L.basename)(t)||t).toLowerCase();try{const d=(0,M.readdirSync)(P).filter(m=>m.toLowerCase()===b);if(d.length===1){const m=E(P);if(m)return(0,L.join)(m,d[0])}else if(d.length>1){const m=d.indexOf(b);if(m>=0){const I=E(P);if(I)return(0,L.join)(I,d[m])}}}catch(v){}return null}e.realcaseSync=E;async function n(t){try{return await M.Promises.realpath(t)}catch(P){const b=w(t);return await M.Promises.access(b,y.constants.R_OK),b}}e.realpath=n;function f(t){try{return y.realpathSync(t)}catch(P){const b=w(t);return y.accessSync(b,y.constants.R_OK),b}}e.realpathSync=f;function w(t){return(0,k.rtrim)((0,L.normalize)(t),L.sep)}}),define(Z[115],x([0,1,59]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(n,f,w,t=1){let P=!1;return new Promise(b=>{const v=setTimeout(()=>{if(!P)return P=!0,b(0)},w);k(n,f,t,d=>{if(!P)return P=!0,clearTimeout(v),b(d)})})}e.findFreePort=L;function k(n,f,w,t){if(f===0)return t(0);const P=new y.Socket;P.once("connect",()=>(E(P),k(n+w,f-1,w,t))),P.once("data",()=>{}),P.once("error",b=>(E(P),b.code!=="ECONNREFUSED"?k(n+w,f-1,w,t):t(n))),P.connect(n,"127.0.0.1")}function M(n,f,w){let t=!1,P,b=1;const v=y.createServer({pauseOnConnect:!0});function d(m,I){t||(t=!0,v.removeAllListeners(),v.close(),P&&clearTimeout(P),I(m))}return new Promise(m=>{P=setTimeout(()=>{d(0,m)},w),v.on("listening",()=>{d(n,m)}),v.on("error",I=>{I&&(I.code==="EADDRINUSE"||I.code==="EACCES")&&b<f?(n++,b++,v.listen(n,"127.0.0.1")):d(0,m)}),v.on("close",()=>{d(0,m)}),v.listen(n,"127.0.0.1")})}e.findFreePortFaster=M;function E(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(f){console.error(f)}}}),define(Z[116],x([0,1,26,8,19]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,E=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var f;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(f||(f={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let t;process.env.PROCESSOR_ARCHITEW6432?t=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?t=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?t=1:t=0;class P{constructor(c,i,a){this.exePath=c,this.displayName=i,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:o=!1}={}){return o?w===0?process.env["ProgramFiles(x86)"]||null:t===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:o=!1,findPreview:c=!1}={}){const i=b({useAlternateBitness:o});if(!i)return null;const a=L.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(a))return null;let r=-1,s=null;for(const S of await k.Promises.readdir(a)){let D=-1;if(c){const F=S.indexOf("-");if(F<0)continue;const U=S.substring(0,F);if(!M.test(U)||S.substring(F+1)!=="preview")continue;D=parseInt(U,10)}else{if(!M.test(S))continue;D=parseInt(S,10)}if(D<=r)continue;const A=L.join(a,S,"pwsh.exe");!await k.SymlinkSupport.existsFile(A)||(s=A,r=D)}if(!s)return null;const l=i.includes("x86")?" (x86)":"",g=c?" Preview":"";return new P(s,`PowerShell${g}${l}`,!0)}async function d({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const c=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:i,pwshMsixName:a}=o?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:E,pwshMsixName:"PowerShell (Store)"};for(const r of await k.Promises.readdir(c))if(i.test(r)){const s=L.join(c,r,"pwsh.exe");return new P(s,a)}return null}function m(){const o=L.join(y.homedir(),".dotnet","tools","pwsh.exe");return new P(o,".NET Core PowerShell Global Tool")}function I(){const o=L.join(process.env.windir,w===1&&t!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(o,"Windows PowerShell",!0)}async function*p(){let o=await v();o&&(yield o),o=await v({useAlternateBitness:!0}),o&&(yield o),o=await d(),o&&(yield o),o=m(),o&&(yield o),o=await v({findPreview:!0}),o&&(yield o),o=await d({findPreview:!0}),o&&(yield o),o=await v({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=I(),o&&(yield o)}async function*u(){for await(const o of p())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=u;async function h(){for await(const o of u())return o;return null}e.getFirstAvailablePowerShellInstallation=h}),define(Z[82],x([0,1,41,10]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(E){return new Promise((n,f)=>{let w;const t=new Map;function P(v,d,m,I,p){const u=t.get(d);if(v===E||u){const h={name:b(m),cmd:m,pid:v,ppid:d,load:I,mem:p};t.set(v,h),v===E&&(w=h),u&&(u.children||(u.children=[]),u.children.push(h),u.children.length>1&&(u.children=u.children.sort((o,c)=>o.pid-c.pid)))}}function b(v){const d=/--disable-blink-features=Auxclick/,m=/\\watcher\\win32\\CodeHelper\.exe/,I=/--crashes-directory/,p=/\\pipe\\winpty-control/,u=/conhost\.exe/,h=/--type=([a-zA-Z-]+)/;if(m.exec(v))return"watcherService ";if(I.exec(v))return"electron-crash-reporter";if(p.exec(v))return"winpty-process";if(u.exec(v))return"console-window-host (Windows internal process)";let o=h.exec(v);if(o&&o.length===2)return o[1]==="renderer"?d.exec(v)?"shared-process":"window":o[1];const c=/[a-zA-Z-]+\.js/g;let i="";do o=c.exec(v),o&&(i+=o+" ");while(o);return i&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${i}`:v}if(process.platform==="win32"){const v=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,m)=>{K(["windows-process-tree"],d,m)}).then(d=>{d.getProcessList(E,m=>{d.getProcessCpuUsage(m,I=>{const p=new Map;I.forEach(u=>{const h=v(u.commandLine||"");p.set(u.pid,{name:b(h),cmd:h,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),w=p.get(E),w?(p.forEach(u=>{const h=p.get(u.ppid);h&&(h.children||(h.children=[]),h.children.push(u))}),p.forEach(u=>{u.children&&(u.children=u.children.sort((h,o)=>h.pid-o.pid))}),n(w)):f(new Error(`Root process ${E} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let v=function(){let d=[w];const m=[];for(;d.length;){const p=d.shift();p&&(m.push(p.pid),p.children&&(d=d.concat(p.children)))}let I=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);I+=" "+m.join(" "),(0,y.exec)(I,{},(p,u,h)=>{if(p||h)f(p||new Error(h.toString()));else{const o=u.toString().split(`
`);for(let c=0;c<m.length;c++){const i=t.get(m[c]);i.load=parseFloat(o[c])}if(!w){f(new Error(`Root process ${E} not found`));return}n(w)}})};(0,y.exec)("which ps",{},(d,m,I)=>{if(d||I)if(process.platform!=="linux")f(d||new Error(I.toString()));else{const p=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,y.exec)(p,{},(u,h,o)=>{u||o?f(u||new Error(o.toString())):(M(h,P),v())})}else{const p=m.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,y.exec)(`${p} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,o,c)=>{h||c&&!c.includes("screen size is bogus")?f(h||new Error(c.toString())):(M(o,P),process.platform==="linux"?v():w?n(w):f(new Error(`Root process ${E} not found`)))})}})}})}e.listProcesses=k;function M(E,n){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=E.toString().split(`
`);for(const t of w){const P=f.exec(t.trim());P&&P.length===6&&n(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}}),define(Z[117],x([0,1,30,29,2,65,8,3,19]),function(K,e,y,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function w(b,v,d){return P({path:b,isDirectory:!1},v,d)}e.watchFile=w;function t(b,v,d){return P({path:b,isDirectory:!0},v,d)}e.watchFolder=t,e.CHANGE_BUFFER_DELAY=100;function P(b,v,d){if(n.isMacintosh&&(0,L.isEqualOrParent)(b.path,"/Volumes/"))return d(`Refusing to watch ${b.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const m=(0,E.basename)(b.path),I=new Map;let p=!1,u=[(0,k.toDisposable)(()=>{I.forEach(h=>(0,k.dispose)(h)),I.clear()})];try{const h=(0,y.watch)(b.path);u.push((0,k.toDisposable)(()=>{h.removeAllListeners(),h.close()}));const o=new Set;b.isDirectory&&f.Promises.readdir(b.path).then(c=>c.forEach(i=>o.add(i))),h.on("error",(c,i)=>{p||d(`Failed to watch ${b.path} for changes using fs.watch() (${c}, ${i})`)}),h.on("change",(c,i)=>{if(p)return;let a="";if(i&&(a=i.toString(),n.isMacintosh&&(a=(0,M.normalizeNFC)(a))),!a||c!=="change"&&c!=="rename")return;const r=b.isDirectory?(0,E.join)(b.path,a):b.path;if(b.isDirectory)if(c==="rename"){const s=I.get(r);s&&(0,k.dispose)(s);const l=setTimeout(async()=>{I.delete(r);const g=await f.Promises.exists(r);if(p)return;let S;g?o.has(a)?S="changed":(S="added",o.add(a)):(o.delete(a),S="deleted"),v(S,r)},e.CHANGE_BUFFER_DELAY);I.set(r,(0,k.toDisposable)(()=>clearTimeout(l)))}else{let s;o.has(a)?s="changed":(s="added",o.add(a)),v(s,r)}else if(c==="rename"||a!==m){const s=setTimeout(async()=>{const l=await f.Promises.exists(r);p||(l?(v("changed",r),u=[P(b,v,d)]):v("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(u),u=[(0,k.toDisposable)(()=>clearTimeout(s))]}else v("changed",r)})}catch(h){f.Promises.exists(b.path).then(o=>{o&&!p&&d(`Failed to watch ${b.path} for changes using fs.watch() (${h.toString()})`)})}return(0,k.toDisposable)(()=>{p=!0,u=(0,k.dispose)(u)})}}),define(Z[118],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[119],x([0,1,14,13,118]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){y.ipcMain.on(k.CONTEXT_MENU_CHANNEL,(n,f,w,t,P)=>{const b=E(n,t,w);b.popup({window:(0,L.withNullAsUndefined)(y.BrowserWindow.fromWebContents(n.sender)),x:P?P.x:void 0,y:P?P.y:void 0,positioningItem:P?P.positioningItem:void 0,callback:()=>{b&&n.sender.send(k.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=M;function E(n,f,w){const t=new y.Menu;return w.forEach(P=>{let b;P.type==="separator"?b=new y.MenuItem({type:P.type}):Array.isArray(P.submenu)?b=new y.MenuItem({submenu:E(n,f,P.submenu),label:P.label}):b=new y.MenuItem({label:P.label,type:P.type,accelerator:P.accelerator,checked:P.checked,enabled:P.enabled,visible:P.visible,click:(v,d,m)=>n.sender.send(f,P.id,m)}),t.append(b)}),t}});var he=this&&this.__decorate||function(K,e,y,L){var k=arguments.length,M=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,y):L,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(K,e,y,L);else for(var n=K.length-1;n>=0;n--)(E=K[n])&&(M=(k<3?E(M):k>3?E(e,y,M):E(e,y))||M);return k>3&&M&&Object.defineProperty(e,y,M),M};define(Z[35],x([0,1,31,9,18,24,47,17,4,2,110,25,13]),function(K,e,y,L,k,M,E,n,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function d(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function I(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(p||(p={}));class u{constructor(_){this.buffer=_,this.pos=0}read(_){const j=this.buffer.slice(this.pos,this.pos+_);return this.pos+=j.byteLength,j}}class h{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}var o;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(o||(o={}));function c(H){const _=k.VSBuffer.alloc(4);return _.writeUInt32BE(H,0),_}function i(H){return H.read(4).readUInt32BE(0)}function a(H){const _=k.VSBuffer.alloc(1);return _.writeUInt8(H,0),_}const r={Undefined:a(o.Undefined),String:a(o.String),Buffer:a(o.Buffer),VSBuffer:a(o.VSBuffer),Array:a(o.Array),Object:a(o.Object)},s=typeof Buffer!="undefined";function l(H,_){if(typeof _=="undefined")H.write(r.Undefined);else if(typeof _=="string"){const j=k.VSBuffer.fromString(_);H.write(r.String),H.write(c(j.byteLength)),H.write(j)}else if(s&&Buffer.isBuffer(_)){const j=k.VSBuffer.wrap(_);H.write(r.Buffer),H.write(c(j.byteLength)),H.write(j)}else if(_ instanceof k.VSBuffer)H.write(r.VSBuffer),H.write(c(_.byteLength)),H.write(_);else if(Array.isArray(_)){H.write(r.Array),H.write(c(_.length));for(const j of _)l(H,j)}else{const j=k.VSBuffer.fromString(JSON.stringify(_));H.write(r.Object),H.write(c(j.byteLength)),H.write(j)}}function g(H){switch(H.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return H.read(i(H)).toString();case o.Buffer:return H.read(i(H)).buffer;case o.VSBuffer:return H.read(i(H));case o.Array:{const j=i(H),T=[];for(let R=0;R<j;R++)T.push(g(H));return T}case o.Object:return JSON.parse(H.read(i(H)).toString())}}class S{constructor(_,j,T=null,R=1e3){this.protocol=_,this.ctx=j,this.logger=T,this.timeoutDelay=R,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(O=>this.onRawMessage(O)),this.sendResponse({type:200})}registerChannel(_,j){this.channels.set(_,j),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const j=this.send([_.type]);this.logger&&this.logger.logOutgoing(j,0,1,I(_.type));return}case 201:case 202:case 204:case 203:{const j=this.send([_.type,_.id],_.data);this.logger&&this.logger.logOutgoing(j,_.id,1,I(_.type),_.data);return}}}send(_,j=void 0){const T=new h;return l(T,_),l(T,j),this.sendBuffer(T.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(j){return 0}}onRawMessage(_){const j=new u(_),T=g(j),R=g(j),O=T[0];switch(O){case 100:return this.logger&&this.logger.logIncoming(_.byteLength,T[1],1,`${d(O)}: ${T[2]}.${T[3]}`,R),this.onPromise({type:O,id:T[1],channelName:T[2],name:T[3],arg:R});case 102:return this.logger&&this.logger.logIncoming(_.byteLength,T[1],1,`${d(O)}: ${T[2]}.${T[3]}`,R),this.onEventListen({type:O,id:T[1],channelName:T[2],name:T[3],arg:R});case 101:return this.logger&&this.logger.logIncoming(_.byteLength,T[1],1,`${d(O)}`),this.disposeActiveRequest({type:O,id:T[1]});case 103:return this.logger&&this.logger.logIncoming(_.byteLength,T[1],1,`${d(O)}`),this.disposeActiveRequest({type:O,id:T[1]})}}onPromise(_){const j=this.channels.get(_.channelName);if(!j){this.collectPendingRequest(_);return}const T=new M.CancellationTokenSource;let R;try{R=j.call(this.ctx,_.name,_.arg,T.token)}catch(N){R=Promise.reject(N)}const O=_.id;R.then(N=>{this.sendResponse({id:O,data:N,type:201}),this.activeRequests.delete(_.id)},N=>{N instanceof Error?this.sendResponse({id:O,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:O,data:N,type:203}),this.activeRequests.delete(_.id)});const z=(0,w.toDisposable)(()=>T.cancel());this.activeRequests.set(_.id,z)}onEventListen(_){const j=this.channels.get(_.channelName);if(!j){this.collectPendingRequest(_);return}const T=_.id,O=j.listen(this.ctx,_.name,_.arg)(z=>this.sendResponse({id:T,data:z,type:204}));this.activeRequests.set(_.id,O)}disposeActiveRequest(_){const j=this.activeRequests.get(_.id);j&&(j.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let j=this.pendingRequests.get(_.channelName);j||(j=[],this.pendingRequests.set(_.channelName,j));const T=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:_,timeoutTimer:T})}flushPendingRequests(_){const j=this.pendingRequests.get(_);if(j){for(const T of j)switch(clearTimeout(T.timeoutTimer),T.request.type){case 100:this.onPromise(T.request);break;case 102:this.onEventListen(T.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}e.ChannelServer=S;var D;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(_,j=null){this.protocol=_,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(T=>this.onBuffer(T)),this.logger=j}getChannel(_){const j=this;return{call(T,R,O){return j.isDisposed?Promise.reject(n.canceled()):j.requestPromise(_,T,R,O)},listen(T,R){return j.isDisposed?Promise.reject(n.canceled()):j.requestEvent(_,T,R)}}}requestPromise(_,j,T,R=M.CancellationToken.None){const O=this.lastRequestId++,N={id:O,type:100,channelName:_,name:j,arg:T};if(R.isCancellationRequested)return Promise.reject(n.canceled());let C;return new Promise((Q,ie)=>{if(R.isCancellationRequested)return ie(n.canceled());const oe=()=>{const me=ue=>{switch(ue.type){case 201:this.handlers.delete(O),Q(ue.data);break;case 202:this.handlers.delete(O);const ve=new Error(ue.data.message);ve.stack=ue.data.stack,ve.name=ue.data.name,ie(ve);break;case 203:this.handlers.delete(O),ie(ue.data);break}};this.handlers.set(O,me),this.sendRequest(N)};let ae=null;this.state===p.Idle?oe():(ae=(0,L.createCancelablePromise)(me=>this.whenInitialized()),ae.then(()=>{ae=null,oe()}));const ee=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:O,type:101}),ie(n.canceled())},le=R.onCancellationRequested(ee);C=(0,w.combinedDisposable)((0,w.toDisposable)(ee),le),this.activeRequests.add(C)}).finally(()=>{this.activeRequests.delete(C)})}requestEvent(_,j,T){const R=this.lastRequestId++,z={id:R,type:102,channelName:_,name:j,arg:T};let N=null;const C=new f.Emitter({onFirstListenerAdd:()=>{N=(0,L.createCancelablePromise)(Q=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add(C),this.sendRequest(z)})},onLastListenerRemove:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete(C),this.sendRequest({id:R,type:103}))}}),q=Q=>C.fire(Q.data);return this.handlers.set(R,q),C.event}sendRequest(_){switch(_.type){case 100:case 102:{const j=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger&&this.logger.logOutgoing(j,_.id,0,`${d(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const j=this.send([_.type,_.id]);this.logger&&this.logger.logOutgoing(j,_.id,0,d(_.type));return}}}send(_,j=void 0){const T=new h;return l(T,_),l(T,j),this.sendBuffer(T.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(j){return 0}}onBuffer(_){const j=new u(_),T=g(j),R=g(j),O=T[0];switch(O){case 200:return this.logger&&this.logger.logIncoming(_.byteLength,0,0,I(O)),this.onResponse({type:T[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(_.byteLength,T[1],0,I(O),R),this.onResponse({type:T[0],id:T[1],data:R})}}onResponse(_){if(_.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(_.id);j&&j(_)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}he([E.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class F{constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,_(({protocol:j,onDidClientDisconnect:T})=>{f.Event.once(j.onMessage)(O=>{const z=new u(O),N=g(z),C=new S(j,N),q=new A(j);this.channels.forEach((ie,oe)=>C.registerChannel(oe,ie));const Q={channelServer:C,channelClient:q,ctx:N};this._connections.add(Q),this._onDidAddConnection.fire(Q),T(()=>{C.dispose(),q.dispose(),this._connections.delete(Q),this._onDidRemoveConnection.fire(Q)})})})}get connections(){const _=[];return this._connections.forEach(j=>_.push(j)),_}getChannel(_,j){const T=this;return{call(R,O,z){let N;if((0,b.isFunction)(j)){let q=(0,y.getRandomElement)(T.connections.filter(j));N=q?Promise.resolve(q):f.Event.toPromise(f.Event.filter(T.onDidAddConnection,j))}else N=j.routeCall(T,R,O);const C=N.then(q=>q.channelClient.getChannel(_));return X(C).call(R,O,z)},listen(R,O){if((0,b.isFunction)(j))return T.getMulticastEvent(_,j,R,O);const z=j.routeEvent(T,R,O).then(N=>N.channelClient.getChannel(_));return X(z).listen(R,O)}}}getMulticastEvent(_,j,T,R){const O=this;let z=new w.DisposableStore;const N=new f.Emitter({onFirstListenerAdd:()=>{z=new w.DisposableStore;const C=new f.EventMultiplexer,q=new Map,Q=oe=>{const ee=oe.channelClient.getChannel(_).listen(T,R),le=C.add(ee);q.set(oe,le)},ie=oe=>{const ae=q.get(oe);!ae||(ae.dispose(),q.delete(oe))};O.connections.filter(j).forEach(Q),f.Event.filter(O.onDidAddConnection,j)(Q,void 0,z),O.onDidRemoveConnection(ie,void 0,z),C.event(N.fire,N,z),z.add(C)},onLastListenerRemove:()=>{z.dispose()}});return N.event}registerChannel(_,j){this.channels.set(_,j),this._connections.forEach(T=>{T.channelServer.registerChannel(_,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=F;class U{constructor(_,j,T=null){const R=new h;l(R,j),_.send(R.buffer),this.channelClient=new A(_,T),this.channelServer=new S(_,j,T)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,j){this.channelServer.registerChannel(_,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function X(H){return{call(_,j,T){return H.then(R=>R.call(_,j,T))},listen(_,j){const T=new f.Relay;return H.then(R=>T.input=R.listen(_,j)),T.event}}}e.getDelayedChannel=X;function ne(H){let _=!1;return{call(j,T,R){return _?H.call(j,T,R):(0,L.timeout)(0).then(()=>_=!0).then(()=>H.call(j,T,R))},listen(j,T){if(_)return H.listen(j,T);const R=new f.Relay;return(0,L.timeout)(0).then(()=>_=!0).then(()=>R.input=H.listen(j,T)),R.event}}}e.getNextTickChannel=ne;class se{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const j of _.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await f.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=se;var G;(function(H){function _(R,O){const z=R,N=O&&O.disableMarshalling,C=new Map;for(const q in z)T(q)&&C.set(q,f.Event.buffer(z[q],!0));return new class{listen(q,Q){const ie=C.get(Q);if(ie)return ie;throw new Error(`Event not found: ${Q}`)}call(q,Q,ie){const oe=z[Q];if(typeof oe=="function"){if(!N&&Array.isArray(ie))for(let ae=0;ae<ie.length;ae++)ie[ae]=(0,t.revive)(ie[ae]);return oe.apply(z,ie)}throw new Error(`Method not found: ${Q}`)}}}H.fromService=_;function j(R,O){const z=O&&O.disableMarshalling;return new Proxy({},{get(N,C){if(typeof C=="string")return O?.properties?.has(C)?O.properties.get(C):T(C)?R.listen(C):async function(...q){let Q;O&&!(0,b.isUndefinedOrNull)(O.context)?Q=[O.context,...q]:Q=q;const ie=await R.call(C,Q);return z?ie:(0,t.revive)(ie)};throw new Error(`Property not found: ${String(C)}`)}})}H.toService=j;function T(R){return R[0]==="o"&&R[1]==="n"&&P.isUpperAsciiLetter(R.charCodeAt(2))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){let _=H.toString();if(_!=="[object Object]")return _}return H}function V(H){return Array.isArray(H)?H.map(W):W(H)}function B(H,_,j,T,R,O,z){z=V(z);const N=J[R],C=N[T%N.length];let q=[`%c[${H}]%c[${String(_).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(T).padStart(5," ")} - ${O}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(O)?(q=q.concat(z),q.push(")")):q.push(z),console.log.apply(console,q)}e.logWithColors=B;class ${constructor(_,j){this._outgoingPrefix=_,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,j,T,R,O){this._totalOutgoing+=_,B(this._outgoingPrefix,this._totalOutgoing,_,j,T,R,O)}logIncoming(_,j,T,R,O){this._totalIncoming+=_,B(this._incomingPrefix,this._totalIncoming,_,j,T,R,O)}}e.IPCLogger=$}),define(Z[120],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class y{constructor(k,M){this.sender=k,this.onMessage=M}send(k){try{this.sender.send("vscode:message",k.buffer)}catch(M){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=y}),define(Z[121],x([0,1,18,4,35]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(f){this.port=f,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",w=>y.VSBuffer.wrap(w.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class E extends k.IPCClient{constructor(f,w){const t=new M(f);super(t,w);this.protocol=t}dispose(){this.protocol.disconnect()}}e.Client=E}),define(Z[83],x([0,1,18,4,2,3,32,35]),function(K,e,y,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var f;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function t(){return w||(w=y.VSBuffer.alloc(0)),w}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,l){if(s===0)return t();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const A=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=s),A}if(this._chunks[0].byteLength>s){const A=this._chunks[0].slice(0,s);return l&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),A}let g=y.VSBuffer.alloc(s),S=0,D=0;for(;s>0;){const A=this._chunks[D];if(A.byteLength>s){const F=A.slice(0,s);g.set(F,S),S+=s,l&&(this._chunks[D]=A.slice(s),this._totalLength-=s),s-=s}else g.set(A,S),S+=A.byteLength,l?(this._chunks.shift(),this._totalLength-=A.byteLength):D++,s-=A.byteLength}return g}}e.ChunkStream=P;var b;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(b||(b={}));var v;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(s,l,g,S){this.type=s,this.id=l,this.ack=g,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends k.Disposable{constructor(s){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const g=this._state.messageType,S=this._state.id,D=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(g,S,D,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class I{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=y.VSBuffer.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this._writeSoon(l,s.data)}_bufferAdd(s,l){const g=this._totalLength===0;return this._data.push(s,l),this._totalLength+=s.byteLength+l.byteLength,g}_bufferTake(){const s=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,l){this._bufferAdd(s,l)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class p extends k.Disposable{constructor(s){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new I(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new d(1,0,0,s))}}e.Protocol=p;class u extends n.IPCClient{constructor(s,l,g=null){super(s,l,g);this.protocol=s}static fromSocket(s,l){return new u(new p(s),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=u;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,E.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class o{constructor(s){this.data=s,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],l=0,g=this._first;for(;g;)s[l++]=g.data,g=g.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const l=new o(s);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class i{constructor(){this.lastRuns=[];const s=Date.now();for(let l=0;l<i._HISTORY_LENGTH;l++)this.lastRuns[l]=s-1e3*l;setInterval(()=>{for(let l=i._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}load(){const s=Date.now(),l=(1+i._HISTORY_LENGTH)*1e3;let g=0;for(let S=0;S<i._HISTORY_LENGTH;S++)s-this.lastRuns[S]<=l&&g++;return 1-g/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;class a{constructor(s,l=null,g=i.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=g,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(S=>this._receiveMessage(S))),this._socketDisposables.push(this._socket.onClose(S=>this._onSocketClose.fire(S))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new d(5,0,0,t());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const l=new d(4,0,0,t());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,l){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.push(this._socket.onClose(g=>this._onSocketClose.fire(g))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let l=0,g=s.length;l<g;l++)this._socketWriter.write(s[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new d(6,0,0,t())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const l=this._outgoingUnackMsg.toArray();for(let g=0,S=l.length;g<S;g++)this._socketWriter.write(l[g]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const g=new d(1,l,this._incomingAckId,s);this._outgoingUnackMsg.push(g),this._isReconnecting||(this._socketWriter.write(g),this._recvAckCheck())}sendControl(s){const l=new d(2,0,0,s);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),l=Date.now()-s.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new d(3,0,this._incomingAckId,t());this._socketWriter.write(s)}}e.PersistentProtocol=a}),define(Z[122],x([0,1,14,18,4,2,35,120]),function(K,e,y,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(t,P){const b=k.Event.fromNodeEventEmitter(y.ipcMain,P,(d,m)=>({event:d,message:m})),v=k.Event.filter(b,({event:d})=>d.sender.id===t);return k.Event.map(v,({message:d})=>d&&L.VSBuffer.wrap(d))}class w extends E.IPCServer{constructor(){super(w.getOnDidClientConnect())}static getOnDidClientConnect(){const P=k.Event.fromNodeEventEmitter(y.ipcMain,"vscode:hello",({sender:b})=>b);return k.Event.map(P,b=>{const v=b.id,d=w.Clients.get(v);d&&d.dispose();const m=new k.Emitter;w.Clients.set(v,(0,M.toDisposable)(()=>m.fire()));const I=f(v,"vscode:message"),p=k.Event.any(k.Event.signal(f(v,"vscode:disconnect")),m.event);return{protocol:new n.Protocol(b,I),onDidClientDisconnect:p}})}}e.Server=w,w.Clients=new Map}),define(Z[84],x([0,1,14,4,28,121]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class E extends M.Client{constructor(w,t){super({addEventListener:(P,b)=>w.addListener(P,b),removeEventListener:(P,b)=>w.removeListener(P,b),postMessage:P=>w.postMessage(P),start:()=>w.start(),close:()=>w.close()},t)}}e.Client=E;async function n(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,k.generateUuid)();f.webContents.send("vscode:createMessageChannel",w);const t=L.Event.fromNodeEventEmitter(y.ipcMain,"vscode:createMessageChannelResult",(b,v)=>({nonce:v,port:b.ports[0]})),{port:P}=await L.Event.toPromise(L.Event.once(L.Event.filter(t,b=>b.nonce===w)));return P}e.connect=n}),define(Z[85],x([0,1,9,4,2,13]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var E;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(E=e.StorageHint||(e.StorageHint={}));function n(P){const b=P;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=n;var f;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(f||(f={}));class w extends k.Disposable{constructor(b,v=Object.create(null)){super();this.database=b,this.options=v,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new y.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){b.changed?.forEach((v,d)=>this.accept(d,v)),b.deleted?.forEach(v=>this.accept(v,void 0))}accept(b,v){if(this.state===f.Closed)return;let d=!1;(0,M.isUndefinedOrNull)(v)?d=this.cache.delete(b):this.cache.get(b)!==v&&(this.cache.set(b,v),d=!0),d&&this._onDidChangeStorage.fire(b)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,v){const d=this.cache.get(b);return(0,M.isUndefinedOrNull)(d)?v:d}getBoolean(b,v){const d=this.get(b);return(0,M.isUndefinedOrNull)(d)?v:d==="true"}getNumber(b,v){const d=this.get(b);return(0,M.isUndefinedOrNull)(d)?v:parseInt(d,10)}async set(b,v){if(this.state===f.Closed)return;if((0,M.isUndefinedOrNull)(v))return this.delete(b);const d=String(v);if(this.cache.get(b)!==d)return this.cache.set(b,d),this.pendingInserts.set(b,d),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async delete(b){if(!(this.state===f.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(b){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class t{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert&&b.insert.forEach((v,d)=>this.items.set(d,v)),b.delete&&b.delete.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=t}),define(Z[123],x([0,1,9,4,37,8,19]),function(K,e,y,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(t,P=Object.create(null)){this.path=t,this.options=P,this.name=(0,M.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const t=await this.whenConnected,P=new Map;return(await this.all(t,"SELECT * FROM ItemTable")).forEach(v=>P.set(v.key,v.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${P.size} rows`),P}async updateItems(t){const P=await this.whenConnected;return this.doUpdateItems(P,t)}doUpdateItems(t,P){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${P.insert?(0,k.mapToString)(P.insert):"0"}), delete(${P.delete?(0,k.setToString)(P.delete):"0"})`),this.transaction(t,()=>{const b=P.insert,v=P.delete;if(b&&b.size>0){const d=[];d.push([]);let m=0;b.forEach((I,p)=>{let u=d[m];u.length>n.MAX_HOST_PARAMETERS&&(m++,u=[],d.push(u)),u.push(p,I)}),d.forEach(I=>{this.prepare(t,`INSERT INTO ItemTable VALUES ${new Array(I.length/2).fill("(?,?)").join(",")}`,p=>p.run(I),()=>{const p=[];let u=0;return b.forEach((h,o)=>{p.push(o),u+=h.length}),`Keys: ${p.join(", ")} Length: ${u}`})})}if(v&&v.size){const d=[];d.push([]);let m=0;v.forEach(I=>{let p=d[m];p.length>n.MAX_HOST_PARAMETERS&&(m++,p=[],d.push(p)),p.push(I)}),d.forEach(I=>{this.prepare(t,`DELETE FROM ItemTable WHERE key IN (${new Array(I.length).fill("?").join(",")})`,p=>p.run(I),()=>{const p=[];return v.forEach(u=>{p.push(u)}),`Keys: ${p.join(", ")}`})})}})}async close(t){this.logger.trace(`[storage ${this.name}] close()`);const P=await this.whenConnected;return this.doClose(P,t)}doClose(t,P){return new Promise((b,v)=>{t.db.close(d=>(d&&this.handleSQLiteError(t,`[storage ${this.name}] close(): ${d}`),this.path===n.IN_MEMORY_PATH?b():!t.isErroneous&&!t.isInMemory?this.backup().then(b,m=>(this.logger.error(`[storage ${this.name}] backup(): ${m}`),b())):typeof P=="function"?E.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(m=>{const I=()=>this.doClose(m,void 0);return this.doUpdateItems(m,{insert:P()}).then(()=>I(),p=>(I(),Promise.reject(p)))})).then(b,v):v(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const t=this.toBackupPath(this.path);return E.Promises.copy(this.path,t,{preserveSymlinks:!1})}toBackupPath(t){return`${t}.backup`}async checkIntegrity(t){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${t})`);const P=await this.whenConnected,b=await this.get(P,t?"PRAGMA integrity_check":"PRAGMA quick_check"),v=t?b.integrity_check:b.quick_check;return P.isErroneous?`${v} (last error: ${P.lastError})`:P.isInMemory?`${v} (in-memory!)`:v}async connect(t,P=!0){this.logger.trace(`[storage ${this.name}] open(${t}, retryOnBusy: ${P})`);try{return await this.doConnect(t)}catch(b){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&P)return await(0,y.timeout)(n.BUSY_OPEN_TIMEOUT),this.connect(t,!1);try{await E.Promises.unlink(t);try{await E.Promises.rename(this.toBackupPath(t),t)}catch(v){}return await this.doConnect(t)}catch(v){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${v}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(t,P){t.isErroneous=!0,t.lastError=P,this.logger.error(P)}doConnect(t){return new Promise((P,b)=>{new Promise((v,d)=>{K(["@vscode/sqlite3"],v,d)}).then(v=>{const d={db:new(this.logger.isTracing?v.verbose().Database:v.Database)(t,m=>m?d.db?d.db.close(()=>b(m)):b(m):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(d),I=>d.db.close(()=>b(I)))),isInMemory:t===n.IN_MEMORY_PATH};d.db.on("error",m=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${m}`)),this.logger.isTracing&&d.db.on("trace",m=>this.logger.trace(`[storage ${this.name}] Trace (event): ${m}`))},b)})}exec(t,P){return new Promise((b,v)=>{t.db.exec(P,d=>d?(this.handleSQLiteError(t,`[storage ${this.name}] exec(): ${d}`),v(d)):b())})}get(t,P){return new Promise((b,v)=>{t.db.get(P,(d,m)=>d?(this.handleSQLiteError(t,`[storage ${this.name}] get(): ${d}`),v(d)):b(m))})}all(t,P){return new Promise((b,v)=>{t.db.all(P,(d,m)=>d?(this.handleSQLiteError(t,`[storage ${this.name}] all(): ${d}`),v(d)):b(m))})}transaction(t,P){return new Promise((b,v)=>{t.db.serialize(()=>{t.db.run("BEGIN TRANSACTION"),P(),t.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(t,`[storage ${this.name}] transaction(): ${d}`),v(d)):b())})})}prepare(t,P,b,v){const d=t.db.prepare(P),m=I=>{this.handleSQLiteError(t,`[storage ${this.name}] prepare(): ${I} (${P}). Details: ${v()}`)};d.on("error",m),b(d),d.finalize(I=>{I&&m(I),d.removeListener("error",m)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class f{constructor(t){t&&typeof t.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=t.logTrace),t&&typeof t.logError=="function"&&(this.logError=t.logError)}get isTracing(){return!!this.logTrace}trace(t){this.logTrace&&this.logTrace(t)}error(t){this.logError&&this.logError(t)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[124],x([12,11]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[125],x([0,1,124]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,M=k*24,E=M*7,n=M*30,f=M*365;function w(P,b){typeof P!="number"&&(P=P.getTime());const v=Math.round((new Date().getTime()-P)/1e3);if(v<-30)return(0,y.localize)(0,null,w(new Date().getTime()+v*1e3,!1));if(v<30)return(0,y.localize)(1,null);let d;return v<L?(d=v,b?d===1?(0,y.localize)(2,null,d):(0,y.localize)(3,null,d):d===1?(0,y.localize)(4,null,d):(0,y.localize)(5,null,d)):v<k?(d=Math.floor(v/L),b?d===1?(0,y.localize)(6,null,d):(0,y.localize)(7,null,d):d===1?(0,y.localize)(8,null,d):(0,y.localize)(9,null,d)):v<M?(d=Math.floor(v/k),b?d===1?(0,y.localize)(10,null,d):(0,y.localize)(11,null,d):d===1?(0,y.localize)(12,null,d):(0,y.localize)(13,null,d)):v<E?(d=Math.floor(v/M),b?d===1?(0,y.localize)(14,null,d):(0,y.localize)(15,null,d):d===1?(0,y.localize)(16,null,d):(0,y.localize)(17,null,d)):v<n?(d=Math.floor(v/E),b?d===1?(0,y.localize)(18,null,d):(0,y.localize)(19,null,d):d===1?(0,y.localize)(20,null,d):(0,y.localize)(21,null,d)):v<f?(d=Math.floor(v/n),b?d===1?(0,y.localize)(22,null,d):(0,y.localize)(23,null,d):d===1?(0,y.localize)(24,null,d):(0,y.localize)(25,null,d)):(d=Math.floor(v/f),b?d===1?(0,y.localize)(26,null,d):(0,y.localize)(27,null,d):d===1?(0,y.localize)(28,null,d):(0,y.localize)(29,null,d))}e.fromNow=w;function t(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=t}),define(Z[126],x([12,11]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[67],x([0,1,31,13,126]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function M(w,t){return t&&(w.stack||w.stacktrace)?k.localize(0,null,n(w),E(w.stack)||E(w.stacktrace)):n(w)}function E(w){return Array.isArray(w)?w.join(`
`):w}function n(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?k.localize(1,null,w.message):w.message||k.localize(2,null)}function f(w=null,t=!1){if(!w)return k.localize(3,null);if(Array.isArray(w)){const P=y.coalesce(w),b=f(P[0],t);return P.length>1?k.localize(4,null,b,P.length):b}if(L.isString(w))return w;if(w.detail){const P=w.detail;if(P.error)return M(P.error,t);if(P.exception)return M(P.exception,t)}return w.stack?M(w,t):w.message?w.message:k.localize(5,null)}e.toErrorMessage=f}),define(Z[127],x([12,11]),function(K,e){return K.create("vs/base/common/keybindingLabels",e)}),define(Z[128],x([0,1,127]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(E,n,f=n){this.modifierLabels=[null],this.modifierLabels[2]=E,this.modifierLabels[1]=n,this.modifierLabels[3]=f}toLabel(E,n,f){if(n.length===0)return null;const w=[];for(let t=0,P=n.length;t<P;t++){const b=n[t],v=f(b);if(v===null)return null;w[t]=k(b,v,this.modifierLabels[E])}return w.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:y.localize(0,null),shiftKey:y.localize(1,null),altKey:y.localize(2,null),metaKey:y.localize(3,null),separator:"+"},{ctrlKey:y.localize(4,null),shiftKey:y.localize(5,null),altKey:y.localize(6,null),metaKey:y.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:y.localize(8,null),shiftKey:y.localize(9,null),altKey:y.localize(10,null),metaKey:y.localize(11,null),separator:"+"},{ctrlKey:y.localize(12,null),shiftKey:y.localize(13,null),altKey:y.localize(14,null),metaKey:y.localize(15,null),separator:"+"},{ctrlKey:y.localize(16,null),shiftKey:y.localize(17,null),altKey:y.localize(18,null),metaKey:y.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function k(M,E,n){if(E===null)return"";const f=[];return M.ctrlKey&&f.push(n.ctrlKey),M.shiftKey&&f.push(n.shiftKey),M.altKey&&f.push(n.altKey),M.metaKey&&f.push(n.metaKey),E!==""&&f.push(E),f.join(n.separator)}}),define(Z[129],x([12,11]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[68],x([0,1,41,29,10,44,8,3,32,13,80,19,129]),function(K,e,y,L,k,M,E,n,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function v(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(o,c){if(n.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};c&&(i.cwd=c);const a=y.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],i);return new Promise(r=>{a.once("error",s=>{r({success:!1,error:s})}),a.once("exit",(s,l)=>{r(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?v(i.status):1})}else if(n.isLinux||n.isMacintosh)try{const i=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(a=>{y.execFile(i,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,s,l)=>{a(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function m(o=f.env){return o.comspec||"cmd.exe"}e.getWindowsShell=m;class I{constructor(c,i,a,r){if(i!==void 0&&a!==void 0&&r!==void 0)this.cmd=c,this.args=i,this.shell=a,this.options=r;else{const s=c;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(f.env).forEach(l=>{s[l]=f.env[l]}),Object.keys(this.options.env).forEach(l=>{s[l]=this.options.env[l]}),this.options.env=s}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const i=c.lastIndexOf(E.sep);return i!==-1&&(c=c.substring(i+1)),I.WellKnowCommands[c]?c:"other"}start(c){return n.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(f.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(i=>{let a,r;const s=new Promise((l,g)=>{a=l,r=g});if(i){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=y.exec(l,this.options,(g,S,D)=>{this.childProcess=null;const A=g;A&&A.killed?r({killed:this.terminateRequested,stdout:S.toString(),stderr:D.toString()}):this.handleExec(a,c,g,S,D)})}else{let l=null;const g=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,a,c,r);const D={terminated:this.terminateRequested};w.isNumber(S)&&(D.cmdCode=S),a(D)};if(this.shell&&n.isWindows){const S=M.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let D=!1,A=!1;const F=[];let U=this.ensureQuotes(this.cmd);F.push(U.value),D=U.quoted,this.args&&this.args.forEach(ne=>{U=this.ensureQuotes(ne),F.push(U.value),A=A&&U.quoted});const X=["/s","/c"];D?A?X.push('"'+F.join(" ")+'"'):F.length>1?X.push('"'+F[0]+'" '+F.slice(1).join(" ")):X.push('"'+F[0]+'"'):X.push(F.join(" ")),l=y.spawn(m(),X,S)}else this.cmd&&(l=y.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(w.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",S=>{this.childProcess=null,r({terminated:this.terminateRequested,error:S})}),l.pid&&(this.childProcess.on("close",g),this.handleSpawn(l,a,c,r,!0)))}return s})}handleClose(c,i,a,r){}ensureQuotes(c){return I.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,d(c,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!n.isWindows)return c(!1);const i=y.spawn(m(),["/s","/c"]);i.on("error",a=>c(!0)),i.on("exit",a=>c(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class p extends I{constructor(c,i,a,r){super(c,i,a,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,i,a,r,s){[r,s].forEach((l,g)=>{const S=new t.LineDecoder;S.write(l).forEach(F=>{i({line:F,source:g===0?0:1})});const A=S.end();A&&i({line:A,source:g===0?0:1})}),c({terminated:this.terminateRequested,error:a})}handleSpawn(c,i,a,r,s){const l=new t.LineDecoder,g=new t.LineDecoder;c.stdout.on("data",S=>{l.write(S).forEach(A=>a({line:A,source:0}))}),c.stderr.on("data",S=>{g.write(S).forEach(A=>a({line:A,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=g}handleClose(c,i,a,r){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&a({line:s,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&a({line:l,source:1})}}e.LineProcess=p;function u(o){let c=[],i=!1;const a=function(r){if(i){c.push(r);return}(!o.send(r,l=>{if(l&&console.error(l),i=!1,c.length>0){const g=c.slice(0);c=[],g.forEach(S=>a(S))}})||n.isWindows)&&(i=!0)};return{send:a}}e.createQueuedSender=u;var h;(function(o){async function c(i,a,r){if(E.isAbsolute(i))return i;if(a===void 0&&(a=f.cwd()),E.dirname(i)!=="."||(r===void 0&&w.isString(f.env.PATH)&&(r=f.env.PATH.split(E.delimiter)),r===void 0||r.length===0))return E.join(a,i);async function l(g){if(await P.Promises.exists(g)){let S;try{S=await P.Promises.stat(g)}catch(D){D.message.startsWith("EACCES")&&(S=await P.Promises.lstat(g))}return S?!S.isDirectory():!1}return!1}for(let g of r){let S;if(E.isAbsolute(g)?S=E.join(g,i):S=E.join(a,g,i),await l(S))return S;let D=S+".com";if(await l(D)||(D=S+".exe",await l(D)))return D}return E.join(a,i)}o.findExecutable=c})(h=e.win32||(e.win32={}))}),define(Z[130],x([0,1,26,3,116,68]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function E(v,d){return v===1?L.isWindows?P():M.getWindowsShell(d):w(v,d)}e.getSystemShell=E;function n(v,d){return v===1?L.isWindows?b(d):M.getWindowsShell(d):w(v,d)}e.getSystemShellSync=n;let f=null;function w(v,d){if(L.isLinux&&v===2||L.isMacintosh&&v===3)return"/bin/bash";if(!f){let m;if(L.isWindows)m="/bin/bash";else{if(m=d.SHELL,!m)try{m=(0,y.userInfo)().shell}catch(I){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}f=m}return f}let t=null;async function P(){return t||(t=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),t}function b(v){if(t)return t;const d=L.isWindows&&parseFloat((0,y.release)())>=10,m=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),I=`${v.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?I:M.getWindowsShell(v)}}),define(Z[86],x([0,1,41,9,18,24,109,17,4,2,44,3,68,35]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends v.ChannelServer{constructor(p){super({send:u=>{try{process.send&&process.send(u.buffer.toString("base64"))}catch(h){}},onMessage:f.Event.fromNodeEventEmitter(process,"message",u=>k.VSBuffer.wrap(Buffer.from(u,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=d;class m{constructor(p,u){this.modulePath=p,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new L.Delayer(h),this.child=null,this._client=null}getChannel(p){const u=this;return{call(h,o,c){return u.requestPromise(p,h,o,c)},listen(h,o){return u.requestEvent(p,h,o)}}}requestPromise(p,u,h,o=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(n.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(p),i=(0,L.createCancelablePromise)(s=>c.call(u,h,s)),a=o.onCancellationRequested(()=>i.cancel()),r=(0,w.toDisposable)(()=>i.cancel());return this.activeRequests.add(r),i.finally(()=>{a.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(p,u,h){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let o;const c=new f.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(p).listen(u,h)(c.fire,c),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,t.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),P.isMacintosh&&u.env&&delete u.env.DYLD_LIBRARY_PATH,this.child=(0,y.fork)(this.modulePath,p,u);const h=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,E.isRemoteConsoleLog)(l)){(0,E.log)(l,`IPC Library: ${this.options.serverName}`);return}h.fire(k.VSBuffer.wrap(Buffer.from(l,"base64")))});const c=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,i=l=>this.child&&this.child.connected&&c.send(l.buffer.toString("base64")),a=h.event,r={send:i,onMessage:a};this._client=new v.ChannelClient(r);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,g)=>{process.removeListener("exit",s),this.activeRequests.forEach(S=>(0,w.dispose)(S)),this.activeRequests.clear(),l!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+g),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:g})})}return this._client}getCachedChannel(p){let u=this.channels.get(p);return u||(u=this.client.getChannel(p),this.channels.set(p,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=m}),define(Z[131],x([12,11]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(Z[132],x([12,11]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[133],x([12,11]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[134],x([12,11]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(Z[135],x([12,11]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(Z[136],x([12,11]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[137],x([12,11]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[138],x([12,11]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[139],x([12,11]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[140],x([12,11]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[141],x([12,11]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[142],x([12,11]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[143],x([12,11]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[144],x([12,11]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[145],x([12,11]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[146],x([12,11]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[147],x([12,11]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[148],x([12,11]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[149],x([12,11]),function(K,e){return K.create("vs/platform/windows/electron-main/window",e)}),define(Z[150],x([12,11]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[151],x([12,11]),function(K,e){return K.create("vs/platform/workspaces/common/workspaces",e)}),define(Z[152],x([12,11]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[153],x([12,11]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[154],x([0,1,4,2]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new y.Emitter,this._onReloadEmitter=new y.Emitter,this._onTerminateEmitter=new y.Emitter,this._onAttachEmitter=new y.Emitter}call(n,f,w){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(n,f,w){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class M extends L.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,f,w){this.channel.call("attach",[n,f,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,f){this.channel.call("terminate",[n,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,f,w){return this.channel.call("openExtensionDevelopmentHostWindow",[n,f||{},w])}}e.ExtensionHostDebugChannelClient=M}),define(Z[155],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class y{constructor(E){this.driver=E}listen(E,n){throw new Error(`No event found: ${n}`)}call(E,n,f){switch(n){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=y;class L{constructor(E){this.channel=E}click(E,n,f){return this.channel.call("click",[E,n,f])}doubleClick(E){return this.channel.call("doubleClick",E)}setValue(E,n){return this.channel.call("setValue",[E,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(E){return this.channel.call("isActiveElement",E)}getElements(E,n){return this.channel.call("getElements",[E,n])}getElementXY(E,n,f){return this.channel.call("getElementXY",[E,n,f])}typeInEditor(E,n){return this.channel.call("typeInEditor",[E,n])}getTerminalBuffer(E){return this.channel.call("getTerminalBuffer",E)}writeInTerminal(E,n){return this.channel.call("writeInTerminal",[E,n])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class k{constructor(E){this.channel=E}registerWindowDriver(E){return this.channel.call("registerWindowDriver",E)}reloadWindowDriver(E){return this.channel.call("reloadWindowDriver",E)}}e.WindowDriverRegistryChannelClient=k}),define(Z[156],x([0,1,125,47,10,8,32,15,7]),function(K,e,y,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(d,m,I){this._args=d,this.paths=m,this.productService=I}get appRoot(){return(0,M.dirname)(k.FileAccess.asFileUri("",K).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,n.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,n.joinPath)(f.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=E.env.VSCODE_PORTABLE;return d?f.URI.file((0,M.join)(d,"argv.json")):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,n.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,M.resolve)(d):(0,M.normalize)((0,M.join)(k.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,M.resolve)(d):(0,M.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,M.resolve)(d);const m=E.env.VSCODE_EXTENSIONS;if(m)return m;const I=E.env.VSCODE_PORTABLE;return I?(0,M.join)(I,"extensions"):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(m=>/^[^:/?#]+?:\/\//.test(m)?f.URI.parse(m):f.URI.file((0,M.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?f.URI.parse(d):f.URI.file((0,M.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return t(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!E.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,n.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],w.prototype,"appRoot",null),he([L.memoize],w.prototype,"userHome",null),he([L.memoize],w.prototype,"userDataPath",null),he([L.memoize],w.prototype,"appSettingsHome",null),he([L.memoize],w.prototype,"tmpDir",null),he([L.memoize],w.prototype,"userRoamingDataHome",null),he([L.memoize],w.prototype,"settingsResource",null),he([L.memoize],w.prototype,"userDataSyncHome",null),he([L.memoize],w.prototype,"userDataSyncLogResource",null),he([L.memoize],w.prototype,"sync",null),he([L.memoize],w.prototype,"machineSettingsResource",null),he([L.memoize],w.prototype,"globalStorageHome",null),he([L.memoize],w.prototype,"workspaceStorageHome",null),he([L.memoize],w.prototype,"keybindingsResource",null),he([L.memoize],w.prototype,"keyboardLayoutResource",null),he([L.memoize],w.prototype,"argvResource",null),he([L.memoize],w.prototype,"snippetsHome",null),he([L.memoize],w.prototype,"isExtensionDevelopment",null),he([L.memoize],w.prototype,"untitledWorkspacesHome",null),he([L.memoize],w.prototype,"installSourcePath",null),he([L.memoize],w.prototype,"builtinExtensionsPath",null),he([L.memoize],w.prototype,"extensionsPath",null),he([L.memoize],w.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],w.prototype,"extensionDevelopmentKind",null),he([L.memoize],w.prototype,"extensionTestsLocationURI",null),he([L.memoize],w.prototype,"debugExtensionHost",null),he([L.memoize],w.prototype,"serviceMachineIdResource",null),he([L.memoize],w.prototype,"telemetryLogResource",null),he([L.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function t(v,d){return b(v["inspect-extensions"],v["inspect-brk-extensions"],5870,d,v.debugId)}e.parseExtensionHostPort=t;function P(v,d){return b(v["inspect-search"],v["inspect-brk-search"],5876,d)}e.parseSearchPort=P;function b(v,d,m,I,p){const h=Number(d||v)||(I?null:m),o=h?Boolean(!!d):!1;return{port:h,break:o,debugId:p}}}),define(Z[87],x([0,1,240,3,134]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,k.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},category:{type:"string",cat:"e",description:(0,k.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,k.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,k.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,k.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,k.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,k.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const E={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(d,m,I=E){const p={},u=[],h=[];for(let a in m){const r=m[a];r.alias&&(p[a]=r.alias),r.type==="string"||r.type==="string[]"?(u.push(a),r.deprecates&&u.push(r.deprecates)):r.type==="boolean"&&(h.push(a),r.deprecates&&h.push(r.deprecates))}const o=y(d,{string:u,boolean:h,alias:p}),c={},i=o;c._=o._.map(a=>String(a)).filter(a=>a.length>0),delete i._;for(let a in m){const r=m[a];r.alias&&delete i[r.alias];let s=i[a];r.deprecates&&i.hasOwnProperty(r.deprecates)&&(s||(s=i[r.deprecates]),delete i[r.deprecates]),typeof s!="undefined"&&(r.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):r.type==="string"&&Array.isArray(s)&&(s=s.pop(),I.onMultipleValues(a,s)),c[a]=s),delete i[a]}for(let a in i)I.onUnknownOption(a);return c}e.parseArgs=n;function f(d,m){let I="";return m.args&&(Array.isArray(m.args)?I=` <${m.args.join("> <")}>`:I=` <${m.args}>`),m.alias?`-${m.alias} --${d}${I}`:`--${d}${I}`}function w(d,m){let I=0,p=[];for(const c in d){const i=d[c],a=f(c,i);I=Math.max(I,a.length),p.push([a,i.description])}let u=I+2+1;if(m-u<25)return p.reduce((c,i)=>c.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);let h=m-u-1,o=[];for(const c of p){let i=c[0],a=P(c[1],h),r=t(u-i.length-2);o.push("  "+i+r+a[0]);for(let s=1;s<a.length;s++)o.push(t(u)+a[s])}return o}e.formatOptions=w;function t(d){return" ".repeat(d)}function P(d,m){let I=[];for(;d.length;){let p=d.length<m?d.length:d.lastIndexOf(" ",m),u=d.slice(0,p).trim();d=d.slice(p),I.push(u)}return I}function b(d,m,I,p,u=!0){const h=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${d} ${I}`];o.push(""),o.push(`${(0,k.localize)(32,null)}: ${m} [${(0,k.localize)(33,null)}][${(0,k.localize)(34,null)}...]`),o.push(""),u&&(L.isWindows?o.push((0,k.localize)(35,null,m)):o.push((0,k.localize)(36,null,m)),o.push(""));const c={};for(const i in p){const a=p[i];if(a.description&&a.cat){let r=c[a.cat];r||(c[a.cat]=r={}),r[i]=a}}for(let i in c){const a=i;let r=c[a];r&&(o.push(M[a]),o.push(...w(r,h)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=b;function v(d,m){return`${d||(0,k.localize)(37,null)}
${m||(0,k.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=v}),define(Z[157],x([0,1,59,154,87]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends L.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,f,w){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(w[0],w[1],w[2]):super.call(n,f,w)}async openExtensionDevelopmentHostWindow(n,f,w){const t=(0,k.parseArgs)(n,k.OPTIONS);t.debugRenderer=w;const P=t.extensionDevelopmentPath;if(!P)return{success:!1};let b;const v=Object.keys(f);for(let h of v){let o=f[h];o===null||(b||(b=Object.create(null)),b[h]=o)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(P,{context:5,cli:t,userEnv:b});if(!w)return{success:!0};const m=d.win;if(!m)return{success:!0};const I=m.webContents.debugger;let p=I.isAttached()?Infinity:0;const u=(0,y.createServer)(h=>{p++==0&&I.attach();let o=!1;const c=r=>{o||h.write(JSON.stringify(r)+"\0")},i=(r,s,l,g)=>c({method:s,params:l,sessionId:g});m.on("close",()=>{I.removeListener("message",i),h.end(),o=!0}),I.addListener("message",i);let a=Buffer.alloc(0);h.on("data",r=>{a=Buffer.concat([a,r]);for(let s=a.indexOf(0);s!==-1;s=a.indexOf(0)){let l;try{const g=a.slice(0,s).toString("utf8");a=a.slice(s+1),l=JSON.parse(g)}catch(g){console.error("error reading cdp line",g)}I.sendCommand(l.method,l.params,l.sessionId).then(g=>c({id:l.id,sessionId:l.sessionId,result:g})).catch(g=>c({id:l.id,sessionId:l.sessionId,error:{code:0,message:g.message}}))}}),h.on("error",r=>{console.error("error on cdp pipe:",r)}),h.on("close",()=>{o=!0,--p==0&&I.detach()})});return await new Promise(h=>u.listen(0,h)),m.on("close",()=>u.close()),{rendererDebugPort:u.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),function(){"use strict";function K(e,y,L,k){function M(n){const f=E(n),w=[f];return e.isAbsolute(f)||w.unshift(k),e.resolve(...w)}function E(n){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,L);const t=n["user-data-dir"];if(t)return t;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(P,"AppData","Roaming")}break;case"darwin":w=e.join(y.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,L)}return{getUserDataPath:M}}if(typeof define=="function")define(Z[158],x([0,159,26,10,15,32]),function(e,y,L,k,M,E){const n=M.dirname(k.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(M.joinPath(n,"package.json").fsPath);return K(y,L,f.name,E.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),y=require("path"),L=require("os");module.exports=K(y,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[160],x([0,1,26,156,158]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends L.AbstractNativeEnvironmentService{constructor(n,f){super(n,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,k.getUserDataPath)(n)},f)}}e.NativeEnvironmentService=M}),define(Z[161],x([0,1,30,26,8]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function M(E){const n=(0,k.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return y.writeFileSync(n,""),E&&console.log(`Marker file for --wait created: ${n}`),n}catch(f){E&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=M}),define(Z[162],x([0,1,137]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function M(b){return b=b.trim(),b==="*"||L.test(b)}e.isValidVersionStr=M;function E(b){if(!M(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=b.match(L);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=E;function n(b){if(!b)return null;let v=b.majorBase,d=b.majorMustEqual,m=b.minorBase,I=b.minorMustEqual,p=b.patchBase,u=b.patchMustEqual;b.hasCaret&&(v===0||(I=!1),u=!1);let h=0;if(b.preRelease){const o=k.exec(b.preRelease);if(o){const[,c,i,a]=o;h=Date.UTC(Number(c),Number(i)-1,Number(a))}}return{majorBase:v,majorMustEqual:d,minorBase:m,minorMustEqual:I,patchBase:p,patchMustEqual:u,isMinimum:b.hasGreaterEquals,notBefore:h}}e.normalizeVersion=n;function f(b,v,d){let m;typeof b=="string"?m=n(E(b)):m=b;let I;v instanceof Date?I=v.getTime():typeof v=="string"&&(I=new Date(v).getTime());let p;if(typeof d=="string"?p=n(E(d)):p=d,!m||!p)return!1;let u=m.majorBase,h=m.minorBase,o=m.patchBase,c=p.majorBase,i=p.minorBase,a=p.patchBase,r=p.notBefore,s=p.majorMustEqual,l=p.minorMustEqual,g=p.patchMustEqual;return p.isMinimum?u>c?!0:u<c?!1:h>i?!0:h<i||I&&I<r?!1:o>=a:(u===1&&c===0&&(!s||!l||!g)&&(c=1,i=0,a=0,s=!0,l=!1,g=!1),u<c?!1:u>c?!s:h<i?!1:h>i?!l:o<a?!1:o>a?!g:!(I&&I<r))}e.isValidVersion=f;function w(b,v,d,m){return d.isBuiltin||typeof d.main=="undefined"?!0:P(b,v,d.engines.vscode,m)}e.isValidExtensionVersion=w;function t(b,v,d){return b==="*"||P(v,d,b)}e.isEngineValid=t;function P(b,v,d,m=[]){let I=n(E(d));if(!I)return m.push(y.localize(0,null,d)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return m.push(y.localize(1,null,d)),!1}else if(!I.majorMustEqual)return m.push(y.localize(2,null,d)),!1;return f(b,v,I)?!0:(m.push(y.localize(3,null,b,d)),!1)}}),define(Z[163],x([0,1,2,10,35,86]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends y.Disposable{constructor(f,w,t,P){super();this.folders=f,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=P,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(Z[164],x([0,1,2,10,35,86]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends y.Disposable{constructor(f,w,t,P,b={}){super();this.folders=f,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=P,this.watcherOptions=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(Z[165],x([0,1,41,111,10,80]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class E{constructor(f,w,t,P,b){this.watchedFolder=f,this.eventCallback=t,this.logCallback=P,this.verboseLogging=b,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(v=>(0,L.parse)(v)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=(0,y.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,f);const w=new M.LineDecoder;this.handle.stdout.on("data",t=>{const P=[];for(const b of w.write(t)){const v=b.split("|");if(v.length===2){const d=Number(v[0]),m=v[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(I=>I(m))){this.verboseLogging&&this.log(m);continue}P.push({type:E.changeTypeMap[d],path:m})}else this.log(v[1])}}P.length>0&&this.eventCallback(P)}),this.handle.on("error",t=>this.onError(t)),this.handle.stderr.on("data",t=>this.onError(t)),this.handle.on("exit",(t,P)=>this.onExit(t,P))}onError(f){this.error("process error: "+f.toString())}onExit(f,w){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${w})`),this.restartCounter<=E.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=E,E.MAX_RESTARTS=5,E.changeTypeMap=[0,1,2]}),define(Z[166],x([0,1,8,25,165]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M{constructor(n,f,w,t){this.onDidFilesChange=f,this.onLogMessage=w,this.verboseLogging=t,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(y.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,y.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new k.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=M}),define(Z[69],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class y{constructor(k,M=[],E=!1){this.ctor=k,this.staticArguments=M,this.supportsDelayedInstantiation=E}}e.SyncDescriptor=y}),define(Z[167],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class y{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=y;class L{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let E of this._nodes.values())E.outgoing.size===0&&M.push(E);return M}insertEdge(M,E){const n=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(E);n.outgoing.set(this._hashFn(E),f),f.incoming.set(this._hashFn(M),n)}removeNode(M){const E=this._hashFn(M);this._nodes.delete(E);for(let n of this._nodes.values())n.outgoing.delete(E),n.incoming.delete(E)}lookupOrInsertNode(M){const E=this._hashFn(M);let n=this._nodes.get(E);return n||(n=new y(M),this._nodes.set(E,n)),n}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[E,n]of this._nodes)M.push(`${E}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,E]of this._nodes){const n=new Set([M]),f=this._findCycle(E,n);if(f)return f}}_findCycle(M,E){for(let[n,f]of M.outgoing){if(E.has(n))return[...E,n].join(" -> ");E.add(n);const w=this._findCycle(f,E);if(w)return w;E.delete(n)}}}e.Graph=L}),define(Z[5],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var y;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function f(w){return w[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=f})(y=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(n,f,w,t){f[y.DI_TARGET]===f?f[y.DI_DEPENDENCIES].push({id:n,index:w,optional:t}):(f[y.DI_DEPENDENCIES]=[{id:n,index:w,optional:t}],f[y.DI_TARGET]=f)}function k(n){if(y.serviceIds.has(n))return y.serviceIds.get(n);const f=function(w,t,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(f,w,P,!1)};return f.toString=()=>n,y.serviceIds.set(n,f),f}e.createDecorator=k;function M(n){return n}e.refineServiceDecorator=M;function E(n){return function(f,w,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(n,f,t,!0)}}e.optional=E}),define(Z[70],x([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,y.createDecorator)(e.ID);function L(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[88],x([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,y.createDecorator)("encryptionMainService");class L{constructor(M){this.machineId=M}encryption(){return new Promise((M,E)=>K(["vscode-encrypt"],M,E))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch(E){return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch(E){return M}}}e.EncryptionMainService=L}),define(Z[48],x([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,y.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,y.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[168],x([0,1,10,136,5]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var M;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE="alpine-x64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(M=e.TargetPlatform||(e.TargetPlatform={}));function E(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=E;function n(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=n;function f(p,u){switch(p){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=f;function w(p,u){return u==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function t(p,u,h){if(w(u,h))return!1;if(p==="undefined"||p==="universal")return!0;if(p==="unknown")return!1;if(p===h)return!0;switch(h){case"win32-x64":return p==="win32-ia32";case"win32-arm64":return p==="win32-ia32";default:return!1}}e.isTargetPlatformCompatible=t;function P(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=P;var b;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=5]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var v;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var d;(function(p){p.Install="install",p.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var m;(function(p){p[p.None=0]="None",p[p.Install=1]="Install",p[p.Update=2]="Update"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class I extends Error{constructor(u,h){super(u);this.code=h,this.name=h}}e.ExtensionManagementError=I,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=y.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(Z[169],x([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,y.createDecorator)("extensionUrlTrustService")}),define(Z[170],x([0,1,25,5]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=k;function M(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class n{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,b){if(typeof P=="undefined"||P===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof P=="string"||typeof b=="string"){let v=typeof P=="string"?P:P.value,d=typeof b=="string"?b:b.value;return y.equalsIgnoreCase(v,d)}return P._lower===b._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=n;function f(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function w(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[171],x([0,1,25,170]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(d,m){return d.uuid&&m.uuid?d.uuid===m.uuid:d.id===m.id?!0:(0,y.compareIgnoreCase)(d.id,m.id)===0}e.areSameExtensions=k;class M{constructor(m,I){this.version=I,this.id=m.id,this.uuid=m.uuid}key(){return`${this.id}-${this.version}`}equals(m){return m instanceof M?k(this,m)&&this.version===m.version:!1}}e.ExtensionIdentifierWithVersion=M;function E(d,m){return`${d}.${m}`}e.getExtensionId=E;function n(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function f(d,m){return n(E(d,m))}e.getGalleryExtensionId=f;function w(d,m){const I=[],p=u=>{for(const h of I)if(h.some(o=>k(m(o),m(u))))return h;return null};for(const u of d){const h=p(u);h?h.push(u):I.push([u])}return I}e.groupByExtension=w;function t(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function P(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function b(d){const m=new Set;for(const I of d)I.malicious&&m.add(I.id.id);return m}e.getMaliciousExtensionsSet=b;function v(d,m){const I=[],p=m.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const u=p.shift();if(u&&I.every(h=>!k(h.identifier,{id:u}))){const h=d.filter(o=>k(o.identifier,{id:u}));h.length===1&&(I.push(h[0]),p.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return I}e.getExtensionDependencies=v}),define(Z[89],x([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,y.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,y.createDecorator)("externalTerminal")}),define(Z[172],x([0,1,41,10,8,3,105,19,68,138,89]),function(K,e,y,L,k,M,E,n,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=w.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends b{openTerminal(o,c){return this.spawnTerminal(y,o,f.getWindowsShell(),c)}spawnTerminal(o,c,i,a){const r=c.windowsExec||v.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const s=k.basename(r).toLowerCase();if(s==="cmder"||s==="cmder.exe")return o.spawn(r,a?[a]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return r.indexOf(" ")>=0&&l.push('""'),l.push(r),(s==="wt"||s==="wt.exe")&&l.push("-d ."),new Promise((g,S)=>{const D=I(process),A=o.spawn(i,l,{cwd:a,env:D});A.on("error",S),A.on("exit",()=>g())})}runInTerminal(o,c,i,a,r){const s="windowsExec"in r&&r.windowsExec?r.windowsExec:v.getDefaultTerminalWindows();return new Promise((l,g)=>{const S=`"${c} - ${P}"`,D=`""${i.join('" "')}" & pause"`,A=["/c","start",S,"/wait",s,"/c",D],F=Object.assign({},I(process),a);Object.keys(F).filter(ne=>F[ne]===null).forEach(ne=>delete F[ne]);const U={cwd:c,env:F,windowsVerbatimArguments:!0};y.spawn(v.CMD,A,U).on("error",ne=>{g(p(ne))}),l(void 0)})}static getDefaultTerminalWindows(){if(!v._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return v._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=v,v.CMD="cmd.exe";class d extends b{openTerminal(o,c){return this.spawnTerminal(y,o,c)}runInTerminal(o,c,i,a,r){const s=r.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((l,g)=>{if(s===t.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const S=s===t.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",A=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`,K).fsPath,"-t",o||P,"-w",c];for(let X of i)A.push("-a"),A.push(X);if(a){const X=Object.assign({},I(process),a);for(let ne in X){const se=X[ne];se===null?(A.push("-u"),A.push(ne)):(A.push("-e"),A.push(`${ne}=${se}`))}}let F="";const U=y.spawn(d.OSASCRIPT,A);U.on("error",X=>{g(p(X))}),U.stderr.on("data",X=>{F+=X.toString()}),U.on("exit",X=>{if(X===0)l(void 0);else if(F){const ne=F.split(`
`,1);g(new Error(ne[0]))}else g(new Error(w.localize(1,null,S,X)))})}else g(new Error(w.localize(2,null,s)))})}spawnTerminal(o,c,i){const a=c.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((r,s)=>{const l=["-a",a];i&&l.push(i);const g=I(process),S=o.spawn("/usr/bin/open",l,{cwd:i,env:g});S.on("error",s),S.on("exit",()=>r())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class m extends b{openTerminal(o,c){return this.spawnTerminal(y,o,c)}runInTerminal(o,c,i,a,r){const s=r.linuxExec?Promise.resolve(r.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,g)=>{let S=[];s.then(D=>{D.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const A=`${u(i)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;S.push(`''${A}''`);const F=Object.assign({},I(process),a);Object.keys(F).filter(se=>F[se]===null).forEach(se=>delete F[se]);const U={cwd:c,env:F};let X="";const ne=y.spawn(D,S,U);ne.on("error",se=>{g(p(se))}),ne.stderr.on("data",se=>{X+=se.toString()}),ne.on("exit",se=>{if(se===0)l(void 0);else if(X){const G=X.split(`
`,1);g(new Error(G[0]))}else g(new Error(w.localize(4,null,D,se)))})})})}static async getDefaultTerminalLinuxReady(){return m._DEFAULT_TERMINAL_LINUX_READY||(m._DEFAULT_TERMINAL_LINUX_READY=new Promise(async o=>{M.isLinux?await n.Promises.exists("/etc/debian_version")?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm"):o("xterm")})),m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,c,i){const a=c.linuxExec?Promise.resolve(c.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((r,s)=>{a.then(l=>{const g=I(process),S=o.spawn(l,[],{cwd:i,env:g});S.on("error",s),S.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=m,m.WAIT_MESSAGE=w.localize(3,null);function I(h){const o={...h.env};return(0,E.sanitizeProcessEnvironment)(o),o}function p(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(w.localize(5,null,h.path)):h}function u(h){let o="";for(let c of h)c.indexOf(" ")>=0?o+='"'+c+'"':o+=c,o+=" ";return o}}),define(Z[20],x([0,1,37,8,25,13,7,140,5]),function(K,e,y,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function w(W){return W.create===!0}e.isFileOpenForWriteOptions=w;var t;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var P;(function(W){W[W.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var b;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=v;function d(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=d;function m(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function I(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=I;var p;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(V,B){super(V);this.code=B}}e.FileSystemProviderError=u;function h(W,V){const B=new u(W.toString(),V);return c(B,V),B}e.createFileSystemProviderError=h;function o(W){return W||h((0,n.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=o;function c(W,V){return W.name=V?`${V} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=c;function i(W){if(!W)return p.Unknown;if(W instanceof u)return W.code;const V=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!V)return p.Unknown;switch(V[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=i;function a(W){if(W instanceof D)return W.fileOperationResult;switch(i(W)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var r;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor(V,B,$){this.resource=V,this.operation=B,this.target=$}isOperation(V){return this.operation===V}}e.FileOperationEvent=s;var l;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class g{constructor(V,B){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const $ of V)switch($.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>B)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>B)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>B)),this.deleted.set($.resource,$);break}}contains(V,...B){return this.doContains(V,{includeChildren:!1},...B)}affects(V,...B){return this.doContains(V,{includeChildren:!0},...B)}doContains(V,B,...$){if(!V)return!1;const H=$.length>0;return!!((!H||$.includes(1))&&(this.added?.get(V)||B.includeChildren&&this.added?.findSuperstr(V))||(!H||$.includes(0))&&(this.updated?.get(V)||B.includeChildren&&this.updated?.findSuperstr(V))||(!H||$.includes(2))&&(this.deleted?.findSubstr(V)||B.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=g;function S(W,V,B){return!W||!V||W===V||V.length>W.length?!1:(V.charAt(V.length-1)!==L.sep&&(V+=L.sep),B?(0,k.startsWithIgnoreCase)(W,V):W.indexOf(V)===0)}e.isParent=S;class D extends Error{constructor(V,B,$){super(V);this.fileOperationResult=B,this.options=$}}e.FileOperationError=D;class A extends D{constructor(V,B,$){super(V,2,$);this.stat=B}}e.NotModifiedSinceFileOperationError=A;var F;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function X(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=X;async function ne(W,V){if(!V.canHandleResource(E.URI.from({scheme:W.scheme})))return new Promise(B=>{const $=V.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===W.scheme&&H.added&&($.dispose(),B())})})}e.whenProviderRegistered=ne,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class se{static formatSize(V){return(0,M.isNumber)(V)||(V=0),V<se.KB?(0,n.localize)(1,null,V.toFixed(0)):V<se.MB?(0,n.localize)(2,null,(V/se.KB).toFixed(2)):V<se.GB?(0,n.localize)(3,null,(V/se.MB).toFixed(2)):V<se.TB?(0,n.localize)(4,null,(V/se.GB).toFixed(2)):(0,n.localize)(5,null,(V/se.TB).toFixed(2))}}e.ByteSize=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;var G;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function J(W){return{maxFileSize:W===0?300*se.MB:16*se.GB,maxHeapSize:W===0?700*se.MB:2*700*se.MB}}e.getPlatformLimits=J}),define(Z[54],x([0,1,241,135,87,20]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function E(b,v){const d={onUnknownOption:I=>{console.warn((0,L.localize)(0,null,I))},onMultipleValues:(I,p)=>{console.warn((0,L.localize)(1,null,I,p))}},m=(0,k.parseArgs)(b,k.OPTIONS,v?d:void 0);return m.goto&&m._.forEach(I=>y(/^(\w:)?[^:]+(:\d*){0,2}$/.test(I),(0,L.localize)(2,null))),m["max-memory"]&&y(parseInt(m["max-memory"])>=M.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${M.MIN_MAX_MEMORY_SIZE_MB} MB.`),m}function n(b){const v=b.findIndex(d=>!/^-/.test(d));if(v>-1)return[...b.slice(0,v),...b.slice(v+1)]}function f(b){let[,...v]=b;process.env.VSCODE_DEV&&(v=n(v)||[]);const d=!P(process.env);return E(v,d)}e.parseMainProcessArgv=f;function w(b){const[,,...v]=b;return E(v,!0)}e.parseCLIProcessArgv=w;function t(b,...v){const d=b.indexOf("--");return d===-1?b.push(...v):b.splice(d,0,...v),b}e.addArg=t;function P(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),define(Z[90],x([0,1,41,159,24,67,17,3,28,130,54]),function(K,e,y,L,k,M,E,n,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function P(d,m,I){return m["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):n.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,t.isLaunchedFromCli)(I)&&!m["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,t.isLaunchedFromCli)(I)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=new Promise(async p=>{const u=new k.CancellationTokenSource,h=setTimeout(()=>{d.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),u.dispose(!0),p({})},1e4);try{const o=await v(d,u.token);p(o)}catch(o){(0,E.isPromiseCanceledError)(o)||d.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),p({})}finally{clearTimeout(h),u.dispose()}})),b)}e.resolveShellEnv=P;let b;async function v(d,m){const I=new Promise(async(p,u)=>{const h=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",o);const c=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(c+"(.*)"+c),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",a);const r=await(0,w.getSystemShell)(n.OS,a);if(d.trace("getUnixShellEnvironment#shell",r),m.isCancellationRequested)return u(E.canceled);const s=L.basename(r);let l,g;/^pwsh(-preview)?$/.test(s)?(l=`& '${process.execPath}' -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,g=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,g=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),l);const S=(0,y.spawn)(r,[...g,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});m.onCancellationRequested(()=>(S.kill(),u(E.canceled))),S.on("error",F=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(F)),p({})});const D=[];S.stdout.on("data",F=>D.push(F));const A=[];S.stderr.on("data",F=>A.push(F)),S.on("close",(F,U)=>{const X=Buffer.concat(D).toString("utf8");d.trace("getUnixShellEnvironment#raw",X);const ne=Buffer.concat(A).toString("utf8");if(ne.trim()&&d.trace("getUnixShellEnvironment#stderr",ne),F||U)return u(new Error(`Failed to get environment (code ${F}, signal ${U})`));const se=i.exec(X),G=se?se[1]:"{}";try{const J=JSON.parse(G);h?J.ELECTRON_RUN_AS_NODE=h:delete J.ELECTRON_RUN_AS_NODE,o?J.ELECTRON_NO_ATTACH_CONSOLE=o:delete J.ELECTRON_NO_ATTACH_CONSOLE,delete J.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",J),p(J)}catch(J){d.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(J)),u(J)}})});try{return await I}catch(p){return d.error("getUnixShellEnvironment#error",(0,M.toErrorMessage)(p)),{}}}}),define(Z[91],x([0,1,3,7,20]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function M(f){return f.map(w=>({type:w.type,resource:L.URI.file(w.path)}))}e.toFileChanges=M;function E(f){const w=new n;for(const t of f)w.processEvent(t);return w.normalize()}e.normalizeFileChanges=E;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(w){const t=this.mapPathToChange.get(w.path);if(t){const P=t.type,b=w.type;P===1&&b===2?(this.mapPathToChange.delete(w.path),this.normalized.splice(this.normalized.indexOf(t),1)):P===2&&b===1?t.type=0:P===1&&b===0||(t.type=b)}else this.normalized.push(w),this.mapPathToChange.set(w.path,w)}normalize(){const w=[],t=[];return this.normalized.filter(P=>P.type!==2?(w.push(P),!1):!0).sort((P,b)=>P.path.length-b.path.length).filter(P=>t.some(b=>(0,k.isParent)(P.path,b,!y.isLinux))?!1:(t.push(P.path),!0)).concat(w)}}}),define(Z[173],x([0,1,9,2,8,81,19,117,91]),function(K,e,y,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends L.Disposable{constructor(P,b,v,d){super();this.path=P,this.onDidFilesChange=b,this.onLogMessage=v,this.verboseLogging=d,this.fileChangesDelayer=this._register(new y.ThrottledDelayer(n.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(P){this.verboseLogging=P}async startWatching(){try{const{stat:P,symbolicLink:b}=await E.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let v=this.path;if(b)try{v=await(0,M.realpath)(v)}catch(d){if(this.onError(d),b.dangling)return}P.isDirectory()?this._register((0,n.watchFolder)(v,(d,m)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,k.join)(this.path,(0,k.basename)(m))})},d=>this.onError(d))):this._register((0,n.watchFile)(v,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(P){P.code!=="ENOENT"&&this.onError(P)}}onFileChange(P){this.fileChangesBuffer.push(P),this.verboseLogging&&this.onVerbose(`${P.type===1?"[ADDED]":P.type===2?"[DELETED]":"[CHANGED]"} ${P.path}`),this.fileChangesDelayer.trigger(async()=>{const b=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=(0,f.normalizeFileChanges)(b);if(this.verboseLogging)for(const d of v)this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);v.length>0&&this.onDidFilesChange(v)})}onError(P){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${P}`})}onVerbose(P){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${P}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(Z[71],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class y{constructor(...k){this._entries=new Map;for(let[M,E]of k)this.set(M,E)}set(k,M){const E=this._entries.get(k);return this._entries.set(k,M),E}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=y}),define(Z[174],x([0,1,9,17,69,167,5,71]),function(K,e,y,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class w extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class t{constructor(d=new n.ServiceCollection,m=!1,I){this._activeInstantiations=new Set,this._services=d,this._strict=m,this._parent=I,this._services.set(E.IInstantiationService,this)}createChild(d){return new t(d,this._strict,this)}invokeFunction(d,...m){let I=b.traceInvocation(d),p=!1;try{return d({get:(h,o)=>{if(p)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(h,I);if(!c&&o!==E.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return c}},...m)}finally{p=!0,I.stop()}}createInstance(d,...m){let I,p;return d instanceof k.SyncDescriptor?(I=b.traceCreation(d.ctor),p=this._createInstance(d.ctor,d.staticArguments.concat(m),I)):(I=b.traceCreation(d),p=this._createInstance(d,m,I)),I.stop(),p}_createInstance(d,m=[],I){let p=E._util.getServiceDependencies(d).sort((o,c)=>o.index-c.index),u=[];for(const o of p){let c=this._getOrCreateServiceInstance(o.id,I);if(!c&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);u.push(c)}let h=p.length>0?p[0].index:m.length;if(m.length!==h){console.warn(`[createInstance] First service dependency of ${d.name} at position ${h+1} conflicts with ${m.length} static arguments`);let o=h-m.length;o>0?m=m.concat(new Array(o)):m=m.slice(0,h)}return new d(...[...m,...u])}_setServiceInstance(d,m){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,m);else if(this._parent)this._parent._setServiceInstance(d,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let m=this._services.get(d);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):m}_getOrCreateServiceInstance(d,m){let I=this._getServiceInstanceOrDescriptor(d);return I instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,I,m.branch(d,!0)):(m.branch(d,!1),I)}_safeCreateAndCacheServiceInstance(d,m,I){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,m,I)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,m,I){const p=new M.Graph(o=>o.id.toString());let u=0;const h=[{id:d,desc:m,_trace:I}];for(;h.length;){const o=h.pop();if(p.lookupOrInsertNode(o),u++>1e3)throw new w(p);for(let c of E._util.getServiceDependencies(o.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(c.id);if(!i&&!c.optional&&console.warn(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`),i instanceof k.SyncDescriptor){const a={id:c.id,desc:i,_trace:o._trace.branch(c.id,!0)};p.insertEdge(o,a),h.push(a)}}}for(;;){const o=p.roots();if(o.length===0){if(!p.isEmpty())throw new w(p);break}for(const{data:c}of o){if(this._getServiceInstanceOrDescriptor(c.id)instanceof k.SyncDescriptor){const a=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,a)}p.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,m,I=[],p,u){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(m,I,p,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,m,I,p,u);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(d,m=[],I,p){if(I){const u=new y.IdleValue(()=>this._createInstance(d,m,p));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let c=u.value,i=c[o];return typeof i!="function"||(i=i.bind(c),h[o]=i),i},set(h,o,c){return u.value[o]=c,!0}})}else return this._createInstance(d,m,p)}}e.InstantiationService=t;var P;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(P||(P={}));class b{constructor(d,m){this.type=d,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return f?new b(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(d){return f?new b(0,d.name):b._None}branch(d,m){let I=new b(2,d.toString());return this._dep.push([d,m,I]),I}stop(){let d=Date.now()-this._start;b._totals+=d;let m=!1;function I(u,h){let o=[],c=new Array(u+1).join("	");for(const[i,a,r]of h._dep)if(a&&r){m=!0,o.push(`${c}CREATES -> ${i}`);let s=I(u+1,r);s&&o.push(s)}else o.push(`${c}uses -> ${i}`);return o.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(d>2||m)&&console.log(p.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(Z[175],x([0,1,17,128,57]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class M extends k.ResolvedKeybinding{constructor(n,f){super();if(f.length===0)throw(0,y.illegalArgument)("parts");this._os=n,this._parts=f}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new k.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=M}),define(Z[176],x([0,1,57,175]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends L.BaseResolvedKeybinding{constructor(E,n){super(n,E.parts)}_keyCodeToUILabel(E){if(this._os===2)switch(E){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return y.KeyCodeUtils.toString(E)}_getLabel(E){return E.isDuplicateModifierCase()?"":this._keyCodeToUILabel(E.keyCode)}_getAriaLabel(E){return E.isDuplicateModifierCase()?"":y.KeyCodeUtils.toString(E.keyCode)}_keyCodeToElectronAccelerator(E){if(E>=93&&E<=108)return null;switch(E){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return y.KeyCodeUtils.toString(E)}_getElectronAccelerator(E){return E.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(E.keyCode)}_getUserSettingsLabel(E){if(E.isDuplicateModifierCase())return"";const n=y.KeyCodeUtils.toUserSettingsUS(E.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(E){return k.getDispatchStr(E)}static getDispatchStr(E){if(E.isModifierKey())return null;let n="";return E.ctrlKey&&(n+="ctrl+"),E.shiftKey&&(n+="shift+"),E.altKey&&(n+="alt+"),E.metaKey&&(n+="meta+"),n+=y.KeyCodeUtils.toString(E.keyCode),n}_getSingleModifierDispatchPart(E){return E.keyCode===5&&!E.shiftKey&&!E.altKey&&!E.metaKey?"ctrl":E.keyCode===4&&!E.ctrlKey&&!E.altKey&&!E.metaKey?"shift":E.keyCode===6&&!E.ctrlKey&&!E.shiftKey&&!E.metaKey?"alt":E.keyCode===57&&!E.ctrlKey&&!E.shiftKey&&!E.altKey?"meta":null}}e.USLayoutResolvedKeybinding=k}),define(Z[177],x([0,1,9]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(k,M){if(k.length===0)return Promise.resolve(!1);const E=[];let n=!1;for(let f of k){if(f===!0)return Promise.resolve(!0);(0,y.isThenable)(f)&&E.push(f.then(w=>{w&&(n=!0)},w=>{M(w),n=!0}))}return y.Promises.settled(E).then(()=>n)}e.handleVetos=L}),define(Z[6],x([0,1,67,4,2,3,5]),function(K,e,y,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function n(){return new Date().toISOString()}var f;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class w extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class t extends w{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...a){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([i,...a]))}debug(i,...a){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([i,...a]))}info(i,...a){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([i,...a]))}warn(i,...a){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([i,...a]))}error(i,...a){if(this.checkLogLevel(f.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(f.Error,this.format(r))}else this.log(f.Error,this.format([i,...a]))}critical(i,...a){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([i,...a]))}flush(){}format(i){let a="";for(let r=0;r<i.length;r++){let s=i[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(l){}a+=(r>0?" ":"")+s}return a}}e.AbstractMessageLogger=t;class P extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!M.isWindows}trace(i,...a){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...a):console.log(`[main ${n()}]`,i,...a))}debug(i,...a){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...a):console.log(`[main ${n()}]`,i,...a))}info(i,...a){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...a):console.log(`[main ${n()}]`,i,...a))}warn(i,...a){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,i,...a):console.warn(`[main ${n()}]`,i,...a))}error(i,...a){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,i,...a):console.error(`[main ${n()}]`,i,...a))}critical(i,...a){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,i,...a):console.error(`[main ${n()}]`,i,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class b extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...a){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",i,...a)}debug(i,...a){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...a)}info(i,...a){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",i,...a)}warn(i,...a){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",i,...a)}error(i,...a){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",i,...a)}critical(i,...a){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...a)}dispose(){}flush(){}}e.ConsoleLogger=b;class v extends w{constructor(i,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(a)}trace(i,...a){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(i),...a])}debug(i,...a){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(i),...a])}info(i,...a){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(i),...a])}warn(i,...a){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(i),...a])}error(i,...a){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(i),...a])}critical(i,...a){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(i),...a])}extractMessage(i){return typeof i=="string"?i:(0,y.toErrorMessage)(i,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class d extends w{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const a of this.logServices)a.setLevel(i);super.setLevel(i)}trace(i,...a){for(const r of this.logServices)r.trace(i,...a)}debug(i,...a){for(const r of this.logServices)r.debug(i,...a)}info(i,...a){for(const r of this.logServices)r.info(i,...a)}warn(i,...a){for(const r of this.logServices)r.warn(i,...a)}error(i,...a){for(const r of this.logServices)r.error(i,...a)}critical(i,...a){for(const r of this.logServices)r.critical(i,...a)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=d;class m extends k.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...a){this.logger.trace(i,...a)}debug(i,...a){this.logger.debug(i,...a)}info(i,...a){this.logger.info(i,...a)}warn(i,...a){this.logger.warn(i,...a)}error(i,...a){this.logger.error(i,...a)}critical(i,...a){this.logger.critical(i,...a)}flush(){this.logger.flush()}}e.LogService=m;class I extends k.Disposable{constructor(i,a){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,a){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,a?.always?f.Trace:this.logLevel,a),this.loggers.set(i.toString(),r),a?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class p{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(i){}getLevel(){return f.Info}trace(i,...a){}debug(i,...a){}info(i,...a){}warn(i,...a){}error(i,...a){}critical(i,...a){}dispose(){}flush(){}}e.NullLogService=p;function u(c){if(c.verbose)return f.Trace;if(typeof c.logLevel=="string"){const i=h(c.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function h(c){switch(c){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=h;function o(c){switch(c){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=o});var te=this&&this.__param||function(K,e){return function(y,L){e(y,L,K)}};define(Z[178],x([0,1,9,18,40,77,48,20,5,6]),function(K,e,y,L,k,M,E,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var t;(function(b){b.ERROR_INVALID_FILE="ERROR_INVALID_FILE",b.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(t=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,f.createDecorator)(e.UserConfigurationFileServiceId);let P=class{constructor(v,d,m){this.environmentService=v,this.fileService=d,this.logService=m,this.queue=new y.Queue}async updateSettings(v,d){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,v,d))}async doWrite(v,d,m){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,v.toString(),d);const{value:I,mtime:p,etag:u}=await this.fileService.readFile(v,{atomic:!0});let h=I.toString();const o=[];if((0,k.parse)(h,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(d,h,m)[0];if(c){h=h.substring(0,c.offset)+c.content+h.substring(c.offset+c.length);try{await this.fileService.writeFile(v,L.VSBuffer.fromString(h),{etag:u,mtime:p})}catch(i){if(i.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:v,path:d},m,I){return d.length?(0,M.setProperty)(m,d,v,I):[{content:JSON.stringify(v,null,I.insertSpaces&&I.tabSize?" ".repeat(I.tabSize):"	"),length:m.length,offset:0}]}};P=he([te(0,E.IEnvironmentService),te(1,n.IFileService),te(2,w.ILogService)],P),e.UserConfigurationFileService=P}),define(Z[92],x([0,1,6]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(M,E){switch(E){case y.LogLevel.Trace:return M.trace;case y.LogLevel.Debug:return M.debug;case y.LogLevel.Info:return M.info;case y.LogLevel.Warning:return M.warn;case y.LogLevel.Error:return M.error;case y.LogLevel.Critical:return M.critical;default:throw new Error("Invalid log level")}}class k extends y.AbstractLogger{constructor(E=y.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(E),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(E){this._logger=E;for(const{level:n,args:f}of this.buffer)L(E,n).apply(E,f);this.buffer=[]}_log(E,...n){this._logger?L(this._logger,E).apply(this._logger,n):this.getLevel()<=E&&this.buffer.push({level:E,args:n})}trace(E,...n){this._log(y.LogLevel.Trace,E,...n)}debug(E,...n){this._log(y.LogLevel.Debug,E,...n)}info(E,...n){this._log(y.LogLevel.Info,E,...n)}warn(E,...n){this._log(y.LogLevel.Warning,E,...n)}error(E,...n){this._log(y.LogLevel.Error,E,...n)}critical(E,...n){this._log(y.LogLevel.Critical,E,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=k}),define(Z[179],x([0,1,9,18,15,20,5,92,6]),function(K,e,y,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const w=5*M.ByteSize.MB;let t=class extends f.AbstractLogger{constructor(v,d,m,I,p){super();this.name=v,this.resource=d,this.donotUseFormatters=I,this.fileService=p,this.backupIndex=1,this.setLevel(m),this.queue=this._register(new y.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const v=arguments[0];if(v instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=v.stack,this._log(f.LogLevel.Error,this.format(d))}else this._log(f.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,this.format(arguments))}flush(){}log(v,d){this._log(v,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(v){if(v.fileOperationResult!==3)throw v}}_log(v,d){this.queue.queue(async()=>{await this.initializePromise;let m=await this.loadContent();m.length>w&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(m)),m=""),this.donotUseFormatters?m+=d:m+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(v)}] ${d}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(m))})}getCurrentTimestamp(){const v=I=>I<10?`0${I}`:I,d=I=>I<10?`00${I}`:I<100?`0${I}`:I,m=new Date;return`${m.getFullYear()}-${v(m.getMonth()+1)}-${v(m.getDate())} ${v(m.getHours())}:${v(m.getMinutes())}:${v(m.getSeconds())}.${d(m.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(v){return""}}stringifyLogLevel(v){switch(v){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}format(v){let d="";for(let m=0;m<v.length;m++){let I=v[m];if(typeof I=="object")try{I=JSON.stringify(I)}catch(p){}d+=(m>0?" ":"")+I}return d}};t=he([te(4,M.IFileService)],t),e.FileLogger=t;let P=class extends f.AbstractLoggerService{constructor(v,d,m){super(v.getLevel(),v.onDidChangeLogLevel);this.instantiationService=d,this.fileService=m}doCreateLogger(v,d,m){const I=new n.BufferLogService(d);return(0,M.whenProviderRegistered)(v,this.fileService).then(()=>I.logger=this.instantiationService.createInstance(t,(0,k.basename)(v),v,I.getLevel(),!!m?.donotUseFormatters)),I}};P=he([te(0,f.ILogService),te(1,E.IInstantiationService),te(2,M.IFileService)],P),e.FileLoggerService=P}),define(Z[180],x([0,1,4,7,6]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(b){this.service=b,this.onDidChangeLogLevel=y.Event.buffer(b.onDidChangeLogLevel,!0)}listen(b,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(b,v,d){switch(v){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=M;class E{constructor(b){this.channel=b}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(b){E.setLevel(this.channel,b)}static setLevel(b,v){return b.call("setLevel",v)}}e.LogLevelChannelClient=E;class n{constructor(b){this.loggerService=b,this.loggers=new Map}listen(b,v){throw new Error(`Event not found: ${v}`)}async call(b,v,d){switch(v){case"createLogger":this.createLogger(L.URI.revive(d[0]),d[1]);return;case"log":return this.log(L.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${v}`)}createLogger(b,v){this.loggers.set(b.toString(),this.loggerService.createLogger(b,v))}consoleLog(b,v){let d=console.log;switch(b){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...v)}log(b,v){const d=this.loggers.get(b.toString());if(!d)throw new Error("Create the logger before logging");for(const[m,I]of v)switch(m){case k.LogLevel.Trace:d.trace(I);break;case k.LogLevel.Debug:d.debug(I);break;case k.LogLevel.Info:d.info(I);break;case k.LogLevel.Warning:d.warn(I);break;case k.LogLevel.Error:d.error(I);break;case k.LogLevel.Critical:d.critical(I);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class f extends k.AbstractLoggerService{constructor(b,v,d){super(b,v);this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(b,v)=>{this.channel.call("consoleLog",[b,v])}})}doCreateLogger(b,v,d){return new w(this.channel,b,v,d)}}e.LoggerChannelClient=f;class w extends k.AbstractMessageLogger{constructor(b,v,d,m){super(m?.always);this.channel=b,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[v,m]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,v){const d=[[b,v]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(b){this.channel.call("log",[this.file,b])}}class t extends k.LogService{constructor(b,v){super(v);this.parent=b,this._register(b.onDidChangeLogLevel(d=>v.setLevel(d)))}setLevel(b){super.setLevel(b),this.parent.setLevel(b)}}e.FollowerLogService=t}),define(Z[93],x([0,1,20,6]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(f,w,t,P){try{const b=await new Promise((v,d)=>{K(["spdlog"],v,d)});return b.setFlushOn(L.LogLevel.Trace),b.createAsyncRotatingLogger(f,w,t,P)}catch(b){console.error(b)}return null}function M(f,w,t,P){const b=K.__$__nodeRequire("spdlog");return b.setFlushOn(L.LogLevel.Trace),b.createRotatingLogger(f,w,t,P)}e.createRotatingLogger=M;function E(f,w,t){switch(w){case L.LogLevel.Trace:f.trace(t);break;case L.LogLevel.Debug:f.debug(t);break;case L.LogLevel.Info:f.info(t);break;case L.LogLevel.Warning:f.warn(t);break;case L.LogLevel.Error:f.error(t);break;case L.LogLevel.Critical:f.critical(t);break;default:throw new Error("Invalid log level")}}class n extends L.AbstractMessageLogger{constructor(w,t,P,b){super();this.name=w,this.filepath=t,this.rotating=P,this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(v=>{this._logger&&this._logger.setLevel(v)}))}_createSpdLogLogger(){const w=this.rotating?6:1,t=30/w*y.ByteSize.MB;return k(this.name,this.filepath,t,w).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:b,message:v}of this.buffer)E(this._logger,b,v);this.buffer=[]}})}log(w,t){this._logger?E(this._logger,w,t):this.getLevel()<=w&&this.buffer.push({level:w,message:t})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(Z[181],x([0,1,10,15,28,20,179,6,93]),function(K,e,y,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let w=class extends n.AbstractLoggerService{constructor(P,b){super(P.getLevel(),P.onDidChangeLogLevel);this.fileService=b}doCreateLogger(P,b,v){if(P.scheme===y.Schemas.file){const d=new f.SpdLogLogger(v?.name||(0,k.generateUuid)(),P.fsPath,!v?.donotRotate,b);return v?.donotUseFormatters&&d.clearFormatters(),d}else return new E.FileLogger(v?.name??(0,L.basename)(P),P,b,!!v?.donotUseFormatters,this.fileService)}};w=he([te(0,n.ILogService),te(1,M.IFileService)],w),e.LoggerService=w}),define(Z[182],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function y(E){return E.submenu!==void 0}e.isMenubarMenuItemSubmenu=y;function L(E){return E.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function k(E){return E.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function M(E){return!y(E)&&!L(E)&&!k(E)}e.isMenubarMenuItemAction=M}),define(Z[45],x([0,1,10,3,32,15]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let E;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const n=L.globals.vscode.context.configuration();if(n)E=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const n=(0,M.dirname)(y.FileAccess.asFileUri("",K));E=K.__$__nodeRequire((0,M.joinPath)(n,"product.json").fsPath);const f=K.__$__nodeRequire((0,M.joinPath)(n,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(E,{nameShort:`${E.nameShort} Dev`,nameLong:`${E.nameLong} Dev`,dataFolderName:`${E.dataFolderName}-dev`}),Object.assign(E,{version:f.version})}else E={},Object.keys(E).length===0&&Object.assign(E,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=E}),define(Z[94],x([0,1,18,17,141,20,45]),function(K,e,y,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(P,b,v,d,m,I){let p;try{await f(P,b,v,d,m,I)}catch(u){p=u}finally{p&&m.errorTransformer&&(p=m.errorTransformer(p)),typeof p!="undefined"&&v.error(p),v.end()}}e.readFileIntoStream=n;async function f(P,b,v,d,m,I){w(I);const p=await P.open(b,{create:!1});try{w(I);let u=0,h=0,o=m&&typeof m.length=="number"?m.length:void 0,c=y.VSBuffer.alloc(Math.min(m.bufferSize,typeof o=="number"?o:m.bufferSize)),i=m&&typeof m.position=="number"?m.position:0,a=0;do h=await P.read(p,i,c.buffer,a,c.byteLength-a),i+=h,a+=h,u+=h,typeof o=="number"&&(o-=h),a===c.byteLength&&(await v.write(d(c)),c=y.VSBuffer.alloc(Math.min(m.bufferSize,typeof o=="number"?o:m.bufferSize)),a=0);while(h>0&&(typeof o!="number"||o>0)&&w(I)&&t(u,m));if(a>0){let r=a;typeof o=="number"&&(r=Math.min(a,o)),v.write(d(c.slice(0,r)))}}catch(u){throw(0,M.ensureFileSystemProviderError)(u)}finally{await P.close(p)}}function w(P){if(P.isCancellationRequested)throw(0,L.canceled)();return!0}function t(P,b){if(b?.limits){if(typeof b.limits.memory=="number"&&P>b.limits.memory)throw(0,M.createFileSystemProviderError)((0,k.localize)(0,null,E.default.nameShort),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&P>b.limits.size)throw(0,M.createFileSystemProviderError)((0,k.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[183],x([0,1,31,9,18,24,4,63,2,37,10,72,15,64,139,20,94,6]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class Ve extends f.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new E.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new E.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new E.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new E.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new E.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new E.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new m.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new m.FileChangesEvent(c,!0)))),this.watchedResources=w.TernarySearchTree.forUris(c=>{const i=this.getProvider(c.scheme);return i?!this.isPathCaseSensitive(i):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,c){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,P.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:c});const i=new f.DisposableStore;return i.add(c.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(c)))),i.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:o}))),typeof c.onDidErrorOccur=="function"&&i.add(c.onDidErrorOccur(a=>this._onError.fire(new Error(a)))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:c}),this.provider.delete(o),(0,f.dispose)(i)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(i){c.push(i)}}),!this.provider.has(o)&&await L.Promises.settled(c)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,c){const i=this.provider.get(o.scheme);return!!(i&&i.capabilities&c)}listCapabilities(){return n.Iterable.map(this.provider,([o,c])=>({scheme:o,capabilities:c.capabilities}))}async withProvider(o){if(!(0,b.isAbsolutePath)(o))throw new m.FileOperationError((0,d.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const c=this.provider.get(o.scheme);if(!c){const i=new Error;throw i.name="ENOPRO",i.message=(0,d.localize)(1,null,o.toString()),i}return c}async withReadProvider(o){const c=await this.withProvider(o);if((0,m.hasOpenReadWriteCloseCapability)(c)||(0,m.hasReadWriteCapability)(c)||(0,m.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const c=await this.withProvider(o);if((0,m.hasOpenReadWriteCloseCapability)(c)||(0,m.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,c){try{return await this.doResolveFile(o,c)}catch(i){throw(0,m.toFileSystemProviderErrorCode)(i)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,d.localize)(2,null,this.resourceForError(o)),1):(0,m.ensureFileSystemProviderError)(i)}}async doResolveFile(o,c){const i=await this.withProvider(o),a=this.isPathCaseSensitive(i),r=c?.resolveTo,s=c?.resolveSingleChildDescendants,l=c?.resolveMetadata,g=await i.stat(o);let S;return this.toFileStat(i,o,g,void 0,!!l,(D,A)=>{if(!S&&(S=w.TernarySearchTree.forUris(()=>!a),S.set(o,!0),r))for(const F of r)S.set(F,!0);return S.get(D.resource)||S.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&s?A===1:!1})}async toFileStat(o,c,i,a,r,s){const{providerExtUri:l}=this.getExtUri(o),g={resource:c,name:l.basename(c),isFile:(i.type&m.FileType.File)!=0,isDirectory:(i.type&m.FileType.Directory)!=0,isSymbolicLink:(i.type&m.FileType.SymbolicLink)!=0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&m.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,m.etag)({mtime:i.mtime,size:i.size})};if(g.isDirectory&&s(g,a)){try{const S=await o.readdir(c),D=await L.Promises.settled(S.map(async([A,F])=>{try{const U=l.joinPath(c,A),X=r?await o.stat(U):{type:F};return await this.toFileStat(o,U,X,S.length,r,s)}catch(U){return this.logService.trace(U),null}}));g.children=(0,y.coalesce)(D)}catch(S){this.logService.trace(S),g.children=[]}return g}return g}async resolveAll(o){return L.Promises.settled(o.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async exists(o){const c=await this.withProvider(o);try{return!!await c.stat(o)}catch(i){return!1}}async canCreateFile(o,c){try{await this.doValidateCreateFile(o,c)}catch(i){return i}return!0}async doValidateCreateFile(o,c){if(!c?.overwrite&&await this.exists(o))throw new m.FileOperationError((0,d.localize)(3,null,this.resourceForError(o)),3,c)}async createFile(o,c=k.VSBuffer.fromString(""),i){await this.doValidateCreateFile(o,i);const a=await this.writeFile(o,c);return this._onDidRunOperation.fire(new m.FileOperationEvent(o,0,a)),a}async writeFile(o,c,i){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(a);try{await this.validateWriteFile(a,o,i)||await this.mkdirp(a,r.dirname(o));let l;if((0,m.hasReadWriteCapability)(a)&&!(c instanceof k.VSBuffer))if((0,v.isReadableStream)(c)){const g=await(0,v.peekStream)(c,3);g.ended?l=k.VSBuffer.concat(g.buffer):l=g}else l=(0,v.peekReadable)(c,g=>k.VSBuffer.concat(g),3);else l=c;!(0,m.hasOpenReadWriteCloseCapability)(a)||(0,m.hasReadWriteCapability)(a)&&l instanceof k.VSBuffer?await this.doWriteUnbuffered(a,o,i,l):await this.doWriteBuffered(a,o,i,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l)}catch(s){throw new m.FileOperationError((0,d.localize)(4,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(s).toString()),(0,m.toFileOperationResult)(s),i)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,c,i){if(!!i?.unlock&&!(o.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(c)));let r;try{r=await o.stat(c)}catch(s){return}if((r.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,d.localize)(6,null,this.resourceForError(c)),0,i);if(this.throwIfFileIsReadonly(c,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==m.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,m.etag)({mtime:i.mtime,size:r.size}))throw new m.FileOperationError((0,d.localize)(7,null),3,i);return r}async readFile(o,c){const i=await this.withReadProvider(o);return c?.atomic?this.doReadFileAtomic(i,o,c):this.doReadFile(i,o,c)}async doReadFileAtomic(o,c,i){return new Promise((a,r)=>{this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,c,i);a(s)}catch(s){r(s)}})})}async doReadFile(o,c,i){const a=await this.doReadFileStream(o,c,{...i,preferUnbuffered:!0});return{...a,value:await(0,k.streamToBuffer)(a.value)}}async readFileStream(o,c){const i=await this.withReadProvider(o);return this.doReadFileStream(i,o,c)}async doReadFileStream(o,c,i){const a=new M.CancellationTokenSource,r=this.validateReadFile(c,i).then(l=>l,l=>{throw a.cancel(),l});let s;try{return typeof i?.etag=="string"&&i.etag!==m.ETAG_DISABLED&&await r,!((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasFileReadStreamCapability)(o))||(0,m.hasReadWriteCapability)(o)&&i?.preferUnbuffered?s=this.readFileUnbuffered(o,c,i):(0,m.hasFileReadStreamCapability)(o)?s=this.readFileStreamed(o,c,a.token,i):s=this.readFileBuffered(o,c,a.token,i),{...await r,value:s}}catch(l){s&&await(0,v.consumeStream)(s);const g=(0,d.localize)(8,null,this.resourceForError(c),(0,m.ensureFileSystemProviderError)(l).toString());throw l instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(g,l.stat,i):new m.FileOperationError(g,(0,m.toFileOperationResult)(l),i)}}readFileStreamed(o,c,i,a=Object.create(null)){const r=o.readFileStream(c,a,i);return(0,v.transform)(r,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new m.FileOperationError((0,d.localize)(9,null,this.resourceForError(c),(0,m.ensureFileSystemProviderError)(s).toString()),(0,m.toFileOperationResult)(s),a)},s=>k.VSBuffer.concat(s))}readFileBuffered(o,c,i,a=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,I.readFileIntoStream)(o,c,r,s=>s,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new m.FileOperationError((0,d.localize)(10,null,this.resourceForError(c),(0,m.ensureFileSystemProviderError)(s).toString()),(0,m.toFileOperationResult)(s),a)},i),r}readFileUnbuffered(o,c,i){const a=(0,v.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r=await o.readFile(c);typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.validateReadFileLimits(c,r.byteLength,i),a.end(k.VSBuffer.wrap(r))}catch(r){a.error(r),a.end()}})(),a}async validateReadFile(o,c){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new m.FileOperationError((0,d.localize)(11,null,this.resourceForError(o)),0,c);if(typeof c?.etag=="string"&&c.etag!==m.ETAG_DISABLED&&c.etag===i.etag)throw new m.NotModifiedSinceFileOperationError((0,d.localize)(12,null),i,c);return this.validateReadFileLimits(o,i.size,c),i}validateReadFileLimits(o,c,i){if(i?.limits){let a;if(typeof i.limits.memory=="number"&&c>i.limits.memory&&(a=9),typeof i.limits.size=="number"&&c>i.limits.size&&(a=7),typeof a=="number")throw new m.FileOperationError((0,d.localize)(13,null,this.resourceForError(o)),a)}}async canMove(o,c,i){return this.doCanMoveCopy(o,c,"move",i)}async canCopy(o,c,i){return this.doCanMoveCopy(o,c,"copy",i)}async doCanMoveCopy(o,c,i,a){if(o.toString()!==c.toString())try{const r=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(r,o,s,c,i,a)}catch(r){return r}return!0}async move(o,c,i){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),s=await this.doMoveCopy(a,o,r,c,"move",!!i),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(o,s==="move"?2:3,l)),l}async copy(o,c,i){const a=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),s=await this.doMoveCopy(a,o,r,c,"copy",!!i),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(o,s==="copy"?3:2,l)),l}async doMoveCopy(o,c,i,a,r,s){if(c.toString()===a.toString())return r;const{exists:l,isSameResourceWithDifferentPathCase:g}=await this.doValidateMoveCopy(o,c,i,a,r,s);if(l&&!g&&s&&await this.del(a,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(a)),r==="copy"){if(o===i&&(0,m.hasFileFolderCopyCapability)(o))await o.copy(c,a,{overwrite:s});else{const S=await this.resolve(c);S.isDirectory?await this.doCopyFolder(o,S,i,a):await this.doCopyFile(o,c,i,a)}return r}else return o===i?(await o.rename(c,a,{overwrite:s}),r):(await this.doMoveCopy(o,c,i,a,"copy",s),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(o,c,i,a){if((0,m.hasOpenReadWriteCloseCapability)(o)&&(0,m.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(o,c,i,a);if((0,m.hasOpenReadWriteCloseCapability)(o)&&(0,m.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(o,c,i,a);if((0,m.hasReadWriteCapability)(o)&&(0,m.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(o,c,i,a);if((0,m.hasReadWriteCapability)(o)&&(0,m.hasReadWriteCapability)(i))return this.doPipeUnbuffered(o,c,i,a)}async doCopyFolder(o,c,i,a){await i.mkdir(a),Array.isArray(c.children)&&await L.Promises.settled(c.children.map(async r=>{const s=this.getExtUri(i).providerExtUri.joinPath(a,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),i,s):this.doCopyFile(o,r.resource,i,s)}))}async doValidateMoveCopy(o,c,i,a,r,s){let l=!1;if(o===i){const{providerExtUri:S,isPathCaseSensitive:D}=this.getExtUri(o);if(D||(l=S.isEqual(c,a)),l&&r==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(c),this.resourceForError(a)));if(!l&&S.isEqualOrParent(a,c))throw new Error((0,d.localize)(15,null,this.resourceForError(c),this.resourceForError(a)))}const g=await this.exists(a);if(g&&!l){if(!s)throw new m.FileOperationError((0,d.localize)(16,null,this.resourceForError(c),this.resourceForError(a)),4);if(o===i){const{providerExtUri:S}=this.getExtUri(o);if(S.isEqualOrParent(c,a))throw new Error((0,d.localize)(17,null,this.resourceForError(c),this.resourceForError(a)))}}return{exists:g,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const c=this.isPathCaseSensitive(o);return{providerExtUri:c?b.extUri:b.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(c,o);const i=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(o,0,i)),i}async mkdirp(o,c){const i=[],{providerExtUri:a}=this.getExtUri(o);for(;!a.isEqual(c,a.dirname(c));)try{if(((await o.stat(c)).type&m.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(c)));break}catch(r){if((0,m.toFileSystemProviderErrorCode)(r)!==m.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(a.basename(c)),c=a.dirname(c)}for(let r=i.length-1;r>=0;r--){c=a.joinPath(c,i[r]);try{await o.mkdir(c)}catch(s){if((0,m.toFileSystemProviderErrorCode)(s)!==m.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,c){try{await this.doValidateDelete(o,c)}catch(i){return i}return!0}async doValidateDelete(o,c){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!c?.useTrash&&!(i.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(o)));let r;try{r=await i.stat(o)}catch(l){}if(r)this.throwIfFileIsReadonly(o,r);else throw new m.FileOperationError((0,d.localize)(20,null,this.resourceForError(o)),1);if(!!!c?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(o)))}return i}async del(o,c){const i=await this.doValidateDelete(o,c),a=!!c?.useTrash,r=!!c?.recursive;await i.delete(o,{recursive:r,useTrash:a}),this._onDidRunOperation.fire(new m.FileOperationEvent(o,1))}onDidChangeFile(o,c){this._onDidChangeFilesRaw.fire({changes:o});let i,a;{for(const r of o)this.watchedResources.has(r.resource)?(i||(i=[]),i.push(r)):(a||(a=[]),a.push(r));i&&this._onDidFilesChange.fire(new m.FileChangesEvent(i,!c))}if(a){const r=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(a)&&Ve.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,c={recursive:!1,excludes:[]}){const i=new f.DisposableStore;{let a=!1,r=()=>{a=!0};i.add((0,f.toDisposable)(()=>r())),this.doWatch(o,c).then(s=>{a?(0,f.dispose)(s):r=()=>(0,f.dispose)(s)},s=>this.logService.error(s))}return c.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),i.add((0,f.toDisposable)(()=>{const a=this.watchedResources.get(o);typeof a=="number"&&(a<=1?this.watchedResources.delete(o):this.watchedResources.set(o,a-1))}))),i}async doWatch(o,c){const i=await this.withProvider(o),a=this.toWatchKey(i,o,c),r=this.activeWatchers.get(a)||{count:0,disposable:i.watch(o,c)};return this.activeWatchers.has(a)||this.activeWatchers.set(a,r),r.count+=1,(0,f.toDisposable)(()=>{r.count--,r.count===0&&((0,f.dispose)(r.disposable),this.activeWatchers.delete(a))})}toWatchKey(o,c,i){const{providerExtUri:a}=this.getExtUri(o);return[a.getComparisonKey(c),String(i.recursive),i.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,f.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,c,i,a){return this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(async()=>{const r=await o.open(c,{create:!0,unlock:i?.unlock??!1});try{(0,v.isReadableStream)(a)||(0,v.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(o,r,a):await this.doWriteReadableBufferedQueued(o,r,a)}catch(s){throw(0,m.ensureFileSystemProviderError)(s)}finally{await o.close(r)}})}async doWriteStreamBufferedQueued(o,c,i){let a=0,r;if((0,v.isReadableBufferedStream)(i)){if(i.buffer.length>0){const s=k.VSBuffer.concat(i.buffer);await this.doWriteBuffer(o,c,s,s.byteLength,a,0),a+=s.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise(async(s,l)=>{(0,v.listenStream)(r,{onData:async g=>{r.pause();try{await this.doWriteBuffer(o,c,g,g.byteLength,a,0)}catch(S){return l(S)}a+=g.byteLength,setTimeout(()=>r.resume())},onError:g=>l(g),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,c,i){let a=0,r;for(;(r=i.read())!==null;)await this.doWriteBuffer(o,c,r,r.byteLength,a,0),a+=r.byteLength}async doWriteBuffer(o,c,i,a,r,s){let l=0;for(;l<a;)l+=await o.write(c,r+l,i.buffer,s+l,a-l)}async doWriteUnbuffered(o,c,i,a){return this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,c,i,a))}async doWriteUnbufferedQueued(o,c,i,a){let r;a instanceof k.VSBuffer?r=a:(0,v.isReadableStream)(a)?r=await(0,k.streamToBuffer)(a):(0,v.isReadableBufferedStream)(a)?r=await(0,k.bufferedStreamToBuffer)(a):r=(0,k.readableToBuffer)(a),await o.writeFile(c,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(o,c,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,c,i,a))}async doPipeBufferedQueued(o,c,i,a){let r,s;try{r=await o.open(c,{create:!1}),s=await i.open(a,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.BUFFER_SIZE);let g=0,S=0,D=0;do D=await o.read(r,g,l.buffer,S,l.byteLength-S),await this.doWriteBuffer(i,s,l,D,g,S),g+=D,S+=D,S===l.byteLength&&(S=0);while(D>0)}catch(l){throw(0,m.ensureFileSystemProviderError)(l)}finally{await L.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof s=="number"?i.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,c,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,c,i,a))}async doPipeUnbufferedQueued(o,c,i,a){return i.writeFile(a,await o.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,c,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,c,i,a))}async doPipeUnbufferedToBufferedQueued(o,c,i,a){const r=await i.open(a,{create:!0,unlock:!1});try{const s=await o.readFile(c);await this.doWriteBuffer(i,r,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,m.ensureFileSystemProviderError)(s)}finally{await i.close(r)}}async doPipeBufferedToUnbuffered(o,c,i,a){const r=await(0,k.streamToBuffer)(this.readFileBuffered(o,c,M.CancellationToken.None));await this.doWriteUnbuffered(i,a,void 0,r)}throwIfFileSystemIsReadonly(o,c){if(o.capabilities&2048)throw new m.FileOperationError((0,d.localize)(22,null,this.resourceForError(c)),6);return o}throwIfFileIsReadonly(o,c){if((c.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,d.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===t.Schemas.file?o.fsPath:o.toString(!0)}};u.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},u=he([te(0,p.ILogService)],u),e.FileService=u}),define(Z[184],x([0,1,31,9,18,4,29,2,8,3,15,64,19,142,20,94,173,163,164,91,166,6,45]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m,I,p,u,h,o,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class a extends n.Disposable{constructor(s,l){super();this.logService=s,this.options=l,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=M.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:l,symbolicLink:g}=await b.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(l,g),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(s){try{const l=await b.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),g=[];return await Promise.all(l.map(async S=>{try{let D;S.isSymbolicLink()?D=(await this.stat((0,t.joinPath)(s,S.name))).type:D=this.toType(S),g.push([S.name,D])}catch(D){this.logService.trace(D)}})),g}catch(l){throw this.toFileSystemProviderError(l)}}toType(s,l){let g;return l?.dangling?g=d.FileType.Unknown:s.isFile()?g=d.FileType.File:s.isDirectory()?g=d.FileType.Directory:g=d.FileType.Unknown,l&&(g|=d.FileType.SymbolicLink),g}async readFile(s){try{const l=this.toFilePath(s);return await b.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(s,l,g){const S=(0,P.newWriteableStream)(D=>k.VSBuffer.concat(D.map(A=>k.VSBuffer.wrap(A))).buffer);return(0,m.readFileIntoStream)(this,s,S,D=>D.buffer,{...l,bufferSize:this.BUFFER_SIZE},g),S}async writeFile(s,l,g){let S;try{const D=this.toFilePath(s);if(!g.create||!g.overwrite){if(await b.Promises.exists(D)){if(!g.overwrite)throw(0,d.createFileSystemProviderError)((0,v.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!g.create)throw(0,d.createFileSystemProviderError)((0,v.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(s,{create:!0,unlock:g.unlock}),await this.write(S,0,l,0,l.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(s,D)}finally{typeof S=="number"&&await this.close(S)}}async open(s,l){try{const g=this.toFilePath(s);if((0,d.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:A}=await b.SymlinkSupport.stat(g);A.mode&128||await b.Promises.chmod(g,A.mode|128)}catch(A){this.logService.trace(A)}let S;if((0,d.isFileOpenForWriteOptions)(l)){if(w.isWindows)try{await b.Promises.truncate(g,0),S="r+"}catch(A){A.code!=="ENOENT"&&this.logService.trace(A)}S||(S="w")}else S="r";const D=await b.Promises.open(g,S);return this.mapHandleToPos.set(D,0),(0,d.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(D,s),D}catch(g){throw(0,d.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(s,g):this.toFileSystemProviderError(g)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await b.Promises.fdatasync(s)}catch(l){this.canFlush=!1,this.logService.error(l)}return await b.Promises.close(s)}catch(l){throw this.toFileSystemProviderError(l)}}async read(s,l,g,S,D){const A=this.normalizePos(s,l);let F=null;try{const U=await b.Promises.read(s,g,S,D,A);return typeof U=="number"?F=U:F=U.bytesRead,F}catch(U){throw this.toFileSystemProviderError(U)}finally{this.updatePos(s,A,F)}}normalizePos(s,l){return l===this.mapHandleToPos.get(s)?null:l}updatePos(s,l,g){const S=this.mapHandleToPos.get(s);typeof S=="number"&&(typeof l=="number"||(typeof g=="number"?this.mapHandleToPos.set(s,S+g):this.mapHandleToPos.delete(s)))}async write(s,l,g,S,D){return(0,L.retry)(()=>this.doWrite(s,l,g,S,D),100,3)}async doWrite(s,l,g,S,D){const A=this.normalizePos(s,l);let F=null;try{const U=await b.Promises.write(s,g,S,D,A);return typeof U=="number"?F=U:F=U.bytesWritten,F}catch(U){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),U)}finally{this.updatePos(s,A,F)}}async mkdir(s){try{await b.Promises.mkdir(this.toFilePath(s))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(s,l){try{const g=this.toFilePath(s);await this.doDelete(g,l)}catch(g){throw this.toFileSystemProviderError(g)}}async doDelete(s,l){l.recursive?await b.Promises.rm(s,b.RimRafMode.MOVE):await b.Promises.unlink(s)}async rename(s,l,g){const S=this.toFilePath(s),D=this.toFilePath(l);if(S!==D)try{await this.validateTargetDeleted(s,l,"move",g.overwrite),await b.Promises.move(S,D)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,v.localize)(2,null,(0,f.basename)(S),(0,f.basename)((0,f.dirname)(D)),A.toString()))),this.toFileSystemProviderError(A)}}async copy(s,l,g){const S=this.toFilePath(s),D=this.toFilePath(l);if(S!==D)try{await this.validateTargetDeleted(s,l,"copy",g.overwrite),await b.Promises.copy(S,D,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,v.localize)(3,null,(0,f.basename)(S),(0,f.basename)((0,f.dirname)(D)),A.toString()))),this.toFileSystemProviderError(A)}}async validateTargetDeleted(s,l,g,S){const D=this.toFilePath(s),A=this.toFilePath(l);let F=!1;if(!!(this.capabilities&1024)||(F=(0,E.isEqual)(D,A,!0)),F&&g==="copy")throw(0,d.createFileSystemProviderError)((0,v.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!F&&await b.Promises.exists(A)){if(!S)throw(0,d.createFileSystemProviderError)((0,v.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}watch(s,l){return l.recursive?this.watchRecursive(s,l.excludes):this.watchNonRecursive(s)}watchRecursive(s,l){const g={path:this.toFilePath(s),excludes:l},S=(0,y.insert)(this.recursiveFoldersToWatch,g);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{S(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof p.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let s,l;this.options?.watcher?.usePolling?(s=u.FileWatcher,l=this.options?.watcher):i.default.quality==="stable"&&this.recursiveFoldersToWatch.length===1?w.isWindows?s=o.FileWatcher:s=u.FileWatcher:s=p.FileWatcher,this.recursiveWatcher=new s(this.recursiveFoldersToWatch,g=>this._onDidChangeFile.fire((0,h.toFileChanges)(g)),g=>{g.type==="error"&&this._onDidWatchErrorOccur.fire(g.message),this.logService[g.type](g.message)},this.logService.getLevel()===c.LogLevel.Trace,l),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)}))}}watchNonRecursive(s){const l=new I.FileWatcher(this.toFilePath(s),S=>this._onDidChangeFile.fire((0,h.toFileChanges)(S)),S=>{S.type==="error"&&this._onDidWatchErrorOccur.fire(S.message),this.logService[S.type](S.message)},this.logService.getLevel()===c.LogLevel.Trace),g=this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)});return(0,n.combinedDisposable)(l,g)}toFilePath(s){return(0,f.normalize)(s.fsPath)}toFileSystemProviderError(s){if(s instanceof d.FileSystemProviderError)return s;let l;switch(s.code){case"ENOENT":l=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=d.FileSystemProviderErrorCode.NoPermissions;break;default:l=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(s,l)}async toFileSystemProviderWriteError(s,l){let g=this.toFileSystemProviderError(l);if(s&&g.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:S}=await b.SymlinkSupport.stat(this.toFilePath(s));S.mode&128||(g=(0,d.createFileSystemProviderError)(l,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(S){this.logService.trace(S)}return g}dispose(){super.dispose(),(0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,n.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=a}),define(Z[21],x([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,y.createDecorator)("productService")}),define(Z[185],x([0,1,58,6,21]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(n,f){this.productService=n,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(f);if(!w)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,t,P]=w;let b=this.trustedExtensionUrlPublicKeys.get(n);if(!b){if(b=this.productService.trustedExtensionUrlPublicKeys[n],!b||b.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...b])}const v=Buffer.from(decodeURIComponent(P),"base64");if(v.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const d=v.slice(0,6),m=v.readUIntBE(0,6),I=Date.now()-m;if(I<0||I>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const p=v.slice(6),u=y.createVerify("SHA256");u.write(d),u.write(Buffer.from(t)),u.end();for(let h=0;h<b.length;h++){let o=b[h];if(o!==null){if(typeof o=="string")try{o=y.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),b[h]=o}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${n}:`,c),b[h]=null;continue}if(u.verify(o,p))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};M=he([te(0,k.IProductService),te(1,L.ILogService)],M),e.ExtensionUrlTrustService=M}),define(Z[55],x([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,y.createDecorator)("protocolMainService")}),define(Z[186],x([0,1,14,2,37,10,3,15,7,28,48,6]),function(K,e,y,L,k,M,E,n,f,w,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let b=class extends L.Disposable{constructor(d,m){super();this.logService=m,this.validRoots=k.TernarySearchTree.forUris(()=>!E.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(f.URI.file(d.appRoot)),this.addValidFileRoot(f.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=y.session;d.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(m,I)=>this.handleResourceRequest(m,I)),d.protocol.interceptFileProtocol(M.Schemas.file,(m,I)=>this.handleFileRequest(m,I)),this._register((0,L.toDisposable)(()=>{d.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?L.Disposable.None:(this.validRoots.set(d,!0),(0,L.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,m){const I=f.URI.parse(d.url);return this.logService.error(`Refused to load resource ${I.fsPath} from ${M.Schemas.file}: protocol (original URL: ${d.url})`),m({error:-3})}handleResourceRequest(d,m){const I=f.URI.parse(d.url),p=M.FileAccess.asFileUri(I);return this.validRoots.findSubstr(p)?m({path:p.fsPath}):this.validExtensions.has((0,n.extname)(p))?m({path:p.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${p.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),m({error:-3}))}createIPCObjectUrl(){let d;const m=f.URI.from({scheme:"vscode",path:(0,w.generateUuid)()}),I=m.toString(),p=async()=>d;return y.ipcMain.handle(I,p),this.logService.trace(`IPC Object URL: Registered new channel ${I}.`),{resource:m,update:u=>d=u,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${I}.`),y.ipcMain.removeHandler(I)}}}};b=he([te(0,t.INativeEnvironmentService),te(1,P.ILogService)],b),e.ProtocolMainService=b}),define(Z[38],x([0,1,102,13]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(E,n){y.ok(L.isString(E)),y.ok(L.isObject(n)),y.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,n)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new k}),define(Z[187],x([0,1,4,38]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class M{constructor(){this._onDidChangeSchema=new y.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,w){this.schemasById[k(f)]=w,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new M;L.Registry.add(e.Extensions.JSONContribution,E)}),define(Z[49],x([0,1,4,13,132,187,38]),function(K,e,y,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var n;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(n=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=E.Registry.as(M.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new y.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new y.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(u,h=!0){this.registerConfigurations([u],h)}registerConfigurations(u,h=!0){const o=[];u.forEach(c=>{o.push(...this.validateAndRegisterProperties(c,h,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(u){const h=[],o=c=>{if(c.properties)for(const i in c.properties)h.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,c.properties[i]);c.allOf&&c.allOf.forEach(i=>o(i))};for(const c of u){o(c);const i=this.configurationContributors.indexOf(c);i!==-1&&this.configurationContributors.splice(i,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}registerDefaultConfigurations(u){const h=[],o=[];for(const c of u)for(const i in c)if(h.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...c[i]};const a={type:"object",default:this.defaultValues[i],description:k.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};o.push(b(i)),this.configurationProperties[i]=a,this.defaultLanguageConfigurationOverridesNode.properties[i]=a}else{this.defaultValues[i]=c[i];const a=this.configurationProperties[i];a&&(this.updatePropertyDefaultValue(i,a),this.updateSchema(i,a))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterDefaultConfigurations(u){const h=[];for(const o of u)for(const c in o)if(h.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const i=this.configurationProperties[c];i&&(this.updatePropertyDefaultValue(c,i),this.updateSchema(c,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const h of u)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(u,h=!0,o,c=3){c=L.isUndefinedOrNull(u.scope)?c:u.scope;let i=[],a=u.properties;if(a)for(let s in a){if(h&&m(s)){delete a[s];continue}const l=a[s];if(this.updatePropertyDefaultValue(s,l),e.OVERRIDE_PROPERTY_PATTERN.test(s)?l.scope=void 0:(l.scope=L.isUndefinedOrNull(l.scope)?c:l.scope,l.restricted=L.isUndefinedOrNull(l.restricted)?!!o?.restrictedConfigurations?.includes(s):l.restricted),a[s].hasOwnProperty("included")&&!a[s].included){this.excludedConfigurationProperties[s]=a[s],delete a[s];continue}else this.configurationProperties[s]=a[s];!a[s].deprecationMessage&&a[s].markdownDeprecationMessage&&(a[s].deprecationMessage=a[s].markdownDeprecationMessage),i.push(s)}let r=u.allOf;if(r)for(let s of r)i.push(...this.validateAndRegisterProperties(s,h,o,c));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(u){const h=o=>{let c=o.properties;if(c)for(const a in c)this.updateSchema(a,c[a]);let i=o.allOf;i&&i.forEach(h)};h(u)}updateSchema(u,h){switch(e.allSettings.properties[u]=h,h.scope){case 1:e.applicationSettings.properties[u]=h;break;case 2:e.machineSettings.properties[u]=h;break;case 6:e.machineOverridableSettings.properties[u]=h;break;case 3:e.windowSettings.properties[u]=h;break;case 4:e.resourceSettings.properties[u]=h;break;case 5:e.resourceSettings.properties[u]=h,this.resourceLanguageSettingsSchema.properties[u]=h;break}}removeFromSchema(u,h){switch(delete e.allSettings.properties[u],h.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const h=`[${u}]`,o={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,o),e.allSettings.properties[h]=o,e.applicationSettings.properties[h]=o,e.machineSettings.properties[h]=o,e.machineOverridableSettings.properties[h]=o,e.windowSettings.properties[h]=o,e.resourceSettings.properties[h]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,h){let o=this.defaultValues[u];L.isUndefined(o)&&(o=h.default),L.isUndefined(o)&&(o=v(h.type)),h.default=o}}const P="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(P);function b(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=b;function v(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const d=new t;E.Registry.add(e.Extensions.Configuration,d);function m(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?k.localize(5,null,p):d.getConfigurationProperties()[p]!==void 0?k.localize(6,null,p):null:k.localize(4,null)}e.validateProperty=m;function I(){const p=[],u=d.getConfigurationProperties();for(const h of Object.keys(u))p.push([h,u[h].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=I}),define(Z[16],x([0,1,44,13,7,49,5,38]),function(K,e,y,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,E.createDecorator)("configurationService");function f(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof k.URI)}e.isConfigurationOverrides=f;var w;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function P(a,r){const s=r?a?r.keys.filter(U=>a.keys.indexOf(U)===-1):[...r.keys]:[],l=a?r?a.keys.filter(U=>r.keys.indexOf(U)===-1):[...a.keys]:[],g=[];if(r&&a){for(const U of a.keys)if(r.keys.indexOf(U)!==-1){const X=p(a.contents,U),ne=p(r.contents,U);y.equals(X,ne)||g.push(U)}}const S=[],D=U=>{const X={};for(const ne of U)for(const se of ne.identifiers)X[c(se)]=ne;return X},A=r?D(r.overrides):{},F=a?D(a.overrides):{};if(Object.keys(A).length)for(const U of s){const X=A[U];X&&S.push([(0,M.overrideIdentifierFromKey)(U),X.keys])}if(Object.keys(F).length)for(const U of l){const X=F[U];X&&S.push([(0,M.overrideIdentifierFromKey)(U),X.keys])}if(Object.keys(A).length&&Object.keys(F).length)for(const U of g){const X=F[U],ne=A[U];if(X&&ne){const se=P({contents:X.contents,keys:X.keys,overrides:[]},{contents:ne.contents,keys:ne.keys,overrides:[]});S.push([(0,M.overrideIdentifierFromKey)(U),[...se.added,...se.removed,...se.updated]])}}return{added:s,removed:l,updated:g,overrides:S}}e.compare=P;function b(a,r){const s=[];for(const l of Object.keys(a))if(M.OVERRIDE_PROPERTY_PATTERN.test(l)){const g={};for(const S in a[l])g[S]=a[l][S];s.push({identifiers:[(0,M.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(g),contents:v(g,r)})}return s}e.toOverrides=b;function v(a,r){const s=Object.create(null);for(let l in a)d(s,l,a[l],r);return s}e.toValuesTree=v;function d(a,r,s,l){const g=r.split("."),S=g.pop();let D=a;for(let A=0;A<g.length;A++){let F=g[A],U=D[F];switch(typeof U){case"undefined":U=D[F]=Object.create(null);break;case"object":break;default:l(`Ignoring ${r} as ${g.slice(0,A+1).join(".")} is ${JSON.stringify(U)}`);return}D=U}if(typeof D=="object"&&D!==null)try{D[S]=s}catch(A){l(`Ignoring ${r} as ${g.join(".")} is ${JSON.stringify(D)}`)}else l(`Ignoring ${r} as ${g.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=d;function m(a,r){const s=r.split(".");I(a,s)}e.removeFromValueTree=m;function I(a,r){const s=r.shift();if(r.length===0){delete a[s];return}if(Object.keys(a).indexOf(s)!==-1){const l=a[s];typeof l=="object"&&!Array.isArray(l)&&(I(l,r),Object.keys(l).length===0&&delete a[s])}}function p(a,r,s){function l(D,A){let F=D;for(const U of A){if(typeof F!="object"||F===null)return;F=F[U]}return F}const g=r.split("."),S=l(a,g);return typeof S=="undefined"?s:S}e.getConfigurationValue=p;function u(a,r,s){Object.keys(r).forEach(l=>{l!=="__proto__"&&(l in a?L.isObject(a[l])&&L.isObject(r[l])?u(a[l],r[l],s):s&&(a[l]=r[l]):a[l]=r[l])})}e.merge=u;function h(){const a=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=h;function o(){const a=Object.create(null),r=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let s in r){let l=r[s].default;d(a,s,l,g=>console.error(`Conflict in default settings: ${g}`))}return a}e.getDefaultValues=o;function c(a){return`[${a}]`}e.keyFromOverrideIdentifier=c;function i(a,r,s){const l=a.inspect(r),g=a.inspect(s);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:l.defaultValue}e.getMigratedSettingValue=i}),define(Z[188],x([0,1,31,4,40,2,37,44,13,7,16,49,38]),function(K,e,y,L,k,M,E,n,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(i={},a=[],r=[]){this._contents=i,this._keys=a,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,a){const r=this.getContentsForOverrideIdentifer(a);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const a of this.overrides)if(a.identifiers.indexOf(i)!==-1)return a.keys;return[]}override(i){const a=this.getContentsForOverrideIdentifer(i);if(!a||typeof a!="object"||!Object.keys(a).length)return this;let r={};for(const s of y.distinct([...Object.keys(this.contents),...Object.keys(a)])){let l=this.contents[s],g=a[s];g&&(typeof l=="object"&&typeof g=="object"?(l=n.deepClone(l),this.mergeContents(l,g)):l=g),r[s]=l}return new v(r,this.keys,this.overrides)}merge(...i){const a=n.deepClone(this.contents),r=n.deepClone(this.overrides),s=[...this.keys];for(const l of i){this.mergeContents(a,l.contents);for(const g of l.overrides){const[S]=r.filter(D=>y.equals(D.identifiers,g.identifiers));S?this.mergeContents(S.contents,g.contents):r.push(n.deepClone(g))}for(const g of l.keys)s.indexOf(g)===-1&&s.push(g)}return new v(a,s,r)}freeze(){return this.isFrozen=!0,this}mergeContents(i,a){for(const r of Object.keys(a)){if(r in i&&f.isObject(i[r])&&f.isObject(a[r])){this.mergeContents(i[r],a[r]);continue}i[r]=n.deepClone(a[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?n.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const a of this.overrides)if(a.identifiers.indexOf(i)!==-1)return a.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,a){this.addKey(i),(0,t.addToValueTree)(this.contents,i,a,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let a=this.keys.length;for(let r=0;r<a;r++)i.indexOf(this.keys[r])===0&&(a=r);this.keys.splice(a,1,i)}removeKey(i){let a=this.keys.indexOf(i);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=v;class d extends v{constructor(){const i=(0,t.getDefaultValues)(),a=(0,t.getConfigurationKeys)(),r=[];for(const s of Object.keys(i))P.OVERRIDE_PROPERTY_PATTERN.test(s)&&r.push({identifiers:[(0,P.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(i[s]),contents:(0,t.toValuesTree)(i[s],l=>console.error(`Conflict in default settings file: ${l}`))});super(i,a,r)}}e.DefaultConfigurationModel=d;class m{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,a){if(!f.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,a)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,a){this._raw=i;const{contents:r,keys:s,overrides:l,restricted:g}=this.doParseRaw(i,a);this._configurationModel=new v(r,s,l),this._restrictedConfigurations=g||[]}doParseContent(i){let a={},r=null,s=[],l=[],g=[];function S(A){Array.isArray(s)?s.push(A):r!==null&&(s[r]=A)}let D={onObjectBegin:()=>{let A={};S(A),l.push(s),s=A,r=null},onObjectProperty:A=>{r=A},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{let A=[];S(A),l.push(s),s=A,r=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:S,onError:(A,F,U)=>{g.push({error:A,offset:F,length:U})}};if(i)try{k.visit(i,D),a=s[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return a}doParseRaw(i,a){const r=b.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,r,!0,a);i=s.raw;const l=(0,t.toValuesTree)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),g=Object.keys(i),S=(0,t.toOverrides)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:l,keys:g,overrides:S,restricted:s.restricted}}filter(i,a,r,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const l={},g=[];for(let S in i)if(P.OVERRIDE_PROPERTY_PATTERN.test(S)&&r){const D=this.filter(i[S],a,!1,s);l[S]=D.raw,g.push(...D.restricted)}else{const D=a[S],A=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&g.push(S),(A===void 0||s.scopes===void 0||s.scopes.includes(A))&&(s.skipRestricted&&D?.restricted||(l[S]=i[S]))}return{raw:l,restricted:g}}}e.ConfigurationModelParser=m;class I extends M.Disposable{constructor(i,a,r,s){super();this.userSettingsResource=i,this.scopes=a,this.fileService=s,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=I;class p{constructor(i,a,r=new v,s=new v,l=new E.ResourceMap,g=new v,S=new E.ResourceMap,D=!0){this._defaultConfiguration=i,this._localUserConfiguration=a,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=l,this._memoryConfiguration=g,this._memoryConfigurationByResource=S,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new E.ResourceMap,this._userConfiguration=null}getValue(i,a,r){return this.getConsolidateConfigurationModel(a,r).getValue(i)}updateValue(i,a,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new v,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,a===void 0?s.removeValue(i):s.setValue(i,a),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,a,r){const s=this.getConsolidateConfigurationModel(a,r),l=this.getFolderConfigurationModelForResource(a.resource,r),g=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,S=a.overrideIdentifier?this._defaultConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),D=a.overrideIdentifier?this.userConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),A=a.overrideIdentifier?this.localUserConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),F=a.overrideIdentifier?this.remoteUserConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),U=r?a.overrideIdentifier?this._workspaceConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,X=l?a.overrideIdentifier?l.freeze().override(a.overrideIdentifier).getValue(i):l.freeze().getValue(i):void 0,ne=a.overrideIdentifier?g.override(a.overrideIdentifier).getValue(i):g.getValue(i),se=s.getValue(i),G=y.distinct(y.flatten(s.overrides.map(J=>J.identifiers))).filter(J=>s.getOverrideValue(i,J)!==void 0);return{defaultValue:S,userValue:D,userLocalValue:A,userRemoteValue:F,workspaceValue:U,workspaceFolderValue:X,memoryValue:ne,value:se,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,workspaceFolder:X!==void 0?{value:l?.freeze().getValue(i),override:a.overrideIdentifier?l?.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:g.getValue(i),override:a.overrideIdentifier?g.getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(i){const a=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,a){this._folderConfigurations.set(i,a),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,a){const r=a.filter(s=>P.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const l=(0,P.overrideIdentifierFromKey)(s),g=this._defaultConfiguration.getKeysForOverrideIdentifier(l),S=i.getKeysForOverrideIdentifier(l),D=[...S.filter(A=>g.indexOf(A)===-1),...g.filter(A=>S.indexOf(A)===-1),...g.filter(A=>!n.equals(this._defaultConfiguration.override(l).getValue(A),i.override(l).getValue(A)))];return[l,D]});return this.updateDefaultConfiguration(i),{keys:a,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:a,updated:r,removed:s,overrides:l}=(0,t.compare)(this.localUserConfiguration,i),g=[...a,...r,...s];return g.length&&this.updateLocalUserConfiguration(i),{keys:g,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:a,updated:r,removed:s,overrides:l}=(0,t.compare)(this.remoteUserConfiguration,i);let g=[...a,...r,...s];return g.length&&this.updateRemoteUserConfiguration(i),{keys:g,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:a,updated:r,removed:s,overrides:l}=(0,t.compare)(this.workspaceConfiguration,i);let g=[...a,...r,...s];return g.length&&this.updateWorkspaceConfiguration(i),{keys:g,overrides:l}}compareAndUpdateFolderConfiguration(i,a){const r=this.folderConfigurations.get(i),{added:s,updated:l,removed:g,overrides:S}=(0,t.compare)(r,a);let D=[...s,...l,...g];return(D.length||!r)&&this.updateFolderConfiguration(i,a),{keys:D,overrides:S}}compareAndDeleteFolderConfiguration(i){const a=this.folderConfigurations.get(i);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:s,removed:l,overrides:g}=(0,t.compare)(a,void 0);return{keys:[...r,...s,...l],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,a){let r=this.getConsolidatedConfigurationModelForResource(i,a);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},a){let r=this.getWorkspaceConsolidatedConfiguration();if(a&&i){const s=a.getFolder(i);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const l=this._memoryConfigurationByResource.get(i);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let a=this._foldersConsolidatedConfigurations.get(i);if(!a){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(a=r.merge(s),this._freeze&&(a=a.freeze()),this._foldersConsolidatedConfigurations.set(i,a)):a=r}return a}getFolderConfigurationModelForResource(i,a){if(a&&i){const r=a.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,a)=>{const{contents:r,overrides:s,keys:l}=this._folderConfigurations.get(a);return i.push([a,{contents:r,overrides:s,keys:l}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(a=>i.add(a)),this.userConfiguration.freeze().keys.forEach(a=>i.add(a)),this._workspaceConfiguration.freeze().keys.forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>a.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>a.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>a.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(s=>a.add(s))),[...a.values()]}static parse(i){const a=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),l=i.folders.reduce((g,S)=>(g.set(w.URI.revive(S[0]),this.parseConfigurationModel(S[1])),g),new E.ResourceMap);return new p(a,r,new v,s,l,new v,new E.ResourceMap,!1)}static parseConfigurationModel(i){return new v(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=p;function u(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,a=new Map;for(const s of c)s.keys.forEach(l=>i.add(l)),s.overrides.forEach(([l,g])=>{const S=(0,E.getOrSet)(a,l,new Set);g.forEach(D=>S.add(D))});const r=[];return a.forEach((s,l)=>r.push([l,[...s.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=u;class h{constructor(i,a,r,s){this.change=i,this.previous=a,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const l=new Set;i.keys.forEach(S=>l.add(S)),i.overrides.forEach(([,S])=>S.forEach(D=>l.add(D))),this.affectedKeys=[...l.values()];const g=new v;this.affectedKeys.forEach(S=>g.setValue(S,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,a){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(a){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,a,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,a,this.currentWorkspace);return!n.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(i,a){let r=(0,t.toValuesTree)({[a]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(i=i[s],!i)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=h;class o extends h{constructor(i,a,r,s){super({keys:i.allKeys(),overrides:[]},void 0,i,a);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=o}),define(Z[189],x([0,1,9,4,2,15,16,188,49,38]),function(K,e,y,L,k,M,E,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class t extends k.Disposable{constructor(b,v){super();this.settingsResource=b,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new n.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,v)),this.configuration=new n.Configuration(new n.DefaultConfigurationModel,new n.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new y.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const b=await this.userConfiguration.loadConfiguration();this.configuration=new n.Configuration(new n.DefaultConfigurationModel,b)}getConfigurationData(){return this.configuration.toData()}getValue(b,v){const d=typeof b=="string"?b:void 0,m=(0,E.isConfigurationOverrides)(b)?b:(0,E.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(d,m,void 0)}updateValue(b,v,d,m){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const v=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(d,v,1)}onDidDefaultConfigurationChange(b){const v=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new n.DefaultConfigurationModel,b);this.trigger(d,v,6)}trigger(b,v,d){const m=new n.ConfigurationChangeEvent(b,{data:v},this.configuration);m.source=d,m.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(b){switch(b){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=t}),define(Z[190],x([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,y.createDecorator)("remoteAuthorityResolverService");var L;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(E,n=L.Unknown,f){super(E);this._message=E,this._code=n,this._detail=f,this.isHandled=n===L.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(E){return E instanceof k&&E._code===L.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof k&&E._code===L.NoResolverFound}static isHandled(E){return E instanceof k&&E.isHandled}}e.RemoteAuthorityResolverError=k}),define(Z[191],x([0,1,9,18,24,17,4,2,28,83,190]),function(K,e,y,L,k,M,E,n,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const P=30*1e3;var b;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(b=e.ConnectionType||(e.ConnectionType={}));function v(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(T){const R=new k.CancellationTokenSource;return setTimeout(()=>R.cancel(),T),R.token}function m(T,R){if(T.isCancellationRequested||R.isCancellationRequested)return k.CancellationToken.Cancelled;const O=new k.CancellationTokenSource;return T.onCancellationRequested(()=>O.cancel()),R.onCancellationRequested(()=>O.cancel()),O.token}class I{constructor(R){this._state="pending",this._disposables=new n.DisposableStore,this.promise=new Promise((O,z)=>{this._resolvePromise=O,this._rejectPromise=z}),R.isCancellationRequested?this._timeout():this._disposables.add(R.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(R){this._state==="pending"?this._disposables.add(R):R.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const R=new Error("Time limit reached");return R.code="ETIMEDOUT",R.syscall="connect",R}resolve(R){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(R))}reject(R){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(R))}}function p(T,R){const O=new I(R);return O.registerDisposable(T.onControlMessage(z=>{const N=JSON.parse(z.toString()),C=B(N);C?O.reject(C):O.resolve(N)})),O.promise}function u(T,R,O,z,N,C){const q=new I(C);return R.connect(O,z,N,(Q,ie)=>{q.didTimeout?(Q&&T.error(Q),ie?.dispose()):Q||!ie?q.reject(Q):q.resolve(ie)}),q.promise}function h(T,R){const O=new I(R);return T.then(z=>{O.didTimeout||O.resolve(z)},z=>{O.didTimeout||O.reject(z)}),O.promise}async function o(T,R,O,z){const N=_(T,R);T.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let C;try{C=await u(T.logService,T.socketFactory,T.host,T.port,`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,z)}catch(oe){throw T.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),T.logService.error(oe),oe}T.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let q,Q;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection(C,null),q=T.reconnectionProtocol,Q=!1):(q=new w.PersistentProtocol(C,null),Q=!0),T.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const ie={type:"auth",auth:T.connectionToken||"00000000000000000000"};q.sendControl(L.VSBuffer.fromString(JSON.stringify(ie)));try{const oe=await p(q,m(z,d(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const le=new Error("Unexpected handshake message");throw le.code="VSCODE_CONNECTION_ERROR",le}T.logService.trace(`${N} 4/6. received SignRequest control message.`);const ae=await h(T.signService.sign(oe.data),z),ee={type:"connectionType",commit:T.commit,signedData:ae,desiredConnectionType:R};return O&&(ee.args=O),T.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),q.sendControl(L.VSBuffer.fromString(JSON.stringify(ee))),{protocol:q,ownsProtocol:Q}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(T.logService.error(`${N} the handshake timed out. Error:`),T.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${N} received error control message when negotiating connection. Error:`),T.logService.error(oe)),Q&&V(q),oe}}async function c(T,R,O,z){const N=Date.now(),C=_(T,R),{protocol:q,ownsProtocol:Q}=await o(T,R,O,z),ie=new I(z);return ie.registerDisposable(q.onControlMessage(oe=>{const ae=JSON.parse(oe.toString()),ee=B(ae);ee?(T.logService.error(`${C} received error control message when negotiating connection. Error:`),T.logService.error(ee),Q&&V(q),ie.reject(ee)):(T.reconnectionProtocol&&T.reconnectionProtocol.endAcceptReconnection(),T.logService.trace(`${C} 6/6. handshake finished, connection is up and running after ${j(N)}!`),ie.resolve({protocol:q,firstMessage:ae}))})),ie.promise}async function i(T,R){const{protocol:O}=await c(T,1,void 0,R);return{protocol:O}}async function a(T,R,O){const{protocol:z,firstMessage:N}=await c(T,2,R,O),C=N&&N.debugPort;return{protocol:z,debugPort:C}}async function r(T,R,O){const z=Date.now(),N=_(T,3),{protocol:C}=await o(T,3,R,O);return T.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${j(z)}!`),C}async function s(T,R,O){const{host:z,port:N,connectionToken:C}=await T.addressProvider.getAddress();return{commit:T.commit,host:z,port:N,connectionToken:C,reconnectionToken:R,reconnectionProtocol:O,socketFactory:T.socketFactory,signService:T.signService,logService:T.logService}}async function l(T,R,O){try{const z=(0,f.generateUuid)(),N=await s(T,z,null),{protocol:C}=await i(N,k.CancellationToken.None);return new J(T,R,O,z,C)}catch(z){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(z),G.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(z)),z}}e.connectRemoteAgentManagement=l;async function g(T,R){try{const O=(0,f.generateUuid)(),z=await s(T,O,null),{protocol:N,debugPort:C}=await a(z,R,k.CancellationToken.None);return new W(T,R,O,N,C)}catch(O){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(O),G.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(O)),O}}e.connectRemoteAgentExtensionHost=g;async function S(T,R,O){const z=await s(T,(0,f.generateUuid)(),null);return await r(z,{host:R,port:O},k.CancellationToken.None)}e.connectRemoteAgentTunnel=S;function D(T){return(0,y.createCancelablePromise)(R=>new Promise((O,z)=>{const N=setTimeout(O,T*1e3);R.onCancellationRequested(()=>{clearTimeout(N),O()})}))}var A;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain"})(A=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class F{constructor(R,O){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=F;class U{constructor(R,O,z,N){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.durationSeconds=z,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=U;class X{constructor(R,O,z){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.attempt=z,this.type=2}}e.ReconnectionRunningEvent=X;class ne{constructor(R,O,z){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.attempt=z,this.type=4}}e.ConnectionGainEvent=ne;class se{constructor(R,O,z,N){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.attempt=z,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class G extends n.Disposable{constructor(R,O,z,N){super();this._connectionType=R,this._onDidStateChange=this._register(new E.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=O,this.reconnectionToken=z,this.protocol=N,this._isReconnecting=!1,this._onDidStateChange.fire(new ne(this.reconnectionToken,0,0)),this._register(N.onSocketClose(C=>{const q=H(this._connectionType,this.reconnectionToken,!0);C?C.type===0?(this._options.logService.info(`${q} received socket close event (hadError: ${C.hadError}).`),C.error&&this._options.logService.error(C.error)):(this._options.logService.info(`${q} received socket close event (wasClean: ${C.wasClean}, code: ${C.code}, reason: ${C.reason}).`),C.event&&this._options.logService.error(C.event)):this._options.logService.info(`${q} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(()=>{const C=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${C} received socket timeout event.`),this._beginReconnecting()})),G._instances.push(this),G._permanentFailure&&this._gotoPermanentFailure(G._permanentFailureMillisSinceLastIncomingData,G._permanentFailureAttempt,G._permanentFailureHandled)}static triggerPermanentFailure(R,O,z){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=R,this._permanentFailureAttempt=O,this._permanentFailureHandled=z,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(G._permanentFailure)return;const R=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${R} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const N=z<O.length?O[z]:O[O.length-1];try{if(N>0){const q=D(N);this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,q)),this._options.logService.info(`${R} waiting for ${N} seconds before reconnecting...`);try{await q}catch{}}if(G._permanentFailure){this._options.logService.error(`${R} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this._options.logService.info(`${R} resolving connection...`);const C=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${R} connecting to ${C.host}:${C.port}...`),await this._reconnect(C,d(P)),this._options.logService.info(`${R} reconnected!`),this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(C){if(C.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${R} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(C),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this._options.logService.error(`${R} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(C),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(t.RemoteAuthorityResolverError.isTemporarilyNotAvailable(C)){this._options.logService.info(`${R} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(C);continue}if((C.code==="ETIMEDOUT"||C.code==="ENETUNREACH"||C.code==="ECONNREFUSED"||C.code==="ECONNRESET")&&C.syscall==="connect"){this._options.logService.info(`${R} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(C);continue}if((0,M.isPromiseCanceledError)(C)){this._options.logService.info(`${R} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(C);continue}if(C instanceof t.RemoteAuthorityResolverError){this._options.logService.error(`${R} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(C),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,t.RemoteAuthorityResolverError.isHandled(C));break}this._options.logService.error(`${R} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(C),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!G._permanentFailure)}_gotoPermanentFailure(R,O,z){this._onDidStateChange.fire(new se(this.reconnectionToken,R,O,z)),V(this.protocol)}}G._permanentFailure=!1,G._permanentFailureMillisSinceLastIncomingData=0,G._permanentFailureAttempt=0,G._permanentFailureHandled=!1,G._instances=[];class J extends G{constructor(R,O,z,N,C){super(1,R,N,C);this.client=this._register(new w.Client(C,{remoteAuthority:O,clientId:z},R.ipcLogger))}async _reconnect(R,O){await i(R,O)}}e.ManagementPersistentConnection=J;class W extends G{constructor(R,O,z,N,C){super(2,R,z,N);this._startArguments=O,this.debugPort=C}async _reconnect(R,O){await a(R,this._startArguments,O)}}e.ExtensionHostPersistentConnection=W;function V(T){try{T.acceptDisconnect();const R=T.getSocket();T.dispose(),R.dispose()}catch(R){(0,M.onUnexpectedError)(R)}}function B(T){if(T&&T.type==="error"){const R=new Error(`Connection error: ${T.reason}`);return R.code="VSCODE_CONNECTION_ERROR",R}return null}function $(T,R){for(;T.length<R;)T+=" ";return T}function H(T,R,O){return`[remote-connection][${$(v(T),13)}][${R.substr(0,5)}\u2026][${O?"reconnect":"initial"}]`}function _(T,R){return`${H(R,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.host}:${T.port}]`}function j(T){return`${Date.now()-T} ms`}}),define(Z[73],x([0,1,10]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(w){return w.scheme===y.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=L;function k(w){if(!w)return;const t=w.indexOf("+");return t<0?w:w.substr(0,t)}e.getRemoteName=k;function M(w){return w.scheme!==y.Schemas.file&&w.scheme!==y.Schemas.vscodeRemote}e.isVirtualResource=M;function E(w){if(w.folders.length)return w.folders.every(t=>M(t.uri))?w.folders[0].uri:void 0;if(w.configuration&&M(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=E;function n(w){return E(w)?.scheme}e.getVirtualWorkspaceScheme=n;function f(w){return E(w)!==void 0}e.isVirtualWorkspace=f}),define(Z[95],x([0,1,4,3,5,6]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var E;(function(v){v.Http="http",v.Https="https"})(E=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(n=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function t(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=t;function P(v,d){return d?d!==1&&v<1024:!L.isWindows&&v<1024}e.isPortPrivileged=P;let b=class{constructor(d){this.logService=d,this._onTunnelOpened=new y.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new y.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new y.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d,m){return this._tunnelProvider=d,d?(this._canElevate=m.elevation,this._canMakePublic=m.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async d=>{const m=[],I=Array.from(this._tunnels.values());for(let p of I){const u=Array.from(p.values());for(let h of u){const o=await h.value;o&&m.push(o)}}d(m)})}async dispose(){for(const d of this._tunnels.values()){for(const{value:m}of d.values())await m.then(I=>I?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,m,I,p,u=!1,h=!1,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${I} on local port ${p}.`),!d)return;m||(m="localhost");const c=this.retainOrCreateTunnel(d,m,I,p,u,h,o);return c?c.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,I);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(i);return(i.tunnelRemoteHost!==m||i.tunnelRemotePort!==I)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,public:d.public,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const m=this._tunnels.get(d.tunnelRemoteHost);if(m){const I=m.get(d.tunnelRemotePort);I&&(I.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,I))}}}}async tryDisposeTunnel(d,m,I){if(I.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${m}.`);const p=I.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(m),p}}async closeTunnel(d,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${m} `);const I=this._tunnels.get(d);if(I&&I.has(m)){const p=I.get(m);p.refcount=0,await this.tryDisposeTunnel(d,m,p)}}addTunnelToMap(d,m,I){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(m,{refcount:1,value:I})}async removeEmptyTunnelFromMap(d,m){const I=this._tunnels.get(d);I&&(await I.get(m)||I.delete(m),I.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,m){let I=[d];w(d)?(I.push(...e.LOCALHOST_ADDRESSES),I.push(...e.ALL_INTERFACES_ADDRESSES)):t(d)&&I.push(...e.ALL_INTERFACES_ADDRESSES);const p=I.map(u=>this._tunnels.get(u));for(const u of p){const h=u?.get(m);if(h)return h}}canTunnel(d){return!!f(d)}createWithProvider(d,m,I,p,u,h,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${I} on local port ${p}.`);const i={elevationRequired:u?P(p===void 0?I:p):!1},a={remoteAddress:{host:m,port:I},localAddressPort:p,public:h,protocol:o},r=d.forwardPort(a,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(m,I,r),r}};b=he([te(0,M.ILogService)],b),e.AbstractTunnelService=b}),define(Z[50],x([0,1,18,146,49,5,38]),function(K,e,y,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function n(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=n;function f(d){return d.res.statusCode===204}async function w(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);return f(d)?null:(await(0,y.streamToBuffer)(d.stream)).toString()}e.asText=w;async function t(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);if(f(d))return null;const I=(await(0,y.streamToBuffer)(d.stream)).toString();try{return JSON.parse(I)}catch(p){throw p.message+=`:
`+I,p}}e.asJson=t;function P(d){v(d)}e.updateProxyConfigurationsScope=P;let b;function v(d){const m=E.Registry.as(k.Extensions.Configuration);b&&m.deregisterConfigurations([b]),b={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},m.registerConfiguration(b)}v(2)}),define(Z[192],x([0,1,193,13]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(E,n){return E.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:E.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function M(E,n,f={}){const w=(0,y.parse)(E),t=f.proxyUrl||k(w,n);if(!t)return null;const P=(0,y.parse)(t);if(!/^https?:$/.test(P.protocol||""))return null;const b={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((v,d)=>{K(["http-proxy-agent"],v,d)}))(b):new(await new Promise((v,d)=>{K(["https-proxy-agent"],v,d)}))(b)}e.getProxyAgent=M}),define(Z[194],x([0,1,18,28]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(M,E,n){let f=n&&n.get("storage.serviceMachineId",0)||null;if(f)return f;try{const t=(await E.readFile(M.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(t)?t:null}catch(w){f=null}if(!f){f=(0,L.generateUuid)();try{await E.writeFile(M.serviceMachineIdResource,y.VSBuffer.fromString(f))}catch(w){}}return n&&n.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=k}),define(Z[74],x([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,y.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[195],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class y{vsda(){return new Promise((k,M)=>K(["vsda"],k,M))}async sign(k){try{const M=await this.vsda(),E=new M.signer;if(E)return E.sign(k)}catch(M){}return k}}e.SignService=y}),define(Z[39],x([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,y.createDecorator)("stateMainService")}),define(Z[22],x([0,1,14,9,4,2,3,32,13,5,177,6,39]),function(K,e,y,L,k,M,E,n,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var v;(function(m){m[m.Starting=1]="Starting",m[m.Ready=2]="Ready",m[m.AfterWindowOpen=3]="AfterWindowOpen"})(v=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let d=class lt extends M.Disposable{constructor(I,p){super();this.logService=I,this.stateMainService=p,this._onBeforeShutdown=this._register(new k.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new k.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new k.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new k.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(lt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(lt.QUIT_AND_RESTART_KEY)}registerListeners(){const I=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),E.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};y.app.addListener("before-quit",I);const p=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!E.isMacintosh)&&y.app.quit()};y.app.addListener("window-all-closed",p),y.app.once("will-quit",u=>{this.logService.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),y.app.removeListener("before-quit",I),y.app.removeListener("window-all-closed",p),y.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const I=[];return this._onWillShutdown.fire({join(p){I.push(p)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(I)}catch(p){this.logService.error(p)}try{await this.stateMainService.close()}catch(p){this.logService.error(p)}})(),this.pendingWillShutdownPromise}set phase(I){if(I<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===I)return;this.logService.trace(`lifecycle (main): phase changed (value: ${I})`),this._phase=I;const p=this.phaseWhen.get(this._phase);p&&(p.open(),this.phaseWhen.delete(this._phase))}async when(I){if(I<=this._phase)return;let p=this.phaseWhen.get(I);p||(p=new L.Barrier,this.phaseWhen.set(I,p)),await p.wait()}registerWindow(I){const p=new M.DisposableStore;this.windowCounter++,p.add(I.onWillLoad(h=>this._onWillLoadWindow.fire({window:I,workspace:h.workspace,reason:h.reason})));const u=(0,f.assertIsDefined)(I.win);u.on("close",h=>{const o=I.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${I.id}`),h.preventDefault(),this.unload(I,1).then(c=>{if(c){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(I),I.close()})}),u.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${I.id}`),this.windowCounter--,p.dispose(),this.windowCounter===0&&(!E.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(I,p){await this.unload(I,3)||I.reload(p)}async unload(I,p){if(!I.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${I.id}`);const u=this._quitRequested?2:p;let h=await this.onBeforeUnloadWindowInRenderer(I,u);return h?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${I.id})`),this.handleWindowUnloadVeto(h)):(h=await this.onBeforeUnloadWindowInMain(I,u),h?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${I.id})`),this.handleWindowUnloadVeto(h)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${I.id})`),await this.onWillUnloadWindowInRenderer(I,u),!1))}handleWindowUnloadVeto(I){return I?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(I){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(I),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(I,p){return new Promise(u=>{const h=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${h}`,c=`vscode:cancel${h}`;y.ipcMain.once(o,()=>{u(!1)}),y.ipcMain.once(c,()=>{u(!0)}),I.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:c,reason:p})})}onBeforeUnloadWindowInMain(I,p){const u=[];return this._onBeforeUnloadWindow.fire({reason:p,window:I,veto(h){u.push(h)}}),(0,t.handleVetos)(u,h=>this.logService.error(h))}onWillUnloadWindowInRenderer(I,p){return new Promise(u=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;y.ipcMain.once(o,()=>u()),I.send("vscode:onWillUnload",{replyChannel:o,reason:p})})}quit(I){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${I}`),I&&this.stateMainService.setItem(lt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(p=>{this.pendingQuitPromiseResolve=p,this.logService.trace("Lifecycle#quit() - calling app.quit()"),y.app.quit()}),this.pendingQuitPromise)}async relaunch(I){this.logService.trace("Lifecycle#relaunch()");const p=process.argv.slice(1);if(I?.addArgs&&p.push(...I.addArgs),I?.removeArgs)for(const o of I.removeArgs){const c=p.indexOf(o);c>=0&&p.splice(c,1)}const u=()=>{try{if(E.isWindows){const o=(0,n.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),y.app.relaunch({args:p})};y.app.once("quit",u),await this.quit(!0)&&y.app.removeListener("quit",u)}async kill(I){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const p of y.BrowserWindow.getAllWindows())if(p&&!p.isDestroyed()){let u;p.webContents&&!p.webContents.isDestroyed()?u=new Promise(h=>p.once("closed",h)):u=Promise.resolve(),p.destroy(),await u}})()]),y.app.exit(I)}};d.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",d=he([te(0,P.ILogService),te(1,b.IStateMainService)],d),e.LifecycleMainService=d}),define(Z[196],x([0,1,4,2,5,22]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,k.createDecorator)("keyboardLayoutMainService");let E=class extends L.Disposable{constructor(w){super();this._onDidChangeKeyboardLayout=this._register(new y.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,w.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const w=await new Promise((t,P)=>{K(["native-keymap"],t,P)});this._keyboardLayoutData=n(w),w.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(w),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=he([te(0,M.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function n(f){const w=f.getKeyMap(),t=f.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:t}}}),define(Z[96],x([0,1,9,4,2,13,85,5]),function(K,e,y,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,n.createDecorator)("storageService");var w;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var t;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(t=e.StorageScope||(e.StorageScope={}));var P;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(P=e.StorageTarget||(e.StorageTarget={}));class b extends k.Disposable{constructor(I={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super();this.options=I,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new y.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,y.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,p){p===f?(I===0?this._globalKeyTargets=void 0:I===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:I})):this._onDidChangeValue.fire({scope:I,key:p,target:this.getKeyTargets(I)[p]})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,p,u){return this.getStorage(p)?.get(I,u)}getBoolean(I,p,u){return this.getStorage(p)?.getBoolean(I,u)}getNumber(I,p,u){return this.getStorage(p)?.getNumber(I,u)}store(I,p,u,h){if((0,M.isUndefinedOrNull)(p)){this.remove(I,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(I,u,h),this.getStorage(u)?.set(I,p)})}remove(I,p){this.withPausedEmitters(()=>{this.updateKeyTarget(I,p,void 0),this.getStorage(p)?.delete(I)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,p){const u=[],h=this.getKeyTargets(I);for(const o of Object.keys(h))h[o]===p&&u.push(o);return u}updateKeyTarget(I,p,u){const h=this.getKeyTargets(p);typeof u=="number"?h[I]!==u&&(h[I]=u,this.getStorage(p)?.set(f,JSON.stringify(h))):typeof h[I]=="number"&&(delete h[I],this.getStorage(p)?.set(f,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(I){return I===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(I){const p=this.get(f,I);if(p)try{return JSON.parse(p)}catch(u){}return Object.create(null)}isNew(I){return this.getBoolean(e.IS_NEW_KEY,I)===!0}async flush(I=w.NONE){this._onWillSaveState.fire({reason:I}),await y.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const I=this.getStorage(0)?.items??new Map,p=this.getStorage(1)?.items??new Map;return d(I,p,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=b,b.DEFAULT_FLUSH_INTERVAL=60*1e3;class v extends b{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(1,I))),this._register(this.globalStorage.onDidChangeStorage(I=>this.emitDidChangeValue(0,I)))}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(I){}}e.InMemoryStorageService=v;async function d(m,I,p,u){const h=l=>{try{return JSON.parse(l)}catch(g){return l}},o=new Map,c=new Map;m.forEach((l,g)=>{o.set(g,l),c.set(g,h(l))});const i=new Map,a=new Map;I.forEach((l,g)=>{i.set(g,l),a.set(g,h(l))}),console.group(`Storage: Global (path: ${p})`);let r=[];o.forEach((l,g)=>{r.push({key:g,value:l})}),console.table(r),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${u})`);let s=[];i.forEach((l,g)=>{s.push({key:g,value:l})}),console.table(s),console.groupEnd(),console.log(a)}e.logStorage=d}),define(Z[197],x([0,1,3,32,7,28]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function E(w){if(y.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function n(w,t,P,b,v,d,m,I,p,u){const h=Object.create(null);h["common.machineId"]=m,h.sessionID=(0,M.generateUuid)()+Date.now(),h.commitHash=v,h.version=d,h["common.platformVersion"]=(t||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,y.PlatformToString)(y.platform),h["common.nodePlatform"]=L.platform,h["common.nodeArch"]=b,h["common.product"]=u||"desktop";const o=f(I||[]);o&&(h["common.msftInternal"]=o);let c=0;const i=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),y.isLinuxSnap&&(h["common.snap"]="true");const a=E(P);a&&(h["common.platformDetail"]=a);try{const r=await w.readFile(k.URI.file(p));h["common.source"]=r.value.toString().slice(0,30)}catch(r){}return h}e.resolveCommonProperties=n;function f(w){const t=L.env.USERDNSDOMAIN;if(!t)return!1;const P=t.toLowerCase();return w.some(b=>P===b)}e.verifyMicrosoftInternalDomain=f}),define(Z[34],x([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,y.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,y.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[198],x([0,1,26,63,40,10,8,3,7,66,19,82,70,20,21,34]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function I(c,i){const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,s=new Map,l=2e4;function g(A,F,U,X){const ne=F.substring(A.length+1);return new Promise(async se=>{let G;try{G=await t.Promises.readdir(F,{withFileTypes:!0})}catch(V){se();return}if(X.count>=l){X.count+=G.length,X.maxReached=!0,se();return}let J=G.length;if(J===0){se();return}let W=G;X.count+G.length>l&&(X.maxReached=!0,J=l-X.count,W=G.slice(0,J)),X.count+=G.length;for(const V of W)if(V.isDirectory()){if(U.includes(V.name)||await g(A,(0,E.join)(F,V.name),U,X),--J==0){se();return}}else{const B=V.name.lastIndexOf(".");if(B>=0){const $=V.name.substring(B+1);$&&r.set($,(r.get($)??0)+1)}for(const $ of a)$.relativePathPattern?.test(ne)!==!1&&$.filePattern.test(V.name)&&s.set($.tag,(s.get($.tag)??0)+1);if(--J==0){se();return}}})}const S={count:0,maxReached:!1};await g(c,c,i,S);const D=await h(c);return{configFiles:p(s),fileTypes:p(r),fileCount:S.count,maxFilesReached:S.maxReached,launchConfigFiles:D}}e.collectWorkspaceStats=I;function p(c){return[...L.Iterable.map(c.entries(),([i,a])=>({name:i,count:a}))].sort((i,a)=>a.count-i.count)}function u(){const c={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},i=y.cpus();return i&&i.length>0&&(c.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),c}e.getMachineInfo=u;async function h(c){try{const i=new Map,a=(0,E.join)(c,".vscode","launch.json"),r=await t.Promises.readFile(a),s=[],l=(0,k.parse)(r.toString(),s);if(s.length)return console.log(`Unable to parse ${a}`),[];if((0,k.getNodeType)(l)==="object"&&l.configurations)for(const g of l.configurations){const S=g.type;S&&(i.has(S)?i.set(S,i.get(S)+1):i.set(S,1))}return p(i)}catch(i){return[]}}e.collectLaunchConfigs=h;let o=class{constructor(i,a){this.telemetryService=i,this.productService=a}formatMachineInfo(i){const a=[];return a.push(`OS Version:       ${i.os}`),a.push(`CPUs:             ${i.cpus}`),a.push(`Memory (System):  ${i.memory}`),a.push(`VM:               ${i.vmHint}`),a.join(`
`)}formatEnvironment(i){const a=[];a.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),a.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const r=y.cpus();return r&&r.length>0&&a.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),a.push(`Memory (System):  ${(y.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||a.push(`Load (avg):       ${y.loadavg().map(s=>Math.round(s)).join(", ")}`),a.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${i.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(i,a){return Promise.all([(0,P.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async r=>{let[s,l]=r,g=this.formatProcessList(i,s);return a.forEach(S=>{if((0,b.isRemoteDiagnosticError)(S))g+=`
${S.errorMessage}`,l+=`
${S.errorMessage}`;else if(g+=`

Remote: ${S.hostName}`,S.processes&&(g+=`
${this.formatProcessList(i,S.processes)}`),S.workspaceMetadata){l+=`
|  Remote: ${S.hostName}`;for(const D of Object.keys(S.workspaceMetadata)){const A=S.workspaceMetadata[D];let F=`${A.fileCount} files`;A.maxFilesReached&&(F=`more than ${F}`),l+=`|    Folder (${D}): ${F}`,l+=this.formatWorkspaceStats(A)}}}),{processInfo:g,workspaceInfo:l}})}async getSystemInfo(i,a){const{memory:r,vmHint:s,os:l,cpus:g}=u(),S={os:l,memory:r,cpus:g,vmHint:s,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:a};return n.isWindows||(S.load=`${y.loadavg().map(D=>Math.round(D)).join(", ")}`),n.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(i,a){const r=[];return(0,P.listProcesses)(i.mainPID).then(async s=>(r.push(""),r.push(this.formatEnvironment(i)),r.push(""),r.push(this.formatProcessList(i,s)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(i))),a.forEach(l=>{if((0,b.isRemoteDiagnosticError)(l))r.push(`
${l.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${l.hostName}`),r.push(this.formatMachineInfo(l.machineInfo)),l.processes&&r.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const g of Object.keys(l.workspaceMetadata)){const S=l.workspaceMetadata[g];let D=`${S.fileCount} files`;S.maxFilesReached&&(D=`more than ${D}`),r.push(`Folder (${g}): ${D}`),r.push(this.formatWorkspaceStats(S))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(i){const a=[],r=60;let s=0;const l=(A,F)=>{const U=` ${A}(${F})`;s+U.length>r?(a.push(g),g="|                 ",s=g.length):s+=U.length,g+=U};let g="|      File types:";const S=10;let D=i.fileTypes.length>S?S:i.fileTypes.length;for(let A=0;A<D;A++){const F=i.fileTypes[A];l(F.name,F.count)}if(a.push(g),i.configFiles.length>=0&&(g="|      Conf files:",s=0,i.configFiles.forEach(A=>{l(A.name,A.count)}),a.push(g)),i.launchConfigFiles.length>0){let A="|      Launch Configs:";i.launchConfigFiles.forEach(F=>{A+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),a.push(A)}return a.join(`
`)}expandGPUFeatures(i){const a=Math.max(...Object.keys(i).map(r=>r.length));return Object.keys(i).map(r=>`${r}:  ${" ".repeat(a-r.length)}  ${i[r]}`).join(`
                  `)}formatWorkspaceMetadata(i){const a=[],r=[];return i.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(a.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const g=f.URI.revive(l);if(g.scheme===M.Schemas.file){const S=g.fsPath;r.push(I(S,["node_modules",".git"]).then(D=>{let A=`${D.fileCount} files`;D.maxFilesReached&&(A=`more than ${A}`),a.push(`|    Folder (${(0,E.basename)(S)}): ${A}`),a.push(this.formatWorkspaceStats(D))}).catch(D=>{a.push(`|      Error: Unable to collect workspace stats for folder ${S} (${D.toString()})`)}))}else a.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(s=>a.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(i,a){const r=new Map;i.windows.forEach(l=>r.set(l.pid,l.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(i.mainPID,r,s,a,0),s.join(`
`)}formatProcessItem(i,a,r,s,l){const g=l===0;let S;g?S=s.pid===i?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(l)} ${s.name}`,s.name==="window"&&(S=`${S} (${a.get(s.pid)})`));const D=process.platform==="win32"?s.mem:y.totalmem()*(s.mem/100);r.push(`${s.load.toFixed(0).padStart(5," ")}	${(D/v.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(s.children)&&s.children.forEach(A=>this.formatProcessItem(i,a,r,A,l+1))}async reportWorkspaceStats(i){for(const{uri:a}of i.folders){const r=f.URI.revive(a);if(r.scheme!==M.Schemas.file)continue;const s=r.fsPath;try{const l=await I(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})}),l.launchConfigFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})}),l.configFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})})}catch{}}}};o=he([te(0,m.ITelemetryService),te(1,d.IProductService)],o),e.DiagnosticsService=o}),define(Z[199],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class y{constructor(M){this.appender=M}listen(M,E){throw new Error(`Event not found: ${E}`)}call(M,E,{eventName:n,data:f}){return this.appender.log(n,f),Promise.resolve(null)}}e.TelemetryAppenderChannel=y;class L{constructor(M){this.channel=M}log(M,E){return this.channel.call("log",{eventName:M,data:E}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[200],x([0,1,2,44,25,147,16,49,45,38]),function(K,e,y,L,k,M,E,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let t=class{constructor(v,d){this._configurationService=d,this._experimentProperties={},this._disposables=new y.DisposableStore,this._cleanupPatterns=[],this._appender=v.appender,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let m of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(m),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(m=>{const I=/^[a-f0-9]+$/i.test(m["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!I})})}setExperimentProperty(v,d){this._experimentProperties[v]=d}setEnabled(v){this._enabled=v}_updateUserOptIn(){const v=this._configurationService?.getValue(P);this._userOptIn=v?v.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const v=await this._commonProperties;let d=v.sessionID,m=v["common.instanceId"],I=v["common.machineId"],p=v["common.firstSessionDate"],u=v["common.msftInternal"];return{sessionId:d,instanceId:m,machineId:I,firstSessionDate:p,msftInternal:u}}dispose(){this._disposables.dispose()}publicLog(v,d,m){return this.isOptedIn?this._commonProperties.then(I=>{d=(0,L.mixin)(d,I),d=(0,L.mixin)(d,this._experimentProperties),d=(0,L.cloneAndChange)(d,p=>{if(typeof p=="string")return this._cleanupInfo(p,m)}),this._appender.log(v,d)},I=>{console.error(I)}):Promise.resolve(void 0)}publicLog2(v,d,m){return this.publicLog(v,d,m)}publicLogError(v,d){return this.sendErrorTelemetry?this.publicLog(v,d,!0):Promise.resolve(void 0)}publicLogError2(v,d){return this.publicLogError(v,d)}_cleanupInfo(v,d){let m=v;if(d){const I=[];for(let o of this._cleanupPatterns)for(;;){const c=o.exec(v);if(!c)break;I.push([c.index,o.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(m="";;){const o=u.exec(v);if(!o)break;!p.test(o[0])&&I.every(([c,i])=>o.index<c||o.index>=i)&&(m+=v.substring(h,o.index)+"<REDACTED: user-file-path>",h=u.lastIndex)}h<v.length&&(m+=v.substr(h))}for(let I of this._cleanupPatterns)m=m.replace(I,"");return m}};t.IDLE_START_EVENT_NAME="UserIdleStart",t.IDLE_STOP_EVENT_NAME="UserIdleStop",t=he([te(1,E.IConfigurationService)],t),e.TelemetryService=t;const P="telemetry";w.Registry.as(n.Extensions.Configuration).registerConfiguration({id:P,order:110,type:"object",title:(0,M.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,M.localize)(2,null,f.default.nameLong,f.default.privacyStatementUrl):(0,M.localize)(1,null,f.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[75],x([0,1,9,44,13,16]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.TelemetryLevel=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(I,p){return Promise.resolve(void 0)}publicLog2(I,p){return this.publicLog(I,p)}publicLogError(I,p){return Promise.resolve(void 0)}publicLogError2(I,p){return this.publicLogError(I,p)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class E{async publicLog(p,u,h){}async publicLogError(p,u,h){}}e.NullEndpointTelemetryService=E;function n(...I){return{log:(p,u)=>I.forEach(h=>h.log(p,u)),flush:()=>y.Promises.settled(I.map(p=>p.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(I,p){return p.onDidChangeConfiguration(u=>{u.source!==6&&I.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(u.source),configurationKeys:d(u.sourceConfig)})})}e.configurationTelemetry=f;var w;(function(I){I[I.NONE=0]="NONE",I[I.LOG=1]="LOG",I[I.USER=2]="USER"})(w=e.TelemetryLevel||(e.TelemetryLevel={}));function t(I,p){return p.disableTelemetry||!I.enableTelemetry?0:p.isBuilt?2:1}e.getTelemetryLevel=t;function P(I){const p=Object.create(null),u=Object.create(null),h=Object.create(null);v(I,h);for(let o in h){o=o.length>150?o.substr(o.length-149):o;const c=h[o];typeof c=="number"?u[o]=c:typeof c=="boolean"?u[o]=c?1:0:typeof c=="string"?p[o]=c.substring(0,1023):typeof c!="undefined"&&c!==null&&(p[o]=c)}return{properties:p,measurements:u}}e.validateTelemetryData=P;function b(I){if(!I)return"none";let p="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{I.indexOf(`${h}+`)===0&&(p=h)}),p}e.cleanRemoteAuthority=b;function v(I,p,u=0,h){if(!!I)for(let o of Object.getOwnPropertyNames(I)){const c=I[o],i=h?h+o:o;Array.isArray(c)?p[i]=(0,L.safeStringify)(c):c instanceof Date?p[i]=c.toISOString():(0,k.isObject)(c)?u<2?v(c,p,u+1,i+"."):p[i]=(0,L.safeStringify)(c):p[i]=c}}function d(I){if(!I)return[];const p=[];return m(p,"",I),p}function m(I,p,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(h=>m(I,p?`${p}.${h}`:h,u[h])):I.push(p)}}),define(Z[201],x([0,1,31,24,17,44,3,32,7,16,48,168,171,162,20,6,21,50,194,96,34,75]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m,I,p,u,h,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=void 0;const i=E.isWeb?"web":(0,P.getTargetPlatform)(E.platform,n.arch);var a;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished"})(a||(a={}));function r(...N){return String(N.reduce((C,q)=>C|q,0))}var s;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},g={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},D={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class A{constructor(C=D){this.state=C}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(C,q=this.state.pageSize){return new A({...this.state,pageNumber:C,pageSize:q})}withFilter(C,...q){const Q=[...this.state.criteria,...q.length?q.map(ie=>({filterType:C,value:ie})):[{filterType:C}]];return new A({...this.state,criteria:Q})}withSortBy(C){return new A({...this.state,sortBy:C})}withSortOrder(C){return new A({...this.state,sortOrder:C})}withFlags(...C){return new A({...this.state,flags:C.reduce((q,Q)=>q|Q,0)})}withAssetTypes(...C){return new A({...this.state,assetTypes:C})}get raw(){const{criteria:C,pageNumber:q,pageSize:Q,sortBy:ie,sortOrder:oe,flags:ae,assetTypes:ee}=this.state;return{filters:[{criteria:C,pageNumber:q,pageSize:Q,sortBy:ie,sortOrder:oe}],assetTypes:ee,flags:ae}}get searchText(){const C=this.state.criteria.filter(q=>q.filterType===s.SearchText)[0];return C&&C.value?C.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(C=>String(C.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function F(N,C){const q=(N||[]).filter(Q=>Q.statisticName===C)[0];return q?q.value:0}function U(N){const C="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(Q=>Q.assetType.indexOf(C)===0).reduce((Q,ie)=>{const oe=G(N,ie.assetType);return oe&&Q.push([ie.assetType.substring(C.length),oe]),Q},[])}function X(N){if(N.properties){const C=N.properties.filter(ie=>ie.key===l.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Q=C.filter(ie=>q.test(ie.value))[0];return Q?{uri:Q.value,fallbackUri:Q.value}:null}return G(N,l.Repository)}function ne(N){return{uri:`${N.fallbackAssetUri}/${l.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${l.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function se(N){const C=G(N,l.Icon);if(C)return C;const q=P.DefaultIconPath;return{uri:q,fallbackUri:q}}function G(N,C){return N.files.filter(Q=>Q.assetType===C)[0]?{uri:`${N.assetUri}/${C}`,fallbackUri:`${N.fallbackAssetUri}/${C}`}:null}function J(N,C){const q=N.properties?N.properties.filter(ie=>ie.key===C):[],Q=q.length>0&&q[0].value;return Q?Q.split(",").map(ie=>(0,b.adoptToGalleryExtensionId)(ie)):[]}function W(N){const C=N.properties?N.properties.filter(q=>q.key===g.Engine):[];return C.length>0&&C[0].value||""}function V(N){const C=N.properties?N.properties.filter(Q=>Q.key===g.LocalizedLanguages):[],q=C.length>0&&C[0].value||"";return q?q.split(","):[]}function B(N){return N.indexOf("preview")!==-1}function $(N){return N.targetPlatform?(0,P.toTargetPlatform)(N.targetPlatform):"undefined"}function H(N){const C=(0,y.distinct)(N.versions.map($)),q=!!N.tags?.includes(P.WEB_EXTENSION_TAG),Q=C.indexOf("web");return q?Q===-1&&C.push("web"):Q!==-1&&C.splice(Q,1),C}function _(N,C,q,Q){const ie=H(N);let oe=N.versions[0];return oe=N.versions.find(ae=>ae.version===oe.version&&(0,P.isTargetPlatformCompatible)($(ae),ie,i))||oe,j(N,oe,ie,C,q,Q)}function j(N,C,q,Q,ie,oe){const ae={manifest:G(C,l.Manifest),readme:G(C,l.Details),changelog:G(C,l.Changelog),license:G(C,l.License),repository:X(C),download:ne(C),icon:se(C),coreTranslations:U(C)};return{identifier:{id:(0,b.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:C.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,description:N.shortDescription||"",installCount:F(N.statistics,"install"),rating:F(N.statistics,"averagerating"),ratingCount:F(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:q,assets:ae,properties:{dependencies:J(C,g.Dependency),extensionPack:J(C,g.ExtensionPack),engine:W(C),localizedLanguages:V(C),targetPlatform:$(C)},preview:B(N.flags),telemetryData:{index:(ie.pageNumber-1)*ie.pageSize+Q,querySource:oe}}}let T=class{constructor(C,q,Q,ie,oe,ae,ee,le){this.requestService=q,this.logService=Q,this.environmentService=ie,this.telemetryService=oe,this.fileService=ae,this.productService=ee,this.configurationService=le;const me=ee.extensionsGallery;this.extensionsGalleryUrl=me&&me.serviceUrl,this.extensionsControlUrl=me&&me.controlUrl,this.commonHeadersPromise=z(ee.version,ee,this.environmentService,this.configurationService,this.fileService,C)}api(C=""){return`${this.extensionsGalleryUrl}${C}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(C,q){const Q=[];let ie=new A().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,C.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...C.map(({id:ae})=>ae.toLowerCase()));C.every(ae=>!ae.version)&&(ie=ie.withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties,a.IncludeLatestVersionOnly));const{galleryExtensions:oe}=await this.queryGallery(ie,L.CancellationToken.None);for(let ae=0;ae<oe.length;ae++){const ee=oe[ae];if(!ee.versions.length)continue;const le=(0,b.getGalleryExtensionId)(ee.publisher.publisherName,ee.extensionName),me=C.find(ue=>(0,b.areSameExtensions)(ue,{id:le}))?.version;if(me){const ue=ee.versions.find(ve=>ve.version===me);ue&&Q.push(j(ee,ue,H(ee),ae,ie))}else Q.push(_(ee,ae,ie))}return Q}async getCompatibleExtension(C,q){const Q=(0,P.isIExtensionIdentifier)(C)?null:C;if(Q){if((0,P.isNotWebExtensionInWebTargetPlatform)(Q.allTargetPlatforms,q))return null;if(await this.isExtensionCompatible(Q,q))return Q}const{id:ie,uuid:oe}=Q?Q.identifier:C;let ae=new A().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");oe?ae=ae.withFilter(s.ExtensionId,oe):ae=ae.withFilter(s.ExtensionName,ie);const{galleryExtensions:ee}=await this.queryGallery(ae,L.CancellationToken.None),[le]=ee;if(!le||!le.versions.length)return null;const me=H(le);if((0,P.isNotWebExtensionInWebTargetPlatform)(me,q))return null;for(let ue of le.versions){if(!W(ue)){const ve=await this.getEngine(ue);ue={...ue,properties:[...ue.properties||[],{key:g.Engine,value:ve}]}}if(await this.isRawExtensionVersionCompatible(ue,me,q))return j(le,ue,me,0,ae)}return null}async isExtensionCompatible(C,q){if(!(0,P.isTargetPlatformCompatible)(C.properties.targetPlatform,C.allTargetPlatforms,q))return!1;let Q=C.properties.engine;if(!Q){const ie=await this.getManifest(C,L.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");Q=ie.engines.vscode}return(0,v.isEngineValid)(Q,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(C,q,Q){if(!(0,P.isTargetPlatformCompatible)($(C),q,Q))return!1;const ie=await this.getEngine(C);return(0,v.isEngineValid)(ie,this.productService.version,this.productService.date)}async query(C,q){const Q=L.CancellationToken.isCancellationToken(C)?{}:C,ie=L.CancellationToken.isCancellationToken(C)?C:q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let oe=Q.text||"";const ae=(0,M.getOrDefault)(Q,Pe=>Pe.pageSize,50);let ee=new A().withFlags(a.IncludeLatestVersionOnly,a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,ae).withFilter(s.Target,"Microsoft.VisualStudio.Code");oe?(oe=oe.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,we,fe)=>(ee=ee.withFilter(s.Category,fe||we),"")),oe=oe.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,we,fe)=>(ee=ee.withFilter(s.Tag,fe||we),"")),oe=oe.replace(/\bfeatured(\s+|\b|$)/g,()=>(ee=ee.withFilter(s.Featured),"")),oe=oe.trim(),oe&&(oe=oe.length<200?oe:oe.substring(0,200),ee=ee.withFilter(s.SearchText,oe)),ee=ee.withSortBy(0)):Q.ids?ee=ee.withFilter(s.ExtensionId,...Q.ids):Q.names?ee=ee.withFilter(s.ExtensionName,...Q.names):ee=ee.withSortBy(4),typeof Q.sortBy=="number"&&(ee=ee.withSortBy(Q.sortBy)),typeof Q.sortOrder=="number"&&(ee=ee.withSortOrder(Q.sortOrder));const{galleryExtensions:le,total:me}=await this.queryGallery(ee,ie),ue=le.map((Pe,we)=>_(Pe,we,ee,Q.source)),ve=async(Pe,we)=>{if(we.isCancellationRequested)throw(0,k.canceled)();const fe=ee.withPage(Pe+1),{galleryExtensions:Ee}=await this.queryGallery(fe,we);return Ee.map((De,Re)=>_(De,Re,fe,Q.source))};return{firstPage:ue,total:me,pageSize:ee.pageSize,getPage:ve}}async queryGallery(C,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");C=C.withFlags(C.flags,a.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,r(a.Unpublished));const Q=await this.commonHeadersPromise,ie=JSON.stringify(C.raw),oe={...Q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ie.length)},ae=new Date().getTime();let ee,le,me=0;try{if(ee=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ie,headers:oe},q),ee.res.statusCode&&ee.res.statusCode>=400&&ee.res.statusCode<500)return{galleryExtensions:[],total:me};const ue=await(0,p.asJson)(ee);if(ue){const ve=ue.results[0],Pe=ve.extensions,we=ve.resultMetadata&&ve.resultMetadata.filter(fe=>fe.metadataType==="ResultCount")[0];return me=we&&we.metadataItems.filter(fe=>fe.name==="TotalCount")[0].count||0,{galleryExtensions:Pe,total:me}}return{galleryExtensions:[],total:me}}catch(ue){throw le=ue,ue}finally{this.telemetryService.publicLog2("galleryService:query",{...C.telemetryData,requestBodySize:String(ie.length),duration:new Date().getTime()-ae,success:!!ee&&(0,p.isSuccess)(ee),responseBodySize:ee?.res.headers["Content-Length"],statusCode:ee?String(ee.res.statusCode):void 0,errorCode:le?(0,k.isPromiseCanceledError)(le)?"canceled":(0,k.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(me)})}}async reportStatistic(C,q,Q,ie){if(!this.isEnabled())return;const oe=E.isWeb?this.api(`/itemName/${C}.${q}/version/${Q}/statType/${ie==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${C}/extensions/${q}/${Q}/stats?statType=${ie}`),ae=E.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",le={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:oe,headers:le},L.CancellationToken.None)}catch(me){}}async download(C,q,Q){this.logService.trace("ExtensionGalleryService#download",C.identifier.id);const ie=(0,b.getGalleryExtensionTelemetryData)(C),oe=new Date().getTime(),ae=ue=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ie,duration:ue}),ee=Q===1?"install":Q===2?"update":"",le=ee?{uri:`${C.assets.download.uri}${f.URI.parse(C.assets.download.uri).query?"&":"?"}${ee}=true`,fallbackUri:`${C.assets.download.fallbackUri}${f.URI.parse(C.assets.download.fallbackUri).query?"&":"?"}${ee}=true`}:C.assets.download,me=await this.getAsset(le);await this.fileService.writeFile(q,me.stream),ae(new Date().getTime()-oe)}async getReadme(C,q){if(C.assets.readme){const Q=await this.getAsset(C.assets.readme,{},q);return await(0,p.asText)(Q)||""}return""}async getManifest(C,q){if(C.assets.manifest){const Q=await this.getAsset(C.assets.manifest,{},q),ie=await(0,p.asText)(Q);return ie?JSON.parse(ie):null}return null}async getManifestFromRawExtensionVersion(C,q){const Q=G(C,l.Manifest);if(!Q)throw new Error("Manifest was not found");const ie={"Accept-Encoding":"gzip"},oe=await this.getAsset(Q,{headers:ie});return await(0,p.asJson)(oe)}async getCoreTranslation(C,q){const Q=C.assets.coreTranslations.filter(ie=>ie[0]===q.toUpperCase())[0];if(Q){const ie=await this.getAsset(Q[1]),oe=await(0,p.asText)(ie);return oe?JSON.parse(oe):null}return null}async getChangelog(C,q){if(C.assets.changelog){const Q=await this.getAsset(C.assets.changelog,{},q);return await(0,p.asText)(Q)||""}return""}async getAllCompatibleVersions(C,q){let Q=new A().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");C.identifier.uuid?Q=Q.withFilter(s.ExtensionId,C.identifier.uuid):Q=Q.withFilter(s.ExtensionName,C.identifier.id);const{galleryExtensions:ie}=await this.queryGallery(Q,L.CancellationToken.None);if(!ie.length)return[];const oe=H(ie[0]);if((0,P.isNotWebExtensionInWebTargetPlatform)(oe,q))return[];const ae=[];for(const ee of ie[0].versions)try{await this.isRawExtensionVersionCompatible(ee,oe,q)&&ae.push({version:ee.version,date:ee.lastUpdated})}catch(le){}return ae}async getAsset(C,q={},Q=L.CancellationToken.None){const ie=await this.commonHeadersPromise,oe={type:"GET"},ae={...ie,...q.headers||{}};q={...q,...oe,headers:ae};const ee=C.uri,le=C.fallbackUri,me={...q,url:ee};try{const ue=await this.requestService.request(me,Q);if(ue.res.statusCode===200)return ue;const ve=await(0,p.asText)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${ve}`)}catch(ue){if((0,k.isPromiseCanceledError)(ue))throw ue;const ve=(0,k.getErrorMessage)(ue);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ee,message:ve});const Pe={...q,url:le};return this.requestService.request(Pe,Q)}}async getEngine(C){let q=W(C);if(!q){const Q=await this.getManifestFromRawExtensionVersion(C,L.CancellationToken.None);if(!Q)throw new Error("Manifest was not found");q=Q.engines.vscode}return q}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const C=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(C.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,p.asJson)(C),Q=new Map;if(q)for(const ie of q.malicious){const oe=Q.get(ie)||{id:{id:ie},malicious:!0,slow:!1};oe.malicious=!0,Q.set(ie,oe)}return[...Q.values()]}};T=he([te(1,p.IRequestService),te(2,m.ILogService),te(3,t.IEnvironmentService),te(4,o.ITelemetryService),te(5,d.IFileService),te(6,I.IProductService),te(7,w.IConfigurationService)],T);let R=class extends T{constructor(C,q,Q,ie,oe,ae,ee,le){super(C,q,Q,ie,oe,ae,ee,le)}};R=he([te(0,h.IStorageService),te(1,p.IRequestService),te(2,m.ILogService),te(3,t.IEnvironmentService),te(4,o.ITelemetryService),te(5,d.IFileService),te(6,I.IProductService),te(7,w.IConfigurationService)],R),e.ExtensionGalleryService=R;let O=class extends T{constructor(C,q,Q,ie,oe,ae,ee){super(void 0,C,q,Q,ie,oe,ae,ee)}};O=he([te(0,p.IRequestService),te(1,m.ILogService),te(2,t.IEnvironmentService),te(3,o.ITelemetryService),te(4,d.IFileService),te(5,I.IProductService),te(6,w.IConfigurationService)],O),e.ExtensionGalleryServiceWithNoStorageService=O;async function z(N,C,q,Q,ie,oe){const ae={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N}`},ee=await(0,u.getServiceMachineId)(q,ie,oe);return(0,c.getTelemetryLevel)(C,q)>=2&&Q.getValue("telemetry.enableTelemetry")===!0&&(ae["X-Market-User-Id"]=ee),ae}e.resolveMarketplaceHeaders=z}),define(Z[202],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var y;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(y=e.ColorScheme||(e.ColorScheme={}))}),define(Z[203],x([0,1,108,4,2,5,38,202]),function(K,e,y,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var f;(function(I){function p(u){return u&&typeof u=="object"&&typeof u.id=="string"}I.isThemeColor=p})(f=e.ThemeColor||(e.ThemeColor={}));function w(I){return{id:I}}e.themeColorFromId=w;var t;(function(I){function p(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||f.isThemeColor(a.color))}I.isThemeIcon=p;const u=new RegExp(`^\\$\\((${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?)\\)$`);function h(a){const r=u.exec(a);if(!r)return;let[,s]=r;return{id:s}}I.fromString=h;function o(a,r){let s=a.id;const l=s.lastIndexOf("~");return l!==-1&&(s=s.substring(0,l)),r&&(s=`${s}~${r}`),{id:s}}I.modify=o;function c(a,r){return a.id===r.id&&a.color?.id===r.color?.id}I.isEqual=c;function i(a,r){return{id:a.id,color:r?w(r):void 0}}I.asThemeIcon=i,I.asClassNameArray=y.CSSIcon.asClassNameArray,I.asClassName=y.CSSIcon.asClassName,I.asCSSSelector=y.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=y.Codicon.file,e.FolderThemeIcon=y.Codicon.folder;function P(I){switch(I){case n.ColorScheme.DARK:return"vs-dark";case n.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,k.toDisposable)(()=>{const u=this.themingParticipants.indexOf(p);this.themingParticipants.splice(u,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new b;E.Registry.add(e.Extensions.ThemingContribution,v);function d(I){return v.onColorThemeChange(I)}e.registerThemingParticipant=d;class m extends k.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(u=>this.onThemeChange(u)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,u){let h=this.theme.getColor(p);return h&&u&&(h=u(h,this.theme)),h?h.toString():null}}e.Themable=m}),define(Z[60],x([0,1,14,3,5,39]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const E="#FFFFFF",n="#1E1E1E",f="#000000",w="theme",t="themeBackground",P="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let b=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&y.nativeTheme.shouldUseInvertedColorScheme)return f;let d=this.stateMainService.getItem(t,null);if(!d){let m;(L.isWindows||L.isMacintosh)&&y.nativeTheme.shouldUseInvertedColorScheme?m="hc-black":m=this.stateMainService.getItem(w,"vs-dark").split(" ")[0],d=m==="hc-black"?f:m==="vs"?E:n}return L.isMacintosh&&d.toUpperCase()===n&&(d="#171717"),d}saveWindowSplash(d,m){this.stateMainService.setItems([{key:w,data:m.baseTheme},{key:t,data:m.colorInfo.background},{key:P,data:m}]),typeof d=="number"&&this.updateBackgroundColor(d,m)}updateBackgroundColor(d,m){for(const I of y.BrowserWindow.getAllWindows())if(I.id===d){I.setBackgroundColor(m.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(P)}};b=he([te(0,M.IStateMainService)],b),e.ThemeMainService=b}),define(Z[42],x([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L=e.StateType||(e.StateType={}));var k;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,E)=>({type:"idle",updateType:M,error:E}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,y.createDecorator)("updateService")}),define(Z[204],x([0,1,3,148,49,38]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:y.isWindows&&!y.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[205],x([0,1,4,42]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(n){this.service=n}listen(n,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(n,f,w){switch(f){case"checkForUpdates":return this.service.checkForUpdates(w);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=k;class M{constructor(n){this.channel=n,this._onStateChange=new y.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=M}),define(Z[97],x([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,y.createDecorator)("urlService")}),define(Z[206],x([0,1,7]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(n){this.handler=n}listen(n,f){throw new Error(`Event not found: ${f}`)}call(n,f,w){switch(f){case"handleURL":return this.handler.handleURL(y.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class k{constructor(n){this.channel=n}handleURL(n,f){return this.channel.call("handleURL",[n.toJSON(),f])}}e.URLHandlerChannelClient=k;class M{constructor(n){this.next=n}async routeCall(n,f,w,t){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(w){const P=y.URI.revive(w);if(P&&P.query){const b=/\bwindowId=(\d+)/.exec(P.query);if(b){const v=b[1],d=new RegExp(`window:${v}`),m=n.connections.find(I=>d.test(I.ctx));if(m)return m}}}return this.next.routeCall(n,f,w,t)}routeEvent(n,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=M}),define(Z[207],x([0,1,9,2,7,21]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class E extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(w,t){const P=[...this.handlers.values()];return(0,y.first)(P.map(b=>()=>b.handleURL(w,t)),void 0,!1).then(b=>b||!1)}registerHandler(w){return this.handlers.add(w),(0,L.toDisposable)(()=>this.handlers.delete(w))}}e.AbstractURLService=E;let n=class extends E{constructor(w){super();this.productService=w}create(w){let{authority:t,path:P,query:b,fragment:v}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return t&&P&&P.indexOf("/")!==0&&(P=`/${P}`),k.URI.from({scheme:this.productService.urlProtocol,authority:t,path:P,query:b,fragment:v})}};n=he([te(0,M.IProductService)],n),e.NativeURLService=n}),define(Z[208],x([0,1,14,9,4,2,3,7]),function(K,e,y,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(t){try{return n.URI.parse(t)}catch(P){return null}}class w{constructor(P,b,v,d,m){if(this.urlService=b,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=P,E.isWindows){const u=d.isBuilt?[]:[`"${d.appRoot}"`];u.push("--open-url","--"),y.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,u)}const I=k.Event.map(k.Event.fromNodeEventEmitter(y.app,"open-url",(u,h)=>({event:u,url:h})),({event:u,url:h})=>(u.preventDefault(),h));this.disposables.add(I(u=>{const h=f(u);!h||this.urlService.open(h,{originalUrl:u})})),v.getWindows().filter(u=>u.isReady).length>0?this.flush():k.Event.once(v.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const P=[];for(const b of this.uris)await this.urlService.open(b.uri,{originalUrl:b.url})||P.push(b);P.length!==0&&(this.uris=P,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=w}),define(Z[209],x([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,y.createDecorator)("webviewManagerService")}),define(Z[210],x([0,1,14,2,10,7]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class E extends L.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);y.protocol.registerFileProtocol(k.Schemas.vscodeWebview,f)}handleWebviewRequest(f,w){try{const t=M.URI.parse(f.url),P=E.validWebviewFilePaths.get(t.path);if(typeof P=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${P}`,v=k.FileAccess.asFileUri(b,K);return w(decodeURIComponent(v.fsPath))}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=E,E.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[61],x([0,1,3]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(w){return!!w.workspaceUri}e.isWorkspaceToOpen=L;function k(w){return!!w.folderUri}e.isFolderToOpen=k;function M(w){return!!w.fileUri}e.isFileToOpen=M;function E(w){const t=n(w),P=w.getValue("window.menuBarVisibility");return P==="default"||t==="native"&&P==="compact"||y.isMacintosh&&y.isNative?"classic":P}e.getMenuBarVisibility=E;function n(w){if(y.isWeb)return"custom";const t=w.getValue("window");if(t){if(y.isMacintosh&&t.nativeTabs===!0||y.isMacintosh&&t.nativeFullScreen===!1)return"native";const v=t.titleBarStyle;if(v==="native"||v==="custom")return v}return y.isLinux?"native":"custom"}e.getTitleBarStyle=n;function f(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=f}),define(Z[36],x([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(w){w[w.INITIAL=1]="INITIAL",w[w.LOAD=2]="LOAD",w[w.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var k;(function(w){w[w.CLOSE=1]="CLOSE",w[w.QUIT=2]="QUIT",w[w.RELOAD=3]="RELOAD",w[w.LOAD=4]="LOAD"})(k=e.UnloadReason||(e.UnloadReason={}));var M;(function(w){w[w.CLI=0]="CLI",w[w.DOCK=1]="DOCK",w[w.MENU=2]="MENU",w[w.DIALOG=3]="DIALOG",w[w.DESKTOP=4]="DESKTOP",w[w.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const E=function(w=1){return{width:1024,height:768,mode:w}};e.defaultWindowState=E;var n;(function(w){w[w.Maximized=0]="Maximized",w[w.Normal=1]="Normal",w[w.Minimized=2]="Minimized",w[w.Fullscreen=3]="Fullscreen"})(n=e.WindowMode||(e.WindowMode={}));var f;(function(w){w[w.UNRESPONSIVE=1]="UNRESPONSIVE",w[w.CRASHED=2]="CRASHED",w[w.LOAD=3]="LOAD"})(f=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,y.createDecorator)("windowsMainService")}),define(Z[211],x([0,1,14,4,2,210,36]),function(K,e,y,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let n=class extends k.Disposable{constructor(w){super();this.windowsMainService=w,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,t){let P;if(typeof w.windowId=="number"){const{windowId:b}=w,v=this.windowsMainService.getWindowById(b);if(!v?.win)throw new Error(`Invalid windowId: ${b}`);P=v.win.webContents}else{const{webContentsId:b}=w;if(P=y.webContents.fromId(b),!P)throw new Error(`Invalid webContentsId: ${b}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(t)}async findInFrame(w,t,P,b){const v=this.getFrameByName(w,t),d=v;if(typeof d.findInFrame=="function"){d.findInFrame(P,{findNext:b.findNext,forward:b.forward});const m=(I,p)=>{p.finalUpdate&&(this._onFoundInFrame.fire(p),v.removeListener("found-in-frame",m))};v.on("found-in-frame",m)}}async stopFindInFrame(w,t,P){const v=this.getFrameByName(w,t);typeof v.stopFindInFrame=="function"&&v.stopFindInFrame(P.keepSelection?"keepSelection":"clearSelection")}getFrameByName(w,t){const P=this.windowsMainService.getWindowById(w.windowId);if(!P?.win)throw new Error(`Invalid windowId: ${w}`);const b=P.win.webContents.mainFrame.framesInSubtree.find(v=>v.name===t);if(!b)throw new Error(`Unknown frame: ${t}`);return b}};n=he([te(0,E.IWindowsMainService)],n),e.WebviewMainService=n}),define(Z[212],x([0,1,9,4,2]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends k.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:f,getActiveWindowId:w}){super();this.disposables=this._register(new k.DisposableStore),L.Event.latch(L.Event.any(n,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,y.createCancelablePromise)(()=>w()),(async()=>{try{const P=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:P}catch(P){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(Z[213],x([0,1,37,15,7,5]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,M.createDecorator)("contextService");var E;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function n(b){const v=b;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.isWorkspace=n;function f(b){const v=b;return!!(v&&typeof v=="object"&&k.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.isWorkspaceFolder=f;class w{constructor(v,d,m,I){this._id=v,this._configuration=m,this._ignorePathCasing=I,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(v){this._id=v.id,this._configuration=v.configuration,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v.with({scheme:v.scheme,authority:v.authority,path:v.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=w;class t{constructor(v,d){this.raw=d,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,L.joinPath)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function P(b){return new t({uri:b,index:0,name:(0,L.basenameOrAuthority)(b)},{uri:b.toString()})}e.toWorkspaceFolder=P}),define(Z[27],x([0,1,29,40,77,33,10,8,3,15,7,151,5,73,213]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(W){return(typeof W=="string"?(0,n.extname)(W):(0,w.extname)(W))===m}e.hasWorkspaceFileExtension=I,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function p(W){return W.hasOwnProperty("workspace")}e.isRecentWorkspace=p;function u(W){return W.hasOwnProperty("folderUri")}e.isRecentFolder=u;function h(W){return W.hasOwnProperty("fileUri")}e.isRecentFile=h;function o(W){const V=W;return typeof V?.id=="string"&&t.URI.isUri(V.uri)}e.isSingleFolderWorkspaceIdentifier=o;function c(W){if(W.configuration)return{id:W.id,configPath:W.configuration};if(W.folders.length===1)return{id:W.id,uri:W.folders[0].uri}}e.toWorkspaceIdentifier=c;function i(W){const V=W;return typeof V?.id=="string"&&t.URI.isUri(V.configPath)}e.isWorkspaceIdentifier=i;function a(W){const V=W;if(V?.uri)return{id:V.id,uri:t.URI.revive(V.uri)};const B=W;if(B?.configPath)return{id:B.id,configPath:t.URI.revive(B.configPath)};if(W?.id)return{id:W.id}}e.reviveIdentifier=a;function r(W,V){return w.extUriBiasedIgnorePathCase.isEqualOrParent(W,V.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function s(W){return l(W)||g(W)}e.isStoredWorkspaceFolder=s;function l(W){const V=W;return typeof V?.path=="string"&&(!V.name||typeof V.name=="string")}e.isRawFileWorkspaceFolder=l;function g(W){const V=W;return typeof V?.uri=="string"&&(!V.name||typeof V.name=="string")}e.isRawUriWorkspaceFolder=g;function S(W,V,B,$,H=!f.isWindows,_){if(W.scheme!==$.scheme)return{name:B,uri:W.toString(!0)};let j=V?void 0:_.relativePath($,W);if(j!==void 0)j.length===0?j=".":f.isWindows&&W.scheme===E.Schemas.file&&!H&&(j=j.replace(/\//g,"\\"));else if(W.scheme===E.Schemas.file)j=W.fsPath,f.isWindows&&(j=(0,M.normalizeDriveLetter)(j),H&&(j=(0,y.toSlashes)(j)));else{if(!_.isEqualAuthority(W.authority,$.authority))return{name:B,uri:W.toString(!0)};j=W.path}return{name:B,path:j}}e.getStoredWorkspaceFolder=S;function D(W,V,B){let $=[],H=new Set;const _=B.dirname(V);for(let j of W){let T;if(l(j))j.path&&(T=B.resolvePath(_,j.path));else if(g(j))try{T=t.URI.parse(j.uri),T.path[0]!=="/"&&(T=T.with({path:"/"+T.path}))}catch(R){console.warn(R)}if(T){let R=B.getComparisonKey(T);if(!H.has(R)){H.add(R);const O=j.name||B.basenameOrAuthority(T);$.push(new d.WorkspaceFolder({uri:T,name:O,index:$.length},j))}}}return $}e.toWorkspaceFolders=D;function A(W,V,B,$,H){let _=F(V,W);const j=H.dirname(V),T=H.dirname($),R=[],O=U(_.folders);for(const q of _.folders){const Q=l(q)?H.resolvePath(j,q.path):t.URI.parse(q.uri);let ie;B?ie=!1:ie=!l(q)||(0,n.isAbsolute)(q.path),R.push(S(Q,ie,q.name,T,O,H))}const z={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},N=k.setProperty(W,["folders"],R,z);let C=k.applyEdits(W,N);return _.remoteAuthority===(0,v.getRemoteAuthority)($)&&(C=k.applyEdits(C,k.removeProperty(C,["remoteAuthority"],z))),C}e.rewriteWorkspaceFileForNewLocation=A;function F(W,V){let B=L.parse(V);if(B&&Array.isArray(B.folders))B.folders=B.folders.filter($=>s($));else throw new Error(`${W} looks like an invalid workspace file.`);return B}function U(W){return f.isWindows?W.some(V=>l(V)&&V.path.indexOf("/")>=0):!0}e.useSlashForPath=U;function X(W){return W.workspace&&typeof W.workspace=="object"&&typeof W.workspace.id=="string"&&typeof W.workspace.configPath=="string"}function ne(W){return typeof W.folderUri=="string"}function se(W){return typeof W.fileUri=="string"}function G(W,V){const B={workspaces:[],files:[]};if(W){const $=function(_,j){for(let T=0;T<_.length;T++)try{j(_[T],T)}catch(R){V.warn(`Error restoring recent entry ${JSON.stringify(_[T])}: ${R.toString()}. Skip entry.`)}},H=W;if(Array.isArray(H.entries))$(H.entries,_=>{const j=_.label,T=_.remoteAuthority;X(_)?B.workspaces.push({label:j,remoteAuthority:T,workspace:{id:_.workspace.id,configPath:t.URI.parse(_.workspace.configPath)}}):ne(_)?B.workspaces.push({label:j,remoteAuthority:T,folderUri:t.URI.parse(_.folderUri)}):se(_)&&B.files.push({label:j,remoteAuthority:T,fileUri:t.URI.parse(_.fileUri)})});else{const _=W;Array.isArray(_.workspaces3)&&$(_.workspaces3,(j,T)=>{const R=Array.isArray(_.workspaceLabels)&&_.workspaceLabels[T]||void 0;typeof j=="object"&&typeof j.id=="string"&&typeof j.configURIPath=="string"?B.workspaces.push({label:R,workspace:{id:j.id,configPath:t.URI.parse(j.configURIPath)}}):typeof j=="string"&&B.workspaces.push({label:R,folderUri:t.URI.parse(j)})}),Array.isArray(_.files2)&&$(_.files2,(j,T)=>{const R=Array.isArray(_.fileLabels)&&_.fileLabels[T]||void 0;typeof j=="string"&&B.files.push({label:R,fileUri:t.URI.parse(j)})})}}return B}e.restoreRecentlyOpened=G;function J(W){const V={entries:[]};for(const B of W.workspaces)u(B)?V.entries.push({folderUri:B.folderUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority}):V.entries.push({workspace:{id:B.workspace.id,configPath:B.workspace.configPath.toString()},label:B.label,remoteAuthority:B.remoteAuthority});for(const B of W.files)V.entries.push({fileUri:B.fileUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority});return V}e.toStoreData=J}),define(Z[51],x([0,1,5,27]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,y.createDecorator)("backupMainService");function k(M){const E=M;return E&&(0,L.isWorkspaceIdentifier)(E.workspace)}e.isWorkspaceBackupInfo=k}),define(Z[52],x([0,1,14,9,79,33,2,65,8,3,13,19,133,5,39,27]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,v.createDecorator)("dialogMainService");let I=class gt{constructor(u){this.stateMainService=u,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(u,h){return this.doPick({...u,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},h)}pickFolder(u,h){return this.doPick({...u,pickFolders:!0,title:(0,b.localize)(1,null)},h)}pickFile(u,h){return this.doPick({...u,pickFiles:!0,title:(0,b.localize)(2,null)},h)}pickWorkspace(u,h){const o=(0,b.localize)(3,null),c=(0,M.mnemonicButtonLabel)((0,b.localize)(4,null)),i=m.WORKSPACE_FILTER;return this.doPick({...u,pickFiles:!0,title:o,filters:i,buttonLabel:c},h)}async doPick(u,h){const o={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters};o.defaultPath=u.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(o.properties=void 0,u.pickFiles&&u.pickFolders&&(o.properties=["multiSelections","openDirectory","openFile","createDirectory"])),o.properties||(o.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&o.properties.push("treatPackageAsDirectory");const c=h||y.BrowserWindow.getFocusedWindow(),i=await this.showOpenDialog(o,(0,t.withNullAsUndefined)(c));if(i&&i.filePaths&&i.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,(0,f.dirname)(i.filePaths[0])),i.filePaths}getWindowDialogQueue(u){if(u){let h=this.windowDialogQueues.get(u.id);return h||(h=new L.Queue,this.windowDialogQueues.set(u.id,h)),h}else return this.noWindowDialogueQueue}showMessageBox(u,h){return this.getWindowDialogQueue(h).queue(async()=>h?y.dialog.showMessageBox(h,u):y.dialog.showMessageBox(u))}async showSaveDialog(u,h){const o=this.acquireFileDialogLock(u,h);if(!o)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(h).queue(async()=>{let c;return h?c=await y.dialog.showSaveDialog(h,u):c=await y.dialog.showSaveDialog(u),c.filePath=this.normalizePath(c.filePath),c})}finally{(0,E.dispose)(o)}}normalizePath(u){return u&&w.isMacintosh&&(u=(0,n.normalizeNFC)(u)),u}normalizePaths(u){return u.map(h=>this.normalizePath(h))}async showOpenDialog(u,h){u.defaultPath&&(await P.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const o=this.acquireFileDialogLock(u,h);if(!o)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(h).queue(async()=>{let c;return h?c=await y.dialog.showOpenDialog(h,u):c=await y.dialog.showOpenDialog(u),c.filePaths=this.normalizePaths(c.filePaths),c})}finally{(0,E.dispose)(o)}}acquireFileDialogLock(u,h){if(!h)return E.Disposable.None;let o=this.windowFileDialogLocks.get(h.id);o||(o=new Set,this.windowFileDialogLocks.set(h.id,o));const c=(0,k.hash)(u);if(!o.has(c))return o.add(c),(0,E.toDisposable)(()=>{o?.delete(c),o?.size===0&&this.windowFileDialogLocks.delete(h.id)})}};I.workingDirPickerStorageKey="pickerWorkingDir",I=he([te(0,d.IStateMainService)],I),e.DialogMainService=I}),define(Z[214],x([0,1,4,2,27]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{constructor(n,f){super();this.logService=n,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new y.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(y.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,f)=>(n?n.push(f):n=[f],n),M.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const f=new Map,w=new Set;return n.forEach(t=>{const P=this.storageMainService.globalStorage.get(t.key);typeof P=="string"?f.set(t.key,P):w.add(t.key)}),{changed:Array.from(f.entries()),deleted:Array.from(w.values())}}listen(n,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(n,f,w){const t=(0,k.reviveIdentifier)(w.workspace),P=await this.withStorageInitialized(t);switch(f){case"getItems":return Array.from(P.items.entries());case"updateItems":{const b=w;if(b.insert)for(const[v,d]of b.insert)P.set(v,d);b.delete&&b.delete.forEach(v=>P.delete(v));break}case"close":{if(t)return P.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(n){const f=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await f.init()}catch(w){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${w}`)}return f}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[215],x([0,1,4,2,8,28,19,85,123,6,96,34,27]),function(K,e,y,L,k,M,E,n,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class v extends L.Disposable{constructor(p){super();this.logService=p,this._onDidChangeStorage=this._register(new y.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new y.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const p=await this.doCreate();this.storage.dispose(),this.storage=p,this._register(p.onDidChangeStorage(h=>this._onDidChangeStorage.fire({key:h}))),await this.doInit(p);const u=p.getBoolean(t.IS_NEW_KEY);u===void 0?p.set(t.IS_NEW_KEY,!0):u&&p.set(t.IS_NEW_KEY,!1)}catch(p){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${p}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?p=>this.logService.trace(p):void 0,logError:p=>this.logService.error(p)}}doInit(p){return p.init()}get items(){return this.storage.items}get(p,u){return this.storage.get(p,u)}set(p,u){return this.storage.set(p,u)}delete(p){return this.storage.delete(p)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class d extends v{constructor(p,u,h){super(u);this.options=p,this.environmentService=h}async doCreate(){let p;return this.options.useInMemoryStorage?p=f.SQLiteStorageDatabase.IN_MEMORY_PATH:p=(0,k.join)(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME),new n.Storage(new f.SQLiteStorageDatabase(p,{logging:this.createLoggingOptions()}))}async doInit(p){await super.doInit(p),this.updateTelemetryState(p)}updateTelemetryState(p){p.get(P.instanceStorageKey,void 0)===void 0&&p.set(P.instanceStorageKey,(0,M.generateUuid)()),p.get(P.firstSessionDateStorageKey,void 0)===void 0&&p.set(P.firstSessionDateStorageKey,new Date().toUTCString());const o=p.get(P.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();p.set(P.lastSessionDateStorageKey,typeof o=="undefined"?null:o),p.set(P.currentSessionDateStorageKey,c)}}e.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class m extends v{constructor(p,u,h,o){super(h);this.workspace=p,this.options=u,this.environmentService=o}async doCreate(){const{storageFilePath:p,wasCreated:u}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new f.SQLiteStorageDatabase(p,{logging:this.createLoggingOptions()}),{hint:u?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const p=(0,k.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),u=(0,k.join)(p,m.WORKSPACE_STORAGE_NAME);return await E.Promises.exists(p)?{storageFilePath:u,wasCreated:!1}:(await E.Promises.mkdir(p,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(p),{storageFilePath:u,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(p){let u;if((0,b.isSingleFolderWorkspaceIdentifier)(this.workspace)?u={folder:this.workspace.uri.toString()}:(0,b.isWorkspaceIdentifier)(this.workspace)&&(u={workspace:this.workspace.configPath.toString()}),u)try{const h=(0,k.join)(p,m.WORKSPACE_META_NAME);await E.Promises.exists(h)||await E.Promises.writeFile(h,JSON.stringify(u,void 0,2))}catch(h){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.WorkspaceStorageMain=m,m.WORKSPACE_STORAGE_NAME="state.vscdb",m.WORKSPACE_META_NAME="workspace.json"}),define(Z[98],x([0,1,43,2,48,5,22,6,215]),function(K,e,y,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let w=class extends L.Disposable{constructor(P,b,v){super();this.logService=P,this.environmentService=b,this.lifecycleMainService=v,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async P=>{P.workspace&&this.workspaceStorage(P.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(P=>{P.join(this.globalStorage.close());for(const[,b]of this.mapWorkspaceToStorage)P.join(b.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const P=new f.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,y.once)(P.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),P}createWorkspaceStorage(P){return new f.WorkspaceStorageMain(P,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(P){let b=this.mapWorkspaceToStorage.get(P.id);return b||(this.logService.trace(`StorageMainService: creating workspace storage (${P.id})`),b=this.createWorkspaceStorage(P),this.mapWorkspaceToStorage.set(P.id,b),(0,y.once)(b.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${P.id})`),this.mapWorkspaceToStorage.delete(P.id)})),b}};w=he([te(0,n.ILogService),te(1,k.IEnvironmentService),te(2,E.ILifecycleMainService)],w),e.StorageMainService=w}),define(Z[99],x([0,1,15,7,27]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function M(f,w,t){for(const b of f){const v=b.openedWorkspace;if((0,k.isWorkspaceIdentifier)(v)){const d=t(v);if(d){if(d.folders.some(m=>y.extUriBiasedIgnorePathCase.isEqualOrParent(w,m.uri)))return b}else if(y.extUriBiasedIgnorePathCase.isEqualOrParent(w,v.configPath))return b}}const P=f.filter(b=>(0,k.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqualOrParent(w,b.openedWorkspace.uri));if(P.length)return P.sort((b,v)=>-(b.openedWorkspace.uri.path.length-v.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function E(f,w){for(const t of f)if((0,k.isWorkspaceIdentifier)(t.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.configPath,w)||(0,k.isSingleFolderWorkspaceIdentifier)(t.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.uri,w))return t}e.findWindowOnWorkspaceOrFolder=E;function n(f,w){const t=P=>w.some(b=>y.extUriBiasedIgnorePathCase.isEqual(L.URI.file(b),L.URI.file(P)));for(const P of f)if(P.config?.extensionDevelopmentPath?.some(b=>t(b)))return P}e.findWindowOnExtensionDevelopmentPath=n}),define(Z[216],x([0,1,14,2,3,15,7,16,22,6,39,36,27]),function(K,e,y,L,k,M,E,n,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let v=class mt extends L.Disposable{constructor(h,o,c,i,a){super();this.windowsMainService=h,this.stateMainService=o,this.lifecycleMainService=c,this.logService=i,this.configurationService=a,this._state=d(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){y.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(a=>!a.isExtensionDevelopmentHost)),i&&(h.lastActiveWindow=this.toWindowState(i))}const o=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>this.toWindowState(i)));const c=I(h);this.stateMainService.setItem(mt.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(c=>{const i=(0,b.isWorkspaceIdentifier)(h.openedWorkspace)&&c.workspace?.id===h.openedWorkspace.id,a=(0,b.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&c.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(c.folderUri,h.openedWorkspace.uri);(i||a)&&(c.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(h){return{workspace:(0,b.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,b.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const o=this.doGetNewWindowState(h),c=this.configurationService.getValue("window");let i;return o.hasDefaultState?i=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(i=!!(this.lifecycleMainService.wasRestarted||c?.restoreFullscreen),i&&k.isMacintosh&&this.windowsMainService.getWindows().some(a=>a.isFullScreen)&&(i=!1)),o.mode===3&&!i&&(o.mode=1),o}doGetNewWindowState(h){const o=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=h.workspace;if((0,b.isWorkspaceIdentifier)(l)){const S=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===l.id).map(D=>D.uiState);if(S.length)return S[0]}if((0,b.isSingleFolderWorkspaceIdentifier)(l)){const S=this.state.openedWindows.filter(D=>D.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(D.folderUri,l.uri)).map(D=>D.uiState);if(S.length)return S[0]}else if(h.backupPath){const S=this.state.openedWindows.filter(D=>D.backupPath===h.backupPath).map(D=>D.uiState);if(S.length)return S[0]}const g=this.lastClosedState||this.state.lastActiveWindow;if(!o&&g)return g.uiState}let c;const i=y.screen.getAllDisplays();if(i.length===1)c=i[0];else{if(k.isMacintosh){const l=y.screen.getCursorScreenPoint();c=y.screen.getDisplayNearestPoint(l)}!c&&o&&(c=y.screen.getDisplayMatching(o.getBounds())),c||(c=y.screen.getPrimaryDisplay()||i[0])}let a=(0,P.defaultWindowState)();a.x=Math.round(c.bounds.x+c.bounds.width/2-a.width/2),a.y=Math.round(c.bounds.y+c.bounds.height/2-a.height/2);const r=this.configurationService.getValue("window");let s=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")a.mode=0,s=!1;else if(r.newWindowDimensions==="fullscreen")a.mode=3,s=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&o){const l=o.serializeWindowState();l.mode===3?a.mode=3:a=l,s=a.mode!==3&&r.newWindowDimensions==="offset"}}return s&&(a=this.ensureNoOverlap(a)),a.hasDefaultState=!0,a}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const o=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;o.some(c=>c.x===h.x||c.y===h.y);)h.x+=30,h.y+=30;return h}};v.windowsStateStorageKey="windowsState",v=he([te(0,P.IWindowsMainService),te(1,t.IStateMainService),te(2,f.ILifecycleMainService),te(3,w.ILogService),te(4,n.IConfigurationService)],v),e.WindowsStateHandler=v;function d(u){const h={openedWindows:[]},o=u||{openedWindows:[]};return o.lastActiveWindow&&(h.lastActiveWindow=m(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=m(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(h.openedWindows=o.openedWindows.map(c=>m(c))),h}e.restoreWindowsState=d;function m(u){const h={uiState:u.uiState};return u.backupPath&&(h.backupPath=u.backupPath),u.remoteAuthority&&(h.remoteAuthority=u.remoteAuthority),u.folder&&(h.folderUri=E.URI.parse(u.folder)),u.workspaceIdentifier&&(h.workspace={id:u.workspaceIdentifier.id,configPath:E.URI.parse(u.workspaceIdentifier.configURIPath)}),h}function I(u){return{lastActiveWindow:u.lastActiveWindow&&p(u.lastActiveWindow),lastPluginDevelopmentHostWindow:u.lastPluginDevelopmentHostWindow&&p(u.lastPluginDevelopmentHostWindow),openedWindows:u.openedWindows.map(h=>p(h))}}e.getWindowsStateStoreData=I;function p(u){return{workspaceIdentifier:u.workspace&&{id:u.workspace.id,configURIPath:u.workspace.configPath.toString()},folder:u.folderUri&&u.folderUri.toString(),backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.uiState}}}),define(Z[100],x([0,1,58,30,10,3,15]),function(K,e,y,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function n(w){function t(){let P=w.scheme===k.Schemas.file?(0,E.originalFSPath)(w):w.toString();return M.isLinux||(P=P.toLowerCase()),(0,y.createHash)("md5").update(P).digest("hex")}return{id:t(),configPath:w}}e.getWorkspaceIdentifier=n;function f(w,t){function P(){if(w.scheme!==k.Schemas.file)return(0,y.createHash)("md5").update(w.toString()).digest("hex");if(!t)try{t=(0,L.statSync)(w.fsPath)}catch(d){return}let v;return M.isLinux?v=t.ino:M.isMacintosh?v=t.birthtime.getTime():M.isWindows&&(typeof t.birthtimeMs=="number"?v=Math.floor(t.birthtimeMs):v=t.birthtime.getTime()),(0,y.createHash)("md5").update(w.fsPath).update(v?String(v):"").digest("hex")}const b=P();if(typeof b=="string")return{id:b,uri:w}}e.getSingleFolderWorkspaceIdentifier=f}),define(Z[56],x([0,1,58,59,26,18,17,4,2,8,3,28,35,83,217]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(S){this.socket=S,this._errorListener=D=>{if(D){if(D.code==="EPIPE")return;(0,E.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(S){const D=A=>S(M.VSBuffer.wrap(A));return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(S){const D=A=>{S({type:0,hadError:A,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(S){return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(S){if(!this.socket.destroyed)try{this.socket.write(S.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,E.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,E.onUnexpectedError)(D)}}end(){this.socket.end()}drain(){return new Promise((S,D)=>{if(this.socket.bufferSize===0){S();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),S()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=m;var I;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(I||(I={}));var p;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(p||(p={}));class u extends f.Disposable{constructor(S,D,A,F){super();this._onDidZlibFlush=this._register(new n.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new n.Emitter),this._onClose=this._register(new n.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=S,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=D,this._recordInflateBytes=F,D?(this._zlibInflate=d.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",U=>{console.error(U),(0,E.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})}),this._zlibInflate.on("data",U=>{this._pendingInflateData.push(U)}),A&&(this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{console.error(U),(0,E.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})}),this._zlibDeflate.on("data",U=>{this._pendingDeflateData.push(U)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new v.ChunkStream,this._register(this.socket.onData(U=>this._acceptChunk(U))),this._register(this.socket.onClose(U=>this._onClose.fire(U)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):M.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this._onData.event(S)}onClose(S){return this._onClose.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){this._totalOutgoingDataBytes+=S.byteLength,this._zlibDeflate?(this._zlibDeflate.write(S.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let D=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.length-4),this._isEnded||this._write(M.VSBuffer.wrap(D),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(S,!1)}_write(S,D){let A=2;S.byteLength<126?A+=0:S.byteLength<2**16?A+=2:A+=8;const F=M.VSBuffer.alloc(A);if(D?F.writeUInt8(194,0):F.writeUInt8(130,0),S.byteLength<126)F.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){F.writeUInt8(126,1);let U=1;F.writeUInt8(S.byteLength>>>8&255,++U),F.writeUInt8(S.byteLength>>>0&255,++U)}else{F.writeUInt8(127,1);let U=1;F.writeUInt8(0,++U),F.writeUInt8(0,++U),F.writeUInt8(0,++U),F.writeUInt8(0,++U),F.writeUInt8(S.byteLength>>>24&255,++U),F.writeUInt8(S.byteLength>>>16&255,++U),F.writeUInt8(S.byteLength>>>8&255,++U),F.writeUInt8(S.byteLength>>>0&255,++U)}this._totalOutgoingWireBytes+=F.byteLength+S.byteLength,this.socket.write(M.VSBuffer.concat([F,S]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(S){if(S.byteLength!==0){for(this._totalIncomingWireBytes+=S.byteLength,this._incomingData.acceptChunk(S);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),F=(D.readUInt8(0)&128)>>>7,U=D.readUInt8(1),X=(U&128)>>>7,ne=U&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(ne===126?2:0)+(ne===127?8:0),this._state.fin=F,this._state.mask=0}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),A=D.readUInt8(1),F=(A&128)>>>7;let U=A&127,X=1;U===126?U=D.readUInt8(++X)*2**8+D.readUInt8(++X):U===127&&(U=D.readUInt8(++X)*0+D.readUInt8(++X)*0+D.readUInt8(++X)*0+D.readUInt8(++X)*0+D.readUInt8(++X)*2**24+D.readUInt8(++X)*2**16+D.readUInt8(++X)*2**8+D.readUInt8(++X));let ne=0;F&&(ne=D.readUInt8(++X)*2**24+D.readUInt8(++X)*2**16+D.readUInt8(++X)*2**8+D.readUInt8(++X)),this._state.state=3,this._state.readLen=U,this._state.mask=ne}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);h(D,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(D.buffer)),this._zlibInflate.write(D.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const A=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=A.length,this._onData.fire(M.VSBuffer.wrap(A))})):(this._totalIncomingDataBytes+=D.byteLength,this._onData.fire(D))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await n.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=u;function h(g,S){if(S===0)return;let D=g.byteLength>>>2;for(let se=0;se<D;se++){const G=g.readUInt32BE(se*4);g.writeUInt32BE(G^S,se*4)}let A=D*4,F=g.byteLength-A;const U=S>>>24&255,X=S>>>16&255,ne=S>>>8&255;F>=1&&g.writeUInt8(g.readUInt8(A)^U,A),F>=2&&g.writeUInt8(g.readUInt8(A+1)^X,A+1),F>=3&&g.writeUInt8(g.readUInt8(A+2)^ne,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function c(){const g=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let S;return e.XDG_RUNTIME_DIR?S=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):S=(0,w.join)((0,k.tmpdir)(),`vscode-ipc-${g}.sock`),a(S),S}e.createRandomIPCHandle=c;function i(g,S,D){const A=(0,y.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${D}-${S}-sock`;let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${D}-${S}.sock`):F=(0,w.join)(g,`${D}-${S}.sock`),a(F),F}e.createStaticIPCHandle=i;function a(g){const S=o[t.platform];typeof S=="number"&&g.length>=S&&console.warn(`WARNING: IPC handle "${g}" is longer than ${S} chars, try a shorter --user-data-dir`)}class r extends b.IPCServer{constructor(S){super(r.toClientConnectionEvent(S));this.server=S}static toClientConnectionEvent(S){const D=n.Event.fromNodeEventEmitter(S,"connection");return n.Event.map(D,A=>({protocol:new v.Protocol(new m(A)),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function s(g){return new Promise((S,D)=>{const A=(0,L.createServer)();A.on("error",D),A.listen(g,()=>{A.removeListener("error",D),S(new r(A))})})}e.serve=s;function l(g,S){return new Promise((D,A)=>{const F=(0,L.createConnection)(g,()=>{F.removeListener("error",A),D(v.Client.fromSocket(new m(F),S))});F.once("error",A)})}e.connect=l}),define(Z[218],x([0,1,56]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(f){this.driver=f}listen(f,w){throw new Error("No event found")}call(f,w,t){switch(w){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(t);case"reloadWindow":return this.driver.reloadWindow(t);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(t[0],t[1]);case"click":return this.driver.click(t[0],t[1],t[2],t[3]);case"doubleClick":return this.driver.doubleClick(t[0],t[1]);case"setValue":return this.driver.setValue(t[0],t[1],t[2]);case"getTitle":return this.driver.getTitle(t[0]);case"isActiveElement":return this.driver.isActiveElement(t[0],t[1]);case"getElements":return this.driver.getElements(t[0],t[1],t[2]);case"getElementXY":return this.driver.getElementXY(t[0],t[1],t[2]);case"typeInEditor":return this.driver.typeInEditor(t[0],t[1],t[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(t[0],t[1]);case"writeInTerminal":return this.driver.writeInTerminal(t[0],t[1],t[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(t);case"getLocalizedStrings":return this.driver.getLocalizedStrings(t)}throw new Error(`Call not found: ${w}`)}}e.DriverChannel=L;class k{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,w){return this.channel.call("dispatchKeybinding",[f,w])}click(f,w,t,P){return this.channel.call("click",[f,w,t,P])}doubleClick(f,w){return this.channel.call("doubleClick",[f,w])}setValue(f,w,t){return this.channel.call("setValue",[f,w,t])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,w){return this.channel.call("isActiveElement",[f,w])}getElements(f,w,t){return this.channel.call("getElements",[f,w,t])}getElementXY(f,w,t,P){return this.channel.call("getElementXY",[f,w,t,P])}typeInEditor(f,w,t){return this.channel.call("typeInEditor",[f,w,t])}getTerminalBuffer(f,w){return this.channel.call("getTerminalBuffer",[f,w])}writeInTerminal(f,w,t){return this.channel.call("writeInTerminal",[f,w,t])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=k;class M{constructor(f){this.registry=f}listen(f,w){throw new Error(`Event not found: ${w}`)}call(f,w,t){switch(w){case"registerWindowDriver":return this.registry.registerWindowDriver(t);case"reloadWindowDriver":return this.registry.reloadWindowDriver(t)}throw new Error(`Call not found: ${w}`)}}e.WindowDriverRegistryChannel=M;async function E(n){const f=await(0,y.connect)(n,"driverClient"),w=f.getChannel("driver"),t=new k(w);return{client:f,driver:t}}e.connect=E}),define(Z[219],x([0,1,9,4,106,57,2,3,78,35,56,155,218,176,22,36]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function I(h){return h<21}let p=class{constructor(o,c,i,a){this.windowServer=o,this.options=c,this.windowsMainService=i,this.lifecycleMainService=a,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(o){return this.registeredWindowIds.add(o),this.reloadingWindowIds.delete(o),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(o){this.reloadingWindowIds.add(o)}async getWindowIds(){return this.windowsMainService.getWindows().map(o=>o.id).filter(o=>this.registeredWindowIds.has(o)&&!this.reloadingWindowIds.has(o))}async capturePage(o){await this.whenUnfrozen(o);const c=this.windowsMainService.getWindowById(o);if(!c?.win)throw new Error("Invalid window");return(await c.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(o){await this.whenUnfrozen(o);const c=this.windowsMainService.getWindowById(o);if(!c)throw new Error("Invalid window");this.reloadingWindowIds.add(o),this.lifecycleMainService.reload(c)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(o,c){await this.whenUnfrozen(o);const i=k.KeybindingParser.parseUserBinding(c);for(let a of i)await this._dispatchKeybinding(o,a)}async _dispatchKeybinding(o,c){if(c instanceof f.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const i=this.windowsMainService.getWindowById(o);if(!i?.win)throw new Error("Invalid window");const a=i.win.webContents,r=new M.SimpleKeybinding(!1,!1,!1,!1,c.keyCode),l=new v.USLayoutResolvedKeybinding(r.toChord(),n.OS).getElectronAccelerator(),g=[];c.ctrlKey&&g.push("ctrl"),c.metaKey&&g.push("meta"),c.shiftKey&&g.push("shift"),c.altKey&&g.push("alt"),a.sendInputEvent({type:"keyDown",keyCode:l,modifiers:g}),I(c.keyCode)||a.sendInputEvent({type:"char",keyCode:l,modifiers:g}),a.sendInputEvent({type:"keyUp",keyCode:l,modifiers:g}),await(0,y.timeout)(100)}async click(o,c,i,a){await(await this.getWindowDriver(o)).click(c,i,a)}async doubleClick(o,c){await(await this.getWindowDriver(o)).doubleClick(c)}async setValue(o,c,i){await(await this.getWindowDriver(o)).setValue(c,i)}async getTitle(o){return await(await this.getWindowDriver(o)).getTitle()}async isActiveElement(o,c){return await(await this.getWindowDriver(o)).isActiveElement(c)}async getElements(o,c,i){return await(await this.getWindowDriver(o)).getElements(c,i)}async getElementXY(o,c,i,a){return await(await this.getWindowDriver(o)).getElementXY(c,i,a)}async typeInEditor(o,c,i){await(await this.getWindowDriver(o)).typeInEditor(c,i)}async getTerminalBuffer(o,c){return await(await this.getWindowDriver(o)).getTerminalBuffer(c)}async writeInTerminal(o,c,i){await(await this.getWindowDriver(o)).writeInTerminal(c,i)}async getLocaleInfo(o){return await(await this.getWindowDriver(o)).getLocaleInfo()}async getLocalizedStrings(o){return await(await this.getWindowDriver(o)).getLocalizedStrings()}async getWindowDriver(o){await this.whenUnfrozen(o);const c=`window:${o}`,i=new w.StaticRouter(r=>r===c),a=this.windowServer.getChannel("windowDriver",i);return new P.WindowDriverChannelClient(a)}async whenUnfrozen(o){for(;this.reloadingWindowIds.has(o);)await L.Event.toPromise(this.onDidReloadingChange.event)}};p=he([te(2,m.IWindowsMainService),te(3,d.ILifecycleMainService)],p),e.Driver=p;async function u(h,o,c,i){const a=c.driverVerbose,r=i.createInstance(p,h,{verbose:a}),s=new b.WindowDriverRegistryChannel(r);h.registerChannel("windowDriverRegistry",s);const l=await(0,t.serve)(o),g=new b.DriverChannel(r);return l.registerChannel("driver",g),(0,E.combinedDisposable)(l,h)}e.serve=u}),define(Z[23],x([0,1,47,8,56,48,160,5]),function(K,e,y,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,n.refineServiceDecorator)(M.IEnvironmentService);class f extends E.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}he([y.memoize],f.prototype,"cachedLanguagesPath",null),he([y.memoize],f.prototype,"backupHome",null),he([y.memoize],f.prototype,"backupWorkspacesPath",null),he([y.memoize],f.prototype,"mainIPCHandle",null),he([y.memoize],f.prototype,"mainLockfile",null),he([y.memoize],f.prototype,"sandbox",null),he([y.memoize],f.prototype,"driverVerbose",null),he([y.memoize],f.prototype,"disableUpdates",null),he([y.memoize],f.prototype,"disableKeytar",null),he([y.memoize],f.prototype,"codeCachePath",null),he([y.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(Z[220],x([0,1,58,30,29,10,8,3,15,7,19,51,16,23,20,6,27]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let p=class{constructor(h,o,c){this.configurationService=o,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,a)=>(0,k.isEqual)(i,a,!n.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await t.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(i){h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let o=[];try{Array.isArray(h.rootURIWorkspaces)&&(o=h.rootURIWorkspaces.map(i=>({workspace:{id:i.id,configPath:w.URI.parse(i.configURIPath)},remoteAuthority:i.remoteAuthority})))}catch(i){}this.workspaces=await this.validateWorkspaces(o);let c=[];try{Array.isArray(h.folderURIWorkspaces)&&(c=h.folderURIWorkspaces.map(i=>w.URI.parse(i)))}catch(i){}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,o){this.workspaces.some(i=>h.workspace.id===i.workspace.id)||(this.workspaces.push(h),this.saveSync());const c=this.getBackupPath(h.workspace.id);return o&&this.moveBackupFolderSync(c,o),c}moveBackupFolderSync(h,o){if(L.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),L.existsSync(o))try{L.renameSync(o,h)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(h){const o=h.id,c=this.workspaces.findIndex(i=>i.workspace.id===o);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(o=>this.backupUriComparer.isEqual(h,o))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const o=this.folders.findIndex(c=>this.backupUriComparer.isEqual(h,c));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(h,o){const c=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:o}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(h){const o=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,h));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(h){return(0,E.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const o=new Set,c=[];for(let i of h){const a=i.workspace;if(!(0,I.isWorkspaceIdentifier)(a))return[];if(!o.has(a.id)){o.add(a.id);const r=this.getBackupPath(a.id);await this.doHasBackups(r)?a.configPath.scheme!==M.Schemas.file||await t.Promises.exists(a.configPath.fsPath)?c.push(i):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return c}async validateFolders(h){if(!Array.isArray(h))return[];const o=[],c=new Set;for(let i of h){const a=this.backupUriComparer.getComparisonKey(i);if(!c.has(a)){c.add(a);const r=this.getBackupPath(this.getFolderHash(i));await this.doHasBackups(r)?i.scheme!==M.Schemas.file||await t.Promises.exists(i.fsPath)?o.push(i):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return o}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const o=[],c=new Set;for(let i of h){const a=i.backupFolder;if(typeof a!="string")return[];if(!c.has(a)){c.add(a);const r=this.getBackupPath(a);await this.doHasBackups(r)?o.push(i):await this.deleteStaleBackup(r)}}return o}async deleteStaleBackup(h){try{await t.Promises.exists(h)&&await t.Promises.rm(h,t.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,o));)o=this.getRandomEmptyWindowId();const c=this.getBackupPath(o);try{await t.Promises.rename(h,c)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,o));)o=this.getRandomEmptyWindowId();const c=this.getBackupPath(o);try{L.renameSync(h,c)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const h=[];for(const o of this.workspaces)await this.hasBackups(o)&&h.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&h.push(o);return h}hasBackups(h){let o;return w.URI.isUri(h)?o=this.getBackupPath(this.getFolderHash(h)):(0,P.isWorkspaceBackupInfo)(h)?o=this.getBackupPath(h.workspace.id):o=h.backupFolder,this.doHasBackups(o)}async doHasBackups(h){try{const o=await t.Promises.readdir(h);for(const c of o)try{if((await t.Promises.readdir((0,E.join)(h,c))).length>0)return!0}catch(i){}}catch(o){}return!1}saveSync(){try{(0,t.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await t.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderURIWorkspaces:this.folders.map(h=>h.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){let o;return h.scheme===M.Schemas.file?o=n.isLinux?h.fsPath:h.fsPath.toLowerCase():o=h.toString().toLowerCase(),(0,y.createHash)("md5").update(o).digest("hex")}};p=he([te(0,v.IEnvironmentMainService),te(1,b.IConfigurationService),te(2,m.ILogService)],p),e.BackupMainService=p}),define(Z[221],x([0,1,59,56]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,M,E,n){const f=t=>n(t,void 0),w=y.createConnection({host:k,port:M},()=>{w.removeListener("error",f);const t=Buffer.alloc(16);for(let d=0;d<16;d++)t[d]=Math.round(Math.random()*256);const P=t.toString("base64");let b=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${M}/?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`];w.write(b.join(`\r
`)+`\r
\r
`);const v=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",v),n(void 0,new L.NodeSocket(w)))};w.on("data",v)});w.once("error",f)}}}),define(Z[222],x([0,1,59,9,2,115,16,6,21,191,95,221,74]),function(K,e,y,L,k,M,E,n,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function v(p,u,h,o,c){return new d(p,u,h,o,c).waitForReady()}class d extends k.Disposable{constructor(u,h,o,c,i){super();this.defaultTunnelHost=h,this.suggestedLocalPort=i,this.public=!1,this._socketsDispose=new Map,this._options=u,this._server=y.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=a=>this._onConnection(a),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let u=await(0,M.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(u){u.pause();const h=await(0,w.connectRemoteAgentTunnel)(this._options,this.tunnelRemoteHost,this.tunnelRemotePort),o=h.getSocket().socket,c=h.readEntireBuffer();h.dispose(),c.byteLength>0&&u.write(c.buffer),u.on("end",()=>{this._socketsDispose.delete(u.localAddress),o.end()}),u.on("close",()=>o.end()),u.on("error",()=>{this._socketsDispose.delete(u.localAddress),o.destroy()}),o.on("end",()=>u.end()),o.on("close",()=>u.end()),o.on("error",()=>{u.destroy()}),u.pipe(o),o.pipe(u),this._socketsDispose.set(u.localAddress,()=>{u.end(),o.end()})}}let m=class extends t.AbstractTunnelService{constructor(u,h,o,c,i){super(h);this.socketFactory=u,this.signService=o,this.productService=c,this.configurationService=i}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(u,h,o,c,i,a,r){const s=this.getTunnelFromMap(h,o);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,o,c,i,a,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${o} on local port ${c}.`);const l={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:u,signService:this.signService,logService:this.logService,ipcLogger:null},g=v(l,this.defaultTunnelHost,h,o,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,o,g),g}}};m=he([te(1,n.ILogService),te(2,b.ISignService),te(3,f.IProductService),te(4,E.IConfigurationService)],m),e.BaseTunnelService=m;let I=class extends m{constructor(u,h,o,c){super(P.nodeSocketFactory,u,h,o,c)}};I=he([te(0,n.ILogService),te(1,b.ISignService),te(2,f.IProductService),te(3,E.IConfigurationService)],I),e.TunnelService=I}),define(Z[223],x([0,1,193,18,17,2,13,16,48,90,6,192,217]),function(K,e,y,L,k,M,E,n,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let v=class extends M.Disposable{constructor(m,I,p){super();this.environmentService=I,this.logService=p,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,I){this.logService.trace("RequestService#request",m.url);const{proxyUrl:p,strictSSL:u}=this,h={...process.env,...await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=m.agent?m.agent:await(0,P.getProxyAgent)(m.url||"",h,{proxyUrl:p,strictSSL:u});return m.agent=o,m.strictSSL=u,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization}),this._request(m,I)}async getNodeRequest(m){return((0,y.parse)(m.url).protocol==="https:"?await new Promise((u,h)=>{K(["https"],u,h)}):await new Promise((u,h)=>{K(["http"],u,h)})).request}_request(m,I){return new Promise(async(p,u)=>{let h;const o=(0,y.parse)(m.url),c=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),i={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,E.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(i.auth=m.user+":"+m.password),h=c(i,a=>{const r=(0,E.isNumber)(m.followRedirects)?m.followRedirects:3;if(a.statusCode&&a.statusCode>=300&&a.statusCode<400&&r>0&&a.headers.location)this._request({...m,url:a.headers.location,followRedirects:r-1},I).then(p,u);else{let s=a;a.headers["content-encoding"]==="gzip"&&(s=a.pipe((0,b.createGunzip)())),p({res:a,stream:(0,L.streamToBufferReadableStream)(s)})}}),h.on("error",u),m.timeout&&h.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&h.write(m.data),h.end(),I.onCancellationRequested(()=>{h.abort(),u((0,k.canceled)())})})}async resolveProxy(m){}};v=he([te(0,n.IConfigurationService),te(1,f.INativeEnvironmentService),te(2,t.ILogService)],v),e.RequestService=v}),define(Z[224],x([0,1,14,223]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(E){return y.net.request}class M extends L.RequestService{request(n,f){return super.request({...n||{},getRawRequest:k},f)}}e.RequestMainService=M}),define(Z[225],x([0,1,14,9,4,2,10,13,84,23,22,6,45,55,60]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends M.Disposable{constructor(p,u,h,o,c,i,a){super();this.machineId=p,this.userEnv=u,this.environmentMainService=h,this.lifecycleMainService=o,this.logService=c,this.themeMainService=i,this.protocolMainService=a,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new k.Emitter),this.onDidError=k.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),y.ipcMain.on("vscode:createSharedProcessMessageChannel",async(p,u)=>this.onWindowConnection(p,u))}async onWindowConnection(p,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const h=await this.connect();if(p.sender.isDestroyed())return h.close();p.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[h])}onWillShutdown(){const p=this.window;!p||(!p.isDestroyed()&&!p.webContents.isDestroyed()&&p.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(p.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{p.close()}catch(u){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(p=>y.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),p()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(p=>y.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),p()}))})()),this._whenIpcReady}createWindow(){const p=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new y.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${p.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),p.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:b.default}),this.window.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",K).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=p=>{this.logService.trace("SharedProcess#close prevented"),p.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(p,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(p,u,h)=>this._onDidError.fire({type:3,details:{reason:h,exitCode:u}})))}async connect(){await this.whenIpcReady;const p=(0,n.assertIsDefined)(this.window);return(0,f.connect)(p)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};m=he([te(2,w.IEnvironmentMainService),te(3,t.ILifecycleMainService),te(4,P.ILogService),te(5,d.IThemeMainService),te(6,v.IProtocolMainService)],m),e.SharedProcess=m}),define(Z[226],x([0,1,9,18,8,13,7,23,20,6]),function(K,e,y,L,k,M,E,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class t{constructor(v,d,m){this.storagePath=v,this.logService=d,this.fileService=m,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new y.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(v){v.fileOperationResult!==1&&this.logService.error(v)}}getItem(v,d){const m=this.storage[v];return(0,M.isUndefinedOrNull)(m)?d:m}setItem(v,d){this.setItems([{key:v,data:d}])}setItems(v){let d=!1;for(const{key:m,data:I}of v)this.storage[m]!==I&&((0,M.isUndefinedOrNull)(I)?(0,M.isUndefined)(this.storage[m])||(this.storage[m]=void 0,d=!0):(this.storage[m]=I,d=!0));d&&this.save()}removeItem(v){(0,M.isUndefined)(this.storage[v])||(this.storage[v]=void 0,this.save())}async save(v){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),v)}async doSave(){if(!this.initializing)return;await this.initializing;const v=JSON.stringify(this.storage,null,4);if(v!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(v)),this.lastSavedStorageContents=v}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=t;let P=class yt{constructor(v,d,m){this.fileStorage=new t(E.URI.file((0,k.join)(v.userDataPath,yt.STATE_FILE)),d,m)}async init(){return this.fileStorage.init()}getItem(v,d){return this.fileStorage.getItem(v,d)}setItem(v,d){this.fileStorage.setItem(v,d)}setItems(v){this.fileStorage.setItems(v)}removeItem(v){this.fileStorage.removeItem(v)}close(){return this.fileStorage.close()}};P.STATE_FILE="storage.json",P=he([te(0,n.IEnvironmentMainService),te(1,w.ILogService),te(2,f.IFileService)],P),e.StateMainService=P}),define(Z[76],x([0,1,9,24,4,16,23,22,6,21,50,42]),function(K,e,y,L,k,M,E,n,f,w,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(d,m,I){return`${I.updateUrl}/api/update/${d}/${m}/${I.commit}`}e.createUpdateURL=b;let v=class{constructor(m,I,p,u,h,o){this.lifecycleMainService=m,this.configurationService=I,this.environmentMainService=p,this.requestService=u,this.logService=h,this.productService=o,this._state=P.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const m=(0,M.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),I=this.getProductQuality(m);if(!I){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(I),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(P.State.Idle(this.getUpdateType())),m==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}getProductQuality(m){return m==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(m=60*60*1e3){return(0,y.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(m){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},L.CancellationToken.None).then(m=>m.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};v=he([te(0,n.ILifecycleMainService),te(1,M.IConfigurationService),te(2,E.IEnvironmentMainService),te(3,t.IRequestService),te(4,f.ILogService),te(5,w.IProductService)],v),e.AbstractUpdateService=v}),define(Z[227],x([0,1,14,47,4,2,16,23,22,6,21,50,34,42,76]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends d.AbstractUpdateService{constructor(p,u,h,o,c,i,a){super(p,u,o,c,i,a);this.telemetryService=h,this.disposables=new M.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(y.autoUpdater,"error",(p,u)=>u)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(y.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(y.autoUpdater,"update-available",(p,u,h)=>({url:u,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(y.autoUpdater,"update-downloaded",(p,u,h,o)=>({releaseNotes:u,version:h,productVersion:h,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(p){this.logService.error("UpdateService error:",p);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?p:void 0;this.setState(v.State.Idle(1,h))}buildUpdateFeedUrl(p){let u;this.productService.darwinUniversalAssetId?u=this.productService.darwinUniversalAssetId:u=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,d.createUpdateURL)(u,p,this.productService);try{y.autoUpdater.setFeedURL({url:h})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return h}doCheckForUpdates(p){this.setState(v.State.CheckingForUpdates(p)),y.autoUpdater.checkForUpdates()}onUpdateAvailable(p){this.state.type==="checking for updates"&&this.setState(v.State.Downloading(p))}onUpdateDownloaded(p){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:p.version}),this.setState(v.State.Ready(p)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(v.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),y.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([L.memoize],m.prototype,"onRawError",null),he([L.memoize],m.prototype,"onRawUpdateNotAvailable",null),he([L.memoize],m.prototype,"onRawUpdateAvailable",null),he([L.memoize],m.prototype,"onRawUpdateDownloaded",null),m=he([te(0,f.ILifecycleMainService),te(1,E.IConfigurationService),te(2,b.ITelemetryService),te(3,n.IEnvironmentMainService),te(4,P.IRequestService),te(5,w.ILogService),te(6,t.IProductService)],m),e.DarwinUpdateService=m}),define(Z[228],x([0,1,41,30,9,4,8,23,22,6,34,42]),function(K,e,y,L,k,M,E,n,f,w,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{constructor(m,I,p){if(this.lifecycleMainService=m,this.logService=p,this._state=P.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,I.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(P.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,u=>this.logService.error(u))}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}scheduleCheckForUpdates(m=60*60*1e3){return(0,k.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(m){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};b=he([te(0,f.ILifecycleMainService),te(1,n.IEnvironmentMainService),te(2,w.ILogService)],b);let v=class extends b{constructor(m,I,p,u,h,o){super(p,u,h);this.snap=m,this.snapRevision=I,this.telemetryService=o;const c=(0,L.watch)(E.dirname(this.snap)),i=M.Event.fromNodeEventEmitter(c,"change",(l,g)=>g),a=M.Event.filter(i,l=>l==="current"),s=M.Event.debounce(a,(l,g)=>g,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{s.dispose(),c.close()})}doCheckForUpdates(){this.setState(P.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(m=>{m?this.setState(P.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2)))},m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2,m.message||m))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,y.spawn)("sleep 3 && "+E.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const m=await new Promise((p,u)=>(0,L.realpath)(`${E.dirname(this.snap)}/current`,(h,o)=>h?u(h):p(o))),I=E.basename(m);return this.snapRevision!==I}isLatestVersion(){return this.isUpdateAvailable().then(void 0,m=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};v=he([te(2,f.ILifecycleMainService),te(3,n.IEnvironmentMainService),te(4,w.ILogService),te(5,t.ITelemetryService)],v),e.SnapUpdateService=v}),define(Z[46],x([0,1,14,30,4,40,33,2,10,8,3,15,13,19,153,51,52,23,5,6,21,99,27,100]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m,I,p,u,h,o,c,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,u.createDecorator)("workspacesManagementMainService");let r=class extends n.Disposable{constructor(l,g,S,D,A){super();this.environmentMainService=l,this.logService=g,this.backupMainService=S,this.dialogMainService=D,this.productService=A,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(l){return this.doResolveLocalWorkspace(l,g=>(0,L.readFileSync)(g,"utf8"))}resolveLocalWorkspace(l){return this.doResolveLocalWorkspace(l,g=>v.Promises.readFile(g,"utf8"))}doResolveLocalWorkspace(l,g){if(!!this.isWorkspacePath(l)&&l.scheme===f.Schemas.file)try{const S=g(l.fsPath);return S instanceof Promise?S.then(D=>this.doResolveWorkspace(l,D),D=>{}):this.doResolveWorkspace(l,S)}catch{return}}isWorkspacePath(l){return(0,i.isUntitledWorkspace)(l,this.environmentMainService)||(0,i.hasWorkspaceFileExtension)(l)}doResolveWorkspace(l,g){try{const S=this.doParseStoredWorkspace(l,g),D=(0,a.getWorkspaceIdentifier)(l);return{id:D.id,configPath:D.configPath,folders:(0,i.toWorkspaceFolders)(S.folders,D.configPath,P.extUriBiasedIgnorePathCase),remoteAuthority:S.remoteAuthority,transient:S.transient}}catch(S){this.logService.warn(S.toString())}}doParseStoredWorkspace(l,g){const S=(0,M.parse)(g);if(S&&Array.isArray(S.folders))S.folders=S.folders.filter(D=>(0,i.isStoredWorkspaceFolder)(D));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return S}async createUntitledWorkspace(l,g){const{workspace:S,storedWorkspace:D}=this.newUntitledWorkspace(l,g),A=S.configPath.fsPath;return await v.Promises.mkdir((0,w.dirname)(A),{recursive:!0}),await v.Promises.writeFile(A,JSON.stringify(D,null,"	")),S}createUntitledWorkspaceSync(l,g){const{workspace:S,storedWorkspace:D}=this.newUntitledWorkspace(l,g),A=S.configPath.fsPath;return(0,L.mkdirSync)((0,w.dirname)(A),{recursive:!0}),(0,v.writeFileSync)(A,JSON.stringify(D,null,"	")),S}newUntitledWorkspace(l=[],g){const S=(Date.now()+Math.round(Math.random()*1e3)).toString(),D=(0,P.joinPath)(this.untitledWorkspacesHome,S),A=(0,P.joinPath)(D,i.UNTITLED_WORKSPACE_NAME),F=[];for(const U of l)F.push((0,i.getStoredWorkspaceFolder)(U.uri,!0,U.name,D,!t.isWindows,P.extUriBiasedIgnorePathCase));return{workspace:(0,a.getWorkspaceIdentifier)(A),storedWorkspace:{folders:F,remoteAuthority:g}}}async getWorkspaceIdentifier(l){return(0,a.getWorkspaceIdentifier)(l)}isUntitledWorkspace(l){return(0,i.isUntitledWorkspace)(l.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(l){!this.isUntitledWorkspace(l)||(this.doDeleteUntitledWorkspaceSync(l),this._onDidDeleteUntitledWorkspace.fire(l))}async deleteUntitledWorkspace(l){this.deleteUntitledWorkspaceSync(l)}doDeleteUntitledWorkspaceSync(l){const g=(0,P.originalFSPath)(l.configPath);try{(0,v.rimrafSync)((0,w.dirname)(g));const S=(0,w.join)(this.environmentMainService.workspaceStorageHome.fsPath,l.id);(0,L.existsSync)(S)&&(0,v.writeFileSync)((0,w.join)(S,"obsolete"),"")}catch(S){this.logService.warn(`Unable to delete untitled workspace ${g} (${S}).`)}}getUntitledWorkspacesSync(){const l=[];try{const g=(0,v.readdirSync)(this.untitledWorkspacesHome.fsPath).map(S=>(0,P.joinPath)(this.untitledWorkspacesHome,S,i.UNTITLED_WORKSPACE_NAME));for(const S of g){const D=(0,a.getWorkspaceIdentifier)(S),A=this.resolveLocalWorkspaceSync(S);A?l.push({workspace:D,remoteAuthority:A.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(D)}}catch(g){g.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${g}).`)}return l}async enterWorkspace(l,g,S){if(!l||!l.win||!l.isReady||!await this.isValidTargetWorkspacePath(l,g,S))return;const A=this.doEnterWorkspace(l,(0,a.getWorkspaceIdentifier)(S));if(!!A)return this._onDidEnterWorkspace.fire({window:l,workspace:A.workspace}),A}async isValidTargetWorkspacePath(l,g,S){if(!S)return!0;if((0,i.isWorkspaceIdentifier)(l.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(l.openedWorkspace.configPath,S))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(g,S)){const D={title:this.productService.nameLong,type:"info",buttons:[(0,E.mnemonicButtonLabel)((0,d.localize)(0,null))],message:(0,d.localize)(1,null,(0,P.basename)(S)),detail:(0,d.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(D,(0,b.withNullAsUndefined)(y.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(l,g){if(!l.config)return;l.focus();let S;return l.config.extensionDevelopmentPath||(S=this.backupMainService.registerWorkspaceBackupSync({workspace:g,remoteAuthority:l.remoteAuthority},l.config.backupPath)),(0,i.isWorkspaceIdentifier)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&this.deleteUntitledWorkspaceSync(l.openedWorkspace),l.config.workspace=g,l.config.backupPath=S,{workspace:g,backupPath:S}}};r=he([te(0,p.IEnvironmentMainService),te(1,h.ILogService),te(2,m.IBackupMainService),te(3,I.IDialogMainService),te(4,o.IProductService)],r),e.WorkspacesManagementMainService=r}),define(Z[101],x([0,1,14,31,24,3,13,7,19,16,54,5,6,97,36,27,46]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,P.createDecorator)(e.ID);let p=class{constructor(h,o,c,i,a){this.logService=h,this.windowsMainService=o,this.urlService=c,this.workspacesManagementMainService=i,this.configurationService=a}async start(h,o){this.logService.trace("Received data from other instance: ",h,o),M.isMacintosh&&y.app.focus({steal:!0});const c=this.parseOpenUrl(h);if(c.length){let i=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(i=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),i.then(()=>{for(const{uri:a,url:r}of c)this.urlService.open(a,{originalUrl:r})})}else return this.startOpenWindow(h,o)}parseOpenUrl(h){return h["open-url"]&&h._urls&&h._urls.length>0?(0,L.coalesce)(h._urls.map(o=>{try{return{uri:n.URI.parse(o),url:o}}catch(c){return null}})):[]}async startOpenWindow(h,o){const c=(0,t.isLaunchedFromCli)(o)?0:4;let i=[];const a=h.wait&&h.waitMarkerFilePath?n.URI.file(h.waitMarkerFilePath):void 0,r=h.remote||void 0;if(h.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(h.extensionDevelopmentPath,{context:c,cli:h,userEnv:o,waitMarkerFileURI:a,remoteAuthority:r});else if(!h._.length&&!h["folder-uri"]&&!h["file-uri"]){let s=!1;if(h["new-window"]||h["unity-launch"])s=!0;else if(h["reuse-window"])s=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":s=!0;break;case"off":s=!1;break;default:s=!M.isMacintosh}if(s)i=this.windowsMainService.open({context:c,cli:h,userEnv:o,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:a,remoteAuthority:r});else{const l=this.windowsMainService.getLastActiveWindow();l?(l.focus(),i=[l]):i=this.windowsMainService.open({context:c,cli:h,forceEmpty:!0,remoteAuthority:r})}}else i=this.windowsMainService.open({context:c,cli:h,userEnv:o,forceNewWindow:h["new-window"],preferNewWindow:!h["reuse-window"]&&!h.wait,forceReuseWindow:h["reuse-window"],diffMode:h.diff,addMode:h.add,noRecentEntry:!!h["skip-add-to-recently-opened"],waitMarkerFileURI:a,gotoLineMode:h.goto,remoteAuthority:r});if(a&&i.length===1&&i[0])return Promise.race([i[0].whenClosedOrLoaded,(0,f.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const h=[];return y.BrowserWindow.getAllWindows().forEach(o=>{const c=this.windowsMainService.getWindowById(o.id);c?h.push(this.codeWindowToInfo(c)):h.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!y.app.accessibilitySupportEnabled,gpuFeatureStatus:y.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(h){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(i=>new Promise(a=>{const r=i.remoteAuthority;if(r){const s=`vscode:getDiagnosticInfoResponse${i.id}`,l={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?this.getFolderURIs(i):void 0};i.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:s,args:l}),y.ipcMain.once(s,(g,S)=>{S||a({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),a(S)}),setTimeout(()=>{a({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else a(void 0)})))).filter(i=>!!i)}getFolderURIs(h){const o=[],c=h.openedWorkspace;if((0,m.isSingleFolderWorkspaceIdentifier)(c))o.push(c.uri);else if((0,m.isWorkspaceIdentifier)(c)){const i=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);i&&i.folders.forEach(r=>{o.push(r.uri)})}return o}codeWindowToInfo(h){const o=this.getFolderURIs(h),c=(0,E.assertIsDefined)(h.win);return this.browserWindowToInfo(c,o,h.remoteAuthority)}browserWindowToInfo(h,o=[],c){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:o,remoteAuthority:c}}};p=he([te(0,b.ILogService),te(1,d.IWindowsMainService),te(2,v.IURLService),te(3,I.IWorkspacesManagementMainService),te(4,w.IConfigurationService)],p),e.LaunchMainService=p}),define(Z[53],x([0,1,41,14,26,114,47,4,33,2,10,8,3,7,81,66,19,145,52,23,5,22,6,21,34,60,36,27,46]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m,I,p,u,h,o,c,i,a,r,s,l,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,o.createDecorator)("nativeHostMainService");let D=class ct extends w.Disposable{constructor(F,U,X,ne,se,G,J,W,V,B){super();this.sharedProcess=F,this.windowsMainService=U,this.dialogMainService=X,this.lifecycleMainService=ne,this.environmentMainService=se,this.telemetryService=G,this.logService=J,this.productService=W,this.themeMainService=V,this.workspacesManagementMainService=B,this.onDidOpenWindow=n.Event.map(this.windowsMainService.onDidOpenWindow,$=>$.id),this.onDidMaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",($,H)=>H.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidUnmaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",($,H)=>H.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidBlurWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-blur",($,H)=>H.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidFocusWindow=n.Event.any(n.Event.map(n.Event.filter(n.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),$=>!!$),$=>$.id),n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-focus",($,H)=>H.id),$=>!!this.windowsMainService.getWindowById($))),this.onDidResumeOS=n.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new n.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=n.Event.debounce(n.Event.any(n.Event.filter(n.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",($,H,_)=>_),$=>!(Array.isArray($)&&$.length===1&&$[0]==="workArea")),n.Event.fromNodeEventEmitter(L.screen,"display-added"),n.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace,title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(F){return this.windowsMainService.getWindowCount()}async getActiveWindowId(F){const U=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(U)return U.id}openWindow(F,U,X){return Array.isArray(U)?this.doOpenWindow(F,U,X):this.doOpenEmptyWindow(F,U)}async doOpenWindow(F,U,X=Object.create(null)){U.length>0&&this.windowsMainService.open({context:5,contextWindowId:F,urisToOpen:U,cli:this.environmentMainService.args,forceNewWindow:X.forceNewWindow,forceReuseWindow:X.forceReuseWindow,preferNewWindow:X.preferNewWindow,diffMode:X.diffMode,addMode:X.addMode,gotoLineMode:X.gotoLineMode,noRecentEntry:X.noRecentEntry,waitMarkerFileURI:X.waitMarkerFileURI,remoteAuthority:X.remoteAuthority||void 0})}async doOpenEmptyWindow(F,U){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:F},U)}async toggleFullScreen(F){const U=this.windowById(F);U&&U.toggleFullScreen()}async handleTitleDoubleClick(F){const U=this.windowById(F);U&&U.handleTitleDoubleClick()}async isMaximized(F){const U=this.windowById(F);return U?.win?U.win.isMaximized():!1}async maximizeWindow(F){const U=this.windowById(F);U?.win&&U.win.maximize()}async unmaximizeWindow(F){const U=this.windowById(F);U?.win&&U.win.unmaximize()}async minimizeWindow(F){const U=this.windowById(F);U?.win&&U.win.minimize()}async focusWindow(F,U){U&&typeof U.windowId=="number"&&(F=U.windowId);const X=this.windowById(F);X&&X.focus({force:U?.force??!1})}async setMinimumSize(F,U,X){const ne=this.windowById(F);if(ne?.win){const[se,G]=ne.win.getSize(),[J,W]=ne.win.getMinimumSize(),[V,B]=[U??J,X??W],[$,H]=[Math.max(se,V),Math.max(G,B)];(J!==V||W!==B)&&ne.win.setMinimumSize(V,B),(se!==$||G!==H)&&ne.win.setSize($,H)}}async saveWindowSplash(F,U){this.themeMainService.saveWindowSplash(F,U)}async installShellCommand(F){const{source:U,target:X}=await this.getShellCommandLink();try{const{symbolicLink:ne}=await I.SymlinkSupport.stat(U);if(ne&&!ne.dangling){const se=await(0,d.realpath)(U);if(X===se)return}await I.Promises.unlink(U)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await I.Promises.symlink(X,U)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:se}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,p.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,p.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,p.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const G=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${X}' '${U}'\\" with administrator privileges"`;await(0,M.promisify)(y.exec)(G)}catch(G){throw new Error((0,p.localize)(3,null,U))}}}async uninstallShellCommand(F){const{source:U}=await this.getShellCommandLink();try{await I.Promises.unlink(U)}catch(X){switch(X.code){case"EACCES":const{response:ne}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,p.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,p.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,p.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ne===0)try{const se=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,M.promisify)(y.exec)(se)}catch(se){throw new Error((0,p.localize)(7,null,U))}break;case"ENOENT":break;default:throw X}}}async getShellCommandLink(){const F=(0,P.resolve)(this.environmentMainService.appRoot,"bin","code"),U=`/usr/local/bin/${this.productService.applicationName}`;if(!await I.Promises.exists(F))throw new Error((0,p.localize)(8,null,F));return{source:U,target:F}}async showMessageBox(F,U){return this.dialogMainService.showMessageBox(U,this.toBrowserWindow(F))}async showSaveDialog(F,U){return this.dialogMainService.showSaveDialog(U,this.toBrowserWindow(F))}async showOpenDialog(F,U){return this.dialogMainService.showOpenDialog(U,this.toBrowserWindow(F))}toBrowserWindow(F){const U=this.windowById(F);if(U?.win)return U.win}async pickFileFolderAndOpen(F,U){const X=await this.dialogMainService.pickFileFolder(U);X&&(this.sendPickerTelemetry(X,U.telemetryEventName||"openFileFolder",U.telemetryExtraData),this.doOpenPicked(await Promise.all(X.map(async ne=>await I.SymlinkSupport.existsDirectory(ne)?{folderUri:v.URI.file(ne)}:{fileUri:v.URI.file(ne)})),U,F))}async pickFolderAndOpen(F,U){const X=await this.dialogMainService.pickFolder(U);X&&(this.sendPickerTelemetry(X,U.telemetryEventName||"openFolder",U.telemetryExtraData),this.doOpenPicked(X.map(ne=>({folderUri:v.URI.file(ne)})),U,F))}async pickFileAndOpen(F,U){const X=await this.dialogMainService.pickFile(U);X&&(this.sendPickerTelemetry(X,U.telemetryEventName||"openFile",U.telemetryExtraData),this.doOpenPicked(X.map(ne=>({fileUri:v.URI.file(ne)})),U,F))}async pickWorkspaceAndOpen(F,U){const X=await this.dialogMainService.pickWorkspace(U);X&&(this.sendPickerTelemetry(X,U.telemetryEventName||"openWorkspace",U.telemetryExtraData),this.doOpenPicked(X.map(ne=>({workspaceUri:v.URI.file(ne)})),U,F))}doOpenPicked(F,U,X){this.windowsMainService.open({context:3,contextWindowId:X,cli:this.environmentMainService.args,urisToOpen:F,forceNewWindow:U.forceNewWindow})}sendPickerTelemetry(F,U,X){const ne=F?F.length:0;this.telemetryService.publicLog(U,{...X,outcome:ne?"success":"canceled",numberOfPaths:ne})}async showItemInFolder(F,U){L.shell.showItemInFolder(U)}async setRepresentedFilename(F,U){const X=this.windowById(F);X&&X.setRepresentedFilename(U)}async setDocumentEdited(F,U){const X=this.windowById(F);X&&X.setDocumentEdited(U)}async openExternal(F,U){return b.isLinuxSnap?this.safeSnapOpenExternal(U):L.shell.openExternal(U),!0}safeSnapOpenExternal(F){const U=process.env.GDK_PIXBUF_MODULE_FILE,X=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(F),process.env.GDK_PIXBUF_MODULE_FILE=U,process.env.GDK_PIXBUF_MODULEDIR=X}moveItemToTrash(F,U){return L.shell.trashItem(U)}async isAdmin(){let F;return b.isWindows?F=(await new Promise((U,X)=>{K(["native-is-elevated"],U,X)}))():F=process.getuid()===0,F}async writeElevated(F,U,X,ne){const se=await new Promise((G,J)=>{K(["sudo-prompt"],G,J)});return new Promise((G,J)=>{const W=[`"${this.cliPath}"`];ne?.unlock&&W.push("--file-chmod"),W.push("--file-write",`"${U.fsPath}"`,`"${X.fsPath}"`);const V={name:this.productService.nameLong.replace("-",""),icns:b.isMacintosh&&this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(W.join(" "),V,(B,$,H)=>{$&&this.logService.trace(`[sudo-prompt] received stdout: ${$}`),H&&this.logService.trace(`[sudo-prompt] received stderr: ${H}`),B?J(B):G(void 0)})})}get cliPath(){return b.isWindows?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):b.isLinux?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,P.join)(this.environmentMainService.appRoot,"bin","code"):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return m.virtualMachineHint.value()}async killProcess(F,U,X){process.kill(U,X)}async readClipboardText(F,U){return L.clipboard.readText(U)}async writeClipboardText(F,U,X){return L.clipboard.writeText(U,X)}async readClipboardFindText(F){return L.clipboard.readFindText()}async writeClipboardFindText(F,U){return L.clipboard.writeFindText(U)}async writeClipboardBuffer(F,U,X,ne){return L.clipboard.writeBuffer(U,Buffer.from(X),ne)}async readClipboardBuffer(F,U){return L.clipboard.readBuffer(U)}async hasClipboard(F,U,X){return L.clipboard.has(U,X)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,U){const X=this.windowById(F);X&&X.updateTouchBar(U)}async notifyReady(F){const U=this.windowById(F);U&&U.setReady()}async relaunch(F,U){return this.lifecycleMainService.relaunch(U)}async reload(F,U){const X=this.windowById(F);if(X){if((0,g.isWorkspaceIdentifier)(X.openedWorkspace)){const ne=X.openedWorkspace.configPath;if(ne.scheme===t.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ne))?.transient)return this.openWindow(X.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(X,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(F){this.closeWindowById(F,F)}async closeWindowById(F,U){const X=this.windowById(U);if(X?.win)return X.win.close()}async quit(F){const U=this.windowsMainService.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&U.win?U.win.close():this.lifecycleMainService.quit()}async exit(F,U){await this.lifecycleMainService.kill(U)}async resolveProxy(F,U){const ne=this.windowById(F)?.win?.webContents?.session;if(ne)return ne.resolveProxy(U)}async openDevTools(F,U){const X=this.windowById(F);X?.win&&X.win.webContents.openDevTools(U)}async toggleDevTools(F){const U=this.windowById(F);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(F,U){const X=this.windowById(F);X?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&X.win.webContents.sendInputEvent(U)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(F,U,X,ne){if(!b.isWindows)return;const se=await new Promise((G,J)=>{K(["vscode-windows-registry"],G,J)});try{return se.GetStringRegKey(U,X,ne)}catch{return}}async getPassword(F,U,X){const ne=await this.withKeytar(),se=await ne.getPassword(U,X);if(se)try{let{content:G,hasNextChunk:J}=JSON.parse(se);if(!G||!J)return se;let W=1;for(;J;){const V=await ne.getPassword(U,`${X}-${W}`),B=JSON.parse(V);G+=B.content,J=B.hasNextChunk,W++}return G}catch{return se}return se}async setPassword(F,U,X,ne){const se=await this.withKeytar(),G=3,J=async(W,V,B)=>{let $=0,H;for(;$<G;)try{await se.setPassword(W,V,B);return}catch(_){H=_,this.logService.warn("Error attempting to set a password: ",_),$++,await new Promise(j=>setTimeout(j,200))}throw H};if(b.isWindows&&ne.length>ct.MAX_PASSWORD_LENGTH){let W=0,V=0,B=!0;for(;B;){const $=ne.substring(W,W+ct.PASSWORD_CHUNK_SIZE);W+=ct.PASSWORD_CHUNK_SIZE,B=ne.length-W>0;const H={content:$,hasNextChunk:B};await J(U,V?`${X}-${V}`:X,JSON.stringify(H)),V++}}else await J(U,X,ne);this._onDidChangePassword.fire({service:U,account:X})}async deletePassword(F,U,X){const se=await(await this.withKeytar()).deletePassword(U,X);return se&&this._onDidChangePassword.fire({service:U,account:X}),se}async findPassword(F,U){return(await this.withKeytar()).findPassword(U)}async findCredentials(F,U){return(await this.withKeytar()).findCredentials(U)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((F,U)=>{K(["keytar"],F,U)})}windowById(F){if(typeof F=="number")return this.windowsMainService.getWindowById(F)}};D.MAX_PASSWORD_LENGTH=2500,D.PASSWORD_CHUNK_SIZE=D.MAX_PASSWORD_LENGTH-100,he([E.memoize],D.prototype,"cliPath",null),D=he([te(1,l.IWindowsMainService),te(2,u.IDialogMainService),te(3,c.ILifecycleMainService),te(4,h.IEnvironmentMainService),te(5,r.ITelemetryService),te(6,i.ILogService),te(7,a.IProductService),te(8,s.IThemeMainService),te(9,S.IWorkspacesManagementMainService)],D),e.NativeHostMainService=D}),define(Z[229],x([0,1,14,24,4,79,2,28,88,6,53,21,36]),function(K,e,y,L,k,M,E,n,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var v;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let d=class extends E.Disposable{constructor(I,p,u,h,o){super();this.logService=I,this.windowsMainService=p,this.nativeHostMainService=u,this.encryptionMainService=h,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=v.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const I=k.Event.fromNodeEventEmitter(y.app,"login",(p,u,h,o,c)=>({event:p,webContents:u,req:h,authInfo:o,callback:c}));this._register(I(this.onLogin,this))}async onLogin({event:I,authInfo:p,req:u,callback:h}){if(!p.isProxy)return;if(!this.pendingProxyResolve&&this.state===v.LoginDialogShown&&u.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}I.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(o?.username,o?.password)}async resolveProxyCredentials(I){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(I);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(I){this.logService.trace("auth#doResolveProxyCredentials - enter",I);const p=String((0,M.hash)({scheme:I.scheme,host:I.host,port:I.port}));let u,h;try{const a=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,p);if(a){const r=JSON.parse(await this.encryptionMainService.decrypt(a));u=r.username,h=r.password}}catch(a){this.logService.error(a)}if(this.state!==v.StoredCredentialsUsed&&typeof u=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=v.StoredCredentialsUsed,{username:u,password:h};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const c={authInfo:I,username:this.sessionCredentials?.username??u,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,c),this.state=v.LoginDialogShown;const i=await new Promise(a=>{const r=async(s,l,g)=>{if(l===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),o.win?.webContents.off("ipc-message",r),g){const S={username:g.username,password:g.password};try{if(g.remember){const D=await this.encryptionMainService.encrypt(JSON.stringify(S));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,p,D)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,p)}catch(D){this.logService.error(D)}a({username:S.username,password:S.password})}else a(void 0)};o.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=i,i}};d=he([te(0,w.ILogService),te(1,b.IWindowsMainService),te(2,t.INativeHostMainService),te(3,f.IEncryptionMainService),te(4,P.IProductService)],d),e.ProxyAuthHandler=d}),define(Z[230],x([0,1,14,26,33,2,10,3,82,143,70,52,23,5,101,6,53,45,21,55,61]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m,I,p,u,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,v.createDecorator)("issueMainService");let c=class St{constructor(a,r,s,l,g,S,D,A,F){this.userEnv=a,this.environmentMainService=r,this.launchMainService=s,this.logService=l,this.diagnosticsService=g,this.dialogMainService=S,this.nativeHostMainService=D,this.protocolMainService=A,this.productService=F,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){y.ipcMain.on("vscode:issueSystemInfoRequest",async a=>{const[r,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(r,s);this.safeSend(a,"vscode:issueSystemInfoResponse",l)}),y.ipcMain.on("vscode:listProcesses",async a=>{const r=[];try{const s=await this.launchMainService.getMainProcessId();r.push({name:(0,w.localize)(0,null),rootProcess:await(0,f.listProcesses)(s)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(g=>{(0,t.isRemoteDiagnosticError)(g)?r.push({name:g.hostName,rootProcess:g}):g.processes&&r.push({name:g.hostName,rootProcess:g.processes})})}catch(s){this.logService.error(`Listing processes failed: ${s}`)}this.safeSend(a,"vscode:listProcessesResponse",r)}),y.ipcMain.on("vscode:issueReporterClipboard",async a=>{const r={title:this.productService.nameLong,message:(0,w.localize)(1,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(2,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const s=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(a,"vscode:issueReporterClipboardResponse",s.response===0)}}),y.ipcMain.on("vscode:issuePerformanceInfoRequest",async a=>{const r=await this.getPerformanceInfo();this.safeSend(a,"vscode:issuePerformanceInfoResponse",r)}),y.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const a={title:this.productService.nameLong,message:(0,w.localize)(4,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(5,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(a,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),y.ipcMain.on("vscode:workbenchCommand",(a,r)=>{const{id:s,from:l,args:g}=r;let S;switch(l){case"issueReporter":S=this.issueReporterParentWindow;break;case"processExplorer":S=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}S&&S.webContents.send("vscode:runAction",{id:s,from:l,args:g})}),y.ipcMain.on("vscode:openExternal",(a,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),y.ipcMain.on("vscode:closeIssueReporter",a=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),y.ipcMain.on("vscode:closeProcessExplorer",a=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),y.ipcMain.on("vscode:windowsInfoRequest",async a=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(a,"vscode:windowsInfoResponse",r.windows)})}safeSend(a,r,...s){a.sender.isDestroyed()||a.sender.send(r,...s)}async openReporter(a){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=y.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new M.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,s,{backgroundColor:a.styles.backgroundColor,title:(0,w.localize)(7,null),zoomLevel:a.zoomLevel,alwaysOnTop:!1}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:a,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:p.default}),this.issueReporterWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",K).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(a){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=y.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new M.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,s,{backgroundColor:a.styles.backgroundColor,title:(0,w.localize)(8,null),zoomLevel:a.zoomLevel,alwaysOnTop:!0}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:a,product:p.default}),this.processExplorerWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",K).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(a,r,s){const l=new y.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:a.width,height:a.height,minWidth:300,minHeight:200,x:a.x,y:a.y,title:s.title,backgroundColor:s.backgroundColor||St.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,o.zoomLevelToZoomFactor)(s.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:s.alwaysOnTop});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[a,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(a,r)}getWindowPosition(a,r,s){let l;const g=y.screen.getAllDisplays();if(g.length===1)l=g[0];else{if(n.isMacintosh){const A=y.screen.getCursorScreenPoint();l=y.screen.getDisplayNearestPoint(A)}!l&&a&&(l=y.screen.getDisplayMatching(a.getBounds())),l||(l=y.screen.getPrimaryDisplay()||g[0])}const S={width:r,height:s},D=l.bounds;return S.x=D.x+D.width/2-S.width/2,S.y=D.y+D.height/2-S.height/2,D.width>0&&D.height>0&&(S.x<D.x&&(S.x=D.x),S.y<D.y&&(S.y=D.y),S.x>D.x+D.width&&(S.x=D.x),S.y>D.y+D.height&&(S.y=D.y),S.width>D.width&&(S.width=D.width),S.height>D.height&&(S.height=D.height)),S}async getPerformanceInfo(){try{const[a,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(a,r)}catch(a){throw this.logService.warn("issueService#getPerformanceInfo ",a.message),a}}};c.DEFAULT_BACKGROUND_COLOR="#1E1E1E",c=he([te(1,b.IEnvironmentMainService),te(2,d.ILaunchMainService),te(3,m.ILogService),te(4,t.IDiagnosticsService),te(5,P.IDialogMainService),te(6,I.INativeHostMainService),te(7,h.IProtocolMainService),te(8,u.IProductService)],c),e.IssueMainService=c}),define(Z[231],x([0,1,24,16,23,22,6,53,21,50,34,42,76]),function(K,e,y,L,k,M,E,n,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let v=class extends b.AbstractUpdateService{constructor(m,I,p,u,h,o,c,i){super(m,I,u,h,o,i);this.telemetryService=p,this.nativeHostMainService=c}buildUpdateFeedUrl(m){return(0,b.createUpdateURL)(`linux-${process.arch}`,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(P.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},y.CancellationToken.None).then(w.asJson).then(I=>{!I||!I.url||!I.version||!I.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(P.State.Idle(1))):this.setState(P.State.AvailableForDownload(I))}).then(void 0,I=>{this.logService.error(I),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const p=m?I.message||I:void 0;this.setState(P.State.Idle(1,p))}))}async doDownloadUpdate(m){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(P.State.Idle(1))}};v=he([te(0,M.ILifecycleMainService),te(1,L.IConfigurationService),te(2,t.ITelemetryService),te(3,k.IEnvironmentMainService),te(4,w.IRequestService),te(5,E.ILogService),te(6,n.INativeHostMainService),te(7,f.IProductService)],v),e.LinuxUpdateService=v}),define(Z[232],x([0,1,41,30,26,9,24,47,8,7,112,19,16,23,20,22,6,53,21,50,34,42,76]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m,I,p,u,h,o,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(g,S=1e3){for(;!g();)await(0,M.timeout)(S)}let r;function s(){return typeof r=="undefined"&&(r=L.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),r}let l=class extends i.AbstractUpdateService{constructor(S,D,A,F,U,X,ne,se,G){super(S,D,F,U,X,G);this.telemetryService=A,this.fileService=ne,this.nativeHostMainService=se}get cachePath(){const S=f.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return P.Promises.mkdir(S,{recursive:!0}).then(()=>S)}initialize(){super.initialize(),s()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(S){let D="win32";return process.arch!=="ia32"&&(D+=`-${process.arch}`),s()===1?D+="-archive":this.productService.target==="user"&&(D+="-user"),(0,i.createUpdateURL)(D,S,this.productService)}doCheckForUpdates(S){!this.url||(this.setState(c.State.CheckingForUpdates(S)),this.requestService.request({url:this.url},E.CancellationToken.None).then(h.asJson).then(D=>{const A=s();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S}),this.setState(c.State.Idle(A)),Promise.resolve(null)):A===1?(this.setState(c.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(c.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(F=>P.Promises.exists(F).then(U=>{if(U)return Promise.resolve(F);const X=D.url,ne=D.hash,se=`${F}.tmp`;return this.requestService.request({url:X},E.CancellationToken.None).then(G=>this.fileService.writeFile(w.URI.file(se),G.stream)).then(ne?()=>(0,t.checksum)(se,D.hash):()=>{}).then(()=>P.Promises.rename(se,F)).then(()=>F)})).then(F=>{const U=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:F},U&&D.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(D)):this.setState(c.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S});const A=S?D.message||D:void 0;this.setState(c.State.Idle(s(),A))}))}async doDownloadUpdate(S){S.update.url&&this.nativeHostMainService.openExternal(void 0,S.update.url),this.setState(c.State.Idle(s()))}async getUpdatePackagePath(S){const D=await this.cachePath;return f.join(D,`CodeSetup-${this.productService.quality}-${S}.exe`)}async cleanup(S=null){const D=S?X=>!new RegExp(`${this.productService.quality}-${S}\\.exe$`).test(X):()=>!0,A=await this.cachePath,U=(await P.Promises.readdir(A)).filter(D).map(async X=>{try{await P.Promises.unlink(f.join(A,X))}catch(ne){}});await Promise.all(U)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const S=this.state.update;this.setState(c.State.Updating(S));const D=await this.cachePath;this.availableUpdate.updateFilePath=f.join(D,`CodeSetup-${this.productService.quality}-${S.version}.flag`),await P.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,y.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(s()))});const F=`${this.productService.win32MutexName}-ready`,U=await new Promise((X,ne)=>{K(["windows-mutex"],X,ne)});a(()=>U.isActive(F)).then(()=>this.setState(c.State.Ready(S)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,y.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return s()}};he([n.memoize],l.prototype,"cachePath",null),l=he([te(0,m.ILifecycleMainService),te(1,b.IConfigurationService),te(2,o.ITelemetryService),te(3,v.IEnvironmentMainService),te(4,h.IRequestService),te(5,I.ILogService),te(6,d.IFileService),te(7,p.INativeHostMainService),te(8,u.IProductService)],l),e.Win32UpdateService=l}),define(Z[233],x([0,1,14,9,24,4,33,2,10,8,72,3,7,149,51,16,52,23,54,201,20,22,6,21,55,98,34,203,60,61,36,27,46]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m,I,p,u,h,o,c,i,a,r,s,l,g,S,D,A,F,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var X;(function(se){se[se.NONE=0]="NONE",se[se.LOADING=1]="LOADING",se[se.NAVIGATING=2]="NAVIGATING",se[se.READY=3]="READY"})(X||(X={}));let ne=class extends n.Disposable{constructor(G,J,W,V,B,$,H,_,j,T,R,O,z,N){super();this.logService=J,this.environmentMainService=W,this.fileService=V,this.configurationService=$,this.themeMainService=H,this.workspacesManagementMainService=_,this.backupMainService=j,this.telemetryService=T,this.dialogMainService=R,this.lifecycleMainService=O,this.productService=z,this.protocolMainService=N,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[C,q]=this.restoreWindowState(G.state);this.windowState=C,this.logService.trace("window#ctor: using window state",C);const Q=this.windowState.mode===0||this.windowState.mode===3,ie=this.configurationService.getValue("window"),oe={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!Q,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,D.zoomLevelToZoomFactor)(ie?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};P.isLinux?oe.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):P.isWindows&&!this.environmentMainService.isBuilt&&(oe.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),P.isMacintosh&&!this.useNativeFullScreen()&&(oe.fullscreenable=!1),P.isMacintosh&&(oe.acceptFirstMouse=!0,ie?.clickThroughInactive===!1&&(oe.acceptFirstMouse=!1));const ae=P.isMacintosh&&ie?.nativeTabs===!0;ae&&(oe.tabbingIdentifier=this.productService.nameShort);const ee=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(ee&&(oe.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,P.isMacintosh||(oe.frame=!1)),(0,t.mark)("code/willCreateCodeBrowserWindow"),this._win=new y.BrowserWindow(oe),(0,t.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),P.isMacintosh&&ee&&this._win.setSheetOffset(22),P.isMacintosh&&q&&(!ae||y.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(le=>typeof le=="number")){const le=this.windowState;this._win.setBounds({width:le.width,height:le.height,x:le.x,y:le.y})}Q&&((0,t.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,t.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,h.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:C=>B.globalStorage.get(C),store:(C,q)=>B.globalStorage.set(C,q)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(G){P.isMacintosh?this._win.setRepresentedFilename(G):this.representedFilename=G}getRepresentedFilename(){return P.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(G){P.isMacintosh&&this._win.setDocumentEdited(G),this.documentEdited=G}isDocumentEdited(){return P.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(G){P.isMacintosh&&G?.force&&y.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(G=>{if(this.isReady)return G(this);this.whenReadyCallbacks.push(G)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(G=>{function J(){W.dispose(),V.dispose(),G()}const W=this.onDidClose(()=>J()),V=this.onWillLoad(()=>J())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(B,$)=>this.onWindowError(2,$)),this._win.webContents.on("did-fail-load",(B,$,H)=>this.onWindowError(3,{reason:H,exitCode:$})),this._win.webContents.on("will-prevent-unload",B=>{B.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const G=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),J=B=>{for(let $=B;$;$=$.parent)if($.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},W=B=>B.resourceType==="xhr"||J(B.frame);this._win.webContents.session.webRequest.onBeforeRequest((B,$)=>{const H=b.URI.parse(B.url);return H.path.endsWith(".svg")&&!(G.has(H.scheme)||H.path.includes(f.Schemas.vscodeRemoteResource))?$({cancel:!W(B)}):$({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((B,$)=>{const H=B.responseHeaders,_=H["content-type"]||H["Content-Type"];if(_&&Array.isArray(_)){const j=b.URI.parse(B.url);if(j.path.endsWith(".svg")&&G.has(j.scheme))return H["Content-Type"]=["image/svg+xml"],$({cancel:!1,responseHeaders:H});if(!j.path.includes(f.Schemas.vscodeRemoteResource)&&_.some(T=>T.toLowerCase().includes("image/svg")))return $({cancel:!W(B)})}return $({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",B=>{this.currentConfig&&(this.currentConfig.maximized=!0),y.app.emit("browser-window-maximize",B,this._win)}),this._win.on("unmaximize",B=>{this.currentConfig&&(this.currentConfig.maximized=!1),y.app.emit("browser-window-unmaximize",B,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(B=>this.onDidDeleteUntitledWorkspace(B)));const V=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:V},async(B,$)=>{const H=await this.marketplaceHeadersPromise;$({cancel:!1,requestHeaders:Object.assign(B.requestHeaders,H)})})}async onWindowError(G,J){switch(G){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${J?.reason||"<unknown>"}, code: ${J?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${J?.reason||"<unknown>"}, code: ${J?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:G,reason:J?.reason,code:J?.exitCode}),G){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(G===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const W=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,v.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,E.mnemonicButtonLabel)((0,v.localize)(2,null))],message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;W.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):W.response===2&&this.destroyWindow()}else if(G===2){let W;J?W=(0,v.localize)(6,null,J.reason,J.exitCode??"<unknown>"):W=(0,v.localize)(5,null);const V=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,v.localize)(7,null)),(0,E.mnemonicButtonLabel)((0,v.localize)(8,null))],message:W,detail:(0,v.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;V.response===0?this.reload():V.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(G){this.openedWorkspace?.id===G.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const G=this.getMenuBarVisibility();G!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=G,this.setMenuBarVisibility(G));let J=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;J?.endsWith("/")&&(J=J.substr(0,J.length-1));const W=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((J||"").indexOf("@")===-1&&(J!==this.currentHttpProxy||W!==this.currentNoProxy)){this.currentHttpProxy=J,this.currentNoProxy=W;const V=J||"",B=W?`${W},<local>`:"<local>";this.logService.trace(`Setting proxy to '${V}', bypassing '${B}'`),this._win.webContents.session.setProxy({proxyRules:V,proxyBypassRules:B,pacScript:""})}}addTabbedWindow(G){P.isMacintosh&&G.win&&this._win.addTabbedWindow(G.win)}load(G,J=Object.create(null)){this.isDocumentEdited()&&(!J.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),J.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(G,J),this.readyState===0?this.currentConfig=G:(this.pendingLoadConfig=G,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",K).toString(!0));const W=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:G.workspace,reason:J.isReload?3:W?2:1})}updateConfiguration(G,J){const W=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(W){const V=(0,u.isLaunchedFromCli)(W)&&!(0,u.isLaunchedFromCli)(G.userEnv),B=this.isExtensionDevelopmentHost;(V||B)&&(G.userEnv={...W,...G.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(G.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),J.disableExtensions!==void 0&&(G["disable-extensions"]=J.disableExtensions),G.fullscreen=this.isFullScreen,G.maximized=this._win.isMaximized(),G.partsSplash=this.themeMainService.getWindowSplash(),(0,t.mark)("code/willOpenNewWindow"),G.perfMarks=(0,t.getMarks)(),this.configObjectUrl.update(G)}async reload(G){const J=Object.assign({},this.currentConfig);J.workspace=await this.validateWorkspaceBeforeReload(J),delete J.filesToOpenOrCreate,delete J.filesToDiff,delete J.filesToWait,this.isExtensionDevelopmentHost&&G&&(J.verbose=G.verbose,J.debugId=G.debugId,J["inspect-extensions"]=G["inspect-extensions"],J["inspect-brk-extensions"]=G["inspect-brk-extensions"],J["extensions-dir"]=G["extensions-dir"]),J.isInitialStartup=!1,this.load(J,{isReload:!0,disableExtensions:G?.["disable-extensions"]})}async validateWorkspaceBeforeReload(G){if((0,F.isWorkspaceIdentifier)(G.workspace)){const J=G.workspace.configPath;if(J.scheme===f.Schemas.file&&!await this.fileService.exists(J))return}else if((0,F.isSingleFolderWorkspaceIdentifier)(G.workspace)){const J=G.workspace.uri;if(J.scheme===f.Schemas.file&&!await this.fileService.exists(J))return}return G.workspace}serializeWindowState(){if(!this._win)return(0,A.defaultWindowState)();if(this.isFullScreen){let W;try{W=y.screen.getDisplayMatching(this.getBounds())}catch($){}const V=(0,A.defaultWindowState)();return{mode:3,display:W?W.id:void 0,width:this.windowState.width||V.width,height:this.windowState.height||V.height,x:this.windowState.x||0,y:this.windowState.y||0}}const G=Object.create(null);let J;if(!P.isMacintosh&&this._win.isMaximized()?J=0:J=1,J===0?G.mode=0:G.mode=1,J===1||J===0){let W;J===1?W=this.getBounds():W=this._win.getNormalBounds(),G.x=W.x,G.y=W.y,G.width=W.width,G.height=W.height}return G}restoreWindowState(G){(0,t.mark)("code/willRestoreCodeWindowState");let J=!1;if(G)try{const W=y.screen.getAllDisplays();J=W.length>1,G=this.validateWindowState(G,W)}catch(W){this.logService.warn(`Unexpected error validating window state: ${W}
${W.stack}`)}return(0,t.mark)("code/didRestoreCodeWindowState"),[G||(0,A.defaultWindowState)(),J]}validateWindowState(G,J){if(this.logService.trace(`window#validateWindowState: validating window state on ${J.length} display(s)`,G),typeof G.x!="number"||typeof G.y!="number"||typeof G.width!="number"||typeof G.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(G.width<=0||G.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(J.length===1){const B=this.getWorkingArea(J[0]);if(B){let $=function(){!G||typeof G.x!="number"||typeof G.y!="number"||!B||(G.x<B.x&&(G.x=B.x),G.y<B.y&&(G.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),$(),G.width>B.width&&(G.width=B.width),G.height>B.height&&(G.height=B.height),G.x>B.x+B.width-128&&(G.x=B.x+B.width-G.width),G.y>B.y+B.height-128&&(G.y=B.y+B.height-G.height),$()}return G}if(G.display&&G.mode===3){const B=J.find($=>$.id===G.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,A.defaultWindowState)(3);return $.x=B.bounds.x,$.y=B.bounds.y,$}}let W,V;try{W=y.screen.getDisplayMatching({x:G.x,y:G.y,width:G.width,height:G.height}),V=this.getWorkingArea(W)}catch(B){}if(W&&V&&G.x+G.width>V.x&&G.y+G.height>V.y&&G.x<V.x+V.width&&G.y<V.y+V.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",V),G}getWorkingArea(G){if(G.workArea.width>0&&G.workArea.height>0)return G.workArea;if(G.bounds.width>0&&G.bounds.height>0)return G.bounds}getBounds(){const[G,J]=this._win.getPosition(),[W,V]=this._win.getSize();return{x:G,y:J,width:W,height:V}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(G){this.useNativeFullScreen()?this.setNativeFullScreen(G):this.setSimpleFullScreen(G),this.sendWhenReady(G?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(G){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(G)}setSimpleFullScreen(G){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(G),this._win.webContents.focus()}useNativeFullScreen(){const G=this.configurationService.getValue("window");return!G||typeof G.nativeFullScreen!="boolean"||G.nativeTabs?!0:G.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let G=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(G)<0&&(G="classic"),G}setMenuBarVisibility(G,J=!0){P.isMacintosh||(G==="toggle"&&J&&this.send("vscode:showInfoMessage",(0,v.localize)(10,null)),G==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(G)}):this.doSetMenuBarVisibility(G))}doSetMenuBarVisibility(G){const J=this.isFullScreen;switch(G){case"classic":this._win.setMenuBarVisibility(!J),this._win.autoHideMenuBar=J;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(P.isMacintosh)switch(y.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(G,J,...W){this.isReady?this.send(G,...W):this.ready().then(()=>{J.isCancellationRequested||this.send(G,...W)})}send(G,...J){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${G} for window that is destroyed`);return}this._win.webContents.send(G,...J)}}updateTouchBar(G){!P.isMacintosh||this.touchBarGroups.forEach((J,W)=>{const V=G[W];J.segments=this.createTouchBarGroupSegments(V)})}createTouchBar(){if(!!P.isMacintosh){for(let G=0;G<10;G++){const J=this.createTouchBarGroup();this.touchBarGroups.push(J)}this._win.setTouchBar(new y.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(G=[]){const J=this.createTouchBarGroupSegments(G),W=new y.TouchBar.TouchBarSegmentedControl({segments:J,mode:"buttons",segmentStyle:"automatic",change:V=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:W.segments[V].id,from:"touchbar"})}});return W}createTouchBarGroupSegments(G=[]){return G.map(W=>{let V;W.icon&&!g.ThemeIcon.isThemeIcon(W.icon)&&W.icon?.dark?.scheme===f.Schemas.file&&(V=y.nativeImage.createFromPath(b.URI.revive(W.icon.dark).fsPath),V.isEmpty()&&(V=void 0));let B;return typeof W.title=="string"?B=W.title:B=W.title.value,{id:W.id,label:V?void 0:B,icon:V}})}dispose(){super.dispose(),this._win=null}};ne=he([te(1,i.ILogService),te(2,p.IEnvironmentMainService),te(3,o.IFileService),te(4,s.IStorageMainService),te(5,m.IConfigurationService),te(6,S.IThemeMainService),te(7,U.IWorkspacesManagementMainService),te(8,d.IBackupMainService),te(9,l.ITelemetryService),te(10,I.IDialogMainService),te(11,c.ILifecycleMainService),te(12,a.IProductService),te(13,r.IProtocolMainService)],ne),e.CodeWindow=ne}),define(Z[62],x([0,1,14,31,9,4,33,2,10,3,15,7,19,152,5,22,6,39,27,46]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m,I,p,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let o=class je extends n.Disposable{constructor(g,S,D,A){super();this.stateMainService=g,this.logService=S,this.workspacesManagementMainService=D,this.lifecycleMainService=A,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(g=>this.addRecentlyOpened([{workspace:g.workspace}])))}handleWindowsJumpList(){!w.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(g){const S=[],D=[];for(let A of g)if((0,u.isRecentWorkspace)(A))!this.workspacesManagementMainService.isUntitledWorkspace(A.workspace)&&a(S,A.workspace)===-1&&S.push(A);else if((0,u.isRecentFolder)(A))r(S,A.folderUri)===-1&&S.push(A);else{const F=s(D,A.fileUri)>=0,U=A.fileUri.scheme===f.Schemas.file&&je.COMMON_FILES_FILTER.indexOf((0,t.basename)(A.fileUri))>=0;!F&&!U&&(D.push(A),w.isWindows&&A.fileUri.scheme===f.Schemas.file&&y.app.addRecentDocument(A.fileUri.fsPath))}this.addEntriesFromStorage(S,D),S.length>je.MAX_TOTAL_RECENT_ENTRIES&&(S.length=je.MAX_TOTAL_RECENT_ENTRIES),D.length>je.MAX_TOTAL_RECENT_ENTRIES&&(D.length=je.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:S,files:D}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(g){const S=U=>{const X=i(U);for(const ne of g)if(t.extUriBiasedIgnorePathCase.isEqual(ne,X))return!1;return!0},D=this.getRecentlyOpened(),A=D.workspaces.filter(S),F=D.files.filter(S);(A.length!==D.workspaces.length||F.length!==D.files.length)&&(this.saveRecentlyOpened({files:F,workspaces:A}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!w.isMacintosh)return;y.app.clearRecentDocuments();const g=this.getRecentlyOpened(),S=[];let D=0;for(let F=0;F<g.workspaces.length&&D<je.MAX_MACOS_DOCK_RECENT_WORKSPACES;F++){const U=i(g.workspaces[F]);if(U.scheme===f.Schemas.file){const X=(0,t.originalFSPath)(U);await b.Promises.exists(X)&&(S.push(X),D++)}}const A=[];for(let F=0;F<g.files.length&&D<je.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;F++){const U=i(g.files[F]);if(U.scheme===f.Schemas.file){const X=(0,t.originalFSPath)(U);if(je.COMMON_FILES_FILTER.includes((0,t.basename)(U))||S.includes(X))continue;await b.Promises.exists(X)&&(A.push(X),D++)}}A.reverse().forEach(F=>y.app.addRecentDocument(F)),S.reverse().forEach(F=>y.app.addRecentDocument(F))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),y.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(g){const S=[],D=[],A=g?.config?.workspace;(0,u.isWorkspaceIdentifier)(A)&&!this.workspacesManagementMainService.isUntitledWorkspace(A)?S.push({workspace:A}):(0,u.isSingleFolderWorkspaceIdentifier)(A)&&S.push({folderUri:A.uri});const F=g?.config?.filesToOpenOrCreate;if(F)for(let U of F){const X=U.fileUri;X&&s(D,X)===-1&&D.push({fileUri:X})}return this.addEntriesFromStorage(S,D),{workspaces:S,files:D}}addEntriesFromStorage(g,S){let D=this.getRecentlyOpenedFromStorage();for(let A of D.workspaces){let F=(0,u.isRecentFolder)(A)?r(g,A.folderUri):a(g,A.workspace);F>=0?g[F].label=g[F].label||A.label:g.push(A)}for(let A of D.files){let F=s(S,A.fileUri);F>=0?S[F].label=S[F].label||A.label:S.push(A)}}getRecentlyOpenedFromStorage(){const g=this.stateMainService.getItem(je.recentlyOpenedStorageKey);return(0,u.restoreRecentlyOpened)(g,this.logService)}saveRecentlyOpened(g){const S=(0,u.toStoreData)(g);this.stateMainService.setItem(je.recentlyOpenedStorageKey,S)}updateWindowsJumpList(){if(!w.isWindows)return;const g=[];if(g.push({type:"tasks",items:[{type:"task",title:(0,v.localize)(0,null),description:(0,v.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let S=[];for(let F of y.app.getJumpListSettings().removedItems){const U=F.args;if(U){const X=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(U);X&&S.push(P.URI.parse(X[2]))}}this.removeRecentlyOpened(S);let D=!1;const A=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(F=>{const U=(0,u.isRecentWorkspace)(F)?F.workspace:F.folderUri,{title:X,description:ne}=this.getWindowsJumpListLabel(U,F.label);let se;return P.URI.isUri(U)?se=`--folder-uri "${U.toString()}"`:(D=!0,se=`--file-uri "${U.configPath.toString()}"`),{type:"task",title:X.substr(0,255),description:ne.substr(0,255),program:process.execPath,args:se,iconPath:"explorer.exe",iconIndex:0}}));A.length>0&&g.push({type:"custom",name:D?(0,v.localize)(2,null):(0,v.localize)(3,null),items:A})}g.push({type:"recent"});try{y.app.setJumpList(g)}catch(S){this.logService.warn("updateWindowsJumpList#setJumpList",S)}}getWindowsJumpListLabel(g,S){if(S)return{title:(0,E.splitName)(S).name,description:S};if(P.URI.isUri(g))return{title:(0,t.basename)(g),description:c(g)};if(this.workspacesManagementMainService.isUntitledWorkspace(g))return{title:(0,v.localize)(4,null),description:""};let D=(0,t.basename)(g.configPath);return D.endsWith(u.WORKSPACE_EXTENSION)&&(D=D.substr(0,D.length-u.WORKSPACE_EXTENSION.length-1)),{title:(0,v.localize)(5,null,D),description:c(g.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=he([te(0,p.IStateMainService),te(1,I.ILogService),te(2,h.IWorkspacesManagementMainService),te(3,m.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function c(l){return l.scheme==="file"?(0,E.normalizeDriveLetter)(l.fsPath):l.toString()}function i(l){return(0,u.isRecentFolder)(l)?l.folderUri:(0,u.isRecentFile)(l)?l.fileUri:l.workspace.configPath}function a(l,g){return l.findIndex(S=>(0,u.isRecentWorkspace)(S)&&S.workspace.id===g.id)}function r(l,g){return l.findIndex(S=>(0,u.isRecentFolder)(S)&&t.extUriBiasedIgnorePathCase.isEqual(S.folderUri,g))}function s(l,g){return l.findIndex(S=>t.extUriBiasedIgnorePathCase.isEqual(S.fileUri,g))}}),define(Z[234],x([0,1,14,9,24,33,3,7,144,16,23,22,6,182,53,21,39,34,42,61,36,62]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m,I,p,u,h,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let a=class wt{constructor(l,g,S,D,A,F,U,X,ne,se,G){this.updateService=l,this.configurationService=g,this.windowsMainService=S,this.environmentMainService=D,this.telemetryService=A,this.workspacesHistoryMainService=F,this.stateMainService=U,this.lifecycleMainService=X,this.logService=ne,this.nativeHostMainService=se,this.productService=G,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(E.isMacintosh||(0,h.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const l=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);l&&(l.menus&&(this.menubarMenus=l.menus),l.keybindings&&(this.keybindings=l.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(F,U,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:U?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(F,U,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:U?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(F,U,X)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(F,U,X)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const l=this.productService.twitterUrl;l&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(l,"openTwitterUrl"));const g=this.productService.requestFeatureUrl;g&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(g,"openUserVoiceUrl"));const S=this.productService.reportIssueUrl;S&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(S,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(E.language){const F=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${F}lang=${E.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const A=this.productService.privacyStatementUrl;A&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(A,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(l=>this.onDidChangeWindowsCount(l)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let l=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof l!="boolean"?!0:l}get currentEnableNativeTabs(){if(!E.isMacintosh)return!1;let l=this.configurationService.getValue("window.nativeTabs");return typeof l!="boolean"?!1:l}updateMenu(l,g){this.menubarMenus=l.menus,this.keybindings=l.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,l),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(l){!E.isMacintosh||(l.oldCount===0&&l.newCount>0||l.oldCount>0&&l.newCount===0)&&(this.closedLastWindow=l.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!E.isMacintosh||(this.noActiveWindow=!y.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const l=y.Menu.getApplicationMenu();if(l&&this.oldMenus.push(l),Object.keys(this.menubarMenus).length===0){y.Menu.setApplicationMenu(E.isMacintosh?new y.Menu:null);return}const g=new y.Menu;let S;if(E.isMacintosh){const A=new y.Menu;S=new y.MenuItem({label:this.productService.nameShort,submenu:A}),this.setMacApplicationMenu(A),g.append(S)}if(E.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const A=new y.Menu;A.append(new y.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),y.app.dock.setMenu(A)}if(this.shouldDrawMenu("File")){const A=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:A});this.setMenuById(A,"File"),g.append(F)}if(this.shouldDrawMenu("Edit")){const A=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:A});this.setMenuById(A,"Edit"),g.append(F)}if(this.shouldDrawMenu("Selection")){const A=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:A});this.setMenuById(A,"Selection"),g.append(F)}if(this.shouldDrawMenu("View")){const A=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:A});this.setMenuById(A,"View"),g.append(F)}if(this.shouldDrawMenu("Go")){const A=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:A});this.setMenuById(A,"Go"),g.append(F)}if(this.shouldDrawMenu("Run")){const A=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:A});this.setMenuById(A,"Run"),g.append(F)}if(this.shouldDrawMenu("Terminal")){const A=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:A});this.setMenuById(A,"Terminal"),g.append(F)}let D;if(this.shouldDrawMenu("Window")){const A=new y.Menu;D=new y.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:A,role:"window"}),this.setMacWindowMenu(A)}if(D&&g.append(D),this.shouldDrawMenu("Help")){const A=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:A,role:"help"});this.setMenuById(A,"Help"),g.append(F)}g.items&&g.items.length>0?y.Menu.setApplicationMenu(g):y.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(l){const g=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),S=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const J=new y.Menu;this.setMenuById(J,"Preferences"),D=new y.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:J})}const A=new y.Menu,F=new y.MenuItem({label:f.localize(12,null),role:"services",submenu:A}),U=new y.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),X=new y.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ne=new y.MenuItem({label:f.localize(15,null),role:"unhide"}),se=new y.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const J=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!y.BrowserWindow.getFocusedWindow()||J?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),G=[g];G.push(...S),D&&G.push(r(),D),G.push(r(),F,r(),U,X,ne,r(),se),G.forEach(J=>l.append(J))}shouldDrawMenu(l){if(!E.isMacintosh&&(0,h.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(l){case"File":case"Help":if(E.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[l];case"Window":if(E.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[l]}}setMenu(l,g){g.forEach(S=>{if((0,v.isMenubarMenuItemSeparator)(S))l.append(r());else if((0,v.isMenubarMenuItemSubmenu)(S)){const D=new y.Menu,A=new y.MenuItem({label:this.mnemonicLabel(S.label),submenu:D});this.setMenu(D,S.submenu.items),l.append(A)}else(0,v.isMenubarMenuItemRecentAction)(S)?l.append(this.createOpenRecentMenuItem(S)):(0,v.isMenubarMenuItemAction)(S)&&(S.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(l),E.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[S.id]?l.append(new y.MenuItem(this.likeAction(S.id,{label:this.mnemonicLabel(S.label),click:this.fallbackMenuHandlers[S.id]}))):l.append(this.createMenuItem(S.label,S.id,!1,S.checked)):l.append(this.createMenuItem(S.label,S.id,S.enabled!==!1,!!S.checked)):l.append(this.createMenuItem(S.label,S.id,S.enabled!==!1,!!S.checked)))})}setMenuById(l,g){this.menubarMenus&&this.menubarMenus[g]&&this.setMenu(l,this.menubarMenus[g].items)}insertCheckForUpdatesItems(l){const g=this.getUpdateMenuItems();g.length&&(g.forEach(S=>l.append(S)),l.append(r()))}createOpenRecentMenuItem(l){const g=n.URI.revive(l.uri),S=l.id,D=S==="openRecentFile"?{fileUri:g}:S==="openRecentWorkspace"?{workspaceUri:g}:{folderUri:g};return new y.MenuItem(this.likeAction(S,{label:l.label,click:(A,F,U)=>{const X=this.isOptionClick(U);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:l.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([g])}},!1))}isOptionClick(l){return!!(l&&(!E.isMacintosh&&(l.ctrlKey||l.shiftKey)||E.isMacintosh&&(l.metaKey||l.altKey)))}createRoleMenuItem(l,g,S){const D={label:this.mnemonicLabel(l),role:S,enabled:!0};return new y.MenuItem(this.withKeybinding(g,D))}setMacWindowMenu(l){const g=new y.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),S=new y.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new y.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),A=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),F=[];this.currentEnableNativeTabs&&(F.push(r()),F.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),F.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),F.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),F.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),F.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[g,S,r(),A,...F,r(),D].forEach(U=>l.append(U))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new y.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new y.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new y.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new y.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new y.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new y.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new y.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(l,g,S,D){const A=this.mnemonicLabel(l),F=typeof g=="function"?g:(G,J,W)=>{const V=G?G.userSettingsLabel:null;let B=g;Array.isArray(g)&&(B=this.isOptionClick(W)?g[1]:g[0]),V&&W.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:V}):this.runActionInRenderer({type:"commandId",commandId:B})},U=typeof S=="boolean"?S:this.windowsMainService.getWindowCount()>0,X=typeof D=="boolean"?D:!1,ne={label:A,click:F,enabled:U};X&&(ne.type="checkbox",ne.checked=X);let se;return typeof g=="string"?se=g:Array.isArray(g)&&(se=g[0]),E.isMacintosh&&(se==="editor.action.clipboardCutAction"?ne.role="cut":se==="editor.action.clipboardCopyAction"?ne.role="copy":se==="editor.action.clipboardPasteAction"&&(ne.role="paste"),se==="undo"?ne.click=this.makeContextAwareClickHandler(F,{inDevTools:G=>G.undo(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?ne.click=this.makeContextAwareClickHandler(F,{inDevTools:G=>G.redo(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(ne.click=this.makeContextAwareClickHandler(F,{inDevTools:G=>G.selectAll(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("selectAll:")}))),new y.MenuItem(this.withKeybinding(se,ne))}makeContextAwareClickHandler(l,g){return(S,D,A)=>{const F=y.BrowserWindow.getFocusedWindow();if(!F)return g.inNoWindow();if(F.webContents.isDevToolsFocused()&&F.webContents.devToolsWebContents)return g.inDevTools(F.webContents.devToolsWebContents);l(S,D||F,A)}}runActionInRenderer(l){let g=y.BrowserWindow.getFocusedWindow();if(!g){const D=this.windowsMainService.getLastActiveWindow();D?.isMinimized()&&(g=D.win)}const S=g?this.windowsMainService.getWindowById(g.id):void 0;if(S){if(this.logService.trace("menubar#runActionInRenderer",l),E.isMacintosh&&!this.environmentMainService.isBuilt&&!S.isReady&&(l.type==="commandId"&&l.commandId==="workbench.action.toggleDevTools"||l.type!=="commandId"&&l.userSettingsLabel==="alt+cmd+i"))return;if(l.type==="commandId"){const D={id:l.commandId,from:"menu"};S.sendWhenReady("vscode:runAction",k.CancellationToken.None,D)}else{const D={userSettingsLabel:l.userSettingsLabel};S.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,D)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",l)}withKeybinding(l,g){const S=typeof l=="string"?this.keybindings[l]:void 0;if(S?.label){if(S.isNative!==!1)g.accelerator=S.label,g.userSettingsLabel=S.userSettingsLabel;else if(typeof g.label=="string"){const D=g.label.indexOf("[");D>=0?g.label=`${g.label.substr(0,D)} [${S.label}]`:g.label=`${g.label} [${S.label}]`}}else g.accelerator=void 0;return g}likeAction(l,g,S=!g.accelerator){S&&(g=this.withKeybinding(l,g));const D=g.click;return g.click=(A,F,U)=>{this.reportMenuActionTelemetry(l),D&&D(A,F,U)},g}openUrl(l,g){this.nativeHostMainService.openExternal(void 0,l),this.reportMenuActionTelemetry(g)}reportMenuActionTelemetry(l){this.telemetryService.publicLog2("workbenchActionExecuted",{id:l,from:i})}mnemonicLabel(l){return(0,M.mnemonicMenuLabel)(l,!this.currentEnableMenuBarMnemonics)}};a.lastKnownMenubarStorageKey="lastKnownMenubarData",a=he([te(0,u.IUpdateService),te(1,w.IConfigurationService),te(2,o.IWindowsMainService),te(3,t.IEnvironmentMainService),te(4,p.ITelemetryService),te(5,c.IWorkspacesHistoryMainService),te(6,I.IStateMainService),te(7,P.ILifecycleMainService),te(8,b.ILogService),te(9,d.INativeHostMainService),te(10,m.IProductService)],a),e.Menubar=a;function r(){return new y.MenuItem({type:"separator"})}}),define(Z[235],x([0,1,5,22,6,234]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,y.createDecorator)("menubarMainService");let E=class{constructor(f,w,t){this.instantiationService=f,this.lifecycleMainService=w,this.logService=t,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(f,w){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(w,f)}};E=he([te(0,y.IInstantiationService),te(1,L.ILifecycleMainService),te(2,k.ILogService)],E),e.MenubarMainService=E}),define(Z[236],x([0,1,14,30,26,31,24,4,29,43,33,2,10,8,72,3,32,15,13,7,150,51,16,52,23,20,5,22,6,45,21,55,73,39,61,233,99,216,27,100,62,46]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m,I,p,u,h,o,c,i,a,r,s,l,g,S,D,A,F,U,X,ne,se,G,J,W,V,B,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function H(T){return(0,W.isWorkspaceIdentifier)(T?.workspace)}function _(T){return(0,W.isSingleFolderWorkspaceIdentifier)(T?.workspace)}let j=class Je extends P.Disposable{constructor(R,O,z,N,C,q,Q,ie,oe,ae,ee,le,me,ue,ve){super();this.machineId=R,this.initialUserEnv=O,this.logService=z,this.stateMainService=N,this.environmentMainService=C,this.lifecycleMainService=q,this.backupMainService=Q,this.configurationService=ie,this.workspacesHistoryMainService=oe,this.workspacesManagementMainService=ae,this.instantiationService=ee,this.dialogMainService=le,this.fileService=me,this.productService=ue,this.protocolMainService=ve,this._onDidOpenWindow=this._register(new n.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new n.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new n.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new n.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new J.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(R=>this._onDidSignalReadyWindow.fire(R.window))),this._register(this.onDidSignalReadyWindow(R=>{if(R.config?.extensionDevelopmentPath||R.config?.extensionTestsPath){const O=new P.DisposableStore;if(O.add(n.Event.any(R.onDidClose,R.onDidDestroy)(()=>O.dispose())),R.config.extensionDevelopmentPath)for(const z of R.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(h.URI.file(z)));R.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(h.URI.file(R.config.extensionTestsPath)))}}))}openEmptyWindow(R,O){let z=this.environmentMainService.args;const N=O?.remoteAuthority||void 0,C=!0,q=O?.forceReuseWindow,Q=!q;return this.open({...R,cli:z,forceEmpty:C,forceNewWindow:Q,forceReuseWindow:q,remoteAuthority:N})}open(R){this.logService.trace("windowsManager#open"),R.addMode&&(R.initialStartup||!this.getLastActiveWindow())&&(R.addMode=!1);const O=[],z=[],N=[],C=[],q=[];let Q,ie=0;const oe=this.getPathsToOpen(R);this.logService.trace("windowsManager#open pathsToOpen",oe);for(const ue of oe)_(ue)?R.addMode?O.push(ue):z.push(ue):H(ue)?N.push(ue):ue.fileUri?(Q||(Q={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ue.remoteAuthority}),Q.filesToOpenOrCreate.push(ue)):ue.backupPath?q.push({backupFolder:(0,v.basename)(ue.backupPath),remoteAuthority:ue.remoteAuthority}):ie++;R.diffMode&&Q&&Q.filesToOpenOrCreate.length>=2&&(Q.filesToDiff=Q.filesToOpenOrCreate.slice(0,2),Q.filesToOpenOrCreate=[]),Q&&R.waitMarkerFileURI&&(Q.filesToWait={paths:[...Q.filesToDiff,...Q.filesToOpenOrCreate],waitMarkerFileUri:R.waitMarkerFileURI}),R.initialStartup?(C.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),N.push(...C),q.push(...this.backupMainService.getEmptyWindowBackupPaths())):q.length=0;const{windows:ae,filesOpenedInWindow:ee}=this.doOpen(R,N,z,q,ie,Q,O);if(this.logService.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${N.length}, foldersToOpen: ${z.length}, emptyToRestore: ${q.length}, emptyToOpen: ${ie})`),ae.length>1)if(ee)ee.focus();else{const ue=this.windowsStateHandler.state.lastActiveWindow&&!R.forceEmpty&&!R.cli._.length&&!R.cli["file-uri"]&&!R.cli["folder-uri"]&&!(R.urisToOpen&&R.urisToOpen.length);let ve=!0,Pe=!0;if(ue){const we=ae.filter(fe=>this.windowsStateHandler.state.lastActiveWindow&&fe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),ve=!1,Pe=!1)}if(ve)for(let we=ae.length-1;we>=0;we--){const fe=ae[we];if(!(fe.openedWorkspace&&C.some(Ee=>fe.openedWorkspace&&Ee.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&q.some(Ee=>fe.backupPath&&Ee.backupFolder===(0,v.basename)(fe.backupPath)))){fe.focus(),Pe=!1;break}}Pe&&ae[ae.length-1].focus()}const le=Q&&Q.filesToDiff.length>0;if(!ae.some(ue=>ue.isExtensionDevelopmentHost)&&!le&&!R.noRecentEntry){const ue=[];for(const ve of oe)H(ve)&&!ve.transient?ue.push({label:ve.label,workspace:ve.workspace,remoteAuthority:ve.remoteAuthority}):_(ve)?ue.push({label:ve.label,folderUri:ve.workspace.uri,remoteAuthority:ve.remoteAuthority}):ve.fileUri&&ue.push({label:ve.label,fileUri:ve.fileUri,remoteAuthority:ve.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ue)}const me=R.waitMarkerFileURI;return R.context===0&&me&&ae.length===1&&ae[0]&&(async()=>{await ae[0].whenClosedOrLoaded;try{await this.fileService.del(me)}catch(ue){}})(),ae}doOpen(R,O,z,N,C,q,Q){const ie=[];let oe;function ae(we,fe){ie.push(we),fe&&(oe=we,q=void 0)}let{openFolderInNewWindow:ee,openFilesInNewWindow:le}=this.shouldOpenNewWindow(R);if(!R.initialStartup&&Q.length>0){const we=Q[0].remoteAuthority,fe=this.getLastActiveWindowForAuthority(we);fe&&ae(this.doAddFoldersToExistingWindow(fe,Q.map(Ee=>Ee.workspace.uri)))}const me=z.length+O.length+N.length;if(q&&me===0){const we=q.filesToOpenOrCreate[0]||q.filesToDiff[0],fe=this.getWindows().filter(De=>q&&De.remoteAuthority===q.remoteAuthority);let Ee;we?.fileUri&&!le&&((R.context===4||R.context===0||R.context===1)&&(Ee=(0,G.findWindowOnFile)(fe,we.fileUri,De=>De.configPath.scheme===b.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(De.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(fe))),Ee?(0,W.isWorkspaceIdentifier)(Ee.openedWorkspace)?O.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,W.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?z.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):ae(this.doOpenFilesInExistingWindow(R,Ee,q),!0):ae(this.openInBrowserWindow({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:q,forceNewWindow:!0,remoteAuthority:q.remoteAuthority,forceNewTabbedWindow:R.forceNewTabbedWindow}),!0)}const ue=(0,M.distinct)(O,we=>we.workspace.id);if(ue.length>0){const we=(0,M.coalesce)(ue.map(fe=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe.workspace.configPath)));if(we.length>0){const fe=we[0],Ee=q?.remoteAuthority===fe.remoteAuthority?q:void 0;ae(this.doOpenFilesInExistingWindow(R,fe,Ee),!!Ee),ee=!0}ue.forEach(fe=>{if(we.some(Re=>Re.openedWorkspace&&Re.openedWorkspace.id===fe.workspace.id))return;const Ee=fe.remoteAuthority,De=q?.remoteAuthority===Ee?q:void 0;ae(this.doOpenFolderOrWorkspace(R,fe,ee,De),!!De),ee=!0})}const ve=(0,M.distinct)(z,we=>p.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(ve.length>0){const we=(0,M.coalesce)(ve.map(fe=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe.workspace.uri)));if(we.length>0){const fe=we[0],Ee=q?.remoteAuthority===fe.remoteAuthority?q:void 0;ae(this.doOpenFilesInExistingWindow(R,fe,Ee),!!Ee),ee=!0}ve.forEach(fe=>{if(we.some(Re=>(0,W.isSingleFolderWorkspaceIdentifier)(Re.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(Re.openedWorkspace.uri,fe.workspace.uri)))return;const Ee=fe.remoteAuthority,De=q?.remoteAuthority===Ee?q:void 0;ae(this.doOpenFolderOrWorkspace(R,fe,ee,De),!!De),ee=!0})}const Pe=(0,M.distinct)(N,we=>we.backupFolder);if(Pe.length>0&&Pe.forEach(we=>{const fe=we.remoteAuthority,Ee=q?.remoteAuthority===fe?q:void 0;ae(this.openInBrowserWindow({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:Ee,remoteAuthority:fe,forceNewWindow:!0,forceNewTabbedWindow:R.forceNewTabbedWindow,emptyWindowBackupInfo:we}),!!Ee),ee=!0}),ie.length===0||q){q&&!C&&C++;const we=q?q.remoteAuthority:R.remoteAuthority;for(let fe=0;fe<C;fe++)ae(this.doOpenEmpty(R,ee,we,q),!!q),ee=!0}return{windows:(0,M.distinct)(ie),filesOpenedInWindow:oe}}doOpenFilesInExistingWindow(R,O,z){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),O.focus();const N={filesToOpenOrCreate:z?.filesToOpenOrCreate,filesToDiff:z?.filesToDiff,filesToWait:z?.filesToWait,termProgram:R?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",E.CancellationToken.None,N),O}doAddFoldersToExistingWindow(R,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),R.focus();const z={foldersToAdd:O};return R.sendWhenReady("vscode:addFolders",E.CancellationToken.None,z),R}doOpenEmpty(R,O,z,N,C){return!O&&!C&&typeof R.contextWindowId=="number"&&(C=this.getWindowById(R.contextWindowId)),this.openInBrowserWindow({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:z,forceNewWindow:O,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:N,windowToUse:C})}doOpenFolderOrWorkspace(R,O,z,N,C){return!z&&!C&&typeof R.contextWindowId=="number"&&(C=this.getWindowById(R.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:z,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:N,windowToUse:C})}getPathsToOpen(R){let O,z=!1,N=!1;if(R.urisToOpen&&R.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(R),z=!0):R.forceEmpty?O=[Object.create(null)]:R.cli._.length||R.cli["folder-uri"]||R.cli["file-uri"]?(O=this.doExtractPathsFromCLI(R.cli),O.length===0&&O.push(Object.create(null)),z=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),N=!0),!R.addMode&&z){const C=O.filter(q=>_(q));if(C.length>1){const q=C[0].remoteAuthority;if(C.every(Q=>Q.remoteAuthority===q)){const Q=this.workspacesManagementMainService.createUntitledWorkspaceSync(C.map(ie=>({uri:ie.workspace.uri})));O.push({workspace:Q,remoteAuthority:q}),O=O.filter(ie=>!_(ie))}}}return R.initialStartup&&!N&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(C=>H(C)||_(C)||C.backupPath)),O}doExtractPathsFromAPI(R){const O=[],z={gotoLineMode:R.gotoLineMode,remoteAuthority:R.remoteAuthority};for(const N of(0,M.coalesce)(R.urisToOpen||[])){const C=this.resolveOpenable(N,z);if(C)C.label=N.label,O.push(C);else{const q=this.resourceFromOpenable(N),Q={title:this.productService.nameLong,type:"info",buttons:[(0,t.mnemonicButtonLabel)((0,o.localize)(0,null))],defaultId:0,message:q.scheme===b.Schemas.file?(0,o.localize)(1,null):(0,o.localize)(2,null),detail:q.scheme===b.Schemas.file?(0,o.localize)(3,null,(0,t.getPathLabel)(q.fsPath,this.environmentMainService)):(0,o.localize)(4,null,q.toString()),noLink:!0};this.dialogMainService.showMessageBox(Q,(0,u.withNullAsUndefined)(y.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(R){const O=[],z={ignoreFileNotFound:!0,gotoLineMode:R.goto,remoteAuthority:R.remote||void 0,forceOpenWorkspaceAsFile:!1},N=R["folder-uri"];if(N)for(const Q of N){const ie=this.cliArgToUri(Q);if(ie){const oe=this.resolveOpenable({folderUri:ie},z);oe&&O.push(oe)}}const C=R["file-uri"];if(C)for(const Q of C){const ie=this.cliArgToUri(Q);if(ie){const oe=this.resolveOpenable((0,W.hasWorkspaceFileExtension)(Q)?{workspaceUri:ie}:{fileUri:ie},z);oe&&O.push(oe)}}const q=R._;for(const Q of q){const ie=z.remoteAuthority?this.doResolvePathRemote(Q,z):this.doResolveFilePath(Q,z);ie&&O.push(ie)}return O}cliArgToUri(R){try{const O=h.URI.parse(R);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${R}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${R}, ${O.message}`)}}doGetPathsFromLastSession(){const R=this.getRestoreWindowsSetting();switch(R){case"none":return[];case"one":case"all":case"preserve":case"folders":const O=[];R!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const z=[];for(const N of O)if(N.workspace){const C=this.resolveOpenable({workspaceUri:N.workspace.configPath},{remoteAuthority:N.remoteAuthority,rejectTransientWorkspaces:!0});H(C)&&z.push(C)}else if(N.folderUri){const C=this.resolveOpenable({folderUri:N.folderUri},{remoteAuthority:N.remoteAuthority});_(C)&&z.push(C)}else R!=="folders"&&N.backupPath&&z.push({backupPath:N.backupPath,remoteAuthority:N.remoteAuthority});return z}}getRestoreWindowsSetting(){let R;return this.lifecycleMainService.wasRestarted?R="all":(R=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(R)||(R="all")),R}resolveOpenable(R,O=Object.create(null)){let z=this.resourceFromOpenable(R);return z.scheme===b.Schemas.file?((0,ne.isFileToOpen)(R)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(z.fsPath,O)):this.doResolveRemoteOpenable(R,O)}doResolveRemoteOpenable(R,O){let z=this.resourceFromOpenable(R);const N=(0,U.getRemoteAuthority)(z)||O.remoteAuthority;if(z=(0,p.removeTrailingPathSeparator)((0,p.normalizePath)(z)),(0,ne.isFileToOpen)(R)){if(O.gotoLineMode){const{path:C,line:q,column:Q}=(0,f.parseLineAndColumnAware)(z.path);return{fileUri:z.with({path:C}),selection:q?{startLineNumber:q,startColumn:Q||1}:void 0,remoteAuthority:N}}return{fileUri:z,remoteAuthority:N}}else if((0,ne.isWorkspaceToOpen)(R))return{workspace:(0,V.getWorkspaceIdentifier)(z),remoteAuthority:N};return{workspace:(0,V.getSingleFolderWorkspaceIdentifier)(z),remoteAuthority:N}}resourceFromOpenable(R){return(0,ne.isWorkspaceToOpen)(R)?R.workspaceUri:(0,ne.isFolderToOpen)(R)?R.folderUri:R.fileUri}doResolveFilePath(R,O){let z,N;O.gotoLineMode&&({path:R,line:z,column:N}=(0,f.parseLineAndColumnAware)(R)),R=(0,f.sanitizeFilePath)((0,v.normalize)(R),(0,I.cwd)());try{const C=(0,L.statSync)(R);if(C.isFile()){if(!O.forceOpenWorkspaceAsFile){const q=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(R));if(q)return q.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:q.id,configPath:q.configPath},remoteAuthority:q.remoteAuthority,exists:!0,transient:q.transient}}return{fileUri:h.URI.file(R),selection:z?{startLineNumber:z,startColumn:N||1}:void 0,exists:!0}}else if(C.isDirectory())return{workspace:(0,V.getSingleFolderWorkspaceIdentifier)(h.URI.file(R),C),exists:!0}}catch(C){const q=h.URI.file(R);if(this.workspacesHistoryMainService.removeRecentlyOpened([q]),O.ignoreFileNotFound)return{fileUri:q,exists:!1}}}doResolvePathRemote(R,O){const z=R.charCodeAt(0),N=O.remoteAuthority;let C,q;O.gotoLineMode&&({path:R,line:C,column:q}=(0,f.parseLineAndColumnAware)(R)),z!==47&&((0,f.isWindowsDriveLetter)(z)&&R.charCodeAt(R.charCodeAt(1))===58&&(R=(0,f.toSlashes)(R)),R=`/${R}`);const Q=h.URI.from({scheme:b.Schemas.vscodeRemote,authority:N,path:R});if(R.charCodeAt(R.length-1)!==47){if((0,W.hasWorkspaceFileExtension)(R))return O.forceOpenWorkspaceAsFile?{fileUri:Q,selection:C?{startLineNumber:C,startColumn:q||1}:void 0,remoteAuthority:O.remoteAuthority}:{workspace:(0,V.getWorkspaceIdentifier)(Q),remoteAuthority:N};if(O.gotoLineMode||v.posix.basename(R).indexOf(".")!==-1)return{fileUri:Q,selection:C?{startLineNumber:C,startColumn:q||1}:void 0,remoteAuthority:N}}return{workspace:(0,V.getSingleFolderWorkspaceIdentifier)(Q),remoteAuthority:N}}shouldOpenNewWindow(R){const O=this.configurationService.getValue("window"),z=O?.openFoldersInNewWindow||"default",N=O?.openFilesInNewWindow||"off";let C=(R.preferNewWindow||R.forceNewWindow)&&!R.forceReuseWindow;!R.forceNewWindow&&!R.forceReuseWindow&&(z==="on"||z==="off")&&(C=z==="on");let q=!1;return R.forceNewWindow||R.forceReuseWindow?q=!!R.forceNewWindow&&!R.forceReuseWindow:(m.isMacintosh?R.context===1&&(q=!0):R.context!==3&&R.context!==2&&!(R.userEnv&&R.userEnv.TERM_PROGRAM==="vscode")&&(q=!0),!R.cli.extensionDevelopmentPath&&(N==="on"||N==="off")&&(q=N==="on")),{openFolderInNewWindow:!!C,openFilesInNewWindow:q}}openExtensionDevelopmentHostWindow(R,O){const z=(0,G.findWindowOnExtensionDevelopmentPath)(this.getWindows(),R);if(z)return this.lifecycleMainService.reload(z,O.cli),z.focus(),[z];let N=O.cli["folder-uri"]||[],C=O.cli["file-uri"]||[],q=O.cli._;if(!q.length&&!N.length&&!C.length&&!O.cli.extensionTestsPath){const ae=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ee=ae&&(ae.workspace||ae.folderUri);ee&&(h.URI.isUri(ee)?ee.scheme===b.Schemas.file?q=[ee.fsPath]:N=[ee.toString()]:ee.configPath.scheme===b.Schemas.file?q=[(0,p.originalFSPath)(ee.configPath)]:C=[ee.configPath.toString()])}let Q=O.remoteAuthority;for(const ae of R)if(ae.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ee=h.URI.parse(ae),le=(0,U.getRemoteAuthority)(ee);le&&(Q?le!==Q&&this.logService.error("more than one extension development path authority"):Q=le)}q=q.filter(ae=>{const ee=h.URI.file(ae);return(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ee)?!1:(0,U.getRemoteAuthority)(ee)===Q}),N=N.filter(ae=>{const ee=this.cliArgToUri(ae);return ee&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ee)?!1:ee?(0,U.getRemoteAuthority)(ee)===Q:!1}),C=C.filter(ae=>{const ee=this.cliArgToUri(ae);return ee&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ee)?!1:ee?(0,U.getRemoteAuthority)(ee)===Q:!1}),O.cli._=q,O.cli["folder-uri"]=N,O.cli["file-uri"]=C;const ie=!q.length&&!N.length&&!C.length,oe={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:ie,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:Q};return this.open(oe)}openInBrowserWindow(R){const O=this.configurationService.getValue("window"),z={...this.environmentMainService.args,...R.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:R.emptyWindowBackupInfo?(0,v.join)(this.environmentMainService.backupHome,R.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:R.remoteAuthority,workspace:R.workspace,userEnv:{...this.initialUserEnv,...R.userEnv},filesToOpenOrCreate:R.filesToOpen?.filesToOpenOrCreate,filesToDiff:R.filesToOpen?.filesToDiff,filesToWait:R.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:D.default,isInitialStartup:R.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,accessibilitySupport:y.app.accessibilitySupportEnabled,colorScheme:{dark:y.nativeTheme.shouldUseDarkColors,highContrast:y.nativeTheme.shouldUseInvertedColorScheme||y.nativeTheme.shouldUseHighContrastColors}};let N;if(!R.forceNewWindow&&!R.forceNewTabbedWindow&&(N=R.windowToUse||this.getLastActiveWindow(),N&&N.focus()),N){const C=N.config;!z.extensionDevelopmentPath&&C&&!!C.extensionDevelopmentPath&&(z.extensionDevelopmentPath=C.extensionDevelopmentPath,z.verbose=C.verbose,z["inspect-brk-extensions"]=C["inspect-brk-extensions"],z.debugId=C.debugId,z["inspect-extensions"]=C["inspect-extensions"],z["extensions-dir"]=C["extensions-dir"])}else{const C=this.windowsStateHandler.getNewWindowState(z);(0,d.mark)("code/willCreateCodeWindow");const q=N=this.instantiationService.createInstance(se.CodeWindow,{state:C,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});if((0,d.mark)("code/didCreateCodeWindow"),R.forceNewTabbedWindow){const ie=this.getLastActiveWindow();ie&&ie.addTabbedWindow(q)}Je.WINDOWS.push(q),this._onDidOpenWindow.fire(q),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(q.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(q)),(0,w.once)(q.onDidClose)(()=>this.onWindowClosed(q)),(0,w.once)(q.onDidDestroy)(()=>this._onDidDestroyWindow.fire(q));const Q=(0,u.assertIsDefined)(q.win?.webContents);Q.removeAllListeners("devtools-reload-page"),Q.on("devtools-reload-page",()=>this.lifecycleMainService.reload(q)),this.lifecycleMainService.registerWindow(q)}return z.windowId=N.id,N.isReady?this.lifecycleMainService.unload(N,4).then(C=>{C||this.doOpenInBrowserWindow(N,z,R)}):this.doOpenInBrowserWindow(N,z,R),N}doOpenInBrowserWindow(R,O,z){if(!O.extensionDevelopmentPath)if((0,W.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,W.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync(O.workspace.uri);else{const N=z.emptyWindowBackupInfo&&z.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(N,O.remoteAuthority)}R.load(O)}onWindowClosed(R){const O=Je.WINDOWS.indexOf(R);Je.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const R=y.BrowserWindow.getFocusedWindow();if(R)return this.getWindowById(R.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(R){return this.doGetLastActiveWindow(this.getWindows().filter(O=>O.remoteAuthority===R))}doGetLastActiveWindow(R){const O=Math.max.apply(Math,R.map(z=>z.lastFocusTime));return R.find(z=>z.lastFocusTime===O)}sendToFocused(R,...O){const z=this.getFocusedWindow()||this.getLastActiveWindow();z&&z.sendWhenReady(R,E.CancellationToken.None,...O)}sendToAll(R,O,z){for(const N of this.getWindows())z&&z.indexOf(N.id)>=0||N.sendWhenReady(R,E.CancellationToken.None,O)}getWindows(){return Je.WINDOWS}getWindowCount(){return Je.WINDOWS.length}getWindowById(R){const O=this.getWindows().filter(z=>z.id===R);return(0,M.firstOrDefault)(O)}getWindowByWebContents(R){const O=y.BrowserWindow.fromWebContents(R);if(!!O)return this.getWindowById(O.id)}};j.WINDOWS=[],j=he([te(2,S.ILogService),te(3,X.IStateMainService),te(4,r.IEnvironmentMainService),te(5,g.ILifecycleMainService),te(6,c.IBackupMainService),te(7,i.IConfigurationService),te(8,B.IWorkspacesHistoryMainService),te(9,$.IWorkspacesManagementMainService),te(10,l.IInstantiationService),te(11,a.IDialogMainService),te(12,s.IFileService),te(13,A.IProductService),te(14,F.IProtocolMainService)],j),e.WindowsMainService=j}),define(Z[237],x([0,1,51,36,62,46]),function(K,e,y,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let E=class{constructor(f,w,t,P){this.workspacesManagementMainService=f,this.windowsMainService=w,this.workspacesHistoryMainService=t,this.backupMainService=P,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,w){const t=this.windowsMainService.getWindowById(f);if(t)return this.workspacesManagementMainService.enterWorkspace(t,this.windowsMainService.getWindows(),w)}createUntitledWorkspace(f,w,t){return this.workspacesManagementMainService.createUntitledWorkspace(w,t)}deleteUntitledWorkspace(f,w){return this.workspacesManagementMainService.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(f,w){return this.workspacesManagementMainService.getWorkspaceIdentifier(w)}async getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}async addRecentlyOpened(f,w){return this.workspacesHistoryMainService.addRecentlyOpened(w)}async removeRecentlyOpened(f,w){return this.workspacesHistoryMainService.removeRecentlyOpened(w)}async clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};E=he([te(0,M.IWorkspacesManagementMainService),te(1,L.IWindowsMainService),te(2,k.IWorkspacesHistoryMainService),te(3,y.IBackupMainService)],E),e.WorkspacesMainService=E}),define(Z[238],x([0,1,14,30,26,18,17,29,43,40,33,2,10,8,3,15,13,7,28,66,119,35,122,84,229,131,51,220,16,178,157,70,52,219,88,23,54,90,169,185,89,172,20,69,5,71,230,196,101,22,6,180,235,53,21,73,225,74,39,214,98,197,34,199,200,75,42,205,227,231,228,232,97,206,207,208,209,211,36,236,212,27,62,237,46]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m,I,p,u,h,o,c,i,a,r,s,l,g,S,D,A,F,U,X,ne,se,G,J,W,V,B,$,H,_,j,T,R,O,z,N,C,q,Q,ie,oe,ae,ee,le,me,ue,ve,Pe,we,fe,Ee,De,Re,Ne,Ue,Ge,Be,st,Ze,ot,Ye,ut,xe,Y,re,ce,ge,ye,Me,Fe,We){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ce=class extends P.Disposable{constructor(de,Se,be,pe,Ie,Le,ke,Ae,Te,$e){super();this.mainProcessNodeIpcServer=de,this.userEnv=Se,this.mainInstantiationService=be,this.logService=pe,this.environmentMainService=Ie,this.lifecycleMainService=Le,this.configurationService=ke,this.stateMainService=Ae,this.fileService=Te,this.productService=$e,this.configureSession(),this.registerListeners()}configureSession(){const de=pe=>pe?.startsWith(`${b.Schemas.vscodeWebview}://`),Se=new Set(["clipboard-read","clipboard-sanitized-write"]);y.session.defaultSession.setPermissionRequestHandler((pe,Ie,Le,ke)=>de(ke.requestingUrl)?Le(Se.has(Ie)):Le(!1)),y.session.defaultSession.setPermissionCheckHandler((pe,Ie,Le,ke)=>de(ke.requestingUrl)?Se.has(Ie):!1);const be=y.session.defaultSession;typeof be.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&be.setCodeCachePath((0,v.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,E.setUnexpectedErrorHandler)(be=>this.onUnexpectedError(be)),process.on("uncaughtException",be=>(0,E.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,E.onUnexpectedError)(be)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,o.registerContextMenuListener)(),y.app.on("accessibility-support-changed",(be,pe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",pe)}),y.app.on("activate",(be,pe)=>{this.logService.trace("app#activate"),pe||this.windowsMainService?.openEmptyWindow({context:1})}),y.app.on("web-contents-created",(be,pe)=>{pe.on("will-navigate",Ie=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),pe.setWindowOpenHandler(({url:Ie})=>(this.nativeHostMainService?.openExternal(void 0,Ie),{action:"deny"}))});let de=[],Se;y.app.on("open-file",(be,pe)=>{this.logService.trace("app#open-file: ",pe),be.preventDefault(),de.push(this.getWindowOpenableFromPathSync(pe)),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],Se=void 0},100)}),y.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),y.ipcMain.handle("vscode:fetchShellEnv",be=>{const pe=this.windowsMainService?.getWindowByWebContents(be.sender);let Ie,Le;return pe?.config?(Ie=pe.config,Le={...process.env,...pe.config.userEnv}):(Ie=this.environmentMainService.args,Le=process.env),(0,J.resolveShellEnv)(this.logService,Ie,Le)}),y.ipcMain.handle("vscode:writeNlsFile",(be,pe,Ie)=>{const Le=this.validateNlsPath([pe]);if(!Le||typeof Ie!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,M.VSBuffer.fromString(Ie))}),y.ipcMain.handle("vscode:readNlsFile",async(be,...pe)=>{const Ie=this.validateNlsPath(pe);if(!Ie)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ie)).value.toString()}),y.ipcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),y.ipcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),y.ipcMain.on("vscode:reloadWindow",be=>be.sender.reload())}validateNlsPath(de){let Se;for(const be of de)typeof be=="string"&&(typeof Se!="string"?Se=be:Se=(0,v.join)(Se,be));if(!(typeof Se!="string"||!(0,v.isAbsolute)(Se)||!(0,n.isEqualOrParent)(Se,this.environmentMainService.cachedLanguagesPath,!d.isLinux)))return p.URI.file(Se)}onUnexpectedError(de){if(de){const Se={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const de=this.productService.win32AppUserModelId;d.isWindows&&de&&y.app.setAppUserModelId(de);try{d.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!y.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&y.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.logService.error(Te)}const Se=new i.Server;this.logService.trace("Resolving machine identifier...");const be=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:pe,sharedProcessReady:Ie,sharedProcessClient:Le}=this.setupSharedProcess(be),ke=await this.initServices(be,pe,Ie);if(this.environmentMainService.driverHandle){const Te=await(0,X.serve)(Se,this.environmentMainService.driverHandle,this.environmentMainService,ke);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Te)}this._register(ke.createInstance(r.ProxyAuthHandler)),ke.invokeFunction(Te=>this.initChannels(Te,Se,Le));const Ae=ke.invokeFunction(Te=>this.openFirstWindow(Te,Se));ke.invokeFunction(Te=>this.afterWindowOpen(Te,pe)),this.environmentMainService.args.trace&&ke.invokeFunction(Te=>this.stopTracingEventually(Te,Ae))}async resolveMachineId(){let de=this.stateMainService.getItem(we.machineIdKey);return(!de||d.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await(0,h.getMachineId)(),this.stateMainService.setItem(we.machineIdKey,de)),de}setupSharedProcess(de){const Se=this._register(this.mainInstantiationService.createInstance(ee.SharedProcess,de,this.userEnv)),be=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ie=await Se.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new a.Client(Ie,"main")})(),pe=(async()=>(await Se.whenReady(),be))();return{sharedProcess:Se,sharedProcessReady:pe,sharedProcessClient:be}}async initServices(de,Se,be){const pe=new T.ServiceCollection;switch(process.platform){case"win32":pe.set(Re.IUpdateService,new _.SyncDescriptor(st.Win32UpdateService));break;case"linux":d.isLinuxSnap?pe.set(Re.IUpdateService,new _.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(Re.IUpdateService,new _.SyncDescriptor(Ge.LinuxUpdateService));break;case"darwin":pe.set(Re.IUpdateService,new _.SyncDescriptor(Ue.DarwinUpdateService));break}pe.set(re.IWindowsMainService,new _.SyncDescriptor(ce.WindowsMainService,[de,this.userEnv])),pe.set(U.IDialogMainService,new _.SyncDescriptor(U.DialogMainService)),pe.set(z.ILaunchMainService,new _.SyncDescriptor(z.LaunchMainService)),pe.set(F.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(be.then(Le=>Le.getChannel("diagnostics"))))),pe.set(R.IIssueMainService,new _.SyncDescriptor(R.IssueMainService,[this.userEnv])),pe.set(ne.IEncryptionMainService,new _.SyncDescriptor(ne.EncryptionMainService,[de])),pe.set(O.IKeyboardLayoutMainService,new _.SyncDescriptor(O.KeyboardLayoutMainService)),pe.set(ie.INativeHostMainService,new _.SyncDescriptor(ie.NativeHostMainService,[Se])),pe.set(xe.IWebviewManagerService,new _.SyncDescriptor(Y.WebviewMainService)),pe.set(ye.IWorkspacesService,new _.SyncDescriptor(Fe.WorkspacesMainService)),pe.set(We.IWorkspacesManagementMainService,new _.SyncDescriptor(We.WorkspacesManagementMainService)),pe.set(Me.IWorkspacesHistoryMainService,new _.SyncDescriptor(Me.WorkspacesHistoryMainService)),pe.set(Q.IMenubarMainService,new _.SyncDescriptor(Q.MenubarMainService)),pe.set(W.IExtensionUrlTrustService,new _.SyncDescriptor(V.ExtensionUrlTrustService)),pe.set(ve.IStorageMainService,new _.SyncDescriptor(ve.StorageMainService)),d.isWindows?pe.set(B.IExternalTerminalMainService,new _.SyncDescriptor($.WindowsExternalTerminalService)):d.isMacintosh?pe.set(B.IExternalTerminalMainService,new _.SyncDescriptor($.MacExternalTerminalService)):d.isLinux&&pe.set(B.IExternalTerminalMainService,new _.SyncDescriptor($.LinuxExternalTerminalService));const Ie=new g.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(pe.set(l.IBackupMainService,Ie),pe.set(Ze.IURLService,new _.SyncDescriptor(Ye.NativeURLService)),(0,De.getTelemetryLevel)(this.productService,this.environmentMainService)>=2){const Le=(0,c.getDelayedChannel)(be.then(Ke=>Ke.getChannel("telemetryAppender"))),ke=new fe.TelemetryAppenderClient(Le),Ae=(0,Pe.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Te=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],$e={appender:ke,commonProperties:Ae,piiPaths:Te,sendErrorTelemetry:!0};pe.set(we.ITelemetryService,new _.SyncDescriptor(Ee.TelemetryService,[$e]))}else pe.set(we.ITelemetryService,De.NullTelemetryService);return await Ie.initialize(),this.mainInstantiationService.createChild(pe)}initChannels(de,Se,be){const pe=c.ProxyChannel.fromService(de.get(z.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",pe),Se.registerChannel(D.UserConfigurationFileServiceId,c.ProxyChannel.fromService(new D.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const Ie=new Ne.UpdateChannel(de.get(Re.IUpdateService));Se.registerChannel("update",Ie);const Le=c.ProxyChannel.fromService(de.get(R.IIssueMainService));Se.registerChannel("issue",Le);const ke=c.ProxyChannel.fromService(de.get(ne.IEncryptionMainService));Se.registerChannel("encryption",ke);const Ae=c.ProxyChannel.fromService(de.get(le.ISignService));Se.registerChannel("sign",Ae);const Te=c.ProxyChannel.fromService(de.get(O.IKeyboardLayoutMainService));Se.registerChannel("keyboardLayout",Te),this.nativeHostMainService=de.get(ie.INativeHostMainService);const $e=c.ProxyChannel.fromService(this.nativeHostMainService);Se.registerChannel("nativeHost",$e),be.then(He=>He.registerChannel("nativeHost",$e));const Ke=c.ProxyChannel.fromService(de.get(ye.IWorkspacesService));Se.registerChannel("workspaces",Ke);const et=c.ProxyChannel.fromService(de.get(Q.IMenubarMainService));Se.registerChannel("menubar",et);const tt=c.ProxyChannel.fromService(de.get(Ze.IURLService));Se.registerChannel("url",tt);const ht=c.ProxyChannel.fromService(de.get(W.IExtensionUrlTrustService));Se.registerChannel("extensionUrlTrust",ht);const _e=c.ProxyChannel.fromService(de.get(xe.IWebviewManagerService));Se.registerChannel("webview",_e);const it=this._register(new ue.StorageDatabaseChannel(this.logService,de.get(ve.IStorageMainService)));Se.registerChannel("storage",it),be.then(He=>He.registerChannel("storage",it));const nt=c.ProxyChannel.fromService(de.get(B.IExternalTerminalMainService));Se.registerChannel("externalTerminal",nt);const Xe=new q.LogLevelChannel(de.get(C.ILogService));Se.registerChannel("logLevel",Xe),be.then(He=>He.registerChannel("logLevel",Xe));const rt=new q.LoggerChannel(de.get(C.ILoggerService));Se.registerChannel("logger",rt),be.then(He=>He.registerChannel("logger",rt));const at=new A.ElectronExtensionHostDebugBroadcastChannel(de.get(re.IWindowsMainService));Se.registerChannel("extensionhostdebugservice",at)}openFirstWindow(de,Se){const be=this.windowsMainService=de.get(re.IWindowsMainService),pe=de.get(Ze.IURLService),Ie=de.get(ie.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],ke=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Oe=>{try{return{uri:p.URI.parse(Oe),url:Oe}}catch{return}}).filter(Oe=>{if(!Oe||this.shouldBlockURI(Oe.uri))return!1;const Qe=this.getWindowOpenableFromProtocolLink(Oe.uri);return Qe?(Le.push(Qe),!1):!0}),Ae=this,Te=this.environmentMainService,$e=this.productService;pe.registerHandler({async handleURL(Oe,Qe){if(Oe.scheme===$e.urlProtocol&&Oe.path==="workspace"&&(Oe=Oe.with({authority:"file",path:p.URI.parse(Oe.query).path,query:""})),Ae.shouldBlockURI(Oe))return!0;const vt=Ae.getWindowOpenableFromProtocolLink(Oe);if(vt){const[ft]=be.open({context:5,cli:{...Te.args},urisToOpen:[vt],gotoLineMode:!0});return ft.focus(),!0}if(d.isMacintosh&&be.getWindowCount()===0){const[ft]=be.open({context:5,cli:{...Te.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ae.getRemoteAuthority)(Oe)});return await ft.ready(),pe.open(Oe,Qe)}return!1}});const Ke=this._register(new ge.ActiveWindowManager({onDidOpenWindow:Ie.onDidOpenWindow,onDidFocusWindow:Ie.onDidFocusWindow,getActiveWindowId:()=>Ie.getActiveWindowId(-1)})),et=new c.StaticRouter(Oe=>Ke.getActiveClientId().then(Qe=>Oe===Qe)),tt=new ot.URLHandlerRouter(et),ht=Se.getChannel("urlHandler",tt);pe.registerHandler(new ot.URLHandlerChannelClient(ht)),this._register(new ut.ElectronURLListener(ke,pe,be,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,it=global.macOpenFiles,nt=(0,G.isLaunchedFromCli)(process.env)?0:4,Xe=_e._.length,rt=!!_e["folder-uri"],at=!!_e["file-uri"],He=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?p.URI.file(_e.waitMarkerFilePath):void 0,pt=_e.remote||void 0;return Le.length>0?be.open({context:nt,cli:_e,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Xe&&!rt&&!at?be.open({context:nt,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:pt}):it.length&&!Xe&&!rt&&!at?be.open({context:1,cli:_e,urisToOpen:it.map(Oe=>this.getWindowOpenableFromPathSync(Oe)),noRecentEntry:He,waitMarkerFileURI:dt,initialStartup:!0}):be.open({context:nt,cli:_e,forceNewWindow:_e["new-window"]||!Xe&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:He,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(de){return!!(de.authority===b.Schemas.file&&d.isWindows&&y.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,t.mnemonicButtonLabel)((0,s.localize)(0,null)),(0,t.mnemonicButtonLabel)((0,s.localize)(1,null))],defaultId:0,cancelId:1,message:(0,s.localize)(2,null,(0,t.getPathLabel)(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,s.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===b.Schemas.file)return{fileUri:p.URI.file(de.fsPath)};if(de.authority===b.Schemas.vscodeRemote){const Se=de.path.indexOf(v.posix.sep,1);if(Se!==-1){const be=de.path.substring(1,Se),pe=de.path.substring(Se),Ie=p.URI.from({scheme:b.Schemas.vscodeRemote,authority:be,path:pe,query:de.query,fragment:de.fragment});return(0,ye.hasWorkspaceFileExtension)(pe)?{workspaceUri:Ie}:/:[\d]+$/.test(pe)?{fileUri:Ie}:{folderUri:Ie}}}}}getWindowOpenableFromPathSync(de){try{if((0,L.statSync)(de).isDirectory())return{folderUri:p.URI.file(de)};if((0,ye.hasWorkspaceFileExtension)(de))return{workspaceUri:p.URI.file(de)}}catch(Se){}return{fileUri:p.URI.file(de)}}async afterWindowOpen(de,Se){this.lifecycleMainService.phase=3;let be=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>be=!0);const pe=de.get(we.ITelemetryService);this._register(Se.onDidError(({type:ke,details:Ae})=>{let Te;switch(ke){case 1:Te="SharedProcess: detected unresponsive window";break;case 2:Te=`SharedProcess: crashed (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break;case 3:Te=`SharedProcess: failed to load (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break}(0,E.onUnexpectedError)(new Error(Te)),pe.publicLog2("sharedprocesserror",{type:ke,reason:Ae?.reason,code:Ae?.exitCode,visible:Se.isVisible(),shuttingdown:be})}));const Ie=this.productService.win32MutexName;if(d.isWindows&&Ie)try{const ke=K.__$__nodeRequire("windows-mutex").Mutex,Ae=new ke(Ie);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Ae.release())}catch(ke){this.logService.error(ke)}y.protocol.registerHttpProtocol(b.Schemas.vscodeRemoteResource,(ke,Ae)=>{Ae({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})});const Le=de.get(Re.IUpdateService);(Le instanceof st.Win32UpdateService||Le instanceof Ge.LinuxUpdateService||Le instanceof Ue.DarwinUpdateService)&&Le.initialize(),(0,J.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const Ae=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,w.stripComments)(Ae))["enable-crash-reporter"]===void 0){const $e=this.configurationService.getValue("telemetry.enableCrashReporter"),Ke=typeof $e=="boolean"?$e:!0,et=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,u.generateUuid)()}"`,"}"],tt=Ae.substring(0,Ae.length-2).concat(`,
`,et.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(tt))}}catch(ke){this.logService.error(ke)}}stopTracingEventually(de,Se){this.logService.info("Tracing: waiting for windows to get ready...");const be=de.get(U.IDialogMainService);let pe=!1;const Ie=async ke=>{if(pe)return;pe=!0;const Ae=await y.contentTracing.stopRecording((0,m.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);ke?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ae}`):be.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,s.localize)(4,null),detail:(0,s.localize)(5,null,Ae),buttons:[(0,t.mnemonicButtonLabel)((0,s.localize)(6,null))],defaultId:0,noLink:!0},(0,I.withNullAsUndefined)(y.BrowserWindow.getFocusedWindow()))},Le=setTimeout(()=>Ie(!0),3e4);Promise.all(Se.map(ke=>ke.ready())).then(()=>{clearTimeout(Le),Ie(!1)})}};Ce=he([te(2,j.IInstantiationService),te(3,C.ILogService),te(4,se.IEnvironmentMainService),te(5,N.ILifecycleMainService),te(6,S.IConfigurationService),te(7,me.IStateMainService),te(8,H.IFileService),te(9,oe.IProductService)],Ce),e.CodeApplication=Ce}),define(Z[242],x([0,1,14,30,31,9,67,17,29,43,33,10,8,72,3,32,25,19,35,56,238,11,16,189,198,23,54,161,20,183,184,69,174,71,22,92,6,181,93,45,21,55,186,95,222,50,224,74,195,39,226,75,60,204]),function(K,e,y,L,k,M,E,n,f,w,t,P,b,v,d,m,I,p,u,h,o,c,i,a,r,s,l,g,S,D,A,F,U,X,ne,se,G,J,W,V,B,$,H,_,j,T,R,O,z,N,C,q,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ie{main(){try{this.startup()}catch(ee){console.error(ee.message),y.app.exit(1)}}async startup(){(0,n.setUnexpectedErrorHandler)(fe=>console.error(fe));const[ee,le,me,ue,ve,Pe,we]=this.createServices();try{try{await this.initServices(me,ue,ve)}catch(fe){throw this.handleStartupDataDirError(me,we.nameLong,fe),fe}await ee.invokeFunction(async fe=>{const Ee=fe.get(G.ILogService),De=fe.get(ne.ILifecycleMainService),Re=fe.get(S.IFileService),Ne=await this.claimInstance(Ee,me,De,ee,we,!0);return p.Promises.writeFile(me.mainLockfile,String(process.pid)).catch(Ue=>{Ee.warn(`Error writing main lockfile: ${Ue.stack}`)}),Pe.logger=new W.SpdLogLogger("main",(0,b.join)(me.logsPath,"main.log"),!0,Pe.getLevel()),(0,w.once)(De.onWillShutdown)(Ue=>{Re.dispose(),ue.dispose(),Ue.join(p.Promises.unlink(me.mainLockfile).catch(()=>{}))}),ee.createInstance(o.CodeApplication,Ne,le).startup()})}catch(fe){ee.invokeFunction(this.quit,fe)}}createServices(){const ee=new X.ServiceCollection,le={_serviceBrand:void 0,...V.default};ee.set(B.IProductService,le);const me=new s.EnvironmentMainService(this.resolveArgs(),le),ue=this.patchEnvironment(me);ee.set(s.IEnvironmentMainService,me);const ve=new se.BufferLogService,Pe=new G.MultiplexLogService([new G.ConsoleMainLogger((0,G.getLogLevel)(me)),ve]);process.once("exit",()=>Pe.dispose()),ee.set(G.ILogService,Pe);const we=new D.FileService(Pe);ee.set(S.IFileService,we);const fe=new A.DiskFileSystemProvider(Pe);we.registerProvider(P.Schemas.file,fe),ee.set(G.ILoggerService,new J.LoggerService(Pe,we));const Ee=new a.ConfigurationService(me.settingsResource,we);ee.set(i.IConfigurationService,Ee),ee.set(ne.ILifecycleMainService,new F.SyncDescriptor(ne.LifecycleMainService));const De=new C.StateMainService(me,Pe,we);return ee.set(N.IStateMainService,De),ee.set(T.IRequestService,new F.SyncDescriptor(R.RequestMainService)),ee.set(Q.IThemeMainService,new F.SyncDescriptor(Q.ThemeMainService)),ee.set(O.ISignService,new F.SyncDescriptor(z.SignService)),ee.set(_.ITunnelService,new F.SyncDescriptor(j.TunnelService)),ee.set($.IProtocolMainService,new F.SyncDescriptor(H.ProtocolMainService)),[new U.InstantiationService(ee,!0),ue,me,Ee,De,ve,le]}patchEnvironment(ee){const le={VSCODE_IPC_HOOK:ee.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(me=>{const ue=process.env[me];typeof ue=="string"&&(le[me]=ue)}),Object.assign(process.env,le),le}initServices(ee,le,me){return M.Promises.settled([Promise.all([ee.extensionsPath,ee.codeCachePath,ee.logsPath,ee.globalStorageHome.fsPath,ee.workspaceStorageHome.fsPath,ee.backupHome].map(ue=>ue?p.Promises.mkdir(ue,{recursive:!0}):void 0)),le.initialize(),me.init()])}async claimInstance(ee,le,me,ue,ve,Pe){let we;try{(0,v.mark)("code/willStartMainServer"),we=await(0,h.serve)(le.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),(0,w.once)(me.onWillShutdown)(()=>we.dispose())}catch(fe){if(fe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(le,ve.nameLong,fe),fe;let Ee;try{Ee=await(0,h.connect)(le.mainIPCHandle,"main")}catch(Ne){if(!Pe||d.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,ve.nameShort),(0,c.localize)(1,null),ve.nameLong),Ne;try{(0,L.unlinkSync)(le.mainIPCHandle)}catch(Ue){throw ee.warn("Could not delete obsolete instance handle",Ue),Ue}return this.claimInstance(ee,le,me,ue,ve,!1)}if(le.extensionTestsLocationURI&&!le.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ee.error(Ne),Ee.dispose(),new Error(Ne)}let De;!le.args.wait&&!le.args.status&&(De=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,ve.nameShort),(0,c.localize)(3,null),ve.nameLong)},1e4));const Re=u.ProxyChannel.toService(Ee.getChannel("launch"),{disableMarshalling:!0});if(le.args.status)return ue.invokeFunction(async()=>{const Ne=new r.DiagnosticsService(q.NullTelemetryService,ve),Ue=await Re.getMainProcessInfo(),Ge=await Re.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(Ue,Ge);throw console.log(Be),new n.ExpectedError});throw d.isWindows&&await this.windowsAllowSetForegroundWindow(Re,ee),ee.trace("Sending env to running instance..."),await Re.start(le.args,process.env),Ee.dispose(),De&&clearTimeout(De),new n.ExpectedError("Sent env to running instance. Terminating...")}if(le.args.status)throw ee.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new n.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),we}handleStartupDataDirError(ee,le,me){if(me.code==="EACCES"||me.code==="EPERM"){const ue=(0,k.coalesce)([ee.userDataPath,ee.extensionsPath,h.XDG_RUNTIME_DIR]).map(ve=>(0,t.getPathLabel)(ve,ee));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,E.toErrorMessage)(me),ue.join(`
`)),le)}}showStartupWarningDialog(ee,le,me){y.dialog.showMessageBoxSync({title:me,type:"warning",buttons:[(0,t.mnemonicButtonLabel)((0,c.localize)(6,null))],message:ee,detail:le,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ee,le){if(d.isWindows){const me=await ee.getMainProcessId();le.trace("Sending some foreground love to the running instance:",me);try{(await new Promise((ue,ve)=>{K(["windows-foreground-love"],ue,ve)})).allowSetForegroundWindow(me)}catch(ue){le.error(ue)}}}quit(ee,le){const me=ee.get(G.ILogService),ue=ee.get(ne.ILifecycleMainService);let ve=0;le&&(le.isExpected?le.message&&me.trace(le.message):(ve=1,le.stack?me.error(le.stack):me.error(`Startup error: ${le.toString()}`))),ue.kill(ve)}resolveArgs(){const ee=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(ee.wait&&!ee.waitMarkerFilePath){const le=(0,g.createWaitMarkerFile)(ee.verbose);le&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",le),ee.waitMarkerFilePath=le)}return ee}validatePaths(ee){if(ee["open-url"]&&(ee._urls=ee._,ee._=[]),!ee.remote){const le=this.doValidatePaths(ee._,ee.goto);ee._=le}return ee}doValidatePaths(ee,le){const me=(0,m.cwd)(),ue=ee.map(we=>{let fe=String(we),Ee;le&&(Ee=(0,f.parseLineAndColumnAware)(fe),fe=Ee.path),fe&&(fe=this.preparePath(me,fe));const De=(0,f.sanitizeFilePath)(fe,me),Re=(0,b.basename)(De);return Re&&!(0,f.isValidBasename)(Re)?null:le&&Ee?(Ee.path=De,this.toPath(Ee)):De}),ve=d.isWindows||d.isMacintosh,Pe=(0,k.distinct)(ue,we=>we&&ve?we.toLowerCase():we||"");return(0,k.coalesce)(Pe)}preparePath(ee,le){return d.isWindows&&(le=(0,I.rtrim)(le,'"')),le=(0,I.trim)((0,I.trim)(le," "),"	"),d.isWindows&&(le=(0,b.resolve)(ee,le),le=(0,I.rtrim)(le,".")),le}toPath(ee){const le=[ee.path];return typeof ee.line=="number"&&le.push(String(ee.line)),typeof ee.column=="number"&&le.push(String(ee.column)),le.join(":")}}new ie().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ec40cbe164c59f3d13b6eff5fc7b0231ec0ab7aa/core/vs/code/electron-main/main.js.map
