/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/common/errors","vs/base/common/platform","vs/base/node/pfs","vs/base/common/types","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/strings","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/process","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","os","child_process","vs/platform/telemetry/common/telemetry","vs/base/common/stream","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/download/common/download","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/telemetry/common/telemetryService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/iterator","vs/base/common/performance","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Z=function($){for(var t=[],T=0,P=$.length;T<P;T++)t[T]=Q[$[T]];return t};define(Q[58],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function T(P,S){if(!P)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}t.ok=T}),define(Q[46],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function T(L){return(R,c,g)=>{let m=null,I=null;if(typeof g.value=="function"?(m="value",I=g.value):typeof g.get=="function"&&(m="get",I=g.get),!I)throw new Error("not supported");g[m]=L(I,c)}}t.createDecorator=T;function P(L,R,c){let g=null,m=null;if(typeof c.value=="function"?(g="value",m=c.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(g="get",m=c.get),!m)throw new Error("not supported");const I=`$memoize$${R}`;c[g]=function(...d){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,d)}),this[I]}}t.memoize=P;function S(L,R,c){return T((g,m)=>{const I=`$debounce$${m}`,d=`$debounce$result$${m}`;return function(...E){this[d]||(this[d]=c?c():void 0),clearTimeout(this[I]),R&&(this[d]=R(this[d],...E),E=[this[d]]),this[I]=setTimeout(()=>{g.apply(this,E),this[d]=c?c():void 0},L)}})}t.debounce=S;function C(L,R,c){return T((g,m)=>{const I=`$throttle$timer$${m}`,d=`$throttle$result$${m}`,E=`$throttle$lastRun$${m}`,l=`$throttle$pending$${m}`;return function(...u){if(this[d]||(this[d]=c?c():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),R&&(this[d]=R(this[d],...u)),this[l])return;const w=this[E]+L;w<=Date.now()?(this[E]=Date.now(),g.apply(this,[this[d]]),this[d]=c?c():void 0):(this[l]=!0,this[I]=setTimeout(()=>{this[l]=!1,this[E]=Date.now(),g.apply(this,[this[d]]),this[d]=c?c():void 0},w-Date.now()))}})}t.throttle=C}),define(Q[59],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var T;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(T=t.ScanError||(t.ScanError={}));var P;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(P=t.SyntaxKind||(t.SyntaxKind={}));var S;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(S=t.ParseErrorCode||(t.ParseErrorCode={}));var C;(function(e){e.DEFAULT={allowTrailingComma:!0}})(C=t.ParseOptions||(t.ParseOptions={}));function L(e,i=!1){let r=0,n=e.length,a="",y=0,b=16,A=0;function p(ee){let ce=0,le=0;for(;ce<ee;){const _=e.charCodeAt(r);if(_>=48&&_<=57)le=le*16+_-48;else if(_>=65&&_<=70)le=le*16+_-65+10;else if(_>=97&&_<=102)le=le*16+_-97+10;else break;r++,ce++}return ce<ee&&(le=-1),le}function O(ee){r=ee,a="",y=0,b=16,A=0}function N(){const ee=r;if(e.charCodeAt(r)===48)r++;else for(r++;r<e.length&&g(e.charCodeAt(r));)r++;if(r<e.length&&e.charCodeAt(r)===46)if(r++,r<e.length&&g(e.charCodeAt(r)))for(r++;r<e.length&&g(e.charCodeAt(r));)r++;else return A=3,e.substring(ee,r);let ce=r;if(r<e.length&&(e.charCodeAt(r)===69||e.charCodeAt(r)===101))if(r++,(r<e.length&&e.charCodeAt(r)===43||e.charCodeAt(r)===45)&&r++,r<e.length&&g(e.charCodeAt(r))){for(r++;r<e.length&&g(e.charCodeAt(r));)r++;ce=r}else A=3;return e.substring(ee,ce)}function j(){let ee="",ce=r;for(;;){if(r>=n){ee+=e.substring(ce,r),A=2;break}const le=e.charCodeAt(r);if(le===34){ee+=e.substring(ce,r),r++;break}if(le===92){if(ee+=e.substring(ce,r),r++,r>=n){A=2;break}switch(e.charCodeAt(r++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:const ne=p(4);ne>=0?ee+=String.fromCharCode(ne):A=4;break;default:A=5}ce=r;continue}if(le>=0&&le<=31)if(c(le)){ee+=e.substring(ce,r),A=2;break}else A=6;r++}return ee}function Y(){if(a="",A=0,y=r,r>=n)return y=n,b=17;let ee=e.charCodeAt(r);if(R(ee)){do r++,a+=String.fromCharCode(ee),ee=e.charCodeAt(r);while(R(ee));return b=15}if(c(ee))return r++,a+=String.fromCharCode(ee),ee===13&&e.charCodeAt(r)===10&&(r++,a+=`
`),b=14;switch(ee){case 123:return r++,b=1;case 125:return r++,b=2;case 91:return r++,b=3;case 93:return r++,b=4;case 58:return r++,b=6;case 44:return r++,b=5;case 34:return r++,a=j(),b=10;case 47:const ce=r-1;if(e.charCodeAt(r+1)===47){for(r+=2;r<n&&!c(e.charCodeAt(r));)r++;return a=e.substring(ce,r),b=12}if(e.charCodeAt(r+1)===42){r+=2;const le=n-1;let _=!1;for(;r<le;){if(e.charCodeAt(r)===42&&e.charCodeAt(r+1)===47){r+=2,_=!0;break}r++}return _||(r++,A=1),a=e.substring(ce,r),b=13}return a+=String.fromCharCode(ee),r++,b=16;case 45:if(a+=String.fromCharCode(ee),r++,r===n||!g(e.charCodeAt(r)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=N(),b=11;default:for(;r<n&&te(ee);)r++,ee=e.charCodeAt(r);if(y!==r){switch(a=e.substring(y,r),a){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return a+=String.fromCharCode(ee),r++,b=16}}function te(ee){if(R(ee)||c(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let ee;do ee=Y();while(ee>=12&&ee<=15);return ee}return{setPosition:O,getPosition:()=>r,scan:i?se:Y,getToken:()=>b,getTokenValue:()=>a,getTokenOffset:()=>y,getTokenLength:()=>r-y,getTokenError:()=>A}}t.createScanner=L;function R(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function g(e){return e>=48&&e<=57}var m;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(m||(m={}));function I(e,i){const r=[],n=new Object;let a;const y={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function A(p,O,N,j){y.value=p,y.offset=O,y.length=N,y.type=j,y.colonOffset=void 0,a=y}try{h(e,{onObjectBegin:(p,O)=>{if(i<=p)throw n;a=void 0,b=i>p,r.push("")},onObjectProperty:(p,O,N)=>{if(i<O||(A(p,O,N,"property"),r[r.length-1]=p,i<=O+N))throw n},onObjectEnd:(p,O)=>{if(i<=p)throw n;a=void 0,r.pop()},onArrayBegin:(p,O)=>{if(i<=p)throw n;a=void 0,r.push(0)},onArrayEnd:(p,O)=>{if(i<=p)throw n;a=void 0,r.pop()},onLiteralValue:(p,O,N)=>{if(i<O||(A(p,O,N,s(p)),i<=O+N))throw n},onSeparator:(p,O,N)=>{if(i<=O)throw n;if(p===":"&&a&&a.type==="property")a.colonOffset=O,b=!1,a=void 0;else if(p===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(b=!0,r[r.length-1]=""),a=void 0}}})}catch(p){if(p!==n)throw p}return{path:r,previousNode:a,isAtPropertyKey:b,matches:p=>{let O=0;for(let N=0;O<p.length&&N<r.length;N++)if(p[O]===r[N]||p[O]==="*")O++;else if(p[O]!=="**")return!1;return O===p.length}}}t.getLocation=I;function d(e,i=[],r=C.DEFAULT){let n=null,a=[];const y=[];function b(p){Array.isArray(a)?a.push(p):n!==null&&(a[n]=p)}return h(e,{onObjectBegin:()=>{const p={};b(p),y.push(a),a=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{a=y.pop()},onArrayBegin:()=>{const p=[];b(p),y.push(a),a=p,n=null},onArrayEnd:()=>{a=y.pop()},onLiteralValue:b,onError:(p,O,N)=>{i.push({error:p,offset:O,length:N})}},r),a[0]}t.parse=d;function E(e,i=[],r=C.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){n.type==="property"&&(n.length=p-n.offset,n=n.parent)}function y(p){return n.children.push(p),p}h(e,{onObjectBegin:p=>{n=y({type:"object",offset:p,length:-1,parent:n,children:[]})},onObjectProperty:(p,O,N)=>{n=y({type:"property",offset:O,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:p,offset:O,length:N,parent:n})},onObjectEnd:(p,O)=>{n.length=p+O-n.offset,n=n.parent,a(p+O)},onArrayBegin:(p,O)=>{n=y({type:"array",offset:p,length:-1,parent:n,children:[]})},onArrayEnd:(p,O)=>{n.length=p+O-n.offset,n=n.parent,a(p+O)},onLiteralValue:(p,O,N)=>{y({type:s(p),offset:O,length:N,parent:n,value:p}),a(O+N)},onSeparator:(p,O,N)=>{n.type==="property"&&(p===":"?n.colonOffset=O:p===","&&a(O))},onError:(p,O,N)=>{i.push({error:p,offset:O,length:N})}},r);const A=n.children[0];return A&&delete A.parent,A}t.parseTree=E;function l(e,i){if(!e)return;let r=e;for(let n of i)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const y of r.children)if(Array.isArray(y.children)&&y.children[0].value===n){r=y.children[1],a=!0;break}if(!a)return}else{const a=n;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}t.findNodeAtLocation=l;function u(e){if(!e.parent||!e.parent.children)return[];const i=u(e.parent);if(e.parent.type==="property"){const r=e.parent.children[0].value;i.push(r)}else if(e.parent.type==="array"){const r=e.parent.children.indexOf(e);r!==-1&&i.push(r)}return i}t.getNodePath=u;function w(e){switch(e.type){case"array":return e.children.map(w);case"object":const i=Object.create(null);for(let r of e.children){const n=r.children[1];n&&(i[r.children[0].value]=w(n))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=w;function f(e,i,r=!1){return i>=e.offset&&i<e.offset+e.length||r&&i===e.offset+e.length}t.contains=f;function v(e,i,r=!1){if(f(e,i,r)){const n=e.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=i;a++){const y=v(n[a],i,r);if(y)return y}return e}}t.findNodeAtOffset=v;function h(e,i,r=C.DEFAULT){const n=L(e,!1);function a(B){return B?()=>B(n.getTokenOffset(),n.getTokenLength()):()=>!0}function y(B){return B?X=>B(X,n.getTokenOffset(),n.getTokenLength()):()=>!0}const b=a(i.onObjectBegin),A=y(i.onObjectProperty),p=a(i.onObjectEnd),O=a(i.onArrayBegin),N=a(i.onArrayEnd),j=y(i.onLiteralValue),Y=y(i.onSeparator),te=a(i.onComment),se=y(i.onError),ee=r&&r.disallowComments,ce=r&&r.allowTrailingComma;function le(){for(;;){const B=n.scan();switch(n.getTokenError()){case 4:_(14);break;case 5:_(15);break;case 3:_(13);break;case 1:ee||_(11);break;case 2:_(12);break;case 6:_(16);break}switch(B){case 12:case 13:ee?_(10):te();break;case 16:_(1);break;case 15:case 14:break;default:return B}}}function _(B,X=[],k=[]){if(se(B),X.length+k.length>0){let F=n.getToken();for(;F!==17;){if(X.indexOf(F)!==-1){le();break}else if(k.indexOf(F)!==-1)break;F=le()}}}function ne(B){const X=n.getTokenValue();return B?j(X):A(X),le(),!0}function z(){switch(n.getToken()){case 11:let B=0;try{B=JSON.parse(n.getTokenValue()),typeof B!="number"&&(_(2),B=0)}catch(X){_(2)}j(B);break;case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return le(),!0}function D(){return n.getToken()!==10?(_(3,[],[2,5]),!1):(ne(!1),n.getToken()===6?(Y(":"),le(),G()||_(4,[],[2,5])):_(5,[],[2,5]),!0)}function M(){b(),le();let B=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(B||_(4,[],[]),Y(","),le(),n.getToken()===2&&ce)break}else B&&_(6,[],[]);D()||_(4,[],[2,5]),B=!0}return p(),n.getToken()!==2?_(7,[2],[]):le(),!0}function U(){O(),le();let B=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(B||_(4,[],[]),Y(","),le(),n.getToken()===4&&ce)break}else B&&_(6,[],[]);G()||_(4,[],[4,5]),B=!0}return N(),n.getToken()!==4?_(8,[4],[]):le(),!0}function G(){switch(n.getToken()){case 3:return U();case 1:return M();case 10:return ne(!0);default:return z()}}return le(),n.getToken()===17?r.allowEmptyContent?!0:(_(4,[],[]),!1):G()?(n.getToken()!==17&&_(9,[],[]),!0):(_(4,[],[]),!1)}t.visit=h;function o(e,i){let r=L(e),n=[],a,y=0,b;do switch(b=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:y!==b&&n.push(e.substring(y,b)),i!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,i)),y=r.getPosition();break}while(a!==17);return n.join("")}t.stripComments=o;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function $(S){const C=[];typeof S=="number"&&C.push("code/timeOrigin",S);function L(c){C.push(c,Date.now())}function R(){const c=[];for(let g=0;g<C.length;g+=2)c.push({name:C[g],startTime:C[g+1]});return c}return{mark:L,getMarks:R}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const L of performance.getEntriesByType("mark"))C.push({name:L.name,startTime:Math.round(S+L.startTime)});return C}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function T(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=t()),S.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=T(P))}(),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var T=t();for(var P in T)(typeof exports=="object"?exports:$)[P]=T[P]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function T(P){if(t[P])return t[P].exports;var S=t[P]={i:P,l:!1,exports:{}};return $[P].call(S.exports,S,S.exports,T),S.l=!0,S.exports}return T.m=$,T.c=t,T.d=function(P,S,C){T.o(P,S)||Object.defineProperty(P,S,{enumerable:!0,get:C})},T.r=function(P){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},T.t=function(P,S){if(1&S&&(P=T(P)),8&S||4&S&&typeof P=="object"&&P&&P.__esModule)return P;var C=Object.create(null);if(T.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:P}),2&S&&typeof P!="string")for(var L in P)T.d(C,L,function(R){return P[R]}.bind(null,L));return C},T.n=function(P){var S=P&&P.__esModule?function(){return P.default}:function(){return P};return T.d(S,"a",S),S},T.o=function(P,S){return Object.prototype.hasOwnProperty.call(P,S)},T.p="",T(T.s=0)}([function($,t,T){(function(P){var S;t=$.exports=k,S=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var C=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,R=t.re=[],c=t.src=[],g=0,m=g++;c[m]="0|[1-9]\\d*";var I=g++;c[I]="[0-9]+";var d=g++;c[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=g++;c[E]="("+c[m]+")\\.("+c[m]+")\\.("+c[m]+")";var l=g++;c[l]="("+c[I]+")\\.("+c[I]+")\\.("+c[I]+")";var u=g++;c[u]="(?:"+c[m]+"|"+c[d]+")";var w=g++;c[w]="(?:"+c[I]+"|"+c[d]+")";var f=g++;c[f]="(?:-("+c[u]+"(?:\\."+c[u]+")*))";var v=g++;c[v]="(?:-?("+c[w]+"(?:\\."+c[w]+")*))";var h=g++;c[h]="[0-9A-Za-z-]+";var o=g++;c[o]="(?:\\+("+c[h]+"(?:\\."+c[h]+")*))";var s=g++,e="v?"+c[E]+c[f]+"?"+c[o]+"?";c[s]="^"+e+"$";var i="[v=\\s]*"+c[l]+c[v]+"?"+c[o]+"?",r=g++;c[r]="^"+i+"$";var n=g++;c[n]="((?:<|>)?=?)";var a=g++;c[a]=c[I]+"|x|X|\\*";var y=g++;c[y]=c[m]+"|x|X|\\*";var b=g++;c[b]="[v=\\s]*("+c[y]+")(?:\\.("+c[y]+")(?:\\.("+c[y]+")(?:"+c[f]+")?"+c[o]+"?)?)?";var A=g++;c[A]="[v=\\s]*("+c[a]+")(?:\\.("+c[a]+")(?:\\.("+c[a]+")(?:"+c[v]+")?"+c[o]+"?)?)?";var p=g++;c[p]="^"+c[n]+"\\s*"+c[b]+"$";var O=g++;c[O]="^"+c[n]+"\\s*"+c[A]+"$";var N=g++;c[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=g++;c[j]="(?:~>?)";var Y=g++;c[Y]="(\\s*)"+c[j]+"\\s+",R[Y]=new RegExp(c[Y],"g");var te=g++;c[te]="^"+c[j]+c[b]+"$";var se=g++;c[se]="^"+c[j]+c[A]+"$";var ee=g++;c[ee]="(?:\\^)";var ce=g++;c[ce]="(\\s*)"+c[ee]+"\\s+",R[ce]=new RegExp(c[ce],"g");var le=g++;c[le]="^"+c[ee]+c[b]+"$";var _=g++;c[_]="^"+c[ee]+c[A]+"$";var ne=g++;c[ne]="^"+c[n]+"\\s*("+i+")$|^$";var z=g++;c[z]="^"+c[n]+"\\s*("+e+")$|^$";var D=g++;c[D]="(\\s*)"+c[n]+"\\s*("+i+"|"+c[b]+")",R[D]=new RegExp(c[D],"g");var M=g++;c[M]="^\\s*("+c[b]+")\\s+-\\s+("+c[b]+")\\s*$";var U=g++;c[U]="^\\s*("+c[A]+")\\s+-\\s+("+c[A]+")\\s*$";var G=g++;c[G]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)S(B,c[B]),R[B]||(R[B]=new RegExp(c[B]));function X(x,q){if(x instanceof k)return x;if(typeof x!="string"||x.length>C||!(q?R[r]:R[s]).test(x))return null;try{return new k(x,q)}catch(K){return null}}function k(x,q){if(x instanceof k){if(x.loose===q)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof k))return new k(x,q);S("SemVer",x,q),this.loose=q;var K=x.trim().match(q?R[r]:R[s]);if(!K)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(oe){if(/^[0-9]+$/.test(oe)){var ue=+oe;if(ue>=0&&ue<L)return ue}return oe}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=X,t.valid=function(x,q){var K=X(x,q);return K?K.version:null},t.clean=function(x,q){var K=X(x.trim().replace(/^[=v]+/,""),q);return K?K.version:null},t.SemVer=k,k.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},k.prototype.toString=function(){return this.version},k.prototype.compare=function(x){return S("SemVer.compare",this.version,this.loose,x),x instanceof k||(x=new k(x,this.loose)),this.compareMain(x)||this.comparePre(x)},k.prototype.compareMain=function(x){return x instanceof k||(x=new k(x,this.loose)),W(this.major,x.major)||W(this.minor,x.minor)||W(this.patch,x.patch)},k.prototype.comparePre=function(x){if(x instanceof k||(x=new k(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var q=0;do{var K=this.prerelease[q],oe=x.prerelease[q];if(S("prerelease compare",q,K,oe),K===void 0&&oe===void 0)return 0;if(oe===void 0)return 1;if(K===void 0)return-1;if(K!==oe)return W(K,oe)}while(++q)},k.prototype.inc=function(x,q){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},t.inc=function(x,q,K,oe){typeof K=="string"&&(oe=K,K=void 0);try{return new k(x,K).inc(q,oe).version}catch(ue){return null}},t.diff=function(x,q){if(re(x,q))return null;var K=X(x),oe=X(q);if(K.prerelease.length||oe.prerelease.length){for(var ue in K)if((ue==="major"||ue==="minor"||ue==="patch")&&K[ue]!==oe[ue])return"pre"+ue;return"prerelease"}for(var ue in K)if((ue==="major"||ue==="minor"||ue==="patch")&&K[ue]!==oe[ue])return ue},t.compareIdentifiers=W;var F=/^[0-9]+$/;function W(x,q){var K=F.test(x),oe=F.test(q);return K&&oe&&(x=+x,q=+q),K&&!oe?-1:oe&&!K?1:x<q?-1:x>q?1:0}function V(x,q,K){return new k(x,K).compare(new k(q,K))}function H(x,q,K){return V(x,q,K)>0}function J(x,q,K){return V(x,q,K)<0}function re(x,q,K){return V(x,q,K)===0}function ie(x,q,K){return V(x,q,K)!==0}function ge(x,q,K){return V(x,q,K)>=0}function ve(x,q,K){return V(x,q,K)<=0}function de(x,q,K,oe){var ue;switch(q){case"===":typeof x=="object"&&(x=x.version),typeof K=="object"&&(K=K.version),ue=x===K;break;case"!==":typeof x=="object"&&(x=x.version),typeof K=="object"&&(K=K.version),ue=x!==K;break;case"":case"=":case"==":ue=re(x,K,oe);break;case"!=":ue=ie(x,K,oe);break;case">":ue=H(x,K,oe);break;case">=":ue=ge(x,K,oe);break;case"<":ue=J(x,K,oe);break;case"<=":ue=ve(x,K,oe);break;default:throw new TypeError("Invalid operator: "+q)}return ue}function ye(x,q){if(x instanceof ye){if(x.loose===q)return x;x=x.value}if(!(this instanceof ye))return new ye(x,q);S("comparator",x,q),this.loose=q,this.parse(x),this.semver===Re?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}t.rcompareIdentifiers=function(x,q){return W(q,x)},t.major=function(x,q){return new k(x,q).major},t.minor=function(x,q){return new k(x,q).minor},t.patch=function(x,q){return new k(x,q).patch},t.compare=V,t.compareLoose=function(x,q){return V(x,q,!0)},t.rcompare=function(x,q,K){return V(q,x,K)},t.sort=function(x,q){return x.sort(function(K,oe){return t.compare(K,oe,q)})},t.rsort=function(x,q){return x.sort(function(K,oe){return t.rcompare(K,oe,q)})},t.gt=H,t.lt=J,t.eq=re,t.neq=ie,t.gte=ge,t.lte=ve,t.cmp=de,t.Comparator=ye;var Re={};function pe(x,q){if(x instanceof pe)return x.loose===q?x:new pe(x.raw,q);if(x instanceof ye)return new pe(x.value,q);if(!(this instanceof pe))return new pe(x,q);if(this.loose=q,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function we(x){return!x||x.toLowerCase()==="x"||x==="*"}function ze(x,q,K,oe,ue,De,Ee,Oe,Pe,Te,ke,Ie,Le){return((q=we(K)?"":we(oe)?">="+K+".0.0":we(ue)?">="+K+"."+oe+".0":">="+q)+" "+(Oe=we(Pe)?"":we(Te)?"<"+(+Pe+1)+".0.0":we(ke)?"<"+Pe+"."+(+Te+1)+".0":Ie?"<="+Pe+"."+Te+"."+ke+"-"+Ie:"<="+Oe)).trim()}function We(x,q){for(var K=0;K<x.length;K++)if(!x[K].test(q))return!1;if(q.prerelease.length){for(K=0;K<x.length;K++)if(S(x[K].semver),x[K].semver!==Re&&x[K].semver.prerelease.length>0){var oe=x[K].semver;if(oe.major===q.major&&oe.minor===q.minor&&oe.patch===q.patch)return!0}return!1}return!0}function Me(x,q,K){try{q=new pe(q,K)}catch(oe){return!1}return q.test(x)}function Ve(x,q,K,oe){var ue,De,Ee,Oe,Pe;switch(x=new k(x,oe),q=new pe(q,oe),K){case">":ue=H,De=ve,Ee=J,Oe=">",Pe=">=";break;case"<":ue=J,De=ge,Ee=H,Oe="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(x,q,oe))return!1;for(var Te=0;Te<q.set.length;++Te){var ke=q.set[Te],Ie=null,Le=null;if(ke.forEach(function(Fe){Fe.semver===Re&&(Fe=new ye(">=0.0.0")),Ie=Ie||Fe,Le=Le||Fe,ue(Fe.semver,Ie.semver,oe)?Ie=Fe:Ee(Fe.semver,Le.semver,oe)&&(Le=Fe)}),Ie.operator===Oe||Ie.operator===Pe||(!Le.operator||Le.operator===Oe)&&De(x,Le.semver)||Le.operator===Pe&&Ee(x,Le.semver))return!1}return!0}ye.prototype.parse=function(x){var q=this.loose?R[ne]:R[z],K=x.match(q);if(!K)throw new TypeError("Invalid comparator: "+x);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new k(K[2],this.loose):this.semver=Re},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(x){return S("Comparator.test",x,this.loose),this.semver===Re||(typeof x=="string"&&(x=new k(x,this.loose)),de(x,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(x,q){if(!(x instanceof ye))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new pe(x.value,q),Me(this.value,K,q);if(x.operator==="")return K=new pe(this.value,q),Me(x.semver,K,q);var oe=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),ue=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),De=this.semver.version===x.semver.version,Ee=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Oe=de(this.semver,"<",x.semver,q)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Pe=de(this.semver,">",x.semver,q)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return oe||ue||De&&Ee||Oe||Pe},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(x){var q=this.loose;x=x.trim(),S("range",x,q);var K=q?R[U]:R[M];x=x.replace(K,ze),S("hyphen replace",x),x=x.replace(R[D],"$1$2$3"),S("comparator trim",x,R[D]),x=(x=(x=x.replace(R[Y],"$1~")).replace(R[ce],"$1^")).split(/\s+/).join(" ");var oe=q?R[ne]:R[z],ue=x.split(" ").map(function(De){return function(Ee,Oe){return S("comp",Ee),Ee=function(Pe,Te){return Pe.trim().split(/\s+/).map(function(ke){return function(Ie,Le){S("caret",Ie,Le);var Fe=Le?R[_]:R[le];return Ie.replace(Fe,function(Ae,he,me,Se,be){var Ce;return S("caret",Ie,Ae,he,me,Se,be),we(he)?Ce="":we(me)?Ce=">="+he+".0.0 <"+(+he+1)+".0.0":we(Se)?Ce=he==="0"?">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":">="+he+"."+me+".0 <"+(+he+1)+".0.0":be?(S("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),Ce=he==="0"?me==="0"?">="+he+"."+me+"."+Se+be+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+be+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+be+" <"+(+he+1)+".0.0"):(S("no pr"),Ce=he==="0"?me==="0"?">="+he+"."+me+"."+Se+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+" <"+(+he+1)+".0.0"),S("caret return",Ce),Ce})}(ke,Te)}).join(" ")}(Ee,Oe),S("caret",Ee),Ee=function(Pe,Te){return Pe.trim().split(/\s+/).map(function(ke){return function(Ie,Le){var Fe=Le?R[se]:R[te];return Ie.replace(Fe,function(Ae,he,me,Se,be){var Ce;return S("tilde",Ie,Ae,he,me,Se,be),we(he)?Ce="":we(me)?Ce=">="+he+".0.0 <"+(+he+1)+".0.0":we(Se)?Ce=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":be?(S("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),Ce=">="+he+"."+me+"."+Se+be+" <"+he+"."+(+me+1)+".0"):Ce=">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0",S("tilde return",Ce),Ce})}(ke,Te)}).join(" ")}(Ee,Oe),S("tildes",Ee),Ee=function(Pe,Te){return S("replaceXRanges",Pe,Te),Pe.split(/\s+/).map(function(ke){return function(Ie,Le){Ie=Ie.trim();var Fe=Le?R[O]:R[p];return Ie.replace(Fe,function(Ae,he,me,Se,be,Ce){S("xRange",Ie,Ae,he,me,Se,be,Ce);var je=we(me),xe=je||we(Se),Ue=xe||we(be);return he==="="&&Ue&&(he=""),je?Ae=he===">"||he==="<"?"<0.0.0":"*":he&&Ue?(xe&&(Se=0),Ue&&(be=0),he===">"?(he=">=",xe?(me=+me+1,Se=0,be=0):Ue&&(Se=+Se+1,be=0)):he==="<="&&(he="<",xe?me=+me+1:Se=+Se+1),Ae=he+me+"."+Se+"."+be):xe?Ae=">="+me+".0.0 <"+(+me+1)+".0.0":Ue&&(Ae=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),S("xRange return",Ae),Ae})}(ke,Te)}).join(" ")}(Ee,Oe),S("xrange",Ee),Ee=function(Pe,Te){return S("replaceStars",Pe,Te),Pe.trim().replace(R[G],"")}(Ee,Oe),S("stars",Ee),Ee}(De,q)}).join(" ").split(/\s+/);return this.loose&&(ue=ue.filter(function(De){return!!De.match(oe)})),ue=ue.map(function(De){return new ye(De,q)})},pe.prototype.intersects=function(x,q){if(!(x instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(oe){return x.set.some(function(ue){return ue.every(function(De){return oe.intersects(De,q)})})})})},t.toComparators=function(x,q){return new pe(x,q).set.map(function(K){return K.map(function(oe){return oe.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new k(x,this.loose));for(var q=0;q<this.set.length;q++)if(We(this.set[q],x))return!0;return!1},t.satisfies=Me,t.maxSatisfying=function(x,q,K){var oe=null,ue=null;try{var De=new pe(q,K)}catch(Ee){return null}return x.forEach(function(Ee){De.test(Ee)&&(oe&&ue.compare(Ee)!==-1||(ue=new k(oe=Ee,K)))}),oe},t.minSatisfying=function(x,q,K){var oe=null,ue=null;try{var De=new pe(q,K)}catch(Ee){return null}return x.forEach(function(Ee){De.test(Ee)&&(oe&&ue.compare(Ee)!==1||(ue=new k(oe=Ee,K)))}),oe},t.validRange=function(x,q){try{return new pe(x,q).range||"*"}catch(K){return null}},t.ltr=function(x,q,K){return Ve(x,q,"<",K)},t.gtr=function(x,q,K){return Ve(x,q,">",K)},t.outside=Ve,t.prerelease=function(x,q){var K=X(x,q);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(x,q,K){return x=new pe(x,K),q=new pe(q,K),x.intersects(q)},t.coerce=function(x){if(x instanceof k)return x;if(typeof x!="string")return null;var q=x.match(R[N]);return q==null?null:X((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,T(1))},function($,t){var T,P,S=$.exports={};function C(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function R(w){if(T===setTimeout)return setTimeout(w,0);if((T===C||!T)&&setTimeout)return T=setTimeout,setTimeout(w,0);try{return T(w,0)}catch(f){try{return T.call(null,w,0)}catch(v){return T.call(this,w,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:C}catch(w){T=C}try{P=typeof clearTimeout=="function"?clearTimeout:L}catch(w){P=L}})();var c,g=[],m=!1,I=-1;function d(){m&&c&&(m=!1,c.length?g=c.concat(g):I=-1,g.length&&E())}function E(){if(!m){var w=R(d);m=!0;for(var f=g.length;f;){for(c=g,g=[];++I<f;)c&&c[I].run();I=-1,f=g.length}c=null,m=!1,function(v){if(P===clearTimeout)return clearTimeout(v);if((P===L||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(v);try{P(v)}catch(h){try{return P.call(null,v)}catch(o){return P.call(this,v)}}}(w)}}function l(w,f){this.fun=w,this.array=f}function u(){}S.nextTick=function(w){var f=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)f[v-1]=arguments[v];g.push(new l(w,f)),g.length!==1||m||R(E)},l.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=u,S.addListener=u,S.once=u,S.off=u,S.removeListener=u,S.removeAllListeners=u,S.emit=u,S.prependListener=u,S.prependOnceListener=u,S.listeners=function(w){return[]},S.binding=function(w){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(w){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Q[37],Z([0,1,9,2]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function S(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=S;function C(h){const o=h;return o?S(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=C;function L(h,o){return new R(h,o)}t.newWriteableStream=L;class R{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,T.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(s);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(h,o){const s=[];let e;for(;(e=h.read())!==null;)s.push(e);return o(s)}t.consumeReadable=c;function g(h,o,s){const e=[];let i;for(;(i=h.read())!==null&&e.length<s;)e.push(i);return i===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const r=i;return i=void 0,r}return h.read()}}}t.peekReadable=g;function m(h,o){return new Promise((s,e)=>{const i=[];I(h,{onData:r=>{o&&i.push(r)},onError:r=>{o?e(r):s(void 0)},onEnd:()=>{s(o?o(i):void 0)}})})}t.consumeStream=m;function I(h,o){h.on("error",s=>o.onError(s)),h.on("end",()=>o.onEnd()),h.on("data",s=>o.onData(s))}t.listenStream=I;function d(h,o){return new Promise((s,e)=>{const i=new P.DisposableStore,r=[],n=b=>{if(r.push(b),r.length>o)return i.dispose(),h.pause(),s({stream:h,buffer:r,ended:!1})},a=b=>e(b),y=()=>s({stream:h,buffer:r,ended:!0});i.add((0,P.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),i.add((0,P.toDisposable)(()=>h.removeListener("end",y))),h.on("end",y),i.add((0,P.toDisposable)(()=>h.removeListener("data",n))),h.on("data",n)})}t.peekStream=d;function E(h,o){const s=L(o);return s.end(h),s}t.toStream=E;function l(){const h=L(()=>{throw new Error("not supported")});return h.end(),h}t.emptyStream=l;function u(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}t.toReadable=u;function w(h,o,s){const e=L(s);return I(h,{onData:i=>e.write(o.data(i)),onError:i=>e.error(o.error?o.error(i):i),onEnd:()=>e.end()}),e}t.transform=w;function f(h,o,s){let e=!1;return{read:()=>{const i=o.read();return e?i:(e=!0,i!==null?s([h,i]):h)}}}t.prefixedReadable=f;function v(h,o,s){let e=!1;const i=L(s);return I(o,{onData:r=>e?i.write(r):(e=!0,i.write(s([h,r]))),onError:r=>i.error(r),onEnd:()=>{e||(e=!0,i.write(h)),i.end()}}),i}t.prefixedStream=v}),define(Q[17],Z([0,1,37]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const P=typeof Buffer!="undefined";let S,C;class L{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return P?new L(Buffer.allocUnsafe(n)):new L(new Uint8Array(n))}static wrap(n){return P&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new L(n)}static fromString(n,a){return!(a?.dontUseNodeBuffer||!1)&&P?new L(Buffer.from(n)):(S||(S=new TextEncoder),new L(S.encode(n)))}static concat(n,a){if(typeof a=="undefined"){a=0;for(let A=0,p=n.length;A<p;A++)a+=n[A].byteLength}const y=L.alloc(a);let b=0;for(let A=0,p=n.length;A<p;A++){const O=n[A];y.set(O,b),b+=O.byteLength}return y}toString(){return P?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(n,a){return new L(this.buffer.subarray(n,a))}set(n,a){n instanceof L?this.buffer.set(n.buffer,a):this.buffer.set(n,a)}readUInt32BE(n){return g(this.buffer,n)}writeUInt32BE(n,a){m(this.buffer,n,a)}readUInt32LE(n){return I(this.buffer,n)}writeUInt32LE(n,a){d(this.buffer,n,a)}readUInt8(n){return E(this.buffer,n)}writeUInt8(n,a){l(this.buffer,n,a)}}t.VSBuffer=L;function R(r,n){return r[n+0]<<0>>>0|r[n+1]<<8>>>0}t.readUInt16LE=R;function c(r,n,a){r[a+0]=n&255,n=n>>>8,r[a+1]=n&255}t.writeUInt16LE=c;function g(r,n){return r[n]*2**24+r[n+1]*2**16+r[n+2]*2**8+r[n+3]}t.readUInt32BE=g;function m(r,n,a){r[a+3]=n,n=n>>>8,r[a+2]=n,n=n>>>8,r[a+1]=n,n=n>>>8,r[a]=n}t.writeUInt32BE=m;function I(r,n){return r[n+0]<<0>>>0|r[n+1]<<8>>>0|r[n+2]<<16>>>0|r[n+3]<<24>>>0}t.readUInt32LE=I;function d(r,n,a){r[a+0]=n&255,n=n>>>8,r[a+1]=n&255,n=n>>>8,r[a+2]=n&255,n=n>>>8,r[a+3]=n&255}t.writeUInt32LE=d;function E(r,n){return r[n]}t.readUInt8=E;function l(r,n,a){r[a]=n}t.writeUInt8=l;function u(r){return T.consumeReadable(r,n=>L.concat(n))}t.readableToBuffer=u;function w(r){return T.toReadable(r)}t.bufferToReadable=w;function f(r){return T.consumeStream(r,n=>L.concat(n))}t.streamToBuffer=f;async function v(r){return r.ended?L.concat(r.buffer):L.concat([...r.buffer,await f(r.stream)])}t.bufferedStreamToBuffer=v;function h(r){return T.toStream(r,n=>L.concat(n))}t.bufferToStream=h;function o(r){return T.transform(r,{data:n=>typeof n=="string"?L.fromString(n):L.wrap(n)},n=>L.concat(n))}t.streamToBufferReadableStream=o;function s(r){return T.newWriteableStream(n=>L.concat(n),r)}t.newWriteableBufferStream=s;function e(r,n){return T.prefixedReadable(r,n,a=>L.concat(a))}t.prefixedBufferReadable=e;function i(r,n){return T.prefixedStream(r,n,a=>L.concat(a))}t.prefixedBufferStream=i}),define(Q[18],Z([0,1,12]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function P(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const w=Array.isArray(u)?[]:{};return Object.keys(u).forEach(f=>{u[f]&&typeof u[f]=="object"?w[f]=P(u[f]):w[f]=u[f]}),w}t.deepClone=P;function S(u){if(!u||typeof u!="object")return u;const w=[u];for(;w.length>0;){const f=w.shift();Object.freeze(f);for(const v in f)if(C.call(f,v)){const h=f[v];typeof h=="object"&&!Object.isFrozen(h)&&w.push(h)}}return u}t.deepFreeze=S;const C=Object.prototype.hasOwnProperty;function L(u,w){return R(u,w,new Set)}t.cloneAndChange=L;function R(u,w,f){if((0,T.isUndefinedOrNull)(u))return u;const v=w(u);if(typeof v!="undefined")return v;if((0,T.isArray)(u)){const h=[];for(const o of u)h.push(R(o,w,f));return h}if((0,T.isObject)(u)){if(f.has(u))throw new Error("Cannot clone recursive data-structure");f.add(u);const h={};for(let o in u)C.call(u,o)&&(h[o]=R(u[o],w,f));return f.delete(u),h}return u}function c(u,w,f=!0){return(0,T.isObject)(u)?((0,T.isObject)(w)&&Object.keys(w).forEach(v=>{v in u?f&&((0,T.isObject)(u[v])&&(0,T.isObject)(w[v])?c(u[v],w[v],f):u[v]=w[v]):u[v]=w[v]}),u):w}t.mixin=c;function g(u,w){if(u===w)return!0;if(u==null||w===null||w===void 0||typeof u!=typeof w||typeof u!="object"||Array.isArray(u)!==Array.isArray(w))return!1;let f,v;if(Array.isArray(u)){if(u.length!==w.length)return!1;for(f=0;f<u.length;f++)if(!g(u[f],w[f]))return!1}else{const h=[];for(v in u)h.push(v);h.sort();const o=[];for(v in w)o.push(v);if(o.sort(),!g(h,o))return!1;for(f=0;f<h.length;f++)if(!g(u[h[f]],w[h[f]]))return!1}return!0}t.equals=g;function m(u){const w=new Set;return JSON.stringify(u,(f,v)=>{if((0,T.isObject)(v)||Array.isArray(v)){if(w.has(v))return"[Circular]";w.add(v)}return v})}t.safeStringify=m;function I(u,w,f){const v=w(u);return typeof v=="undefined"?f:v}t.getOrDefault=I;function d(u,w){const f=Object.create(null);return!u||!w||Object.keys(w).forEach(h=>{const o=u[h],s=w[h];g(o,s)||(f[h]=s)}),f}t.distinct=d;function E(u,w){const f=w.toLowerCase(),v=Object.keys(u).find(h=>h.toLowerCase()===f);return v?u[v]:u[w]}t.getCaseInsensitive=E;function l(u,w){const f=Object.create(null);for(const v of Object.keys(u))w(v,u[v])&&(f[v]=u[v]);return f}t.filter=l}),define(Q[60],Z([0,1,7]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function P(g){const m=g;return m&&typeof m.type=="string"&&typeof m.severity=="string"}t.isRemoteConsoleLog=P;function S(g){const m=[];let I;try{const d=JSON.parse(g.arguments),E=d[d.length-1];E&&E.__$stack&&(d.pop(),I=E.__$stack),m.push(...d)}catch(d){m.push("Unable to log remote console arguments",g.arguments)}return{args:m,stack:I}}t.parse=S;function C(g){if(typeof g!="string")return C(S(g).stack);const m=g;if(m){const I=L(m),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(d&&d.length===4)return{uri:T.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}t.getFirstFrame=C;function L(g){if(!g)return g;const m=g.indexOf(`
`);return m===-1?g:g.substring(0,m)}function R(g,m){const{args:I,stack:d}=S(g),E=typeof I[0]=="string"&&I.length===1;let l=L(d);l&&(l=`(${l.trim()})`);let u=[];if(typeof I[0]=="string"?l&&E?u=[`%c[${m}] %c${I[0]} %c${l}`,c("blue"),c(""),c("grey")]:u=[`%c[${m}] %c${I[0]}`,c("blue"),c(""),...I.slice(1)]:u=[`%c[${m}]%`,c("blue"),...I],l&&!E&&u.push(l),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,u)}t.log=R;function c(g){return`color: ${g}`}}),define(Q[61],Z([0,1,17,21,7]),function($,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function C(m){return JSON.stringify(m,c)}t.stringify=C;function L(m){let I=JSON.parse(m);return I=g(I),I}t.parse=L;var R;(function(m){m[m.Uri=1]="Uri",m[m.Regexp=2]="Regexp",m[m.ScmResource=3]="ScmResource",m[m.ScmResourceGroup=4]="ScmResourceGroup",m[m.ScmProvider=5]="ScmProvider",m[m.CommentController=6]="CommentController",m[m.CommentThread=7]="CommentThread",m[m.CommentThreadReply=8]="CommentThreadReply",m[m.CommentNode=9]="CommentNode",m[m.CommentThreadNode=10]="CommentThreadNode",m[m.TimelineActionContext=11]="TimelineActionContext",m[m.NotebookCellActionContext=12]="NotebookCellActionContext",m[m.TestItemContext=13]="TestItemContext"})(R=t.MarshalledId||(t.MarshalledId={}));function c(m,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,P.regExpFlags)(I)}:I}function g(m,I=0){if(!m||I>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return S.URI.revive(m);case 2:return new RegExp(m.source,m.flags)}if(m instanceof T.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let d=0;d<m.length;++d)m[d]=g(m[d],I+1);else for(const d in m)Object.hasOwnProperty.call(m,d)&&(m[d]=g(m[d],I+1))}return m}t.revive=g}),define(Q[62],Z([0,1,3,33,47,4,21]),function($,t,T,P,S,C,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function R(){return Object.create(null)}t.getEmptyExpression=R;const c="**",g="/",m="[/\\\\]",I="[^/\\\\]",d=/\//g;function E(D){switch(D){case 0:return"";case 1:return`${I}*?`;default:return`(?:${m}|${I}+${m}|${m}${I}+)*?`}}function l(D,M){if(!D)return[];const U=[];let G=!1,B=!1,X="";for(const k of D){switch(k){case M:if(!G&&!B){U.push(X),X="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":B=!0;break;case"]":B=!1;break}X+=k}return X&&U.push(X),U}t.splitGlobAware=l;function u(D){if(!D)return"";let M="";const U=l(D,g);if(U.every(G=>G===c))M=".*";else{let G=!1;U.forEach((B,X)=>{if(B===c){G||(M+=E(2),G=!0);return}let k=!1,F="",W=!1,V="";for(const H of B){if(H!=="}"&&k){F+=H;continue}if(W&&(H!=="]"||!V)){let J;H==="-"?J=H:(H==="^"||H==="!")&&!V?J="^":H===g?J="":J=L.escapeRegExpCharacters(H),V+=J;continue}switch(H){case"{":k=!0;continue;case"[":W=!0;continue;case"}":M+=`(?:${l(F,",").map(ie=>u(ie)).join("|")})`,k=!1,F="";break;case"]":M+="["+V+"]",W=!1,V="";break;case"?":M+=I;continue;case"*":M+=E(1);continue;default:M+=L.escapeRegExpCharacters(H)}}X<U.length-1&&(U[X+1]!==c||X+2<U.length)&&(M+=m),G=!1})}return M}const w=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new S.LRUCache(1e4),i=function(){return!1},r=function(){return null};function n(D,M){if(!D)return r;let U;typeof D!="string"?U=D.pattern:U=D,U=U.trim();const G=`${U}_${!!M.trimForExclusions}`;let B=e.get(G);if(B)return a(B,D);let X;if(w.test(U)){const k=U.substr(4);B=function(F,W){return typeof F=="string"&&F.endsWith(k)?U:null}}else(X=f.exec(y(U,M)))?B=b(X[1],U):(M.trimForExclusions?h:v).test(U)?B=A(U,M):(X=o.exec(y(U,M)))?B=p(X[1].substr(1),U,!0):(X=s.exec(y(U,M)))?B=p(X[1],U,!1):B=O(U);return e.set(G,B),a(B,D)}function a(D,M){return typeof M=="string"?D:function(U,G){return P.isEqualOrParent(U,M.base)?D(C.relative(M.base,U),G):null}}function y(D,M){return M.trimForExclusions&&D.endsWith("/**")?D.substr(0,D.length-2):D}function b(D,M){const U=`/${D}`,G=`\\${D}`,B=function(k,F){return typeof k!="string"?null:F?F===D?M:null:k===D||k.endsWith(U)||k.endsWith(G)?M:null},X=[D];return B.basenames=X,B.patterns=[M],B.allBasenames=X,B}function A(D,M){const U=z(D.slice(1,-1).split(",").map(F=>n(F,M)).filter(F=>F!==r),D),G=U.length;if(!G)return r;if(G===1)return U[0];const B=function(F,W){for(let V=0,H=U.length;V<H;V++)if(U[V](F,W))return D;return null},X=U.find(F=>!!F.allBasenames);X&&(B.allBasenames=X.allBasenames);const k=U.reduce((F,W)=>W.allPaths?F.concat(W.allPaths):F,[]);return k.length&&(B.allPaths=k),B}function p(D,M,U){const G=C.sep===C.posix.sep,B=G?D:D.replace(d,C.sep),X=C.sep+B,k=C.posix.sep+D,F=U?function(W,V){return typeof W=="string"&&(W===B||W.endsWith(X)||!G&&(W===D||W.endsWith(k)))?M:null}:function(W,V){return typeof W=="string"&&(W===B||!G&&W===D)?M:null};return F.allPaths=[(U?"*/":"./")+D],F}function O(D){try{const M=new RegExp(`^${u(D)}$`);return function(U){return M.lastIndex=0,typeof U=="string"&&M.test(U)?D:null}}catch(M){return r}}function N(D,M,U){return!D||typeof M!="string"?!1:j(D)(M,void 0,U)}t.match=N;function j(D,M={}){if(!D)return i;if(typeof D=="string"||ee(D)){const U=n(D,M);if(U===r)return i;const G=function(B,X){return!!U(B,X)};return U.allBasenames&&(G.allBasenames=U.allBasenames),U.allPaths&&(G.allPaths=U.allPaths),G}return _(D,M)}t.parse=j;function Y(D){if(!D)return;let M;return U=>(M||(M=(D()||Promise.resolve([])).then(G=>G?se(G):{})),M.then(G=>!!G[U]))}t.hasSiblingPromiseFn=Y;function te(D){if(!D)return;let M;return U=>{if(!M){const G=D();M=G?se(G):{}}return!!M[U]}}t.hasSiblingFn=te;function se(D){const M={};for(const U of D)M[U]=!0;return M}function ee(D){const M=D;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}t.isRelativePattern=ee;function ce(D){return D.allBasenames||[]}t.getBasenameTerms=ce;function le(D){return D.allPaths||[]}t.getPathTerms=le;function _(D,M){const U=z(Object.getOwnPropertyNames(D).map(F=>ne(F,D[F],M)).filter(F=>F!==r)),G=U.length;if(!G)return r;if(!U.some(F=>!!F.requiresSiblings)){if(G===1)return U[0];const F=function(H,J){for(let re=0,ie=U.length;re<ie;re++){const ge=U[re](H,J);if(ge)return ge}return null},W=U.find(H=>!!H.allBasenames);W&&(F.allBasenames=W.allBasenames);const V=U.reduce((H,J)=>J.allPaths?H.concat(J.allPaths):H,[]);return V.length&&(F.allPaths=V),F}const B=function(F,W,V){let H;for(let J=0,re=U.length;J<re;J++){const ie=U[J];ie.requiresSiblings&&V&&(W||(W=C.basename(F)),H||(H=W.substr(0,W.length-C.extname(F).length)));const ge=ie(F,W,H,V);if(ge)return ge}return null},X=U.find(F=>!!F.allBasenames);X&&(B.allBasenames=X.allBasenames);const k=U.reduce((F,W)=>W.allPaths?F.concat(W.allPaths):F,[]);return k.length&&(B.allPaths=k),B}function ne(D,M,U){if(M===!1)return r;const G=n(D,U);if(G===r)return r;if(typeof M=="boolean")return G;if(M){const B=M.when;if(typeof B=="string"){const X=(k,F,W,V)=>{if(!V||!G(k,F))return null;const H=B.replace("$(basename)",W),J=V(H);return(0,T.isThenable)(J)?J.then(re=>re?D:null):J?D:null};return X.requiresSiblings=!0,X}}return G}function z(D,M){const U=D.filter(F=>!!F.basenames);if(U.length<2)return D;const G=U.reduce((F,W)=>{const V=W.basenames;return V?F.concat(V):F},[]);let B;if(M){B=[];for(let F=0,W=G.length;F<W;F++)B.push(M)}else B=U.reduce((F,W)=>{const V=W.patterns;return V?F.concat(V):F},[]);const X=function(F,W){if(typeof F!="string")return null;if(!W){let H;for(H=F.length;H>0;H--){const J=F.charCodeAt(H-1);if(J===47||J===92)break}W=F.substr(H)}const V=G.indexOf(W);return V!==-1?B[V]:null};X.basenames=G,X.patterns=B,X.allBasenames=G;const k=D.filter(F=>!F.basenames);return k.push(X),k}}),define(Q[63],Z([0,1,33,8,4,10,19,21,7]),function($,t,T,P,S,C,L,R,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function g(n,a,y){if(typeof n=="string"&&(n=c.URI.file(n)),y){const A=y.getWorkspaceFolder(n);if(A){const p=y.getWorkspace().folders.length>1;let O;if((0,L.isEqual)(A.uri,n)?O="":O=(0,L.relativePath)(A.uri,n),p){const N=A.name?A.name:(0,L.basename)(A.uri);O=O?N+" \u2022 "+O:N}return O}}if(n.scheme!==P.Schemas.file&&n.scheme!==P.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,T.hasDriveLetter)(n.fsPath))return(0,S.normalize)(I(n.fsPath));let b=(0,S.normalize)(n.fsPath);return!C.isWindows&&a?.userHome&&(b=E(b,a.userHome.fsPath)),b}t.getPathLabel=g;function m(n){if(!n)return;typeof n=="string"&&(n=c.URI.file(n));const a=(0,L.basename)(n)||(n.scheme===P.Schemas.file?n.fsPath:n.path);return C.isWindows&&(0,T.isRootOrDriveLetter)(a)?I(a):a}t.getBaseLabel=m;function I(n){return(0,T.hasDriveLetter)(n)?n.charAt(0).toUpperCase()+n.slice(1):n}t.normalizeDriveLetter=I;let d=Object.create(null);function E(n,a){if(C.isWindows||!n||!a)return n;let y=d.original===a?d.normalized:void 0;return y||(y=`${(0,R.rtrim)(a,S.posix.sep)}${S.posix.sep}`,d={original:a,normalized:y}),(C.isLinux?n.startsWith(y):(0,R.startsWithIgnoreCase)(n,y))&&(n=`~/${n.substr(y.length)}`),n}t.tildify=E;function l(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=l;const u="\u2026",w="\\\\",f="~";function v(n,a=S.sep){const y=new Array(n.length);let b=!1;for(let A=0;A<n.length;A++){let p=n[A];if(p===""){y[A]=`.${a}`;continue}if(!p){y[A]=p;continue}b=!0;let O="";p.indexOf(w)===0?(O=p.substr(0,p.indexOf(w)+w.length),p=p.substr(p.indexOf(w)+w.length)):p.indexOf(a)===0?(O=p.substr(0,p.indexOf(a)+a.length),p=p.substr(p.indexOf(a)+a.length)):p.indexOf(f)===0&&(O=p.substr(0,p.indexOf(f)+f.length),p=p.substr(p.indexOf(f)+f.length));const N=p.split(a);for(let j=1;b&&j<=N.length;j++)for(let Y=N.length-j;b&&Y>=0;Y--){b=!1;let te=N.slice(Y,Y+j).join(a);for(let se=0;!b&&se<n.length;se++)if(se!==A&&n[se]&&n[se].indexOf(te)>-1){const ee=Y+j===N.length,ce=Y>0&&n[se].indexOf(a)>-1?a+te:te,le=n[se].endsWith(ce);b=!ee||le}if(!b){let se="";(N[0].endsWith(":")||O!=="")&&(Y===1&&(Y=0,j++,te=N[0]+a+te),Y>0&&(se=N[0]+a),se=O+se),Y>0&&(se=se+u+a),se=se+te,Y+j<N.length&&(se=se+a+u),y[A]=se}}b&&(y[A]=p)}return y}t.shorten=v;var h;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(n,a=Object.create(null)){const y=[];let b=!1,A="";for(const p of n)if(p==="$"||b&&p==="{")A&&y.push({value:A,type:h.TEXT}),A="",b=!0;else if(p==="}"&&b){const O=a[A];if(typeof O=="string")O.length&&y.push({value:O,type:h.VARIABLE});else if(O){const N=y[y.length-1];(!N||N.type!==h.SEPARATOR)&&y.push({value:O.label,type:h.SEPARATOR})}A="",b=!1}else A+=p;return A&&!b&&y.push({value:A,type:h.TEXT}),y.filter((p,O)=>{if(p.type===h.SEPARATOR){const N=y[O-1],j=y[O+1];return[N,j].every(Y=>Y&&(Y.type===h.VARIABLE||Y.type===h.TEXT)&&Y.value.length>0)}return!0}).map(p=>p.value).join("")}t.template=o;function s(n,a){return C.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):n.replace(/&&|&/g,y=>y==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(n,a){return C.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,""):C.isWindows?n.replace(/&&|&/g,y=>y==="&"?"&&":"&"):n.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(n){return n.replace(/&/g,"&&")}t.unmnemonicLabel=i;function r(n){const a=n.indexOf("/")!==-1?S.posix:S.win32,y=a.basename(n),b=a.dirname(n);return y.length?{name:y,parentPath:b}:{name:b,parentPath:""}}t.splitName=r}),define(Q[48],Z([0,1,127]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class P{constructor(C="utf8"){this.stringDecoder=new T.StringDecoder(C),this.remaining=null}write(C){const L=[],R=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(R.length<1)return L;let c=0,g,m=c;for(;m<R.length;)if(g=R.charCodeAt(m),g===13||g===10){if(L.push(R.substring(c,m)),m++,m<R.length){const I=g;g=R.charCodeAt(m),(I===13&&g===10||I===10&&g===13)&&m++}c=m}else m++;return this.remaining=c<R.length?R.substr(c):null,L}end(){return this.remaining}}t.LineDecoder=P}),define(Q[64],Z([0,1,38,4,21,11]),function($,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function L(m){const I=(0,P.dirname)(m);if(m===I)return m;const d=((0,P.basename)(m)||m).toLowerCase();try{const l=(0,C.readdirSync)(I).filter(u=>u.toLowerCase()===d);if(l.length===1){const u=L(I);if(u)return(0,P.join)(u,l[0])}else if(l.length>1){const u=l.indexOf(d);if(u>=0){const w=L(I);if(w)return(0,P.join)(w,l[u])}}}catch(E){}return null}t.realcaseSync=L;async function R(m){try{return await C.Promises.realpath(m)}catch(I){const d=g(m);return await C.Promises.access(d,T.constants.R_OK),d}}t.realpath=R;function c(m){try{return T.realpathSync(m)}catch(I){const d=g(m);return T.accessSync(d,T.constants.R_OK),d}}t.realpathSync=c;function g(m){return(0,S.rtrim)((0,P.normalize)(m),P.sep)}}),define(Q[65],Z([0,1,34,4,11]),function($,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,L=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var c;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(c||(c={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class I{constructor(s,e,i){this.exePath=s,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:o=!1}={}){return o?g===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:o=!1,findPreview:s=!1}={}){const e=d({useAlternateBitness:o});if(!e)return null;const i=P.join(e,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(i))return null;let r=-1,n=null;for(const b of await S.Promises.readdir(i)){let A=-1;if(s){const O=b.indexOf("-");if(O<0)continue;const N=b.substring(0,O);if(!C.test(N)||b.substring(O+1)!=="preview")continue;A=parseInt(N,10)}else{if(!C.test(b))continue;A=parseInt(b,10)}if(A<=r)continue;const p=P.join(i,b,"pwsh.exe");!await S.SymlinkSupport.existsFile(p)||(n=p,r=A)}if(!n)return null;const a=e.includes("x86")?" (x86)":"",y=s?" Preview":"";return new I(n,`PowerShell${y}${a}`,!0)}async function l({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=P.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=o?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const r of await S.Promises.readdir(s))if(e.test(r)){const n=P.join(s,r,"pwsh.exe");return new I(n,i)}return null}function u(){const o=P.join(T.homedir(),".dotnet","tools","pwsh.exe");return new I(o,".NET Core PowerShell Global Tool")}function w(){const o=P.join(process.env.windir,g===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(o,"Windows PowerShell",!0)}async function*f(){let o=await E();o&&(yield o),o=await E({useAlternateBitness:!0}),o&&(yield o),o=await l(),o&&(yield o),o=u(),o&&(yield o),o=await E({findPreview:!0}),o&&(yield o),o=await l({findPreview:!0}),o&&(yield o),o=await E({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=w(),o&&(yield o)}async function*v(){for await(const o of f())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=v;async function h(){for await(const o of v())return o;return null}t.getFirstAvailablePowerShellInstallation=h}),define(Q[66],Z([0,1,38,33,2,128,4,10,11]),function($,t,T,P,S,C,L,R,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function g(d,E,l){return I({path:d,isDirectory:!1},E,l)}t.watchFile=g;function m(d,E,l){return I({path:d,isDirectory:!0},E,l)}t.watchFolder=m,t.CHANGE_BUFFER_DELAY=100;function I(d,E,l){if(R.isMacintosh&&(0,P.isEqualOrParent)(d.path,"/Volumes/"))return l(`Refusing to watch ${d.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),S.Disposable.None;const u=(0,L.basename)(d.path),w=new Map;let f=!1,v=[(0,S.toDisposable)(()=>{w.forEach(h=>(0,S.dispose)(h)),w.clear()})];try{const h=(0,T.watch)(d.path);v.push((0,S.toDisposable)(()=>{h.removeAllListeners(),h.close()}));const o=new Set;d.isDirectory&&c.Promises.readdir(d.path).then(s=>s.forEach(e=>o.add(e))),h.on("error",(s,e)=>{f||l(`Failed to watch ${d.path} for changes using fs.watch() (${s}, ${e})`)}),h.on("change",(s,e)=>{if(f)return;let i="";if(e&&(i=e.toString(),R.isMacintosh&&(i=(0,C.normalizeNFC)(i))),!i||s!=="change"&&s!=="rename")return;const r=d.isDirectory?(0,L.join)(d.path,i):d.path;if(d.isDirectory)if(s==="rename"){const n=w.get(r);n&&(0,S.dispose)(n);const a=setTimeout(async()=>{w.delete(r);const y=await c.Promises.exists(r);if(f)return;let b;y?o.has(i)?b="changed":(b="added",o.add(i)):(o.delete(i),b="deleted"),E(b,r)},t.CHANGE_BUFFER_DELAY);w.set(r,(0,S.toDisposable)(()=>clearTimeout(a)))}else{let n;o.has(i)?n="changed":(n="added",o.add(i)),E(n,r)}else if(s==="rename"||i!==u){const n=setTimeout(async()=>{const a=await c.Promises.exists(r);f||(a?(E("changed",r),v=[I(d,E,l)]):E("deleted",r))},t.CHANGE_BUFFER_DELAY);(0,S.dispose)(v),v=[(0,S.toDisposable)(()=>clearTimeout(n))]}else E("changed",r)})}catch(h){c.Promises.exists(d.path).then(o=>{o&&!f&&l(`Failed to watch ${d.path} for changes using fs.watch() (${h.toString()})`)})}return(0,S.toDisposable)(()=>{f=!0,v=(0,S.dispose)(v)})}});var fe=this&&this.__decorate||function($,t,T,P){var S=arguments.length,C=S<3?t:P===null?P=Object.getOwnPropertyDescriptor(t,T):P,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate($,t,T,P);else for(var R=$.length-1;R>=0;R--)(L=$[R])&&(C=(S<3?L(C):S>3?L(t,T,C):L(t,T))||C);return S>3&&C&&Object.defineProperty(t,T,C),C};define(Q[39],Z([0,1,22,3,17,25,46,9,13,2,61,21,12]),function($,t,T,P,S,C,L,R,c,g,m,I,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var E;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(E=t.RequestType||(t.RequestType={}));function l(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(u=t.ResponseType||(t.ResponseType={}));function w(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(f||(f={}));class v{constructor(D){this.buffer=D,this.pos=0}read(D){const M=this.buffer.slice(this.pos,this.pos+D);return this.pos+=M.byteLength,M}}class h{constructor(){this.buffers=[]}get buffer(){return S.VSBuffer.concat(this.buffers)}write(D){this.buffers.push(D)}}var o;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(o||(o={}));function s(z){const D=S.VSBuffer.alloc(4);return D.writeUInt32BE(z,0),D}function e(z){return z.read(4).readUInt32BE(0)}function i(z){const D=S.VSBuffer.alloc(1);return D.writeUInt8(z,0),D}const r={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object)},n=typeof Buffer!="undefined";function a(z,D){if(typeof D=="undefined")z.write(r.Undefined);else if(typeof D=="string"){const M=S.VSBuffer.fromString(D);z.write(r.String),z.write(s(M.byteLength)),z.write(M)}else if(n&&Buffer.isBuffer(D)){const M=S.VSBuffer.wrap(D);z.write(r.Buffer),z.write(s(M.byteLength)),z.write(M)}else if(D instanceof S.VSBuffer)z.write(r.VSBuffer),z.write(s(D.byteLength)),z.write(D);else if(Array.isArray(D)){z.write(r.Array),z.write(s(D.length));for(const M of D)a(z,M)}else{const M=S.VSBuffer.fromString(JSON.stringify(D));z.write(r.Object),z.write(s(M.byteLength)),z.write(M)}}function y(z){switch(z.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return z.read(e(z)).toString();case o.Buffer:return z.read(e(z)).buffer;case o.VSBuffer:return z.read(e(z));case o.Array:{const M=e(z),U=[];for(let G=0;G<M;G++)U.push(y(z));return U}case o.Object:return JSON.parse(z.read(e(z)).toString())}}class b{constructor(D,M,U=null,G=1e3){this.protocol=D,this.ctx=M,this.logger=U,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(D,M){this.channels.set(D,M),setTimeout(()=>this.flushPendingRequests(D),0)}sendResponse(D){switch(D.type){case 200:{const M=this.send([D.type]);this.logger&&this.logger.logOutgoing(M,0,1,w(D.type));return}case 201:case 202:case 204:case 203:{const M=this.send([D.type,D.id],D.data);this.logger&&this.logger.logOutgoing(M,D.id,1,w(D.type),D.data);return}}}send(D,M=void 0){const U=new h;return a(U,D),a(U,M),this.sendBuffer(U.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(M){return 0}}onRawMessage(D){const M=new v(D),U=y(M),G=y(M),B=U[0];switch(B){case 100:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],1,`${l(B)}: ${U[2]}.${U[3]}`,G),this.onPromise({type:B,id:U[1],channelName:U[2],name:U[3],arg:G});case 102:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],1,`${l(B)}: ${U[2]}.${U[3]}`,G),this.onEventListen({type:B,id:U[1],channelName:U[2],name:U[3],arg:G});case 101:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],1,`${l(B)}`),this.disposeActiveRequest({type:B,id:U[1]});case 103:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],1,`${l(B)}`),this.disposeActiveRequest({type:B,id:U[1]})}}onPromise(D){const M=this.channels.get(D.channelName);if(!M){this.collectPendingRequest(D);return}const U=new C.CancellationTokenSource;let G;try{G=M.call(this.ctx,D.name,D.arg,U.token)}catch(k){G=Promise.reject(k)}const B=D.id;G.then(k=>{this.sendResponse({id:B,data:k,type:201}),this.activeRequests.delete(D.id)},k=>{k instanceof Error?this.sendResponse({id:B,data:{message:k.message,name:k.name,stack:k.stack?k.stack.split?k.stack.split(`
`):k.stack:void 0},type:202}):this.sendResponse({id:B,data:k,type:203}),this.activeRequests.delete(D.id)});const X=(0,g.toDisposable)(()=>U.cancel());this.activeRequests.set(D.id,X)}onEventListen(D){const M=this.channels.get(D.channelName);if(!M){this.collectPendingRequest(D);return}const U=D.id,B=M.listen(this.ctx,D.name,D.arg)(X=>this.sendResponse({id:U,data:X,type:204}));this.activeRequests.set(D.id,B)}disposeActiveRequest(D){const M=this.activeRequests.get(D.id);M&&(M.dispose(),this.activeRequests.delete(D.id))}collectPendingRequest(D){let M=this.pendingRequests.get(D.channelName);M||(M=[],this.pendingRequests.set(D.channelName,M));const U=setTimeout(()=>{console.error(`Unknown channel: ${D.channelName}`),D.type===100&&this.sendResponse({id:D.id,data:{name:"Unknown channel",message:`Channel name '${D.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:D,timeoutTimer:U})}flushPendingRequests(D){const M=this.pendingRequests.get(D);if(M){for(const U of M)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(D)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}t.ChannelServer=b;var A;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(A=t.RequestInitiator||(t.RequestInitiator={}));class p{constructor(D,M=null){this.protocol=D,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=M}getChannel(D){const M=this;return{call(U,G,B){return M.isDisposed?Promise.reject(R.canceled()):M.requestPromise(D,U,G,B)},listen(U,G){return M.isDisposed?Promise.reject(R.canceled()):M.requestEvent(D,U,G)}}}requestPromise(D,M,U,G=C.CancellationToken.None){const B=this.lastRequestId++,k={id:B,type:100,channelName:D,name:M,arg:U};if(G.isCancellationRequested)return Promise.reject(R.canceled());let F;return new Promise((V,H)=>{if(G.isCancellationRequested)return H(R.canceled());const J=()=>{const ve=de=>{switch(de.type){case 201:this.handlers.delete(B),V(de.data);break;case 202:this.handlers.delete(B);const ye=new Error(de.data.message);ye.stack=de.data.stack,ye.name=de.data.name,H(ye);break;case 203:this.handlers.delete(B),H(de.data);break}};this.handlers.set(B,ve),this.sendRequest(k)};let re=null;this.state===f.Idle?J():(re=(0,P.createCancelablePromise)(ve=>this.whenInitialized()),re.then(()=>{re=null,J()}));const ie=()=>{re?(re.cancel(),re=null):this.sendRequest({id:B,type:101}),H(R.canceled())},ge=G.onCancellationRequested(ie);F=(0,g.combinedDisposable)((0,g.toDisposable)(ie),ge),this.activeRequests.add(F)}).finally(()=>{this.activeRequests.delete(F)})}requestEvent(D,M,U){const G=this.lastRequestId++,X={id:G,type:102,channelName:D,name:M,arg:U};let k=null;const F=new c.Emitter({onFirstListenerAdd:()=>{k=(0,P.createCancelablePromise)(V=>this.whenInitialized()),k.then(()=>{k=null,this.activeRequests.add(F),this.sendRequest(X)})},onLastListenerRemove:()=>{k?(k.cancel(),k=null):(this.activeRequests.delete(F),this.sendRequest({id:G,type:103}))}}),W=V=>F.fire(V.data);return this.handlers.set(G,W),F.event}sendRequest(D){switch(D.type){case 100:case 102:{const M=this.send([D.type,D.id,D.channelName,D.name],D.arg);this.logger&&this.logger.logOutgoing(M,D.id,0,`${l(D.type)}: ${D.channelName}.${D.name}`,D.arg);return}case 101:case 103:{const M=this.send([D.type,D.id]);this.logger&&this.logger.logOutgoing(M,D.id,0,l(D.type));return}}}send(D,M=void 0){const U=new h;return a(U,D),a(U,M),this.sendBuffer(U.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(M){return 0}}onBuffer(D){const M=new v(D),U=y(M),G=y(M),B=U[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(D.byteLength,0,0,w(B)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],0,w(B),G),this.onResponse({type:U[0],id:U[1],data:G})}}onResponse(D){if(D.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(D.id);M&&M(D)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}fe([L.memoize],p.prototype,"onDidInitializePromise",null),t.ChannelClient=p;class O{constructor(D){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,D(({protocol:M,onDidClientDisconnect:U})=>{c.Event.once(M.onMessage)(B=>{const X=new v(B),k=y(X),F=new b(M,k),W=new p(M);this.channels.forEach((H,J)=>F.registerChannel(J,H));const V={channelServer:F,channelClient:W,ctx:k};this._connections.add(V),this._onDidAddConnection.fire(V),U(()=>{F.dispose(),W.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const D=[];return this._connections.forEach(M=>D.push(M)),D}getChannel(D,M){const U=this;return{call(G,B,X){let k;if((0,d.isFunction)(M)){let W=(0,T.getRandomElement)(U.connections.filter(M));k=W?Promise.resolve(W):c.Event.toPromise(c.Event.filter(U.onDidAddConnection,M))}else k=M.routeCall(U,G,B);const F=k.then(W=>W.channelClient.getChannel(D));return j(F).call(G,B,X)},listen(G,B){if((0,d.isFunction)(M))return U.getMulticastEvent(D,M,G,B);const X=M.routeEvent(U,G,B).then(k=>k.channelClient.getChannel(D));return j(X).listen(G,B)}}}getMulticastEvent(D,M,U,G){const B=this;let X=new g.DisposableStore;const k=new c.Emitter({onFirstListenerAdd:()=>{X=new g.DisposableStore;const F=new c.EventMultiplexer,W=new Map,V=J=>{const ie=J.channelClient.getChannel(D).listen(U,G),ge=F.add(ie);W.set(J,ge)},H=J=>{const re=W.get(J);!re||(re.dispose(),W.delete(J))};B.connections.filter(M).forEach(V),c.Event.filter(B.onDidAddConnection,M)(V,void 0,X),B.onDidRemoveConnection(H,void 0,X),F.event(k.fire,k,X),X.add(F)},onLastListenerRemove:()=>{X.dispose()}});return k.event}registerChannel(D,M){this.channels.set(D,M),this._connections.forEach(U=>{U.channelServer.registerChannel(D,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=O;class N{constructor(D,M,U=null){const G=new h;a(G,M),D.send(G.buffer),this.channelClient=new p(D,U),this.channelServer=new b(D,M,U)}getChannel(D){return this.channelClient.getChannel(D)}registerChannel(D,M){this.channelServer.registerChannel(D,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=N;function j(z){return{call(D,M,U){return z.then(G=>G.call(D,M,U))},listen(D,M){const U=new c.Relay;return z.then(G=>U.input=G.listen(D,M)),U.event}}}t.getDelayedChannel=j;function Y(z){let D=!1;return{call(M,U,G){return D?z.call(M,U,G):(0,P.timeout)(0).then(()=>D=!0).then(()=>z.call(M,U,G))},listen(M,U){if(D)return z.listen(M,U);const G=new c.Relay;return(0,P.timeout)(0).then(()=>D=!0).then(()=>G.input=z.listen(M,U)),G.event}}}t.getNextTickChannel=Y;class te{constructor(D){this.fn=D}routeCall(D){return this.route(D)}routeEvent(D){return this.route(D)}async route(D){for(const M of D.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await c.Event.toPromise(D.onDidAddConnection),await this.route(D)}}t.StaticRouter=te;var se;(function(z){function D(G,B){const X=G,k=B&&B.disableMarshalling,F=new Map;for(const W in X)U(W)&&F.set(W,c.Event.buffer(X[W],!0));return new class{listen(W,V){const H=F.get(V);if(H)return H;throw new Error(`Event not found: ${V}`)}call(W,V,H){const J=X[V];if(typeof J=="function"){if(!k&&Array.isArray(H))for(let re=0;re<H.length;re++)H[re]=(0,m.revive)(H[re]);return J.apply(X,H)}throw new Error(`Method not found: ${V}`)}}}z.fromService=D;function M(G,B){const X=B&&B.disableMarshalling;return new Proxy({},{get(k,F){if(typeof F=="string")return B?.properties?.has(F)?B.properties.get(F):U(F)?G.listen(F):async function(...W){let V;B&&!(0,d.isUndefinedOrNull)(B.context)?V=[B.context,...W]:V=W;const H=await G.call(F,V);return X?H:(0,m.revive)(H)};throw new Error(`Property not found: ${String(F)}`)}})}z.toService=M;function U(G){return G[0]==="o"&&G[1]==="n"&&I.isUpperAsciiLetter(G.charCodeAt(2))}})(se=t.ProxyChannel||(t.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let D=z.toString();if(D!=="[object Object]")return D}return z}function le(z){return Array.isArray(z)?z.map(ce):ce(z)}function _(z,D,M,U,G,B,X){X=le(X);const k=ee[G],F=k[U%k.length];let W=[`%c[${z}]%c[${String(D).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${F}`];/\($/.test(B)?(W=W.concat(X),W.push(")")):W.push(X),console.log.apply(console,W)}t.logWithColors=_;class ne{constructor(D,M){this._outgoingPrefix=D,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(D,M,U,G,B){this._totalOutgoing+=D,_(this._outgoingPrefix,this._totalOutgoing,D,M,U,G,B)}logIncoming(D,M,U,G,B){this._totalIncoming+=D,_(this._incomingPrefix,this._totalIncoming,D,M,U,G,B)}}t.IPCLogger=ne}),define(Q[67],Z([0,1,3,13,2,12]),function($,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var L;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=t.StorageHint||(t.StorageHint={}));function R(I){const d=I;return d?.changed instanceof Map||d?.deleted instanceof Set}t.isStorageItemsChangeEvent=R;var c;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(c||(c={}));class g extends S.Disposable{constructor(d,E=Object.create(null)){super();this.database=d,this.options=E,this._onDidChangeStorage=this._register(new P.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((E,l)=>this.accept(l,E)),d.deleted?.forEach(E=>this.accept(E,void 0))}accept(d,E){if(this.state===c.Closed)return;let l=!1;(0,C.isUndefinedOrNull)(E)?l=this.cache.delete(d):this.cache.get(d)!==E&&(this.cache.set(d,E),l=!0),l&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,E){const l=this.cache.get(d);return(0,C.isUndefinedOrNull)(l)?E:l}getBoolean(d,E){const l=this.get(d);return(0,C.isUndefinedOrNull)(l)?E:l==="true"}getNumber(d,E){const l=this.get(d);return(0,C.isUndefinedOrNull)(l)?E:parseInt(l,10)}async set(d,E){if(this.state===c.Closed)return;if((0,C.isUndefinedOrNull)(E))return this.delete(d);const l=String(E);if(this.cache.get(d)!==l)return this.cache.set(d,l),this.pendingInserts.set(d,l),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}async delete(d){if(!(this.state===c.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class m{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((E,l)=>this.items.set(l,E)),d.delete&&d.delete.forEach(E=>this.items.delete(E))}async close(){}}t.InMemoryStorageDatabase=m}),define(Q[68],Z([5,6]),function($,t){return $.create("vs/base/common/date",t)}),define(Q[69],Z([0,1,68]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const P=60,S=P*60,C=S*24,L=C*7,R=C*30,c=C*365;function g(I,d){typeof I!="number"&&(I=I.getTime());const E=Math.round((new Date().getTime()-I)/1e3);if(E<-30)return(0,T.localize)(0,null,g(new Date().getTime()+E*1e3,!1));if(E<30)return(0,T.localize)(1,null);let l;return E<P?(l=E,d?l===1?(0,T.localize)(2,null,l):(0,T.localize)(3,null,l):l===1?(0,T.localize)(4,null,l):(0,T.localize)(5,null,l)):E<S?(l=Math.floor(E/P),d?l===1?(0,T.localize)(6,null,l):(0,T.localize)(7,null,l):l===1?(0,T.localize)(8,null,l):(0,T.localize)(9,null,l)):E<C?(l=Math.floor(E/S),d?l===1?(0,T.localize)(10,null,l):(0,T.localize)(11,null,l):l===1?(0,T.localize)(12,null,l):(0,T.localize)(13,null,l)):E<L?(l=Math.floor(E/C),d?l===1?(0,T.localize)(14,null,l):(0,T.localize)(15,null,l):l===1?(0,T.localize)(16,null,l):(0,T.localize)(17,null,l)):E<R?(l=Math.floor(E/L),d?l===1?(0,T.localize)(18,null,l):(0,T.localize)(19,null,l):l===1?(0,T.localize)(20,null,l):(0,T.localize)(21,null,l)):E<c?(l=Math.floor(E/R),d?l===1?(0,T.localize)(22,null,l):(0,T.localize)(23,null,l):l===1?(0,T.localize)(24,null,l):(0,T.localize)(25,null,l)):(l=Math.floor(E/c),d?l===1?(0,T.localize)(26,null,l):(0,T.localize)(27,null,l):l===1?(0,T.localize)(28,null,l):(0,T.localize)(29,null,l))}t.fromNow=g;function m(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=m}),define(Q[70],Z([5,6]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(Q[29],Z([0,1,22,12,70]),function($,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function C(g,m){return m&&(g.stack||g.stacktrace)?S.localize(0,null,R(g),L(g.stack)||L(g.stacktrace)):R(g)}function L(g){return Array.isArray(g)?g.join(`
`):g}function R(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?S.localize(1,null,g.message):g.message||S.localize(2,null)}function c(g=null,m=!1){if(!g)return S.localize(3,null);if(Array.isArray(g)){const I=T.coalesce(g),d=c(I[0],m);return I.length>1?S.localize(4,null,d,I.length):d}if(P.isString(g))return g;if(g.detail){const I=g.detail;if(I.error)return C(I.error,m);if(I.exception)return C(I.exception,m)}return g.stack?C(g,m):g.message?g.message:S.localize(5,null)}t.toErrorMessage=c}),define(Q[71],Z([5,6]),function($,t){return $.create("vs/base/node/processes",t)}),define(Q[49],Z([0,1,35,33,8,18,4,10,28,12,48,11,71]),function($,t,T,P,S,C,L,R,c,g,m,I,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function E(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(o,s){if(R.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};s&&(e.cwd=s);const i=T.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],e);return new Promise(r=>{i.once("error",n=>{r({success:!1,error:n})}),i.once("exit",(n,a)=>{r(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?E(e.status):1})}else if(R.isLinux||R.isMacintosh)try{const e=S.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(i=>{T.execFile(e,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,n,a)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function u(o=c.env){return o.comspec||"cmd.exe"}t.getWindowsShell=u;class w{constructor(s,e,i,r){if(e!==void 0&&i!==void 0&&r!==void 0)this.cmd=s,this.args=e,this.shell=i,this.options=r;else{const n=s;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(c.env).forEach(a=>{n[a]=c.env[a]}),Object.keys(this.options.env).forEach(a=>{n[a]=this.options.env[a]}),this.options.env=n}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const e=s.lastIndexOf(L.sep);return e!==-1&&(s=s.substring(e+1)),w.WellKnowCommands[s]?s:"other"}start(s){return R.isWindows&&(this.options&&this.options.cwd&&P.isUNC(this.options.cwd)||!this.options&&P.isUNC(c.cwd()))?Promise.reject(new Error(d.localize(0,null))):this.useExec().then(e=>{let i,r;const n=new Promise((a,y)=>{i=a,r=y});if(e){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=T.exec(a,this.options,(y,b,A)=>{this.childProcess=null;const p=y;p&&p.killed?r({killed:this.terminateRequested,stdout:b.toString(),stderr:A.toString()}):this.handleExec(i,s,y,b,A)})}else{let a=null;const y=b=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(b,i,s,r);const A={terminated:this.terminateRequested};g.isNumber(b)&&(A.cmdCode=b),i(A)};if(this.shell&&R.isWindows){const b=C.deepClone(this.options);b.windowsVerbatimArguments=!0,b.detached=!1;let A=!1,p=!1;const O=[];let N=this.ensureQuotes(this.cmd);O.push(N.value),A=N.quoted,this.args&&this.args.forEach(Y=>{N=this.ensureQuotes(Y),O.push(N.value),p=p&&N.quoted});const j=["/s","/c"];A?p?j.push('"'+O.join(" ")+'"'):O.length>1?j.push('"'+O[0]+'" '+O.slice(1).join(" ")):j.push('"'+O[0]+'"'):j.push(O.join(" ")),a=T.spawn(u(),j,b)}else this.cmd&&(a=T.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(g.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",b=>{this.childProcess=null,r({terminated:this.terminateRequested,error:b})}),a.pid&&(this.childProcess.on("close",y),this.handleSpawn(a,i,s,r,!0)))}return n})}handleClose(s,e,i,r){}ensureQuotes(s){return w.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,l(s,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!R.isWindows)return s(!1);const e=T.spawn(u(),["/s","/c"]);e.on("error",i=>s(!0)),e.on("exit",i=>s(!1))})}}t.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class f extends w{constructor(s,e,i,r){super(s,e,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,e,i,r,n){[r,n].forEach((a,y)=>{const b=new m.LineDecoder;b.write(a).forEach(O=>{e({line:O,source:y===0?0:1})});const p=b.end();p&&e({line:p,source:y===0?0:1})}),s({terminated:this.terminateRequested,error:i})}handleSpawn(s,e,i,r,n){const a=new m.LineDecoder,y=new m.LineDecoder;s.stdout.on("data",b=>{a.write(b).forEach(p=>i({line:p,source:0}))}),s.stderr.on("data",b=>{y.write(b).forEach(p=>i({line:p,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=y}handleClose(s,e,i,r){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&i({line:n,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}t.LineProcess=f;function v(o){let s=[],e=!1;const i=function(r){if(e){s.push(r);return}(!o.send(r,a=>{if(a&&console.error(a),e=!1,s.length>0){const y=s.slice(0);s=[],y.forEach(b=>i(b))}})||R.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=v;var h;(function(o){async function s(e,i,r){if(L.isAbsolute(e))return e;if(i===void 0&&(i=c.cwd()),L.dirname(e)!=="."||(r===void 0&&g.isString(c.env.PATH)&&(r=c.env.PATH.split(L.delimiter)),r===void 0||r.length===0))return L.join(i,e);async function a(y){if(await I.Promises.exists(y)){let b;try{b=await I.Promises.stat(y)}catch(A){A.message.startsWith("EACCES")&&(b=await I.Promises.lstat(y))}return b?!b.isDirectory():!1}return!1}for(let y of r){let b;if(L.isAbsolute(y)?b=L.join(y,e):b=L.join(i,y,e),await a(b))return b;let A=b+".com";if(await a(A)||(A=b+".exe",await a(A)))return A}return L.join(i,e)}o.findExecutable=s})(h=t.win32||(t.win32={}))}),define(Q[72],Z([0,1,34,10,65,49]),function($,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function L(E,l){return E===1?P.isWindows?I():C.getWindowsShell(l):g(E,l)}t.getSystemShell=L;function R(E,l){return E===1?P.isWindows?d(l):C.getWindowsShell(l):g(E,l)}t.getSystemShellSync=R;let c=null;function g(E,l){if(P.isLinux&&E===2||P.isMacintosh&&E===3)return"/bin/bash";if(!c){let u;if(P.isWindows)u="/bin/bash";else{if(u=l.SHELL,!u)try{u=(0,T.userInfo)().shell}catch(w){}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}c=u}return c}let m=null;async function I(){return m||(m=(await(0,S.getFirstAvailablePowerShellInstallation)()).exePath),m}function d(E){if(m)return m;const l=P.isWindows&&parseFloat((0,T.release)())>=10,u=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${E.windir}\\${u?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?w:C.getWindowsShell(E)}}),define(Q[50],Z([0,1,35,3,17,25,60,9,13,2,18,10,49,39]),function($,t,T,P,S,C,L,R,c,g,m,I,d,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class l extends E.ChannelServer{constructor(f){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch(h){}},onMessage:c.Event.fromNodeEventEmitter(process,"message",v=>S.VSBuffer.wrap(Buffer.from(v,"base64")))},f);process.once("disconnect",()=>this.dispose())}}t.Server=l;class u{constructor(f,v){this.modulePath=f,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new P.Delayer(h),this.child=null,this._client=null}getChannel(f){const v=this;return{call(h,o,s){return v.requestPromise(f,h,o,s)},listen(h,o){return v.requestEvent(f,h,o)}}}requestPromise(f,v,h,o=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(f),e=(0,P.createCancelablePromise)(n=>s.call(v,h,n)),i=o.onCancellationRequested(()=>e.cancel()),r=(0,g.toDisposable)(()=>e.cancel());return this.activeRequests.add(r),e.finally(()=>{i.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(f,v,h){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let o;const s=new c.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(f).listen(v,h)(s.fire,s),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),I.isMacintosh&&v.env&&delete v.env.DYLD_LIBRARY_PATH,this.child=(0,T.fork)(this.modulePath,f,v);const h=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,L.isRemoteConsoleLog)(a)){(0,L.log)(a,`IPC Library: ${this.options.serverName}`);return}h.fire(S.VSBuffer.wrap(Buffer.from(a,"base64")))});const s=this.options.useQueue?(0,d.createQueuedSender)(this.child):this.child,e=a=>this.child&&this.child.connected&&s.send(a.buffer.toString("base64")),i=h.event,r={send:e,onMessage:i};this._client=new E.ChannelClient(r);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,y)=>{process.removeListener("exit",n),this.activeRequests.forEach(b=>(0,g.dispose)(b)),this.activeRequests.clear(),a!==0&&y!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+y),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:y})})}return this._client}getCachedChannel(f){let v=this.channels.get(f);return v||(v=this.client.getChannel(f),this.channels.set(f,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=u}),define(Q[73],Z([5,6]),function($,t){return $.create("vs/base/node/zip",t)}),define(Q[74],Z([5,6]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[75],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Q[76],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[77],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Q[78],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[79],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[80],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Q[81],Z([5,6]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[82],Z([5,6]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(Q[83],Z([5,6]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(Q[84],Z([5,6]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[85],Z([5,6]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(Q[86],Z([5,6]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)}),define(Q[87],Z([0,1,69,46,8,4,28,19,7]),function($,t,T,P,S,C,L,R,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class g{constructor(l,u,w){this._args=l,this.paths=u,this.productService=w}get appRoot(){return(0,C.dirname)(S.FileAccess.asFileUri("",$).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const l=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",l)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(c.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return c.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return c.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=L.env.VSCODE_PORTABLE;return l?c.URI.file((0,C.join)(l,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,C.resolve)(l):(0,C.normalize)((0,C.join)(S.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const l=this.args["extensions-download-dir"];return l?(0,C.resolve)(l):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,C.resolve)(l);const u=L.env.VSCODE_EXTENSIONS;if(u)return u;const w=L.env.VSCODE_PORTABLE;return w?(0,C.join)(w,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(u=>/^[^:/?#]+?:\/\//.test(u)?c.URI.parse(u):c.URI.file((0,C.normalize)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?c.URI.parse(l):c.URI.file((0,C.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([P.memoize],g.prototype,"appRoot",null),fe([P.memoize],g.prototype,"userHome",null),fe([P.memoize],g.prototype,"userDataPath",null),fe([P.memoize],g.prototype,"appSettingsHome",null),fe([P.memoize],g.prototype,"tmpDir",null),fe([P.memoize],g.prototype,"userRoamingDataHome",null),fe([P.memoize],g.prototype,"settingsResource",null),fe([P.memoize],g.prototype,"userDataSyncHome",null),fe([P.memoize],g.prototype,"userDataSyncLogResource",null),fe([P.memoize],g.prototype,"sync",null),fe([P.memoize],g.prototype,"machineSettingsResource",null),fe([P.memoize],g.prototype,"globalStorageHome",null),fe([P.memoize],g.prototype,"workspaceStorageHome",null),fe([P.memoize],g.prototype,"keybindingsResource",null),fe([P.memoize],g.prototype,"keyboardLayoutResource",null),fe([P.memoize],g.prototype,"argvResource",null),fe([P.memoize],g.prototype,"snippetsHome",null),fe([P.memoize],g.prototype,"isExtensionDevelopment",null),fe([P.memoize],g.prototype,"untitledWorkspacesHome",null),fe([P.memoize],g.prototype,"installSourcePath",null),fe([P.memoize],g.prototype,"builtinExtensionsPath",null),fe([P.memoize],g.prototype,"extensionsPath",null),fe([P.memoize],g.prototype,"extensionDevelopmentLocationURI",null),fe([P.memoize],g.prototype,"extensionDevelopmentKind",null),fe([P.memoize],g.prototype,"extensionTestsLocationURI",null),fe([P.memoize],g.prototype,"debugExtensionHost",null),fe([P.memoize],g.prototype,"serviceMachineIdResource",null),fe([P.memoize],g.prototype,"telemetryLogResource",null),fe([P.memoize],g.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=g;function m(E,l){return d(E["inspect-extensions"],E["inspect-brk-extensions"],5870,l,E.debugId)}t.parseExtensionHostPort=m;function I(E,l){return d(E["inspect-search"],E["inspect-brk-search"],5876,l)}t.parseSearchPort=I;function d(E,l,u,w,f){const h=Number(l||E)||(w?null:u),o=h?Boolean(!!l):!1;return{port:h,break:o,debugId:f}}}),function(){"use strict";function $(t,T,P,S){function C(R){const c=L(R),g=[c];return t.isAbsolute(c)||g.unshift(S),t.resolve(...g)}function L(R){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return t.join(g,P);const m=R["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=t.join(I,"AppData","Roaming")}break;case"darwin":g=t.join(T.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||t.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(g,P)}return{getUserDataPath:C}}if(typeof define=="function")define(Q[88],Z([0,89,34,8,19,28]),function(t,T,P,S,C,L){const R=C.dirname(S.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(C.joinPath(R,"package.json").fsPath);return $(T,P,c.name,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),T=require("path"),P=require("os");module.exports=$(T,P,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[90],Z([0,1,34,87,88]),function($,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class C extends P.AbstractNativeEnvironmentService{constructor(R,c){super(R,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,S.getUserDataPath)(R)},c)}}t.NativeEnvironmentService=C}),define(Q[91],Z([0,1,18]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const P=/^%([\w\d.-]+)%$/i;function S(C,L){const R=c=>{if(typeof c!="string")return;const g=P.exec(c);if(!g)return;const m=L[g[1]]??c;return typeof m=="string"?m:typeof m.message=="string"?m.message:c};return(0,T.cloneAndChange)(C,R)}t.localizeManifest=S}),define(Q[51],Z([0,1,81]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function C(d){return d=d.trim(),d==="*"||P.test(d)}t.isValidVersionStr=C;function L(d){if(!C(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=d.match(P);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}t.parseVersion=L;function R(d){if(!d)return null;let E=d.majorBase,l=d.majorMustEqual,u=d.minorBase,w=d.minorMustEqual,f=d.patchBase,v=d.patchMustEqual;d.hasCaret&&(E===0||(w=!1),v=!1);let h=0;if(d.preRelease){const o=S.exec(d.preRelease);if(o){const[,s,e,i]=o;h=Date.UTC(Number(s),Number(e)-1,Number(i))}}return{majorBase:E,majorMustEqual:l,minorBase:u,minorMustEqual:w,patchBase:f,patchMustEqual:v,isMinimum:d.hasGreaterEquals,notBefore:h}}t.normalizeVersion=R;function c(d,E,l){let u;typeof d=="string"?u=R(L(d)):u=d;let w;E instanceof Date?w=E.getTime():typeof E=="string"&&(w=new Date(E).getTime());let f;if(typeof l=="string"?f=R(L(l)):f=l,!u||!f)return!1;let v=u.majorBase,h=u.minorBase,o=u.patchBase,s=f.majorBase,e=f.minorBase,i=f.patchBase,r=f.notBefore,n=f.majorMustEqual,a=f.minorMustEqual,y=f.patchMustEqual;return f.isMinimum?v>s?!0:v<s?!1:h>e?!0:h<e||w&&w<r?!1:o>=i:(v===1&&s===0&&(!n||!a||!y)&&(s=1,e=0,i=0,n=!0,a=!1,y=!1),v<s?!1:v>s?!n:h<e?!1:h>e?!a:o<i?!1:o>i?!y:!(w&&w<r))}t.isValidVersion=c;function g(d,E,l,u){return l.isBuiltin||typeof l.main=="undefined"?!0:I(d,E,l.engines.vscode,u)}t.isValidExtensionVersion=g;function m(d,E,l){return d==="*"||I(E,l,d)}t.isEngineValid=m;function I(d,E,l,u=[]){let w=R(L(l));if(!w)return u.push(T.localize(0,null,l)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return u.push(T.localize(1,null,l)),!1}else if(!w.majorMustEqual)return u.push(T.localize(2,null,l)),!1;return c(d,E,w)?!0:(u.push(T.localize(3,null,d,l)),!1)}}),define(Q[92],Z([0,1,2,8,39,50]),function($,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class L extends T.Disposable{constructor(c,g,m,I){super();this.folders=c,this.onDidFilesChange=g,this.onLogMessage=m,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new C.Client(P.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=L.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(c.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.setFolders(this.folders)}setVerboseLogging(c){this.verboseLogging=c,!this.isDisposed&&this.service&&this.service.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${c}`})}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=L,L.MAX_RESTARTS=5}),define(Q[93],Z([0,1,2,8,39,50]),function($,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class L extends T.Disposable{constructor(c,g,m,I,d={}){super();this.folders=c,this.onDidFilesChange=g,this.onLogMessage=m,this.verboseLogging=I,this.watcherOptions=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new C.Client(P.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=L.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(c.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.service.setRoots(this.folders)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${c}`})}setVerboseLogging(c){this.verboseLogging=c,this.service&&this.service.setVerboseLogging(c)}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=L,L.MAX_RESTARTS=5}),define(Q[94],Z([0,1,35,62,8,48]),function($,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class L{constructor(c,g,m,I,d){this.watchedFolder=c,this.eventCallback=m,this.logCallback=I,this.verboseLogging=d,this.restartCounter=0,Array.isArray(g)?this.ignored=g.map(E=>(0,P.parse)(E)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${c}, excludes: ${g.join(",")}`),this.startWatcher()}startWatcher(){const c=[this.watchedFolder];this.verboseLogging&&c.push("-verbose"),this.handle=(0,T.spawn)(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,c);const g=new C.LineDecoder;this.handle.stdout.on("data",m=>{const I=[];for(const d of g.write(m)){const E=d.split("|");if(E.length===2){const l=Number(E[0]),u=E[1];if(l>=0&&l<3){if(this.ignored&&this.ignored.some(w=>w(u))){this.verboseLogging&&this.log(u);continue}I.push({type:L.changeTypeMap[l],path:u})}else this.log(E[1])}}I.length>0&&this.eventCallback(I)}),this.handle.on("error",m=>this.onError(m)),this.handle.stderr.on("data",m=>this.onError(m)),this.handle.on("exit",(m,I)=>this.onExit(m,I))}onError(c){this.error("process error: "+c.toString())}onExit(c,g){this.handle&&(this.error(`terminated unexpectedly (code: ${c}, signal: ${g})`),this.restartCounter<=L.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(c){this.logCallback({type:"error",message:`[File Watcher (C#)] ${c}`})}log(c){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${c}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=L,L.MAX_RESTARTS=5,L.changeTypeMap=[0,1,2]}),define(Q[95],Z([0,1,4,21,94]),function($,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class C{constructor(R,c,g,m){this.onDidFilesChange=c,this.onLogMessage=g,this.verboseLogging=m,this.service=void 0,this.folder=R[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(T.posix.sep)&&(this.folder.path=(0,P.rtrim)(this.folder.path,T.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new S.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,R=>this.onFileEvents(R),R=>this.onLogMessage(R),this.verboseLogging)}setVerboseLogging(R){this.verboseLogging=R,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(R){this.isDisposed||R.length>0&&this.onDidFilesChange(R)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=C}),define(Q[52],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class T{constructor(S,C=[],L=!1){this.ctor=S,this.staticArguments=C,this.supportsDelayedInstantiation=L}}t.SyncDescriptor=T}),define(Q[96],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class T{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}t.Node=T;class P{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let L of this._nodes.values())L.outgoing.size===0&&C.push(L);return C}insertEdge(C,L){const R=this.lookupOrInsertNode(C),c=this.lookupOrInsertNode(L);R.outgoing.set(this._hashFn(L),c),c.incoming.set(this._hashFn(C),R)}removeNode(C){const L=this._hashFn(C);this._nodes.delete(L);for(let R of this._nodes.values())R.outgoing.delete(L),R.incoming.delete(L)}lookupOrInsertNode(C){const L=this._hashFn(C);let R=this._nodes.get(L);return R||(R=new T(C),this._nodes.set(L,R)),R}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[L,R]of this._nodes)C.push(`${L}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,L]of this._nodes){const R=new Set([C]),c=this._findCycle(L,R);if(c)return c}}_findCycle(C,L){for(let[R,c]of C.outgoing){if(L.has(R))return[...L,R].join(" -> ");L.add(R);const g=this._findCycle(c,L);if(g)return g;L.delete(R)}}}t.Graph=P}),define(Q[53],Z([0,1,15]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,T.createDecorator)("downloadService")}),define(Q[20],Z([0,1,15]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,T.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,T.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[23],Z([0,1,8,76,15]),function($,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var C;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE="alpine-x64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(C=t.TargetPlatform||(t.TargetPlatform={}));function L(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=L;function R(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=R;function c(f,v){switch(f){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=c;function g(f,v){return v==="web"&&!f.includes("web")}t.isNotWebExtensionInWebTargetPlatform=g;function m(f,v,h){if(g(v,h))return!1;if(f==="undefined"||f==="universal")return!0;if(f==="unknown")return!1;if(f===h)return!0;switch(h){case"win32-x64":return f==="win32-ia32";case"win32-arm64":return f==="win32-ia32";default:return!1}}t.isTargetPlatformCompatible=m;function I(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=I;var d;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=5]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(d=t.SortBy||(t.SortBy={}));var E;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(E=t.SortOrder||(t.SortOrder={}));var l;(function(f){f.Install="install",f.Uninstall="uninstall"})(l=t.StatisticType||(t.StatisticType={}));var u;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(u=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,S.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class w extends Error{constructor(v,h){super(v);this.code=h,this.name=h}}t.ExtensionManagementError=w,t.IExtensionManagementService=(0,S.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,S.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,S.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),t.ExtensionsLabel=(0,P.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,P.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,S.createDecorator)("IExtensionManagementCLIService")}),define(Q[40],Z([0,1,21,15]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}t.getWorkspaceSupportTypeMessage=S;function C(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}t.isIExtensionIdentifier=C,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(L=t.ExtensionType||(t.ExtensionType={}));class R{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,d){if(typeof I=="undefined"||I===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof I=="string"||typeof d=="string"){let E=typeof I=="string"?I:I.value,l=typeof d=="string"?d:d.value;return T.equalsIgnoreCase(E,l)}return I._lower===d._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}t.ExtensionIdentifier=R;function c(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}t.isLanguagePackExtension=c;function g(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=g,t.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[24],Z([0,1,21,40]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function S(l,u){return l.uuid&&u.uuid?l.uuid===u.uuid:l.id===u.id?!0:(0,T.compareIgnoreCase)(l.id,u.id)===0}t.areSameExtensions=S;class C{constructor(u,w){this.version=w,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof C?S(this,u)&&this.version===u.version:!1}}t.ExtensionIdentifierWithVersion=C;function L(l,u){return`${l}.${u}`}t.getExtensionId=L;function R(l){return l.toLocaleLowerCase()}t.adoptToGalleryExtensionId=R;function c(l,u){return R(L(l,u))}t.getGalleryExtensionId=c;function g(l,u){const w=[],f=v=>{for(const h of w)if(h.some(o=>S(u(o),u(v))))return h;return null};for(const v of l){const h=f(v);h?h.push(v):w.push([v])}return w}t.groupByExtension=g;function m(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=m;function I(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}t.getGalleryExtensionTelemetryData=I,t.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function d(l){const u=new Set;for(const w of l)w.malicious&&u.add(w.id.id);return u}t.getMaliciousExtensionsSet=d;function E(l,u){const w=[],f=u.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const v=f.shift();if(v&&w.every(h=>!S(h.identifier,{id:v}))){const h=l.filter(o=>S(o.identifier,{id:v}));h.length===1&&(w.push(h[0]),f.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}t.getExtensionDependencies=E});var ae=this&&this.__param||function($,t){return function(T,P){t(T,P,$)}};define(Q[97],Z([0,1,25,9,63,8,41,7,77,23,24,40]),function($,t,T,P,S,C,L,R,c,g,m,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const d=v=>(0,c.localize)(0,null,v),E=(0,c.localize)(1,null,"ms-dotnettools.csharp");function l(v,h){return h?`${v.publisher}.${v.name}@${v.version}`:`${v.publisher}.${v.name}`}const u=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function w(v){const h=u.exec(v);return h&&h[1]?[(0,m.adoptToGalleryExtensionId)(h[1]),h[2]]:[(0,m.adoptToGalleryExtensionId)(v),void 0]}t.getIdAndVersion=w;let f=class{constructor(h,o){this.extensionManagementService=h,this.extensionGalleryService=o}get location(){}async listExtensions(h,o,s=console){let e=await this.extensionManagementService.getInstalled(1);const i=I.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(n=>n.manifest.categories?n.manifest.categories.map(y=>y.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){s.log("Possible Categories: "),i.forEach(n=>{s.log(n)});return}this.location&&s.log((0,c.localize)(2,null,this.location)),e=e.sort((n,a)=>n.identifier.id.localeCompare(a.identifier.id));let r;for(let n of e)r!==n.identifier.id&&(r=n.identifier.id,s.log(l(n.manifest,h)))}async installExtensions(h,o,s,e,i=console){const r=[],n=[];h.length&&i.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),y=(p,O)=>{const N=a.find(j=>(0,m.areSameExtensions)(j.identifier,{id:p}));if(N){if(!O&&!e)return i.log((0,c.localize)(5,null,p,N.manifest.version,p)),!1;if(O&&N.manifest.version===O)return i.log((0,c.localize)(6,null,`${p}@${O}`)),!1}return!0},b=[],A=[];for(const p of h)if(p instanceof R.URI)b.push(p);else{const[O,N]=w(p);y(O,N)&&A.push({id:O,version:N,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const p of o){const[O,N]=w(p);y(O,N)&&A.push({id:O,version:N,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(b.length&&await Promise.all(b.map(async p=>{try{const O=await this.installVSIX(p,{isBuiltin:!1,isMachineScoped:s},e,i);O&&n.push(O)}catch(O){i.error(O.message||O.stack||O),r.push(p.toString())}})),A.length){const p=await this.getGalleryExtensions(A);await Promise.all(A.map(async O=>{const N=p.get(O.id.toLowerCase());if(N)try{const j=await this.installFromGallery(O,N,a,e,i);j&&n.push(j)}catch(j){i.error(j.message||j.stack||j),r.push(O.id)}else i.error(`${d(O.version?`${O.id}@${O.version}`:O.id)}
${E}`),r.push(O.id)}))}if(r.length)throw new Error((0,c.localize)(7,null,r.join(", ")))}async installVSIX(h,o,s,e){const i=await this.extensionManagementService.getManifest(h);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,s,e))try{return await this.extensionManagementService.install(h,o),e.log((0,c.localize)(8,null,(0,S.getBaseLabel)(h))),i}catch(n){if((0,P.isPromiseCanceledError)(n))return e.log((0,c.localize)(9,null,(0,S.getBaseLabel)(h))),null;throw n}return null}async getGalleryExtensions(h){const o=new Map,s=await this.extensionGalleryService.getExtensions(h,T.CancellationToken.None);for(const e of s)o.set(e.identifier.id.toLowerCase(),e);return o}async installFromGallery({id:h,version:o,installOptions:s},e,i,r,n){const a=await this.extensionGalleryService.getManifest(e,T.CancellationToken.None);if(a&&!this.validateExtensionKind(a,n))return null;const y=i.find(b=>(0,m.areSameExtensions)(b.identifier,e.identifier));if(y){if(e.version===y.manifest.version)return n.log((0,c.localize)(10,null,o?`${h}@${o}`:h)),null;n.log((0,c.localize)(11,null,h,e.version))}try{return s.isBuiltin?n.log(o?(0,c.localize)(12,null,h,o):(0,c.localize)(13,null,h)):n.log(o?(0,c.localize)(14,null,h,o):(0,c.localize)(15,null,h)),await this.extensionManagementService.installFromGallery(e,{...s,installGivenVersion:!!o}),n.log((0,c.localize)(16,null,h,e.version)),a}catch(b){if((0,P.isPromiseCanceledError)(b))return n.log((0,c.localize)(17,null,h)),null;throw b}}validateExtensionKind(h,o){return!0}async validateVSIX(h,o,s){const e={id:(0,m.getGalleryExtensionId)(h.publisher,h.name)},r=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,m.areSameExtensions)(e,n.identifier)&&(0,L.gt)(n.manifest.version,h.version));return r&&!o?(s.log((0,c.localize)(18,null,r.identifier.id,r.manifest.version,h.version)),!1):this.validateExtensionKind(h,s)}async uninstallExtensions(h,o,s=console){const e=async r=>{if(r instanceof R.URI){const n=await this.extensionManagementService.getManifest(r);return l(n)}return r},i=[];for(const r of h){const n=await e(r),y=(await this.extensionManagementService.getInstalled()).filter(b=>(0,m.areSameExtensions)(b.identifier,{id:n}));if(!y.length)throw new Error(`${this.notInstalled(n)}
${E}`);if(y.some(b=>b.type===0)){s.log((0,c.localize)(19,null,n));return}if(!o&&y.some(b=>b.isBuiltin)){s.log((0,c.localize)(20,null,n));return}s.log((0,c.localize)(21,null,n));for(const b of y)await this.extensionManagementService.uninstall(b),i.push(b);this.location?s.log((0,c.localize)(22,null,n,this.location)):s.log((0,c.localize)(23,null,n))}}async locateExtension(h,o=console){const s=await this.extensionManagementService.getInstalled();h.forEach(e=>{s.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===C.Schemas.file){o.log(i.location.fsPath);return}})})}notInstalled(h){return this.location?(0,c.localize)(24,null,h,this.location):(0,c.localize)(25,null,h)}};f=fe([ae(0,g.IExtensionManagementService),ae(1,g.IExtensionGalleryService)],f),t.ExtensionManagementCLIService=f}),define(Q[98],Z([0,1,2,4,11,40]),function($,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class L extends T.Disposable{constructor(c,g){super();this.environmentService=c,this.extensionsManifestCache=(0,P.join)(this.environmentService.userDataPath,C.MANIFEST_CACHE_FOLDER,C.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(g.onDidUninstallExtension(m=>this.onDidUnInstallExtension(m)))}onDidInstallExtensions(c){c.some(g=>!!g.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){S.Promises.rm(this.extensionsManifestCache,S.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=L}),define(Q[99],Z([0,1,35,89,25,29,9,10,30,72,129]),function($,t,T,P,S,C,L,R,c,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function I(l,u,w){return u["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):R.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,m.isLaunchedFromCli)(w)&&!u["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,m.isLaunchedFromCli)(w)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=new Promise(async f=>{const v=new S.CancellationTokenSource,h=setTimeout(()=>{l.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),v.dispose(!0),f({})},1e4);try{const o=await E(l,v.token);f(o)}catch(o){(0,L.isPromiseCanceledError)(o)||l.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),f({})}finally{clearTimeout(h),v.dispose()}})),d)}t.resolveShellEnv=I;let d;async function E(l,u){const w=new Promise(async(f,v)=>{const h=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",o);const s=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",i);const r=await(0,g.getSystemShell)(R.OS,i);if(l.trace("getUnixShellEnvironment#shell",r),u.isCancellationRequested)return v(L.canceled);const n=P.basename(r);let a,y;/^pwsh(-preview)?$/.test(n)?(a=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,y=["-Login","-Command"]):(a=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,y=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),a);const b=(0,T.spawn)(r,[...y,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});u.onCancellationRequested(()=>(b.kill(),v(L.canceled))),b.on("error",O=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(O)),f({})});const A=[];b.stdout.on("data",O=>A.push(O));const p=[];b.stderr.on("data",O=>p.push(O)),b.on("close",(O,N)=>{const j=Buffer.concat(A).toString("utf8");l.trace("getUnixShellEnvironment#raw",j);const Y=Buffer.concat(p).toString("utf8");if(Y.trim()&&l.trace("getUnixShellEnvironment#stderr",Y),O||N)return v(new Error(`Failed to get environment (code ${O}, signal ${N})`));const te=e.exec(j),se=te?te[1]:"{}";try{const ee=JSON.parse(se);h?ee.ELECTRON_RUN_AS_NODE=h:delete ee.ELECTRON_RUN_AS_NODE,o?ee.ELECTRON_NO_ATTACH_CONSOLE=o:delete ee.ELECTRON_NO_ATTACH_CONSOLE,delete ee.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",ee),f(ee)}catch(ee){l.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(ee)),v(ee)}})});try{return await w}catch(f){return l.error("getUnixShellEnvironment#error",(0,C.toErrorMessage)(f)),{}}}}),define(Q[54],Z([0,1,10,7,16]),function($,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function C(c){return c.map(g=>({type:g.type,resource:P.URI.file(g.path)}))}t.toFileChanges=C;function L(c){const g=new R;for(const m of c)g.processEvent(m);return g.normalize()}t.normalizeFileChanges=L;class R{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(g){const m=this.mapPathToChange.get(g.path);if(m){const I=m.type,d=g.type;I===1&&d===2?(this.mapPathToChange.delete(g.path),this.normalized.splice(this.normalized.indexOf(m),1)):I===2&&d===1?m.type=0:I===1&&d===0||(m.type=d)}else this.normalized.push(g),this.mapPathToChange.set(g.path,g)}normalize(){const g=[],m=[];return this.normalized.filter(I=>I.type!==2?(g.push(I),!1):!0).sort((I,d)=>I.path.length-d.path.length).filter(I=>m.some(d=>(0,S.isParent)(I.path,d,!T.isLinux))?!1:(m.push(I.path),!0)).concat(g)}}}),define(Q[100],Z([0,1,3,2,4,64,11,66,54]),function($,t,T,P,S,C,L,R,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class g extends P.Disposable{constructor(I,d,E,l){super();this.path=I,this.onDidFilesChange=d,this.onLogMessage=E,this.verboseLogging=l,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(R.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:d}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let E=this.path;if(d)try{E=await(0,C.realpath)(E)}catch(l){if(this.onError(l),d.dangling)return}I.isDirectory()?this._register((0,R.watchFolder)(E,(l,u)=>{this.onFileChange({type:l==="changed"?0:l==="added"?1:2,path:(0,S.join)(this.path,(0,S.basename)(u))})},l=>this.onError(l))):this._register((0,R.watchFile)(E,l=>{this.onFileChange({type:l==="changed"?0:2,path:this.path})},l=>this.onError(l)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=(0,c.normalizeFileChanges)(d);if(this.verboseLogging)for(const l of E)this.onVerbose(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);E.length>0&&this.onDidFilesChange(E)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=g}),define(Q[55],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class T{constructor(...S){this._entries=new Map;for(let[C,L]of S)this.set(C,L)}set(S,C){const L=this._entries.get(S);return this._entries.set(S,C),L}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}t.ServiceCollection=T}),define(Q[101],Z([0,1,3,9,52,96,15,55]),function($,t,T,P,S,C,L,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class g extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class m{constructor(l=new R.ServiceCollection,u=!1,w){this._activeInstantiations=new Set,this._services=l,this._strict=u,this._parent=w,this._services.set(L.IInstantiationService,this)}createChild(l){return new m(l,this._strict,this)}invokeFunction(l,...u){let w=d.traceInvocation(l),f=!1;try{return l({get:(h,o)=>{if(f)throw(0,P.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(h,w);if(!s&&o!==L.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return s}},...u)}finally{f=!0,w.stop()}}createInstance(l,...u){let w,f;return l instanceof S.SyncDescriptor?(w=d.traceCreation(l.ctor),f=this._createInstance(l.ctor,l.staticArguments.concat(u),w)):(w=d.traceCreation(l),f=this._createInstance(l,u,w)),w.stop(),f}_createInstance(l,u=[],w){let f=L._util.getServiceDependencies(l).sort((o,s)=>o.index-s.index),v=[];for(const o of f){let s=this._getOrCreateServiceInstance(o.id,w);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${o.id}.`);v.push(s)}let h=f.length>0?f[0].index:u.length;if(u.length!==h){console.warn(`[createInstance] First service dependency of ${l.name} at position ${h+1} conflicts with ${u.length} static arguments`);let o=h-u.length;o>0?u=u.concat(new Array(o)):u=u.slice(0,h)}return new l(...[...u,...v])}_setServiceInstance(l,u){if(this._services.get(l)instanceof S.SyncDescriptor)this._services.set(l,u);else if(this._parent)this._parent._setServiceInstance(l,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let u=this._services.get(l);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):u}_getOrCreateServiceInstance(l,u){let w=this._getServiceInstanceOrDescriptor(l);return w instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,w,u.branch(l,!0)):(u.branch(l,!1),w)}_safeCreateAndCacheServiceInstance(l,u,w){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,u,w)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,u,w){const f=new C.Graph(o=>o.id.toString());let v=0;const h=[{id:l,desc:u,_trace:w}];for(;h.length;){const o=h.pop();if(f.lookupOrInsertNode(o),v++>1e3)throw new g(f);for(let s of L._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${l} depends on ${s.id} which is NOT registered.`),e instanceof S.SyncDescriptor){const i={id:s.id,desc:e,_trace:o._trace.branch(s.id,!0)};f.insertEdge(o,i),h.push(i)}}}for(;;){const o=f.roots();if(o.length===0){if(!f.isEmpty())throw new g(f);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof S.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}f.removeNode(s)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,u,w=[],f,v){if(this._services.get(l)instanceof S.SyncDescriptor)return this._createServiceInstance(u,w,f,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,u,w,f,v);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(l,u=[],w,f){if(w){const v=new T.IdleValue(()=>this._createInstance(l,u,f));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let s=v.value,e=s[o];return typeof e!="function"||(e=e.bind(s),h[o]=e),e},set(h,o,s){return v.value[o]=s,!0}})}else return this._createInstance(l,u,f)}}t.InstantiationService=m;var I;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(I||(I={}));class d{constructor(l,u){this.type=l,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return c?new d(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(l){return c?new d(0,l.name):d._None}branch(l,u){let w=new d(2,l.toString());return this._dep.push([l,u,w]),w}stop(){let l=Date.now()-this._start;d._totals+=l;let u=!1;function w(v,h){let o=[],s=new Array(v+1).join("	");for(const[e,i,r]of h._dep)if(i&&r){u=!0,o.push(`${s}CREATES -> ${e}`);let n=w(v+1,r);n&&o.push(n)}else o.push(`${s}uses -> ${e}`);return o.join(`
`)}let f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(l>2||u)&&console.log(f.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(Q[56],Z([0,1,15]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,T.createDecorator)("localizationsService");function P(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const C of S.translations)if(typeof C.id!="string"||typeof C.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}t.isValidLocalization=P}),define(Q[14],Z([0,1,29,13,2,10,15]),function($,t,T,P,S,C,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,L.createDecorator)("logService"),t.ILoggerService=(0,L.createDecorator)("loggerService");function R(){return new Date().toISOString()}var c;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;class g extends S.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=g;class m extends g{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(c.Trace)&&this.log(c.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(c.Debug)&&this.log(c.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(c.Info)&&this.log(c.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(c.Warning)&&this.log(c.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(c.Error))if(e instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=e.stack,this.log(c.Error,this.format(r))}else this.log(c.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(c.Critical)&&this.log(c.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let r=0;r<e.length;r++){let n=e[r];if(typeof n=="object")try{n=JSON.stringify(n)}catch(a){}i+=(r>0?" ":"")+n}return i}}t.AbstractMessageLogger=m;class I extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!C.isWindows}trace(e,...i){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...i):console.log(`[main ${R()}]`,e,...i))}debug(e,...i){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...i):console.log(`[main ${R()}]`,e,...i))}info(e,...i){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...i):console.log(`[main ${R()}]`,e,...i))}warn(e,...i){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,e,...i):console.warn(`[main ${R()}]`,e,...i))}error(e,...i){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,e,...i):console.error(`[main ${R()}]`,e,...i))}critical(e,...i){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,e,...i):console.error(`[main ${R()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=I;class d extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=d;class E extends g{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=E;class l extends g{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const r of this.logServices)r.trace(e,...i)}debug(e,...i){for(const r of this.logServices)r.debug(e,...i)}info(e,...i){for(const r of this.logServices)r.info(e,...i)}warn(e,...i){for(const r of this.logServices)r.warn(e,...i)}error(e,...i){for(const r of this.logServices)r.error(e,...i)}critical(e,...i){for(const r of this.logServices)r.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=l;class u extends S.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=u;class w extends S.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(r))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let r=this.loggers.get(e.toString());return r||(r=this.doCreateLogger(e,i?.always?c.Trace:this.logLevel,i),this.loggers.set(e.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=w;class f{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=f;function v(s){if(s.verbose)return c.Trace;if(typeof s.logLevel=="string"){const e=h(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=v;function h(s){switch(s){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=h;function o(s){switch(s){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=o}),define(Q[102],Z([0,1,3,9,2,10,19,41,7,30,11,20,23,24,16,14]),function($,t,T,P,S,C,L,R,c,g,m,I,d,E,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let f=class extends S.Disposable{constructor(h,o,s,e){super();this.fileService=o,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=c.URI.file(h.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(h,o){await this.cleanUpPromise;const s=this.getName(h),e=(0,L.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const i=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,g.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(h,i,o);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(i)}catch(n){}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",h.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,i.path),r}}return e}async delete(h){}async rename(h,o,s){try{await m.Promises.rename(h.fsPath,o.fsPath)}catch(e){if(C.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${h} to ${o} with 'EPERM' error. Trying again...`),this.rename(h,o,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const o=[],s=[];for(const r of h.children){const n=this.parse(r.name);n&&s.push([n,r])}const e=(0,E.groupByExtension)(s,([r])=>r),i=[];for(const r of e)r.sort((n,a)=>R.rcompare(n[0].version,a[0].version)),o.push(...r.slice(1).map(n=>n[1].resource)),i.push(r[0][1]);i.sort((r,n)=>r.mtime-n.mtime),o.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(r=>r.resource)),await T.Promises.settled(o.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?`${new E.ExtensionIdentifierWithVersion(h.identifier,h.version).key().toLowerCase()}${h.properties.targetPlatform!=="undefined"?`-${h.properties.targetPlatform}`:""}`:(0,g.generateUuid)()}parse(h){const o=w.exec(h);return o&&o[1]&&o[2]?new E.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};f=fe([ae(0,I.INativeEnvironmentService),ae(1,l.IFileService),ae(2,d.IExtensionGalleryService),ae(3,u.ILogService)],f),t.ExtensionsDownloader=f}),define(Q[103],Z([0,1,35,3,29,13,2,8,4,11,20,14]),function($,t,T,P,S,C,L,R,c,g,m,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let d=class extends L.Disposable{constructor(l,u){super();this.environmentService=l,this.logService=u,this.processesLimiter=new P.Limiter(5)}async postUninstall(l){const u=this.parseScript(l,"uninstall");return u&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(u.script,"uninstall",u.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),w=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${w}`)))),g.Promises.rm(this.getExtensionStoragePath(l)).then(void 0,w=>this.logService.error("Error while removing extension storage path",w))}parseScript(l,u){const w=`vscode:${u}`;if(l.location.scheme===R.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[w]=="string"){const f=l.manifest.scripts[w].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${w} should be a node script`),null):{script:(0,c.join)(l.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(l,u,w,f,v){return new Promise((h,o)=>{const s=this.start(l,u,w,v);let e;const i=r=>{e&&(clearTimeout(e),e=null),r?o(r):h(void 0)};s.on("error",r=>{i((0,S.toErrorMessage)(r)||"Unknown")}),s.on("exit",(r,n)=>{i(r?`post-${u} process exited with code ${r}`:void 0)}),f&&(e=setTimeout(()=>{e=null,s.kill(),o("timed out")},5e3))})}start(l,u,w,f){const v={silent:!0,execArgv:void 0},h=(0,T.fork)(l,[`--type=extension-post-${u}`,...w],v);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const o=C.Event.fromNodeEventEmitter(h.stdout,"data"),s=C.Event.fromNodeEventEmitter(h.stderr,"data");o(r=>this.logService.info(f.identifier.id,f.manifest.version,`post-${u}`,r)),s(r=>this.logService.error(f.identifier.id,f.manifest.version,`post-${u}`,r));const e=C.Event.any(C.Event.map(o,r=>({data:`%c${r}`,format:[""]})),C.Event.map(s,r=>({data:`%c${r}`,format:["color: red"]})));return C.Event.debounce(e,(r,n)=>r?{data:r.data+n.data,format:[...r.format,...n.format]}:{data:n.data,format:n.format},100)(r=>{console.group(f.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),h}getExtensionStoragePath(l){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};d=fe([ae(0,m.IEnvironmentService),ae(1,I.ILogService)],d),t.ExtensionsLifecycle=d}),define(Q[104],Z([0,1,13,2,19,7,20,24,16,14]),function($,t,T,P,S,C,L,R,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let m=class extends P.Disposable{constructor(d,E,l,u){super();this.extensionsManagementService=d,this.logService=u,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(v=>{this.installedExtensions=v.map(h=>h.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(v=>this.onInstallExtension(v))),this._register(d.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(d.onDidUninstallExtension(v=>this.onDidUninstallExtension(v)));const w=C.URI.file(l.extensionsPath),f=new S.ExtUri(v=>!E.hasCapability(v,1024));this._register(E.watch(w)),this._register(T.Event.filter(E.onDidChangeFilesRaw,v=>v.changes.some(h=>this.doesChangeAffects(h,w,f)))(()=>this.onDidChange()))}doesChangeAffects(d,E,l){return l.isEqual(l.dirname(d.resource),E)?l.isEqual(d.resource,l.joinPath(E,".obsolete"))?!0:!(d.type!==1&&d.type!==2||l.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const E of d)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(E=>!(0,R.areSameExtensions)(E,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,R.areSameExtensions)(E,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),E=d.filter(u=>[...this.installingExtensions,...this.installedExtensions].some(w=>(0,R.areSameExtensions)(w,u.identifier))?!1:u.installedTimestamp&&u.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",u.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",u.identifier.id),!1)),l=this.installedExtensions.filter(u=>this.installingExtensions.some(w=>(0,R.areSameExtensions)(w,u))?!1:d.every(w=>!(0,R.areSameExtensions)(w.identifier,u))?(this.logService.info("Detected extension removed from another source",u.id),!0):!1);this.installedExtensions=d.map(u=>u.identifier),(E.length||l.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:l})}}};m=fe([ae(1,c.IFileService),ae(2,L.INativeEnvironmentService),ae(3,g.ILogService)],m),t.ExtensionsWatcher=m}),define(Q[105],Z([0,1,130,22,3,2,8,4,11,20,23,24,56,14]),function($,t,T,P,S,C,L,R,c,g,m,I,d,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let l=class extends C.Disposable{constructor(f,v,h){super();this.extensionManagementService=f,this.logService=h,this.cache=this._register(new u(v,h)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const f=await this.cache.getLanguagePacks(),v=["en",...Object.keys(f)];return(0,P.distinct)(v)}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const v=await this.cache.getLanguagePacks();Object.keys(v).some(h=>v[h]&&v[h].extensions.some(o=>(0,I.areSameExtensions)(o.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),h=await this.cache.update(v);return!(0,P.equals)(Object.keys(f),Object.keys(h))}};l=fe([ae(0,m.IExtensionManagementService),ae(1,g.INativeEnvironmentService),ae(2,E.ILogService)],l),t.LocalizationsService=l;let u=class extends C.Disposable{constructor(f,v){super();this.logService=v,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new S.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(v=>{Object.keys(v).forEach(h=>delete v[h]),this.createLanguagePacksFromExtensions(v,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...v){for(const h of v)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,h);Object.keys(f).forEach(h=>this.updateHash(f[h]))}createLanguagePacksFromExtension(f,v){const h=v.identifier,o=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const s of o)if(v.location.scheme===L.Schemas.file&&(0,d.isValidLocalization)(s)){let e=f[s.languageId];e||(e={hash:"",extensions:[],translations:{}},f[s.languageId]=e);let i=e.extensions.filter(r=>(0,I.areSameExtensions)(r.extensionIdentifier,h))[0];i?i.version=v.manifest.version:e.extensions.push({extensionIdentifier:h,version:v.manifest.version});for(const r of s.translations)e.translations[r.id]=(0,R.join)(v.location.fsPath,r.path)}}updateHash(f){if(f){const v=(0,T.createHash)("md5");for(const h of f.extensions)v.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);f.hash=v.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch(o){return{}}}).then(h=>(v=f(h),h)).then(h=>{for(const s of Object.keys(h))h[s]||delete h[s];this.languagePacks=h,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),c.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>v,h=>this.logService.error(h))})}};u=fe([ae(0,g.INativeEnvironmentService),ae(1,E.ILogService)],u)}),define(Q[106],Z([0,1,16,14]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function S(c,g,m,I){try{const d=await new Promise((E,l)=>{$(["spdlog"],E,l)});return d.setFlushOn(P.LogLevel.Trace),d.createAsyncRotatingLogger(c,g,m,I)}catch(d){console.error(d)}return null}function C(c,g,m,I){const d=$.__$__nodeRequire("spdlog");return d.setFlushOn(P.LogLevel.Trace),d.createRotatingLogger(c,g,m,I)}t.createRotatingLogger=C;function L(c,g,m){switch(g){case P.LogLevel.Trace:c.trace(m);break;case P.LogLevel.Debug:c.debug(m);break;case P.LogLevel.Info:c.info(m);break;case P.LogLevel.Warning:c.warn(m);break;case P.LogLevel.Error:c.error(m);break;case P.LogLevel.Critical:c.critical(m);break;default:throw new Error("Invalid log level")}}class R extends P.AbstractMessageLogger{constructor(g,m,I,d){super();this.name=g,this.filepath=m,this.rotating=I,this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}_createSpdLogLogger(){const g=this.rotating?6:1,m=30/g*T.ByteSize.MB;return S(this.name,this.filepath,m,g).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:d,message:E}of this.buffer)L(this._logger,d,E);this.buffer=[]}})}log(g,m){this._logger?L(this._logger,g,m):this.getLevel()<=g&&this.buffer.push({level:g,message:m})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=R}),define(Q[57],Z([0,1,17,9,83,16,31]),function($,t,T,P,S,C,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function R(I,d,E,l,u,w){let f;try{await c(I,d,E,l,u,w)}catch(v){f=v}finally{f&&u.errorTransformer&&(f=u.errorTransformer(f)),typeof f!="undefined"&&E.error(f),E.end()}}t.readFileIntoStream=R;async function c(I,d,E,l,u,w){g(w);const f=await I.open(d,{create:!1});try{g(w);let v=0,h=0,o=u&&typeof u.length=="number"?u.length:void 0,s=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof o=="number"?o:u.bufferSize)),e=u&&typeof u.position=="number"?u.position:0,i=0;do h=await I.read(f,e,s.buffer,i,s.byteLength-i),e+=h,i+=h,v+=h,typeof o=="number"&&(o-=h),i===s.byteLength&&(await E.write(l(s)),s=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof o=="number"?o:u.bufferSize)),i=0);while(h>0&&(typeof o!="number"||o>0)&&g(w)&&m(v,u));if(i>0){let r=i;typeof o=="number"&&(r=Math.min(i,o)),E.write(l(s.slice(0,r)))}}catch(v){throw(0,C.ensureFileSystemProviderError)(v)}finally{await I.close(f)}}function g(I){if(I.isCancellationRequested)throw(0,P.canceled)();return!0}function m(I,d){if(d?.limits){if(typeof d.limits.memory=="number"&&I>d.limits.memory)throw(0,C.createFileSystemProviderError)((0,S.localize)(0,null,L.default.nameShort),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof d.limits.size=="number"&&I>d.limits.size)throw(0,C.createFileSystemProviderError)((0,S.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[107],Z([0,1,22,3,17,25,13,131,2,47,8,132,19,37,82,16,57,14]),function($,t,T,P,S,C,L,R,c,g,m,I,d,E,l,u,w,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let v=class Ne extends c.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new L.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new P.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new u.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new P.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new u.FileChangesEvent(s,!0)))),this.watchedResources=g.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new P.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const e=new c.DisposableStore;return e.add(s.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,c.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){s.push(e)}}),!this.provider.has(o)&&await P.Promises.settled(s)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,s){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return R.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,d.isAbsolutePath)(o))throw new u.FileOperationError((0,l.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,l.localize)(1,null,o.toString()),e}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s)||(0,u.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(e){throw(0,u.toFileSystemProviderErrorCode)(e)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,l.localize)(2,null,this.resourceForError(o)),1):(0,u.ensureFileSystemProviderError)(e)}}async doResolveFile(o,s){const e=await this.withProvider(o),i=this.isPathCaseSensitive(e),r=s?.resolveTo,n=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,y=await e.stat(o);let b;return this.toFileStat(e,o,y,void 0,!!a,(A,p)=>{if(!b&&(b=g.TernarySearchTree.forUris(()=>!i),b.set(o,!0),r))for(const O of r)b.set(O,!0);return b.get(A.resource)||b.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&n?p===1:!1})}async toFileStat(o,s,e,i,r,n){const{providerExtUri:a}=this.getExtUri(o),y={resource:s,name:a.basename(s),isFile:(e.type&u.FileType.File)!=0,isDirectory:(e.type&u.FileType.Directory)!=0,isSymbolicLink:(e.type&u.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&u.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,u.etag)({mtime:e.mtime,size:e.size})};if(y.isDirectory&&n(y,i)){try{const b=await o.readdir(s),A=await P.Promises.settled(b.map(async([p,O])=>{try{const N=a.joinPath(s,p),j=r?await o.stat(N):{type:O};return await this.toFileStat(o,N,j,b.length,r,n)}catch(N){return this.logService.trace(N),null}}));y.children=(0,T.coalesce)(A)}catch(b){this.logService.trace(b),y.children=[]}return y}return y}async resolveAll(o){return P.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(e){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(e){return e}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new u.FileOperationError((0,l.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=S.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const i=await this.writeFile(o,s);return this._onDidRunOperation.fire(new u.FileOperationEvent(o,0,i)),i}async writeFile(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(i);try{await this.validateWriteFile(i,o,e)||await this.mkdirp(i,r.dirname(o));let a;if((0,u.hasReadWriteCapability)(i)&&!(s instanceof S.VSBuffer))if((0,E.isReadableStream)(s)){const y=await(0,E.peekStream)(s,3);y.ended?a=S.VSBuffer.concat(y.buffer):a=y}else a=(0,E.peekReadable)(s,y=>S.VSBuffer.concat(y),3);else a=s;!(0,u.hasOpenReadWriteCloseCapability)(i)||(0,u.hasReadWriteCapability)(i)&&a instanceof S.VSBuffer?await this.doWriteUnbuffered(i,o,e,a):await this.doWriteBuffered(i,o,e,a instanceof S.VSBuffer?(0,S.bufferToReadable)(a):a)}catch(n){throw new u.FileOperationError((0,l.localize)(4,null,this.resourceForError(o),(0,u.ensureFileSystemProviderError)(n).toString()),(0,u.toFileOperationResult)(n),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,l.localize)(5,null,this.resourceForError(s)));let r;try{r=await o.stat(s)}catch(n){return}if((r.type&u.FileType.Directory)!=0)throw new u.FileOperationError((0,l.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,r),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==u.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&e.mtime<r.mtime&&e.etag!==(0,u.etag)({mtime:e.mtime,size:r.size}))throw new u.FileOperationError((0,l.localize)(7,null),3,e);return r}async readFile(o,s){const e=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(e,o,s):this.doReadFile(e,o,s)}async doReadFileAtomic(o,s,e){return new Promise((i,r)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const n=await this.doReadFile(o,s,e);i(n)}catch(n){r(n)}})})}async doReadFile(o,s,e){const i=await this.doReadFileStream(o,s,{...e,preferUnbuffered:!0});return{...i,value:await(0,S.streamToBuffer)(i.value)}}async readFileStream(o,s){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,s)}async doReadFileStream(o,s,e){const i=new C.CancellationTokenSource,r=this.validateReadFile(s,e).then(a=>a,a=>{throw i.cancel(),a});let n;try{return typeof e?.etag=="string"&&e.etag!==u.ETAG_DISABLED&&await r,!((0,u.hasOpenReadWriteCloseCapability)(o)||(0,u.hasFileReadStreamCapability)(o))||(0,u.hasReadWriteCapability)(o)&&e?.preferUnbuffered?n=this.readFileUnbuffered(o,s,e):(0,u.hasFileReadStreamCapability)(o)?n=this.readFileStreamed(o,s,i.token,e):n=this.readFileBuffered(o,s,i.token,e),{...await r,value:n}}catch(a){n&&await(0,E.consumeStream)(n);const y=(0,l.localize)(8,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(a).toString());throw a instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(y,a.stat,e):new u.FileOperationError(y,(0,u.toFileOperationResult)(a),e)}}readFileStreamed(o,s,e,i=Object.create(null)){const r=o.readFileStream(s,i,e);return(0,E.transform)(r,{data:n=>n instanceof S.VSBuffer?n:S.VSBuffer.wrap(n),error:n=>new u.FileOperationError((0,l.localize)(9,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(n).toString()),(0,u.toFileOperationResult)(n),i)},n=>S.VSBuffer.concat(n))}readFileBuffered(o,s,e,i=Object.create(null)){const r=(0,S.newWriteableBufferStream)();return(0,w.readFileIntoStream)(o,s,r,n=>n,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:n=>new u.FileOperationError((0,l.localize)(10,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(n).toString()),(0,u.toFileOperationResult)(n),i)},e),r}readFileUnbuffered(o,s,e){const i=(0,E.newWriteableStream)(r=>S.VSBuffer.concat(r));return(async()=>{try{let r=await o.readFile(s);typeof e?.position=="number"&&(r=r.slice(e.position)),typeof e?.length=="number"&&(r=r.slice(0,e.length)),this.validateReadFileLimits(s,r.byteLength,e),i.end(S.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async validateReadFile(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new u.FileOperationError((0,l.localize)(11,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==u.ETAG_DISABLED&&s.etag===e.etag)throw new u.NotModifiedSinceFileOperationError((0,l.localize)(12,null),e,s);return this.validateReadFileLimits(o,e.size,s),e}validateReadFileLimits(o,s,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&s>e.limits.size&&(i=7),typeof i=="number")throw new u.FileOperationError((0,l.localize)(13,null,this.resourceForError(o)),i)}}async canMove(o,s,e){return this.doCanMoveCopy(o,s,"move",e)}async canCopy(o,s,e){return this.doCanMoveCopy(o,s,"copy",e)}async doCanMoveCopy(o,s,e,i){if(o.toString()!==s.toString())try{const r=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(r,o,n,s,e,i)}catch(r){return r}return!0}async move(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=await this.doMoveCopy(i,o,r,s,"move",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,n==="move"?2:3,a)),a}async copy(o,s,e){const i=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=await this.doMoveCopy(i,o,r,s,"copy",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,n==="copy"?3:2,a)),a}async doMoveCopy(o,s,e,i,r,n){if(s.toString()===i.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:y}=await this.doValidateMoveCopy(o,s,e,i,r,n);if(a&&!y&&n&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),r==="copy"){if(o===e&&(0,u.hasFileFolderCopyCapability)(o))await o.copy(s,i,{overwrite:n});else{const b=await this.resolve(s);b.isDirectory?await this.doCopyFolder(o,b,e,i):await this.doCopyFile(o,s,e,i)}return r}else return o===e?(await o.rename(s,i,{overwrite:n}),r):(await this.doMoveCopy(o,s,e,i,"copy",n),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,e,i){if((0,u.hasOpenReadWriteCloseCapability)(o)&&(0,u.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,s,e,i);if((0,u.hasOpenReadWriteCloseCapability)(o)&&(0,u.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,s,e,i);if((0,u.hasReadWriteCapability)(o)&&(0,u.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,s,e,i);if((0,u.hasReadWriteCapability)(o)&&(0,u.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,s,e,i)}async doCopyFolder(o,s,e,i){await e.mkdir(i),Array.isArray(s.children)&&await P.Promises.settled(s.children.map(async r=>{const n=this.getExtUri(e).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),e,n):this.doCopyFile(o,r.resource,e,n)}))}async doValidateMoveCopy(o,s,e,i,r,n){let a=!1;if(o===e){const{providerExtUri:b,isPathCaseSensitive:A}=this.getExtUri(o);if(A||(a=b.isEqual(s,i)),a&&r==="copy")throw new Error((0,l.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&b.isEqualOrParent(i,s))throw new Error((0,l.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const y=await this.exists(i);if(y&&!a){if(!n)throw new u.FileOperationError((0,l.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(o===e){const{providerExtUri:b}=this.getExtUri(o);if(b.isEqualOrParent(s,i))throw new Error((0,l.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:y,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,0,e)),e}async mkdirp(o,s){const e=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(s,i.dirname(s));)try{if(((await o.stat(s)).type&u.FileType.Directory)==0)throw new Error((0,l.localize)(18,null,this.resourceForError(s)));break}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileNotFound)throw r;e.push(i.basename(s)),s=i.dirname(s)}for(let r=e.length-1;r>=0;r--){s=i.joinPath(s,e[r]);try{await o.mkdir(s)}catch(n){if((0,u.toFileSystemProviderErrorCode)(n)!==u.FileSystemProviderErrorCode.FileExists)throw n}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(e){return e}return!0}async doValidateDelete(o,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,l.localize)(19,null,this.resourceForError(o)));let r;try{r=await e.stat(o)}catch(a){}if(r)this.throwIfFileIsReadonly(o,r);else throw new u.FileOperationError((0,l.localize)(20,null,this.resourceForError(o)),1);if(!!!s?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,l.localize)(21,null,this.resourceForError(o)))}return e}async del(o,s){const e=await this.doValidateDelete(o,s),i=!!s?.useTrash,r=!!s?.recursive;await e.delete(o,{recursive:r,useTrash:i}),this._onDidRunOperation.fire(new u.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let e,i;{for(const r of o)this.watchedResources.has(r.resource)?(e||(e=[]),e.push(r)):(i||(i=[]),i.push(r));e&&this._onDidFilesChange.fire(new u.FileChangesEvent(e,!s))}if(i){const r=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(i)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){const e=new c.DisposableStore;{let i=!1,r=()=>{i=!0};e.add((0,c.toDisposable)(()=>r())),this.doWatch(o,s).then(n=>{i?(0,c.dispose)(n):r=()=>(0,c.dispose)(n)},n=>this.logService.error(n))}return s.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,c.toDisposable)(()=>{const i=this.watchedResources.get(o);typeof i=="number"&&(i<=1?this.watchedResources.delete(o):this.watchedResources.set(o,i-1))}))),e}async doWatch(o,s){const e=await this.withProvider(o),i=this.toWatchKey(e,o,s),r=this.activeWatchers.get(i)||{count:0,disposable:e.watch(o,s)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,r),r.count+=1,(0,c.toDisposable)(()=>{r.count--,r.count===0&&((0,c.dispose)(r.disposable),this.activeWatchers.delete(i))})}toWatchKey(o,s,e){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,c.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const r=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,E.isReadableStream)(i)||(0,E.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(o,r,i):await this.doWriteReadableBufferedQueued(o,r,i)}catch(n){throw(0,u.ensureFileSystemProviderError)(n)}finally{await o.close(r)}})}async doWriteStreamBufferedQueued(o,s,e){let i=0,r;if((0,E.isReadableBufferedStream)(e)){if(e.buffer.length>0){const n=S.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,s,n,n.byteLength,i,0),i+=n.byteLength}if(e.ended)return;r=e.stream}else r=e;return new Promise(async(n,a)=>{(0,E.listenStream)(r,{onData:async y=>{r.pause();try{await this.doWriteBuffer(o,s,y,y.byteLength,i,0)}catch(b){return a(b)}i+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>a(y),onEnd:()=>n()})})}async doWriteReadableBufferedQueued(o,s,e){let i=0,r;for(;(r=e.read())!==null;)await this.doWriteBuffer(o,s,r,r.byteLength,i,0),i+=r.byteLength}async doWriteBuffer(o,s,e,i,r,n){let a=0;for(;a<i;)a+=await o.write(s,r+a,e.buffer,n+a,i-a)}async doWriteUnbuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,e,i))}async doWriteUnbufferedQueued(o,s,e,i){let r;i instanceof S.VSBuffer?r=i:(0,E.isReadableStream)(i)?r=await(0,S.streamToBuffer)(i):(0,E.isReadableBufferedStream)(i)?r=await(0,S.bufferedStreamToBuffer)(i):r=(0,S.readableToBuffer)(i),await o.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,e,i))}async doPipeBufferedQueued(o,s,e,i){let r,n;try{r=await o.open(s,{create:!1}),n=await e.open(i,{create:!0,unlock:!1});const a=S.VSBuffer.alloc(this.BUFFER_SIZE);let y=0,b=0,A=0;do A=await o.read(r,y,a.buffer,b,a.byteLength-b),await this.doWriteBuffer(e,n,a,A,y,b),y+=A,b+=A,b===a.byteLength&&(b=0);while(A>0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await P.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof n=="number"?e.close(n):Promise.resolve()])}}async doPipeUnbuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,e,i))}async doPipeUnbufferedQueued(o,s,e,i){return e.writeFile(i,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,e,i))}async doPipeUnbufferedToBufferedQueued(o,s,e,i){const r=await e.open(i,{create:!0,unlock:!1});try{const n=await o.readFile(s);await this.doWriteBuffer(e,r,S.VSBuffer.wrap(n),n.byteLength,0,0)}catch(n){throw(0,u.ensureFileSystemProviderError)(n)}finally{await e.close(r)}}async doPipeBufferedToUnbuffered(o,s,e,i){const r=await(0,S.streamToBuffer)(this.readFileBuffered(o,s,C.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,r)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new u.FileOperationError((0,l.localize)(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,l.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===m.Schemas.file?o.fsPath:o.toString(!0)}};v.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},v=fe([ae(0,f.ILogService)],v),t.FileService=v}),define(Q[108],Z([0,1,22,3,17,13,33,2,4,10,19,37,11,84,16,57,100,92,93,54,95,14,31]),function($,t,T,P,S,C,L,R,c,g,m,I,d,E,l,u,w,f,v,h,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class i extends R.Disposable{constructor(n,a){super();this.logService=n,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=C.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new C.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new P.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,g.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:a,symbolicLink:y}=await d.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(a,y),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(n){try{const a=await d.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),y=[];return await Promise.all(a.map(async b=>{try{let A;b.isSymbolicLink()?A=(await this.stat((0,m.joinPath)(n,b.name))).type:A=this.toType(b),y.push([b.name,A])}catch(A){this.logService.trace(A)}})),y}catch(a){throw this.toFileSystemProviderError(a)}}toType(n,a){let y;return a?.dangling?y=l.FileType.Unknown:n.isFile()?y=l.FileType.File:n.isDirectory()?y=l.FileType.Directory:y=l.FileType.Unknown,a&&(y|=l.FileType.SymbolicLink),y}async readFile(n){try{const a=this.toFilePath(n);return await d.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(n,a,y){const b=(0,I.newWriteableStream)(A=>S.VSBuffer.concat(A.map(p=>S.VSBuffer.wrap(p))).buffer);return(0,u.readFileIntoStream)(this,n,b,A=>A.buffer,{...a,bufferSize:this.BUFFER_SIZE},y),b}async writeFile(n,a,y){let b;try{const A=this.toFilePath(n);if(!y.create||!y.overwrite){if(await d.Promises.exists(A)){if(!y.overwrite)throw(0,l.createFileSystemProviderError)((0,E.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!y.create)throw(0,l.createFileSystemProviderError)((0,E.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(n,{create:!0,unlock:y.unlock}),await this.write(b,0,a,0,a.byteLength)}catch(A){throw await this.toFileSystemProviderWriteError(n,A)}finally{typeof b=="number"&&await this.close(b)}}async open(n,a){try{const y=this.toFilePath(n);if((0,l.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:p}=await d.SymlinkSupport.stat(y);p.mode&128||await d.Promises.chmod(y,p.mode|128)}catch(p){this.logService.trace(p)}let b;if((0,l.isFileOpenForWriteOptions)(a)){if(g.isWindows)try{await d.Promises.truncate(y,0),b="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}b||(b="w")}else b="r";const A=await d.Promises.open(y,b);return this.mapHandleToPos.set(A,0),(0,l.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(A,n),A}catch(y){throw(0,l.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(n,y):this.toFileSystemProviderError(y)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await d.Promises.fdatasync(n)}catch(a){this.canFlush=!1,this.logService.error(a)}return await d.Promises.close(n)}catch(a){throw this.toFileSystemProviderError(a)}}async read(n,a,y,b,A){const p=this.normalizePos(n,a);let O=null;try{const N=await d.Promises.read(n,y,b,A,p);return typeof N=="number"?O=N:O=N.bytesRead,O}catch(N){throw this.toFileSystemProviderError(N)}finally{this.updatePos(n,p,O)}}normalizePos(n,a){return a===this.mapHandleToPos.get(n)?null:a}updatePos(n,a,y){const b=this.mapHandleToPos.get(n);typeof b=="number"&&(typeof a=="number"||(typeof y=="number"?this.mapHandleToPos.set(n,b+y):this.mapHandleToPos.delete(n)))}async write(n,a,y,b,A){return(0,P.retry)(()=>this.doWrite(n,a,y,b,A),100,3)}async doWrite(n,a,y,b,A){const p=this.normalizePos(n,a);let O=null;try{const N=await d.Promises.write(n,y,b,A,p);return typeof N=="number"?O=N:O=N.bytesWritten,O}catch(N){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),N)}finally{this.updatePos(n,p,O)}}async mkdir(n){try{await d.Promises.mkdir(this.toFilePath(n))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(n,a){try{const y=this.toFilePath(n);await this.doDelete(y,a)}catch(y){throw this.toFileSystemProviderError(y)}}async doDelete(n,a){a.recursive?await d.Promises.rm(n,d.RimRafMode.MOVE):await d.Promises.unlink(n)}async rename(n,a,y){const b=this.toFilePath(n),A=this.toFilePath(a);if(b!==A)try{await this.validateTargetDeleted(n,a,"move",y.overwrite),await d.Promises.move(b,A)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,E.localize)(2,null,(0,c.basename)(b),(0,c.basename)((0,c.dirname)(A)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(n,a,y){const b=this.toFilePath(n),A=this.toFilePath(a);if(b!==A)try{await this.validateTargetDeleted(n,a,"copy",y.overwrite),await d.Promises.copy(b,A,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,E.localize)(3,null,(0,c.basename)(b),(0,c.basename)((0,c.dirname)(A)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(n,a,y,b){const A=this.toFilePath(n),p=this.toFilePath(a);let O=!1;if(!!(this.capabilities&1024)||(O=(0,L.isEqual)(A,p,!0)),O&&y==="copy")throw(0,l.createFileSystemProviderError)((0,E.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(!O&&await d.Promises.exists(p)){if(!b)throw(0,l.createFileSystemProviderError)((0,E.localize)(5,null),l.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(n,a){return a.recursive?this.watchRecursive(n,a.excludes):this.watchNonRecursive(n)}watchRecursive(n,a){const y={path:this.toFilePath(n),excludes:a},b=(0,T.insert)(this.recursiveFoldersToWatch,y);return this.refreshRecursiveWatchers(),(0,R.toDisposable)(()=>{b(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof f.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,R.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,a;this.options?.watcher?.usePolling?(n=v.FileWatcher,a=this.options?.watcher):e.default.quality==="stable"&&this.recursiveFoldersToWatch.length===1?g.isWindows?n=o.FileWatcher:n=v.FileWatcher:n=f.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,y=>this._onDidChangeFile.fire((0,h.toFileChanges)(y)),y=>{y.type==="error"&&this._onDidWatchErrorOccur.fire(y.message),this.logService[y.type](y.message)},this.logService.getLevel()===s.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)}))}}watchNonRecursive(n){const a=new w.FileWatcher(this.toFilePath(n),b=>this._onDidChangeFile.fire((0,h.toFileChanges)(b)),b=>{b.type==="error"&&this._onDidWatchErrorOccur.fire(b.message),this.logService[b.type](b.message)},this.logService.getLevel()===s.LogLevel.Trace),y=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)});return(0,R.combinedDisposable)(a,y)}toFilePath(n){return(0,c.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof l.FileSystemProviderError)return n;let a;switch(n.code){case"ENOENT":a=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=l.FileSystemProviderErrorCode.NoPermissions;break;default:a=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(n,a)}async toFileSystemProviderWriteError(n,a){let y=this.toFileSystemProviderError(a);if(n&&y.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:b}=await d.SymlinkSupport.stat(this.toFilePath(n));b.mode&128||(y=(0,l.createFileSystemProviderError)(a,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(b){this.logService.trace(b)}return y}dispose(){super.dispose(),(0,R.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,R.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=i}),define(Q[42],Z([0,1,15]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,T.createDecorator)("productService")}),define(Q[26],Z([0,1,58,12]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class S{constructor(){this.data=new Map}add(L,R){T.ok(P.isString(L)),T.ok(P.isObject(R)),T.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,R)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}t.Registry=new S}),define(Q[109],Z([0,1,13,26]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function S(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class C{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,g){this.schemasById[S(c)]=g,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new C;P.Registry.add(t.Extensions.JSONContribution,L)}),define(Q[32],Z([0,1,13,12,74,109,26]),function($,t,T,P,S,C,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var R;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(R=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var c;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(c=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const g=L.Registry.as(C.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},g.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,h=!0){this.registerConfigurations([v],h)}registerConfigurations(v,h=!0){const o=[];v.forEach(s=>{o.push(...this.validateAndRegisterProperties(s,h,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),g.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(v){const h=[],o=s=>{if(s.properties)for(const e in s.properties)h.push(e),delete this.configurationProperties[e],this.removeFromSchema(e,s.properties[e]);s.allOf&&s.allOf.forEach(e=>o(e))};for(const s of v){o(s);const e=this.configurationContributors.indexOf(s);e!==-1&&this.configurationContributors.splice(e,1)}g.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}registerDefaultConfigurations(v){const h=[],o=[];for(const s of v)for(const e in s)if(h.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]={...this.defaultValues[e]||{},...s[e]};const i={type:"object",default:this.defaultValues[e],description:S.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};o.push(d(e)),this.configurationProperties[e]=i,this.defaultLanguageConfigurationOverridesNode.properties[e]=i}else{this.defaultValues[e]=s[e];const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterDefaultConfigurations(v){const h=[];for(const o of v)for(const s in o)if(h.push(s),delete this.defaultValues[s],t.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const e=this.configurationProperties[s];e&&(this.updatePropertyDefaultValue(s,e),this.updateSchema(s,e))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const h of v)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(v,h=!0,o,s=3){s=P.isUndefinedOrNull(v.scope)?s:v.scope;let e=[],i=v.properties;if(i)for(let n in i){if(h&&u(n)){delete i[n];continue}const a=i[n];if(this.updatePropertyDefaultValue(n,a),t.OVERRIDE_PROPERTY_PATTERN.test(n)?a.scope=void 0:(a.scope=P.isUndefinedOrNull(a.scope)?s:a.scope,a.restricted=P.isUndefinedOrNull(a.restricted)?!!o?.restrictedConfigurations?.includes(n):a.restricted),i[n].hasOwnProperty("included")&&!i[n].included){this.excludedConfigurationProperties[n]=i[n],delete i[n];continue}else this.configurationProperties[n]=i[n];!i[n].deprecationMessage&&i[n].markdownDeprecationMessage&&(i[n].deprecationMessage=i[n].markdownDeprecationMessage),e.push(n)}let r=v.allOf;if(r)for(let n of r)e.push(...this.validateAndRegisterProperties(n,h,o,s));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const h=o=>{let s=o.properties;if(s)for(const i in s)this.updateSchema(i,s[i]);let e=o.allOf;e&&e.forEach(h)};h(v)}updateSchema(v,h){switch(t.allSettings.properties[v]=h,h.scope){case 1:t.applicationSettings.properties[v]=h;break;case 2:t.machineSettings.properties[v]=h;break;case 6:t.machineOverridableSettings.properties[v]=h;break;case 3:t.windowSettings.properties[v]=h;break;case 4:t.resourceSettings.properties[v]=h;break;case 5:t.resourceSettings.properties[v]=h,this.resourceLanguageSettingsSchema.properties[v]=h;break}}removeFromSchema(v,h){switch(delete t.allSettings.properties[v],h.scope){case 1:delete t.applicationSettings.properties[v];break;case 2:delete t.machineSettings.properties[v];break;case 6:delete t.machineOverridableSettings.properties[v];break;case 3:delete t.windowSettings.properties[v];break;case 4:case 5:delete t.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const h=`[${v}]`,o={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,o),t.allSettings.properties[h]=o,t.applicationSettings.properties[h]=o,t.machineSettings.properties[h]=o,t.machineOverridableSettings.properties[h]=o,t.windowSettings.properties[h]=o,t.resourceSettings.properties[h]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,h){let o=this.defaultValues[v];P.isUndefined(o)&&(o=h.default),P.isUndefined(o)&&(o=E(h.type)),h.default=o}}const I="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function d(f){return f.substring(1,f.length-1)}t.overrideIdentifierFromKey=d;function E(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=E;const l=new m;L.Registry.add(t.Extensions.Configuration,l);function u(f){return f.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(f)?S.localize(5,null,f):l.getConfigurationProperties()[f]!==void 0?S.localize(6,null,f):null:S.localize(4,null)}t.validateProperty=u;function w(){const f=[],v=l.getConfigurationProperties();for(const h of Object.keys(v))f.push([h,v[h].scope]);return f.push(["launch",4]),f.push(["task",4]),f}t.getScopes=w}),define(Q[27],Z([0,1,18,12,7,32,15,26]),function($,t,T,P,S,C,L,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,L.createDecorator)("configurationService");function c(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof S.URI)}t.isConfigurationOverrides=c;var g;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(g=t.ConfigurationTarget||(t.ConfigurationTarget={}));function m(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=m;function I(i,r){const n=r?i?r.keys.filter(N=>i.keys.indexOf(N)===-1):[...r.keys]:[],a=i?r?i.keys.filter(N=>r.keys.indexOf(N)===-1):[...i.keys]:[],y=[];if(r&&i){for(const N of i.keys)if(r.keys.indexOf(N)!==-1){const j=f(i.contents,N),Y=f(r.contents,N);T.equals(j,Y)||y.push(N)}}const b=[],A=N=>{const j={};for(const Y of N)for(const te of Y.identifiers)j[s(te)]=Y;return j},p=r?A(r.overrides):{},O=i?A(i.overrides):{};if(Object.keys(p).length)for(const N of n){const j=p[N];j&&b.push([(0,C.overrideIdentifierFromKey)(N),j.keys])}if(Object.keys(O).length)for(const N of a){const j=O[N];j&&b.push([(0,C.overrideIdentifierFromKey)(N),j.keys])}if(Object.keys(p).length&&Object.keys(O).length)for(const N of y){const j=O[N],Y=p[N];if(j&&Y){const te=I({contents:j.contents,keys:j.keys,overrides:[]},{contents:Y.contents,keys:Y.keys,overrides:[]});b.push([(0,C.overrideIdentifierFromKey)(N),[...te.added,...te.removed,...te.updated]])}}return{added:n,removed:a,updated:y,overrides:b}}t.compare=I;function d(i,r){const n=[];for(const a of Object.keys(i))if(C.OVERRIDE_PROPERTY_PATTERN.test(a)){const y={};for(const b in i[a])y[b]=i[a][b];n.push({identifiers:[(0,C.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(y),contents:E(y,r)})}return n}t.toOverrides=d;function E(i,r){const n=Object.create(null);for(let a in i)l(n,a,i[a],r);return n}t.toValuesTree=E;function l(i,r,n,a){const y=r.split("."),b=y.pop();let A=i;for(let p=0;p<y.length;p++){let O=y[p],N=A[O];switch(typeof N){case"undefined":N=A[O]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${y.slice(0,p+1).join(".")} is ${JSON.stringify(N)}`);return}A=N}if(typeof A=="object"&&A!==null)try{A[b]=n}catch(p){a(`Ignoring ${r} as ${y.join(".")} is ${JSON.stringify(A)}`)}else a(`Ignoring ${r} as ${y.join(".")} is ${JSON.stringify(A)}`)}t.addToValueTree=l;function u(i,r){const n=r.split(".");w(i,n)}t.removeFromValueTree=u;function w(i,r){const n=r.shift();if(r.length===0){delete i[n];return}if(Object.keys(i).indexOf(n)!==-1){const a=i[n];typeof a=="object"&&!Array.isArray(a)&&(w(a,r),Object.keys(a).length===0&&delete i[n])}}function f(i,r,n){function a(A,p){let O=A;for(const N of p){if(typeof O!="object"||O===null)return;O=O[N]}return O}const y=r.split("."),b=a(i,y);return typeof b=="undefined"?n:b}t.getConfigurationValue=f;function v(i,r,n){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in i?P.isObject(i[a])&&P.isObject(r[a])?v(i[a],r[a],n):n&&(i[a]=r[a]):i[a]=r[a])})}t.merge=v;function h(){const i=R.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=h;function o(){const i=Object.create(null),r=R.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let n in r){let a=r[n].default;l(i,n,a,y=>console.error(`Conflict in default settings: ${y}`))}return i}t.getDefaultValues=o;function s(i){return`[${i}]`}t.keyFromOverrideIdentifier=s;function e(i,r,n){const a=i.inspect(r),y=i.inspect(n);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:a.defaultValue}t.getMigratedSettingValue=e}),define(Q[110],Z([0,1,22,13,59,2,47,18,12,7,27,32,26]),function($,t,T,P,S,C,L,R,c,g,m,I,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class E{constructor(e={},i=[],r=[]){this._contents=e,this._keys=i,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,m.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const r=this.getContentsForOverrideIdentifer(i);return r?e?(0,m.getConfigurationValue)(r,e):r:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const n of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[n],y=i[n];y&&(typeof a=="object"&&typeof y=="object"?(a=R.deepClone(a),this.mergeContents(a,y)):a=y),r[n]=a}return new E(r,this.keys,this.overrides)}merge(...e){const i=R.deepClone(this.contents),r=R.deepClone(this.overrides),n=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const y of a.overrides){const[b]=r.filter(A=>T.equals(A.identifiers,y.identifiers));b?this.mergeContents(b.contents,y.contents):r.push(R.deepClone(y))}for(const y of a.keys)n.indexOf(y)===-1&&n.push(y)}return new E(i,n,r)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const r of Object.keys(i)){if(r in e&&c.isObject(e[r])&&c.isObject(i[r])){this.mergeContents(e[r],i[r]);continue}e[r]=R.deepClone(i[r])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?R.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,m.addToValueTree)(this.contents,e,i,r=>{throw new Error(r)})}removeValue(e){this.removeKey(e)&&(0,m.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let r=0;r<i;r++)e.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=E;class l extends E{constructor(){const e=(0,m.getDefaultValues)(),i=(0,m.getConfigurationKeys)(),r=[];for(const n of Object.keys(e))I.OVERRIDE_PROPERTY_PATTERN.test(n)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(e[n]),contents:(0,m.toValuesTree)(e[n],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,r)}}t.DefaultConfigurationModel=l;class u{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!c.isUndefinedOrNull(e)){const r=this.doParseContent(e);this.parseRaw(r,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:r,keys:n,overrides:a,restricted:y}=this.doParseRaw(e,i);this._configurationModel=new E(r,n,a),this._restrictedConfigurations=y||[]}doParseContent(e){let i={},r=null,n=[],a=[],y=[];function b(p){Array.isArray(n)?n.push(p):r!==null&&(n[r]=p)}let A={onObjectBegin:()=>{let p={};b(p),a.push(n),n=p,r=null},onObjectProperty:p=>{r=p},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{let p=[];b(p),a.push(n),n=p,r=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:b,onError:(p,O,N)=>{y.push({error:p,offset:O,length:N})}};if(e)try{S.visit(e,A),i=n[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return i}doParseRaw(e,i){const r=d.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),n=this.filter(e,r,!0,i);e=n.raw;const a=(0,m.toValuesTree)(e,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),y=Object.keys(e),b=(0,m.toOverrides)(e,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:a,keys:y,overrides:b,restricted:n.restricted}}filter(e,i,r,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:e,restricted:[]};const a={},y=[];for(let b in e)if(I.OVERRIDE_PROPERTY_PATTERN.test(b)&&r){const A=this.filter(e[b],i,!1,n);a[b]=A.raw,y.push(...A.restricted)}else{const A=i[b],p=A?typeof A.scope!="undefined"?A.scope:3:void 0;A?.restricted&&y.push(b),(p===void 0||n.scopes===void 0||n.scopes.includes(p))&&(n.skipRestricted&&A?.restricted||(a[b]=e[b]))}return{raw:a,restricted:y}}}t.ConfigurationModelParser=u;class w extends C.Disposable{constructor(e,i,r,n){super();this.userSettingsResource=e,this.scopes=i,this.fileService=n,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(P.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=w;class f{constructor(e,i,r=new E,n=new E,a=new L.ResourceMap,y=new E,b=new L.ResourceMap,A=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=n,this._folderConfigurations=a,this._memoryConfiguration=y,this._memoryConfigurationByResource=b,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(e,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(e)}updateValue(e,i,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new E,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,i===void 0?n.removeValue(e):n.setValue(e,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,r){const n=this.getConsolidateConfigurationModel(i,r),a=this.getFolderConfigurationModelForResource(i.resource,r),y=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,b=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),A=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),p=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),O=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),N=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,j=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,Y=i.overrideIdentifier?y.override(i.overrideIdentifier).getValue(e):y.getValue(e),te=n.getValue(e),se=T.distinct(T.flatten(n.overrides.map(ee=>ee.identifiers))).filter(ee=>n.getOverrideValue(e,ee)!==void 0);return{defaultValue:b,userValue:A,userLocalValue:p,userRemoteValue:O,workspaceValue:N,workspaceFolderValue:j,memoryValue:Y,value:te,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:j!==void 0?{value:a?.freeze().getValue(e),override:i.overrideIdentifier?a?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:Y!==void 0?{value:y.getValue(e),override:i.overrideIdentifier?y.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const r=i.filter(n=>I.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const a=(0,I.overrideIdentifierFromKey)(n),y=this._defaultConfiguration.getKeysForOverrideIdentifier(a),b=e.getKeysForOverrideIdentifier(a),A=[...b.filter(p=>y.indexOf(p)===-1),...y.filter(p=>b.indexOf(p)===-1),...y.filter(p=>!R.equals(this._defaultConfiguration.override(a).getValue(p),e.override(a).getValue(p)))];return[a,A]});return this.updateDefaultConfiguration(e),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:r,removed:n,overrides:a}=(0,m.compare)(this.localUserConfiguration,e),y=[...i,...r,...n];return y.length&&this.updateLocalUserConfiguration(e),{keys:y,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:r,removed:n,overrides:a}=(0,m.compare)(this.remoteUserConfiguration,e);let y=[...i,...r,...n];return y.length&&this.updateRemoteUserConfiguration(e),{keys:y,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:r,removed:n,overrides:a}=(0,m.compare)(this.workspaceConfiguration,e);let y=[...i,...r,...n];return y.length&&this.updateWorkspaceConfiguration(e),{keys:y,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const r=this.folderConfigurations.get(e),{added:n,updated:a,removed:y,overrides:b}=(0,m.compare)(r,i);let A=[...n,...a,...y];return(A.length||!r)&&this.updateFolderConfiguration(e,i),{keys:A,overrides:b}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:r,updated:n,removed:a,overrides:y}=(0,m.compare)(i,void 0);return{keys:[...r,...n,...a],overrides:y}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let r=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?r.override(e.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:e},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const n=i.getFolder(e);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const a=this._memoryConfigurationByResource.get(e);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(e);n?(i=r.merge(n),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=r}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const r=i.getFolder(e);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:r,overrides:n,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:r,overrides:n,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>e.add(r))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),r=this.parseConfigurationModel(e.user),n=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((y,b)=>(y.set(g.URI.revive(b[0]),this.parseConfigurationModel(b[1])),y),new L.ResourceMap);return new f(i,r,new E,n,a,new E,new L.ResourceMap,!1)}static parseConfigurationModel(e){return new E(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=f;function v(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,i=new Map;for(const n of s)n.keys.forEach(a=>e.add(a)),n.overrides.forEach(([a,y])=>{const b=(0,L.getOrSet)(i,a,new Set);y.forEach(A=>b.add(A))});const r=[];return i.forEach((n,a)=>r.push([a,[...n.values()]])),{keys:[...e.values()],overrides:r}}t.mergeChanges=v;class h{constructor(e,i,r,n){this.change=e,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(b=>a.add(b)),e.overrides.forEach(([,b])=>b.forEach(A=>a.add(A))),this.affectedKeys=[...a.values()];const y=new E;this.affectedKeys.forEach(b=>y.setValue(b,{})),this.affectedKeysTree=y.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!R.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let r=(0,m.toValuesTree)({[i]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(e=e[n],!e)return!1;r=r[n]}return!0}}t.ConfigurationChangeEvent=h;class o extends h{constructor(e,i,r,n){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=r,this.sourceConfig=n}}t.AllKeysConfigurationChangeEvent=o}),define(Q[111],Z([0,1,3,13,2,19,27,110,32,26]),function($,t,T,P,S,C,L,R,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class m extends S.Disposable{constructor(d,E){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,E)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(l=>this.onDidDefaultConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,E){const l=typeof d=="string"?d:void 0,u=(0,L.isConfigurationOverrides)(d)?d:(0,L.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(l,u,void 0)}updateValue(d,E,l,u){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const E=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(l,E,1)}onDidDefaultConfigurationChange(d){const E=this.configuration.toData(),l=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,d);this.trigger(l,E,6)}trigger(d,E,l){const u=new R.ConfigurationChangeEvent(d,{data:E},this.configuration);u.source=l,u.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(u)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=m}),define(Q[43],Z([0,1,17,85,32,15,26]),function($,t,T,P,S,C,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,C.createDecorator)("requestService");function R(l){return l.res.statusCode&&l.res.statusCode>=200&&l.res.statusCode<300||l.res.statusCode===1223}t.isSuccess=R;function c(l){return l.res.statusCode===204}async function g(l){if(!R(l))throw new Error("Server returned "+l.res.statusCode);return c(l)?null:(await(0,T.streamToBuffer)(l.stream)).toString()}t.asText=g;async function m(l){if(!R(l))throw new Error("Server returned "+l.res.statusCode);if(c(l))return null;const w=(await(0,T.streamToBuffer)(l.stream)).toString();try{return JSON.parse(w)}catch(f){throw f.message+=`:
`+w,f}}t.asJson=m;function I(l){E(l)}t.updateProxyConfigurationsScope=I;let d;function E(l){const u=L.Registry.as(S.Extensions.Configuration);d&&u.deregisterConfigurations([d]),d={id:"http",order:15,title:(0,P.localize)(0,null),type:"object",scope:l,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,P.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,P.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,P.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,P.localize)(4,null),(0,P.localize)(5,null),(0,P.localize)(6,null),(0,P.localize)(7,null)],default:"override",description:(0,P.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,P.localize)(9,null),restricted:!0}}},u.registerConfiguration(d)}E(2)}),define(Q[112],Z([0,1,25,8,16,43]),function($,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let L=class{constructor(c,g){this.requestService=c,this.fileService=g}async download(c,g,m=T.CancellationToken.None){if(c.scheme===P.Schemas.file||c.scheme===P.Schemas.vscodeRemote){await this.fileService.copy(c,g);return}const I={type:"GET",url:c.toString()},d=await this.requestService.request(I,m);if(d.res.statusCode===200)await this.fileService.writeFile(g,d.stream);else{const E=await(0,C.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${E}`)}}};L=fe([ae(0,C.IRequestService),ae(1,S.IFileService)],L),t.DownloadService=L}),define(Q[113],Z([0,1,114,12]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function S(L,R){return L.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:L.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function C(L,R,c={}){const g=(0,T.parse)(L),m=c.proxyUrl||S(g,R);if(!m)return null;const I=(0,T.parse)(m);if(!/^https?:$/.test(I.protocol||""))return null;const d={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,P.isBoolean)(c.strictSSL)?c.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((E,l)=>{$(["http-proxy-agent"],E,l)}))(d):new(await new Promise((E,l)=>{$(["https-proxy-agent"],E,l)}))(d)}t.getProxyAgent=C}),define(Q[115],Z([0,1,17,30]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function S(C,L,R){let c=R&&R.get("storage.serviceMachineId",0)||null;if(c)return c;try{const m=(await L.readFile(C.serviceMachineIdResource)).value.toString();c=(0,P.isUUID)(m)?m:null}catch(g){c=null}if(!c){c=(0,P.generateUuid)();try{await L.writeFile(C.serviceMachineIdResource,T.VSBuffer.fromString(c))}catch(g){}}return R&&R.store("storage.serviceMachineId",c,0,1),c}t.getServiceMachineId=S}),define(Q[116],Z([0,1,3,13,2,12,67,15]),function($,t,T,P,S,C,L,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const c="__$__targetStorageMarker";t.IStorageService=(0,R.createDecorator)("storageService");var g;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(g=t.WillSaveStateReason||(t.WillSaveStateReason={}));var m;(function(u){u[u.GLOBAL=0]="GLOBAL",u[u.WORKSPACE=1]="WORKSPACE"})(m=t.StorageScope||(t.StorageScope={}));var I;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(I=t.StorageTarget||(t.StorageTarget={}));class d extends S.Disposable{constructor(w={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=w,this._onDidChangeValue=this._register(new P.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new P.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new P.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new S.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,S.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(w,f){f===c?(w===0?this._globalKeyTargets=void 0:w===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:w})):this._onDidChangeValue.fire({scope:w,key:f,target:this.getKeyTargets(w)[f]})}emitWillSaveState(w){this._onWillSaveState.fire({reason:w})}get(w,f,v){return this.getStorage(f)?.get(w,v)}getBoolean(w,f,v){return this.getStorage(f)?.getBoolean(w,v)}getNumber(w,f,v){return this.getStorage(f)?.getNumber(w,v)}store(w,f,v,h){if((0,C.isUndefinedOrNull)(f)){this.remove(w,v);return}this.withPausedEmitters(()=>{this.updateKeyTarget(w,v,h),this.getStorage(v)?.set(w,f)})}remove(w,f){this.withPausedEmitters(()=>{this.updateKeyTarget(w,f,void 0),this.getStorage(f)?.delete(w)})}withPausedEmitters(w){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{w()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(w,f){const v=[],h=this.getKeyTargets(w);for(const o of Object.keys(h))h[o]===f&&v.push(o);return v}updateKeyTarget(w,f,v){const h=this.getKeyTargets(f);typeof v=="number"?h[w]!==v&&(h[w]=v,this.getStorage(f)?.set(c,JSON.stringify(h))):typeof h[w]=="number"&&(delete h[w],this.getStorage(f)?.set(c,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(w){return w===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(w){const f=this.get(c,w);if(f)try{return JSON.parse(f)}catch(v){}return Object.create(null)}isNew(w){return this.getBoolean(t.IS_NEW_KEY,w)===!0}async flush(w=g.NONE){this._onWillSaveState.fire({reason:w}),await T.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const w=this.getStorage(0)?.items??new Map,f=this.getStorage(1)?.items??new Map;return l(w,f,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;class E extends d{constructor(){super();this.globalStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(w=>this.emitDidChangeValue(1,w))),this._register(this.globalStorage.onDidChangeStorage(w=>this.emitDidChangeValue(0,w)))}getStorage(w){return w===0?this.globalStorage:this.workspaceStorage}getLogDetails(w){return w===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(w){}}t.InMemoryStorageService=E;async function l(u,w,f,v){const h=a=>{try{return JSON.parse(a)}catch(y){return a}},o=new Map,s=new Map;u.forEach((a,y)=>{o.set(y,a),s.set(y,h(a))});const e=new Map,i=new Map;w.forEach((a,y)=>{e.set(y,a),i.set(y,h(a))}),console.group(`Storage: Global (path: ${f})`);let r=[];o.forEach((a,y)=>{r.push({key:y,value:a})}),console.table(r),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${v})`);let n=[];e.forEach((a,y)=>{n.push({key:y,value:a})}),console.table(n),console.groupEnd(),console.log(i)}t.logStorage=l}),define(Q[117],Z([0,1,10,28,7,30]),function($,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function L(g){if(T.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function R(g,m,I,d,E,l,u,w,f,v){const h=Object.create(null);h["common.machineId"]=u,h.sessionID=(0,C.generateUuid)()+Date.now(),h.commitHash=E,h.version=l,h["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,T.PlatformToString)(T.platform),h["common.nodePlatform"]=P.platform,h["common.nodeArch"]=d,h["common.product"]=v||"desktop";const o=c(w||[]);o&&(h["common.msftInternal"]=o);let s=0;const e=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),T.isLinuxSnap&&(h["common.snap"]="true");const i=L(I);i&&(h["common.platformDetail"]=i);try{const r=await g.readFile(S.URI.file(f));h["common.source"]=r.value.toString().slice(0,30)}catch(r){}return h}t.resolveCommonProperties=R;function c(g){const m=P.env.USERDNSDOMAIN;if(!m)return!1;const I=m.toLowerCase();return g.some(d=>I===d)}t.verifyMicrosoftInternalDomain=c}),define(Q[36],Z([0,1,15]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,T.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Q[118],Z([0,1,22,3,25,9,13,2,10,7,75,23,24,14,31,36]),function($,t,T,P,S,C,L,R,c,g,m,I,d,E,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let w=class extends R.Disposable{constructor(s,e,i){super();this.galleryService=s,this.telemetryService=e,this.logService=i,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const e=await this.getTargetPlatform();return s.allTargetPlatforms.some(i=>(0,I.isTargetPlatformCompatible)(i,s.allTargetPlatforms,e))}async installFromGallery(s,e={}){if(!this.galleryService.isEnabled())throw new Error(m.localize(0,null));if(!await this.canInstall(s)){const r=await this.getTargetPlatform(),n=new I.ExtensionManagementError(m.localize(1,null,s.identifier.id,l.default.nameLong,(0,I.TargetPlatformToString)(r)),t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",s.identifier.id,n.message),v(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,n),n}try{s=await this.checkAndGetCompatibleVersion(s,!e.installGivenVersion)}catch(r){throw this.logService.error((0,C.getErrorMessage)(r)),v(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,r),r}const i=await this.galleryService.getManifest(s,S.CancellationToken.None);if(i===null){const r=new I.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,r.message),v(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,r),r}if(i.version!==s.version){const r=new I.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error(r.message),v(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,r),r}return this.installExtension(i,s,e)}async uninstall(s,e={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,e)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(m.localize(2,null));const e=await this.findGalleryExtension(s);if(!e)throw new Error(m.localize(3,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,e,i){if(!g.URI.isUri(e)){let b=this.installingExtensions.get(new d.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(b)return this.logService.info("Extensions is already requested to install",e.identifier.id),b.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],n=[],a=this.createInstallExtensionTask(s,e,i);g.URI.isUri(e)||this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(a.identifier,s.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),r.push({task:a,manifest:s});let y=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const A=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,s,!!i.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:p,manifest:O}of A)if(y=y||!!O.extensionDependencies?.some(N=>(0,d.areSameExtensions)({id:N},a.identifier)),this.installingExtensions.has(new d.ExtensionIdentifierWithVersion(p.identifier,p.version).key()))this.logService.info("Extension is already requested to install",p.identifier.id);else{const N=this.createInstallExtensionTask(O,p,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(N.identifier,O.version).key(),N),this._onInstallExtension.fire({identifier:N.identifier,source:p}),this.logService.info("Installing extension:",N.identifier.id),r.push({task:N,manifest:O})}}catch(A){if(g.URI.isUri(a.source))(0,T.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,A.message),(0,T.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,A.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(A),A}const b=r.reduce((A,{task:p,manifest:O})=>(A.set(p.identifier.id.toLowerCase(),{task:p,manifest:O}),A),new Map);for(;b.size;){let A;const p=[...b.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(N=>b.has(N.toLowerCase())));p.length?A=b.size===1?p:p.filter(({task:O})=>!(O===a&&!y)):(this.logService.info("Found extensions with circular dependencies",p.map(({task:O})=>O.identifier.id)),A=[...b.values()]),await this.joinAllSettled(A.map(async({task:O})=>{const N=new Date().getTime();try{const j=await O.run();if(await this.joinAllSettled(this.participants.map(Y=>Y.postInstall(j,O.source,i,S.CancellationToken.None))),!g.URI.isUri(O.source)&&(v(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-N,void 0),c.isWeb&&O.operation===1))try{await this.galleryService.reportStatistic(j.manifest.publisher,j.manifest.name,j.manifest.version,"install")}catch(Y){}n.push({local:j,identifier:O.identifier,operation:O.operation,source:O.source})}catch(j){throw g.URI.isUri(O.source)||v(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-N,j),this.logService.error("Error while installing the extension:",O.identifier.id),this.logService.error(j),j}finally{b.delete(O.identifier.id.toLowerCase())}}))}return n.forEach(({identifier:A})=>this.logService.info("Extension installed successfully:",A.id)),this._onDidInstallExtensions.fire(n),n.filter(({identifier:A})=>(0,d.areSameExtensions)(A,a.identifier))[0].local}catch(b){if(r.forEach(({task:A})=>A.cancel()),n.length)try{const A=await Promise.allSettled(n.map(({local:p})=>this.createUninstallExtensionTask(p,{versionOnly:!0}).run()));for(let p=0;p<A.length;p++){const O=A[p],{identifier:N}=n[p];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,C.getErrorMessage)(O.reason))}}catch(A){this.logService.warn("Error while rolling back extensions",(0,C.getErrorMessage)(A),n.map(({identifier:p})=>p.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,C.getErrorMessage)(b)),this._onDidInstallExtensions.fire(r.map(({task:A})=>({identifier:A.identifier,operation:1,source:A.source}))),b instanceof Error&&(b.name=b&&b.code?b.code:t.ERROR_UNKNOWN),b}finally{for(const{task:b,manifest:A}of r)if(!g.URI.isUri(b.source)){const p=new d.ExtensionIdentifierWithVersion(b.identifier,A.version).key();this.installingExtensions.delete(p)||this.logService.warn("Installation task is not found in the cache",p)}}}async joinAllSettled(s){const e=[],i=[],r=await Promise.allSettled(s);for(const n of r)n.status==="fulfilled"?e.push(n.value):i.push(n.reason);if(i.length)throw f(i);return e}async getAllDepsAndPackExtensionsToInstall(s,e,i){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const n=[s,...r.map(b=>b.identifier)],a=[],y=async(b,A)=>{const p=A.extensionDependencies||[],O=[...p];if(A.extensionPack){const N=i?r.find(j=>(0,d.areSameExtensions)(j.identifier,b)):void 0;for(const j of A.extensionPack)N&&N.manifest.extensionPack&&N.manifest.extensionPack.some(Y=>(0,d.areSameExtensions)({id:Y},{id:j}))||O.every(Y=>!(0,d.areSameExtensions)({id:Y},{id:j}))&&O.push(j)}if(O.length){const N=[...n,...a.map(Y=>Y.gallery.identifier)],j=O.filter(Y=>N.every(te=>!(0,d.areSameExtensions)(te,{id:Y})));if(j.length){const Y=await this.galleryService.query({names:j,pageSize:O.length},S.CancellationToken.None);for(const te of Y.firstPage){if(N.find(le=>(0,d.areSameExtensions)(le,te.identifier)))continue;if(!p.some(le=>(0,d.areSameExtensions)({id:le},te.identifier))&&!await this.canInstall(te)){this.logService.info("Skipping the packed extension as it cannot be installed",te.identifier.id);continue}const ee=await this.checkAndGetCompatibleVersion(te,!0),ce=await this.galleryService.getManifest(ee,S.CancellationToken.None);if(ce===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${ee.identifier.id}`,t.INSTALL_ERROR_VALIDATING);a.push({gallery:ee,manifest:ce}),await y(ee.identifier,ce)}}}};return await y(s,e),r=await this.getInstalled(),a.filter(b=>!r.some(A=>(0,d.areSameExtensions)(A.identifier,b.gallery.identifier)))}async checkAndGetCompatibleVersion(s,e){if(await this.isMalicious(s))throw new I.ExtensionManagementError(m.localize(4,null,s.identifier.id),I.INSTALL_ERROR_MALICIOUS);const i=await this.getTargetPlatform();let r=null;if(await this.galleryService.isExtensionCompatible(s,i)&&(r=s),!r&&e&&(r=await this.galleryService.getCompatibleExtension(s,i)),!r)throw new I.ExtensionManagementError(m.localize(5,null,s.identifier.id,l.default.version),I.INSTALL_ERROR_INCOMPATIBLE);return r}async isMalicious(s){const e=await this.getExtensionsReport();return(0,d.getMaliciousExtensionsSet)(e).has(s.identifier.id)}async unininstallExtension(s,e){const i=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),i.waitUntilTaskIsFinished();const r=(b,A)=>{const p=this.createUninstallExtensionTask(b,A);return this.uninstallingExtensions.set(p.extension.identifier.id.toLowerCase(),p),this.logService.info("Uninstalling extension:",b.identifier.id),this._onUninstallExtension.fire(b.identifier),p},n=(b,A)=>{A?this.logService.error("Failed to uninstall extension:",b.identifier.id,A.message):this.logService.info("Successfully uninstalled extension:",b.identifier.id),v(this.telemetryService,"extensionGallery:uninstall",(0,d.getLocalExtensionTelemetryData)(b),void 0,A),this._onDidUninstallExtension.fire({identifier:b.identifier,error:A?.code})},a=[],y=[];try{a.push(r(s,{}));const b=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const A=this.getAllPackExtensionsToUninstall(s,b);for(const p of A)this.uninstallingExtensions.has(p.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",p.identifier.id):a.push(r(p,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(a.map(A=>A.extension),b,s),await this.joinAllSettled(a.map(async A=>{try{if(await A.run(),await this.joinAllSettled(this.participants.map(p=>p.postUninstall(A.extension,e,S.CancellationToken.None))),A.extension.identifier.uuid)try{await this.galleryService.reportStatistic(A.extension.manifest.publisher,A.extension.manifest.name,A.extension.manifest.version,"uninstall")}catch(p){}n(A.extension)}catch(p){const O=p instanceof I.ExtensionManagementError?p:new I.ExtensionManagementError((0,C.getErrorMessage)(p),t.ERROR_UNKNOWN);throw n(A.extension,O),O}finally{y.push(A)}}))}catch(b){const A=b instanceof I.ExtensionManagementError?b:new I.ExtensionManagementError((0,C.getErrorMessage)(b),t.ERROR_UNKNOWN);for(const p of a){try{p.cancel()}catch(O){}y.includes(p)||n(p.extension,A)}throw A}finally{for(const b of a)this.uninstallingExtensions.delete(b.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",b.extension.identifier.id)}}checkForDependents(s,e,i){for(const r of s){const n=this.getDependents(r,e);if(n.length){const a=n.filter(y=>!s.some(b=>(0,d.areSameExtensions)(b.identifier,y.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(r,a,i))}}}getDependentsErrorMessage(s,e,i){return i===s?e.length===1?m.localize(6,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?m.localize(7,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):m.localize(8,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?m.localize(9,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?m.localize(10,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):m.localize(11,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(s,e,i=[]){if(i.indexOf(s)!==-1)return[];i.push(s);const r=s.manifest.extensionPack?s.manifest.extensionPack:[];if(r.length){const n=e.filter(y=>!y.isBuiltin&&r.some(b=>(0,d.areSameExtensions)({id:b},y.identifier))),a=[];for(const y of n)a.push(...this.getAllPackExtensionsToUninstall(y,e,i));return[...n,...a]}return[]}getDependents(s,e){return e.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(r=>(0,d.areSameExtensions)({id:r},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const e=await this.findGalleryExtensionById(s.identifier.uuid);return e||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},S.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},S.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};w=fe([ae(0,I.IExtensionGalleryService),ae(1,u.ITelemetryService),ae(2,E.ILogService)],w),t.AbstractExtensionManagementService=w;function f(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((e,i)=>new Error(`${e.message}${e.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}t.joinErrors=f;function v(o,s,e,i,r){const n=r?r instanceof I.ExtensionManagementError?r.code:t.ERROR_UNKNOWN:void 0;o.publicLogError(s,{...e,success:!r,duration:i,errorcode:n})}t.reportTelemetry=v;class h{constructor(){this.barrier=new P.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(s=>new Promise((e,i)=>{const r=s.onCancellationRequested(()=>{r.dispose(),i((0,C.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=h}),define(Q[119],Z([0,1,2,18,21,86,27,32,31,26]),function($,t,T,P,S,C,L,R,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let m=class{constructor(E,l){this._configurationService=l,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appender=E.appender,this._commonProperties=E.commonProperties||Promise.resolve({}),this._piiPaths=E.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!E.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,S.escapeRegExpCharacters)(u),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(u=>{const w=/^[a-f0-9]+$/i.test(u["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!w})})}setExperimentProperty(E,l){this._experimentProperties[E]=l}setEnabled(E){this._enabled=E}_updateUserOptIn(){const E=this._configurationService?.getValue(I);this._userOptIn=E?E.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const E=await this._commonProperties;let l=E.sessionID,u=E["common.instanceId"],w=E["common.machineId"],f=E["common.firstSessionDate"],v=E["common.msftInternal"];return{sessionId:l,instanceId:u,machineId:w,firstSessionDate:f,msftInternal:v}}dispose(){this._disposables.dispose()}publicLog(E,l,u){return this.isOptedIn?this._commonProperties.then(w=>{l=(0,P.mixin)(l,w),l=(0,P.mixin)(l,this._experimentProperties),l=(0,P.cloneAndChange)(l,f=>{if(typeof f=="string")return this._cleanupInfo(f,u)}),this._appender.log(E,l)},w=>{console.error(w)}):Promise.resolve(void 0)}publicLog2(E,l,u){return this.publicLog(E,l,u)}publicLogError(E,l){return this.sendErrorTelemetry?this.publicLog(E,l,!0):Promise.resolve(void 0)}publicLogError2(E,l){return this.publicLogError(E,l)}_cleanupInfo(E,l){let u=E;if(l){const w=[];for(let o of this._cleanupPatterns)for(;;){const s=o.exec(E);if(!s)break;w.push([s.index,o.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(u="";;){const o=v.exec(E);if(!o)break;!f.test(o[0])&&w.every(([s,e])=>o.index<s||o.index>=e)&&(u+=E.substring(h,o.index)+"<REDACTED: user-file-path>",h=v.lastIndex)}h<E.length&&(u+=E.substr(h))}for(let w of this._cleanupPatterns)u=u.replace(w,"");return u}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=fe([ae(1,L.IConfigurationService)],m),t.TelemetryService=m;const I="telemetry";g.Registry.as(R.Extensions.Configuration).registerConfiguration({id:I,order:110,type:"object",title:(0,C.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,C.localize)(2,null,c.default.nameLong,c.default.privacyStatementUrl):(0,C.localize)(1,null,c.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[44],Z([0,1,3,18,12,27]),function($,t,T,P,S,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.TelemetryLevel=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(w,f){return Promise.resolve(void 0)}publicLog2(w,f){return this.publicLog(w,f)}publicLogError(w,f){return Promise.resolve(void 0)}publicLogError2(w,f){return this.publicLogError(w,f)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class L{async publicLog(f,v,h){}async publicLogError(f,v,h){}}t.NullEndpointTelemetryService=L;function R(...w){return{log:(f,v)=>w.forEach(h=>h.log(f,v)),flush:()=>T.Promises.settled(w.map(f=>f.flush()))}}t.combinedAppender=R,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(w,f){return f.onDidChangeConfiguration(v=>{v.source!==6&&w.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(v.source),configurationKeys:l(v.sourceConfig)})})}t.configurationTelemetry=c;var g;(function(w){w[w.NONE=0]="NONE",w[w.LOG=1]="LOG",w[w.USER=2]="USER"})(g=t.TelemetryLevel||(t.TelemetryLevel={}));function m(w,f){return f.disableTelemetry||!w.enableTelemetry?0:f.isBuilt?2:1}t.getTelemetryLevel=m;function I(w){const f=Object.create(null),v=Object.create(null),h=Object.create(null);E(w,h);for(let o in h){o=o.length>150?o.substr(o.length-149):o;const s=h[o];typeof s=="number"?v[o]=s:typeof s=="boolean"?v[o]=s?1:0:typeof s=="string"?f[o]=s.substring(0,1023):typeof s!="undefined"&&s!==null&&(f[o]=s)}return{properties:f,measurements:v}}t.validateTelemetryData=I;function d(w){if(!w)return"none";let f="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{w.indexOf(`${h}+`)===0&&(f=h)}),f}t.cleanRemoteAuthority=d;function E(w,f,v=0,h){if(!!w)for(let o of Object.getOwnPropertyNames(w)){const s=w[o],e=h?h+o:o;Array.isArray(s)?f[e]=(0,P.safeStringify)(s):s instanceof Date?f[e]=s.toISOString():(0,S.isObject)(s)?v<2?E(s,f,v+1,e+"."):f[e]=(0,P.safeStringify)(s):f[e]=s}}function l(w){if(!w)return[];const f=[];return u(f,"",w),f}function u(w,f,v){v&&typeof v=="object"&&!Array.isArray(v)?Object.keys(v).forEach(h=>u(w,f?`${f}.${h}`:h,v[h])):w.push(f)}}),define(Q[120],Z([0,1,22,25,9,18,10,28,7,27,20,23,24,51,16,14,42,43,115,116,36,44]),function($,t,T,P,S,C,L,R,c,g,m,I,d,E,l,u,w,f,v,h,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=void 0;const e=L.isWeb?"web":(0,I.getTargetPlatform)(L.platform,R.arch);var i;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished"})(i||(i={}));function r(...k){return String(k.reduce((F,W)=>F|W,0))}var n;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},y={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},A={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class p{constructor(F=A){this.state=F}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(F,W=this.state.pageSize){return new p({...this.state,pageNumber:F,pageSize:W})}withFilter(F,...W){const V=[...this.state.criteria,...W.length?W.map(H=>({filterType:F,value:H})):[{filterType:F}]];return new p({...this.state,criteria:V})}withSortBy(F){return new p({...this.state,sortBy:F})}withSortOrder(F){return new p({...this.state,sortOrder:F})}withFlags(...F){return new p({...this.state,flags:F.reduce((W,V)=>W|V,0)})}withAssetTypes(...F){return new p({...this.state,assetTypes:F})}get raw(){const{criteria:F,pageNumber:W,pageSize:V,sortBy:H,sortOrder:J,flags:re,assetTypes:ie}=this.state;return{filters:[{criteria:F,pageNumber:W,pageSize:V,sortBy:H,sortOrder:J}],assetTypes:ie,flags:re}}get searchText(){const F=this.state.criteria.filter(W=>W.filterType===n.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(F=>String(F.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(k,F){const W=(k||[]).filter(V=>V.statisticName===F)[0];return W?W.value:0}function N(k){const F="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(V=>V.assetType.indexOf(F)===0).reduce((V,H)=>{const J=se(k,H.assetType);return J&&V.push([H.assetType.substring(F.length),J]),V},[])}function j(k){if(k.properties){const F=k.properties.filter(H=>H.key===a.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=F.filter(H=>W.test(H.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return se(k,a.Repository)}function Y(k){return{uri:`${k.fallbackAssetUri}/${a.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${a.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function te(k){const F=se(k,a.Icon);if(F)return F;const W=I.DefaultIconPath;return{uri:W,fallbackUri:W}}function se(k,F){return k.files.filter(V=>V.assetType===F)[0]?{uri:`${k.assetUri}/${F}`,fallbackUri:`${k.fallbackAssetUri}/${F}`}:null}function ee(k,F){const W=k.properties?k.properties.filter(H=>H.key===F):[],V=W.length>0&&W[0].value;return V?V.split(",").map(H=>(0,d.adoptToGalleryExtensionId)(H)):[]}function ce(k){const F=k.properties?k.properties.filter(W=>W.key===y.Engine):[];return F.length>0&&F[0].value||""}function le(k){const F=k.properties?k.properties.filter(V=>V.key===y.LocalizedLanguages):[],W=F.length>0&&F[0].value||"";return W?W.split(","):[]}function _(k){return k.indexOf("preview")!==-1}function ne(k){return k.targetPlatform?(0,I.toTargetPlatform)(k.targetPlatform):"undefined"}function z(k){const F=(0,T.distinct)(k.versions.map(ne)),W=!!k.tags?.includes(I.WEB_EXTENSION_TAG),V=F.indexOf("web");return W?V===-1&&F.push("web"):V!==-1&&F.splice(V,1),F}function D(k,F,W,V){const H=z(k);let J=k.versions[0];return J=k.versions.find(re=>re.version===J.version&&(0,I.isTargetPlatformCompatible)(ne(re),H,e))||J,M(k,J,H,F,W,V)}function M(k,F,W,V,H,J){const re={manifest:se(F,a.Manifest),readme:se(F,a.Details),changelog:se(F,a.Changelog),license:se(F,a.License),repository:j(F),download:Y(F),icon:te(F),coreTranslations:N(F)};return{identifier:{id:(0,d.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:F.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,description:k.shortDescription||"",installCount:O(k.statistics,"install"),rating:O(k.statistics,"averagerating"),ratingCount:O(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:W,assets:re,properties:{dependencies:ee(F,y.Dependency),extensionPack:ee(F,y.ExtensionPack),engine:ce(F),localizedLanguages:le(F),targetPlatform:ne(F)},preview:_(k.flags),telemetryData:{index:(H.pageNumber-1)*H.pageSize+V,querySource:J}}}let U=class{constructor(F,W,V,H,J,re,ie,ge){this.requestService=W,this.logService=V,this.environmentService=H,this.telemetryService=J,this.fileService=re,this.productService=ie,this.configurationService=ge;const ve=ie.extensionsGallery;this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=X(ie.version,ie,this.environmentService,this.configurationService,this.fileService,F)}api(F=""){return`${this.extensionsGalleryUrl}${F}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(F,W){const V=[];let H=new p().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,F.length).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExtensionName,...F.map(({id:re})=>re.toLowerCase()));F.every(re=>!re.version)&&(H=H.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:J}=await this.queryGallery(H,P.CancellationToken.None);for(let re=0;re<J.length;re++){const ie=J[re];if(!ie.versions.length)continue;const ge=(0,d.getGalleryExtensionId)(ie.publisher.publisherName,ie.extensionName),ve=F.find(de=>(0,d.areSameExtensions)(de,{id:ge}))?.version;if(ve){const de=ie.versions.find(ye=>ye.version===ve);de&&V.push(M(ie,de,z(ie),re,H))}else V.push(D(ie,re,H))}return V}async getCompatibleExtension(F,W){const V=(0,I.isIExtensionIdentifier)(F)?null:F;if(V){if((0,I.isNotWebExtensionInWebTargetPlatform)(V.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(V,W))return V}const{id:H,uuid:J}=V?V.identifier:F;let re=new p().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");J?re=re.withFilter(n.ExtensionId,J):re=re.withFilter(n.ExtensionName,H);const{galleryExtensions:ie}=await this.queryGallery(re,P.CancellationToken.None),[ge]=ie;if(!ge||!ge.versions.length)return null;const ve=z(ge);if((0,I.isNotWebExtensionInWebTargetPlatform)(ve,W))return null;for(let de of ge.versions){if(!ce(de)){const ye=await this.getEngine(de);de={...de,properties:[...de.properties||[],{key:y.Engine,value:ye}]}}if(await this.isRawExtensionVersionCompatible(de,ve,W))return M(ge,de,ve,0,re)}return null}async isExtensionCompatible(F,W){if(!(0,I.isTargetPlatformCompatible)(F.properties.targetPlatform,F.allTargetPlatforms,W))return!1;let V=F.properties.engine;if(!V){const H=await this.getManifest(F,P.CancellationToken.None);if(!H)throw new Error("Manifest was not found");V=H.engines.vscode}return(0,E.isEngineValid)(V,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(F,W,V){if(!(0,I.isTargetPlatformCompatible)(ne(F),W,V))return!1;const H=await this.getEngine(F);return(0,E.isEngineValid)(H,this.productService.version,this.productService.date)}async query(F,W){const V=P.CancellationToken.isCancellationToken(F)?{}:F,H=P.CancellationToken.isCancellationToken(F)?F:W;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let J=V.text||"";const re=(0,C.getOrDefault)(V,Re=>Re.pageSize,50);let ie=new p().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,re).withFilter(n.Target,"Microsoft.VisualStudio.Code");J?(J=J.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Re,pe,we)=>(ie=ie.withFilter(n.Category,we||pe),"")),J=J.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Re,pe,we)=>(ie=ie.withFilter(n.Tag,we||pe),"")),J=J.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(n.Featured),"")),J=J.trim(),J&&(J=J.length<200?J:J.substring(0,200),ie=ie.withFilter(n.SearchText,J)),ie=ie.withSortBy(0)):V.ids?ie=ie.withFilter(n.ExtensionId,...V.ids):V.names?ie=ie.withFilter(n.ExtensionName,...V.names):ie=ie.withSortBy(4),typeof V.sortBy=="number"&&(ie=ie.withSortBy(V.sortBy)),typeof V.sortOrder=="number"&&(ie=ie.withSortOrder(V.sortOrder));const{galleryExtensions:ge,total:ve}=await this.queryGallery(ie,H),de=ge.map((Re,pe)=>D(Re,pe,ie,V.source)),ye=async(Re,pe)=>{if(pe.isCancellationRequested)throw(0,S.canceled)();const we=ie.withPage(Re+1),{galleryExtensions:ze}=await this.queryGallery(we,pe);return ze.map((We,Me)=>D(We,Me,we,V.source))};return{firstPage:de,total:ve,pageSize:ie.pageSize,getPage:ye}}async queryGallery(F,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,i.ExcludeNonValidated).withFilter(n.ExcludeWithFlags,r(i.Unpublished));const V=await this.commonHeadersPromise,H=JSON.stringify(F.raw),J={...V,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},re=new Date().getTime();let ie,ge,ve=0;try{if(ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:H,headers:J},W),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:ve};const de=await(0,f.asJson)(ie);if(de){const ye=de.results[0],Re=ye.extensions,pe=ye.resultMetadata&&ye.resultMetadata.filter(we=>we.metadataType==="ResultCount")[0];return ve=pe&&pe.metadataItems.filter(we=>we.name==="TotalCount")[0].count||0,{galleryExtensions:Re,total:ve}}return{galleryExtensions:[],total:ve}}catch(de){throw ge=de,de}finally{this.telemetryService.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(H.length),duration:new Date().getTime()-re,success:!!ie&&(0,f.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:ge?(0,S.isPromiseCanceledError)(ge)?"canceled":(0,S.getErrorMessage)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(F,W,V,H){if(!this.isEnabled())return;const J=L.isWeb?this.api(`/itemName/${F}.${W}/version/${V}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${F}/extensions/${W}/${V}/stats?statType=${H}`),re=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.commonHeadersPromise,Accept:re};try{await this.requestService.request({type:"POST",url:J,headers:ge},P.CancellationToken.None)}catch(ve){}}async download(F,W,V){this.logService.trace("ExtensionGalleryService#download",F.identifier.id);const H=(0,d.getGalleryExtensionTelemetryData)(F),J=new Date().getTime(),re=de=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:de}),ie=V===1?"install":V===2?"update":"",ge=ie?{uri:`${F.assets.download.uri}${c.URI.parse(F.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${F.assets.download.fallbackUri}${c.URI.parse(F.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:F.assets.download,ve=await this.getAsset(ge);await this.fileService.writeFile(W,ve.stream),re(new Date().getTime()-J)}async getReadme(F,W){if(F.assets.readme){const V=await this.getAsset(F.assets.readme,{},W);return await(0,f.asText)(V)||""}return""}async getManifest(F,W){if(F.assets.manifest){const V=await this.getAsset(F.assets.manifest,{},W),H=await(0,f.asText)(V);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(F,W){const V=se(F,a.Manifest);if(!V)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},J=await this.getAsset(V,{headers:H});return await(0,f.asJson)(J)}async getCoreTranslation(F,W){const V=F.assets.coreTranslations.filter(H=>H[0]===W.toUpperCase())[0];if(V){const H=await this.getAsset(V[1]),J=await(0,f.asText)(H);return J?JSON.parse(J):null}return null}async getChangelog(F,W){if(F.assets.changelog){const V=await this.getAsset(F.assets.changelog,{},W);return await(0,f.asText)(V)||""}return""}async getAllCompatibleVersions(F,W){let V=new p().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");F.identifier.uuid?V=V.withFilter(n.ExtensionId,F.identifier.uuid):V=V.withFilter(n.ExtensionName,F.identifier.id);const{galleryExtensions:H}=await this.queryGallery(V,P.CancellationToken.None);if(!H.length)return[];const J=z(H[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(J,W))return[];const re=[];for(const ie of H[0].versions)try{await this.isRawExtensionVersionCompatible(ie,J,W)&&re.push({version:ie.version,date:ie.lastUpdated})}catch(ge){}return re}async getAsset(F,W={},V=P.CancellationToken.None){const H=await this.commonHeadersPromise,J={type:"GET"},re={...H,...W.headers||{}};W={...W,...J,headers:re};const ie=F.uri,ge=F.fallbackUri,ve={...W,url:ie};try{const de=await this.requestService.request(ve,V);if(de.res.statusCode===200)return de;const ye=await(0,f.asText)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${ye}`)}catch(de){if((0,S.isPromiseCanceledError)(de))throw de;const ye=(0,S.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:ye});const Re={...W,url:ge};return this.requestService.request(Re,V)}}async getEngine(F){let W=ce(F);if(!W){const V=await this.getManifestFromRawExtensionVersion(F,P.CancellationToken.None);if(!V)throw new Error("Manifest was not found");W=V.engines.vscode}return W}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const F=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},P.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,f.asJson)(F),V=new Map;if(W)for(const H of W.malicious){const J=V.get(H)||{id:{id:H},malicious:!0,slow:!1};J.malicious=!0,V.set(H,J)}return[...V.values()]}};U=fe([ae(1,f.IRequestService),ae(2,u.ILogService),ae(3,m.IEnvironmentService),ae(4,o.ITelemetryService),ae(5,l.IFileService),ae(6,w.IProductService),ae(7,g.IConfigurationService)],U);let G=class extends U{constructor(F,W,V,H,J,re,ie,ge){super(F,W,V,H,J,re,ie,ge)}};G=fe([ae(0,h.IStorageService),ae(1,f.IRequestService),ae(2,u.ILogService),ae(3,m.IEnvironmentService),ae(4,o.ITelemetryService),ae(5,l.IFileService),ae(6,w.IProductService),ae(7,g.IConfigurationService)],G),t.ExtensionGalleryService=G;let B=class extends U{constructor(F,W,V,H,J,re,ie){super(void 0,F,W,V,H,J,re,ie)}};B=fe([ae(0,f.IRequestService),ae(1,u.ILogService),ae(2,m.IEnvironmentService),ae(3,o.ITelemetryService),ae(4,l.IFileService),ae(5,w.IProductService),ae(6,g.IConfigurationService)],B),t.ExtensionGalleryServiceWithNoStorageService=B;async function X(k,F,W,V,H,J){const re={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k}`},ie=await(0,v.getServiceMachineId)(W,H,J);return(0,s.getTelemetryLevel)(F,W)>=2&&V.getValue("telemetry.enableTelemetry")===!0&&(re["X-Market-User-Id"]=ie),re}t.resolveMarketplaceHeaders=X}),define(Q[121],Z([0,1,9,18,44]),function($,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function C(R){const c=await new Promise((m,I)=>{$(["applicationinsights"],m,I)});let g;return c.defaultClient?(g=new c.TelemetryClient(R),g.channel.setUseDiskRetryCaching(!0)):(c.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=c.defaultClient),R.indexOf("AIF-")===0&&(g.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),g}class L{constructor(c,g,m){this._eventPrefix=c,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof m=="function"?this._aiClient=m():this._aiClient=m,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=C(this._aiClient)),this._asyncAIClient.then(g=>{c(g)},g=>{(0,T.onUnexpectedError)(g),console.error(g)})}}log(c,g){!this._aiClient||(g=(0,P.mixin)(g,this._defaultData),g=(0,S.validateTelemetryData)(g),this._withAIClient(m=>m.trackEvent({name:this._eventPrefix+"/"+c,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=L}),define(Q[122],Z([0,1,4,11]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function S(C,L){const R=Object.create(null),c=(m,I)=>{const d=JSON.parse(m);R[I]=d};if(L){const m=[],I=await P.Promises.readdir(L);for(const E of I)try{(await P.Promises.stat((0,T.join)(L,E))).isDirectory()&&m.push(E)}catch{}const d=[];for(const E of m)(await P.Promises.readdir((0,T.join)(L,E))).filter(u=>u==="telemetry.json").length===1&&d.push(E);for(const E of d){const l=(await P.Promises.readFile((0,T.join)(L,E,"telemetry.json"))).toString();c(l,E)}}let g=(await P.Promises.readFile((0,T.join)(C,"telemetry-core.json"))).toString();return c(g,"vscode-core"),g=(await P.Promises.readFile((0,T.join)(C,"telemetry-extensions.json"))).toString(),c(g,"vscode-extensions"),JSON.stringify(R,null,4)}t.buildTelemetryMessage=S}),define(Q[45],Z([0,1,38,3,4,12,11,73,133,134]),function($,t,T,P,S,C,L,R,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class m extends Error{constructor(e,i){let r=i.message;switch(e){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=e,this.cause=i}}t.ExtractError=m;function I(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,r)=>i+r,e&61440)}function d(s){if(s instanceof m)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new m(e,s)}function E(s,e,i,r,n,a){const y=S.dirname(e),b=S.join(r,y);if(!b.startsWith(r))return Promise.reject(new Error(R.localize(0,null,e)));const A=S.join(r,e);let p;return a.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(L.Promises.mkdir(b,{recursive:!0})).then(()=>new Promise((O,N)=>{if(!a.isCancellationRequested)try{p=(0,T.createWriteStream)(A,{mode:i}),p.once("close",()=>O()),p.once("error",N),s.once("error",N),s.pipe(p)}catch(j){N(j)}}))}function l(s,e,i,r){let n=(0,P.createCancelablePromise)(()=>Promise.resolve()),a=0;return r.onCancellationRequested(()=>{n.cancel(),s.close()}),new Promise((y,b)=>{const A=new P.Sequencer,p=O=>{O.isCancellationRequested||(a++,s.readEntry())};s.once("error",b),s.once("close",()=>n.then(()=>{r.isCancellationRequested||s.entryCount===a?y():b(new m("Incomplete",new Error(R.localize(1,null,a,s.entryCount))))},b)),s.readEntry(),s.on("entry",O=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(O.fileName)){p(r);return}const N=O.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(N)){const te=S.join(e,N);n=(0,P.createCancelablePromise)(se=>L.Promises.mkdir(te,{recursive:!0}).then(()=>p(se)).then(void 0,b));return}const j=w(s,O),Y=I(O);n=(0,P.createCancelablePromise)(te=>A.queue(()=>j.then(se=>E(se,N,Y,e,i,te).then(()=>p(te)))).then(null,b))})})}function u(s,e=!1){return new Promise((i,r)=>{(0,c.open)(s,e?{lazyEntries:!0}:void 0,(n,a)=>{n?r(d(n)):i((0,C.assertIsDefined)(a))})})}function w(s,e){return new Promise((i,r)=>{s.openReadStream(e,(n,a)=>{n?r(d(n)):i((0,C.assertIsDefined)(a))})})}function f(s,e){return new Promise((i,r)=>{const n=new g.ZipFile;e.forEach(y=>{y.contents?n.addBuffer(typeof y.contents=="string"?Buffer.from(y.contents,"utf8"):y.contents,y.path):y.localPath&&n.addFile(y.localPath,y.path)}),n.end();const a=(0,T.createWriteStream)(s);n.outputStream.pipe(a),n.outputStream.once("error",r),a.once("error",r),a.once("finish",()=>i(s))})}t.zip=f;function v(s,e,i={},r){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=u(s,!0);return i.overwrite&&(a=a.then(y=>L.Promises.rm(e).then(()=>y))),a.then(y=>l(y,e,{sourcePathRegex:n},r))}t.extract=v;function h(s,e){return u(s).then(i=>new Promise((r,n)=>{i.on("entry",a=>{a.fileName===e&&w(i,a).then(y=>r(y),y=>n(y))}),i.once("close",()=>n(new Error(R.localize(2,null,e))))}))}function o(s,e){return h(s,e).then(i=>new Promise((r,n)=>{const a=[];i.once("error",n),i.on("data",y=>a.push(y)),i.on("end",()=>r(Buffer.concat(a)))}))}t.buffer=o}),define(Q[123],Z([0,1,45,79]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function S(C){return(0,T.buffer)(C,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch(R){throw new Error((0,P.localize)(0,null))}})}t.getManifest=S}),define(Q[124],Z([0,1,22,3,9,2,8,4,10,19,41,7,30,11,45,80,20,23,24,91,16,14,42]),function($,t,T,P,S,C,L,R,c,g,m,I,d,E,l,u,w,f,v,h,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",r="scanningUser",n="extracting",a="deleting",y="renaming";let b=class extends C.Disposable{constructor(p,O,N,j,Y){super();this.beforeRemovingExtension=p,this.fileService=O,this.logService=N,this.environmentService=j,this.productService=Y,this._devSystemExtensionsPath=null,this.systemExtensionsPath=j.builtinExtensionsPath,this.extensionsPath=j.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new P.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(p){const O=[];(p===null||p===0)&&O.push(this.scanSystemExtensions().then(null,N=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(N).message,i)))),(p===null||p===1)&&O.push(this.scanUserExtensions(!0).then(null,N=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(N).message,r))));try{const N=await Promise.all(O);return(0,T.flatten)(N)}catch(N){throw this.joinErrors(N)}}async scanUserExtensions(p){this.logService.trace("Started scanning user extensions");let[O,N]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return N=N.filter(j=>!O[new v.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).key()]),p&&(N=(0,v.groupByExtension)(N,Y=>Y.identifier).map(Y=>Y.sort((te,se)=>m.rcompare(te.manifest.version,se.manifest.version))[0])),this.logService.trace("Scanned user extensions:",N.length),N}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(p,O,N,j){const Y=p.key(),te=R.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),se=R.join(this.extensionsPath,Y);try{await E.Promises.rm(se)}catch(ce){try{await E.Promises.rm(se)}catch(le){}throw new f.ExtensionManagementError((0,u.localize)(0,null,se,p.id),a)}await this.extractAtLocation(p,O,te,j);let ee=await this.scanExtension(I.URI.file(te),1);if(!ee)throw new Error((0,u.localize)(1,null,te));await this.storeMetadata(ee,{...N,installedTimestamp:Date.now()});try{await this.rename(p,te,se,Date.now()+2*60*1e3),this.logService.info("Renamed to",se)}catch(ce){try{await E.Promises.rm(te)}catch(le){}if(ce.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",p.id);else throw this.logService.info(`Rename failed because of ${(0,S.getErrorMessage)(ce)}. Deleted from extracted location`,te),ce}try{ee=await this.scanExtension(I.URI.file(se),1)}catch(ce){}if(ee)return ee;throw new Error((0,u.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(p,O){return this.setMetadata(p,O),await this.storeMetadata(p,{...O,installedTimestamp:p.installedTimestamp}),p}async storeMetadata(p,O){O.isMachineScoped=O.isMachineScoped||void 0,O.isBuiltin=O.isBuiltin||void 0,O.installedTimestamp=O.installedTimestamp||void 0;const N=R.join(p.location.fsPath,"package.json"),j=await E.Promises.readFile(N,"utf8"),{manifest:Y}=await this.parseManifest(j);return Y.__metadata=O,await E.Promises.writeFile(N,JSON.stringify(Y,null,"	")),p}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...p){const O=p.map(N=>new v.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version));await this.withUninstalledExtensions(N=>{O.forEach(j=>N[j.key()]=!0)})}async setInstalled(p){await this.withUninstalledExtensions(j=>delete j[p.key()]);const N=(await this.scanExtensions(1)).find(j=>new v.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).equals(p))||null;return N?(await this.storeMetadata(N,{installedTimestamp:Date.now()}),this.scanExtension(N.location,1)):null}async withUninstalledExtensions(p){return this.uninstalledFileLimiter.queue(async()=>{let O;try{O=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(j){if(j.code!=="ENOENT")throw j}let N={};if(O)try{N=JSON.parse(O)}catch(j){}return p&&(p(N),Object.keys(N).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(N)):await E.Promises.rm(this.uninstalledPath)),N})}async removeExtension(p,O){this.logService.trace(`Deleting ${O} extension from disk`,p.identifier.id,p.location.fsPath),await E.Promises.rm(p.location.fsPath),this.logService.info("Deleted from disk",p.identifier.id,p.location.fsPath)}async removeUninstalledExtension(p){await this.removeExtension(p,"uninstalled"),await this.withUninstalledExtensions(O=>delete O[new v.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()])}async extractAtLocation(p,O,N,j){this.logService.trace(`Started extracting the extension from ${O} to ${N}`);try{await E.Promises.rm(N)}catch(Y){throw new f.ExtensionManagementError(this.joinErrors(Y).message,a)}try{await(0,l.extract)(O,N,{sourcePath:"extension",overwrite:!0},j),this.logService.info(`Extracted extension to ${N}:`,p.id)}catch(Y){try{await E.Promises.rm(N)}catch(te){}throw new f.ExtensionManagementError(Y.message,Y instanceof l.ExtractError&&Y.type?Y.type:n)}}async rename(p,O,N,j){try{await E.Promises.rename(O,N)}catch(Y){if(c.isWindows&&Y&&Y.code==="EPERM"&&Date.now()<j)return this.logService.info(`Failed renaming ${O} to ${N} with 'EPERM' error. Trying again...`,p.id),this.rename(p,O,N,j);throw new f.ExtensionManagementError(Y.message||(0,u.localize)(3,null,O,N),Y.code||y)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const p=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return p;const O=this.scanDevSystemExtensions(),[N,j]=await Promise.all([p,O]);return[...N,...j]}async scanExtensionsInDir(p,O){const N=new P.Limiter(10),j=await this.fileService.resolve(I.URI.file(p));return j.children?(await Promise.all(j.children.filter(te=>te.isDirectory).map(te=>N.queue(async()=>O===1&&(0,g.basename)(te.resource).indexOf(".")===0?null:this.scanExtension(te.resource,O))))).filter(te=>te&&te.identifier):[]}async scanExtension(p,O){try{const N=await this.fileService.resolve(p);if(N.children){const{manifest:j,metadata:Y}=await this.readManifest(p.fsPath),te=N.children.find(({name:le})=>/^readme(\.txt|\.md|)$/i.test(le))?.resource,se=N.children.find(({name:le})=>/^changelog(\.txt|\.md|)$/i.test(le))?.resource,ee={id:(0,v.getGalleryExtensionId)(j.publisher,j.name)},ce={type:O,identifier:ee,manifest:j,location:p,readmeUrl:te,changelogUrl:se,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:O===0};return Y&&(this.setMetadata(ce,Y),ce.installedTimestamp=Y.installedTimestamp),ce}}catch(N){O!==0&&this.logService.trace(N)}return null}async scanDefaultSystemExtensions(){const p=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",p.length),p}async scanDevSystemExtensions(){const p=this.getDevSystemExtensionsList();if(p.length){const O=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",O.length),O.filter(N=>p.some(j=>(0,v.areSameExtensions)(N.identifier,{id:j})))}else return[]}setMetadata(p,O){p.publisherDisplayName=O.publisherDisplayName||null,p.publisherId=O.publisherId||null,p.identifier.uuid=O.id,p.isMachineScoped=!!O.isMachineScoped,p.isBuiltin=p.type===0||!!O.isBuiltin}async removeUninstalledExtensions(){const p=await this.getUninstalledExtensions(),O=await this.scanAllUserExtensions(),N=new Set;for(const te of O)p[new v.ExtensionIdentifierWithVersion(te.identifier,te.manifest.version).key()]||N.add(te.identifier.id.toLowerCase());const j=(0,v.groupByExtension)(O,te=>te.identifier);await P.Promises.settled(j.map(async te=>{const se=te.sort((ee,ce)=>m.rcompare(ee.manifest.version,ce.manifest.version))[0];N.has(se.identifier.id.toLowerCase())||await this.beforeRemovingExtension(se)}));const Y=O.filter(te=>p[new v.ExtensionIdentifierWithVersion(te.identifier,te.manifest.version).key()]);await P.Promises.settled(Y.map(te=>this.removeUninstalledExtension(te)))}async removeOutdatedExtensions(){const p=await this.scanAllUserExtensions(),O=[],N=(0,v.groupByExtension)(p,j=>j.identifier);O.push(...(0,T.flatten)(N.map(j=>j.sort((Y,te)=>m.rcompare(Y.manifest.version,te.manifest.version)).slice(1)))),await P.Promises.settled(O.map(j=>this.removeExtension(j,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(p=>p.name)}joinErrors(p){const O=Array.isArray(p)?p:[p];return O.length===1?O[0]instanceof Error?O[0]:new Error(O[0]):O.reduce((N,j)=>new Error(`${N.message}${N.message?",":""}${j instanceof Error?j.message:j}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(L.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(p){const O=[E.Promises.readFile(R.join(p,"package.json"),"utf8").then(te=>this.parseManifest(te)),E.Promises.readFile(R.join(p,"package.nls.json"),"utf8").then(void 0,te=>te.code!=="ENOENT"?Promise.reject(te):"{}").then(te=>JSON.parse(te))],[{manifest:N,metadata:j},Y]=await Promise.all(O);return{manifest:(0,h.localizeManifest)(N,Y),metadata:j}}parseManifest(p){return new Promise((O,N)=>{try{const j=JSON.parse(p),Y=j.__metadata||null;O({manifest:j,metadata:Y})}catch(j){N(new Error((0,u.localize)(4,null)))}})}};b=fe([ae(1,o.IFileService),ae(2,s.ILogService),ae(3,w.INativeEnvironmentService),ae(4,e.IProductService)],b),t.ExtensionsScanner=b}),define(Q[125],Z([0,1,29,9,8,4,10,28,19,41,7,30,11,45,78,53,20,118,23,24,102,103,123,98,124,104,51,16,15,14,31,36]),function($,t,T,P,S,C,L,R,c,g,m,I,d,E,l,u,w,f,v,h,o,s,e,i,r,n,a,y,b,A,p,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const N="unsetUninstalled",j="downloading";let Y=class extends f.AbstractExtensionManagementService{constructor(_,ne,z,D,M,U,G){super(_,ne,z);this.environmentService=D,this.downloadService=M,this.fileService=G;const B=this._register(U.createInstance(s.ExtensionsLifecycle));this.extensionsScanner=this._register(U.createInstance(r.ExtensionsScanner,k=>B.postUninstall(k))),this.manifestCache=this._register(new i.ExtensionsManifestCache(D,this)),this.extensionsDownloader=this._register(U.createInstance(o.ExtensionsDownloader));const X=this._register(new n.ExtensionsWatcher(this,G,D,z));this._register(X.onDidChangeExtensionsByAnotherSource(({added:k,removed:F})=>{k.length&&this._onDidInstallExtensions.fire(k.map(W=>({identifier:W.identifier,operation:0,local:W}))),F.forEach(W=>this._onDidUninstallExtension.fire({identifier:W}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{let _=(0,v.getTargetPlatform)(L.platform,R.arch);return _==="linux-x64"&&await this.isAlpineLinux()&&(_="alpine-x64"),this.logService.debug("ExtensionManagementService#TargetPlatform:",_),_})()),this._targetPlatformPromise}async isAlpineLinux(){let _;try{_=(await this.fileService.readFile(m.URI.file("/etc/os-release"))).value.toString()}catch(ne){try{_=(await this.fileService.readFile(m.URI.file("/usr/lib/os-release"))).value.toString()}catch(z){this.logService.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(z))}}return!!_&&(_.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(_){this.logService.trace("ExtensionManagementService#zip",_.identifier.id);const ne=await this.collectFiles(_),z=await(0,E.zip)((0,c.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)()).fsPath,ne);return m.URI.file(z)}async unzip(_){return this.logService.trace("ExtensionManagementService#unzip",_.toString()),(await this.install(_)).identifier}async getManifest(_){const ne=await this.downloadVsix(_),z=C.resolve(ne.fsPath);return(0,e.getManifest)(z)}getInstalled(_=null){return this.extensionsScanner.scanExtensions(_)}async install(_,ne={}){this.logService.trace("ExtensionManagementService#install",_.toString());const z=await this.downloadVsix(_),D=await(0,e.getManifest)(C.resolve(z.fsPath));if(D.engines&&D.engines.vscode&&!(0,a.isEngineValid)(D.engines.vscode,p.default.version,p.default.date))throw new Error(l.localize(0,null,(0,h.getGalleryExtensionId)(D.publisher,D.name),p.default.version));return this.installExtension(D,z,ne)}async updateMetadata(_,ne){return this.logService.trace("ExtensionManagementService#updateMetadata",_.identifier.id),_=await this.extensionsScanner.saveMetadataForLocalExtension(_,{..._.manifest.__metadata||{},...ne}),this.manifestCache.invalidate(),_}async updateExtensionScope(_,ne){return this.logService.trace("ExtensionManagementService#updateExtensionScope",_.identifier.id),_=await this.extensionsScanner.saveMetadataForLocalExtension(_,{..._.manifest.__metadata||{},isMachineScoped:ne}),this.manifestCache.invalidate(),_}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(_){if(_.scheme===S.Schemas.file)return _;const ne=(0,c.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)());return await this.downloadService.download(_,ne),ne}createInstallExtensionTask(_,ne,z){return m.URI.isUri(ne)?new ee(_,ne,z,this.galleryService,this.extensionsScanner,this.logService):new se(ne,z,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(_,ne){return new ce(_,ne,this.extensionsScanner)}async collectFiles(_){const ne=async D=>{let M=await d.Promises.readdir(D);M=M.map(B=>C.join(D,B));const U=await Promise.all(M.map(B=>d.Promises.stat(B)));let G=Promise.resolve([]);return U.forEach((B,X)=>{const k=M[X];B.isFile()&&(G=G.then(F=>[...F,k])),B.isDirectory()&&(G=G.then(F=>ne(k).then(W=>[...F,...W])))}),G};return(await ne(_.location.fsPath)).map(D=>({path:`extension/${C.relative(_.location.fsPath,D)}`,localPath:D}))}};Y=fe([ae(0,v.IExtensionGalleryService),ae(1,O.ITelemetryService),ae(2,A.ILogService),ae(3,w.INativeEnvironmentService),ae(4,u.IDownloadService),ae(5,b.IInstantiationService),ae(6,y.IFileService)],Y),t.ExtensionManagementService=Y;class te extends f.AbstractExtensionTask{constructor(_,ne,z,D){super();this.identifier=_,this.source=ne,this.extensionsScanner=z,this.logService=D,this._operation=1}get operation(){return this._operation}async installExtension(_,ne){try{const z=await this.unsetUninstalledAndGetLocal(_.identifierWithVersion);if(z)return _.metadata?this.extensionsScanner.saveMetadataForLocalExtension(z,_.metadata):z}catch(z){throw L.isMacintosh?new v.ExtensionManagementError(l.localize(1,null),N):new v.ExtensionManagementError(l.localize(2,null),N)}return this.extract(_,ne)}async unsetUninstalledAndGetLocal(_){if(!await this.isUninstalled(_))return null;this.logService.trace("Removing the extension from uninstalled list:",_.id);const z=await this.extensionsScanner.setInstalled(_);return this.logService.info("Removed the extension from uninstalled list:",_.id),z}async isUninstalled(_){return!!(await this.extensionsScanner.getUninstalledExtensions())[_.key()]}async extract({zipPath:_,identifierWithVersion:ne,metadata:z},D){let M=await this.extensionsScanner.extractUserExtension(ne,_,z,D);return this.logService.info("Extracting completed.",ne.id),M}}class se extends te{constructor(_,ne,z,D,M){super(_.identifier,_,D,M);this.gallery=_,this.options=ne,this.extensionsDownloader=z}async doRun(_){const z=(await this.extensionsScanner.scanExtensions(null)).find(U=>(0,h.areSameExtensions)(U.identifier,this.gallery.identifier));z&&(this._operation=2);const D=await this.downloadInstallableExtension(this.gallery,this._operation);D.metadata.isMachineScoped=this.options.isMachineScoped||z?.isMachineScoped,D.metadata.isBuiltin=this.options.isBuiltin||z?.isBuiltin;const M=await this.installExtension(D,_);z&&g.neq(z.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(z);try{await this.extensionsDownloader.delete(m.URI.file(D.zipPath))}catch(U){}return M}async downloadInstallableExtension(_,ne){const z={id:_.identifier.uuid,publisherId:_.publisherId,publisherDisplayName:_.publisherDisplayName};let D;try{this.logService.trace("Started downloading extension:",_.identifier.id),D=(await this.extensionsDownloader.downloadExtension(_,ne)).fsPath,this.logService.info("Downloaded extension:",_.identifier.id,D)}catch(M){throw new v.ExtensionManagementError((0,f.joinErrors)(M).message,j)}try{const M=await(0,e.getManifest)(D);return{zipPath:D,identifierWithVersion:new h.ExtensionIdentifierWithVersion(_.identifier,M.version),metadata:z}}catch(M){throw new v.ExtensionManagementError((0,f.joinErrors)(M).message,f.INSTALL_ERROR_VALIDATING)}}}class ee extends te{constructor(_,ne,z,D,M,U){super({id:(0,h.getGalleryExtensionId)(_.publisher,_.name)},ne,M,U);this.manifest=_,this.location=ne,this.options=z,this.galleryService=D}async doRun(_){const ne=new h.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),D=(await this.extensionsScanner.scanExtensions(1)).find(U=>(0,h.areSameExtensions)(this.identifier,U.identifier)),M=await this.getMetadata(this.identifier.id,_);if(M.isMachineScoped=this.options.isMachineScoped||D?.isMachineScoped,M.isBuiltin=this.options.isBuiltin||D?.isBuiltin,D)if(this._operation=2,ne.equals(new h.ExtensionIdentifierWithVersion(D.identifier,D.manifest.version)))try{await this.extensionsScanner.removeExtension(D,"existing")}catch(U){throw new Error(l.localize(3,null,this.manifest.displayName||this.manifest.name))}else g.gt(D.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(D);else{const U=await this.unsetUninstalledAndGetLocal(ne);if(U)try{await this.extensionsScanner.removeExtension(U,"existing")}catch(G){throw new Error(l.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:C.resolve(this.location.fsPath),identifierWithVersion:ne,metadata:M},_)}async getMetadata(_,ne){try{const z=(await this.galleryService.query({names:[_],pageSize:1},ne)).firstPage[0];if(z)return{id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId}}catch(z){}return{}}}class ce extends f.AbstractExtensionTask{constructor(_,ne,z){super();this.extension=_,this.options=ne,this.extensionsScanner=z}async doRun(_){const ne=[],z=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const D=new h.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);ne.push(...z.filter(M=>D.equals(new h.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version))))}else ne.push(...z.filter(D=>(0,h.areSameExtensions)(D.identifier,this.extension.identifier)));if(!ne.length)throw new Error(l.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...ne),this.options.remove)for(const D of ne)try{_.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(D)}catch(M){throw new Error(l.localize(6,null,(0,T.toErrorMessage)(M)))}}}}),define(Q[126],Z([0,1,114,17,9,2,12,27,20,99,14,113,135]),function($,t,T,P,S,C,L,R,c,g,m,I,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let E=class extends C.Disposable{constructor(u,w,f){super();this.environmentService=w,this.logService=f,this.configure(u.getValue()),this._register(u.onDidChangeConfiguration(()=>this.configure(u.getValue()),this))}configure(u){this.proxyUrl=u.http&&u.http.proxy,this.strictSSL=!!(u.http&&u.http.proxyStrictSSL),this.authorization=u.http&&u.http.proxyAuthorization}async request(u,w){this.logService.trace("RequestService#request",u.url);const{proxyUrl:f,strictSSL:v}=this,h={...process.env,...await(0,g.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=u.agent?u.agent:await(0,I.getProxyAgent)(u.url||"",h,{proxyUrl:f,strictSSL:v});return u.agent=o,u.strictSSL=v,this.authorization&&(u.headers={...u.headers||{},"Proxy-Authorization":this.authorization}),this._request(u,w)}async getNodeRequest(u){return((0,T.parse)(u.url).protocol==="https:"?await new Promise((v,h)=>{$(["https"],v,h)}):await new Promise((v,h)=>{$(["http"],v,h)})).request}_request(u,w){return new Promise(async(f,v)=>{let h;const o=(0,T.parse)(u.url),s=u.getRawRequest?u.getRawRequest(u):await this.getNodeRequest(u),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,L.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(e.auth=u.user+":"+u.password),h=s(e,i=>{const r=(0,L.isNumber)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)this._request({...u,url:i.headers.location,followRedirects:r-1},w).then(f,v);else{let n=i;i.headers["content-encoding"]==="gzip"&&(n=i.pipe((0,d.createGunzip)())),f({res:i,stream:(0,P.streamToBufferReadableStream)(n)})}}),h.on("error",v),u.timeout&&h.setTimeout(u.timeout),u.data&&typeof u.data=="string"&&h.write(u.data),h.end(),w.onCancellationRequested(()=>{h.abort(),v((0,S.canceled)())})})}async resolveProxy(u){}};E=fe([ae(0,R.IConfigurationService),ae(1,c.INativeEnvironmentService),ae(2,m.ILogService)],E),t.RequestService=E}),define(Q[136],Z([0,1,38,137,34,3,17,29,9,2,8,4,28,7,11,27,111,53,112,20,90,120,23,97,125,16,107,108,52,101,55,56,105,14,106,31,42,43,126,117,36,119,44,121,122]),function($,t,T,P,S,C,L,R,c,g,m,I,d,E,l,u,w,f,v,h,o,s,e,i,r,n,a,y,b,A,p,O,N,j,Y,te,se,ee,ce,le,_,ne,z,D,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class U extends g.Disposable{constructor(X){super();this.argv=X,(0,P.gracefulify)(T),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[X,k]=await this.initServices();return X.invokeFunction(async F=>{const W=F.get(j.ILogService),V=F.get(n.IFileService),H=F.get(h.INativeEnvironmentService),J=F.get(e.IExtensionManagementCLIService);return W.info("CLI main",this.argv),this.registerErrorHandler(W),await this.doRun(H,J,V),(0,C.raceTimeout)((0,z.combinedAppender)(...k).flush(),1e3)})}async initServices(){const X=new p.ServiceCollection,k={_serviceBrand:void 0,...te.default};X.set(se.IProductService,k);const F=new o.NativeEnvironmentService(this.argv,k);X.set(h.INativeEnvironmentService,F),await Promise.all([F.appSettingsHome.fsPath,F.extensionsPath].map(ve=>ve?l.Promises.mkdir(ve,{recursive:!0}):void 0));const W=(0,j.getLogLevel)(F),V=[];V.push(new Y.SpdLogLogger("cli",(0,I.join)(F.logsPath,"cli.log"),!0,W)),W===j.LogLevel.Trace&&V.push(new j.ConsoleLogger(W));const H=this._register(new j.MultiplexLogService(V));X.set(j.ILogService,H);const J=this._register(new a.FileService(H));X.set(n.IFileService,J);const re=this._register(new y.DiskFileSystemProvider(H));J.registerProvider(m.Schemas.file,re);const ie=this._register(new w.ConfigurationService(F.settingsResource,J));X.set(u.IConfigurationService,ie),await ie.initialize(),X.set(ee.IRequestService,new b.SyncDescriptor(ce.RequestService)),X.set(f.IDownloadService,new b.SyncDescriptor(v.DownloadService)),X.set(e.IExtensionManagementService,new b.SyncDescriptor(r.ExtensionManagementService)),X.set(e.IExtensionGalleryService,new b.SyncDescriptor(s.ExtensionGalleryServiceWithNoStorageService)),X.set(e.IExtensionManagementCLIService,new b.SyncDescriptor(i.ExtensionManagementCLIService)),X.set(O.ILocalizationsService,new b.SyncDescriptor(N.LocalizationsService));const ge=[];if((0,z.getTelemetryLevel)(k,F)>=2){k.aiConfig&&k.aiConfig.asimovKey&&ge.push(new D.AppInsightsAppender("monacoworkbench",null,k.aiConfig.asimovKey));const{appRoot:ve,extensionsPath:de,installSourcePath:ye}=F,Re={appender:(0,z.combinedAppender)(...ge),sendErrorTelemetry:!1,commonProperties:(async()=>{let pe;try{const we=await l.Promises.readFile((0,I.join)(F.userDataPath,"storage.json"));pe=JSON.parse(we.toString())[_.machineIdKey]}catch(we){we.code!=="ENOENT"&&H.error(we)}return(0,le.resolveCommonProperties)(J,(0,S.release)(),(0,S.hostname)(),process.arch,k.commit,k.version,pe,k.msftInternalDomains,ye)})(),piiPaths:[ve,de]};X.set(_.ITelemetryService,new b.SyncDescriptor(ne.TelemetryService,[Re]))}else X.set(_.ITelemetryService,z.NullTelemetryService);return[new A.InstantiationService(X),ge]}registerErrorHandler(X){(0,c.setUnexpectedErrorHandler)(k=>{const F=(0,R.toErrorMessage)(k,!0);!F||X.error(`[uncaught exception in CLI]: ${F}`)}),process.on("uncaughtException",k=>(0,c.onUnexpectedError)(k)),process.on("unhandledRejection",k=>(0,c.onUnexpectedError)(k))}async doRun(X,k,F){if(this.argv["install-source"])return this.setInstallSource(X,F,this.argv["install-source"]);if(this.argv["list-extensions"])return k.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return k.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return k.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return k.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(X.appRoot,X.extensionsPath))}asExtensionIdOrVSIX(X){return X.map(k=>/\.vsix$/i.test(k)?E.URI.file((0,I.isAbsolute)(k)?k:(0,I.join)((0,d.cwd)(),k)):k)}async setInstallSource(X,k,F){await k.writeFile(E.URI.file(X.installSourcePath),L.VSBuffer.fromString(F.slice(0,30)))}}async function G(B){const X=new U(B);try{await X.run()}finally{X.dispose()}}t.main=G})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ec40cbe164c59f3d13b6eff5fc7b0231ec0ab7aa/core/vs/code/node/cliProcessMain.js.map
