/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/severity","fs","vs/editor/common/core/position","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/skipList","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(Y){for(var e=[],g=0,L=Y.length;g<L;g++)e[g]=me[Y[g]];return e};define(me[56],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(L,I){if(!L)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=g}),define(me[57],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function L(n){const P=[];for(let c in n)g.call(n,c)&&P.push(n[c]);return P}e.values=L;function I(n,P){for(let c in n)if(g.call(n,c)&&P({key:c,value:n[c]},function(){delete n[c]})===!1)return}e.forEach=I;function C(n,P){const c=Object.create(null);for(const m of n){const u=P(m);let h=c[u];h||(h=c[u]=[]),h.push(m)}return c}e.groupBy=C;function R(n){const P=Object.create(null);return n&&n.forEach((c,m)=>{P[m]=c}),P}e.fromMap=R;function E(n,P){const c=[],m=[];for(let u of n)P.has(u)||c.push(u);for(let u of P)n.has(u)||m.push(u);return{removed:c,added:m}}e.diffSets=E;function S(n,P){const c=[],m=[];for(let[u,h]of n)P.has(u)||c.push(h);for(let[u,h]of P)n.has(u)||m.push(h);return{removed:c,added:m}}e.diffMaps=S;class T{constructor(){this.map=new Map}add(P,c){let m=this.map.get(P);m||(m=new Set,this.map.set(P,m)),m.add(c)}delete(P,c){const m=this.map.get(P);!m||(m.delete(c),m.size===0&&this.map.delete(P))}forEach(P,c){const m=this.map.get(P);!m||m.forEach(c)}}e.SetMap=T}),define(me[58],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(R){return(E,S,T)=>{let n=null,P=null;if(typeof T.value=="function"?(n="value",P=T.value):typeof T.get=="function"&&(n="get",P=T.get),!P)throw new Error("not supported");T[n]=R(P,S)}}e.createDecorator=g;function L(R,E,S){let T=null,n=null;if(typeof S.value=="function"?(T="value",n=S.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(T="get",n=S.get),!n)throw new Error("not supported");const P=`$memoize$${E}`;S[T]=function(...c){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,c)}),this[P]}}e.memoize=L;function I(R,E,S){return g((T,n)=>{const P=`$debounce$${n}`,c=`$debounce$result$${n}`;return function(...m){this[c]||(this[c]=S?S():void 0),clearTimeout(this[P]),E&&(this[c]=E(this[c],...m),m=[this[c]]),this[P]=setTimeout(()=>{T.apply(this,m),this[c]=S?S():void 0},R)}})}e.debounce=I;function C(R,E,S){return g((T,n)=>{const P=`$throttle$timer$${n}`,c=`$throttle$result$${n}`,m=`$throttle$lastRun$${n}`,u=`$throttle$pending$${n}`;return function(...h){if(this[c]||(this[c]=S?S():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),E&&(this[c]=E(this[c],...h)),this[u])return;const D=this[m]+R;D<=Date.now()?(this[m]=Date.now(),T.apply(this,[this[c]]),this[c]=S?S():void 0):(this[u]=!0,this[P]=setTimeout(()=>{this[u]=!1,this[m]=Date.now(),T.apply(this,[this[c]]),this[c]=S?S():void 0},D-Date.now()))}})}e.throttle=C}),define(me[16],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function L(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=L;function I(p){S(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=I;function C(p){S(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=C;function R(p){if(p instanceof Error){let{name:t,message:s}=p;const r=p.stacktrace||p.stack;return{$isError:!0,name:t,message:s,stack:r}}return p}e.transformErrorForSerialization=R;const E="Canceled";function S(p){return p instanceof Error&&p.name===E&&p.message===E}e.isPromiseCanceledError=S;class T extends Error{constructor(){super(E);this.name=this.message}}e.CancellationError=T;function n(){const p=new Error(E);return p.name=p.message,p}e.canceled=n;function P(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=P;function c(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=c;function m(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function u(p){const t=new Error(`${p} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function h(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=h;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class k extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=k;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;function o(p){const t=p;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=o;function a(p,t=Object.create(null)){const s=new Error(p);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=a}),define(me[17],ge([0,1,16]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L($,Q=0){return $[$.length-(1+Q)]}e.tail=L;function I($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=I;function C($,Q,X=(he,_e)=>he===_e){if($===Q)return!0;if(!$||!Q||$.length!==Q.length)return!1;for(let he=0,_e=$.length;he<_e;he++)if(!X($[he],Q[he]))return!1;return!0}e.equals=C;function R($,Q,X){let he=0,_e=$.length-1;for(;he<=_e;){const ye=(he+_e)/2|0,Re=X($[ye],Q);if(Re<0)he=ye+1;else if(Re>0)_e=ye-1;else return ye}return-(he+1)}e.binarySearch=R;function E($,Q){let X=0,he=$.length;if(he===0)return 0;for(;X<he;){const _e=Math.floor((X+he)/2);Q($[_e])?he=_e:X=_e+1}return X}e.findFirstInSorted=E;function S($,Q,X){if($=$|0,$>=Q.length)throw new TypeError("invalid index");let he=Q[Math.floor(Q.length*Math.random())],_e=[],ye=[],Re=[];for(let We of Q){const Be=X(We,he);Be<0?_e.push(We):Be>0?ye.push(We):Re.push(We)}return $<_e.length?S($,_e,X):$<_e.length+Re.length?Re[0]:S($-(_e.length+Re.length),ye,X)}e.quickSelect=S;function T($,Q){const X=[];let he;for(const _e of $.slice(0).sort(Q))!he||Q(he[0],_e)!==0?(he=[_e],X.push(he)):he.push(_e);return X}e.groupBy=T;function n($,Q,X){const he=[];function _e(We,Be,je){if(Be===0&&je.length===0)return;const V=he[he.length-1];V&&V.start+V.deleteCount===We?(V.deleteCount+=Be,V.toInsert.push(...je)):he.push({start:We,deleteCount:Be,toInsert:je})}let ye=0,Re=0;for(;;){if(ye===$.length){_e(ye,0,Q.slice(Re));break}if(Re===Q.length){_e(ye,$.length-ye,[]);break}const We=$[ye],Be=Q[Re],je=X(We,Be);je===0?(ye+=1,Re+=1):je<0?(_e(ye,1,[]),ye+=1):je>0&&(_e(ye,0,[Be]),Re+=1)}return he}e.sortedDiff=n;function P($,Q,X){const he=n($,Q,X),_e=[],ye=[];for(const Re of he)_e.push(...$.slice(Re.start,Re.start+Re.deleteCount)),ye.push(...Re.toInsert);return{removed:_e,added:ye}}e.delta=P;function c($,Q,X){if(X===0)return[];const he=$.slice(0,X).sort(Q);return u($,Q,he,X,$.length),he}e.top=c;function m($,Q,X,he,_e){return X===0?Promise.resolve([]):new Promise((ye,Re)=>{(async()=>{const We=$.length,Be=$.slice(0,X).sort(Q);for(let je=X,V=Math.min(X+he,We);je<We;je=V,V=Math.min(V+he,We)){if(je>X&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,g.canceled)();u($,Q,Be,je,V)}return Be})().then(ye,Re)})}e.topAsync=m;function u($,Q,X,he,_e){for(const ye=X.length;he<_e;he++){const Re=$[he];if(Q(Re,X[ye-1])<0){X.pop();const We=E(X,Be=>Q(Re,Be)<0);X.splice(We,0,Re)}}}function h($){return $.filter(Q=>!!Q)}e.coalesce=h;function D($){let Q=0;for(let X=0;X<$.length;X++)$[X]&&($[Q]=$[X],Q+=1);$.length=Q}e.coalesceInPlace=D;function k($,Q,X){$.splice(X,0,$.splice(Q,1)[0])}e.move=k;function _($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=_;function o($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=o;function a($,Q){if(!Q)return $.filter((he,_e)=>$.indexOf(he)===_e);const X=Object.create(null);return $.filter(he=>{const _e=Q(he);return X[_e]?!1:(X[_e]=!0,!0)})}e.distinct=a;function p($){const Q=new Set;return $.filter(X=>Q.has(X)?!1:(Q.add(X),!0))}e.distinctES6=p;function t($){const Q=Object.create(null);return X=>{const he=$(X);return Q[he]?!1:(Q[he]=!0,!0)}}e.uniqueFilter=t;function s($,Q){for(let X=$.length-1;X>=0;X--){const he=$[X];if(Q(he))return X}return-1}e.lastIndex=s;function r($,Q){return $.length>0?$[0]:Q}e.firstOrDefault=r;function i($,Q,X=(he,_e)=>he===_e){let he=0;for(let _e=0,ye=Math.min($.length,Q.length);_e<ye&&X($[_e],Q[_e]);_e++)he++;return he}e.commonPrefixLength=i;function f($){return[].concat(...$)}e.flatten=f;function l($,Q){let X=typeof Q=="number"?$:0;typeof Q=="number"?X=$:(X=0,Q=$);const he=[];if(X<=Q)for(let _e=X;_e<Q;_e++)he.push(_e);else for(let _e=X;_e>Q;_e--)he.push(_e);return he}e.range=l;function d($,Q,X){return $.reduce((he,_e)=>(he[Q(_e)]=X?X(_e):_e,he),Object.create(null))}e.index=d;function b($,Q){return $.push(Q),()=>y($,Q)}e.insert=b;function y($,Q){const X=$.indexOf(Q);if(X>-1)return $.splice(X,1),Q}e.remove=y;function v($,Q,X){const he=$.slice(0,Q),_e=$.slice(Q);return he.concat(X,_e)}e.arrayInsert=v;function A($,Q){let X;if(typeof Q=="number"){let he=Q;X=()=>{const _e=Math.sin(he++)*179426549;return _e-Math.floor(_e)}}else X=Math.random;for(let he=$.length-1;he>0;he-=1){const _e=Math.floor(X()*(he+1)),ye=$[he];$[he]=$[_e],$[_e]=ye}}e.shuffle=A;function w($,Q){const X=$.indexOf(Q);X>-1&&($.splice(X,1),$.unshift(Q))}e.pushToStart=w;function F($,Q){const X=$.indexOf(Q);X>-1&&($.splice(X,1),$.push(Q))}e.pushToEnd=F;function O($,Q){return Array.isArray($)?$.map(Q):Q($)}e.mapArrayOrNot=O;function G($){return Array.isArray($)?$:[$]}e.asArray=G;function K($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=K;function U($,Q){for(const X of $){const he=Q(X);if(he!==void 0)return he}}e.mapFind=U;function z($,Q,X){const he=B($,Q),_e=$.length,ye=X.length;$.length=_e+ye;for(let Re=_e-1;Re>=he;Re--)$[Re+ye]=$[Re];for(let Re=0;Re<ye;Re++)$[Re+he]=X[Re]}e.insertInto=z;function N($,Q,X,he){const _e=B($,Q),ye=$.splice(_e,X);return z($,_e,he),ye}e.splice=N;function B($,Q){return Q<0?Math.max(Q+$.length,0):Math.min(Q,$.length)}function x($,Q){let X=Number.MAX_SAFE_INTEGER,he=0;return $.forEach((_e,ye)=>{const Re=Q(_e);Re<X&&(X=Re,he=ye)}),he}e.minIndex=x;function M($,Q){let X=Number.MIN_SAFE_INTEGER,he=0;return $.forEach((_e,ye)=>{const Re=Q(_e);Re>X&&(X=Re,he=ye)}),he}e.maxIndex=M;class H{constructor(Q){this.items=Q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Q){let X=this.firstIdx;for(;X<this.items.length&&Q(this.items[X]);)X++;const he=X===this.firstIdx?null:this.items.slice(this.firstIdx,X);return this.firstIdx=X,he}takeFromEndWhile(Q){let X=this.lastIdx;for(;X>=0&&Q(this.items[X]);)X--;const he=X===this.lastIdx?null:this.items.slice(X+1,this.lastIdx+1);return this.lastIdx=X,he}}e.ArrayQueue=H}),define(me[75],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(L){const I=this;let C=!1,R;return function(){return C||(C=!0,R=L.apply(I,arguments)),R}}e.once=g}),define(me[76],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(me[94],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(L){function I(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}L.is=I;const C=Object.freeze([]);function R(){return C}L.empty=R;function*E(p){yield p}L.single=E;function S(p){return p||C}L.from=S;function T(p){return!p||p[Symbol.iterator]().next().done===!0}L.isEmpty=T;function n(p){return p[Symbol.iterator]().next().value}L.first=n;function P(p,t){for(const s of p)if(t(s))return!0;return!1}L.some=P;function c(p,t){for(const s of p)if(t(s))return s}L.find=c;function*m(p,t){for(const s of p)t(s)&&(yield s)}L.filter=m;function*u(p,t){let s=0;for(const r of p)yield t(r,s++)}L.map=u;function*h(...p){for(const t of p)for(const s of t)yield s}L.concat=h;function*D(p){for(const t of p)for(const s of t)yield s}L.concatNested=D;function k(p,t,s){let r=s;for(const i of p)r=t(r,i);return r}L.reduce=k;function*_(p,t,s=p.length){for(t<0&&(t+=p.length),s<0?s+=p.length:s>p.length&&(s=p.length);t<s;t++)yield p[t]}L.slice=_;function o(p,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,p];const r=p[Symbol.iterator]();for(let i=0;i<t;i++){const f=r.next();if(f.done)return[s,L.empty()];s.push(f.value)}return[s,{[Symbol.iterator](){return r}}]}L.consume=o;function a(p,t,s=(r,i)=>r===i){const r=p[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const f=r.next(),l=i.next();if(f.done!==l.done)return!1;if(f.done)return!0;if(!s(f.value,l.value))return!1}}L.equals=a})(g=e.Iterable||(e.Iterable={}))}),define(me[59],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function R(t,s=!1){let r=0,i=t.length,f="",l=0,d=16,b=0;function y(K){let U=0,z=0;for(;U<K;){const N=t.charCodeAt(r);if(N>=48&&N<=57)z=z*16+N-48;else if(N>=65&&N<=70)z=z*16+N-65+10;else if(N>=97&&N<=102)z=z*16+N-97+10;else break;r++,U++}return U<K&&(z=-1),z}function v(K){r=K,f="",l=0,d=16,b=0}function A(){const K=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&T(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&T(t.charCodeAt(r)))for(r++;r<t.length&&T(t.charCodeAt(r));)r++;else return b=3,t.substring(K,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&T(t.charCodeAt(r))){for(r++;r<t.length&&T(t.charCodeAt(r));)r++;U=r}else b=3;return t.substring(K,U)}function w(){let K="",U=r;for(;;){if(r>=i){K+=t.substring(U,r),b=2;break}const z=t.charCodeAt(r);if(z===34){K+=t.substring(U,r),r++;break}if(z===92){if(K+=t.substring(U,r),r++,r>=i){b=2;break}switch(t.charCodeAt(r++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const B=y(4);B>=0?K+=String.fromCharCode(B):b=4;break;default:b=5}U=r;continue}if(z>=0&&z<=31)if(S(z)){K+=t.substring(U,r),b=2;break}else b=6;r++}return K}function F(){if(f="",b=0,l=r,r>=i)return l=i,d=17;let K=t.charCodeAt(r);if(E(K)){do r++,f+=String.fromCharCode(K),K=t.charCodeAt(r);while(E(K));return d=15}if(S(K))return r++,f+=String.fromCharCode(K),K===13&&t.charCodeAt(r)===10&&(r++,f+=`
`),d=14;switch(K){case 123:return r++,d=1;case 125:return r++,d=2;case 91:return r++,d=3;case 93:return r++,d=4;case 58:return r++,d=6;case 44:return r++,d=5;case 34:return r++,f=w(),d=10;case 47:const U=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!S(t.charCodeAt(r));)r++;return f=t.substring(U,r),d=12}if(t.charCodeAt(r+1)===42){r+=2;const z=i-1;let N=!1;for(;r<z;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,N=!0;break}r++}return N||(r++,b=1),f=t.substring(U,r),d=13}return f+=String.fromCharCode(K),r++,d=16;case 45:if(f+=String.fromCharCode(K),r++,r===i||!T(t.charCodeAt(r)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return f+=A(),d=11;default:for(;r<i&&O(K);)r++,K=t.charCodeAt(r);if(l!==r){switch(f=t.substring(l,r),f){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return f+=String.fromCharCode(K),r++,d=16}}function O(K){if(E(K)||S(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let K;do K=F();while(K>=12&&K<=15);return K}return{setPosition:v,getPosition:()=>r,scan:s?G:F,getToken:()=>d,getTokenValue:()=>f,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>b}}e.createScanner=R;function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function T(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function P(t,s){const r=[],i=new Object;let f;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function b(y,v,A,w){l.value=y,l.offset=v,l.length=A,l.type=w,l.colonOffset=void 0,f=l}try{o(t,{onObjectBegin:(y,v)=>{if(s<=y)throw i;f=void 0,d=s>y,r.push("")},onObjectProperty:(y,v,A)=>{if(s<v||(b(y,v,A,"property"),r[r.length-1]=y,s<=v+A))throw i},onObjectEnd:(y,v)=>{if(s<=y)throw i;f=void 0,r.pop()},onArrayBegin:(y,v)=>{if(s<=y)throw i;f=void 0,r.push(0)},onArrayEnd:(y,v)=>{if(s<=y)throw i;f=void 0,r.pop()},onLiteralValue:(y,v,A)=>{if(s<v||(b(y,v,A,p(y)),s<=v+A))throw i},onSeparator:(y,v,A)=>{if(s<=v)throw i;if(y===":"&&f&&f.type==="property")f.colonOffset=v,d=!1,f=void 0;else if(y===","){const w=r[r.length-1];typeof w=="number"?r[r.length-1]=w+1:(d=!0,r[r.length-1]=""),f=void 0}}})}catch(y){if(y!==i)throw y}return{path:r,previousNode:f,isAtPropertyKey:d,matches:y=>{let v=0;for(let A=0;v<y.length&&A<r.length;A++)if(y[v]===r[A]||y[v]==="*")v++;else if(y[v]!=="**")return!1;return v===y.length}}}e.getLocation=P;function c(t,s=[],r=C.DEFAULT){let i=null,f=[];const l=[];function d(y){Array.isArray(f)?f.push(y):i!==null&&(f[i]=y)}return o(t,{onObjectBegin:()=>{const y={};d(y),l.push(f),f=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{f=l.pop()},onArrayBegin:()=>{const y=[];d(y),l.push(f),f=y,i=null},onArrayEnd:()=>{f=l.pop()},onLiteralValue:d,onError:(y,v,A)=>{s.push({error:y,offset:v,length:A})}},r),f[0]}e.parse=c;function m(t,s=[],r=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function l(y){return i.children.push(y),y}o(t,{onObjectBegin:y=>{i=l({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,v,A)=>{i=l({type:"property",offset:v,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:v,length:A,parent:i})},onObjectEnd:(y,v)=>{i.length=y+v-i.offset,i=i.parent,f(y+v)},onArrayBegin:(y,v)=>{i=l({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,v)=>{i.length=y+v-i.offset,i=i.parent,f(y+v)},onLiteralValue:(y,v,A)=>{l({type:p(y),offset:v,length:A,parent:i,value:y}),f(v+A)},onSeparator:(y,v,A)=>{i.type==="property"&&(y===":"?i.colonOffset=v:y===","&&f(v))},onError:(y,v,A)=>{s.push({error:y,offset:v,length:A})}},r);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=m;function u(t,s){if(!t)return;let r=t;for(let i of s)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let f=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===i){r=l.children[1],f=!0;break}if(!f)return}else{const f=i;if(r.type!=="array"||f<0||!Array.isArray(r.children)||f>=r.children.length)return;r=r.children[f]}return r}e.findNodeAtLocation=u;function h(t){if(!t.parent||!t.parent.children)return[];const s=h(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=h;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const s=Object.create(null);for(let r of t.children){const i=r.children[1];i&&(s[r.children[0].value]=D(i))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function k(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=k;function _(t,s,r=!1){if(k(t,s,r)){const i=t.children;if(Array.isArray(i))for(let f=0;f<i.length&&i[f].offset<=s;f++){const l=_(i[f],s,r);if(l)return l}return t}}e.findNodeAtOffset=_;function o(t,s,r=C.DEFAULT){const i=R(t,!1);function f(X){return X?()=>X(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(X){return X?he=>X(he,i.getTokenOffset(),i.getTokenLength()):()=>!0}const d=f(s.onObjectBegin),b=l(s.onObjectProperty),y=f(s.onObjectEnd),v=f(s.onArrayBegin),A=f(s.onArrayEnd),w=l(s.onLiteralValue),F=l(s.onSeparator),O=f(s.onComment),G=l(s.onError),K=r&&r.disallowComments,U=r&&r.allowTrailingComma;function z(){for(;;){const X=i.scan();switch(i.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:K||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(X){case 12:case 13:K?N(10):O();break;case 16:N(1);break;case 15:case 14:break;default:return X}}}function N(X,he=[],_e=[]){if(G(X),he.length+_e.length>0){let ye=i.getToken();for(;ye!==17;){if(he.indexOf(ye)!==-1){z();break}else if(_e.indexOf(ye)!==-1)break;ye=z()}}}function B(X){const he=i.getTokenValue();return X?w(he):b(he),z(),!0}function x(){switch(i.getToken()){case 11:let X=0;try{X=JSON.parse(i.getTokenValue()),typeof X!="number"&&(N(2),X=0)}catch(he){N(2)}w(X);break;case 7:w(null);break;case 8:w(!0);break;case 9:w(!1);break;default:return!1}return z(),!0}function M(){return i.getToken()!==10?(N(3,[],[2,5]),!1):(B(!1),i.getToken()===6?(F(":"),z(),Q()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function H(){d(),z();let X=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(X||N(4,[],[]),F(","),z(),i.getToken()===2&&U)break}else X&&N(6,[],[]);M()||N(4,[],[2,5]),X=!0}return y(),i.getToken()!==2?N(7,[2],[]):z(),!0}function $(){v(),z();let X=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(X||N(4,[],[]),F(","),z(),i.getToken()===4&&U)break}else X&&N(6,[],[]);Q()||N(4,[],[4,5]),X=!0}return A(),i.getToken()!==4?N(8,[4],[]):z(),!0}function Q(){switch(i.getToken()){case 3:return $();case 1:return H();case 10:return B(!0);default:return x()}}return z(),i.getToken()===17?r.allowEmptyContent?!0:(N(4,[],[]),!1):Q()?(i.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=o;function a(t,s){let r=R(t),i=[],f,l=0,d;do switch(d=r.getPosition(),f=r.scan(),f){case 12:case 13:case 17:l!==d&&i.push(t.substring(l,d)),s!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,s)),l=r.getPosition();break}while(f!==17);return i.join("")}e.stripComments=a;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(me[137],ge([0,1,59]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(S,T,n){let P,c,m,u,h;if(T){for(u=T.offset,h=u+T.length,m=u;m>0&&!E(S,m-1);)m--;let l=h;for(;l<S.length&&!E(S,l);)l++;c=S.substring(m,l),P=C(c,n)}else c=S,P=0,m=0,u=0,h=S.length;const D=R(n,S);let k=!1,_=0,o;n.insertSpaces?o=I(" ",n.tabSize||4):o="	";const a=(0,g.createScanner)(c,!1);let p=!1;function t(){return D+I(o,P+_)}function s(){let l=a.scan();for(k=!1;l===15||l===14;)k=k||l===14,l=a.scan();return p=l===16||a.getTokenError()!==0,l}const r=[];function i(l,d,b){!p&&d<h&&b>u&&S.substring(d,b)!==l&&r.push({offset:d,length:b-d,content:l})}let f=s();if(f!==17){const l=a.getTokenOffset()+m,d=I(o,P);i(d,m,l)}for(;f!==17;){let l=a.getTokenOffset()+a.getTokenLength()+m,d=s(),b="";for(;!k&&(d===12||d===13);){const v=a.getTokenOffset()+m;i(" ",l,v),l=a.getTokenOffset()+a.getTokenLength()+m,b=d===12?t():"",d=s()}if(d===2)f!==1&&(_--,b=t());else if(d===4)f!==3&&(_--,b=t());else{switch(f){case 3:case 1:_++,b=t();break;case 5:case 12:b=t();break;case 13:k?b=t():b=" ";break;case 6:b=" ";break;case 10:if(d===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?b=" ":d!==5&&d!==17&&(p=!0);break;case 16:p=!0;break}k&&(d===12||d===13)&&(b=t())}const y=a.getTokenOffset()+m;i(b,l,y),f=d}return r}e.format=L;function I(S,T){let n="";for(let P=0;P<T;P++)n+=S;return n}function C(S,T){let n=0,P=0;const c=T.tabSize||4;for(;n<S.length;){const m=S.charAt(n);if(m===" ")P++;else if(m==="	")P+=c;else break;n++}return Math.floor(P/c)}function R(S,T){for(let n=0;n<T.length;n++){const P=T.charAt(n);if(P==="\r")return n+1<T.length&&T.charAt(n+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=R;function E(S,T){return`\r
`.indexOf(S.charAt(T))!==-1}e.isEOL=E}),define(me[138],ge([0,1,59,137]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function I(T,n,P){return C(T,n,void 0,P)}e.removeProperty=I;function C(T,n,P,c,m){const u=n.slice(),h=[],D=(0,g.parseTree)(T,h);let k,_;for(;u.length>0&&(_=u.pop(),k=(0,g.findNodeAtLocation)(D,u),k===void 0&&P!==void 0);)typeof _=="string"?P={[_]:P}:P=[P];if(k)if(k.type==="object"&&typeof _=="string"&&Array.isArray(k.children)){const o=(0,g.findNodeAtLocation)(k,[_]);if(o!==void 0)if(P===void 0){if(!o.parent)throw new Error("Malformed AST");const a=k.children.indexOf(o.parent);let p,t=o.parent.offset+o.parent.length;if(a>0){const s=k.children[a-1];p=s.offset+s.length}else p=k.offset+1,k.children.length>1&&(t=k.children[1].offset);return R(T,{offset:p,length:t-p,content:""},c)}else return R(T,{offset:o.offset,length:o.length,content:JSON.stringify(P)},c);else{if(P===void 0)return[];const a=`${JSON.stringify(_)}: ${JSON.stringify(P)}`,p=m?m(k.children.map(s=>s.children[0].value)):k.children.length;let t;if(p>0){const s=k.children[p-1];t={offset:s.offset+s.length,length:0,content:","+a}}else k.children.length===0?t={offset:k.offset+1,length:0,content:a}:t={offset:k.offset+1,length:0,content:a+","};return R(T,t,c)}}else if(k.type==="array"&&typeof _=="number"&&Array.isArray(k.children))if(P!==void 0){const o=`${JSON.stringify(P)}`;let a;if(k.children.length===0||_===0)a={offset:k.offset+1,length:0,content:k.children.length===0?o:o+","};else{const p=_===-1||_>k.children.length?k.children.length:_,t=k.children[p-1];a={offset:t.offset+t.length,length:0,content:","+o}}return R(T,a,c)}else{const o=_,a=k.children[o];let p;if(k.children.length===1)p={offset:k.offset+1,length:k.length-2,content:""};else if(k.children.length-1===o){const t=k.children[o-1],s=t.offset+t.length,r=k.offset+k.length;p={offset:s,length:r-2-s,content:""}}else p={offset:a.offset,length:k.children[o+1].offset-a.offset,content:""};return R(T,p,c)}else throw new Error(`Can not add ${typeof _!="number"?"index":"property"} to parent of type ${k.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return R(T,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(P)},c)}}e.setProperty=C;function R(T,n,P){let c=E(T,n),m=n.offset,u=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;m>0&&!(0,L.isEOL)(c,m-1);)m--;for(;u<c.length&&!(0,L.isEOL)(c,u);)u++}const h=(0,L.format)(c,{offset:m,length:u-m},P);for(let k=h.length-1;k>=0;k--){const _=h[k];c=E(c,_),m=Math.min(m,_.offset),u=Math.max(u,_.offset+_.length),u+=_.content.length-_.length}const D=T.length-(c.length-u)-m;return[{offset:m,length:D,content:c.substring(m,u)}]}e.withFormatting=R;function E(T,n){return T.substring(0,n.offset)+n.content+T.substring(n.offset+n.length)}e.applyEdit=E;function S(T,n){let P=n.slice(0).sort((m,u)=>{const h=m.offset-u.offset;return h===0?m.length-u.length:h}),c=T.length;for(let m=P.length-1;m>=0;m--){let u=P[m];if(u.offset+u.length<=c)T=E(T,u);else throw new Error("Overlapping edit");c=u.offset}return T}e.applyEdits=S}),define(me[139],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new g(()=>I(this.getValue()))}}e.Lazy=g}),define(me[6],ge([0,1,75,94]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let C=null;function R(r){C=r}if(e.setDisposableTracker=R,I){const r="__is_disposable_tracked__";R(new class{trackDisposable(i){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[r]||console.log(f)},3e3)}setParent(i,f){if(i&&i!==_.None)try{i[r]=!0}catch{}}markAsDisposed(i){if(i&&i!==_.None)try{i[r]=!0}catch{}}markAsSingleton(i){}})}function E(r){return C?.trackDisposable(r),r}function S(r){C?.markAsDisposed(r)}function T(r,i){C?.setParent(r,i)}function n(r,i){if(!!C)for(const f of r)C.setParent(f,i)}function P(r){return C?.markAsSingleton(r),r}e.markAsSingleton=P;class c extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=c;function m(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=m;function u(r){if(L.Iterable.is(r)){let i=[];for(const f of r)if(f)try{f.dispose()}catch(l){i.push(l)}if(i.length===1)throw i[0];if(i.length>1)throw new c(i);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=u;function h(...r){const i=D(()=>u(r));return n(r,i),i}e.combinedDisposable=h;function D(r){const i=E({dispose:(0,g.once)(()=>{S(i),r()})});return i}e.toDisposable=D;class k{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return T(i,this),this._isDisposed?k.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=k,k.DISABLE_DISPOSED_WARNING=!1;class _{constructor(){this._store=new k,E(this),T(this._store,this)}dispose(){S(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=_,_.None=Object.freeze({dispose(){}});class o{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&T(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&T(i,null),i}}e.MutableDisposable=o;class a{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class p{constructor(){this.references=new Map}acquire(i,...f){let l=this.references.get(i);l||(l={counter:0,object:this.createReferencedObject(i,...f)},this.references.set(i,l));const{object:d}=l,b=(0,g.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(i,l.object),this.references.delete(i))});return l.counter++,{object:d,dispose:b}}}e.ReferenceCollection=p;class t{constructor(i){this.referenceCollection=i}async acquire(i,...f){const l=this.referenceCollection.acquire(i,...f);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(d){throw l.dispose(),d}}}e.AsyncReferenceCollection=t;class s{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=s}),define(me[95],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(C){this.element=C,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class L{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let C=this._first;for(;C!==g.Undefined;){const R=C.next;C.prev=g.Undefined,C.next=g.Undefined,C=R}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,R){const E=new g(C);if(this._first===g.Undefined)this._first=E,this._last=E;else if(R){const T=this._last;this._last=E,E.prev=T,T.next=E}else{const T=this._first;this._first=E,E.next=T,T.prev=E}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(E))}}shift(){if(this._first!==g.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==g.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==g.Undefined&&C.next!==g.Undefined){const R=C.prev;R.next=C.next,C.next.prev=R}else C.prev===g.Undefined&&C.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):C.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):C.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==g.Undefined;)yield C.element,C=C.next}}e.LinkedList=L}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Le,De){for(var ke=0;ke<De.length;ke++){var ne=De[ke];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Le,ne.key,ne)}}function e(Le,De,ke){return De&&Y(Le.prototype,De),ke&&Y(Le,ke),Le}function g(Le,De){if(!!Le){if(typeof Le=="string")return L(Le,De);var ke=Object.prototype.toString.call(Le).slice(8,-1);if(ke==="Object"&&Le.constructor&&(ke=Le.constructor.name),ke==="Map"||ke==="Set")return Array.from(Le);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return L(Le,De)}}function L(Le,De){(De==null||De>Le.length)&&(De=Le.length);for(var ke=0,ne=new Array(De);ke<De;ke++)ne[ke]=Le[ke];return ne}function I(Le,De){var ke=typeof Symbol!="undefined"&&Le[Symbol.iterator]||Le["@@iterator"];if(ke)return(ke=ke.call(Le)).next.bind(ke);if(Array.isArray(Le)||(ke=g(Le))||De&&Le&&typeof Le.length=="number"){ke&&(Le=ke);var ne=0;return function(){return ne>=Le.length?{done:!0}:{done:!1,value:Le[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function R(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function E(Le){C.exports.defaults=Le}C.exports={defaults:R(),getDefaults:R,changeDefaults:E};var S=/[&<>"']/,T=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(De){return c[De]};function u(Le,De){if(De){if(S.test(Le))return Le.replace(T,m)}else if(n.test(Le))return Le.replace(P,m);return Le}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function D(Le){return Le.replace(h,function(De,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var k=/(^|[^\[])\^/g;function _(Le,De){Le=Le.source||Le,De=De||"";var ke={replace:function(de,be){return be=be.source||be,be=be.replace(k,"$1"),Le=Le.replace(de,be),ke},getRegex:function(){return new RegExp(Le,De)}};return ke}var o=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Le,De,ke){if(Le){var ne;try{ne=decodeURIComponent(D(ke)).replace(o,"").toLowerCase()}catch(de){return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}De&&!a.test(ke)&&(ke=f(De,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch(de){return null}return ke}var t={},s=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function f(Le,De){t[" "+Le]||(s.test(Le)?t[" "+Le]=Le+"/":t[" "+Le]=y(Le,"/",!0)),Le=t[" "+Le];var ke=Le.indexOf(":")===-1;return De.substring(0,2)==="//"?ke?De:Le.replace(r,"$1")+De:De.charAt(0)==="/"?ke?De:Le.replace(i,"$1")+De:Le+De}var l={exec:function(){}};function d(Le){for(var De=1,ke,ne;De<arguments.length;De++){ke=arguments[De];for(ne in ke)Object.prototype.hasOwnProperty.call(ke,ne)&&(Le[ne]=ke[ne])}return Le}function b(Le,De){var ke=Le.replace(/\|/g,function(be,we,Fe){for(var Ge=!1,He=we;--He>=0&&Fe[He]==="\\";)Ge=!Ge;return Ge?"|":" |"}),ne=ke.split(/ \|/),de=0;if(ne[0].trim()||ne.shift(),ne[ne.length-1].trim()||ne.pop(),ne.length>De)ne.splice(De);else for(;ne.length<De;)ne.push("");for(;de<ne.length;de++)ne[de]=ne[de].trim().replace(/\\\|/g,"|");return ne}function y(Le,De,ke){var ne=Le.length;if(ne===0)return"";for(var de=0;de<ne;){var be=Le.charAt(ne-de-1);if(be===De&&!ke)de++;else if(be!==De&&ke)de++;else break}return Le.substr(0,ne-de)}function v(Le,De){if(Le.indexOf(De[1])===-1)return-1;for(var ke=Le.length,ne=0,de=0;de<ke;de++)if(Le[de]==="\\")de++;else if(Le[de]===De[0])ne++;else if(Le[de]===De[1]&&(ne--,ne<0))return de;return-1}function A(Le){Le&&Le.sanitize&&!Le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function w(Le,De){if(De<1)return"";for(var ke="";De>1;)De&1&&(ke+=Le),De>>=1,Le+=Le;return ke+Le}var F={escape:u,unescape:D,edit:_,cleanUrl:p,resolveUrl:f,noopTest:l,merge:d,splitCells:b,rtrim:y,findClosingBracket:v,checkSanitizeDeprecation:A,repeatString:w},O=C.exports.defaults,G=F.rtrim,K=F.splitCells,U=F.escape,z=F.findClosingBracket;function N(Le,De,ke,ne){var de=De.href,be=De.title?U(De.title):null,we=Le[1].replace(/\\([\[\]])/g,"$1");if(Le[0].charAt(0)!=="!"){ne.state.inLink=!0;var Fe={type:"link",raw:ke,href:de,title:be,text:we,tokens:ne.inlineTokens(we,[])};return ne.state.inLink=!1,Fe}else return{type:"image",raw:ke,href:de,title:be,text:U(we)}}function B(Le,De){var ke=Le.match(/^(\s+)(?:```)/);if(ke===null)return De;var ne=ke[1];return De.split(`
`).map(function(de){var be=de.match(/^\s+/);if(be===null)return de;var we=be[0];return we.length>=ne.length?de.slice(ne.length):de}).join(`
`)}var x=function(){function Le(ke){this.options=ke||O}var De=Le.prototype;return De.space=function(ne){var de=this.rules.block.newline.exec(ne);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},De.code=function(ne){var de=this.rules.block.code.exec(ne);if(de){var be=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?be:G(be,`
`)}}},De.fences=function(ne){var de=this.rules.block.fences.exec(ne);if(de){var be=de[0],we=B(be,de[3]||"");return{type:"code",raw:be,lang:de[2]?de[2].trim():de[2],text:we}}},De.heading=function(ne){var de=this.rules.block.heading.exec(ne);if(de){var be=de[2].trim();if(/#$/.test(be)){var we=G(be,"#");(this.options.pedantic||!we||/ $/.test(we))&&(be=we.trim())}var Fe={type:"heading",raw:de[0],depth:de[1].length,text:be,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},De.hr=function(ne){var de=this.rules.block.hr.exec(ne);if(de)return{type:"hr",raw:de[0]}},De.blockquote=function(ne){var de=this.rules.block.blockquote.exec(ne);if(de){var be=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},De.list=function(ne){var de=this.rules.block.list.exec(ne);if(de){var be,we,Fe,Ge,He,Je,it,le,Ee,ce,q=de[1].trim(),Ae=q.length>1,Pe={type:"list",raw:"",ordered:Ae,start:Ae?+q.slice(0,-1):"",loose:!1,items:[]};q=Ae?"\\d{1,9}\\"+q.slice(-1):"\\"+q,this.options.pedantic&&(q=Ae?q:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+q+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ne&&!(this.rules.block.hr.test(ne)||!(de=Ze.exec(ne)));){Ee=de[2].split(`
`),this.options.pedantic?(Ge=2,ce=Ee[0].trimLeft()):(Ge=de[2].search(/[^ ]/),Ge=de[1].length+(Ge>4?1:Ge),ce=Ee[0].slice(Ge-de[1].length)),Je=!1,be=de[0],!Ee[0]&&/^ *$/.test(Ee[1])&&(be=de[1]+Ee.slice(0,2).join(`
`)+`
`,Pe.loose=!0,Ee=[]);var Xe=new RegExp("^ {0,"+Math.min(3,Ge-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(He=1;He<Ee.length;He++){if(le=Ee[He],this.options.pedantic&&(le=le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Xe.test(le)){be=de[1]+Ee.slice(0,He).join(`
`)+`
`;break}if(!Je){le.trim()||(Je=!0),le.search(/[^ ]/)>=Ge?ce+=`
`+le.slice(Ge):ce+=`
`+le;continue}if(le.search(/[^ ]/)>=Ge||!le.trim()){ce+=`
`+le.slice(Ge);continue}else{be=de[1]+Ee.slice(0,He).join(`
`)+`
`;break}}Pe.loose||(it?Pe.loose=!0:/\n *\n *$/.test(be)&&(it=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(ce),we&&(Fe=we[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Pe.items.push({type:"list_item",raw:be,task:!!we,checked:Fe,loose:!1,text:ce}),Pe.raw+=be,ne=ne.slice(be.length)}Pe.items[Pe.items.length-1].raw=be.trimRight(),Pe.items[Pe.items.length-1].text=ce.trimRight(),Pe.raw=Pe.raw.trimRight();var ot=Pe.items.length;for(He=0;He<ot;He++)this.lexer.state.top=!1,Pe.items[He].tokens=this.lexer.blockTokens(Pe.items[He].text,[]),Pe.items[He].tokens.some(function(vt){return vt.type==="space"})&&(Pe.loose=!0,Pe.items[He].loose=!0);return Pe}},De.html=function(ne){var de=this.rules.block.html.exec(ne);if(de){var be={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(de[0]):U(de[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},De.def=function(ne){var de=this.rules.block.def.exec(ne);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var be=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:de[0],href:de[2],title:de[3]}}},De.table=function(ne){var de=this.rules.block.table.exec(ne);if(de){var be={type:"table",header:K(de[1]).map(function(it){return{text:it}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=de[0];var we=be.align.length,Fe,Ge,He,Je;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(be.align[Fe])?be.align[Fe]="right":/^ *:-+: *$/.test(be.align[Fe])?be.align[Fe]="center":/^ *:-+ *$/.test(be.align[Fe])?be.align[Fe]="left":be.align[Fe]=null;for(we=be.rows.length,Fe=0;Fe<we;Fe++)be.rows[Fe]=K(be.rows[Fe],be.header.length).map(function(it){return{text:it}});for(we=be.header.length,Ge=0;Ge<we;Ge++)be.header[Ge].tokens=[],this.lexer.inlineTokens(be.header[Ge].text,be.header[Ge].tokens);for(we=be.rows.length,Ge=0;Ge<we;Ge++)for(Je=be.rows[Ge],He=0;He<Je.length;He++)Je[He].tokens=[],this.lexer.inlineTokens(Je[He].text,Je[He].tokens);return be}}},De.lheading=function(ne){var de=this.rules.block.lheading.exec(ne);if(de){var be={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},De.paragraph=function(ne){var de=this.rules.block.paragraph.exec(ne);if(de){var be={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},De.text=function(ne){var de=this.rules.block.text.exec(ne);if(de){var be={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},De.escape=function(ne){var de=this.rules.inline.escape.exec(ne);if(de)return{type:"escape",raw:de[0],text:U(de[1])}},De.tag=function(ne){var de=this.rules.inline.tag.exec(ne);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):U(de[0]):de[0]}},De.link=function(ne){var de=this.rules.inline.link.exec(ne);if(de){var be=de[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var we=G(be.slice(0,-1),"\\");if((be.length-we.length)%2==0)return}else{var Fe=z(de[2],"()");if(Fe>-1){var Ge=de[0].indexOf("!")===0?5:4,He=Ge+de[1].length+Fe;de[2]=de[2].substring(0,Fe),de[0]=de[0].substring(0,He).trim(),de[3]=""}}var Je=de[2],it="";if(this.options.pedantic){var le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Je);le&&(Je=le[1],it=le[3])}else it=de[3]?de[3].slice(1,-1):"";return Je=Je.trim(),/^</.test(Je)&&(this.options.pedantic&&!/>$/.test(be)?Je=Je.slice(1):Je=Je.slice(1,-1)),N(de,{href:Je&&Je.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},De.reflink=function(ne,de){var be;if((be=this.rules.inline.reflink.exec(ne))||(be=this.rules.inline.nolink.exec(ne))){var we=(be[2]||be[1]).replace(/\s+/g," ");if(we=de[we.toLowerCase()],!we||!we.href){var Fe=be[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return N(be,we,be[0],this.lexer)}},De.emStrong=function(ne,de,be){be===void 0&&(be="");var we=this.rules.inline.emStrong.lDelim.exec(ne);if(!!we&&!(we[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(be===""||this.rules.inline.punctuation.exec(be))){var Ge=we[0].length-1,He,Je,it=Ge,le=0,Ee=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ee.lastIndex=0,de=de.slice(-1*ne.length+Ge);(we=Ee.exec(de))!=null;)if(He=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!He){if(Je=He.length,we[3]||we[4]){it+=Je;continue}else if((we[5]||we[6])&&Ge%3&&!((Ge+Je)%3)){le+=Je;continue}if(it-=Je,!(it>0)){if(Je=Math.min(Je,Je+it+le),Math.min(Ge,Je)%2){var ce=ne.slice(1,Ge+we.index+Je);return{type:"em",raw:ne.slice(0,Ge+we.index+Je+1),text:ce,tokens:this.lexer.inlineTokens(ce,[])}}var q=ne.slice(2,Ge+we.index+Je-1);return{type:"strong",raw:ne.slice(0,Ge+we.index+Je+1),text:q,tokens:this.lexer.inlineTokens(q,[])}}}}}},De.codespan=function(ne){var de=this.rules.inline.code.exec(ne);if(de){var be=de[2].replace(/\n/g," "),we=/[^ ]/.test(be),Fe=/^ /.test(be)&&/ $/.test(be);return we&&Fe&&(be=be.substring(1,be.length-1)),be=U(be,!0),{type:"codespan",raw:de[0],text:be}}},De.br=function(ne){var de=this.rules.inline.br.exec(ne);if(de)return{type:"br",raw:de[0]}},De.del=function(ne){var de=this.rules.inline.del.exec(ne);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},De.autolink=function(ne,de){var be=this.rules.inline.autolink.exec(ne);if(be){var we,Fe;return be[2]==="@"?(we=U(this.options.mangle?de(be[1]):be[1]),Fe="mailto:"+we):(we=U(be[1]),Fe=we),{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},De.url=function(ne,de){var be;if(be=this.rules.inline.url.exec(ne)){var we,Fe;if(be[2]==="@")we=U(this.options.mangle?de(be[0]):be[0]),Fe="mailto:"+we;else{var Ge;do Ge=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(Ge!==be[0]);we=U(be[0]),be[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},De.inlineText=function(ne,de){var be=this.rules.inline.text.exec(ne);if(be){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):U(be[0]):be[0]:we=U(this.options.smartypants?de(be[0]):be[0]),{type:"text",raw:be[0],text:we}}},Le}(),M=F.noopTest,H=F.edit,$=F.merge,Q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Q.def=H(Q.def).replace("label",Q._label).replace("title",Q._title).getRegex(),Q.bullet=/(?:[*+-]|\d{1,9}[.)])/,Q.listItemStart=H(/^( *)(bull) */).replace("bull",Q.bullet).getRegex(),Q.list=H(Q.list).replace(/bull/g,Q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Q.def.source+")").getRegex(),Q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Q.html=H(Q.html,"i").replace("comment",Q._comment).replace("tag",Q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Q.paragraph=H(Q._paragraph).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.blockquote=H(Q.blockquote).replace("paragraph",Q.paragraph).getRegex(),Q.normal=$({},Q),Q.gfm=$({},Q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Q.gfm.table=H(Q.gfm.table).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.pedantic=$({},Q.normal,{html:H(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:H(Q.normal._paragraph).replace("hr",Q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var X={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};X._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",X.punctuation=H(X.punctuation).replace(/punctuation/g,X._punctuation).getRegex(),X.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,X.escapedEmSt=/\\\*|\\_/g,X._comment=H(Q._comment).replace("(?:-->|$)","-->").getRegex(),X.emStrong.lDelim=H(X.emStrong.lDelim).replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimAst=H(X.emStrong.rDelimAst,"g").replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimUnd=H(X.emStrong.rDelimUnd,"g").replace(/punct/g,X._punctuation).getRegex(),X._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,X._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,X._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,X.autolink=H(X.autolink).replace("scheme",X._scheme).replace("email",X._email).getRegex(),X._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,X.tag=H(X.tag).replace("comment",X._comment).replace("attribute",X._attribute).getRegex(),X._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,X._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,X._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,X.link=H(X.link).replace("label",X._label).replace("href",X._href).replace("title",X._title).getRegex(),X.reflink=H(X.reflink).replace("label",X._label).getRegex(),X.reflinkSearch=H(X.reflinkSearch,"g").replace("reflink",X.reflink).replace("nolink",X.nolink).getRegex(),X.normal=$({},X),X.pedantic=$({},X.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:H(/^!?\[(label)\]\((.*?)\)/).replace("label",X._label).getRegex(),reflink:H(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",X._label).getRegex()}),X.gfm=$({},X.normal,{escape:H(X.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),X.gfm.url=H(X.gfm.url,"i").replace("email",X.gfm._extended_email).getRegex(),X.breaks=$({},X.gfm,{br:H(X.br).replace("{2,}","*").getRegex(),text:H(X.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var he={block:Q,inline:X},_e=x,ye=C.exports.defaults,Re=he.block,We=he.inline,Be=F.repeatString;function je(Le){return Le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Le){var De="",ke,ne,de=Le.length;for(ke=0;ke<de;ke++)ne=Le.charCodeAt(ke),Math.random()>.5&&(ne="x"+ne.toString(16)),De+="&#"+ne+";";return De}var ee=function(){function Le(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||ye,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:Re.normal,inline:We.normal};this.options.pedantic?(ne.block=Re.pedantic,ne.inline=We.pedantic):this.options.gfm&&(ne.block=Re.gfm,this.options.breaks?ne.inline=We.breaks:ne.inline=We.gfm),this.tokenizer.rules=ne}Le.lex=function(ne,de){var be=new Le(de);return be.lex(ne)},Le.lexInline=function(ne,de){var be=new Le(de);return be.inlineTokens(ne)};var De=Le.prototype;return De.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},De.blockTokens=function(ne,de){var be=this;de===void 0&&(de=[]),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var we,Fe,Ge,He;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(we=it.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.space(ne)){ne=ne.substring(we.raw.length),we.type&&de.push(we);continue}if(we=this.tokenizer.code(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we);continue}if(we=this.tokenizer.fences(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.heading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.hr(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.blockquote(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.list(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.html(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.def(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.lheading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(Ge=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,le=ne.slice(1),Ee=void 0;be.options.extensions.startBlock.forEach(function(ce){Ee=ce.call({lexer:this},le),typeof Ee=="number"&&Ee>=0&&(it=Math.min(it,Ee))}),it<Infinity&&it>=0&&(Ge=ne.substring(0,it+1))}(),this.state.top&&(we=this.tokenizer.paragraph(Ge))){Fe=de[de.length-1],He&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we),He=Ge.length!==ne.length,ne=ne.substring(we.raw.length);continue}if(we=this.tokenizer.text(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we);continue}if(ne){var Je="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Je);break}else throw new Error(Je)}}return this.state.top=!0,de},De.inline=function(ne,de){this.inlineQueue.push({src:ne,tokens:de})},De.inlineTokens=function(ne,de){var be=this;de===void 0&&(de=[]);var we,Fe,Ge,He=ne,Je,it,le;if(this.tokens.links){var Ee=Object.keys(this.tokens.links);if(Ee.length>0)for(;(Je=this.tokenizer.rules.inline.reflinkSearch.exec(He))!=null;)Ee.includes(Je[0].slice(Je[0].lastIndexOf("[")+1,-1))&&(He=He.slice(0,Je.index)+"["+Be("a",Je[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Je=this.tokenizer.rules.inline.blockSkip.exec(He))!=null;)He=He.slice(0,Je.index)+"["+Be("a",Je[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Je=this.tokenizer.rules.inline.escapedEmSt.exec(He))!=null;)He=He.slice(0,Je.index)+"++"+He.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(it||(le=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(q){return(we=q.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.escape(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.tag(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(we=this.tokenizer.link(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(we=this.tokenizer.emStrong(ne,He,le)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.codespan(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.br(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.del(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.autolink(ne,V)){ne=ne.substring(we.raw.length),de.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(ne,V))){ne=ne.substring(we.raw.length),de.push(we);continue}if(Ge=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var q=Infinity,Ae=ne.slice(1),Pe=void 0;be.options.extensions.startInline.forEach(function(Ze){Pe=Ze.call({lexer:this},Ae),typeof Pe=="number"&&Pe>=0&&(q=Math.min(q,Pe))}),q<Infinity&&q>=0&&(Ge=ne.substring(0,q+1))}(),we=this.tokenizer.inlineText(Ge,je)){ne=ne.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(le=we.raw.slice(-1)),it=!0,Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(ne){var ce="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return de},e(Le,null,[{key:"rules",get:function(){return{block:Re,inline:We}}}]),Le}(),re=C.exports.defaults,ae=F.cleanUrl,J=F.escape,oe=function(){function Le(ke){this.options=ke||re}var De=Le.prototype;return De.code=function(ne,de,be){var we=(de||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(ne,we);Fe!=null&&Fe!==ne&&(be=!0,ne=Fe)}return ne=ne.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+J(we,!0)+'">'+(be?ne:J(ne,!0))+`</code></pre>
`:"<pre><code>"+(be?ne:J(ne,!0))+`</code></pre>
`},De.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},De.html=function(ne){return ne},De.heading=function(ne,de,be,we){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+we.slug(be)+'">'+ne+"</h"+de+`>
`:"<h"+de+">"+ne+"</h"+de+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(ne,de,be){var we=de?"ol":"ul",Fe=de&&be!==1?' start="'+be+'"':"";return"<"+we+Fe+`>
`+ne+"</"+we+`>
`},De.listitem=function(ne){return"<li>"+ne+`</li>
`},De.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(ne){return"<p>"+ne+`</p>
`},De.table=function(ne,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+de+`</table>
`},De.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},De.tablecell=function(ne,de){var be=de.header?"th":"td",we=de.align?"<"+be+' align="'+de.align+'">':"<"+be+">";return we+ne+"</"+be+`>
`},De.strong=function(ne){return"<strong>"+ne+"</strong>"},De.em=function(ne){return"<em>"+ne+"</em>"},De.codespan=function(ne){return"<code>"+ne+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(ne){return"<del>"+ne+"</del>"},De.link=function(ne,de,be){if(ne=ae(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<a href="'+J(ne)+'"';return de&&(we+=' title="'+de+'"'),we+=">"+be+"</a>",we},De.image=function(ne,de,be){if(ne=ae(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<img src="'+ne+'" alt="'+be+'"';return de&&(we+=' title="'+de+'"'),we+=this.options.xhtml?"/>":">",we},De.text=function(ne){return ne},Le}(),ve=function(){function Le(){}var De=Le.prototype;return De.strong=function(ne){return ne},De.em=function(ne){return ne},De.codespan=function(ne){return ne},De.del=function(ne){return ne},De.html=function(ne){return ne},De.text=function(ne){return ne},De.link=function(ne,de,be){return""+be},De.image=function(ne,de,be){return""+be},De.br=function(){return""},Le}(),Me=function(){function Le(){this.seen={}}var De=Le.prototype;return De.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(ne,de){var be=ne,we=0;if(this.seen.hasOwnProperty(be)){we=this.seen[ne];do we++,be=ne+"-"+we;while(this.seen.hasOwnProperty(be))}return de||(this.seen[ne]=we,this.seen[be]=0),be},De.slug=function(ne,de){de===void 0&&(de={});var be=this.serialize(ne);return this.getNextSafeSlug(be,de.dryrun)},Le}(),qe=oe,Ke=ve,Se=Me,tt=C.exports.defaults,Z=F.unescape,te=function(){function Le(ke){this.options=ke||tt,this.options.renderer=this.options.renderer||new qe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Se}Le.parse=function(ne,de){var be=new Le(de);return be.parse(ne)},Le.parseInline=function(ne,de){var be=new Le(de);return be.parseInline(ne)};var De=Le.prototype;return De.parse=function(ne,de){de===void 0&&(de=!0);var be="",we,Fe,Ge,He,Je,it,le,Ee,ce,q,Ae,Pe,Ze,Xe,ot,vt,Et,lt,dt,mt=ne.length;for(we=0;we<mt;we++){if(q=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[q.type]&&(dt=this.options.extensions.renderers[q.type].call({parser:this},q),dt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(q.type))){be+=dt||"";continue}switch(q.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(q.tokens),q.depth,Z(this.parseInline(q.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(q.text,q.lang,q.escaped);continue}case"table":{for(Ee="",le="",He=q.header.length,Fe=0;Fe<He;Fe++)le+=this.renderer.tablecell(this.parseInline(q.header[Fe].tokens),{header:!0,align:q.align[Fe]});for(Ee+=this.renderer.tablerow(le),ce="",He=q.rows.length,Fe=0;Fe<He;Fe++){for(it=q.rows[Fe],le="",Je=it.length,Ge=0;Ge<Je;Ge++)le+=this.renderer.tablecell(this.parseInline(it[Ge].tokens),{header:!1,align:q.align[Ge]});ce+=this.renderer.tablerow(le)}be+=this.renderer.table(Ee,ce);continue}case"blockquote":{ce=this.parse(q.tokens),be+=this.renderer.blockquote(ce);continue}case"list":{for(Ae=q.ordered,Pe=q.start,Ze=q.loose,He=q.items.length,ce="",Fe=0;Fe<He;Fe++)ot=q.items[Fe],vt=ot.checked,Et=ot.task,Xe="",ot.task&&(lt=this.renderer.checkbox(vt),Ze?ot.tokens.length>0&&ot.tokens[0].type==="paragraph"?(ot.tokens[0].text=lt+" "+ot.tokens[0].text,ot.tokens[0].tokens&&ot.tokens[0].tokens.length>0&&ot.tokens[0].tokens[0].type==="text"&&(ot.tokens[0].tokens[0].text=lt+" "+ot.tokens[0].tokens[0].text)):ot.tokens.unshift({type:"text",text:lt}):Xe+=lt),Xe+=this.parse(ot.tokens,Ze),ce+=this.renderer.listitem(Xe,Et,vt);be+=this.renderer.list(ce,Ae,Pe);continue}case"html":{be+=this.renderer.html(q.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(q.tokens));continue}case"text":{for(ce=q.tokens?this.parseInline(q.tokens):q.text;we+1<mt&&ne[we+1].type==="text";)q=ne[++we],ce+=`
`+(q.tokens?this.parseInline(q.tokens):q.text);be+=de?this.renderer.paragraph(ce):ce;continue}default:{var Rt='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(Rt);return}else throw new Error(Rt)}}}return be},De.parseInline=function(ne,de){de=de||this.renderer;var be="",we,Fe,Ge,He=ne.length;for(we=0;we<He;we++){if(Fe=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Ge=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){be+=Ge||"";continue}switch(Fe.type){case"escape":{be+=de.text(Fe.text);break}case"html":{be+=de.html(Fe.text);break}case"link":{be+=de.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,de));break}case"image":{be+=de.image(Fe.href,Fe.title,Fe.text);break}case"strong":{be+=de.strong(this.parseInline(Fe.tokens,de));break}case"em":{be+=de.em(this.parseInline(Fe.tokens,de));break}case"codespan":{be+=de.codespan(Fe.text);break}case"br":{be+=de.br();break}case"del":{be+=de.del(this.parseInline(Fe.tokens,de));break}case"text":{be+=de.text(Fe.text);break}default:{var Je='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}}return be},Le}(),pe=ee,xe=te,Ye=x,rt=oe,ft=ve,pt=Me,St=F.merge,Ct=F.checkSanitizeDeprecation,ue=F.escape,Ie=C.exports.getDefaults,Ue=C.exports.changeDefaults,Qe=C.exports.defaults;function ze(Le,De,ke){if(typeof Le=="undefined"||Le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Le)+", string expected");if(typeof De=="function"&&(ke=De,De=null),De=St({},ze.defaults,De||{}),Ct(De),ke){var ne=De.highlight,de;try{de=pe.lex(Le,De)}catch(Ge){return ke(Ge)}var be=function(He){var Je;if(!He)try{De.walkTokens&&ze.walkTokens(de,De.walkTokens),Je=xe.parse(de,De)}catch(it){He=it}return De.highlight=ne,He?ke(He):ke(null,Je)};if(!ne||ne.length<3||(delete De.highlight,!de.length))return be();var we=0;ze.walkTokens(de,function(Ge){Ge.type==="code"&&(we++,setTimeout(function(){ne(Ge.text,Ge.lang,function(He,Je){if(He)return be(He);Je!=null&&Je!==Ge.text&&(Ge.text=Je,Ge.escaped=!0),we--,we===0&&be()})},0))}),we===0&&be();return}try{var Fe=pe.lex(Le,De);return De.walkTokens&&ze.walkTokens(Fe,De.walkTokens),xe.parse(Fe,De)}catch(Ge){if(Ge.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+ue(Ge.message+"",!0)+"</pre>";throw Ge}}ze.options=ze.setOptions=function(Le){return St(ze.defaults,Le),Ue(ze.defaults),ze},ze.getDefaults=Ie,ze.defaults=Qe,ze.use=function(){for(var Le=this,De=arguments.length,ke=new Array(De),ne=0;ne<De;ne++)ke[ne]=arguments[ne];var de=St.apply(void 0,[{}].concat(ke)),be=ze.defaults.extensions||{renderers:{},childTokens:{}},we;ke.forEach(function(Fe){if(Fe.extensions&&(we=!0,Fe.extensions.forEach(function(He){if(!He.name)throw new Error("extension name required");if(He.renderer){var Je=be.renderers?be.renderers[He.name]:null;Je?be.renderers[He.name]=function(){for(var it=arguments.length,le=new Array(it),Ee=0;Ee<it;Ee++)le[Ee]=arguments[Ee];var ce=He.renderer.apply(this,le);return ce===!1&&(ce=Je.apply(this,le)),ce}:be.renderers[He.name]=He.renderer}if(He.tokenizer){if(!He.level||He.level!=="block"&&He.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[He.level]?be[He.level].unshift(He.tokenizer):be[He.level]=[He.tokenizer],He.start&&(He.level==="block"?be.startBlock?be.startBlock.push(He.start):be.startBlock=[He.start]:He.level==="inline"&&(be.startInline?be.startInline.push(He.start):be.startInline=[He.start]))}He.childTokens&&(be.childTokens[He.name]=He.childTokens)})),Fe.renderer&&function(){var He=ze.defaults.renderer||new rt,Je=function(Ee){var ce=He[Ee];He[Ee]=function(){for(var q=arguments.length,Ae=new Array(q),Pe=0;Pe<q;Pe++)Ae[Pe]=arguments[Pe];var Ze=Fe.renderer[Ee].apply(He,Ae);return Ze===!1&&(Ze=ce.apply(He,Ae)),Ze}};for(var it in Fe.renderer)Je(it);de.renderer=He}(),Fe.tokenizer&&function(){var He=ze.defaults.tokenizer||new Ye,Je=function(Ee){var ce=He[Ee];He[Ee]=function(){for(var q=arguments.length,Ae=new Array(q),Pe=0;Pe<q;Pe++)Ae[Pe]=arguments[Pe];var Ze=Fe.tokenizer[Ee].apply(He,Ae);return Ze===!1&&(Ze=ce.apply(He,Ae)),Ze}};for(var it in Fe.tokenizer)Je(it);de.tokenizer=He}(),Fe.walkTokens){var Ge=ze.defaults.walkTokens;de.walkTokens=function(He){Fe.walkTokens.call(Le,He),Ge&&Ge(He)}}we&&(de.extensions=be),ze.setOptions(de)})},ze.walkTokens=function(Le,De){for(var ke=function(){var we=de.value;switch(De(we),we.type){case"table":{for(var Fe=I(we.header),Ge;!(Ge=Fe()).done;){var He=Ge.value;ze.walkTokens(He.tokens,De)}for(var Je=I(we.rows),it;!(it=Je()).done;)for(var le=it.value,Ee=I(le),ce;!(ce=Ee()).done;){var q=ce.value;ze.walkTokens(q.tokens,De)}break}case"list":{ze.walkTokens(we.items,De);break}default:ze.defaults.extensions&&ze.defaults.extensions.childTokens&&ze.defaults.extensions.childTokens[we.type]?ze.defaults.extensions.childTokens[we.type].forEach(function(Ae){ze.walkTokens(we[Ae],De)}):we.tokens&&ze.walkTokens(we.tokens,De)}},ne=I(Le),de;!(de=ne()).done;)ke()},ze.parseInline=function(Le,De){if(typeof Le=="undefined"||Le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Le)+", string expected");De=St({},ze.defaults,De||{}),Ct(De);try{var ke=pe.lexInline(Le,De);return De.walkTokens&&ze.walkTokens(ke,De.walkTokens),xe.parseInline(ke,De)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+ue(ne.message+"",!0)+"</pre>";throw ne}},ze.Parser=xe,ze.parser=xe.parse,ze.Renderer=rt,ze.TextRenderer=ft,ze.Lexer=pe,ze.lexer=pe.lex,ze.Tokenizer=Ye,ze.Slugger=pt,ze.parse=ze;var at=ze;return at}),define(me[77],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(R,E,S){return Math.min(Math.max(R,E),S)}e.clamp=g;function L(R,E){return(E+R%E)%E}e.rot=L;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class C{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function Y(I){const C=[];typeof I=="number"&&C.push("code/timeOrigin",I);function R(S){C.push(S,Date.now())}function E(){const S=[];for(let T=0;T<C.length;T+=2)S.push({name:C[T],startTime:C[T+1]});return S}return{mark:R,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const R of performance.getEntriesByType("mark"))C.push({name:R.name,startTime:Math.round(I+R.startTime)});return C}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function g(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=g(L))}(),define(me[11],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const g="en";let L=!1,I=!1,C=!1,R=!1,E=!1,S=!1,T=!1,n,P=g,c,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const h=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=h&&u?.sandboxed,typeof navigator=="object"&&!h)m=navigator.userAgent,L=m.indexOf("Windows")>=0,I=m.indexOf("Macintosh")>=0,T=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=m.indexOf("Linux")>=0,S=!0,n=navigator.language,P=n;else if(typeof u=="object"){L=u.platform==="win32",I=u.platform==="darwin",C=u.platform==="linux",R=C&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,n=g,P=g;const r=u.env.VSCODE_NLS_CONFIG;if(r)try{const i=JSON.parse(r),f=i.availableLanguages["*"];n=i.locale,P=f||g,c=i._translationsConfigFile}catch(i){}E=!0}else console.error("Unable to resolve platform.");var D;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function k(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=k;let _=0;I?_=1:L?_=3:C&&(_=2),e.isWindows=L,e.isMacintosh=I,e.isLinux=C,e.isLinuxSnap=R,e.isNative=E,e.isWeb=S,e.isIOS=T,e.platform=_,e.userAgent=m,e.language=P;var o;(function(r){function i(){return e.language}r.value=i;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=f;function l(){return e.language==="en"}r.isDefault=l})(o=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=c,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let b=0,y=f.length;b<y;b++){const v=f[b];if(v.id===d.data.vscodeSetImmediateId){f.splice(b,1),v.callback();return}}});let l=0;return d=>{const b=++l;f.push({id:b,callback:d}),e.globals.postMessage({vscodeSetImmediateId:b},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const i=Promise.resolve();return f=>i.then(f)}();var a;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||T?2:L?1:3;let p=!0,t=!1;function s(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,p=new Uint16Array(r.buffer)[0]===(2<<8)+1}return p}e.isLittleEndian=s}),define(me[38],ge([0,1,11]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const I=g.globals.vscode.process;L={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()},nextTick(C){return(0,g.setImmediate)(C)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(I){return process.nextTick(I)}}:L={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},get arch(){},nextTick(I){return(0,g.setImmediate)(I)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(me[8],ge([0,1,38]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,I=97,C=90,R=122,E=46,S=47,T=92,n=58,P=63;class c extends Error{constructor(a,p,t){let s;typeof p=="string"&&p.indexOf("not ")===0?(s="must not be",p=p.replace(/^not /,"")):s="must be";const r=a.indexOf(".")!==-1?"property":"argument";let i=`The "${a}" ${r} ${s} of type ${p}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function m(o,a){if(typeof o!="string")throw new c(a,"string",o)}function u(o){return o===S||o===T}function h(o){return o===S}function D(o){return o>=L&&o<=C||o>=I&&o<=R}function k(o,a,p,t){let s="",r=0,i=-1,f=0,l=0;for(let d=0;d<=o.length;++d){if(d<o.length)l=o.charCodeAt(d);else{if(t(l))break;l=S}if(t(l)){if(!(i===d-1||f===1))if(f===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==E||s.charCodeAt(s.length-2)!==E){if(s.length>2){const b=s.lastIndexOf(p);b===-1?(s="",r=0):(s=s.slice(0,b),r=s.length-1-s.lastIndexOf(p)),i=d,f=0;continue}else if(s.length!==0){s="",r=0,i=d,f=0;continue}}a&&(s+=s.length>0?`${p}..`:"..",r=2)}else s.length>0?s+=`${p}${o.slice(i+1,d)}`:s=o.slice(i+1,d),r=d-i-1;i=d,f=0}else l===E&&f!==-1?++f:f=-1}return s}function _(o,a){if(a===null||typeof a!="object")throw new c("pathObject","Object",a);const p=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return p?p===a.root?`${p}${t}`:`${p}${o}${t}`:t}e.win32={resolve(...o){let a="",p="",t=!1;for(let s=o.length-1;s>=-1;s--){let r;if(s>=0){if(r=o[s],m(r,"path"),r.length===0)continue}else a.length===0?r=g.cwd():(r=g.env[`=${a}`]||g.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===T)&&(r=`${a}\\`));const i=r.length;let f=0,l="",d=!1;const b=r.charCodeAt(0);if(i===1)u(b)&&(f=1,d=!0);else if(u(b))if(d=!0,u(r.charCodeAt(1))){let y=2,v=y;for(;y<i&&!u(r.charCodeAt(y));)y++;if(y<i&&y!==v){const A=r.slice(v,y);for(v=y;y<i&&u(r.charCodeAt(y));)y++;if(y<i&&y!==v){for(v=y;y<i&&!u(r.charCodeAt(y));)y++;(y===i||y!==v)&&(l=`\\\\${A}\\${r.slice(v,y)}`,f=y)}}}else f=1;else D(b)&&r.charCodeAt(1)===n&&(l=r.slice(0,2),f=2,i>2&&u(r.charCodeAt(2))&&(d=!0,f=3));if(l.length>0)if(a.length>0){if(l.toLowerCase()!==a.toLowerCase())continue}else a=l;if(t){if(a.length>0)break}else if(p=`${r.slice(f)}\\${p}`,t=d,d&&a.length>0)break}return p=k(p,!t,"\\",u),t?`${a}\\${p}`:`${a}${p}`||"."},normalize(o){m(o,"path");const a=o.length;if(a===0)return".";let p=0,t,s=!1;const r=o.charCodeAt(0);if(a===1)return h(r)?"\\":o;if(u(r))if(s=!0,u(o.charCodeAt(1))){let f=2,l=f;for(;f<a&&!u(o.charCodeAt(f));)f++;if(f<a&&f!==l){const d=o.slice(l,f);for(l=f;f<a&&u(o.charCodeAt(f));)f++;if(f<a&&f!==l){for(l=f;f<a&&!u(o.charCodeAt(f));)f++;if(f===a)return`\\\\${d}\\${o.slice(l)}\\`;f!==l&&(t=`\\\\${d}\\${o.slice(l,f)}`,p=f)}}}else p=1;else D(r)&&o.charCodeAt(1)===n&&(t=o.slice(0,2),p=2,a>2&&u(o.charCodeAt(2))&&(s=!0,p=3));let i=p<a?k(o.slice(p),!s,"\\",u):"";return i.length===0&&!s&&(i="."),i.length>0&&u(o.charCodeAt(a-1))&&(i+="\\"),t===void 0?s?`\\${i}`:i:s?`${t}\\${i}`:`${t}${i}`},isAbsolute(o){m(o,"path");const a=o.length;if(a===0)return!1;const p=o.charCodeAt(0);return u(p)||a>2&&D(p)&&o.charCodeAt(1)===n&&u(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let a,p;for(let r=0;r<o.length;++r){const i=o[r];m(i,"path"),i.length>0&&(a===void 0?a=p=i:a+=`\\${i}`)}if(a===void 0)return".";let t=!0,s=0;if(typeof p=="string"&&u(p.charCodeAt(0))){++s;const r=p.length;r>1&&u(p.charCodeAt(1))&&(++s,r>2&&(u(p.charCodeAt(2))?++s:t=!1))}if(t){for(;s<a.length&&u(a.charCodeAt(s));)s++;s>=2&&(a=`\\${a.slice(s)}`)}return e.win32.normalize(a)},relative(o,a){if(m(o,"from"),m(a,"to"),o===a)return"";const p=e.win32.resolve(o),t=e.win32.resolve(a);if(p===t||(o=p.toLowerCase(),a=t.toLowerCase(),o===a))return"";let s=0;for(;s<o.length&&o.charCodeAt(s)===T;)s++;let r=o.length;for(;r-1>s&&o.charCodeAt(r-1)===T;)r--;const i=r-s;let f=0;for(;f<a.length&&a.charCodeAt(f)===T;)f++;let l=a.length;for(;l-1>f&&a.charCodeAt(l-1)===T;)l--;const d=l-f,b=i<d?i:d;let y=-1,v=0;for(;v<b;v++){const w=o.charCodeAt(s+v);if(w!==a.charCodeAt(f+v))break;w===T&&(y=v)}if(v!==b){if(y===-1)return t}else{if(d>b){if(a.charCodeAt(f+v)===T)return t.slice(f+v+1);if(v===2)return t.slice(f+v)}i>b&&(o.charCodeAt(s+v)===T?y=v:v===2&&(y=3)),y===-1&&(y=0)}let A="";for(v=s+y+1;v<=r;++v)(v===r||o.charCodeAt(v)===T)&&(A+=A.length===0?"..":"\\..");return f+=y,A.length>0?`${A}${t.slice(f,l)}`:(t.charCodeAt(f)===T&&++f,t.slice(f,l))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const a=e.win32.resolve(o);if(a.length<=2)return o;if(a.charCodeAt(0)===T){if(a.charCodeAt(1)===T){const p=a.charCodeAt(2);if(p!==P&&p!==E)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(D(a.charCodeAt(0))&&a.charCodeAt(1)===n&&a.charCodeAt(2)===T)return`\\\\?\\${a}`;return o},dirname(o){m(o,"path");const a=o.length;if(a===0)return".";let p=-1,t=0;const s=o.charCodeAt(0);if(a===1)return u(s)?o:".";if(u(s)){if(p=t=1,u(o.charCodeAt(1))){let f=2,l=f;for(;f<a&&!u(o.charCodeAt(f));)f++;if(f<a&&f!==l){for(l=f;f<a&&u(o.charCodeAt(f));)f++;if(f<a&&f!==l){for(l=f;f<a&&!u(o.charCodeAt(f));)f++;if(f===a)return o;f!==l&&(p=t=f+1)}}}}else D(s)&&o.charCodeAt(1)===n&&(p=a>2&&u(o.charCodeAt(2))?3:2,t=p);let r=-1,i=!0;for(let f=a-1;f>=t;--f)if(u(o.charCodeAt(f))){if(!i){r=f;break}}else i=!1;if(r===-1){if(p===-1)return".";r=p}return o.slice(0,r)},basename(o,a){a!==void 0&&m(a,"ext"),m(o,"path");let p=0,t=-1,s=!0,r;if(o.length>=2&&D(o.charCodeAt(0))&&o.charCodeAt(1)===n&&(p=2),a!==void 0&&a.length>0&&a.length<=o.length){if(a===o)return"";let i=a.length-1,f=-1;for(r=o.length-1;r>=p;--r){const l=o.charCodeAt(r);if(u(l)){if(!s){p=r+1;break}}else f===-1&&(s=!1,f=r+1),i>=0&&(l===a.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=f))}return p===t?t=f:t===-1&&(t=o.length),o.slice(p,t)}for(r=o.length-1;r>=p;--r)if(u(o.charCodeAt(r))){if(!s){p=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":o.slice(p,t)},extname(o){m(o,"path");let a=0,p=-1,t=0,s=-1,r=!0,i=0;o.length>=2&&o.charCodeAt(1)===n&&D(o.charCodeAt(0))&&(a=t=2);for(let f=o.length-1;f>=a;--f){const l=o.charCodeAt(f);if(u(l)){if(!r){t=f+1;break}continue}s===-1&&(r=!1,s=f+1),l===E?p===-1?p=f:i!==1&&(i=1):p!==-1&&(i=-1)}return p===-1||s===-1||i===0||i===1&&p===s-1&&p===t+1?"":o.slice(p,s)},format:_.bind(null,"\\"),parse(o){m(o,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return a;const p=o.length;let t=0,s=o.charCodeAt(0);if(p===1)return u(s)?(a.root=a.dir=o,a):(a.base=a.name=o,a);if(u(s)){if(t=1,u(o.charCodeAt(1))){let y=2,v=y;for(;y<p&&!u(o.charCodeAt(y));)y++;if(y<p&&y!==v){for(v=y;y<p&&u(o.charCodeAt(y));)y++;if(y<p&&y!==v){for(v=y;y<p&&!u(o.charCodeAt(y));)y++;y===p?t=y:y!==v&&(t=y+1)}}}}else if(D(s)&&o.charCodeAt(1)===n){if(p<=2)return a.root=a.dir=o,a;if(t=2,u(o.charCodeAt(2))){if(p===3)return a.root=a.dir=o,a;t=3}}t>0&&(a.root=o.slice(0,t));let r=-1,i=t,f=-1,l=!0,d=o.length-1,b=0;for(;d>=t;--d){if(s=o.charCodeAt(d),u(s)){if(!l){i=d+1;break}continue}f===-1&&(l=!1,f=d+1),s===E?r===-1?r=d:b!==1&&(b=1):r!==-1&&(b=-1)}return f!==-1&&(r===-1||b===0||b===1&&r===f-1&&r===i+1?a.base=a.name=o.slice(i,f):(a.name=o.slice(i,r),a.base=o.slice(i,f),a.ext=o.slice(r,f))),i>0&&i!==t?a.dir=o.slice(0,i-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...o){let a="",p=!1;for(let t=o.length-1;t>=-1&&!p;t--){const s=t>=0?o[t]:g.cwd();m(s,"path"),s.length!==0&&(a=`${s}/${a}`,p=s.charCodeAt(0)===S)}return a=k(a,!p,"/",h),p?`/${a}`:a.length>0?a:"."},normalize(o){if(m(o,"path"),o.length===0)return".";const a=o.charCodeAt(0)===S,p=o.charCodeAt(o.length-1)===S;return o=k(o,!a,"/",h),o.length===0?a?"/":p?"./":".":(p&&(o+="/"),a?`/${o}`:o)},isAbsolute(o){return m(o,"path"),o.length>0&&o.charCodeAt(0)===S},join(...o){if(o.length===0)return".";let a;for(let p=0;p<o.length;++p){const t=o[p];m(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(o,a){if(m(o,"from"),m(a,"to"),o===a||(o=e.posix.resolve(o),a=e.posix.resolve(a),o===a))return"";const p=1,t=o.length,s=t-p,r=1,i=a.length-r,f=s<i?s:i;let l=-1,d=0;for(;d<f;d++){const y=o.charCodeAt(p+d);if(y!==a.charCodeAt(r+d))break;y===S&&(l=d)}if(d===f)if(i>f){if(a.charCodeAt(r+d)===S)return a.slice(r+d+1);if(d===0)return a.slice(r+d)}else s>f&&(o.charCodeAt(p+d)===S?l=d:d===0&&(l=0));let b="";for(d=p+l+1;d<=t;++d)(d===t||o.charCodeAt(d)===S)&&(b+=b.length===0?"..":"/..");return`${b}${a.slice(r+l)}`},toNamespacedPath(o){return o},dirname(o){if(m(o,"path"),o.length===0)return".";const a=o.charCodeAt(0)===S;let p=-1,t=!0;for(let s=o.length-1;s>=1;--s)if(o.charCodeAt(s)===S){if(!t){p=s;break}}else t=!1;return p===-1?a?"/":".":a&&p===1?"//":o.slice(0,p)},basename(o,a){a!==void 0&&m(a,"ext"),m(o,"path");let p=0,t=-1,s=!0,r;if(a!==void 0&&a.length>0&&a.length<=o.length){if(a===o)return"";let i=a.length-1,f=-1;for(r=o.length-1;r>=0;--r){const l=o.charCodeAt(r);if(l===S){if(!s){p=r+1;break}}else f===-1&&(s=!1,f=r+1),i>=0&&(l===a.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=f))}return p===t?t=f:t===-1&&(t=o.length),o.slice(p,t)}for(r=o.length-1;r>=0;--r)if(o.charCodeAt(r)===S){if(!s){p=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":o.slice(p,t)},extname(o){m(o,"path");let a=-1,p=0,t=-1,s=!0,r=0;for(let i=o.length-1;i>=0;--i){const f=o.charCodeAt(i);if(f===S){if(!s){p=i+1;break}continue}t===-1&&(s=!1,t=i+1),f===E?a===-1?a=i:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||t===-1||r===0||r===1&&a===t-1&&a===p+1?"":o.slice(a,t)},format:_.bind(null,"/"),parse(o){m(o,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return a;const p=o.charCodeAt(0)===S;let t;p?(a.root="/",t=1):t=0;let s=-1,r=0,i=-1,f=!0,l=o.length-1,d=0;for(;l>=t;--l){const b=o.charCodeAt(l);if(b===S){if(!f){r=l+1;break}continue}i===-1&&(f=!1,i=l+1),b===E?s===-1?s=l:d!==1&&(d=1):s!==-1&&(d=-1)}if(i!==-1){const b=r===0&&p?1:r;s===-1||d===0||d===1&&s===i-1&&s===r+1?a.base=a.name=o.slice(b,i):(a.name=o.slice(b,s),a.base=o.slice(b,i),a.ext=o.slice(s,i))}return r>0?a.dir=o.slice(0,r-1):p&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[140],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(C,...R){const E=R.reduce((n,P)=>(n[P]=!0,n),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(n=>!E[n]).forEach(n=>{for(let P=0;P<S.length;P++)if(n.search(S[P])!==-1){delete C[n];break}})}e.sanitizeProcessEnvironment=I}),define(me[141],ge([0,1]),function(Y,e){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(E,S,T){this.level=E,this.key=S,this.value=T,this.forward=[]}}const I=void 0;class C{constructor(E,S=2**16){this.comparator=E,this[g]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(S)|0),this._header=new L(this._maxLevel,I,I)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,I,I)}has(E){return Boolean(C._search(this,E,this.comparator))}get(E){return C._search(this,E,this.comparator)?.value}set(E,S){return C._insert(this,E,S,this.comparator)&&(this._size+=1),this}delete(E){const S=C._delete(this,E,this.comparator);return S&&(this._size-=1),S}forEach(E,S){let T=this._header.forward[0];for(;T;)E.call(S,T.value,T.key,this),T=T.forward[0]}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this._header.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this._header.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this._header.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",S=this._header.forward[0];for(;S;)E+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return E}static _search(E,S,T){let n=E._header;for(let P=E._level-1;P>=0;P--)for(;n.forward[P]&&T(n.forward[P].key,S)<0;)n=n.forward[P];if(n=n.forward[0],n&&T(n.key,S)===0)return n}static _insert(E,S,T,n){let P=[],c=E._header;for(let m=E._level-1;m>=0;m--){for(;c.forward[m]&&n(c.forward[m].key,S)<0;)c=c.forward[m];P[m]=c}if(c=c.forward[0],c&&n(c.key,S)===0)return c.value=T,!1;{let m=C._randomLevel(E);if(m>E._level){for(let u=E._level;u<m;u++)P[u]=E._header;E._level=m}c=new L(m,S,T);for(let u=0;u<m;u++)c.forward[u]=P[u].forward[u],P[u].forward[u]=c;return!0}}static _randomLevel(E,S=.5){let T=1;for(;Math.random()<S&&T<E._maxLevel;)T+=1;return T}static _delete(E,S,T){let n=[],P=E._header;for(let c=E._level-1;c>=0;c--){for(;P.forward[c]&&T(P.forward[c].key,S)<0;)P=P.forward[c];n[c]=P}if(P=P.forward[0],!P||T(P.key,S)!==0)return!1;for(let c=0;c<E._level&&n[c].forward[c]===P;c++)n[c].forward[c]=P.forward[c];for(;E._level>0&&E._header.forward[E._level-1]===I;)E._level-=1;return!0}}e.SkipList=C}),define(me[46],ge([0,1,11]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=g.globals.performance&&typeof g.globals.performance.now=="function";class I{constructor(R){this._highResolution=L&&R,this._startTime=this._now(),this._stopTime=-1}static create(R=!0){return new I(R)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=I}),define(me[3],ge([0,1,16,75,6,95,46]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var E;(function(o){o.None=()=>I.Disposable.None;function a(K){return(U,z=null,N)=>{let B=!1,x;return x=K(M=>{if(!B)return x?x.dispose():B=!0,U.call(z,M)},null,N),B&&x.dispose(),x}}o.once=a;function p(K,U){return l((z,N=null,B)=>K(x=>z.call(N,U(x)),null,B))}o.map=p;function t(K,U){return l((z,N=null,B)=>K(x=>{U(x),z.call(N,x)},null,B))}o.forEach=t;function s(K,U){return l((z,N=null,B)=>K(x=>U(x)&&z.call(N,x),null,B))}o.filter=s;function r(K){return K}o.signal=r;function i(...K){return(U,z=null,N)=>(0,I.combinedDisposable)(...K.map(B=>B(x=>U.call(z,x),null,N)))}o.any=i;function f(K,U,z){let N=z;return p(K,B=>(N=U(N,B),N))}o.reduce=f;function l(K){let U;const z=new c({onFirstListenerAdd(){U=K(z.fire,z)},onLastListenerRemove(){U.dispose()}});return z.event}function d(K,U,z=100,N=!1,B){let x,M,H,$=0;const Q=new c({leakWarningThreshold:B,onFirstListenerAdd(){x=K(X=>{$++,M=U(M,X),N&&!H&&(Q.fire(M),M=void 0),clearTimeout(H),H=setTimeout(()=>{const he=M;M=void 0,H=void 0,(!N||$>1)&&Q.fire(he),$=0},z)})},onLastListenerRemove(){x.dispose()}});return Q.event}o.debounce=d;function b(K,U=(z,N)=>z===N){let z=!0,N;return s(K,B=>{const x=z||!U(B,N);return z=!1,N=B,x})}o.latch=b;function y(K,U){return[o.filter(K,U),o.filter(K,z=>!U(z))]}o.split=y;function v(K,U=!1,z=[]){let N=z.slice(),B=K(H=>{N?N.push(H):M.fire(H)});const x=()=>{N&&N.forEach(H=>M.fire(H)),N=null},M=new c({onFirstListenerAdd(){B||(B=K(H=>M.fire(H)))},onFirstListenerDidAdd(){N&&(U?setTimeout(x):x())},onLastListenerRemove(){B&&B.dispose(),B=null}});return M.event}o.buffer=v;class A{constructor(U){this.event=U}map(U){return new A(p(this.event,U))}forEach(U){return new A(t(this.event,U))}filter(U){return new A(s(this.event,U))}reduce(U,z){return new A(f(this.event,U,z))}latch(){return new A(b(this.event))}debounce(U,z=100,N=!1,B){return new A(d(this.event,U,z,N,B))}on(U,z,N){return this.event(U,z,N)}once(U,z,N){return a(this.event)(U,z,N)}}function w(K){return new A(K)}o.chain=w;function F(K,U,z=N=>N){const N=(...H)=>M.fire(z(...H)),B=()=>K.on(U,N),x=()=>K.removeListener(U,N),M=new c({onFirstListenerAdd:B,onLastListenerRemove:x});return M.event}o.fromNodeEventEmitter=F;function O(K,U,z=N=>N){const N=(...H)=>M.fire(z(...H)),B=()=>K.addEventListener(U,N),x=()=>K.removeEventListener(U,N),M=new c({onFirstListenerAdd:B,onLastListenerRemove:x});return M.event}o.fromDOMEventEmitter=O;function G(K){return new Promise(U=>a(K)(U))}o.toPromise=G})(E=e.Event||(e.Event={}));class S{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${S._idPool++}`}start(a){this._stopWatch=new R.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let T=-1;function n(o){const a=T;return T=o,{dispose(){T=a}}}e.setGlobalLeakWarningThreshold=n;class P{constructor(a,p=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let p=T;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),p<=0||a<p)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let r,i=0;for(const[f,l]of this._stacks)(!r||i<l)&&(r=f,i=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${i}):`),console.warn(r)}return()=>{const r=this._stacks.get(t)||0;this._stacks.set(t,r-1)}}}class c{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=T>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(a,p,t)=>{this._listeners||(this._listeners=new C.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(p?[a,p]:a);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,p);const i=this._leakageMon?.check(this._listeners.size),f=(0,I.toDisposable)(()=>{i&&i(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof I.DisposableStore?t.add(f):Array.isArray(t)&&t.push(f),f}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let p of this._listeners)this._deliveryQueue.push([p,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[p,t]=this._deliveryQueue.shift();try{typeof p=="function"?p.call(void 0,t):p[0].call(p[1],t)}catch(s){(0,g.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class m extends c{async fireAsync(a,p,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,a]);for(;this._asyncDeliveryQueue.size>0&&!p.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),i=[],f={...r,waitUntil:l=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(l=t(l,typeof s=="function"?s:s[0])),i.push(l)}};try{typeof s=="function"?s.call(void 0,f):s[0].call(s[1],f)}catch(l){(0,g.onUnexpectedError)(l);continue}Object.freeze(i),await Promise.allSettled(i).then(l=>{for(const d of l)d.status==="rejected"&&(0,g.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=m;class u extends c{constructor(a){super(a);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=u;class h extends u{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=h;class D{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const p={event:a,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const t=()=>{this.hasListeners&&this.unhook(p);const s=this.events.indexOf(p);this.events.splice(s,1)};return(0,I.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(p=>this.emitter.fire(p))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=D;class k{constructor(){this.buffers=[]}wrapEvent(a){return(p,t,s)=>a(r=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>p.call(t,r)):p.call(t,r)},void 0,s)}bufferEvents(a){const p=[];this.buffers.push(p);const t=a();return this.buffers.pop(),p.forEach(s=>s()),t}}e.EventBufferer=k;class _{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=I.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=_}),define(me[21],ge([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(E,S){const T=setTimeout(E.bind(S),0);return{dispose(){clearTimeout(T)}}});var I;(function(E){function S(T){return T===E.None||T===E.Cancelled||T instanceof C?!0:!T||typeof T!="object"?!1:typeof T.isCancellationRequested=="boolean"&&typeof T.onCancellationRequested=="function"}E.isCancellationToken=S,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(I=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=I.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=R}),define(me[47],ge([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(P){const c=this._icons.get(P.id);c?P.description?c.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const I=new L;e.iconRegistry=I;function C(n,P){return new E(n,P)}e.registerCodicon=C;function R(n){return n?n.replace(/\$\((.*?)\)/g,(P,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=R;class E{constructor(P,c,m){this.id=P,this.definition=c,this.description=m,I.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=E;function S(n,P){const c=["codicon","codicon-"+n];return P&&c.push("codicon-modifier-"+P),c}e.getClassNamesArray=S;var T;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function c(h){if(h instanceof E)return["codicon","codicon-"+h.id];const D=P.exec(h.id);if(!D)return c(E.error);let[,k,_]=D;const o=["codicon","codicon-"+k];return _&&o.push("codicon-modifier-"+_.substr(1)),o}n.asClassNameArray=c;function m(h){return c(h).join(" ")}n.asClassName=m;function u(h){return"."+c(h).join(".")}n.asCSSSelector=u})(T=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(E=e.Codicon||(e.Codicon={}))}),define(me[96],ge([0,1,16,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(o){const a=o;return a?[a.on,a.pause,a.resume,a.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=I;function C(o){const a=o;return a?I(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=C;function R(o,a){return new E(o,a)}e.newWriteableStream=R;class E{constructor(a,p){this.reducer=a,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(p=>this.pendingWritePromises.push(p))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(p=>p(a))}emitError(a){this.listeners.error.length===0?(0,g.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(p=>p(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,p){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(a,p){if(this.state.destroyed)return;let t;switch(a){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(p);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(o,a){const p=[];let t;for(;(t=o.read())!==null;)p.push(t);return a(p)}e.consumeReadable=S;function T(o,a,p){const t=[];let s;for(;(s=o.read())!==null&&t.length<p;)t.push(s);return s===null&&t.length>0?a(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return o.read()}}}e.peekReadable=T;function n(o,a){return new Promise((p,t)=>{const s=[];P(o,{onData:r=>{a&&s.push(r)},onError:r=>{a?t(r):p(void 0)},onEnd:()=>{p(a?a(s):void 0)}})})}e.consumeStream=n;function P(o,a){o.on("error",p=>a.onError(p)),o.on("end",()=>a.onEnd()),o.on("data",p=>a.onData(p))}e.listenStream=P;function c(o,a){return new Promise((p,t)=>{const s=new L.DisposableStore,r=[],i=d=>{if(r.push(d),r.length>a)return s.dispose(),o.pause(),p({stream:o,buffer:r,ended:!1})},f=d=>t(d),l=()=>p({stream:o,buffer:r,ended:!0});s.add((0,L.toDisposable)(()=>o.removeListener("error",f))),o.on("error",f),s.add((0,L.toDisposable)(()=>o.removeListener("end",l))),o.on("end",l),s.add((0,L.toDisposable)(()=>o.removeListener("data",i))),o.on("data",i)})}e.peekStream=c;function m(o,a){const p=R(a);return p.end(o),p}e.toStream=m;function u(){const o=R(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=u;function h(o){let a=!1;return{read:()=>a?null:(a=!0,o)}}e.toReadable=h;function D(o,a,p){const t=R(p);return P(o,{onData:s=>t.write(a.data(s)),onError:s=>t.error(a.error?a.error(s):s),onEnd:()=>t.end()}),t}e.transform=D;function k(o,a,p){let t=!1;return{read:()=>{const s=a.read();return t?s:(t=!0,s!==null?p([o,s]):o)}}}e.prefixedReadable=k;function _(o,a,p){let t=!1;const s=R(p);return P(a,{onData:r=>t?s.write(r):(t=!0,s.write(p([o,r]))),onError:r=>s.error(r),onEnd:()=>{t||(t=!0,s.write(o)),s.end()}}),s}e.prefixedStream=_}),define(me[23],ge([0,1,96]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let I,C;class R{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return L?new R(Buffer.allocUnsafe(i)):new R(new Uint8Array(i))}static wrap(i){return L&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new R(i)}static fromString(i,f){return!(f?.dontUseNodeBuffer||!1)&&L?new R(Buffer.from(i)):(I||(I=new TextEncoder),new R(I.encode(i)))}static concat(i,f){if(typeof f=="undefined"){f=0;for(let b=0,y=i.length;b<y;b++)f+=i[b].byteLength}const l=R.alloc(f);let d=0;for(let b=0,y=i.length;b<y;b++){const v=i[b];l.set(v,d),d+=v.byteLength}return l}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(i,f){return new R(this.buffer.subarray(i,f))}set(i,f){i instanceof R?this.buffer.set(i.buffer,f):this.buffer.set(i,f)}readUInt32BE(i){return T(this.buffer,i)}writeUInt32BE(i,f){n(this.buffer,i,f)}readUInt32LE(i){return P(this.buffer,i)}writeUInt32LE(i,f){c(this.buffer,i,f)}readUInt8(i){return m(this.buffer,i)}writeUInt8(i,f){u(this.buffer,i,f)}}e.VSBuffer=R;function E(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=E;function S(r,i,f){r[f+0]=i&255,i=i>>>8,r[f+1]=i&255}e.writeUInt16LE=S;function T(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=T;function n(r,i,f){r[f+3]=i,i=i>>>8,r[f+2]=i,i=i>>>8,r[f+1]=i,i=i>>>8,r[f]=i}e.writeUInt32BE=n;function P(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=P;function c(r,i,f){r[f+0]=i&255,i=i>>>8,r[f+1]=i&255,i=i>>>8,r[f+2]=i&255,i=i>>>8,r[f+3]=i&255}e.writeUInt32LE=c;function m(r,i){return r[i]}e.readUInt8=m;function u(r,i,f){r[f]=i}e.writeUInt8=u;function h(r){return g.consumeReadable(r,i=>R.concat(i))}e.readableToBuffer=h;function D(r){return g.toReadable(r)}e.bufferToReadable=D;function k(r){return g.consumeStream(r,i=>R.concat(i))}e.streamToBuffer=k;async function _(r){return r.ended?R.concat(r.buffer):R.concat([...r.buffer,await k(r.stream)])}e.bufferedStreamToBuffer=_;function o(r){return g.toStream(r,i=>R.concat(i))}e.bufferToStream=o;function a(r){return g.transform(r,{data:i=>typeof i=="string"?R.fromString(i):R.wrap(i)},i=>R.concat(i))}e.streamToBufferReadableStream=a;function p(r){return g.newWriteableStream(i=>R.concat(i),r)}e.newWriteableBufferStream=p;function t(r,i){return g.prefixedReadable(r,i,f=>R.concat(f))}e.prefixedBufferReadable=t;function s(r,i){return g.prefixedStream(r,i,f=>R.concat(f))}e.prefixedBufferStream=s}),define(me[9],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=g;const L=/{(\d+)}/g;function I(ue,...Ie){return Ie.length===0?ue:ue.replace(L,function(Ue,Qe){const ze=parseInt(Qe,10);return isNaN(ze)||ze<0||ze>=Ie.length?Ue:Ie[ze]})}e.format=I;const C=/{([^}]+)}/g;function R(ue,Ie){return ue.replace(C,(Ue,Qe)=>Ie[Qe]??Ue)}e.format2=R;function E(ue){return ue.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=E;function S(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function T(ue,Ie){let Ue=0;const Qe=Ie.charCodeAt(0);for(let ze=ue.length-1;ze>=0;ze--)ue.charCodeAt(ze)===Qe&&Ue++;return Ue}e.count=T;function n(ue,Ie,Ue="\u2026"){return ue.length<=Ie?ue:`${ue.substr(0,Ie)}${Ue}`}e.truncate=n;function P(ue,Ie=" "){const Ue=c(ue,Ie);return m(Ue,Ie)}e.trim=P;function c(ue,Ie){if(!ue||!Ie)return ue;const Ue=Ie.length;if(Ue===0||ue.length===0)return ue;let Qe=0;for(;ue.indexOf(Ie,Qe)===Qe;)Qe=Qe+Ue;return ue.substring(Qe)}e.ltrim=c;function m(ue,Ie){if(!ue||!Ie)return ue;const Ue=Ie.length,Qe=ue.length;if(Ue===0||Qe===0)return ue;let ze=Qe,at=-1;for(;at=ue.lastIndexOf(Ie,ze-1),!(at===-1||at+Ue!==ze);){if(at===0)return"";ze=at}return ue.substring(0,ze)}e.rtrim=m;function u(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function h(ue){return ue.replace(/\*/g,"")}e.stripWildcards=h;function D(ue,Ie,Ue={}){if(!ue)throw new Error("Cannot create regex from empty string");Ie||(ue=S(ue)),Ue.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Qe="";return Ue.global&&(Qe+="g"),Ue.matchCase||(Qe+="i"),Ue.multiline&&(Qe+="m"),Ue.unicode&&(Qe+="u"),new RegExp(ue,Qe)}e.createRegExp=D;function k(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=k;function _(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=_;function o(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=o;function a(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=a;function p(ue){for(let Ie=0,Ue=ue.length;Ie<Ue;Ie++){const Qe=ue.charCodeAt(Ie);if(Qe!==32&&Qe!==9)return Ie}return-1}e.firstNonWhitespaceIndex=p;function t(ue,Ie=0,Ue=ue.length){for(let Qe=Ie;Qe<Ue;Qe++){const ze=ue.charCodeAt(Qe);if(ze!==32&&ze!==9)return ue.substring(Ie,Qe)}return ue.substring(Ie,Ue)}e.getLeadingWhitespace=t;function s(ue,Ie=ue.length-1){for(let Ue=Ie;Ue>=0;Ue--){const Qe=ue.charCodeAt(Ue);if(Qe!==32&&Qe!==9)return Ue}return-1}e.lastNonWhitespaceIndex=s;function r(ue,Ie){return ue<Ie?-1:ue>Ie?1:0}e.compare=r;function i(ue,Ie,Ue=0,Qe=ue.length,ze=0,at=Ie.length){for(;Ue<Qe&&ze<at;Ue++,ze++){let ke=ue.charCodeAt(Ue),ne=Ie.charCodeAt(ze);if(ke<ne)return-1;if(ke>ne)return 1}const Le=Qe-Ue,De=at-ze;return Le<De?-1:Le>De?1:0}e.compareSubstring=i;function f(ue,Ie){return l(ue,Ie,0,ue.length,0,Ie.length)}e.compareIgnoreCase=f;function l(ue,Ie,Ue=0,Qe=ue.length,ze=0,at=Ie.length){for(;Ue<Qe&&ze<at;Ue++,ze++){let ke=ue.charCodeAt(Ue),ne=Ie.charCodeAt(ze);if(ke===ne)continue;const de=ke-ne;if(!(de===32&&b(ne))&&!(de===-32&&b(ke)))return d(ke)&&d(ne)?de:i(ue.toLowerCase(),Ie.toLowerCase(),Ue,Qe,ze,at)}const Le=Qe-Ue,De=at-ze;return Le<De?-1:Le>De?1:0}e.compareSubstringIgnoreCase=l;function d(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=d;function b(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=b;function y(ue){return d(ue)||b(ue)}function v(ue,Ie){return ue.length===Ie.length&&A(ue,Ie)}e.equalsIgnoreCase=v;function A(ue,Ie,Ue=ue.length){for(let Qe=0;Qe<Ue;Qe++){const ze=ue.charCodeAt(Qe),at=Ie.charCodeAt(Qe);if(ze!==at){if(y(ze)&&y(at)){const Le=Math.abs(ze-at);if(Le!==0&&Le!==32)return!1}else if(String.fromCharCode(ze).toLowerCase()!==String.fromCharCode(at).toLowerCase())return!1}}return!0}function w(ue,Ie){const Ue=Ie.length;return Ie.length>ue.length?!1:A(ue,Ie,Ue)}e.startsWithIgnoreCase=w;function F(ue,Ie){let Ue,Qe=Math.min(ue.length,Ie.length);for(Ue=0;Ue<Qe;Ue++)if(ue.charCodeAt(Ue)!==Ie.charCodeAt(Ue))return Ue;return Qe}e.commonPrefixLength=F;function O(ue,Ie){let Ue,Qe=Math.min(ue.length,Ie.length);const ze=ue.length-1,at=Ie.length-1;for(Ue=0;Ue<Qe;Ue++)if(ue.charCodeAt(ze-Ue)!==Ie.charCodeAt(at-Ue))return Ue;return Qe}e.commonSuffixLength=O;function G(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=G;function K(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=K;function U(ue,Ie){return(ue-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=U;function z(ue,Ie,Ue){const Qe=ue.charCodeAt(Ue);if(G(Qe)&&Ue+1<Ie){const ze=ue.charCodeAt(Ue+1);if(K(ze))return U(Qe,ze)}return Qe}e.getNextCodePoint=z;function N(ue,Ie){const Ue=ue.charCodeAt(Ie-1);if(K(Ue)&&Ie>1){const Qe=ue.charCodeAt(Ie-2);if(G(Qe))return U(Qe,Ue)}return Ue}function B(ue,Ie){const Ue=xe.getInstance(),Qe=Ie,ze=ue.length,at=z(ue,ze,Ie);Ie+=at>=65536?2:1;let Le=Ue.getGraphemeBreakType(at);for(;Ie<ze;){const De=z(ue,ze,Ie),ke=Ue.getGraphemeBreakType(De);if(te(Le,ke))break;Ie+=De>=65536?2:1,Le=ke}return Ie-Qe}e.nextCharLength=B;function x(ue,Ie){const Ue=xe.getInstance(),Qe=Ie,ze=N(ue,Ie);Ie-=ze>=65536?2:1;let at=Ue.getGraphemeBreakType(ze);for(;Ie>0;){const Le=N(ue,Ie),De=Ue.getGraphemeBreakType(Le);if(te(De,at))break;Ie-=Le>=65536?2:1,at=De}return Qe-Ie}e.prevCharLength=x;function M(ue,Ie){const Ue=xe.getInstance(),Qe=ue.length,ze=Ie,at=z(ue,Qe,Ie),Le=Ue.getGraphemeBreakType(at);Ie+=at>=65536?2:1;let De=Le;for(;Ie<Qe;){const ne=z(ue,Qe,Ie),de=Ue.getGraphemeBreakType(ne);if(te(De,de))break;Ie+=ne>=65536?2:1,De=de}const ke=Ie;for(Ie=ze,De=Le;Ie>0;){const ne=N(ue,Ie),de=Ue.getGraphemeBreakType(ne);if(te(de,De))break;Ie-=ne>=65536?2:1,De=de}return[Ie,ke]}function H(ue,Ie){return Ie>0&&K(ue.charCodeAt(Ie))?M(ue,Ie-1):M(ue,Ie)}e.getCharContainingOffset=H;const $=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(ue){return $.test(ue)}e.containsRTL=Q;const X=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function he(ue){return X.test(ue)}e.containsEmoji=he;const _e=/^[\t\n\r\x20-\x7E]*$/;function ye(ue){return _e.test(ue)}e.isBasicASCII=ye,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Re(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=Re;function We(ue){for(let Ie=0,Ue=ue.length;Ie<Ue;Ie++)if(Be(ue.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=We;function Be(ue){return ue=+ue,ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=Be;function je(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129003||ue>=129280&&ue<=129535||ue>=129648&&ue<=129750}e.isEmojiImprecise=je;function V(ue,Ie){if(ue.length<Ie)return ue;const Ue=/\b/g;let Qe=0;for(;Ue.test(ue)&&!(ue.length-Ue.lastIndex<Ie);)Qe=Ue.lastIndex,Ue.lastIndex+=1;return ue.substring(Qe).replace(/^\s/,"")}e.lcut=V;const ee=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,ae=/\x1b\[0?m/g;function J(ue){return ue&&(ue=ue.replace(ee,""),ue=ue.replace(re,""),ue=ue.replace(ae,"")),ue}e.removeAnsiEscapeCodes=J,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function oe(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=oe;function ve(ue){return oe(ue)?ue.substr(1):ue}e.stripUTF8BOM=ve;function Me(ue,Ie){if(!ue||!Ie||ue.length<Ie.length)return!1;const Ue=Ie.length,Qe=ue.toLowerCase();let ze=0,at=-1;for(;ze<Ue;){const Le=Qe.indexOf(Ie[ze],at+1);if(Le<0)return!1;at=Le,ze++}return!0}e.fuzzyContains=Me;function qe(ue,Ie=!1){return ue?(Ie&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=qe;function Ke(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=Ke;function Se(ue,Ie=1){if(Ie===0)return"";let Ue=-1;do Ue=ue.indexOf(`
`,Ue+1),Ie--;while(Ie>0&&Ue>=0);return Ue===-1?ue:(ue[Ue-1]==="\r"&&Ue--,ue.substr(0,Ue))}e.getNLines=Se;function tt(ue){const Ie=90-65+1;return ue=ue%(2*Ie),ue<Ie?String.fromCharCode(97+ue):String.fromCharCode(65+ue-Ie)}e.singleLetterHash=tt;function Z(ue){return xe.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=Z;function te(ue,Ie){return ue===0?Ie!==5&&Ie!==7:ue===2&&Ie===3?!1:ue===4||ue===2||ue===3||Ie===4||Ie===2||Ie===3?!0:!(ue===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(ue===11||ue===9)&&(Ie===9||Ie===10)||(ue===12||ue===10)&&Ie===10||Ie===5||Ie===13||Ie===7||ue===1||ue===13&&Ie===14||ue===6&&Ie===6)}e.breakBetweenGraphemeBreakType=te;var pe;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})(pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class xe{constructor(){this._data=Ye()}static getInstance(){return xe._INSTANCE||(xe._INSTANCE=new xe),xe._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ue=this._data,Qe=Ue.length/3;let ze=1;for(;ze<=Qe;)if(Ie<Ue[3*ze])ze=2*ze;else if(Ie>Ue[3*ze+1])ze=2*ze+1;else return Ue[3*ze+2];return 0}}xe._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function rt(ue,Ie){if(ue===0)return 0;const Ue=ft(ue,Ie);if(Ue!==void 0)return Ue;const Qe=N(Ie,ue);return ue-=pt(Qe),ue}e.getLeftDeleteOffset=rt;function ft(ue,Ie){let Ue=N(Ie,ue);for(ue-=pt(Ue);St(Ue)||Ue===65039||Ue===8419;){if(ue===0)return;Ue=N(Ie,ue),ue-=pt(Ue)}if(!!je(Ue)){if(ue>=0){const Qe=N(Ie,ue);Qe===8205&&(ue-=pt(Qe))}return ue}}function pt(ue){return ue>=65536?2:1}function St(ue){return 127995<=ue&&ue<=127999}var Ct;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(Ct||(Ct={}))}),define(me[48],ge([0,1,9]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(k){return I(k,0)}e.hash=L;function I(k,_){switch(typeof k){case"object":return k===null?C(349,_):Array.isArray(k)?S(k,_):T(k,_);case"string":return E(k,_);case"boolean":return R(k,_);case"number":return C(k,_);case"undefined":return C(937,_);default:return C(617,_)}}e.doHash=I;function C(k,_){return(_<<5)-_+k|0}function R(k,_){return C(k?433:863,_)}function E(k,_){_=C(149417,_);for(let o=0,a=k.length;o<a;o++)_=C(k.charCodeAt(o),_);return _}e.stringHash=E;function S(k,_){return _=C(104579,_),k.reduce((o,a)=>I(a,o),_)}function T(k,_){return _=C(181387,_),Object.keys(k).sort().reduce((o,a)=>(o=E(a,o),I(k[a],o)),_)}class n{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=I(_,this._value),this._value}}e.Hasher=n;var P;(function(k){k[k.BLOCK_SIZE=64]="BLOCK_SIZE",k[k.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function c(k,_,o=32){const a=o-_,p=~((1<<a)-1);return(k<<_|(p&k)>>>a)>>>0}function m(k,_=0,o=k.byteLength,a=0){for(let p=0;p<o;p++)k[_+p]=a}function u(k,_,o="0"){for(;k.length<_;)k=o+k;return k}function h(k,_=32){return k instanceof ArrayBuffer?Array.from(new Uint8Array(k)).map(o=>o.toString(16).padStart(2,"0")).join(""):u((k>>>0).toString(16),_/4)}e.toHexString=h;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const o=_.length;if(o===0)return;const a=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,s,r;for(t!==0?(s=t,r=-1,t=0):(s=_.charCodeAt(0),r=0);;){let i=s;if(g.isHighSurrogate(s))if(r+1<o){const f=_.charCodeAt(r+1);g.isLowSurrogate(f)?(r++,i=g.computeCodePoint(s,f)):i=65533}else{t=s;break}else g.isLowSurrogate(s)&&(i=65533);if(p=this._push(a,p,i),r++,r<o)s=_.charCodeAt(r);else break}this._buffLen=p,this._leftoverHighSurrogate=t}_push(_,o,a){return a<128?_[o++]=a:a<2048?(_[o++]=192|(a&1984)>>>6,_[o++]=128|(a&63)>>>0):a<65536?(_[o++]=224|(a&61440)>>>12,_[o++]=128|(a&4032)>>>6,_[o++]=128|(a&63)>>>0):(_[o++]=240|(a&1835008)>>>18,_[o++]=128|(a&258048)>>>12,_[o++]=128|(a&4032)>>>6,_[o++]=128|(a&63)>>>0),o>=64&&(this._step(),o-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),o}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=D._bigBlock32,o=this._buffDV;for(let d=0;d<64;d+=4)_.setUint32(d,o.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)_.setUint32(d,c(_.getUint32(d-12,!1)^_.getUint32(d-32,!1)^_.getUint32(d-56,!1)^_.getUint32(d-64,!1),1),!1);let a=this._h0,p=this._h1,t=this._h2,s=this._h3,r=this._h4,i,f,l;for(let d=0;d<80;d++)d<20?(i=p&t|~p&s,f=1518500249):d<40?(i=p^t^s,f=1859775393):d<60?(i=p&t|p&s|t&s,f=2400959708):(i=p^t^s,f=3395469782),l=c(a,5)+i+r+f+_.getUint32(d*4,!1)&4294967295,r=s,s=t,t=c(p,30),p=a,a=l;this._h0=this._h0+a&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[49],ge([0,1,9]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(L||(L={})),function(I){const C="error",R="warning",E="warn",S="info",T="ignore";function n(c){return c?g.equalsIgnoreCase(C,c)?I.Error:g.equalsIgnoreCase(R,c)||g.equalsIgnoreCase(E,c)?I.Warning:g.equalsIgnoreCase(S,c)?I.Info:I.Ignore:I.Ignore}I.fromValue=n;function P(c){switch(c){case I.Error:return C;case I.Warning:return R;case I.Info:return S;default:return T}}I.toString=P}(L||(L={})),e.default=L}),define(me[13],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(b){return Array.isArray(b)}e.isArray=g;function L(b){return typeof b=="string"}e.isString=L;function I(b){return Array.isArray(b)&&b.every(y=>L(y))}e.isStringArray=I;function C(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=C;function R(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=R;function E(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=E;function S(b){return b===!0||b===!1}e.isBoolean=S;function T(b){return typeof b=="undefined"}e.isUndefined=T;function n(b){return!P(b)}e.isDefined=n;function P(b){return T(b)||b===null}e.isUndefinedOrNull=P;function c(b,y){if(!b)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}e.assertType=c;function m(b){if(P(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=m;function u(...b){const y=[];for(let v=0;v<b.length;v++){const A=b[v];if(P(A))throw new Error(`Assertion Failed: argument at index ${v} is undefined or null`);y.push(A)}return y}e.assertAllDefined=u;const h=Object.prototype.hasOwnProperty;function D(b){if(!C(b))return!1;for(let y in b)if(h.call(b,y))return!1;return!0}e.isEmptyObject=D;function k(b){return typeof b=="function"}e.isFunction=k;function _(...b){return b.length>0&&b.every(k)}e.areFunctions=_;function o(b,y){const v=Math.min(b.length,y.length);for(let A=0;A<v;A++)a(b[A],y[A])}e.validateConstraints=o;function a(b,y){if(L(y)){if(typeof b!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(k(y)){try{if(b instanceof y)return}catch{}if(!P(b)&&b.constructor===y||y.length===1&&y.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function p(b){let y=[],v=Object.getPrototypeOf(b);for(;Object.prototype!==v;)y=y.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return y}e.getAllPropertyNames=p;function t(b){const y=[];for(const v of p(b))typeof b[v]=="function"&&y.push(v);return y}e.getAllMethodNames=t;function s(b,y){const v=w=>function(){const F=Array.prototype.slice.call(arguments,0);return y(w,F)};let A={};for(const w of b)A[w]=v(w);return A}e.createProxyObject=s;function r(b){return b===null?void 0:b}e.withNullAsUndefined=r;function i(b){return typeof b=="undefined"?null:b}e.withUndefinedAsNull=i;function f(b){return class{constructor(){return new Proxy({},{get(y,v){if(y[v])return y[v];throw new Error(`Not Implemented: ${b}->${String(v)}`)}})}}}e.NotImplementedProxy=f;function l(b,y="Unreachable"){throw new Error(y)}e.assertNever=l;function d(b){return!!b&&typeof b.then=="function"&&typeof b.catch=="function"}e.isPromise=d}),define(me[29],ge([0,1,8,11,9,13]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(r){return r===47||r===92}e.isPathSeparator=R;function E(r){return r.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=E;function S(r){return r.indexOf("/")===-1&&(r=E(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function T(r,i=g.posix.sep){if(!r)return"";const f=r.length,l=r.charCodeAt(0);if(R(l)){if(R(r.charCodeAt(1))&&!R(r.charCodeAt(2))){let b=3;const y=b;for(;b<f&&!R(r.charCodeAt(b));b++);if(y!==b&&!R(r.charCodeAt(b+1))){for(b+=1;b<f;b++)if(R(r.charCodeAt(b)))return r.slice(0,b+1).replace(/[\\/]/g,i)}}return i}else if(k(l)&&r.charCodeAt(1)===58)return R(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let d=r.indexOf("://");if(d!==-1){for(d+=3;d<f;d++)if(R(r.charCodeAt(d)))return r.slice(0,d+1)}return""}e.getRoot=T;function n(r){if(!L.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let f=2;const l=f;for(;f<r.length&&(i=r.charCodeAt(f),i!==92);f++);return!(l===f||(i=r.charCodeAt(f+1),isNaN(i)||i===92))}e.isUNC=n;const P=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(r,i=L.isWindows){const f=i?P:c;return!(!r||r.length===0||/^\s+$/.test(r)||(f.lastIndex=0,f.test(r))||i&&m.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=u;function h(r,i,f){const l=r===i;return!f||l?l:!r||!i?!1:(0,I.equalsIgnoreCase)(r,i)}e.isEqual=h;function D(r,i,f,l=g.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(f){if(!(0,I.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let b=i.length;return i.charAt(i.length-1)===l&&b--,r.charAt(b)===l}return i.charAt(i.length-1)!==l&&(i+=l),r.indexOf(i)===0}e.isEqualOrParent=D;function k(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=k;function _(r,i){return L.isWindows&&r.endsWith(":")&&(r+=g.sep),(0,g.isAbsolute)(r)||(r=(0,g.join)(i,r)),r=(0,g.normalize)(r),L.isWindows?(r=(0,I.rtrim)(r,g.sep),r.endsWith(":")&&(r+=g.sep)):(r=(0,I.rtrim)(r,g.sep),r||(r=g.sep)),r}e.sanitizeFilePath=_;function o(r){const i=(0,g.normalize)(r);return L.isWindows?r.length>3?!1:a(i)&&(r.length===2||i.charCodeAt(2)===92):i===g.posix.sep}e.isRootOrDriveLetter=o;function a(r){return L.isWindows?k(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function p(r){return a(r)?r[0]:void 0}e.getDriveLetter=p;function t(r,i,f){return i.length>r.length?-1:r===i?0:(f&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=t;function s(r){const i=r.split(":");let f,l,d;if(i.forEach(b=>{const y=Number(b);(0,C.isNumber)(y)?l===void 0?l=y:d===void 0&&(d=y):f=f?[f,b].join(":"):b}),!f)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:f,line:l!==void 0?l:void 0,column:d!==void 0?d:l!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(me[25],ge([0,1,13]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const D=Array.isArray(h)?[]:{};return Object.keys(h).forEach(k=>{h[k]&&typeof h[k]=="object"?D[k]=L(h[k]):D[k]=h[k]}),D}e.deepClone=L;function I(h){if(!h||typeof h!="object")return h;const D=[h];for(;D.length>0;){const k=D.shift();Object.freeze(k);for(const _ in k)if(C.call(k,_)){const o=k[_];typeof o=="object"&&!Object.isFrozen(o)&&D.push(o)}}return h}e.deepFreeze=I;const C=Object.prototype.hasOwnProperty;function R(h,D){return E(h,D,new Set)}e.cloneAndChange=R;function E(h,D,k){if((0,g.isUndefinedOrNull)(h))return h;const _=D(h);if(typeof _!="undefined")return _;if((0,g.isArray)(h)){const o=[];for(const a of h)o.push(E(a,D,k));return o}if((0,g.isObject)(h)){if(k.has(h))throw new Error("Cannot clone recursive data-structure");k.add(h);const o={};for(let a in h)C.call(h,a)&&(o[a]=E(h[a],D,k));return k.delete(h),o}return h}function S(h,D,k=!0){return(0,g.isObject)(h)?((0,g.isObject)(D)&&Object.keys(D).forEach(_=>{_ in h?k&&((0,g.isObject)(h[_])&&(0,g.isObject)(D[_])?S(h[_],D[_],k):h[_]=D[_]):h[_]=D[_]}),h):D}e.mixin=S;function T(h,D){if(h===D)return!0;if(h==null||D===null||D===void 0||typeof h!=typeof D||typeof h!="object"||Array.isArray(h)!==Array.isArray(D))return!1;let k,_;if(Array.isArray(h)){if(h.length!==D.length)return!1;for(k=0;k<h.length;k++)if(!T(h[k],D[k]))return!1}else{const o=[];for(_ in h)o.push(_);o.sort();const a=[];for(_ in D)a.push(_);if(a.sort(),!T(o,a))return!1;for(k=0;k<o.length;k++)if(!T(h[o[k]],D[o[k]]))return!1}return!0}e.equals=T;function n(h){const D=new Set;return JSON.stringify(h,(k,_)=>{if((0,g.isObject)(_)||Array.isArray(_)){if(D.has(_))return"[Circular]";D.add(_)}return _})}e.safeStringify=n;function P(h,D,k){const _=D(h);return typeof _=="undefined"?k:_}e.getOrDefault=P;function c(h,D){const k=Object.create(null);return!h||!D||Object.keys(D).forEach(o=>{const a=h[o],p=D[o];T(a,p)||(k[o]=p)}),k}e.distinct=c;function m(h,D){const k=D.toLowerCase(),_=Object.keys(h).find(o=>o.toLowerCase()===k);return _?h[_]:h[D]}e.getCaseInsensitive=m;function u(h,D){const k=Object.create(null);for(const _ of Object.keys(h))D(_,h[_])&&(k[_]=h[_]);return k}e.filter=u}),define(me[97],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function L(C){return C<0?0:C>255?255:C|0}e.toUint8=L;function I(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=I}),define(me[2],ge([0,1,8,11]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,C=/^\//,R=/^\/\//;function E(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!I.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!C.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(r,i){return!r&&!i?"file":r}function T(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==P&&(i=P+i):i=P;break}return i}const n="",P="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(i,f,l,d,b,y=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=S(i,y),this.authority=f||n,this.path=T(this.scheme,l||n),this.query=d||n,this.fragment=b||n,E(this,y))}static isUri(i){return i instanceof m?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return o(this,!1)}with(i){if(!i)return this;let{scheme:f,authority:l,path:d,query:b,fragment:y}=i;return f===void 0?f=this.scheme:f===null&&(f=n),l===void 0?l=this.authority:l===null&&(l=n),d===void 0?d=this.path:d===null&&(d=n),b===void 0?b=this.query:b===null&&(b=n),y===void 0?y=this.fragment:y===null&&(y=n),f===this.scheme&&l===this.authority&&d===this.path&&b===this.query&&y===this.fragment?this:new h(f,l,d,b,y)}static parse(i,f=!1){const l=c.exec(i);return l?new h(l[2]||n,s(l[4]||n),s(l[5]||n),s(l[7]||n),s(l[9]||n),f):new h(n,n,n,n,n)}static file(i){let f=n;if(L.isWindows&&(i=i.replace(/\\/g,P)),i[0]===P&&i[1]===P){const l=i.indexOf(P,2);l===-1?(f=i.substring(2),i=P):(f=i.substring(2,l),i=i.substring(l)||P)}return new h("file",f,i,n,n)}static from(i){const f=new h(i.scheme,i.authority,i.path,i.query,i.fragment);return E(f,!0),f}static joinPath(i,...f){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&i.scheme==="file"?l=m.file(g.win32.join(o(i,!0),...f)).path:l=g.posix.join(i.path,...f),i.with({path:l})}toString(i=!1){return a(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof m)return i;{const f=new h(i);return f._formatted=i.external,f._fsPath=i._sep===u?i.fsPath:null,f}}else return i}}e.URI=m;const u=L.isWindows?1:void 0;class h extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(i=!1){return i?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=u),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function k(r,i){let f,l=-1;for(let d=0;d<r.length;d++){const b=r.charCodeAt(d);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||i&&b===47)l!==-1&&(f+=encodeURIComponent(r.substring(l,d)),l=-1),f!==void 0&&(f+=r.charAt(d));else{f===void 0&&(f=r.substr(0,d));const y=D[b];y!==void 0?(l!==-1&&(f+=encodeURIComponent(r.substring(l,d)),l=-1),f+=y):l===-1&&(l=d)}}return l!==-1&&(f+=encodeURIComponent(r.substring(l))),f!==void 0?f:r}function _(r){let i;for(let f=0;f<r.length;f++){const l=r.charCodeAt(f);l===35||l===63?(i===void 0&&(i=r.substr(0,f)),i+=D[l]):i!==void 0&&(i+=r[f])}return i!==void 0?i:r}function o(r,i){let f;return r.authority&&r.path.length>1&&r.scheme==="file"?f=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?f=r.path.substr(1):f=r.path[1].toLowerCase()+r.path.substr(2):f=r.path,L.isWindows&&(f=f.replace(/\//g,"\\")),f}e.uriToFsPath=o;function a(r,i){const f=i?_:k;let l="",{scheme:d,authority:b,path:y,query:v,fragment:A}=r;if(d&&(l+=d,l+=":"),(b||d==="file")&&(l+=P,l+=P),b){let w=b.indexOf("@");if(w!==-1){const F=b.substr(0,w);b=b.substr(w+1),w=F.indexOf(":"),w===-1?l+=f(F,!1):(l+=f(F.substr(0,w),!1),l+=":",l+=f(F.substr(w+1),!1)),l+="@"}b=b.toLowerCase(),w=b.indexOf(":"),w===-1?l+=f(b,!1):(l+=f(b.substr(0,w),!1),l+=b.substr(w))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const w=y.charCodeAt(1);w>=65&&w<=90&&(y=`/${String.fromCharCode(w+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const w=y.charCodeAt(0);w>=65&&w<=90&&(y=`${String.fromCharCode(w+32)}:${y.substr(2)}`)}l+=f(y,!0)}return v&&(l+="?",l+=f(v,!1)),A&&(l+="#",l+=i?A:k(A,!1)),l}function p(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+p(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,i=>p(i)):r}});var nt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[24],ge([0,1,17,9,2]),function(Y,e,g,L,I){"use strict";var C,R,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(s,r,i){let f=s.get(r);return f===void 0&&(f=i,s.set(r,f)),f}e.getOrSet=S;function T(s){const r=[];return s.forEach((i,f)=>{r.push(`${f} => ${i}`)}),`Map(${s.size}) {${r.join(", ")}}`}e.mapToString=T;function n(s){const r=[];return s.forEach(i=>{r.push(i)}),`Set(${s.size}) {${r.join(", ")}}`}e.setToString=n;class P{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),f=this._value.charCodeAt(this._pos);return i-f}value(){return this._value[this._pos]}}e.StringIterator=P;class c{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=c;class m{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var u;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(u||(u={}));class h{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class D{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class k{constructor(r){this._iter=r}static forUris(r=()=>!1){return new k(new h(r))}static forPaths(){return new k(new m)}static forStrings(){return new k(new P)}static forConfigKeys(){return new k(new c)}clear(){this._root=void 0}set(r,i){const f=this._iter.reset(r);let l;for(this._root||(this._root=new D,this._root.segment=f.value()),l=this._root;;){const b=f.cmp(l.segment);if(b>0)l.left||(l.left=new D,l.left.segment=f.value()),l=l.left;else if(b<0)l.right||(l.right=new D,l.right.segment=f.value()),l=l.right;else if(f.hasNext())f.next(),l.mid||(l.mid=new D,l.mid.segment=f.value()),l=l.mid;else break}const d=l.value;return l.value=i,l.key=r,d}fill(r,i){const f=i.slice(0);(0,g.shuffle)(f);for(let l of f)this.set(l,r)}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let f=this._root;for(;f;){const l=i.cmp(f.segment);if(l>0)f=f.left;else if(l<0)f=f.right;else if(i.hasNext())i.next(),f=f.mid;else break}return f}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const f=this._iter.reset(r),l=[];let d=this._root;for(;d;){const b=f.cmp(d.segment);if(b>0)l.push([1,d]),d=d.left;else if(b<0)l.push([-1,d]),d=d.right;else if(f.hasNext())f.next(),l.push([0,d]),d=d.mid;else{for(i?(d.left=void 0,d.mid=void 0,d.right=void 0):d.value=void 0;l.length>0&&d.isEmpty();){let[y,v]=l.pop();switch(y){case 1:v.left=void 0;break;case 0:v.mid=void 0;break;case-1:v.right=void 0;break}d=v}break}}}findSubstr(r){const i=this._iter.reset(r);let f=this._root,l;for(;f;){const d=i.cmp(f.segment);if(d>0)f=f.left;else if(d<0)f=f.right;else if(i.hasNext())i.next(),l=f.value||l,f=f.mid;else break}return f&&f.value||l}findSuperstr(r){const i=this._iter.reset(r);let f=this._root;for(;f;){const l=i.cmp(f.segment);if(l>0)f=f.left;else if(l<0)f=f.right;else if(i.hasNext())i.next(),f=f.mid;else return f.mid?this._entries(f.mid):void 0}}forEach(r){for(const[i,f]of this)r(f,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const f=i.pop();f&&(f.value&&(yield[f.key,f.value]),f.left&&i.push(f.left),f.mid&&i.push(f.mid),f.right&&i.push(f.right))}}}e.TernarySearchTree=k;class _{constructor(r,i){this[C]="ResourceMap",r instanceof _?(this.map=new Map(r.map),this.toKey=i??_.defaultToKey):(this.map=new Map,this.toKey=r??_.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[f,l]of this.map)r(l,I.URI.parse(f),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield I.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[I.URI.parse(r[0]),r[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[I.URI.parse(r[0]),r[1]]}}e.ResourceMap=_,_.defaultToKey=s=>s.toString();var o;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class a{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const f=this._map.get(r);if(!!f)return i!==0&&this.touch(f,i),f.value}set(r,i,f=0){let l=this._map.get(r);if(l)l.value=i,f!==0&&this.touch(l,f);else{switch(l={key:r,value:i,next:void 0,previous:void 0},f){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(r,l),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const f=this._state;let l=this._head;for(;l;){if(i?r.bind(i)(l.value,l.key,this):r(l.value,l.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const r=this,i=this._state;let f=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(f){const d={value:f.key,done:!1};return f=f.next,d}else return{value:void 0,done:!0}}};return l}values(){const r=this,i=this._state;let f=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(f){const d={value:f.value,done:!1};return f=f.next,d}else return{value:void 0,done:!0}}};return l}entries(){const r=this,i=this._state;let f=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(f){const d={value:[f.key,f.value],done:!1};return f=f.next,d}else return{value:void 0,done:!0}}};return l}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,f=this.size;for(;i&&f>r;)this._map.delete(i.key),i=i.next,f--;this._head=i,this._size=f,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,f=r.previous;if(!i||!f)throw new Error("Invalid list");i.previous=f,f.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const f=r.next,l=r.previous;r===this._tail?(l.next=void 0,this._tail=l):(f.previous=l,l.next=f),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const f=r.next,l=r.previous;r===this._head?(f.previous=void 0,this._head=f):(f.previous=l,l.next=f),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,f)=>{r.push([f,i])}),r}fromJSON(r){this.clear();for(const[i,f]of r)this.set(i,f)}}e.LinkedMap=a;class p extends a{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=p;class t{constructor(r){E.set(this,void 0),nt(this,E,r,"f")}get size(){return Oe(this,E,"f").size}forEach(r,i){Oe(this,E,"f").forEach(r,i)}get(r){return Oe(this,E,"f").get(r)}has(r){return Oe(this,E,"f").has(r)}entries(){return Oe(this,E,"f").entries()}keys(){return Oe(this,E,"f").keys()}values(){return Oe(this,E,"f").values()}[(E=new WeakMap,Symbol.iterator)](){return Oe(this,E,"f").entries()}}e.ReadonlyMapView=t}),define(me[98],ge([0,1,24,9]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...J){return function(oe,ve){for(let Me=0,qe=J.length;Me<qe;Me++){const Ke=J[Me](oe,ve);if(Ke)return Ke}return null}}e.or=I,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(J,oe,ve){if(!ve||ve.length<oe.length)return null;let Me;return J?Me=L.startsWithIgnoreCase(ve,oe):Me=ve.indexOf(oe)===0,Me?oe.length>0?[{start:0,end:oe.length}]:[]:null}function R(J,oe){const ve=oe.toLowerCase().indexOf(J.toLowerCase());return ve===-1?null:[{start:ve,end:ve+J.length}]}e.matchesContiguousSubString=R;function E(J,oe){return S(J.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=E;function S(J,oe,ve,Me){if(ve===J.length)return[];if(Me===oe.length)return null;if(J[ve]===oe[Me]){let qe=null;return(qe=S(J,oe,ve+1,Me+1))?k({start:Me,end:Me+1},qe):null}return S(J,oe,ve,Me+1)}function T(J){return 97<=J&&J<=122}function n(J){return 65<=J&&J<=90}e.isUpper=n;function P(J){return 48<=J&&J<=57}function c(J){return J===32||J===9||J===10||J===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(J=>m.add(J.charCodeAt(0)));function u(J){return c(J)||m.has(J)}function h(J,oe){return J===oe||u(J)&&u(oe)}function D(J){return T(J)||n(J)||P(J)}function k(J,oe){return oe.length===0?oe=[J]:J.end===oe[0].start?oe[0].start=J.start:oe.unshift(J),oe}function _(J,oe){for(let ve=oe;ve<J.length;ve++){const Me=J.charCodeAt(ve);if(n(Me)||P(Me)||ve>0&&!D(J.charCodeAt(ve-1)))return ve}return J.length}function o(J,oe,ve,Me){if(ve===J.length)return[];if(Me===oe.length)return null;if(J[ve]!==oe[Me].toLowerCase())return null;{let qe=null,Ke=Me+1;for(qe=o(J,oe,ve+1,Me+1);!qe&&(Ke=_(oe,Ke))<oe.length;)qe=o(J,oe,ve+1,Ke),Ke++;return qe===null?null:k({start:Me,end:Me+1},qe)}}function a(J){let oe=0,ve=0,Me=0,qe=0,Ke=0;for(let pe=0;pe<J.length;pe++)Ke=J.charCodeAt(pe),n(Ke)&&oe++,T(Ke)&&ve++,D(Ke)&&Me++,P(Ke)&&qe++;const Se=oe/J.length,tt=ve/J.length,Z=Me/J.length,te=qe/J.length;return{upperPercent:Se,lowerPercent:tt,alphaPercent:Z,numericPercent:te}}function p(J){const{upperPercent:oe,lowerPercent:ve}=J;return ve===0&&oe>.6}function t(J){const{upperPercent:oe,lowerPercent:ve,alphaPercent:Me,numericPercent:qe}=J;return ve>.2&&oe<.8&&Me>.6&&qe<.2}function s(J){let oe=0,ve=0,Me=0,qe=0;for(let Ke=0;Ke<J.length;Ke++)Me=J.charCodeAt(Ke),n(Me)&&oe++,T(Me)&&ve++,c(Me)&&qe++;return(oe===0||ve===0)&&qe===0?J.length<=30:oe<=5}function r(J,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!s(J)||oe.length>60)return null;const ve=a(oe);if(!t(ve)){if(!p(ve))return null;oe=oe.toLowerCase()}let Me=null,qe=0;for(J=J.toLowerCase();qe<oe.length&&(Me=o(J,oe,0,qe))===null;)qe=_(oe,qe+1);return Me}e.matchesCamelCase=r;function i(J,oe,ve=!1){if(!oe||oe.length===0)return null;let Me=null,qe=0;for(J=J.toLowerCase(),oe=oe.toLowerCase();qe<oe.length&&(Me=f(J,oe,0,qe,ve))===null;)qe=l(oe,qe+1);return Me}e.matchesWords=i;function f(J,oe,ve,Me,qe){if(ve===J.length)return[];if(Me===oe.length)return null;if(h(J.charCodeAt(ve),oe.charCodeAt(Me))){let Ke=null,Se=Me+1;if(Ke=f(J,oe,ve+1,Me+1,qe),!qe)for(;!Ke&&(Se=l(oe,Se))<oe.length;)Ke=f(J,oe,ve+1,Se,qe),Se++;return Ke===null?null:k({start:Me,end:Me+1},Ke)}else return null}function l(J,oe){for(let ve=oe;ve<J.length;ve++)if(u(J.charCodeAt(ve))||ve>0&&u(J.charCodeAt(ve-1)))return ve;return J.length}const d=I(e.matchesPrefix,r,R),b=I(e.matchesPrefix,r,E),y=new g.LRUCache(1e4);function v(J,oe,ve=!1){if(typeof J!="string"||typeof oe!="string")return null;let Me=y.get(J);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(J),"i"),y.set(J,Me));const qe=Me.exec(oe);return qe?[{start:qe.index,end:qe.index+qe[0].length}]:ve?b(J,oe):d(J,oe)}e.matchesFuzzy=v;function A(J,oe){const ve=We(J,J.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return ve?F(ve):null}e.matchesFuzzy2=A;function w(J,oe,ve,Me,qe,Ke){const Se=Math.min(13,J.length);for(;ve<Se;ve++){const tt=We(J,oe,ve,Me,qe,Ke,!1);if(tt)return tt}return[0,Ke]}e.anyScore=w;function F(J){if(typeof J=="undefined")return[];const oe=[],ve=J[1];for(let Me=J.length-1;Me>1;Me--){const qe=J[Me]+ve,Ke=oe[oe.length-1];Ke&&Ke.end===qe?Ke.end=qe+1:oe.push({start:qe,end:qe+1})}return oe}e.createMatches=F;const O=128;function G(){const J=[],oe=[];for(let ve=0;ve<=O;ve++)oe[ve]=0;for(let ve=0;ve<=O;ve++)J.push(oe.slice(0));return J}function K(J){const oe=[];for(let ve=0;ve<=J;ve++)oe[ve]=0;return oe}const U=K(2*O),z=K(2*O),N=G(),B=G(),x=G(),M=!1;function H(J,oe,ve,Me,qe){function Ke(tt,Z,te=" "){for(;tt.length<Z;)tt=te+tt;return tt}let Se=` |   |${Me.split("").map(tt=>Ke(tt,3)).join("|")}
`;for(let tt=0;tt<=ve;tt++)tt===0?Se+=" |":Se+=`${oe[tt-1]}|`,Se+=J[tt].slice(0,qe+1).map(Z=>Ke(Z.toString(),3)).join("|")+`
`;return Se}function $(J,oe,ve,Me){J=J.substr(oe),ve=ve.substr(Me),console.log(H(B,J,J.length,ve,ve.length)),console.log(H(x,J,J.length,ve,ve.length)),console.log(H(N,J,J.length,ve,ve.length))}function Q(J,oe){if(oe<0||oe>=J.length)return!1;const ve=J.codePointAt(oe);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(ve)}}function X(J,oe){if(oe<0||oe>=J.length)return!1;switch(J.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function he(J,oe,ve){return oe[J]!==ve[J]}function _e(J,oe,ve,Me,qe,Ke,Se=!1){for(;oe<ve&&qe<Ke;)J[oe]===Me[qe]&&(Se&&(U[oe]=qe),oe+=1),qe+=1;return oe===ve}e.isPatternInWord=_e;var ye;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var Re;(function(J){J.Default=[-100,0];function oe(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}J.isDefault=oe})(Re=e.FuzzyScore||(e.FuzzyScore={}));function We(J,oe,ve,Me,qe,Ke,Se){const tt=J.length>O?O:J.length,Z=Me.length>O?O:Me.length;if(ve>=tt||Ke>=Z||tt-ve>Z-Ke||!_e(oe,ve,tt,qe,Ke,Z,!0))return;Be(tt,Z,ve,Ke,oe,qe);let te=1,pe=1,xe=ve,Ye=Ke;const rt=[!1];for(te=1,xe=ve;xe<tt;te++,xe++){const ue=U[xe],Ie=z[xe],Ue=xe+1<tt?z[xe+1]:Z;for(pe=ue-Ke+1,Ye=ue;Ye<Ue;pe++,Ye++){let Qe=Number.MIN_SAFE_INTEGER,ze=!1;Ye<=Ie&&(Qe=je(J,oe,xe,ve,Me,qe,Ye,Z,Ke,N[te-1][pe-1]===0,rt));let at=0;Qe!==Number.MAX_SAFE_INTEGER&&(ze=!0,at=Qe+B[te-1][pe-1]);const Le=Ye>ue,De=Le?B[te][pe-1]+(N[te][pe-1]>0?-5:0):0,ke=Ye>ue+1&&N[te][pe-1]>0,ne=ke?B[te][pe-2]+(N[te][pe-2]>0?-5:0):0;if(ke&&(!Le||ne>=De)&&(!ze||ne>=at))B[te][pe]=ne,x[te][pe]=3,N[te][pe]=0;else if(Le&&(!ze||De>=at))B[te][pe]=De,x[te][pe]=2,N[te][pe]=0;else if(ze)B[te][pe]=at,x[te][pe]=1,N[te][pe]=N[te-1][pe-1]+1;else throw new Error("not possible")}}if(M&&$(J,ve,Me,Ke),!rt[0]&&!Se)return;te--,pe--;const ft=[B[te][pe],Ke];let pt=0,St=0;for(;te>=1;){let ue=pe;do{const Ie=x[te][ue];if(Ie===3)ue=ue-2;else if(Ie===2)ue=ue-1;else break}while(ue>=1);pt>1&&oe[ve+te-1]===qe[Ke+pe-1]&&!he(ue+Ke-1,Me,qe)&&pt+1>N[te][ue]&&(ue=pe),ue===pe?pt++:pt=1,St||(St=ue),te--,pe=ue-1,ft.push(pe)}Z===tt&&(ft[0]+=2);const Ct=St-tt;return ft[0]-=Ct,ft}e.fuzzyScore=We;function Be(J,oe,ve,Me,qe,Ke){let Se=J-1,tt=oe-1;for(;Se>=ve&&tt>=Me;)qe[Se]===Ke[tt]&&(z[Se]=tt,Se--),tt--}function je(J,oe,ve,Me,qe,Ke,Se,tt,Z,te,pe){if(oe[ve]!==Ke[Se])return Number.MIN_SAFE_INTEGER;let xe=1,Ye=!1;return Se===ve-Me?xe=J[ve]===qe[Se]?7:5:he(Se,qe,Ke)&&(Se===0||!he(Se-1,qe,Ke))?(xe=J[ve]===qe[Se]?7:5,Ye=!0):Q(Ke,Se)&&(Se===0||!Q(Ke,Se-1))?xe=5:(Q(Ke,Se-1)||X(Ke,Se-1))&&(xe=5,Ye=!0),xe>1&&ve===Me&&(pe[0]=!0),Ye||(Ye=he(Se,qe,Ke)||Q(Ke,Se-1)||X(Ke,Se-1)),ve===Me?Se>Z&&(xe-=Ye?3:5):te?xe+=Ye?2:0:xe+=Ye?0:1,Se+1===tt&&(xe-=Ye?3:5),xe}function V(J,oe,ve,Me,qe,Ke,Se){return re(J,oe,ve,Me,qe,Ke,!0,Se)}e.fuzzyScoreGracefulAggressive=V;function ee(J,oe,ve,Me,qe,Ke,Se){return re(J,oe,ve,Me,qe,Ke,!1,Se)}e.fuzzyScoreGraceful=ee;function re(J,oe,ve,Me,qe,Ke,Se,tt){let Z=We(J,oe,ve,Me,qe,Ke,tt);if(Z&&!Se)return Z;if(J.length>=3){const te=Math.min(7,J.length-1);for(let pe=ve+1;pe<te;pe++){const xe=ae(J,pe);if(xe){const Ye=We(xe,xe.toLowerCase(),ve,Me,qe,Ke,tt);Ye&&(Ye[0]-=3,(!Z||Ye[0]>Z[0])&&(Z=Ye))}}}return Z}function ae(J,oe){if(oe+1>=J.length)return;const ve=J[oe],Me=J[oe+1];if(ve!==Me)return J.slice(0,oe)+Me+ve+J.slice(oe+2)}}),define(me[142],ge([0,1,47,98,9]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${C.source}`,"g");function E(h){return h.replace(R,(D,k)=>k?D:`\\${D}`)}e.escapeIcons=E;const S=new RegExp(`\\\\${C.source}`,"g");function T(h){return h.replace(S,D=>`\\${D}`)}e.markdownEscapeEscapedIcons=T;const n=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function P(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(n,(D,k,_,o)=>_?D:k||o||"")}e.stripIcons=P;function c(h){const D=h.indexOf(e.iconStartMarker);return D===-1?{text:h}:m(h,D)}e.parseLabelWithIcons=c;function m(h,D){const k=[];let _="";function o(l){if(l){_+=l;for(const d of l)k.push(t)}}let a=-1,p="",t=0,s,r,i=D;const f=h.length;for(o(h.substr(0,D));i<f;)s=h[i],r=h[i+1],s===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(a=i,o(p),p=e.iconStartMarker,i++):s===")"&&a!==-1?(t+=i-a+1,a=-1,p=""):a!==-1?/^[a-z0-9\-]$/i.test(s)?p+=s:(o(p),a=-1,p=""):o(s),i++;return o(p),{text:_,iconOffsets:k}}function u(h,D,k=!1){const{text:_,iconOffsets:o}=D;if(!o||o.length===0)return(0,L.matchesFuzzy)(h,_,k);const a=(0,I.ltrim)(_," "),p=_.length-a.length,t=(0,L.matchesFuzzy)(h,a,k);if(t)for(const s of t){const r=o[s.start+p]+p;s.start+=r,s.end+=r}return t}e.matchesFuzzyIconAware=u}),define(me[99],ge([0,1,16,142]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(m="",u=!1){if(this.value=m,typeof this.value!="string")throw(0,g.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1,this.supportHtml=u.supportHtml??!1)}appendText(m,u=0){return this.value+=T(this.supportThemeIcons?(0,L.escapeIcons)(m):m).replace(/([ \t]+)/g,(h,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,u){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}}e.MarkdownString=C;function R(c){return E(c)?!c.value:Array.isArray(c)?c.every(R):!0}e.isEmptyMarkdownString=R;function E(c){return c instanceof C?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=E;function S(c,m){return c===m?!0:!c||!m?!1:c.value===m.value&&c.isTrusted===m.isTrusted&&c.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=S;function T(c){return c.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function n(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function P(c){const m=[],u=c.split("|").map(D=>D.trim());c=u[0];const h=u[1];if(h){const D=/height=(\d+)/.exec(h),k=/width=(\d+)/.exec(h),_=D?D[1]:"",o=k?k[1]:"",a=isFinite(parseInt(o)),p=isFinite(parseInt(_));a&&m.push(`width="${o}"`),p&&m.push(`height="${_}"`)}return{href:c,dimensions:m}}e.parseHrefAndDimensions=P}),define(me[60],ge([0,1,23,9,2]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(n){return JSON.stringify(n,S)}e.stringify=C;function R(n){let P=JSON.parse(n);return P=T(P),P}e.parse=R;var E;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(E=e.MarshalledId||(e.MarshalledId={}));function S(n,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,L.regExpFlags)(P)}:P}function T(n,P=0){if(!n||P>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return I.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof g.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let c=0;c<n.length;++c)n[c]=T(n[c],P+1);else for(const c in n)Object.hasOwnProperty.call(n,c)&&(n[c]=T(n[c],P+1))}return n}e.revive=T}),define(me[10],ge([0,1,11,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var I;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.userData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp"})(I=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,T,n){this._hosts[S]=T,this._ports[S]=n}setConnectionToken(S,T){this._connectionTokens[S]=T}rewrite(S){if(this._delegate)return this._delegate(S);const T=S.authority;let n=this._hosts[T];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const P=this._ports[T],c=this._connectionTokens[T];let m=`path=${encodeURIComponent(S.path)}`;return typeof c=="string"&&(m+=`&tkn=${encodeURIComponent(c)}`),L.URI.from({scheme:g.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${n}:${P}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new C;class R{asBrowserUri(S,T){const n=this.toUri(S,T);return n.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===I.file&&(g.isNative||typeof g.globals.importScripts=="function"&&g.globals.origin===`${I.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?n.with({scheme:I.vscodeFileResource,authority:n.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(S,T){const n=this.toUri(S,T);return n.scheme===I.vscodeFileResource?n.with({scheme:I.file,authority:n.authority!==R.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(S,T){return L.URI.isUri(S)?S:L.URI.parse(T.toUrl(S))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(me[78],ge([0,1,24]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new g.LRUCache(1e4);function I(T){return S(T,"NFC",L)}e.normalizeNFC=I;const C=new g.LRUCache(1e4);function R(T){return S(T,"NFD",C)}e.normalizeNFD=R;const E=/[^\u0000-\u0080]/;function S(T,n,P){if(!T)return T;const c=P.get(T);if(c)return c;let m;return E.test(T)?m=T.normalize(n):m=T,P.set(T,m),m}e.removeAccents=function(){const T=/[\u0300-\u036f]/g;return function(n){return R(n).replace(T,"")}}()}),define(me[22],ge([0,1,29,10,8,11,9,2]),function(Y,e,g,L,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(m){return(0,E.uriToFsPath)(m,!0)}e.originalFSPath=S;class T{constructor(u){this._ignorePathCasing=u}compare(u,h,D=!1){return u===h?0:(0,R.compare)(this.getComparisonKey(u,D),this.getComparisonKey(h,D))}isEqual(u,h,D=!1){return u===h?!0:!u||!h?!1:this.getComparisonKey(u,D)===this.getComparisonKey(h,D)}getComparisonKey(u,h=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,h,D=!1){if(u.scheme===h.scheme){if(u.scheme===L.Schemas.file)return g.isEqualOrParent(S(u),S(h),this._ignorePathCasing(u))&&u.query===h.query&&(D||u.fragment===h.fragment);if((0,e.isEqualAuthority)(u.authority,h.authority))return g.isEqualOrParent(u.path,h.path,this._ignorePathCasing(u),"/")&&u.query===h.query&&(D||u.fragment===h.fragment)}return!1}joinPath(u,...h){return E.URI.joinPath(u,...h)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return I.posix.basename(u.path)}extname(u){return I.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let h;return u.scheme===L.Schemas.file?h=E.URI.file(I.dirname(S(u))).path:(h=I.posix.dirname(u.path),u.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),h="/")),u.with({path:h})}normalizePath(u){if(!u.path.length)return u;let h;return u.scheme===L.Schemas.file?h=E.URI.file(I.normalize(S(u))).path:h=I.posix.normalize(u.path),u.with({path:h})}relativePath(u,h){if(u.scheme!==h.scheme||!(0,e.isEqualAuthority)(u.authority,h.authority))return;if(u.scheme===L.Schemas.file){const _=I.relative(S(u),S(h));return C.isWindows?g.toSlashes(_):_}let D=u.path||"/",k=h.path||"/";if(this._ignorePathCasing(u)){let _=0;for(const o=Math.min(D.length,k.length);_<o&&!(D.charCodeAt(_)!==k.charCodeAt(_)&&D.charAt(_).toLowerCase()!==k.charAt(_).toLowerCase());_++);D=k.substr(0,_)+D.substr(_)}return I.posix.relative(D,k)}resolvePath(u,h){if(u.scheme===L.Schemas.file){const D=E.URI.file(I.resolve(S(u),h));return u.with({authority:D.authority,path:D.path})}return h=g.toPosixPath(h),u.with({path:I.posix.resolve(u.path,h)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,h){return u===h||(0,R.equalsIgnoreCase)(u,h)}hasTrailingPathSeparator(u,h=I.sep){if(u.scheme===L.Schemas.file){const D=S(u);return D.length>g.getRoot(D).length&&D[D.length-1]===h}else{const D=u.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,h=I.sep){return(0,e.hasTrailingPathSeparator)(u,h)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,h=I.sep){let D=!1;if(u.scheme===L.Schemas.file){const k=S(u);D=k!==void 0&&k.length===g.getRoot(k).length&&k[k.length-1]===h}else{h="/";const k=u.path;D=k.length===1&&k.charCodeAt(k.length-1)===47}return!D&&!(0,e.hasTrailingPathSeparator)(u,h)?u.with({path:u.path+"/"}):u}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(m=>m.scheme===L.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new T(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(m,u){const h=[];for(let D=0;D<m.length;D++){const k=u(m[D]);m.some((_,o)=>o===D?!1:(0,e.isEqualOrParent)(k,u(_)))||h.push(m[D])}return h}e.distinctParents=n;var P;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function u(h){const D=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(o=>{const[a,p]=o.split(":");a&&p&&D.set(a,p)});const _=h.path.substring(0,h.path.indexOf(";"));return _&&D.set(m.META_DATA_MIME,_),D}m.parseMetaData=u})(P=e.DataUri||(e.DataUri={}));function c(m,u,h){if(u){let D=m.path;return D&&D[0]!==I.posix.sep&&(D=I.posix.sep+D),m.with({scheme:h,authority:u,path:D})}return m.with({scheme:h})}e.toLocalResource=c}),define(me[18],ge([0,1,21,16,3,6,22]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(N){return!!N&&typeof N.then=="function"}e.isThenable=E;function S(N){const B=new g.CancellationTokenSource,x=N(B.token),M=new Promise((H,$)=>{const Q=B.token.onCancellationRequested(()=>{Q.dispose(),B.dispose(),$((0,L.canceled)())});Promise.resolve(x).then(X=>{Q.dispose(),B.dispose(),H(X)},X=>{Q.dispose(),B.dispose(),$(X)})});return new class{cancel(){B.cancel()}then(H,$){return M.then(H,$)}catch(H){return this.then(void 0,H)}finally(H){return M.finally(H)}}}e.createCancelablePromise=S;function T(N,B,x){return Promise.race([N,new Promise(M=>B.onCancellationRequested(()=>M(x)))])}e.raceCancellation=T;async function n(N){let B=-1;const x=N.map((H,$)=>H.then(Q=>(B=$,Q))),M=await Promise.race(x);return N.forEach((H,$)=>{$!==B&&H.cancel()}),M}e.raceCancellablePromises=n;function P(N,B,x){let M;const H=setTimeout(()=>{M?.(void 0),x?.()},B);return Promise.race([N.finally(()=>clearTimeout(H)),new Promise($=>M=$)])}e.raceTimeout=P;function c(N){return new Promise((B,x)=>{const M=N();E(M)?M.then(B,x):B(M)})}e.asPromise=c;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const M=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,M};this.queuedPromise=new Promise(M=>{this.activePromise.then(x,x).then(M)})}return new Promise((x,M)=>{this.queuedPromise.then(x,M)})}return this.activePromise=B(),new Promise((x,M)=>{this.activePromise.then(H=>{this.activePromise=null,x(H)},H=>{this.activePromise=null,M(H)})})}}e.Throttler=m;class u{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=u;class h{constructor(){this.promiseMap=new Map}queue(B,x){const H=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(B)===H&&this.promiseMap.delete(B)});return this.promiseMap.set(B,H),H}}e.SequencerByKey=h;class D{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,x=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((M,H)=>{this.doResolve=M,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const M=this.task;return this.task=null,M()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=D;class k{constructor(B){this.delayer=new D(B),this.throttler=new m}trigger(B,x){return this.delayer.trigger(()=>this.throttler.queue(B),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=k;class _{constructor(){this._isOpen=!1,this._promise=new Promise((B,x)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=_;class o extends _{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function a(N,B){return B?new Promise((x,M)=>{const H=setTimeout(()=>{$.dispose(),x()},N),$=B.onCancellationRequested(()=>{clearTimeout(H),$.dispose(),M((0,L.canceled)())})}):S(x=>a(N,x))}e.timeout=a;function p(N,B=0){const x=setTimeout(N,B);return(0,C.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=p;function t(N){const B=[];let x=0;const M=N.length;function H(){return x<M?N[x++]():null}function $(Q){Q!=null&&B.push(Q);const X=H();return X?X.then($):Promise.resolve(B)}return Promise.resolve(null).then($)}e.sequence=t;function s(N,B=M=>!!M,x=null){let M=0;const H=N.length,$=()=>{if(M>=H)return Promise.resolve(x);const Q=N[M++];return Promise.resolve(Q()).then(he=>B(he)?Promise.resolve(he):$())};return $()}e.first=s;function r(N,B=M=>!!M,x=null){if(N.length===0)return Promise.resolve(x);let M=N.length;const H=()=>{M=-1;for(const $ of N)$.cancel?.()};return new Promise(($,Q)=>{for(const X of N)X.then(he=>{--M>=0&&B(he)?(H(),$(he)):M===0&&$(x)}).catch(he=>{--M>=0&&(H(),Q(he))})})}e.firstParallel=r;class i{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((x,M)=>{this.outstandingPromises.push({factory:B,c:x,e:M}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const x=B.factory();x.then(B.c,B.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class f extends i{constructor(){super(1)}}e.Queue=f;class l{constructor(){this.queues=new Map}queueFor(B,x=R.extUri){const M=x.getComparisonKey(B);let H=this.queues.get(M);return H||(H=new f,I.Event.once(H.onFinished)(()=>{H?.dispose(),this.queues.delete(M)}),this.queues.set(M,H)),H}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=l;class d{constructor(B,x){this._token=-1,typeof B=="function"&&typeof x=="number"&&this.setIfNotSet(B,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},x)}setIfNotSet(B,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},x))}}e.TimeoutTimer=d;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,x){this.cancel(),this._token=setInterval(()=>{B()},x)}}e.IntervalTimer=b;class y{constructor(B,x){this.timeoutToken=-1,this.runner=B,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=y;class v{constructor(B,x){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=x,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=v;class A extends y{constructor(B,x){super(B,x);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=A;class w extends C.Disposable{constructor(B,x,M,H){super();this.maxWorkChunkSize=B,this.maxPendingWork=x,this.throttleDelay=M,this.handler=H,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new y(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=w,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=B=>{const x=setTimeout(()=>B(N));let M=!1;return{dispose(){M||(M=!0,clearTimeout(x))}}}}else e.runWhenIdle=(N,B)=>{const x=requestIdleCallback(N,typeof B=="number"?{timeout:B}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(x))}}}}();class F{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function O(N,B,x){let M;for(let H=0;H<x;H++)try{return await N()}catch($){M=$,await a(B)}throw M}e.retry=O;class G{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,x,M){return this._pending={taskId:B,cancel:()=>M?.(),promise:x},x.then(()=>this.donePending(B),()=>this.donePending(B)),x}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let x,M;const H=new Promise(($,Q)=>{x=$,M=Q});this._next={run:B,promise:H,promiseResolve:x,promiseReject:M}}return this._next.promise}}e.TaskSequentializer=G;class K{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,x)=>{this.completeCallback=B,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(x=>{this.completeCallback(B),this.resolved=!0,x()})}error(B){return new Promise(x=>{this.errorCallback(B),this.rejected=!0,x()})}cancel(){new Promise(B=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=U;var z;(function(N){async function B(x){let M;const H=await Promise.all(x.map($=>$.then(Q=>Q,Q=>{M||(M=Q)})));if(typeof M!="undefined")throw M;return H}N.settled=B})(z=e.Promises||(e.Promises={}))}),define(me[100],ge([0,1,18,8]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new g.IdleValue(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),C=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function E(y,v,A=!1){const w=y||"",F=v||"",O=I.value.collator.compare(w,F);return I.value.collatorIsNumeric&&O===0&&w!==F?w<F?-1:1:O}e.compareFileNames=E;function S(y,v){const A=C.value.collator;return y=y||"",v=v||"",p(A,y,v)}e.compareFileNamesDefault=S;function T(y,v){const A=C.value.collator;return y=y||"",v=v||"",i(y,v)||p(A,y,v)}e.compareFileNamesUpper=T;function n(y,v){const A=C.value.collator;return y=y||"",v=v||"",r(y,v)||p(A,y,v)}e.compareFileNamesLower=n;function P(y,v){return y=y||"",v=v||"",y===v?0:y<v?-1:1}e.compareFileNamesUnicode=P;function c(y,v,A=!1){A||(y=y&&y.toLowerCase(),v=v&&v.toLowerCase());const[w,F]=o(y),[O,G]=o(v);return w!==O?w<O?-1:1:F===G?0:F<G?-1:1}e.noIntlCompareFileNames=c;function m(y,v){const[A,w]=o(y),[F,O]=o(v);let G=I.value.collator.compare(w,O);if(G===0){if(I.value.collatorIsNumeric&&w!==O)return w<O?-1:1;if(G=I.value.collator.compare(A,F),I.value.collatorIsNumeric&&G===0&&A!==F)return A<F?-1:1}return G}e.compareFileExtensions=m;function u(y,v){y=y||"",v=v||"";const A=a(y),w=a(v),F=C.value.collator,O=R.value.collator;return p(O,A,w)||p(F,y,v)}e.compareFileExtensionsDefault=u;function h(y,v){y=y||"",v=v||"";const A=a(y),w=a(v),F=C.value.collator,O=R.value.collator;return p(O,A,w)||i(y,v)||p(F,y,v)}e.compareFileExtensionsUpper=h;function D(y,v){y=y||"",v=v||"";const A=a(y),w=a(v),F=C.value.collator,O=R.value.collator;return p(O,A,w)||r(y,v)||p(F,y,v)}e.compareFileExtensionsLower=D;function k(y,v){y=y||"",v=v||"";const A=a(y).toLowerCase(),w=a(v).toLowerCase();return A!==w?A<w?-1:1:y!==v?y<v?-1:1:0}e.compareFileExtensionsUnicode=k;const _=/^(.*?)(\.([^.]*))?$/;function o(y,v=!1){const A=y?_.exec(y):[];let w=[A&&A[1]||"",A&&A[3]||""];return v&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function a(y){const v=y?_.exec(y):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function p(y,v,A){let w=y.compare(v,A);return w!==0?w:v.length!==A.length?v.length<A.length?-1:1:0}function t(y){const v=y.charAt(0);return v.toLocaleUpperCase()!==v}function s(y){const v=y.charAt(0);return v.toLocaleLowerCase()!==v}function r(y,v){return t(y)&&s(v)?-1:s(y)&&t(v)?1:0}function i(y,v){return s(y)&&t(v)?-1:t(y)&&s(v)?1:0}function f(y,v,A=!1){return A||(y=y&&y.toLowerCase(),v=v&&v.toLowerCase()),y===v?0:y<v?-1:1}function l(y,v,A=!1){const w=y.split(L.sep),F=v.split(L.sep),O=w.length-1,G=F.length-1;let K,U;for(let z=0;;z++){if(K=O===z,U=G===z,K&&U)return E(w[z],F[z],A);if(K)return-1;if(U)return 1;const N=f(w[z],F[z],A);if(N!==0)return N}}e.comparePaths=l;function d(y,v,A){const w=y.toLowerCase(),F=v.toLowerCase(),O=b(y,v,A);if(O)return O;const G=w.endsWith(A),K=F.endsWith(A);if(G!==K)return G?-1:1;const U=E(w,F);return U!==0?U:w.localeCompare(F)}e.compareAnything=d;function b(y,v,A){const w=y.toLowerCase(),F=v.toLowerCase(),O=w.startsWith(A),G=F.startsWith(A);if(O!==G)return O?-1:1;if(O&&G){if(w.length<F.length)return-1;if(w.length>F.length)return 1}return 0}e.compareByPrefix=b}),define(me[101],ge([0,1,100,98,48,8,11,9]),function(Y,e,g,L,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,T=[S,[]];function n(N,B,x,M){if(!N||!B)return T;const H=N.length,$=B.length;if(H<$)return T;const Q=N.toLowerCase();return P(B,x,$,N,Q,H,M)}e.scoreFuzzy=n;function P(N,B,x,M,H,$,Q){const X=[],he=[];for(let We=0;We<x;We++){const Be=We*$,je=Be-$,V=We>0,ee=N[We],re=B[We];for(let ae=0;ae<$;ae++){const J=ae>0,oe=Be+ae,ve=oe-1,Me=je+ae-1,qe=J?X[ve]:0,Ke=V&&J?X[Me]:0,Se=V&&J?he[Me]:0;let tt;!Ke&&V?tt=0:tt=c(ee,re,M,H,ae,Se),tt&&Ke+tt>=qe&&(Q||V||H.startsWith(B,ae))?(he[oe]=Se+1,X[oe]=Ke+tt):(he[oe]=S,X[oe]=qe)}}const _e=[];let ye=x-1,Re=$-1;for(;ye>=0&&Re>=0;){const We=ye*$+Re;he[We]===S||(_e.push(Re),ye--),Re--}return[X[x*$-1],_e.reverse()]}function c(N,B,x,M,H,$){let Q=0;if(!m(B,M[H]))return Q;if(Q+=1,$>0&&(Q+=$*5),N===x[H]&&(Q+=1),H===0)Q+=8;else{const X=u(x.charCodeAt(H-1));X?Q+=X:(0,L.isUpper)(x.charCodeAt(H))&&(Q+=2)}return Q}function m(N,B){return N===B?!0:N==="/"||N==="\\"?B==="/"||B==="\\":!1}function u(N){switch(N){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function D(N,B,x=0,M=0){const H=B;return H.values&&H.values.length>1?k(N,H.values,x,M):_(N,B,x,M)}e.scoreFuzzy2=D;function k(N,B,x,M){let H=0;const $=[];for(const Q of B){const[X,he]=_(N,Q,x,M);if(typeof X!="number")return h;H+=X,$.push(...he)}return[H,b($)]}function _(N,B,x,M){const H=(0,L.fuzzyScore)(B.original,B.originalLowercase,x,N,N.toLowerCase(),M,!0);return H?[H[0],(0,L.createMatches)(H)]:h}const o=Object.freeze({score:0}),a=1<<18,p=1<<17,t=1<<16;function s(N,B,x,M){const H=M.values?M.values:[M];return(0,I.hash)({[M.normalized]:{values:H.map(Q=>({value:Q.normalized,expectContiguousMatch:Q.expectContiguousMatch})),label:N,description:B,allowNonContiguousMatches:x}})}function r(N,B,x,M,H){if(!N||!B.normalized)return o;const $=M.getItemLabel(N);if(!$)return o;const Q=M.getItemDescription(N),X=s($,Q,x,B),he=H[X];if(he)return he;const _e=i($,Q,M.getItemPath(N),B,x);return H[X]=_e,_e}e.scoreItemFuzzy=r;function i(N,B,x,M,H){const $=!x||!M.containsPathSeparator;return x&&(R.isLinux?M.pathNormalized===x:(0,E.equalsIgnoreCase)(M.pathNormalized,x))?{score:a,labelMatch:[{start:0,end:N.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:M.values&&M.values.length>1?f(N,B,x,M.values,$,H):l(N,B,x,M,$,H)}function f(N,B,x,M,H,$){let Q=0;const X=[],he=[];for(const _e of M){const{score:ye,labelMatch:Re,descriptionMatch:We}=l(N,B,x,_e,H,$);if(ye===S)return o;Q+=ye,Re&&X.push(...Re),We&&he.push(...We)}return{score:Q,labelMatch:b(X),descriptionMatch:b(he)}}function l(N,B,x,M,H,$){if(H||!B){const[Q,X]=n(N,M.normalized,M.normalizedLowercase,$&&!M.expectContiguousMatch);if(Q){const he=(0,L.matchesPrefix)(M.normalized,N);let _e;return he?(_e=p,_e+=Math.round(M.normalized.length/N.length*100)):_e=t,{score:_e+Q,labelMatch:he||d(X)}}}if(B){let Q=B;x&&(Q=`${B}${C.sep}`);const X=Q.length,he=`${Q}${N}`,[_e,ye]=n(he,M.normalized,M.normalizedLowercase,$&&!M.expectContiguousMatch);if(_e){const Re=d(ye),We=[],Be=[];return Re.forEach(je=>{je.start<X&&je.end>X?(We.push({start:0,end:je.end-X}),Be.push({start:je.start,end:X})):je.start>=X?We.push({start:je.start-X,end:je.end-X}):Be.push(je)}),{score:_e,labelMatch:We,descriptionMatch:Be}}}return o}function d(N){const B=[];if(!N)return B;let x;for(const M of N)x&&x.end===M?x.end+=1:(x={start:M,end:M+1},B.push(x));return B}function b(N){const B=N.sort((H,$)=>H.start-$.start),x=[];let M;for(const H of B)!M||!y(M,H)?(M=H,x.push(H)):(M.start=Math.min(M.start,H.start),M.end=Math.max(M.end,H.end));return x}function y(N,B){return!(N.end<B.start||B.end<N.start)}function v(N,B,x,M,H,$){const Q=r(N,x,M,H,$),X=r(B,x,M,H,$),he=Q.score,_e=X.score;if((he===a||_e===a)&&he!==_e)return he===a?-1:1;if(he>t||_e>t){if(he!==_e)return he>_e?-1:1;if(he<p&&_e<p){const ee=w(Q.labelMatch,X.labelMatch);if(ee!==0)return ee}const je=H.getItemLabel(N)||"",V=H.getItemLabel(B)||"";if(je.length!==V.length)return je.length-V.length}if(he!==_e)return he>_e?-1:1;const ye=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0,Re=Array.isArray(X.labelMatch)&&X.labelMatch.length>0;if(ye&&!Re)return-1;if(Re&&!ye)return 1;const We=A(N,Q,H),Be=A(B,X,H);return We&&Be&&We!==Be?Be>We?-1:1:F(N,B,x,H)}e.compareItemsByFuzzyScore=v;function A(N,B,x){let M=-1,H=-1;if(B.descriptionMatch&&B.descriptionMatch.length?M=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(M=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(H=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const $=x.getItemDescription(N);$&&(H+=$.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(H=B.descriptionMatch[B.descriptionMatch.length-1].end);return H-M}function w(N,B){if(!N&&!B||(!N||!N.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!N||!N.length)return 1;const x=N[0].start,H=N[N.length-1].end-x,$=B[0].start,X=B[B.length-1].end-$;return H===X?0:X<H?1:-1}function F(N,B,x,M){const H=M.getItemLabel(N)||"",$=M.getItemLabel(B)||"",Q=M.getItemDescription(N),X=M.getItemDescription(B),he=H.length+(Q?Q.length:0),_e=$.length+(X?X.length:0);if(he!==_e)return he-_e;const ye=M.getItemPath(N),Re=M.getItemPath(B);return ye&&Re&&ye.length!==Re.length?ye.length-Re.length:H!==$?(0,g.compareAnything)(H,$,x.normalized):Q&&X&&Q!==X?(0,g.compareAnything)(Q,X,x.normalized):ye&&Re&&ye!==Re?(0,g.compareAnything)(ye,Re,x.normalized):0}function O(N){return N.startsWith('"')&&N.endsWith('"')}const G=" ";function K(N){typeof N!="string"&&(N="");const B=N.toLowerCase(),{pathNormalized:x,normalized:M,normalizedLowercase:H}=U(N),$=x.indexOf(C.sep)>=0,Q=O(N);let X;const he=N.split(G);if(he.length>1)for(const _e of he){const ye=O(_e),{pathNormalized:Re,normalized:We,normalizedLowercase:Be}=U(_e);We&&(X||(X=[]),X.push({original:_e,originalLowercase:_e.toLowerCase(),pathNormalized:Re,normalized:We,normalizedLowercase:Be,expectContiguousMatch:ye}))}return{original:N,originalLowercase:B,pathNormalized:x,normalized:M,normalizedLowercase:H,values:X,containsPathSeparator:$,expectContiguousMatch:Q}}e.prepareQuery=K;function U(N){let B;R.isWindows?B=N.replace(/\//g,C.sep):B=N.replace(/\\/g,C.sep);const x=(0,E.stripWildcards)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:x,normalizedLowercase:x.toLowerCase()}}function z(N){return Array.isArray(N)?K(N.map(B=>B.original).join(G)):K(N.original)}e.pieceToQuery=z}),define(me[30],ge([0,1,18,29,24,8,9]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function E(){return Object.create(null)}e.getEmptyExpression=E;const S="**",T="/",n="[/\\\\]",P="[^/\\\\]",c=/\//g;function m(M){switch(M){case 0:return"";case 1:return`${P}*?`;default:return`(?:${n}|${P}+${n}|${n}${P}+)*?`}}function u(M,H){if(!M)return[];const $=[];let Q=!1,X=!1,he="";for(const _e of M){switch(_e){case H:if(!Q&&!X){$.push(he),he="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":X=!0;break;case"]":X=!1;break}he+=_e}return he&&$.push(he),$}e.splitGlobAware=u;function h(M){if(!M)return"";let H="";const $=u(M,T);if($.every(Q=>Q===S))H=".*";else{let Q=!1;$.forEach((X,he)=>{if(X===S){Q||(H+=m(2),Q=!0);return}let _e=!1,ye="",Re=!1,We="";for(const Be of X){if(Be!=="}"&&_e){ye+=Be;continue}if(Re&&(Be!=="]"||!We)){let je;Be==="-"?je=Be:(Be==="^"||Be==="!")&&!We?je="^":Be===T?je="":je=R.escapeRegExpCharacters(Be),We+=je;continue}switch(Be){case"{":_e=!0;continue;case"[":Re=!0;continue;case"}":H+=`(?:${u(ye,",").map(ee=>h(ee)).join("|")})`,_e=!1,ye="";break;case"]":H+="["+We+"]",Re=!1,We="";break;case"?":H+=P;continue;case"*":H+=m(1);continue;default:H+=R.escapeRegExpCharacters(Be)}}he<$.length-1&&($[he+1]!==S||he+2<$.length)&&(H+=n),Q=!1})}return H}const D=/^\*\*\/\*\.[\w\.-]+$/,k=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.LRUCache(1e4),s=function(){return!1},r=function(){return null};function i(M,H){if(!M)return r;let $;typeof M!="string"?$=M.pattern:$=M,$=$.trim();const Q=`${$}_${!!H.trimForExclusions}`;let X=t.get(Q);if(X)return f(X,M);let he;if(D.test($)){const _e=$.substr(4);X=function(ye,Re){return typeof ye=="string"&&ye.endsWith(_e)?$:null}}else(he=k.exec(l($,H)))?X=d(he[1],$):(H.trimForExclusions?o:_).test($)?X=b($,H):(he=a.exec(l($,H)))?X=y(he[1].substr(1),$,!0):(he=p.exec(l($,H)))?X=y(he[1],$,!1):X=v($);return t.set(Q,X),f(X,M)}function f(M,H){return typeof H=="string"?M:function($,Q){return L.isEqualOrParent($,H.base)?M(C.relative(H.base,$),Q):null}}function l(M,H){return H.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function d(M,H){const $=`/${M}`,Q=`\\${M}`,X=function(_e,ye){return typeof _e!="string"?null:ye?ye===M?H:null:_e===M||_e.endsWith($)||_e.endsWith(Q)?H:null},he=[M];return X.basenames=he,X.patterns=[H],X.allBasenames=he,X}function b(M,H){const $=x(M.slice(1,-1).split(",").map(ye=>i(ye,H)).filter(ye=>ye!==r),M),Q=$.length;if(!Q)return r;if(Q===1)return $[0];const X=function(ye,Re){for(let We=0,Be=$.length;We<Be;We++)if($[We](ye,Re))return M;return null},he=$.find(ye=>!!ye.allBasenames);he&&(X.allBasenames=he.allBasenames);const _e=$.reduce((ye,Re)=>Re.allPaths?ye.concat(Re.allPaths):ye,[]);return _e.length&&(X.allPaths=_e),X}function y(M,H,$){const Q=C.sep===C.posix.sep,X=Q?M:M.replace(c,C.sep),he=C.sep+X,_e=C.posix.sep+M,ye=$?function(Re,We){return typeof Re=="string"&&(Re===X||Re.endsWith(he)||!Q&&(Re===M||Re.endsWith(_e)))?H:null}:function(Re,We){return typeof Re=="string"&&(Re===X||!Q&&Re===M)?H:null};return ye.allPaths=[($?"*/":"./")+M],ye}function v(M){try{const H=new RegExp(`^${h(M)}$`);return function($){return H.lastIndex=0,typeof $=="string"&&H.test($)?M:null}}catch(H){return r}}function A(M,H,$){return!M||typeof H!="string"?!1:w(M)(H,void 0,$)}e.match=A;function w(M,H={}){if(!M)return s;if(typeof M=="string"||K(M)){const $=i(M,H);if($===r)return s;const Q=function(X,he){return!!$(X,he)};return $.allBasenames&&(Q.allBasenames=$.allBasenames),$.allPaths&&(Q.allPaths=$.allPaths),Q}return N(M,H)}e.parse=w;function F(M){if(!M)return;let H;return $=>(H||(H=(M()||Promise.resolve([])).then(Q=>Q?G(Q):{})),H.then(Q=>!!Q[$]))}e.hasSiblingPromiseFn=F;function O(M){if(!M)return;let H;return $=>{if(!H){const Q=M();H=Q?G(Q):{}}return!!H[$]}}e.hasSiblingFn=O;function G(M){const H={};for(const $ of M)H[$]=!0;return H}function K(M){const H=M;return H&&typeof H.base=="string"&&typeof H.pattern=="string"}e.isRelativePattern=K;function U(M){return M.allBasenames||[]}e.getBasenameTerms=U;function z(M){return M.allPaths||[]}e.getPathTerms=z;function N(M,H){const $=x(Object.getOwnPropertyNames(M).map(ye=>B(ye,M[ye],H)).filter(ye=>ye!==r)),Q=$.length;if(!Q)return r;if(!$.some(ye=>!!ye.requiresSiblings)){if(Q===1)return $[0];const ye=function(Be,je){for(let V=0,ee=$.length;V<ee;V++){const re=$[V](Be,je);if(re)return re}return null},Re=$.find(Be=>!!Be.allBasenames);Re&&(ye.allBasenames=Re.allBasenames);const We=$.reduce((Be,je)=>je.allPaths?Be.concat(je.allPaths):Be,[]);return We.length&&(ye.allPaths=We),ye}const X=function(ye,Re,We){let Be;for(let je=0,V=$.length;je<V;je++){const ee=$[je];ee.requiresSiblings&&We&&(Re||(Re=C.basename(ye)),Be||(Be=Re.substr(0,Re.length-C.extname(ye).length)));const re=ee(ye,Re,Be,We);if(re)return re}return null},he=$.find(ye=>!!ye.allBasenames);he&&(X.allBasenames=he.allBasenames);const _e=$.reduce((ye,Re)=>Re.allPaths?ye.concat(Re.allPaths):ye,[]);return _e.length&&(X.allPaths=_e),X}function B(M,H,$){if(H===!1)return r;const Q=i(M,$);if(Q===r)return r;if(typeof H=="boolean")return Q;if(H){const X=H.when;if(typeof X=="string"){const he=(_e,ye,Re,We)=>{if(!We||!Q(_e,ye))return null;const Be=X.replace("$(basename)",Re),je=We(Be);return(0,g.isThenable)(je)?je.then(V=>V?M:null):je?M:null};return he.requiresSiblings=!0,he}}return Q}function x(M,H){const $=M.filter(ye=>!!ye.basenames);if($.length<2)return M;const Q=$.reduce((ye,Re)=>{const We=Re.basenames;return We?ye.concat(We):ye},[]);let X;if(H){X=[];for(let ye=0,Re=Q.length;ye<Re;ye++)X.push(H)}else X=$.reduce((ye,Re)=>{const We=Re.patterns;return We?ye.concat(We):ye},[]);const he=function(ye,Re){if(typeof ye!="string")return null;if(!Re){let Be;for(Be=ye.length;Be>0;Be--){const je=ye.charCodeAt(Be-1);if(je===47||je===92)break}Re=ye.substr(Be)}const We=Q.indexOf(Re);return We!==-1?X[We]:null};he.basenames=Q,he.patterns=X,he.allBasenames=Q;const _e=M.filter(ye=>!ye.basenames);return _e.push(he),_e}}),define(me[79],ge([0,1,29,10,8,11,22,9,2]),function(Y,e,g,L,I,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(i,f,l){if(typeof i=="string"&&(i=S.URI.file(i)),l){const b=l.getWorkspaceFolder(i);if(b){const y=l.getWorkspace().folders.length>1;let v;if((0,R.isEqual)(b.uri,i)?v="":v=(0,R.relativePath)(b.uri,i),y){const A=b.name?b.name:(0,R.basename)(b.uri);v=v?A+" \u2022 "+v:A}return v}}if(i.scheme!==L.Schemas.file&&i.scheme!==L.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,g.hasDriveLetter)(i.fsPath))return(0,I.normalize)(P(i.fsPath));let d=(0,I.normalize)(i.fsPath);return!C.isWindows&&f?.userHome&&(d=m(d,f.userHome.fsPath)),d}e.getPathLabel=T;function n(i){if(!i)return;typeof i=="string"&&(i=S.URI.file(i));const f=(0,R.basename)(i)||(i.scheme===L.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,g.isRootOrDriveLetter)(f)?P(f):f}e.getBaseLabel=n;function P(i){return(0,g.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=P;let c=Object.create(null);function m(i,f){if(C.isWindows||!i||!f)return i;let l=c.original===f?c.normalized:void 0;return l||(l=`${(0,E.rtrim)(f,I.posix.sep)}${I.posix.sep}`,c={original:f,normalized:l}),(C.isLinux?i.startsWith(l):(0,E.startsWithIgnoreCase)(i,l))&&(i=`~/${i.substr(l.length)}`),i}e.tildify=m;function u(i,f){return i.replace(/^~($|\/|\\)/,`${f}$1`)}e.untildify=u;const h="\u2026",D="\\\\",k="~";function _(i,f=I.sep){const l=new Array(i.length);let d=!1;for(let b=0;b<i.length;b++){let y=i[b];if(y===""){l[b]=`.${f}`;continue}if(!y){l[b]=y;continue}d=!0;let v="";y.indexOf(D)===0?(v=y.substr(0,y.indexOf(D)+D.length),y=y.substr(y.indexOf(D)+D.length)):y.indexOf(f)===0?(v=y.substr(0,y.indexOf(f)+f.length),y=y.substr(y.indexOf(f)+f.length)):y.indexOf(k)===0&&(v=y.substr(0,y.indexOf(k)+k.length),y=y.substr(y.indexOf(k)+k.length));const A=y.split(f);for(let w=1;d&&w<=A.length;w++)for(let F=A.length-w;d&&F>=0;F--){d=!1;let O=A.slice(F,F+w).join(f);for(let G=0;!d&&G<i.length;G++)if(G!==b&&i[G]&&i[G].indexOf(O)>-1){const K=F+w===A.length,U=F>0&&i[G].indexOf(f)>-1?f+O:O,z=i[G].endsWith(U);d=!K||z}if(!d){let G="";(A[0].endsWith(":")||v!=="")&&(F===1&&(F=0,w++,O=A[0]+f+O),F>0&&(G=A[0]+f),G=v+G),F>0&&(G=G+h+f),G=G+O,F+w<A.length&&(G=G+f+h),l[b]=G}}d&&(l[b]=y)}return l}e.shorten=_;var o;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function a(i,f=Object.create(null)){const l=[];let d=!1,b="";for(const y of i)if(y==="$"||d&&y==="{")b&&l.push({value:b,type:o.TEXT}),b="",d=!0;else if(y==="}"&&d){const v=f[b];if(typeof v=="string")v.length&&l.push({value:v,type:o.VARIABLE});else if(v){const A=l[l.length-1];(!A||A.type!==o.SEPARATOR)&&l.push({value:v.label,type:o.SEPARATOR})}b="",d=!1}else b+=y;return b&&!d&&l.push({value:b,type:o.TEXT}),l.filter((y,v)=>{if(y.type===o.SEPARATOR){const A=l[v-1],w=l[v+1];return[A,w].every(F=>F&&(F.type===o.VARIABLE||F.type===o.TEXT)&&F.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=a;function p(i,f){return C.isMacintosh||f?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function t(i,f){return C.isMacintosh||f?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function s(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(i){const f=i.indexOf("/")!==-1?I.posix:I.win32,l=f.basename(i),d=f.dirname(i);return l.length?{name:l,parentPath:d}:{name:d,parentPath:""}}e.splitName=r}),define(me[102],ge([0,1,30,10,8,22,9]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var E;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(E=e.Mimes||(e.Mimes={}));let S=[],T=[],n=[];function P(i,f=!1){const l=c(i);S.push(l),l.userConfigured?n.push(l):T.push(l),f&&!l.userConfigured&&S.forEach(d=>{d.mime===l.mime||d.userConfigured||(l.extension&&d.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&d.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&d.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&d.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=P;function c(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,g.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(I.posix.sep)>=0:!1}}function m(i){i?(S=S.filter(f=>!f.userConfigured),n=[]):(S=[],T=[],n=[])}e.clearTextMimes=m;function u(i,f){let l;if(i)switch(i.scheme){case L.Schemas.file:l=i.fsPath;break;case L.Schemas.data:l=C.DataUri.parseMetaData(i).get(C.DataUri.META_DATA_LABEL);break;default:l=i.path}if(!l)return[E.unknown];l=l.toLowerCase();const d=(0,I.basename)(l),b=h(l,d,n);if(b)return[b,E.text];const y=h(l,d,T);if(y)return[y,E.text];if(f){const v=D(f);if(v)return[v,E.text]}return[E.unknown]}e.guessMimeTypes=u;function h(i,f,l){let d=null,b=null,y=null;for(let v=l.length-1;v>=0;v--){const A=l[v];if(f===A.filenameLowercase){d=A;break}if(A.filepattern&&(!b||A.filepattern.length>b.filepattern.length)){const w=A.filepatternOnPath?i:f;A.filepatternLowercase?.(w)&&(b=A)}A.extension&&(!y||A.extension.length>y.extension.length)&&f.endsWith(A.extensionLowercase)&&(y=A)}return d?d.mime:b?b.mime:y?y.mime:null}function D(i){if((0,R.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let f=S.length-1;f>=0;f--){const l=S[f];if(!l.firstline)continue;const d=i.match(l.firstline);if(d&&d.length>0)return l.mime}return null}function k(i){return i?typeof i=="string"?i===E.binary||i===E.text||i===E.unknown:i.length===1&&k(i[0]):!0}e.isUnspecific=k;const _={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function a(i){const f=(0,I.extname)(i),l=_[f.toLowerCase()];return l!==void 0?l:p(i)}e.getMediaOrTextMime=a;function p(i){const f=(0,I.extname)(i);return o[f.toLowerCase()]}e.getMediaMime=p;function t(i){for(const f in o)if(o[f]===i)return f}e.getExtensionForMimeType=t;const s=/^(.+)\/(.+?)(;.+)?$/;function r(i,f){const l=s.exec(i);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:f?void 0:i}e.normalizeMimeType=r}),define(me[103],ge([0,1,2]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class I{constructor(P){this._uriTransformer=P}transformIncoming(P){const c=this._uriTransformer.transformIncoming(P);return c===P?P:L(g.URI.from(c))}transformOutgoing(P){const c=this._uriTransformer.transformOutgoing(P);return c===P?P:L(g.URI.from(c))}transformOutgoingURI(P){const c=this._uriTransformer.transformOutgoing(P);return c===P?P:g.URI.from(c)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function C(n,P,c){if(!n||c>200)return null;if(typeof n=="object"){if(n instanceof g.URI)return P.transformOutgoing(n);for(let m in n)if(Object.hasOwnProperty.call(n,m)){const u=C(n[m],P,c+1);u!==null&&(n[m]=u)}}return null}function R(n,P){const c=C(n,P,0);return c===null?n:c}e.transformOutgoingURIs=R;function E(n,P,c,m){if(!n||m>200)return null;if(typeof n=="object"){if(n.$mid===1)return c?g.URI.revive(P.transformIncoming(n)):P.transformIncoming(n);for(let u in n)if(Object.hasOwnProperty.call(n,u)){const h=E(n[u],P,c,m+1);h!==null&&(n[u]=h)}}return null}function S(n,P){const c=E(n,P,!1,0);return c===null?n:c}e.transformIncomingURIs=S;function T(n,P){const c=E(n,P,!0,0);return c===null?n:c}e.transformAndReviveIncomingURIs=T}),define(me[32],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return g.test(S)}e.isUUID=L;const I=new Uint8Array(16),C=[];for(let S=0;S<256;S++)C.push(S.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(S){for(let T=0;T<S.length;T++)S[T]=Math.floor(Math.random()*256);return S};function E(){R(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let S=0,T="";return T+=C[I[S++]],T+=C[I[S++]],T+=C[I[S++]],T+=C[I[S++]],T+="-",T+=C[I[S++]],T+=C[I[S++]],T+="-",T+=C[I[S++]],T+=C[I[S++]],T+="-",T+=C[I[S++]],T+=C[I[S++]],T+="-",T+=C[I[S++]],T+=C[I[S++]],T+=C[I[S++]],T+=C[I[S++]],T+=C[I[S++]],T+=C[I[S++]],T}e.generateUuid=E}),define(me[143],ge([0,1,104]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(C="utf8"){this.stringDecoder=new g.StringDecoder(C),this.remaining=null}write(C){const R=[],E=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(E.length<1)return R;let S=0,T,n=S;for(;n<E.length;)if(T=E.charCodeAt(n),T===13||T===10){if(R.push(E.substring(S,n)),n++,n<E.length){const P=T;T=E.charCodeAt(n),(P===13&&T===10||P===10&&T===13)&&n++}S=n}else n++;return this.remaining=S<E.length?E.substr(S):null,R}end(){return this.remaining}}e.LineDecoder=L}),define(me[28],ge([0,1,50,80,292,18,29,78,8,11,22,2,32]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function u(U,z=m.UNLINK){if((0,R.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return z===m.UNLINK?D(U):h(U)}async function h(U){try{const z=(0,S.join)((0,L.tmpdir)(),(0,c.generateUuid)());try{await e.Promises.rename(U,z)}catch(N){return D(U)}D(z).catch(N=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function D(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function k(U){if((0,R.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(U,{recursive:!0})}e.rimrafSync=k;async function _(U,z){return p(await(z?o(U):(0,I.promisify)(g.readdir)(U)))}async function o(U){try{return await(0,I.promisify)(g.readdir)(U,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const z=[],N=await _(U);for(const B of N){let x=!1,M=!1,H=!1;try{const $=await e.Promises.lstat((0,S.join)(U,B));x=$.isFile(),M=$.isDirectory(),H=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}z.push({name:B,isFile:()=>x,isDirectory:()=>M,isSymbolicLink:()=>H})}return z}function a(U){return p(g.readdirSync(U))}e.readdirSync=a;function p(U){return U.map(z=>typeof z=="string"?T.isMacintosh?(0,E.normalizeNFC)(z):z:(z.name=T.isMacintosh?(0,E.normalizeNFC)(z.name):z.name,z))}async function t(U){const z=await _(U),N=[];for(const B of z)await r.existsDirectory((0,S.join)(U,B))&&N.push(B);return N}function s(U,z=1e3){return new Promise(N=>{let B=!1;const x=setInterval(()=>{B||(B=!0,g.access(U,M=>{B=!1,M&&(clearInterval(x),N(void 0))}))},z)})}e.whenDeleted=s;var r;(function(U){async function z(x){let M;try{if(M=await e.Promises.lstat(x),!M.isSymbolicLink())return{stat:M}}catch(H){}try{return{stat:await e.Promises.stat(x),symbolicLink:M?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(T.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw $}throw H}}U.stat=z;async function N(x){try{const{stat:M,symbolicLink:H}=await U.stat(x);return M.isFile()&&H?.dangling!==!0}catch(M){}return!1}U.existsFile=N;async function B(x){try{const{stat:M,symbolicLink:H}=await U.stat(x);return M.isDirectory()&&H?.dangling!==!0}catch(M){}return!1}U.existsDirectory=B})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new C.ResourceQueue;function f(U,z,N){return i.queueFor(P.URI.file(U),n.extUriBiasedIgnorePathCase).queue(()=>{const B=y(N);return new Promise((x,M)=>d(U,z,B,H=>H?M(H):x()))})}let l=!0;function d(U,z,N,B){if(!l)return g.writeFile(U,z,{mode:N.mode,flag:N.flag},B);g.open(U,N.flag,N.mode,(x,M)=>{if(x)return B(x);g.writeFile(M,z,H=>{if(H)return g.close(M,()=>B(H));g.fdatasync(M,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),l=!1),g.close(M,Q=>B(Q))))})})}function b(U,z,N){const B=y(N);if(!l)return g.writeFileSync(U,z,{mode:B.mode,flag:B.flag});const x=g.openSync(U,B.flag,B.mode);try{g.writeFileSync(x,z);try{g.fdatasyncSync(x)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),l=!1}}finally{g.closeSync(x)}}e.writeFileSync=b;function y(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function v(U,z){if(U===z)return;async function N(B){try{const x=await e.Promises.lstat(B);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(B,x.atime,new Date)}catch(x){}}try{await e.Promises.rename(U,z),await N(z)}catch(B){if(U.toLowerCase()!==z.toLowerCase()&&B.code==="EXDEV"||U.endsWith("."))await A(U,z,{preserveSymlinks:!1}),await u(U,m.MOVE),await N(z);else throw B}}async function A(U,z,N){return F(U,z,{root:{source:U,target:z},options:N,handledSourcePaths:new Set})}const w=511;async function F(U,z,N){if(N.handledSourcePaths.has(U))return;N.handledSourcePaths.add(U);const{stat:B,symbolicLink:x}=await r.stat(U);if(x){if(N.options.preserveSymlinks)try{return await K(U,z,N)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(x.dangling)return}return B.isDirectory()?O(U,z,B.mode&w,N):G(U,z,B.mode&w)}async function O(U,z,N,B){await e.Promises.mkdir(z,{recursive:!0,mode:N});const x=await _(U);for(const M of x)await F((0,S.join)(U,M),(0,S.join)(z,M),B)}async function G(U,z,N){await e.Promises.copyFile(U,z),await e.Promises.chmod(z,N)}async function K(U,z,N){let B=await e.Promises.readlink(U);(0,R.isEqualOrParent)(B,N.root.source,!T.isLinux)&&(B=(0,S.join)(N.root.target,B.substr(N.root.source.length+1))),await e.Promises.symlink(B,z)}e.Promises=new class{get access(){return(0,I.promisify)(g.access)}get stat(){return(0,I.promisify)(g.stat)}get lstat(){return(0,I.promisify)(g.lstat)}get utimes(){return(0,I.promisify)(g.utimes)}get read(){return(0,I.promisify)(g.read)}get readFile(){return(0,I.promisify)(g.readFile)}get write(){return(0,I.promisify)(g.write)}get appendFile(){return(0,I.promisify)(g.appendFile)}get fdatasync(){return(0,I.promisify)(g.fdatasync)}get truncate(){return(0,I.promisify)(g.truncate)}get rename(){return(0,I.promisify)(g.rename)}get copyFile(){return(0,I.promisify)(g.copyFile)}get open(){return(0,I.promisify)(g.open)}get close(){return(0,I.promisify)(g.close)}get symlink(){return(0,I.promisify)(g.symlink)}get readlink(){return(0,I.promisify)(g.readlink)}get chmod(){return(0,I.promisify)(g.chmod)}get mkdir(){return(0,I.promisify)(g.mkdir)}get unlink(){return(0,I.promisify)(g.unlink)}get rmdir(){return(0,I.promisify)(g.rmdir)}get realpath(){return(0,I.promisify)(g.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return _}get readDirsInDir(){return t}get writeFile(){return f}get rm(){return u}get move(){return v}get copy(){return A}}}),define(me[105],ge([0,1,50,8,9,28]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function R(n){const P=(0,L.dirname)(n);if(n===P)return n;const c=((0,L.basename)(n)||n).toLowerCase();try{const u=(0,C.readdirSync)(P).filter(h=>h.toLowerCase()===c);if(u.length===1){const h=R(P);if(h)return(0,L.join)(h,u[0])}else if(u.length>1){const h=u.indexOf(c);if(h>=0){const D=R(P);if(D)return(0,L.join)(D,u[h])}}}catch(m){}return null}e.realcaseSync=R;async function E(n){try{return await C.Promises.realpath(n)}catch(P){const c=T(n);return await C.Promises.access(c,g.constants.R_OK),c}}e.realpath=E;function S(n){try{return g.realpathSync(n)}catch(P){const c=T(n);return g.accessSync(c,g.constants.R_OK),c}}e.realpathSync=S;function T(n){return(0,I.rtrim)((0,L.normalize)(n),L.sep)}});var Ve=this&&this.__decorate||function(Y,e,g,L){var I=arguments.length,C=I<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,g):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(Y,e,g,L);else for(var E=Y.length-1;E>=0;E--)(R=Y[E])&&(C=(I<3?R(C):I>3?R(e,g,C):R(e,g))||C);return I>3&&C&&Object.defineProperty(e,g,C),C};define(me[106],ge([0,1,17,18,23,21,58,16,3,6,60,9,13]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function u(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function D(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var k;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(k||(k={}));class _{constructor(M){this.buffer=M,this.pos=0}read(M){const H=this.buffer.slice(this.pos,this.pos+M);return this.pos+=H.byteLength,H}}class o{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var a;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(a||(a={}));function p(x){const M=I.VSBuffer.alloc(4);return M.writeUInt32BE(x,0),M}function t(x){return x.read(4).readUInt32BE(0)}function s(x){const M=I.VSBuffer.alloc(1);return M.writeUInt8(x,0),M}const r={Undefined:s(a.Undefined),String:s(a.String),Buffer:s(a.Buffer),VSBuffer:s(a.VSBuffer),Array:s(a.Array),Object:s(a.Object)},i=typeof Buffer!="undefined";function f(x,M){if(typeof M=="undefined")x.write(r.Undefined);else if(typeof M=="string"){const H=I.VSBuffer.fromString(M);x.write(r.String),x.write(p(H.byteLength)),x.write(H)}else if(i&&Buffer.isBuffer(M)){const H=I.VSBuffer.wrap(M);x.write(r.Buffer),x.write(p(H.byteLength)),x.write(H)}else if(M instanceof I.VSBuffer)x.write(r.VSBuffer),x.write(p(M.byteLength)),x.write(M);else if(Array.isArray(M)){x.write(r.Array),x.write(p(M.length));for(const H of M)f(x,H)}else{const H=I.VSBuffer.fromString(JSON.stringify(M));x.write(r.Object),x.write(p(H.byteLength)),x.write(H)}}function l(x){switch(x.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return x.read(t(x)).toString();case a.Buffer:return x.read(t(x)).buffer;case a.VSBuffer:return x.read(t(x));case a.Array:{const H=t(x),$=[];for(let Q=0;Q<H;Q++)$.push(l(x));return $}case a.Object:return JSON.parse(x.read(t(x)).toString())}}class d{constructor(M,H,$=null,Q=1e3){this.protocol=M,this.ctx=H,this.logger=$,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(M,H){this.channels.set(M,H),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const H=this.send([M.type]);this.logger&&this.logger.logOutgoing(H,0,1,D(M.type));return}case 201:case 202:case 204:case 203:{const H=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing(H,M.id,1,D(M.type),M.data);return}}}send(M,H=void 0){const $=new o;return f($,M),f($,H),this.sendBuffer($.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(H){return 0}}onRawMessage(M){const H=new _(M),$=l(H),Q=l(H),X=$[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,$[1],1,`${u(X)}: ${$[2]}.${$[3]}`,Q),this.onPromise({type:X,id:$[1],channelName:$[2],name:$[3],arg:Q});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,$[1],1,`${u(X)}: ${$[2]}.${$[3]}`,Q),this.onEventListen({type:X,id:$[1],channelName:$[2],name:$[3],arg:Q});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,$[1],1,`${u(X)}`),this.disposeActiveRequest({type:X,id:$[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,$[1],1,`${u(X)}`),this.disposeActiveRequest({type:X,id:$[1]})}}onPromise(M){const H=this.channels.get(M.channelName);if(!H){this.collectPendingRequest(M);return}const $=new C.CancellationTokenSource;let Q;try{Q=H.call(this.ctx,M.name,M.arg,$.token)}catch(_e){Q=Promise.reject(_e)}const X=M.id;Q.then(_e=>{this.sendResponse({id:X,data:_e,type:201}),this.activeRequests.delete(M.id)},_e=>{_e instanceof Error?this.sendResponse({id:X,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:X,data:_e,type:203}),this.activeRequests.delete(M.id)});const he=(0,T.toDisposable)(()=>$.cancel());this.activeRequests.set(M.id,he)}onEventListen(M){const H=this.channels.get(M.channelName);if(!H){this.collectPendingRequest(M);return}const $=M.id,X=H.listen(this.ctx,M.name,M.arg)(he=>this.sendResponse({id:$,data:he,type:204}));this.activeRequests.set(M.id,X)}disposeActiveRequest(M){const H=this.activeRequests.get(M.id);H&&(H.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let H=this.pendingRequests.get(M.channelName);H||(H=[],this.pendingRequests.set(M.channelName,H));const $=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:M,timeoutTimer:$})}flushPendingRequests(M){const H=this.pendingRequests.get(M);if(H){for(const $ of H)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var b;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class y{constructor(M,H=null){this.protocol=M,this.isDisposed=!1,this.state=k.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=H}getChannel(M){const H=this;return{call($,Q,X){return H.isDisposed?Promise.reject(E.canceled()):H.requestPromise(M,$,Q,X)},listen($,Q){return H.isDisposed?Promise.reject(E.canceled()):H.requestEvent(M,$,Q)}}}requestPromise(M,H,$,Q=C.CancellationToken.None){const X=this.lastRequestId++,_e={id:X,type:100,channelName:M,name:H,arg:$};if(Q.isCancellationRequested)return Promise.reject(E.canceled());let ye;return new Promise((We,Be)=>{if(Q.isCancellationRequested)return Be(E.canceled());const je=()=>{const ae=J=>{switch(J.type){case 201:this.handlers.delete(X),We(J.data);break;case 202:this.handlers.delete(X);const oe=new Error(J.data.message);oe.stack=J.data.stack,oe.name=J.data.name,Be(oe);break;case 203:this.handlers.delete(X),Be(J.data);break}};this.handlers.set(X,ae),this.sendRequest(_e)};let V=null;this.state===k.Idle?je():(V=(0,L.createCancelablePromise)(ae=>this.whenInitialized()),V.then(()=>{V=null,je()}));const ee=()=>{V?(V.cancel(),V=null):this.sendRequest({id:X,type:101}),Be(E.canceled())},re=Q.onCancellationRequested(ee);ye=(0,T.combinedDisposable)((0,T.toDisposable)(ee),re),this.activeRequests.add(ye)}).finally(()=>{this.activeRequests.delete(ye)})}requestEvent(M,H,$){const Q=this.lastRequestId++,he={id:Q,type:102,channelName:M,name:H,arg:$};let _e=null;const ye=new S.Emitter({onFirstListenerAdd:()=>{_e=(0,L.createCancelablePromise)(We=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(ye),this.sendRequest(he)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(ye),this.sendRequest({id:Q,type:103}))}}),Re=We=>ye.fire(We.data);return this.handlers.set(Q,Re),ye.event}sendRequest(M){switch(M.type){case 100:case 102:{const H=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(H,M.id,0,`${u(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const H=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(H,M.id,0,u(M.type));return}}}send(M,H=void 0){const $=new o;return f($,M),f($,H),this.sendBuffer($.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(H){return 0}}onBuffer(M){const H=new _(M),$=l(H),Q=l(H),X=$[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,D(X)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,$[1],0,D(X),Q),this.onResponse({type:$[0],id:$[1],data:Q})}}onResponse(M){if(M.type===200){this.state=k.Idle,this._onDidInitialize.fire();return}const H=this.handlers.get(M.id);H&&H(M)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===k.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}Ve([R.memoize],y.prototype,"onDidInitializePromise",null),e.ChannelClient=y;class v{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:H,onDidClientDisconnect:$})=>{S.Event.once(H.onMessage)(X=>{const he=new _(X),_e=l(he),ye=new d(H,_e),Re=new y(H);this.channels.forEach((Be,je)=>ye.registerChannel(je,Be));const We={channelServer:ye,channelClient:Re,ctx:_e};this._connections.add(We),this._onDidAddConnection.fire(We),$(()=>{ye.dispose(),Re.dispose(),this._connections.delete(We),this._onDidRemoveConnection.fire(We)})})})}get connections(){const M=[];return this._connections.forEach(H=>M.push(H)),M}getChannel(M,H){const $=this;return{call(Q,X,he){let _e;if((0,c.isFunction)(H)){let Re=(0,g.getRandomElement)($.connections.filter(H));_e=Re?Promise.resolve(Re):S.Event.toPromise(S.Event.filter($.onDidAddConnection,H))}else _e=H.routeCall($,Q,X);const ye=_e.then(Re=>Re.channelClient.getChannel(M));return w(ye).call(Q,X,he)},listen(Q,X){if((0,c.isFunction)(H))return $.getMulticastEvent(M,H,Q,X);const he=H.routeEvent($,Q,X).then(_e=>_e.channelClient.getChannel(M));return w(he).listen(Q,X)}}}getMulticastEvent(M,H,$,Q){const X=this;let he=new T.DisposableStore;const _e=new S.Emitter({onFirstListenerAdd:()=>{he=new T.DisposableStore;const ye=new S.EventMultiplexer,Re=new Map,We=je=>{const ee=je.channelClient.getChannel(M).listen($,Q),re=ye.add(ee);Re.set(je,re)},Be=je=>{const V=Re.get(je);!V||(V.dispose(),Re.delete(je))};X.connections.filter(H).forEach(We),S.Event.filter(X.onDidAddConnection,H)(We,void 0,he),X.onDidRemoveConnection(Be,void 0,he),ye.event(_e.fire,_e,he),he.add(ye)},onLastListenerRemove:()=>{he.dispose()}});return _e.event}registerChannel(M,H){this.channels.set(M,H),this._connections.forEach($=>{$.channelServer.registerChannel(M,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=v;class A{constructor(M,H,$=null){const Q=new o;f(Q,H),M.send(Q.buffer),this.channelClient=new y(M,$),this.channelServer=new d(M,H,$)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,H){this.channelServer.registerChannel(M,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function w(x){return{call(M,H,$){return x.then(Q=>Q.call(M,H,$))},listen(M,H){const $=new S.Relay;return x.then(Q=>$.input=Q.listen(M,H)),$.event}}}e.getDelayedChannel=w;function F(x){let M=!1;return{call(H,$,Q){return M?x.call(H,$,Q):(0,L.timeout)(0).then(()=>M=!0).then(()=>x.call(H,$,Q))},listen(H,$){if(M)return x.listen(H,$);const Q=new S.Relay;return(0,L.timeout)(0).then(()=>M=!0).then(()=>Q.input=x.listen(H,$)),Q.event}}}e.getNextTickChannel=F;class O{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const H of M.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await S.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=O;var G;(function(x){function M(Q,X){const he=Q,_e=X&&X.disableMarshalling,ye=new Map;for(const Re in he)$(Re)&&ye.set(Re,S.Event.buffer(he[Re],!0));return new class{listen(Re,We){const Be=ye.get(We);if(Be)return Be;throw new Error(`Event not found: ${We}`)}call(Re,We,Be){const je=he[We];if(typeof je=="function"){if(!_e&&Array.isArray(Be))for(let V=0;V<Be.length;V++)Be[V]=(0,n.revive)(Be[V]);return je.apply(he,Be)}throw new Error(`Method not found: ${We}`)}}}x.fromService=M;function H(Q,X){const he=X&&X.disableMarshalling;return new Proxy({},{get(_e,ye){if(typeof ye=="string")return X?.properties?.has(ye)?X.properties.get(ye):$(ye)?Q.listen(ye):async function(...Re){let We;X&&!(0,c.isUndefinedOrNull)(X.context)?We=[X.context,...Re]:We=Re;const Be=await Q.call(ye,We);return he?Be:(0,n.revive)(Be)};throw new Error(`Property not found: ${String(ye)}`)}})}x.toService=H;function $(Q){return Q[0]==="o"&&Q[1]==="n"&&P.isUpperAsciiLetter(Q.charCodeAt(2))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let M=x.toString();if(M!=="[object Object]")return M}return x}function z(x){return Array.isArray(x)?x.map(U):U(x)}function N(x,M,H,$,Q,X,he){he=z(he);const _e=K[Q],ye=_e[$%_e.length];let Re=[`%c[${x}]%c[${String(M).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String($).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(X)?(Re=Re.concat(he),Re.push(")")):Re.push(he),console.log.apply(console,Re)}e.logWithColors=N;class B{constructor(M,H){this._outgoingPrefix=M,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,H,$,Q,X){this._totalOutgoing+=M,N(this._outgoingPrefix,this._totalOutgoing,M,H,$,Q,X)}logIncoming(M,H,$,Q,X){this._totalIncoming+=M,N(this._incomingPrefix,this._totalIncoming,M,H,$,Q,X)}}e.IPCLogger=B}),define(me[107],ge([0,1,23,3,6,11,38,106]),function(Y,e,g,L,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var S;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let T=null;function n(){return T||(T=g.VSBuffer.alloc(0)),T}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,f){if(i===0)return n();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const y=this._chunks[0];return f&&(this._chunks.shift(),this._totalLength-=i),y}if(this._chunks[0].byteLength>i){const y=this._chunks[0].slice(0,i);return f&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),y}let l=g.VSBuffer.alloc(i),d=0,b=0;for(;i>0;){const y=this._chunks[b];if(y.byteLength>i){const v=y.slice(0,i);l.set(v,d),d+=i,f&&(this._chunks[b]=y.slice(i),this._totalLength-=i),i-=i}else l.set(y,d),d+=y.byteLength,f?(this._chunks.shift(),this._totalLength-=y.byteLength):b++,i-=y.byteLength}return l}}e.ChunkStream=P;var c;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(c||(c={}));var m;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class u{constructor(i,f,l,d){this.type=i,this.id=f,this.ack=l,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends I.Disposable{constructor(i){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(f=>this.acceptChunk(f))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const f=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=f.readUInt32BE(9),this._state.messageType=f.readUInt8(0),this._state.id=f.readUInt32BE(1),this._state.ack=f.readUInt32BE(5);else{const l=this._state.messageType,d=this._state.id,b=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new u(l,d,b,f)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class D{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const f=g.VSBuffer.alloc(13);f.writeUInt8(i.type,0),f.writeUInt32BE(i.id,1),f.writeUInt32BE(i.ack,5),f.writeUInt32BE(i.data.byteLength,9),this._writeSoon(f,i.data)}_bufferAdd(i,f){const l=this._totalLength===0;return this._data.push(i,f),this._totalLength+=i.byteLength+f.byteLength,l}_bufferTake(){const i=g.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,f){this._bufferAdd(i,f)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class k extends I.Disposable{constructor(i){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new D(this._socket)),this._socketReader=this._register(new h(this._socket)),this._register(this._socketReader.onMessage(f=>{f.type===1&&this._onMessage.fire(f.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new u(1,0,0,i))}}e.Protocol=k;class _ extends E.IPCClient{constructor(i,f,l=null){super(i,f,l);this.protocol=i}static fromSocket(i,f){return new _(new k(i),f)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=_;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,R.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class a{constructor(i){this.data=i,this.next=null}}class p{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],f=0,l=this._first;for(;l;)i[f++]=l.data,l=l.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const f=new a(i);if(!this._first){this._first=f,this._last=f;return}this._last.next=f,this._last=f}}class t{constructor(){this.lastRuns=[];const i=Date.now();for(let f=0;f<t._HISTORY_LENGTH;f++)this.lastRuns[f]=i-1e3*f;setInterval(()=>{for(let f=t._HISTORY_LENGTH;f>=1;f--)this.lastRuns[f]=this.lastRuns[f-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const i=Date.now(),f=(1+t._HISTORY_LENGTH)*1e3;let l=0;for(let d=0;d<t._HISTORY_LENGTH;d++)i-this.lastRuns[d]<=f&&l++;return 1-l/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(i,f=null,l=t.getInstance()){this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new p,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),f&&this._socketReader.acceptChunk(f),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new u(5,0,0,n());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const f=new u(4,0,0,n());this._socketWriter.write(f),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,f){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(f)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let f=0,l=i.length;f<l;f++)this._socketWriter.write(i[f]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const f=this._outgoingUnackMsg.peek();if(f&&f.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const f=Date.now();f-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=f,this._socketWriter.write(new u(6,0,0,n())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const f=this._outgoingUnackMsg.toArray();for(let l=0,d=f.length;l<d;l++)this._socketWriter.write(f[l]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const f=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new u(1,f,this._incomingAckId,i);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(i){const f=new u(2,0,0,i);this._socketWriter.write(f)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),f=Date.now()-i.writtenTime;if(f>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-f,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new u(3,0,this._incomingAckId,n());this._socketWriter.write(i)}}e.PersistentProtocol=s}),define(me[108],ge([0,1,97]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(E){let S=(0,g.toUint8)(E);this._defaultValue=S,this._asciiMap=L._createAsciiMap(S),this._map=new Map}static _createAsciiMap(E){let S=new Uint8Array(256);for(let T=0;T<256;T++)S[T]=E;return S}set(E,S){let T=(0,g.toUint8)(S);E>=0&&E<256?this._asciiMap[E]=T:this._map.set(E,T)}get(E){return E>=0&&E<256?this._asciiMap[E]:this._map.get(E)||this._defaultValue}}e.CharacterClassifier=L;var I;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(I||(I={}));class C{constructor(){this._actual=new L(0)}add(E){this._actual.set(E,1)}has(E){return this._actual.get(E)===1}}e.CharacterSet=C}),define(me[144],ge([0,1,108]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends g.CharacterClassifier{constructor(E){super(0);for(let S=0,T=E.length;S<T;S++)this.set(E.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function C(R){let E={};return S=>(E.hasOwnProperty(S)||(E[S]=R(S)),E[S])}e.getMapForWordSeparators=C(R=>new I(R))}),define(me[51],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(I,C){this.lineNumber=I,this.column=C}with(I=this.lineNumber,C=this.column){return I===this.lineNumber&&C===this.column?this:new g(I,C)}delta(I=0,C=0){return this.with(this.lineNumber+I,this.column+C)}equals(I){return g.equals(this,I)}static equals(I,C){return!I&&!C?!0:!!I&&!!C&&I.lineNumber===C.lineNumber&&I.column===C.column}isBefore(I){return g.isBefore(this,I)}static isBefore(I,C){return I.lineNumber<C.lineNumber?!0:C.lineNumber<I.lineNumber?!1:I.column<C.column}isBeforeOrEqual(I){return g.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,C){return I.lineNumber<C.lineNumber?!0:C.lineNumber<I.lineNumber?!1:I.column<=C.column}static compare(I,C){let R=I.lineNumber|0,E=C.lineNumber|0;if(R===E){let S=I.column|0,T=C.column|0;return S-T}return R-E}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new g(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=g}),define(me[41],ge([0,1,51]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(C,R,E,S){C>E||C===E&&R>S?(this.startLineNumber=E,this.startColumn=S,this.endLineNumber=C,this.endColumn=R):(this.startLineNumber=C,this.startColumn=R,this.endLineNumber=E,this.endColumn=S)}isEmpty(){return L.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return L.containsPosition(this,C)}static containsPosition(C,R){return!(R.lineNumber<C.startLineNumber||R.lineNumber>C.endLineNumber||R.lineNumber===C.startLineNumber&&R.column<C.startColumn||R.lineNumber===C.endLineNumber&&R.column>C.endColumn)}containsRange(C){return L.containsRange(this,C)}static containsRange(C,R){return!(R.startLineNumber<C.startLineNumber||R.endLineNumber<C.startLineNumber||R.startLineNumber>C.endLineNumber||R.endLineNumber>C.endLineNumber||R.startLineNumber===C.startLineNumber&&R.startColumn<C.startColumn||R.endLineNumber===C.endLineNumber&&R.endColumn>C.endColumn)}strictContainsRange(C){return L.strictContainsRange(this,C)}static strictContainsRange(C,R){return!(R.startLineNumber<C.startLineNumber||R.endLineNumber<C.startLineNumber||R.startLineNumber>C.endLineNumber||R.endLineNumber>C.endLineNumber||R.startLineNumber===C.startLineNumber&&R.startColumn<=C.startColumn||R.endLineNumber===C.endLineNumber&&R.endColumn>=C.endColumn)}plusRange(C){return L.plusRange(this,C)}static plusRange(C,R){let E,S,T,n;return R.startLineNumber<C.startLineNumber?(E=R.startLineNumber,S=R.startColumn):R.startLineNumber===C.startLineNumber?(E=R.startLineNumber,S=Math.min(R.startColumn,C.startColumn)):(E=C.startLineNumber,S=C.startColumn),R.endLineNumber>C.endLineNumber?(T=R.endLineNumber,n=R.endColumn):R.endLineNumber===C.endLineNumber?(T=R.endLineNumber,n=Math.max(R.endColumn,C.endColumn)):(T=C.endLineNumber,n=C.endColumn),new L(E,S,T,n)}intersectRanges(C){return L.intersectRanges(this,C)}static intersectRanges(C,R){let E=C.startLineNumber,S=C.startColumn,T=C.endLineNumber,n=C.endColumn,P=R.startLineNumber,c=R.startColumn,m=R.endLineNumber,u=R.endColumn;return E<P?(E=P,S=c):E===P&&(S=Math.max(S,c)),T>m?(T=m,n=u):T===m&&(n=Math.min(n,u)),E>T||E===T&&S>n?null:new L(E,S,T,n)}equalsRange(C){return L.equalsRange(this,C)}static equalsRange(C,R){return!!C&&!!R&&C.startLineNumber===R.startLineNumber&&C.startColumn===R.startColumn&&C.endLineNumber===R.endLineNumber&&C.endColumn===R.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(C){return new g.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(C){return new g.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,R){return new L(this.startLineNumber,this.startColumn,C,R)}setStartPosition(C,R){return new L(C,R,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(C){return new L(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,R=C){return new L(C.lineNumber,C.column,R.lineNumber,R.column)}static lift(C){return C?new L(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,R){return!(C.endLineNumber<R.startLineNumber||C.endLineNumber===R.startLineNumber&&C.endColumn<R.startColumn||R.endLineNumber<C.startLineNumber||R.endLineNumber===C.startLineNumber&&R.endColumn<C.startColumn)}static areIntersecting(C,R){return!(C.endLineNumber<R.startLineNumber||C.endLineNumber===R.startLineNumber&&C.endColumn<=R.startColumn||R.endLineNumber<C.startLineNumber||R.endLineNumber===C.startLineNumber&&R.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,R){if(C&&R){const T=C.startLineNumber|0,n=R.startLineNumber|0;if(T===n){const P=C.startColumn|0,c=R.startColumn|0;if(P===c){const m=C.endLineNumber|0,u=R.endLineNumber|0;if(m===u){const h=C.endColumn|0,D=R.endColumn|0;return h-D}return m-u}return P-c}return T-n}return(C?1:0)-(R?1:0)}static compareRangesUsingEnds(C,R){return C.endLineNumber===R.endLineNumber?C.endColumn===R.endColumn?C.startLineNumber===R.startLineNumber?C.startColumn-R.startColumn:C.startLineNumber-R.startLineNumber:C.endColumn-R.endColumn:C.endLineNumber-R.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=L}),define(me[145],ge([0,1,51,41]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class C extends L.Range{constructor(E,S,T,n){super(E,S,T,n);this.selectionStartLineNumber=E,this.selectionStartColumn=S,this.positionLineNumber=T,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(E){return C.selectionsEqual(this,E)}static selectionsEqual(E,S){return E.selectionStartLineNumber===S.selectionStartLineNumber&&E.selectionStartColumn===S.selectionStartColumn&&E.positionLineNumber===S.positionLineNumber&&E.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(E,S){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,E,S):new C(E,S,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(E,S){return this.getDirection()===0?new C(E,S,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,E,S)}static fromPositions(E,S=E){return new C(E.lineNumber,E.column,S.lineNumber,S.column)}static liftSelection(E){return new C(E.selectionStartLineNumber,E.selectionStartColumn,E.positionLineNumber,E.positionColumn)}static selectionsArrEqual(E,S){if(E&&!S||!E&&S)return!1;if(!E&&!S)return!0;if(E.length!==S.length)return!1;for(let T=0,n=E.length;T<n;T++)if(!this.selectionsEqual(E[T],S[T]))return!1;return!0}static isISelection(E){return E&&typeof E.selectionStartLineNumber=="number"&&typeof E.selectionStartColumn=="number"&&typeof E.positionLineNumber=="number"&&typeof E.positionColumn=="number"}static createWithDirection(E,S,T,n,P){return P===0?new C(E,S,T,n):new C(T,n,E,S)}}e.Selection=C}),define(me[109],ge([0,1,25]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var R;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(R=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var E;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(E=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(D){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,D.tabSize|0),this.indentSize=D.tabSize|0,this.insertSpaces=Boolean(D.insertSpaces),this.defaultEOL=D.defaultEOL|0,this.trimAutoWhitespace=Boolean(D.trimAutoWhitespace),this.bracketPairColorizationOptions=D.bracketPairColorizationOptions}equals(D){return this.tabSize===D.tabSize&&this.indentSize===D.indentSize&&this.insertSpaces===D.insertSpaces&&this.defaultEOL===D.defaultEOL&&this.trimAutoWhitespace===D.trimAutoWhitespace&&(0,g.equals)(this.bracketPairColorizationOptions,D.bracketPairColorizationOptions)}createChangeEvent(D){return{tabSize:this.tabSize!==D.tabSize,indentSize:this.indentSize!==D.indentSize,insertSpaces:this.insertSpaces!==D.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==D.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class T{constructor(D,k){this._findMatchBrand=void 0,this.range=D,this.matches=k}}e.FindMatch=T;var n;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var P;(function(h){h[h.Left=0]="Left",h[h.Right=1]="Right",h[h.None=2]="None"})(P=e.PositionAffinity||(e.PositionAffinity={}));var c;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c=e.ModelConstants||(e.ModelConstants={}));class m{constructor(D,k,_,o,a,p){this.identifier=D,this.range=k,this.text=_,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=a,this._isTracked=p}}e.ValidAnnotatedEditOperation=m;class u{constructor(D,k,_){this.reverseEdits=D,this.changes=k,this.trimAutoWhitespaceLineNumbers=_}}e.ApplyEditsResult=u}),define(me[146],ge([0,1,9,144,51,41,109]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const E=999;class S{constructor(o,a,p,t){this.searchString=o,this.isRegex=a,this.matchCase=p,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=T(this.searchString):o=this.searchString.indexOf(`
`)>=0;let a=null;try{a=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(t){return null}if(!a)return null;let p=!this.isRegex&&!o;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new n(a,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=S;function T(_){if(!_||_.length===0)return!1;for(let o=0,a=_.length;o<a;o++)if(_.charCodeAt(o)===92){if(o++,o>=a)break;const t=_.charCodeAt(o);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=T;class n{constructor(o,a,p){this.regex=o,this.wordSeparators=a,this.simpleSearch=p}}e.SearchData=n;function P(_,o,a){if(!a)return new R.FindMatch(_,null);let p=[];for(let t=0,s=o.length;t<s;t++)p[t]=o[t];return new R.FindMatch(_,p)}e.createFindMatch=P;class c{constructor(o){let a=[],p=0;for(let t=0,s=o.length;t<s;t++)o.charCodeAt(t)===10&&(a[p++]=t);this._lineFeedsOffsets=a}findLineFeedCountBeforeOffset(o){const a=this._lineFeedsOffsets;let p=0,t=a.length-1;if(t===-1||o<=a[0])return 0;for(;p<t;){const s=p+((t-p)/2>>0);a[s]>=o?t=s-1:a[s+1]>=o?(p=s,t=s):p=s+1}return p+1}}class m{static findMatches(o,a,p,t,s){const r=a.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(o,p,new k(r.wordSeparators,r.regex),t,s):this._doFindMatchesLineByLine(o,p,r,t,s):[]}static _getMultilineMatchRange(o,a,p,t,s,r){let i,f=0;t?(f=t.findLineFeedCountBeforeOffset(s),i=a+s+f):i=a+s;let l;if(t){let v=t.findLineFeedCountBeforeOffset(s+r.length)-f;l=i+r.length+v}else l=i+r.length;const d=o.getPositionAt(i),b=o.getPositionAt(l);return new C.Range(d.lineNumber,d.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(o,a,p,t,s){const r=o.getOffsetAt(a.getStartPosition()),i=o.getValueInRange(a,1),f=o.getEOL()===`\r
`?new c(i):null,l=[];let d=0,b;for(p.reset(0);b=p.next(i);)if(l[d++]=P(this._getMultilineMatchRange(o,r,i,f,b.index,b[0]),b,t),d>=s)return l;return l}static _doFindMatchesLineByLine(o,a,p,t,s){const r=[];let i=0;if(a.startLineNumber===a.endLineNumber){const l=o.getLineContent(a.startLineNumber).substring(a.startColumn-1,a.endColumn-1);return i=this._findMatchesInLine(p,l,a.startLineNumber,a.startColumn-1,i,r,t,s),r}const f=o.getLineContent(a.startLineNumber).substring(a.startColumn-1);i=this._findMatchesInLine(p,f,a.startLineNumber,a.startColumn-1,i,r,t,s);for(let l=a.startLineNumber+1;l<a.endLineNumber&&i<s;l++)i=this._findMatchesInLine(p,o.getLineContent(l),l,0,i,r,t,s);if(i<s){const l=o.getLineContent(a.endLineNumber).substring(0,a.endColumn-1);i=this._findMatchesInLine(p,l,a.endLineNumber,0,i,r,t,s)}return r}static _findMatchesInLine(o,a,p,t,s,r,i,f){const l=o.wordSeparators;if(!i&&o.simpleSearch){const y=o.simpleSearch,v=y.length,A=a.length;let w=-v;for(;(w=a.indexOf(y,w+v))!==-1;)if((!l||D(l,a,A,w,v))&&(r[s++]=new R.FindMatch(new C.Range(p,w+1+t,p,w+1+v+t),null),s>=f))return s;return s}const d=new k(o.wordSeparators,o.regex);let b;d.reset(0);do if(b=d.next(a),b&&(r[s++]=P(new C.Range(p,b.index+1+t,p,b.index+1+b[0].length+t),b,i),s>=f))return s;while(b);return s}static findNextMatch(o,a,p,t){const s=a.parseSearchRequest();if(!s)return null;const r=new k(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(o,p,r,t):this._doFindNextMatchLineByLine(o,p,r,t)}static _doFindNextMatchMultiline(o,a,p,t){const s=new I.Position(a.lineNumber,1),r=o.getOffsetAt(s),i=o.getLineCount(),f=o.getValueInRange(new C.Range(s.lineNumber,s.column,i,o.getLineMaxColumn(i)),1),l=o.getEOL()===`\r
`?new c(f):null;p.reset(a.column-1);let d=p.next(f);return d?P(this._getMultilineMatchRange(o,r,f,l,d.index,d[0]),d,t):a.lineNumber!==1||a.column!==1?this._doFindNextMatchMultiline(o,new I.Position(1,1),p,t):null}static _doFindNextMatchLineByLine(o,a,p,t){const s=o.getLineCount(),r=a.lineNumber,i=o.getLineContent(r),f=this._findFirstMatchInLine(p,i,r,a.column,t);if(f)return f;for(let l=1;l<=s;l++){const d=(r+l-1)%s,b=o.getLineContent(d+1),y=this._findFirstMatchInLine(p,b,d+1,1,t);if(y)return y}return null}static _findFirstMatchInLine(o,a,p,t,s){o.reset(t-1);const r=o.next(a);return r?P(new C.Range(p,r.index+1,p,r.index+1+r[0].length),r,s):null}static findPreviousMatch(o,a,p,t){const s=a.parseSearchRequest();if(!s)return null;const r=new k(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(o,p,r,t):this._doFindPreviousMatchLineByLine(o,p,r,t)}static _doFindPreviousMatchMultiline(o,a,p,t){const s=this._doFindMatchesMultiline(o,new C.Range(1,1,a.lineNumber,a.column),p,t,10*E);if(s.length>0)return s[s.length-1];const r=o.getLineCount();return a.lineNumber!==r||a.column!==o.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(o,new I.Position(r,o.getLineMaxColumn(r)),p,t):null}static _doFindPreviousMatchLineByLine(o,a,p,t){const s=o.getLineCount(),r=a.lineNumber,i=o.getLineContent(r).substring(0,a.column-1),f=this._findLastMatchInLine(p,i,r,t);if(f)return f;for(let l=1;l<=s;l++){const d=(s+r-l-1)%s,b=o.getLineContent(d+1),y=this._findLastMatchInLine(p,b,d+1,t);if(y)return y}return null}static _findLastMatchInLine(o,a,p,t){let s=null,r;for(o.reset(0);r=o.next(a);)s=P(new C.Range(p,r.index+1,p,r.index+1+r[0].length),r,t);return s}}e.TextModelSearch=m;function u(_,o,a,p,t){if(p===0)return!0;const s=o.charCodeAt(p-1);if(_.get(s)!==0||s===13||s===10)return!0;if(t>0){const r=o.charCodeAt(p);if(_.get(r)!==0)return!0}return!1}function h(_,o,a,p,t){if(p+t===a)return!0;const s=o.charCodeAt(p+t);if(_.get(s)!==0||s===13||s===10)return!0;if(t>0){const r=o.charCodeAt(p+t-1);if(_.get(r)!==0)return!0}return!1}function D(_,o,a,p,t){return u(_,o,a,p,t)&&h(_,o,a,p,t)}e.isValidMatch=D;class k{constructor(o,a){this._wordSeparators=o,this._searchRegex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const a=o.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===a||(p=this._searchRegex.exec(o),!p))return null;const t=p.index,s=p[0].length;if(t===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){g.getNextCodePoint(o,a,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=s,!this._wordSeparators||D(this._wordSeparators,o,a,t,s))return p}while(p);return null}}e.Searcher=k}),define(me[110],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(E=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)E.indexOf(T)>=0||(S+="\\"+T);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=g();function L(E){let S=e.DEFAULT_WORD_REGEXP;if(E&&E instanceof RegExp)if(E.global)S=E;else{let T="g";E.ignoreCase&&(T+="i"),E.multiline&&(T+="m"),E.unicode&&(T+="u"),S=new RegExp(E.source,T)}return S.lastIndex=0,S}e.ensureValidWordDefinition=L;const I={maxLen:1e3,windowSize:15,timeBudget:150};function C(E,S,T,n,P=I){if(T.length>P.maxLen){let D=E-P.maxLen/2;return D<0?D=0:n+=D,T=T.substring(D,E+P.maxLen/2),C(E,S,T,n,P)}const c=Date.now(),m=E-1-n;let u=-1,h=null;for(let D=1;!(Date.now()-c>=P.timeBudget);D++){const k=m-P.windowSize*D;S.lastIndex=Math.max(0,k);const _=R(S,T,m,u);if(!_&&h||(h=_,k<=0))break;u=k}if(h){let D={word:h[0],startColumn:n+1+h.index,endColumn:n+1+h.index+h[0].length};return S.lastIndex=0,D}return null}e.getWordAtText=C;function R(E,S,T,n){let P;for(;P=E.exec(S);){const c=P.index||0;if(c<=T&&E.lastIndex>=T)return P;if(n>0&&c>n)return null}return null}}),define(me[147],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class L{constructor(E){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=E.open,this.close=E.close,this._standardTokenMask=0,Array.isArray(E.notIn))for(let S=0,T=E.notIn.length;S<T;S++)switch(E.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(E){return(this._standardTokenMask&E)==0}}e.StandardAutoClosingPairConditional=L;class I{constructor(E){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of E)C(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),C(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),C(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),C(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&C(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=I;function C(R,E,S){R.has(E)?R.get(E).push(S):R.set(E,[S])}}),define(me[81],ge([0,1,30,8]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(C,R,E,S){if(Array.isArray(C)){let T=0;for(const n of C){const P=I(n,R,E,S);if(P===10)return P;P>T&&(T=P)}return T}else{if(typeof C=="string")return S?C==="*"?5:C===E?10:0:0;if(C){const{language:T,pattern:n,scheme:P,hasAccessToAllModels:c}=C;if(!S&&!c)return 0;let m=0;if(P)if(P===R.scheme)m=10;else if(P==="*")m=5;else return 0;if(T)if(T===E)m=10;else if(T==="*")m=Math.max(m,5);else return 0;if(n){let u;if(typeof n=="string"?u=n:u={...n,base:(0,L.normalize)(n.base)},u===R.fsPath||(0,g.match)(u,R.fsPath))m=10;else return 0}return m}else return 0}}e.score=I}),define(me[148],ge([0,1,108]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class I{constructor(u,h,D){const k=new Uint8Array(u*h);for(let _=0,o=u*h;_<o;_++)k[_]=D;this._data=k,this.rows=u,this.cols=h}get(u,h){return this._data[u*this.cols+h]}set(u,h,D){this._data[u*this.cols+h]=D}}e.Uint8Matrix=I;class C{constructor(u){let h=0,D=0;for(let _=0,o=u.length;_<o;_++){let[a,p,t]=u[_];p>h&&(h=p),a>D&&(D=a),t>D&&(D=t)}h++,D++;let k=new I(D,h,0);for(let _=0,o=u.length;_<o;_++){let[a,p,t]=u[_];k.set(a,p,t)}this._states=k,this._maxCharCode=h}nextState(u,h){return h<0||h>=this._maxCharCode?0:this._states.get(u,h)}}e.StateMachine=C;let R=null;function E(){return R===null&&(R=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var S;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let T=null;function n(){if(T===null){T=new g.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<m.length;h++)T.set(m.charCodeAt(h),1);const u=".,;";for(let h=0;h<u.length;h++)T.set(u.charCodeAt(h),2)}return T}class P{static _createLink(u,h,D,k,_){let o=_-1;do{const a=h.charCodeAt(o);if(u.get(a)!==2)break;o--}while(o>k);if(k>0){const a=h.charCodeAt(k-1),p=h.charCodeAt(o);(a===40&&p===41||a===91&&p===93||a===123&&p===125)&&o--}return{range:{startLineNumber:D,startColumn:k+1,endLineNumber:D,endColumn:o+2},url:h.substring(k,o+1)}}static computeLinks(u,h=E()){const D=n();let k=[];for(let _=1,o=u.getLineCount();_<=o;_++){const a=u.getLineContent(_),p=a.length;let t=0,s=0,r=0,i=1,f=!1,l=!1,d=!1,b=!1;for(;t<p;){let y=!1;const v=a.charCodeAt(t);if(i===13){let A;switch(v){case 40:f=!0,A=0;break;case 41:A=f?0:1;break;case 91:d=!0,l=!0,A=0;break;case 93:d=!1,A=l?0:1;break;case 123:b=!0,A=0;break;case 125:A=b?0:1;break;case 39:A=r===34||r===96?0:1;break;case 34:A=r===39||r===96?0:1;break;case 96:A=r===39||r===34?0:1;break;case 42:A=r===42?1:0;break;case 124:A=r===124?1:0;break;case 32:A=d?0:1;break;default:A=D.get(v)}A===1&&(k.push(P._createLink(D,a,_,s,t)),y=!0)}else if(i===12){let A;v===91?(l=!0,A=0):A=D.get(v),A===1?y=!0:i=13}else i=h.nextState(i,v),i===0&&(y=!0);y&&(i=1,f=!1,l=!1,b=!1,s=t+1,r=v),t++}i===13&&k.push(P._createLink(D,a,_,s,p))}return k}}e.LinkComputer=P;function c(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:P.computeLinks(m)}e.computeLinks=c}),define(me[149],ge([0,1,3,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class I{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(R){this._onDidChange.fire({changedLanguages:R,changedColorMap:!1})}register(R,E){return this._map.set(R,E),this.fire([R]),(0,L.toDisposable)(()=>{this._map.get(R)===E&&(this._map.delete(R),this.fire([R]))})}registerPromise(R,E){let S=null,T=!1;return this._promises.set(R,E.then(n=>{this._promises.delete(R),!(T||!n)&&(S=this.register(R,n))})),(0,L.toDisposable)(()=>{T=!0,S&&S.dispose()})}getPromise(R){const E=this.get(R);if(E)return Promise.resolve(E);const S=this._promises.get(R);return S?S.then(T=>this.get(R)):null}get(R){return this._map.get(R)||null}setColorMap(R){this._colorMap=R,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=I}),define(me[111],ge([0,1,23,11]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(I||(I={}));function C(P){for(let c=0,m=P.length;c<m;c+=4){const u=P[c+0],h=P[c+1],D=P[c+2],k=P[c+3];P[c+0]=k,P[c+1]=D,P[c+2]=h,P[c+3]=u}}function R(P){const c=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return L.isLittleEndian()||C(c),g.VSBuffer.wrap(c)}function E(P){const c=P.buffer;if(L.isLittleEndian()||C(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const m=new Uint8Array(c.byteLength);return m.set(c),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function S(P){const c=new Uint32Array(T(P));let m=0;if(c[m++]=P.id,P.type==="full")c[m++]=1,c[m++]=P.data.length,c.set(P.data,m),m+=P.data.length;else{c[m++]=2,c[m++]=P.deltas.length;for(const u of P.deltas)c[m++]=u.start,c[m++]=u.deleteCount,u.data?(c[m++]=u.data.length,c.set(u.data,m),m+=u.data.length):c[m++]=0}return R(c)}e.encodeSemanticTokensDto=S;function T(P){let c=0;if(c+=1+1,P.type==="full")c+=1+P.data.length;else{c+=1,c+=(1+1+1)*P.deltas.length;for(const m of P.deltas)m.data&&(c+=m.data.length)}return c}function n(P){const c=E(P);let m=0;const u=c[m++];if(c[m++]===1){const _=c[m++],o=c.subarray(m,m+_);return m+=_,{id:u,type:"full",data:o}}const D=c[m++];let k=[];for(let _=0;_<D;_++){const o=c[m++],a=c[m++],p=c[m++];let t;p>0&&(t=c.subarray(m,m+p),m+=p),k[_]={start:o,deleteCount:a,data:t}}return{id:u,type:"delta",deltas:k}}e.decodeSemanticTokensDto=n}),define(me[112],ge([0,1,97]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(R,E){this._prefixSumIndexOfResultBrand=void 0,this.index=R,this.remainder=E}}e.PrefixSumIndexOfResult=L;class I{constructor(R){this.values=R,this.prefixSum=new Uint32Array(R.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(R,E){R=(0,g.toUint32)(R);const S=this.values,T=this.prefixSum,n=E.length;return n===0?!1:(this.values=new Uint32Array(S.length+n),this.values.set(S.subarray(0,R),0),this.values.set(S.subarray(R),R+n),this.values.set(E,R),R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(R,E){return R=(0,g.toUint32)(R),E=(0,g.toUint32)(E),this.values[R]===E?!1:(this.values[R]=E,R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),!0)}removeValues(R,E){R=(0,g.toUint32)(R),E=(0,g.toUint32)(E);const S=this.values,T=this.prefixSum;if(R>=S.length)return!1;let n=S.length-R;return E>=n&&(E=n),E===0?!1:(this.values=new Uint32Array(S.length-E),this.values.set(S.subarray(0,R),0),this.values.set(S.subarray(R+E),R),this.prefixSum=new Uint32Array(this.values.length),R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(R){return R<0?0:(R=(0,g.toUint32)(R),this._getPrefixSum(R))}_getPrefixSum(R){if(R<=this.prefixSumValidIndex[0])return this.prefixSum[R];let E=this.prefixSumValidIndex[0]+1;E===0&&(this.prefixSum[0]=this.values[0],E++),R>=this.values.length&&(R=this.values.length-1);for(let S=E;S<=R;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],R),this.prefixSum[R]}getIndexOf(R){R=Math.floor(R),this.getTotalSum();let E=0,S=this.values.length-1,T=0,n=0,P=0;for(;E<=S;)if(T=E+(S-E)/2|0,n=this.prefixSum[T],P=n-this.values[T],R<P)S=T-1;else if(R>=n)E=T+1;else break;return new L(T,R-P)}}e.PrefixSumComputer=I}),define(me[150],ge([0,1,9,51,112]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(E,S,T,n){this._uri=E,this._lines=S,this._eol=T,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(E){E.eol&&E.eol!==this._eol&&(this._eol=E.eol,this._lineStarts=null);const S=E.changes;for(const T of S)this._acceptDeleteRange(T.range),this._acceptInsertText(new L.Position(T.range.startLineNumber,T.range.startColumn),T.text);this._versionId=E.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const E=this._eol.length,S=this._lines.length,T=new Uint32Array(S);for(let n=0;n<S;n++)T[n]=this._lines[n].length+E;this._lineStarts=new I.PrefixSumComputer(T)}}_setLineText(E,S){this._lines[E]=S,this._lineStarts&&this._lineStarts.changeValue(E,this._lines[E].length+this._eol.length)}_acceptDeleteRange(E){if(E.startLineNumber===E.endLineNumber){if(E.startColumn===E.endColumn)return;this._setLineText(E.startLineNumber-1,this._lines[E.startLineNumber-1].substring(0,E.startColumn-1)+this._lines[E.startLineNumber-1].substring(E.endColumn-1));return}this._setLineText(E.startLineNumber-1,this._lines[E.startLineNumber-1].substring(0,E.startColumn-1)+this._lines[E.endLineNumber-1].substring(E.endColumn-1)),this._lines.splice(E.startLineNumber,E.endLineNumber-E.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(E.startLineNumber,E.endLineNumber-E.startLineNumber)}_acceptInsertText(E,S){if(S.length===0)return;let T=(0,g.splitLines)(S);if(T.length===1){this._setLineText(E.lineNumber-1,this._lines[E.lineNumber-1].substring(0,E.column-1)+T[0]+this._lines[E.lineNumber-1].substring(E.column-1));return}T[T.length-1]+=this._lines[E.lineNumber-1].substring(E.column-1),this._setLineText(E.lineNumber-1,this._lines[E.lineNumber-1].substring(0,E.column-1)+T[0]);let n=new Uint32Array(T.length-1);for(let P=1;P<T.length;P++)this._lines.splice(E.lineNumber+P-1,0,T[P]),n[P-1]=T[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(E.lineNumber,n)}}e.MirrorTextModel=C}),define(me[151],ge([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(me[152],ge([0,1,151]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,I=L*60,C=I*24,R=C*7,E=C*30,S=C*365;function T(P,c){typeof P!="number"&&(P=P.getTime());const m=Math.round((new Date().getTime()-P)/1e3);if(m<-30)return(0,g.localize)(0,null,T(new Date().getTime()+m*1e3,!1));if(m<30)return(0,g.localize)(1,null);let u;return m<L?(u=m,c?u===1?(0,g.localize)(2,null,u):(0,g.localize)(3,null,u):u===1?(0,g.localize)(4,null,u):(0,g.localize)(5,null,u)):m<I?(u=Math.floor(m/L),c?u===1?(0,g.localize)(6,null,u):(0,g.localize)(7,null,u):u===1?(0,g.localize)(8,null,u):(0,g.localize)(9,null,u)):m<C?(u=Math.floor(m/I),c?u===1?(0,g.localize)(10,null,u):(0,g.localize)(11,null,u):u===1?(0,g.localize)(12,null,u):(0,g.localize)(13,null,u)):m<R?(u=Math.floor(m/C),c?u===1?(0,g.localize)(14,null,u):(0,g.localize)(15,null,u):u===1?(0,g.localize)(16,null,u):(0,g.localize)(17,null,u)):m<E?(u=Math.floor(m/R),c?u===1?(0,g.localize)(18,null,u):(0,g.localize)(19,null,u):u===1?(0,g.localize)(20,null,u):(0,g.localize)(21,null,u)):m<S?(u=Math.floor(m/E),c?u===1?(0,g.localize)(22,null,u):(0,g.localize)(23,null,u):u===1?(0,g.localize)(24,null,u):(0,g.localize)(25,null,u)):(u=Math.floor(m/S),c?u===1?(0,g.localize)(26,null,u):(0,g.localize)(27,null,u):u===1?(0,g.localize)(28,null,u):(0,g.localize)(29,null,u))}e.fromNow=T;function n(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(me[153],ge([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(me[61],ge([0,1,17,13,153]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(T,n){return n&&(T.stack||T.stacktrace)?I.localize(0,null,E(T),R(T.stack)||R(T.stacktrace)):E(T)}function R(T){return Array.isArray(T)?T.join(`
`):T}function E(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?I.localize(1,null,T.message):T.message||I.localize(2,null)}function S(T=null,n=!1){if(!T)return I.localize(3,null);if(Array.isArray(T)){const P=g.coalesce(T),c=S(P[0],n);return P.length>1?I.localize(4,null,c,P.length):c}if(L.isString(T))return T;if(T.detail){const P=T.detail;if(P.error)return C(P.error,n);if(P.exception)return C(P.exception,n)}return T.stack?C(T,n):T.message?T.message:I.localize(5,null)}e.toErrorMessage=S}),define(me[154],ge([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(me[113],ge([0,1,39,29,10,25,8,11,38,13,143,28,154]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function m(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(a,p){if(E.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};p&&(t.cwd=p);const s=g.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],t);return new Promise(r=>{s.once("error",i=>{r({success:!1,error:i})}),s.once("exit",(i,f)=>{r(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?m(t.status):1})}else if(E.isLinux||E.isMacintosh)try{const t=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(s=>{g.execFile(t,[a.pid.toString()],{encoding:"utf8",shell:!0},(r,i,f)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function h(a=S.env){return a.comspec||"cmd.exe"}e.getWindowsShell=h;class D{constructor(p,t,s,r){if(t!==void 0&&s!==void 0&&r!==void 0)this.cmd=p,this.args=t,this.shell=s,this.options=r;else{const i=p;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(S.env).forEach(f=>{i[f]=S.env[f]}),Object.keys(this.options.env).forEach(f=>{i[f]=this.options.env[f]}),this.options.env=i}}getSanitizedCommand(){let p=this.cmd.toLowerCase();const t=p.lastIndexOf(R.sep);return t!==-1&&(p=p.substring(t+1)),D.WellKnowCommands[p]?p:"other"}start(p){return E.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(S.cwd()))?Promise.reject(new Error(c.localize(0,null))):this.useExec().then(t=>{let s,r;const i=new Promise((f,l)=>{s=f,r=l});if(t){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=g.exec(f,this.options,(l,d,b)=>{this.childProcess=null;const y=l;y&&y.killed?r({killed:this.terminateRequested,stdout:d.toString(),stderr:b.toString()}):this.handleExec(s,p,l,d,b)})}else{let f=null;const l=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,s,p,r);const b={terminated:this.terminateRequested};T.isNumber(d)&&(b.cmdCode=d),s(b)};if(this.shell&&E.isWindows){const d=C.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let b=!1,y=!1;const v=[];let A=this.ensureQuotes(this.cmd);v.push(A.value),b=A.quoted,this.args&&this.args.forEach(F=>{A=this.ensureQuotes(F),v.push(A.value),y=y&&A.quoted});const w=["/s","/c"];b?y?w.push('"'+v.join(" ")+'"'):v.length>1?w.push('"'+v[0]+'" '+v.slice(1).join(" ")):w.push('"'+v[0]+'"'):w.push(v.join(" ")),f=g.spawn(h(),w,d)}else this.cmd&&(f=g.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(T.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",d=>{this.childProcess=null,r({terminated:this.terminateRequested,error:d})}),f.pid&&(this.childProcess.on("close",l),this.handleSpawn(f,s,p,r,!0)))}return i})}handleClose(p,t,s,r){}ensureQuotes(p){return D.regexp.test(p)?{value:'"'+p+'"',quoted:!0}:{value:p,quoted:p.length>0&&p[0]==='"'&&p[p.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(p=>p.pid,p=>-1):new Promise(p=>{this.pidResolve=p})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(p=>(this.terminateRequested=!0,u(p,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),p=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(p=>{if(!this.shell||!E.isWindows)return p(!1);const t=g.spawn(h(),["/s","/c"]);t.on("error",s=>p(!0)),t.on("exit",s=>p(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class k extends D{constructor(p,t,s,r){super(p,t,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(p,t,s,r,i){[r,i].forEach((f,l)=>{const d=new n.LineDecoder;d.write(f).forEach(v=>{t({line:v,source:l===0?0:1})});const y=d.end();y&&t({line:y,source:l===0?0:1})}),p({terminated:this.terminateRequested,error:s})}handleSpawn(p,t,s,r,i){const f=new n.LineDecoder,l=new n.LineDecoder;p.stdout.on("data",d=>{f.write(d).forEach(y=>s({line:y,source:0}))}),p.stderr.on("data",d=>{l.write(d).forEach(y=>s({line:y,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=l}handleClose(p,t,s,r){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&s({line:i,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&s({line:f,source:1})}}e.LineProcess=k;function _(a){let p=[],t=!1;const s=function(r){if(t){p.push(r);return}(!a.send(r,f=>{if(f&&console.error(f),t=!1,p.length>0){const l=p.slice(0);p=[],l.forEach(d=>s(d))}})||E.isWindows)&&(t=!0)};return{send:s}}e.createQueuedSender=_;var o;(function(a){async function p(t,s,r){if(R.isAbsolute(t))return t;if(s===void 0&&(s=S.cwd()),R.dirname(t)!=="."||(r===void 0&&T.isString(S.env.PATH)&&(r=S.env.PATH.split(R.delimiter)),r===void 0||r.length===0))return R.join(s,t);async function f(l){if(await P.Promises.exists(l)){let d;try{d=await P.Promises.stat(l)}catch(b){b.message.startsWith("EACCES")&&(d=await P.Promises.lstat(l))}return d?!d.isDirectory():!1}return!1}for(let l of r){let d;if(R.isAbsolute(l)?d=R.join(l,t):d=R.join(s,l,t),await f(d))return d;let b=d+".com";if(await f(b)||(b=d+".exe",await f(b)))return b}return R.join(s,t)}a.findExecutable=p})(o=e.win32||(e.win32={}))}),define(me[155],ge([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(me[114],ge([0,1,155,11,110]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var C;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(C=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=R;class E{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,pe){this._values[te]=pe}}e.ValidatedEditorOptions=E;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class T{constructor(te,pe,xe,Ye){this.id=te,this.name=pe,this.defaultValue=xe,this.schema=Ye}compute(te,pe,xe){return xe}}class n{constructor(te,pe=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(te){return this.defaultValue}}class P{constructor(te,pe,xe,Ye){this.id=te,this.name=pe,this.defaultValue=xe,this.schema=Ye}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,pe,xe){return xe}}function c(Z,te){return typeof Z=="undefined"?te:Z==="false"?!1:Boolean(Z)}e.boolean=c;class m extends P{constructor(te,pe,xe,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=xe),super(te,pe,xe,Ye)}validate(te){return c(te,this.defaultValue)}}class u extends P{constructor(te,pe,xe,Ye,rt,ft=void 0){typeof ft!="undefined"&&(ft.type="integer",ft.default=xe,ft.minimum=Ye,ft.maximum=rt),super(te,pe,xe,ft),this.minimum=Ye,this.maximum=rt}static clampedInt(te,pe,xe,Ye){if(typeof te=="undefined")return pe;let rt=parseInt(te,10);return isNaN(rt)?pe:(rt=Math.max(xe,rt),rt=Math.min(Ye,rt),rt|0)}validate(te){return u.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class h extends P{constructor(te,pe,xe,Ye,rt){typeof rt!="undefined"&&(rt.type="number",rt.default=xe),super(te,pe,xe,rt),this.validationFn=Ye}static clamp(te,pe,xe){return te<pe?pe:te>xe?xe:te}static float(te,pe){if(typeof te=="number")return te;if(typeof te=="undefined")return pe;const xe=parseFloat(te);return isNaN(xe)?pe:xe}validate(te){return this.validationFn(h.float(te,this.defaultValue))}}class D extends P{static string(te,pe){return typeof te!="string"?pe:te}constructor(te,pe,xe,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=xe),super(te,pe,xe,Ye)}validate(te){return D.string(te,this.defaultValue)}}function k(Z,te,pe){return typeof Z!="string"||pe.indexOf(Z)===-1?te:Z}e.stringSet=k;class _ extends P{constructor(te,pe,xe,Ye,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=Ye,rt.default=xe),super(te,pe,xe,rt),this._allowedValues=Ye}validate(te){return k(te,this.defaultValue,this._allowedValues)}}class o extends T{constructor(te,pe,xe,Ye,rt,ft,pt=void 0){typeof pt!="undefined"&&(pt.type="string",pt.enum=rt,pt.default=Ye),super(te,pe,xe,pt),this._allowedValues=rt,this._convert=ft}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function a(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,pe,xe){return xe===0?te.accessibilitySupport:xe}}class t extends T{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:g.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertSpace:c(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function f(Z){switch(Z){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function l(Z){switch(Z){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class d extends n{constructor(){super(127,[65,32])}compute(te,pe,xe){const Ye=["monaco-editor"];return pe.get(32)&&Ye.push(pe.get(32)),te.extraEditorClassName&&Ye.push(te.extraEditorClassName),pe.get(65)==="default"?Ye.push("mouse-default"):pe.get(65)==="copy"&&Ye.push("mouse-copy"),pe.get(100)&&Ye.push("showUnused"),pe.get(125)&&Ye.push("showDeprecated"),Ye.join(" ")}}class b extends m{constructor(){super(31,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(te,pe,xe){return xe&&te.emptySelectionClipboard}}class y extends T{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:te.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:g.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:g.localize(18,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{cursorMoveOnType:c(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof te.seedSearchStringFromSelection=="boolean"?te.seedSearchStringFromSelection?"always":"never":k(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":k(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(pe.loop,this.defaultValue.loop)}}}class v extends T{constructor(){super(43,"fontLigatures",v.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?v.OFF:te==="true"?v.ON:te:Boolean(te)?v.ON:v.OFF}}e.EditorFontLigatures=v,v.OFF='"liga" off, "calt" off',v.ON='"liga" on, "calt" on';class A extends n{constructor(){super(42)}compute(te,pe,xe){return te.fontInfo}}class w extends P{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(te){let pe=h.float(te,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(pe,6,100)}compute(te,pe,xe){return te.fontInfo.fontSize}}class F extends T{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:F.MINIMUM_VALUE,maximum:F.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:F.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(te){return te==="normal"||te==="bold"?te:String(u.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,F.MINIMUM_VALUE,F.MAXIMUM_VALUE))}}F.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],F.MINIMUM_VALUE=1,F.MAXIMUM_VALUE=1e3;class O extends T{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:xe,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:xe,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:xe,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:xe,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:xe,description:g.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{multiple:k(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??k(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??k(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??k(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??k(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??k(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:D.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:D.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:D.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:D.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:D.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class G extends T{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(52,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:te.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:g.localize(41,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),delay:u.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:c(pe.sticky,this.defaultValue.sticky)}}}var K;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(K=e.RenderMinimap||(e.RenderMinimap={}));class U extends n{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(te,pe,xe){return U.computeLayout(pe,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const pe=te.height/te.lineHeight,xe=te.scrollBeyondLastLine?pe-1:0,Ye=(te.viewLineCount+xe)/(te.pixelRatio*te.height),rt=Math.floor(te.viewLineCount/Ye);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:xe,desiredRatio:Ye,minimapLineCount:rt}}static _computeMinimapLayout(te,pe){const xe=te.outerWidth,Ye=te.outerHeight,rt=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const ft=pe.stableMinimapLayoutInput,pt=ft&&te.outerHeight===ft.outerHeight&&te.lineHeight===ft.lineHeight&&te.typicalHalfwidthCharacterWidth===ft.typicalHalfwidthCharacterWidth&&te.pixelRatio===ft.pixelRatio&&te.scrollBeyondLastLine===ft.scrollBeyondLastLine&&te.minimap.enabled===ft.minimap.enabled&&te.minimap.side===ft.minimap.side&&te.minimap.size===ft.minimap.size&&te.minimap.showSlider===ft.minimap.showSlider&&te.minimap.renderCharacters===ft.minimap.renderCharacters&&te.minimap.maxColumn===ft.minimap.maxColumn&&te.minimap.scale===ft.minimap.scale&&te.verticalScrollbarWidth===ft.verticalScrollbarWidth&&te.isViewportWrapping===ft.isViewportWrapping,St=te.lineHeight,Ct=te.typicalHalfwidthCharacterWidth,ue=te.scrollBeyondLastLine,Ie=te.minimap.renderCharacters;let Ue=rt>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const Qe=te.minimap.maxColumn,ze=te.minimap.size,at=te.minimap.side,Le=te.verticalScrollbarWidth,De=te.viewLineCount,ke=te.remainingWidth,ne=te.isViewportWrapping,de=Ie?2:3;let be=Math.floor(rt*Ye);const we=be/rt;let Fe=!1,Ge=!1,He=de*Ue,Je=Ue/rt,it=1;if(ze==="fill"||ze==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeyondLastLine:Xe,desiredRatio:ot,minimapLineCount:vt}=U.computeContainedMinimapLineCount({viewLineCount:De,scrollBeyondLastLine:ue,height:Ye,lineHeight:St,pixelRatio:rt});if(De/vt>1)Fe=!0,Ge=!0,Ue=1,He=1,Je=Ue/rt;else{let lt=!1,dt=Ue+1;if(ze==="fit"){const mt=Math.ceil((De+Xe)*He);ne&&pt&&ke<=pe.stableFitRemainingWidth?(lt=!0,dt=pe.stableFitMaxMinimapScale):lt=mt>be}if(ze==="fill"||lt){Fe=!0;const mt=Ue;He=Math.min(St*rt,Math.max(1,Math.floor(1/ot))),ne&&pt&&ke<=pe.stableFitRemainingWidth&&(dt=pe.stableFitMaxMinimapScale),Ue=Math.min(dt,Math.max(1,Math.floor(He/de))),Ue>mt&&(it=Math.min(2,Ue/mt)),Je=Ue/rt/it,be=Math.ceil(Math.max(Ze,De+Xe)*He),ne?(pe.stableMinimapLayoutInput=te,pe.stableFitRemainingWidth=ke,pe.stableFitMaxMinimapScale=Ue):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const le=Math.floor(Qe*Je),Ee=Math.min(le,Math.max(0,Math.floor((ke-Le-2)*Je/(Ct+Je)))+e.MINIMAP_GUTTER_WIDTH);let ce=Math.floor(rt*Ee);const q=ce/rt;ce=Math.floor(ce*it);const Ae=Ie?1:2,Pe=at==="left"?0:xe-Ee-Le;return{renderMinimap:Ae,minimapLeft:Pe,minimapWidth:Ee,minimapHeightIsEditorHeight:Fe,minimapIsSampling:Ge,minimapScale:Ue,minimapLineHeight:He,minimapCanvasInnerWidth:ce,minimapCanvasInnerHeight:be,minimapCanvasOuterWidth:q,minimapCanvasOuterHeight:we}}static computeLayout(te,pe){const xe=pe.outerWidth|0,Ye=pe.outerHeight|0,rt=pe.lineHeight|0,ft=pe.lineNumbersDigitCount|0,pt=pe.typicalHalfwidthCharacterWidth,St=pe.maxDigitWidth,Ct=pe.pixelRatio,ue=pe.viewLineCount,Ie=te.get(122),Ue=Ie==="inherit"?te.get(121):Ie,Qe=Ue==="inherit"?te.get(117):Ue,ze=te.get(120),at=te.get(2),Le=pe.isDominatedByLongLines,De=te.get(48),ke=te.get(59).renderType!==0,ne=te.get(60),de=te.get(94),be=te.get(64),we=te.get(92),Fe=we.verticalScrollbarSize,Ge=we.verticalHasArrows,He=we.arrowSize,Je=we.horizontalScrollbarSize,it=te.get(57),le=te.get(36);let Ee;if(typeof it=="string"&&/^\d+(\.\d+)?ch$/.test(it)){const Ot=parseFloat(it.substr(0,it.length-2));Ee=u.clampedInt(Ot*pt,0,0,1e3)}else Ee=u.clampedInt(it,0,0,1e3);le&&(Ee+=16);let ce=0;if(ke){const Ot=Math.max(ft,ne);ce=Math.round(Ot*St)}let q=0;De&&(q=rt);let Ae=0,Pe=Ae+q,Ze=Pe+ce,Xe=Ze+Ee;const ot=xe-q-ce-Ee;let vt=!1,Et=!1,lt=-1;at!==2&&(Ue==="inherit"&&Le?(vt=!0,Et=!0):Qe==="on"||Qe==="bounded"?Et=!0:Qe==="wordWrapColumn"&&(lt=ze));const dt=U._computeMinimapLayout({outerWidth:xe,outerHeight:Ye,lineHeight:rt,typicalHalfwidthCharacterWidth:pt,pixelRatio:Ct,scrollBeyondLastLine:de,minimap:be,verticalScrollbarWidth:Fe,viewLineCount:ue,remainingWidth:ot,isViewportWrapping:Et},pe.memory||new S);dt.renderMinimap!==0&&dt.minimapLeft===0&&(Ae+=dt.minimapWidth,Pe+=dt.minimapWidth,Ze+=dt.minimapWidth,Xe+=dt.minimapWidth);const mt=ot-dt.minimapWidth,Rt=Math.max(1,Math.floor((mt-Fe-2)/pt)),yt=Ge?He:0;return Et&&(lt=Math.max(1,Rt),Qe==="bounded"&&(lt=Math.min(lt,ze))),{width:xe,height:Ye,glyphMarginLeft:Ae,glyphMarginWidth:q,lineNumbersLeft:Pe,lineNumbersWidth:ce,decorationsLeft:Ze,decorationsWidth:Ee,contentLeft:Xe,contentWidth:mt,minimap:dt,viewportColumn:Rt,isWordWrapMinified:vt,isViewportWrapping:Et,wrappingColumn:lt,verticalScrollbarWidth:Fe,horizontalScrollbarHeight:Je,overviewRuler:{top:yt,width:Fe,height:Ye-2*yt,right:0}}}}e.EditorLayoutInfoComputer=U;class z extends T{constructor(){const te={enabled:!0};super(56,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:g.localize(42,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:c(te.enabled,this.defaultValue.enabled)}}}class N extends T{constructor(){const te={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:g.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,markdownDescription:g.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,markdownDescription:g.localize(45,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:D.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class B extends h{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,te=>h.clamp(te,0,150),{markdownDescription:g.localize(46,null)})}compute(te,pe,xe){return te.fontInfo.lineHeight}}class x extends T{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:g.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(48,null),g.localize(49,null),g.localize(50,null)],default:te.size,description:g.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:g.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:g.localize(53,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:g.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:g.localize(56,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),size:k(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:k(pe.side,this.defaultValue.side,["right","left"]),showSlider:k(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(pe.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(pe.scale,1,1,3),maxColumn:u.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(Z){return Z==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class H extends T{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{top:u.clampedInt(pe.top,0,0,1e3),bottom:u.clampedInt(pe.bottom,0,0,1e3)}}}class $ extends T{constructor(){const te={enabled:!0,cycle:!1};super(75,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:g.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:g.localize(60,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),cycle:c(pe.cycle,this.defaultValue.cycle)}}}class Q extends n{constructor(){super(128)}compute(te,pe,xe){return te.pixelRatio}}class X extends T{constructor(){const te={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:g.localize(61,null)},comments:{type:"boolean",default:te.comments,description:g.localize(62,null)},other:{type:"boolean",default:te.other,description:g.localize(63,null)}}}],default:te,description:g.localize(64,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const pe=te,xe={other:c(pe.other,this.defaultValue.other),comments:c(pe.comments,this.defaultValue.comments),strings:c(pe.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var he;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(he=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class _e extends T{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(65,null),g.localize(66,null),g.localize(67,null),g.localize(68,null)],default:"on",description:g.localize(69,null)})}validate(te){let pe=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(pe=4,xe=te):te==="interval"?pe=3:te==="relative"?pe=2:te==="on"?pe=1:pe=0),{renderType:pe,renderFn:xe}}}function ye(Z){const te=Z.get(87);return te==="editable"?Z.get(80):te!=="on"}e.filterValidationDecorations=ye;class Re extends T{constructor(){const te=[],pe={type:"number",description:g.localize(70,null)};super(91,"rulers",te,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:g.localize(71,null),format:"color-hex"}}}]},default:te,description:g.localize(72,null)})}validate(te){if(Array.isArray(te)){let pe=[];for(let xe of te)if(typeof xe=="number")pe.push({column:u.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const Ye=xe;pe.push({column:u.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return pe.sort((xe,Ye)=>xe.column-Ye.column),pe}return this.defaultValue}}function We(Z,te){if(typeof Z!="string")return te;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Be extends T{constructor(){const te={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",te,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(73,null),g.localize(74,null),g.localize(75,null)],default:"auto",description:g.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(77,null),g.localize(78,null),g.localize(79,null)],default:"auto",description:g.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:te.verticalScrollbarSize,description:g.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:te.horizontalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:te.scrollByPage,description:g.localize(83,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te,xe=u.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=u.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:We(pe.vertical,this.defaultValue.vertical),horizontal:We(pe.horizontal,this.defaultValue.horizontal),useShadows:c(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:u.clampedInt(pe.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:u.clampedInt(pe.verticalSliderSize,Ye,0,1e3),scrollByPage:c(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class je extends T{constructor(){const te={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",te,{"editor.inlineSuggest.enabled":{type:"boolean",default:te.enabled,description:g.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(85,null),g.localize(86,null),g.localize(87,null)],default:te.mode,description:g.localize(88,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),mode:k(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class V extends T{constructor(){const te={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",te,{"editor.bracketPairColorization.enabled":{type:"boolean",default:te.enabled,description:g.localize(89,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:c(te.enabled,this.defaultValue.enabled)}}}class ee extends T{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(90,null),g.localize(91,null)],default:te.insertMode,description:g.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:g.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:g.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:g.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:g.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:g.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:g.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:te.preview,description:g.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(100,null),g.localize(101,null),g.localize(102,null)],default:te.previewMode,description:g.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:g.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(135,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertMode:k(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(pe.showIcons,this.defaultValue.showIcons),showStatusBar:c(pe.showStatusBar,this.defaultValue.showStatusBar),preview:c(pe.preview,this.defaultValue.preview),previewMode:k(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(pe.showMethods,this.defaultValue.showMethods),showFunctions:c(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:c(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:c(pe.showFields,this.defaultValue.showFields),showVariables:c(pe.showVariables,this.defaultValue.showVariables),showClasses:c(pe.showClasses,this.defaultValue.showClasses),showStructs:c(pe.showStructs,this.defaultValue.showStructs),showInterfaces:c(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:c(pe.showModules,this.defaultValue.showModules),showProperties:c(pe.showProperties,this.defaultValue.showProperties),showEvents:c(pe.showEvents,this.defaultValue.showEvents),showOperators:c(pe.showOperators,this.defaultValue.showOperators),showUnits:c(pe.showUnits,this.defaultValue.showUnits),showValues:c(pe.showValues,this.defaultValue.showValues),showConstants:c(pe.showConstants,this.defaultValue.showConstants),showEnums:c(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:c(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(pe.showKeywords,this.defaultValue.showKeywords),showWords:c(pe.showWords,this.defaultValue.showWords),showColors:c(pe.showColors,this.defaultValue.showColors),showFiles:c(pe.showFiles,this.defaultValue.showFiles),showReferences:c(pe.showReferences,this.defaultValue.showReferences),showFolders:c(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:c(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(pe.showSnippets,this.defaultValue.showSnippets),showUsers:c(pe.showUsers,this.defaultValue.showUsers),showIssues:c(pe.showIssues,this.defaultValue.showIssues)}}}class re extends T{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(136,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ae extends n{constructor(){super(129,[80])}compute(te,pe,xe){return pe.get(80)?!0:te.tabFocusMode}}var J;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(J=e.WrappingIndent||(e.WrappingIndent={}));function oe(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ve extends n{constructor(){super(131,[130])}compute(te,pe,xe){const Ye=pe.get(130);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const Me="Consolas, 'Courier New', monospace",qe="Menlo, Monaco, 'Courier New', monospace",Ke="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?qe:L.isLinux?Ke:Me,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Se(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var tt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.autoClosingBrackets=5]="autoClosingBrackets",Z[Z.autoClosingDelete=6]="autoClosingDelete",Z[Z.autoClosingOvertype=7]="autoClosingOvertype",Z[Z.autoClosingQuotes=8]="autoClosingQuotes",Z[Z.autoIndent=9]="autoIndent",Z[Z.automaticLayout=10]="automaticLayout",Z[Z.autoSurround=11]="autoSurround",Z[Z.bracketPairColorization=12]="bracketPairColorization",Z[Z.codeLens=13]="codeLens",Z[Z.codeLensFontFamily=14]="codeLensFontFamily",Z[Z.codeLensFontSize=15]="codeLensFontSize",Z[Z.colorDecorators=16]="colorDecorators",Z[Z.columnSelection=17]="columnSelection",Z[Z.comments=18]="comments",Z[Z.contextmenu=19]="contextmenu",Z[Z.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=21]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=23]="cursorStyle",Z[Z.cursorSurroundingLines=24]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=26]="cursorWidth",Z[Z.disableLayerHinting=27]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",Z[Z.domReadOnly=29]="domReadOnly",Z[Z.dragAndDrop=30]="dragAndDrop",Z[Z.emptySelectionClipboard=31]="emptySelectionClipboard",Z[Z.extraEditorClassName=32]="extraEditorClassName",Z[Z.fastScrollSensitivity=33]="fastScrollSensitivity",Z[Z.find=34]="find",Z[Z.fixedOverflowWidgets=35]="fixedOverflowWidgets",Z[Z.folding=36]="folding",Z[Z.foldingStrategy=37]="foldingStrategy",Z[Z.foldingHighlight=38]="foldingHighlight",Z[Z.foldingImportsByDefault=39]="foldingImportsByDefault",Z[Z.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=41]="fontFamily",Z[Z.fontInfo=42]="fontInfo",Z[Z.fontLigatures=43]="fontLigatures",Z[Z.fontSize=44]="fontSize",Z[Z.fontWeight=45]="fontWeight",Z[Z.formatOnPaste=46]="formatOnPaste",Z[Z.formatOnType=47]="formatOnType",Z[Z.glyphMargin=48]="glyphMargin",Z[Z.gotoLocation=49]="gotoLocation",Z[Z.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",Z[Z.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",Z[Z.hover=52]="hover",Z[Z.inDiffEditor=53]="inDiffEditor",Z[Z.inlineSuggest=54]="inlineSuggest",Z[Z.letterSpacing=55]="letterSpacing",Z[Z.lightbulb=56]="lightbulb",Z[Z.lineDecorationsWidth=57]="lineDecorationsWidth",Z[Z.lineHeight=58]="lineHeight",Z[Z.lineNumbers=59]="lineNumbers",Z[Z.lineNumbersMinChars=60]="lineNumbersMinChars",Z[Z.linkedEditing=61]="linkedEditing",Z[Z.links=62]="links",Z[Z.matchBrackets=63]="matchBrackets",Z[Z.minimap=64]="minimap",Z[Z.mouseStyle=65]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=67]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=69]="multiCursorModifier",Z[Z.multiCursorPaste=70]="multiCursorPaste",Z[Z.occurrencesHighlight=71]="occurrencesHighlight",Z[Z.overviewRulerBorder=72]="overviewRulerBorder",Z[Z.overviewRulerLanes=73]="overviewRulerLanes",Z[Z.padding=74]="padding",Z[Z.parameterHints=75]="parameterHints",Z[Z.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=78]="quickSuggestions",Z[Z.quickSuggestionsDelay=79]="quickSuggestionsDelay",Z[Z.readOnly=80]="readOnly",Z[Z.renameOnType=81]="renameOnType",Z[Z.renderControlCharacters=82]="renderControlCharacters",Z[Z.renderIndentGuides=83]="renderIndentGuides",Z[Z.renderFinalNewline=84]="renderFinalNewline",Z[Z.renderLineHighlight=85]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=87]="renderValidationDecorations",Z[Z.renderWhitespace=88]="renderWhitespace",Z[Z.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",Z[Z.roundedSelection=90]="roundedSelection",Z[Z.rulers=91]="rulers",Z[Z.scrollbar=92]="scrollbar",Z[Z.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=94]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=95]="scrollPredominantAxis",Z[Z.selectionClipboard=96]="selectionClipboard",Z[Z.selectionHighlight=97]="selectionHighlight",Z[Z.selectOnLineNumbers=98]="selectOnLineNumbers",Z[Z.showFoldingControls=99]="showFoldingControls",Z[Z.showUnused=100]="showUnused",Z[Z.snippetSuggestions=101]="snippetSuggestions",Z[Z.smartSelect=102]="smartSelect",Z[Z.smoothScrolling=103]="smoothScrolling",Z[Z.stickyTabStops=104]="stickyTabStops",Z[Z.stopRenderingLineAfter=105]="stopRenderingLineAfter",Z[Z.suggest=106]="suggest",Z[Z.suggestFontSize=107]="suggestFontSize",Z[Z.suggestLineHeight=108]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",Z[Z.suggestSelection=110]="suggestSelection",Z[Z.tabCompletion=111]="tabCompletion",Z[Z.tabIndex=112]="tabIndex",Z[Z.unusualLineTerminators=113]="unusualLineTerminators",Z[Z.useShadowDOM=114]="useShadowDOM",Z[Z.useTabStops=115]="useTabStops",Z[Z.wordSeparators=116]="wordSeparators",Z[Z.wordWrap=117]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=120]="wordWrapColumn",Z[Z.wordWrapOverride1=121]="wordWrapOverride1",Z[Z.wordWrapOverride2=122]="wordWrapOverride2",Z[Z.wrappingIndent=123]="wrappingIndent",Z[Z.wrappingStrategy=124]="wrappingStrategy",Z[Z.showDeprecated=125]="showDeprecated",Z[Z.inlayHints=126]="inlayHints",Z[Z.editorClassName=127]="editorClassName",Z[Z.pixelRatio=128]="pixelRatio",Z[Z.tabFocusMode=129]="tabFocusMode",Z[Z.layoutInfo=130]="layoutInfo",Z[Z.wrappingInfo=131]="wrappingInfo"})(tt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(137,null)})),acceptSuggestionOnEnter:Se(new _(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(138,null),""],markdownDescription:g.localize(139,null)})),accessibilitySupport:Se(new p),accessibilityPageSize:Se(new u(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(140,null)})),ariaLabel:Se(new D(4,"ariaLabel",g.localize(141,null))),autoClosingBrackets:Se(new _(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(142,null),g.localize(143,null),""],description:g.localize(144,null)})),autoClosingDelete:Se(new _(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(145,null),""],description:g.localize(146,null)})),autoClosingOvertype:Se(new _(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(147,null),""],description:g.localize(148,null)})),autoClosingQuotes:Se(new _(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(149,null),g.localize(150,null),""],description:g.localize(151,null)})),autoIndent:Se(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[g.localize(152,null),g.localize(153,null),g.localize(154,null),g.localize(155,null),g.localize(156,null)],description:g.localize(157,null)})),automaticLayout:Se(new m(10,"automaticLayout",!1)),autoSurround:Se(new _(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(158,null),g.localize(159,null),g.localize(160,null),""],description:g.localize(161,null)})),bracketPairColorization:Se(new V),stickyTabStops:Se(new m(104,"stickyTabStops",!1,{description:g.localize(162,null)})),codeLens:Se(new m(13,"codeLens",!0,{description:g.localize(163,null)})),codeLensFontFamily:Se(new D(14,"codeLensFontFamily","",{description:g.localize(164,null)})),codeLensFontSize:Se(new u(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(165,null)})),colorDecorators:Se(new m(16,"colorDecorators",!0,{description:g.localize(166,null)})),columnSelection:Se(new m(17,"columnSelection",!1,{description:g.localize(167,null)})),comments:Se(new t),contextmenu:Se(new m(19,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new m(20,"copyWithSyntaxHighlighting",!0,{description:g.localize(168,null)})),cursorBlinking:Se(new o(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:g.localize(169,null)})),cursorSmoothCaretAnimation:Se(new m(22,"cursorSmoothCaretAnimation",!1,{description:g.localize(170,null)})),cursorStyle:Se(new o(23,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],l,{description:g.localize(171,null)})),cursorSurroundingLines:Se(new u(24,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(172,null)})),cursorSurroundingLinesStyle:Se(new _(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(173,null),g.localize(174,null)],description:g.localize(175,null)})),cursorWidth:Se(new u(26,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(176,null)})),disableLayerHinting:Se(new m(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new m(28,"disableMonospaceOptimizations",!1)),domReadOnly:Se(new m(29,"domReadOnly",!1)),dragAndDrop:Se(new m(30,"dragAndDrop",!0,{description:g.localize(177,null)})),emptySelectionClipboard:Se(new b),extraEditorClassName:Se(new D(32,"extraEditorClassName","")),fastScrollSensitivity:Se(new h(33,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:g.localize(178,null)})),find:Se(new y),fixedOverflowWidgets:Se(new m(35,"fixedOverflowWidgets",!1)),folding:Se(new m(36,"folding",!0,{description:g.localize(179,null)})),foldingStrategy:Se(new _(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(180,null),g.localize(181,null)],description:g.localize(182,null)})),foldingHighlight:Se(new m(38,"foldingHighlight",!0,{description:g.localize(183,null)})),foldingImportsByDefault:Se(new m(39,"foldingImportsByDefault",!1,{description:g.localize(184,null)})),unfoldOnClickAfterEndOfLine:Se(new m(40,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(185,null)})),fontFamily:Se(new D(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(186,null)})),fontInfo:Se(new A),fontLigatures2:Se(new v),fontSize:Se(new w),fontWeight:Se(new F),formatOnPaste:Se(new m(46,"formatOnPaste",!1,{description:g.localize(187,null)})),formatOnType:Se(new m(47,"formatOnType",!1,{description:g.localize(188,null)})),glyphMargin:Se(new m(48,"glyphMargin",!0,{description:g.localize(189,null)})),gotoLocation:Se(new O),hideCursorInOverviewRuler:Se(new m(50,"hideCursorInOverviewRuler",!1,{description:g.localize(190,null)})),highlightActiveIndentGuide:Se(new m(51,"highlightActiveIndentGuide",!0,{description:g.localize(191,null)})),hover:Se(new G),inDiffEditor:Se(new m(53,"inDiffEditor",!1)),letterSpacing:Se(new h(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>h.clamp(Z,-5,20),{description:g.localize(192,null)})),lightbulb:Se(new z),lineDecorationsWidth:Se(new P(57,"lineDecorationsWidth",10)),lineHeight:Se(new B),lineNumbers:Se(new _e),lineNumbersMinChars:Se(new u(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new m(61,"linkedEditing",!1,{description:g.localize(193,null)})),links:Se(new m(62,"links",!0,{description:g.localize(194,null)})),matchBrackets:Se(new _(63,"matchBrackets","always",["always","near","never"],{description:g.localize(195,null)})),minimap:Se(new x),mouseStyle:Se(new _(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new h(66,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:g.localize(196,null)})),mouseWheelZoom:Se(new m(67,"mouseWheelZoom",!1,{markdownDescription:g.localize(197,null)})),multiCursorMergeOverlapping:Se(new m(68,"multiCursorMergeOverlapping",!0,{description:g.localize(198,null)})),multiCursorModifier:Se(new o(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[g.localize(199,null),g.localize(200,null)],markdownDescription:g.localize(201,null)})),multiCursorPaste:Se(new _(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(202,null),g.localize(203,null)],markdownDescription:g.localize(204,null)})),occurrencesHighlight:Se(new m(71,"occurrencesHighlight",!0,{description:g.localize(205,null)})),overviewRulerBorder:Se(new m(72,"overviewRulerBorder",!0,{description:g.localize(206,null)})),overviewRulerLanes:Se(new u(73,"overviewRulerLanes",3,0,3)),padding:Se(new H),parameterHints:Se(new $),peekWidgetDefaultFocus:Se(new _(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(207,null),g.localize(208,null)],description:g.localize(209,null)})),definitionLinkOpensInPeek:Se(new m(77,"definitionLinkOpensInPeek",!1,{description:g.localize(210,null)})),quickSuggestions:Se(new X),quickSuggestionsDelay:Se(new u(79,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(211,null)})),readOnly:Se(new m(80,"readOnly",!1)),renameOnType:Se(new m(81,"renameOnType",!1,{description:g.localize(212,null),markdownDeprecationMessage:g.localize(213,null)})),renderControlCharacters:Se(new m(82,"renderControlCharacters",!1,{description:g.localize(214,null)})),renderIndentGuides:Se(new m(83,"renderIndentGuides",!0,{description:g.localize(215,null)})),renderFinalNewline:Se(new m(84,"renderFinalNewline",!0,{description:g.localize(216,null)})),renderLineHighlight:Se(new _(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(217,null)],description:g.localize(218,null)})),renderLineHighlightOnlyWhenFocus:Se(new m(86,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(219,null)})),renderValidationDecorations:Se(new _(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new _(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(220,null),g.localize(221,null),g.localize(222,null),""],description:g.localize(223,null)})),revealHorizontalRightPadding:Se(new u(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Se(new m(90,"roundedSelection",!0,{description:g.localize(224,null)})),rulers:Se(new Re),scrollbar:Se(new Be),scrollBeyondLastColumn:Se(new u(93,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(225,null)})),scrollBeyondLastLine:Se(new m(94,"scrollBeyondLastLine",!0,{description:g.localize(226,null)})),scrollPredominantAxis:Se(new m(95,"scrollPredominantAxis",!0,{description:g.localize(227,null)})),selectionClipboard:Se(new m(96,"selectionClipboard",!0,{description:g.localize(228,null),included:L.isLinux})),selectionHighlight:Se(new m(97,"selectionHighlight",!0,{description:g.localize(229,null)})),selectOnLineNumbers:Se(new m(98,"selectOnLineNumbers",!0)),showFoldingControls:Se(new _(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(230,null),g.localize(231,null)],description:g.localize(232,null)})),showUnused:Se(new m(100,"showUnused",!0,{description:g.localize(233,null)})),showDeprecated:Se(new m(125,"showDeprecated",!0,{description:g.localize(234,null)})),inlayHints:Se(new N),snippetSuggestions:Se(new _(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(235,null),g.localize(236,null),g.localize(237,null),g.localize(238,null)],description:g.localize(239,null)})),smartSelect:Se(new re),smoothScrolling:Se(new m(103,"smoothScrolling",!1,{description:g.localize(240,null)})),stopRenderingLineAfter:Se(new u(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new ee),inlineSuggest:Se(new je),suggestFontSize:Se(new u(107,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(241,null)})),suggestLineHeight:Se(new u(108,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(242,null)})),suggestOnTriggerCharacters:Se(new m(109,"suggestOnTriggerCharacters",!0,{description:g.localize(243,null)})),suggestSelection:Se(new _(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(244,null),g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),tabCompletion:Se(new _(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(248,null),g.localize(249,null),g.localize(250,null)],description:g.localize(251,null)})),tabIndex:Se(new u(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Se(new _(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(252,null),g.localize(253,null),g.localize(254,null)],description:g.localize(255,null)})),useShadowDOM:Se(new m(114,"useShadowDOM",!0)),useTabStops:Se(new m(115,"useTabStops",!0,{description:g.localize(256,null)})),wordSeparators:Se(new D(116,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:g.localize(257,null)})),wordWrap:Se(new _(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(258,null),g.localize(259,null),g.localize(260,null),g.localize(261,null)],description:g.localize(262,null)})),wordWrapBreakAfterCharacters:Se(new D(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new D(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new u(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(263,null)})),wordWrapOverride1:Se(new _(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new _(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Se(new o(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],oe,{enumDescriptions:[g.localize(264,null),g.localize(265,null),g.localize(266,null),g.localize(267,null)],description:g.localize(268,null)})),wrappingStrategy:Se(new _(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(269,null),g.localize(270,null)],description:g.localize(271,null)})),editorClassName:Se(new d),pixelRatio:Se(new Q),tabFocusMode:Se(new ae),layoutInfo:Se(new U),wrappingInfo:Se(new ve)}}),define(me[156],ge([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[157],ge([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[158],ge([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[159],ge([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[160],ge([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(me[161],ge([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(me[162],ge([19,20]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(me[163],ge([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(me[164],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[165],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[166],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(me[167],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[168],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[169],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[170],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[171],ge([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[172],ge([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(me[173],ge([19,20]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(me[174],ge([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[175],ge([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[176],ge([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[177],ge([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[178],ge([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[179],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(R){R[R.ACTIVATE=1]="ACTIVATE",R[R.RESTORE=2]="RESTORE",R[R.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var L;(function(R){R[R.PICK=0]="PICK",R[R.DISABLED=1]="DISABLED",R[R.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var I;(function(R){R[R.API=0]="API",R[R.USER=1]="USER"})(I=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(R){R[R.Center=0]="Center",R[R.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",R[R.NearTop=2]="NearTop",R[R.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[180],ge([0,1,158]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function C(c){return c=c.trim(),c==="*"||L.test(c)}e.isValidVersionStr=C;function R(c){if(!C(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=c.match(L);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=R;function E(c){if(!c)return null;let m=c.majorBase,u=c.majorMustEqual,h=c.minorBase,D=c.minorMustEqual,k=c.patchBase,_=c.patchMustEqual;c.hasCaret&&(m===0||(D=!1),_=!1);let o=0;if(c.preRelease){const a=I.exec(c.preRelease);if(a){const[,p,t,s]=a;o=Date.UTC(Number(p),Number(t)-1,Number(s))}}return{majorBase:m,majorMustEqual:u,minorBase:h,minorMustEqual:D,patchBase:k,patchMustEqual:_,isMinimum:c.hasGreaterEquals,notBefore:o}}e.normalizeVersion=E;function S(c,m,u){let h;typeof c=="string"?h=E(R(c)):h=c;let D;m instanceof Date?D=m.getTime():typeof m=="string"&&(D=new Date(m).getTime());let k;if(typeof u=="string"?k=E(R(u)):k=u,!h||!k)return!1;let _=h.majorBase,o=h.minorBase,a=h.patchBase,p=k.majorBase,t=k.minorBase,s=k.patchBase,r=k.notBefore,i=k.majorMustEqual,f=k.minorMustEqual,l=k.patchMustEqual;return k.isMinimum?_>p?!0:_<p?!1:o>t?!0:o<t||D&&D<r?!1:a>=s:(_===1&&p===0&&(!i||!f||!l)&&(p=1,t=0,s=0,i=!0,f=!1,l=!1),_<p?!1:_>p?!i:o<t?!1:o>t?!f:a<s?!1:a>s?!l:!(D&&D<r))}e.isValidVersion=S;function T(c,m,u,h){return u.isBuiltin||typeof u.main=="undefined"?!0:P(c,m,u.engines.vscode,h)}e.isValidExtensionVersion=T;function n(c,m,u){return c==="*"||P(m,u,c)}e.isEngineValid=n;function P(c,m,u,h=[]){let D=E(R(u));if(!D)return h.push(g.localize(0,null,u)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return h.push(g.localize(1,null,u)),!1}else if(!D.majorMustEqual)return h.push(g.localize(2,null,u)),!1;return S(c,m,D)?!0:(h.push(g.localize(3,null,c,u)),!1)}}),define(me[115],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(I,C=[],R=!1){this.ctor=I,this.staticArguments=C,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=g}),define(me[82],ge([0,1,115]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function I(R,E,S){E instanceof g.SyncDescriptor||(E=new g.SyncDescriptor(E,[],S)),L.push([R,E])}e.registerSingleton=I;function C(){return L}e.getSingletonServiceDescriptors=C}),define(me[181],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=g;class L{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let R of this._nodes.values())R.outgoing.size===0&&C.push(R);return C}insertEdge(C,R){const E=this.lookupOrInsertNode(C),S=this.lookupOrInsertNode(R);E.outgoing.set(this._hashFn(R),S),S.incoming.set(this._hashFn(C),E)}removeNode(C){const R=this._hashFn(C);this._nodes.delete(R);for(let E of this._nodes.values())E.outgoing.delete(R),E.incoming.delete(R)}lookupOrInsertNode(C){const R=this._hashFn(C);let E=this._nodes.get(R);return E||(E=new g(C),this._nodes.set(R,E)),E}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[R,E]of this._nodes)C.push(`${R}, (incoming)[${[...E.incoming.keys()].join(", ")}], (outgoing)[${[...E.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,R]of this._nodes){const E=new Set([C]),S=this._findCycle(R,E);if(S)return S}}_findCycle(C,R){for(let[E,S]of C.outgoing){if(R.has(E))return[...R,E].join(" -> ");R.add(E);const T=this._findCycle(S,R);if(T)return T;R.delete(E)}}}e.Graph=L}),define(me[4],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function S(T){return T[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=S})(g=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function L(E,S,T,n){S[g.DI_TARGET]===S?S[g.DI_DEPENDENCIES].push({id:E,index:T,optional:n}):(S[g.DI_DEPENDENCIES]=[{id:E,index:T,optional:n}],S[g.DI_TARGET]=S)}function I(E){if(g.serviceIds.has(E))return g.serviceIds.get(E);const S=function(T,n,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(S,T,P,!1)};return S.toString=()=>E,g.serviceIds.set(E,S),S}e.createDecorator=I;function C(E){return E}e.refineServiceDecorator=C;function R(E){return function(S,T,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(E,S,n,!0)}}e.optional=R}),define(me[182],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function L(I){return!I.isTooLargeForSyncing()&&!I.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(me[183],ge([0,1,3,48,6,24,77,81,182]),function(Y,e,g,L,I,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function T(h){return typeof h=="string"?!1:Array.isArray(h)?h.every(T):!!h.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(D,k){let _={selector:D,provider:k,_score:-1,_time:this._clock++};return this._entries.push(_),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,I.toDisposable)(()=>{if(_){let o=this._entries.indexOf(_);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),_=void 0)}})}has(D){return this.all(D).length>0}all(D){if(!D)return[];this._updateScores(D);const k=[];for(let _ of this._entries)_._score>0&&k.push(_.provider);return k}ordered(D){const k=[];return this._orderedForEach(D,_=>k.push(_.provider)),k}orderedGroups(D){const k=[];let _,o;return this._orderedForEach(D,a=>{_&&o===a._score?_.push(a.provider):(o=a._score,_=[a.provider],k.push(_))}),k}_orderedForEach(D,k){if(!!D){this._updateScores(D);for(const _ of this._entries)_._score>0&&k(_)}}_updateScores(D){let k={uri:D.uri.toString(),language:D.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===k.language&&this._lastCandidate.uri===k.uri)){this._lastCandidate=k;for(let _ of this._entries)if(_._score=(0,E.score)(_.selector,D.uri,D.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(D)),T(_.selector)&&_._score>0){for(let o of this._entries)o._score=0;_._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(D,k){return D._score<k._score?1:D._score>k._score?-1:D._time<k._time?1:D._time>k._time?-1:0}}e.LanguageFeatureRegistry=n;const P=new WeakMap;let c=0;function m(h){let D=P.get(h);return D===void 0&&(D=++c,P.set(h,D)),D}class u{constructor(D,k,_=Number.MAX_SAFE_INTEGER){this._registry=D,this.min=k,this.max=_,this._cache=new C.LRUCache(50,.7)}_key(D){return D.id+this._registry.all(D).reduce((k,_)=>(0,L.doHash)(m(_),k),0)}_clamp(D){return D===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(D*1.3)))}get(D){const k=this._key(D),_=this._cache.get(k);return this._clamp(_?.value)}update(D,k){const _=this._key(D);let o=this._cache.get(_);return o||(o=new R.MovingAverage,this._cache.set(_,o)),o.update(k),this.get(D)}}e.LanguageFeatureRequestDelays=u}),define(me[83],ge([0,1,2,41,183,149,47]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var E;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(E=e.LanguageId||(e.LanguageId={}));class S{constructor(A,w){this.language=A,this.id=w}}e.LanguageIdentifier=S;var T;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline"})(T=e.FontStyle||(e.FontStyle={}));var n;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var P;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var c;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",v[v.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",v[v.ITALIC_MASK=2048]="ITALIC_MASK",v[v.BOLD_MASK=4096]="BOLD_MASK",v[v.UNDERLINE_MASK=8192]="UNDERLINE_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(c=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(A){return(A&255)>>>0}static getTokenType(A){return(A&1792)>>>8}static getFontStyle(A){return(A&14336)>>>11}static getForeground(A){return(A&8372224)>>>14}static getBackground(A){return(A&4286578688)>>>23}static getClassNameFromMetadata(A){let w=this.getForeground(A),F="mtk"+w,O=this.getFontStyle(A);return O&1&&(F+=" mtki"),O&2&&(F+=" mtkb"),O&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(A,w){const F=this.getForeground(A),O=this.getFontStyle(A);let G=`color: ${w[F]};`;return O&1&&(G+="font-style: italic;"),O&2&&(G+="font-weight: bold;"),O&4&&(G+="text-decoration: underline;"),G}}e.TokenMetadata=m;var u;(function(v){v[v.Method=0]="Method",v[v.Function=1]="Function",v[v.Constructor=2]="Constructor",v[v.Field=3]="Field",v[v.Variable=4]="Variable",v[v.Class=5]="Class",v[v.Struct=6]="Struct",v[v.Interface=7]="Interface",v[v.Module=8]="Module",v[v.Property=9]="Property",v[v.Event=10]="Event",v[v.Operator=11]="Operator",v[v.Unit=12]="Unit",v[v.Value=13]="Value",v[v.Constant=14]="Constant",v[v.Enum=15]="Enum",v[v.EnumMember=16]="EnumMember",v[v.Keyword=17]="Keyword",v[v.Text=18]="Text",v[v.Color=19]="Color",v[v.File=20]="File",v[v.Reference=21]="Reference",v[v.Customcolor=22]="Customcolor",v[v.Folder=23]="Folder",v[v.TypeParameter=24]="TypeParameter",v[v.User=25]="User",v[v.Issue=26]="Issue",v[v.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let v=Object.create(null);return v[0]="symbol-method",v[1]="symbol-function",v[2]="symbol-constructor",v[3]="symbol-field",v[4]="symbol-variable",v[5]="symbol-class",v[6]="symbol-struct",v[7]="symbol-interface",v[8]="symbol-module",v[9]="symbol-property",v[10]="symbol-event",v[11]="symbol-operator",v[12]="symbol-unit",v[13]="symbol-value",v[14]="symbol-constant",v[15]="symbol-enum",v[16]="symbol-enum-member",v[17]="symbol-keyword",v[27]="symbol-snippet",v[18]="symbol-text",v[19]="symbol-color",v[20]="symbol-file",v[21]="symbol-reference",v[22]="symbol-customcolor",v[23]="symbol-folder",v[24]="symbol-type-parameter",v[25]="account",v[26]="issues",function(A){const w=v[A];let F=w&&R.iconRegistry.get(w);return F||(console.info("No codicon found for CompletionItemKind "+A),F=R.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let v=Object.create(null);return v.method=0,v.function=1,v.constructor=2,v.field=3,v.variable=4,v.class=5,v.struct=6,v.interface=7,v.module=8,v.property=9,v.event=10,v.operator=11,v.unit=12,v.value=13,v.constant=14,v.enum=15,v["enum-member"]=16,v.enumMember=16,v.keyword=17,v.snippet=27,v.text=18,v.color=19,v.file=20,v.reference=21,v.customcolor=22,v.folder=23,v["type-parameter"]=24,v.typeParameter=24,v.account=25,v.issue=26,function(A,w){let F=v[A];return typeof F=="undefined"&&!w&&(F=9),F}}();var h;(function(v){v[v.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var D;(function(v){v[v.KeepWhitespace=1]="KeepWhitespace",v[v.InsertAsSnippet=4]="InsertAsSnippet"})(D=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var k;(function(v){v[v.Invoke=0]="Invoke",v[v.TriggerCharacter=1]="TriggerCharacter",v[v.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(k=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(v){v[v.Automatic=0]="Automatic",v[v.Explicit=1]="Explicit"})(_=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var o;(function(v){v[v.Invoke=1]="Invoke",v[v.Auto=2]="Auto"})(o=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var a;(function(v){v[v.Invoke=1]="Invoke",v[v.TriggerCharacter=2]="TriggerCharacter",v[v.ContentChange=3]="ContentChange"})(a=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var p;(function(v){v[v.Text=0]="Text",v[v.Read=1]="Read",v[v.Write=2]="Write"})(p=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(v){return v&&g.URI.isUri(v.uri)&&L.Range.isIRange(v.range)&&(L.Range.isIRange(v.originSelectionRange)||L.Range.isIRange(v.targetSelectionRange))}e.isLocationLink=t;var s;(function(v){v[v.File=0]="File",v[v.Module=1]="Module",v[v.Namespace=2]="Namespace",v[v.Package=3]="Package",v[v.Class=4]="Class",v[v.Method=5]="Method",v[v.Property=6]="Property",v[v.Field=7]="Field",v[v.Constructor=8]="Constructor",v[v.Enum=9]="Enum",v[v.Interface=10]="Interface",v[v.Function=11]="Function",v[v.Variable=12]="Variable",v[v.Constant=13]="Constant",v[v.String=14]="String",v[v.Number=15]="Number",v[v.Boolean=16]="Boolean",v[v.Array=17]="Array",v[v.Object=18]="Object",v[v.Key=19]="Key",v[v.Null=20]="Null",v[v.EnumMember=21]="EnumMember",v[v.Struct=22]="Struct",v[v.Event=23]="Event",v[v.Operator=24]="Operator",v[v.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var r;(function(v){v[v.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(v){const A=new Map;A.set("file",0),A.set("module",1),A.set("namespace",2),A.set("package",3),A.set("class",4),A.set("method",5),A.set("property",6),A.set("field",7),A.set("constructor",8),A.set("enum",9),A.set("interface",10),A.set("function",11),A.set("variable",12),A.set("constant",13),A.set("string",14),A.set("number",15),A.set("boolean",16),A.set("array",17),A.set("object",18),A.set("key",19),A.set("null",20),A.set("enum-member",21),A.set("struct",22),A.set("event",23),A.set("operator",24),A.set("type-parameter",25);const w=new Map;w.set(0,"file"),w.set(1,"module"),w.set(2,"namespace"),w.set(3,"package"),w.set(4,"class"),w.set(5,"method"),w.set(6,"property"),w.set(7,"field"),w.set(8,"constructor"),w.set(9,"enum"),w.set(10,"interface"),w.set(11,"function"),w.set(12,"variable"),w.set(13,"constant"),w.set(14,"string"),w.set(15,"number"),w.set(16,"boolean"),w.set(17,"array"),w.set(18,"object"),w.set(19,"key"),w.set(20,"null"),w.set(21,"enum-member"),w.set(22,"struct"),w.set(23,"event"),w.set(24,"operator"),w.set(25,"type-parameter");function F(K){return A.get(K)}v.fromString=F;function O(K){return w.get(K)}v.toString=O;function G(K,U){const z=w.get(K);let N=z&&R.iconRegistry.get("symbol-"+z);return N||(console.info("No codicon found for SymbolKind "+K),N=R.Codicon.symbolProperty),`${U?"inline":"block"} ${N.classNames}`}v.toCssClassName=G})(i=e.SymbolKinds||(e.SymbolKinds={}));class f{constructor(A){this.value=A}}e.FoldingRangeKind=f,f.Comment=new f("comment"),f.Imports=new f("imports"),f.Region=new f("region");var l;(function(v){v[v.Collapsed=0]="Collapsed",v[v.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(v){v[v.Editing=0]="Editing",v[v.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var b;(function(v){v[v.Other=0]="Other",v[v.Type=1]="Type",v[v.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new I.LanguageFeatureRegistry,e.RenameProviderRegistry=new I.LanguageFeatureRegistry,e.CompletionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new I.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new I.LanguageFeatureRegistry,e.HoverProviderRegistry=new I.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new I.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new I.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new I.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new I.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new I.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.LinkProviderRegistry=new I.LanguageFeatureRegistry,e.ColorProviderRegistry=new I.LanguageFeatureRegistry,e.SelectionRangeRegistry=new I.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var y;(function(v){v[v.None=0]="None",v[v.Option=1]="Option",v[v.Default=2]="Default",v[v.Preferred=3]="Preferred"})(y=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[62],ge([0,1,11,9,4]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=g.userAgent||"";const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",g.isMacintosh),R.set("isLinux",g.isLinux),R.set("isWindows",g.isWindows),R.set("isWeb",g.isWeb),R.set("isMacNative",g.isMacintosh&&!g.isWeb),R.set("isEdge",C.indexOf("Edg/")>=0),R.set("isFirefox",C.indexOf("Firefox")>=0),R.set("isChrome",C.indexOf("Chrome")>=0),R.set("isSafari",C.indexOf("Safari")>=0);const E=Object.prototype.hasOwnProperty;var S;(function(A){A[A.False=0]="False",A[A.True=1]="True",A[A.Defined=2]="Defined",A[A.Not=3]="Not",A[A.Equals=4]="Equals",A[A.NotEquals=5]="NotEquals",A[A.And=6]="And",A[A.Regex=7]="Regex",A[A.NotRegex=8]="NotRegex",A[A.Or=9]="Or",A[A.In=10]="In",A[A.NotIn=11]="NotIn",A[A.Greater=12]="Greater",A[A.GreaterEquals=13]="GreaterEquals",A[A.Smaller=14]="Smaller",A[A.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class T{static false(){return P.INSTANCE}static true(){return c.INSTANCE}static has(w){return m.create(w)}static equals(w,F){return u.create(w,F)}static notEquals(w,F){return k.create(w,F)}static regex(w,F){return s.create(w,F)}static in(w,F){return h.create(w,F)}static not(w){return _.create(w)}static and(...w){return i.create(w,null)}static or(...w){return f.create(w,null,!0)}static greater(w,F){return o.create(w,F)}static less(w,F){return p.create(w,F)}static deserialize(w,F=!1){if(!!w)return this._deserializeOrExpression(w,F)}static _deserializeOrExpression(w,F){let O=w.split("||");return f.create(O.map(G=>this._deserializeAndExpression(G,F)),null,!0)}static _deserializeAndExpression(w,F){let O=w.split("&&");return i.create(O.map(G=>this._deserializeOne(G,F)),null)}static _deserializeOne(w,F){if(w=w.trim(),w.indexOf("!=")>=0){let O=w.split("!=");return k.create(O[0].trim(),this._deserializeValue(O[1],F))}if(w.indexOf("==")>=0){let O=w.split("==");return u.create(O[0].trim(),this._deserializeValue(O[1],F))}if(w.indexOf("=~")>=0){let O=w.split("=~");return s.create(O[0].trim(),this._deserializeRegexValue(O[1],F))}if(w.indexOf(" in ")>=0){let O=w.split(" in ");return h.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const O=w.split(">=");return a.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const O=w.split(">");return o.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const O=w.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const O=w.split("<");return p.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(w)?_.create(w.substr(1).trim()):m.create(w)}static _deserializeValue(w,F){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let O=/^'([^']*)'$/.exec(w);return O?O[1].trim():w}static _deserializeRegexValue(w,F){if((0,L.isFalsyOrWhitespace)(w)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=w.indexOf("/"),G=w.lastIndexOf("/");if(O===G||O<0){if(F)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let K=w.slice(O+1,G),U=w[G+1]==="i"?"i":"";try{return new RegExp(K,U)}catch(z){if(F)throw new Error(`bad regexp-value '${w}', parse error: ${z}`);return console.warn(`bad regexp-value '${w}', parse error: ${z}`),null}}}e.ContextKeyExpr=T;function n(A,w){return A.cmp(w)}class P{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class c{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class m{constructor(w,F){this.key=w,this.negated=F,this.type=2}static create(w,F=null){const O=R.get(w);return typeof O=="boolean"?O?c.INSTANCE:P.INSTANCE:new m(w,F)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=m;class u{constructor(w,F,O){this.key=w,this.value=F,this.negated=O,this.type=4}static create(w,F,O=null){if(typeof F=="boolean")return F?m.create(w,O):_.create(w,O);const G=R.get(w);return typeof G=="boolean"?F===(G?"true":"false")?c.INSTANCE:P.INSTANCE:new u(w,F,O)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class h{constructor(w,F){this.key=w,this.valueKey=F,this.type=10,this.negated=null}static create(w,F){return new h(w,F)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}evaluate(w){const F=w.getValue(this.valueKey),O=w.getValue(this.key);return Array.isArray(F)?F.indexOf(O)>=0:typeof O=="string"&&typeof F=="object"&&F!==null?E.call(F,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=D.create(this)),this.negated}}e.ContextKeyInExpr=h;class D{constructor(w){this._actual=w,this.type=11}static create(w){return new D(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new D(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class k{constructor(w,F,O){this.key=w,this.value=F,this.negated=O,this.type=5}static create(w,F,O=null){if(typeof F=="boolean")return F?_.create(w,O):m.create(w,O);const G=R.get(w);return typeof G=="boolean"?F===(G?"true":"false")?P.INSTANCE:c.INSTANCE:new k(w,F,O)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=k;class _{constructor(w,F){this.key=w,this.negated=F,this.type=3}static create(w,F=null){const O=R.get(w);return typeof O=="boolean"?O?P.INSTANCE:c.INSTANCE:new _(w,F)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;class o{constructor(w,F,O){this.key=w,this.value=F,this.negated=O,this.type=12}static create(w,F,O=null){return new o(w,F,O)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=o;class a{constructor(w,F,O){this.key=w,this.value=F,this.negated=O,this.type=13}static create(w,F,O=null){return new a(w,F,O)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=a;class p{constructor(w,F,O){this.key=w,this.value=F,this.negated=O,this.type=14}static create(w,F,O=null){return new p(w,F,O)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=p;class t{constructor(w,F,O){this.key=w,this.value=F,this.negated=O,this.type=15}static create(w,F,O=null){return new t(w,F,O)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(w,F){this.key=w,this.regexp=F,this.type=7,this.negated=null}static create(w,F){return new s(w,F)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const F=this.regexp?this.regexp.source:"",O=w.regexp?w.regexp.source:"";return F<O?-1:F>O?1:0}equals(w){if(w.type===this.type){const F=this.regexp?this.regexp.source:"",O=w.regexp?w.regexp.source:"";return this.key===w.key&&F===O}return!1}evaluate(w){let F=w.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class r{constructor(w){this._actual=w,this.type=8}static create(w){return new r(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new r(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class i{constructor(w,F){this.expr=w,this.negated=F,this.type=6}static create(w,F){return i._normalizeArr(w,F)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const G=n(this.expr[F],w.expr[F]);if(G!==0)return G}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(w.expr[F]))return!1;return!0}return!1}evaluate(w){for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].evaluate(w))return!1;return!0}static _normalizeArr(w,F){const O=[];let G=!1;for(const K of w)if(!!K){if(K.type===1){G=!0;continue}if(K.type===0)return P.INSTANCE;if(K.type===6){O.push(...K.expr);continue}O.push(K)}if(O.length===0&&G)return c.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];O.sort(n);for(let K=1;K<O.length;K++)O[K-1].equals(O[K])&&(O.splice(K,1),K--);if(O.length===1)return O[0];for(;O.length>1;){const K=O[O.length-1];if(K.type!==9)break;O.pop();const U=O.pop(),z=O.length===0,N=f.create(K.expr.map(B=>i.create([B,U],null)),null,z);N&&(O.push(N),O.sort(n))}return O.length===1?O[0]:new i(O,F)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let F of this.expr)w.push(...F.keys());return w}map(w){return new i(this.expr.map(F=>F.map(w)),null)}negate(){if(!this.negated){const w=[];for(let F of this.expr)w.push(F.negate());this.negated=f.create(w,this,!0)}return this.negated}}class f{constructor(w,F){this.expr=w,this.negated=F,this.type=9}static create(w,F,O){return f._normalizeArr(w,F,O)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const G=n(this.expr[F],w.expr[F]);if(G!==0)return G}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(w.expr[F]))return!1;return!0}return!1}evaluate(w){for(let F=0,O=this.expr.length;F<O;F++)if(this.expr[F].evaluate(w))return!0;return!1}static _normalizeArr(w,F,O){let G=[],K=!1;if(w){for(let U=0,z=w.length;U<z;U++){const N=w[U];if(!!N){if(N.type===0){K=!0;continue}if(N.type===1)return c.INSTANCE;if(N.type===9){G=G.concat(N.expr);continue}G.push(N)}}if(G.length===0&&K)return P.INSTANCE;G.sort(n)}if(G.length!==0){if(G.length===1)return G[0];for(let U=1;U<G.length;U++)G[U-1].equals(G[U])&&(G.splice(U,1),U--);if(G.length===1)return G[0];if(O){for(let U=0;U<G.length;U++)for(let z=U+1;z<G.length;z++)y(G[U],G[z])&&(G.splice(z,1),z--);if(G.length===1)return G[0]}return new f(G,F)}}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let F of this.expr)w.push(...F.keys());return w}map(w){return new f(this.expr.map(F=>F.map(w)),null)}negate(){if(!this.negated){let w=[];for(let F of this.expr)w.push(F.negate());for(;w.length>1;){const F=w.shift(),O=w.shift(),G=[];for(const U of v(F))for(const z of v(O))G.push(i.create([U,z],null));const K=w.length===0;w.unshift(f.create(G,null,K))}this.negated=w[0]}return this.negated}}class l extends m{constructor(w,F,O){super(w,null);this._defaultValue=F,typeof O=="object"?l._info.push({...O,key:w}):O!==!0&&l._info.push({key:w,description:O,type:F!=null?typeof F:void 0})}static all(){return l._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(w){return u.create(this.key,w)}notEqualsTo(w){return k.create(this.key,w)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(A,w){return A<w?-1:A>w?1:0}function b(A,w,F,O){return A<F?-1:A>F?1:w<O?-1:w>O?1:0}function y(A,w){if(w.type===6&&A.type!==9&&A.type!==6){for(const G of w.expr)if(A.equals(G))return!0}const F=A.negate(),O=v(F).concat(v(w));O.sort(n);for(let G=0;G<O.length;G++){const U=O[G].negate();for(let z=G+1;z<O.length;z++){const N=O[z];if(U.equals(N))return!0}}return!1}e.implies=y;function v(A){return A.type===9?A.expr:[A]}}),define(me[184],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(me[185],ge([0,1,10,157,4]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(k){k.WIN32_X64="win32-x64",k.WIN32_IA32="win32-ia32",k.WIN32_ARM64="win32-arm64",k.LINUX_X64="linux-x64",k.LINUX_ARM64="linux-arm64",k.LINUX_ARMHF="linux-armhf",k.ALPINE="alpine-x64",k.DARWIN_X64="darwin-x64",k.DARWIN_ARM64="darwin-arm64",k.WEB="web",k.UNIVERSAL="universal",k.UNKNOWN="unknown",k.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function R(k){switch(k){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function E(k){switch(k){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=E;function S(k,_){switch(k){case 3:return _==="x64"?"win32-x64":_==="ia32"?"win32-ia32":_==="arm64"?"win32-arm64":"unknown";case 2:return _==="x64"?"linux-x64":_==="arm64"?"linux-arm64":_==="arm"?"linux-armhf":"unknown";case 1:return _==="x64"?"darwin-x64":_==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function T(k,_){return _==="web"&&!k.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function n(k,_,o){if(T(_,o))return!1;if(k==="undefined"||k==="universal")return!0;if(k==="unknown")return!1;if(k===o)return!0;switch(o){case"win32-x64":return k==="win32-ia32";case"win32-arm64":return k==="win32-ia32";default:return!1}}e.isTargetPlatformCompatible=n;function P(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=P;var c;(function(k){k[k.NoneOrRelevance=0]="NoneOrRelevance",k[k.LastUpdatedDate=1]="LastUpdatedDate",k[k.Title=2]="Title",k[k.PublisherName=3]="PublisherName",k[k.InstallCount=4]="InstallCount",k[k.PublishedDate=5]="PublishedDate",k[k.AverageRating=6]="AverageRating",k[k.WeightedRating=12]="WeightedRating"})(c=e.SortBy||(e.SortBy={}));var m;(function(k){k[k.Default=0]="Default",k[k.Ascending=1]="Ascending",k[k.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var u;(function(k){k.Install="install",k.Uninstall="uninstall"})(u=e.StatisticType||(e.StatisticType={}));var h;(function(k){k[k.None=0]="None",k[k.Install=1]="Install",k[k.Update=2]="Update"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class D extends Error{constructor(_,o){super(_);this.code=o,this.name=o}}e.ExtensionManagementError=D,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,9,4]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=I;function C(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class E{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,c){if(typeof P=="undefined"||P===null)return typeof c=="undefined"||c===null;if(typeof c=="undefined"||c===null)return!1;if(typeof P=="string"||typeof c=="string"){let m=typeof P=="string"?P:P.value,u=typeof c=="string"?c:c.value;return g.equalsIgnoreCase(m,u)}return P._lower===c._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=E;function S(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function T(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=T,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[186],ge([0,1,9,26]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(u,h){return u.uuid&&h.uuid?u.uuid===h.uuid:u.id===h.id?!0:(0,g.compareIgnoreCase)(u.id,h.id)===0}e.areSameExtensions=I;class C{constructor(h,D){this.version=D,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof C?I(this,h)&&this.version===h.version:!1}}e.ExtensionIdentifierWithVersion=C;function R(u,h){return`${u}.${h}`}e.getExtensionId=R;function E(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function S(u,h){return E(R(u,h))}e.getGalleryExtensionId=S;function T(u,h){const D=[],k=_=>{for(const o of D)if(o.some(a=>I(h(a),h(_))))return o;return null};for(const _ of u){const o=k(_);o?o.push(_):D.push([_])}return D}e.groupByExtension=T;function n(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function P(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function c(u){const h=new Set;for(const D of u)D.malicious&&h.add(D.id.id);return h}e.getMaliciousExtensionsSet=c;function m(u,h){const D=[],k=h.manifest.extensionDependencies?.slice(0)??[];for(;k.length;){const _=k.shift();if(_&&D.every(o=>!I(o.identifier,{id:_}))){const o=u.filter(a=>I(a.identifier,{id:_}));o.length===1&&(D.push(o[0]),k.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return D}e.getExtensionDependencies=m}),define(me[187],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(me[188],ge([0,1,39,10,8,11,140,28,113,159,187]),function(Y,e,g,L,I,C,R,E,S,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=T.localize(0,null);class c{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends c{openTerminal(a,p){return this.spawnTerminal(g,a,S.getWindowsShell(),p)}spawnTerminal(a,p,t,s){const r=p.windowsExec||m.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const i=I.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return a.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const f=["/c","start","/wait"];return r.indexOf(" ")>=0&&f.push('""'),f.push(r),(i==="wt"||i==="wt.exe")&&f.push("-d ."),new Promise((l,d)=>{const b=D(process),y=a.spawn(t,f,{cwd:s,env:b});y.on("error",d),y.on("exit",()=>l())})}runInTerminal(a,p,t,s,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:m.getDefaultTerminalWindows();return new Promise((f,l)=>{const d=`"${p} - ${P}"`,b=`""${t.join('" "')}" & pause"`,y=["/c","start",d,"/wait",i,"/c",b],v=Object.assign({},D(process),s);Object.keys(v).filter(F=>v[F]===null).forEach(F=>delete v[F]);const A={cwd:p,env:v,windowsVerbatimArguments:!0};g.spawn(m.CMD,y,A).on("error",F=>{l(k(F))}),f(void 0)})}static getDefaultTerminalWindows(){if(!m._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return m._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=m,m.CMD="cmd.exe";class u extends c{openTerminal(a,p){return this.spawnTerminal(g,a,p)}runInTerminal(a,p,t,s,r){const i=r.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((f,l)=>{if(i===n.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const d=i===n.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",y=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${d}.scpt`,Y).fsPath,"-t",a||P,"-w",p];for(let w of t)y.push("-a"),y.push(w);if(s){const w=Object.assign({},D(process),s);for(let F in w){const O=w[F];O===null?(y.push("-u"),y.push(F)):(y.push("-e"),y.push(`${F}=${O}`))}}let v="";const A=g.spawn(u.OSASCRIPT,y);A.on("error",w=>{l(k(w))}),A.stderr.on("data",w=>{v+=w.toString()}),A.on("exit",w=>{if(w===0)f(void 0);else if(v){const F=v.split(`
`,1);l(new Error(F[0]))}else l(new Error(T.localize(1,null,d,w)))})}else l(new Error(T.localize(2,null,i)))})}spawnTerminal(a,p,t){const s=p.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const f=["-a",s];t&&f.push(t);const l=D(process),d=a.spawn("/usr/bin/open",f,{cwd:t,env:l});d.on("error",i),d.on("exit",()=>r())})}}e.MacExternalTerminalService=u,u.OSASCRIPT="/usr/bin/osascript";class h extends c{openTerminal(a,p){return this.spawnTerminal(g,a,p)}runInTerminal(a,p,t,s,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((f,l)=>{let d=[];i.then(b=>{b.indexOf("gnome-terminal")>=0?d.push("-x"):d.push("-e"),d.push("bash"),d.push("-c");const y=`${_(t)}; echo; read -p "${h.WAIT_MESSAGE}" -n1;`;d.push(`''${y}''`);const v=Object.assign({},D(process),s);Object.keys(v).filter(O=>v[O]===null).forEach(O=>delete v[O]);const A={cwd:p,env:v};let w="";const F=g.spawn(b,d,A);F.on("error",O=>{l(k(O))}),F.stderr.on("data",O=>{w+=O.toString()}),F.on("exit",O=>{if(O===0)f(void 0);else if(w){const G=w.split(`
`,1);l(new Error(G[0]))}else l(new Error(T.localize(4,null,b,O)))})})})}static async getDefaultTerminalLinuxReady(){return h._DEFAULT_TERMINAL_LINUX_READY||(h._DEFAULT_TERMINAL_LINUX_READY=new Promise(async a=>{C.isLinux?await E.Promises.exists("/etc/debian_version")?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm"):a("xterm")})),h._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,p,t){const s=p.linuxExec?Promise.resolve(p.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{s.then(f=>{const l=D(process),d=a.spawn(f,[],{cwd:t,env:l});d.on("error",i),d.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=h,h.WAIT_MESSAGE=T.localize(3,null);function D(o){const a={...o.env};return(0,R.sanitizeProcessEnvironment)(a),a}function k(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(T.localize(5,null,o.path)):o}function _(o){let a="";for(let p of o)p.indexOf(" ")>=0?a+='"'+p+'"':a+=p,a+=" ";return a}}),define(me[42],ge([0,1,24,8,9,13,2,160,4]),function(Y,e,g,L,I,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function T(U){return U.create===!0}e.isFileOpenForWriteOptions=T;var n;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var P;(function(U){U[U.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var c;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=m;function u(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=u;function h(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function D(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=D;var k;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class _ extends Error{constructor(z,N){super(z);this.code=N}}e.FileSystemProviderError=_;function o(U,z){const N=new _(U.toString(),z);return p(N,z),N}e.createFileSystemProviderError=o;function a(U){return U||o((0,E.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=a;function p(U,z){return U.name=z?`${z} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=p;function t(U){if(!U)return k.Unknown;if(U instanceof _)return U.code;const z=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!z)return k.Unknown;switch(z[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=t;function s(U){if(U instanceof b)return U.fileOperationResult;switch(t(U)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(z,N,B){this.resource=z,this.operation=N,this.target=B}isOperation(z){return this.operation===z}}e.FileOperationEvent=i;var f;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class l{constructor(z,N){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const B of z)switch(B.type){case 1:this.added||(this.added=g.TernarySearchTree.forUris(()=>N)),this.added.set(B.resource,B);break;case 0:this.updated||(this.updated=g.TernarySearchTree.forUris(()=>N)),this.updated.set(B.resource,B);break;case 2:this.deleted||(this.deleted=g.TernarySearchTree.forUris(()=>N)),this.deleted.set(B.resource,B);break}}contains(z,...N){return this.doContains(z,{includeChildren:!1},...N)}affects(z,...N){return this.doContains(z,{includeChildren:!0},...N)}doContains(z,N,...B){if(!z)return!1;const x=B.length>0;return!!((!x||B.includes(1))&&(this.added?.get(z)||N.includeChildren&&this.added?.findSuperstr(z))||(!x||B.includes(0))&&(this.updated?.get(z)||N.includeChildren&&this.updated?.findSuperstr(z))||(!x||B.includes(2))&&(this.deleted?.findSubstr(z)||N.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function d(U,z,N){return!U||!z||U===z||z.length>U.length?!1:(z.charAt(z.length-1)!==L.sep&&(z+=L.sep),N?(0,I.startsWithIgnoreCase)(U,z):U.indexOf(z)===0)}e.isParent=d;class b extends Error{constructor(z,N,B){super(z);this.fileOperationResult=N,this.options=B}}e.FileOperationError=b;class y extends b{constructor(z,N,B){super(z,2,B);this.stat=N}}e.NotModifiedSinceFileOperationError=y;var v;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(v=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function w(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=w;async function F(U,z){if(!z.canHandleResource(R.URI.from({scheme:U.scheme})))return new Promise(N=>{const B=z.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===U.scheme&&x.added&&(B.dispose(),N())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(z){return(0,C.isNumber)(z)||(z=0),z<O.KB?(0,E.localize)(1,null,z.toFixed(0)):z<O.MB?(0,E.localize)(2,null,(z/O.KB).toFixed(2)):z<O.GB?(0,E.localize)(3,null,(z/O.MB).toFixed(2)):z<O.TB?(0,E.localize)(4,null,(z/O.GB).toFixed(2)):(0,E.localize)(5,null,(z/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var G;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function K(U){return{maxFileSize:U===0?300*O.MB:16*O.GB,maxHeapSize:U===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=K}),define(me[84],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...I){this._entries=new Map;for(let[C,R]of I)this.set(C,R)}set(I,C){const R=this._entries.get(I);return this._entries.set(I,C),R}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=g}),define(me[189],ge([0,1,18,16,115,181,4,84]),function(Y,e,g,L,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class T extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class n{constructor(u=new E.ServiceCollection,h=!1,D){this._activeInstantiations=new Set,this._services=u,this._strict=h,this._parent=D,this._services.set(R.IInstantiationService,this)}createChild(u){return new n(u,this._strict,this)}invokeFunction(u,...h){let D=c.traceInvocation(u),k=!1;try{return u({get:(o,a)=>{if(k)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(o,D);if(!p&&a!==R.optional)throw new Error(`[invokeFunction] unknown service '${o}'`);return p}},...h)}finally{k=!0,D.stop()}}createInstance(u,...h){let D,k;return u instanceof I.SyncDescriptor?(D=c.traceCreation(u.ctor),k=this._createInstance(u.ctor,u.staticArguments.concat(h),D)):(D=c.traceCreation(u),k=this._createInstance(u,h,D)),D.stop(),k}_createInstance(u,h=[],D){let k=R._util.getServiceDependencies(u).sort((a,p)=>a.index-p.index),_=[];for(const a of k){let p=this._getOrCreateServiceInstance(a.id,D);if(!p&&this._strict&&!a.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${a.id}.`);_.push(p)}let o=k.length>0?k[0].index:h.length;if(h.length!==o){console.warn(`[createInstance] First service dependency of ${u.name} at position ${o+1} conflicts with ${h.length} static arguments`);let a=o-h.length;a>0?h=h.concat(new Array(a)):h=h.slice(0,o)}return new u(...[...h,..._])}_setServiceInstance(u,h){if(this._services.get(u)instanceof I.SyncDescriptor)this._services.set(u,h);else if(this._parent)this._parent._setServiceInstance(u,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let h=this._services.get(u);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):h}_getOrCreateServiceInstance(u,h){let D=this._getServiceInstanceOrDescriptor(u);return D instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,D,h.branch(u,!0)):(h.branch(u,!1),D)}_safeCreateAndCacheServiceInstance(u,h,D){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,h,D)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,h,D){const k=new C.Graph(a=>a.id.toString());let _=0;const o=[{id:u,desc:h,_trace:D}];for(;o.length;){const a=o.pop();if(k.lookupOrInsertNode(a),_++>1e3)throw new T(k);for(let p of R._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(p.id);if(!t&&!p.optional&&console.warn(`[createInstance] ${u} depends on ${p.id} which is NOT registered.`),t instanceof I.SyncDescriptor){const s={id:p.id,desc:t,_trace:a._trace.branch(p.id,!0)};k.insertEdge(a,s),o.push(s)}}}for(;;){const a=k.roots();if(a.length===0){if(!k.isEmpty())throw new T(k);break}for(const{data:p}of a){if(this._getServiceInstanceOrDescriptor(p.id)instanceof I.SyncDescriptor){const s=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,s)}k.removeNode(p)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,h,D=[],k,_){if(this._services.get(u)instanceof I.SyncDescriptor)return this._createServiceInstance(h,D,k,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,h,D,k,_);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(u,h=[],D,k){if(D){const _=new g.IdleValue(()=>this._createInstance(u,h,k));return new Proxy(Object.create(null),{get(o,a){if(a in o)return o[a];let p=_.value,t=p[a];return typeof t!="function"||(t=t.bind(p),o[a]=t),t},set(o,a,p){return _.value[a]=p,!0}})}else return this._createInstance(u,h,k)}}e.InstantiationService=n;var P;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(P||(P={}));class c{constructor(u,h){this.type=u,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return S?new c(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(u){return S?new c(0,u.name):c._None}branch(u,h){let D=new c(2,u.toString());return this._dep.push([u,h,D]),D}stop(){let u=Date.now()-this._start;c._totals+=u;let h=!1;function D(_,o){let a=[],p=new Array(_+1).join("	");for(const[t,s,r]of o._dep)if(s&&r){h=!0,a.push(`${p}CREATES -> ${t}`);let i=D(_+1,r);i&&a.push(i)}else a.push(`${p}uses -> ${t}`);return a.join(`
`)}let k=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(u>2||h)&&console.log(k.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(me[12],ge([0,1,61,3,6,11,4]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function E(){return new Date().toISOString()}var S;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class T extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class n extends T{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(S.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(S.Error,this.format(r))}else this.log(S.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let r=0;r<t.length;r++){let i=t[r];if(typeof i=="object")try{i=JSON.stringify(i)}catch(f){}s+=(r>0?" ":"")+i}return s}}e.AbstractMessageLogger=n;class P extends T{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...s){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${E()}][0m`,t,...s):console.log(`[main ${E()}]`,t,...s))}debug(t,...s){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${E()}][0m`,t,...s):console.log(`[main ${E()}]`,t,...s))}info(t,...s){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${E()}][0m`,t,...s):console.log(`[main ${E()}]`,t,...s))}warn(t,...s){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${E()}][0m`,t,...s):console.warn(`[main ${E()}]`,t,...s))}error(t,...s){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${E()}][0m`,t,...s):console.error(`[main ${E()}]`,t,...s))}critical(t,...s){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${E()}][0m`,t,...s):console.error(`[main ${E()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class c extends T{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=c;class m extends T{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,g.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class u extends T{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const r of this.logServices)r.trace(t,...s)}debug(t,...s){for(const r of this.logServices)r.debug(t,...s)}info(t,...s){for(const r of this.logServices)r.info(t,...s)}warn(t,...s){for(const r of this.logServices)r.warn(t,...s)}error(t,...s){for(const r of this.logServices)r.error(t,...s)}critical(t,...s){for(const r of this.logServices)r.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class h extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=h;class D extends I.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,s?.always?S.Trace:this.logLevel,s),this.loggers.set(t.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class k{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=k;function _(p){if(p.verbose)return S.Trace;if(typeof p.logLevel=="string"){const t=o(p.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function o(p){switch(p){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=o;function a(p){switch(p){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=a}),define(me[116],ge([0,1,42,12]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function I(S,T,n,P){try{const c=await new Promise((m,u)=>{Y(["spdlog"],m,u)});return c.setFlushOn(L.LogLevel.Trace),c.createAsyncRotatingLogger(S,T,n,P)}catch(c){console.error(c)}return null}function C(S,T,n,P){const c=Y.__$__nodeRequire("spdlog");return c.setFlushOn(L.LogLevel.Trace),c.createRotatingLogger(S,T,n,P)}e.createRotatingLogger=C;function R(S,T,n){switch(T){case L.LogLevel.Trace:S.trace(n);break;case L.LogLevel.Debug:S.debug(n);break;case L.LogLevel.Info:S.info(n);break;case L.LogLevel.Warning:S.warn(n);break;case L.LogLevel.Error:S.error(n);break;case L.LogLevel.Critical:S.critical(n);break;default:throw new Error("Invalid log level")}}class E extends L.AbstractMessageLogger{constructor(T,n,P,c){super();this.name=T,this.filepath=n,this.rotating=P,this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const T=this.rotating?6:1,n=30/T*g.ByteSize.MB;return I(this.name,this.filepath,n,T).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:c,message:m}of this.buffer)R(this._logger,c,m);this.buffer=[]}})}log(T,n){this._logger?R(this._logger,T,n):this.getLevel()<=T&&this.buffer.push({level:T,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=E}),define(me[117],ge([0,1,49,161,4]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var R;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function T(u,h){return h-u}S.compare=T;const n=Object.create(null);n[S.Error]=(0,L.localize)(0,null),n[S.Warning]=(0,L.localize)(1,null),n[S.Info]=(0,L.localize)(2,null);function P(u){return n[u]||""}S.toString=P;function c(u){switch(u){case g.default.Error:return S.Error;case g.default.Warning:return S.Warning;case g.default.Info:return S.Info;case g.default.Ignore:return S.Hint}}S.fromSeverity=c;function m(u){switch(u){case S.Error:return g.default.Error;case S.Warning:return g.default.Warning;case S.Info:return g.default.Info;case S.Hint:return g.default.Ignore}}S.toSeverity=m}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var E;(function(S){const T="";function n(c){return P(c,!0)}S.makeKey=n;function P(c,m){let u=[T];return c.source?u.push(c.source.replace("\xA6","\\\xA6")):u.push(T),c.code?typeof c.code=="string"?u.push(c.code.replace("\xA6","\\\xA6")):u.push(c.code.value.replace("\xA6","\\\xA6")):u.push(T),c.severity!==void 0&&c.severity!==null?u.push(R.toString(c.severity)):u.push(T),c.message&&m?u.push(c.message.replace("\xA6","\\\xA6")):u.push(T),c.startLineNumber!==void 0&&c.startLineNumber!==null?u.push(c.startLineNumber.toString()):u.push(T),c.startColumn!==void 0&&c.startColumn!==null?u.push(c.startColumn.toString()):u.push(T),c.endLineNumber!==void 0&&c.endLineNumber!==null?u.push(c.endLineNumber.toString()):u.push(T),c.endColumn!==void 0&&c.endColumn!==null?u.push(c.endColumn.toString()):u.push(T),u.push(T),u.join("\xA6")}S.makeKeyOptionalMessage=P})(E=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(me[190],ge([0,1,3,49,4]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,I.createDecorator)("notificationService");var C;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class E{constructor(){this.progress=new S,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=E;class S{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=S}),define(me[191],ge([0,1,6,9,2,4]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(E){return{resolved:E,dispose(){}}}});function R(E,S){return I.URI.isUri(E)?(0,L.equalsIgnoreCase)(E.scheme,S):(0,L.startsWithIgnoreCase)(E,S+":")}e.matchesScheme=R}),define(me[192],ge([0,1,10,11,38,22]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const E=L.globals.vscode.context.configuration();if(E)R=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const E=(0,C.dirname)(g.FileAccess.asFileUri("",Y));R=Y.__$__nodeRequire((0,C.joinPath)(E,"product.json").fsPath);const S=Y.__$__nodeRequire((0,C.joinPath)(E,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`}),Object.assign(R,{version:S.version})}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=R});var $e=this&&this.__param||function(Y,e){return function(g,L){e(g,L,Y)}};define(me[118],ge([0,1,18,21,6,4]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var R;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class E{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=E,E.None=Object.freeze({report(){}});let S=class extends I.Disposable{constructor(P,c){super();this.deferred=new g.DeferredPromise,c.withProgress(P,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};S=Ve([$e(1,e.IProgressService)],S),e.UnmanagedProgress=S;class T extends I.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(P){this.stop();const c=++this.currentOperationId,m=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:m.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(me[34],ge([0,1,56,13]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(R,E){g.ok(L.isString(R)),g.ok(L.isObject(E)),g.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,E)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new I}),define(me[119],ge([0,1,3,34]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class C{constructor(){this._onDidChangeSchema=new g.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,T){this.schemasById[I(S)]=T,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new C;L.Registry.add(e.Extensions.JSONContribution,R)}),define(me[85],ge([0,1,3,13,156,119,34]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const T=R.Registry.as(C.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new g.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new g.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(_,o=!0){this.registerConfigurations([_],o)}registerConfigurations(_,o=!0){const a=[];_.forEach(p=>{a.push(...this.validateAndRegisterProperties(p,o,p.extensionInfo)),this.configurationContributors.push(p),this.registerJSONConfiguration(p)}),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(_){const o=[],a=p=>{if(p.properties)for(const t in p.properties)o.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,p.properties[t]);p.allOf&&p.allOf.forEach(t=>a(t))};for(const p of _){a(p);const t=this.configurationContributors.indexOf(p);t!==-1&&this.configurationContributors.splice(t,1)}T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}registerDefaultConfigurations(_){const o=[],a=[];for(const p of _)for(const t in p)if(o.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...p[t]};const s={type:"object",default:this.defaultValues[t],description:I.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};a.push(c(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=p[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(_){const o=[];for(const a of _)for(const p in a)if(o.push(p),delete this.defaultValues[p],e.OVERRIDE_PROPERTY_PATTERN.test(p))delete this.configurationProperties[p],delete this.defaultLanguageConfigurationOverridesNode.properties[p];else{const t=this.configurationProperties[p];t&&(this.updatePropertyDefaultValue(p,t),this.updateSchema(p,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(..._){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(_){for(const o of _)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(_,o=!0,a,p=3){p=L.isUndefinedOrNull(_.scope)?p:_.scope;let t=[],s=_.properties;if(s)for(let i in s){if(o&&h(i)){delete s[i];continue}const f=s[i];if(this.updatePropertyDefaultValue(i,f),e.OVERRIDE_PROPERTY_PATTERN.test(i)?f.scope=void 0:(f.scope=L.isUndefinedOrNull(f.scope)?p:f.scope,f.restricted=L.isUndefinedOrNull(f.restricted)?!!a?.restrictedConfigurations?.includes(i):f.restricted),s[i].hasOwnProperty("included")&&!s[i].included){this.excludedConfigurationProperties[i]=s[i],delete s[i];continue}else this.configurationProperties[i]=s[i];!s[i].deprecationMessage&&s[i].markdownDeprecationMessage&&(s[i].deprecationMessage=s[i].markdownDeprecationMessage),t.push(i)}let r=_.allOf;if(r)for(let i of r)t.push(...this.validateAndRegisterProperties(i,o,a,p));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(_){const o=a=>{let p=a.properties;if(p)for(const s in p)this.updateSchema(s,p[s]);let t=a.allOf;t&&t.forEach(o)};o(_)}updateSchema(_,o){switch(e.allSettings.properties[_]=o,o.scope){case 1:e.applicationSettings.properties[_]=o;break;case 2:e.machineSettings.properties[_]=o;break;case 6:e.machineOverridableSettings.properties[_]=o;break;case 3:e.windowSettings.properties[_]=o;break;case 4:e.resourceSettings.properties[_]=o;break;case 5:e.resourceSettings.properties[_]=o,this.resourceLanguageSettingsSchema.properties[_]=o;break}}removeFromSchema(_,o){switch(delete e.allSettings.properties[_],o.scope){case 1:delete e.applicationSettings.properties[_];break;case 2:delete e.machineSettings.properties[_];break;case 6:delete e.machineOverridableSettings.properties[_];break;case 3:delete e.windowSettings.properties[_];break;case 4:case 5:delete e.resourceSettings.properties[_];break}}updateOverridePropertyPatternKey(){for(const _ of this.overrideIdentifiers.values()){const o=`[${_}]`,a={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,a),e.allSettings.properties[o]=a,e.applicationSettings.properties[o]=a,e.machineSettings.properties[o]=a,e.machineOverridableSettings.properties[o]=a,e.windowSettings.properties[o]=a,e.resourceSettings.properties[o]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(_,o){let a=this.defaultValues[_];L.isUndefined(a)&&(a=o.default),L.isUndefined(a)&&(a=m(o.type)),o.default=a}}const P="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(P);function c(k){return k.substring(1,k.length-1)}e.overrideIdentifierFromKey=c;function m(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const u=new n;R.Registry.add(e.Extensions.Configuration,u);function h(k){return k.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(k)?I.localize(5,null,k):u.getConfigurationProperties()[k]!==void 0?I.localize(6,null,k):null:I.localize(4,null)}e.validateProperty=h;function D(){const k=[],_=u.getConfigurationProperties();for(const o of Object.keys(_))k.push([o,_[o].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.getScopes=D}),define(me[120],ge([0,1,25,13,2,85,4,34]),function(Y,e,g,L,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function S(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof I.URI)}e.isConfigurationOverrides=S;var T;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function P(s,r){const i=r?s?r.keys.filter(A=>s.keys.indexOf(A)===-1):[...r.keys]:[],f=s?r?s.keys.filter(A=>r.keys.indexOf(A)===-1):[...s.keys]:[],l=[];if(r&&s){for(const A of s.keys)if(r.keys.indexOf(A)!==-1){const w=k(s.contents,A),F=k(r.contents,A);g.equals(w,F)||l.push(A)}}const d=[],b=A=>{const w={};for(const F of A)for(const O of F.identifiers)w[p(O)]=F;return w},y=r?b(r.overrides):{},v=s?b(s.overrides):{};if(Object.keys(y).length)for(const A of i){const w=y[A];w&&d.push([(0,C.overrideIdentifierFromKey)(A),w.keys])}if(Object.keys(v).length)for(const A of f){const w=v[A];w&&d.push([(0,C.overrideIdentifierFromKey)(A),w.keys])}if(Object.keys(y).length&&Object.keys(v).length)for(const A of l){const w=v[A],F=y[A];if(w&&F){const O=P({contents:w.contents,keys:w.keys,overrides:[]},{contents:F.contents,keys:F.keys,overrides:[]});d.push([(0,C.overrideIdentifierFromKey)(A),[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:f,updated:l,overrides:d}}e.compare=P;function c(s,r){const i=[];for(const f of Object.keys(s))if(C.OVERRIDE_PROPERTY_PATTERN.test(f)){const l={};for(const d in s[f])l[d]=s[f][d];i.push({identifiers:[(0,C.overrideIdentifierFromKey)(f).trim()],keys:Object.keys(l),contents:m(l,r)})}return i}e.toOverrides=c;function m(s,r){const i=Object.create(null);for(let f in s)u(i,f,s[f],r);return i}e.toValuesTree=m;function u(s,r,i,f){const l=r.split("."),d=l.pop();let b=s;for(let y=0;y<l.length;y++){let v=l[y],A=b[v];switch(typeof A){case"undefined":A=b[v]=Object.create(null);break;case"object":break;default:f(`Ignoring ${r} as ${l.slice(0,y+1).join(".")} is ${JSON.stringify(A)}`);return}b=A}if(typeof b=="object"&&b!==null)try{b[d]=i}catch(y){f(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(b)}`)}else f(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=u;function h(s,r){const i=r.split(".");D(s,i)}e.removeFromValueTree=h;function D(s,r){const i=r.shift();if(r.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const f=s[i];typeof f=="object"&&!Array.isArray(f)&&(D(f,r),Object.keys(f).length===0&&delete s[i])}}function k(s,r,i){function f(b,y){let v=b;for(const A of y){if(typeof v!="object"||v===null)return;v=v[A]}return v}const l=r.split("."),d=f(s,l);return typeof d=="undefined"?i:d}e.getConfigurationValue=k;function _(s,r,i){Object.keys(r).forEach(f=>{f!=="__proto__"&&(f in s?L.isObject(s[f])&&L.isObject(r[f])?_(s[f],r[f],i):i&&(s[f]=r[f]):s[f]=r[f])})}e.merge=_;function o(){const s=E.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=o;function a(){const s=Object.create(null),r=E.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let i in r){let f=r[i].default;u(s,i,f,l=>console.error(`Conflict in default settings: ${l}`))}return s}e.getDefaultValues=a;function p(s){return`[${s}]`}e.keyFromOverrideIdentifier=p;function t(s,r,i){const f=s.inspect(r),l=s.inspect(i);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:f.defaultValue}e.getMigratedSettingValue=t}),define(me[193],ge([0,1,17,3,59,6,24,25,13,2,120,85,34]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},s=[],r=[]){this._contents=t,this._keys=s,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?(0,n.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const i of g.distinct([...Object.keys(this.contents),...Object.keys(s)])){let f=this.contents[i],l=s[i];l&&(typeof f=="object"&&typeof l=="object"?(f=E.deepClone(f),this.mergeContents(f,l)):f=l),r[i]=f}return new m(r,this.keys,this.overrides)}merge(...t){const s=E.deepClone(this.contents),r=E.deepClone(this.overrides),i=[...this.keys];for(const f of t){this.mergeContents(s,f.contents);for(const l of f.overrides){const[d]=r.filter(b=>g.equals(b.identifiers,l.identifiers));d?this.mergeContents(d.contents,l.contents):r.push(E.deepClone(l))}for(const l of f.keys)i.indexOf(l)===-1&&i.push(l)}return new m(s,i,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&S.isObject(t[r])&&S.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=E.deepClone(s[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?E.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,n.addToValueTree)(this.contents,t,s,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let r=0;r<s;r++)t.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=m;class u extends m{constructor(){const t=(0,n.getDefaultValues)(),s=(0,n.getConfigurationKeys)(),r=[];for(const i of Object.keys(t))P.OVERRIDE_PROPERTY_PATTERN.test(i)&&r.push({identifiers:[(0,P.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],f=>console.error(`Conflict in default settings file: ${f}`))});super(t,s,r)}}e.DefaultConfigurationModel=u;class h{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!S.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:i,overrides:f,restricted:l}=this.doParseRaw(t,s);this._configurationModel=new m(r,i,f),this._restrictedConfigurations=l||[]}doParseContent(t){let s={},r=null,i=[],f=[],l=[];function d(y){Array.isArray(i)?i.push(y):r!==null&&(i[r]=y)}let b={onObjectBegin:()=>{let y={};d(y),f.push(i),i=y,r=null},onObjectProperty:y=>{r=y},onObjectEnd:()=>{i=f.pop()},onArrayBegin:()=>{let y=[];d(y),f.push(i),i=y,r=null},onArrayEnd:()=>{i=f.pop()},onLiteralValue:d,onError:(y,v,A)=>{l.push({error:y,offset:v,length:A})}};if(t)try{I.visit(t,b),s=i[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return s}doParseRaw(t,s){const r=c.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,r,!0,s);t=i.raw;const f=(0,n.toValuesTree)(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),l=Object.keys(t),d=(0,n.toOverrides)(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:f,keys:l,overrides:d,restricted:i.restricted}}filter(t,s,r,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const f={},l=[];for(let d in t)if(P.OVERRIDE_PROPERTY_PATTERN.test(d)&&r){const b=this.filter(t[d],s,!1,i);f[d]=b.raw,l.push(...b.restricted)}else{const b=s[d],y=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&l.push(d),(y===void 0||i.scopes===void 0||i.scopes.includes(y))&&(i.skipRestricted&&b?.restricted||(f[d]=t[d]))}return{raw:f,restricted:l}}}e.ConfigurationModelParser=h;class D extends C.Disposable{constructor(t,s,r,i){super();this.userSettingsResource=t,this.scopes=s,this.fileService=i,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class k{constructor(t,s,r=new m,i=new m,f=new R.ResourceMap,l=new m,d=new R.ResourceMap,b=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=f,this._memoryConfiguration=l,this._memoryConfigurationByResource=d,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(t)}updateValue(t,s,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new m,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,s===void 0?i.removeValue(t):i.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const i=this.getConsolidateConfigurationModel(s,r),f=this.getFolderConfigurationModelForResource(s.resource,r),l=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,d=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),b=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),y=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),v=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),A=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,w=f?s.overrideIdentifier?f.freeze().override(s.overrideIdentifier).getValue(t):f.freeze().getValue(t):void 0,F=s.overrideIdentifier?l.override(s.overrideIdentifier).getValue(t):l.getValue(t),O=i.getValue(t),G=g.distinct(g.flatten(i.overrides.map(K=>K.identifiers))).filter(K=>i.getOverrideValue(t,K)!==void 0);return{defaultValue:d,userValue:b,userLocalValue:y,userRemoteValue:v,workspaceValue:A,workspaceFolderValue:w,memoryValue:F,value:O,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:y!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:v!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:w!==void 0?{value:f?.freeze().getValue(t),override:s.overrideIdentifier?f?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:l.getValue(t),override:s.overrideIdentifier?l.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=s.filter(i=>P.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const f=(0,P.overrideIdentifierFromKey)(i),l=this._defaultConfiguration.getKeysForOverrideIdentifier(f),d=t.getKeysForOverrideIdentifier(f),b=[...d.filter(y=>l.indexOf(y)===-1),...l.filter(y=>d.indexOf(y)===-1),...l.filter(y=>!E.equals(this._defaultConfiguration.override(f).getValue(y),t.override(f).getValue(y)))];return[f,b]});return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:i,overrides:f}=(0,n.compare)(this.localUserConfiguration,t),l=[...s,...r,...i];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:f}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:i,overrides:f}=(0,n.compare)(this.remoteUserConfiguration,t);let l=[...s,...r,...i];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:f}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:i,overrides:f}=(0,n.compare)(this.workspaceConfiguration,t);let l=[...s,...r,...i];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:f}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:i,updated:f,removed:l,overrides:d}=(0,n.compare)(r,s);let b=[...i,...f,...l];return(b.length||!r)&&this.updateFolderConfiguration(t,s),{keys:b,overrides:d}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:i,removed:f,overrides:l}=(0,n.compare)(s,void 0);return{keys:[...r,...i,...f],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let r=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const i=s.getFolder(t);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const f=this._memoryConfigurationByResource.get(t);f&&(r=r.merge(f))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(s=r.merge(i),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:i,keys:f}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:i,keys:f}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),f=t.folders.reduce((l,d)=>(l.set(T.URI.revive(d[0]),this.parseConfigurationModel(d[1])),l),new R.ResourceMap);return new k(s,r,new m,i,f,new m,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=k;function _(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const t=new Set,s=new Map;for(const i of p)i.keys.forEach(f=>t.add(f)),i.overrides.forEach(([f,l])=>{const d=(0,R.getOrSet)(s,f,new Set);l.forEach(b=>d.add(b))});const r=[];return s.forEach((i,f)=>r.push([f,[...i.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=_;class o{constructor(t,s,r,i){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const f=new Set;t.keys.forEach(d=>f.add(d)),t.overrides.forEach(([,d])=>d.forEach(b=>f.add(b))),this.affectedKeys=[...f.values()];const l=new m;this.affectedKeys.forEach(d=>l.setValue(d,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=k.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!E.equals(r,i)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let r=(0,n.toValuesTree)({[s]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(t=t[i],!t)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=o;class a extends o{constructor(t,s,r,i){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=a}),define(me[121],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var L;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(R,E=L.Unknown,S){super(R);this._message=R,this._code=E,this._detail=S,this.isHandled=E===L.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(R){return R instanceof I&&R._code===L.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof I&&R._code===L.NoResolverFound}static isHandled(R){return R instanceof I&&R.isHandled}}e.RemoteAuthorityResolverError=I}),define(me[86],ge([0,1,10]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(T){return T.scheme===g.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=L;function I(T){if(!T)return;const n=T.indexOf("+");return n<0?T:T.substr(0,n)}e.getRemoteName=I;function C(T){return T.scheme!==g.Schemas.file&&T.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=C;function R(T){if(T.folders.length)return T.folders.every(n=>C(n.uri))?T.folders[0].uri:void 0;if(T.configuration&&C(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=R;function E(T){return R(T)?.scheme}e.getVirtualWorkspaceScheme=E;function S(T){return R(T)!==void 0}e.isVirtualWorkspace=S}),define(me[194],ge([0,1,3,11,4,12]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService");var R;(function(m){m.Http="http",m.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var E;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function T(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=T,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function n(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=n;function P(m,u){return u?u!==1&&m<1024:!L.isWindows&&m<1024}e.isPortPrivileged=P;let c=class{constructor(u){this.logService=u,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u,h){return this._tunnelProvider=u,u?(this._canElevate=h.elevation,this._canMakePublic=h.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async u=>{const h=[],D=Array.from(this._tunnels.values());for(let k of D){const _=Array.from(k.values());for(let o of _){const a=await o.value;a&&h.push(a)}}u(h)})}async dispose(){for(const u of this._tunnels.values()){for(const{value:h}of u.values())await h.then(D=>D?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,h,D,k,_=!1,o=!1,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${D} on local port ${k}.`),!u)return;h||(h="localhost");const p=this.retainOrCreateTunnel(u,h,D,k,_,o,a);return p?p.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,D);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(t);return(t.tunnelRemoteHost!==h||t.tunnelRemotePort!==D)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,public:u.public,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const h=this._tunnels.get(u.tunnelRemoteHost);if(h){const D=h.get(u.tunnelRemotePort);D&&(D.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,D))}}}}async tryDisposeTunnel(u,h,D){if(D.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${h}.`);const k=D.value.then(async _=>{_&&(await _.dispose(!0),this._onTunnelClosed.fire({host:_.tunnelRemoteHost,port:_.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(h),k}}async closeTunnel(u,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${h} `);const D=this._tunnels.get(u);if(D&&D.has(h)){const k=D.get(h);k.refcount=0,await this.tryDisposeTunnel(u,h,k)}}addTunnelToMap(u,h,D){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(h,{refcount:1,value:D})}async removeEmptyTunnelFromMap(u,h){const D=this._tunnels.get(u);D&&(await D.get(h)||D.delete(h),D.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,h){let D=[u];T(u)?(D.push(...e.LOCALHOST_ADDRESSES),D.push(...e.ALL_INTERFACES_ADDRESSES)):n(u)&&D.push(...e.ALL_INTERFACES_ADDRESSES);const k=D.map(_=>this._tunnels.get(_));for(const _ of k){const o=_?.get(h);if(o)return o}}canTunnel(u){return!!S(u)}createWithProvider(u,h,D,k,_,o,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${D} on local port ${k}.`);const t={elevationRequired:_?P(k===void 0?D:k):!1},s={remoteAddress:{host:h,port:D},localAddressPort:k,public:o,protocol:a},r=u.forwardPort(s,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(h,D,r),r}};c=Ve([$e(0,C.ILogService)],c),e.AbstractTunnelService=c}),define(me[195],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{vsda(){return new Promise((I,C)=>Y(["vsda"],I,C))}async sign(I){try{const C=await this.vsda(),R=new C.signer;if(R)return R.sign(I)}catch(C){}return I}}e.SignService=g}),define(me[196],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.TerminalPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(h){h.Shell="terminal.integrated.shell.",h.ShellArgs="terminal.integrated.shellArgs.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var I;(function(h){h.ShellLinux="terminal.integrated.shell.linux",h.ShellMacOs="terminal.integrated.shell.osx",h.ShellWindows="terminal.integrated.shell.windows",h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationShellLinux="terminal.integrated.automationShell.linux",h.AutomationShellMacOs="terminal.integrated.automationShell.osx",h.AutomationShellWindows="terminal.integrated.automationShell.windows",h.ShellArgsLinux="terminal.integrated.shellArgs.linux",h.ShellArgsMacOs="terminal.integrated.shellArgs.osx",h.ShellArgsWindows="terminal.integrated.shellArgs.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.TitleMode="terminal.integrated.titleMode",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.PersistentSessionExperimentalSerializer="terminal.integrated.persistentSessionExperimentalSerializer",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover"})(I=e.TerminalSettingId||(e.TerminalSettingId={}));var C;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(C=e.WindowsShellType||(e.WindowsShellType={}));var R;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(R=e.TitleEventSource||(e.TitleEventSource={}));var E;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.Log="log",h.Heartbeat="heartbeat"})(E=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,g.createDecorator)("ptyService");var S;(function(h){h[h.Cwd=0]="Cwd",h[h.InitialCwd=1]="InitialCwd"})(S=e.TerminalPropertyType||(e.TerminalPropertyType={}));var T;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(T=e.HeartbeatConstants||(e.HeartbeatConstants={}));var n;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(n=e.TerminalLocation||(e.TerminalLocation={}));var P;(function(h){h.TerminalView="view",h.Editor="editor"})(P=e.TerminalLocationString||(e.TerminalLocationString={}));var c;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(c=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var m;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(m=e.FlowControlConstants||(e.FlowControlConstants={}));var u;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(u=e.ProfileSource||(e.ProfileSource={}))}),define(me[197],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,C,R=5){let E;return E=C(S=>{const T=typeof S=="string"?S:S.data;let n=this._terminalBufferMap.get(I);if(n){n.data.push(T);return}const P=setTimeout(()=>this.flushBuffer(I),R);n={data:[T],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(I),E.dispose()}},this._terminalBufferMap.set(I,n)}),E}stopBuffering(I){const C=this._terminalBufferMap.get(I);C&&C.dispose()}flushBuffer(I){const C=this._terminalBufferMap.get(I);C&&(this._terminalBufferMap.delete(I),this._callback(I,C.data.join("")))}}e.TerminalDataBufferer=g}),define(me[198],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(me[63],ge([0,1,47,3,6,4,34,198]),function(Y,e,g,L,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var S;(function(D){function k(_){return _&&typeof _=="object"&&typeof _.id=="string"}D.isThemeColor=k})(S=e.ThemeColor||(e.ThemeColor={}));function T(D){return{id:D}}e.themeColorFromId=T;var n;(function(D){function k(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||S.isThemeColor(s.color))}D.isThemeIcon=k;const _=new RegExp(`^\\$\\((${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?)\\)$`);function o(s){const r=_.exec(s);if(!r)return;let[,i]=r;return{id:i}}D.fromString=o;function a(s,r){let i=s.id;const f=i.lastIndexOf("~");return f!==-1&&(i=i.substring(0,f)),r&&(i=`${i}~${r}`),{id:i}}D.modify=a;function p(s,r){return s.id===r.id&&s.color?.id===r.color?.id}D.isEqual=p;function t(s,r){return{id:s.id,color:r?T(r):void 0}}D.asThemeIcon=t,D.asClassNameArray=g.CSSIcon.asClassNameArray,D.asClassName=g.CSSIcon.asClassName,D.asCSSSelector=g.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=g.Codicon.file,e.FolderThemeIcon=g.Codicon.folder;function P(D){switch(D){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(k){return this.themingParticipants.push(k),this.onThemingParticipantAddedEmitter.fire(k),(0,I.toDisposable)(()=>{const _=this.themingParticipants.indexOf(k);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new c;R.Registry.add(e.Extensions.ThemingContribution,m);function u(D){return m.onColorThemeChange(D)}e.registerThemingParticipant=u;class h extends I.Disposable{constructor(k){super();this.themeService=k,this.theme=k.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(k){this.theme=k,this.updateStyles()}updateStyles(){}getColor(k,_){let o=this.theme.getColor(k);return o&&_&&(o=_(o,this.theme)),o?o.toString():null}}e.Themable=h}),define(me[199],ge([0,1,18,47,3,162,119,34,63]),function(Y,e,g,L,I,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class T{constructor(){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,C.localize)(0,null)},fontCharacter:{type:"string",description:(0,C.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(k,_,o,a){const p=this.iconsById[k];if(p){if(o&&!p.description){p.description=o,this.iconSchema.properties[k].markdownDescription=`${o} $(${k})`;const r=this.iconReferenceSchema.enum.indexOf(k);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=o),this._onDidChange.fire()}return p}let t={id:k,description:o,defaults:_,deprecationMessage:a};this.iconsById[k]=t;let s={$ref:"#/definitions/icons"};return a&&(s.deprecationMessage=a),o&&(s.markdownDescription=`${o}: $(${k})`),this.iconSchema.properties[k]=s,this.iconReferenceSchema.enum.push(k),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:k}}deregisterIcon(k){delete this.iconsById[k],delete this.iconSchema.properties[k];const _=this.iconReferenceSchema.enum.indexOf(k);_!==-1&&(this.iconReferenceSchema.enum.splice(_,1),this.iconReferenceSchema.enumDescriptions.splice(_,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(k=>this.iconsById[k])}getIcon(k){return this.iconsById[k]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(k,_){const o=this.iconFontsById[k];if(o)return o;let a={id:k,definition:_};return this.iconFontsById[k]=a,this._onDidChange.fire(),a}deregisterIconFont(k){delete this.iconFontsById[k]}getIconFonts(){return Object.keys(this.iconFontsById).map(k=>this.iconFontsById[k])}getIconFont(k){return this.iconFontsById[k]}toString(){const k=(p,t)=>p.id.localeCompare(t.id),_=p=>{for(;S.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of a.filter(t=>!!t.description).sort(k))o.push(`|<i class="${_(p)}"></i>|${p.id}|${S.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const p of a.filter(t=>!S.ThemeIcon.isThemeIcon(t.defaults)).sort(k))o.push(`|<i class="${_(p)}"></i>|${p.id}|`);return o.join(`
`)}}const n=new T;E.Registry.add(e.Extensions.IconContribution,n);function P(D,k,_,o){return n.registerIcon(D,k,_,o)}e.registerIcon=P;function c(){return n}e.getIconRegistry=c;function m(){for(const D of L.iconRegistry.all)n.registerIcon(D.id,D.definition,D.description);L.iconRegistry.onDidRegister(D=>n.registerIcon(D.id,D.definition,D.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let u=E.Registry.as(R.Extensions.JSONContribution);u.registerSchema(e.iconsSchemaId,n.getIconSchema());const h=new g.RunOnceScheduler(()=>u.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{h.isScheduled()||h.schedule()}),e.widgetClose=P("widget-close",L.Codicon.close,(0,C.localize)(2,null)),e.gotoPreviousLocation=P("goto-previous-location",L.Codicon.arrowUp,(0,C.localize)(3,null)),e.gotoNextLocation=P("goto-next-location",L.Codicon.arrowDown,(0,C.localize)(4,null)),e.syncing=S.ThemeIcon.modify(L.Codicon.sync,"spin")}),define(me[43],ge([0,1,24,22,2,4]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var R;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(R=e.WorkbenchState||(e.WorkbenchState={}));function E(c){const m=c;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=E;function S(c){const m=c;return!!(m&&typeof m=="object"&&I.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=S;class T{constructor(m,u,h,D){this._id=m,this._configuration=h,this._ignorePathCasing=D,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=T;class n{constructor(m,u){this.raw=u,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,L.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function P(c){return new n({uri:c,index:0,name:(0,L.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=P}),define(me[200],ge([0,1,29,59,138,79,10,8,11,22,2,163,4,86,43]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(U){return(typeof U=="string"?(0,E.extname)(U):(0,T.extname)(U))===h}e.hasWorkspaceFileExtension=D,e.IWorkspacesService=(0,c.createDecorator)("workspacesService");function k(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=k;function _(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=_;function o(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=o;function a(U){const z=U;return typeof z?.id=="string"&&n.URI.isUri(z.uri)}e.isSingleFolderWorkspaceIdentifier=a;function p(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=p;function t(U){const z=U;return typeof z?.id=="string"&&n.URI.isUri(z.configPath)}e.isWorkspaceIdentifier=t;function s(U){const z=U;if(z?.uri)return{id:z.id,uri:n.URI.revive(z.uri)};const N=U;if(N?.configPath)return{id:N.id,configPath:n.URI.revive(N.configPath)};if(U?.id)return{id:U.id}}e.reviveIdentifier=s;function r(U,z){return T.extUriBiasedIgnorePathCase.isEqualOrParent(U,z.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function i(U){return f(U)||l(U)}e.isStoredWorkspaceFolder=i;function f(U){const z=U;return typeof z?.path=="string"&&(!z.name||typeof z.name=="string")}e.isRawFileWorkspaceFolder=f;function l(U){const z=U;return typeof z?.uri=="string"&&(!z.name||typeof z.name=="string")}e.isRawUriWorkspaceFolder=l;function d(U,z,N,B,x=!S.isWindows,M){if(U.scheme!==B.scheme)return{name:N,uri:U.toString(!0)};let H=z?void 0:M.relativePath(B,U);if(H!==void 0)H.length===0?H=".":S.isWindows&&U.scheme===R.Schemas.file&&!x&&(H=H.replace(/\//g,"\\"));else if(U.scheme===R.Schemas.file)H=U.fsPath,S.isWindows&&(H=(0,C.normalizeDriveLetter)(H),x&&(H=(0,g.toSlashes)(H)));else{if(!M.isEqualAuthority(U.authority,B.authority))return{name:N,uri:U.toString(!0)};H=U.path}return{name:N,path:H}}e.getStoredWorkspaceFolder=d;function b(U,z,N){let B=[],x=new Set;const M=N.dirname(z);for(let H of U){let $;if(f(H))H.path&&($=N.resolvePath(M,H.path));else if(l(H))try{$=n.URI.parse(H.uri),$.path[0]!=="/"&&($=$.with({path:"/"+$.path}))}catch(Q){console.warn(Q)}if($){let Q=N.getComparisonKey($);if(!x.has(Q)){x.add(Q);const X=H.name||N.basenameOrAuthority($);B.push(new u.WorkspaceFolder({uri:$,name:X,index:B.length},H))}}}return B}e.toWorkspaceFolders=b;function y(U,z,N,B,x){let M=v(z,U);const H=x.dirname(z),$=x.dirname(B),Q=[],X=A(M.folders);for(const Re of M.folders){const We=f(Re)?x.resolvePath(H,Re.path):n.URI.parse(Re.uri);let Be;N?Be=!1:Be=!f(Re)||(0,E.isAbsolute)(Re.path),Q.push(d(We,Be,Re.name,$,X,x))}const he={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},_e=I.setProperty(U,["folders"],Q,he);let ye=I.applyEdits(U,_e);return M.remoteAuthority===(0,m.getRemoteAuthority)(B)&&(ye=I.applyEdits(ye,I.removeProperty(ye,["remoteAuthority"],he))),ye}e.rewriteWorkspaceFileForNewLocation=y;function v(U,z){let N=L.parse(z);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(B=>i(B));else throw new Error(`${U} looks like an invalid workspace file.`);return N}function A(U){return S.isWindows?U.some(z=>f(z)&&z.path.indexOf("/")>=0):!0}e.useSlashForPath=A;function w(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function F(U){return typeof U.folderUri=="string"}function O(U){return typeof U.fileUri=="string"}function G(U,z){const N={workspaces:[],files:[]};if(U){const B=function(M,H){for(let $=0;$<M.length;$++)try{H(M[$],$)}catch(Q){z.warn(`Error restoring recent entry ${JSON.stringify(M[$])}: ${Q.toString()}. Skip entry.`)}},x=U;if(Array.isArray(x.entries))B(x.entries,M=>{const H=M.label,$=M.remoteAuthority;w(M)?N.workspaces.push({label:H,remoteAuthority:$,workspace:{id:M.workspace.id,configPath:n.URI.parse(M.workspace.configPath)}}):F(M)?N.workspaces.push({label:H,remoteAuthority:$,folderUri:n.URI.parse(M.folderUri)}):O(M)&&N.files.push({label:H,remoteAuthority:$,fileUri:n.URI.parse(M.fileUri)})});else{const M=U;Array.isArray(M.workspaces3)&&B(M.workspaces3,(H,$)=>{const Q=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[$]||void 0;typeof H=="object"&&typeof H.id=="string"&&typeof H.configURIPath=="string"?N.workspaces.push({label:Q,workspace:{id:H.id,configPath:n.URI.parse(H.configURIPath)}}):typeof H=="string"&&N.workspaces.push({label:Q,folderUri:n.URI.parse(H)})}),Array.isArray(M.files2)&&B(M.files2,(H,$)=>{const Q=Array.isArray(M.fileLabels)&&M.fileLabels[$]||void 0;typeof H=="string"&&N.files.push({label:Q,fileUri:n.URI.parse(H)})})}}return N}e.restoreRecentlyOpened=G;function K(U){const z={entries:[]};for(const N of U.workspaces)_(N)?z.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):z.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of U.files)z.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return z}e.toStoreData=K}),define(me[87],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const C=this._idPool++;return this._data.set(C,I),this.logDebugInfo(),C}get(I,C){return this._data.has(I)?this._data.get(I)[C]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(me[52],ge([0,1,10,22,4]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(E=>{const S=this._providerInfo.get(E.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(E,S){S===null?this._providerInfo.delete(E):this._providerInfo.set(E,S)}isFreeScheme(E){return!this._providerInfo.has(E)&&!this._systemSchemes.has(E)}getCapabilities(E){return this._providerInfo.get(E)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(me[201],ge([0,1,18]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(R,E,S){this._deferredPromises=new Map,this._id=R,this._shared=E,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of T.values())n.complete()}catch(n){for(const P of T.values())P.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,E){let S=this._value[R];return typeof S=="undefined"&&(S=E),S}update(R,E){this._value[R]=E;let S=this._deferredPromises.get(R);if(S!==void 0)return S.p;const T=new g.DeferredPromise;return this._deferredPromises.set(R,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class I extends L{constructor(R,E){super(R.identifier.value,!0,E);this._extension=R}setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}}e.ExtensionGlobalMemento=I}),define(me[202],ge([0,1,3,2,12]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(E,S){this._logService=E,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(E,S,T){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(E)).acceptModelChanged(S.value,T)}$acceptDirtyStateChanged(E,S){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(E)).acceptDirty(S)}$acceptModelSaved(E){const S=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(E));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(E,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",E.path,S);const T=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(E));T.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};C=Ve([$e(0,I.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(me[14],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class L{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=L});var nt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[203],ge([0,1,26,3]),function(Y,e,g,L){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(E,S){I.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(E.identifier),nt(this,I,S,"f"),Oe(this,I,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(E){return Oe(this,I,"f").get(this._id,E)}store(E,S){return Oe(this,I,"f").store(this._id,E,S)}delete(E){return Oe(this,I,"f").delete(this._id,E)}}e.ExtensionSecrets=C,I=new WeakMap}),define(me[122],ge([0,1,4,3]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(R){this._enabled=R}$onDidChangeTelemetryEnabled(R){this._enabled=R,this._onDidChangeTelemetryEnabled.fire(R)}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(me[64],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(_){_[_.Upsert=0]="Upsert",_[_.RemoveChild=1]="RemoveChild",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp",_[_.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,I=(_,o)=>{const a={controllerId:o};return L.set(_,a),a};e.createPrivateApiFor=I;const C=_=>L.get(_);e.getPrivateApiFor=C;const R=(_,o,a,p)=>{let t=a;return{enumerable:!0,configurable:!1,get(){return t},set(s){if(!p(t,s)){const r=t;t=s,_.listener?.({op:3,key:o,value:s,previous:r})}}}},E=(_,o)=>_===o,S={range:(_,o)=>_===o?!0:!_||!o?!1:_.isEqual(o),label:E,description:E,busy:E,error:E,canResolveChildren:E,tags:(_,o)=>!(_.length!==o.length||_.some(a=>!o.find(p=>a.id===p.id)))},T=Object.keys(S),n=(_,o)=>({range:R(_,"range",void 0,S.range),label:R(_,"label",o,S.label),description:R(_,"description",void 0,S.description),canResolveChildren:R(_,"canResolveChildren",!1,S.canResolveChildren),busy:R(_,"busy",!1,S.busy),error:R(_,"error",void 0,S.error),tags:R(_,"tags",[],S.tags)}),P=(_,o)=>{const a=new Map;for(const p of T)S[p](_[p],o[p])||a.set(p,o[p]);return a};e.diffTestItems=P;class c extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=c;class m extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class u extends Error{constructor(o,a,p){super(`TestItem with ID "${o}" is from controller "${a}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=u;const h=_=>{const o=(0,e.getPrivateApiFor)(_);let a=new Map;return{get size(){return a.size},forEach(p,t){for(const s of a.values())p.call(t,s,this)},replace(p){const t=new Map,s=new Set(a.keys()),r={op:4,ops:[]};for(const i of p){if(!(i instanceof D))throw new m(i.id);const f=(0,e.getPrivateApiFor)(i).controllerId;if(f!==o.controllerId)throw new u(i.id,f,o.controllerId);if(t.has(i.id))throw new c(i.id);t.set(i.id,i),s.delete(i.id),r.ops.push({op:0,item:i})}for(const i of s.keys())r.ops.push({op:1,id:i});o.listener?.(r),a=t},add(p){if(!(p instanceof D))throw new m(p.id);a.set(p.id,p),o.listener?.({op:0,item:p})},delete(p){a.delete(p)&&o.listener?.({op:1,id:p})},get(p){return a.get(p)},toJSON(){return Array.from(a.values())},[Symbol.iterator](){return a.values()}}};class D{constructor(o,a,p,t){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const s=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof k?void 0:s.parent}},children:{value:h(this),enumerable:!0,writable:!1},...n(s,p)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=D;class k extends D{constructor(o,a){super(o,o,a,void 0)}}e.TestItemRootImpl=k}),define(me[53],ge([0,1,4,3,14]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var C;(function(E){function S(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}E.fromApiTunnel=S;function T(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}E.fromServiceTunnel=T})(C=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let R=class{constructor(S){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,T){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,T){return{dispose:()=>{}}}async $providePortAttributes(S,T,n,P,c){return[]}async $forwardPort(S,T){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=Ve([$e(0,I.IExtHostRpcService)],R),e.ExtHostTunnelService=R});var nt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[7],ge([0,1,17,16,99,24,102,13,2,32,42,121]),function(Y,e,g,L,I,C,R,E,S,T,n,P){"use strict";var c,m,u,h,D,k,_,o,a,p,t,s,r,i,f,l,d,b,y,v;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(j){function W(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(W,j),Object.setPrototypeOf(W.prototype,j.prototype),W}let w=D=class{constructor(W){c.set(this,void 0),nt(this,c,W,"f")}static from(...W){let se=W;return new D(function(){if(se){for(const Ce of se)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();se=void 0}})}dispose(){typeof Oe(this,c,"f")=="function"&&(Oe(this,c,"f").call(this),nt(this,c,void 0,"f"))}};c=new WeakMap,w=D=Ve([A],w),e.Disposable=w;let F=k=class{constructor(W,se){if(W<0)throw(0,L.illegalArgument)("line must be non-negative");if(se<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=W,this._character=se}static Min(...W){if(W.length===0)throw new TypeError;let se=W[0];for(let Ce=1;Ce<W.length;Ce++){const et=W[Ce];et.isBefore(se)&&(se=et)}return se}static Max(...W){if(W.length===0)throw new TypeError;let se=W[0];for(let Ce=1;Ce<W.length;Ce++){const et=W[Ce];et.isAfter(se)&&(se=et)}return se}static isPosition(W){if(!W)return!1;if(W instanceof k)return!0;let{line:se,character:Ce}=W;return typeof se=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,se=0){if(W===null||se===null)throw(0,L.illegalArgument)();let Ce;return typeof W=="undefined"?Ce=0:typeof W=="number"?Ce=W:(Ce=typeof W.lineDelta=="number"?W.lineDelta:0,se=typeof W.characterDelta=="number"?W.characterDelta:0),Ce===0&&se===0?this:new k(this.line+Ce,this.character+se)}with(W,se=this.character){if(W===null||se===null)throw(0,L.illegalArgument)();let Ce;return typeof W=="undefined"?Ce=this.line:typeof W=="number"?Ce=W:(Ce=typeof W.line=="number"?W.line:this.line,se=typeof W.character=="number"?W.character:this.character),Ce===this.line&&se===this.character?this:new k(Ce,se)}toJSON(){return{line:this.line,character:this.character}}};F=k=Ve([A],F),e.Position=F;let O=_=class{constructor(W,se,Ce,et){let st,ut;if(typeof W=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof et=="number"?(st=new F(W,se),ut=new F(Ce,et)):W instanceof F&&se instanceof F&&(st=W,ut=se),!st||!ut)throw new Error("Invalid arguments");st.isBefore(ut)?(this._start=st,this._end=ut):(this._start=ut,this._end=st)}static isRange(W){return W instanceof _?!0:W?F.isPosition(W.start)&&F.isPosition(W.end):!1}get start(){return this._start}get end(){return this._end}contains(W){return W instanceof _?this.contains(W._start)&&this.contains(W._end):W instanceof F?!(W.isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const se=F.Max(W.start,this._start),Ce=F.Min(W.end,this._end);if(!se.isAfter(Ce))return new _(se,Ce)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const se=F.Min(W.start,this._start),Ce=F.Max(W.end,this.end);return new _(se,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,se=this.end){if(W===null||se===null)throw(0,L.illegalArgument)();let Ce;return W?F.isPosition(W)?Ce=W:(Ce=W.start||this.start,se=W.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&se.isEqual(this.end)?this:new _(Ce,se)}toJSON(){return[this.start,this.end]}};O=_=Ve([A],O),e.Range=O;let G=o=class extends O{constructor(W,se,Ce,et){let st,ut;if(typeof W=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof et=="number"?(st=new F(W,se),ut=new F(Ce,et)):W instanceof F&&se instanceof F&&(st=W,ut=se),!st||!ut)throw new Error("Invalid arguments");super(st,ut);this._anchor=st,this._active=ut}static isSelection(W){return W instanceof o?!0:W?O.isRange(W)&&F.isPosition(W.anchor)&&F.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=o=Ve([A],G),e.Selection=G;class K{constructor(W,se,Ce){if(typeof W!="string"||W.length===0)throw(0,L.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,L.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,L.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(se),this.connectionToken=Ce}}e.ResolvedAuthority=K;class U extends Error{constructor(W,se=P.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(W);this._message=W,this._code=se,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}static NotAvailable(W,se){return new U(W,P.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(W){return new U(W,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=U;var z;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var N;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(N=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=a=class{constructor(W,se){this._range=W,this._newText=se}static isTextEdit(W){return W instanceof a?!0:W?O.isRange(W)&&typeof W.newText=="string":!1}static replace(W,se){return new a(W,se)}static insert(W,se){return a.replace(new O(W,W),se)}static delete(W){return a.replace(W,"")}static setEndOfLine(W){const se=new a(new O(new F(0,0),new F(0,0)),"");return se.newEol=W,se}get range(){return this._range}set range(W){if(W&&!O.isRange(W))throw(0,L.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,L.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,L.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=a=Ve([A],B),e.TextEdit=B;var x;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace"})(x=e.FileEditType||(e.FileEditType={}));let M=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,se,Ce,et){this._edits.push({_type:1,from:W,to:se,options:Ce,metadata:et})}createFile(W,se,Ce){this._edits.push({_type:1,from:void 0,to:W,options:se,metadata:Ce})}deleteFile(W,se,Ce){this._edits.push({_type:1,from:W,to:void 0,options:se,metadata:Ce})}replaceNotebookMetadata(W,se,Ce){this._edits.push({_type:3,metadata:Ce,uri:W,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(W,se,Ce,et,st){let ut,ht,Dt=[],At;if(zt.isNotebookRange(se)&&Ft.isNotebookCellDataArray(Ce)&&!Ft.isNotebookCellDataArray(et)?(ut=se.start,ht=se.end,Dt=Ce,At=et):typeof se=="number"&&typeof Ce=="number"&&Ft.isNotebookCellDataArray(et)&&(ut=se,ht=Ce,Dt=et,At=st),ut===void 0||ht===void 0)throw new Error("Invalid arguments");(ut!==ht||Dt.length>0)&&this._edits.push({_type:5,uri:W,index:ut,count:ht-ut,cells:Dt,metadata:At})}replaceNotebookCellMetadata(W,se,Ce,et){this._edits.push({_type:3,metadata:et,uri:W,edit:{editType:8,index:se,metadata:Ce}})}replace(W,se,Ce,et){this._edits.push({_type:2,uri:W,edit:new B(se,Ce),metadata:et})}insert(W,se,Ce,et){this.replace(W,new O(se,se),Ce,et)}delete(W,se,Ce){this.replace(W,se,"",Ce)}has(W){return this._edits.some(se=>se._type===2&&se.uri.toString()===W.toString())}set(W,se){if(se)for(const Ce of se)Ce&&this._edits.push({_type:2,uri:W,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const et=this._edits[Ce];et._type===2&&et.uri.toString()===W.toString()&&(this._edits[Ce]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get(W){const se=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===W.toString()&&se.push(Ce.edit);return se}entries(){const W=new C.ResourceMap;for(let se of this._edits)if(se._type===2){let Ce=W.get(se.uri);Ce||(Ce=[se.uri,[]],W.set(se.uri,Ce)),Ce[1].push(se.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};M=Ve([A],M),e.WorkspaceEdit=M;let H=p=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof p?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=p._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,se=this._tabstop++){if(typeof W=="function"){const Ce=new p;Ce._tabstop=this._tabstop,W(Ce),this._tabstop=Ce._tabstop,W=Ce.value}else W=p._escape(W);return this.value+="${",this.value+=se,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,se=this._tabstop++){const Ce=W.map(et=>et.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(W,se){if(typeof se=="function"){const Ce=new p;Ce._tabstop=this._tabstop,se(Ce),this._tabstop=Ce._tabstop,se=Ce.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,se&&(this.value+=":",this.value+=se),this.value+="}",this}};H=p=Ve([A],H),e.SnippetString=H;var $;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})($=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let X=t=class{constructor(W,se){if(this.uri=W,se)if(se instanceof O)this.range=se;else if(se instanceof F)this.range=new O(se,se);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof t?!0:W?O.isRange(W.range)&&S.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};X=t=Ve([A],X),e.Location=X;let he=class{constructor(W,se){this.location=W,this.message=se}static is(W){return W?typeof W.message=="string"&&W.location&&O.isRange(W.location.range)&&S.URI.isUri(W.location.uri):!1}static isEqual(W,se){return W===se?!0:!W||!se?!1:W.message===se.message&&W.location.range.isEqual(se.location.range)&&W.location.uri.toString()===se.location.uri.toString()}};he=Ve([A],he),e.DiagnosticRelatedInformation=he;let _e=class{constructor(W,se,Ce=Q.Error){if(!O.isRange(W))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=W,this.message=se,this.severity=Ce}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,se){return W===se?!0:!W||!se?!1:W.message===se.message&&W.severity===se.severity&&W.code===se.code&&W.severity===se.severity&&W.source===se.source&&W.range.isEqual(se.range)&&(0,g.equals)(W.tags,se.tags)&&(0,g.equals)(W.relatedInformation,se.relatedInformation,he.isEqual)}};_e=Ve([A],_e),e.Diagnostic=_e;let ye=class{constructor(W,se){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=se}};ye=Ve([A],ye),e.Hover=ye;var Re;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Re=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor(W,se=Re.Text){this.range=W,this.kind=se}toJSON(){return{range:this.range,kind:Re[this.kind]}}};We=Ve([A],We),e.DocumentHighlight=We;var Be;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Be=e.SymbolKind||(e.SymbolKind={}));var je;(function(j){j[j.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let V=s=class{constructor(W,se,Ce,et,st){this.name=W,this.kind=se,this.containerName=st,typeof Ce=="string"&&(this.containerName=Ce),et instanceof X?this.location=et:Ce instanceof O&&(this.location=new X(et,Ce)),s.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Be[this.kind],location:this.location,containerName:this.containerName}}};V=s=Ve([A],V),e.SymbolInformation=V;let ee=r=class{constructor(W,se,Ce,et,st){this.name=W,this.detail=se,this.kind=Ce,this.range=et,this.selectionRange=st,this.children=[],r.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(r.validate)}};ee=r=Ve([A],ee),e.DocumentSymbol=ee;var re;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(re=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(W,se){this.title=W,this.kind=se}};ae=Ve([A],ae),e.CodeAction=ae;let J=i=class{constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.sep)}};J.sep=".",J=i=Ve([A],J),e.CodeActionKind=J,J.Empty=new J(""),J.QuickFix=J.Empty.append("quickfix"),J.Refactor=J.Empty.append("refactor"),J.RefactorExtract=J.Refactor.append("extract"),J.RefactorInline=J.Refactor.append("inline"),J.RefactorRewrite=J.Refactor.append("rewrite"),J.Source=J.Empty.append("source"),J.SourceOrganizeImports=J.Source.append("organizeImports"),J.SourceFixAll=J.Source.append("fixAll");let oe=class{constructor(W,se){if(this.range=W,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=Ve([A],oe),e.SelectionRange=oe;class ve{constructor(W,se,Ce,et,st,ut){this.kind=W,this.name=se,this.detail=Ce,this.uri=et,this.range=st,this.selectionRange=ut}}e.CallHierarchyItem=ve;class Me{constructor(W,se){this.fromRanges=se,this.from=W}}e.CallHierarchyIncomingCall=Me;class qe{constructor(W,se){this.fromRanges=se,this.to=W}}e.CallHierarchyOutgoingCall=qe;var Ke;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ke=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Se=class{constructor(W,se){this.range=W,this.command=se}get isResolved(){return!!this.command}};Se=Ve([A],Se),e.CodeLens=Se;let tt=f=class{constructor(W,se=!1){m.set(this,void 0),nt(this,m,new I.MarkdownString(W,{supportThemeIcons:se}),"f")}static isMarkdownString(W){return W instanceof f?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return Oe(this,m,"f").value}set value(W){Oe(this,m,"f").value=W}get isTrusted(){return Oe(this,m,"f").isTrusted}set isTrusted(W){Oe(this,m,"f").isTrusted=W}get supportThemeIcons(){return Oe(this,m,"f").supportThemeIcons}set supportThemeIcons(W){Oe(this,m,"f").supportThemeIcons=W}get supportHtml(){return Oe(this,m,"f").supportHtml}set supportHtml(W){Oe(this,m,"f").supportHtml=W}appendText(W){return Oe(this,m,"f").appendText(W),this}appendMarkdown(W){return Oe(this,m,"f").appendMarkdown(W),this}appendCodeblock(W,se){return Oe(this,m,"f").appendCodeblock(se??"",W),this}};m=new WeakMap,tt=f=Ve([A],tt),e.MarkdownString=tt;let Z=class{constructor(W,se){this.label=W,this.documentation=se}};Z=Ve([A],Z),e.ParameterInformation=Z;let te=class{constructor(W,se){this.label=W,this.documentation=se,this.parameters=[]}};te=Ve([A],te),e.SignatureInformation=te;let pe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};pe=Ve([A],pe),e.SignatureHelp=pe;var xe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(xe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ye;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(Ye=e.InlayHintKind||(e.InlayHintKind={}));let rt=class{constructor(W,se,Ce){this.text=W,this.position=se,this.kind=Ce}};rt=Ve([A],rt),e.InlayHint=rt;var ft;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ft=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var pt;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(pt=e.CompletionItemKind||(e.CompletionItemKind={}));var St;(function(j){j[j.Deprecated=1]="Deprecated"})(St=e.CompletionItemTag||(e.CompletionItemTag={}));let Ct=class{constructor(W,se){this.label=W,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&pt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ct=Ve([A],Ct),e.CompletionItem=Ct;let ue=class{constructor(W=[],se=!1){this.items=W,this.isIncomplete=se}};ue=Ve([A],ue),e.CompletionList=ue;let Ie=class{constructor(W,se,Ce){this.text=W,this.range=se,this.command=Ce}};Ie=Ve([A],Ie),e.InlineSuggestion=Ie;let Ue=class{constructor(W){this.items=W}};Ue=Ve([A],Ue),e.InlineSuggestions=Ue;var Qe;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(Qe=e.ViewColumn||(e.ViewColumn={}));var ze;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(ze=e.StatusBarAlignment||(e.StatusBarAlignment={}));var at;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Le;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Le=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var De;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(De=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ke;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ne;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(ne=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var de;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(de=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function W(se){switch(se){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=W}(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let be=class{constructor(W,se){if(se&&!S.URI.isUri(se))throw(0,L.illegalArgument)("target");if(!O.isRange(W)||W.isEmpty)throw(0,L.illegalArgument)("range");this.range=W,this.target=se}};be=Ve([A],be),e.DocumentLink=be;let we=class{constructor(W,se,Ce,et){this.red=W,this.green=se,this.blue=Ce,this.alpha=et}};we=Ve([A],we),e.Color=we;let Fe=class{constructor(W,se){if(se&&!(se instanceof we))throw(0,L.illegalArgument)("color");if(!O.isRange(W)||W.isEmpty)throw(0,L.illegalArgument)("range");this.range=W,this.color=se}};Fe=Ve([A],Fe),e.ColorInformation=Fe;let Ge=class{constructor(W){if(!W||typeof W!="string")throw(0,L.illegalArgument)("label");this.label=W}};Ge=Ve([A],Ge),e.ColorPresentation=Ge;var He;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(He=e.ColorFormat||(e.ColorFormat={}));var Je;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Je=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class it{constructor(W,se,Ce){if(this.startIndex=W,this.length=se,this.tooltip=Ce,typeof W!="number"||W<0)throw(0,L.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,L.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=it;var le;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(le=e.TerminalLocation||(e.TerminalLocation={}));class Ee{constructor(W){this.options=W,typeof W!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=Ee;var ce;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var q;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(q=e.TaskPanelKind||(e.TaskPanelKind={}));let Ae=l=class{constructor(W,se){if(this.label=se,typeof W!="string"||typeof se!="string")throw(0,L.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};Ae.Clean=new l("clean","Clean"),Ae.Build=new l("build","Build"),Ae.Rebuild=new l("rebuild","Rebuild"),Ae.Test=new l("test","Test"),Ae=l=Ve([A],Ae),e.TaskGroup=Ae;function Pe(j){let W="";for(let se=0;se<j.length;se++)W+=j[se].replace(/,/g,",,")+",";return W}let Ze=class{constructor(W,se,Ce){if(typeof W!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=W,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Ce):this._options=se)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,L.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let se of this._args)W.push(se);return Pe(W)}};Ze=Ve([A],Ze),e.ProcessExecution=Ze;let Xe=class{constructor(W,se,Ce){if(this._args=[],Array.isArray(se)){if(!W)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,L.illegalArgument)("command");this._command=W,this._args=se,this._options=Ce}else{if(typeof W!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=W,this._options=se}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,L.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)W.push(typeof se=="string"?se:se.value);return Pe(W)}};Xe=Ve([A],Xe),e.ShellExecution=Xe;var ot;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(ot=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class Et{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Et;let lt=d=class{constructor(W,se,Ce,et,st,ut){this.__deprecated=!1,this._definition=this.definition=W;let ht;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Ce,this.execution=et,ht=st,this.__deprecated=!0):se===vt.Global||se===vt.Workspace?(this.target=se,this._name=this.name=Ce,this._source=this.source=et,this.execution=st,ht=ut):(this.target=se,this._name=this.name=Ce,this._source=this.source=et,this.execution=st,ht=ut),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof Xe?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const se=this._definition.type;(d.EmptyType===se||d.ProcessType===se||d.ShellType===se||d.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};lt.ExtensionCallbackType="customExecution",lt.ProcessType="process",lt.ShellType="shell",lt.EmptyType="$empty",lt=d=Ve([A],lt),e.Task=lt;var dt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let mt=class{constructor(W,se=Rt.None){this.collapsibleState=se,S.URI.isUri(W)?this.resourceUri=W:this.label=W}};mt=Ve([A],mt),e.TreeItem=mt;var Rt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Rt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let yt=class{constructor(W,se){this.id=W,this.color=se}};yt=Ve([A],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let Ot=class{constructor(W){this.id=W}};Ot=Ve([A],Ot),e.ThemeColor=Ot;var hn;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(hn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let It=class{constructor(W,se){if(typeof W!="string"&&(!W||!S.URI.isUri(W)&&!S.URI.isUri(W.uri)))throw(0,L.illegalArgument)("base");if(typeof se!="string")throw(0,L.illegalArgument)("pattern");typeof W=="string"?(this.baseFolder=S.URI.file(W),this.base=W):S.URI.isUri(W)?(this.baseFolder=W,this.base=W.fsPath):(this.baseFolder=W.uri,this.base=W.uri.fsPath),this.pattern=se}};It=Ve([A],It),e.RelativePattern=It;let Wt=class{constructor(W,se,Ce,et){this.enabled=typeof W=="boolean"?W:!0,typeof se=="string"&&(this.condition=se),typeof Ce=="string"&&(this.hitCondition=Ce),typeof et=="string"&&(this.logMessage=et)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};Wt=Ve([A],Wt),e.Breakpoint=Wt;let Zt=class extends Wt{constructor(W,se,Ce,et,st){super(se,Ce,et,st);if(W===null)throw(0,L.illegalArgument)("location");this.location=W}};Zt=Ve([A],Zt),e.SourceBreakpoint=Zt;let wt=class extends Wt{constructor(W,se,Ce,et,st){super(se,Ce,et,st);this.functionName=W}};wt=Ve([A],wt),e.FunctionBreakpoint=wt;let Kt=class extends Wt{constructor(W,se,Ce,et,st,ut,ht){super(et,st,ut,ht);if(!se)throw(0,L.illegalArgument)("dataId");this.label=W,this.dataId=se,this.canPersist=Ce}};Kt=Ve([A],Kt),e.DataBreakpoint=Kt;let Vt=class{constructor(W,se,Ce){this.command=W,this.args=se||[],this.options=Ce}};Vt=Ve([A],Vt),e.DebugAdapterExecutable=Vt;let en=class{constructor(W,se){this.port=W,this.host=se}};en=Ve([A],en),e.DebugAdapterServer=en;let tn=class{constructor(W){this.path=W}};tn=Ve([A],tn),e.DebugAdapterNamedPipeServer=tn;let Pt=class{constructor(W){this.implementation=W}};Pt=Ve([A],Pt),e.DebugAdapterInlineImplementation=Pt;let Qt=class{constructor(W,se){this.range=W,this.expression=se}};Qt=Ve([A],Qt),e.EvaluatableExpression=Qt;var bn;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(bn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let $t=class{constructor(W,se){this.range=W,this.text=se}};$t=Ve([A],$t),e.InlineValueText=$t;let Ht=class{constructor(W,se,Ce=!0){this.range=W,this.variableName=se,this.caseSensitiveLookup=Ce}};Ht=Ve([A],Ht),e.InlineValueVariableLookup=Ht;let gt=class{constructor(W,se){this.range=W,this.expression=se}};gt=Ve([A],gt),e.InlineValueEvaluatableExpression=gt;let nn=class{constructor(W,se){this.frameId=W,this.stoppedLocation=se}};nn=Ve([A],nn),e.InlineValueContext=nn;var Nt;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let Ut=b=class extends Error{constructor(W,se=n.FileSystemProviderErrorCode.Unknown,Ce){super(S.URI.isUri(W)?W.toString(!0):W);this.code=Ce?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(W){return new b(W,n.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(W){return new b(W,n.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(W){return new b(W,n.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(W){return new b(W,n.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(W){return new b(W,n.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(W){return new b(W,n.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};Ut=b=Ve([A],Ut),e.FileSystemError=Ut;let Xt=class{constructor(W,se,Ce){this.start=W,this.end=se,this.kind=Ce}};Xt=Ve([A],Xt),e.FoldingRange=Xt;var En;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class mn{constructor(W,se=[]){this.tokenTypes=W,this.tokenModifiers=se}}e.SemanticTokensLegend=mn;function rn(j){return typeof j=="undefined"||(0,E.isStringArray)(j)}class sn{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let se=0,Ce=W.tokenTypes.length;se<Ce;se++)this._tokenTypeStrToInt.set(W.tokenTypes[se],se);for(let se=0,Ce=W.tokenModifiers.length;se<Ce;se++)this._tokenModifierStrToInt.set(W.tokenModifiers[se],se)}}push(W,se,Ce,et,st){if(typeof W=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof et=="number"&&(typeof st=="number"||typeof st=="undefined"))return typeof st=="undefined"&&(st=0),this._pushEncoded(W,se,Ce,et,st);if(O.isRange(W)&&typeof se=="string"&&rn(Ce))return this._push(W,se,Ce);throw(0,L.illegalArgument)()}_push(W,se,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const et=W.start.line,st=W.start.character,ut=W.end.character-W.start.character,ht=this._tokenTypeStrToInt.get(se);let Dt=0;if(Ce)for(const At of Ce){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(At);Dt|=1<<Lt>>>0}this._pushEncoded(et,st,ut,ht,Dt)}_pushEncoded(W,se,Ce,et,st){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let At=0,Lt=0;for(let Mt=0;Mt<Dt;Mt++){let Bt=this._data[5*Mt],un=this._data[5*Mt+1];Bt===0?(Bt=At,un+=Lt):Bt+=At,this._data[5*Mt]=Bt,this._data[5*Mt+1]=un,At=Bt,Lt=un}}let ut=W,ht=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=et,this._data[this._dataLen++]=st,this._prevLine=W,this._prevChar=se}static _sortAndDeltaEncode(W){let se=[];const Ce=W.length/5|0;for(let ht=0;ht<Ce;ht++)se[ht]=ht;se.sort((ht,Dt)=>{const At=W[5*ht],Lt=W[5*Dt];if(At===Lt){const Mt=W[5*ht+1],Bt=W[5*Dt+1];return Mt-Bt}return At-Lt});const et=new Uint32Array(W.length);let st=0,ut=0;for(let ht=0;ht<Ce;ht++){const Dt=5*se[ht],At=W[Dt+0],Lt=W[Dt+1],Mt=W[Dt+2],Bt=W[Dt+3],un=W[Dt+4],Bn=At-st,Gn=Bn===0?Lt-ut:Lt,dn=5*ht;et[dn+0]=Bn,et[dn+1]=Gn,et[dn+2]=Mt,et[dn+3]=Bt,et[dn+4]=un,st=At,ut=Lt}return et}build(W){return this._dataIsSortedAndDeltaEncoded?new jt(new Uint32Array(this._data),W):new jt(sn._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=sn;class jt{constructor(W,se){this.resultId=se,this.data=W}}e.SemanticTokens=jt;class on{constructor(W,se,Ce){this.start=W,this.deleteCount=se,this.data=Ce}}e.SemanticTokensEdit=on;class Sn{constructor(W,se){this.resultId=se,this.edits=W}}e.SemanticTokensEdits=Sn;var yn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var qt;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(qt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Yt=class{constructor(){}};Yt.Back={iconPath:new yt("arrow-left")},Yt=Ve([A],Yt),e.QuickInputButtons=Yt;var Dn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(W,se,Ce){this.badge=W,this.tooltip=se,this.color=Ce}static validate(W){if(W.badge&&W.badge.length!==1&&W.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let an=class{constructor(W){this.kind=W}};an=Ve([A],an),e.ColorTheme=an;var ln;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(ln=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(W,se){if(W<0)throw(0,L.illegalArgument)("start must be positive");if(se<0)throw(0,L.illegalArgument)("end must be positive");W<=se?(this._start=W,this._end=se):(this._start=se,this._end=W)}static isNotebookRange(W){return W instanceof zt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let se=this._start,Ce=this._end;return W.start!==void 0&&(se=W.start),W.end!==void 0&&(Ce=W.end),se===this._start&&Ce===this._end?this:new zt(se,Ce)}}e.NotebookRange=zt;class Ft{constructor(W,se,Ce,et,st,ut,ht){this.kind=W,this.value=se,this.languageId=Ce,this.mime=et,this.outputs=st??[],this.metadata=ut,this.executionSummary=ht,Ft.validate(this)}static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(se=>Ft.isNotebookCellData(se))}static isNotebookCellData(W){return!0}}e.NotebookCellData=Ft;class Ne{constructor(W){this.cells=W}}e.NotebookData=Ne;class Tt{constructor(W,se){this.data=W,this.mime=se;const Ce=(0,R.normalizeMimeType)(se,!0);if(!Ce)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}static isNotebookCellOutputItem(W){return W instanceof Tt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const se={name:W.name,message:W.message,stack:W.stack};return Tt.json(se,"application/vnd.code.notebook.error")}static stdout(W){return Tt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Tt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,se="application/octet-stream"){return new Tt(W,se)}static text(W,se=R.Mimes.text){const Ce=Oe(Tt,u,"f",h).encode(String(W));return new Tt(Ce,se)}static json(W,se="application/json"){const Ce=JSON.stringify(W,void 0,"	");return Tt.text(Ce,se)}}e.NotebookCellOutputItem=Tt,u=Tt,h={value:new TextEncoder};class Gt{constructor(W,se,Ce){this.items=Gt.ensureUniqueMimeTypes(W,!0),typeof se=="string"?(this.id=se,this.metadata=Ce):(this.id=(0,T.generateUuid)(),this.metadata=se??Ce)}static isNotebookCellOutput(W){return W instanceof Gt?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&(0,E.isArray)(W.items)}static ensureUniqueMimeTypes(W,se=!1){const Ce=new Set,et=new Set;for(let st=0;st<W.length;st++){const ut=W[st],ht=(0,R.normalizeMimeType)(ut.mime);if(!Ce.has(ht)){Ce.add(ht);continue}et.add(st),se&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return et.size===0?W:W.filter((st,ut)=>!et.has(ut))}}e.NotebookCellOutput=Gt;var bt;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(bt=e.NotebookCellKind||(e.NotebookCellKind={}));var kn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(kn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(gn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pn{constructor(W,se){this.text=W,this.alignment=se}}e.NotebookCellStatusBarItem=pn;var Pn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class An{constructor(W,se=[]){this.uri=W,this.provides=(0,g.asArray)(se)}}e.NotebookRendererScript=An;let cn=class{constructor(W,se){this.label=W,this.timestamp=se}};cn=Ve([A],cn),e.TimelineItem=cn;var Tn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var vn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(vn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor(W,se){this.ranges=W,this.wordPattern=se}}e.LinkedEditingRanges=Ln;class Fn{constructor(W,se){this._port=W,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var On;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ie=class{constructor(W,se,Ce){this.include=W,this.exclude=se,this.profile=Ce}};ie=Ve([A],ie),e.TestRunRequest=ie;let fe=y=class{constructor(W){this.message=W}static diff(W,se,Ce){const et=new y(W);return et.expectedOutput=se,et.actualOutput=Ce,et}};fe=y=Ve([A],fe),e.TestMessage=fe;let Te=class{constructor(W){this.id=W}};Te=Ve([A],Te),e.TestTag=Te;let ct=class{constructor(W,se){this.covered=W,this.total=se}};ct=Ve([A],ct),e.CoveredCount=ct;let _t=v=class{constructor(W,se,Ce,et){this.uri=W,this.statementCoverage=se,this.branchCoverage=Ce,this.functionCoverage=et}static fromDetails(W,se){const Ce=new ct(0,0),et=new ct(0,0),st=new ct(0,0);for(const ht of se)if("branches"in ht){Ce.total+=1,Ce.covered+=ht.executionCount>0?1:0;for(const Dt of ht.branches)et.total+=1,et.covered+=Dt.executionCount>0?1:0}else st.total+=1,st.covered+=ht.executionCount>0?1:0;const ut=new v(W,Ce,et.total>0?et:void 0,st.total>0?st:void 0);return ut.detailedCoverage=se,ut}};_t=v=Ve([A],_t),e.FileCoverage=_t;let kt=class{constructor(W,se,Ce=[]){this.executionCount=W,this.location=se,this.branches=Ce}};kt=Ve([A],kt),e.StatementCoverage=kt;let Nn=class{constructor(W,se){this.executionCount=W,this.location=se}};Nn=Ve([A],Nn),e.BranchCoverage=Nn;let Un=class{constructor(W,se){this.executionCount=W,this.location=se}};Un=Ve([A],Un),e.FunctionCoverage=Un;var zn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(zn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var jn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(jn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor(W,se,Ce,et,st,ut){this.kind=W,this.name=se,this.detail=Ce,this.uri=et,this.range=st,this.selectionRange=ut}}e.TypeHierarchyItem=qn}),define(me[123],ge([0,1,56,10,9,150,110,7,17]),function(Y,e,g,L,I,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function n(u,h){h?T.set(u,h):T.delete(u)}e.setWordDefinitionFor=n;function P(u){return T.get(u)}e.getWordDefinitionFor=P;class c extends C.MirrorTextModel{constructor(h,D,k,_,o,a,p,t){super(D,k,_,o);this._proxy=h,this._languageId=a,this._isDirty=p,this._notebook=t,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,S.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===L.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},get notebook(){return h._notebook},save(){return h._save()},getText(D){return D?h._getTextInRange(D):h.getText()},get eol(){return h._eol===`
`?E.EndOfLine.LF:E.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(D){return h._lineAt(D)},offsetAt(D){return h._offsetAt(D)},positionAt(D){return h._positionAt(D)},validateRange(D){return h._validateRange(D)},validatePosition(D){return h._validatePosition(D)},getWordRangeAtPosition(D,k){return h._getWordRangeAtPosition(D,k)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,g.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,g.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const D=this._validateRange(h);if(D.isEmpty)return"";if(D.isSingleLine)return this._lines[D.start.line].substring(D.start.character,D.end.character);const k=this._eol,_=D.start.line,o=D.end.line,a=[];a.push(this._lines[_].substring(D.start.character));for(let p=_+1;p<o;p++)a.push(this._lines[p]);return a.push(this._lines[o].substring(0,D.end.character)),a.join(k)}_lineAt(h){let D;if(h instanceof E.Position?D=h.line:typeof h=="number"&&(D=h),typeof D!="number"||D<0||D>=this._lines.length||Math.floor(D)!==D)throw new Error("Illegal value for `line`");return new m(D,this._lines[D],D===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getPrefixSum(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const D=this._lineStarts.getIndexOf(h),k=this._lines[D.index].length;return new E.Position(D.index,Math.min(D.remainder,k))}_validateRange(h){if(!(h instanceof E.Range))throw new Error("Invalid argument");const D=this._validatePosition(h.start),k=this._validatePosition(h.end);return D===h.start&&k===h.end?h:new E.Range(D.line,D.character,k.line,k.character)}_validatePosition(h){if(!(h instanceof E.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:D,character:k}=h,_=!1;if(D<0)D=0,k=0,_=!0;else if(D>=this._lines.length)D=this._lines.length-1,k=this._lines[D].length,_=!0;else{const o=this._lines[D].length;k<0?(k=0,_=!0):k>o&&(k=o,_=!0)}return _?new E.Position(D,k):h}_getWordRangeAtPosition(h,D){const k=this._validatePosition(h);if(!D)D=P(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(D))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${D.source}' because it matches the empty string.`);const _=(0,R.getWordAtText)(k.character+1,(0,R.ensureValidWordDefinition)(D),this._lines[k.line],0);if(_)return new E.Range(k.line,_.startColumn-1,k.line,_.endColumn-1)}}e.ExtHostDocumentData=c;class m{constructor(h,D,k){this._line=h,this._text=D,this._isLastLine=k}get lineNumber(){return this._line}get text(){return this._text}get range(){return new E.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new E.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(me[204],ge([0,1,7,3,112,6,81,24,2,32]),function(Y,e,g,L,I,C,R,E,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(c,m,u,h){this._notebook=u,this._selector=h,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(k=>{const _=this._cellUris.get(k.document.uri);_!==void 0&&(this._cellLengths.changeValue(_,this._cells[_].document.getText().length+1),this._cellLines.changeValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const D=k=>{k===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(k=>D(k.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new E.ResourceMap;const c=[],m=[];for(const u of this._notebook.getCells())u.kind===g.NotebookCellKind.Code&&(!this._selector||(0,R.score)(this._selector,u.document.uri,u.document.languageId,!0))&&(this._cellUris.set(u.document.uri,this._cells.length),this._cells.push(u),c.push(u.document.getText().length+1),m.push(u.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(c){if(!c){let _="";for(const o of this._cells)_+=o.document.getText()+`
`;return _=_.slice(0,-1),_}if(c.isEmpty)return"";const m=this.locationAt(c.start),u=this.locationAt(c.end),h=this._cellUris.get(m.uri),D=this._cellUris.get(u.uri);if(h===void 0||D===void 0)return"";if(h===D)return this._cells[h].document.getText(new g.Range(m.range.start,u.range.end));const k=[this._cells[h].document.getText(new g.Range(m.range.start,new g.Position(this._cells[h].document.lineCount,0)))];for(let _=h+1;_<D;_++)k.push(this._cells[_].document.getText());return k.push(this._cells[D].document.getText(new g.Range(new g.Position(0,0),u.range.end))),k.join(`
`)}offsetAt(c){const m=this._cellLines.getIndexOf(c.line),u=this._cellLengths.getPrefixSum(m.index-1),h=this._cells[m.index].document.offsetAt(c.with(m.remainder));return u+h}positionAt(c){if(typeof c=="number"){const u=this._cellLengths.getIndexOf(c),h=this._cellLines.getPrefixSum(u.index-1);return this._cells[u.index].document.positionAt(u.remainder).translate(h)}const m=this._cellUris.get(c.uri);if(m!==void 0){const u=this._cellLines.getPrefixSum(m-1);return new g.Position(u+c.range.start.line,c.range.start.character)}return new g.Position(0,0)}locationAt(c){g.Range.isRange(c)||(c=new g.Range(c,c));const m=this._cellLines.getIndexOf(c.start.line);let u=m;c.isEmpty||(u=this._cellLines.getIndexOf(c.end.line));const h=new g.Position(m.remainder,c.start.character),D=new g.Position(u.remainder,c.end.character),k=new g.Range(h,D),_=this._cells[m.index];return new g.Location(_.document.uri,_.document.validateRange(k))}contains(c){return this._cellUris.has(c)}validateRange(c){const m=this.validatePosition(c.start),u=this.validatePosition(c.end);return c.with(m,u)}validatePosition(c){const m=this._cellLines.getIndexOf(c.line),u=new g.Position(m.remainder,c.character),h=this._cells[m.index].document.validatePosition(u),D=this._cellLines.getPrefixSum(m.index-1);return new g.Position(D+h.line,h.character)}}e.ExtHostNotebookConcatDocument=n}),define(me[205],ge([0,1,7,14,3]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(E){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(E){let S=E==="light"?g.ColorThemeKind.Light:E==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(me[65],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class L{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=L}),define(me[206],ge([0,1,23]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(S){let T=this.buffers.indexOf(S);return T<0&&(T=this.buffers.length,this.buffers.push(S)),T}}function I(E,S){if(S.serializeBuffersForPostMessage){const T=new L,n=(m,u)=>{if(u instanceof ArrayBuffer){const h=T.add(u);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(u)){const h=C(u);if(h){const D=T.add(u.buffer);return{$$vscode_array_buffer_reference$$:!0,index:D,view:{type:h,byteLength:u.byteLength,byteOffset:u.byteOffset}}}}return u},P=JSON.stringify(E,n),c=T.buffers.map(m=>{const u=new Uint8Array(m);return g.VSBuffer.wrap(u)});return{message:P,buffers:c}}else return{message:JSON.stringify(E),buffers:[]}}e.serializeWebviewMessage=I;function C(E){switch(E.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(E,S){const T=S.map(c=>{const m=new ArrayBuffer(c.byteLength);return new Uint8Array(m).set(c.buffer),m}),n=S.length?(c,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const u=m,{index:h}=u,D=T[h];if(u.view)switch(u.view.type){case 1:return new Int8Array(D,u.view.byteOffset,u.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(D,u.view.byteOffset,u.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(D,u.view.byteOffset,u.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(D,u.view.byteOffset,u.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(D,u.view.byteOffset,u.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(D,u.view.byteOffset,u.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(D,u.view.byteOffset,u.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(D,u.view.byteOffset,u.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(D,u.view.byteOffset,u.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(D,u.view.byteOffset,u.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(D,u.view.byteOffset,u.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return D}return m}:void 0;return{message:JSON.parse(E,n),arrayBuffers:T}}e.deserializeWebviewMessage=R}),define(me[207],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(L){function I(R){const E={items:new Map};return R.types.forEach((S,T)=>{E.items.set(S,{asString:async()=>R.items[T].asString})}),E}L.toITreeDataTransfer=I;async function C(R){const E={types:[],items:[]},S=Array.from(R.items.entries());for(const T of S)E.types.push(T[0]),E.items.push({asString:await T[1].asString()});return E}L.toTreeDataTransferDTO=C})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(me[88],ge([0,1,10,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(E,S){return E.scheme===g.Schemas.http||E.scheme===g.Schemas.https?E:(S&&S.authority&&S.isRemote&&E.scheme===g.Schemas.file&&(E=L.URI.from({scheme:g.Schemas.vscodeRemote,authority:S.authority,path:E.path})),L.URI.from({scheme:g.Schemas.https,authority:`${E.scheme}+${C(E.authority)}.${e.webviewRootResourceAuthority}`,path:E.path,fragment:E.fragment,query:E.query}))}e.asWebviewUri=I;function C(E){return E.replace(/./g,S=>{const T=S.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?S:"-"+T.toString(16).padStart(4,"0")})}function R(E){return E.replace(/-([0-9a-f]{4})/g,(S,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=R}),define(me[208],ge([0,1,3,6,88]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(E,S,T){this._proxy=E,this._editors=S,this._initData=T,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const n=S.getVisibleTextEditors();for(const P of this._insets.values())n.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(E=>E.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(E,S,T,n,P){let c;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===E){c=o;break}if(!c)throw new Error("not a visible editor");const m=this,u=this._handlePool++,h=new g.Emitter,D=new g.Emitter,k=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,I.asWebviewUri)(o,m._initData.remote)}get cspSource(){return I.webviewGenericCspSource}set options(o){this._options=o,m._proxy.$setOptions(u,o)}get options(){return this._options}set html(o){this._html=o,m._proxy.$setHtml(u,o)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(o){return m._proxy.$postMessage(u,o)}},_=new class{constructor(){this.editor=E,this.line=S,this.height=T,this.webview=k,this.onDidDispose=D.event}dispose(){m._insets.has(u)&&(m._insets.delete(u),m._proxy.$disposeEditorInset(u),D.fire(),D.dispose(),h.dispose())}};return this._proxy.$createEditorInset(u,c.id,c.value.document.uri,S+1,T,n||{},P.identifier,P.extensionLocation),this._insets.set(u,{editor:E,inset:_,onDidReceiveMessage:h}),_}$onDidDispose(E){const S=this._insets.get(E);S&&S.inset.dispose()}$onDidReceiveMessage(E,S){const T=this._insets.get(E);T&&T.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=C}),define(me[209],ge([0,1,172,13,2,6,4,62,34,17,10]),function(Y,e,g,L,I,C,R,E,S,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new E.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new E.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new E.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new E.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new E.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new E.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new E.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new E.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new E.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new E.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.SideBySideEditorActiveContext=new E.RawContextKey("sideBySideEditorActive",!1,(0,g.localize)(11,null)),e.EditorGroupEditorsCountContext=new E.RawContextKey("groupEditorsCount",0,(0,g.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new E.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(13,null)),e.ActiveEditorGroupIndexContext=new E.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(14,null)),e.ActiveEditorGroupLastContext=new E.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(15,null)),e.ActiveEditorGroupLockedContext=new E.RawContextKey("activeEditorGroupLocked",!1,(0,g.localize)(16,null)),e.MultipleEditorGroupsContext=new E.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new E.RawContextKey("editorIsOpen",!1,(0,g.localize)(18,null)),e.InEditorZenModeContext=new E.RawContextKey("inZenMode",!1,(0,g.localize)(19,null)),e.IsCenteredLayoutContext=new E.RawContextKey("isCenteredLayout",!1,(0,g.localize)(20,null)),e.SplitEditorsVertically=new E.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(21,null)),e.EditorAreaVisibleContext=new E.RawContextKey("editorAreaVisible",!0,(0,g.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function P(w,F,O){for(const G of O.visibleEditorPanes)if(G.group.id===F&&w.matches(G.input))return G.getViewState()}e.findViewStateForEditor=P;function c(w){if(a(w))return!1;const F=w;return I.URI.isUri(F?.resource)}e.isResourceEditorInput=c;function m(w){if(a(w))return!1;const F=w;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=m;function u(w){if(a(w)||m(w))return!1;const F=w;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=u;function h(w){if(a(w))return!1;const F=w;return F?F.resource===void 0||F.resource.scheme===n.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=h;var D;(function(w){w[w.SHORT=0]="SHORT",w[w.MEDIUM=1]="MEDIUM",w[w.LONG=2]="LONG"})(D=e.Verbosity||(e.Verbosity={}));var k;(function(w){w[w.EXPLICIT=1]="EXPLICIT",w[w.AUTO=2]="AUTO",w[w.FOCUS_CHANGE=3]="FOCUS_CHANGE",w[w.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(k=e.SaveReason||(e.SaveReason={}));var _;(function(w){w[w.None=0]="None",w[w.Readonly=2]="Readonly",w[w.Untitled=4]="Untitled",w[w.Singleton=8]="Singleton",w[w.RequiresTrust=16]="RequiresTrust",w[w.CanSplitInGroup=32]="CanSplitInGroup"})(_=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends C.Disposable{}e.AbstractEditorInput=o;function a(w){return w instanceof o}e.isEditorInput=a;function p(w){const F=w;return I.URI.isUri(F?.preferredResource)}function t(w){const F=w;return a(F?.primary)&&a(F?.secondary)}e.isSideBySideEditorInput=t;function s(w){const F=w;return a(F?.modified)&&a(F?.original)}e.isDiffEditorInput=s;function r(w){return a(w?.editor)}e.isEditorInputWithOptions=r;function i(w){const F=w;return r(w)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=i;function f(w){const F=w;return typeof F?.groupId=="number"&&a(F.editor)}e.isEditorIdentifier=f;var l;(function(w){w[w.PRIMARY=1]="PRIMARY",w[w.SECONDARY=2]="SECONDARY",w[w.BOTH=3]="BOTH",w[w.ANY=4]="ANY"})(l=e.SideBySideEditor||(e.SideBySideEditor={}));class d{getOriginalUri(F,O){if(!F)return;if(O?.supportSideBySide){const{primary:K,secondary:U}=this.getSideEditors(F);if(K&&U){if(O?.supportSideBySide===l.BOTH)return{primary:this.getOriginalUri(K,{filterByScheme:O.filterByScheme}),secondary:this.getOriginalUri(U,{filterByScheme:O.filterByScheme})};if(O?.supportSideBySide===l.ANY)return this.getOriginalUri(K,{filterByScheme:O.filterByScheme})??this.getOriginalUri(U,{filterByScheme:O.filterByScheme});F=O.supportSideBySide===l.PRIMARY?K:U}}if(m(F)||u(F))return;const G=p(F)?F.preferredResource:F.resource;return!G||!O||!O.filterByScheme?G:this.filterUri(G,O.filterByScheme)}getSideEditors(F){return t(F)||u(F)?{primary:F.primary,secondary:F.secondary}:s(F)||m(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,O){if(!F)return;if(O?.supportSideBySide){const{primary:K,secondary:U}=this.getSideEditors(F);if(K&&U){if(O?.supportSideBySide===l.BOTH)return{primary:this.getCanonicalUri(K,{filterByScheme:O.filterByScheme}),secondary:this.getCanonicalUri(U,{filterByScheme:O.filterByScheme})};if(O?.supportSideBySide===l.ANY)return this.getCanonicalUri(K,{filterByScheme:O.filterByScheme})??this.getCanonicalUri(U,{filterByScheme:O.filterByScheme});F=O.supportSideBySide===l.PRIMARY?K:U}}if(m(F)||u(F))return;const G=F.resource;return!G||!O||!O.filterByScheme?G:this.filterUri(G,O.filterByScheme)}filterUri(F,O){if(Array.isArray(O)){if(O.some(G=>F.scheme===G))return F}else if(O===F.scheme)return F}}e.EditorResourceAccessor=new d;var b;(function(w){w[w.LEFT=0]="LEFT",w[w.RIGHT=1]="RIGHT"})(b=e.CloseDirection||(e.CloseDirection={}));class y{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const O=this.instantiationService=F.get(R.IInstantiationService);for(const[G,K]of this.editorSerializerConstructors)this.createEditorSerializer(G,K,O);this.editorSerializerConstructors.clear()}createEditorSerializer(F,O,G){const K=G.createInstance(O);this.editorSerializerInstances.set(F,K)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,O){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,O,this.instantiationService):this.editorSerializerConstructors.set(F,O),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new y);async function v(w,F){if(!w||!w.length)return[];const O=await Promise.all(w.map(async G=>{const K=I.URI.revive(G.fileUri);if(!K||(await F.activateProvider(K.scheme),!F.canHandleResource(K)))return;const U=typeof G.exists=="boolean"?G.exists:await F.exists(K);if(!U&&G.openOnlyIfExists)return;const z={selection:U?G.selection:void 0,pinned:!0,override:G.editorOverrideId};let N;return U?N={resource:K,options:z}:N={resource:K,options:z,forceUntitled:!0},N}));return(0,T.coalesce)(O)}e.pathsToEditors=v;var A;(function(w){w[w.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",w[w.SEQUENTIAL=1]="SEQUENTIAL"})(A=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[210],ge([0,1,3,62,173,4,6,24,34,17,57,25,47,199]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",c.Codicon.window,(0,I.localize)(0,null));var u;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(u=e.Extensions||(e.Extensions={}));var h;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel"})(h=e.ViewContainerLocation||(e.ViewContainerLocation={}));function D(f){switch(f){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=D;function k(f){return`viewContainer.${f}.enabled`}e.getEnabledViewContainerContextKey=k;class _ extends R.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,T.flatten)([...this.viewContainers.values()])}registerViewContainer(l,d,b){const y=this.get(l.id);if(y)return y;const v=l;return v.openCommandActionDescriptor=b?.donotRegisterOpenCommand?void 0:v.openCommandActionDescriptor??{id:v.id},(0,E.getOrSet)(this.viewContainers,d,[]).push(v),b?.isDefault&&this.defaultViewContainers.push(v),this._onDidRegister.fire({viewContainer:v,viewContainerLocation:d}),v}deregisterViewContainer(l){for(const d of this.viewContainers.keys()){const b=this.viewContainers.get(d),y=b?.indexOf(l);if(y!==-1){b?.splice(y,1),b.length===0&&this.viewContainers.delete(d),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:d});return}}}get(l){return this.all.filter(d=>d.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(d=>this.getViewContainers(d).filter(b=>b?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(d=>this.getViewContainerLocation(d)===l)}}S.Registry.add(u.ViewContainersRegistry,new _);var o;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function a(f,l){const d=f.group??o.More,b=l.group??o.More;return d!==b?d.localeCompare(b):(f.order??5)-(l.order??5)}class p extends R.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(l,d){this.registerViews2([{views:l,viewContainer:d}])}registerViews2(l){l.forEach(({views:d,viewContainer:b})=>this.addViews(d,b)),this._onViewsRegistered.fire(l)}deregisterViews(l,d){const b=this.removeViews(l,d);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:d})}moveViews(l,d){for(const b of this._views.keys())if(b!==d){const y=this.removeViews(l,b);y.length&&(this.addViews(y,d),this._onDidChangeContainer.fire({views:y,from:b,to:d}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const d of this._viewContainers){const b=(this._views.get(d)||[]).filter(y=>y.id===l)[0];if(b)return b}return null}getViewContainer(l){for(const d of this._viewContainers)if((this._views.get(d)||[]).filter(y=>y.id===l)[0])return d;return null}registerViewWelcomeContent(l,d){return this._viewWelcomeContents.add(l,d),this._onDidChangeViewWelcomeContent.fire(l),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(l,d),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,d){const b=new Map;for(const[y,v]of d)this._viewWelcomeContents.add(l,v),b.set(y,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(l,v),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),b}getViewWelcomeContent(l){const d=[];return this._viewWelcomeContents.forEach(l,b=>d.push(b)),d.sort(a)}addViews(l,d){let b=this._views.get(d);b||(b=[],this._views.set(d,b),this._viewContainers.push(d));for(const y of l){if(this.getView(y.id)!==null)throw new Error((0,I.localize)(1,null,y.id));b.push(y)}}removeViews(l,d){const b=this._views.get(d);if(!b)return[];const y=[],v=[];for(const A of b)l.includes(A)?y.push(A):v.push(A);return y.length&&(v.length?this._views.set(d,v):(this._views.delete(d),this._viewContainers.splice(this._viewContainers.indexOf(d),1))),y}}S.Registry.add(u.ViewsRegistry,new p),e.IViewsService=(0,C.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,I.localize)(2,null));function t(f){return`view.${f}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,C.createDecorator)("viewDescriptorService");var s;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(s=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(l,d){this.resolved=!1,this._hasResolve=!1,(0,P.mixin)(this,l),this._hasResolve=!!d,this.resolve=async b=>{if(d&&!this.resolved){const y=await d(b);y&&(this.tooltip=this.tooltip??y.tooltip,this.command=this.command??y.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(me[124],ge([0,1,3,18,174]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(E){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=E}onEvent(E){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=E}onRequest(E){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=E}sendResponse(E){E.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${E.command}`)):this.internalSend("response",E)}sendRequest(E,S,T,n){const P={command:E};if(S&&Object.keys(S).length>0&&(P.arguments=S),this.internalSend("request",P),typeof n=="number"){const c=setTimeout(()=>{clearTimeout(c);const m=this.pendingRequests.get(P.seq);if(m){this.pendingRequests.delete(P.seq);const u={type:"response",seq:0,request_seq:P.seq,success:!1,command:E,message:(0,I.localize)(0,null,n,E)};m(u)}},n)}return T&&this.pendingRequests.set(P.seq,T),P.seq}acceptMessage(E){this.messageCallback?this.messageCallback(E):(this.queue.push(E),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(E,S){return E.type!=="event"||S.type!=="event"}async processQueue(){let E;for(;this.queue.length;){if((!E||this.needsTaskBoundaryBetween(this.queue[0],E))&&await(0,L.timeout)(0),E=this.queue.shift(),!E)return;switch(E.type){case"event":this.eventCallback&&this.eventCallback(E);break;case"request":this.requestCallback&&this.requestCallback(E);break;case"response":const S=E,T=this.pendingRequests.get(S.request_seq);T&&(this.pendingRequests.delete(S.request_seq),T(S));break}}}internalSend(E,S){S.type=E,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const E=new Map;this.pendingRequests.forEach((S,T)=>E.set(T,S)),await(0,L.timeout)(500),E.forEach((S,T)=>{S({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(me[211],ge([0,1,9,2,8,25,10]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const E=/{([^}]+)}/g;function S(r,i,f){return r.replace(E,function(l,d){return i&&d.length>0&&d[0]!=="_"?l:f&&f.hasOwnProperty(d)?f[d]:l})}e.formatPII=S;function T(r){const i={};for(const f of Object.keys(r))f.startsWith("!")||(i[f]=r[f]);return i}e.filterExceptionsFromTelemetry=T;function n(r){return r.configuration.request==="attach"&&!P(r)&&(!r.parentSession||n(r.parentSession))}e.isSessionAttach=n;function P(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(i,"extensionhost")||(0,g.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?P(r.parentSession):void 0}e.getExtensionHostDebugSession=P;function c(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=c;function m(r,i,f){let l,d=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,y=null;for(;y=b.exec(r);){let v=y.index+1,A=v+y[0].length;if(v<=i&&A>=f){l=y[0],d=v;break}}if(l){let v=/\w+/g,A=null;for(;(A=v.exec(l))&&!(A.index+1+d+A[0].length>=f););A&&(l=l.substring(0,v.lastIndex))}return l?{start:d,end:d+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(r){return!!(r&&r.match(u))}e.isUri=h;function D(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(h(r.path))return L.URI.parse(r.path);if((0,I.isAbsolute)(r.path))return L.URI.file(r.path)}return r.path}function k(r){if(typeof r.path=="object"){const i=L.URI.revive(r.path);if(i)return i.scheme===R.Schemas.file?i.fsPath:i.toString()}return r.path}function _(r,i){const f=i?D:k,l=(0,C.deepClone)(r);return a(l,(d,b)=>{d&&b&&(b.path=f(b))}),l}e.convertToDAPaths=_;function o(r,i){const f=i?D:k,l=(0,C.deepClone)(r);return a(l,(d,b)=>{!d&&b&&(b.path=f(b))}),l}e.convertToVSCPaths=o;function a(r,i){switch(r.type){case"event":const f=r;switch(f.event){case"output":i(!1,f.body.source);break;case"loadedSource":i(!1,f.body.source);break;case"breakpoint":i(!1,f.body.breakpoint.source);break;default:break}break;case"request":const l=r;switch(l.command){case"setBreakpoints":i(!0,l.arguments.source);break;case"breakpointLocations":i(!0,l.arguments.source);break;case"source":i(!0,l.arguments.source);break;case"gotoTargets":i(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(b=>i(!1,b));break;default:break}break;case"response":const d=r;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(b=>i(!1,b.source));break;case"loadedSources":d.body.sources.forEach(b=>i(!1,b));break;case"scopes":d.body.scopes.forEach(b=>i(!1,b.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(b=>i(!1,b.source));break;case"setBreakpoints":d.body.breakpoints.forEach(b=>i(!1,b.source));break;default:break}break}}function p(r){return r.filter(i=>!i.presentation?.hidden).sort((i,f)=>i.presentation?f.presentation?i.presentation.group?f.presentation.group?i.presentation.group!==f.presentation.group?i.presentation.group.localeCompare(f.presentation.group):t(i.presentation.order,f.presentation.order):-1:f.presentation.group?1:t(i.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.getVisibleAndSorted=p;function t(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function s(r,i){const f=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(f!=="none"&&(await i.saveAll(),f==="allEditorsInActiveGroup")){const l=i.activeEditorPane;l&&await i.save({editor:l.input,groupId:l.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=s}),define(me[212],ge([0,1,28,39,175,125,8,9,25,11,185,124]),function(Y,e,g,L,I,C,R,E,S,T,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends P.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,o){this.outputStream=o,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",a=>this.handleData(a))}sendMessage(_){if(this.outputStream){const o=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(o,"utf8")}${c.TWO_CRLF}${o}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const o=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,o.length>0)try{this.acceptMessage(JSON.parse(o))}catch(a){this._onError.fire(new Error((a.message||a)+`
`+o))}continue}}else{const o=this.rawData.indexOf(c.TWO_CRLF);if(o!==-1){const p=this.rawData.toString("utf8",0,o).split(c.HEADER_LINESEPARATOR);for(const t of p){const s=t.split(c.HEADER_FIELDSEPARATOR);s[0]==="Content-Length"&&(this.contentLength=Number(s[1]))}this.rawData=this.rawData.slice(o+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class m extends c{startSession(){return new Promise((_,o)=>{let a=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),a=!0}),this.socket.on("close",()=>{a?this._onError.fire(new Error("connection closed")):o(new Error("connection closed"))}),this.socket.on("error",p=>{a?this._onError.fire(p):o(p)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class u extends m{constructor(_){super();this.adapterServer=_}createConnection(_){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=u;class h extends m{constructor(_){super();this.adapterServer=_}createConnection(_){return C.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=h;class D extends c{constructor(_,o,a){super();this.adapterExecutable=_,this.debugType=o,this.outputService=a}async startSession(){const _=this.adapterExecutable.command,o=this.adapterExecutable.args,a=this.adapterExecutable.options||{};try{if(_)if(R.isAbsolute(_)){if(!await g.Promises.exists(_))throw new Error(I.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let p=process.env;if(a.env&&Object.keys(a.env).length>0&&(p=S.mixin(S.deepClone(process.env),a.env)),_==="node")if(Array.isArray(o)&&o.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:p,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};a.cwd&&(r.cwd=a.cwd);const i=L.fork(o[0],o.slice(1),r);if(!i.pid)throw new Error(I.localize(2,null,o[0]));this.serverProcess=i}else throw new Error(I.localize(3,null));else{const s={env:p};a.cwd&&(s.cwd=a.cwd),this.serverProcess=L.spawn(_,o,s)}this.serverProcess.on("error",s=>{this._onError.fire(s)}),this.serverProcess.on("exit",(s,r)=>{this._onExit.fire(s)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",s=>{this._onError.fire(s)}),this.serverProcess.stdin.on("error",s=>{this._onError.fire(s)});const t=this.outputService;if(t){const s=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const i=t.getChannel(n.ExtensionsChannelId);i&&i.append(s(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(p){this._onError.fire(p)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),T.isWindows?new Promise((_,o)=>{const a=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(p,t,s){if(p)return o(p)});a.on("exit",_),a.on("error",o)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,o){if(!_)return;const a=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?a.runtime=R.join(o,_.runtime):a.runtime=_.runtime),_.runtimeArgs&&(a.runtimeArgs=_.runtimeArgs),_.program&&(R.isAbsolute(_.program)?a.program=_.program:a.program=R.join(o,_.program)),_.args&&(a.args=_.args);const p=_;return p.win&&(a.win=D.extract(p.win,o)),p.winx86&&(a.winx86=D.extract(p.winx86,o)),p.windows&&(a.windows=D.extract(p.windows,o)),p.osx&&(a.osx=D.extract(p.osx,o)),p.linux&&(a.linux=D.extract(p.linux,o)),a}static platformAdapterExecutable(_,o){let a=Object.create(null);o=o.toLowerCase();for(const f of _)if(f.contributes){const l=f.contributes.debuggers;l&&l.length>0&&l.filter(d=>typeof d.type=="string"&&E.equalsIgnoreCase(d.type,o)).forEach(d=>{const b=D.extract(d,f.extensionLocation.fsPath);a=S.mixin(a,b,f.isBuiltin)})}let p;T.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=a.winx86||a.win||a.windows:T.isWindows?p=a.win||a.windows:T.isMacintosh?p=a.osx:T.isLinux&&(p=a.linux),p=p||a;let t=p.program||a.program;const s=p.args||a.args;let r=p.runtime||a.runtime;const i=p.runtimeArgs||a.runtimeArgs;if(r)return{type:"executable",command:r,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(s||[])};if(t)return{type:"executable",command:t,args:s||[]}}}e.ExecutableDebugAdapter=D}),define(me[213],ge([0,1,39,11,29,188]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function R(c,m){return new Promise((u,h)=>{let D="";const k=g.spawn(c,m);k.pid&&k.stdout.on("data",_=>{D+=_.toString()}),k.on("error",_=>{h(_)}),k.on("close",_=>{u(D)})})}let E;function S(c,m){if(!E)if(L.isWindows)E=new C.WindowsExternalTerminalService;else if(L.isMacintosh)E=new C.MacExternalTerminalService;else if(L.isLinux)E=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const u=m.getConfiguration("terminal");return E.runInTerminal(c.title,c.cwd,c.args,c.env||{},u.external||{})}e.runInExternalTerminal=S;function T(c){return c?L.isWindows?new Promise(async m=>{(await new Promise((h,D)=>{Y(["windows-process-tree"],h,D)})).getProcessTree(c,h=>{m(h.children.length>0)})}):R("/usr/bin/pgrep",["-lP",String(c)]).then(m=>{const u=m.trim();return!(u.length===0||u.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=T;var n;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(n||(n={}));function P(c,m,u,h){c=c.trim().toLowerCase();let D;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?D=1:c.indexOf("cmd.exe")>=0?D=0:c.indexOf("bash")>=0?D=2:L.isWindows?D=0:D=2;let k,_=" ";switch(D){case 1:if(k=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),u){const a=(0,I.getDriveLetter)(u);a&&(_+=`${a}:; `),_+=`cd ${k(u)}; `}if(h)for(let a in h){const p=h[a];p===null?_+=`Remove-Item env:${a}; `:_+=`\${env:${a}}='${p}'; `}if(m.length>0){const a=k(m.shift());_+=a[0]==="'"?`& ${a} `:`${a} `;for(let p of m)_+=`${k(p)} `}break;case 0:if(k=a=>(a=a.replace(/\"/g,'""'),a.indexOf(" ")>=0||a.indexOf('"')>=0||a.length===0?`"${a}"`:a),u){const a=(0,I.getDriveLetter)(u);a&&(_+=`${a}: && `),_+=`cd ${k(u)} && `}if(h){_+='cmd /C "';for(let a in h){let p=h[a];p===null?_+=`set "${a}=" && `:(p=p.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),_+=`set "${a}=${p}" && `)}}for(let a of m)_+=`${k(a)} `;h&&(_+='"');break;case 2:k=a=>(a=a.replace(/(["'\\\$])/g,"\\$1"),a.indexOf(" ")>=0||a.indexOf(";")>=0||a.length===0?`"${a}"`:a);const o=a=>/[^\w@%\/+=,.:^-]/.test(a)?`'${a.replace(/'/g,"'\\''")}'`:a;if(u&&(_+=`cd ${k(u)} ; `),h){_+="/usr/bin/env";for(let a in h){const p=h[a];p===null?_+=` -u ${o(a)}`:_+=` ${o(`${a}=${p}`)}`}_+=" "}for(let a of m)_+=`${k(a)} `;break}return _}e.prepareCommand=P}),define(me[126],ge([0,1,30,102,10,8,11,62]),function(Y,e,g,L,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(v){v[v.Markup=1]="Markup",v[v.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(v){v[v.Running=1]="Running",v[v.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(v){v[v.Pending=2]="Pending",v[v.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var P;(function(v){v[v.WithHardKernelDependency=0]="WithHardKernelDependency",v[v.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",v[v.Pure=2]="Pure",v[v.Never=3]="Never"})(P=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var c;(function(v){v.Always="always",v.Never="never",v.Optional="optional"})(c=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(v){v[v.ModelChange=1]="ModelChange",v[v.Move=2]="Move",v[v.ChangeLanguage=5]="ChangeLanguage",v[v.Initialize=6]="Initialize",v[v.ChangeCellMetadata=7]="ChangeCellMetadata",v[v.Output=8]="Output",v[v.OutputItem=9]="OutputItem",v[v.ChangeCellContent=10]="ChangeCellContent",v[v.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",v[v.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",v[v.ChangeCellMime=13]="ChangeCellMime",v[v.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(v){v[v.Handle=0]="Handle",v[v.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(v){v[v.Replace=1]="Replace",v[v.Output=2]="Output",v[v.Metadata=3]="Metadata",v[v.CellLanguage=4]="CellLanguage",v[v.DocumentMetadata=5]="DocumentMetadata",v[v.Move=6]="Move",v[v.OutputItems=7]="OutputItems",v[v.PartialMetadata=8]="PartialMetadata",v[v.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var D;(function(v){v.scheme=I.Schemas.vscodeNotebookCell;const A=/^ch(\d{7,})/;function w(U,z){return U.with({scheme:v.scheme,fragment:`ch${z.toString().padStart(7,"0")}${U.scheme!==I.Schemas.file?U.scheme:""}`})}v.generate=w;function F(U){if(U.scheme!==v.scheme)return;const z=A.exec(U.fragment);return z?{handle:Number(z[1]),notebook:U.with({scheme:U.fragment.substr(z[0].length)||I.Schemas.file,fragment:null})}:void 0}v.parse=F;function O(U){if(U.scheme!==I.Schemas.vscodeNotebookCellMetadata)return;const z=A.exec(U.fragment);return z?{handle:Number(z[1]),notebook:U.with({scheme:U.fragment.substr(z[0].length)||I.Schemas.file,fragment:null})}:void 0}v.parseCellMetadataUri=O;function G(U,z,N){return U.with({scheme:N,fragment:`ch${z.toString().padStart(7,"0")}${U.scheme!==I.Schemas.file?U.scheme:""}`})}v.generateCellUri=G;function K(U,z){if(U.scheme!==z)return;const N=A.exec(U.fragment);return N?{handle:Number(N[1]),notebook:U.with({scheme:U.fragment.substr(N[0].length)||I.Schemas.file,fragment:null})}:void 0}v.parseCellUri=K})(D=e.CellUri||(e.CellUri={}));const k=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function _(v){return k.get(v)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=_;function o(v){return k.get(v)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function a(v){return k.get(v)?.mergeable??!1}e.mimeTypeIsMergeable=a;function p(v,A){return R.isWindows&&(v=v.replace(/\//g,"\\"),A=A.replace(/\//g,"\\")),g.match(v,A)}function t(v,A,w){let F=0;for(let O=0;O<A.length;O++){if(p(A[O],v))return F;F++}for(let O=0;O<w.length;O++){if(p(w[O],v))return F;F++}return F}function s(v,A,w){return v.sort((F,O)=>t(F,A,w)-t(O,A,w))}e.sortMimeTypes=s;function r(v,A,w,F=(O,G)=>O===G){const O=[];function G(z,N,B){if(N===0&&B.length===0)return;const x=O[O.length-1];x&&x.start+x.deleteCount===z?(x.deleteCount+=N,x.toInsert.push(...B)):O.push({start:z,deleteCount:N,toInsert:B})}let K=0,U=0;for(;;){if(K===v.length){G(K,0,A.slice(U));break}if(U===A.length){G(K,v.length-K,[]);break}const z=v[K],N=A[U];if(F(z,N)){K+=1,U+=1;continue}w(N)?(G(K,1,[]),K+=1):(G(K,0,[N]),U+=1)}return O}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(v){v.default="default",v.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function f(v){const A=v;return!!((typeof A.include=="string"||g.isRelativePattern(A.include))&&(typeof A.exclude=="string"||g.isRelativePattern(A.exclude)))}e.isDocumentExcludePattern=f;function l(v,A,w){if(Array.isArray(v.viewType)&&v.viewType.indexOf(A)>=0||v.viewType===A)return!0;if(v.filenamePattern){let F=f(v.filenamePattern)?v.filenamePattern.include:v.filenamePattern,O=f(v.filenamePattern)?v.filenamePattern.exclude:void 0;if(g.match(F,(0,C.basename)(w.fsPath).toLowerCase()))return!(O&&g.match(O,(0,C.basename)(w.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class d{constructor(A){this.textModel=A}getElements(){const A=new Int32Array(this.textModel.cells.length);for(let w=0;w<this.textModel.cells.length;w++)A[w]=this.textModel.cells[w].getHashValue();return A}}e.CellSequence=d,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var b;(function(v){v[v.Left=1]="Left",v[v.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class y{static create(A){return`${y._prefix}${A}`}static parse(A){if(A.startsWith(y._prefix))return A.substr(y._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=y,y._prefix="notebook/"}),define(me[214],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState",I[I.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,g.createDecorator)("INotebookExecutionService")}),define(me[215],ge([0,1,177,4,62]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[216],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=g;function L(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=L}),define(me[127],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var L;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(P){P[P.Error=0]="Error",P[P.Info=1]="Info"})(I=e.TestMessageType||(e.TestMessageType={}));var C;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(P,c)=>{c.expand!==void 0&&(P.expand=c.expand),c.item!==void 0&&(P.item=P.item?Object.assign(P.item,c.item):c.item)};e.applyTestItemUpdate=R;var E;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement"})(E=e.DetailType||(e.DetailType={}));var S;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.Remove=2]="Remove",P[P.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",P[P.Retire=4]="Retire",P[P.AddTag=5]="AddTag",P[P.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(c){}update(c){}remove(c,m){}complete(){}}e.IncrementalChangeCollector=T;class n{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const m=this.createChangeCollector();for(const u of c)switch(u[0]){case 0:{const h=u[1];if(h.parent){if(this.items.has(h.parent)){const D=this.items.get(h.parent);D.children.add(h.item.extId);const k=this.createItem(h,D);this.items.set(h.item.extId,k),m.add(k)}}else{const D=this.createItem(h);this.roots.add(D),this.items.set(h.item.extId,D),m.add(D)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=u[1],D=this.items.get(h.extId);if(!D)break;h.expand!==void 0&&(D.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(D,h),m.update(D);break}case 2:{const h=this.items.get(u[1]);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h);const D=[[u[1]]];for(;D.length;)for(const k of D.pop()){const _=this.items.get(k);_&&(D.push(_.children),this.items.delete(k),m.remove(_,_!==h),_.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(u[1]);break;case 3:this.updatePendingRoots(u[1]);break;case 5:this._tags.set(u[1].id,u[1]);break;case 6:this._tags.delete(u[1]);break}m.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=n}),define(me[89],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(C){C.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class I{constructor(R,E=R.length){if(this.path=R,this.viewEnd=E,R.length===0||E<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(R,E,S=R.parent){if(R.id===E)return new I([E]);let T=[R.id];for(let n=S;n&&n.id!==E;n=n.parent)T.push(n.id);return T.push(E),new I(T.reverse())}static isRoot(R){return!R.includes("\0")}static fromString(R){return new I(R.split("\0"))}static join(R,E){return new I([...R.path,E])}static joinToString(R,E){return R.toString()+"\0"+E}static compare(R,E){return R===E?0:E.startsWith(R+"\0")?2:R.startsWith(E+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new I(this.path,R)}compare(R){if(typeof R=="string")return I.compare(this.toString(),R);for(let E=0;E<R.viewEnd&&E<this.viewEnd;E++)if(R.path[E]!==this.path[E])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=I}),define(me[217],ge([0,1,8,38,13,25,11,79,178]),function(Y,e,g,L,I,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(P,c,m){this._contributedVariables=new Map,this._context=P,this._labelService=c,m&&(this._envVariablesPromise=m.then(u=>this.prepareEnv(u)))}prepareEnv(P){if(R.isWindows){const c=Object.create(null);return Object.keys(P).forEach(m=>{c[m.toLowerCase()]=P[m]}),c}return P}resolveWithEnvironment(P,c,m){return this.recursiveResolve(this.prepareEnv(P),c?c.uri:void 0,m)}async resolveAsync(P,c){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,c)}async resolveAnyBase(P,c,m,u){const h=C.deepClone(c);return R.isWindows&&h.windows?Object.keys(h.windows).forEach(D=>h[D]=h.windows[D]):R.isMacintosh&&h.osx?Object.keys(h.osx).forEach(D=>h[D]=h.osx[D]):R.isLinux&&h.linux&&Object.keys(h.linux).forEach(D=>h[D]=h.linux[D]),delete h.windows,delete h.osx,delete h.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,h,m,u)}async resolveAnyAsync(P,c,m){return this.resolveAnyBase(P,c,m)}async resolveAnyMap(P,c,m){const u=new Map;return{newConfig:await this.resolveAnyBase(P,c,m,u),resolvedVariables:u}}resolveWithInteractionReplace(P,c,m,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,c,m,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,c){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,c)}recursiveResolve(P,c,m,u,h){if(I.isString(m))return this.resolveString(P,c,m,u,h);if(I.isArray(m))return m.map(D=>this.recursiveResolve(P,c,D,u,h));if(I.isObject(m)){let D=Object.create(null);return Object.keys(m).forEach(k=>{const _=this.resolveString(P,c,k,u,h);D[_]=this.recursiveResolve(P,c,m[k],u,h)}),D}return m}resolveString(P,c,m,u,h){return m.replace(T.VARIABLE_REGEXP,(k,_)=>{if(_.includes(T.VARIABLE_LHS))return k;let o=this.evaluateSingleVariable(P,k,_,c,u);return h&&h.set(_,o),o!==k&&I.isString(o)&&o.match(T.VARIABLE_REGEXP)&&(o=this.resolveString(P,c,o,u,h)),o})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,c,m,u,h){let D;const k=m.split(":");k.length>1&&(m=k[0],D=k[1]);const _=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error((0,S.localize)(0,null,c))},o=()=>{const p=_();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,S.localize)(1,null,c,g.basename(p)))},a=()=>{if(D){const p=this._context.getFolderUri(D);if(p)return p;throw new Error((0,S.localize)(2,null,c,D))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,c)):new Error((0,S.localize)(4,null,c))};switch(m){case"env":if(D){if(P){const p=P[R.isWindows?D.toLowerCase():D];if(I.isString(p))return p}return""}throw new Error((0,S.localize)(5,null,c));case"config":if(D){const p=this._context.getConfigurationValue(u,D);if(I.isUndefinedOrNull(p))throw new Error((0,S.localize)(6,null,c,D));if(I.isObject(p))throw new Error((0,S.localize)(7,null,c,D));return p}throw new Error((0,S.localize)(8,null,c));case"command":return this.resolveFromMap(c,D,h,"command");case"input":return this.resolveFromMap(c,D,h,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,E.normalizeDriveLetter)(this.fsPath(a()));case"cwd":return u||D?(0,E.normalizeDriveLetter)(this.fsPath(a())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(a()));case"lineNumber":const p=this._context.getLineNumber();if(p)return p;throw new Error((0,S.localize)(9,null,c));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,S.localize)(10,null,c));case"file":return _();case"fileWorkspaceFolder":return o();case"relativeFile":return u||D?g.relative(this.fsPath(a()),_()):_();case"relativeFileDirname":const s=g.dirname(_());if(u||D){const l=g.relative(this.fsPath(a()),s);return l.length===0?".":l}return s;case"fileDirname":return g.dirname(_());case"fileExtname":return g.extname(_());case"fileBasename":return g.basename(_());case"fileBasenameNoExtension":const r=g.basename(_());return r.slice(0,r.length-g.extname(r).length);case"fileDirnameBasename":return g.basename(g.dirname(_()));case"execPath":const i=this._context.getExecPath();return i||c;case"execInstallFolder":const f=this._context.getAppRoot();return f||c;case"pathSeparator":return g.sep;default:try{const l=D?`${m}:${D}`:m;return this.resolveFromMap(c,l,h,void 0)}catch(l){return c}}}}resolveFromMap(P,c,m,u){if(c&&m){const h=u===void 0?m[c]:m[u+":"+c];if(typeof h=="string")return h;throw new Error((0,S.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[128],ge([0,1,4,209]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var I;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var C;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var E;(function(h){h[h.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(E=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function T(h){const D=h;return(0,L.isEditorInput)(D?.editor)&&(0,L.isEditorInput)(D?.replacement)}e.isEditorReplacement=T;var n;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(h){h[h.GROUP_ACTIVE=0]="GROUP_ACTIVE",h[h.GROUP_INDEX=1]="GROUP_INDEX",h[h.GROUP_LOCKED=2]="GROUP_LOCKED",h[h.EDITOR_OPEN=3]="EDITOR_OPEN",h[h.EDITOR_CLOSE=4]="EDITOR_CLOSE",h[h.EDITOR_MOVE=5]="EDITOR_MOVE",h[h.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",h[h.EDITOR_LABEL=7]="EDITOR_LABEL",h[h.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",h[h.EDITOR_PIN=9]="EDITOR_PIN",h[h.EDITOR_STICKY=10]="EDITOR_STICKY",h[h.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var c;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(c=e.OpenEditorContext||(e.OpenEditorContext={}));function m(h){const D=h;return!!D&&typeof D.id=="number"&&Array.isArray(D.editors)}e.isEditorGroup=m;function u(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=u}),define(me[218],ge([0,1,4,128]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(C){const R=C;return typeof C=="number"||(0,L.isEditorGroup)(R)}e.isPreferredGroup=I}),define(me[15],ge([0,1,17,23,99,293,60,25,13,2,41,83,179,117,64,126,89,218,7]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(le){function Ee(q){const{selectionStartLineNumber:Ae,selectionStartColumn:Pe,positionLineNumber:Ze,positionColumn:Xe}=q,ot=new _.Position(Ae-1,Pe-1),vt=new _.Position(Ze-1,Xe-1);return new _.Selection(ot,vt)}le.to=Ee;function ce(q){const{anchor:Ae,active:Pe}=q;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}le.from=ce})(o=e.Selection||(e.Selection={}));var a;(function(le){function Ee(q){if(!q)return;const{start:Ae,end:Pe}=q;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}le.from=Ee;function ce(q){if(!q)return;const{startLineNumber:Ae,startColumn:Pe,endLineNumber:Ze,endColumn:Xe}=q;return new _.Range(Ae-1,Pe-1,Ze-1,Xe-1)}le.to=ce})(a=e.Range||(e.Range={}));var p;(function(le){function Ee(ce){switch(ce){case 1:return _.StandardTokenType.Comment;case 0:return _.StandardTokenType.Other;case 4:return _.StandardTokenType.RegEx;case 2:return _.StandardTokenType.String}}le.to=Ee})(p=e.TokenType||(e.TokenType={}));var t;(function(le){function Ee(q){return new _.Position(q.lineNumber-1,q.column-1)}le.to=Ee;function ce(q){return{lineNumber:q.line+1,column:q.character+1}}le.from=ce})(t=e.Position||(e.Position={}));var s;(function(le){function Ee(q){switch(q){case _.DiagnosticTag.Unnecessary:return 1;case _.DiagnosticTag.Deprecated:return 2}}le.from=Ee;function ce(q){switch(q){case 1:return _.DiagnosticTag.Unnecessary;case 2:return _.DiagnosticTag.Deprecated;default:return}}le.to=ce})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(le){function Ee(q){let Ae;return q.code&&((0,S.isString)(q.code)||(0,S.isNumber)(q.code)?Ae=String(q.code):Ae={value:String(q.code.value),target:q.code.target}),{...a.from(q.range),message:q.message,source:q.source,code:Ae,severity:f.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(i.from),tags:Array.isArray(q.tags)?(0,g.coalesce)(q.tags.map(s.from)):void 0}}le.from=Ee;function ce(q){const Ae=new _.Diagnostic(a.to(q),q.message,f.to(q.severity));return Ae.source=q.source,Ae.code=(0,S.isString)(q.code)?q.code:q.code?.value,Ae.relatedInformation=q.relatedInformation&&q.relatedInformation.map(i.to),Ae.tags=q.tags&&(0,g.coalesce)(q.tags.map(s.to)),Ae}le.to=ce})(r=e.Diagnostic||(e.Diagnostic={}));var i;(function(le){function Ee(q){return{...a.from(q.location.range),message:q.message,resource:q.location.uri}}le.from=Ee;function ce(q){return new _.DiagnosticRelatedInformation(new _.Location(q.resource,a.to(q)),q.message)}le.to=ce})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var f;(function(le){function Ee(q){switch(q){case _.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case _.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case _.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case _.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}le.from=Ee;function ce(q){switch(q){case m.MarkerSeverity.Info:return _.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return _.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return _.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return _.DiagnosticSeverity.Hint;default:return _.DiagnosticSeverity.Error}}le.to=ce})(f=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var l;(function(le){function Ee(q){return typeof q=="number"&&q>=_.ViewColumn.One?q-1:q===_.ViewColumn.Beside?k.SIDE_GROUP:k.ACTIVE_GROUP}le.from=Ee;function ce(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}le.to=ce})(l=e.ViewColumn||(e.ViewColumn={}));function d(le){return typeof le.range!="undefined"}function b(le){return le.length===0?!0:!!d(le[0])}e.isDecorationOptionsArr=b;var y;(function(le){function Ee(Xe){return Xe.map(le.from)}le.fromMany=Ee;function ce(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function q(Xe){let ot;if(ce(Xe)){const{language:dt,value:mt}=Xe;ot={value:"```"+dt+`
`+mt+"\n```\n"}}else _.MarkdownString.isMarkdownString(Xe)?ot={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml}:typeof Xe=="string"?ot={value:Xe}:ot={value:""};const vt=Object.create(null);ot.uris=vt;const Et=dt=>{try{let mt=T.URI.parse(dt,!0);mt=mt.with({query:Ae(mt.query,vt)}),vt[dt]=mt}catch(mt){}return""},lt=new C.Renderer;return lt.link=Et,lt.image=dt=>Et(I.parseHrefAndDimensions(dt).href),C(ot.value,{renderer:lt}),ot}le.from=q;function Ae(Xe,ot){if(!Xe)return Xe;let vt;try{vt=(0,R.parse)(Xe)}catch(lt){}if(!vt)return Xe;let Et=!1;return vt=(0,E.cloneAndChange)(vt,lt=>{if(T.URI.isUri(lt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[dt]=lt,Et=!0,dt}else return}),Et?JSON.stringify(vt):Xe}function Pe(Xe){const ot=new _.MarkdownString(Xe.value,Xe.supportThemeIcons);return ot.isTrusted=Xe.isTrusted,ot.supportHtml=Xe.supportHtml,ot}le.to=Pe;function Ze(Xe){if(!!Xe)return typeof Xe=="string"?Xe:le.from(Xe)}le.fromStrict=Ze})(y=e.MarkdownString||(e.MarkdownString={}));function v(le){return b(le)?le.map(Ee=>({range:a.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?y.fromMany(Ee.hoverMessage):Ee.hoverMessage?y.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):le.map(Ee=>({range:a.from(Ee)}))}e.fromRangeOrRangeWithMessage=v;function A(le){return typeof le=="undefined"?le:typeof le=="string"?T.URI.file(le):le}e.pathOrURIToURI=A;var w;(function(le){function Ee(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?A(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}le.from=Ee})(w=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(le){function Ee(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?A(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?w.from(ce.before):void 0,after:ce.after?w.from(ce.after):void 0}}le.from=Ee})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var O;(function(le){function Ee(ce){if(typeof ce=="undefined")return ce;switch(ce){case _.DecorationRangeBehavior.OpenOpen:return 0;case _.DecorationRangeBehavior.ClosedClosed:return 1;case _.DecorationRangeBehavior.OpenClosed:return 2;case _.DecorationRangeBehavior.ClosedOpen:return 3}}le.from=Ee})(O=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var G;(function(le){function Ee(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?O.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?F.from(ce.light):void 0,dark:ce.dark?F.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?A(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?w.from(ce.before):void 0,after:ce.after?w.from(ce.after):void 0}}le.from=Ee})(G=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(le){function Ee(q){return{text:q.newText,eol:q.newEol&&pe.from(q.newEol),range:a.from(q.range)}}le.from=Ee;function ce(q){const Ae=new _.TextEdit(a.to(q.range),q.text);return Ae.newEol=typeof q.eol=="undefined"?void 0:pe.to(q.eol),Ae}le.to=ce})(K=e.TextEdit||(e.TextEdit={}));var U;(function(le){function Ee(q,Ae,Pe){const Ze={edits:[]};if(q instanceof _.WorkspaceEdit)for(let Xe of q._allEntries())if(Xe._type===1)Ze.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const ot=Ae?.getDocument(Xe.uri);Ze.edits.push({_type:2,resource:Xe.uri,edit:K.from(Xe.edit),modelVersionId:ot?.version,metadata:Xe.metadata})}else Xe._type===3?Ze.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Pe?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version}):Xe._type===5&&Ze.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Pe?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(Qe.from)}});return Ze}le.from=Ee;function ce(q){const Ae=new _.WorkspaceEdit;for(const Pe of q.edits)Pe.edit?Ae.replace(T.URI.revive(Pe.resource),a.to(Pe.edit.range),Pe.edit.text):Ae.renameFile(T.URI.revive(Pe.oldUri),T.URI.revive(Pe.newUri),Pe.options);return Ae}le.to=ce})(U=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(le){const Ee=Object.create(null);Ee[_.SymbolKind.File]=0,Ee[_.SymbolKind.Module]=1,Ee[_.SymbolKind.Namespace]=2,Ee[_.SymbolKind.Package]=3,Ee[_.SymbolKind.Class]=4,Ee[_.SymbolKind.Method]=5,Ee[_.SymbolKind.Property]=6,Ee[_.SymbolKind.Field]=7,Ee[_.SymbolKind.Constructor]=8,Ee[_.SymbolKind.Enum]=9,Ee[_.SymbolKind.Interface]=10,Ee[_.SymbolKind.Function]=11,Ee[_.SymbolKind.Variable]=12,Ee[_.SymbolKind.Constant]=13,Ee[_.SymbolKind.String]=14,Ee[_.SymbolKind.Number]=15,Ee[_.SymbolKind.Boolean]=16,Ee[_.SymbolKind.Array]=17,Ee[_.SymbolKind.Object]=18,Ee[_.SymbolKind.Key]=19,Ee[_.SymbolKind.Null]=20,Ee[_.SymbolKind.EnumMember]=21,Ee[_.SymbolKind.Struct]=22,Ee[_.SymbolKind.Event]=23,Ee[_.SymbolKind.Operator]=24,Ee[_.SymbolKind.TypeParameter]=25;function ce(Ae){return typeof Ee[Ae]=="number"?Ee[Ae]:6}le.from=ce;function q(Ae){for(const Pe in Ee)if(Ee[Pe]===Ae)return Number(Pe);return _.SymbolKind.Property}le.to=q})(z=e.SymbolKind||(e.SymbolKind={}));var N;(function(le){function Ee(q){switch(q){case _.SymbolTag.Deprecated:return 1}}le.from=Ee;function ce(q){switch(q){case 1:return _.SymbolTag.Deprecated}}le.to=ce})(N=e.SymbolTag||(e.SymbolTag={}));var B;(function(le){function Ee(q){return{name:q.name,kind:z.from(q.kind),tags:q.tags&&q.tags.map(N.from),containerName:q.containerName,location:Q.from(q.location)}}le.from=Ee;function ce(q){const Ae=new _.SymbolInformation(q.name,z.to(q.kind),q.containerName,Q.to(q.location));return Ae.tags=q.tags&&q.tags.map(N.to),Ae}le.to=ce})(B=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var x;(function(le){function Ee(q){const Ae={name:q.name||"!!MISSING: name!!",detail:q.detail,range:a.from(q.range),selectionRange:a.from(q.selectionRange),kind:z.from(q.kind),tags:q.tags?.map(N.from)??[]};return q.children&&(Ae.children=q.children.map(Ee)),Ae}le.from=Ee;function ce(q){const Ae=new _.DocumentSymbol(q.name,q.detail,z.to(q.kind),a.to(q.range),a.to(q.selectionRange));return(0,g.isNonEmptyArray)(q.tags)&&(Ae.tags=q.tags.map(N.to)),q.children&&(Ae.children=q.children.map(ce)),Ae}le.to=ce})(x=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(le){function Ee(q){const Ae=new _.CallHierarchyItem(z.to(q.kind),q.name,q.detail||"",T.URI.revive(q.uri),a.to(q.range),a.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}le.to=Ee;function ce(q,Ae,Pe){if(Ae=Ae??q._sessionId,Pe=Pe??q._itemId,Ae===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Pe,name:q.name,detail:q.detail,kind:z.from(q.kind),uri:q.uri,range:a.from(q.range),selectionRange:a.from(q.selectionRange),tags:q.tags?.map(N.from)}}le.from=ce})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var H;(function(le){function Ee(ce){return new _.CallHierarchyIncomingCall(M.to(ce.from),ce.fromRanges.map(q=>a.to(q)))}le.to=Ee})(H=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var $;(function(le){function Ee(ce){return new _.CallHierarchyOutgoingCall(M.to(ce.to),ce.fromRanges.map(q=>a.to(q)))}le.to=Ee})($=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(le){function Ee(q){return{range:q.range&&a.from(q.range),uri:q.uri}}le.from=Ee;function ce(q){return new _.Location(T.URI.revive(q.uri),a.to(q.range))}le.to=ce})(Q=e.location||(e.location={}));var X;(function(le){function Ee(q){const Ae=q,Pe=q;return{originSelectionRange:Ae.originSelectionRange?a.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Pe.uri,range:a.from(Ae.targetRange?Ae.targetRange:Pe.range),targetSelectionRange:Ae.targetSelectionRange?a.from(Ae.targetSelectionRange):void 0}}le.from=Ee;function ce(q){return{targetUri:T.URI.revive(q.uri),targetRange:a.to(q.range),targetSelectionRange:q.targetSelectionRange?a.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?a.to(q.originSelectionRange):void 0}}le.to=ce})(X=e.DefinitionLink||(e.DefinitionLink={}));var he;(function(le){function Ee(q){return{range:a.from(q.range),contents:y.fromMany(q.contents)}}le.from=Ee;function ce(q){return new _.Hover(q.contents.map(y.to),a.to(q.range))}le.to=ce})(he=e.Hover||(e.Hover={}));var _e;(function(le){function Ee(q){return{range:a.from(q.range),expression:q.expression}}le.from=Ee;function ce(q){return new _.EvaluatableExpression(a.to(q.range),q.expression)}le.to=ce})(_e=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(le){function Ee(q){if(q instanceof _.InlineValueText)return{type:"text",range:a.from(q.range),text:q.text};if(q instanceof _.InlineValueVariableLookup)return{type:"variable",range:a.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof _.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}le.from=Ee;function ce(q){switch(q.type){case"text":return{range:a.to(q.range),text:q.text};case"variable":return{range:a.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:a.to(q.range),expression:q.expression}}}le.to=ce})(ye=e.InlineValue||(e.InlineValue={}));var Re;(function(le){function Ee(q){return{frameId:q.frameId,stoppedLocation:a.from(q.stoppedLocation)}}le.from=Ee;function ce(q){return new _.InlineValueContext(q.frameId,a.to(q.stoppedLocation))}le.to=ce})(Re=e.InlineValueContext||(e.InlineValueContext={}));var We;(function(le){function Ee(q){return{range:a.from(q.range),kind:q.kind}}le.from=Ee;function ce(q){return new _.DocumentHighlight(a.to(q.range),q.kind)}le.to=ce})(We=e.DocumentHighlight||(e.DocumentHighlight={}));var Be;(function(le){function Ee(ce){switch(ce){case 1:return _.CompletionTriggerKind.TriggerCharacter;case 2:return _.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return _.CompletionTriggerKind.Invoke}}le.to=Ee})(Be=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(le){function Ee(ce){return{triggerKind:Be.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}le.to=Ee})(je=e.CompletionContext||(e.CompletionContext={}));var V;(function(le){function Ee(q){switch(q){case _.CompletionItemTag.Deprecated:return 1}}le.from=Ee;function ce(q){switch(q){case 1:return _.CompletionItemTag.Deprecated}}le.to=ce})(V=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(le){const Ee=new Map([[_.CompletionItemKind.Method,0],[_.CompletionItemKind.Function,1],[_.CompletionItemKind.Constructor,2],[_.CompletionItemKind.Field,3],[_.CompletionItemKind.Variable,4],[_.CompletionItemKind.Class,5],[_.CompletionItemKind.Interface,7],[_.CompletionItemKind.Struct,6],[_.CompletionItemKind.Module,8],[_.CompletionItemKind.Property,9],[_.CompletionItemKind.Unit,12],[_.CompletionItemKind.Value,13],[_.CompletionItemKind.Constant,14],[_.CompletionItemKind.Enum,15],[_.CompletionItemKind.EnumMember,16],[_.CompletionItemKind.Keyword,17],[_.CompletionItemKind.Snippet,27],[_.CompletionItemKind.Text,18],[_.CompletionItemKind.Color,19],[_.CompletionItemKind.File,20],[_.CompletionItemKind.Reference,21],[_.CompletionItemKind.Folder,23],[_.CompletionItemKind.Event,10],[_.CompletionItemKind.Operator,11],[_.CompletionItemKind.TypeParameter,24],[_.CompletionItemKind.Issue,26],[_.CompletionItemKind.User,25]]);function ce(Pe){return Ee.get(Pe)??9}le.from=ce;const q=new Map([[0,_.CompletionItemKind.Method],[1,_.CompletionItemKind.Function],[2,_.CompletionItemKind.Constructor],[3,_.CompletionItemKind.Field],[4,_.CompletionItemKind.Variable],[5,_.CompletionItemKind.Class],[7,_.CompletionItemKind.Interface],[6,_.CompletionItemKind.Struct],[8,_.CompletionItemKind.Module],[9,_.CompletionItemKind.Property],[12,_.CompletionItemKind.Unit],[13,_.CompletionItemKind.Value],[14,_.CompletionItemKind.Constant],[15,_.CompletionItemKind.Enum],[16,_.CompletionItemKind.EnumMember],[17,_.CompletionItemKind.Keyword],[27,_.CompletionItemKind.Snippet],[18,_.CompletionItemKind.Text],[19,_.CompletionItemKind.Color],[20,_.CompletionItemKind.File],[21,_.CompletionItemKind.Reference],[23,_.CompletionItemKind.Folder],[10,_.CompletionItemKind.Event],[11,_.CompletionItemKind.Operator],[24,_.CompletionItemKind.TypeParameter],[25,_.CompletionItemKind.User],[26,_.CompletionItemKind.Issue]]);function Ae(Pe){return q.get(Pe)??_.CompletionItemKind.Property}le.to=Ae})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(le){function Ee(ce,q){const Ae=new _.CompletionItem(ce.label);return Ae.insertText=ce.insertText,Ae.kind=ee.to(ce.kind),Ae.tags=ce.tags?.map(V.to),Ae.detail=ce.detail,Ae.documentation=I.isMarkdownString(ce.documentation)?y.to(ce.documentation):ce.documentation,Ae.sortText=ce.sortText,Ae.filterText=ce.filterText,Ae.preselect=ce.preselect,Ae.commitCharacters=ce.commitCharacters,n.Range.isIRange(ce.range)?Ae.range=a.to(ce.range):typeof ce.range=="object"&&(Ae.range={inserting:a.to(ce.range.insert),replacing:a.to(ce.range.replace)}),Ae.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Ae.insertText=new _.SnippetString(ce.insertText):(Ae.insertText=ce.insertText,Ae.textEdit=Ae.range instanceof _.Range?new _.TextEdit(Ae.range,Ae.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ce.additionalTextEdits.map(Pe=>K.to(Pe))),Ae.command=q&&ce.command?q.fromInternal(ce.command):void 0,Ae}le.to=Ee})(re=e.CompletionItem||(e.CompletionItem={}));var ae;(function(le){function Ee(q){return{label:q.label,documentation:q.documentation?y.fromStrict(q.documentation):void 0}}le.from=Ee;function ce(q){return{label:q.label,documentation:I.isMarkdownString(q.documentation)?y.to(q.documentation):q.documentation}}le.to=ce})(ae=e.ParameterInformation||(e.ParameterInformation={}));var J;(function(le){function Ee(q){return{label:q.label,documentation:q.documentation?y.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(ae.from):[],activeParameter:q.activeParameter}}le.from=Ee;function ce(q){return{label:q.label,documentation:I.isMarkdownString(q.documentation)?y.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(ae.to):[],activeParameter:q.activeParameter}}le.to=ce})(J=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(le){function Ee(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(J.from):[]}}le.from=Ee;function ce(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(J.to):[]}}le.to=ce})(oe=e.SignatureHelp||(e.SignatureHelp={}));var ve;(function(le){function Ee(q){return{text:q.text,position:t.from(q.position),kind:Me.from(q.kind??_.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}le.from=Ee;function ce(q){const Ae=new _.InlayHint(q.text,t.to(q.position),Me.to(q.kind));return Ae.whitespaceAfter=q.whitespaceAfter,Ae.whitespaceBefore=q.whitespaceBefore,Ae}le.to=ce})(ve=e.InlayHint||(e.InlayHint={}));var Me;(function(le){function Ee(q){return q}le.from=Ee;function ce(q){return q}le.to=ce})(Me=e.InlayHintKind||(e.InlayHintKind={}));var qe;(function(le){function Ee(q){return{range:a.from(q.range),url:q.target,tooltip:q.tooltip}}le.from=Ee;function ce(q){let Ae;if(q.url)try{Ae=typeof q.url=="string"?T.URI.parse(q.url,!0):T.URI.revive(q.url)}catch(Pe){}return new _.DocumentLink(a.to(q.range),Ae)}le.to=ce})(qe=e.DocumentLink||(e.DocumentLink={}));var Ke;(function(le){function Ee(q){const Ae=new _.ColorPresentation(q.label);return q.textEdit&&(Ae.textEdit=K.to(q.textEdit)),q.additionalTextEdits&&(Ae.additionalTextEdits=q.additionalTextEdits.map(Pe=>K.to(Pe))),Ae}le.to=Ee;function ce(q){return{label:q.label,textEdit:q.textEdit?K.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ae=>K.from(Ae)):void 0}}le.from=ce})(Ke=e.ColorPresentation||(e.ColorPresentation={}));var Se;(function(le){function Ee(q){return new _.Color(q[0],q[1],q[2],q[3])}le.to=Ee;function ce(q){return[q.red,q.green,q.blue,q.alpha]}le.from=ce})(Se=e.Color||(e.Color={}));var tt;(function(le){function Ee(q){return{range:a.from(q.range)}}le.from=Ee;function ce(q){return new _.SelectionRange(a.to(q.range))}le.to=ce})(tt=e.SelectionRange||(e.SelectionRange={}));var Z;(function(le){function Ee(ce){switch(ce){case 2:return _.TextDocumentSaveReason.AfterDelay;case 1:return _.TextDocumentSaveReason.Manual;case 3:case 4:return _.TextDocumentSaveReason.FocusOut}}le.to=Ee})(Z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var te;(function(le){function Ee(q){switch(q){case _.TextEditorLineNumbersStyle.Off:return 0;case _.TextEditorLineNumbersStyle.Relative:return 2;case _.TextEditorLineNumbersStyle.On:default:return 1}}le.from=Ee;function ce(q){switch(q){case 0:return _.TextEditorLineNumbersStyle.Off;case 2:return _.TextEditorLineNumbersStyle.Relative;case 1:default:return _.TextEditorLineNumbersStyle.On}}le.to=ce})(te=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var pe;(function(le){function Ee(q){if(q===_.EndOfLine.CRLF)return 1;if(q===_.EndOfLine.LF)return 0}le.from=Ee;function ce(q){if(q===1)return _.EndOfLine.CRLF;if(q===0)return _.EndOfLine.LF}le.to=ce})(pe=e.EndOfLine||(e.EndOfLine={}));var xe;(function(le){function Ee(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case _.ProgressLocation.SourceControl:return 3;case _.ProgressLocation.Window:return 10;case _.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}le.from=Ee})(xe=e.ProgressLocation||(e.ProgressLocation={}));var Ye;(function(le){function Ee(ce){const q={start:ce.start+1,end:ce.end+1};return ce.kind&&(q.kind=rt.from(ce.kind)),q}le.from=Ee})(Ye=e.FoldingRange||(e.FoldingRange={}));var rt;(function(le){function Ee(ce){if(ce)switch(ce){case _.FoldingRangeKind.Comment:return P.FoldingRangeKind.Comment;case _.FoldingRangeKind.Imports:return P.FoldingRangeKind.Imports;case _.FoldingRangeKind.Region:return P.FoldingRangeKind.Region}}le.from=Ee})(rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ft;(function(le){function Ee(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?a.from(ce.selection):void 0,override:typeof ce.override=="boolean"?c.EditorResolution.DISABLED:void 0}}le.from=Ee})(ft=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var pt;(function(le){function Ee(q){return q instanceof _.RelativePattern||typeof q=="string"?q:ce(q)?new _.RelativePattern(q.base,q.pattern):q}le.from=Ee;function ce(q){const Ae=q;return Ae&&typeof Ae.base=="string"&&typeof Ae.pattern=="string"}})(pt=e.GlobPattern||(e.GlobPattern={}));var St;(function(le){function Ee(ce){if(ce){if(Array.isArray(ce))return ce.map(Ee);if(typeof ce=="string")return ce;{const q=ce;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:pt.from(q.pattern),exclusive:q.exclusive}}}else return}le.from=Ee})(St=e.LanguageSelector||(e.LanguageSelector={}));var Ct;(function(le){function Ee(q){return{start:q.start,end:q.end}}le.from=Ee;function ce(q){return new _.NotebookRange(q.start,q.end)}le.to=ce})(Ct=e.NotebookRange||(e.NotebookRange={}));var ue;(function(le){function Ee(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}le.to=Ee;function ce(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}le.from=ce})(ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ie;(function(le){function Ee(q){switch(q){case _.NotebookCellKind.Markup:return h.CellKind.Markup;case _.NotebookCellKind.Code:default:return h.CellKind.Code}}le.from=Ee;function ce(q){switch(q){case h.CellKind.Markup:return _.NotebookCellKind.Markup;case h.CellKind.Code:default:return _.NotebookCellKind.Code}}le.to=ce})(Ie=e.NotebookCellKind||(e.NotebookCellKind={}));var Ue;(function(le){function Ee(q){const Ae={metadata:q.metadata??Object.create(null),cells:[]};for(let Pe of q.cells)_.NotebookCellData.validate(Pe),Ae.cells.push(Qe.from(Pe));return Ae}le.from=Ee;function ce(q){const Ae=new _.NotebookData(q.cells.map(Qe.to));return(0,S.isEmptyObject)(q.metadata)||(Ae.metadata=q.metadata),Ae}le.to=ce})(Ue=e.NotebookData||(e.NotebookData={}));var Qe;(function(le){function Ee(q){return{cellKind:Ie.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:ue.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(at.from):[]}}le.from=Ee;function ce(q){return new _.NotebookCellData(Ie.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(at.to):void 0,q.metadata,q.internalMetadata?ue.to(q.internalMetadata):void 0)}le.to=ce})(Qe=e.NotebookCellData||(e.NotebookCellData={}));var ze;(function(le){function Ee(q){return{mime:q.mime,valueBytes:L.VSBuffer.wrap(q.data)}}le.from=Ee;function ce(q){return new _.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}le.to=ce})(ze=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var at;(function(le){function Ee(q){return{outputId:q.id,items:q.items.map(ze.from),metadata:q.metadata}}le.from=Ee;function ce(q){const Ae=q.items.map(ze.to);return new _.NotebookCellOutput(Ae,q.outputId,q.metadata)}le.to=ce})(at=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Le;(function(le){function Ee(Pe){if(Pe!=null){if(Pe instanceof _.RelativePattern||typeof Pe=="string")return Pe;if(Ae(Pe))return new _.RelativePattern(Pe.base,Pe.pattern);if(q(Pe))return{include:pt.from(Pe.include)||void 0,exclude:pt.from(Pe.exclude)||void 0}}}le.from=Ee;function ce(Pe){return typeof Pe=="string"?Pe:Ae(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}le.to=ce;function q(Pe){const Ze=Pe,Xe=pt.from(Ze.include);if(!(Xe&&Xe instanceof _.RelativePattern||typeof Xe=="string"))return!1;const ot=pt.from(Ze.exclude);return!!(ot&&ot instanceof _.RelativePattern||typeof ot=="string")}function Ae(Pe){const Ze=Pe;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Le=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var De;(function(le){function Ee(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?w.from(ce.top):void 0}}le.from=Ee})(De=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ke;(function(le){function Ee(ce,q,Ae){const Pe=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===_.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Pe,Ae),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}le.from=Ee})(ke=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ne;(function(le){function Ee(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}le.from=Ee})(ne=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var de;(function(le){function Ee(q){return{uri:q.uri,provides:q.provides}}le.from=Ee;function ce(q){return new _.NotebookRendererScript(T.URI.revive(q.uri),q.provides)}le.to=ce})(de=e.NotebookRendererScript||(e.NotebookRendererScript={}));var be;(function(le){function Ee(q){return{message:y.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location?Q.from(q.location):void 0}}le.from=Ee;function ce(q){const Ae=new _.TestMessage(typeof q.message=="string"?q.message:y.to(q.message));return Ae.actualOutput=q.actual,Ae.expectedOutput=q.expected,Ae.location=q.location?Q.to(q.location):void 0,Ae}le.to=ce})(be=e.TestMessage||(e.TestMessage={}));var we;(function(le){let Ee;(function(ce){ce.Delimiter="\0"})(Ee||(Ee={})),le.namespace=(ce,q)=>ce+"\0"+q,le.denamespace=ce=>{const q=ce.indexOf("\0");return{ctrlId:ce.slice(0,q),tagId:ce.slice(q+1)}}})(we=e.TestTag||(e.TestTag={}));var Fe;(function(le){function Ee(Pe){const Ze=(0,u.getPrivateApiFor)(Pe).controllerId;return{extId:D.TestId.fromExtHostTestItem(Pe,Ze).toString(),label:Pe.label,uri:Pe.uri,tags:Pe.tags.map(Xe=>we.namespace(Ze,Xe.id)),range:a.from(Pe.range)||null,description:Pe.description||null,error:Pe.error&&y.fromStrict(Pe.error)||null}}le.from=Ee;function ce(Pe){return{id:D.TestId.fromString(Pe.extId).localId,label:Pe.label,uri:T.URI.revive(Pe.uri),tags:(Pe.tags||[]).map(Ze=>{const{tagId:Xe}=we.denamespace(Ze);return new _.TestTag(Xe)}),range:a.to(Pe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Pe.description||void 0}}le.toPlain=ce;function q(Pe){const Ze=D.TestId.fromString(Pe.extId),Xe=new u.TestItemImpl(Ze.controllerId,Ze.localId,Pe.label,T.URI.revive(Pe.uri));return Xe.range=a.to(Pe.range||void 0),Xe.description=Pe.description||void 0,Xe}function Ae(Pe){let Ze;for(const Xe of Pe.tests){const ot=q(Xe.item);(0,u.getPrivateApiFor)(ot).parent=Ze,Ze=ot}return Ze}le.toItemFromContext=Ae})(Fe=e.TestItem||(e.TestItem={})),function(le){function Ee(q){return{id:q.id}}le.from=Ee;function ce(q){return new _.TestTag(q.id)}le.to=ce}(we=e.TestTag||(e.TestTag={}));var Ge;(function(le){const Ee=(q,Ae)=>{const Pe={...Fe.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(Xe=>Xe.type===0).map(be.to)})),children:q.children.map(Ze=>Ae.get(Ze)).filter(S.isDefined).map(Ze=>Ee(Ze,Ae))};for(const Ze of Pe.children)Ze.parent=Pe;return Pe};function ce(q){const Ae=[],Pe=new Map;for(const Ze of q.items)Pe.set(Ze.item.extId,Ze),q.request.targets.some(Xe=>Xe.controllerId===Ze.controllerId&&Xe.testIds.includes(Ze.item.extId))&&Ae.push(Ze);return{completedAt:q.completedAt,results:Ae.map(Ze=>Ee(Ze,Pe))}}le.to=ce})(Ge=e.TestResults||(e.TestResults={}));var He;(function(le){function Ee(Pe){return{covered:Pe.covered,total:Pe.covered}}function ce(Pe){return"line"in Pe?t.from(Pe):a.from(Pe)}function q(Pe){return"branches"in Pe?{count:Pe.executionCount,location:ce(Pe.location),type:1,branches:Pe.branches.length?Pe.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ce(Ze.location)})):void 0}:{type:0,count:Pe.executionCount,location:ce(Pe.location)}}le.fromDetailed=q;function Ae(Pe){return{uri:Pe.uri,statement:Ee(Pe.statementCoverage),branch:Pe.branchCoverage&&Ee(Pe.branchCoverage),function:Pe.functionCoverage&&Ee(Pe.functionCoverage),details:Pe.detailedCoverage?.map(q)}}le.fromFile=Ae})(He=e.TestCoverage||(e.TestCoverage={}));var Je;(function(le){function Ee(ce){switch(ce){case 1:return _.CodeActionTriggerKind.Invoke;case 2:return _.CodeActionTriggerKind.Automatic}}le.to=Ee})(Je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var it;(function(le){function Ee(q){const Ae=new _.TypeHierarchyItem(z.to(q.kind),q.name,q.detail||"",T.URI.revive(q.uri),a.to(q.range),a.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}le.to=Ee;function ce(q,Ae,Pe){if(Ae=Ae??q._sessionId,Pe=Pe??q._itemId,Ae===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Pe,kind:z.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:a.from(q.range),selectionRange:a.from(q.selectionRange),tags:q.tags?.map(N.from)}}le.from=ce})(it=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[219],ge([0,1,2,16,7,15,95]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class E{constructor(T,n,P,c={timeout:1500,errors:3}){this._logService=T,this._documents=n,this._mainThreadBulkEdits=P,this._thresholds=c,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(n,P,c)=>{const u={dispose:this._callbacks.push([n,P,T])};return Array.isArray(c)&&c.push(u),u}}async $participateInSave(T,n){const P=g.URI.revive(T);let c=!1;const m=setTimeout(()=>c=!0,this._thresholds.timeout),u=[];try{for(let h of[...this._callbacks]){if(c)break;const D=this._documents.getDocument(P),k=await this._deliverEventAsyncAndBlameBadListeners(h,{document:D,reason:C.TextDocumentSaveReason.to(n)});u.push(k)}}finally{clearTimeout(m)}return u}_deliverEventAsyncAndBlameBadListeners([T,n,P],c){const m=this._badListeners.get(T);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,T,n,c).then(()=>!0,u=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(u),!(u instanceof Error)||u.message!=="concurrent_edits"){const h=this._badListeners.get(T);this._badListeners.set(T,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,n,P,c){const m=[],u=Date.now(),{document:h,reason:D}=c,{version:k}=h,_=Object.freeze({document:h,reason:D,waitUntil(o){if(Object.isFrozen(m))throw(0,L.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(o))}});try{n.apply(P,[_])}catch(o){return Promise.reject(o)}return Object.freeze(m),new Promise((o,a)=>{const p=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-u}ms`),clearTimeout(p),o(t)}).catch(t=>{clearTimeout(p),a(t)})}).then(o=>{const a={edits:[]};for(const p of o)if(Array.isArray(p)&&p.every(t=>t instanceof I.TextEdit))for(const{newText:t,newEol:s,range:r}of p)a.edits.push({_type:2,resource:h.uri,edit:{range:r&&C.Range.from(r),text:t,eol:s&&C.EndOfLine.from(s)}});if(a.edits.length!==0)return k===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=E}),define(me[54],ge([0,1,15,2,3,4]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class R{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new I.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[]}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(S){let T=-1;this._tabs=S.map((P,c)=>(P.isActive&&(T=c),Object.freeze({label:P.label,viewColumn:g.ViewColumn.to(P.viewColumn),resource:L.URI.revive(P.resource),viewId:P.editorId,isActive:P.isActive})));const n=this._activeTab;this._activeTab=T===-1?void 0:this._tabs[T],this._activeTab!==n&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}}e.ExtHostEditorTabs=R}),define(me[220],ge([0,1,3,30,2,15,7]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{constructor(n,P,c,m,u){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,c&&(this._config+=1),m&&(this._config+=2),u&&(this._config+=4);const h=(0,L.parse)(P),D=n(k=>{if(!c)for(let _ of k.created){const o=I.URI.revive(_);h(o.fsPath)&&this._onDidCreate.fire(o)}if(!m)for(let _ of k.changed){const o=I.URI.revive(_);h(o.fsPath)&&this._onDidChange.fire(o)}if(!u)for(let _ of k.deleted){const o=I.URI.revive(_);h(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=R.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,D)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(n,P,c){this._logService=P,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,P,c,m){return new E(this._onFileSystemEvent.event,n,P,c,m)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,P){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:P.map(c=>({oldUri:I.URI.revive(c.source),newUri:I.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:P.map(c=>I.URI.revive(c.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:P.map(c=>I.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,P){return(c,m,u)=>{const h=function(k){c.call(m,k)};return h.extension=n,P.event(h,void 0,u)}}async $onWillRunFileOperation(n,P,c,m){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:P.map(u=>({oldUri:I.URI.revive(u.source),newUri:I.URI.revive(u.target)}))},c,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:P.map(u=>I.URI.revive(u.target))},c,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:P.map(u=>I.URI.revive(u.target))},c,m)}}async _fireWillEvent(n,P,c,m){const u=new Set,h=[];if(await n.fireAsync(P,m,async(k,_)=>{const o=Date.now(),a=await Promise.resolve(k);a instanceof R.WorkspaceEdit&&(h.push(a),u.add(_.extension.displayName??_.extension.identifier.value)),Date.now()-o>c&&this._logService.warn("SLOW file-participant",_.extension.identifier)}),m.isCancellationRequested||h.length===0)return;const D={edits:[]};for(let k of h){let{edits:_}=C.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);D.edits=D.edits.concat(_)}return{edit:D,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=S}),define(me[221],ge([0,1,10,25,2,15,7,126]),function(Y,e,g,L,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(c,m,u,h){this.start=c,this.deletedCount=m,this.deletedItems=u,this.items=h}static asApiEvents(c){return c.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(u=>u.apiCell)}))}}class T{constructor(c,m,u){this.notebook=c,this._extHostDocument=m,this._cellData=u,this.handle=u.handle,this.uri=I.URI.revive(u.uri),this.cellKind=u.cellKind,this._outputs=u.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=u.internalMetadata??{},this._metadata=Object.freeze(u.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(u.internalMetadata??{}))}static asModelAddData(c,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return c._mime},set mime(u){c._mime=u},get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(C.NotebookCellOutput.to)}setOutputItems(c,m,u){const h=u.map(C.NotebookCellOutputItem.to),D=this._outputs.find(k=>k.id===c);D&&(m||(D.items.length=0),D.items.push(...h))}setMetadata(c){this._metadata=Object.freeze(c)}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(c))}setMime(c){}}e.ExtHostCell=T;class n{constructor(c,m,u,h,D,k){this._proxy=c,this._textDocumentsAndEditors=m,this._textDocuments=u,this._emitter=h,this.uri=D,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=k.viewType,this._metadata=Object.freeze(k.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,k.cells]],!0),this._versionId=k.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get notebookType(){return c._notebookType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===g.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(m){return m=c._validateIndex(m),c._cells[m].apiCell},getCells(m){return(m?c._getCells(m):c._cells).map(h=>h.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata=Object.freeze({...this._metadata,...c.metadata}))}acceptDirty(c){this._isDirty=c}acceptModelChanged(c,m){this._versionId=c.versionId,this._isDirty=m;for(const u of c.rawEvents)u.kind===E.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1):u.kind===E.NotebookCellsChangeType.Move?this._moveCell(u.index,u.newIdx):u.kind===E.NotebookCellsChangeType.Output?this._setCellOutputs(u.index,u.outputs):u.kind===E.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems):u.kind===E.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(u.index,u.language):u.kind===E.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===E.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(u.index,u.metadata):u.kind===E.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(u.index,u.internalMetadata)}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let m=c.start|0,u=c.end|0;return m<0&&(m=0),u>this._cells.length&&(u=this._cells.length),c.with({start:m,end:u})}_getCells(c){c=this._validateRange(c);const m=[];for(let u=c.start;u<c.end;u++)m.push(this._cells[u]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,m){if(this._disposed)return;const u=[],h=[],D=[];c.reverse().forEach(k=>{const o=k[2].map(t=>{const s=new T(this,this._textDocumentsAndEditors,t);return m||h.push(T.asModelAddData(this.apiNotebook,t)),s}),a=new S(k[0],k[1],[],o),p=this._cells.splice(k[0],k[1],...o);for(const t of p)D.push(t.uri),a.deletedItems.push(t.apiCell);u.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:D}),m||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(u)}))}_moveCell(c,m){const u=this._cells.splice(c,1);this._cells.splice(m,0,...u);const h=[new S(c,1,u.map(D=>D.apiCell),[]),new S(m,0,[],u)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(h)}))}_setCellOutputs(c,m){const u=this._cells[c];u.setOutputs(m),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[u.apiCell]}))}_setCellOutputItems(c,m,u,h){const D=this._cells[c];D.setOutputItems(m,u,h),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[D.apiCell]}))}_changeCellLanguage(c,m){const u=this._cells[c];u.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(u.uri,m)}_changeCellMime(c,m){const u=this._cells[c];u.apiCell.mime=m}_changeCellMetadata(c,m){const u=this._cells[c],h=u.apiCell.metadata;u.setMetadata(m);const D=u.apiCell.metadata;(0,L.equals)(h,D)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:u.apiCell}))}_changeCellInternalMetadata(c,m){const u=this._cells[c],h=u.internalMetadata;if(u.setInternalMetadata(m),h.runState!==m.runState){const D=m.runState??R.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:u.apiCell,state:D}))}}getCellFromApiCell(c){return this._cells.find(m=>m.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(m=>m.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(me[129],ge([0,1,7,15,16]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:T})}replaceCells(S,T,n){this._throwIfFinalized(),!(S===T&&n.length===0)&&this._collectedEdits.push({editType:1,index:S,count:T-S,cells:n.map(L.NotebookCellData.from)})}}class R{constructor(S,T,n,P,c,m){this.id=S,this._proxy=T,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=P,this._viewColumn=m}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(T){if(!Array.isArray(T)||!T.every(g.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");S._selections=T,S._trySetSelections(T)},get visibleRanges(){return S._visibleRanges},revealRange(T,n){S._proxy.$tryRevealRange(S.id,L.NotebookRange.from(T),n??g.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(T){const n=new C(this.document.version);return T(n),S._applyEdit(n.finalize())},setDecorations(T,n){return S.setDecorations(T,n)}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(L.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const T=[];let n=-1;for(let P=0;P<S.cellEdits.length;P++){if(n<0){T.push(S.cellEdits[P]),n++;continue}const m=T[n],u=S.cellEdits[P];if(m.editType===1&&u.editType===1&&m.index===u.index){m.cells.push(...S.cellEdits[P].cells),m.count+=S.cellEdits[P].count;continue}T.push(S.cellEdits[P]),n++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,T)}setDecorations(S,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return T.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(T),S.key)}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(me[222],ge([0,1,15,118,166,21,58]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,c,m){const u=this._handles++,{title:h,location:D,cancellable:k}=c,_={label:(0,I.localize)(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(u,{location:g.ProgressLocation.from(D),title:h,source:_,cancellable:k},P),this._withProgress(u,m,!!k)}_withProgress(P,c,m){let u;m&&(u=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,u));const h=k=>{this._proxy.$progressEnd(k),this._mapHandleToCancellationSource.delete(k),u&&u.dispose()};let D;try{D=c(new T(this._proxy,P),m&&u?u.token:C.CancellationToken.None)}catch(k){throw h(P),k}return D.then(k=>h(P),k=>h(P)),D}$acceptProgressCanceled(P){const c=this._mapHandleToCancellationSource.get(P);c&&(c.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=E;function S(n,P){return n.message=P.message,typeof P.increment=="number"&&(typeof n.increment=="number"?n.increment+=P.increment:n.increment=P.increment),n}class T extends L.Progress{constructor(P,c){super(m=>this.throttledReport(m));this._proxy=P,this._handle=c}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}Ve([(0,R.throttle)(100,(n,P)=>S(n,P),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(me[130],ge([0,1,56,16,76,15,7]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class E{constructor(c,m,u){const h=E._Keys.nextId();c.$registerTextEditorDecorationType(m.identifier,h,C.DecorationRenderOptions.from(u)),this.value=Object.freeze({key:h,dispose(){c.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=E,E._Keys=new I.IdGenerator("TextEditorDecorationType");class S{constructor(c,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,m){this._throwIfFinalized();let u=null;if(c instanceof R.Position)u=new R.Range(c,c);else if(c instanceof R.Range)u=c;else throw new Error("Unrecognized location");this._pushEdit(u,m,!1)}insert(c,m){this._throwIfFinalized(),this._pushEdit(new R.Range(c,c),m,!0)}delete(c){this._throwIfFinalized();let m=null;if(c instanceof R.Range)m=c;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(c,m,u){const h=this._document.validateRange(c);this._collectedEdits.push({range:h,text:m,forceMoveMarkers:u})}setEndOfLine(c){if(this._throwIfFinalized(),c!==R.EndOfLine.LF&&c!==R.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=S;class T{constructor(c,m,u,h){this._proxy=c,this._id=m,this._accept(u),this._logService=h;const D=this;this.value={get tabSize(){return D._tabSize},set tabSize(k){D._setTabSize(k)},get insertSpaces(){return D._insertSpaces},set insertSpaces(k){D._setInsertSpaces(k)},get cursorStyle(){return D._cursorStyle},set cursorStyle(k){D._setCursorStyle(k)},get lineNumbers(){return D._lineNumbers},set lineNumbers(k){D._setLineNumbers(k)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const m=Math.floor(c);return m>0?m:null}if(typeof c=="string"){const m=parseInt(c,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(c){const m=this._validateTabSize(c);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const m=this._validateInsertSpaces(c);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(c)})))}assign(c){const m={};let u=!1;if(typeof c.tabSize!="undefined"){const h=this._validateTabSize(c.tabSize);h==="auto"?(u=!0,m.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,u=!0,m.tabSize=h)}if(typeof c.insertSpaces!="undefined"){const h=this._validateInsertSpaces(c.insertSpaces);h==="auto"?(u=!0,m.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,u=!0,m.insertSpaces=h)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,u=!0,m.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,u=!0,m.lineNumbers=C.TextEditorLineNumbersStyle.from(c.lineNumbers)),u&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(c){c.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=T;class n{constructor(c,m,u,h,D,k,_,o){this.id=c,this._proxy=m,this._logService=u,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=D,this._options=new T(this._proxy,this.id,k,u),this._visibleRanges=_,this._viewColumn=o;const a=this;this.value=Object.freeze({get document(){return h.getValue()},set document(p){throw(0,L.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(p){if(!(p instanceof R.Selection))throw(0,L.illegalArgument)("selection");a._selections=[p],a._trySetSelection()},get selections(){return a._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof R.Selection)))throw(0,L.illegalArgument)("selections");a._selections=p,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(p){throw(0,L.readonly)("visibleRanges")},get options(){return a._options.value},set options(p){a._disposed||a._options.assign(p)},get viewColumn(){return a._viewColumn},set viewColumn(p){throw(0,L.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new S(h.getValue(),t);return p(s),a._applyEdit(s)},insertSnippet(p,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=a._selections.map(i=>C.Range.from(i));else if(t instanceof R.Position){const{lineNumber:i,column:f}=C.Position.from(t);r=[{startLineNumber:i,startColumn:f,endLineNumber:i,endColumn:f}]}else if(t instanceof R.Range)r=[C.Range.from(t)];else{r=[];for(const i of t)if(i instanceof R.Range)r.push(C.Range.from(i));else{const{lineNumber:f,column:l}=C.Position.from(i);r.push({startLineNumber:f,startColumn:l,endLineNumber:f,endColumn:l})}}return m.$tryInsertSnippet(c,p.value,r,s)},setDecorations(p,t){const s=t.length===0;s&&!a._hasDecorationsForKey.has(p.key)||(s?a._hasDecorationsForKey.delete(p.key):a._hasDecorationsForKey.add(p.key),a._runOnProxy(()=>{if(C.isDecorationOptionsArr(t))return m.$trySetDecorations(c,p.key,C.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let i=0,f=t.length;i<f;i++){const l=t[i];r[4*i]=l.start.line+1,r[4*i+1]=l.start.character+1,r[4*i+2]=l.end.line+1,r[4*i+3]=l.end.character+1}return m.$trySetDecorationsFast(c,p.key,r)}}))},revealRange(p,t){a._runOnProxy(()=>m.$tryRevealRange(c,C.Range.from(p),t||R.TextEditorRevealType.Default))},show(p){m.$tryShowEditor(c,C.ViewColumn.from(p))},hide(){m.$tryHideEditor(c)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,g.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,g.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,g.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,g.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const m=c.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const u=m.edits.map(D=>D.range);u.sort((D,k)=>D.end.line===k.end.line?D.end.character===k.end.character?D.start.line===k.start.line?D.start.character-k.start.character:D.start.line-k.start.line:D.end.character-k.end.character:D.end.line-k.end.line);for(let D=0,k=u.length-1;D<k;D++){const _=u[D].end;if(u[D+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=m.edits.map(D=>({range:C.Range.from(D.range),text:D.text,forceMoveMarkers:D.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,h,{setEndOfLine:typeof m.setEndOfLine=="number"?C.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=n}),define(me[223],ge([0,1,169,22,2,3,6,210,18,7,13,17,15,21,207]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(_,o){if((0,n.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let a;return Array.isArray(_.highlights)&&(a=_.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),a=a.length?a:void 0),{label:_.label,highlights:a}}}class D{constructor(o,a,p){this._proxy=o,this.commands=a,this.logService=p,this.treeViews=new Map;function t(s){return s&&s.$treeViewId&&s.$treeItemHandle}a.registerArgumentProcessor({processArgument:s=>t(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(r=>t(r)?this.convertArgument(r):r):s})}registerTreeDataProvider(o,a,p){const t=this.createTreeView(o,{treeDataProvider:a},p);return{dispose:()=>t.dispose()}}createTreeView(o,a,p){if(!a||!a.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=a.dragAndDropController!==void 0,s=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!a.showCollapseAll,canSelectMany:!!a.canSelectMany,canDragAndDrop:t}),r=this.createExtHostTreeView(o,a,p);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(i){r.message=i},get title(){return r.title},set title(i){r.title=i},get description(){return r.description},set description(i){r.description=i},reveal:(i,f)=>r.reveal(i,f),dispose:async()=>{await s,this.treeViews.delete(o),r.dispose()}}}$getChildren(o,a){const p=this.treeViews.get(o);return p?p.getChildren(a):Promise.reject(new Error((0,g.localize)(0,null,o)))}async $onDrop(o,a,p){const t=this.treeViews.get(o);if(!t)return Promise.reject(new Error((0,g.localize)(1,null,o)));const s=u.TreeDataTransferConverter.toITreeDataTransfer(a);if(s.items.has(E.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await s.items.get(E.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(f=>t.getExtensionElement(f)).filter(f=>!!f);i.length>0?s.items.set(E.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):s.items.delete(E.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(s,p)}async $hasResolve(o){const a=this.treeViews.get(o);if(!a)throw new Error((0,g.localize)(2,null,o));return a.hasResolve}$resolve(o,a,p){const t=this.treeViews.get(o);if(!t)throw new Error((0,g.localize)(3,null,o));return t.resolveTreeItem(a,p)}$setExpanded(o,a,p){const t=this.treeViews.get(o);if(!t)throw new Error((0,g.localize)(4,null,o));t.setExpanded(a,p)}$setSelection(o,a){const p=this.treeViews.get(o);if(!p)throw new Error((0,g.localize)(5,null,o));p.setSelection(a)}$setVisible(o,a){const p=this.treeViews.get(o);if(!p)throw new Error((0,g.localize)(6,null,o));p.setVisible(a)}createExtHostTreeView(o,a,p){const t=new k(o,a,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(o,t),t}convertArgument(o){const a=this.treeViews.get(o.$treeViewId);return a?a.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=D;class k extends R.Disposable{constructor(o,a,p,t,s,r){super();if(this.viewId=o,this.proxy=p,this.commands=t,this.logService=s,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,r.contributes&&r.contributes.views)for(const l in r.contributes.views)for(const d of r.contributes.views[l])d.id===o&&(this._title=d.name);this.dataProvider=a.treeDataProvider,this.dndController=a.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(l=>this._onDidChangeData.fire({message:!1,element:l}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let i,f;this._register(C.Event.debounce(this._onDidChangeData.event,(l,d)=>(l||(l={message:!1,elements:[]}),d.element!==!1&&(i||(i=new Promise(b=>f=b),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(d.element)?l.elements.push(...d.element):l.elements.push(d.element)),d.message&&(l.message=!0),l),200,!0)(({message:l,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=f;return i=null,this.refresh(d).then(()=>b())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,n.isUndefinedOrNull)(o))}async getChildren(o){const a=o?this.getExtensionElement(o):void 0;if(o&&!a)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let p=this.getChildrenNodes(o);return p||(p=await this.fetchChildrenNodes(a)),p?p.map(t=>t.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,a){a=a||{select:!0,focus:!1};const p=(0,n.isUndefinedOrNull)(a.select)?!0:a.select,t=(0,n.isUndefinedOrNull)(a.focus)?!1:a.focus,s=(0,n.isUndefinedOrNull)(a.expand)?!1:a.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(r=>this.resolveTreeNode(o,r[r.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:r.map(f=>f.item)},{select:p,focus:t,expand:s})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:t,expand:s})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,a){const p=this.getExtensionElement(o);p&&(a?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(o){(0,P.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,a){const p=this.getExtensionElement(a);if(!!p)return(0,S.asPromise)(()=>this.dndController?.onDrop(o,p))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,a){if(!this.dataProvider.resolveTreeItem)return;const p=this.elements.get(o);if(p){const t=this.nodes.get(p);if(t){const s=await this.dataProvider.resolveTreeItem(t.extensionItem,p,a)??t.extensionItem;return t.item.tooltip=this.getTooltip(s.tooltip),t.item.command=this.getCommand(t.disposableStore,s.command),t.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(a=>a?this.resolveUnknownParentChain(a).then(p=>this.resolveTreeNode(a,p[p.length-1]).then(t=>(p.push(t),p))):Promise.resolve([]))}resolveParent(o){const a=this.nodes.get(o);return a?Promise.resolve(a.parent?this.elements.get(a.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,a){const p=this.nodes.get(o);return p?Promise.resolve(p):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(t=>this.createHandle(o,t,a,!0)).then(t=>this.getChildren(a?a.item.handle:void 0).then(()=>{const s=this.getExtensionElement(t);if(s){const r=this.nodes.get(s);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(o){if(o){let a;if(typeof o=="string"){const p=this.getExtensionElement(o);a=p?this.nodes.get(p):void 0}else a=o;return a&&a.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const a=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=o?this.nodes.get(o):void 0,t=await this.dataProvider.getChildren(o);if(a.token.isCancellationRequested)return;const s=await Promise.all((0,P.coalesce)(t||[]).map(async r=>{const i=await this.dataProvider.getTreeItem(r);return i&&!a.token.isCancellationRequested?this.createAndRegisterTreeNode(r,i,p):null}));return a.token.isCancellationRequested?void 0:(0,P.coalesce)(s)}finally{a.dispose()}}refresh(o){if(o.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(o);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const a=new Set,p=o.map(s=>this.nodes.get(s));for(const s of p)if(s&&!a.has(s.item.handle)){let r=s;for(;r&&r.parent&&p.findIndex(i=>r&&r.parent&&i&&i.item.handle===r.parent.item.handle)===-1;){const i=this.elements.get(r.parent.item.handle);r=i?this.nodes.get(i):void 0}r&&!r.parent&&a.add(s.item.handle)}const t=[];return a.forEach(s=>{const r=this.elements.get(s);if(r){const i=this.nodes.get(r);i&&(!i.parent||!a.has(i.parent.item.handle))&&t.push(s)}}),t}refreshHandles(o){const a={};return Promise.all(o.map(p=>this.refreshNode(p).then(t=>{t&&(a[p]=t.item)}))).then(()=>Object.keys(a).length?this.proxy.$refresh(this.viewId,a):void 0)}refreshNode(o){const a=this.getExtensionElement(o);if(a){const p=this.nodes.get(a);if(p)return this.clearChildren(a),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(t=>{if(t){const s=this.createTreeNode(a,t,p.parent);return this.updateNodeCache(a,s,p,p.parent),p.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,a,p){const t=this.createTreeNode(o,a,p);if(a.id&&this.elements.has(t.item.handle))throw new Error((0,g.localize)(7,null,a.id));return this.addNodeToCache(o,t),this.addNodeToParentCache(t,p),t}getTooltip(o){return T.MarkdownString.isMarkdownString(o)?c.MarkdownString.from(o):o}getCommand(o,a){return a?this.commands.toInternal(a,o):void 0}createTreeNode(o,a,p){const t=new R.DisposableStore,s=this.createHandle(o,a,p),r=this.getLightIconPath(a);return{item:{handle:s,parentHandle:p?p.item.handle:void 0,label:h(a.label,this.extension),description:a.description,resourceUri:a.resourceUri,tooltip:this.getTooltip(a.tooltip),command:this.getCommand(t,a.command),contextValue:a.contextValue,icon:r,iconDark:this.getDarkIconPath(a)||r,themeIcon:this.getThemeIcon(a),collapsibleState:(0,n.isUndefinedOrNull)(a.collapsibleState)?T.TreeItemCollapsibleState.None:a.collapsibleState,accessibilityInformation:a.accessibilityInformation},extensionItem:a,parent:p,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(o){return o.iconPath instanceof T.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:a,label:p,resourceUri:t},s,r){if(a)return`${k.ID_HANDLE_PREFIX}/${a}`;const i=h(p,this.extension),f=s?s.item.handle:k.LABEL_HANDLE_PREFIX;let l=i?i.label:t?(0,L.basename)(t):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const d=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,b=this.getChildrenNodes(s)||[];let y,v=0;do{if(y=`${f}/${v}:${l}`,r||!this.elements.has(y)||d===y)break;v++}while(v<=b.length);return y}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof T.ThemeIcon))return typeof o.iconPath=="string"||I.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof T.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return I.URI.isUri(o)?o:I.URI.file(o)}addNodeToCache(o,a){this.elements.set(a.item.handle,o),this.nodes.set(o,a)}updateNodeCache(o,a,p,t){this.elements.delete(a.item.handle),this.nodes.delete(o),a.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(o,a);const s=this.getChildrenNodes(t)||[],r=s.filter(i=>i.item.handle===p.item.handle)[0];r&&s.splice(s.indexOf(r),1,a)}addNodeToParentCache(o,a){a?(a.children||(a.children=[]),a.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const a=this.nodes.get(o);if(a){if(a.children)for(const p of a.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}a.children=void 0}}else this.clearAll()}clear(o){const a=this.nodes.get(o);if(a){if(a.children)for(const p of a.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}this.nodes.delete(o),this.elements.delete(a.item.handle),a.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}k.LABEL_HANDLE_PREFIX="0",k.ID_HANDLE_PREFIX="1"}),define(me[224],ge([0,1,18,3,6,13,64,15,127,89]),function(Y,e,g,L,I,C,R,E,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends I.Disposable{constructor(c){super();this.controllerId=c,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new R.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){const m=this.diff[this.diff.length-1];if(m&&c[0]===1){if(m[0]===1&&m[1].extId===c[1].extId){(0,S.applyTestItemUpdate)(m[1],c[1]);return}if(m[0]===0&&m[1].item.extId===c[1].extId){(0,S.applyTestItemUpdate)(m[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,m){const u=this.tree.get(c);if(!!u){if((u.expandLevels===void 0||m>u.expandLevels)&&(u.expandLevels=m),u.expand===1){const h=this.resolveChildren(u);return h.isOpen()?this.expandChildren(u,m-1):h.wait().then(()=>this.expandChildren(u,m-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.expandChildren(u,m-1)):this.expandChildren(u,m-1)}}dispose(){for(const c of this.tree.values())(0,R.getPrivateApiFor)(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,m){switch(m.op){case 2:this.pushDiff([4,c.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(c.fullId,m.id));break;case 0:this.upsertItem(m.item,c);break;case 4:for(const _ of m.ops)this.onTestItemEvent(c,_);break;case 3:const{key:u,value:h,previous:D}=m,k=c.fullId.toString();switch(u){case"canResolveChildren":this.updateExpandability(c);break;case"tags":this.diffTagRefs(h,D,k);break;case"range":this.pushDiff([1,{extId:k,item:{range:E.Range.from(h)}}]);break;case"error":this.pushDiff([1,{extId:k,item:{error:E.MarkdownString.fromStrict(h)||null}}]);break;default:this.pushDiff([1,{extId:k,item:{[u]:h??null}}]);break}break;default:(0,C.assertNever)(m)}}upsertItem(c,m){if(!(c instanceof R.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);const u=T.TestId.fromExtHostTestItem(c,this.root.id,m?.actual),h=(0,R.getPrivateApiFor)(c);h.parent&&h.parent!==m?.actual&&h.parent.children.delete(c.id);let D=this.tree.get(u.toString());if(!D){D={fullId:u,actual:c,parent:m?u.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},c.tags.forEach(this.incrementTagRefs,this),this.tree.set(D.fullId.toString(),D),this.setItemParent(c,m),this.pushDiff([0,{parent:D.parent&&D.parent.toString(),controllerId:this.controllerId,expand:D.expand,item:E.TestItem.from(c)}]),this.connectItemAndChildren(c,D,m);return}if(D.actual===c){this.connectItem(c,D,m);return}const k=D.actual.children,_=D.actual,o=(0,R.diffTestItems)(_,c);(0,R.getPrivateApiFor)(_).listener=void 0,D.actual=c,D.expand=0;for(const[a,p]of o)this.onTestItemEvent(D,{op:3,key:a,value:p,previous:_[a]});this.connectItemAndChildren(c,D,m);for(const a of k)c.children.get(a.id)||this.removeItem(T.TestId.joinToString(u,a.id))}diffTagRefs(c,m,u){const h=new Set(m.map(D=>D.id));for(const D of c)h.delete(D.id)||this.incrementTagRefs(D);this.pushDiff([1,{extId:u,item:{tags:c.map(D=>E.TestTag.namespace(this.controllerId,D.id))}}]),h.forEach(this.decrementTagRefs,this)}incrementTagRefs(c){const m=this.tags.get(c.id);m?m.refCount++:(this.tags.set(c.id,{refCount:1}),this.pushDiff([5,{id:E.TestTag.namespace(this.controllerId,c.id),ctrlLabel:this.root.label}]))}decrementTagRefs(c){const m=this.tags.get(c);m&&!--m.refCount&&(this.tags.delete(c),this.pushDiff([6,E.TestTag.namespace(this.controllerId,c)]))}setItemParent(c,m){(0,R.getPrivateApiFor)(c).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(c,m,u){this.setItemParent(c,u);const h=(0,R.getPrivateApiFor)(c);h.parent=u?.actual,h.listener=D=>this.onTestItemEvent(m,D),this.updateExpandability(m)}connectItemAndChildren(c,m,u){this.connectItem(c,m,u);for(const h of c.children)this.upsertItem(h,m)}updateExpandability(c){let m;this._resolveHandler?c.resolveBarrier?m=c.resolveBarrier.isOpen()?3:2:m=c.actual.canResolveChildren?1:0:m=0,m!==c.expand&&(c.expand=m,this.pushDiff([1,{extId:c.fullId.toString(),expand:m}]),m===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,m){if(m<0)return;const u=[];for(const h of c.actual.children){const D=this.expand(T.TestId.joinToString(c.fullId,h.id),m);(0,g.isThenable)(D)&&u.push(D)}if(u.length)return Promise.all(u).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const D=new g.Barrier;return D.open(),D}c.expand=2,this.pushExpandStateUpdate(c);const m=c.resolveBarrier=new g.Barrier,u=D=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),c.actual!==this.root&&(c.actual.error=D.stack||D.message||String(D))};let h;try{h=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(D){u(D)}return(0,g.isThenable)(h)?h.catch(u).then(()=>{m.open(),this.updateExpandability(c)}):(m.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.fullId.toString(),expand:c.expand}])}removeItem(c){const m=this.tree.get(c);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,c]);const u=[m];for(;u.length;){const h=u.pop();if(!!h){(0,R.getPrivateApiFor)(h.actual).listener=void 0;for(const D of h.actual.tags)this.decrementTagRefs(D.id);this.tree.delete(h.fullId.toString());for(const D of h.actual.children)u.push(this.tree.get(T.TestId.joinToString(h.fullId,D.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.SingleUseTestCollection=n}),define(me[225],ge([0,1,4,184]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(L.IEnvironmentService)}),define(me[226],ge([0,1,26,3,8]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=C;class R{constructor(n){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let P of n.activationEvents)P==="onUri"&&(P=`onUri:${g.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(n)}}keepOnly(n){const P=new Set;n.forEach(c=>P.add(g.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>P.has(g.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,P){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const c=R._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(c.map(m=>m.identifier)),P.length>0){const m=new Set;P.forEach(u=>m.add(g.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>!m.has(g.ExtensionIdentifier.toKey(u.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(c)}static _findLoopingExtensions(n){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(D){this._nodesSet.has(D)||(this._nodesSet.add(D),this._nodesArr.push(D))}addArc(D,k){this.addNode(D),this.addNode(k),this._arcs.has(D)?this._arcs.get(D).push(k):this._arcs.set(D,[k])}getArcs(D){return this._arcs.has(D)?this._arcs.get(D):[]}hasOnlyGoodArcs(D,k){const _=P.getArcs(D);for(let o=0;o<_.length;o++)if(!k.has(_[o]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let D of n){const k=g.ExtensionIdentifier.toKey(D.identifier);if(c.set(k,D),D.extensionDependencies)for(let _ of D.extensionDependencies){const o=g.ExtensionIdentifier.toKey(_);P.addArc(k,o)}}let m=new Set;P.getNodes().filter(D=>P.getArcs(D).length===0).forEach(D=>m.add(D));let u=P.getNodes().filter(D=>!m.has(D)),h;do{h=!1;for(let D=0;D<u.length;D++){const k=u[D];P.hasOnlyGoodArcs(k,m)&&(u.splice(D,1),D--,m.add(k),h=!0)}}while(h);return u.map(D=>c.get(D))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const P=this._activationMap.get(n);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const P=this._extensionsMap.get(g.ExtensionIdentifier.toKey(n));return P||void 0}}e.ExtensionDescriptionRegistry=R;var E;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(E||(E={}));function S(T,n){const P=T.isBuiltin?0:T.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(P!==c)return P-c;const m=I.posix.basename(T.extensionLocation.path),u=I.posix.basename(n.extensionLocation.path);return m<u?-1:m>u?1:0}}),define(me[227],ge([0,1,23]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var I;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(I=e.MessageType||(e.MessageType={}));function C(E){const S=g.VSBuffer.alloc(1);switch(E){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=C;function R(E,S){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=R}),define(me[35],ge([0,1,3,2,4,26,186]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");var E;(function(o){o[o.None=0]="None",o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(E=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class S{constructor(a){this.dependency=a}}e.MissingExtensionDependency=S;var T;(function(o){o[o.LocalProcess=0]="LocalProcess",o[o.LocalWebWorker=1]="LocalWebWorker",o[o.Remote=2]="Remote"})(T=e.ExtensionHostKind||(e.ExtensionHostKind={}));function n(o){switch(o){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=n;class P{constructor(a,p,t,s){this.codeLoadingTime=a,this.activateCallTime=p,this.activateResolvedTime=t,this.activationReason=s}}e.ActivationTimes=P;class c{constructor(a,p){this.description=a,this.value=p}}e.ExtensionPointContribution=c,e.ExtensionHostLogFileName="exthost";var m;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(m=e.ActivationKind||(e.ActivationKind={}));function u(o){o.enableProposedApi||h(o)}e.checkProposedApiEnabled=u;function h(o){throw new Error(`[${o.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.throwProposedApiError=h;function D(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,R.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation}}e.toExtension=D;function k(o,a){return{identifier:new C.ExtensionIdentifier(o.identifier.id),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!a,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid}}e.toExtensionDescription=k;class _{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(a){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(a,p){return Promise.resolve()}_onWillActivateExtension(a){}_onDidActivateExtension(a,p,t,s,r){}_onDidActivateExtensionError(a,p){}_onExtensionRuntimeError(a,p){}_onExtensionHostExit(a){}}e.NullExtensionService=_}),define(me[228],ge([0,1,26,35,12]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class R{constructor(u,h,D,k){this.startup=u,this.codeLoadingTime=h,this.activateCallTime=D,this.activateResolvedTime=k}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class E{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,h){return u===-1||h===-1?-1:h-u}build(){return new R(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class S{constructor(u,h,D,k,_,o){this.activationFailed=u,this.activationFailedError=h,this.activationTimes=D,this.module=k,this.exports=_,this.subscriptions=o}}e.ActivatedExtension=S;class T extends S{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class n extends S{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class P extends S{constructor(u){super(!0,u,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let c=class{constructor(u,h,D,k,_){this._logService=_,this._registry=u,this._resolvedExtensionsSet=new Set,h.forEach(o=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,D.forEach(o=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(o),o)),this._host=k,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(u){const h=g.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(h)}getActivatedExtension(u){const h=g.ExtensionIdentifier.toKey(u),D=this._activatedExtensions.get(h);if(!D)throw new Error("Extension `"+u.value+"` is not known or not activated");return D}activateByEvent(u,h){if(this._alreadyActivatedEvents[u])return C;const D=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(D.map(k=>({id:k.identifier,reason:{startup:h,extensionId:k.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,h){const D=this._registry.getExtensionDescription(u);if(!D)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:D.identifier,reason:h}])}_handleActivateRequest(u,h,D){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(u.id))){h[g.ExtensionIdentifier.toKey(u.id)]=u;return}const k=this._registry.getExtensionDescription(u.id);if(!k){const a=new Error(`Cannot activate unknown extension '${u.id.value}'`);this._host.onExtensionActivationError(u.id,a,new L.MissingExtensionDependency(u.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(u.id),new P(a));return}const _=typeof k.extensionDependencies=="undefined"?[]:k.extensionDependencies;let o=!0;for(let a=0,p=_.length;a<p;a++){const t=_[a];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const s=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const l=k.displayName||k.identifier.value,d=this._registry.getExtensionDescription(t),b=d&&d.displayName||t,y=new Error(`Cannot activate the '${l}' extension because its dependency '${b}' failed to activate`);y.detail=s.activationFailedError,this._host.onExtensionActivationError(k.identifier,y,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(k.identifier),new P(y));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){o=!1,h[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:u.reason};continue}const r=this._registry.getExtensionDescription(t);if(r){o=!1,h[g.ExtensionIdentifier.toKey(t)]={id:r.identifier,reason:u.reason};continue}const i=k.displayName||k.identifier.value,f=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(k.identifier,f,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(k.identifier),new P(f));return}o?h[g.ExtensionIdentifier.toKey(k.identifier)]=u:D.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(_=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(_.id))),u.length===0))return Promise.resolve(void 0);const h=Object.create(null),D=[];for(let _=0,o=u.length;_<o;_++)this._handleActivateRequest(u[_],h,D);for(let _=0,o=D.length;_<o;_++){const a=g.ExtensionIdentifier.toKey(D[_].id);h[a]&&delete h[a]}const k=Object.keys(h).map(_=>h[_]);return D.length===0?Promise.all(k.map(_=>this._activateExtension(_.id,_.reason))).then(_=>{}):this._activateExtensions(k).then(_=>this._activateExtensions(D))}_activateExtension(u,h){const D=g.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(D))return Promise.resolve(void 0);const k=this._activatingExtensions.get(D);if(k)return k;const _=this._host.actualActivateExtension(u,h).then(void 0,o=>{const a=new Error;return o&&o.name&&(a.name=o.name),o&&o.message?a.message=`Activating extension '${u.value}' failed: ${o.message}.`:a.message=`Activating extension '${u.value}' failed: ${o}.`,o&&o.stack&&(a.stack=o.stack),this._host.onExtensionActivationError(u,a,null),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(o),new P(o)}).then(o=>{this._activatedExtensions.set(D,o),this._activatingExtensions.delete(D)});return this._activatingExtensions.set(D,_),_}};c=Ve([$e(4,I.ILogService)],c),e.ExtensionsActivator=c}),define(me[229],ge([0,1,12,35,27,10,116]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let E=class extends g.LogService{constructor(T){if(T.logFile.scheme!==C.Schemas.file)throw new Error("Only file-logging supported");super(new R.SpdLogLogger(L.ExtensionHostLogFileName,T.logFile.fsPath,!0,T.logLevel))}$setLevel(T){this.setLevel(T)}};E=Ve([$e(0,I.IExtHostInitDataService)],E),e.ExtHostLogService=E}),define(me[230],ge([0,1,16]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,R)=>{this._actualOk=C,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,g.onUnexpectedError)(C))}then(C,R){return this._ensureActual().then(C,R)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=L}),define(me[66],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(T,n){this._proxyIdentifierBrand=void 0,this.isMain=T,this.sid=n,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const L=[];function I(S){const T=new g(!0,S);return L[T.nid]=T,T}e.createMainContextProxyIdentifier=I;function C(S){const T=new g(!1,S);return L[T.nid]=T,T}e.createExtHostContextProxyIdentifier=C;function R(S){return L[S].sid}e.getStringIdentifierForProxy=R;class E{constructor(T){this.value=T}}e.SerializableObjectWithBuffers=E}),define(me[5],ge([0,1,60,2,66]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var R;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var E;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(E=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(o){o.name="$ident";function a(t,s){return Object.defineProperty(t,o.name,{value:s,enumerable:!0}),t}o.mixin=a;function p(t){return t[o.name]}o.of=p})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(a){return a._id=m._n++,a}}e.IdObject=m,m._n=0;var u;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var D;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(D=e.WorkspaceEditType||(e.WorkspaceEditType={}));function k(o){if(o&&o.edits)for(const a of o.edits)typeof a.resource=="object"?a.resource=L.URI.revive(a.resource):(a.newUri=L.URI.revive(a.newUri),a.oldUri=L.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=(0,g.revive)(a.metadata));return o}e.reviveWorkspaceEditDto=k;var _;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[90],ge([0,1,5,3,4]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(E){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=E.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(E){this._onDidChangePassword.fire(E)}get(E,S){return this._proxy.$getPassword(E,S)}store(E,S,T){return this._proxy.$setPassword(E,S,T)}delete(E,S){return this._proxy.$deletePassword(E,S)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(me[67],ge([0,1,4,12,5,14]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(S,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(I.MainContext.MainThreadTelemetry)}report(S,T,n){const P=this.getUsageKey(S,T);this._reportedUsages.has(P)||(this._reportedUsages.add(P),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:S}))}getUsageKey(S,T){return`${S}-${T.identifier.value}`}};R=Ve([$e(0,C.IExtHostRpcService),$e(1,L.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(E,S,T){}})}),define(me[231],ge([0,1,3,5,7,26]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,T,n,P={}){const c=C.ExtensionIdentifier.toKey(S.identifier),m=this._inFlightRequests.get(c)||[],u=[...n].sort().join(" ");let h=m.find(D=>D.scopes===u);if(h)return h.result;{const D=this._getSession(S,c,T,n,P);h={scopes:u,result:D},m.push(h),this._inFlightRequests.set(c,m);try{await D}finally{const k=m.findIndex(_=>_.scopes===u);k>-1&&(m.splice(k),this._inFlightRequests.set(c,m))}return D}}async _getSession(S,T,n,P,c={}){await this._proxy.$ensureProvider(n);const m=S.displayName||S.name;return this._proxy.$getSession(n,P,T,m,c)}async removeSession(S,T){const n=this._authenticationProviders.get(S);return n?n.provider.removeSession(T):this._proxy.$removeSession(S,T)}registerAuthenticationProvider(S,T,n,P){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:T,provider:n,options:P??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===S)||this._providers.push({id:S,label:T});const c=n.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(S,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,T,P?.supportsMultipleAccounts??!1),new I.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(S);const m=this._providers.findIndex(u=>u.id===S);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,T){const n=this._authenticationProviders.get(S);if(n)return Promise.resolve(n.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,T){const n=this._authenticationProviders.get(S);if(n)return Promise.resolve(n.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,T){const n=this._authenticationProviders.get(S);if(n)return Promise.resolve(n.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,T){return this._onDidChangeSessions.fire({provider:{id:S,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(me[232],ge([0,1,5,14,15]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(E,S){this._extHostDocumentsAndEditors=S,this._proxy=E.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(E){const S=I.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(me[233],ge([0,1,5]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(C){const R=C.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(E){return R.$writeText(E)}})}}e.ExtHostClipboard=L}),define(me[44],ge([0,1,13,7,15,25,5,17,12,60,41,51,2,6,4,14,64]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let k=class{constructor(s,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=s.getProxy(R.MainContext.MainThreadCommands),this._logService=r,this.converter=new _(this,i=>{const f=this._apiCommands.get(i);return f?.result===a.Void?f:void 0},r),this._argumentProcessors=[{processArgument(i){return(0,T.revive)(i)}},{processArgument(i){return(0,C.cloneAndChange)(i,function(f){if(n.Range.isIRange(f))return I.Range.to(f);if(P.Position.isIPosition(f))return I.Position.to(f);if(n.Range.isIRange(f.range)&&c.URI.isUri(f.uri))return I.location.to(f);if(!Array.isArray(f))return f})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const r=this.registerCommand(!1,s.id,async(...i)=>{const f=s.args.map((d,b)=>{if(!d.validate(i[b]))throw new Error(`Invalid argument '${d.name}' when running '${s.id}', received: ${i[b]}`);return d.convert(i[b])}),l=await this.executeCommand(s.internalId,...f);return s.result.convert(l,i,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new L.Disposable(()=>{r.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,r,i,f,l){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:i,thisArg:f,description:l}),s&&this._proxy.$registerCommand(r),new L.Disposable(()=>{this._commands.delete(r)&&s&&this._proxy.$unregisterCommand(r)})}executeCommand(s,...r){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,r,!0)}async _doExecuteCommand(s,r,i){if(this._commands.has(s))return this._executeContributedCommand(s,r);{const f=(0,C.cloneAndChange)(r,function(l){if(l instanceof L.Position)return I.Position.from(l);if(l instanceof L.Range)return I.Range.from(l);if(l instanceof L.Location)return I.location.from(l);if(L.NotebookRange.isNotebookRange(l))return I.NotebookRange.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(s,f,i);return(0,T.revive)(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(s,r,!1);throw l}}}async _executeContributedCommand(s,r){const i=this._commands.get(s);if(!i)throw new Error("Unknown command");let{callback:f,thisArg:l,description:d}=i;if(d)for(let b=0;b<d.args.length;b++)try{(0,g.validateConstraint)(r[b],d.args[b].constraint)}catch(y){throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${d.args[b].name}' - ${d.args[b].description}`)}try{return await f.apply(l,r)}catch(b){if(s===this.converter.delegatingCommandId){const y=this.converter.getActualCommand(...r);y&&(s=y.command)}throw this._logService.error(b,s),new Error(`Running the contributed command: '${s}' failed.`)}}$executeContributedCommand(s,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(r=r.map(i=>this._argumentProcessors.reduce((f,l)=>l.processArgument(f),i)),this._executeContributedCommand(s,r)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),this._proxy.$getCommands().then(r=>(s&&(r=r.filter(i=>i[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(let[r,i]of this._commands){let{description:f}=i;f&&(s[r]=f)}return Promise.resolve(s)}};k=Ve([$e(0,h.IExtHostRpcService),$e(1,S.ILogService)],k),e.ExtHostCommands=k,e.IExtHostCommands=(0,u.createDecorator)("IExtHostCommands");class _{constructor(s,r,i){this._commands=s,this._lookupApiCommand=r,this._logService=i,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,r){if(!s)return;const i={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return i;const f=this._lookupApiCommand(s.command);if(f)i.id=f.internalId,i.arguments=f.args.map((l,d)=>l.convert(s.arguments&&s.arguments[d]));else if((0,E.isNonEmptyArray)(s.arguments)){const l=++this._cachIdPool;this._cache.set(l,s),r.add((0,m.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),i.$ident=l,i.id=this.delegatingCommandId,i.arguments=[l],this._logService.trace("CommandsConverter#CREATE",s.command,l)}return i}fromInternal(s){const r=R.ObjectIdentifier.of(s);return typeof r=="number"?this._cache.get(r):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const r=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=_;class o{constructor(s,r,i,f){this.name=s,this.description=r,this.validate=i,this.convert=f}optional(){return new o(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,r){return new o(s??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=o,o.Uri=new o("uri","Uri of a text document",t=>c.URI.isUri(t),t=>t),o.Position=new o("position","A position in a text document",t=>L.Position.isPosition(t),I.Position.from),o.Range=new o("range","A range in a text document",t=>L.Range.isRange(t),I.Range.from),o.Selection=new o("selection","A selection in a text document",t=>L.Selection.isSelection(t),I.Selection.from),o.Number=new o("number","",t=>typeof t=="number",t=>t),o.String=new o("string","",t=>typeof t=="string",t=>t),o.CallHierarchyItem=new o("item","A call hierarchy item",t=>t instanceof L.CallHierarchyItem,I.CallHierarchyItem.from),o.TypeHierarchyItem=new o("item","A type hierarchy item",t=>t instanceof L.TypeHierarchyItem,I.TypeHierarchyItem.from),o.TestItem=new o("testItem","A VS Code TestItem",t=>t instanceof D.TestItemImpl,I.TestItem.from);class a{constructor(s,r){this.description=s,this.convert=r}}e.ApiCommandResult=a,a.Void=new a("no result",t=>t);class p{constructor(s,r,i,f,l){this.id=s,this.internalId=r,this.description=i,this.args=f,this.result=l}}e.ApiCommand=p}),define(me[234],ge([0,1,15,7,83,44,17,111]),function(Y,e,g,L,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(g.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,m)=>{if((0,R.isFalsyOrEmpty)(c))return;class u extends L.SymbolInformation{static to(D){const k=new u(D.name,g.SymbolKind.to(D.kind),D.containerName||"",new L.Location(m[0],g.Range.to(D.range)));return k.detail=D.detail,k.range=k.location.range,k.selectionRange=g.Range.to(D.selectionRange),k.children=D.children?D.children.map(u.to):[],k}}return c.map(u.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(g.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(g.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(m=>L.Position.isPosition(m)),c=>c.map(g.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(m=>{let u;for(const h of m.reverse())u=new L.SelectionRange(g.Range.to(h),u);return u}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>{const m=[];if(Array.isArray(c))for(let u of c)m.push(...u[1].map(g.WorkspaceSymbol.to));return m})),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return g.WorkspaceEdit.to(c)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(g.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,E.decodeSemanticTokensDto)(c);if(m.type==="full")return new L.SemanticTokens(m.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,E.decodeSemanticTokensDto)(c);if(m.type==="full")return new L.SemanticTokens(m.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,m,u)=>{if(!c)return new L.CompletionList([]);const h=c.suggestions.map(D=>g.CompletionItem.to(D,u));return new L.CompletionList(h,c.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return g.SignatureHelp.to(c)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,m,u)=>n(h=>new L.CodeLens(g.Range.to(h.range),h.command&&u.fromInternal(h.command)))(c))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>L.Range.isRange(c),c=>L.Selection.isSelection(c)?g.Selection.from(c):g.Range.from(c)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,m,u)=>n(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(h.command)}else{const D=new L.CodeAction(h.title,h.kind?new L.CodeActionKind(h.kind):void 0);return h.edit&&(D.edit=g.WorkspaceEdit.to(h.edit)),h.command&&(D.command=u.fromInternal(h.command)),D.isPreferred=h.isPreferred,D}})(c))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(m=>new L.ColorInformation(g.Range.to(m.range),g.Color.to(m.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",c=>c instanceof L.Color,g.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:g.Range.from(c.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(g.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",c=>c.map(g.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(m=>g.NotebookExclusiveDocumentPattern.to(m))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(g.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class T{static register(m){S.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=T;function n(c){return m=>{if(Array.isArray(m))return m.map(c)}}function P(c){if(!Array.isArray(c))return;const m=[];for(const u of c)I.isLocationLink(u)?m.push(g.DefinitionLink.to(u)):m.push(g.location.to(u));return m}}),define(me[235],ge([0,1,18,58,3,6,2,83,26,15,7,5]),function(Y,e,g,L,I,C,R,E,S,T,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(m,u,h){const D=m.getProxy(P.MainContext.MainThreadComments);class k{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,u.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const f=this._commentControllers.get(i.handle);return f||i}else if(i&&i.$mid===7){const f=this._commentControllers.get(i.commentControlHandle);if(!f)return i;const l=f.getCommentThread(i.commentThreadHandle);return l||i}else if(i&&i.$mid===8){const f=this._commentControllers.get(i.thread.commentControlHandle);if(!f)return i;const l=f.getCommentThread(i.thread.commentThreadHandle);return l?{thread:l,text:i.text}:i}else if(i&&i.$mid===9){const f=this._commentControllers.get(i.thread.commentControlHandle);if(!f)return i;const l=f.getCommentThread(i.thread.commentThreadHandle);if(!l)return i;let d=i.commentUniqueId,b=l.getCommentByUniqueId(d);return b||i}else if(i&&i.$mid===10){const f=this._commentControllers.get(i.thread.commentControlHandle);if(!f)return i;const l=f.getCommentThread(i.thread.commentThreadHandle);if(!l)return i;let d=i.text,b=i.commentUniqueId,y=l.getCommentByUniqueId(b);return y?(y.body=d,y):i}return i}})}createCommentController(i,f,l){const d=k.handlePool++,b=new o(i,d,f,l);this._commentControllers.set(b.handle,b);const y=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(i.identifier))||[];return y.push(b),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(i.identifier),y),b.value}$createCommentThreadTemplate(i,f,l){const d=this._commentControllers.get(i);!d||d.$createCommentThreadTemplate(f,l)}async $updateCommentThreadTemplate(i,f,l){const d=this._commentControllers.get(i);!d||d.$updateCommentThreadTemplate(f,l)}$deleteCommentThread(i,f){const l=this._commentControllers.get(i);l&&l.$deleteCommentThread(f)}$provideCommentingRanges(i,f,l){const d=this._commentControllers.get(i);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const b=h.getDocument(R.URI.revive(f));return(0,g.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(b,l)).then(y=>y?y.map(v=>T.Range.from(v)):void 0)}$toggleReaction(i,f,l,d,b){const y=this._commentControllers.get(i);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const v=y.getCommentThread(f);if(v){const A=v.getCommentByUniqueId(d.uniqueIdInThread);if(y!==void 0&&A&&y.reactionHandler)return y.reactionHandler(A,t(b))}return Promise.resolve(void 0)})}dispose(){}}k.handlePool=0;class _{constructor(i,f,l,d,b,y,v){this._commentControllerHandle=f,this._id=l,this._uri=d,this._range=b,this._comments=y,this.handle=_._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),D.$createCommentThread(f,this.handle,this._id,this._uri,T.Range.from(this._range),v),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this._localDisposables.push({dispose:()=>{D.$deleteCommentThread(f,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(w){A.range=w},get comments(){return A.comments},set comments(w){A.comments=w},get collapsibleState(){return A.collapsibleState},set collapsibleState(w){A.collapsibleState=w},get canReply(){return A.canReply},set canReply(w){A.canReply=w},get contextValue(){return A.contextValue},set contextValue(w){A.contextValue=w},get label(){return A.label},set label(w){A.label=w},dispose:()=>{A.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const i=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),f={};i("range")&&(f.range=T.Range.from(this._range)),i("label")&&(f.label=this.label),i("contextValue")&&(f.contextValue=this.contextValue),i("comments")&&(f.comments=this._comments.map(l=>a(this,l,this._commentsMap))),i("collapsibleState")&&(f.collapseState=s(this._collapseState)),i("canReply")&&(f.canReply=this.canReply),this.modifications={},D.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,f)}getCommentByUniqueId(i){for(let f of this._commentsMap){let l=f[0],d=f[1];if(i===d)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}_._handlePool=0,Ve([(0,L.debounce)(100)],_.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(i,f,l,d){this._extension=i,this._handle=f,this._id=l,this._label=d,this._threads=new Map,D.$registerCommentController(this.handle,l,d);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(y){b.options=y},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(y){b.commentingRangeProvider=y},get reactionHandler(){return b.reactionHandler},set reactionHandler(y){b.reactionHandler=y},createCommentThread(y,v,A){return b.createCommentThread(y,v,A).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{D.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,D.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,D.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,f,l,d){if(typeof i=="string"){const b=new _(this.id,this.handle,i,f,l,d,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new _(this.id,this.handle,void 0,i,f,l,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(i,f){const l=new _(this.id,this.handle,void 0,R.URI.revive(i),T.Range.to(f),[],this._extension.identifier);return l.collapsibleState=E.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(i,f){let l=this._threads.get(i);l&&(l.range=T.Range.to(f))}$deleteCommentThread(i){let f=this._threads.get(i);f&&f.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function a(r,i,f){let l=f.get(i);l||(l=++r.commentHandle,f.set(i,l));const d=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:l,body:T.MarkdownString.from(i.body),userName:i.author.name,userIconPath:d,label:i.label,commentReactions:i.reactions?i.reactions.map(b=>p(b)):void 0}}function p(r){return{label:r.label,iconPath:r.iconPath?T.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function t(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?R.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function s(r){if(r!==void 0)switch(r){case n.CommentThreadCollapsibleState.Expanded:return E.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return E.CommentThreadCollapsibleState.Collapsed}return E.CommentThreadCollapsibleState.Collapsed}return new k}e.createExtHostComments=c}),define(me[131],ge([0,1,2,5,7,4,14,12,17,9,8]),function(Y,e,g,L,I,C,R,E,S,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class wn{constructor(m,u){this._logService=u,this._provider=new Map,this._proxy=m.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,u){const h=wn._handlePool++;this._provider.set(h,{provider:m,extensionId:u}),this._proxy.$registerDecorationProvider(h,u.value);const D=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(k=>{if(!k){this._proxy.$onDidChange(h,null);return}let _=(0,S.asArray)(k);if(_.length<=wn._maxEventSize){this._proxy.$onDidChange(h,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",u.value,_.length);const o=_.map(t=>({uri:t,rank:(0,T.count)(t.path,"/")})),a=(0,S.groupBy)(o,(t,s)=>t.rank-s.rank||(0,T.compare)(t.uri.path,s.uri.path));let p=[];e:for(let t of a){let s;for(let r of t){let i=(0,n.dirname)(r.uri.path);if(s!==i&&(s=i,p.push(r.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(h,p)});return new I.Disposable(()=>{D?.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(m,u,h){if(!this._provider.has(m))return Object.create(null);const D=Object.create(null),{provider:k,extensionId:_}=this._provider.get(m);return await Promise.all(u.map(async o=>{try{const{uri:a,id:p}=o,t=await Promise.resolve(k.provideFileDecoration(g.URI.revive(a),h));if(!t)return;try{I.FileDecoration.validate(t),D[p]=[t.propagate,t.tooltip,t.badge,t.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${_.value}': ${s}`)}}catch(a){this._logService.error(a)}})),D}};P._handlePool=0,P._maxEventSize=250,P=Ve([$e(0,R.IExtHostRpcService),$e(1,E.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[236],ge([0,1,164,117,2,5,7,15,3,12,24,52,141]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c){"use strict";var m,u,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class D{constructor(o,a,p,t,s,r){this._name=o,this._owner=a,this._maxDiagnosticsPerFile=p,m.set(this,void 0),u.set(this,void 0),h.set(this,void 0),this._isDisposed=!1,nt(this,h,new c.SkipList((i,f)=>t.compare(i,f)),"f"),nt(this,m,s,"f"),nt(this,u,r,"f")}dispose(){this._isDisposed||(Oe(this,u,"f").fire([...Oe(this,h,"f").keys()]),Oe(this,m,"f")&&Oe(this,m,"f").$clear(this._owner),Oe(this,h,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,a){if(!o){this.clear();return}this._checkDisposed();let p=[];if(I.URI.isUri(o)){if(!a){this.delete(o);return}Oe(this,h,"f").set(o,a.slice()),p=[o]}else if(Array.isArray(o)){p=[];let s;o=[...o].sort(D._compareIndexedTuplesByUri);for(const r of o){const[i,f]=r;if((!s||i.toString()!==s.toString())&&(s&&Oe(this,h,"f").get(s).length===0&&Oe(this,h,"f").delete(s),s=i,p.push(i),Oe(this,h,"f").set(i,[])),f){const l=Oe(this,h,"f").get(i);l&&l.push(...f)}else{const l=Oe(this,h,"f").get(i);l&&(l.length=0)}}}if(Oe(this,u,"f").fire(p),!Oe(this,m,"f"))return;const t=[];for(let s of p){let r=[];const i=Oe(this,h,"f").get(s);if(i)if(i.length>this._maxDiagnosticsPerFile){r=[];const f=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(let d of i)if(d.severity===f[l]&&r.push(E.Diagnostic.from(d))===this._maxDiagnosticsPerFile)break e;r.push({severity:L.MarkerSeverity.Info,message:(0,g.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=i.map(f=>E.Diagnostic.from(f));t.push([s,r])}Oe(this,m,"f").$changeMany(this._owner,t)}delete(o){this._checkDisposed(),Oe(this,u,"f").fire([o]),Oe(this,h,"f").delete(o),Oe(this,m,"f")&&Oe(this,m,"f").$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),Oe(this,u,"f").fire([...Oe(this,h,"f").keys()]),Oe(this,h,"f").clear(),Oe(this,m,"f")&&Oe(this,m,"f").$clear(this._owner)}forEach(o,a){this._checkDisposed();for(let p of Oe(this,h,"f").keys())o.apply(a,[p,this.get(p),this])}get(o){this._checkDisposed();const a=Oe(this,h,"f").get(o);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(Oe(this,h,"f").get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,a){return o[0].toString()<a[0].toString()?-1:o[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=D,m=new WeakMap,u=new WeakMap,h=new WeakMap;let k=class Jt{constructor(o,a,p){this._logService=a,this._fileSystemInfoService=p,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,Jt._mapper),this._proxy=o.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(o){const a=new n.ResourceMap;for(const p of o)a.set(p,p);return{uris:Object.freeze(Array.from(a.values()))}}createDiagnosticCollection(o,a){const{_collections:p,_proxy:t,_onDidChangeDiagnostics:s,_logService:r,_fileSystemInfoService:i}=this,f=new class{$changeMany(b,y){t.$changeMany(b,y),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,b,y.length===0?"CLEARING":y)}$clear(b){t.$clear(b),r.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,b)}dispose(){t.dispose()}};let l;if(!a)a="_generated_diagnostic_collection_name_#"+Jt._idPool++,l=a;else if(!p.has(a))l=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do l=a+Jt._idPool++;while(p.has(l))}return new class extends D{constructor(){super(a,l,Jt._maxDiagnosticsPerFile,i.extUri,f,s);p.set(l,this)}dispose(){super.dispose(),p.delete(l)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const a=new Map,p=[];for(const t of this._collections.values())t.forEach((s,r)=>{let i=a.get(s.toString());typeof i=="undefined"&&(i=p.length,a.set(s.toString(),i),p.push([s,[]])),p[i][1]=p[i][1].concat(...r)});return p}}_getDiagnostics(o){let a=[];for(let p of this._collections.values())p.has(o)&&(a=a.concat(p.get(o)));return a}$acceptMarkersChange(o){if(!this._mirrorCollection){const a="_generated_mirror",p=new D(a,a,Jt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(a,p),this._mirrorCollection=p}for(const[a,p]of o)this._mirrorCollection.set(I.URI.revive(a),p.map(E.Diagnostic.to))}};k._idPool=0,k._maxDiagnosticsPerFile=1e3,k=Ve([$e(1,T.ILogService),$e(2,P.IExtHostFileSystemInfo)],k),e.ExtHostDiagnostics=k}),define(me[237],ge([0,1,2,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(R){this._proxy=R.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(R){return this._proxy.$showOpenDialog(R).then(E=>E?E.map(S=>g.URI.revive(S)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(E=>E?g.URI.revive(E):void 0)}}e.ExtHostDialogs=I}),define(me[238],ge([0,1,16,2,7,5,10,21,9]),function(Y,e,g,L,I,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(P,c,m){this._documentsAndEditors=c,this._logService=m,this._documentContentProviders=new Map,this._proxy=P.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,c){if(Object.keys(R.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const m=T._handlePool++;this._documentContentProviders.set(m,c),this._proxy.$registerTextContentProvider(m,P);let u;return typeof c.onDidChange=="function"&&(u=c.onDidChange(h=>{if(h.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(m,h).then(D=>{if(!D&&typeof D!="string")return;const k=this._documentsAndEditors.getDocument(h);if(!k)return;const _=(0,S.splitLines)(D);if(!k.equalLines(_))return this._proxy.$onVirtualDocumentChange(h,D)},g.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),u&&(u.dispose(),u=void 0)})}$provideTextDocumentContent(P,c){const m=this._documentContentProviders.get(P);return m?Promise.resolve(m.provideTextDocumentContent(L.URI.revive(c),E.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(me[239],ge([0,1,3,6,2,5,123,15,13,25,7]),function(Y,e,g,L,I,C,R,E,S,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(m,u){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=u,this._documentsAndEditors.onDidRemoveDocuments(h=>{for(const D of h)this._onDidRemoveDocument.fire(D.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(h=>{for(const D of h)this._onDidAddDocument.fire(D.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const u=this._documentsAndEditors.getDocument(m);if(u)return u}getDocument(m){const u=this.getDocumentData(m);if(!u?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return u.document}ensureDocumentData(m){const u=this._documentsAndEditors.getDocument(m);if(u)return Promise.resolve(u);let h=this._documentLoader.get(m.toString());return h||(h=this._proxy.$tryOpenDocument(m).then(D=>{this._documentLoader.delete(m.toString());const k=I.URI.revive(D);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(k))},D=>(this._documentLoader.delete(m.toString()),Promise.reject(D))),this._documentLoader.set(m.toString(),h)),h}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(u=>I.URI.revive(u))}$acceptModelModeChanged(m,u){const h=I.URI.revive(m),D=this._documentsAndEditors.getDocument(h);if(!D)throw new Error("unknown document");this._onDidRemoveDocument.fire(D.document),D._acceptLanguageId(u),this._onDidAddDocument.fire(D.document)}$acceptModelSaved(m){const u=I.URI.revive(m),h=this._documentsAndEditors.getDocument(u);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(h.document)}$acceptDirtyStateChanged(m,u){const h=I.URI.revive(m),D=this._documentsAndEditors.getDocument(h);if(!D)throw new Error("unknown document");D._acceptIsDirty(u),this._onDidChangeDocument.fire({document:D.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,u,h){const D=I.URI.revive(m),k=this._documentsAndEditors.getDocument(D);if(!k)throw new Error("unknown document");k._acceptIsDirty(h),k.onEvents(u);let _;u.isUndoing?_=n.TextDocumentChangeReason.Undo:u.isRedoing&&(_=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:k.document,contentChanges:u.changes.map(o=>({range:E.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:_}))}setWordDefinitionFor(m,u){(0,R.setWordDefinitionFor)(m,u)}}e.ExtHostDocuments=P}),define(me[45],ge([0,1,56,3,6,2,4,5,123,14,130,15,12,24,10,94,139]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class k{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(a,p){this._extHostRpc=a,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const p=[],t=[],s=[];if(a.removedDocuments)for(const r of a.removedDocuments){const i=C.URI.revive(r),f=this._documents.get(i);f?.unref()&&(this._documents.delete(i),p.push(f.value))}if(a.addedDocuments)for(const r of a.addedDocuments){const i=C.URI.revive(r.uri);let f=this._documents.get(i);if(f&&i.scheme!==u.Schemas.vscodeNotebookCell&&i.scheme!==u.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);f||(f=new k(new S.ExtHostDocumentData(this._extHostRpc.getProxy(E.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(i,f),t.push(f.value)),f.ref()}if(a.removedEditors)for(const r of a.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&s.push(i)}if(a.addedEditors)for(const r of a.addedEditors){const i=C.URI.revive(r.documentUri);g.ok(this._documents.has(i),`document '${i}' does not exist`),g.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const f=this._documents.get(i).value,l=new n.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(E.MainContext.MainThreadTextEditors),this._logService,new D.Lazy(()=>f.document),r.selections.map(P.Selection.to),r.options,r.visibleRanges.map(d=>P.Range.to(d)),typeof r.editorPosition=="number"?P.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,l)}a.newActiveEditor!==void 0&&(g.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,I.dispose)(p),(0,I.dispose)(s),a.removedDocuments&&this._onDidRemoveDocuments.fire(p),a.addedDocuments&&this._onDidAddDocuments.fire(t),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return h.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return a?p:p?.value}allEditors(){return[...this._editors.values()]}};_=Ve([$e(0,T.IExtHostRpcService),$e(1,c.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[240],ge([0,1,2,5,6,7,15,148,9,23]),function(Y,e,g,L,I,C,R,E,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const u=this._schemes.indexOf(m);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),u=[];let h,D,k=14,_=14;for(const o of m){let a=h?(0,S.commonPrefixLength)(h,o):0;for(a===0?D=1:D=_;a<o.length;a++)a+1===o.length?(k=_,_=9):_+=1,u.push([D,o.toUpperCase().charCodeAt(a),_]),u.push([D,o.toLowerCase().charCodeAt(a),_]),D=_;h=o,_=k}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new E.StateMachine(u)}}provideDocumentLinks(m){this._initStateMachine();const u=[],h=E.LinkComputer.computeLinks({getLineContent(D){return m.lineAt(D-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const D of h){const k=R.DocumentLink.to(D);k.target&&u.push(k)}return u}}class P{constructor(m,u){this._extHostLanguageFeatures=u,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,u,h,D={}){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const k=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(k,h);let _=2;D.isCaseSensitive&&(_+=1024),D.isReadonly&&(_+=2048),typeof h.copy=="function"&&(_+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&(_+=4),this._proxy.$registerFileSystemProvider(k,u,_).catch(a=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${u}`),console.error(a)});const o=h.onDidChangeFile(a=>{const p=[];for(const t of a){let{uri:s,type:r}=t;if(s.scheme!==u)continue;let i;switch(r){case C.FileChangeType.Changed:i=0;break;case C.FileChangeType.Created:i=1;break;case C.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}p.push({resource:s,type:i})}this._proxy.$onFileSystemChange(k,p)});return(0,I.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(k),this._proxy.$unregisterProvider(k)})}static _asIStat(m){const{type:u,ctime:h,mtime:D,size:k,permissions:_}=m;return{type:u,ctime:h,mtime:D,size:k,permissions:_}}$stat(m,u){return Promise.resolve(this._getFsProvider(m).stat(g.URI.revive(u))).then(h=>P._asIStat(h))}$readdir(m,u){return Promise.resolve(this._getFsProvider(m).readDirectory(g.URI.revive(u)))}$readFile(m,u){return Promise.resolve(this._getFsProvider(m).readFile(g.URI.revive(u))).then(h=>T.VSBuffer.wrap(h))}$writeFile(m,u,h,D){return Promise.resolve(this._getFsProvider(m).writeFile(g.URI.revive(u),h.buffer,D))}$delete(m,u,h){return Promise.resolve(this._getFsProvider(m).delete(g.URI.revive(u),h))}$rename(m,u,h,D){return Promise.resolve(this._getFsProvider(m).rename(g.URI.revive(u),g.URI.revive(h),D))}$copy(m,u,h,D){const k=this._getFsProvider(m);if(!k.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(k.copy(g.URI.revive(u),g.URI.revive(h),D))}$mkdir(m,u){return Promise.resolve(this._getFsProvider(m).createDirectory(g.URI.revive(u)))}$watch(m,u,h,D){const k=this._getFsProvider(m).watch(g.URI.revive(h),D);this._watches.set(u,k)}$unwatch(m,u){const h=this._watches.get(u);h&&(h.dispose(),this._watches.delete(u))}$open(m,u,h){const D=this._getFsProvider(m);if(!D.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(D.open(g.URI.revive(u),h))}$close(m,u){const h=this._getFsProvider(m);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(u))}$read(m,u,h,D){const k=this._getFsProvider(m);if(!k.read)throw new Error('FileSystemProvider does not implement "read"');const _=T.VSBuffer.alloc(D);return Promise.resolve(k.read(u,h,_.buffer,0,D)).then(o=>_.slice(0,o))}$write(m,u,h,D){const k=this._getFsProvider(m);if(!k.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(k.write(u,h,D.buffer,0,D.byteLength))}_getFsProvider(m){const u=this._fsProvider.get(m);if(!u){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return u}}e.ExtHostFileSystem=P}),define(me[91],ge([0,1,5,42,7,23,4,14,52]),function(Y,e,g,L,I,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=class xt{constructor(P,c){const m=P.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(u){return m.$stat(u).catch(xt._handleError)},readDirectory(u){return m.$readdir(u).catch(xt._handleError)},createDirectory(u){return m.$mkdir(u).catch(xt._handleError)},async readFile(u){return m.$readFile(u).then(h=>h.buffer).catch(xt._handleError)},writeFile(u,h){return m.$writeFile(u,C.VSBuffer.wrap(h)).catch(xt._handleError)},delete(u,h){return m.$delete(u,{recursive:!1,useTrash:!1,...h}).catch(xt._handleError)},rename(u,h,D){return m.$rename(u,h,{overwrite:!1,...D}).catch(xt._handleError)},copy(u,h,D){return m.$copy(u,h,{overwrite:!1,...D}).catch(xt._handleError)},isWritableFileSystem(u){const h=c.getCapabilities(u);if(typeof h=="number")return!(h&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new I.FileSystemError(String(P));if(P.name==="ENOPRO")throw I.FileSystemError.Unavailable(P.message);switch(P.name){case L.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(P.message);case L.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(P.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(P.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(P.message);case L.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(P.message);case L.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(P.message);default:throw new I.FileSystemError(P.message,P.name)}}};T=Ve([$e(0,E.IExtHostRpcService),$e(1,S.IExtHostFileSystemInfo)],T),e.ExtHostConsumerFileSystem=T,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(me[241],ge([0,1,2,44]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(R,E,S,T){this._extHostNotebooks=E,this._textDocumentsAndEditors=S,this._commands=T;const n=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",P=>!0,P=>P),new L.ApiCommandArgument("resource","Interactive resource Uri",P=>!0,P=>P),new L.ApiCommandArgument("controllerId","Notebook controller Id",P=>!0,P=>P),new L.ApiCommandArgument("title","Interactive editor title",P=>!0,P=>P)],new L.ApiCommandResult("Notebook and input URI",P=>{if(P.notebookEditorId!==void 0){const c=this._extHostNotebooks.getEditorById(P.notebookEditorId);return{notebookUri:g.URI.revive(P.notebookUri),inputUri:g.URI.revive(P.inputUri),notebookEditor:c.apiEditor}}return{notebookUri:g.URI.revive(P.notebookUri),inputUri:g.URI.revive(P.inputUri)}}));this._commands.registerApiCommand(n)}$willAddInteractiveDocument(R,E,S,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:E,lines:[""],modeId:S,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,E){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=I}),define(me[242],ge([0,1,6,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(R){this._handlePool=0,this._proxy=R.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const E=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(E,R),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(E)})}}e.ExtHostLabelService=I}),define(me[243],ge([0,1,2,25,15,7,5,9,41,17,13,145,6,111,76,87,46,16,3]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentSymbols(V,ee){const re=this._documents.getDocument(V),ae=await this._provider.provideDocumentSymbols(re,ee);if(!(0,T.isFalsyOrEmpty)(ae))return ae[0]instanceof C.DocumentSymbol?ae.map(I.DocumentSymbol.from):o._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(V){V=V.slice(0).sort((ae,J)=>{let oe=ae.location.range.start.compareTo(J.location.range.start);return oe===0&&(oe=J.location.range.end.compareTo(ae.location.range.end)),oe});const ee=[],re=[];for(const ae of V){const J={name:ae.name||"!!MISSING: name!!",kind:I.SymbolKind.from(ae.kind),tags:ae.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:I.Range.from(ae.location.range),selectionRange:I.Range.from(ae.location.range),children:[]};for(;;){if(re.length===0){re.push(J),ee.push(J);break}const oe=re[re.length-1];if(S.Range.containsRange(oe.range,J.range)&&!S.Range.equalsRange(oe.range,J.range)){oe.children&&oe.children.push(J),re.push(J);break}re.pop()}}return ee}}class a{constructor(V,ee,re){this._documents=V,this._commands=ee,this._provider=re,this._cache=new h.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(V,ee){const re=this._documents.getDocument(V),ae=await this._provider.provideCodeLenses(re,ee);if(!ae||ee.isCancellationRequested)return;const J=this._cache.add(ae),oe=new c.DisposableStore;this._disposables.set(J,oe);const ve={cacheId:J,lenses:[]};for(let Me=0;Me<ae.length;Me++)ve.lenses.push({cacheId:[J,Me],range:I.Range.from(ae[Me].range),command:this._commands.toInternal(ae[Me].command,oe)});return ve}async resolveCodeLens(V,ee){const re=V.cacheId&&this._cache.get(...V.cacheId);if(!re)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?ae=re:ae=await this._provider.resolveCodeLens(re,ee),ae||(ae=re),ee.isCancellationRequested)return;const J=V.cacheId&&this._disposables.get(V.cacheId[0]);if(!!J)return V.command=this._commands.toInternal(ae.command??a._badCmd,J),V}releaseCodeLenses(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}}a._badCmd={command:"missing",title:"!!MISSING: command!!"};function p(je){return Array.isArray(je)?je.map(I.DefinitionLink.from):je?[I.DefinitionLink.from(je)]:[]}class t{constructor(V,ee){this._documents=V,this._provider=ee}async provideDefinition(V,ee,re){const ae=this._documents.getDocument(V),J=I.Position.to(ee),oe=await this._provider.provideDefinition(ae,J,re);return p(oe)}}class s{constructor(V,ee){this._documents=V,this._provider=ee}async provideDeclaration(V,ee,re){const ae=this._documents.getDocument(V),J=I.Position.to(ee),oe=await this._provider.provideDeclaration(ae,J,re);return p(oe)}}class r{constructor(V,ee){this._documents=V,this._provider=ee}async provideImplementation(V,ee,re){const ae=this._documents.getDocument(V),J=I.Position.to(ee),oe=await this._provider.provideImplementation(ae,J,re);return p(oe)}}class i{constructor(V,ee){this._documents=V,this._provider=ee}async provideTypeDefinition(V,ee,re){const ae=this._documents.getDocument(V),J=I.Position.to(ee),oe=await this._provider.provideTypeDefinition(ae,J,re);return p(oe)}}class f{constructor(V,ee){this._documents=V,this._provider=ee}async provideHover(V,ee,re){const ae=this._documents.getDocument(V),J=I.Position.to(ee),oe=await this._provider.provideHover(ae,J,re);if(!(!oe||(0,T.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=ae.getWordRangeAtPosition(J)),oe.range||(oe.range=new C.Range(J,J)),I.Hover.from(oe)}}class l{constructor(V,ee){this._documents=V,this._provider=ee}async provideEvaluatableExpression(V,ee,re){const ae=this._documents.getDocument(V),J=I.Position.to(ee),oe=await this._provider.provideEvaluatableExpression(ae,J,re);if(oe)return I.EvaluatableExpression.from(oe)}}class d{constructor(V,ee){this._documents=V,this._provider=ee}async provideInlineValues(V,ee,re,ae){const J=this._documents.getDocument(V),oe=await this._provider.provideInlineValues(J,I.Range.to(ee),I.InlineValueContext.to(re),ae);if(Array.isArray(oe))return oe.map(ve=>I.InlineValue.from(ve))}}class b{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentHighlights(V,ee,re){const ae=this._documents.getDocument(V),J=I.Position.to(ee),oe=await this._provider.provideDocumentHighlights(ae,J,re);if(Array.isArray(oe))return oe.map(I.DocumentHighlight.from)}}class y{constructor(V,ee){this._documents=V,this._provider=ee}async provideLinkedEditingRanges(V,ee,re){const ae=this._documents.getDocument(V),J=I.Position.to(ee),oe=await this._provider.provideLinkedEditingRanges(ae,J,re);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,T.coalesce)(oe.ranges.map(I.Range.from)),wordPattern:oe.wordPattern}}}class v{constructor(V,ee){this._documents=V,this._provider=ee}async provideReferences(V,ee,re,ae){const J=this._documents.getDocument(V),oe=I.Position.to(ee),ve=await this._provider.provideReferences(J,oe,re,ae);if(Array.isArray(ve))return ve.map(I.location.from)}}class A{constructor(V,ee,re,ae,J,oe,ve){this._documents=V,this._commands=ee,this._diagnostics=re,this._provider=ae,this._logService=J,this._extension=oe,this._apiDeprecation=ve,this._cache=new h.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(V,ee,re,ae){const J=this._documents.getDocument(V),oe=P.Selection.isISelection(ee)?I.Selection.to(ee):I.Range.to(ee),ve=[];for(const Z of this._diagnostics.getDiagnostics(V))if(oe.intersection(Z.range)&&ve.push(Z)>A._maxCodeActionsPerFile)break;const Me={diagnostics:ve,only:re.only?new C.CodeActionKind(re.only):void 0,triggerKind:I.CodeActionTriggerKind.to(re.trigger)},qe=await this._provider.provideCodeActions(J,oe,Me,ae);if(!(0,T.isNonEmptyArray)(qe)||ae.isCancellationRequested)return;const Ke=this._cache.add(qe),Se=new c.DisposableStore;this._disposables.set(Ke,Se);const tt=[];for(let Z=0;Z<qe.length;Z++){const te=qe[Z];!te||(A._isCommand(te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:te.title,command:this._commands.toInternal(te,Se)})):(Me.only&&(te.kind?Me.only.contains(te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[Ke,Z],title:te.title,command:te.command&&this._commands.toInternal(te.command,Se),diagnostics:te.diagnostics&&te.diagnostics.map(I.Diagnostic.from),edit:te.edit&&I.WorkspaceEdit.from(te.edit),kind:te.kind&&te.kind.value,isPreferred:te.isPreferred,disabled:te.disabled?.reason})))}return{cacheId:Ke,actions:tt}}async resolveCodeAction(V,ee){const[re,ae]=V,J=this._cache.get(re,ae);if(!J||A._isCommand(J)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(J,ee)??J;return oe?.edit?I.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}static _isCommand(V){return typeof V.command=="string"&&typeof V.title=="string"}}A._maxCodeActionsPerFile=1e3;class w{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentFormattingEdits(V,ee,re){const ae=this._documents.getDocument(V),J=await this._provider.provideDocumentFormattingEdits(ae,ee,re);if(Array.isArray(J))return J.map(I.TextEdit.from)}}class F{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentRangeFormattingEdits(V,ee,re,ae){const J=this._documents.getDocument(V),oe=I.Range.to(ee),ve=await this._provider.provideDocumentRangeFormattingEdits(J,oe,re,ae);if(Array.isArray(ve))return ve.map(I.TextEdit.from)}}class O{constructor(V,ee){this._documents=V,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,ee,re,ae,J){const oe=this._documents.getDocument(V),ve=I.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(oe,ve,re,ae,J);if(Array.isArray(Me))return Me.map(I.TextEdit.from)}}class G{constructor(V,ee){this._provider=V,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(V,ee){const re=R.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(V,ee);if((0,T.isNonEmptyArray)(ae))for(const J of ae){if(!J)continue;if(!J.name){this._logService.warn("INVALID SymbolInformation, lacks name",J);continue}const oe=R.IdObject.mixin(I.WorkspaceSymbol.from(J));this._symbolCache.set(oe._id,J),re.symbols.push(oe)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(V,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return V;const re=this._symbolCache.get(V._id);if(re){const ae=await this._provider.resolveWorkspaceSymbol(re,ee);return ae&&(0,L.mixin)(V,I.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(V){const ee=this._resultCache.get(V);if(ee){for(let[re,ae]=ee;re<=ae;re++)this._symbolCache.delete(re);this._resultCache.delete(V)}}}class K{constructor(V,ee,re){this._documents=V,this._provider=ee,this._logService=re}static supportsResolving(V){return typeof V.prepareRename=="function"}async provideRenameEdits(V,ee,re,ae){const J=this._documents.getDocument(V),oe=I.Position.to(ee);try{const ve=await this._provider.provideRenameEdits(J,oe,re,ae);return ve?I.WorkspaceEdit.from(ve):void 0}catch(ve){const Me=K._asMessage(ve);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(V,ee,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(V),J=I.Position.to(ee);try{const oe=await this._provider.prepareRename(ae,J,re);let ve,Me;if(C.Range.isRange(oe)?(ve=oe,Me=ae.getText(oe)):(0,n.isObject)(oe)&&(ve=oe.range,Me=oe.placeholder),!ve||!Me)return;if(ve.start.line>J.line||ve.end.line<J.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ve),text:Me}}catch(oe){const ve=K._asMessage(oe);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class U{constructor(V,ee){this.resultId=V,this.tokens=ee}}class z{constructor(V,ee){this._documents=V,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(V,ee,re){const ae=this._documents.getDocument(V),J=ee!==0?this._previousResults.get(ee):null;let oe=typeof J?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,J.resultId,re):await this._provider.provideDocumentSemanticTokens(ae,re);return J&&this._previousResults.delete(ee),oe?(oe=z._fixProvidedSemanticTokens(oe),this._send(z._convertToEdits(J,oe),oe)):null}async releaseDocumentSemanticColoring(V){this._previousResults.delete(V)}static _fixProvidedSemanticTokens(V){return z._isSemanticTokens(V)?z._isCorrectSemanticTokens(V)?V:new C.SemanticTokens(new Uint32Array(V.data),V.resultId):z._isSemanticTokensEdits(V)?z._isCorrectSemanticTokensEdits(V)?V:new C.SemanticTokensEdits(V.edits.map(ee=>new C.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),V.resultId):V}static _isSemanticTokens(V){return V&&!!V.data}static _isCorrectSemanticTokens(V){return V.data instanceof Uint32Array}static _isSemanticTokensEdits(V){return V&&Array.isArray(V.edits)}static _isCorrectSemanticTokensEdits(V){for(const ee of V.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(V,ee){if(!z._isSemanticTokens(ee)||!V||!V.tokens)return ee;const re=V.tokens,ae=re.length,J=ee.data,oe=J.length;let ve=0;const Me=Math.min(ae,oe);for(;ve<Me&&re[ve]===J[ve];)ve++;if(ve===ae&&ve===oe)return new C.SemanticTokensEdits([],ee.resultId);let qe=0;const Ke=Me-ve;for(;qe<Ke&&re[ae-qe-1]===J[oe-qe-1];)qe++;return new C.SemanticTokensEdits([{start:ve,deleteCount:ae-ve-qe,data:J.subarray(ve,oe-qe)}],ee.resultId)}_send(V,ee){if(z._isSemanticTokens(V)){const re=this._nextResultId++;return this._previousResults.set(re,new U(V.resultId,V.data)),(0,m.encodeSemanticTokensDto)({id:re,type:"full",data:V.data})}if(z._isSemanticTokensEdits(V)){const re=this._nextResultId++;return z._isSemanticTokens(ee)?this._previousResults.set(re,new U(ee.resultId,ee.data)):this._previousResults.set(re,new U(V.resultId)),(0,m.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(V.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class N{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentRangeSemanticTokens(V,ee,re){const ae=this._documents.getDocument(V),J=await this._provider.provideDocumentRangeSemanticTokens(ae,I.Range.to(ee),re);return J?this._send(J):null}_send(V){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:V.data})}}e.DocumentRangeSemanticTokensAdapter=N;class B{constructor(V,ee,re,ae,J){this._documents=V,this._commands=ee,this._provider=re,this._apiDeprecation=ae,this._extension=J,this._cache=new h.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}async provideCompletionItems(V,ee,re,ae){const J=this._documents.getDocument(V),oe=I.Position.to(ee),ve=J.getWordRangeAtPosition(oe)||new C.Range(oe,oe),Me=ve.with({end:oe}),qe=new D.StopWatch(!0),Ke=await this._provider.provideCompletionItems(J,oe,ae,I.CompletionContext.to(re));if(!Ke||ae.isCancellationRequested)return;const Se=Array.isArray(Ke)?new C.CompletionList(Ke):Ke,tt=B.supportsResolving(this._provider)?this._cache.add(Se.items):this._cache.add([]),Z=new c.DisposableStore;this._disposables.set(tt,Z);const te=[],pe={x:tt,b:te,a:{replace:I.Range.from(ve),insert:I.Range.from(Me)},c:Se.isIncomplete||void 0,d:qe.elapsed()};for(let xe=0;xe<Se.items.length;xe++){const Ye=Se.items[xe],rt=this._convertCompletionItem(Ye,[tt,xe],Me,ve);te.push(rt)}return pe}async resolveCompletionItem(V,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...V);if(!re)return;const ae=await this._provider.resolveCompletionItem(re,ee);if(!!ae)return this._convertCompletionItem(ae,V)}releaseCompletionItems(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}_convertCompletionItem(V,ee,re,ae){const J=this._disposables.get(ee[0]);if(!J)throw Error("DisposableStore is missing...");const oe={x:ee,a:V.label,b:V.kind!==void 0?I.CompletionItemKind.from(V.kind):void 0,n:V.tags&&V.tags.map(I.CompletionItemTag.from),c:V.detail,d:typeof V.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters,l:V.additionalTextEdits&&V.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(V.command,J)};V.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=V.textEdit.newText):typeof V.insertText=="string"?oe.h=V.insertText:V.insertText instanceof C.SnippetString&&(oe.h=V.insertText.value,oe.i|=4);let ve;return V.textEdit?ve=V.textEdit.range:V.range&&(ve=V.range),C.Range.isRange(ve)?oe.j=I.Range.from(ve):ve&&(!re?.isEqual(ve.inserting)||!ae?.isEqual(ve.replacing))&&(oe.j={insert:I.Range.from(ve.inserting),replace:I.Range.from(ve.replacing)}),oe}}class x{constructor(V,ee,re){this._documents=V,this._provider=ee,this._commands=re,this._cache=new h.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(V,ee,re,ae){const J=this._documents.getDocument(V),oe=I.Position.to(ee),ve=await this._provider.provideInlineCompletionItems(J,oe,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:I.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text}:void 0,triggerKind:re.triggerKind},ae);if(!ve||ae.isCancellationRequested)return;const Me=(0,n.isArray)(ve)?{items:ve}:ve,qe=this._cache.add(Me.items);let Ke;return{pid:qe,items:Me.items.map((Se,tt)=>{let Z;return Se.command&&(Ke||(Ke=new c.DisposableStore,this._disposables.set(qe,Ke)),Z=this._commands.toInternal(Se.command,Ke)),{text:Se.text,range:Se.range?I.Range.from(Se.range):void 0,command:Z,idx:tt}})}}disposeCompletions(V){this._cache.delete(V);const ee=this._disposables.get(V);ee&&ee.clear(),this._disposables.delete(V)}handleDidShowCompletionItem(V,ee){const re=this._cache.get(V,ee);re&&M.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class M{constructor(){this._onDidShowCompletionItemEmitter=new _.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(V){let ee=M.map.get(V);return ee||(ee=new M,M.map.set(V,ee)),ee}fireOnDidShowCompletionItem(V){this._onDidShowCompletionItemEmitter.fire(V)}}e.InlineCompletionController=M,M.map=new WeakMap;class H{constructor(V,ee){this._documents=V,this._provider=ee,this._cache=new h.Cache("SignatureHelp")}async provideSignatureHelp(V,ee,re,ae){const J=this._documents.getDocument(V),oe=I.Position.to(ee),ve=this.reviveContext(re),Me=await this._provider.provideSignatureHelp(J,oe,ae,ve);if(Me){const qe=this._cache.add([Me]);return{...I.SignatureHelp.from(Me),id:qe}}}reviveContext(V){let ee;if(V.activeSignatureHelp){const re=I.SignatureHelp.to(V.activeSignatureHelp),ae=this._cache.get(V.activeSignatureHelp.id,0);ae?(ee=ae,ee.activeSignature=re.activeSignature,ee.activeParameter=re.activeParameter):ee=re}return{...V,activeSignatureHelp:ee}}releaseSignatureHelp(V){this._cache.delete(V)}}class ${constructor(V,ee){this._documents=V,this._provider=ee}async provideInlayHints(V,ee,re){const ae=this._documents.getDocument(V),J=await this._provider.provideInlayHints(ae,I.Range.to(ee),re);return J?{hints:J.map(I.InlayHint.from)}:void 0}}class Q{constructor(V,ee){this._documents=V,this._provider=ee,this._cache=new h.Cache("DocumentLink")}async provideLinks(V,ee){const re=this._documents.getDocument(V),ae=await this._provider.provideDocumentLinks(re,ee);if(!(!Array.isArray(ae)||ae.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(Q._validateLink).map(I.DocumentLink.from)};{const J=this._cache.add(ae),oe={links:[],id:J};for(let ve=0;ve<ae.length;ve++){if(!Q._validateLink(ae[ve]))continue;const Me=I.DocumentLink.from(ae[ve]);Me.cacheId=[J,ve],oe.links.push(Me)}return oe}}}static _validateLink(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...V);if(!re)return;const ae=await this._provider.resolveDocumentLink(re,ee);if(!(!ae||!Q._validateLink(ae)))return I.DocumentLink.from(ae)}releaseLinks(V){this._cache.delete(V)}}class X{constructor(V,ee){this._documents=V,this._provider=ee}async provideColors(V,ee){const re=this._documents.getDocument(V),ae=await this._provider.provideDocumentColors(re,ee);return Array.isArray(ae)?ae.map(oe=>({color:I.Color.from(oe.color),range:I.Range.from(oe.range)})):[]}async provideColorPresentations(V,ee,re){const ae=this._documents.getDocument(V),J=I.Range.to(ee.range),oe=I.Color.to(ee.color),ve=await this._provider.provideColorPresentations(oe,{document:ae,range:J},re);if(!!Array.isArray(ve))return ve.map(I.ColorPresentation.from)}}class he{constructor(V,ee){this._documents=V,this._provider=ee}async provideFoldingRanges(V,ee,re){const ae=this._documents.getDocument(V),J=await this._provider.provideFoldingRanges(ae,ee,re);if(!!Array.isArray(J))return J.map(I.FoldingRange.from)}}class _e{constructor(V,ee,re){this._documents=V,this._provider=ee,this._logService=re}async provideSelectionRanges(V,ee,re){const ae=this._documents.getDocument(V),J=ee.map(I.Position.to),oe=await this._provider.provideSelectionRanges(ae,J,re);if(!(0,T.isNonEmptyArray)(oe))return[];if(oe.length!==J.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Me=0;Me<J.length;Me++){const qe=[];ve.push(qe);let Ke=J[Me],Se=oe[Me];for(;;){if(!Se.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(qe.push(I.SelectionRange.from(Se)),!Se.parent)break;Ke=Se.range,Se=Se.parent}}return ve}}class ye{constructor(V,ee){this._documents=V,this._provider=ee,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(V,ee,re){const ae=this._documents.getDocument(V),J=I.Position.to(ee),oe=await this._provider.prepareCallHierarchy(ae,J,re);if(!oe)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,oe)]}async provideCallsTo(V,ee,re){const ae=this._itemFromCache(V,ee);if(!ae)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyIncomingCalls(ae,re);if(!!J)return J.map(oe=>({from:this._cacheAndConvertItem(V,oe.from),fromRanges:oe.fromRanges.map(ve=>I.Range.from(ve))}))}async provideCallsFrom(V,ee,re){const ae=this._itemFromCache(V,ee);if(!ae)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyOutgoingCalls(ae,re);if(!!J)return J.map(oe=>({to:this._cacheAndConvertItem(V,oe.to),fromRanges:oe.fromRanges.map(ve=>I.Range.from(ve))}))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,ee){const re=this._cache.get(V),ae=I.CallHierarchyItem.from(ee,V,re.size.toString(36));return re.set(ae._itemId,ee),ae}_itemFromCache(V,ee){return this._cache.get(V)?.get(ee)}}class Re{constructor(V,ee){this._documents=V,this._provider=ee,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(V,ee,re){const ae=this._documents.getDocument(V),J=I.Position.to(ee),oe=await this._provider.prepareTypeHierarchy(ae,J,re);if(!oe)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,oe)]}async provideSupertypes(V,ee,re){const ae=this._itemFromCache(V,ee);if(!ae)throw new Error("missing type hierarchy item");const J=await this._provider.provideTypeHierarchySupertypes(ae,re);if(!!J)return J.map(oe=>this._cacheAndConvertItem(V,oe))}async provideSubtypes(V,ee,re){const ae=this._itemFromCache(V,ee);if(!ae)throw new Error("missing type hierarchy item");const J=await this._provider.provideTypeHierarchySubtypes(ae,re);if(!!J)return J.map(oe=>this._cacheAndConvertItem(V,oe))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,ee){const re=this._cache.get(V),ae=I.TypeHierarchyItem.from(ee,V,re.size.toString(36));return re.set(ae._itemId,ee),ae}_itemFromCache(V,ee){return this._cache.get(V)?.get(ee)}}class We{constructor(V,ee){this.adapter=V,this.extension=ee}}class Be{constructor(V,ee,re,ae,J,oe,ve){this._adapter=new Map,this._uriTransformer=ee,this._proxy=V.getProxy(R.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=ae,this._diagnostics=J,this._logService=oe,this._apiDeprecation=ve}_transformDocumentSelector(V){return(0,T.coalesce)((0,T.asArray)(V).map(ee=>this._doTransformDocumentSelector(ee)))}_doTransformDocumentSelector(V){if(typeof V=="string")return{$serialized:!0,language:V};if(V)return{$serialized:!0,language:V.language,scheme:this._transformScheme(V.scheme),pattern:typeof V.pattern=="undefined"?void 0:I.GlobPattern.from(V.pattern),exclusive:V.exclusive}}_transformScheme(V){return this._uriTransformer&&typeof V=="string"?this._uriTransformer.transformOutgoingScheme(V):V}_createDisposable(V){return new C.Disposable(()=>{this._adapter.delete(V),this._proxy.$unregister(V)})}_nextHandle(){return Be._handlePool++}_withAdapter(V,ee,re,ae,J=!1){const oe=this._adapter.get(V);if(!oe)return Promise.resolve(ae);if(oe.adapter instanceof ee){let ve;oe.extension&&(ve=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=re(oe.adapter,oe.extension),qe=oe.extension;return qe&&Promise.resolve(Me).then(()=>this._logService.trace(`[${qe.identifier.value}] provider DONE after ${Date.now()-ve}ms`),Ke=>{J&&Ke instanceof k.CancellationError||(this._logService.error(`[${qe.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(V,ee){const re=this._nextHandle();return this._adapter.set(re,new We(V,ee)),re}static _extLabel(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,ee,re,ae){const J=this._addNewAdapter(new o(this._documents,re),V),oe=ae&&ae.label||Be._extLabel(V);return this._proxy.$registerDocumentSymbolProvider(J,this._transformDocumentSelector(ee),oe),this._createDisposable(J)}$provideDocumentSymbols(V,ee,re){return this._withAdapter(V,o,ae=>ae.provideDocumentSymbols(g.URI.revive(ee),re),void 0)}registerCodeLensProvider(V,ee,re){const ae=this._nextHandle(),J=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new We(new a(this._documents,this._commands.converter,re),V)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(ee),J);let oe=this._createDisposable(ae);if(J!==void 0){const ve=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(J));oe=C.Disposable.from(oe,ve)}return oe}$provideCodeLenses(V,ee,re){return this._withAdapter(V,a,ae=>ae.provideCodeLenses(g.URI.revive(ee),re),void 0)}$resolveCodeLens(V,ee,re){return this._withAdapter(V,a,ae=>ae.resolveCodeLens(ee,re),void 0)}$releaseCodeLenses(V,ee){this._withAdapter(V,a,re=>Promise.resolve(re.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(V,ee,re){const ae=this._addNewAdapter(new t(this._documents,re),V);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideDefinition(V,ee,re,ae){return this._withAdapter(V,t,J=>J.provideDefinition(g.URI.revive(ee),re,ae),[])}registerDeclarationProvider(V,ee,re){const ae=this._addNewAdapter(new s(this._documents,re),V);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideDeclaration(V,ee,re,ae){return this._withAdapter(V,s,J=>J.provideDeclaration(g.URI.revive(ee),re,ae),[])}registerImplementationProvider(V,ee,re){const ae=this._addNewAdapter(new r(this._documents,re),V);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideImplementation(V,ee,re,ae){return this._withAdapter(V,r,J=>J.provideImplementation(g.URI.revive(ee),re,ae),[])}registerTypeDefinitionProvider(V,ee,re){const ae=this._addNewAdapter(new i(this._documents,re),V);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideTypeDefinition(V,ee,re,ae){return this._withAdapter(V,i,J=>J.provideTypeDefinition(g.URI.revive(ee),re,ae),[])}registerHoverProvider(V,ee,re,ae){const J=this._addNewAdapter(new f(this._documents,re),V);return this._proxy.$registerHoverProvider(J,this._transformDocumentSelector(ee)),this._createDisposable(J)}$provideHover(V,ee,re,ae){return this._withAdapter(V,f,J=>J.provideHover(g.URI.revive(ee),re,ae),void 0)}registerEvaluatableExpressionProvider(V,ee,re,ae){const J=this._addNewAdapter(new l(this._documents,re),V);return this._proxy.$registerEvaluatableExpressionProvider(J,this._transformDocumentSelector(ee)),this._createDisposable(J)}$provideEvaluatableExpression(V,ee,re,ae){return this._withAdapter(V,l,J=>J.provideEvaluatableExpression(g.URI.revive(ee),re,ae),void 0)}registerInlineValuesProvider(V,ee,re,ae){const J=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new d(this._documents,re),V);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(ee),J);let ve=this._createDisposable(oe);if(J!==void 0){const Me=re.onDidChangeInlineValues(qe=>this._proxy.$emitInlineValuesEvent(J));ve=C.Disposable.from(ve,Me)}return ve}$provideInlineValues(V,ee,re,ae,J){return this._withAdapter(V,d,oe=>oe.provideInlineValues(g.URI.revive(ee),re,ae,J),void 0)}registerDocumentHighlightProvider(V,ee,re){const ae=this._addNewAdapter(new b(this._documents,re),V);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideDocumentHighlights(V,ee,re,ae){return this._withAdapter(V,b,J=>J.provideDocumentHighlights(g.URI.revive(ee),re,ae),void 0)}registerLinkedEditingRangeProvider(V,ee,re){const ae=this._addNewAdapter(new y(this._documents,re),V);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideLinkedEditingRanges(V,ee,re,ae){return this._withAdapter(V,y,async J=>{const oe=await J.provideLinkedEditingRanges(g.URI.revive(ee),re,ae);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Be._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(V,ee,re){const ae=this._addNewAdapter(new v(this._documents,re),V);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideReferences(V,ee,re,ae,J){return this._withAdapter(V,v,oe=>oe.provideReferences(g.URI.revive(ee),re,ae,J),void 0)}registerCodeActionProvider(V,ee,re,ae){const J=new c.DisposableStore,oe=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,re,this._logService,V,this._apiDeprecation),V);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(ee),{providedKinds:ae?.providedCodeActionKinds?.map(ve=>ve.value),documentation:ae?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,J)}))},Be._extLabel(V),Boolean(re.resolveCodeAction)),J.add(this._createDisposable(oe)),J}$provideCodeActions(V,ee,re,ae,J){return this._withAdapter(V,A,oe=>oe.provideCodeActions(g.URI.revive(ee),re,ae,J),void 0)}$resolveCodeAction(V,ee,re){return this._withAdapter(V,A,ae=>ae.resolveCodeAction(ee,re),void 0)}$releaseCodeActions(V,ee){this._withAdapter(V,A,re=>Promise.resolve(re.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(V,ee,re){const ae=this._addNewAdapter(new w(this._documents,re),V);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(ee),V.identifier,V.displayName||V.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(V,ee,re,ae){return this._withAdapter(V,w,J=>J.provideDocumentFormattingEdits(g.URI.revive(ee),re,ae),void 0)}registerDocumentRangeFormattingEditProvider(V,ee,re){const ae=this._addNewAdapter(new F(this._documents,re),V);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(ee),V.identifier,V.displayName||V.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(V,ee,re,ae,J){return this._withAdapter(V,F,oe=>oe.provideDocumentRangeFormattingEdits(g.URI.revive(ee),re,ae,J),void 0)}registerOnTypeFormattingEditProvider(V,ee,re,ae){const J=this._addNewAdapter(new O(this._documents,re),V);return this._proxy.$registerOnTypeFormattingSupport(J,this._transformDocumentSelector(ee),ae,V.identifier),this._createDisposable(J)}$provideOnTypeFormattingEdits(V,ee,re,ae,J,oe){return this._withAdapter(V,O,ve=>ve.provideOnTypeFormattingEdits(g.URI.revive(ee),re,ae,J,oe),void 0)}registerWorkspaceSymbolProvider(V,ee){const re=this._addNewAdapter(new G(ee,this._logService),V);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(V,ee,re){return this._withAdapter(V,G,ae=>ae.provideWorkspaceSymbols(ee,re),{symbols:[]})}$resolveWorkspaceSymbol(V,ee,re){return this._withAdapter(V,G,ae=>ae.resolveWorkspaceSymbol(ee,re),void 0)}$releaseWorkspaceSymbols(V,ee){this._withAdapter(V,G,re=>re.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(V,ee,re){const ae=this._addNewAdapter(new K(this._documents,re,this._logService),V);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(ee),K.supportsResolving(re)),this._createDisposable(ae)}$provideRenameEdits(V,ee,re,ae,J){return this._withAdapter(V,K,oe=>oe.provideRenameEdits(g.URI.revive(ee),re,ae,J),void 0)}$resolveRenameLocation(V,ee,re,ae){return this._withAdapter(V,K,J=>J.resolveRenameLocation(g.URI.revive(ee),re,ae),void 0)}registerDocumentSemanticTokensProvider(V,ee,re,ae){const J=this._nextHandle(),oe=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(J,new We(new z(this._documents,re),V)),this._proxy.$registerDocumentSemanticTokensProvider(J,this._transformDocumentSelector(ee),ae,oe);let ve=this._createDisposable(J);if(oe){const Me=re.onDidChangeSemanticTokens(qe=>this._proxy.$emitDocumentSemanticTokensEvent(oe));ve=C.Disposable.from(ve,Me)}return ve}$provideDocumentSemanticTokens(V,ee,re,ae){return this._withAdapter(V,z,J=>J.provideDocumentSemanticTokens(g.URI.revive(ee),re,ae),null,!0)}$releaseDocumentSemanticTokens(V,ee){this._withAdapter(V,z,re=>re.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(V,ee,re,ae){const J=this._addNewAdapter(new N(this._documents,re),V);return this._proxy.$registerDocumentRangeSemanticTokensProvider(J,this._transformDocumentSelector(ee),ae),this._createDisposable(J)}$provideDocumentRangeSemanticTokens(V,ee,re,ae){return this._withAdapter(V,N,J=>J.provideDocumentRangeSemanticTokens(g.URI.revive(ee),re,ae),null,!0)}registerCompletionItemProvider(V,ee,re,ae){const J=this._addNewAdapter(new B(this._documents,this._commands.converter,re,this._apiDeprecation,V),V);return this._proxy.$registerSuggestSupport(J,this._transformDocumentSelector(ee),ae,B.supportsResolving(re),`${V.identifier.value}(${ae.join("")})`),this._createDisposable(J)}$provideCompletionItems(V,ee,re,ae,J){return this._withAdapter(V,B,oe=>oe.provideCompletionItems(g.URI.revive(ee),re,ae,J),void 0)}$resolveCompletionItem(V,ee,re){return this._withAdapter(V,B,ae=>ae.resolveCompletionItem(ee,re),void 0)}$releaseCompletionItems(V,ee){this._withAdapter(V,B,re=>re.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(V,ee,re){const ae=this._addNewAdapter(new x(this._documents,re,this._commands.converter),V);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideInlineCompletions(V,ee,re,ae,J){return this._withAdapter(V,x,oe=>oe.provideInlineCompletions(g.URI.revive(ee),re,ae,J),void 0)}$handleInlineCompletionDidShow(V,ee,re){this._withAdapter(V,x,async ae=>{ae.handleDidShowCompletionItem(ee,re)},void 0)}$freeInlineCompletionsList(V,ee){this._withAdapter(V,x,async re=>{re.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(V,ee,re,ae){const J=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,oe=this._addNewAdapter(new H(this._documents,re),V);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(ee),J),this._createDisposable(oe)}$provideSignatureHelp(V,ee,re,ae,J){return this._withAdapter(V,H,oe=>oe.provideSignatureHelp(g.URI.revive(ee),re,ae,J),void 0)}$releaseSignatureHelp(V,ee){this._withAdapter(V,H,re=>re.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(V,ee,re){const ae=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,J=this._addNewAdapter(new $(this._documents,re),V);this._proxy.$registerInlayHintsProvider(J,this._transformDocumentSelector(ee),ae);let oe=this._createDisposable(J);if(ae!==void 0){const ve=re.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(ae));oe=C.Disposable.from(oe,ve)}return oe}$provideInlayHints(V,ee,re,ae){return this._withAdapter(V,$,J=>J.provideInlayHints(g.URI.revive(ee),re,ae),void 0)}registerDocumentLinkProvider(V,ee,re){const ae=this._addNewAdapter(new Q(this._documents,re),V);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(ee),typeof re.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(V,ee,re){return this._withAdapter(V,Q,ae=>ae.provideLinks(g.URI.revive(ee),re),void 0)}$resolveDocumentLink(V,ee,re){return this._withAdapter(V,Q,ae=>ae.resolveLink(ee,re),void 0)}$releaseDocumentLinks(V,ee){this._withAdapter(V,Q,re=>re.releaseLinks(ee),void 0)}registerColorProvider(V,ee,re){const ae=this._addNewAdapter(new X(this._documents,re),V);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideDocumentColors(V,ee,re){return this._withAdapter(V,X,ae=>ae.provideColors(g.URI.revive(ee),re),[])}$provideColorPresentations(V,ee,re,ae){return this._withAdapter(V,X,J=>J.provideColorPresentations(g.URI.revive(ee),re,ae),void 0)}registerFoldingRangeProvider(V,ee,re){const ae=this._nextHandle(),J=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new We(new he(this._documents,re),V)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(ee),J);let oe=this._createDisposable(ae);if(J!==void 0){const ve=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(J));oe=C.Disposable.from(oe,ve)}return oe}$provideFoldingRanges(V,ee,re,ae){return this._withAdapter(V,he,J=>J.provideFoldingRanges(g.URI.revive(ee),re,ae),void 0)}registerSelectionRangeProvider(V,ee,re){const ae=this._addNewAdapter(new _e(this._documents,re,this._logService),V);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideSelectionRanges(V,ee,re,ae){return this._withAdapter(V,_e,J=>J.provideSelectionRanges(g.URI.revive(ee),re,ae),[])}registerCallHierarchyProvider(V,ee,re){const ae=this._addNewAdapter(new ye(this._documents,re),V);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$prepareCallHierarchy(V,ee,re,ae){return this._withAdapter(V,ye,J=>Promise.resolve(J.prepareSession(g.URI.revive(ee),re,ae)),void 0)}$provideCallHierarchyIncomingCalls(V,ee,re,ae){return this._withAdapter(V,ye,J=>J.provideCallsTo(ee,re,ae),void 0)}$provideCallHierarchyOutgoingCalls(V,ee,re,ae){return this._withAdapter(V,ye,J=>J.provideCallsFrom(ee,re,ae),void 0)}$releaseCallHierarchy(V,ee){this._withAdapter(V,ye,re=>Promise.resolve(re.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(V,ee,re){const ae=this._addNewAdapter(new Re(this._documents,re),V);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$prepareTypeHierarchy(V,ee,re,ae){return this._withAdapter(V,Re,J=>Promise.resolve(J.prepareSession(g.URI.revive(ee),re,ae)),void 0)}$provideTypeHierarchySupertypes(V,ee,re,ae){return this._withAdapter(V,Re,J=>J.provideSupertypes(ee,re,ae),void 0)}$provideTypeHierarchySubtypes(V,ee,re,ae){return this._withAdapter(V,Re,J=>J.provideSubtypes(ee,re,ae),void 0)}$releaseTypeHierarchy(V,ee){this._withAdapter(V,Re,re=>Promise.resolve(re.releaseSession(ee)),void 0)}static _serializeRegExp(V){return{pattern:V.source,flags:(0,E.regExpFlags)(V)}}static _serializeIndentationRule(V){return{decreaseIndentPattern:Be._serializeRegExp(V.decreaseIndentPattern),increaseIndentPattern:Be._serializeRegExp(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Be._serializeRegExp(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Be._serializeRegExp(V.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(V){return{beforeText:Be._serializeRegExp(V.beforeText),afterText:V.afterText?Be._serializeRegExp(V.afterText):void 0,previousLineText:V.previousLineText?Be._serializeRegExp(V.previousLineText):void 0,action:V.action}}static _serializeOnEnterRules(V){return V.map(Be._serializeOnEnterRule)}setLanguageConfiguration(V,ee,re){let{wordPattern:ae}=re;if(ae&&(0,E.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(ee,ae):this._documents.setWordDefinitionFor(ee,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const J=this._nextHandle(),oe={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?Be._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?Be._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?Be._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(J,ee,oe),this._createDisposable(J)}$setWordDefinitions(V){for(const ee of V)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=Be,Be._handlePool=0}),define(me[244],ge([0,1,5,15,7,49,18,6]),function(Y,e,g,L,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(n,P,c){this._documents=P,this._commands=c,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=n.getProxy(g.MainContext.MainThreadLanguages)}$acceptLanguageIds(n){this._languageIds=n}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(n,P){await this._proxy.$changeLanguage(n,P);const c=this._documents.getDocumentData(n);if(!c)throw new Error(`document '${n.toString}' NOT found`);return c.document}async tokenAtPosition(n,P){const c=n.version,m=L.Position.from(P),u=await this._proxy.$tokensAtPosition(n.uri,m),h={type:I.StandardTokenType.Other,range:n.getWordRangeAtPosition(P)??new I.Range(P.line,P.character,P.line,P.character)};if(!u)return h;const D={range:L.Range.to(u.range),type:L.TokenType.to(u.type)};return!D.range.contains(P)||c!==n.version?h:D}createLanguageStatusItem(n,P,c){const m=this._handlePool++,u=this._proxy,h=this._ids,D=`${n.identifier.value}/${P}`;if(h.has(D))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);h.add(D);const k={selector:c,id:P,name:n.displayName??n.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let _,o=new E.DisposableStore;const a=()=>{_?.dispose(),_=(0,R.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(m,{id:D,name:k.name??n.displayName??n.name,source:n.displayName??n.name,selector:k.selector,label:k.text,detail:k.detail??"",severity:k.severity===I.LanguageStatusSeverity.Error?C.default.Error:k.severity===I.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:k.command&&this._commands.toInternal(k.command,o),accessibilityInfo:k.accessibilityInformation})},0)},p={dispose(){o.dispose(),_?.dispose(),u.$removeLanguageStatus(m),h.delete(D)},get id(){return k.id},get name(){return k.name},set name(t){k.name=t,a()},get selector(){return k.selector},set selector(t){k.selector=t,a()},get text(){return k.text},set text(t){k.text=t,a()},get detail(){return k.detail},set detail(t){k.detail=t,a()},get severity(){return k.severity},set severity(t){k.severity=t,a()},get accessibilityInformation(){return k.accessibilityInformation},set accessibilityInformation(t){k.accessibilityInformation=t,a()},get command(){return k.command},set command(t){k.command=t,a()}};return a(),p}}e.ExtHostLanguages=S}),define(me[245],ge([0,1,5,12,35]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(E){return E&&E.title}let R=class{constructor(S,T){this._logService=T,this._proxy=S.getProxy(g.MainContext.MainThreadMessageService)}showMessage(S,T,n,P,c){const m={extension:S};let u;typeof P=="string"||C(P)?u=[P,...c]:(m.modal=P?.modal,m.useCustom=P?.useCustom,m.detail=P?.detail,u=c),m.useCustom&&(0,I.checkProposedApiEnabled)(S);const h=[];for(let D=0;D<u.length;D++){const k=u[D];if(typeof k=="string")h.push({title:k,handle:D,isCloseAffordance:!1});else if(typeof k=="object"){let{title:_,isCloseAffordance:o}=k;h.push({title:_,isCloseAffordance:!!o,handle:D})}else this._logService.warn("Invalid message item:",k)}return this._proxy.$showMessage(T,n,m,h).then(D=>{if(typeof D=="number")return u[D]})}};R=Ve([$e(1,L.ILogService)],R),e.ExtHostMessageService=R}),define(me[246],ge([0,1,23,3,48,6,24,9,13,2,87,5,15,7,66,221,129]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class k{constructor(o,a,p,t,s){this._textDocumentsAndEditors=p,this._textDocuments=t,this._extensionStoragePaths=s,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(P.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(P.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(P.MainContext.MainThreadNotebookEditors),this._commandsConverter=a.converter,a.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,f=r.cell.handle,d=this._documents.get(i)?.getCell(f);if(d)return d.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const a=this._editors.get(o);if(!a)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return a}getIdByEditor(o){for(const[a,p]of this._editors)if(p.apiEditor===o)return a}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,a){const p=this._documents.get(o);if(!p&&!a)throw new Error(`NO notebook document for '${o}'`);return p}_getProviderData(o){const a=this._notebookContentProviders.get(o);if(!a)throw new Error(`NO provider for '${o}'`);return a}registerNotebookContentProvider(o,a,p,t,s){if((0,E.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(a))throw new Error(`Notebook provider for '${a}' already registered`);this._notebookContentProviders.set(a,{extension:o,provider:p});let r;return p.onDidChangeNotebookContentOptions&&(r=p.onDidChangeNotebookContentOptions(()=>{const i=c.NotebookDocumentContentOptions.from(p.options);this._notebookProxy.$updateNotebookProviderOptions(a,i)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},a,c.NotebookDocumentContentOptions.from(t),k._convertNotebookRegistrationData(o,s)),new m.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(a),this._notebookProxy.$unregisterNotebookProvider(a)})}static _convertNotebookRegistrationData(o,a){if(!a)return;const p=a.filenamePattern.map(t=>c.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(a.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${a.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:a.displayName,filenamePattern:p,exclusive:a.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,a,p){const t=k._notebookStatusBarItemProviderHandlePool++,s=typeof p.onDidChangeCellStatusBarItems=="function"?k._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,p),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,s,a);let r;return s!==void 0&&(r=p.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(s))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,s),r&&r.dispose()})}async createNotebookDocument(o){const a=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&c.NotebookData.from(o.content)});return T.URI.revive(a)}async openNotebookDocument(o){const a=this._documents.get(o);if(a)return a.apiNotebook;const p=await this._notebookDocumentsProxy.$tryOpenNotebook(o),t=this._documents.get(T.URI.revive(p));return(0,S.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(o,a){T.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let p;typeof a=="object"?p={position:c.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selections:a.selections&&a.selections.map(c.NotebookRange.from),pinned:typeof a.preview=="boolean"?!a.preview:void 0}:p={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,p),s=t&&this._editors.get(t)?.apiEditor;if(s)return s;throw t?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,a,p,t){const s=this._notebookStatusBarItemProviders.get(o),r=T.URI.revive(a),i=this._documents.get(r);if(!i||!s)return;const f=i.getCellFromIndex(p);if(!f)return;const l=await s.provideCellStatusBarItems(f.apiCell,t);if(!l)return;const d=new C.DisposableStore,b=this._statusBarCache.add([d]),v=(Array.isArray(l)?l:[l]).map(A=>c.NotebookStatusBarItem.from(A,this._commandsConverter,d));return{cacheId:b,items:v}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,a,p,t,s){if((0,E.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,p),this._notebookProxy.$registerNotebookSerializer(r,{id:o.identifier,location:o.extensionLocation},a,c.NotebookDocumentContentOptions.from(t),k._convertNotebookRegistrationData(o,s)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(o,a,p){const t=this._notebookSerializer.get(o);if(!t)throw new Error("NO serializer found");const s=await t.deserializeNotebook(a.buffer,p);return new u.SerializableObjectWithBuffers(c.NotebookData.from(s))}async $notebookToData(o,a,p){const t=this._notebookSerializer.get(o);if(!t)throw new Error("NO serializer found");const s=await t.serializeNotebook(c.NotebookData.to(a.value),p);return g.VSBuffer.wrap(s)}async $openNotebook(o,a,p,t,s){const{provider:r}=this._getProviderData(o),i=await r.openNotebook(T.URI.revive(a),{backupId:p,untitledDocumentData:t?.buffer},s);return new u.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(c.NotebookCellData.from)})}async $saveNotebook(o,a,p){const t=this.getNotebookDocument(T.URI.revive(a)),{provider:s}=this._getProviderData(o);return await s.saveNotebook(t.apiNotebook,p),!0}async $saveNotebookAs(o,a,p,t){const s=this.getNotebookDocument(T.URI.revive(a)),{provider:r}=this._getProviderData(o);return await r.saveNotebookAs(T.URI.revive(p),s.apiNotebook,t),!0}async $backupNotebook(o,a,p){const t=this.getNotebookDocument(T.URI.revive(a)),s=this._getProviderData(o),r=this._extensionStoragePaths.workspaceValue(s.extension)??this._extensionStoragePaths.globalValue(s.extension),i=String((0,I.hash)([t.uri.toString(),this._backupIdPool++])),f=T.URI.joinPath(r,i),l=await s.provider.backupNotebook(t.apiNotebook,{destination:f},p);return t.updateBackup(l),l.id}_createExtHostEditor(o,a,p){if(this._editors.has(a))throw new Error(`editor with id ALREADY EXSIST: ${a}`);const t=new D.ExtHostNotebookEditor(a,this._notebookEditorsProxy,o,p.visibleRanges.map(c.NotebookRange.to),p.selections.map(c.NotebookRange.to),typeof p.viewColumn=="number"?c.ViewColumn.to(p.viewColumn):void 0);this._editors.set(a,t)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const p of o.value.removedDocuments){const t=T.URI.revive(p),s=this._documents.get(t);s&&(s.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(s.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===t.toString()&&this._editors.delete(r.id)}if(o.value.addedDocuments){const p=[];for(const t of o.value.addedDocuments){const s=T.URI.revive(t.uri);if(this._documents.has(s))throw new Error(`adding EXISTING notebook ${s} `);const r=this,i=new h.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(f){r._onDidChangeNotebookCells.fire(f)},emitCellOutputsChange(f){r._onDidChangeCellOutputs.fire(f)},emitCellMetadataChange(f){r._onDidChangeCellMetadata.fire(f)},emitCellExecutionStateChange(f){r._onDidChangeCellExecutionState.fire(f)}},s,t);p.push(...t.cells.map(f=>h.ExtHostCell.asModelAddData(i.apiNotebook,f))),this._documents.get(s)?.dispose(),this._documents.set(s,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(o.value.addedEditors)for(const p of o.value.addedEditors){if(this._editors.has(p.id))return;const t=T.URI.revive(p.documentUri),s=this._documents.get(t);s&&this._createExtHostEditor(s,p.id,p)}const a=[];if(o.value.removedEditors)for(const p of o.value.removedEditors){const t=this._editors.get(p);t&&(this._editors.delete(p),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),a.push(t))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const p=new Set;this._visibleNotebookEditors.forEach(t=>p.add(t.id));for(const t of this._editors.values()){const s=p.has(t.id);t._acceptVisibility(s)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=k,k._notebookStatusBarItemProviderHandlePool=0}),define(me[247],ge([0,1,3,76,12,5,14,15]),function(Y,e,g,L,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(P,c){const m=S._Keys.nextId();P.$registerNotebookEditorDecorationType(m,E.NotebookDecorationRenderOptions.from(c)),this.value={key:m,dispose(){P.$removeNotebookEditorDecorationType(m)}}}}S._Keys=new L.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(P,c,m){this._logService=P,this._extHostRpc=c,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(P){return new S(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),P).value}$acceptEditorPropertiesChanged(P,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,c);const m=this._notebooksAndEditors.getEditorById(P);c.visibleRanges&&m._acceptVisibleRanges(c.visibleRanges.ranges.map(E.NotebookRange.to)),c.selections&&m._acceptSelections(c.selections.selections.map(E.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const c in P)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(E.ViewColumn.to(P[c]))}};T=Ve([$e(0,I.ILogService),$e(1,R.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(me[248],ge([0,1,17,18,21,3,6,24,2,26,12,5,15,7,88,214,35,66]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let _=class{constructor(s,r,i,f){this._initData=r,this._extHostNotebook=i,this._logService=f,this._activeExecutions=new E.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=s.getProxy(P.MainContext.MainThreadNotebookKernels)}createNotebookController(s,r,i,f,l,d){for(let M of this._kernelData.values())if(M.controller.id===r&&T.ExtensionIdentifier.equals(s.identifier,M.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const b=this._handlePool++,y=this;this._logService.trace(`NotebookController[${b}], CREATED by ${s.identifier.value}, ${r}`);const v=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${s.identifier}'`);let A=!1;const w=new R.DisposableStore,F=new C.Emitter,O=new C.Emitter,G={id:`${s.identifier.value}/${r}`,notebookType:i,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:f||s.identifier.value,preloads:d?d.map(c.NotebookRendererScript.from):[]};let K=l??v,U;this._proxy.$addKernel(b,G).catch(M=>{console.log(M),A=!0});let z=0;const N=()=>{if(A)return;const M=++z;Promise.resolve().then(()=>{M===z&&this._proxy.$updateKernel(b,G)})},B=new E.ResourceMap,x={get id(){return r},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return G.label},set label(M){G.label=M??s.displayName??s.name,N()},get detail(){return G.detail??""},set detail(M){G.detail=M,N()},get description(){return G.description??""},set description(M){G.description=M,N()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(M){G.supportedLanguages=M,N()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(M){G.supportsExecutionOrder=M,N()},get rendererScripts(){return G.preloads?G.preloads.map(c.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(M){K=M??v},get interruptHandler(){return U},set interruptHandler(M){U=M,G.supportsInterrupt=Boolean(M),N()},createNotebookCellExecution(M){if(A)throw new Error("notebook controller is DISPOSED");if(!B.has(M.notebook.uri))throw y._logService.trace(`NotebookController[${b}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(B.keys()).map(H=>H.toString())),new Error(`notebook controller is NOT associated to notebook: ${M.notebook.uri.toString()}`);return y._createNotebookCellExecution(M)},dispose:()=>{A||(this._logService.trace(`NotebookController[${b}], DISPOSED`),A=!0,this._kernelData.delete(b),w.dispose(),F.dispose(),O.dispose(),this._proxy.$removeKernel(b))},updateNotebookAffinity(M,H){y._proxy.$updateNotebookPriority(b,M.uri,H)},onDidReceiveMessage:O.event,postMessage(M,H){return(0,D.checkProposedApiEnabled)(s),y._proxy.$postMessage(b,H&&y._extHostNotebook.getIdByEditor(H),M)},asWebviewUri(M){return(0,D.checkProposedApiEnabled)(s),(0,u.asWebviewUri)(M,y._initData.remote)}};return this._kernelData.set(b,{extensionId:s.identifier,controller:x,onDidReceiveMessage:O,onDidChangeSelection:F,associatedNotebooks:B}),x}$acceptNotebookAssociation(s,r,i){const f=this._kernelData.get(s);if(f){const l=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));i?f.associatedNotebooks.set(l.uri,!0):f.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,l.uri.toString(),i),f.onDidChangeSelection.fire({selected:i,notebook:l.apiNotebook})}}async $executeCells(s,r,i){const f=this._kernelData.get(s);if(!f)return;const l=this._extHostNotebook.getNotebookDocument(S.URI.revive(r)),d=[];for(let b of i){const y=l.getCell(b);y&&d.push(y.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,l.uri.toString(),d.length),await f.controller.executeHandler.call(f.controller,d,l.apiNotebook,f.controller)}catch(b){this._logService.error(`NotebookController[${s}] execute cells FAILED`,b),console.error(b)}}async $cancelCells(s,r,i){const f=this._kernelData.get(s);if(!f)return;const l=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,l.apiNotebook);else for(let d of i){const b=l.getCell(d);b&&this._activeExecutions.get(b.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,r,i){const f=this._kernelData.get(s);if(!f)return;const l=this._extHostNotebook.getEditorById(r);f.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:i}))}_createNotebookCellExecution(s){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!i)throw new Error("invalid cell");if(this._activeExecutions.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const f=new a(i.notebook,i,this._proxy);this._activeExecutions.set(i.uri,f);const l=f.onDidChangeState(()=>{f.state===o.Resolved&&(f.dispose(),l.dispose(),this._activeExecutions.delete(i.uri))});return f.asApiObject()}};_=Ve([$e(3,n.ILogService)],_),e.ExtHostNotebookKernels=_;var o;(function(t){t[t.Init=0]="Init",t[t.Started=1]="Started",t[t.Resolved=2]="Resolved"})(o||(o={}));class a extends R.Disposable{constructor(s,r,i){super();this._document=s,this._cell=r,this._proxy=i,this._handle=a.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new p(10,f=>this.update(f)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const r=Array.isArray(s)?s:[s];return this._proxy.$updateExecutions(new k.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(s){let r=this._cell;if(s&&(r=this._document.getCellFromApiCell(s)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(s){return s.map(r=>{const i=m.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return i===r.items?c.NotebookCellOutput.from(r):c.NotebookCellOutput.from({items:i,id:r.id,metadata:r.metadata})})}async updateOutputs(s,r,i){const f=this.cellIndexToHandle(r),l=this.validateAndConvertOutputs((0,g.asArray)(s));return this.updateSoon({editType:h.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:f,append:i,outputs:l})}async updateOutputItems(s,r,i){return s=m.NotebookCellOutput.ensureUniqueMimeTypes((0,g.asArray)(s),!0),this.updateSoon({editType:h.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:s.map(c.NotebookCellOutputItem.from),outputId:r.id,append:i})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(i){s._executionOrder=i,s.update([{editType:h.CellExecutionUpdateType.ExecutionState,executionHandle:s._handle,executionOrder:s._executionOrder}])},start(i){if(s._state===o.Resolved||s._state===o.Started)throw new Error("Cannot call start again");s._state=o.Started,s._onDidChangeState.fire(),s.update({editType:h.CellExecutionUpdateType.ExecutionState,executionHandle:s._handle,runStartTime:i})},end(i,f){if(s._state===o.Resolved)throw new Error("Cannot call resolve twice");s._state=o.Resolved,s._onDidChangeState.fire(),s.updateSoon({editType:h.CellExecutionUpdateType.Complete,executionHandle:s._handle,runEndTime:f,lastRunSuccess:i}),s._collector.flush(),s._proxy.$removeExecution(s._handle)},clearOutput(i){return s.verifyStateForOutput(),s.updateOutputs([],i,!1)},appendOutput(i,f){return s.verifyStateForOutput(),s.updateOutputs(i,f,!0)},replaceOutput(i,f){return s.verifyStateForOutput(),s.updateOutputs(i,f,!1)},appendOutputItems(i,f){return s.verifyStateForOutput(),s.updateOutputItems(i,f,!0)},replaceOutputItems(i,f){return s.verifyStateForOutput(),s.updateOutputItems(i,f,!1)}})}}a.HANDLE=0;class p{constructor(s,r){this.delay=s,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(s){return this.batch.push(s),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const s=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>s.complete())}}}),define(me[249],ge([0,1,3,5,129]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class C{constructor(E,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=E.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(E,S,T){const n=this._extHostNotebook.getEditorById(E);this._rendererMessageEmitters.get(S)?.fire({editor:n.apiEditor,message:T})}createRendererMessaging(E,S){if(!E.contributes?.notebookRenderer?.some(c=>c.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);const T=!!E.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(c,m,u)=>{const h=T?c:D=>{const k={};n.set(k,D.editor),c({editor:k,message:D.message})};return this.getOrCreateEmitterFor(S).event(h,m,u)},postMessage:(c,m)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(c)&&([c,m]=[m,c]);const u=T?m:n.get(m),h=u&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(h?.id,S,c)}}}getOrCreateEmitterFor(E){let S=this._rendererMessageEmitters.get(E);return S||(S=new g.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(E)}}),this._rendererMessageEmitters.set(E,S),S)}}e.ExtHostNotebookRenderers=C}),define(me[68],ge([0,1,5,3,6,23,4,14]),function(Y,e,g,L,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends I.Disposable{constructor(u,h,D,k,_){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=u,this._proxy=_,this._id=_.$register(this.name,h,D,k),this._disposed=!1,this._offset=0}get name(){return this._name}append(u){this.validate(),this._offset+=u?C.VSBuffer.fromString(u).byteLength:0}update(){this._id.then(u=>this._proxy.$update(u))}appendLine(u){this.validate(),this.append(u+`
`)}clear(){this.validate();const u=this._offset;this._id.then(h=>this._proxy.$clear(h,u))}show(u,h){this.validate(),this._id.then(D=>this._proxy.$reveal(D,!!(typeof u=="boolean"?u:h)))}hide(){this.validate(),this._id.then(u=>this._proxy.$close(u))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(u=>this._proxy.$dispose(u)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class T extends S{constructor(u,h,D){super(u,!1,void 0,h,D)}append(u){super.append(u),this._id.then(h=>this._proxy.$append(h,u)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=T;class n extends S{constructor(u,h,D){super(u,!0,h,void 0,D)}append(u){throw new Error("Not supported")}}class P{constructor(u,h){this.name=u,this._channel=h}append(u){this._channel.then(h=>h.append(u))}appendLine(u){this._channel.then(h=>h.appendLine(u))}clear(){this._channel.then(u=>u.clear())}show(u,h){this._channel.then(D=>D.show(u,h))}hide(){this._channel.then(u=>u.hide())}dispose(){this._channel.then(u=>u.dispose())}}e.LazyOutputChannel=P;let c=class{constructor(u){this._proxy=u.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(u){}createOutputChannel(u,h){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");return new T(u,h.identifier.value,this._proxy)}createOutputChannelFromLogFile(u,h){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");if(!h)throw new Error("illegal argument `file`. must not be falsy");return new n(u,h,this._proxy)}};c=Ve([$e(0,E.IExtHostRpcService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(me[250],ge([0,1,18,21,3,6,5,2,7,16,17,49,63]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(u,h,D){const k=u.getProxy(R.MainContext.MainThreadQuickOpen);class _{constructor(l,d){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=d}showQuickPick(l,d,b,y=L.CancellationToken.None){this._onDidSelectItem=void 0;const v=Promise.resolve(l),A=++this._instances,w=k.$show(A,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},y),F={},O=w.then(()=>F);return Promise.race([O,v]).then(G=>{if(G!==F)return v.then(K=>{const U=[];for(let z=0;z<K.length;z++){const N=K[z];let B,x,M,H,$;typeof N=="string"?B=N:(B=N.label,x=N.description,M=N.detail,H=N.picked,$=N.alwaysShow),U.push({label:B,description:x,handle:z,detail:M,picked:H,alwaysShow:$})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{b.onDidSelectItem(K[z])}),k.$setItems(A,U),w.then(z=>{if(typeof z=="number")return K[z];if(Array.isArray(z))return z.map(N=>K[N])})})}).then(void 0,G=>{if(!(0,T.isPromiseCanceledError)(G))return k.$setError(A,G),Promise.reject(G)})}$onItemSelected(l){this._onDidSelectItem&&this._onDidSelectItem(l)}showInput(l,d=L.CancellationToken.None){return this._validateInput=l?l.validateInput:void 0,k.$input(l,typeof this._validateInput=="function",d).then(void 0,b=>{if(!(0,T.isPromiseCanceledError)(b))return Promise.reject(b)})}$validateInput(l){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(l)):Promise.resolve(void 0)}async showWorkspaceFolderPick(l,d=L.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!b)return;const y=await this._workspace.getWorkspaceFolders2();if(!!y)return y.find(v=>v.uri.toString()===b.uri.toString())}createQuickPick(l,d){const b=new r(l,d,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(l){const d=new i(l,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(l,d){const b=this._sessions.get(l);b&&b._fireDidChangeValue(d)}$onDidAccept(l){const d=this._sessions.get(l);d&&d._fireDidAccept()}$onDidChangeActive(l,d){const b=this._sessions.get(l);b instanceof r&&b._fireDidChangeActive(d)}$onDidChangeSelection(l,d){const b=this._sessions.get(l);b instanceof r&&b._fireDidChangeSelection(d)}$onDidTriggerButton(l,d){const b=this._sessions.get(l);b&&b._fireDidTriggerButton(d)}$onDidTriggerItemButton(l,d,b){const y=this._sessions.get(l);y instanceof r&&y._fireDidTriggerItemButton(d,b)}$onDidHide(l){const d=this._sessions.get(l);d&&d._fireDidHide()}}class o{constructor(l,d){this._extensionId=l,this._onDidDispose=d,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((d,b)=>{const y=d===S.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(y,d)}),this.update({buttons:l.map((d,b)=>({...s(d),tooltip:d.tooltip,handle:d===S.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const d=this._handlesToButtons.get(l);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),k.$dispose(this._id))}update(l){if(!this._disposed){for(const d of Object.keys(l)){const b=l[d];this._pendingUpdate[d]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){k.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function a(f){if(f instanceof S.ThemeIcon)return{id:f.id};const l=t(f),d=p(f);return{dark:typeof l=="string"?E.URI.file(l):l,light:typeof d=="string"?E.URI.file(d):d}}function p(f){return typeof f=="object"&&"light"in f?f.light:f}function t(f){return typeof f=="object"&&"dark"in f?f.dark:f}function s(f){const l=a(f.iconPath);let d,b;return"id"in l?b=c.ThemeIcon.asClassName(l):d=l,{iconPath:d,iconClass:b}}class r extends o{constructor(l,d,b){super(l,b);this.enableProposedApi=d,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((d,b)=>{this._handlesToItems.set(b,d),this._itemsToHandles.set(d,b)}),this.update({items:l.map((d,b)=>({label:d.label,description:d.description,handle:b,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons&&this.enableProposedApi?d.buttons.map((y,v)=>({...s(y),tooltip:y.tooltip,handle:v})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(l){const d=(0,n.coalesce)(l.map(b=>this._handlesToItems.get(b)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(l){const d=(0,n.coalesce)(l.map(b=>this._handlesToItems.get(b)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(l,d){const b=this._handlesToItems.get(l);if(!b||!b.buttons||!b.buttons.length)return;const y=b.buttons[d];y&&this._onDidTriggerItemButtonEmitter.fire({button:y,item:b})}}class i extends o{constructor(l,d){super(l,d);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,this.update({validationMessage:l,severity:l?P.default.Error:P.default.Ignore})}}return new _(h,D)}e.createExtHostQuickOpen=m}),define(me[251],ge([0,1,2,3,58,6,18,5,17,100,12,26,35,63,15]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(l){if(l)return typeof l.iconPath=="string"?g.URI.file(l.iconPath):g.URI.isUri(l.iconPath)||m.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function D(l,d){if(!l.iconPath&&!d.iconPath)return 0;if(l.iconPath){if(!d.iconPath)return 1}else return-1;const b=typeof l.iconPath=="string"?l.iconPath:g.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,y=typeof d.iconPath=="string"?d.iconPath:g.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,T.comparePaths)(b,y)}function k(l,d){let b=0;if(l.strikeThrough!==d.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==d.faded)return l.faded?1:-1;if(l.tooltip!==d.tooltip)return(l.tooltip||"").localeCompare(d.tooltip||"");if(b=D(l,d),b!==0)return b;if(l.light&&d.light)b=D(l.light,d.light);else{if(l.light)return 1;if(d.light)return-1}if(b!==0)return b;if(l.dark&&d.dark)b=D(l.dark,d.dark);else{if(l.dark)return 1;if(d.dark)return-1}return b}function _(l,d){if(l.command!==d.command)return l.command<d.command?-1:1;if(l.title!==d.title)return l.title<d.title?-1:1;if(l.tooltip!==d.tooltip){if(l.tooltip!==void 0&&d.tooltip!==void 0)return l.tooltip<d.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(l.arguments===d.arguments)return 0;if(l.arguments)if(d.arguments){if(l.arguments.length!==d.arguments.length)return l.arguments.length-d.arguments.length}else return 1;else return-1;for(let b=0;b<l.arguments.length;b++){const y=l.arguments[b],v=d.arguments[b];if(y!==v)return y<v?-1:1}return 0}function o(l,d){let b=(0,T.comparePaths)(l.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(b!==0)return b;if(l.command&&d.command)b=_(l.command,d.command);else{if(l.command)return 1;if(d.command)return-1}if(b!==0)return b;if(l.decorations&&d.decorations)b=k(l.decorations,d.decorations);else{if(l.decorations)return 1;if(d.decorations)return-1}return b}function a(l,d){for(let b=0;b<l.length;b++)if(l[b]!==d[b])return!1;return!0}function p(l,d){return l.command===d.command&&l.title===d.title&&l.tooltip===d.tooltip&&(l.arguments&&d.arguments?a(l.arguments,d.arguments):l.arguments===d.arguments)}function t(l,d){return(0,S.equals)(l,d,p)}class s{constructor(d,b,y){this._extension=d,this._proxy=b,this._sourceControlHandle=y,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(d){this._proxy.$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,c.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(d){if((0,c.checkProposedApiEnabled)(this._extension),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,d))}focus(){(0,c.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(d,b){(0,c.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,d,b)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=s;class r{constructor(d,b,y,v,A){this._proxy=d,this._commands=b,this._sourceControlHandle=y,this._id=v,this._label=A,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,b){const y=this._resourceStatesCommandsMap.get(d);return y?(0,R.asPromise)(()=>this._commands.executeCommand(y.command,...y.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(o),y=(0,S.sortedDiff)(this._resourceSnapshot,d,o).map(w=>{const F=w.toInsert.map(O=>{const G=this._resourceHandlePool++;this._resourceStatesMap.set(G,O);const K=O.resourceUri;let U;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const he=new C.DisposableStore;U=this._commands.converter.toInternal(O.command,he),this._resourceStatesDisposablesMap.set(G,he)}else this._resourceStatesCommandsMap.set(G,O.command);const z=h(O.decorations),N=O.decorations&&h(O.decorations.light)||z,B=O.decorations&&h(O.decorations.dark)||z,x=[N,B],M=O.decorations&&O.decorations.tooltip||"",H=O.decorations&&!!O.decorations.strikeThrough,$=O.decorations&&!!O.decorations.faded,Q=O.contextValue||"";return{rawResource:[G,K,x,M,H,$,Q,U],handle:G}});return{start:w.start,deleteCount:w.deleteCount,toInsert:F}}),v=y.map(({start:w,deleteCount:F,toInsert:O})=>[w,F,O.map(G=>G.rawResource)]),A=y.reverse();for(const{start:w,deleteCount:F,toInsert:O}of A){const G=O.map(U=>U.handle),K=this._handlesSnapshot.splice(w,F,...G);for(const U of K)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=d,v}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class i{constructor(d,b,y,v,A,w){this._proxy=b,this._commands=y,this._id=v,this._label=A,this._rootUri=w,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new s(d,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,v,A,w)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,this._proxy.$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,this._proxy.$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=d;const b=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&t(this._statusBarCommands,d))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=d;const b=(d||[]).map(y=>this._commands.converter.toInternal(y,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(d,b){const y=new r(this._proxy,this._commands,this.handle,d,b),v=L.Event.once(y.onDidDispose)(()=>this.createdResourceGroups.delete(y));return this.createdResourceGroups.set(y,v),this.eventuallyAddResourceGroups(),y}eventuallyAddResourceGroups(){const d=[],b=[];for(const[y,v]of this.createdResourceGroups){v.dispose();const A=y.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(y),this.eventuallyUpdateResourceStates()});L.Event.once(y.onDidDispose)(()=>{this.updatedResourceGroups.delete(y),A.dispose(),this._groups.delete(y.handle),this._proxy.$unregisterGroup(this.handle,y.handle)}),d.push([y.handle,y.id,y.label,y.features]);const w=y._takeResourceStateSnapshot();w.length>0&&b.push([y.handle,w]),this._groups.set(y.handle,y)}this._proxy.$registerGroups(this.handle,d,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(b=>{const y=b._takeResourceStateSnapshot();y.length!==0&&d.push([b.handle,y])}),d.length>0&&this._proxy.$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ve([(0,I.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Ve([(0,I.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let f=class xn{constructor(d,b,y){this._commands=b,this.logService=y,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=d.getProxy(E.MainContext.MainThreadSCM),this._telemetry=d.getProxy(E.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===3){const A=this._sourceControls.get(v.sourceControlHandle);if(!A)return v;const w=A.getResourceGroup(v.groupHandle);return w?w.getResourceState(v.handle):v}else if(v&&v.$mid===4){const A=this._sourceControls.get(v.sourceControlHandle);return A?A.getResourceGroup(v.groupHandle):v}else if(v&&v.$mid===5){const A=this._sourceControls.get(v.handle);return A||v}return v}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,b,y,v){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,b,y,v),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const A=xn._handlePool++,w=new i(d,this._proxy,this._commands,b,y,v);this._sourceControls.set(A,w);const F=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(d.identifier))||[];return F.push(w),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(d.identifier),F),w}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const b=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(d.identifier)),y=b&&b[b.length-1];return y&&y.inputBox}$provideOriginalResource(d,b,y){const v=g.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,v.toString());const A=this._sourceControls.get(d);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>A.quickDiffProvider.provideOriginalResource(v,y)).then(w=>w||null)}$onInputBoxValueChange(d,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const y=this._sourceControls.get(d);return y&&y.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(d,b,y,v){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,b,y);const A=this._sourceControls.get(d);if(!A)return Promise.resolve(void 0);const w=A.getResourceGroup(b);return w?w.$executeResourceCommand(y,v):Promise.resolve(void 0)}$validateInput(d,b,y){this.logService.trace("ExtHostSCM#$validateInput",d);const v=this._sourceControls.get(d);return!v||!v.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>v.inputBox.validateInput(b,y)).then(A=>{if(!A)return Promise.resolve(void 0);const w=u.MarkdownString.fromStrict(A.message);return w?Promise.resolve([w,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};f._handlePool=0,f=Ve([$e(2,n.ILogService)],f),e.ExtHostSCM=f});var nt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[252],ge([0,1,7,5,167,6,15]),function(Y,e,g,L,I,C,R){"use strict";var E,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class T{constructor(m,u,h,D,k=g.StatusBarAlignment.Left,_){E.set(this,void 0),S.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,nt(this,E,m,"f"),nt(this,S,u,"f"),this._entryId=T.ID_GEN++,this._extension=h,this._id=D,this._alignment=k,this._priority=_}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(m){this._text=m,this.update()}set name(m){this._name=m,this.update()}set tooltip(m){this._tooltip=m,this.update()}set color(m){this._color=m,this.update()}set backgroundColor(m){m&&!T.ALLOWED_BACKGROUND_COLORS.has(m.id)&&(m=void 0),this._backgroundColor=m,this.update()}set command(m){this._command?.fromApi!==m&&(this._internalCommandRegistration.clear(),typeof m=="string"?this._command={fromApi:m,internal:Oe(this,S,"f").toInternal({title:"",command:m},this._internalCommandRegistration)}:m?this._command={fromApi:m,internal:Oe(this,S,"f").toInternal(m,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let m;this._extension?this._id?m=`${this._extension.identifier.value}.${this._id}`:m=this._extension.identifier.value:m=this._id;let u;this._name?u=this._name:u=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let h=this._color;this._backgroundColor&&(h=T.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const D=this._tooltip?R.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,E,"f").$setEntry(this._entryId,m,u,this._text,D,this._command?.internal,h,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=T,E=new WeakMap,S=new WeakMap,T.ID_GEN=0,T.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class n{constructor(m){this._messages=[],this._item=m.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(m){const u={message:m};return this._messages.unshift(u),this._update(),new g.Disposable(()=>{const h=this._messages.indexOf(u);h>=0&&(this._messages.splice(h,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class P{constructor(m,u){this._proxy=m.getProxy(L.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new n(this)}createStatusBarEntry(m,u,h,D){return new T(this._proxy,this._commands,m,u,h,D)}setStatusBarMessage(m,u){const h=this._statusMessage.setMessage(m);let D;return typeof u=="number"?D=setTimeout(()=>h.dispose(),u):typeof u!="undefined"&&u.then(()=>h.dispose(),()=>h.dispose()),new g.Disposable(()=>{h.dispose(),clearTimeout(D)})}}e.ExtHostStatusBar=P}),define(me[92],ge([0,1,5,3,4]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(E){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=E.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(E,S){this._proxy.$registerExtensionStorageKeysToSync(E,S)}getValue(E,S,T){return this._proxy.$getValue(E,S).then(n=>n||T)}setValue(E,S,T){return this._proxy.$setValue(E,S,T)}$acceptValue(E,S,T){this._onDidChangeStorage.fire({shared:E,key:S,value:T})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(me[69],ge([0,1,4,27,12,91,2]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let E=class{constructor(T,n,P){this._logService=n,this._extHostFileSystem=P,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(T){return R.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,n=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(P){this._logService.error("[ExtHostStorage]",P);return}}workspaceValue(T){if(this._value)return R.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return R.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};E=Ve([$e(0,L.IExtHostInitDataService),$e(1,I.ILogService),$e(2,C.IExtHostConsumerFileSystem)],E),e.ExtensionStoragePaths=E}),define(me[33],ge([0,1,3,5,4,2,14,6,7,168,16,216,21,32,196,197,63,13]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class _{constructor(l,d,b,y){this._proxy=l,this._id=d,this._creationOptions=b,this._name=y,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(A=>this._pidPromiseComplete=A);const v=this;this.value={get name(){return v._name||""},get processId(){return v._pidPromise},get creationOptions(){return v._creationOptions},get exitStatus(){return v._exitStatus},get state(){return v._state},sendText(A,w=!0){v._checkDisposed(),v._proxy.$sendText(v._id,A,w)},show(A){v._checkDisposed(),v._proxy.$show(v._id,A)},hide(){v._checkDisposed(),v._proxy.$hide(v._id)},dispose(){v._disposed||(v._disposed=!0,v._proxy.$dispose(v._id))},get dimensions(){if(!(v._cols===void 0||v._rows===void 0))return{columns:v._cols,rows:v._rows}}}}async create(l,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:l.name,shellPath:(0,k.withNullAsUndefined)(l.shellPath),shellArgs:(0,k.withNullAsUndefined)(l.shellArgs),cwd:(0,k.withNullAsUndefined)(l.cwd),env:(0,k.withNullAsUndefined)(l.env),icon:(0,k.withNullAsUndefined)(r(l.iconPath)),color:D.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:(0,k.withNullAsUndefined)(l.message),strictEnv:(0,k.withNullAsUndefined)(l.strictEnv),hideFromUser:(0,k.withNullAsUndefined)(l.hideFromUser),isFeatureTerminal:(0,k.withNullAsUndefined)(d?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,k.withNullAsUndefined)(d?.useShellEnvironment),location:d?.location||this._serializeParentTerminal(l.location,d?.resolvedExtHostIdentifier,d?.location)})}async createExtensionTerminal(l,d,b,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:D.ThemeColor.isThemeColor(y)?y.id:void 0,location:this._serializeParentTerminal(l,d)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(l,d,b){return typeof l=="object"&&"parentTerminal"in l?d?{parentTerminal:d}:void 0:(b&&(l=b),l)}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(l){this._name=l}setExitCode(l){this._exitStatus=Object.freeze({code:l})}setDimensions(l,d){return l===this._cols&&d===this._rows||l===0||d===0?!1:(this._cols=l,this._rows=d,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(l){this._pidPromiseComplete?(this._pidPromiseComplete(l),this._pidPromiseComplete=void 0):this._pidPromise.then(d=>{d!==l&&(this._pidPromise=Promise.resolve(l))})}}e.ExtHostTerminal=_;class o{constructor(l){this._pty=l,this.id=0,this.shouldPersist=!1,this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new g.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(l){this._pty.handleInput&&this._pty.handleInput(l)}resize(l,d){this._pty.setDimensions&&this._pty.setDimensions({columns:l,rows:d})}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(l){this._pty.onDidWrite(d=>this._onProcessData.fire(d)),this._pty.onDidClose&&this._pty.onDidClose((d=void 0)=>{this._onProcessExit.fire(d===void 0?void 0:d)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d&&{cols:d.columns,rows:d.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(d=>this._onProcessTitleChanged.fire(d)),this._pty.open(l||void 0),this._pty.setDimensions&&l&&this._pty.setDimensions(l),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=o;let a=1,p=class extends E.Disposable{constructor(l,d){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new g.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new g.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new g.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new g.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=d.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new h.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(l),this._register({dispose:()=>{for(const[b,y]of this._terminalProcesses)y.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(l=>l.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(l,d){const b=new _(this._proxy,(0,m.generateUuid)(),l,l.name),y=new o(l.pty);return b.createExtensionTerminal(this._resolveLocation(l.location),d?.resolvedExtHostIdentifier,r(l.iconPath),i(l.color)).then(v=>{const A=this._setupExtHostProcessListeners(v,y);this._terminalProcessDisposables[v]=A}),this._terminals.push(b),b.value}_resolveLocation(l){return typeof l=="object"&&"viewColumn"in l&&l.viewColumn!==void 0?{viewColumn:l.viewColumn,preserveFocus:l.preserveFocus}:typeof l=="object"&&"parentTerminal"in l?void 0:(l===u.TerminalLocation.Editor||l===u.TerminalLocation.Panel,l)}attachPtyToTerminal(l,d){if(!this._getTerminalById(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const y=new o(d),v=this._setupExtHostProcessListeners(l,y);this._terminalProcessDisposables[l]=v}async $acceptActiveTerminalChanged(l){const d=this._activeTerminal;if(l===null){this._activeTerminal=void 0,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(l);b&&(this._activeTerminal=b,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(l,d){const b=this._getTerminalById(l);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:d})}async $acceptTerminalDimensions(l,d,b){const y=this._getTerminalById(l);y&&y.setDimensions(d,b)&&this._onDidChangeTerminalDimensions.fire({terminal:y.value,dimensions:y.value.dimensions})}async $acceptTerminalMaximumDimensions(l,d,b){this._terminalProcesses.get(l)?.resize(d,b)}async $acceptTerminalTitleChange(l,d){const b=this._getTerminalById(l);b&&(b.name=d)}async $acceptTerminalClosed(l,d){const b=this._getTerminalObjectIndexById(this._terminals,l);if(b!==null){const y=this._terminals.splice(b,1)[0];y.setExitCode(d),this._onDidCloseTerminal.fire(y.value)}}$acceptTerminalOpened(l,d,b,y){if(d){const w=this._getTerminalObjectIndexById(this._terminals,d);if(w!==null){this._terminals[w]._id=l,this._onDidOpenTerminal.fire(this.terminals[w]),this._terminals[w].isOpen=!0;return}}const v={name:y.name,shellPath:y.executable,shellArgs:y.args,cwd:typeof y.cwd=="string"?y.cwd:C.URI.revive(y.cwd),env:y.env,hideFromUser:y.hideFromUser},A=new _(this._proxy,l,v,b);this._terminals.push(A),this._onDidOpenTerminal.fire(A.value),A.isOpen=!0}async $acceptTerminalProcessId(l,d){const b=this._getTerminalById(l);b&&b._setProcessId(d)}async $startExtensionTerminal(l,d){const b=this._getTerminalById(l);if(!b)return{message:(0,T.localize)(0,null,l)};b.isOpen||await new Promise(v=>{const A=this.onDidOpenTerminal(async w=>{w===b.value&&(A.dispose(),v())})});const y=this._terminalProcesses.get(l);y?y.startSendingEvents(d):this._extensionTerminalAwaitingStart[l]={initialDimensions:d}}_setupExtHostProcessListeners(l,d){const b=new E.DisposableStore;b.add(d.onProcessReady(v=>this._proxy.$sendProcessReady(l,v.pid,v.cwd))),b.add(d.onProcessTitleChanged(v=>this._proxy.$sendProcessTitle(l,v))),this._bufferer.startBuffering(l,d.onProcessData),b.add(d.onProcessExit(v=>this._onProcessExit(l,v))),d.onProcessOverrideDimensions&&b.add(d.onProcessOverrideDimensions(v=>this._proxy.$sendOverrideDimensions(l,v))),this._terminalProcesses.set(l,d);const y=this._extensionTerminalAwaitingStart[l];return y&&d instanceof o&&(d.startSendingEvents(y.initialDimensions),delete this._extensionTerminalAwaitingStart[l]),b}$acceptProcessAckDataEvent(l,d){this._terminalProcesses.get(l)?.acknowledgeDataEvent(d)}$acceptProcessInput(l,d){this._terminalProcesses.get(l)?.input(d)}$acceptTerminalInteraction(l){const d=this._getTerminalById(l);d?.setInteractedWith()&&this._onDidChangeTerminalState.fire(d.value)}$acceptProcessResize(l,d,b){try{this._terminalProcesses.get(l)?.resize(d,b)}catch(y){if(y.code!=="EPIPE"&&y.code!=="ERR_IPC_CHANNEL_CLOSED")throw y}}$acceptProcessShutdown(l,d){this._terminalProcesses.get(l)?.shutdown(d)}$acceptProcessRequestInitialCwd(l){this._terminalProcesses.get(l)?.getInitialCwd().then(d=>this._proxy.$sendProcessInitialCwd(l,d))}$acceptProcessRequestCwd(l){this._terminalProcesses.get(l)?.getCwd().then(d=>this._proxy.$sendProcessCwd(l,d))}$acceptProcessRequestLatency(l){return l}registerLinkProvider(l){return this._linkProviders.add(l),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(l),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(l,d,b){if(this._profileProviders.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this._profileProviders.set(d,b),this._proxy.$registerProfileProvider(d,l.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(d),this._proxy.$unregisterProfileProvider(d)})}async $createContributedProfileTerminal(l,d){const b=new c.CancellationTokenSource().token,y=await this._profileProviders.get(l)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(!y||!("options"in y))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in y.options){this.createExtensionTerminal(y.options,d);return}this.createTerminalFromOptions(y.options,d)}}async $provideLinks(l,d){const b=this._getTerminalById(l);if(!b)return[];this._terminalLinkCache.delete(l);const y=this._terminalLinkCancellationSource.get(l);y&&y.dispose(!0);const v=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(l,v);const A=[],w={terminal:b.value,line:d},F=[];for(const K of this._linkProviders)F.push(new Promise(async U=>{v.token.onCancellationRequested(()=>U({provider:K,links:[]}));const z=await K.provideTerminalLinks(w,v.token)||[];v.token.isCancellationRequested||U({provider:K,links:z})}));const O=await Promise.all(F);if(v.token.isCancellationRequested)return[];const G=new Map;for(const K of O)K&&K.links.length>0&&A.push(...K.links.map(U=>{const z={id:a++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return G.set(z.id,{provider:K.provider,link:U}),z}));return this._terminalLinkCache.set(l,G),A}$activateLink(l,d){const b=this._terminalLinkCache.get(l)?.get(d);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(l,d){this._bufferer.stopBuffering(l),this._terminalProcesses.delete(l),delete this._extensionTerminalAwaitingStart[l];const b=this._terminalProcessDisposables[l];b&&(b.dispose(),delete this._terminalProcessDisposables[l]),this._proxy.$sendProcessExit(l,d)}_getTerminalById(l){return this._getTerminalObjectById(this._terminals,l)}_getTerminalObjectById(l,d){const b=this._getTerminalObjectIndexById(l,d);return b!==null?l[b]:null}_getTerminalObjectIndexById(l,d){let b=null;return l.some((y,v)=>y._id===d?(b=v,!0):!1),b}getEnvironmentVariableCollection(l){let d=this._environmentVariableCollections.get(l.identifier.value);return d||(d=new t,this._setEnvironmentVariableCollection(l.identifier.value,d)),d}_syncEnvironmentVariableCollection(l,d){const b=(0,P.serializeEnvironmentVariableCollection)(d.map);this._proxy.$setEnvironmentVariableCollection(l,d.persistent,b.length===0?void 0:b)}$initEnvironmentVariableCollections(l){l.forEach(d=>{const b=d[0],y=new t(d[1]);this._setEnvironmentVariableCollection(b,y)})}$acceptDefaultProfile(l,d){this._defaultProfile=l,this._defaultAutomationProfile=d}_setEnvironmentVariableCollection(l,d){this._environmentVariableCollections.set(l,d),d.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(l,d)})}};p=Ve([$e(1,R.IExtHostRpcService)],p),e.BaseExtHostTerminalService=p;class t{constructor(l){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(l)}get persistent(){return this._persistent}set persistent(l){this._persistent=l,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(l,d){this._setIfDiffers(l,{value:d,type:S.EnvironmentVariableMutatorType.Replace})}append(l,d){this._setIfDiffers(l,{value:d,type:S.EnvironmentVariableMutatorType.Append})}prepend(l,d){this._setIfDiffers(l,{value:d,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(l,d){const b=this.map.get(l);(!b||b.value!==d.value||b.type!==d.type)&&(this.map.set(l,d),this._onDidChangeCollection.fire())}get(l){return this.map.get(l)}forEach(l,d){this.map.forEach((b,y)=>l.call(d,y,b,this))}delete(l){this.map.delete(l),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=t;let s=class extends p{constructor(l){super(!1,l)}createTerminal(l,d,b){throw new n.NotSupportedError}createTerminalFromOptions(l,d){throw new n.NotSupportedError}};s=Ve([$e(0,R.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function r(f){if(!(!f||typeof f=="string"))return"id"in f?{id:f.id,color:f.color}:f}function i(f){return D.ThemeColor.isThemeColor(f)?f:void 0}});var nt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[253],ge([0,1,17,23,21,3,75,48,6,25,13,32,5,14,64,15,7,224,127,89]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D,k,_,o){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let p=class{constructor(w,F){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=w.getProxy(c.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new s(this.proxy),F.registerArgumentProcessor({processArgument:O=>O?.$mid===13?h.TestItem.toItemFromContext(O):O})}createTestController(w,F){if(this.controllers.has(w))throw new Error(`Attempt to insert a duplicate controller with ID "${w}"`);const O=new S.DisposableStore,G=O.add(new k.SingleUseTestCollection(w));G.root.label=F;const K=new Map,U=this.proxy,z={items:G.root.children,get label(){return F},set label(B){F=B,G.root.label=B,U.$updateControllerLabel(w,F)},get id(){return w},createRunProfile:(B,x,M,H,$)=>{let Q=(0,E.hash)(B);for(;K.has(Q);)Q++;const X=new y(this.proxy,w,Q,B,x,M,H,$);return K.set(Q,X),X},createTestItem(B,x,M){return new u.TestItemImpl(w,B,x,M)},createTestRun:(B,x,M=!0)=>this.runTracker.createTestRun(w,G,B,x,M),set resolveHandler(B){G.resolveHandler=B},get resolveHandler(){return G.resolveHandler},dispose:()=>{O.dispose()}};z.createRunConfiguration=z.createRunProfile,U.$registerTestController(w,F),O.add((0,S.toDisposable)(()=>U.$unregisterTestController(w)));const N={controller:z,collection:G,profiles:K};return this.controllers.set(w,N),O.add((0,S.toDisposable)(()=>this.controllers.delete(w))),O.add(G.onDidGenerateDiff(B=>U.$publishDiff(w,B))),z}createTestObserver(){return this.observer.checkout()}async runTests(w,F=I.CancellationToken.None){const O=r(w);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const G=this.controllers.get(O.controllerId);if(!G)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:w.include?.map(K=>K.id)??[G.collection.root.id],profileGroup:v[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:w.exclude?.map(K=>K.id)},F)}$provideFileCoverage(w,F,O){return(0,g.mapFind)(this.runTracker.trackers,K=>K.id===w?K.getCoverage(F):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(w,F,O,G){return(0,g.mapFind)(this.runTracker.trackers,U=>U.id===w?U.getCoverage(F):void 0)?.resolveFileCoverage(O,G)??Promise.resolve([])}$configureRunProfile(w,F){this.controllers.get(w)?.profiles.get(F)?.configureHandler?.()}$publishTestResults(w){this.results=Object.freeze(w.map(F=>(0,T.deepFreeze)(h.TestResults.to(F))).concat(this.results).sort((F,O)=>O.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(w,F){const O=this.controllers.get(o.TestId.fromString(w).controllerId)?.collection;O&&(await O.expand(w,F<0?Infinity:F),O.flushDiff())}$acceptDiff(w){this.observer.applyDiff(w)}async $runControllerTests(w,F){const O=this.controllers.get(w.controllerId);if(!O)return;const{collection:G,profiles:K}=O,U=K.get(w.profileId);if(!U)return;const z=w.testIds.map(M=>G.tree.get(M)).filter(n.isDefined),N=w.excludeExtIds.map(M=>O.collection.tree.get(M)).filter(n.isDefined).filter(M=>z.some(H=>H.fullId.compare(M.fullId)===2));if(!z.length)return;const B=new D.TestRunRequest(z.some(M=>M.actual instanceof u.TestItemRootImpl)?void 0:z.map(M=>M.actual),N.map(M=>M.actual),U),x=this.runTracker.prepareForMainThreadTestRun(B,i.fromInternal(w,O.collection),F);try{await U.runHandler(B,F)}finally{x.isRunning&&!F.isCancellationRequested&&await C.Event.toPromise(x.onEnd),x.dispose()}}$cancelExtensionTestRun(w){w===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(w)}};p=Ve([$e(0,m.IExtHostRpcService)],p),e.ExtHostTesting=p;class t extends S.Disposable{constructor(w,F,O){super();this.dto=w,this.proxy=F,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(O)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:G}of this.tasks.values())G.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(w){return this.tasks.get(w)?.coverage}createRun(w){const F=this.dto.id,O=this.dto.controllerId,G=(0,P.generateUuid)(),K=new f(this.proxy,F,G),U=x=>(M,...H)=>{if(N){console.warn(`Setting the state of test "${M.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(M)||(this.ensureTestIsKnown(M),x(M,...H))},z=(x,M)=>{const H=M instanceof Array?M.map(h.TestMessage.from):[h.TestMessage.from(M)];if(x.uri&&x.range){const $={range:h.Range.from(x.range),uri:x.uri};for(const Q of H)Q.location=Q.location||$}this.proxy.$appendTestMessagesInRun(F,G,o.TestId.fromExtHostTestItem(x,O).toString(),H)};let N=!1;const B={isPersisted:this.dto.isPersisted,token:this.cts.token,name:w,get coverageProvider(){return K.coverageProvider},set coverageProvider(x){K.coverageProvider=x},enqueued:U(x=>{this.proxy.$updateTestStateInRun(F,G,o.TestId.fromExtHostTestItem(x,O).toString(),1)}),skipped:U(x=>{this.proxy.$updateTestStateInRun(F,G,o.TestId.fromExtHostTestItem(x,O).toString(),5)}),started:U(x=>{this.proxy.$updateTestStateInRun(F,G,o.TestId.fromExtHostTestItem(x,O).toString(),2)}),errored:U((x,M,H)=>{z(x,M),this.proxy.$updateTestStateInRun(F,G,o.TestId.fromExtHostTestItem(x,O).toString(),6,H)}),failed:U((x,M,H)=>{z(x,M),this.proxy.$updateTestStateInRun(F,G,o.TestId.fromExtHostTestItem(x,O).toString(),4,H)}),passed:U((x,M)=>{this.proxy.$updateTestStateInRun(F,G,o.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString(),3,M)}),appendOutput:(x,M,H)=>{N||(H&&(this.dto.isIncluded(H)?this.ensureTestIsKnown(H):H=void 0),this.proxy.$appendOutputToRun(F,G,L.VSBuffer.fromString(x),M&&h.location.from(M),H&&o.TestId.fromExtHostTestItem(H,O).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(F,G),this.tasks.delete(G),this.isRunning||this.dispose())}};return this.tasks.set(G,{run:B,coverage:K}),this.proxy.$startedTestRunTask(F,{id:G,name:w,running:!0}),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(w){if(!(w instanceof u.TestItemImpl))throw new u.InvalidTestItemError(w.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(w,this.dto.controllerId).toString()))return;const F=[],O=this.dto.colllection.root;for(;;){const G=h.TestItem.from(w);if(F.unshift(G),this.sharedTestIds.has(G.extId)||(this.sharedTestIds.add(G.extId),w===O))break;w=w.parent||O}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,F)}}class s{constructor(w){this.proxy=w,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(w,F,O){return this.getTracker(w,F,O)}cancelRunById(w){for(const F of this.tracked.values())if(F.id===w){F.dispose();return}}cancelAllRuns(){for(const w of this.tracked.values())w.dispose()}createTestRun(w,F,O,G,K){const U=this.tracked.get(O);if(U)return U.createRun(G);const z=i.fromPublic(w,F,O,K),N=r(O);this.proxy.$startedExtensionTestRun({controllerId:w,profile:N&&{group:v[N.kind],id:N.profileId},exclude:O.exclude?.map(x=>x.id)??[],id:z.id,include:O.include?.map(x=>x.id)??[F.root.id],persist:K});const B=this.getTracker(O,z);return B.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),B.createRun(G)}getTracker(w,F,O){const G=new t(F,this.proxy,O);return this.tracked.set(w,G),G.onEnd(()=>this.tracked.delete(w)),G}}e.TestRunCoordinator=s;const r=A=>{if(!!A.profile){if(!(A.profile instanceof y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return A.profile}};class i{constructor(w,F,O,G,K,U){this.controllerId=w,this.id=F,this.isPersisted=K,this.colllection=U,this.includePrefix=O.map(z=>z+"\0"),this.excludePrefix=G.map(z=>z+"\0")}static fromPublic(w,F,O,G){return new i(w,(0,P.generateUuid)(),O.include?.map(K=>o.TestId.fromExtHostTestItem(K,w).toString())??[w],O.exclude?.map(K=>o.TestId.fromExtHostTestItem(K,w).toString())??[],G,F)}static fromInternal(w,F){return new i(w.controllerId,w.runId,w.testIds,w.excludeExtIds,!0,F)}isIncluded(w){const F=o.TestId.fromExtHostTestItem(w,this.controllerId).toString()+"\0";for(const O of this.excludePrefix)if(F===O||F.startsWith(O))return!1;for(const O of this.includePrefix)if(F===O||F.startsWith(O))return!0;return!1}}e.TestRunDto=i;class f{constructor(w,F,O){this.proxy=w,this.runId=F,this.taskId=O}set coverageProvider(w){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!w||(this._coverageProvider=w,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(w){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(w))());try{return(await this.fileCoverage)?.map(h.TestCoverage.fromFile)??[]}catch(F){throw this.fileCoverage=void 0,F}}async resolveFileCoverage(w,F){const O=await this.fileCoverage;let G=O?.[w];return!this._coverageProvider||!O||!G?[]:(G.detailedCoverage||(G=O[w]=await this._coverageProvider.resolveFileCoverage?.(G,F)??G),G.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class l extends _.IncrementalChangeCollector{constructor(w){super();this.emitter=w,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(w){this.added.add(w)}update(w){Object.assign(w.revived,h.TestItem.toPlain(w.item)),this.added.has(w)||this.updated.add(w)}remove(w){if(this.added.has(w)){this.added.delete(w);return}if(this.updated.delete(w),w.parent&&this.alreadyRemoved.has(w.parent)){this.alreadyRemoved.add(w.item.extId);return}this.removed.add(w)}getChangeEvent(){const{added:w,updated:F,removed:O}=this;return{get added(){return[...w].map(G=>G.revived)},get updated(){return[...F].map(G=>G.revived)},get removed(){return[...O].map(G=>G.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(w){return this.items.get(w)}getMirroredTestDataByReference(w){return this.items.get(w.id)}createItem(w,F){return{...w,revived:h.TestItem.toPlain(w.item),depth:F?F.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=d;class b{constructor(w){this.proxy=w}checkout(){this.current||(this.current=this.createObserverData());const w=this.current;return w.observers++,{onDidChangeTest:w.tests.onDidChangeTests,get tests(){return[...w.tests.rootTests].map(F=>F.revived)},dispose:(0,R.once)(()=>{--w.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(w){return this.current?.tests.getMirroredTestDataByReference(w)}applyDiff(w){this.current?.tests.apply(w)}createObserverData(){const w=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:w}}}class y{constructor(w,F,O,G,K,U,z=!1,N=void 0){this.controllerId=F,this.profileId=O,this._label=G,this.kind=K,this.runHandler=U,this._isDefault=z,this._tag=N,a.set(this,void 0),nt(this,a,w,"f");const B=v[K];if(typeof B!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Oe(this,a,"f").$publishTestRunProfile({profileId:O,controllerId:F,tag:N?h.TestTag.namespace(this.controllerId,N.id):null,label:G,group:B,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(w){w!==this._label&&(this._label=w,Oe(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:w}))}get isDefault(){return this._isDefault}set isDefault(w){w!==this._isDefault&&(this._isDefault=w,Oe(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:w}))}get tag(){return this._tag}set tag(w){w?.id!==this._tag?.id&&(this._tag=w,Oe(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:w?h.TestTag.namespace(this.controllerId,w.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(w){w!==this._configureHandler&&(this._configureHandler=w,Oe(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!w}))}dispose(){Oe(this,a,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=y,a=new WeakMap;const v={[D.TestRunProfileKind.Coverage]:8,[D.TestRunProfileKind.Debug]:4,[D.TestRunProfileKind.Run]:2}}),define(me[254],ge([0,1,3,17,5,130,15,7]),function(Y,e,g,L,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(n,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const P=this._extHostDocumentsAndEditors.allEditors();return n?P:P.map(c=>c.value)}async showTextDocument(n,P,c){let m;typeof P=="number"?m={position:R.ViewColumn.from(P),preserveFocus:c}:typeof P=="object"?m={position:R.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?R.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:m={preserveFocus:!1};const u=await this._proxy.$tryShowTextDocument(n.uri,m),h=u&&this._extHostDocumentsAndEditors.getEditor(u);if(h)return h.value;throw u?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,P){return new C.TextEditorDecorationType(this._proxy,n,P).value}$acceptEditorPropertiesChanged(n,P){const c=this._extHostDocumentsAndEditors.getEditor(n);if(!c)throw new Error("unknown text editor");if(P.options&&c._acceptOptions(P.options),P.selections){const m=P.selections.selections.map(R.Selection.to);c._acceptSelections(m)}if(P.visibleRanges){const m=L.coalesce(P.visibleRanges.map(R.Range.to));c._acceptVisibleRanges(m)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...P.options,lineNumbers:R.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const m=E.TextEditorSelectionChangeKind.fromValue(P.selections.source),u=P.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:u,kind:m})}if(P.visibleRanges){const m=L.coalesce(P.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:m})}}$acceptEditorPositionData(n){for(const P in n){const c=this._extHostDocumentsAndEditors.getEditor(P);if(!c)throw new Error("Unknown text editor");const m=R.ViewColumn.to(n[P]);c.value.viewColumn!==m&&(c._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:m}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=S}),define(me[255],ge([0,1,2,4,5,6,7]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class E{constructor(n,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(I.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const m=c.uri===void 0?void 0:g.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(S(m))?.get(c.handle)}return c}})}async $getTimeline(n,P,c,m,u){return this._providers.get(n)?.provideTimeline(g.URI.revive(P),c,m,u)}registerTimelineProvider(n,P,c,m){const u=new C.DisposableStore,h=this.convertTimelineItem(P.id,m,u).bind(this);let D;P.onDidChange&&(D=P.onDidChange(_=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,..._,id:P.id}),this));const k=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...P,scheme:n,onDidChange:void 0,async provideTimeline(_,o,a,p){p?.resetCache&&(u.clear(),k.get(P.id)?.clear());const t=await P.provideTimeline(_,o,a);if(t==null)return;const s=h(_,p);return{...t,source:P.id,items:t.items.map(s)}},dispose(){for(const _ of k.values())_.get(P.id)?.clear();D?.dispose(),u.dispose()}})}convertTimelineItem(n,P,c){return(m,u)=>{let h;if(u?.cacheResults){let D=this._itemsBySourceAndUriMap.get(n);D===void 0&&(D=new Map,this._itemsBySourceAndUriMap.set(n,D));const k=S(m);h=D.get(k),h===void 0&&(h=new Map,D.set(k,h))}return D=>{const{iconPath:k,..._}=D,o=`${n}|${D.id??D.timestamp}`;h?.set(o,D);let a,p,t;return D.iconPath&&(k instanceof R.ThemeIcon?t={id:k.id,color:k.color}:g.URI.isUri(k)?(a=k,p=k):{light:a,dark:p}=k),{..._,id:_.id??void 0,handle:o,source:n,command:D.command?P.toInternal(D.command,c):void 0,icon:a,iconDark:p,themeIcon:t,accessibilityInformation:D.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,C.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=E;function S(T){return T?.toString()}}),define(me[256],ge([0,1,6,10,2,5]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(S){this._openers=new Map,this._proxy=S.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,T,n,P){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const c=P.schemes.find(m=>!R.supportedSchemes.has(m));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,n),this._proxy.$registerUriOpener(T,P.schemes,S,P.label),(0,g.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(S,T,n){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener with id: ${S}`);const c=I.URI.revive(T);return P.canOpenExternalUri(c,n)}async $openUri(S,T,n){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener id: '${S}'`);return P.openExternalUri(I.URI.revive(T.resolvedUri),{sourceUri:I.URI.revive(T.sourceUri)},n)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(me[257],ge([0,1,5,2,6,16,26]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class E{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(T,n){if(this.handles.has(R.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const P=E.HandlePool++;return this.handles.add(R.ExtensionIdentifier.toKey(T)),this.handlers.set(P,n),this._proxy.$registerUriHandler(P,T),(0,I.toDisposable)(()=>{this.handles.delete(R.ExtensionIdentifier.toKey(T)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(T,n){const P=this.handlers.get(T);if(!P)return Promise.resolve(void 0);try{P.handleUri(L.URI.revive(n))}catch(c){(0,C.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(T){return L.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=E,E.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[70],ge([0,1,3,2,180,206,88,5]),function(Y,e,g,L,I,C,R,E){"use strict";var S,T,n,P,c,m,u,h,D,k,_,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class a{constructor(d,b,y,v,A,w,F){S.set(this,void 0),T.set(this,void 0),n.set(this,void 0),P.set(this,void 0),c.set(this,void 0),m.set(this,void 0),u.set(this,""),h.set(this,void 0),D.set(this,!1),k.set(this,!1),_.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new g.Emitter),this._onDidDispose=Oe(this,o,"f").event,nt(this,S,d,"f"),nt(this,T,b,"f"),nt(this,h,y,"f"),nt(this,P,v,"f"),nt(this,c,A,"f"),nt(this,m,w,"f"),nt(this,_,p(w),"f"),nt(this,n,F,"f")}dispose(){nt(this,D,!0,"f"),Oe(this,o,"f").fire(),Oe(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return nt(this,k,!0,"f"),(0,R.asWebviewUri)(d,Oe(this,P,"f").remote)}get cspSource(){return R.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,u,"f")}set html(d){this.assertNotDisposed(),Oe(this,u,"f")!==d&&(nt(this,u,d,"f"),!Oe(this,k,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(nt(this,k,!0,"f"),Oe(this,n,"f").report("Webview vscode-resource: uris",Oe(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,T,"f").$setHtml(Oe(this,S,"f"),d))}get options(){return this.assertNotDisposed(),Oe(this,h,"f")}set options(d){this.assertNotDisposed(),Oe(this,T,"f").$setOptions(Oe(this,S,"f"),r(Oe(this,m,"f"),Oe(this,c,"f"),d)),nt(this,h,d,"f")}async postMessage(d){if(Oe(this,D,"f"))return!1;const b=(0,C.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:Oe(this,_,"f")});return Oe(this,T,"f").$postMessage(Oe(this,S,"f"),b.message,...b.buffers)}assertNotDisposed(){if(Oe(this,D,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=a,S=new WeakMap,T=new WeakMap,n=new WeakMap,P=new WeakMap,c=new WeakMap,m=new WeakMap,u=new WeakMap,h=new WeakMap,D=new WeakMap,k=new WeakMap,_=new WeakMap,o=new WeakMap;function p(l){try{const d=(0,I.normalizeVersion)((0,I.parseVersion)(l.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=p;class t{constructor(d,b,y,v,A){this.initData=b,this.workspace=y,this._logService=v,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=d.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(d,b,...y){const v=this.getWebview(d);if(v){const{message:A}=(0,C.deserializeWebviewMessage)(b,y);v._onMessageEmitter.fire(A)}}$onMissingCsp(d,b){this._logService.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,b,y){const v=new a(d,this._webviewProxy,i(b),this.initData,this.workspace,y,this._deprecationService);return this._webviews.set(d,v),v._onDidDispose(()=>{this._webviews.delete(d)}),v}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=t;function s(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=s;function r(l,d,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||f(l,d)}}e.serializeWebviewOptions=r;function i(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(d=>L.URI.from(d))}}e.reviveOptions=i;function f(l,d){return[...(d?.getWorkspaceFolders()||[]).map(b=>b.uri),l.extensionLocation]}}),define(me[258],ge([0,1,21,48,6,10,22,2,15,70,87,5,7]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,s){this.document=t,this._storagePath=s,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,s){await this.getEdit(t).undo(),s||this.disposeBackup()}async redo(t,s){await this.getEdit(t).redo(),s||this.disposeBackup()}disposeEdits(t){for(const s of t)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=a(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const s=this._edits.get(t,0);if(!s)throw new Error("No edit found");return s}}class u{constructor(){this._documents=new Map}get(t,s){return this._documents.get(this.key(t,s))}add(t,s,r){const i=this.key(t,s.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${s.uri}`);const f=new m(s,r);return this._documents.set(i,f),f}delete(t,s){const r=this.key(t,s.uri);this._documents.delete(r)}key(t,s){return`${t}@@@${s}`}}var h;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(h||(h={}));class D{constructor(){this._providers=new Map}addTextProvider(t,s,r){return this.add(0,t,s,r)}addCustomProvider(t,s,r){return this.add(1,t,s,r)}get(t){return this._providers.get(t)}add(t,s,r,i){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:t,extension:r,provider:i}),new c.Disposable(()=>this._providers.delete(s))}}class k{constructor(t,s,r,i,f){this._extHostDocuments=s,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=f,this._editorProviders=new D,this._documents=new u,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,s,r,i){const f=new I.DisposableStore;return _(r)?(f.add(this._editorProviders.addTextProvider(s,t,r)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(t),s,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(t))):(f.add(this._editorProviders.addCustomProvider(s,t,r)),this.supportEditing(r)&&f.add(r.onDidChangeCustomDocument(l=>{const d=this.getCustomDocumentEntry(s,l.document.uri);if(o(l)){const b=d.addEdit(l);this._proxy.$onDidEdit(l.document.uri,s,b,l.label)}else this._proxy.$onContentChange(l.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(t),s,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(t))),c.Disposable.from(f,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(t,s,r,i,f){const l=this._editorProviders.get(s);if(!l)throw new Error(`No provider found for '${s}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${s}'`);const d=E.URI.revive(t),b=await l.provider.openCustomDocument(d,{backupId:r,untitledDocumentData:i?.buffer},f);let y;return this.supportEditing(l.provider)&&this._extensionStoragePaths&&(y=this._extensionStoragePaths.workspaceValue(l.extension)??this._extensionStoragePaths.globalValue(l.extension)),this._documents.add(s,b,y),{editable:this.supportEditing(l.provider)}}async $disposeCustomDocument(t,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${s}'`);const i=E.URI.revive(t),{document:f}=this.getCustomDocumentEntry(s,i);this._documents.delete(s,f),f.dispose()}async $resolveWebviewEditor(t,s,r,i,f,l){const d=this._editorProviders.get(r);if(!d)throw new Error(`No provider found for '${r}'`);const b=S.ViewColumn.to(f),y=this._extHostWebview.createNewWebview(s,i.webviewOptions,d.extension),v=this._extHostWebviewPanels.createNewWebviewPanel(s,r,i.title,b,i.panelOptions,y),A=E.URI.revive(t);switch(d.type){case 1:{const{document:w}=this.getCustomDocumentEntry(r,A);return d.provider.resolveCustomEditor(w,v,l)}case 0:{const w=this._extHostDocuments.getDocument(A);return d.provider.resolveCustomTextEditor(w,v,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,s,r){this.getCustomDocumentEntry(s,t).disposeEdits(r)}async $onMoveCustomEditor(t,s,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const f=this._extHostWebviewPanels.getWebviewPanel(t);if(!f)throw new Error("No webview found");const l=E.URI.revive(s),d=this._extHostDocuments.getDocument(l);await i.provider.moveCustomTextEditor(d,f,g.CancellationToken.None)}async $undo(t,s,r,i){return this.getCustomDocumentEntry(s,t).undo(r,i)}async $redo(t,s,r,i){return this.getCustomDocumentEntry(s,t).redo(r,i)}async $revert(t,s,r){const i=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(t,s,r){const i=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(t,s,r,i){const f=this.getCustomDocumentEntry(s,t);return this.getCustomEditorProvider(s).saveCustomDocumentAs(f.document,E.URI.revive(r),i)}async $backup(t,s,r){const i=this.getCustomDocumentEntry(s,t),l=await this.getCustomEditorProvider(s).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(l),l.id}getCustomDocumentEntry(t,s){const r=this._documents.get(t,E.URI.revive(s));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const r=this._editorProviders.get(t)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=k;function _(p){return typeof p.resolveCustomTextEditor=="function"}function o(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function a(p){const t=p.scheme===C.Schemas.file||p.scheme===C.Schemas.untitled?p.fsPath:p.toString();return(0,L.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[259],ge([0,1,3,6,2,32,15,70,5,7]),function(Y,e,g,L,I,C,R,E,S,T){"use strict";var n,P,c,m,u,h,D,k,_,o,a,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends L.Disposable{constructor(l,d,b,y,v,A,w){super();n.set(this,void 0),P.set(this,void 0),c.set(this,void 0),m.set(this,void 0),u.set(this,void 0),h.set(this,void 0),D.set(this,void 0),k.set(this,void 0),_.set(this,!0),o.set(this,!0),a.set(this,!1),p.set(this,this._register(new g.Emitter)),this.onDidDispose=Oe(this,p,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,nt(this,n,l,"f"),nt(this,P,d,"f"),nt(this,c,b,"f"),nt(this,u,A,"f"),nt(this,k,v,"f"),nt(this,h,y,"f"),nt(this,m,w,"f")}dispose(){Oe(this,a,"f")||(nt(this,a,!0,"f"),Oe(this,p,"f").fire(),Oe(this,P,"f").$disposeWebview(Oe(this,n,"f")),Oe(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,m,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,c,"f")}get title(){return this.assertNotDisposed(),Oe(this,h,"f")}set title(l){this.assertNotDisposed(),Oe(this,h,"f")!==l&&(nt(this,h,l,"f"),Oe(this,P,"f").$setTitle(Oe(this,n,"f"),l))}get iconPath(){return this.assertNotDisposed(),Oe(this,D,"f")}set iconPath(l){this.assertNotDisposed(),Oe(this,D,"f")!==l&&(nt(this,D,l,"f"),Oe(this,P,"f").$setIconPath(Oe(this,n,"f"),I.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Oe(this,u,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,k,"f")=="number"&&Oe(this,k,"f")<0))return Oe(this,k,"f")}get active(){return this.assertNotDisposed(),Oe(this,o,"f")}get visible(){return this.assertNotDisposed(),Oe(this,_,"f")}_updateViewState(l){Oe(this,a,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(nt(this,o,l.active,"f"),nt(this,_,l.visible,"f"),nt(this,k,l.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(l,d){this.assertNotDisposed(),Oe(this,P,"f").$reveal(Oe(this,n,"f"),{viewColumn:l?R.ViewColumn.from(l):void 0,preserveFocus:!!d})}assertNotDisposed(){if(Oe(this,a,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,P=new WeakMap,c=new WeakMap,m=new WeakMap,u=new WeakMap,h=new WeakMap,D=new WeakMap,k=new WeakMap,_=new WeakMap,o=new WeakMap,a=new WeakMap,p=new WeakMap,t=new WeakMap;class r{constructor(l,d,b){this.webviews=d,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(l,d,b,y,v={}){const A=typeof y=="object"?y.viewColumn:y,w={viewColumn:R.ViewColumn.from(A),preserveFocus:typeof y=="object"&&!!y.preserveFocus},F=(0,E.shouldSerializeBuffersForPostMessage)(l),O=r.newHandle();this._proxy.$createWebviewPanel((0,E.toExtensionData)(l),O,d,{title:b,panelOptions:i(v),webviewOptions:(0,E.serializeWebviewOptions)(l,this.workspace,v),serializeBuffersForPostMessage:F},w);const G=this.webviews.createNewWebview(O,v,l);return this.createNewWebviewPanel(O,d,b,A,v,G)}$onDidChangeWebviewPanelViewStates(l){const d=Object.keys(l);d.sort((b,y)=>{const v=l[b],A=l[y];return v.active?1:A.active?-1:+v.visible-+A.visible});for(const b of d){const y=this.getWebviewPanel(b);if(!y)continue;const v=l[b];y._updateViewState({active:v.active,visible:v.visible,viewColumn:R.ViewColumn.to(v.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,d,b){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:b,extension:l}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:(0,E.shouldSerializeBuffersForPostMessage)(l)}),new T.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(l,d,b,y){const v=this._serializers.get(d);if(!v)throw new Error(`No serializer found for '${d}'`);const{serializer:A,extension:w}=v,F=this.webviews.createNewWebview(l,b.webviewOptions,w),O=this.createNewWebviewPanel(l,d,b.title,y,b.panelOptions,F);await A.deserializeWebviewPanel(O,b.state)}createNewWebviewPanel(l,d,b,y,v,A){const w=new s(l,this._proxy,d,b,y,v,A);return this._webviewPanels.set(l,w),w}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=r;function i(f){return{enableFindWidget:f.enableFindWidget,retainContextWhenHidden:f.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[260],ge([0,1,3,6,70,5,7]),function(Y,e,g,L,I,C,R){"use strict";var E,S,T,n,P,c,m,u,h,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class k extends L.Disposable{constructor(a,p,t,s,r,i){super();E.set(this,void 0),S.set(this,void 0),T.set(this,void 0),n.set(this,void 0),P.set(this,!1),c.set(this,void 0),m.set(this,void 0),u.set(this,void 0),h.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Oe(this,h,"f").event,D.set(this,this._register(new g.Emitter)),this.onDidDispose=Oe(this,D,"f").event,nt(this,T,t,"f"),nt(this,m,s,"f"),nt(this,E,a,"f"),nt(this,S,p,"f"),nt(this,n,r,"f"),nt(this,c,i,"f")}dispose(){Oe(this,P,"f")||(nt(this,P,!0,"f"),Oe(this,D,"f").fire(),Oe(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,m,"f")}set title(a){this.assertNotDisposed(),Oe(this,m,"f")!==a&&(nt(this,m,a,"f"),Oe(this,S,"f").$setWebviewViewTitle(Oe(this,E,"f"),a))}get description(){return this.assertNotDisposed(),Oe(this,u,"f")}set description(a){this.assertNotDisposed(),Oe(this,u,"f")!==a&&(nt(this,u,a,"f"),Oe(this,S,"f").$setWebviewViewDescription(Oe(this,E,"f"),a))}get visible(){return Oe(this,c,"f")}get webview(){return Oe(this,n,"f")}get viewType(){return Oe(this,T,"f")}_setVisible(a){a===Oe(this,c,"f")||Oe(this,P,"f")||(nt(this,c,a,"f"),Oe(this,h,"f").fire())}show(a){this.assertNotDisposed(),Oe(this,S,"f").$show(Oe(this,E,"f"),!!a)}assertNotDisposed(){if(Oe(this,P,"f"))throw new Error("Webview is disposed")}}E=new WeakMap,S=new WeakMap,T=new WeakMap,n=new WeakMap,P=new WeakMap,c=new WeakMap,m=new WeakMap,u=new WeakMap,h=new WeakMap,D=new WeakMap;class _{constructor(a,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=a.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(a,p,t,s){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:t,extension:a}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(a),p,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new R.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(a,p,t,s,r){const i=this._viewProviders.get(p);if(!i)throw new Error(`No view provider found for '${p}'`);const{provider:f,extension:l}=i,d=this._extHostWebview.createNewWebview(a,{},l),b=new k(a,this._proxy,p,t,d,!0);this._webviewViews.set(a,b),await f.resolveWebviewView(b,{state:s},r)}async $onDidChangeWebviewViewVisibility(a,p){this.getWebviewView(a)._setVisible(p)}async $disposeWebviewView(a){const p=this.getWebviewView(a);this._webviewViews.delete(a),p.dispose(),this._extHostWebview.deleteWebview(a)}getWebviewView(a){const p=this._webviewViews.get(a);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=_}),define(me[132],ge([0,1,3,5,2,10,9,4,14]),function(Y,e,g,L,I,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class Wn{constructor(P){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wn.InitialState,this._proxy=P.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state={...this._state,focused:P},this._onDidChangeWindowState.fire(this._state))}openUri(P,c){let m;if(typeof P=="string"){m=P;try{P=I.URI.parse(P)}catch(u){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,R.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,m,c)}async asExternalUri(P,c){if((0,R.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(P,c);return I.URI.from(m)}};T.InitialState={focused:!0},T=Ve([$e(0,S.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,E.createDecorator)("IExtHostWindow")}),define(me[261],ge([0,1,8,80,32,44,6,5,2,14]),function(Y,e,g,L,I,C,R,E,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let n=class extends R.Disposable{constructor(c,m){super();const u=c.getProxy(E.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async h=>{const D=S.URI.file((0,g.join)((0,L.tmpdir)(),(0,I.generateUuid)()));return await u.$download(h,D),D})}};n=Ve([$e(0,T.IExtHostRpcService),$e(1,C.IExtHostCommands)],n),e.ExtHostDownloadService=n}),define(me[262],ge([0,1,2,8,152,28,68,27,14,6,12,116,42]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class m{constructor(k,_,o){this.name=k,this.file=_,this.appender=o}static async create(k,_){const o=await(0,P.createRotatingLogger)(k,_,30*c.ByteSize.MB,1);return o.clearFormatters(),new m(k,_,o)}append(k){this.appender.critical(k)}flush(){this.appender.flush()}}class u extends R.AbstractExtHostOutputChannel{constructor(k,_,o,a){super(k,!1,g.URI.file(_.file),o,a);this._appender=_}append(k){super.append(k),this._appender.append(k),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(k,_){this._appender.flush(),super.show(k,_)}clear(){this._appender.flush(),super.clear()}}let h=class extends R.ExtHostOutputService{constructor(k,_,o){super(k);this.logService=_,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new T.MutableDisposable,this._logsLocation=o.logsLocation}$setVisibleChannel(k){if(k){const _=this._channels.get(k);_&&(this._visibleChannelDisposable.value=_.onDidAppend(()=>_.update()))}}createOutputChannel(k,_){if(k=k.trim(),!k)throw new Error("illegal argument `name`. must not be falsy");const o=this._doCreateOutChannel(k,_);return o.then(a=>a._id.then(p=>this._channels.set(p,a))),new R.LazyOutputChannel(k,o)}async _doCreateOutChannel(k,_){try{const o=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await C.SymlinkSupport.existsDirectory(o)||await C.Promises.mkdir(o,{recursive:!0});const p=`${this._namePool++}-${k.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=g.URI.file((0,L.join)(o,`${p}.log`)),s=await m.create(p,t.fsPath);return new u(k,s,_.identifier.value,this._proxy)}catch(o){return this.logService.error(o),new R.ExtHostPushOutputChannel(k,_.identifier.value,this._proxy)}}};h=Ve([$e(0,S.IExtHostRpcService),$e(1,n.ILogService),$e(2,E.IExtHostInitDataService)],h),e.ExtHostOutputService2=h}),define(me[263],ge([0,1,50,294,2,69,6,10,18]),function(Y,e,g,L,I,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class T extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(p){const t=await super._getWorkspaceStorageURI(p);if(t.scheme!==E.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const s=t.fsPath;let r=0;do{let i;r===0?i=s:i=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${r}`:`${s}-${r}`,await n(i);const f=L.join(i,"vscode.lock"),l=await u(this._logService,f,!1);if(l)return this._workspaceStorageLock=l,process.on("exit",()=>{l.dispose()}),I.URI.file(i);r++}while(r<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=T;async function n(a){try{await g.promises.stat(a);return}catch{}try{await g.promises.mkdir(a,{recursive:!0})}catch{}}const P=1e3,c=10*60*1e3;class m extends R.Disposable{constructor(p,t){super();this.logService=p,this.filename=t,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await h(p,t);(!s||s.pid!==process.pid)&&(p.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await g.promises.utimes(t,new Date,new Date)}catch(r){p.error(r),p.info(`Lock '${t}': Could not update mtime.`)}},P)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(p){}}async setWillRelease(p){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${p} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+p};await g.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function u(a,p,t){try{const r={pid:process.pid,willReleaseAt:0};await g.promises.writeFile(p,JSON.stringify(r),{flag:"wx"})}catch(r){a.error(r)}const s=await h(a,p);return!s||s.pid!==process.pid?t?(a.info(`Lock '${p}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${p}': Could not acquire lock, checking if the file is stale.`),_(a,p)):(a.info(`Lock '${p}': Lock acquired.`),new m(a,p))}async function h(a,p){let t;try{t=await g.promises.readFile(p)}catch(s){return a.error(s),null}try{return JSON.parse(String(t))}catch(s){return a.error(s),null}}async function D(a,p){let t;try{t=await g.promises.stat(p)}catch(s){return a.error(s),0}return t.mtime.getTime()}function k(a){try{return process.kill(a,0),!0}catch(p){return!1}}async function _(a,p){const t=await h(a,p);if(!t)return a.info(`Lock '${p}': Could not read pid of lock holder.`),o(a,p);if(t.willReleaseAt){let l=t.willReleaseAt-Date.now();if(l<5e3){for(l>0?a.info(`Lock '${p}': The lockfile is scheduled to be released in ${l} ms.`):a.info(`Lock '${p}': The lockfile is scheduled to have been released.`);l>0;){if(await(0,S.timeout)(Math.min(100,l)),await D(a,p)===0)return o(a,p);l=t.willReleaseAt-Date.now()}return o(a,p)}}if(!k(t.pid))return a.info(`Lock '${p}': The pid ${t.pid} appears to be gone.`),o(a,p);const s=await D(a,p),r=Date.now()-s;if(r<=c)return a.info(`Lock '${p}': The lock does not look stale, elapsed: ${r} ms, giving up.`),null;a.info(`Lock '${p}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const i=await D(a,p),f=Date.now()-i;return f<=c?(a.info(`Lock '${p}': The lock does not look stale, elapsed: ${f} ms, giving up.`),null):(a.info(`Lock '${p}': The lock looks stale even after waiting for 2s.`),o(a,p))}async function o(a,p){a.info(`Lock '${p}': Deleting a stale lock.`);try{await g.promises.unlink(p)}catch(t){}return u(a,p,!0)}}),define(me[264],ge([0,1,32,14,33]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends I.BaseExtHostTerminalService{constructor(E){super(!0,E)}createTerminal(E,S,T){return this.createTerminalFromOptions({name:E,shellPath:S,shellArgs:T})}createTerminalFromOptions(E,S){const T=new I.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),E,E.name);return this._terminals.push(T),T.create(E,this._serializeParentTerminal(E,S)),T.value}_serializeParentTerminal(E,S){if(S=S||{},E.location&&typeof E.location=="object"&&"parentTerminal"in E.location){const T=E.location.parentTerminal;if(T){const n=this._terminals.find(P=>P.value===T);n&&(S.resolvedExtHostIdentifier=n._id)}}else E.location&&typeof E.location!="object"?S.location=E.location:S.location&&typeof S.location=="object"&&"splitActiveTerminal"in S.location&&(S.location={splitActiveTerminal:!0});return S}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(me[265],ge([0,1,5,14,6,27,2,39,22,28,7,11,53,3,194,77,12]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class k{constructor(d,b,y){this.remoteAddress=d,this.localAddress=b,this._dispose=y,this._onDispose=new m.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function _(l){const d=l.trim().split(`
`),b=[];return d.forEach(v=>{const A=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(v);A&&A.length>=3&&b.push({pid:parseInt(A[1],10),socket:parseInt(A[2],10)})}),b.reduce((v,A)=>(v[A.socket]=A,v),{})}e.getSockets=_;function o(...l){const d=[].concat(...l.map(p));return[...new Map(d.filter(b=>b.st==="0A").map(b=>{const y=b.local_address.split(":");return{socket:parseInt(b.inode,10),ip:a(y[0]),port:parseInt(y[1],16)}}).map(b=>[b.ip+":"+b.port,b])).values()]}e.loadListeningPorts=o;function a(l){let d="";if(l.length===8)for(let b=l.length-2;b>=0;b-=2)d+=parseInt(l.substr(b,2),16),b!==0&&(d+=".");else for(let b=l.length-4;b>=0;b-=4)d+=parseInt(l.substr(b,4),16).toString(16),b!==0&&(d+=":");return d}e.parseIpAddress=a;function p(l){const d=l.trim().split(`
`),b=d.shift().trim().split(/\s+/).filter(v=>v!=="rx_queue"&&v!=="tm->when");return d.map(v=>v.trim().split(/\s+/).reduce((A,w,F)=>(A[b[F]||F]=w,A),{}))}e.loadConnectionTable=p;function t(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/vs/server/main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function s(l){const d=l.trim().split(`
`),b=[];return d.forEach(y=>{const v=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(y);v&&v.length>=4&&b.push({pid:parseInt(v[1],10),ppid:parseInt(v[2]),cmd:v[3]})}),b}e.getRootProcesses=s;async function r(l,d,b){const y=b.reduce((A,w)=>(A[w.pid]=w,A),{}),v=[];return l.forEach(({socket:A,ip:w,port:F})=>{const O=d[A]?d[A].pid:void 0,G=O?y[O]?.cmd:void 0;O&&G&&!t(G)&&v.push({host:w,port:F,detail:G,pid:O})}),v}e.findPorts=r;function i(l,d,b){const y=new Map,v=s(d);for(const A of l){const w=b.get(A.port);if(w){y.set(A.port,w);continue}const F=v.find(O=>O.cmd.includes(`${A.port}`));if(F){let O=F,G;do G=v.find(K=>K.ppid===O.pid),G&&(O=G);while(G);y.set(A.port,{host:A.ip,port:A.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else y.set(A.port,{host:A.ip,port:A.port,ppid:Number.MAX_VALUE})}return y}e.tryFindRootPorts=i;let f=class extends I.Disposable{constructor(d,b,y){super();this.logService=y,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new m.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=d.getProxy(g.MainContext.MainThreadTunnelService),P.isLinux&&b.remote.isRemote&&b.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(d,b){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${b.remoteAddress.host}:${b.remoteAddress.port}.`);const y=await this._proxy.$openTunnel(b,d.displayName);if(y){const v=new k(y.remoteAddress,y.localAddress,()=>this._proxy.$closeTunnel(y.remoteAddress));return this._register(v),v}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(d){return Math.max(d*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(d,b){const y=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(y,{selector:d,provider:b}),this._proxy.$registerPortsAttributesProvider(d,y),new n.Disposable(()=>{this._portAttributesProviders.delete(y),this._proxy.$unregisterPortsAttributesProvider(y)})}async $providePortAttributes(d,b,y,v,A){const w=[];for(const O of d){const G=this._portAttributesProviders.get(O);if(!G)return[];w.push(...await Promise.all(b.map(async K=>G.provider.providePortAttributes(K,y,v,A))))}const F=w.filter(O=>!!O);return F.length>0?F.map(O=>({autoForwardAction:O.autoForwardAction,port:O.port})):[]}async $registerCandidateFinder(d){if(d&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=d;let b=new h.MovingAverage,y;for(;this._candidateFindingEnabled;){const v=new Date().getTime(),A=(await this.findCandidatePorts()).filter(F=>(0,u.isLocalhost)(F.host)||(0,u.isAllInterfaces)(F.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${A.map(F=>F.port).join(", ")}`);const w=new Date().getTime()-v;b.update(w),(!y||JSON.stringify(y)!==JSON.stringify(A))&&(y=A,await this._proxy.$onFoundNewCandidates(y)),await new Promise(F=>setTimeout(()=>F(),this.calculateDelay(b.value)))}}async setTunnelExtensionFunctions(d){return d?(d.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this._showCandidatePort=d.showCandidatePort,this._proxy.$setCandidateFilter()),d.tunnelFactory&&(this._forwardPortProvider=d.tunnelFactory,this._proxy.$setTunnelProvider(d.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,I.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(d,b){if(this._extensionTunnels.has(d.host)){const y=this._extensionTunnels.get(d.host);y.has(d.port)&&(b&&y.get(d.port).disposeListener.dispose(),await y.get(d.port).tunnel.dispose(),y.delete(d.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(d,b){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const y=this._forwardPortProvider(d,b);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),y!==void 0){const v=await y;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(d.remoteAddress.host)||this._extensionTunnels.set(d.remoteAddress.host,new Map);const A=this._register(v.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(v.remoteAddress))));return this._extensionTunnels.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:v,disposeListener:A}),c.TunnelDto.fromApiTunnel(v)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(y){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(d){const b=await Promise.all(d.map(v=>this._showCandidatePort(v.host,v.port,v.detail??""))),y=d.filter((v,A)=>b[A]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(v=>v.port).join(", ")} to ${y.map(v=>v.port).join(", ")}`),y}async findCandidatePorts(){let d="",b="";try{d=await T.Promises.readFile("/proc/net/tcp","utf8"),b=await T.Promises.readFile("/proc/net/tcp6","utf8")}catch(z){}const y=o(d,b),v=await new Promise(z=>{(0,E.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(N,B,x)=>{z(B)})}),A=_(v),w=await T.Promises.readdir("/proc"),F=[];for(let z of w)try{const N=Number(z),B=S.joinPath(R.URI.file("/proc"),z);if((await T.Promises.stat(B.fsPath)).isDirectory()&&!isNaN(N)){const M=await T.Promises.readlink(S.joinPath(B,"cwd").fsPath),H=await T.Promises.readFile(S.joinPath(B,"cmdline").fsPath,"utf8");F.push({pid:N,cwd:M,cmd:H})}}catch(N){}const O=[],G=y.filter(z=>{const N=A[z.socket];return N||O.push(z),N}),K=r(G,A,F);let U;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const z=await new Promise(N=>{(0,E.exec)("ps -F -A -l | grep root",(B,x,M)=>{N(x)})});this._foundRootPorts=i(O,z,this._foundRootPorts),U=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.join(", ")}`)}return K.then(z=>U?z.concat(U):z)}};f=Ve([$e(0,L.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,D.ILogService)],f),e.ExtHostTunnelService=f}),define(me[266],ge([0,1,18,23,21,16,3,6,103,230,66]),function(Y,e,g,L,I,C,R,E,S,T,n){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(v,A){try{return JSON.stringify(v,A)}catch(w){return"null"}}const m="$$ref$$",u={[m]:-1};class h{constructor(A,w){this.jsonString=A,this.referencedBuffers=w}}function D(v,A=null,w=!1){const F=[];return{jsonString:(w?c:JSON.stringify)(v,(G,K)=>{if(typeof K=="undefined")return u;if(typeof K=="object"){if(K instanceof L.VSBuffer){const U=F.push(K)-1;return{[m]:U}}if(A)return A(G,K)}return K}),referencedBuffers:F}}e.stringifyJsonWithBufferRefs=D;function k(v,A,w){return JSON.parse(v,(F,O)=>{if(O){const G=O[m];if(typeof G=="number")return A[G];if(w&&O.$mid===1)return w.transformIncoming(O)}return O})}e.parseJsonAndRestoreBufferRefs=k;function _(v,A){return JSON.stringify(v,A)}function o(v){return v?(A,w)=>w&&w.$mid===1?v.transformOutgoing(w):w:null}var a;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},s=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends E.Disposable{constructor(A,w=null,F=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=A,this._logger=w,this._uriTransformer=F,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let O=0,G=n.ProxyIdentifier.count;O<G;O++)this._locals[O]=null,this._proxies[O]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(O=>this._receiveOneMessage(O))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(A=>{this._pendingRPCReplies[A].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(A){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(A){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(A){this._responsiveState!==A&&(this._responsiveState=A,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(A){return this._uriTransformer?(0,S.transformIncomingURIs)(A,this._uriTransformer):A}getProxy(A){const{nid:w,sid:F}=A;return this._proxies[w]||(this._proxies[w]=this._createProxy(w,F)),this._proxies[w]}_createProxy(A,w){let F={get:(O,G)=>(typeof G=="string"&&!O[G]&&G.charCodeAt(0)===36&&(O[G]=(...K)=>this._remoteCall(A,G,K)),G===r?w:O[G])};return new Proxy(Object.create(null),F)}set(A,w){return this._locals[A.nid]=w,w}assertRegistered(A){for(let w=0,F=A.length;w<F;w++){const O=A[w];if(!this._locals[O.nid])throw new Error(`Missing actor ${O.sid} (isMain: ${O.isMain})`)}}_receiveOneMessage(A){if(this._isDisposed)return;const w=A.byteLength,F=f.read(A,0),O=F.readUInt8(),G=F.readUInt32();switch(O){case 1:case 2:{let{rpcId:K,method:U,args:z}=d.deserializeRequestJSONArgs(F);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(w,G,K,U,z,O===2);break}case 3:case 4:{let{rpcId:K,method:U,args:z}=d.deserializeRequestMixedArgs(F);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(w,G,K,U,z,O===4);break}case 5:{this._logger&&this._logger.logIncoming(w,G,0,"ack"),this._onDidReceiveAcknowledge(G);break}case 6:{this._receiveCancel(w,G);break}case 7:{this._receiveReply(w,G,void 0);break}case 9:{let K=d.deserializeReplyOKJSON(F);this._uriTransformer&&(K=(0,S.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReply(w,G,K);break}case 10:{const K=d.deserializeReplyOKJSONWithBuffers(F,this._uriTransformer);this._receiveReply(w,G,K);break}case 8:{let K=d.deserializeReplyOKVSBuffer(F);this._receiveReply(w,G,K);break}case 11:{let K=d.deserializeReplyErrError(F);this._uriTransformer&&(K=(0,S.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReplyErr(w,G,K);break}case 12:{this._receiveReplyErr(w,G,void 0);break}default:console.error("received unexpected message"),console.error(A)}}_receiveRequest(A,w,F,O,G,K){this._logger&&this._logger.logIncoming(A,w,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(F)}.${O}(`,G);const U=String(w);let z,N;if(K){const x=new I.CancellationTokenSource;G.push(x.token),z=this._invokeHandler(F,O,G),N=()=>x.cancel()}else z=this._invokeHandler(F,O,G),N=t;this._cancelInvokedHandlers[U]=N;const B=d.serializeAcknowledged(w);this._logger&&this._logger.logOutgoing(B.byteLength,w,1,"ack"),this._protocol.send(B),z.then(x=>{delete this._cancelInvokedHandlers[U];const M=d.serializeReplyOK(w,x,this._uriReplacer);this._logger&&this._logger.logOutgoing(M.byteLength,w,1,"reply:",x),this._protocol.send(M)},x=>{delete this._cancelInvokedHandlers[U];const M=d.serializeReplyErr(w,x);this._logger&&this._logger.logOutgoing(M.byteLength,w,1,"replyErr:",x),this._protocol.send(M)})}_receiveCancel(A,w){this._logger&&this._logger.logIncoming(A,w,1,"receiveCancel");const F=String(w);this._cancelInvokedHandlers[F]&&this._cancelInvokedHandlers[F]()}_receiveReply(A,w,F){this._logger&&this._logger.logIncoming(A,w,0,"receiveReply:",F);const O=String(w);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const G=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],G.resolveOk(F)}_receiveReplyErr(A,w,F){this._logger&&this._logger.logIncoming(A,w,0,"receiveReplyErr:",F);const O=String(w);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const G=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O];let K;F&&(F.$isError?(K=new Error,K.name=F.name,K.message=F.message,K.stack=F.stack):K=F),G.resolveErr(K)}_invokeHandler(A,w,F){try{return Promise.resolve(this._doInvokeHandler(A,w,F))}catch(O){return Promise.reject(O)}}_doInvokeHandler(A,w,F){const O=this._locals[A];if(!O)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(A));let G=O[w];if(typeof G!="function")throw new Error("Unknown method "+w+" on actor "+(0,n.getStringIdentifierForProxy)(A));return G.apply(O,F)}_remoteCall(A,w,F){if(this._isDisposed)return Promise.reject(C.canceled());let O=null;if(F.length>0&&I.CancellationToken.isCancellationToken(F[F.length-1])&&(O=F.pop()),O&&O.isCancellationRequested)return Promise.reject(C.canceled());const G=d.serializeRequestArguments(F,this._uriReplacer),K=++this._lastMessageId,U=String(K),z=new T.LazyPromise;O&&O.onCancellationRequested(()=>{const B=d.serializeCancel(K);this._logger&&this._logger.logOutgoing(B.byteLength,K,0,"cancel"),this._protocol.send(d.serializeCancel(K))}),this._pendingRPCReplies[U]=z,this._onWillSendRequest(K);const N=d.serializeRequest(K,A,w,G,!!O);return this._logger&&this._logger.logOutgoing(N.byteLength,K,0,`request: ${(0,n.getStringIdentifierForProxy)(A)}.${w}(`,F),this._protocol.send(N),z}}e.RPCProtocol=i,P=s,i.UNRESPONSIVE_TIME=3*1e3;class f{constructor(A,w){this._buff=A,this._offset=w}static alloc(A,w,F){let O=new f(L.VSBuffer.alloc(F+1+4),0);return O.writeUInt8(A),O.writeUInt32(w),O}static read(A,w){return new f(A,w)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(A){this._buff.writeUInt8(A,this._offset),this._offset+=1}readUInt8(){const A=this._buff.readUInt8(this._offset);return this._offset+=1,A}writeUInt32(A){this._buff.writeUInt32BE(A,this._offset),this._offset+=4}readUInt32(){const A=this._buff.readUInt32BE(this._offset);return this._offset+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this._buff.writeUInt8(A.byteLength,this._offset),this._offset+=1,this._buff.set(A,this._offset),this._offset+=A.byteLength}readShortString(){const A=this._buff.readUInt8(this._offset);this._offset+=1;const F=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,F}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readLongString(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,F}writeBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readVSBuffer(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const w=this._buff.slice(this._offset,this._offset+A);return this._offset+=A,w}static sizeMixedArray(A){let w=0;w+=1;for(let F=0,O=A.length;F<O;F++){const G=A[F];switch(w+=1,G.type){case 1:w+=this.sizeLongString(G.value);break;case 2:w+=this.sizeVSBuffer(G.value);break;case 3:w+=this.sizeUInt32,w+=this.sizeLongString(G.value);for(let K=0;K<G.buffers.length;++K)w+=this.sizeVSBuffer(G.buffers[K]);break;case 4:break}}return w}writeMixedArray(A){this._buff.writeUInt8(A.length,this._offset),this._offset+=1;for(let w=0,F=A.length;w<F;w++){const O=A[w];switch(O.type){case 1:this.writeUInt8(1),this.writeLongString(O.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(O.value);break;case 3:this.writeUInt8(3),this.writeUInt32(O.buffers.length),this.writeLongString(O.value);for(let G=0;G<O.buffers.length;++G)this.writeBuffer(O.buffers[G]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this._buff.readUInt8(this._offset);this._offset+=1;let w=new Array(A);for(let F=0;F<A;F++)switch(this.readUInt8()){case 1:w[F]=this.readLongString();break;case 2:w[F]=this.readVSBuffer();break;case 3:const G=this.readUInt32(),K=this.readLongString(),U=[];for(let z=0;z<G;++z)U.push(this.readVSBuffer());w[F]=new n.SerializableObjectWithBuffers(k(K,U,null));break;case 4:w[F]=void 0;break}return w}}f.sizeUInt32=4;var l;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(l||(l={}));class d{static _useMixedArgSerialization(A){for(let w=0,F=A.length;w<F;w++)if(A[w]instanceof L.VSBuffer||A[w]instanceof n.SerializableObjectWithBuffers||typeof A[w]=="undefined")return!0;return!1}static serializeRequestArguments(A,w){if(this._useMixedArgSerialization(A)){const F=[];for(let O=0,G=A.length;O<G;O++){const K=A[O];if(K instanceof L.VSBuffer)F[O]={type:2,value:K};else if(typeof K=="undefined")F[O]={type:4};else if(K instanceof n.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:z}=D(K.value,w);F[O]={type:3,value:L.VSBuffer.fromString(U),buffers:z}}else F[O]={type:1,value:L.VSBuffer.fromString(_(K,w))}}return{type:1,args:F}}return{type:0,args:_(A,w)}}static serializeRequest(A,w,F,O,G){switch(O.type){case 0:return this._requestJSONArgs(A,w,F,O.args,G);case 1:return this._requestMixedArgs(A,w,F,O.args,G)}}static _requestJSONArgs(A,w,F,O,G){const K=L.VSBuffer.fromString(F),U=L.VSBuffer.fromString(O);let z=0;z+=f.sizeUInt8(),z+=f.sizeShortString(K),z+=f.sizeLongString(U);let N=f.alloc(G?2:1,A,z);return N.writeUInt8(w),N.writeShortString(K),N.writeLongString(U),N.buffer}static deserializeRequestJSONArgs(A){const w=A.readUInt8(),F=A.readShortString(),O=A.readLongString();return{rpcId:w,method:F,args:JSON.parse(O)}}static _requestMixedArgs(A,w,F,O,G){const K=L.VSBuffer.fromString(F);let U=0;U+=f.sizeUInt8(),U+=f.sizeShortString(K),U+=f.sizeMixedArray(O);let z=f.alloc(G?4:3,A,U);return z.writeUInt8(w),z.writeShortString(K),z.writeMixedArray(O),z.buffer}static deserializeRequestMixedArgs(A){const w=A.readUInt8(),F=A.readShortString(),O=A.readMixedArray(),G=new Array(O.length);for(let K=0,U=O.length;K<U;K++){const z=O[K];typeof z=="string"?G[K]=JSON.parse(z):G[K]=z}return{rpcId:w,method:F,args:G}}static serializeAcknowledged(A){return f.alloc(5,A,0).buffer}static serializeCancel(A){return f.alloc(6,A,0).buffer}static serializeReplyOK(A,w,F){if(typeof w=="undefined")return this._serializeReplyOKEmpty(A);if(w instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(A,w);if(w instanceof n.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:G}=D(w.value,F,!0);return this._serializeReplyOKJSONWithBuffers(A,O,G)}else return this._serializeReplyOKJSON(A,c(w,F))}static _serializeReplyOKEmpty(A){return f.alloc(7,A,0).buffer}static _serializeReplyOKVSBuffer(A,w){let F=0;F+=f.sizeVSBuffer(w);let O=f.alloc(8,A,F);return O.writeVSBuffer(w),O.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static _serializeReplyOKJSON(A,w){const F=L.VSBuffer.fromString(w);let O=0;O+=f.sizeLongString(F);let G=f.alloc(9,A,O);return G.writeLongString(F),G.buffer}static _serializeReplyOKJSONWithBuffers(A,w,F){const O=L.VSBuffer.fromString(w);let G=0;G+=f.sizeUInt32,G+=f.sizeLongString(O);for(const U of F)G+=f.sizeVSBuffer(U);let K=f.alloc(10,A,G);K.writeUInt32(F.length),K.writeLongString(O);for(const U of F)K.writeBuffer(U);return K.buffer}static deserializeReplyOKJSON(A){const w=A.readLongString();return JSON.parse(w)}static deserializeReplyOKJSONWithBuffers(A,w){const F=A.readUInt32(),O=A.readLongString(),G=[];for(let K=0;K<F;++K)G.push(A.readVSBuffer());return new n.SerializableObjectWithBuffers(k(O,G,w))}static serializeReplyErr(A,w){return w?this._serializeReplyErrEror(A,w):this._serializeReplyErrEmpty(A)}static _serializeReplyErrEror(A,w){const F=L.VSBuffer.fromString(c(C.transformErrorForSerialization(w),null));let O=0;O+=f.sizeLongString(F);let G=f.alloc(11,A,O);return G.writeLongString(F),G.buffer}static deserializeReplyErrError(A){const w=A.readLongString();return JSON.parse(w)}static _serializeReplyErrEmpty(A){return f.alloc(12,A,0).buffer}}var b;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var y;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(y||(y={}))}),define(me[267],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(me[268],ge([0,1,10,8,11,2,4,86,43,225,267]),function(Y,e,g,L,I,C,R,E,S,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,R.createDecorator)("pathService");let P=class $n{constructor(m,u,h,D){this.localUserHome=m,this.remoteAgentService=u,this.environmentService=h,this.contextService=D,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||I.OS)(),this.resolveUserHome=(async()=>{const k=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=k?.userHome||m})()}get defaultUriScheme(){return $n.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,u){if(m.remoteAuthority)return g.Schemas.vscodeRemote;const h=(0,E.getVirtualWorkspaceScheme)(u.getWorkspace());if(h)return h;const D=u.getWorkspace().folders[0];if(D)return D.uri.scheme;const k=u.getWorkspace().configuration;return k?k.scheme:g.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?L.win32:L.posix)}async fileURI(m){let u="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const D=m.indexOf("/",2);D===-1?(u=m.substring(2),m="/"):(u=m.substring(2,D),m=m.substring(D)||"/")}return C.URI.from({scheme:g.Schemas.file,authority:u,path:m,query:"",fragment:""})}};P=Ve([$e(1,n.IRemoteAgentService),$e(2,T.IWorkbenchEnvironmentService),$e(3,S.IWorkspaceContextService)],P),e.AbstractPathService=P}),define(me[71],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(R,E){this.line=R,this.character=E}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,E){return new g(0,0)}with(R){return new g(0,0)}}e.Position=g;class L{constructor(R,E,S,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(R,E),this.end=new g(S,T)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.Range=L;var I;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,17,30,25,29,9,4,8,16,71,13]),function(Y,e,g,L,I,C,R,E,S,T,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",m=" characters skipped \u27EB",u=(c.length+m.length+5)*2;e.ISearchService=(0,E.createDecorator)("searchService");var h;(function(B){B[B.file=0]="file",B[B.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var D;(function(B){B[B.File=1]="File",B[B.Text=2]="Text"})(D=e.QueryType||(e.QueryType={}));function k(B){return!!B.preview}e.resultIsMatch=k;function _(B){return!!B.resource}e.isFileMatch=_;function o(B){return!!B.message}e.isProgressMessage=o;var a;(function(B){B[B.Normal=0]="Normal",B[B.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(x){this.resource=x,this.results=[]}}e.FileMatch=p;class t{constructor(x,M,H){this.ranges=M;const $=Array.isArray(M)?M:[M];if(H&&H.matchLines===1&&s($)){x=(0,R.getNLines)(x,H.matchLines);let Q="",X=0,he=0;const _e=Math.floor(H.charsPerLine/5),ye=[];for(const Re of $){const We=Math.max(Re.startColumn-_e,0),Be=Re.startColumn+H.charsPerLine;if(We>he+_e+u){const je=c+(We-he)+m;Q+=je+x.slice(We,Be),X+=We-(he+je.length)}else Q+=x.slice(he,Be);ye.push(new i(0,Re.startColumn-X,Re.endColumn-X)),he=Be}this.preview={text:Q,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const Q=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:x,matches:(0,g.mapArrayOrNot)(M,X=>new r(X.startLineNumber-Q,X.startColumn,X.endLineNumber-Q,X.endColumn))}}}}e.TextSearchMatch=t;function s(B){const x=B[0].startLineNumber;for(const M of B)if(M.startLineNumber!==x||M.endLineNumber!==x)return!1;return!0}class r{constructor(x,M,H,$){this.startLineNumber=x,this.startColumn=M,this.endLineNumber=H,this.endColumn=$}}e.SearchRange=r;class i extends r{constructor(x,M,H){super(x,M,x,H)}}e.OneLineRange=i;var f;(function(B){B.Default="default",B.FileNames="fileNames",B.Type="type",B.Modified="modified",B.CountDescending="countDescending",B.CountAscending="countAscending"})(f=e.SearchSortOrder||(e.SearchSortOrder={}));function l(B,x=!0){const M=B&&B.files&&B.files.exclude,H=x&&B&&B.search&&B.search.exclude;if(!M&&!H)return;if(!M||!H)return M||H;let $=Object.create(null);return $=I.mixin($,I.deepClone(M)),$=I.mixin($,I.deepClone(H),!0),$}e.getExcludes=l;function d(B,x){return B.excludePattern&&L.match(B.excludePattern,x)?!1:B.includePattern||B.usingSearchPaths?B.includePattern&&L.match(B.includePattern,x)?!0:B.usingSearchPaths?!!B.folderQueries&&B.folderQueries.some(M=>{const H=M.folder.fsPath;if(C.isEqualOrParent(x,H)){const $=S.relative(H,x);return!M.includePattern||!!L.match(M.includePattern,$)}else return!1}):!1:!0}e.pathIncludedInQuery=d;var b;(function(B){B[B.unknownEncoding=1]="unknownEncoding",B[B.regexParseError=2]="regexParseError",B[B.globParseError=3]="globParseError",B[B.invalidLiteral=4]="invalidLiteral",B[B.rgProcessError=5]="rgProcessError",B[B.other=6]="other",B[B.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class y extends Error{constructor(x,M){super(x);this.code=M}}e.SearchError=y;function v(B){const x=B.message;if((0,T.isPromiseCanceledError)(B))return new y(x,b.canceled);try{const M=JSON.parse(x);return new y(M.message,M.code)}catch(M){return new y(x,b.other)}}e.deserializeSearchError=v;function A(B){const x={message:B.message,code:B.code};return new Error(JSON.stringify(x))}e.serializeSearchError=A;function w(B){return B.type==="error"?!0:B.type==="success"}e.isSerializedSearchComplete=w;function F(B){return B.type==="success"}e.isSerializedSearchSuccess=F;function O(B){return!!B.path}e.isSerializedFileMatch=O;function G(B,x){const M=B.searchPath?B.searchPath:B.relativePath;return(0,R.fuzzyContains)(M,x)}e.isFilePatternMatch=G;class K{constructor(x){this.path=x,this.results=[]}addMatch(x){this.results.push(x)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=K;function U(B,x){const M={...B||{},...x||{}};return Object.keys(M).filter(H=>{const $=M[H];return typeof $=="boolean"&&$})}e.resolvePatternsForProvider=U;class z{constructor(x,M){this._parsedIncludeExpression=null,this._excludeExpression={...x.excludePattern||{},...M.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let H=x.includePattern;M.includePattern&&(H?H={...H,...M.includePattern}:H=M.includePattern),H&&(this._parsedIncludeExpression=L.parse(H))}includedInQuerySync(x,M,H){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(x,M,H)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(x,M,H))}includedInQuery(x,M,H){const $=this._parsedExcludeExpression(x,M,H),Q=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(x,M,H):!0;return(0,P.isPromise)($)?$.then(X=>X?!1:Q()):Q()}hasSiblingExcludeClauses(){return N(this._excludeExpression)}}e.QueryGlobTester=z;function N(B){for(const x in B)if(typeof B[x]!="boolean")return!0;return!1}}),define(me[36],ge([0,1,17,18,21,3,24,10,77,22,9,13,2,170,4,12,190,43,52,27,14,7,31,5]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D,k,_,o,a,p,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(A,w,F){return new T.ExtUri(O=>d(O,F)).isEqual(A,w)}function i(A,w,F){return r(A.uri,w.uri,F)?0:(0,n.compare)(A.uri.toString(),w.uri.toString())}function f(A,w,F){return A.index!==w.index?A.index<w.index?-1:1:r(A.uri,w.uri,F)?(0,n.compare)(A.name,w.name):(0,n.compare)(A.uri.toString(),w.uri.toString())}function l(A,w,F,O){const G=A.slice(0).sort((U,z)=>F(U,z,O)),K=w.slice(0).sort((U,z)=>F(U,z,O));return(0,g.delta)(G,K,(U,z)=>F(U,z,O))}function d(A,w){const F=w.getCapabilities(A.scheme);return!(F&&F&1024)}class b extends k.Workspace{constructor(w,F,O,G,K,U){super(w,O.map(z=>new k.WorkspaceFolder(z)),G,U);this._name=F,this._isUntitled=K,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(U),O.forEach(z=>{this._workspaceFolders.push(z),this._structure.set(z.uri,z)})}static toExtHostWorkspace(w,F,O,G){if(!w)return{workspace:null,added:[],removed:[]};const{id:K,name:U,folders:z,configuration:N,isUntitled:B}=w,x=[],M=F;F?z.forEach((X,he)=>{const _e=c.URI.revive(X.uri),ye=b._findFolder(O||F,_e,G);ye?(ye.name=X.name,ye.index=X.index,x.push(ye)):x.push({uri:_e,name:X.name,index:he})}):x.push(...z.map(({uri:X,name:he,index:_e})=>({uri:c.URI.revive(X),name:he,index:_e}))),x.sort((X,he)=>X.index<he.index?-1:1);const H=new b(K,U,x,N?c.URI.revive(N):null,!!B,X=>d(X,G)),{added:$,removed:Q}=l(M?M.workspaceFolders:[],H.workspaceFolders,i,G);return{workspace:H,added:$,removed:Q}}static _findFolder(w,F,O){for(let G=0;G<w.folders.length;G++){const K=w.workspaceFolders[G];if(r(K.uri,F,O))return K}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(w,F){return F&&this._structure.get(w)&&(w=(0,T.dirname)(w)),this._structure.findSubstr(w)}resolveWorkspaceFolder(w){return this._structure.get(w)}}let y=class{constructor(w,F,O,G){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=G,this._extHostFileSystemInfo=O,this._requestIdProvider=new S.Counter,this._barrier=new L.Barrier,this._proxy=w.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=w.getProxy(s.MainContext.MainThreadMessageService);const K=F.workspace;this._confirmedWorkspace=K?new b(K.id,K.name,[],K.configuration?c.URI.revive(K.configuration):null,!!K.isUntitled,U=>d(U,O)):void 0}$initializeWorkspace(w,F){this._trusted=F,this.$acceptWorkspaceData(w),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:E.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(w,F,O,...G){const K=[];if(Array.isArray(G)&&G.forEach(x=>{c.URI.isUri(x.uri)&&!K.some(M=>r(M.uri,x.uri,this._extHostFileSystemInfo))&&K.push({uri:x.uri,name:x.name||(0,T.basenameOrAuthority)(x.uri)})}),this._unconfirmedWorkspace||[F,O].some(x=>typeof x!="number"||x<0)||O===0&&K.length===0)return!1;const U=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(F+O>U.length)return!1;const z=U.slice(0);z.splice(F,O,...K.map(x=>({uri:x.uri,name:x.name||(0,T.basenameOrAuthority)(x.uri),index:void 0})));for(let x=0;x<z.length;x++){const M=z[x];if(z.some((H,$)=>$!==x&&r(M.uri,H.uri,this._extHostFileSystemInfo)))return!1}z.forEach((x,M)=>x.index=M);const{added:N,removed:B}=l(U,z,f,this._extHostFileSystemInfo);if(N.length===0&&B.length===0)return!1;if(this._proxy){const x=w.displayName||w.name;this._proxy.$updateWorkspaceFolders(x,F,O,K).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(D.Severity.Error,(0,m.localize)(0,null,x,M.toString()),{extension:w},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(w,F){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(w,F)}async getWorkspaceFolder2(w,F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(w,F)}async resolveWorkspaceFolder(w){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(w)}getPath(){if(!this._actualWorkspace)return;const{folders:w}=this._actualWorkspace;if(w.length!==0)return w[0].uri.fsPath}getRelativePath(w,F){let O,G="";if(typeof w=="string"?(O=c.URI.file(w),G=w):typeof w!="undefined"&&(O=w,G=w.fsPath),!O)return G;const K=this.getWorkspaceFolder(O,!0);if(!K)return G;typeof F=="undefined"&&this._actualWorkspace&&(F=this._actualWorkspace.folders.length>1);let U=(0,T.relativePath)(K.uri,O);return F&&K.name&&(U=`${K.name}/${U}`),U}trySetWorkspaceFolders(w){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:w,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(w){const{workspace:F,added:O,removed:G}=b.toExtHostWorkspace(w,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=F||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:G}))}findFiles(w,F,O,G,K=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${G.value}, entryPoint: findFiles`);let U;if(F===null?U=!1:F&&(typeof F=="string"?U=F:U=F.pattern),K&&K.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:N}=v(w);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)(z),(0,P.withUndefinedAsNull)(N),(0,P.withUndefinedAsNull)(U),(0,P.withUndefinedAsNull)(O),K).then(B=>Array.isArray(B)?B.map(x=>c.URI.revive(x)):[])}async findTextInFiles(w,F,O,G,K=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${G.value}, entryPoint: findTextInFiles`);const U=this._requestIdProvider.getNext(),z=typeof F.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:N,folder:B}=v(F.include),x=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,M={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:z,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:N,excludePattern:x},H=!1;if(this._activeSearchCallbacks[U]=$=>{if(H)return;const Q=c.URI.revive($.resource);$.results.forEach(X=>{(0,t.resultIsMatch)(X)?O({uri:Q,preview:{text:X.preview.text,matches:(0,g.mapArrayOrNot)(X.preview.matches,he=>new p.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,g.mapArrayOrNot)(X.ranges,he=>new p.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):O({uri:Q,text:X.text,lineNumber:X.lineNumber})})},K.isCancellationRequested)return{};try{const $=await this._proxy.$startTextSearch(w,(0,P.withUndefinedAsNull)(B),M,U,K);return delete this._activeSearchCallbacks[U],$||{}}catch($){throw delete this._activeSearchCallbacks[U],$}}$handleTextSearchResult(w,F){this._activeSearchCallbacks[F]&&this._activeSearchCallbacks[F](w)}saveAll(w){return this._proxy.$saveAll(w)}resolveProxy(w){return this._proxy.$resolveProxy(w)}get trusted(){return this._trusted}requestWorkspaceTrust(w){return this._proxy.$requestWorkspaceTrust(w)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};y=Ve([$e(0,a.IExtHostRpcService),$e(1,o.IExtHostInitDataService),$e(2,_.IExtHostFileSystemInfo),$e(3,h.ILogService)],y),e.ExtHostWorkspace=y,e.IExtHostWorkspace=(0,u.createDecorator)("IExtHostWorkspace");function v(A){let w,F;return A&&(typeof A=="string"?w=A:(w=A.pattern,F=A.baseFolder||c.URI.file(A.base))),{includePattern:w,folder:F}}}),define(me[37],ge([0,1,25,3,36,5,7,193,85,13,18,4,14,12,2]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(s,r){if(r){const i=r.split(".");let f=s;for(let l=0;f&&l<i.length;l++)f=f[i[l]];return f}}function D(s){return s instanceof u.URI}function k(s){return s&&s.uri instanceof u.URI&&s.languageId&&typeof s.languageId=="string"}function _(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function o(s){return s&&s.uri instanceof u.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function a(s){if(D(s))return{resource:s};if(k(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(_(s))return{overrideIdentifier:s.languageId};if(o(s))return{resource:s.uri};if(s===null)return{resource:null}}let p=class{constructor(r,i,f){this._proxy=r.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=f,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(f=>f.$acceptConfigurationChanged(r,i))}};p=Ve([$e(0,c.IExtHostRpcService),$e(1,I.IExtHostWorkspace),$e(2,m.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(r,i,f,l){this._onDidChangeConfiguration=new L.Emitter,this._proxy=r,this._logService=l,this._extHostWorkspace=i,this._configuration=E.Configuration.parse(f),this._configurationScopes=this._toMap(f.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const f={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=E.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,f))}getConfiguration(r,i,f){const l=a(i)||{},d=this._toReadonlyValue(r?h(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,l,f?.identifier);function b(v){if(v==null)return null;if(typeof v=="boolean")return v?1:4;switch(v){case R.ConfigurationTarget.Global:return 1;case R.ConfigurationTarget.Workspace:return 4;case R.ConfigurationTarget.WorkspaceFolder:return 5}}const y={has(v){return typeof h(d,v)!="undefined"},get:(v,A)=>{this._validateConfigurationAccess(r?`${r}.${v}`:v,l,f?.identifier);let w=h(d,v);if(typeof w=="undefined")w=A;else{let F;const O=(G,K)=>{let U;const z=()=>{F=F||(0,g.deepClone)(d),U=U||h(F,K)};return(0,T.isObject)(G)?new Proxy(G,{get:(N,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return z(),()=>U;if(F)return U=U||h(F,K),U[B];const x=N[B];return typeof B=="string"?O(x,`${K}.${B}`):x},set:(N,B,x)=>(z(),U&&(U[B]=x),!0),deleteProperty:(N,B)=>(z(),U&&delete U[B],!0),defineProperty:(N,B,x)=>(z(),U&&Object.defineProperty(U,B,x),!0)}):G};w=O(w,v)}return w},update:(v,A,w,F)=>{v=r?`${r}.${v}`:v;const O=b(w);return A!==void 0?this._proxy.$updateConfigurationOption(O,v,A,l,F):this._proxy.$removeConfigurationOption(O,v,l,F)},inspect:v=>{v=r?`${r}.${v}`:v;const A=(0,g.deepClone)(this._configuration.inspect(v,l,this._extHostWorkspace.workspace));if(A)return{key:v,defaultValue:A.default?.value,globalValue:A.user?.value,workspaceValue:A.workspace?.value,workspaceFolderValue:A.workspaceFolder?.value,defaultLanguageValue:A.default?.override,globalLanguageValue:A.user?.override,workspaceLanguageValue:A.workspace?.override,workspaceFolderLanguageValue:A.workspaceFolder?.override,languageIds:A.overrideIdentifiers}}};return typeof d=="object"&&(0,g.mixin)(y,d,!1),Object.freeze(y)}_toReadonlyValue(r){const i=f=>(0,T.isObject)(f)?new Proxy(f,{get:(l,d)=>i(l[d]),set:(l,d,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(l,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(l,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):f;return i(r)}_validateConfigurationAccess(r,i,f){const l=S.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),d=f?`[${f.value}] `:"";if(l===4){typeof i?.resource=="undefined"&&this._logService.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){i?.resource&&this._logService.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const f=new E.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,d)=>f.affectsConfiguration(l,a(d))})}_toMap(r){return r.reduce((i,f)=>(i.set(f[0],f[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[72],ge([0,1,2,18,3,5,7,36,45,37,21,33,14,27,4,10,11,12,67,215,16]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D,k,_,o,a){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(K){function U(N){if(N!=null)return N}K.from=U;function z(N){if(N!=null)return N}K.to=z})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var s;(function(K){function U(N){if(N!=null)return N}K.from=U;function z(N){if(N!=null)return N}K.to=z})(s=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(K){function U(N){if(N!=null)return N}K.from=U;function z(N){if(N!=null)return N}K.to=z})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(K){function U(B){if(B){const x=B;return x&&!!x.process}else return!1}K.is=U;function z(B){if(B==null)return;const x={process:B.process,args:B.args};return B.options&&(x.options=r.from(B.options)),x}K.from=z;function N(B){if(B!=null)return new R.ProcessExecution(B.process,B.args,B.options)}K.to=N})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var f;(function(K){function U(N){if(N!=null)return N}K.from=U;function z(N){if(N!=null)return N}K.to=z})(f=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function(K){function U(B){if(B){const x=B;return x&&(!!x.commandLine||!!x.command)}else return!1}K.is=U;function z(B){if(B==null)return;const x={};return B.commandLine!==void 0?x.commandLine=B.commandLine:(x.command=B.command,x.args=B.args),B.options&&(x.options=f.from(B.options)),x}K.from=z;function N(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new R.ShellExecution(B.commandLine,B.options):new R.ShellExecution(B.command,B.args?B.args:[],B.options)}K.to=N})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var d;(function(K){function U(B){if(B){let x=B;return x&&x.customExecution==="customExecution"}else return!1}K.is=U;function z(B){return{customExecution:"customExecution"}}K.from=z;function N(B,x){return x.get(B)}K.to=N})(d=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(K){function U(z,N){let B;return z.scope!==void 0&&typeof z.scope!="number"?B=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&N&&N.workspaceFile?B=N.workspaceFile:B=o.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:B}}K.from=U})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var y;(function(K){function U(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}K.from=U})(y=e.TaskGroupDTO||(e.TaskGroupDTO={}));var v;(function(K){function U(B,x){if(B==null)return[];const M=[];for(let H of B){const $=z(H,x);$&&M.push($)}return M}K.fromMany=U;function z(B,x){if(B==null)return;let M;B.execution instanceof R.ProcessExecution?M=i.from(B.execution):B.execution instanceof R.ShellExecution?M=l.from(B.execution):B.execution&&B.execution instanceof R.CustomExecution&&(M=d.from(B.execution));const H=t.from(B.definition);let $;return B.scope?typeof B.scope=="number"?$=B.scope:$=B.scope.uri:$=R.TaskScope.Workspace,!H||!$?void 0:{_id:B._id,definition:H,name:B.name,source:{extensionId:x.identifier.value,label:B.source,scope:$},execution:M,isBackground:B.isBackground,group:y.from(B.group),presentationOptions:s.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}K.from=z;async function N(B,x,M){if(B==null)return;let H;i.is(B.execution)?H=i.to(B.execution):l.is(B.execution)?H=l.to(B.execution):d.is(B.execution)&&(H=d.to(B._id,M));const $=t.to(B.definition);let Q;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?Q=B.source.scope:Q=await x.resolveWorkspaceFolder(g.URI.revive(B.source.scope)):Q=R.TaskScope.Workspace),!$||!Q)return;const X=new R.Task($,Q,B.name,B.source.label,H,B.problemMatchers);return B.isBackground!==void 0&&(X.isBackground=B.isBackground),B.group!==void 0&&(X.group=R.TaskGroup.from(B.group._id),X.group&&(X.group=new R.TaskGroup(X.group.id,X.group.label),B.group.isDefault&&(X.group.isDefault=B.group.isDefault))),B.presentationOptions&&(X.presentationOptions=s.to(B.presentationOptions)),B._id&&(X._id=B._id),B.detail&&(X.detail=B.detail),X}K.to=N})(v=e.TaskDTO||(e.TaskDTO={}));var A;(function(K){function U(N){return N}K.from=U;function z(N){if(!!N)return Object.assign(Object.create(null),N)}K.to=z})(A=e.TaskFilterDTO||(e.TaskFilterDTO={}));class w{constructor(U,z,N){this._id=z,this._task=N,p.set(this,void 0),nt(this,p,U,"f")}get task(){return this._task}terminate(){Oe(this,p,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}p=new WeakMap;var F;(function(K){function U(z){return{id:z._id,task:void 0}}K.from=U})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let O=class{constructor(U,z,N,B,x,M,H,$){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=U.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=B,this._configurationService=x,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=H,this._deprecationService=$,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,z,N){if(!N)return new R.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:z,provider:N,extension:U}),this._proxy.$registerTaskProvider(B,z),new R.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(U,z){this._proxy.$registerTaskSystem(U,z)}fetchTasks(U){return this._proxy.$fetchTasks(A.from(U)).then(async z=>{const N=[];for(let B of z){const x=await v.to(B,this._workspaceProvider,this._providedCustomExecutions2);x&&N.push(x)}return N})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(z=>U.push(z)),U}terminateTask(U){if(!(U instanceof w))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,z,N){const B=this._providedCustomExecutions2.get(U.id);if(B){if(this._activeCustomExecutions2.get(U.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(U.id,B),this._terminalService.attachPtyToTerminal(z,await B.callback(N))}this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const z=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const z=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:z,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const z=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:U.exitCode})}$provideTasks(U,z){const N=this._handlers.get(U);if(!N)return Promise.reject(new Error("no handler found"));const B=[],x=(0,L.asPromise)(()=>N.provider.provideTasks(n.CancellationToken.None)).then(M=>this.provideTasksInternal(z,B,N,M));return new Promise(M=>{x.then(H=>{Promise.all(B).then(()=>{M(H)})})})}async $resolveTask(U,z){const N=this._handlers.get(U);if(!N)return Promise.reject(new Error("no handler found"));if(z.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${N.type}].`);const B=await v.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const x=await N.provider.resolveTask(B,n.CancellationToken.None);if(!x)return;this.checkDeprecation(x,N);const M=v.from(x,N.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(M.execution)&&await this.addCustomExecution(M,x,!0),await this.resolveTaskInternal(M)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,z,N){const B=await this._proxy.$createTaskId(U);!N&&!this._providedCustomExecutions2.has(B)&&this._notProvidedCustomExecutions.add(B),this._providedCustomExecutions2.set(B,z.execution)}async getTaskExecution(U,z){if(typeof U=="string"){const x=this._taskExecutionPromises.get(U);if(!x)throw new Error("Unexpected: The specified task is missing an execution");return x}let N=this._taskExecutionPromises.get(U.id);if(N)return N;const B=new Promise(async(x,M)=>{const H=z||await v.to(U.task,this._workspaceProvider,this._providedCustomExecutions2);H?x(new w(this,U.id,H)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(U.id,B),B.then(x=>(this._taskExecutions.set(U.id,x),x),x=>Promise.reject(x))}checkDeprecation(U,z){U._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));let N=this._notProvidedCustomExecutions.values(),B=N.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=N.next()}};O=Ve([$e(0,c.IExtHostRpcService),$e(1,m.IExtHostInitDataService),$e(2,E.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,P.IExtHostTerminalService),$e(6,k.ILogService),$e(7,_.IExtHostApiDeprecationService)],O),e.ExtHostTaskBase=O;let G=class extends O{constructor(U,z,N,B,x,M,H,$){super(U,z,N,B,x,M,H,$);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:D.PlatformToString(0)})}async executeTask(U,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const N=v.from(z,U);if(N===void 0)throw new Error("Task is not valid");if(d.is(N.execution))await this.addCustomExecution(N,z,!1);else throw new a.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),z);return this._proxy.$executeTask(N).catch(x=>{throw new Error(x)}),B}provideTasksInternal(U,z,N,B){const x=[];if(B)for(let M of B){this.checkDeprecation(M,N),(!M.definition||!U[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const H=v.from(M,N.extension);H&&d.is(H.execution)?(x.push(H),z.push(this.addCustomExecution(H,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:N.extension}}async resolveTaskInternal(U){if(d.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,z,N){}};G=Ve([$e(0,c.IExtHostRpcService),$e(1,m.IExtHostInitDataService),$e(2,E.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,P.IExtHostTerminalService),$e(6,k.ILogService),$e(7,_.IExtHostApiDeprecationService)],G),e.WorkerExtHostTask=G,e.IExtHostTask=(0,u.createDecorator)("IExtHostTask")}),define(me[269],ge([0,1,17,57,30,79,24,10,8,22,9,13,2,146,176,120,43,128,268,31]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D,k,_,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let a=class{constructor(b,y,v,A){this.configurationService=b,this.workspaceContextService=y,this.editorGroupsService=v,this.pathService=A}text(b,y,v={}){b=this.getContentPattern(b,v);const A=this.configurationService.getValue(),w=y&&y.some(O=>!this.configurationService.getValue({resource:O}).search.useRipgrep);return{...this.commonQuery(y?.map(D.toWorkspaceFolder),v),type:2,contentPattern:b,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:A.search.usePCRE2||w||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}getContentPattern(b,y){const v=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const A={...b,wordSeparators:v.editor.wordSeparators};return this.isCaseSensitive(b,y)&&(A.isCaseSensitive=!0),this.isMultiline(b)&&(A.isMultiline=!0),A}file(b,y={}){return{...this.commonQuery(b,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}handleIncludeExclude(b,y){return b?(b=Array.isArray(b)?b.map(i):i(b),y?this.parseSearchPaths(b):{pattern:t(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],y={}){const v=this.handleIncludeExclude(y.includePattern,y.expandPatterns),A=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),w=b.length>1,F=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(K=>this.getFolderQueryForSearchPath(K,y,A)):b.map(K=>this.getFolderQueryForRoot(K,y,A,w))).filter(K=>!!K),O={_reason:y._reason,folderQueries:F,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:A.pattern,includePattern:v.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const U=g.coalesce(g.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(B=>B.resource)))).filter(N=>(0,o.pathIncludedInQuery)(O,N.fsPath)),z=this.commonQueryFromFileList(U);return{...O,...z}}const G=y.extraFileResources&&y.extraFileResources.filter(K=>(0,o.pathIncludedInQuery)(O,K.fsPath));return O.extraFileResources=G&&G.length?G:void 0,O}commonQueryFromFileList(b){const y=[],v=new R.ResourceMap,A={};let w=!1;return b.forEach(F=>{if(F.scheme===E.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(F)){const G=this.workspaceContextService.getWorkspaceFolder(F)?.uri??F.with({path:S.dirname(F.fsPath)});let K=v.get(G);K||(w=!0,K={folder:G,includePattern:{}},y.push(K),v.set(G,K));const U=S.relative(G.fsPath,F.fsPath);(0,P.assertIsDefined)(K.includePattern)[U.replace(/\\/g,"/")]=!0}else F.fsPath&&(w=!0,A[F.fsPath]=!0)}),{folderQueries:y,includePattern:A,usingSearchPaths:!0,excludePattern:w?void 0:{"**/*":!0}}}isCaseSensitive(b,y){if(y.isSmartCase){if(b.isRegExp){if(n.containsUppercaseCharacter(b.pattern,!0))return!0}else if(n.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,m.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const y=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),A=(Array.isArray(b)?b:s(b)).map(z=>{const N=this.pathService.resolvedUserHome;return N?(0,C.untildify)(z,N.scheme===E.Schemas.file?N.fsPath:N.path):z}),w=L.groupBy(A,z=>y(z)?"searchPaths":"exprSegments"),F=(w.exprSegments||[]).map(z=>n.rtrim(z,"/")).map(z=>n.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),r(z))),O={},G=this.expandSearchPathPatterns(w.searchPaths||[]);G&&G.length&&(O.searchPaths=G);const K=g.flatten(F),U=t(...K);return U&&(O.pattern=U),O}getExcludesForFolder(b,y){return y.disregardExcludeSettings?void 0:(0,o.getExcludes)(b,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const y=g.flatten(b.map(A=>{let{pathPortion:w,globPortion:F}=p(A);F&&(F=f(F));const O=this.expandOneSearchPath(w);return g.flatten(O.map(G=>this.resolveOneSearchPathPattern(G,F)))})),v=new Map;return y.forEach(A=>{const w=A.searchPath.toString(),F=v.get(w);F?A.pattern&&(F.pattern=F.pattern||{},F.pattern[A.pattern]=!0):v.set(w,{searchPath:A.searchPath,pattern:A.pattern?t(A.pattern):void 0})}),Array.from(v.values())}expandOneSearchPath(b){if(S.isAbsolute(b)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==E.Schemas.file?[{searchPath:y[0].uri.with({path:b})}]:[{searchPath:c.URI.file(S.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=i(b),b.startsWith("../")||b===".."){const A=S.posix.resolve(y.path,b);return[{searchPath:y.with({path:A})}]}const v=f(b);return[{searchPath:y,pattern:v}]}else{if(b==="./"||b===".\\")return[];{const y=b.replace(/^\.[\/\\]/,""),A=this.workspaceContextService.getWorkspace().folders.map(w=>{const F=y.match(new RegExp(`^${n.escapeRegExpCharacters(w.name)}(?:/(.*)|$)`));return F?{match:F,folder:w}:null}).filter(P.isDefined);if(A.length)return A.map(w=>{const F=w.match[1];return{searchPath:w.folder.uri,pattern:F&&f(F)}});{const w=b.match(/\.[\/\\](.+)[\/\\]?/),F=w?w[1]:b,O=u.localize(0,null,F);throw new Error(O)}}}}resolveOneSearchPathPattern(b,y){const v=b.pattern&&y?`${b.pattern}/${y}`:b.pattern||y,A=[{searchPath:b.searchPath,pattern:v}];return v&&!v.endsWith("**")&&A.push({searchPath:b.searchPath,pattern:v+"/**"}),A}getFolderQueryForSearchPath(b,y,v){const A=this.getFolderQueryForRoot((0,D.toWorkspaceFolder)(b.searchPath),y,v,!1);return A?{...A,includePattern:b.pattern}:null}getFolderQueryForRoot(b,y,v,A){let w;const F=c.URI.isUri(b)?b:b.uri;if(v.searchPaths){const z=v.searchPaths.filter(N=>(0,T.isEqual)(N.searchPath,F))[0];if(z&&!z.pattern)return null;z&&(w=z.pattern)}const O=this.configurationService.getValue({resource:F}),K={...this.getExcludesForFolder(O,y)||{},...w||{}},U=c.URI.isUri(b)?(0,T.basename)(b):b.name;return{folder:F,folderName:A?U:void 0,excludePattern:Object.keys(K).length>0?K:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!O.search.followSymlinks}}};a=Ve([$e(0,h.IConfigurationService),$e(1,D.IWorkspaceContextService),$e(2,k.IEditorGroupsService),$e(3,_.IPathService)],a),e.QueryBuilder=a;function p(d){const b=d.match(/[\*\{\}\(\)\[\]\?]/);if(b){const y=b.index,v=d.substr(0,y).match(/[/|\\][^/\\]*$/);if(v){let A=d.substr(0,v.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:d.substr((v.index||0)+1)}}}return{pathPortion:d}}function t(...d){return d.length?d.reduce((b,y)=>(b[y]=!0,b),Object.create(null)):void 0}function s(d){return I.splitGlobAware(d,",").map(b=>b.trim()).filter(b=>!!b.length)}function r(d){return[`**/${d}/**`,`**/${d}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function i(d){return d.replace(/\\/g,"/")}function f(d){return i(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(d,b){d=g.distinct(d,A=>A.toString());const y=[],v=b.getWorkspace();return d&&d.forEach(A=>{let w;if(b.getWorkbenchState()===2)w=(0,T.relativePath)(v.folders[0].uri,A),w&&w!=="."&&(w="./"+w);else{const F=b.getWorkspaceFolder(A);if(F){const O=F.name;if(v.folders.filter(K=>K.name===O).length===1){const K=(0,T.relativePath)(F.uri,A);K===""?w=`./${F.name}`:w=`./${F.name}/${K}`}else w=A.fsPath}}w&&y.push(w)}),y}e.resolveResourcesForSearchIncludes=l}),define(me[270],ge([0,1,22,2,21,16,4,269,31,43]),function(Y,e,g,L,I,C,R,E,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function P(h,D){const k=D.activationEvents;if(!k)return Promise.resolve(void 0);const _=[],o=[];for(const i of k)if(/^workspaceContains:/.test(i)){const f=i.substr("workspaceContains:".length);f.indexOf("*")>=0||f.indexOf("?")>=0||h.forceUsingSearch?o.push(f):_.push(f)}if(_.length===0&&o.length===0)return Promise.resolve(void 0);let a;const p=new Promise((i,f)=>{a=i}),t=i=>a({activationEvent:i}),s=Promise.all(_.map(i=>c(h,i,t))).then(()=>{}),r=m(h,D.identifier,o,t);return Promise.all([s,r]).then(()=>{a(void 0)}),p}e.checkActivateWorkspaceContainsExtension=P;async function c(h,D,k){for(const _ of h.folders)if(await h.exists(g.joinPath(L.URI.revive(_),D))){k(`workspaceContains:${D}`);return}}async function m(h,D,k,_){if(k.length===0)return Promise.resolve(void 0);const o=new I.CancellationTokenSource,a=h.checkExists(h.folders,k,o.token),p=setTimeout(async()=>{o.cancel(),_(`workspaceContainsTimeout:${k.join(",")}`)},n);let t=!1;try{t=await a}catch(s){C.isPromiseCanceledError(s)||C.onUnexpectedError(s)}o.dispose(),clearTimeout(p),t&&_(`workspaceContains:${k.join(",")}`)}function u(h,D,k,_){const o=h.get(R.IInstantiationService),a=h.get(S.ISearchService),t=o.createInstance(E.QueryBuilder).file(D.map(s=>(0,T.toWorkspaceFolder)(L.URI.revive(s))),{_reason:"checkExists",includePattern:k,exists:!0});return a.fileSearch(t,_).then(s=>!!s.limitHit,s=>C.isPromiseCanceledError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=u});var nt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[40],ge([0,1,165,8,73,22,18,6,24,2,12,5,37,228,92,36,35,226,16,26,23,201,7,121,4,27,69,14,84,53,33,3,270,90,203]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D,k,_,o,a,p,t,s,r,i,f,l,d,b,y,v,A,w,F){"use strict";var O,G,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let U=class Hn extends E.Disposable{constructor(x,M,H,$,Q,X,he,_e,ye,Re){super();this._onDidChangeRemoteConnectionData=this._register(new v.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=H,this._initData=he,this._extHostWorkspace=$,this._extHostConfiguration=Q,this._logService=X,this._extHostTunnelService=ye,this._extHostTerminalService=Re,this._disposables=new E.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._registry=new k.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new u.ExtHostStorage(this._extHostContext),this._secretState=new w.ExtHostSecretState(this._extHostContext),this._storagePath=_e,this._instaService=x.createChild(new d.ServiceCollection([u.IExtHostStorage,this._storage],[w.IExtHostSecretState,this._secretState]));const We=new Set;this._initData.hostExtensions.forEach(Be=>We.add(o.ExtensionIdentifier.toKey(Be))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Be,je,V)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Be,_.transformErrorForSerialization(je),V)},actualActivateExtension:async(Be,je)=>{if(We.has(o.ExtensionIdentifier.toKey(Be)))return await this._mainThreadExtensionsProxy.$activateExtension(Be,je),new m.HostExtension;const V=this._registry.getExtensionDescription(Be);return this._activateExtension(V,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(x){_.onUnexpectedError(x)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let x=[];try{x=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(M){}await Promise.all(x)}isActivated(x){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(x):!1}_activateByEvent(x,M){return this._activator.activateByEvent(x,M)}_activateById(x,M){return this._activator.activateById(x,M)}activateByIdWithErrors(x,M){return this._activateById(x,M).then(()=>{const H=this._activator.getActivatedExtension(x);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(x=>this._registry)}getExtensionExports(x){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(x).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const x=S.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map(H=>{if(!!this._getEntryPoint(H))return this._hostUtils.realpath(H.extensionLocation.fsPath).then($=>x.set(T.URI.file($).fsPath,H))});this._extensionPathIndex=Promise.all(M).then(()=>x)}return this._extensionPathIndex}_deactivate(x){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(x))return M;const H=this._activator.getActivatedExtension(x);if(!H)return M;try{typeof H.module.deactivate=="function"&&(M=Promise.resolve(H.module.deactivate()).then(void 0,$=>(this._logService.error($),Promise.resolve(void 0))))}catch($){this._logService.error($)}try{(0,E.dispose)(H.subscriptions)}catch($){this._logService.error($)}return M}async _activateExtension(x,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier),this._doActivateExtension(x,M).then(H=>{const $=H.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(x.identifier,$.codeLoadingTime,$.activateCallTime,$.activateResolvedTime,M),this._logExtensionActivationTimes(x,M,"success",$),H},H=>{throw this._logExtensionActivationTimes(x,M,"failure"),H})}_logExtensionActivationTimes(x,M,H,$){const Q=z(x,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...$||{},outcome:H})}_doActivateExtension(x,M){const H=z(x,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",H);const $=this._getEntryPoint(x);if(!$)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${x.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const Q=new m.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(x.identifier,(0,C.joinPath)(x.extensionLocation,$),Q),this._loadExtensionContext(x)]).then(X=>(I.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),Hn._callActivate(this._logService,x.identifier,X[0],X[1],Q))).then(X=>(I.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),X))}_loadExtensionContext(x){const M=new p.ExtensionGlobalMemento(x,this._storage),H=new p.ExtensionMemento(x.identifier.value,!1,this._storage),$=new F.ExtensionSecrets(x,this._secretState),Q=x.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,X=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([M.whenReady,H.whenReady,this._storagePath.whenReady]).then(()=>{const he=this;let _e;return Object.freeze({globalState:M,workspaceState:H,secrets:$,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(ye){return L.join(x.extensionLocation.fsPath,ye)},get storagePath(){return he._storagePath.workspaceValue(x)?.fsPath},get globalStoragePath(){return he._storagePath.globalValue(x).fsPath},get logPath(){return L.join(he._initData.logsLocation.fsPath,x.identifier.value)},get logUri(){return T.URI.joinPath(he._initData.logsLocation,x.identifier.value)},get storageUri(){return he._storagePath.workspaceValue(x)},get globalStorageUri(){return he._storagePath.globalValue(x)},get extensionMode(){return Q},get extension(){return _e===void 0&&(_e=new N(he,x.identifier,x,X)),_e},get extensionRuntime(){return(0,D.checkProposedApiEnabled)(x),he.extensionRuntime},get environmentVariableCollection(){return he._extHostTerminalService.getEnvironmentVariableCollection(x)}})})}static _callActivate(x,M,H,$,Q){return H=H||{activate:void 0,deactivate:void 0},this._callActivateOptional(x,M,H,$,Q).then(X=>new m.ActivatedExtension(!1,null,Q.build(),H,X,$.subscriptions))}static _callActivateOptional(x,M,H,$,Q){if(typeof H.activate=="function")try{Q.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${M.value}`);const X=typeof global=="object"?global:self,he=H.activate.apply(X,[$]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(he).then(_e=>(Q.activateResolveStop(),_e))}catch(X){return Promise.reject(X)}else return Promise.resolve(H)}_activateOneStartupFinished(x,M){this._activateById(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:M}).then(void 0,H=>{this._logService.error(H)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const x of this._registry.getAllExtensionDescriptions())if(x.activationEvents)for(const M of x.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(x,M)}_handleEagerExtensions(){const x=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],H=this._handleWorkspaceContainsEagerExtensions(M),$=Promise.all([x,H]).then(()=>{});return Promise.race([$,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),$}_handleWorkspaceContainsEagerExtensions(x){return x.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(x,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(x,M){if(this.isActivated(M.identifier))return;const H=!this._initData.remote.isRemote&&!!this._initData.remote.authority,$={folders:x.map(X=>X.uri),forceUsingSearch:H,exists:X=>this._hostUtils.exists(X.fsPath),checkExists:(X,he,_e)=>this._mainThreadWorkspaceProxy.$checkExists(X,he,_e)},Q=await(0,A.checkActivateWorkspaceContainsExtension)($,M);if(!!Q)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:Q.activationEvent}).then(void 0,X=>this._logService.error(X))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(x){throw console.error(x),x}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:M}=this._initData.environment;if(!x||!M)throw new Error(g.localize(0,null));const H=await this._loadCommonJSModule(null,M,new m.ExtensionActivationTimesBuilder(!1));if(!H||typeof H.run!="function")throw new Error(g.localize(1,null,M.toString()));return new Promise(($,Q)=>{const X=(ye,Re)=>{ye?Q(ye):$(typeof Re=="number"&&Re>0?1:0)},he=(0,C.originalFSPath)(M),_e=H.run(he,X);_e&&_e.then&&_e.then(()=>{$(0)}).catch(ye=>{Q(ye.toString())})})}async $extensionTestsExit(x){this._logService.info(`extension host terminating: test runner requested exit with code ${x}`),this._logService.info(`exiting with code ${x}`),this._logService.flush(),this._hostUtils.exit(x)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(x,M){return this._resolvers[x]=M,(0,E.toDisposable)(()=>{delete this._resolvers[x]})}async _activateAndGetResolver(x){const M=x.indexOf("+");if(M===-1)throw new Error("Not an authority that can be resolved!");const H=x.substr(0,M);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this._resolvers[H]}}async $resolveAuthority(x,M){const{authorityPrefix:H,resolver:$}=await this._activateAndGetResolver(x);if(!$)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${H}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions($)),I.mark(`code/extHost/willResolveAuthority/${H}`);const Q=await $.resolve(x,{resolveAttempt:M});I.mark(`code/extHost/didResolveAuthorityOK/${H}`);const X={authority:x,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},he={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted};return{type:"ok",value:{authority:X,options:he,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(I.mark(`code/extHost/didResolveAuthorityError/${H}`),Q instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(x,M){const{authorityPrefix:H,resolver:$}=await this._activateAndGetResolver(x);if(!$)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${H}`);const Q=T.URI.revive(M);if(typeof $.getCanonicalURI=="undefined")return Q;const X=await(0,R.asPromise)(()=>$.getCanonicalURI(Q));return X||Q}$startExtensionHost(x){return this._registry.keepOnly(x),this._startExtensionHost()}$activateByEvent(x,M){return M===1?this._activateByEvent(x,!1):this._readyToRunExtensions.wait().then(H=>this._activateByEvent(x,!1))}async $activate(x,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(x)?(await this._activateById(x,M),!0):!1}async $deltaExtensions(x,M){x.forEach($=>$.extensionLocation=T.URI.revive($.extensionLocation));const H=await this.getExtensionPathIndex();return await Promise.all(M.map(async $=>{const Q=this._registry.getExtensionDescription($);if(!Q)return;const X=await this._hostUtils.realpath(Q.extensionLocation.fsPath);H.delete(T.URI.file(X).fsPath)})),await Promise.all(x.map(async $=>{const Q=await this._hostUtils.realpath($.extensionLocation.fsPath);H.set(T.URI.file(Q).fsPath,$)})),this._registry.deltaExtensions(x,M),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){let M=a.VSBuffer.alloc(x),H=Math.random()%256;for(let $=0;$<x;$++)M.writeUInt8(H,$);return M}async $updateRemoteConnectionData(x){this._remoteConnectionData=x,this._onDidChangeRemoteConnectionData.fire()}};U=Ve([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,l.IExtHostRpcService),$e(3,h.IExtHostWorkspace),$e(4,c.IExtHostConfiguration),$e(5,n.ILogService),$e(6,i.IExtHostInitDataService),$e(7,f.IExtensionStoragePaths),$e(8,b.IExtHostTunnelService),$e(9,y.IExtHostTerminalService)],U),e.AbstractExtHostExtensionService=U;function z(B,x){return{id:B.identifier.value,name:B.name,extensionVersion:B.version,publisherDisplayName:B.publisher,activationEvents:B.activationEvents?B.activationEvents.join(","):null,isBuiltin:B.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class N{constructor(x,M,H,$){O.set(this,void 0),G.set(this,void 0),K.set(this,void 0),nt(this,O,x,"f"),nt(this,G,M,"f"),nt(this,K,H.identifier,"f"),this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=L.normalize((0,C.originalFSPath)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=$}get isActive(){return Oe(this,O,"f").isActivated(Oe(this,K,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,O,"f").getExtensionExports(Oe(this,K,"f"))}activate(){return Oe(this,O,"f").activateByIdWithErrors(Oe(this,K,"f"),{startup:!1,extensionId:Oe(this,G,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=N,O=new WeakMap,G=new WeakMap,K=new WeakMap}),define(me[55],ge([0,1,8,2,3,18,5,7,124,36,40,45,217,37,211,14,4,13,38,54]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D,k,_,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let a=class{constructor(d,b,y,v,A,w){this._workspaceService=b,this._extensionService=y,this._editorsService=v,this._configurationService=A,this._editorTabs=w,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=d.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(O=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(d,b){const y=d;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let v=`debug:${encodeURIComponent(y.path||"")}`,A="?";return b&&(v+=`${A}session=${encodeURIComponent(b.id)}`,A="&"),v+=`${A}ref=${y.sourceReference}`,L.URI.parse(v)}else{if(y.path)return L.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(d){const b=[];for(const y of d.getAllExtensionDescriptions())if(y.contributes){const v=y.contributes.debuggers;if(v&&v.length>0)for(const A of v)(0,u.isDebuggerMainContribution)(A)&&b.push(A.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const d=[];return this._breakpoints.forEach(b=>d.push(b)),d}addBreakpoints(d){this.startBreakpoints();const b=d.filter(A=>{const w=A.id;return this._breakpoints.has(w)?!1:(this._breakpoints.set(w,A),!0)});this.fireBreakpointChanges(b,[],[]);const y=[],v=new Map;for(const A of b)if(A instanceof E.SourceBreakpoint){let w=v.get(A.location.uri.toString());w||(w={type:"sourceMulti",uri:A.location.uri,lines:[]},v.set(A.location.uri.toString(),w),y.push(w)),w.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character})}else A instanceof E.FunctionBreakpoint&&y.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName});return this._debugServiceProxy.$registerBreakpoints(y)}removeBreakpoints(d){this.startBreakpoints();const b=d.filter(w=>this._breakpoints.delete(w.id));this.fireBreakpointChanges([],b,[]);const y=b.filter(w=>w instanceof E.SourceBreakpoint).map(w=>w.id),v=b.filter(w=>w instanceof E.FunctionBreakpoint).map(w=>w.id),A=b.filter(w=>w instanceof E.DataBreakpoint).map(w=>w.id);return this._debugServiceProxy.$unregisterBreakpoints(y,v,A)}startDebugging(d,b,y){return this._debugServiceProxy.$startDebugging(d?d.uri:void 0,b,{parentSessionID:y.parentSession?y.parentSession.id:void 0,lifecycleManagedByParent:y.lifecycleManagedByParent,repl:y.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact,debugUI:y.debugUI,suppressSaveBeforeStart:y.suppressSaveBeforeStart})}stopDebugging(d){return this._debugServiceProxy.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,b,y){if(!b)return new E.Disposable(()=>{});const v=this._configProviderHandleCounter++;return this._configProviders.push({type:d,handle:v,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(d,y,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,v),new E.Disposable(()=>{this._configProviders=this._configProviders.filter(A=>A.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(d,b,y){if(!y)return new E.Disposable(()=>{});if(!this.definesDebugType(d,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:v,factory:y}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,v),new E.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(A=>A.factory!==y),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(d,b){if(!b)return new E.Disposable(()=>{});const y=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:d,handle:y,factory:b}),new E.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(v=>v.factory!==b)})}async $runInTerminal(d,b){return Promise.resolve(void 0)}async $substituteVariables(d,b){if(!this._variableResolver){const[A,w]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(A||[],this._editorsService,w)}let y;const v=await this.getFolder(d);return v&&(y={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(y,b)}createDebugAdapter(d,b){if(d.type==="implementation")return new i(d.implementation)}createSignService(){}async $startDASession(d,b){const y=this,v=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(v.type),v).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const w=this.convertToDto(A),F=this.createDebugAdapter(w,v);if(!F)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const O=F;return this._debugAdapters.set(d,O),this.getDebugAdapterTrackers(v).then(G=>(G&&this._debugAdaptersTrackers.set(d,G),O.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const U=K,z={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(U.arguments.value);z.body={signature:N},O.sendResponse(z)}else throw new Error("no signer")}catch(N){z.success=!1,z.message=N.message,O.sendResponse(z)}}else G&&G.onDidSendMessage&&G.onDidSendMessage(K),K=(0,u.convertToVSCPaths)(K,!0),y._debugServiceProxy.$acceptDAMessage(d,K)}),O.onError(K=>{G&&G.onError&&G.onError(K),this._debugServiceProxy.$acceptDAError(d,K.name,K.message,K.stack)}),O.onExit(K=>{G&&G.onExit&&G.onExit((0,k.withNullAsUndefined)(K),void 0),this._debugServiceProxy.$acceptDAExit(d,(0,k.withNullAsUndefined)(K),void 0)}),G&&G.onWillStartSession&&G.onWillStartSession(),O.startSession()))})}$sendDAMessage(d,b){b=(0,u.convertToDAPaths)(b,!1);const y=this._debugAdaptersTrackers.get(d);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(b);const v=this._debugAdapters.get(d);v&&v.sendMessage(b)}$stopDASession(d){const b=this._debugAdaptersTrackers.get(d);this._debugAdaptersTrackers.delete(d),b&&b.onWillStopSession&&b.onWillStopSession();const y=this._debugAdapters.get(d);return this._debugAdapters.delete(d),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const b=[],y=[],v=[];if(d.added)for(const A of d.added){const w=A.id;if(w&&!this._breakpoints.has(w)){let F;if(A.type==="function")F=new E.FunctionBreakpoint(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage);else if(A.type==="data")F=new E.DataBreakpoint(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage);else{const O=L.URI.revive(A.uri);F=new E.SourceBreakpoint(new E.Location(O,new E.Position(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage)}F._id=w,this._breakpoints.set(w,F),b.push(F)}}if(d.removed)for(const A of d.removed){const w=this._breakpoints.get(A);w&&(this._breakpoints.delete(A),y.push(w))}if(d.changed){for(const A of d.changed)if(A.id){const w=this._breakpoints.get(A.id);if(w){if(w instanceof E.FunctionBreakpoint&&A.type==="function"){const F=w;F.enabled=A.enabled,F.condition=A.condition,F.hitCondition=A.hitCondition,F.logMessage=A.logMessage,F.functionName=A.functionName}else if(w instanceof E.SourceBreakpoint&&A.type==="source"){const F=w;F.enabled=A.enabled,F.condition=A.condition,F.hitCondition=A.hitCondition,F.logMessage=A.logMessage,F.location=new E.Location(L.URI.revive(A.uri),new E.Position(A.line,A.character))}v.push(w)}}}this.fireBreakpointChanges(b,y,v)}$provideDebugConfigurations(d,b,y){return(0,C.asPromise)(async()=>{const v=this.getConfigProviderByHandle(d);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.getFolder(b);return v.provideDebugConfigurations(A,y)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(d,b,y,v){return(0,C.asPromise)(async()=>{const A=this.getConfigProviderByHandle(d);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const w=await this.getFolder(b);return A.resolveDebugConfiguration(w,y,v)})}$resolveDebugConfigurationWithSubstitutedVariables(d,b,y,v){return(0,C.asPromise)(async()=>{const A=this.getConfigProviderByHandle(d);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const w=await this.getFolder(b);return A.resolveDebugConfigurationWithSubstitutedVariables(w,y,v)})}async $provideDebugAdapter(d,b){const y=this.getAdapterDescriptorFactoryByHandle(d);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.getSession(b);return this.getAdapterDescriptor(y,v).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.convertToDto(A)})}async $acceptDebugSessionStarted(d){const b=await this.getSession(d);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(d){const b=await this.getSession(d);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(d){this._activeDebugSession=d?await this.getSession(d):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(d,b){const y=await this.getSession(d);y&&y._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(d,b){const v={session:await this.getSession(d),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(v)}convertToDto(d){if(d instanceof E.DebugAdapterExecutable)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof E.DebugAdapterServer)return{type:"server",port:d.port,host:d.host};if(d instanceof E.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:d.path};if(d instanceof E.DebugAdapterInlineImplementation)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(d){const b=this._adapterFactories.filter(y=>y.type===d);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(d){const b=this._adapterFactories.filter(y=>y.handle===d);if(b.length>0)return b[0].factory}getConfigProviderByHandle(d){const b=this._configProviders.filter(y=>y.handle===d);if(b.length>0)return b[0].provider}definesDebugType(d,b){if(d.contributes){const y=d.contributes.debuggers;if(y&&y.length>0){for(const v of y)if(v.label&&v.type&&v.type===b)return!0}}return!1}getDebugAdapterTrackers(d){const y=d.configuration.type,v=this._trackerFactories.filter(A=>A.type===y||A.type==="*").map(A=>(0,C.asPromise)(()=>A.factory.createDebugAdapterTracker(d)).then(w=>w,w=>null));return Promise.race([Promise.all(v).then(A=>{const w=A.filter(F=>!!F);if(w.length>0)return new r(w)}),new Promise((A,w)=>{const F=setTimeout(()=>{clearTimeout(F),w(new Error("timeout"))},1e3)})]).catch(A=>{})}async getAdapterDescriptor(d,b){const y=b.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new E.DebugAdapterServer(y));if(d){const A=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>d.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,A))).then(w=>{if(w)return w})}const v=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,v))}daExecutableFromPackage(d,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(d,b,y){(d.length>0||b.length>0||y.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:d,removed:b,changed:y}))}async getSession(d){if(d)if(typeof d=="string"){const b=this._debugSessions.get(d);if(b)return b}else{let b=this._debugSessions.get(d.id);if(!b){const y=await this.getFolder(d.folderUri),v=d.parent?this._debugSessions.get(d.parent):void 0;b=new p(this._debugServiceProxy,d.id,d.type,d.name,y,d.configuration,v),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(d){if(d){const b=L.URI.revive(d);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};a=Ve([$e(0,h.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,n.IExtHostExtensionService),$e(3,P.IExtHostDocumentsAndEditors),$e(4,m.IExtHostConfiguration),$e(5,o.IExtHostEditorTabs)],a),e.ExtHostDebugServiceBase=a;class p{constructor(d,b,y,v,A,w,F){this._debugServiceProxy=d,this._id=b,this._type=y,this._name=v,this._workspaceFolder=A,this._configuration=w,this._parentSession=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(d){this._name=d,this._debugServiceProxy.$setDebugSessionName(this._id,d)}get parentSession(){return this._parentSession}_acceptNameChanged(d){this._name=d}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(d,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,d,b)}getDebugProtocolBreakpoint(d){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,d.id)}}e.ExtHostDebugSession=p;class t{constructor(d){this.value=Object.freeze({append(b){d.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=t;class s extends c.AbstractVariableResolverService{constructor(d,b,y,v,A){function w(){if(b){const F=b.activeEditor();if(F)return F.document.uri;const O=v.tabs.filter(G=>G.isActive);if(O.length>0){const G=O[0].resource;return G&&(G.primary||G.secondary)?G.primary??G.secondary:O[0].resource}}}super({getFolderUri:F=>{const O=d.filter(G=>G.name===F);if(O&&O.length>0)return O[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:(F,O)=>y.getConfiguration(void 0,F).get(O),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{const F=w();if(F)return g.normalize(F.fsPath)},getWorkspaceFolderPathForFile:()=>{if(A){const F=w();if(F){const O=A.getWorkspaceFolder(F);if(O)return g.normalize(O.uri.fsPath)}}},getSelectedText:()=>{if(b){const F=b.activeEditor();if(F&&!F.selection.isEmpty)return F.document.getText(F.selection)}},getLineNumber:()=>{if(b){const F=b.activeEditor();if(F)return String(F.selection.end.line+1)}}},void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=s;class r{constructor(d){this.trackers=d}onWillStartSession(){this.trackers.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(d):void 0)}onWillStopSession(){this.trackers.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.trackers.forEach(b=>b.onError?b.onError(d):void 0)}onExit(d,b){this.trackers.forEach(y=>y.onExit?y.onExit(d,b):void 0)}}class i extends S.AbstractDebugAdapter{constructor(d){super();this.implementation=d,d.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.implementation.handleMessage(d)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let f=class extends a{constructor(d,b,y,v,A,w){super(d,b,y,v,A,w)}createVariableResolver(d,b,y){return new s(d,b,y,this._editorTabs)}};f=Ve([$e(0,h.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,n.IExtHostExtensionService),$e(3,P.IExtHostDocumentsAndEditors),$e(4,m.IExtHostConfiguration),$e(5,o.IExtHostEditorTabs)],f),e.WorkerExtHostDebugService=f}),define(me[271],ge([0,1,73,2,5,37,35,26,14,27,4,40,38,12]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(o,a,p,t,s,r,i){this._apiFactory=o,this._extensionRegistry=a,this._instaService=p,this._extHostConfiguration=t,this._extHostExtensionService=s,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,a,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(D)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(k,a,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let a of o.nodeModuleName)this._factories.set(a,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(a=>o.alternativeModuleName(a))}};u=Ve([$e(2,n.IInstantiationService),$e(3,C.IExtHostConfiguration),$e(4,P.IExtHostExtensionService),$e(5,T.IExtHostInitDataService),$e(6,m.ILogService)],u),e.RequireInterceptor=u;class h{constructor(o,a,p,t,s){this._apiFactory=o,this._extensionPaths=a,this._extensionRegistry=p,this._configProvider=t,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,a){const p=this._extensionPaths.findSubstr(a.fsPath);if(p){let t=this._extApiImpl.get(E.ExtensionIdentifier.toKey(p.identifier));return t||(t=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(E.ExtensionIdentifier.toKey(p.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((s,r)=>t+=`	${r} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let D=class{constructor(o,a){this.nodeModuleName="keytar";const{environment:p}=a,t=o.getProxy(I.MainContext.MainThreadKeytar);if(p.appRoot){let s=p.appRoot.fsPath;c.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,r)=>t.$getPassword(s,r),setPassword:(s,r,i)=>t.$setPassword(s,r,i),deletePassword:(s,r)=>t.$deletePassword(s,r),findPassword:s=>t.$findPassword(s),findCredentials(s){return t.$findCredentials(s)}}}load(o,a){return this._impl}alternativeModuleName(o){const a=o.length;if(a<=7||!this.alternativeNames)return;const p=a-7;if((o.charAt(p)==="/"||o.charAt(p)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};D=Ve([$e(0,S.IExtHostRpcService),$e(1,T.IExtHostInitDataService)],D);let k=class{constructor(o,a,p){this._extensionPaths=o,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(I.MainContext.MainThreadTelemetry);const t=p.getProxy(I.MainContext.MainThreadWindow);this._impl=(s,r)=>{const i=L.URI.parse(s);return r?this.callOriginal(s,r):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,s,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,s,{}):this.callOriginal(s,r)}}load(o,a,p){const t=this._extensionPaths.findSubstr(a.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=p(o),this._impl}callOriginal(o,a){return this.sendNoForwardTelemetry(),this._original(o,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};k=Ve([$e(2,S.IExtHostRpcService)],k)}),define(me[272],ge([0,1,171,11,7,212,36,40,45,37,33,14,55,195,18,213,54]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let k=class extends c.ExtHostDebugServiceBase{constructor(a,p,t,s,r,i,f){super(a,p,t,s,r,f);this._terminalService=i,this._integratedTerminalInstances=new _}createDebugAdapter(a,p){switch(a.type){case"server":return new C.SocketDebugAdapter(a);case"pipeServer":return new C.NamedPipeDebugAdapter(a);case"executable":return new C.ExecutableDebugAdapter(a,p.type)}return super.createDebugAdapter(a,p)}daExecutableFromPackage(a,p){const t=C.ExecutableDebugAdapter.platformAdapterExecutable(p.getAllExtensionDescriptions(),a.type);if(t)return new I.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new m.SignService}async $runInTerminal(a,p){if(a.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(w=>{this._integratedTerminalInstances.onTerminalClosed(w)}));const t=await this._configurationService.getConfigProvider(),s=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),i=a.title||g.localize(0,null),f=JSON.stringify({shell:s,shellArgs:r});let l=await this._integratedTerminalInstances.checkout(f,i),d,b=!1;if(l)d=a.cwd;else{const w={shellPath:s,shellArgs:r,cwd:a.cwd,name:i,iconPath:new I.ThemeIcon("debug")};b=!0,l=this._terminalService.createTerminalFromOptions(w,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(l,f)}l.show(!0);const y=await l.processId;b?await new Promise(w=>setTimeout(w,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(s.indexOf("powershell")>=0||s.indexOf("pwsh")>=0||s.indexOf("cmd.exe")>=0?l.sendText("cls"):s.indexOf("bash")>=0?l.sendText("clear"):L.isWindows?l.sendText("cls"):l.sendText("clear"));const v=(0,h.prepareCommand)(s,a.args,d,a.env);l.sendText(v);const A=this.onDidTerminateDebugSession(w=>{w.id===p&&(this._integratedTerminalInstances.free(l),A.dispose())});return y}else if(a.kind==="external")return(0,h.runInExternalTerminal)(a,await this._configurationService.getConfigProvider());return super.$runInTerminal(a,p)}createVariableResolver(a,p,t){return new c.ExtHostVariableResolverService(a,p,t,this._editorTabs,this._workspaceService)}};k=Ve([$e(0,P.IExtHostRpcService),$e(1,R.IExtHostWorkspace),$e(2,E.IExtHostExtensionService),$e(3,S.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,n.IExtHostTerminalService),$e(6,D.IExtHostEditorTabs)],k),e.ExtHostDebugService=k;class _{constructor(){this._terminalInstances=new Map}async checkout(a,p){const s=[...this._terminalInstances.entries()].map(([r,i])=>(0,u.createCancelablePromise)(async f=>{if(r.name!==p||i.lastUsedAt!==-1&&await(0,h.hasChildProcesses)(await r.processId))return null;const l=Date.now();return i.lastUsedAt+_.minUseDelay>l||f.isCancellationRequested||i.config!==a?null:(i.lastUsedAt=l,r)}));return await(0,u.firstParallel)(s,r=>!!r)}insert(a,p){this._terminalInstances.set(a,{lastUsedAt:Date.now(),config:p})}free(a){const p=this._terminalInstances.get(a);p&&(p.lastUsedAt=-1)}onTerminalClosed(a){this._terminalInstances.delete(a)}}_.minUseDelay=1e3}),define(me[273],ge([0,1,8,2,113,36,55,45,37,43,33,14,27,72,10,12,67,54,22,80]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D,k,_,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let a=class extends m.ExtHostTaskBase{constructor(t,s,r,i,f,l,d,b,y){super(t,s,r,i,f,l,d,b);this.workspaceService=r,this.editorTabs=y,s.remote.isRemote&&s.remote.authority?this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:s.remote.authority,platform:process.platform}):this.registerTaskSystem(u.Schemas.file,{scheme:u.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,s){const r=s;if(!s.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const i=m.TaskHandleDTO.from(r,this.workspaceService),f=await this._proxy.$getTaskExecution(i);if(f.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.getTaskExecution(f,s);return this._proxy.$executeTask(i).catch(()=>{}),l}else{const i=m.TaskDTO.from(s,t);if(i===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,s,!1);const f=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),s);return this._proxy.$executeTask(i).catch(()=>{}),f}}provideTasksInternal(t,s,r,i){const f=[];if(i)for(let l of i){this.checkDeprecation(l,r),(!l.definition||!t[l.definition.type])&&this._logService.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const d=m.TaskDTO.from(l,r.extension);d&&(f.push(d),m.CustomExecutionDTO.is(d.execution)&&s.push(this.addCustomExecution(d,l,!0)))}return{tasks:f,extension:r.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const s=await this._configurationService.getConfigProvider();this._variableResolver=new R.ExtHostVariableResolverService(t,this._editorService,s,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let s=t&&t.length>0?t[0]:void 0;if(!s){const r=L.URI.file((0,o.homedir)());s=new T.WorkspaceFolder({uri:r,name:_.basename(r),index:0})}return{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,s){const r=L.URI.revive(t),i={process:void 0,variables:Object.create(null)},f=await this._workspaceProvider.resolveWorkspaceFolder(r),l=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.getVariableResolver(l),b=f?{uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(l);for(let y of s.variables)i.variables[y]=await d.resolveAsync(b,y);if(s.process!==void 0){let y;if(s.process.path!==void 0){y=s.process.path.split(g.delimiter);for(let v=0;v<y.length;v++)y[v]=await d.resolveAsync(b,y[v])}i.process=await I.win32.findExecutable(await d.resolveAsync(b,s.process.name),s.process.cwd!==void 0?await d.resolveAsync(b,s.process.cwd):void 0,y)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(t,s,r){return I.win32.findExecutable(t,s,r)}};a=Ve([$e(0,P.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,C.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,S.IExtHostConfiguration),$e(5,n.IExtHostTerminalService),$e(6,h.ILogService),$e(7,D.IExtHostApiDeprecationService),$e(8,k.IExtHostEditorTabs)],a),e.ExtHostTask=a}),define(me[274],ge([0,1,18,16,73,6,2,5,266,12,82,84,27,189,14,65,40,33]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(a,p,t,s){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new S.RPCProtocol(a,null,s),p=_._transform(p,this._rpcProtocol);const r=new P.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());r.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...p}),r.set(u.IExtHostRpcService,new u.ExtHostRpcService(this._rpcProtocol)),r.set(h.IURITransformerService,new h.URITransformerService(s)),r.set(D.IHostUtils,t);const i=new m.InstantiationService(r,!0),f=i.invokeFunction(y=>y.get(k.IExtHostTerminalService));this._disposables.add(f),this._logService=i.invokeFunction(y=>y.get(T.ILogService)),I.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",p),this._extensionService=i.invokeFunction(y=>y.get(D.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const l=new WeakMap;this._extensionService.getExtensionPathIndex().then(y=>{Error.prepareStackTrace=(v,A)=>{let w="",F,O;for(const G of A)w+=`
	at ${G.toString()}`,O=G.getFileName(),!F&&O&&(F=y.findSubstr(O));return l.set(v,F),`${v.name||"Error"}: ${v.message||""}${w}`}});const d=this._rpcProtocol.getProxy(E.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(E.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(y=>{const v=L.transformErrorForSerialization(y),A=l.get(y);A?d.$onExtensionRuntimeError(A.identifier,v):b.$onUnexpectedError(v)})}terminate(a){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${a}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const p=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),p]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(a,p){a.extensions.forEach(s=>s.extensionLocation=R.URI.revive(p.transformIncomingURIs(s.extensionLocation))),a.environment.appRoot=R.URI.revive(p.transformIncomingURIs(a.environment.appRoot));const t=a.environment.extensionDevelopmentLocationURI;return t&&(a.environment.extensionDevelopmentLocationURI=t.map(s=>R.URI.revive(p.transformIncomingURIs(s)))),a.environment.extensionTestsLocationURI=R.URI.revive(p.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=R.URI.revive(p.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=R.URI.revive(p.transformIncomingURIs(a.environment.workspaceStorageHome)),a.logsLocation=R.URI.revive(p.transformIncomingURIs(a.logsLocation)),a.logFile=R.URI.revive(p.transformIncomingURIs(a.logFile)),a.workspace=p.transformIncomingURIs(a.workspace),a}}e.ExtensionHostMain=_}),define(me[275],ge([0,1,8,21,61,30,22,46,31]),function(Y,e,g,L,I,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(c,m,u){this.config=c,this.provider=m,this.sessionToken=u,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&C.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&C.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const m=this.config.folderQueries||[];return new Promise((u,h)=>{const D=k=>{this.resultCount++,c(k)};if(this.isCanceled)return u({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(k=>{const _=k.toString(),o=g.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,o)||this.matchFile(D,{base:k,basename:o})}),Promise.all(m.map(k=>this.searchInFolder(k,D))).then(k=>{u({limitHit:this.isLimitHit,stats:k[0]||void 0})},k=>{h(new Error((0,I.toErrorMessage)(k)))})})}async searchInFolder(c,m){const u=new L.CancellationTokenSource,h=this.getSearchOptionsForFolder(c),D=this.initDirectoryTree(),k=new S.QueryGlobTester(this.config,c),_=!k.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(u),o=E.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,u.token),p=o.elapsed(),t=E.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(s=>{const r=g.posix.relative(c.folder.path,s.path);if(_){const i=g.basename(s.path);this.matchFile(m,{base:c.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(D,c.folder,r,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(D,k,m),{providerTime:p,postProcessTime:t.elapsed()})}finally{u.dispose(),this.activeCancellationTokens.delete(u)}}getSearchOptionsForFolder(c){const m=(0,S.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),u=(0,S.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:u,includes:m,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},m,u,h){if(u===this.filePattern){const k=g.basename(this.filePattern);this.matchFile(h,{base:m,relativePath:this.filePattern,basename:k})}function D(k){const _=g.basename(k),o=g.dirname(k);let a=c[o];a||(a=c[o]=[],D(o)),a.push({base:m,relativePath:k,basename:_})}D(u)}matchDirectoryTree({rootEntries:c,pathToEntries:m},u,h){const D=this,k=this.filePattern;function _(o){const a=C.hasSiblingFn(()=>o.map(p=>p.basename));for(let p=0,t=o.length;p<t;p++){const s=o[p],{relativePath:r,basename:i}=s;if(!u.includedInQuerySync(r,i,k!==i?a:void 0))continue;const f=m[r];if(f)_(f);else{if(r===k)continue;D.matchFile(h,s)}if(D.isLimitHit)break}}_(c)}matchFile(c,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(m))}}class n{constructor(){this.sessions=new Map}fileSearch(c,m,u,h){const D=this.getSessionTokenSource(c.cacheKey),k=new T(c,m,D&&D.token);let _=0;const o=a=>{_+=a.length,u(a.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(k,n.BATCH_SIZE,o,h).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:a.stats}}))}clearCache(c){const m=this.getSessionTokenSource(c);m&&m.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new L.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:R.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,m,u,h){h.onCancellationRequested(()=>{c.cancel()});const D=_=>{_&&(k.push(_),m>0&&k.length>=m&&(u(k),k=[]))};let k=[];return c.search(D).then(_=>(k.length&&u(k),_),_=>(k.length&&u(k),Promise.reject(_)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(me[133],ge([0,1,17,21,61,30,10,8,22,13,2,31]),function(Y,e,g,L,I,C,R,E,S,T,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(o,a,p,t){this.query=o,this.provider=a,this.fileUtils=p,this.processType=t,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,a){const p=this.query.folderQueries||[],t=new L.CancellationTokenSource;return a.onCancellationRequested(()=>t.cancel()),new Promise((s,r)=>{this.collector=new u(o);let i=!1;const f=(l,d)=>{if(!i&&!this.isLimitHit){const b=this.resultSize(l);D(l)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const y=this.resultSize(l);this.resultCount+=y,(y>0||!D(l))&&this.collector.add(l,d)}};Promise.all(p.map((l,d)=>this.searchInFolder(l,b=>f(b,d),t.token))).then(l=>{t.dispose(),this.collector.flush();const d=l.some(b=>!!b&&!!b.limitHit);s({limitHit:this.isLimitHit||d,messages:(0,g.flatten)(l.map(b=>b?.message?(0,T.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},l=>{t.dispose();const d=(0,I.toErrorMessage)(l);r(new Error(d))})})}resultSize(o){return D(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,a){const p=Array.isArray(o.ranges)?o.ranges:[o.ranges],t=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:p.slice(0,a),preview:{matches:t.slice(0,a),text:o.preview.text},uri:o.uri}}async searchInFolder(o,a,p){const t=new P.QueryGlobTester(this.query,o),s=[],r={report:l=>{if(!this.validateProviderResult(l))return;const d=o.folder.scheme===R.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(l.uri))):void 0,b=S.relativePath(o.folder,l.uri);if(b){const y=t.includedInQuery(b,E.basename(b),d);(0,T.isPromise)(y)?s.push(y.then(v=>{v&&a(l)})):y&&a(l)}}},i=this.getSearchOptionsForFolder(o),f=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,r,p);return s.length&&await Promise.all(s),f}validateProviderResult(o){if(D(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const a=(0,P.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),p=(0,P.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),t={folder:n.URI.from(o.folder),excludes:p,includes:a,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=c;function m(_){return{isCaseSensitive:_.isCaseSensitive||!1,isRegExp:_.isRegExp||!1,isWordMatch:_.isWordMatch||!1,isMultiline:_.isMultiline||!1,pattern:_.pattern}}class u{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new k(512,a=>this.sendItems(a))}add(o,a){this._currentFileMatch&&(this._currentFolderIdx!==a||!S.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=a,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(h(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=u;function h(_){return D(_)?{preview:{matches:(0,g.mapArrayOrNot)(_.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:_.preview.text},ranges:(0,g.mapArrayOrNot)(_.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:_.text,lineNumber:_.lineNumber}}function D(_){return!!_.preview}e.extensionResultIsMatch=D;class k{constructor(o,a){this.maxBatchSize=o,this.cb=a,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,a){!o||this.addItemToBatch(o,a)}addItems(o,a){!o||this.addItemsToBatch(o,a)}addItemToBatch(o,a){this.batch.push(o),this.batchSize+=a,this.onUpdate()}addItemsToBatch(o,a){this.batch=this.batch.concat(o),this.batchSize+=a,this.onUpdate()}onUpdate(){this.totalNumberCompleted<k.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},k.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=k,k.TIMEOUT=4e3,k.START_BATCH_AFTER_COUNT=50}),define(me[74],ge([0,1,6,5,4,275,14,65,12,2,133]),function(Y,e,g,L,I,C,R,E,S,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let P=class{constructor(h,D,k){this.extHostRpc=h,this._uriTransformer=D,this._logService=k,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,D){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const k=this._handlePool++;return this._textSearchProvider.set(k,D),this._proxy.$registerTextSearchProvider(k,this._transformScheme(h)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(k),this._proxy.$unregisterProvider(k)})}registerFileSearchProvider(h,D){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const k=this._handlePool++;return this._fileSearchProvider.set(k,D),this._proxy.$registerFileSearchProvider(k,this._transformScheme(h)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(k),this._proxy.$unregisterProvider(k)})}$provideFileSearchResults(h,D,k,_){const o=c(k),a=this._fileSearchProvider.get(h);if(a)return this._fileSearchManager.fileSearch(o,a,p=>{this._proxy.$handleFileMatch(h,D,p.map(t=>t.resource))},_);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,D,k,_){const o=this._textSearchProvider.get(h);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const a=c(k);return this.createTextSearchManager(a,o).search(t=>this._proxy.$handleTextMatch(h,D,t),_)}$enableExtensionHostSearch(){}createTextSearchManager(h,D){return new n.TextSearchManager(h,D,{readdir:k=>Promise.resolve([]),toCanonicalName:k=>k},"textSearchProvider")}};P=Ve([$e(0,R.IExtHostRpcService),$e(1,E.IURITransformerService),$e(2,S.ILogService)],P),e.ExtHostSearch=P;function c(u){return{...u,folderQueries:u.folderQueries&&u.folderQueries.map(m),extraFileResources:u.extraFileResources&&u.extraFileResources.map(h=>T.URI.revive(h))}}e.reviveQuery=c;function m(u){return{...u,folder:T.URI.revive(u.folder)}}}),define(me[276],ge([0,1,21,16,3,49,2,114,109,147,81,42,5,234,233,44,235,37,236,237,238,219,239,45,40,240,220,243,244,245,68,222,250,251,252,92,33,254,223,15,7,257,70,132,36,35,57,208,242,86,131,72,55,74,12,65,14,27,246,205,53,67,231,255,204,69,91,260,258,259,232,52,253,256,90,54,122,248,71,249,10,191,247,202,241]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D,k,_,o,a,p,t,s,r,i,f,l,d,b,y,v,A,w,F,O,G,K,U,z,N,B,x,M,H,$,Q,X,he,_e,ye,Re,We,Be,je,V,ee,re,ae,J,oe,ve,Me,qe,Ke,Se,tt,Z,te,pe,xe,Ye,rt,ft,pt,St,Ct,ue,Ie,Ue,Qe,ze,at,Le,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ke(ne){const de=ne.get(re.IExtHostInitDataService),be=ne.get(Ye.IExtHostFileSystemInfo),we=ne.get(tt.IExtHostConsumerFileSystem),Fe=ne.get(r.IExtHostExtensionService),Ge=ne.get(H.IExtHostWorkspace),He=ne.get(Ct.IExtHostTelemetry),Je=ne.get(k.IExtHostConfiguration),it=ne.get(V.IURITransformerService),le=ne.get(ee.IExtHostRpcService),Ee=ne.get(O.IExtHostStorage),ce=ne.get(Se.IExtensionStoragePaths),q=ne.get(je.ILogService),Ae=ne.get(oe.IExtHostTunnelService),Pe=ne.get(ve.IExtHostApiDeprecationService),Ze=ne.get(M.IExtHostWindow),Xe=ne.get(pt.IExtHostSecretState),ot=ne.get(St.IExtHostEditorTabs);le.set(c.ExtHostContext.ExtHostFileSystemInfo,be),le.set(c.ExtHostContext.ExtHostLogService,q),le.set(c.ExtHostContext.ExtHostWorkspace,Ge),le.set(c.ExtHostContext.ExtHostConfiguration,Je),le.set(c.ExtHostContext.ExtHostExtensionService,Fe),le.set(c.ExtHostContext.ExtHostStorage,Ee),le.set(c.ExtHostContext.ExtHostTunnelService,Ae),le.set(c.ExtHostContext.ExtHostWindow,Ze),le.set(c.ExtHostContext.ExtHostSecretState,Xe),le.set(c.ExtHostContext.ExtHostTelemetry,He),le.set(c.ExtHostContext.ExtHostEditorTabs,ot);const vt=le.set(c.ExtHostContext.ExtHostDecorations,ne.get(ye.IExtHostDecorations)),Et=le.set(c.ExtHostContext.ExtHostDocumentsAndEditors,ne.get(s.IExtHostDocumentsAndEditors)),lt=le.set(c.ExtHostContext.ExtHostCommands,ne.get(h.IExtHostCommands)),dt=le.set(c.ExtHostContext.ExtHostTerminalService,ne.get(G.IExtHostTerminalService)),mt=le.set(c.ExtHostContext.ExtHostDebugService,ne.get(We.IExtHostDebugService)),Rt=le.set(c.ExtHostContext.ExtHostSearch,ne.get(Be.IExtHostSearch)),yt=le.set(c.ExtHostContext.ExtHostTask,ne.get(Re.IExtHostTask)),Ot=le.set(c.ExtHostContext.ExtHostOutputService,ne.get(y.IExtHostOutputService)),hn=le.set(c.ExtHostContext.ExtHostUrls,new B.ExtHostUrls(le)),It=le.set(c.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(le,Et)),Wt=le.set(c.ExtHostContext.ExtHostDocumentContentProviders,new a.ExtHostDocumentContentProvider(le,Et,q)),Zt=le.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new p.ExtHostDocumentSaveParticipant(q,It,le.getProxy(c.MainContext.MainThreadBulkEdits))),wt=le.set(c.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(le,lt,Et,It,ce)),Kt=le.set(c.ExtHostContext.ExtHostNotebookDocuments,new Le.ExtHostNotebookDocuments(q,wt)),Vt=le.set(c.ExtHostContext.ExtHostNotebookEditors,new at.ExtHostNotebookEditors(q,le,wt)),en=le.set(c.ExtHostContext.ExtHostNotebookKernels,new ue.ExtHostNotebookKernels(le,de,wt,q)),tn=le.set(c.ExtHostContext.ExtHostNotebookRenderers,new Ue.ExtHostNotebookRenderers(le,wt)),Pt=le.set(c.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(le,Et)),Qt=le.set(c.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(le.getProxy(c.MainContext.MainThreadTreeViews),lt,q)),bn=le.set(c.ExtHostContext.ExtHostEditorInsets,new X.ExtHostEditorInsets(le.getProxy(c.MainContext.MainThreadEditorInsets),Pt,de)),$t=le.set(c.ExtHostContext.ExtHostDiagnostics,new _.ExtHostDiagnostics(le,q,be)),Ht=le.set(c.ExtHostContext.ExtHostLanguages,new d.ExtHostLanguages(le,It,lt.converter)),gt=le.set(c.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(le,it,It,lt,$t,q,Pe)),nn=le.set(c.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(le,gt)),Nt=le.set(c.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(le,q,Et)),Ut=le.set(c.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(le,Ge,lt)),Xt=le.set(c.ExtHostContext.ExtHostSCM,new w.ExtHostSCM(le,lt,q)),En=le.set(c.ExtHostContext.ExtHostComments,(0,D.createExtHostComments)(le,lt,It)),fn=le.set(c.ExtHostContext.ExtHostProgress,new v.ExtHostProgress(le.getProxy(c.MainContext.MainThreadProgress))),_n=le.set(c.ExtHostContext.ExtHosLabelService,new he.ExtHostLabelService(le)),mn=le.set(c.ExtHostContext.ExtHostTheming,new J.ExtHostTheming(le)),rn=le.set(c.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(le)),sn=le.set(c.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(le,lt)),jt=le.set(c.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(le,{remote:de.remote},Ge,q,Pe)),on=le.set(c.ExtHostContext.ExtHostWebviewPanels,new pe.ExtHostWebviewPanels(le,jt,Ge)),Sn=le.set(c.ExtHostContext.ExtHostCustomEditors,new te.ExtHostCustomEditors(le,It,ce,jt,on)),yn=le.set(c.ExtHostContext.ExtHostWebviewViews,new Z.ExtHostWebviewViews(le,jt)),qt=le.set(c.ExtHostContext.ExtHostTesting,new rt.ExtHostTesting(le,lt)),Yt=le.set(c.ExtHostContext.ExtHostUriOpeners,new ft.ExtHostUriOpeners(le));le.set(c.ExtHostContext.ExtHostInteractive,new De.ExtHostInteractive(le,wt,Et,lt));const Dn=(0,Q.values)(c.ExtHostContext);le.assertRegistered(Dn);const Cn=new xe.ExtHostBulkEdits(le,Et),an=new u.ExtHostClipboard(le),ln=new b.ExtHostMessageService(le,q),zt=new o.ExtHostDialogs(le),Ft=new F.ExtHostStatusBar(le,lt.converter);return m.ExtHostApiCommands.register(lt),function(Ne,Tt,Gt){const bt=function(){let ie=!Ne.isUnderDevelopment;function fe(Te){ie||(q.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Te(ct){if(Array.isArray(ct))ct.forEach(Te);else if(typeof ct=="string")fe(ct);else{const _t=ct;typeof _t.scheme=="undefined"&&fe(ct),!Ne.enableProposedApi&&typeof _t.exclusive=="boolean"&&(0,$.throwProposedApiError)(Ne)}return ct}}(),kn={getSession(ie,fe,Te){return Te?.forceNewSession&&(0,$.checkProposedApiEnabled)(Ne),rn.getSession(Ne,ie,fe,Te)},get onDidChangeSessions(){return rn.onDidChangeSessions},registerAuthenticationProvider(ie,fe,Te,ct){return rn.registerAuthenticationProvider(ie,fe,Te,ct)}},In={registerCommand(ie,fe,Te){return lt.registerCommand(!0,ie,fe,Te)},registerTextEditorCommand(ie,fe,Te){return lt.registerCommand(!0,ie,(...ct)=>{const _t=Pt.getActiveTextEditor();if(!_t){q.warn("Cannot execute "+ie+" because there is no active text editor.");return}return _t.edit(kt=>{fe.apply(Te,[_t,kt,...ct])}).then(kt=>{kt||q.warn("Edits from command "+ie+" were not applied.")},kt=>{q.warn("An error occurred while running command "+ie,kt)})})},registerDiffInformationCommand:(ie,fe,Te)=>((0,$.checkProposedApiEnabled)(Ne),lt.registerCommand(!0,ie,async(...ct)=>{const _t=Et.activeEditor(!0);if(!_t){q.warn("Cannot execute "+ie+" because there is no active text editor.");return}const kt=await Pt.getDiffInformation(_t.id);fe.apply(Te,[kt,...ct])})),executeCommand(ie,...fe){return lt.executeCommand(ie,...fe)},getCommands(ie=!1){return lt.getCommands(ie)}},gn={get machineId(){return de.telemetryInfo.machineId},get sessionId(){return de.telemetryInfo.sessionId},get language(){return de.environment.appLanguage},get appName(){return de.environment.appName},get appRoot(){return de.environment.appRoot?.fsPath??""},get appHost(){return de.environment.appHost},get uriScheme(){return de.environment.appUriScheme},get clipboard(){return an.value},get shell(){return dt.getDefaultShell(!1)},get isTelemetryEnabled(){return He.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return He.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(de.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,fe){return Ze.openUri(ie,{allowTunneling:!!de.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===de.environment.appUriScheme)return hn.createAppUri(ie);try{return await Ze.asExternalUri(ie,{allowTunneling:!!de.remote.authority})}catch(fe){if((0,ze.matchesScheme)(ie,Qe.Schemas.http)||(0,ze.matchesScheme)(ie,Qe.Schemas.https))return ie;throw fe}},get remoteName(){return(0,_e.getRemoteName)(de.remote.authority)},get remoteAuthority(){return de.remote.authority},get uiKind(){return de.uiKind}};de.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=de.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,Pn={createTestController(ie,fe){return qt.createTestController(ie,fe)},createTestObserver(){return(0,$.checkProposedApiEnabled)(Ne),qt.createTestObserver()},runTests(ie){return(0,$.checkProposedApiEnabled)(Ne),qt.runTests(ie)},get onDidChangeTestResults(){return(0,$.checkProposedApiEnabled)(Ne),qt.onResultsChanged},get testResults(){return(0,$.checkProposedApiEnabled)(Ne),qt.results}},An={getExtension(ie){const fe=Tt.getExtensionDescription(ie);if(fe)return new r.Extension(Fe,Ne.identifier,fe,pn)},get all(){return Tt.getAllExtensionDescriptions().map(ie=>new r.Extension(Fe,Ne.identifier,ie,pn))},get onDidChange(){return Tt.onDidChange}},cn={createDiagnosticCollection(ie){return $t.createDiagnosticCollection(Ne.identifier,ie)},get onDidChangeDiagnostics(){return $t.onDidChangeDiagnostics},getDiagnostics:ie=>$t.getDiagnostics(ie),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(ie,fe){return Ht.changeLanguage(ie.uri,fe)},match(ie,fe){return(0,n.score)(z.LanguageSelector.from(ie),fe.uri,fe.languageId,!0)},registerCodeActionsProvider(ie,fe,Te){return gt.registerCodeActionProvider(Ne,bt(ie),fe,Te)},registerCodeLensProvider(ie,fe){return gt.registerCodeLensProvider(Ne,bt(ie),fe)},registerDefinitionProvider(ie,fe){return gt.registerDefinitionProvider(Ne,bt(ie),fe)},registerDeclarationProvider(ie,fe){return gt.registerDeclarationProvider(Ne,bt(ie),fe)},registerImplementationProvider(ie,fe){return gt.registerImplementationProvider(Ne,bt(ie),fe)},registerTypeDefinitionProvider(ie,fe){return gt.registerTypeDefinitionProvider(Ne,bt(ie),fe)},registerHoverProvider(ie,fe){return gt.registerHoverProvider(Ne,bt(ie),fe,Ne.identifier)},registerEvaluatableExpressionProvider(ie,fe){return gt.registerEvaluatableExpressionProvider(Ne,bt(ie),fe,Ne.identifier)},registerInlineValuesProvider(ie,fe){return gt.registerInlineValuesProvider(Ne,bt(ie),fe,Ne.identifier)},registerDocumentHighlightProvider(ie,fe){return gt.registerDocumentHighlightProvider(Ne,bt(ie),fe)},registerLinkedEditingRangeProvider(ie,fe){return gt.registerLinkedEditingRangeProvider(Ne,bt(ie),fe)},registerReferenceProvider(ie,fe){return gt.registerReferenceProvider(Ne,bt(ie),fe)},registerRenameProvider(ie,fe){return gt.registerRenameProvider(Ne,bt(ie),fe)},registerDocumentSymbolProvider(ie,fe,Te){return gt.registerDocumentSymbolProvider(Ne,bt(ie),fe,Te)},registerWorkspaceSymbolProvider(ie){return gt.registerWorkspaceSymbolProvider(Ne,ie)},registerDocumentFormattingEditProvider(ie,fe){return gt.registerDocumentFormattingEditProvider(Ne,bt(ie),fe)},registerDocumentRangeFormattingEditProvider(ie,fe){return gt.registerDocumentRangeFormattingEditProvider(Ne,bt(ie),fe)},registerOnTypeFormattingEditProvider(ie,fe,Te,...ct){return gt.registerOnTypeFormattingEditProvider(Ne,bt(ie),fe,[Te].concat(ct))},registerDocumentSemanticTokensProvider(ie,fe,Te){return gt.registerDocumentSemanticTokensProvider(Ne,bt(ie),fe,Te)},registerDocumentRangeSemanticTokensProvider(ie,fe,Te){return gt.registerDocumentRangeSemanticTokensProvider(Ne,bt(ie),fe,Te)},registerSignatureHelpProvider(ie,fe,Te,...ct){return typeof Te=="object"?gt.registerSignatureHelpProvider(Ne,bt(ie),fe,Te):gt.registerSignatureHelpProvider(Ne,bt(ie),fe,typeof Te=="undefined"?[]:[Te,...ct])},registerCompletionItemProvider(ie,fe,...Te){return gt.registerCompletionItemProvider(Ne,bt(ie),fe,Te)},registerInlineCompletionItemProvider(ie,fe){return(0,$.checkProposedApiEnabled)(Ne),gt.registerInlineCompletionsProvider(Ne,bt(ie),fe)},registerDocumentLinkProvider(ie,fe){return gt.registerDocumentLinkProvider(Ne,bt(ie),fe)},registerColorProvider(ie,fe){return gt.registerColorProvider(Ne,bt(ie),fe)},registerFoldingRangeProvider(ie,fe){return gt.registerFoldingRangeProvider(Ne,bt(ie),fe)},registerSelectionRangeProvider(ie,fe){return gt.registerSelectionRangeProvider(Ne,ie,fe)},registerCallHierarchyProvider(ie,fe){return gt.registerCallHierarchyProvider(Ne,ie,fe)},setLanguageConfiguration:(ie,fe)=>gt.setLanguageConfiguration(Ne,ie,fe),getTokenInformationAtPosition(ie,fe){return(0,$.checkProposedApiEnabled)(Ne),Ht.tokenAtPosition(ie,fe)},registerInlayHintsProvider(ie,fe){return(0,$.checkProposedApiEnabled)(Ne),gt.registerInlayHintsProvider(Ne,ie,fe)},registerTypeHierarchyProvider(ie,fe){return(0,$.checkProposedApiEnabled)(Ne),gt.registerTypeHierarchyProvider(Ne,ie,fe)},createLanguageStatusItem(ie,fe){return(0,$.checkProposedApiEnabled)(Ne),Ht.createLanguageStatusItem(Ne,ie,fe)}},Tn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(ie,fe,Te){const ct=await(R.URI.isUri(ie)?Promise.resolve(vn.openTextDocument(ie)):Promise.resolve(ie));return Pt.showTextDocument(ct,fe,Te)},createTextEditorDecorationType(ie){return Pt.createTextEditorDecorationType(Ne,ie)},onDidChangeActiveTextEditor(ie,fe,Te){return Pt.onDidChangeActiveTextEditor(ie,fe,Te)},onDidChangeVisibleTextEditors(ie,fe,Te){return Pt.onDidChangeVisibleTextEditors(ie,fe,Te)},onDidChangeTextEditorSelection(ie,fe,Te){return Pt.onDidChangeTextEditorSelection(ie,fe,Te)},onDidChangeTextEditorOptions(ie,fe,Te){return Pt.onDidChangeTextEditorOptions(ie,fe,Te)},onDidChangeTextEditorVisibleRanges(ie,fe,Te){return Pt.onDidChangeTextEditorVisibleRanges(ie,fe,Te)},onDidChangeTextEditorViewColumn(ie,fe,Te){return Pt.onDidChangeTextEditorViewColumn(ie,fe,Te)},onDidCloseTerminal(ie,fe,Te){return dt.onDidCloseTerminal(ie,fe,Te)},onDidOpenTerminal(ie,fe,Te){return dt.onDidOpenTerminal(ie,fe,Te)},onDidChangeActiveTerminal(ie,fe,Te){return dt.onDidChangeActiveTerminal(ie,fe,Te)},onDidChangeTerminalDimensions(ie,fe,Te){return(0,$.checkProposedApiEnabled)(Ne),dt.onDidChangeTerminalDimensions(ie,fe,Te)},onDidChangeTerminalState(ie,fe,Te){return(0,$.checkProposedApiEnabled)(Ne),dt.onDidChangeTerminalState(ie,fe,Te)},onDidWriteTerminalData(ie,fe,Te){return(0,$.checkProposedApiEnabled)(Ne),dt.onDidWriteTerminalData(ie,fe,Te)},get state(){return Ze.state},onDidChangeWindowState(ie,fe,Te){return Ze.onDidChangeWindowState(ie,fe,Te)},showInformationMessage(ie,...fe){return ln.showMessage(Ne,C.default.Info,ie,fe[0],fe.slice(1))},showWarningMessage(ie,...fe){return ln.showMessage(Ne,C.default.Warning,ie,fe[0],fe.slice(1))},showErrorMessage(ie,...fe){return ln.showMessage(Ne,C.default.Error,ie,fe[0],fe.slice(1))},showQuickPick(ie,fe,Te){return Ut.showQuickPick(ie,!!Ne.enableProposedApi,fe,Te)},showWorkspaceFolderPick(ie){return Ut.showWorkspaceFolderPick(ie)},showInputBox(ie,fe){return Ut.showInput(ie,fe)},showOpenDialog(ie){return zt.showOpenDialog(ie)},showSaveDialog(ie){return zt.showSaveDialog(ie)},createStatusBarItem(ie,fe,Te){let ct,_t,kt;return typeof ie=="string"?(ct=ie,_t=fe,kt=Te):(_t=ie,kt=fe),Ft.createStatusBarEntry(Ne,ct,_t,kt)},setStatusBarMessage(ie,fe){return Ft.setStatusBarMessage(ie,fe)},withScmProgress(ie){return Pe.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),fn.withProgress(Ne,{location:N.ProgressLocation.SourceControl},(fe,Te)=>ie({report(ct){}}))},withProgress(ie,fe){return fn.withProgress(Ne,ie,fe)},createOutputChannel(ie){return Ot.createOutputChannel(ie,Ne)},createWebviewPanel(ie,fe,Te,ct){return on.createWebviewPanel(Ne,ie,fe,Te,ct)},createWebviewTextEditorInset(ie,fe,Te,ct){return(0,$.checkProposedApiEnabled)(Ne),bn.createWebviewEditorInset(ie,fe,Te,ct,Ne)},createTerminal(ie,fe,Te){return typeof ie=="object"?("location"in ie&&(0,$.checkProposedApiEnabled)(Ne),"pty"in ie?dt.createExtensionTerminal(ie):dt.createTerminalFromOptions(ie)):dt.createTerminal(ie,fe,Te)},registerTerminalLinkProvider(ie){return dt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,fe){return dt.registerProfileProvider(Ne,ie,fe)},registerTreeDataProvider(ie,fe){return Qt.registerTreeDataProvider(ie,fe,Ne)},createTreeView(ie,fe){return Qt.createTreeView(ie,fe,Ne)},registerWebviewPanelSerializer:(ie,fe)=>on.registerWebviewPanelSerializer(Ne,ie,fe),registerCustomEditorProvider:(ie,fe,Te={})=>Sn.registerCustomEditorProvider(Ne,ie,fe,Te),registerFileDecorationProvider(ie){return vt.registerFileDecorationProvider(ie,Ne.identifier)},registerUriHandler(ie){return hn.registerUriHandler(Ne.identifier,ie)},createQuickPick(){return Ut.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return Ut.createInputBox(Ne.identifier)},get activeColorTheme(){return mn.activeColorTheme},onDidChangeActiveColorTheme(ie,fe,Te){return mn.onDidChangeActiveColorTheme(ie,fe,Te)},registerWebviewViewProvider(ie,fe,Te){return yn.registerWebviewViewProvider(Ne,ie,fe,Te?.webviewOptions)},get activeNotebookEditor(){return(0,$.checkProposedApiEnabled)(Ne),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,fe,Te){return(0,$.checkProposedApiEnabled)(Ne),wt.onDidChangeActiveNotebookEditor(ie,fe,Te)},get visibleNotebookEditors(){return(0,$.checkProposedApiEnabled)(Ne),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,$.checkProposedApiEnabled)(Ne),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,fe,Te){return(0,$.checkProposedApiEnabled)(Ne),Vt.onDidChangeNotebookEditorSelection(ie,fe,Te)},onDidChangeNotebookEditorVisibleRanges(ie,fe,Te){return(0,$.checkProposedApiEnabled)(Ne),Vt.onDidChangeNotebookEditorVisibleRanges(ie,fe,Te)},showNotebookDocument(ie,fe){return(0,$.checkProposedApiEnabled)(Ne),wt.showNotebookDocument(ie,fe)},registerExternalUriOpener(ie,fe,Te){return(0,$.checkProposedApiEnabled)(Ne),Yt.registerExternalUriOpener(Ne.identifier,ie,fe,Te)},get tabs(){return(0,$.checkProposedApiEnabled)(Ne),ot.tabs},get activeTab(){return(0,$.checkProposedApiEnabled)(Ne),ot.activeTab},get onDidChangeTabs(){return(0,$.checkProposedApiEnabled)(Ne),ot.onDidChangeTabs},get onDidChangeActiveTab(){return(0,$.checkProposedApiEnabled)(Ne),ot.onDidChangeActiveTab},getInlineCompletionItemController(ie){return(0,$.checkProposedApiEnabled)(Ne),l.InlineCompletionController.get(ie)}},vn={get rootPath(){return Pe.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ge.getPath()},set rootPath(ie){throw L.readonly()},getWorkspaceFolder(ie){return Ge.getWorkspaceFolder(ie)},get workspaceFolders(){return Ge.getWorkspaceFolders()},get name(){return Ge.name},set name(ie){throw L.readonly()},get workspaceFile(){return Ge.workspaceFile},set workspaceFile(ie){throw L.readonly()},updateWorkspaceFolders:(ie,fe,...Te)=>Ge.updateWorkspaceFolders(Ne,ie,fe||0,...Te),onDidChangeWorkspaceFolders:function(ie,fe,Te){return Ge.onDidChangeWorkspace(ie,fe,Te)},asRelativePath:(ie,fe)=>Ge.getRelativePath(ie,fe),findFiles:(ie,fe,Te,ct)=>Ge.findFiles(z.GlobPattern.from(ie),z.GlobPattern.from(fe),Te,Ne.identifier,ct),findTextInFiles:(ie,fe,Te,ct)=>{let _t,kt;return typeof fe=="object"?(_t=fe,kt=Te):(_t={},kt=fe,ct=Te),Ge.findTextInFiles(ie,_t||{},kt,Ne.identifier,ct)},saveAll:ie=>Ge.saveAll(ie),applyEdit(ie){return Cn.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,fe,Te,ct)=>Nt.createFileSystemWatcher(z.GlobPattern.from(ie),fe,Te,ct),get textDocuments(){return It.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw L.readonly()},openTextDocument(ie){let fe;const Te=ie;if(typeof ie=="string")fe=Promise.resolve(R.URI.file(ie));else if(R.URI.isUri(ie))fe=Promise.resolve(ie);else if(!Te||typeof Te=="object")fe=It.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(ct=>It.ensureDocumentData(ct).then(_t=>_t.document))},onDidOpenTextDocument:(ie,fe,Te)=>It.onDidAddDocument(ie,fe,Te),onDidCloseTextDocument:(ie,fe,Te)=>It.onDidRemoveDocument(ie,fe,Te),onDidChangeTextDocument:(ie,fe,Te)=>It.onDidChangeDocument(ie,fe,Te),onDidSaveTextDocument:(ie,fe,Te)=>It.onDidSaveDocument(ie,fe,Te),onWillSaveTextDocument:(ie,fe,Te)=>Zt.getOnWillSaveTextDocumentEvent(Ne)(ie,fe,Te),get notebookDocuments(){return wt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,fe){let Te;if(R.URI.isUri(ie))Te=ie,await wt.openNotebookDocument(ie);else if(typeof ie=="string")Te=R.URI.revive(await wt.createNotebookDocument({viewType:ie,content:fe}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,fe,Te,ct){return wt.registerNotebookSerializer(Ne,ie,fe,Te,Ne.enableProposedApi?ct:void 0)},registerNotebookContentProvider:(ie,fe,Te,ct)=>((0,$.checkProposedApiEnabled)(Ne),wt.registerNotebookContentProvider(Ne,ie,fe,Te,Ne.enableProposedApi?ct:void 0)),onDidChangeConfiguration:(ie,fe,Te)=>Gt.onDidChangeConfiguration(ie,fe,Te),getConfiguration(ie,fe){return fe=arguments.length===1?void 0:fe,Gt.getConfiguration(ie,fe,Ne)},registerTextDocumentContentProvider(ie,fe){return Wt.registerTextDocumentContentProvider(ie,fe)},registerTaskProvider:(ie,fe)=>(Pe.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Ne,ie,fe)),registerFileSystemProvider(ie,fe,Te){return nn.registerFileSystemProvider(Ne.identifier,ie,fe,Te)},get fs(){return we.value},registerFileSearchProvider:(ie,fe)=>((0,$.checkProposedApiEnabled)(Ne),Rt.registerFileSearchProvider(ie,fe)),registerTextSearchProvider:(ie,fe)=>((0,$.checkProposedApiEnabled)(Ne),Rt.registerTextSearchProvider(ie,fe)),registerRemoteAuthorityResolver:(ie,fe)=>((0,$.checkProposedApiEnabled)(Ne),Fe.registerRemoteAuthorityResolver(ie,fe)),registerResourceLabelFormatter:ie=>((0,$.checkProposedApiEnabled)(Ne),_n.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,fe,Te)=>Nt.onDidCreateFile(ie,fe,Te),onDidDeleteFiles:(ie,fe,Te)=>Nt.onDidDeleteFile(ie,fe,Te),onDidRenameFiles:(ie,fe,Te)=>Nt.onDidRenameFile(ie,fe,Te),onWillCreateFiles:(ie,fe,Te)=>Nt.getOnWillCreateFileEvent(Ne)(ie,fe,Te),onWillDeleteFiles:(ie,fe,Te)=>Nt.getOnWillDeleteFileEvent(Ne)(ie,fe,Te),onWillRenameFiles:(ie,fe,Te)=>Nt.getOnWillRenameFileEvent(Ne)(ie,fe,Te),openTunnel:ie=>((0,$.checkProposedApiEnabled)(Ne),Ae.openTunnel(Ne,ie).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,$.checkProposedApiEnabled)(Ne),Ae.getTunnels()},onDidChangeTunnels:(ie,fe,Te)=>((0,$.checkProposedApiEnabled)(Ne),Ae.onDidChangeTunnels(ie,fe,Te)),registerPortAttributesProvider:(ie,fe)=>((0,$.checkProposedApiEnabled)(Ne),Ae.registerPortsAttributesProvider(ie,fe)),registerTimelineProvider:(ie,fe)=>((0,$.checkProposedApiEnabled)(Ne),sn.registerTimelineProvider(ie,fe,Ne.identifier,lt.converter)),get isTrusted(){return Ge.trusted},requestWorkspaceTrust:ie=>((0,$.checkProposedApiEnabled)(Ne),Ge.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,fe,Te)=>Ge.onDidGrantWorkspaceTrust(ie,fe,Te)},Rn={get inputBox(){return Pe.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),Xt.getLastInputBox(Ne)},createSourceControl(ie,fe,Te){return Xt.createSourceControl(Ne,ie,fe,Te)}},Ln={createCommentController(ie,fe){return En.createCommentController(Ne,ie,fe)}},Fn={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(ie,fe,Te){return mt.onDidStartDebugSession(ie,fe,Te)},onDidTerminateDebugSession(ie,fe,Te){return mt.onDidTerminateDebugSession(ie,fe,Te)},onDidChangeActiveDebugSession(ie,fe,Te){return mt.onDidChangeActiveDebugSession(ie,fe,Te)},onDidReceiveDebugSessionCustomEvent(ie,fe,Te){return mt.onDidReceiveDebugSessionCustomEvent(ie,fe,Te)},onDidChangeBreakpoints(ie,fe,Te){return mt.onDidChangeBreakpoints(ie,fe,Te)},registerDebugConfigurationProvider(ie,fe,Te){return mt.registerDebugConfigurationProvider(ie,fe,Te||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,fe){return mt.registerDebugAdapterDescriptorFactory(Ne,ie,fe)},registerDebugAdapterTrackerFactory(ie,fe){return mt.registerDebugAdapterTrackerFactory(ie,fe)},startDebugging(ie,fe,Te){return!Te||typeof Te=="object"&&"configuration"in Te?mt.startDebugging(ie,fe,{parentSession:Te}):mt.startDebugging(ie,fe,Te||{})},stopDebugging(ie){return mt.stopDebugging(ie)},addBreakpoints(ie){return mt.addBreakpoints(ie)},removeBreakpoints(ie){return mt.removeBreakpoints(ie)},asDebugSourceUri(ie,fe){return mt.asDebugSourceUri(ie,fe)}},Mn={registerTaskProvider:(ie,fe)=>yt.registerTaskProvider(Ne,ie,fe),fetchTasks:ie=>yt.fetchTasks(ie),executeTask:ie=>yt.executeTask(Ne,ie),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(ie,fe,Te)=>yt.onDidStartTask(ie,fe,Te),onDidEndTask:(ie,fe,Te)=>yt.onDidEndTask(ie,fe,Te),onDidStartTaskProcess:(ie,fe,Te)=>yt.onDidStartTaskProcess(ie,fe,Te),onDidEndTaskProcess:(ie,fe,Te)=>yt.onDidEndTaskProcess(ie,fe,Te)},On={createNotebookController(ie,fe,Te,ct,_t){return en.createNotebookController(Ne,ie,fe,Te,ct,Ne.enableProposedApi?_t:void 0)},registerNotebookCellStatusBarItemProvider:(ie,fe)=>wt.registerNotebookCellStatusBarItemProvider(Ne,ie,fe),get onDidSaveNotebookDocument(){return(0,$.checkProposedApiEnabled)(Ne),Kt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ie){return(0,$.checkProposedApiEnabled)(Ne),Vt.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return tn.createRendererMessaging(Ne,ie)},onDidChangeNotebookDocumentMetadata(ie,fe,Te){return(0,$.checkProposedApiEnabled)(Ne),Kt.onDidChangeNotebookDocumentMetadata(ie,fe,Te)},onDidChangeNotebookCells(ie,fe,Te){return(0,$.checkProposedApiEnabled)(Ne),wt.onDidChangeNotebookCells(ie,fe,Te)},onDidChangeNotebookCellExecutionState(ie,fe,Te){return(0,$.checkProposedApiEnabled)(Ne),wt.onDidChangeNotebookCellExecutionState(ie,fe,Te)},onDidChangeCellOutputs(ie,fe,Te){return(0,$.checkProposedApiEnabled)(Ne),wt.onDidChangeCellOutputs(ie,fe,Te)},onDidChangeCellMetadata(ie,fe,Te){return(0,$.checkProposedApiEnabled)(Ne),wt.onDidChangeCellMetadata(ie,fe,Te)},createConcatTextDocument(ie,fe){return(0,$.checkProposedApiEnabled)(Ne),new Ke.ExtHostNotebookConcatDocument(wt,It,ie,fe)}};return{version:de.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:gn,extensions:An,languages:cn,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:Tn,workspace:vn,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionList:N.InlineSuggestions,Hover:N.Hover,IndentAction:T.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:c.UIKind,Uri:R.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:Ie.TextSearchCompleteMessageType,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=ke}),define(me[277],ge([0,1,82,68,36,131,37,44,45,33,72,55,74,92,53,67,132,91,52,90,122,54]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D,k,_,o,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(h.IExtHostApiDeprecationService,h.ExtHostApiDeprecationService),(0,g.registerSingleton)(E.IExtHostCommands,E.ExtHostCommands),(0,g.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration),(0,g.registerSingleton)(k.IExtHostConsumerFileSystem,k.ExtHostConsumerFileSystem),(0,g.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,g.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,g.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(_.IExtHostFileSystemInfo,_.ExtHostFileSystemInfo),(0,g.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,g.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,g.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,g.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,g.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,g.registerSingleton)(u.IExtHostTunnelService,u.ExtHostTunnelService),(0,g.registerSingleton)(D.IExtHostWindow,D.ExtHostWindow),(0,g.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,g.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,g.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry),(0,g.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs)}),define(me[93],ge([0,1,17,12,31,71]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function R(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=R;function E(P,c,m,u){const h=(0,g.mapArrayOrNot)(m,S),D=new I.TextSearchMatch(c,h,u),k=D.preview.matches;return{ranges:(0,g.mapArrayOrNot)(h,T),uri:P,preview:{text:D.preview.text,matches:(0,g.mapArrayOrNot)(k,T)}}}e.createTextSearchResult=E;function S(P){return new I.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function T(P){return new C.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let n=class{constructor(c,m){this.prefix=c,this.logService=m}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};n=Ve([$e(1,L.ILogService)],n),e.OutputChannel=n}),define(me[278],ge([0,1,96,23]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(s=>s===t)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,R=512,E=512*8,S=512*128;class T{constructor(s){this.iconvLiteDecoder=s}static async create(s){let r;if(s!==e.UTF8)r=(await new Promise((f,l)=>{Y(["iconv-lite-umd"],f,l)})).getDecoder(m(s));else{const i=new TextDecoder;r={write(f){return i.decode(f,{stream:!0})},end(){return i.decode()}}}return new T(r)}write(s){return this.iconvLiteDecoder.write(s)}end(){return this.iconvLiteDecoder.end()}}function n(t,s){const r=s.minBytesRequiredForDetection??s.guessEncoding?E:R;return new Promise((i,f)=>{const l=(0,g.newWriteableStream)(A=>A.join("")),d=[];let b=0,y;const v=async()=>{try{const A=await p({buffer:L.VSBuffer.concat(d),bytesRead:b},s.guessEncoding);A.encoding=await s.overwriteEncoding(A.encoding),y=await T.create(A.encoding);const w=y.write(L.VSBuffer.concat(d).buffer);l.write(w),d.length=0,b=0,i({stream:l,detected:A})}catch(A){f(A)}};(0,g.listenStream)(t,{onData:async A=>{y?l.write(y.write(A.buffer)):(d.push(A),b+=A.byteLength,b>=r&&(t.pause(),await v(),setTimeout(()=>t.resume())))},onError:A=>l.error(A),onEnd:async()=>{y||await v(),l.end(y?.end())}})})}e.toDecodeStream=n;async function P(t,s,r){const f=(await new Promise((b,y)=>{Y(["iconv-lite-umd"],b,y)})).getEncoder(m(s),r);let l=!1,d=!1;return{read(){if(d)return null;const b=t.read();if(typeof b!="string"){if(d=!0,!l&&r?.addBOM)switch(s){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const y=f.end();return y&&y.length>0?(l=!0,L.VSBuffer.wrap(y)):null}return l=!0,L.VSBuffer.wrap(f.write(b))}}}e.toEncodeReadable=P;async function c(t){return(await new Promise((r,i)=>{Y(["iconv-lite-umd"],r,i)})).encodingExists(m(t))}e.encodingExists=c;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function u(t,s){if(!t||s<e.UTF16be_BOM.length)return null;const r=t.readUInt8(0),i=t.readUInt8(1);if(r===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(s<e.UTF8_BOM.length)return null;const f=t.readUInt8(2);return r===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&f===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=u;const h=["ascii","utf-16","utf-32"];async function D(t){const s=await new Promise((d,b)=>{Y(["jschardet"],d,b)}),r=t.slice(0,S),i=o(r.buffer),f=s.detect(i);if(!f||!f.encoding)return null;const l=f.encoding.toLowerCase();return 0<=h.indexOf(l)?null:_(f.encoding)}const k={ibm866:"cp866",big5:"cp950"};function _(t){const s=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return k[s]||s}function o(t){let s="";for(let r=0;r<t.length;r++)s+=String.fromCharCode(t[r]);return s}function a(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const s=t.match(/windows(\d+)/);return s?"windows-"+s[1]:t}}e.toCanonicalName=a;function p({buffer:t,bytesRead:s},r){let i=u(t,s),f=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let l=!0,d=!0,b=!1;for(let y=0;y<s&&y<C;y++){const v=y%2==1,A=t.readUInt8(y)===0;if(A&&(b=!0),l&&(v&&!A||!v&&A)&&(l=!1),d&&(v&&A||!v&&!A)&&(d=!1),A&&!l&&!d)break}b&&(l?i=e.UTF16le:d?i=e.UTF16be:f=!0)}return r&&!f&&!i&&t?D(t.slice(0,s)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:f,encoding:i}}e.detectEncodingFromBuffer=p,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[134],ge([0,1,278,28,133]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends I.TextSearchManager{constructor(E,S,T=L,n="searchProcess"){super(E,S,{readdir:P=>T.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,g.toCanonicalName)(P)},n)}}e.NativeTextSearchManager=C}),define(me[279],ge([0,1,280,295,296,2,297]),function(Y,e,g,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function E(P,c,m,u,h,D){const k=D.environment.useHostProxy,_=typeof k=="boolean"?k:!D.remote.isRemote,o=(0,R.createProxyResolver)({resolveProxy:p=>P.resolveProxy(p),getHttpProxySetting:()=>c.getConfiguration("http").get("proxy"),log:(p,t,...s)=>{switch(p){case R.LogLevel.Trace:u.trace(t,...s);break;case R.LogLevel.Debug:u.debug(t,...s);break;case R.LogLevel.Info:u.info(t,...s);break;case R.LogLevel.Warning:u.warn(t,...s);break;case R.LogLevel.Error:u.error(t,...s);break;case R.LogLevel.Critical:u.critical(t,...s);break;case R.LogLevel.Off:break;default:r(p,t,s);break}function r(i,f,...l){u.error("Unknown log level",i),u.error(f,...l)}},getLogLevel:()=>u.getLevel(),proxyResolveTelemetry:p=>{h.$publicLog2("resolveProxy",p)},useHostProxy:_,env:process.env}),a=S(c,o);return n(m,a)}e.connectProxyResolver=E;function S(P,c){const m={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(h=>{m.config=P.getConfiguration("http").get("proxySupport")||"off"});const u={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(h=>{u.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,R.createHttpPatch)(g,c,{config:"off"},u,!0)),on:Object.assign({},g,(0,R.createHttpPatch)(g,c,{config:"on"},u,!0)),override:Object.assign({},g,(0,R.createHttpPatch)(g,c,{config:"override"},u,!0)),onRequest:Object.assign({},g,(0,R.createHttpPatch)(g,c,m,u,!0)),default:Object.assign(g,(0,R.createHttpPatch)(g,c,m,u,!1))},https:{off:Object.assign({},L,(0,R.createHttpPatch)(L,c,{config:"off"},u,!0)),on:Object.assign({},L,(0,R.createHttpPatch)(L,c,{config:"on"},u,!0)),override:Object.assign({},L,(0,R.createHttpPatch)(L,c,{config:"override"},u,!0)),onRequest:Object.assign({},L,(0,R.createHttpPatch)(L,c,m,u,!0)),default:Object.assign(L,(0,R.createHttpPatch)(L,c,m,u,!1))},tls:Object.assign(I,(0,R.createTlsPatch)(I))}}const T=new Map;function n(P,c){return P.getExtensionPathIndex().then(m=>{const u=Y.__$__nodeRequire("module"),h=u._load;u._load=function(k,_,o){if(k==="tls")return c.tls;if(k!=="http"&&k!=="https")return h.apply(this,arguments);const a=c[k],p=m.findSubstr(C.URI.file(_.filename).fsPath);let t=T.get(p);if(t||T.set(p,t={}),!t[k]){let s=a.default;p&&p.enableProposedApi&&(s=a[p.proxySupport]||a.onRequest),t[k]={...s}}return t[k]}})}}),define(me[281],ge([0,1,39,8,78,29,11,9,93,282]),function(Y,e,g,L,I,C,R,E,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const n=T.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(o,a,p,t){const s=c(o,a,p,t),r=a.folder.fsPath;return{cmd:g.spawn(n,s.args,{cwd:r}),rgDiskPath:n,siblingClauses:s.siblingClauses,rgArgs:s,cwd:r}}e.spawnRipgrepCmd=P;function c(o,a,p,t){const s=["--files","--hidden","--case-sensitive"];u([a],p,!1).forEach(i=>{const f=(0,S.anchorGlob)(i);if(s.push("-g",f),R.isMacintosh){const l=(0,I.normalizeNFD)(f);l!==f&&s.push("-g",l)}});const r=m([a],t,void 0,!1);return r.globArgs.forEach(i=>{const f=`!${(0,S.anchorGlob)(i)}`;if(s.push("-g",f),R.isMacintosh){const l=(0,I.normalizeNFD)(f);l!==f&&s.push("-g",l)}}),a.disregardIgnoreFiles!==!1?s.push("--no-ignore"):s.push("--no-ignore-parent"),a.ignoreSymlinks||s.push("--follow"),o.exists&&s.push("--quiet"),s.push("--no-config"),a.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:r.siblingClauses}}function m(o,a,p,t=!0){const s=[];let r={};return o.forEach(i=>{const f=Object.assign({},i.excludePattern||{},a||{}),l=h(f,t?i.folder.fsPath:void 0,p);s.push(...l.globArgs),l.siblingClauses&&(r=Object.assign(r,l.siblingClauses))}),{globArgs:s,siblingClauses:r}}e.foldersToRgExcludeGlobs=m;function u(o,a,p=!0){const t=[];return o.forEach(s=>{const r=Object.assign({},a||{},s.includePattern||{}),i=h(r,p?s.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=u;function h(o,a,p){const t=[],s={};return Object.keys(o).forEach(r=>{if(p&&p.has(r)||!r)return;const i=o[r];r=k(a?D(a,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof i=="boolean"&&i?(r.startsWith("\\\\")&&(r+="**"),t.push(_(r))):i&&i.when&&(s[r]=i)}),{globArgs:t,siblingClauses:s}}function D(o,a){return L.isAbsolute(a)?a:L.join(o,a)}e.getAbsoluteGlob=D;function k(o){return o=E.rtrim(o,"\\"),E.rtrim(o,"/")}function _(o){return C.getRoot(o).toLowerCase()==="c:/"?o.replace(/^c:[/\\]/i,"/"):o}e.fixDriveC=_}),define(me[283],ge([0,1,39,50,8,104,17,61,30,78,29,11,46,9,13,28,31,281,101]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const o=new Set;process.on("exit",()=>{o.forEach(r=>r())});class a{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&S.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,_.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&S.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(f=>{const l=Object.assign({},f.excludePattern||{},this.config.excludePattern||{}),d=f.folder.fsPath;i.folderQueries.map(b=>b.folder.fsPath).filter(b=>b!==d).forEach(b=>{(0,n.isEqualOrParent)(b,d)&&(l[I.relative(d,b)]=!0)}),this.folderExcludePatterns.set(d,new t(l,d))})}cancel(){this.isCanceled=!0}walk(i,f,l,d,b){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return b(null,this.isLimitHit);f.forEach(y=>{const v=I.basename(y.fsPath);this.globalExcludePattern&&this.globalExcludePattern(y.fsPath,v)||this.matchFile(l,{relativePath:y.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(i,(y,v)=>{this.call(this.cmdTraversal,this,y,l,d,A=>{if(A){const w=(0,E.toErrorMessage)(A);console.error(w),this.errors.push(w),v(A,void 0)}else v(null,void 0)})},(y,v)=>{this.fileWalkSW.stop();const A=y?R.coalesce(y)[0]:null;b(A,this.isLimitHit)})}parallel(i,f,l){const d=new Array(i.length),b=new Array(i.length);let y=!1,v=0;if(i.length===0)return l(null,[]);i.forEach((A,w)=>{f(A,(F,O)=>{if(F?(y=!0,d[w]=null,b[w]=F):(d[w]=O,b[w]=null),++v===i.length)return l(y?b:null,d)})})}call(i,f,...l){try{i.apply(f,l)}catch(d){l[l.length-1](d)}}cmdTraversal(i,f,l,d){const b=i.folder.fsPath,y=P.isMacintosh;let v;const A=()=>v&&v.kill();o.add(A);let w=N=>{o.delete(A),w=()=>{},d(N)},F="";const O=this.initDirectoryTree();let G;const K=(0,k.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);v=K.cmd,G=!Object.keys(K.siblingClauses).length;const U=K.rgArgs.args.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");let z=`${K.rgDiskPath} ${U}
 - cwd: ${K.cwd}`;K.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify(K.rgArgs.siblingClauses)}`),l({message:z}),this.cmdResultCount=0,this.collectStdout(v,"utf8",l,(N,B,x)=>{if(N){w(N);return}if(this.isLimitHit){w();return}const H=(F+(y?T.normalizeNFC(B||""):B)).split(`
`);if(x){const $=H.length;H[$-1]=H[$-1].trim(),H[$-1]||H.pop()}else F=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=H.length,G){for(const $ of H)if(this.matchFile(f,{base:b,relativePath:$,searchPath:this.getSearchPath(i,$)}),this.isLimitHit){A();break}(x||this.isLimitHit)&&w();return}this.addDirectoryEntries(i,O,b,H,f),x&&(this.matchDirectoryTree(O,b,f),w())})}spawnFindCmd(i){const f=this.folderExcludePatterns.get(i.folder.fsPath),l=f.getBasenameTerms(),d=f.getPathTerms(),b=["-L","."];if(l.length||d.length){b.push("-not","(","(");for(const y of l)b.push("-name",y),b.push("-o");for(const y of d)b.push("-path",y),b.push("-o");b.pop(),b.push(")","-prune",")")}return b.push("-type","f"),g.spawn("find",b,{cwd:i.folder.fsPath})}readStdout(i,f,l){let d="";this.collectStdout(i,f,()=>{},(b,y,v)=>{if(b){l(b);return}d+=y,v&&l(null,d)})}collectStdout(i,f,l,d){let b=(A,w,F)=>{(A||F)&&(b=()=>{},this.cmdSW&&this.cmdSW.stop()),d(A,w,F)},y=!1;i.stdout?(this.forwardData(i.stdout,f,b),i.stdout.once("data",()=>y=!0)):l({message:"stdout is null"});let v;i.stderr?v=this.collectData(i.stderr):l({message:"stderr is null"}),i.on("error",A=>{b(A)}),i.on("close",A=>{let w;!y&&(w=this.decodeData(v,f))&&s(w)?b(new Error(`command failed with error code ${A}: ${this.decodeData(v,f)}`)):(this.exists&&A===0&&(this.isLimitHit=!0),b(null,"",!0))})}forwardData(i,f,l){const d=new C.StringDecoder(f);return i.on("data",b=>{l(null,d.write(b))}),d}collectData(i){const f=[];return i.on("data",l=>{f.push(l)}),f}decodeData(i,f){const l=new C.StringDecoder(f);return i.map(d=>l.write(d)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:f},l,d,b){d.indexOf(this.filePattern)!==-1&&this.matchFile(b,{base:l,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const y=v=>{const A=I.basename(v),w=I.dirname(v);let F=f[w];F||(F=f[w]=[],y(w)),F.push({base:l,relativePath:v,basename:A,searchPath:this.getSearchPath(i,v)})};d.forEach(y)}matchDirectoryTree({rootEntries:i,pathToEntries:f},l,d){const b=this,y=this.folderExcludePatterns.get(l),v=this.filePattern;function A(w){b.directoriesWalked++;const F=S.hasSiblingFn(()=>w.map(O=>O.basename));for(let O=0,G=w.length;O<G;O++){const K=w[O],{relativePath:U,basename:z}=K;if(y.test(U,z,v!==z?F:void 0))continue;const N=f[U];if(N)A(N);else{if(b.filesWalked++,U===v)continue;b.matchFile(d,K)}if(b.isLimitHit)break}}A(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,f,l,d,b){const y=i.folder,v=S.hasSiblingFn(()=>l);this.parallel(l,(A,w)=>{if(this.isCanceled||this.isLimitHit)return w(null);const F=f?[f,A].join(I.sep):A;if(this.folderExcludePatterns.get(i.folder.fsPath).test(F,A,this.config.filePattern!==A?v:void 0))return w(null);const O=[y.fsPath,F].join(I.sep);L.lstat(O,(G,K)=>{if(G||this.isCanceled||this.isLimitHit)return w(null);this.statLinkIfNeeded(O,K,(U,z)=>U||this.isCanceled||this.isLimitHit?w(null):z.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(O,K,(N,B)=>N||this.isCanceled||this.isLimitHit||(B=B||"",this.walkedPaths[B])?w(null):(this.walkedPaths[B]=!0,h.Promises.readdir(O).then(x=>{if(this.isCanceled||this.isLimitHit)return w(null);this.doWalk(i,F,x,d,M=>w(M||null))},x=>{w(null)})))):(this.filesWalked++,F===this.filePattern||this.maxFilesize&&u.isNumber(z.size)&&z.size>this.maxFilesize||this.matchFile(d,{base:y.fsPath,relativePath:F,searchPath:this.getSearchPath(i,F)}),w(null,void 0)))})},A=>{const w=A&&R.coalesce(A);return b(w&&w.length>0?w[0]:void 0)})}matchFile(i,f){this.isFileMatch(f)&&(!this.includePattern||this.includePattern(f.relativePath,I.basename(f.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(f))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,D.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,f,l){return f.isSymbolicLink()?L.stat(i,l):l(null,f)}realPathIfNeeded(i,f,l){return f.isSymbolicLink()?L.realpath(i,(d,b)=>d?l(d):l(null,b)):l(null,i)}getSearchPath(i,f){return i.folderName?I.join(i.folderName,f):f}}e.FileWalker=a;class p{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new a(i)}search(i,f,l){this.walker.walk(this.folderQueries,this.extraFiles,i,f,(d,b)=>{l(d,{limitHit:b,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class t{constructor(i,f){this.expression=i,this.root=f,this.init(i)}init(i){let f,l;Object.keys(i).filter(d=>i[d]).forEach(d=>{I.isAbsolute(d)?(f=f||S.getEmptyExpression(),f[d]=i[d]):(l=l||S.getEmptyExpression(),l[d]=i[d])}),this.absoluteParsedExpr=f&&S.parse(f,{trimForExclusions:!0}),this.relativeParsedExpr=l&&S.parse(l,{trimForExclusions:!0})}test(i,f,l){return this.relativeParsedExpr&&this.relativeParsedExpr(i,f,l)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,i),f,l)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...S.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...S.getPathTerms(this.relativeParsedExpr)),i}}function s(r){const i=r.trim().split(`
`),f=i[0].trim();if(f.startsWith("Error parsing regex"))return f;if(f.startsWith("regex parse error"))return m.uppercaseFirstLetter(i[i.length-1].trim());if(f.startsWith("error parsing glob")||f.startsWith("unsupported encoding"))return f.charAt(0).toUpperCase()+f.substr(1);if(f==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(f.startsWith("Literal "))return f}e.rgErrorMsgForDisplay=s}),define(me[135],ge([0,1,39,298,104,17,57,30,8,9,2,31,71,299,282,93]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const D=u.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class k{constructor(y){this.outputChannel=y}provideTextSearchResults(y,v,A,w){return this.outputChannel.appendLine(`provideTextSearchResults ${y.pattern}, ${JSON.stringify({...v,folder:v.folder.toString()})}`),new Promise((F,O)=>{w.onCancellationRequested(()=>M());const G=s(y,v),K=v.folder.fsPath,U=G.map(he=>he.match(/^-/)?he:`'${he}'`).join(" ");this.outputChannel.appendLine(`${D} ${U}
 - cwd: ${K}`);let z=g.spawn(D,G,{cwd:K});z.on("error",he=>{console.error(he),this.outputChannel.appendLine("Error: "+(he&&he.message)),O((0,P.serializeSearchError)(new P.SearchError(he&&he.message,P.SearchErrorCode.rgProcessError)))});let N=!1;const B=new a(v.maxResults,K,v.previewOptions);B.on("result",he=>{N=!0,$="",A.report(he)});let x=!1;const M=()=>{x=!0,z&&z.kill(),B&&B.cancel()};let H=!1;B.on("hitLimit",()=>{H=!0,M()});let $="";z.stdout.on("data",he=>{B.handleData(he),N||($+=he)});let Q=!1;z.stdout.once("data",()=>Q=!0);let X="";z.stderr.on("data",he=>{const _e=he.toString();this.outputChannel.appendLine(_e),X+=_e}),z.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(N?"Got result from parser":"No result from parser"),$&&this.outputChannel.appendLine(`Got data without result: ${$}`),this.outputChannel.appendLine(""),x)F({limitHit:H});else{B.flush(),z=null;let he;X&&!Q&&(he=_(X))?O((0,P.serializeSearchError)(new P.SearchError(he.message,he.code))):F({limitHit:H})}})})}}e.RipgrepTextSearchEngine=k;function _(b){const y=b.split(`
`),v=y[0].trim();if(y.some(w=>w.startsWith("regex parse error")))return new P.SearchError(o(y),P.SearchErrorCode.regexParseError);const A=v.match(/grep config error: unknown encoding: (.*)/);if(A)return new P.SearchError(`Unknown encoding: ${A[1]}`,P.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new P.SearchError(v.charAt(0).toUpperCase()+v.substr(1),P.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new P.SearchError(v.charAt(0).toUpperCase()+v.substr(1),P.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(v,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function o(b){const y=["Regex parse error"],v=b.filter(A=>A.startsWith("PCRE2:"));if(v.length>=1){const A=v[0].replace("PCRE2:","");if(A.indexOf(":")!==-1&&A.split(":").length>=2){const w=A.split(":")[1];y.push(":"+w)}}return y.join("")}e.buildRegexParseError=o;class a extends L.EventEmitter{constructor(y,v,A){super();this.maxResults=y,this.rootFolder=v,this.previewOptions=A,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(y,v){return super.on(y,v),this}handleData(y){if(this.isDone)return;const v=typeof y=="string"?y:this.stringDecoder.write(y);this.handleDecodedData(v)}handleDecodedData(y){let v=y.indexOf(`
`);const A=this.remainder+y;if(v>=0)v+=this.remainder.length;else{this.remainder=A;return}let w=0;for(;v>=0;)this.handleLine(A.substring(w,v).trim()),w=v+1,v=A.indexOf(`
`,w);this.remainder=A.substring(w)}handleLine(y){if(this.isDone||!y)return;let v;try{v=JSON.parse(y)}catch(A){throw new Error(`malformed line from rg: ${y}`)}if(v.type==="match"){const A=p(v.data.path),w=n.URI.file(S.join(this.rootFolder,A)),F=this.createTextSearchMatch(v.data,w);this.onResult(F),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const A=p(v.data.path),w=n.URI.file(S.join(this.rootFolder,A));this.createTextSearchContext(v.data,w).forEach(O=>this.onResult(O))}}createTextSearchMatch(y,v){const A=y.line_number-1,w=p(y.lines),F=Buffer.from(w);let O=0,G=0,K=A;y.submatches.length===0&&y.submatches.push(w.length?{start:0,end:1,match:{text:w[0]}}:{start:0,end:0,match:{text:""}});const U=(0,C.coalesce)(y.submatches.map((z,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const B=p(z.match),x=F.slice(O,z.start).toString().length,M=G+x,H=t(B),$=K,Q=H.numLines+$,X=H.numLines>0?H.lastLineLength:H.lastLineLength+M;return O=z.end,G=X,K=Q,new c.Range($,M,Q,X)}));return(0,h.createTextSearchResult)(v,w,U,this.previewOptions)}createTextSearchContext(y,v){const A=p(y.lines),w=y.line_number;return A.replace(/\r?\n$/,"").split(`
`).map((F,O)=>({text:F,uri:v,lineNumber:w+O}))}onResult(y){this.emit("result",y)}}e.RipgrepParser=a;function p(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const y=/\n/g;let v=0,A=-1,w;for(;w=y.exec(b);)v++,A=w.index;const F=A>=0?b.length-A-1:b.length;return{numLines:v,lastLineLength:F}}function s(b,y){const v=["--hidden"];v.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:A,otherIncludes:w}=(0,R.groupBy)(y.includes,O=>O.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(w&&w.length){const O=new Set;w.forEach(G=>{O.add(G)}),v.push("-g","!*"),O.forEach(G=>{r(G).map(h.anchorGlob).forEach(K=>{v.push("-g",K)})})}A&&A.length&&A.forEach(O=>{v.push("-g",O)}),y.excludes.map(h.anchorGlob).forEach(O=>v.push("-g",`!${O}`)),y.maxFileSize&&v.push("--max-filesize",y.maxFileSize+""),y.useIgnoreFiles?v.push("--no-ignore-parent"):v.push("--no-ignore"),y.followSymlinks&&v.push("--follow"),y.encoding&&y.encoding!=="utf8"&&v.push("--encoding",y.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,T.escapeRegExpCharacters)(b.pattern),b.isRegExp=!0),y.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),b.isRegExp&&(b.pattern=i(b.pattern),v.push("--auto-hybrid-regex"));let F;if(b.isWordMatch){const G=(0,T.createRegExp)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",G)}else if(b.isRegExp){let O=l(b.pattern);O=d(O),v.push("--regexp",O)}else F=b.pattern,v.push("--fixed-strings");return v.push("--no-config"),y.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),b.isMultiline&&v.push("--multiline"),y.beforeContext&&v.push("--before-context",y.beforeContext+""),y.afterContext&&v.push("--after-context",y.afterContext+""),v.push("--"),F&&v.push(F),v.push("."),v}function r(b){const y=(0,E.splitGlobAware)(b,"/");return y.map((v,A)=>y.slice(0,A+1).join("/"))}e.spreadGlobComponents=r;function i(b){const y=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(y);)b=b.replace(y,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(v);)b=b.replace(v,"$1\\x{$2}");return b}e.unicodeEscapesToPCRE2=i;const f=b=>b.type==="Assertion"&&b.kind==="lookbehind";function l(b){let y;try{y=new m.RegExpParser().parsePattern(b)}catch{return b}let v="",A=0;const w=(G,K,U)=>{v+=b.slice(A,G)+U,A=K},F=[];return new m.RegExpVisitor({onCharacterEnter(G){if(G.raw!=="\\n")return;const K=F[0];if(!K)w(G.start,G.end,"\\r?\\n");else if(!F.some(f))if(K.type==="CharacterClass")if(K.negate){const U=b.slice(K.start+2,G.start)+b.slice(G.end,K.end-1);w(K.start,K.end,"(?!\\r?\\n"+(U?`|[${U}]`:"")+")")}else{const U=b.slice(K.start+1,G.start)+b.slice(G.end,K.end-1);w(K.start,K.end,U===""?"\\r?\\n":`(?:[${U}]|\\r?\\n)`)}else K.type==="Quantifier"&&w(G.start,G.end,"(?:\\r?\\n)")},onQuantifierEnter(G){F.unshift(G)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(G){F.unshift(G)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(G){F.unshift(G)},onCharacterClassLeave(){F.shift()},onAssertionEnter(G){f(G)&&F.push(G)},onAssertionLeave(G){F[0]===G&&F.shift()}}).visit(y),v+=b.slice(A),v}e.fixRegexNewline=l;function d(b){return b.replace(/\n/g,"\\r?\\n")}e.fixNewline=d}),define(me[284],ge([0,1,21,135,118,10]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class R{constructor(T){this.outputChannel=T,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(T,n,P,c){const m=new L.RipgrepTextSearchEngine(this.outputChannel);if(n.folder.scheme===C.Schemas.userData){const u={...n,folder:n.folder.with({scheme:C.Schemas.file})},h=new I.Progress(D=>P.report({...D,uri:D.uri.with({scheme:n.folder.scheme})}));return this.withToken(c,D=>m.provideTextSearchResults(T,u,h,D))}else return this.withToken(c,u=>m.provideTextSearchResults(T,n,P,u))}async withToken(T,n){const P=E(T);this.inProgress.add(P);const c=await n(P.token);return this.inProgress.delete(P),c}dispose(){this.inProgress.forEach(T=>T.cancel())}}e.RipgrepSearchProvider=R;function E(S){const T=new g.CancellationTokenSource;return S.onCancellationRequested(()=>T.cancel()),T}}),define(me[285],ge([0,1,28,135,134]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(S){this.query=S}search(S,T,n){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(m){n({message:m})}},c=new I.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(P),g);return new Promise((m,u)=>c.search(h=>{T(h.map(R))},S).then(h=>m({limitHit:h.limitHit,type:"success",stats:h.stats}),u))}}e.TextSearchEngineAdapter=C;function R(E){return{path:E.resource&&E.resource.fsPath,results:E.results,numMatches:(E.results||[]).reduce((S,T)=>{if(T.ranges){const n=T;return S+(Array.isArray(n.ranges)?n.ranges.length:1)}else return S+1},0)}}}),define(me[286],ge([0,1,50,300,17,18,16,3,101,8,46,2,42,31,283,285]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(g);class D{constructor(t="searchProcess"){this.processType=t,this.caches=Object.create(null)}fileSearch(t){let s;const r=o(t),i=new E.Emitter({onFirstListenerDidAdd:()=>{s=(0,C.createCancelablePromise)(f=>this.doFileSearchWithEngine(u.Engine,r,l=>i.fire(l),f)),s.then(f=>i.fire(f),f=>i.fire({type:"error",error:{message:f.message,stack:f.stack}}))},onLastListenerRemove:()=>{s.cancel()}});return i.event}textSearch(t){let s;const r=o(t),i=new E.Emitter({onFirstListenerDidAdd:()=>{s=(0,C.createCancelablePromise)(f=>this.ripgrepTextSearch(r,l=>i.fire(l),f)),s.then(f=>i.fire(f),f=>i.fire({type:"error",error:{message:f.message,stack:f.stack}}))},onLastListenerRemove:()=>{s.cancel()}});return i.event}ripgrepTextSearch(t,s,r){return t.maxFileSize=(0,c.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new h.TextSearchEngineAdapter(t).search(r,s,s)}doFileSearch(t,s,r){return this.doFileSearchWithEngine(u.Engine,t,s,r)}doFileSearchWithEngine(t,s,r,i,f=D.BATCH_SIZE){let l=0;const d=y=>{Array.isArray(y)?(l+=y.length,r(y.map(v=>this.rawMatchToSearchItem(v)))):y.relativePath?(l++,r(this.rawMatchToSearchItem(y))):r(y)};if(s.sortByScore){let y=this.trySortedSearchFromCache(s,d,i);if(!y){const v=s.maxResults?Object.assign({},s,{maxResults:null}):s,A=new t(v);y=this.doSortedSearch(A,s,r,d,i)}return new Promise((v,A)=>{y.then(([w,F])=>{const O=F.map(G=>this.rawMatchToSearchItem(G));this.sendProgress(O,r,f),v(w)},A)})}const b=new t(s);return this.doSearch(b,d,f,i).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:this.processType,fromCache:!1,resultCount:l,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,T.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,s,r,i,f){const l=new E.Emitter;let d=(0,C.createCancelablePromise)(y=>{let v=[];const A=w=>{Array.isArray(w)?v=w:(i(w),l.fire(w))};return this.doSearch(t,A,-1,y).then(w=>[w,v])}),b;if(s.cacheKey){b=this.getOrCreateCache(s.cacheKey);const y={promise:d,event:l.event,resolved:!1};b.resultsToSearchCache[s.filePattern||""]=y,d.then(()=>{y.resolved=!0},v=>{delete b.resultsToSearchCache[s.filePattern||""]}),d=this.preventCancellation(d)}return d.then(([y,v])=>{const A=b?b.scorerCache:Object.create(null),w=(typeof s.maxResults!="number"||s.maxResults>0)&&n.StopWatch.create(!1);return this.sortResults(s,v,A,f).then(F=>{const O=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:y.stats,sortingTime:O,fromCache:!1,type:this.processType,workspaceFolderCount:s.folderQueries.length,resultCount:F.length},messages:y.messages,limitHit:y.limitHit||typeof s.maxResults=="number"&&v.length>s.maxResults},F]})})}getOrCreateCache(t){const s=this.caches[t];return s||(this.caches[t]=new k)}trySortedSearchFromCache(t,s,r){const i=t.cacheKey&&this.caches[t.cacheKey];if(!i)return;const f=this.getResultsFromCache(i,t.filePattern||"",s,r);if(f)return f.then(([l,d,b])=>{const y=n.StopWatch.create(!1);return this.sortResults(t,d,i.scorerCache,r).then(v=>{const A=y.elapsed(),w={fromCache:!0,detailStats:b,type:this.processType,resultCount:d.length,sortingTime:A};return[{type:"success",limitHit:l.limitHit||typeof t.maxResults=="number"&&d.length>t.maxResults,stats:w},v]})})}sortResults(t,s,r,i){const f=(0,S.prepareQuery)(t.filePattern||""),l=(b,y)=>(0,S.compareItemsByFuzzyScore)(b,y,f,!0,_,r),d=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return I.topAsync(s,l,d,1e4,i)}sendProgress(t,s,r){if(r&&r>0)for(let i=0;i<t.length;i+=r)s(t.slice(i,i+r));else s(t)}getResultsFromCache(t,s,r,i){const f=n.StopWatch.create(!1),l=s.indexOf(T.sep)>=0;let d;for(const A in t.resultsToSearchCache)if(s.startsWith(A)){if(l&&A.indexOf(T.sep)<0&&A!=="")continue;const w=t.resultsToSearchCache[A];d={promise:this.preventCancellation(w.promise),event:w.event,resolved:w.resolved};break}if(!d)return null;const b=f.elapsed(),y=n.StopWatch.create(!1),v=d.event(r);return i&&i.onCancellationRequested(()=>{v.dispose()}),d.promise.then(([A,w])=>{if(i&&i.isCancellationRequested)throw(0,R.canceled)();const F=[],O=(0,S.prepareQuery)(s).normalizedLowercase;for(const G of w)!(0,m.isFilePatternMatch)(G,O)||F.push(G);return[A,F,{cacheWasResolved:d.resolved,cacheLookupTime:b,cacheFilterTime:y.elapsed(),cacheEntryCount:w.length}]})}doSearch(t,s,r,i){return new Promise((f,l)=>{let d=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(b=>{b&&(r?(d.push(b),r>0&&d.length>=r&&(s(d),d=[])):s(b))},b=>{s(b)},(b,y)=>{d.length&&s(d),b?l(b):f(y)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,r){return t.then(s,r)}catch(s){return this.then(void 0,s)}finally(s){return t.finally(s)}}}}e.SearchService=D,D.BATCH_SIZE=512;class k{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const _=new class{getItemLabel(p){return(0,T.basename)(p.relativePath)}getItemDescription(p){return(0,T.dirname)(p.relativePath)}getItemPath(p){return p.relativePath}};function o(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(a),extraFileResources:p.extraFileResources&&p.extraFileResources.map(t=>P.URI.revive(t))}}function a(p){return{...p,folder:P.URI.revive(p.folder)}}}),define(me[287],ge([0,1,6,10,2,28,12,27,14,74,65,31,286,284,93,134]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let D=class extends T.ExtHostSearch{constructor(_,o,a,p){super(_,a,p);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const t=new u.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new m.RipgrepSearchProvider(t)),o.remote.isRemote&&o.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const _=new u.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new m.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(L.Schemas.file,new c.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(_,o){const a=this._handlePool++;return this._internalFileSearchProvider=o,this._internalFileSearchHandle=a,this._proxy.$registerFileSearchProvider(a,this._transformScheme(_)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(_,o,a,p){const t=(0,T.reviveQuery)(a);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,o,t,p):super.$provideFileSearchResults(_,o,a,p)}doInternalFileSearch(_,o,a,p){const t=s=>{if((0,P.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this._proxy.$handleFileMatch(_,o,s.map(r=>I.URI.file(r.path)));return}s.message&&this._logService.debug("ExtHostSearch",s.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(a,t,p)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,o){return new h.NativeTextSearchManager(_,o,void 0,"textSearchProvider")}};D=Ve([$e(0,S.IExtHostRpcService),$e(1,E.IExtHostInitDataService),$e(2,n.IURITransformerService),$e(3,R.ILogService)],D),e.NativeExtHostSearch=D}),define(me[136],ge([0,1,301,125,80,23,16,3,6,8,11,32,106,107,302]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(d){this.socket=d,this._errorListener=b=>{if(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(d){const b=y=>d(C.VSBuffer.wrap(y));return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(d){const b=y=>{d({type:0,hadError:y,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(d){return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(d){if(!this.socket.destroyed)try{this.socket.write(d.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}}end(){this.socket.end()}drain(){return new Promise((d,b)=>{if(this.socket.bufferSize===0){d();return}const y=()=>{this.socket.off("close",y),this.socket.off("end",y),this.socket.off("error",y),this.socket.off("timeout",y),this.socket.off("drain",y),d()};this.socket.on("close",y),this.socket.on("end",y),this.socket.on("error",y),this.socket.on("timeout",y),this.socket.on("drain",y)})}}e.NodeSocket=h;var D;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var k;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(k||(k={}));class _ extends S.Disposable{constructor(d,b,y,v){super();this._onDidZlibFlush=this._register(new E.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new E.Emitter),this._onClose=this._register(new E.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=d,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=b,this._recordInflateBytes=v,b?(this._zlibInflate=u.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",A=>{console.error(A),(0,R.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibInflate.on("data",A=>{this._pendingInflateData.push(A)}),y&&(this._zlibInflate.write(y.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=u.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{console.error(A),(0,R.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibDeflate.on("data",A=>{this._pendingDeflateData.push(A)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new m.ChunkStream,this._register(this.socket.onData(A=>this._acceptChunk(A))),this._register(this.socket.onClose(A=>this._onClose.fire(A)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){this._totalOutgoingDataBytes+=d.byteLength,this._zlibDeflate?(this._zlibDeflate.write(d.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let b=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.length-4),this._isEnded||this._write(C.VSBuffer.wrap(b),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(d,!1)}_write(d,b){let y=2;d.byteLength<126?y+=0:d.byteLength<2**16?y+=2:y+=8;const v=C.VSBuffer.alloc(y);if(b?v.writeUInt8(194,0):v.writeUInt8(130,0),d.byteLength<126)v.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){v.writeUInt8(126,1);let A=1;v.writeUInt8(d.byteLength>>>8&255,++A),v.writeUInt8(d.byteLength>>>0&255,++A)}else{v.writeUInt8(127,1);let A=1;v.writeUInt8(0,++A),v.writeUInt8(0,++A),v.writeUInt8(0,++A),v.writeUInt8(0,++A),v.writeUInt8(d.byteLength>>>24&255,++A),v.writeUInt8(d.byteLength>>>16&255,++A),v.writeUInt8(d.byteLength>>>8&255,++A),v.writeUInt8(d.byteLength>>>0&255,++A)}this._totalOutgoingWireBytes+=v.byteLength+d.byteLength,this.socket.write(C.VSBuffer.concat([v,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._totalIncomingWireBytes+=d.byteLength,this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const b=this._incomingData.peek(this._state.readLen),v=(b.readUInt8(0)&128)>>>7,A=b.readUInt8(1),w=(A&128)>>>7,F=A&127;this._state.state=2,this._state.readLen=2+(w?4:0)+(F===126?2:0)+(F===127?8:0),this._state.fin=v,this._state.mask=0}else if(this._state.state===2){const b=this._incomingData.read(this._state.readLen),y=b.readUInt8(1),v=(y&128)>>>7;let A=y&127,w=1;A===126?A=b.readUInt8(++w)*2**8+b.readUInt8(++w):A===127&&(A=b.readUInt8(++w)*0+b.readUInt8(++w)*0+b.readUInt8(++w)*0+b.readUInt8(++w)*0+b.readUInt8(++w)*2**24+b.readUInt8(++w)*2**16+b.readUInt8(++w)*2**8+b.readUInt8(++w));let F=0;v&&(F=b.readUInt8(++w)*2**24+b.readUInt8(++w)*2**16+b.readUInt8(++w)*2**8+b.readUInt8(++w)),this._state.state=3,this._state.readLen=A,this._state.mask=F}else if(this._state.state===3){const b=this._incomingData.read(this._state.readLen);o(b,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(b.buffer)),this._zlibInflate.write(b.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const y=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=y.length,this._onData.fire(C.VSBuffer.wrap(y))})):(this._totalIncomingDataBytes+=b.byteLength,this._onData.fire(b))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await E.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=_;function o(l,d){if(d===0)return;let b=l.byteLength>>>2;for(let O=0;O<b;O++){const G=l.readUInt32BE(O*4);l.writeUInt32BE(G^d,O*4)}let y=b*4,v=l.byteLength-y;const A=d>>>24&255,w=d>>>16&255,F=d>>>8&255;v>=1&&l.writeUInt8(l.readUInt8(y)^A,y),v>=2&&l.writeUInt8(l.readUInt8(y+1)^w,y+1),v>=3&&l.writeUInt8(l.readUInt8(y+2)^F,y+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function p(){const l=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let d;return e.XDG_RUNTIME_DIR?d=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):d=(0,T.join)((0,I.tmpdir)(),`vscode-ipc-${l}.sock`),s(d),d}e.createRandomIPCHandle=p;function t(l,d,b){const y=(0,g.createHash)("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${y}-${b}-${d}-sock`;let v;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?v=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${y.substr(0,8)}-${b}-${d}.sock`):v=(0,T.join)(l,`${b}-${d}.sock`),s(v),v}e.createStaticIPCHandle=t;function s(l){const d=a[n.platform];typeof d=="number"&&l.length>=d&&console.warn(`WARNING: IPC handle "${l}" is longer than ${d} chars, try a shorter --user-data-dir`)}class r extends c.IPCServer{constructor(d){super(r.toClientConnectionEvent(d));this.server=d}static toClientConnectionEvent(d){const b=E.Event.fromNodeEventEmitter(d,"connection");return E.Event.map(b,y=>({protocol:new m.Protocol(new h(y)),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(y,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function i(l){return new Promise((d,b)=>{const y=(0,L.createServer)();y.on("error",b),y.listen(l,()=>{y.removeListener("error",b),d(new r(y))})})}e.serve=i;function f(l,d){return new Promise((b,y)=>{const v=(0,L.createConnection)(l,()=>{v.removeListener("error",y),b(m.Client.fromSocket(new h(v),d))});v.once("error",y)})}e.connect=f}),define(me[288],ge([0,1,136,280,50,44,2,200,12]),function(Y,e,g,L,I,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class T{constructor(c,m,u){this._commands=c,this.logService=m,this._ipcHandlePath=u,this._server=L.createServer((h,D)=>this.onRequest(h,D)),this.setup().catch(h=>(m.error(h),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch(c){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,m){const u=[];c.setEncoding("utf8"),c.on("data",h=>u.push(h)),c.on("end",()=>{const h=JSON.parse(u.join(""));switch(h.type){case"open":this.open(h,m);break;case"openExternal":this.openExternal(h,m);break;case"status":this.getStatus(h,m);break;case"extensionManagement":this.manageExtensions(h,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${h.type}`,D=>{D&&this.logService.error(D)}),m.end();break}})}open(c,m){let{fileURIs:u,folderURIs:h,forceNewWindow:D,diffMode:k,addMode:_,forceReuseWindow:o,gotoLineMode:a,waitMarkerFilePath:p}=c;const t=[];if(Array.isArray(h))for(const s of h)try{t.push({folderUri:R.URI.parse(s)})}catch(r){}if(Array.isArray(u))for(const s of u)try{(0,E.hasWorkspaceFileExtension)(s)?t.push({workspaceUri:R.URI.parse(s)}):t.push({fileUri:R.URI.parse(s)})}catch(r){}if(t.length){const s=p?R.URI.file(p):void 0,i={forceNewWindow:D,diffMode:k,addMode:_,gotoLineMode:a,forceReuseWindow:o,preferNewWindow:!o&&!s&&!_,waitMarkerFileURI:s};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}m.writeHead(200),m.end()}async openExternal(c,m){for(const u of c.uris){const h=R.URI.parse(u),D=h.scheme==="file"?h:u;await this._commands.executeCommand("_remoteCLI.openExternal",D)}m.writeHead(200),m.end()}async manageExtensions(c,m){try{const u=k=>k?.map(_=>/\.vsix$/i.test(_)?R.URI.parse(_):_),h={list:c.list,install:u(c.install),uninstall:u(c.uninstall),force:c.force},D=await this._commands.executeCommand("_remoteCLI.manageExtensions",h);m.writeHead(200),m.write(D)}catch(u){m.writeHead(500),m.write(String(u),h=>{h&&this.logService.error(h)})}m.end()}async getStatus(c,m){try{const u=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(u),m.end()}catch(u){m.writeHead(500),m.write(String(u),h=>{h&&this.logService.error(h)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=T;let n=class extends T{constructor(c,m){super(c,m,(0,g.createRandomIPCHandle)())}};n=Ve([$e(0,C.IExtHostCommands),$e(1,S.ILogService)],n),e.CLIServer=n}),define(me[289],ge([0,1,73,276,271,5,279,40,261,2,10,7,288,105]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class u extends I.RequireInterceptor{_installInterceptor(){const k=this,_=Y.__$__nodeRequire("module"),o=_._load;_._load=function(p,t,s){for(let r of k._alternatives){let i=r(p);if(i){p=i;break}}return k._factories.has(p)?k._factories.get(p).load(p,T.URI.file((0,m.realpathSync)(t.filename)),r=>o.apply(this,[r,t,s])):o.apply(this,arguments)}}}class h extends E.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const k=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(u,k,this._registry).install(),g.mark("code/extHost/didInitAPI");const o=await this._extHostConfiguration.getConfigProvider();await(0,R.connectProxyResolver)(this._extHostWorkspace,o,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const a=process.send,p=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?a.apply(process,t):(p.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(k){return k.main}_loadCommonJSModule(k,_,o){if(_.scheme!==n.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let a=null;o.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{k&&g.mark(`code/extHost/willLoadExtensionCode/${k.value}`),a=Y.__$__nodeRequire(_.fsPath)}catch(p){return Promise.reject(p)}finally{k&&g.mark(`code/extHost/didLoadExtensionCode/${k.value}`),o.codeLoadingStop()}return Promise.resolve(a)}async $setRemoteEnvironment(k){if(!!this._initData.remote.isRemote)for(const _ in k){const o=k[_];o===null?delete process.env[_]:process.env[_]=o}}}e.ExtHostExtensionService=h}),define(me[290],ge([0,1,82,262,264,273,272,287,289,229,265,55,40,68,74,72,33,53,12,69,263]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D,k,_,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(c.IExtHostExtensionService,S.ExtHostExtensionService),(0,g.registerSingleton)(_.ILogService,T.ExtHostLogService),(0,g.registerSingleton)(o.IExtensionStoragePaths,a.ExtensionStoragePaths),(0,g.registerSingleton)(P.IExtHostDebugService,R.ExtHostDebugService),(0,g.registerSingleton)(m.IExtHostOutputService,L.ExtHostOutputService2),(0,g.registerSingleton)(u.IExtHostSearch,E.NativeExtHostSearch),(0,g.registerSingleton)(h.IExtHostTask,C.ExtHostTask),(0,g.registerSingleton)(D.IExtHostTerminalService,I.ExtHostTerminalService),(0,g.registerSingleton)(k.IExtHostTunnelService,n.ExtHostTunnelService)}),define(me[291],ge([0,1,125,303,73,16,107,136,192,227,274,23,103,28,105,18,114,277,290]),function(Y,e,g,L,I,C,R,E,S,T,n,P,c,m,u,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let f=0;f<process.execArgv.length;f++)process.execArgv[f]==="--inspect-port=0"&&(process.execArgv.splice(f,1),f--)}();const k=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const i=Y.__$__nodeRequire("module"),f=i._load;i._load=function(l){if(l==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return f.apply(this,arguments)}})();const _=process.exit.bind(process);function o(i){process.exit=function(f){if(i)_(f);else{const l=new Error("An extension called process.exit() and this was prevented.");console.warn(l.stack)}},process.crash=function(){const f=new Error("An extension called process.crash() and this was prevented.");console.warn(f.stack)}}let a=function(i){_()};function p(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,f)=>{let l=null,d=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const b=108e5,y=3e5,v=new h.ProcessTimeRunOnceScheduler(()=>a("renderer disconnected for too long (1)"),b),A=new h.ProcessTimeRunOnceScheduler(()=>a("renderer disconnected for too long (2)"),y);process.on("message",(F,O)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){const G=P.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let K;if(F.skipWebSocketFrames)K=new E.NodeSocket(O);else{const U=P.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));K=new E.WebSocketNodeSocket(new E.NodeSocket(O),F.permessageDeflate,U,!1)}l?(v.cancel(),A.cancel(),l.beginAcceptReconnection(K,G),l.endAcceptReconnection()):(clearTimeout(d),l=new R.PersistentProtocol(K,G),l.onDidDispose(()=>a("renderer disconnected")),i(l),l.onSocketClose(()=>{v.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(A.isScheduled())return;v.isScheduled()&&A.schedule()}});const w={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(w)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((f,l)=>{const d=g.createConnection(i,()=>{d.removeListener("error",l),f(new R.PersistentProtocol(new E.NodeSocket(d)))});d.once("error",l),d.on("close",()=>{a("renderer closed the socket")})})}}async function t(){const i=await p();return new class{constructor(){this._onMessage=new R.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(f=>{(0,T.isMessageOfType)(f,2)?(this._terminating=!0,a("received terminate message from renderer")):this._onMessage.fire(f)})}send(f){this._terminating||i.send(f)}drain(){return i.drain()}}}function s(i){return new Promise(f=>{const l=i.onMessage(d=>{l.dispose();const b=JSON.parse(d.toString()),y=b.commit,v=S.default.commit;y&&v&&y!==v&&_(55);const A=[];process.on("unhandledRejection",(O,G)=>{A.push(G),setTimeout(()=>{const K=A.indexOf(G);K>=0&&G.catch(U=>{A.splice(K,1),(0,C.isPromiseCanceledError)(U)||(console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),(0,C.onUnexpectedError)(O))})},1e3)}),process.on("rejectionHandled",O=>{const G=A.indexOf(O);G>=0&&A.splice(G,1)}),process.on("uncaughtException",function(O){(0,C.onUnexpectedError)(O)});let w=0;setInterval(function(){try{process.kill(b.parentPid,0),w=0}catch(O){O&&O.code==="EPERM"?(w++,w>=3&&a(`parent process ${b.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):a(`parent process ${b.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let F;try{F=Y.__$__nodeRequire("native-watchdog"),F.start(b.parentPid)}catch(O){(0,C.onUnexpectedError)(O)}i.send((0,T.createMessageOfType)(0)),f({protocol:i,initData:b})});i.send((0,T.createMessageOfType)(1))})}async function r(){I.mark("code/extHost/willConnectToRenderer");const i=await t();I.mark("code/extHost/didConnectToRenderer");const f=await s(i);I.mark("code/extHost/didWaitForInitData");const{initData:l}=f;o(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=k.useHostProxy!==void 0?k.useHostProxy!=="false":void 0,l.environment.skipWorkspaceStorageLock=(0,D.boolean)(k.skipWorkspaceStorageLock,!1);const d=new class{exit(A){_(A)}exists(A){return m.Promises.exists(A)}realpath(A){return(0,u.realpath)(A)}};let b=null;if(l.remote.authority&&k.uriTransformerPath)try{const A=Y.__$__nodeRequire(k.uriTransformerPath)(l.remote.authority);b=new c.URITransformer(A)}catch(v){console.error(v)}const y=new n.ExtensionHostMain(f.protocol,l,d,b);a=v=>y.terminate(v)}e.startExtensionHostProcess=r}),define(me[304],ge([0,1,291]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ec40cbe164c59f3d13b6eff5fc7b0231ec0ab7aa/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
