/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/skipList","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/base/common/iterator","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(ie){for(var e=[],h=0,M=ie.length;h<M;h++)e[h]=be[ie[h]];return e};define(be[40],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function h(M,b){if(!M)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=h}),define(be[51],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const h=Object.prototype.hasOwnProperty;function M(t){const E=[];for(let n in t)h.call(t,n)&&E.push(t[n]);return E}e.values=M;function b(t,E){for(let n in t)if(h.call(t,n)&&E({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=b;function T(t,E){const n=Object.create(null);for(const f of t){const l=E(f);let s=n[l];s||(s=n[l]=[]),s.push(f)}return n}e.groupBy=T;function F(t){const E=Object.create(null);return t&&t.forEach((n,f)=>{E[f]=n}),E}e.fromMap=F;function C(t,E){const n=[],f=[];for(let l of t)E.has(l)||n.push(l);for(let l of E)t.has(l)||f.push(l);return{removed:n,added:f}}e.diffSets=C;function _(t,E){const n=[],f=[];for(let[l,s]of t)E.has(l)||n.push(s);for(let[l,s]of E)t.has(l)||f.push(s);return{removed:n,added:f}}e.diffMaps=_;class P{constructor(){this.map=new Map}add(E,n){let f=this.map.get(E);f||(f=new Set,this.map.set(E,f)),f.add(n)}delete(E,n){const f=this.map.get(E);!f||(f.delete(n),f.size===0&&this.map.delete(E))}forEach(E,n){const f=this.map.get(E);!f||f.forEach(n)}}e.SetMap=P}),define(be[52],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function h(F){return(C,_,P)=>{let t=null,E=null;if(typeof P.value=="function"?(t="value",E=P.value):typeof P.get=="function"&&(t="get",E=P.get),!E)throw new Error("not supported");P[t]=F(E,_)}}e.createDecorator=h;function M(F,C,_){let P=null,t=null;if(typeof _.value=="function"?(P="value",t=_.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(P="get",t=_.get),!t)throw new Error("not supported");const E=`$memoize$${C}`;_[P]=function(...n){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[E]}}e.memoize=M;function b(F,C,_){return h((P,t)=>{const E=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...f){this[n]||(this[n]=_?_():void 0),clearTimeout(this[E]),C&&(this[n]=C(this[n],...f),f=[this[n]]),this[E]=setTimeout(()=>{P.apply(this,f),this[n]=_?_():void 0},F)}})}e.debounce=b;function T(F,C,_){return h((P,t)=>{const E=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,f=`$throttle$lastRun$${t}`,l=`$throttle$pending$${t}`;return function(...s){if(this[n]||(this[n]=_?_():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),C&&(this[n]=C(this[n],...s)),this[l])return;const v=this[f]+F;v<=Date.now()?(this[f]=Date.now(),P.apply(this,[this[n]]),this[n]=_?_():void 0):(this[l]=!0,this[E]=setTimeout(()=>{this[l]=!1,this[f]=Date.now(),P.apply(this,[this[n]]),this[n]=_?_():void 0},v-Date.now()))}})}e.throttle=T}),define(be[13],Ee([0,1,16]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(q,le=0){return q[q.length-(1+le)]}e.tail=M;function b(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=b;function T(q,le,se=(ve,Fe)=>ve===Fe){if(q===le)return!0;if(!q||!le||q.length!==le.length)return!1;for(let ve=0,Fe=q.length;ve<Fe;ve++)if(!se(q[ve],le[ve]))return!1;return!0}e.equals=T;function F(q,le,se){let ve=0,Fe=q.length-1;for(;ve<=Fe;){const Me=(ve+Fe)/2|0,Ne=se(q[Me],le);if(Ne<0)ve=Me+1;else if(Ne>0)Fe=Me-1;else return Me}return-(ve+1)}e.binarySearch=F;function C(q,le){let se=0,ve=q.length;if(ve===0)return 0;for(;se<ve;){const Fe=Math.floor((se+ve)/2);le(q[Fe])?ve=Fe:se=Fe+1}return se}e.findFirstInSorted=C;function _(q,le,se){if(q=q|0,q>=le.length)throw new TypeError("invalid index");let ve=le[Math.floor(le.length*Math.random())],Fe=[],Me=[],Ne=[];for(let Qe of le){const ze=se(Qe,ve);ze<0?Fe.push(Qe):ze>0?Me.push(Qe):Ne.push(Qe)}return q<Fe.length?_(q,Fe,se):q<Fe.length+Ne.length?Ne[0]:_(q-(Fe.length+Ne.length),Me,se)}e.quickSelect=_;function P(q,le){const se=[];let ve;for(const Fe of q.slice(0).sort(le))!ve||le(ve[0],Fe)!==0?(ve=[Fe],se.push(ve)):ve.push(Fe);return se}e.groupBy=P;function t(q,le,se){const ve=[];function Fe(Qe,ze,qe){if(ze===0&&qe.length===0)return;const x=ve[ve.length-1];x&&x.start+x.deleteCount===Qe?(x.deleteCount+=ze,x.toInsert.push(...qe)):ve.push({start:Qe,deleteCount:ze,toInsert:qe})}let Me=0,Ne=0;for(;;){if(Me===q.length){Fe(Me,0,le.slice(Ne));break}if(Ne===le.length){Fe(Me,q.length-Me,[]);break}const Qe=q[Me],ze=le[Ne],qe=se(Qe,ze);qe===0?(Me+=1,Ne+=1):qe<0?(Fe(Me,1,[]),Me+=1):qe>0&&(Fe(Me,0,[ze]),Ne+=1)}return ve}e.sortedDiff=t;function E(q,le,se){const ve=t(q,le,se),Fe=[],Me=[];for(const Ne of ve)Fe.push(...q.slice(Ne.start,Ne.start+Ne.deleteCount)),Me.push(...Ne.toInsert);return{removed:Fe,added:Me}}e.delta=E;function n(q,le,se){if(se===0)return[];const ve=q.slice(0,se).sort(le);return l(q,le,ve,se,q.length),ve}e.top=n;function f(q,le,se,ve,Fe){return se===0?Promise.resolve([]):new Promise((Me,Ne)=>{(async()=>{const Qe=q.length,ze=q.slice(0,se).sort(le);for(let qe=se,x=Math.min(se+ve,Qe);qe<Qe;qe=x,x=Math.min(x+ve,Qe)){if(qe>se&&await new Promise(Y=>setTimeout(Y)),Fe&&Fe.isCancellationRequested)throw(0,h.canceled)();l(q,le,ze,qe,x)}return ze})().then(Me,Ne)})}e.topAsync=f;function l(q,le,se,ve,Fe){for(const Me=se.length;ve<Fe;ve++){const Ne=q[ve];if(le(Ne,se[Me-1])<0){se.pop();const Qe=C(se,ze=>le(Ne,ze)<0);se.splice(Qe,0,Ne)}}}function s(q){return q.filter(le=>!!le)}e.coalesce=s;function v(q){let le=0;for(let se=0;se<q.length;se++)q[se]&&(q[le]=q[se],le+=1);q.length=le}e.coalesceInPlace=v;function I(q,le,se){q.splice(se,0,q.splice(le,1)[0])}e.move=I;function y(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=y;function a(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=a;function m(q,le){if(!le)return q.filter((ve,Fe)=>q.indexOf(ve)===Fe);const se=Object.create(null);return q.filter(ve=>{const Fe=le(ve);return se[Fe]?!1:(se[Fe]=!0,!0)})}e.distinct=m;function k(q){const le=new Set;return q.filter(se=>le.has(se)?!1:(le.add(se),!0))}e.distinctES6=k;function i(q){const le=Object.create(null);return se=>{const ve=q(se);return le[ve]?!1:(le[ve]=!0,!0)}}e.uniqueFilter=i;function u(q,le){for(let se=q.length-1;se>=0;se--){const ve=q[se];if(le(ve))return se}return-1}e.lastIndex=u;function r(q,le){return q.length>0?q[0]:le}e.firstOrDefault=r;function o(q,le,se=(ve,Fe)=>ve===Fe){let ve=0;for(let Fe=0,Me=Math.min(q.length,le.length);Fe<Me&&se(q[Fe],le[Fe]);Fe++)ve++;return ve}e.commonPrefixLength=o;function w(q){return[].concat(...q)}e.flatten=w;function d(q,le){let se=typeof le=="number"?q:0;typeof le=="number"?se=q:(se=0,le=q);const ve=[];if(se<=le)for(let Fe=se;Fe<le;Fe++)ve.push(Fe);else for(let Fe=se;Fe>le;Fe--)ve.push(Fe);return ve}e.range=d;function g(q,le,se){return q.reduce((ve,Fe)=>(ve[le(Fe)]=se?se(Fe):Fe,ve),Object.create(null))}e.index=g;function S(q,le){return q.push(le),()=>R(q,le)}e.insert=S;function R(q,le){const se=q.indexOf(le);if(se>-1)return q.splice(se,1),le}e.remove=R;function p(q,le,se){const ve=q.slice(0,le),Fe=q.slice(le);return ve.concat(se,Fe)}e.arrayInsert=p;function D(q,le){let se;if(typeof le=="number"){let ve=le;se=()=>{const Fe=Math.sin(ve++)*179426549;return Fe-Math.floor(Fe)}}else se=Math.random;for(let ve=q.length-1;ve>0;ve-=1){const Fe=Math.floor(se()*(ve+1)),Me=q[ve];q[ve]=q[Fe],q[Fe]=Me}}e.shuffle=D;function c(q,le){const se=q.indexOf(le);se>-1&&(q.splice(se,1),q.unshift(le))}e.pushToStart=c;function A(q,le){const se=q.indexOf(le);se>-1&&(q.splice(se,1),q.push(le))}e.pushToEnd=A;function O(q,le){return Array.isArray(q)?q.map(le):le(q)}e.mapArrayOrNot=O;function z(q){return Array.isArray(q)?q:[q]}e.asArray=z;function K(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=K;function $(q,le){for(const se of q){const ve=le(se);if(ve!==void 0)return ve}}e.mapFind=$;function Q(q,le,se){const ve=U(q,le),Fe=q.length,Me=se.length;q.length=Fe+Me;for(let Ne=Fe-1;Ne>=ve;Ne--)q[Ne+Me]=q[Ne];for(let Ne=0;Ne<Me;Ne++)q[Ne+ve]=se[Ne]}e.insertInto=Q;function W(q,le,se,ve){const Fe=U(q,le),Me=q.splice(Fe,se);return Q(q,Fe,ve),Me}e.splice=W;function U(q,le){return le<0?Math.max(le+q.length,0):Math.min(le,q.length)}function H(q,le){let se=Number.MAX_SAFE_INTEGER,ve=0;return q.forEach((Fe,Me)=>{const Ne=le(Fe);Ne<se&&(se=Ne,ve=Me)}),ve}e.minIndex=H;function G(q,le){let se=Number.MIN_SAFE_INTEGER,ve=0;return q.forEach((Fe,Me)=>{const Ne=le(Fe);Ne>se&&(se=Ne,ve=Me)}),ve}e.maxIndex=G;class ue{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let se=this.firstIdx;for(;se<this.items.length&&le(this.items[se]);)se++;const ve=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,ve}takeFromEndWhile(le){let se=this.lastIdx;for(;se>=0&&le(this.items[se]);)se--;const ve=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,ve}}e.ArrayQueue=ue}),define(be[53],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class h{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=h,e.defaultGenerator=new h("id#")}),define(be[102],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var h;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(h=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(i){i.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function F(i,u=!1){let r=0,o=i.length,w="",d=0,g=16,S=0;function R(K){let $=0,Q=0;for(;$<K;){const W=i.charCodeAt(r);if(W>=48&&W<=57)Q=Q*16+W-48;else if(W>=65&&W<=70)Q=Q*16+W-65+10;else if(W>=97&&W<=102)Q=Q*16+W-97+10;else break;r++,$++}return $<K&&(Q=-1),Q}function p(K){r=K,w="",d=0,g=16,S=0}function D(){const K=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&P(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&P(i.charCodeAt(r)))for(r++;r<i.length&&P(i.charCodeAt(r));)r++;else return S=3,i.substring(K,r);let $=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&P(i.charCodeAt(r))){for(r++;r<i.length&&P(i.charCodeAt(r));)r++;$=r}else S=3;return i.substring(K,$)}function c(){let K="",$=r;for(;;){if(r>=o){K+=i.substring($,r),S=2;break}const Q=i.charCodeAt(r);if(Q===34){K+=i.substring($,r),r++;break}if(Q===92){if(K+=i.substring($,r),r++,r>=o){S=2;break}switch(i.charCodeAt(r++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const U=R(4);U>=0?K+=String.fromCharCode(U):S=4;break;default:S=5}$=r;continue}if(Q>=0&&Q<=31)if(_(Q)){K+=i.substring($,r),S=2;break}else S=6;r++}return K}function A(){if(w="",S=0,d=r,r>=o)return d=o,g=17;let K=i.charCodeAt(r);if(C(K)){do r++,w+=String.fromCharCode(K),K=i.charCodeAt(r);while(C(K));return g=15}if(_(K))return r++,w+=String.fromCharCode(K),K===13&&i.charCodeAt(r)===10&&(r++,w+=`
`),g=14;switch(K){case 123:return r++,g=1;case 125:return r++,g=2;case 91:return r++,g=3;case 93:return r++,g=4;case 58:return r++,g=6;case 44:return r++,g=5;case 34:return r++,w=c(),g=10;case 47:const $=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<o&&!_(i.charCodeAt(r));)r++;return w=i.substring($,r),g=12}if(i.charCodeAt(r+1)===42){r+=2;const Q=o-1;let W=!1;for(;r<Q;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,W=!0;break}r++}return W||(r++,S=1),w=i.substring($,r),g=13}return w+=String.fromCharCode(K),r++,g=16;case 45:if(w+=String.fromCharCode(K),r++,r===o||!P(i.charCodeAt(r)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=D(),g=11;default:for(;r<o&&O(K);)r++,K=i.charCodeAt(r);if(d!==r){switch(w=i.substring(d,r),w){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return w+=String.fromCharCode(K),r++,g=16}}function O(K){if(C(K)||_(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let K;do K=A();while(K>=12&&K<=15);return K}return{setPosition:p,getPosition:()=>r,scan:u?z:A,getToken:()=>g,getTokenValue:()=>w,getTokenOffset:()=>d,getTokenLength:()=>r-d,getTokenError:()=>S}}e.createScanner=F;function C(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function _(i){return i===10||i===13||i===8232||i===8233}function P(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function E(i,u){const r=[],o=new Object;let w;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function S(R,p,D,c){d.value=R,d.offset=p,d.length=D,d.type=c,d.colonOffset=void 0,w=d}try{a(i,{onObjectBegin:(R,p)=>{if(u<=R)throw o;w=void 0,g=u>R,r.push("")},onObjectProperty:(R,p,D)=>{if(u<p||(S(R,p,D,"property"),r[r.length-1]=R,u<=p+D))throw o},onObjectEnd:(R,p)=>{if(u<=R)throw o;w=void 0,r.pop()},onArrayBegin:(R,p)=>{if(u<=R)throw o;w=void 0,r.push(0)},onArrayEnd:(R,p)=>{if(u<=R)throw o;w=void 0,r.pop()},onLiteralValue:(R,p,D)=>{if(u<p||(S(R,p,D,k(R)),u<=p+D))throw o},onSeparator:(R,p,D)=>{if(u<=p)throw o;if(R===":"&&w&&w.type==="property")w.colonOffset=p,g=!1,w=void 0;else if(R===","){const c=r[r.length-1];typeof c=="number"?r[r.length-1]=c+1:(g=!0,r[r.length-1]=""),w=void 0}}})}catch(R){if(R!==o)throw R}return{path:r,previousNode:w,isAtPropertyKey:g,matches:R=>{let p=0;for(let D=0;p<R.length&&D<r.length;D++)if(R[p]===r[D]||R[p]==="*")p++;else if(R[p]!=="**")return!1;return p===R.length}}}e.getLocation=E;function n(i,u=[],r=T.DEFAULT){let o=null,w=[];const d=[];function g(R){Array.isArray(w)?w.push(R):o!==null&&(w[o]=R)}return a(i,{onObjectBegin:()=>{const R={};g(R),d.push(w),w=R,o=null},onObjectProperty:R=>{o=R},onObjectEnd:()=>{w=d.pop()},onArrayBegin:()=>{const R=[];g(R),d.push(w),w=R,o=null},onArrayEnd:()=>{w=d.pop()},onLiteralValue:g,onError:(R,p,D)=>{u.push({error:R,offset:p,length:D})}},r),w[0]}e.parse=n;function f(i,u=[],r=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(R){o.type==="property"&&(o.length=R-o.offset,o=o.parent)}function d(R){return o.children.push(R),R}a(i,{onObjectBegin:R=>{o=d({type:"object",offset:R,length:-1,parent:o,children:[]})},onObjectProperty:(R,p,D)=>{o=d({type:"property",offset:p,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:R,offset:p,length:D,parent:o})},onObjectEnd:(R,p)=>{o.length=R+p-o.offset,o=o.parent,w(R+p)},onArrayBegin:(R,p)=>{o=d({type:"array",offset:R,length:-1,parent:o,children:[]})},onArrayEnd:(R,p)=>{o.length=R+p-o.offset,o=o.parent,w(R+p)},onLiteralValue:(R,p,D)=>{d({type:k(R),offset:p,length:D,parent:o,value:R}),w(p+D)},onSeparator:(R,p,D)=>{o.type==="property"&&(R===":"?o.colonOffset=p:R===","&&w(p))},onError:(R,p,D)=>{u.push({error:R,offset:p,length:D})}},r);const S=o.children[0];return S&&delete S.parent,S}e.parseTree=f;function l(i,u){if(!i)return;let r=i;for(let o of u)if(typeof o=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let w=!1;for(const d of r.children)if(Array.isArray(d.children)&&d.children[0].value===o){r=d.children[1],w=!0;break}if(!w)return}else{const w=o;if(r.type!=="array"||w<0||!Array.isArray(r.children)||w>=r.children.length)return;r=r.children[w]}return r}e.findNodeAtLocation=l;function s(i){if(!i.parent||!i.parent.children)return[];const u=s(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;u.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&u.push(r)}return u}e.getNodePath=s;function v(i){switch(i.type){case"array":return i.children.map(v);case"object":const u=Object.create(null);for(let r of i.children){const o=r.children[1];o&&(u[r.children[0].value]=v(o))}return u;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=v;function I(i,u,r=!1){return u>=i.offset&&u<i.offset+i.length||r&&u===i.offset+i.length}e.contains=I;function y(i,u,r=!1){if(I(i,u,r)){const o=i.children;if(Array.isArray(o))for(let w=0;w<o.length&&o[w].offset<=u;w++){const d=y(o[w],u,r);if(d)return d}return i}}e.findNodeAtOffset=y;function a(i,u,r=T.DEFAULT){const o=F(i,!1);function w(se){return se?()=>se(o.getTokenOffset(),o.getTokenLength()):()=>!0}function d(se){return se?ve=>se(ve,o.getTokenOffset(),o.getTokenLength()):()=>!0}const g=w(u.onObjectBegin),S=d(u.onObjectProperty),R=w(u.onObjectEnd),p=w(u.onArrayBegin),D=w(u.onArrayEnd),c=d(u.onLiteralValue),A=d(u.onSeparator),O=w(u.onComment),z=d(u.onError),K=r&&r.disallowComments,$=r&&r.allowTrailingComma;function Q(){for(;;){const se=o.scan();switch(o.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:K||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(se){case 12:case 13:K?W(10):O();break;case 16:W(1);break;case 15:case 14:break;default:return se}}}function W(se,ve=[],Fe=[]){if(z(se),ve.length+Fe.length>0){let Me=o.getToken();for(;Me!==17;){if(ve.indexOf(Me)!==-1){Q();break}else if(Fe.indexOf(Me)!==-1)break;Me=Q()}}}function U(se){const ve=o.getTokenValue();return se?c(ve):S(ve),Q(),!0}function H(){switch(o.getToken()){case 11:let se=0;try{se=JSON.parse(o.getTokenValue()),typeof se!="number"&&(W(2),se=0)}catch(ve){W(2)}c(se);break;case 7:c(null);break;case 8:c(!0);break;case 9:c(!1);break;default:return!1}return Q(),!0}function G(){return o.getToken()!==10?(W(3,[],[2,5]),!1):(U(!1),o.getToken()===6?(A(":"),Q(),le()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function ue(){g(),Q();let se=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(se||W(4,[],[]),A(","),Q(),o.getToken()===2&&$)break}else se&&W(6,[],[]);G()||W(4,[],[2,5]),se=!0}return R(),o.getToken()!==2?W(7,[2],[]):Q(),!0}function q(){p(),Q();let se=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(se||W(4,[],[]),A(","),Q(),o.getToken()===4&&$)break}else se&&W(6,[],[]);le()||W(4,[],[4,5]),se=!0}return D(),o.getToken()!==4?W(8,[4],[]):Q(),!0}function le(){switch(o.getToken()){case 3:return q();case 1:return ue();case 10:return U(!0);default:return H()}}return Q(),o.getToken()===17?r.allowEmptyContent?!0:(W(4,[],[]),!1):le()?(o.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=a;function m(i,u){let r=F(i),o=[],w,d=0,g;do switch(g=r.getPosition(),w=r.scan(),w){case 12:case 13:case 17:d!==g&&o.push(i.substring(d,g)),u!==void 0&&o.push(r.getTokenValue().replace(/[^\r\n]/g,u)),d=r.getPosition();break}while(w!==17);return o.join("")}e.stripComments=m;function k(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=k}),define(be[103],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class h{constructor(b){this.executor=b,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(b){this._error=b}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(b){return new h(()=>b(this.getValue()))}}e.Lazy=h}),function(ie,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ie=typeof globalThis!="undefined"?globalThis:ie||self,ie.marked=e())}(this,function(){"use strict";function ie(Pe,ye){for(var De=0;De<ye.length;De++){var Z=ye[De];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(Pe,Z.key,Z)}}function e(Pe,ye,De){return ye&&ie(Pe.prototype,ye),De&&ie(Pe,De),Pe}function h(Pe,ye){if(!!Pe){if(typeof Pe=="string")return M(Pe,ye);var De=Object.prototype.toString.call(Pe).slice(8,-1);if(De==="Object"&&Pe.constructor&&(De=Pe.constructor.name),De==="Map"||De==="Set")return Array.from(Pe);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return M(Pe,ye)}}function M(Pe,ye){(ye==null||ye>Pe.length)&&(ye=Pe.length);for(var De=0,Z=new Array(ye);De<ye;De++)Z[De]=Pe[De];return Z}function b(Pe,ye){var De=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(De)return(De=De.call(Pe)).next.bind(De);if(Array.isArray(Pe)||(De=h(Pe))||ye&&Pe&&typeof Pe.length=="number"){De&&(Pe=De);var Z=0;return function(){return Z>=Pe.length?{done:!0}:{done:!1,value:Pe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var T={exports:{}};function F(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function C(Pe){T.exports.defaults=Pe}T.exports={defaults:F(),getDefaults:F,changeDefaults:C};var _=/[&<>"']/,P=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(ye){return n[ye]};function l(Pe,ye){if(ye){if(_.test(Pe))return Pe.replace(P,f)}else if(t.test(Pe))return Pe.replace(E,f);return Pe}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Pe){return Pe.replace(s,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var I=/(^|[^\[])\^/g;function y(Pe,ye){Pe=Pe.source||Pe,ye=ye||"";var De={replace:function(ce,ge){return ge=ge.source||ge,ge=ge.replace(I,"$1"),Pe=Pe.replace(ce,ge),De},getRegex:function(){return new RegExp(Pe,ye)}};return De}var a=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function k(Pe,ye,De){if(Pe){var Z;try{Z=decodeURIComponent(v(De)).replace(a,"").toLowerCase()}catch(ce){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ye&&!m.test(De)&&(De=w(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch(ce){return null}return De}var i={},u=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(Pe,ye){i[" "+Pe]||(u.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=R(Pe,"/",!0)),Pe=i[" "+Pe];var De=Pe.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:Pe.replace(r,"$1")+ye:ye.charAt(0)==="/"?De?ye:Pe.replace(o,"$1")+ye:Pe+ye}var d={exec:function(){}};function g(Pe){for(var ye=1,De,Z;ye<arguments.length;ye++){De=arguments[ye];for(Z in De)Object.prototype.hasOwnProperty.call(De,Z)&&(Pe[Z]=De[Z])}return Pe}function S(Pe,ye){var De=Pe.replace(/\|/g,function(ge,me,Ie){for(var Be=!1,Le=me;--Le>=0&&Ie[Le]==="\\";)Be=!Be;return Be?"|":" |"}),Z=De.split(/ \|/),ce=0;if(Z[0].trim()||Z.shift(),Z[Z.length-1].trim()||Z.pop(),Z.length>ye)Z.splice(ye);else for(;Z.length<ye;)Z.push("");for(;ce<Z.length;ce++)Z[ce]=Z[ce].trim().replace(/\\\|/g,"|");return Z}function R(Pe,ye,De){var Z=Pe.length;if(Z===0)return"";for(var ce=0;ce<Z;){var ge=Pe.charAt(Z-ce-1);if(ge===ye&&!De)ce++;else if(ge!==ye&&De)ce++;else break}return Pe.substr(0,Z-ce)}function p(Pe,ye){if(Pe.indexOf(ye[1])===-1)return-1;for(var De=Pe.length,Z=0,ce=0;ce<De;ce++)if(Pe[ce]==="\\")ce++;else if(Pe[ce]===ye[0])Z++;else if(Pe[ce]===ye[1]&&(Z--,Z<0))return ce;return-1}function D(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function c(Pe,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=Pe),ye>>=1,Pe+=Pe;return De+Pe}var A={escape:l,unescape:v,edit:y,cleanUrl:k,resolveUrl:w,noopTest:d,merge:g,splitCells:S,rtrim:R,findClosingBracket:p,checkSanitizeDeprecation:D,repeatString:c},O=T.exports.defaults,z=A.rtrim,K=A.splitCells,$=A.escape,Q=A.findClosingBracket;function W(Pe,ye,De,Z){var ce=ye.href,ge=ye.title?$(ye.title):null,me=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){Z.state.inLink=!0;var Ie={type:"link",raw:De,href:ce,title:ge,text:me,tokens:Z.inlineTokens(me,[])};return Z.state.inLink=!1,Ie}else return{type:"image",raw:De,href:ce,title:ge,text:$(me)}}function U(Pe,ye){var De=Pe.match(/^(\s+)(?:```)/);if(De===null)return ye;var Z=De[1];return ye.split(`
`).map(function(ce){var ge=ce.match(/^\s+/);if(ge===null)return ce;var me=ge[0];return me.length>=Z.length?ce.slice(Z.length):ce}).join(`
`)}var H=function(){function Pe(De){this.options=De||O}var ye=Pe.prototype;return ye.space=function(Z){var ce=this.rules.block.newline.exec(Z);if(ce)return ce[0].length>1?{type:"space",raw:ce[0]}:{raw:`
`}},ye.code=function(Z){var ce=this.rules.block.code.exec(Z);if(ce){var ge=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:z(ge,`
`)}}},ye.fences=function(Z){var ce=this.rules.block.fences.exec(Z);if(ce){var ge=ce[0],me=U(ge,ce[3]||"");return{type:"code",raw:ge,lang:ce[2]?ce[2].trim():ce[2],text:me}}},ye.heading=function(Z){var ce=this.rules.block.heading.exec(Z);if(ce){var ge=ce[2].trim();if(/#$/.test(ge)){var me=z(ge,"#");(this.options.pedantic||!me||/ $/.test(me))&&(ge=me.trim())}var Ie={type:"heading",raw:ce[0],depth:ce[1].length,text:ge,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},ye.hr=function(Z){var ce=this.rules.block.hr.exec(Z);if(ce)return{type:"hr",raw:ce[0]}},ye.blockquote=function(Z){var ce=this.rules.block.blockquote.exec(Z);if(ce){var ge=ce[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ye.list=function(Z){var ce=this.rules.block.list.exec(Z);if(ce){var ge,me,Ie,Be,Le,je,Xe,ne,pe,re,B=ce[1].trim(),Ce=B.length>1,Se={type:"list",raw:"",ordered:Ce,start:Ce?+B.slice(0,-1):"",loose:!1,items:[]};B=Ce?"\\d{1,9}\\"+B.slice(-1):"\\"+B,this.options.pedantic&&(B=Ce?B:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+B+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");Z&&!(this.rules.block.hr.test(Z)||!(ce=Ge.exec(Z)));){pe=ce[2].split(`
`),this.options.pedantic?(Be=2,re=pe[0].trimLeft()):(Be=ce[2].search(/[^ ]/),Be=ce[1].length+(Be>4?1:Be),re=pe[0].slice(Be-ce[1].length)),je=!1,ge=ce[0],!pe[0]&&/^ *$/.test(pe[1])&&(ge=ce[1]+pe.slice(0,2).join(`
`)+`
`,Se.loose=!0,pe=[]);var We=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<pe.length;Le++){if(ne=pe[Le],this.options.pedantic&&(ne=ne.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),We.test(ne)){ge=ce[1]+pe.slice(0,Le).join(`
`)+`
`;break}if(!je){ne.trim()||(je=!0),ne.search(/[^ ]/)>=Be?re+=`
`+ne.slice(Be):re+=`
`+ne;continue}if(ne.search(/[^ ]/)>=Be||!ne.trim()){re+=`
`+ne.slice(Be);continue}else{ge=ce[1]+pe.slice(0,Le).join(`
`)+`
`;break}}Se.loose||(Xe?Se.loose=!0:/\n *\n *$/.test(ge)&&(Xe=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(re),me&&(Ie=me[0]!=="[ ] ",re=re.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:ge,task:!!me,checked:Ie,loose:!1,text:re}),Se.raw+=ge,Z=Z.slice(ge.length)}Se.items[Se.items.length-1].raw=ge.trimRight(),Se.items[Se.items.length-1].text=re.trimRight(),Se.raw=Se.raw.trimRight();var it=Se.items.length;for(Le=0;Le<it;Le++)this.lexer.state.top=!1,Se.items[Le].tokens=this.lexer.blockTokens(Se.items[Le].text,[]),Se.items[Le].tokens.some(function(mt){return mt.type==="space"})&&(Se.loose=!0,Se.items[Le].loose=!0);return Se}},ye.html=function(Z){var ce=this.rules.block.html.exec(Z);if(ce){var ge={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};return this.options.sanitize&&(ge.type="paragraph",ge.text=this.options.sanitizer?this.options.sanitizer(ce[0]):$(ce[0]),ge.tokens=[],this.lexer.inline(ge.text,ge.tokens)),ge}},ye.def=function(Z){var ce=this.rules.block.def.exec(Z);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var ge=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:ce[0],href:ce[2],title:ce[3]}}},ye.table=function(Z){var ce=this.rules.block.table.exec(Z);if(ce){var ge={type:"table",header:K(ce[1]).map(function(Xe){return{text:Xe}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]?ce[3].replace(/\n$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=ce[0];var me=ge.align.length,Ie,Be,Le,je;for(Ie=0;Ie<me;Ie++)/^ *-+: *$/.test(ge.align[Ie])?ge.align[Ie]="right":/^ *:-+: *$/.test(ge.align[Ie])?ge.align[Ie]="center":/^ *:-+ *$/.test(ge.align[Ie])?ge.align[Ie]="left":ge.align[Ie]=null;for(me=ge.rows.length,Ie=0;Ie<me;Ie++)ge.rows[Ie]=K(ge.rows[Ie],ge.header.length).map(function(Xe){return{text:Xe}});for(me=ge.header.length,Be=0;Be<me;Be++)ge.header[Be].tokens=[],this.lexer.inlineTokens(ge.header[Be].text,ge.header[Be].tokens);for(me=ge.rows.length,Be=0;Be<me;Be++)for(je=ge.rows[Be],Le=0;Le<je.length;Le++)je[Le].tokens=[],this.lexer.inlineTokens(je[Le].text,je[Le].tokens);return ge}}},ye.lheading=function(Z){var ce=this.rules.block.lheading.exec(Z);if(ce){var ge={type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.paragraph=function(Z){var ce=this.rules.block.paragraph.exec(Z);if(ce){var ge={type:"paragraph",raw:ce[0],text:ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.text=function(Z){var ce=this.rules.block.text.exec(Z);if(ce){var ge={type:"text",raw:ce[0],text:ce[0],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.escape=function(Z){var ce=this.rules.inline.escape.exec(Z);if(ce)return{type:"escape",raw:ce[0],text:$(ce[1])}},ye.tag=function(Z){var ce=this.rules.inline.tag.exec(Z);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):$(ce[0]):ce[0]}},ye.link=function(Z){var ce=this.rules.inline.link.exec(Z);if(ce){var ge=ce[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var me=z(ge.slice(0,-1),"\\");if((ge.length-me.length)%2==0)return}else{var Ie=Q(ce[2],"()");if(Ie>-1){var Be=ce[0].indexOf("!")===0?5:4,Le=Be+ce[1].length+Ie;ce[2]=ce[2].substring(0,Ie),ce[0]=ce[0].substring(0,Le).trim(),ce[3]=""}}var je=ce[2],Xe="";if(this.options.pedantic){var ne=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(je);ne&&(je=ne[1],Xe=ne[3])}else Xe=ce[3]?ce[3].slice(1,-1):"";return je=je.trim(),/^</.test(je)&&(this.options.pedantic&&!/>$/.test(ge)?je=je.slice(1):je=je.slice(1,-1)),W(ce,{href:je&&je.replace(this.rules.inline._escapes,"$1"),title:Xe&&Xe.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},ye.reflink=function(Z,ce){var ge;if((ge=this.rules.inline.reflink.exec(Z))||(ge=this.rules.inline.nolink.exec(Z))){var me=(ge[2]||ge[1]).replace(/\s+/g," ");if(me=ce[me.toLowerCase()],!me||!me.href){var Ie=ge[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return W(ge,me,ge[0],this.lexer)}},ye.emStrong=function(Z,ce,ge){ge===void 0&&(ge="");var me=this.rules.inline.emStrong.lDelim.exec(Z);if(!!me&&!(me[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=me[1]||me[2]||"";if(!Ie||Ie&&(ge===""||this.rules.inline.punctuation.exec(ge))){var Be=me[0].length-1,Le,je,Xe=Be,ne=0,pe=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ce=ce.slice(-1*Z.length+Be);(me=pe.exec(ce))!=null;)if(Le=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Le){if(je=Le.length,me[3]||me[4]){Xe+=je;continue}else if((me[5]||me[6])&&Be%3&&!((Be+je)%3)){ne+=je;continue}if(Xe-=je,!(Xe>0)){if(je=Math.min(je,je+Xe+ne),Math.min(Be,je)%2){var re=Z.slice(1,Be+me.index+je);return{type:"em",raw:Z.slice(0,Be+me.index+je+1),text:re,tokens:this.lexer.inlineTokens(re,[])}}var B=Z.slice(2,Be+me.index+je-1);return{type:"strong",raw:Z.slice(0,Be+me.index+je+1),text:B,tokens:this.lexer.inlineTokens(B,[])}}}}}},ye.codespan=function(Z){var ce=this.rules.inline.code.exec(Z);if(ce){var ge=ce[2].replace(/\n/g," "),me=/[^ ]/.test(ge),Ie=/^ /.test(ge)&&/ $/.test(ge);return me&&Ie&&(ge=ge.substring(1,ge.length-1)),ge=$(ge,!0),{type:"codespan",raw:ce[0],text:ge}}},ye.br=function(Z){var ce=this.rules.inline.br.exec(Z);if(ce)return{type:"br",raw:ce[0]}},ye.del=function(Z){var ce=this.rules.inline.del.exec(Z);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2],[])}},ye.autolink=function(Z,ce){var ge=this.rules.inline.autolink.exec(Z);if(ge){var me,Ie;return ge[2]==="@"?(me=$(this.options.mangle?ce(ge[1]):ge[1]),Ie="mailto:"+me):(me=$(ge[1]),Ie=me),{type:"link",raw:ge[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},ye.url=function(Z,ce){var ge;if(ge=this.rules.inline.url.exec(Z)){var me,Ie;if(ge[2]==="@")me=$(this.options.mangle?ce(ge[0]):ge[0]),Ie="mailto:"+me;else{var Be;do Be=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(Be!==ge[0]);me=$(ge[0]),ge[1]==="www."?Ie="http://"+me:Ie=me}return{type:"link",raw:ge[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},ye.inlineText=function(Z,ce){var ge=this.rules.inline.text.exec(Z);if(ge){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):$(ge[0]):ge[0]:me=$(this.options.smartypants?ce(ge[0]):ge[0]),{type:"text",raw:ge[0],text:me}}},Pe}(),G=A.noopTest,ue=A.edit,q=A.merge,le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:G,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=ue(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=ue(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=ue(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=ue(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=ue(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=ue(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=q({},le),le.gfm=q({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=ue(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=q({},le.normal,{html:ue(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:G,paragraph:ue(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:G,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:G,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=ue(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=ue(le._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=ue(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=ue(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=ue(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=ue(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=ue(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=ue(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=ue(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=ue(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=q({},se),se.pedantic=q({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ue(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:ue(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=q({},se.normal,{escape:ue(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),se.gfm.url=ue(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=q({},se.gfm,{br:ue(se.br).replace("{2,}","*").getRegex(),text:ue(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:le,inline:se},Fe=H,Me=T.exports.defaults,Ne=ve.block,Qe=ve.inline,ze=A.repeatString;function qe(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(Pe){var ye="",De,Z,ce=Pe.length;for(De=0;De<ce;De++)Z=Pe.charCodeAt(De),Math.random()>.5&&(Z="x"+Z.toString(16)),ye+="&#"+Z+";";return ye}var Y=function(){function Pe(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||Me,this.options.tokenizer=this.options.tokenizer||new Fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:Ne.normal,inline:Qe.normal};this.options.pedantic?(Z.block=Ne.pedantic,Z.inline=Qe.pedantic):this.options.gfm&&(Z.block=Ne.gfm,this.options.breaks?Z.inline=Qe.breaks:Z.inline=Qe.gfm),this.tokenizer.rules=Z}Pe.lex=function(Z,ce){var ge=new Pe(ce);return ge.lex(Z)},Pe.lexInline=function(Z,ce){var ge=new Pe(ce);return ge.inlineTokens(Z)};var ye=Pe.prototype;return ye.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},ye.blockTokens=function(Z,ce){var ge=this;ce===void 0&&(ce=[]),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var me,Ie,Be,Le;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Xe){return(me=Xe.call({lexer:ge},Z,ce))?(Z=Z.substring(me.raw.length),ce.push(me),!0):!1}))){if(me=this.tokenizer.space(Z)){Z=Z.substring(me.raw.length),me.type&&ce.push(me);continue}if(me=this.tokenizer.code(Z)){Z=Z.substring(me.raw.length),Ie=ce[ce.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ce.push(me);continue}if(me=this.tokenizer.fences(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.heading(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.hr(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.blockquote(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.list(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.html(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.def(Z)){Z=Z.substring(me.raw.length),Ie=ce[ce.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.lheading(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(Be=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Xe=Infinity,ne=Z.slice(1),pe=void 0;ge.options.extensions.startBlock.forEach(function(re){pe=re.call({lexer:this},ne),typeof pe=="number"&&pe>=0&&(Xe=Math.min(Xe,pe))}),Xe<Infinity&&Xe>=0&&(Be=Z.substring(0,Xe+1))}(),this.state.top&&(me=this.tokenizer.paragraph(Be))){Ie=ce[ce.length-1],Le&&Ie.type==="paragraph"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ce.push(me),Le=Be.length!==Z.length,Z=Z.substring(me.raw.length);continue}if(me=this.tokenizer.text(Z)){Z=Z.substring(me.raw.length),Ie=ce[ce.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ce.push(me);continue}if(Z){var je="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return this.state.top=!0,ce},ye.inline=function(Z,ce){this.inlineQueue.push({src:Z,tokens:ce})},ye.inlineTokens=function(Z,ce){var ge=this;ce===void 0&&(ce=[]);var me,Ie,Be,Le=Z,je,Xe,ne;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(je=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)pe.includes(je[0].slice(je[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,je.index)+"["+ze("a",je[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(je=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,je.index)+"["+ze("a",je[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(je=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,je.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(Xe||(ne=""),Xe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(B){return(me=B.call({lexer:ge},Z,ce))?(Z=Z.substring(me.raw.length),ce.push(me),!0):!1}))){if(me=this.tokenizer.escape(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.tag(Z)){Z=Z.substring(me.raw.length),Ie=ce[ce.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ce.push(me);continue}if(me=this.tokenizer.link(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(me.raw.length),Ie=ce[ce.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ce.push(me);continue}if(me=this.tokenizer.emStrong(Z,Le,ne)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.codespan(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.br(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.del(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.autolink(Z,x)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(Z,x))){Z=Z.substring(me.raw.length),ce.push(me);continue}if(Be=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var B=Infinity,Ce=Z.slice(1),Se=void 0;ge.options.extensions.startInline.forEach(function(Ge){Se=Ge.call({lexer:this},Ce),typeof Se=="number"&&Se>=0&&(B=Math.min(B,Se))}),B<Infinity&&B>=0&&(Be=Z.substring(0,B+1))}(),me=this.tokenizer.inlineText(Be,qe)){Z=Z.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(ne=me.raw.slice(-1)),Xe=!0,Ie=ce[ce.length-1],Ie&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ce.push(me);continue}if(Z){var re="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(re);break}else throw new Error(re)}}return ce},e(Pe,null,[{key:"rules",get:function(){return{block:Ne,inline:Qe}}}]),Pe}(),ee=T.exports.defaults,ae=A.cleanUrl,j=A.escape,oe=function(){function Pe(De){this.options=De||ee}var ye=Pe.prototype;return ye.code=function(Z,ce,ge){var me=(ce||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(Z,me);Ie!=null&&Ie!==Z&&(ge=!0,Z=Ie)}return Z=Z.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+j(me,!0)+'">'+(ge?Z:j(Z,!0))+`</code></pre>
`:"<pre><code>"+(ge?Z:j(Z,!0))+`</code></pre>
`},ye.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ye.html=function(Z){return Z},ye.heading=function(Z,ce,ge,me){return this.options.headerIds?"<h"+ce+' id="'+this.options.headerPrefix+me.slug(ge)+'">'+Z+"</h"+ce+`>
`:"<h"+ce+">"+Z+"</h"+ce+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(Z,ce,ge){var me=ce?"ol":"ul",Ie=ce&&ge!==1?' start="'+ge+'"':"";return"<"+me+Ie+`>
`+Z+"</"+me+`>
`},ye.listitem=function(Z){return"<li>"+Z+`</li>
`},ye.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(Z){return"<p>"+Z+`</p>
`},ye.table=function(Z,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ce+`</table>
`},ye.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ye.tablecell=function(Z,ce){var ge=ce.header?"th":"td",me=ce.align?"<"+ge+' align="'+ce.align+'">':"<"+ge+">";return me+Z+"</"+ge+`>
`},ye.strong=function(Z){return"<strong>"+Z+"</strong>"},ye.em=function(Z){return"<em>"+Z+"</em>"},ye.codespan=function(Z){return"<code>"+Z+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(Z){return"<del>"+Z+"</del>"},ye.link=function(Z,ce,ge){if(Z=ae(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ge;var me='<a href="'+j(Z)+'"';return ce&&(me+=' title="'+ce+'"'),me+=">"+ge+"</a>",me},ye.image=function(Z,ce,ge){if(Z=ae(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ge;var me='<img src="'+Z+'" alt="'+ge+'"';return ce&&(me+=' title="'+ce+'"'),me+=this.options.xhtml?"/>":">",me},ye.text=function(Z){return Z},Pe}(),fe=function(){function Pe(){}var ye=Pe.prototype;return ye.strong=function(Z){return Z},ye.em=function(Z){return Z},ye.codespan=function(Z){return Z},ye.del=function(Z){return Z},ye.html=function(Z){return Z},ye.text=function(Z){return Z},ye.link=function(Z,ce,ge){return""+ge},ye.image=function(Z,ce,ge){return""+ge},ye.br=function(){return""},Pe}(),Ae=function(){function Pe(){this.seen={}}var ye=Pe.prototype;return ye.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(Z,ce){var ge=Z,me=0;if(this.seen.hasOwnProperty(ge)){me=this.seen[Z];do me++,ge=Z+"-"+me;while(this.seen.hasOwnProperty(ge))}return ce||(this.seen[Z]=me,this.seen[ge]=0),ge},ye.slug=function(Z,ce){ce===void 0&&(ce={});var ge=this.serialize(Z);return this.getNextSafeSlug(ge,ce.dryrun)},Pe}(),xe=oe,$e=fe,we=Ae,Ze=T.exports.defaults,V=A.unescape,J=function(){function Pe(De){this.options=De||Ze,this.options.renderer=this.options.renderer||new xe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $e,this.slugger=new we}Pe.parse=function(Z,ce){var ge=new Pe(ce);return ge.parse(Z)},Pe.parseInline=function(Z,ce){var ge=new Pe(ce);return ge.parseInline(Z)};var ye=Pe.prototype;return ye.parse=function(Z,ce){ce===void 0&&(ce=!0);var ge="",me,Ie,Be,Le,je,Xe,ne,pe,re,B,Ce,Se,Ge,We,it,mt,vt,nt,ot,lt=Z.length;for(me=0;me<lt;me++){if(B=Z[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[B.type]&&(ot=this.options.extensions.renderers[B.type].call({parser:this},B),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(B.type))){ge+=ot||"";continue}switch(B.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(B.tokens),B.depth,V(this.parseInline(B.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(B.text,B.lang,B.escaped);continue}case"table":{for(pe="",ne="",Le=B.header.length,Ie=0;Ie<Le;Ie++)ne+=this.renderer.tablecell(this.parseInline(B.header[Ie].tokens),{header:!0,align:B.align[Ie]});for(pe+=this.renderer.tablerow(ne),re="",Le=B.rows.length,Ie=0;Ie<Le;Ie++){for(Xe=B.rows[Ie],ne="",je=Xe.length,Be=0;Be<je;Be++)ne+=this.renderer.tablecell(this.parseInline(Xe[Be].tokens),{header:!1,align:B.align[Be]});re+=this.renderer.tablerow(ne)}ge+=this.renderer.table(pe,re);continue}case"blockquote":{re=this.parse(B.tokens),ge+=this.renderer.blockquote(re);continue}case"list":{for(Ce=B.ordered,Se=B.start,Ge=B.loose,Le=B.items.length,re="",Ie=0;Ie<Le;Ie++)it=B.items[Ie],mt=it.checked,vt=it.task,We="",it.task&&(nt=this.renderer.checkbox(mt),Ge?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=nt+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=nt+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:nt}):We+=nt),We+=this.parse(it.tokens,Ge),re+=this.renderer.listitem(We,vt,mt);ge+=this.renderer.list(re,Ce,Se);continue}case"html":{ge+=this.renderer.html(B.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(B.tokens));continue}case"text":{for(re=B.tokens?this.parseInline(B.tokens):B.text;me+1<lt&&Z[me+1].type==="text";)B=Z[++me],re+=`
`+(B.tokens?this.parseInline(B.tokens):B.text);ge+=ce?this.renderer.paragraph(re):re;continue}default:{var Rt='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(Rt);return}else throw new Error(Rt)}}}return ge},ye.parseInline=function(Z,ce){ce=ce||this.renderer;var ge="",me,Ie,Be,Le=Z.length;for(me=0;me<Le;me++){if(Ie=Z[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(Be=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){ge+=Be||"";continue}switch(Ie.type){case"escape":{ge+=ce.text(Ie.text);break}case"html":{ge+=ce.html(Ie.text);break}case"link":{ge+=ce.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ce));break}case"image":{ge+=ce.image(Ie.href,Ie.title,Ie.text);break}case"strong":{ge+=ce.strong(this.parseInline(Ie.tokens,ce));break}case"em":{ge+=ce.em(this.parseInline(Ie.tokens,ce));break}case"codespan":{ge+=ce.codespan(Ie.text);break}case"br":{ge+=ce.br();break}case"del":{ge+=ce.del(this.parseInline(Ie.tokens,ce));break}case"text":{ge+=ce.text(Ie.text);break}default:{var je='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return ge},Pe}(),he=Y,Oe=J,Ve=H,tt=oe,ut=fe,ht=Ae,St=A.merge,Pt=A.checkSanitizeDeprecation,dt=A.escape,bt=T.exports.getDefaults,ft=T.exports.changeDefaults,Et=T.exports.defaults;function Ye(Pe,ye,De){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=St({},Ye.defaults,ye||{}),Pt(ye),De){var Z=ye.highlight,ce;try{ce=he.lex(Pe,ye)}catch(Be){return De(Be)}var ge=function(Le){var je;if(!Le)try{ye.walkTokens&&Ye.walkTokens(ce,ye.walkTokens),je=Oe.parse(ce,ye)}catch(Xe){Le=Xe}return ye.highlight=Z,Le?De(Le):De(null,je)};if(!Z||Z.length<3||(delete ye.highlight,!ce.length))return ge();var me=0;Ye.walkTokens(ce,function(Be){Be.type==="code"&&(me++,setTimeout(function(){Z(Be.text,Be.lang,function(Le,je){if(Le)return ge(Le);je!=null&&je!==Be.text&&(Be.text=je,Be.escaped=!0),me--,me===0&&ge()})},0))}),me===0&&ge();return}try{var Ie=he.lex(Pe,ye);return ye.walkTokens&&Ye.walkTokens(Ie,ye.walkTokens),Oe.parse(Ie,ye)}catch(Be){if(Be.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+dt(Be.message+"",!0)+"</pre>";throw Be}}Ye.options=Ye.setOptions=function(Pe){return St(Ye.defaults,Pe),ft(Ye.defaults),Ye},Ye.getDefaults=bt,Ye.defaults=Et,Ye.use=function(){for(var Pe=this,ye=arguments.length,De=new Array(ye),Z=0;Z<ye;Z++)De[Z]=arguments[Z];var ce=St.apply(void 0,[{}].concat(De)),ge=Ye.defaults.extensions||{renderers:{},childTokens:{}},me;De.forEach(function(Ie){if(Ie.extensions&&(me=!0,Ie.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var je=ge.renderers?ge.renderers[Le.name]:null;je?ge.renderers[Le.name]=function(){for(var Xe=arguments.length,ne=new Array(Xe),pe=0;pe<Xe;pe++)ne[pe]=arguments[pe];var re=Le.renderer.apply(this,ne);return re===!1&&(re=je.apply(this,ne)),re}:ge.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Le.level]?ge[Le.level].unshift(Le.tokenizer):ge[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?ge.startBlock?ge.startBlock.push(Le.start):ge.startBlock=[Le.start]:Le.level==="inline"&&(ge.startInline?ge.startInline.push(Le.start):ge.startInline=[Le.start]))}Le.childTokens&&(ge.childTokens[Le.name]=Le.childTokens)})),Ie.renderer&&function(){var Le=Ye.defaults.renderer||new tt,je=function(pe){var re=Le[pe];Le[pe]=function(){for(var B=arguments.length,Ce=new Array(B),Se=0;Se<B;Se++)Ce[Se]=arguments[Se];var Ge=Ie.renderer[pe].apply(Le,Ce);return Ge===!1&&(Ge=re.apply(Le,Ce)),Ge}};for(var Xe in Ie.renderer)je(Xe);ce.renderer=Le}(),Ie.tokenizer&&function(){var Le=Ye.defaults.tokenizer||new Ve,je=function(pe){var re=Le[pe];Le[pe]=function(){for(var B=arguments.length,Ce=new Array(B),Se=0;Se<B;Se++)Ce[Se]=arguments[Se];var Ge=Ie.tokenizer[pe].apply(Le,Ce);return Ge===!1&&(Ge=re.apply(Le,Ce)),Ge}};for(var Xe in Ie.tokenizer)je(Xe);ce.tokenizer=Le}(),Ie.walkTokens){var Be=Ye.defaults.walkTokens;ce.walkTokens=function(Le){Ie.walkTokens.call(Pe,Le),Be&&Be(Le)}}me&&(ce.extensions=ge),Ye.setOptions(ce)})},Ye.walkTokens=function(Pe,ye){for(var De=function(){var me=ce.value;switch(ye(me),me.type){case"table":{for(var Ie=b(me.header),Be;!(Be=Ie()).done;){var Le=Be.value;Ye.walkTokens(Le.tokens,ye)}for(var je=b(me.rows),Xe;!(Xe=je()).done;)for(var ne=Xe.value,pe=b(ne),re;!(re=pe()).done;){var B=re.value;Ye.walkTokens(B.tokens,ye)}break}case"list":{Ye.walkTokens(me.items,ye);break}default:Ye.defaults.extensions&&Ye.defaults.extensions.childTokens&&Ye.defaults.extensions.childTokens[me.type]?Ye.defaults.extensions.childTokens[me.type].forEach(function(Ce){Ye.walkTokens(me[Ce],ye)}):me.tokens&&Ye.walkTokens(me.tokens,ye)}},Z=b(Pe),ce;!(ce=Z()).done;)De()},Ye.parseInline=function(Pe,ye){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");ye=St({},Ye.defaults,ye||{}),Pt(ye);try{var De=he.lexInline(Pe,ye);return ye.walkTokens&&Ye.walkTokens(De,ye.walkTokens),Oe.parseInline(De,ye)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+dt(Z.message+"",!0)+"</pre>";throw Z}},Ye.Parser=Oe,Ye.parser=Oe.parse,Ye.Renderer=tt,Ye.TextRenderer=ut,Ye.Lexer=he,Ye.lexer=he.lex,Ye.Tokenizer=Ve,Ye.Slugger=ht,Ye.parse=Ye;var Ct=Ye;return Ct}),define(be[75],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function h(F,C,_){return Math.min(Math.max(F,C),_)}e.clamp=h;function M(F,C){return(C+F%C)%C}e.rot=M;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class T{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function ie(b){const T=[];typeof b=="number"&&T.push("code/timeOrigin",b);function F(_){T.push(_,Date.now())}function C(){const _=[];for(let P=0;P<T.length;P+=2)_.push({name:T[P],startTime:T[P+1]});return _}return{mark:F,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const F of performance.getEntriesByType("mark"))T.push({name:F.name,startTime:Math.round(b+F.startTime)});return T}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function h(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return h(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=h(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=h(M))}(),define(be[104],Ee([0,1]),function(ie,e){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(C,_,P){this.level=C,this.key=_,this.value=P,this.forward=[]}}const b=void 0;class T{constructor(C,_=2**16){this.comparator=C,this[h]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(_)|0),this._header=new M(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new M(this._maxLevel,b,b)}has(C){return Boolean(T._search(this,C,this.comparator))}get(C){return T._search(this,C,this.comparator)?.value}set(C,_){return T._insert(this,C,_,this.comparator)&&(this._size+=1),this}delete(C){const _=T._delete(this,C,this.comparator);return _&&(this._size-=1),_}forEach(C,_){let P=this._header.forward[0];for(;P;)C.call(_,P.value,P.key,this),P=P.forward[0]}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",_=this._header.forward[0];for(;_;)C+=`node(${_.key}, ${_.value}, lvl:${_.level})`,_=_.forward[0];return C}static _search(C,_,P){let t=C._header;for(let E=C._level-1;E>=0;E--)for(;t.forward[E]&&P(t.forward[E].key,_)<0;)t=t.forward[E];if(t=t.forward[0],t&&P(t.key,_)===0)return t}static _insert(C,_,P,t){let E=[],n=C._header;for(let f=C._level-1;f>=0;f--){for(;n.forward[f]&&t(n.forward[f].key,_)<0;)n=n.forward[f];E[f]=n}if(n=n.forward[0],n&&t(n.key,_)===0)return n.value=P,!1;{let f=T._randomLevel(C);if(f>C._level){for(let l=C._level;l<f;l++)E[l]=C._header;C._level=f}n=new M(f,_,P);for(let l=0;l<f;l++)n.forward[l]=E[l].forward[l],E[l].forward[l]=n;return!0}}static _randomLevel(C,_=.5){let P=1;for(;Math.random()<_&&P<C._maxLevel;)P+=1;return P}static _delete(C,_,P){let t=[],E=C._header;for(let n=C._level-1;n>=0;n--){for(;E.forward[n]&&P(E.forward[n].key,_)<0;)E=E.forward[n];t[n]=E}if(E=E.forward[0],!E||P(E.key,_)!==0)return!1;for(let n=0;n<C._level&&t[n].forward[n]===E;n++)t[n].forward[n]=E.forward[n];for(;C._level>0&&C._header.forward[C._level-1]===b;)C._level-=1;return!0}}e.SkipList=T}),define(be[34],Ee([0,1,3]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new h.Emitter}add(E){const n=this._icons.get(E.id);n?E.description?n.description=E.description:console.error(`Duplicate registration of codicon ${E.id}`):(this._icons.set(E.id,E),this._onDidRegister.fire(E))}get(E){return this._icons.get(E)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const b=new M;e.iconRegistry=b;function T(t,E){return new C(t,E)}e.registerCodicon=T;function F(t){return t?t.replace(/\$\((.*?)\)/g,(E,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=F;class C{constructor(E,n,f){this.id=E,this.definition=n,this.description=f,b.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function _(t,E){const n=["codicon","codicon-"+t];return E&&n.push("codicon-modifier-"+E),n}e.getClassNamesArray=_;var P;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const E=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(s){if(s instanceof C)return["codicon","codicon-"+s.id];const v=E.exec(s.id);if(!v)return n(C.error);let[,I,y]=v;const a=["codicon","codicon-"+I];return y&&a.push("codicon-modifier-"+y.substr(1)),a}t.asClassNameArray=n;function f(s){return n(s).join(" ")}t.asClassName=f;function l(s){return"."+n(s).join(".")}t.asCSSSelector=l})(P=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(be[105],Ee([0,1,16,6]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function b(a){const m=a;return m?[m.on,m.pause,m.resume,m.destroy].every(k=>typeof k=="function"):!1}e.isReadableStream=b;function T(a){const m=a;return m?b(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=T;function F(a,m){return new C(a,m)}e.newWriteableStream=F;class C{constructor(m,k){this.reducer=m,this.options=k,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(k=>this.pendingWritePromises.push(k))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(k=>k(m))}emitError(m){this.listeners.error.length===0?(0,h.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(k=>k(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,k){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(k),this.resume();break;case"end":this.listeners.end.push(k),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(k),this.state.flowing&&this.flowErrors();break}}removeListener(m,k){if(this.state.destroyed)return;let i;switch(m){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const u=i.indexOf(k);u>=0&&i.splice(u,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const k=[...this.pendingWritePromises];this.pendingWritePromises.length=0,k.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(a,m){const k=[];let i;for(;(i=a.read())!==null;)k.push(i);return m(k)}e.consumeReadable=_;function P(a,m,k){const i=[];let u;for(;(u=a.read())!==null&&i.length<k;)i.push(u);return u===null&&i.length>0?m(i):{read:()=>{if(i.length>0)return i.shift();if(typeof u!="undefined"){const r=u;return u=void 0,r}return a.read()}}}e.peekReadable=P;function t(a,m){return new Promise((k,i)=>{const u=[];E(a,{onData:r=>{m&&u.push(r)},onError:r=>{m?i(r):k(void 0)},onEnd:()=>{k(m?m(u):void 0)}})})}e.consumeStream=t;function E(a,m){a.on("error",k=>m.onError(k)),a.on("end",()=>m.onEnd()),a.on("data",k=>m.onData(k))}e.listenStream=E;function n(a,m){return new Promise((k,i)=>{const u=new M.DisposableStore,r=[],o=g=>{if(r.push(g),r.length>m)return u.dispose(),a.pause(),k({stream:a,buffer:r,ended:!1})},w=g=>i(g),d=()=>k({stream:a,buffer:r,ended:!0});u.add((0,M.toDisposable)(()=>a.removeListener("error",w))),a.on("error",w),u.add((0,M.toDisposable)(()=>a.removeListener("end",d))),a.on("end",d),u.add((0,M.toDisposable)(()=>a.removeListener("data",o))),a.on("data",o)})}e.peekStream=n;function f(a,m){const k=F(m);return k.end(a),k}e.toStream=f;function l(){const a=F(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=l;function s(a){let m=!1;return{read:()=>m?null:(m=!0,a)}}e.toReadable=s;function v(a,m,k){const i=F(k);return E(a,{onData:u=>i.write(m.data(u)),onError:u=>i.error(m.error?m.error(u):u),onEnd:()=>i.end()}),i}e.transform=v;function I(a,m,k){let i=!1;return{read:()=>{const u=m.read();return i?u:(i=!0,u!==null?k([a,u]):a)}}}e.prefixedReadable=I;function y(a,m,k){let i=!1;const u=F(k);return E(m,{onData:r=>i?u.write(r):(i=!0,u.write(k([a,r]))),onError:r=>u.error(r),onEnd:()=>{i||(i=!0,u.write(a)),u.end()}}),u}e.prefixedStream=y}),define(be[23],Ee([0,1,105]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let b,T;class F{constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}static alloc(o){return M?new F(Buffer.allocUnsafe(o)):new F(new Uint8Array(o))}static wrap(o){return M&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new F(o)}static fromString(o,w){return!(w?.dontUseNodeBuffer||!1)&&M?new F(Buffer.from(o)):(b||(b=new TextEncoder),new F(b.encode(o)))}static concat(o,w){if(typeof w=="undefined"){w=0;for(let S=0,R=o.length;S<R;S++)w+=o[S].byteLength}const d=F.alloc(w);let g=0;for(let S=0,R=o.length;S<R;S++){const p=o[S];d.set(p,g),g+=p.byteLength}return d}toString(){return M?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(o,w){return new F(this.buffer.subarray(o,w))}set(o,w){o instanceof F?this.buffer.set(o.buffer,w):this.buffer.set(o,w)}readUInt32BE(o){return P(this.buffer,o)}writeUInt32BE(o,w){t(this.buffer,o,w)}readUInt32LE(o){return E(this.buffer,o)}writeUInt32LE(o,w){n(this.buffer,o,w)}readUInt8(o){return f(this.buffer,o)}writeUInt8(o,w){l(this.buffer,o,w)}}e.VSBuffer=F;function C(r,o){return r[o+0]<<0>>>0|r[o+1]<<8>>>0}e.readUInt16LE=C;function _(r,o,w){r[w+0]=o&255,o=o>>>8,r[w+1]=o&255}e.writeUInt16LE=_;function P(r,o){return r[o]*2**24+r[o+1]*2**16+r[o+2]*2**8+r[o+3]}e.readUInt32BE=P;function t(r,o,w){r[w+3]=o,o=o>>>8,r[w+2]=o,o=o>>>8,r[w+1]=o,o=o>>>8,r[w]=o}e.writeUInt32BE=t;function E(r,o){return r[o+0]<<0>>>0|r[o+1]<<8>>>0|r[o+2]<<16>>>0|r[o+3]<<24>>>0}e.readUInt32LE=E;function n(r,o,w){r[w+0]=o&255,o=o>>>8,r[w+1]=o&255,o=o>>>8,r[w+2]=o&255,o=o>>>8,r[w+3]=o&255}e.writeUInt32LE=n;function f(r,o){return r[o]}e.readUInt8=f;function l(r,o,w){r[w]=o}e.writeUInt8=l;function s(r){return h.consumeReadable(r,o=>F.concat(o))}e.readableToBuffer=s;function v(r){return h.toReadable(r)}e.bufferToReadable=v;function I(r){return h.consumeStream(r,o=>F.concat(o))}e.streamToBuffer=I;async function y(r){return r.ended?F.concat(r.buffer):F.concat([...r.buffer,await I(r.stream)])}e.bufferedStreamToBuffer=y;function a(r){return h.toStream(r,o=>F.concat(o))}e.bufferToStream=a;function m(r){return h.transform(r,{data:o=>typeof o=="string"?F.fromString(o):F.wrap(o)},o=>F.concat(o))}e.streamToBufferReadableStream=m;function k(r){return h.newWriteableStream(o=>F.concat(o),r)}e.newWriteableBufferStream=k;function i(r,o){return h.prefixedReadable(r,o,w=>F.concat(w))}e.prefixedBufferReadable=i;function u(r,o){return h.prefixedStream(r,o,w=>F.concat(w))}e.prefixedBufferStream=u}),define(be[35],Ee([0,1,9]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(M||(M={})),function(b){const T="error",F="warning",C="warn",_="info",P="ignore";function t(n){return n?h.equalsIgnoreCase(T,n)?b.Error:h.equalsIgnoreCase(F,n)||h.equalsIgnoreCase(C,n)?b.Warning:h.equalsIgnoreCase(_,n)?b.Info:b.Ignore:b.Ignore}b.fromValue=t;function E(n){switch(n){case b.Error:return T;case b.Warning:return F;case b.Info:return _;default:return P}}b.toString=E}(M||(M={})),e.default=M}),define(be[41],Ee([0,1,17,26,9,10]),function(ie,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function F(r){return r===47||r===92}e.isPathSeparator=F;function C(r){return r.replace(/[\\/]/g,h.posix.sep)}e.toSlashes=C;function _(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=_;function P(r,o=h.posix.sep){if(!r)return"";const w=r.length,d=r.charCodeAt(0);if(F(d)){if(F(r.charCodeAt(1))&&!F(r.charCodeAt(2))){let S=3;const R=S;for(;S<w&&!F(r.charCodeAt(S));S++);if(R!==S&&!F(r.charCodeAt(S+1))){for(S+=1;S<w;S++)if(F(r.charCodeAt(S)))return r.slice(0,S+1).replace(/[\\/]/g,o)}}return o}else if(I(d)&&r.charCodeAt(1)===58)return F(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let g=r.indexOf("://");if(g!==-1){for(g+=3;g<w;g++)if(F(r.charCodeAt(g)))return r.slice(0,g+1)}return""}e.getRoot=P;function t(r){if(!M.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let w=2;const d=w;for(;w<r.length&&(o=r.charCodeAt(w),o!==92);w++);return!(d===w||(o=r.charCodeAt(w+1),isNaN(o)||o===92))}e.isUNC=t;const E=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(r,o=M.isWindows){const w=o?E:n;return!(!r||r.length===0||/^\s+$/.test(r)||(w.lastIndex=0,w.test(r))||o&&f.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=l;function s(r,o,w){const d=r===o;return!w||d?d:!r||!o?!1:(0,b.equalsIgnoreCase)(r,o)}e.isEqual=s;function v(r,o,w,d=h.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(w){if(!(0,b.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let S=o.length;return o.charAt(o.length-1)===d&&S--,r.charAt(S)===d}return o.charAt(o.length-1)!==d&&(o+=d),r.indexOf(o)===0}e.isEqualOrParent=v;function I(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=I;function y(r,o){return M.isWindows&&r.endsWith(":")&&(r+=h.sep),(0,h.isAbsolute)(r)||(r=(0,h.join)(o,r)),r=(0,h.normalize)(r),M.isWindows?(r=(0,b.rtrim)(r,h.sep),r.endsWith(":")&&(r+=h.sep)):(r=(0,b.rtrim)(r,h.sep),r||(r=h.sep)),r}e.sanitizeFilePath=y;function a(r){const o=(0,h.normalize)(r);return M.isWindows?r.length>3?!1:m(o)&&(r.length===2||o.charCodeAt(2)===92):o===h.posix.sep}e.isRootOrDriveLetter=a;function m(r){return M.isWindows?I(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function k(r){return m(r)?r[0]:void 0}e.getDriveLetter=k;function i(r,o,w){return o.length>r.length?-1:r===o?0:(w&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=i;function u(r){const o=r.split(":");let w,d,g;if(o.forEach(S=>{const R=Number(S);(0,T.isNumber)(R)?d===void 0?d=R:g===void 0&&(g=R):w=w?[w,S].join(":"):S}),!w)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:w,line:d!==void 0?d:void 0,column:g!==void 0?g:d!==void 0?1:void 0}}e.parseLineAndColumnAware=u}),define(be[22],Ee([0,1,10]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const v=Array.isArray(s)?[]:{};return Object.keys(s).forEach(I=>{s[I]&&typeof s[I]=="object"?v[I]=M(s[I]):v[I]=s[I]}),v}e.deepClone=M;function b(s){if(!s||typeof s!="object")return s;const v=[s];for(;v.length>0;){const I=v.shift();Object.freeze(I);for(const y in I)if(T.call(I,y)){const a=I[y];typeof a=="object"&&!Object.isFrozen(a)&&v.push(a)}}return s}e.deepFreeze=b;const T=Object.prototype.hasOwnProperty;function F(s,v){return C(s,v,new Set)}e.cloneAndChange=F;function C(s,v,I){if((0,h.isUndefinedOrNull)(s))return s;const y=v(s);if(typeof y!="undefined")return y;if((0,h.isArray)(s)){const a=[];for(const m of s)a.push(C(m,v,I));return a}if((0,h.isObject)(s)){if(I.has(s))throw new Error("Cannot clone recursive data-structure");I.add(s);const a={};for(let m in s)T.call(s,m)&&(a[m]=C(s[m],v,I));return I.delete(s),a}return s}function _(s,v,I=!0){return(0,h.isObject)(s)?((0,h.isObject)(v)&&Object.keys(v).forEach(y=>{y in s?I&&((0,h.isObject)(s[y])&&(0,h.isObject)(v[y])?_(s[y],v[y],I):s[y]=v[y]):s[y]=v[y]}),s):v}e.mixin=_;function P(s,v){if(s===v)return!0;if(s==null||v===null||v===void 0||typeof s!=typeof v||typeof s!="object"||Array.isArray(s)!==Array.isArray(v))return!1;let I,y;if(Array.isArray(s)){if(s.length!==v.length)return!1;for(I=0;I<s.length;I++)if(!P(s[I],v[I]))return!1}else{const a=[];for(y in s)a.push(y);a.sort();const m=[];for(y in v)m.push(y);if(m.sort(),!P(a,m))return!1;for(I=0;I<a.length;I++)if(!P(s[a[I]],v[a[I]]))return!1}return!0}e.equals=P;function t(s){const v=new Set;return JSON.stringify(s,(I,y)=>{if((0,h.isObject)(y)||Array.isArray(y)){if(v.has(y))return"[Circular]";v.add(y)}return y})}e.safeStringify=t;function E(s,v,I){const y=v(s);return typeof y=="undefined"?I:y}e.getOrDefault=E;function n(s,v){const I=Object.create(null);return!s||!v||Object.keys(v).forEach(a=>{const m=s[a],k=v[a];P(m,k)||(I[a]=k)}),I}e.distinct=n;function f(s,v){const I=v.toLowerCase(),y=Object.keys(s).find(a=>a.toLowerCase()===I);return y?s[y]:s[v]}e.getCaseInsensitive=f;function l(s,v){const I=Object.create(null);for(const y of Object.keys(s))v(y,s[y])&&(I[y]=s[y]);return I}e.filter=l});var Je=this&&this.__classPrivateFieldSet||function(ie,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ie,h):b?b.value=h:e.set(ie,h),h},Te=this&&this.__classPrivateFieldGet||function(ie,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[20],Ee([0,1,13,9,2]),function(ie,e,h,M,b){"use strict";var T,F,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function _(u,r,o){let w=u.get(r);return w===void 0&&(w=o,u.set(r,w)),w}e.getOrSet=_;function P(u){const r=[];return u.forEach((o,w)=>{r.push(`${w} => ${o}`)}),`Map(${u.size}) {${r.join(", ")}}`}e.mapToString=P;function t(u){const r=[];return u.forEach(o=>{r.push(o)}),`Set(${u.size}) {${r.join(", ")}}`}e.setToString=t;class E{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const o=r.charCodeAt(0),w=this._value.charCodeAt(this._pos);return o-w}value(){return this._value[this._pos]}}e.StringIterator=E;class n{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=n;class f{constructor(r=!0,o=!0){this._splitOnBackslash=r,this._caseSensitive=o}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var l;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(l||(l={}));class s{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,M.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=s;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class I{constructor(r){this._iter=r}static forUris(r=()=>!1){return new I(new s(r))}static forPaths(){return new I(new f)}static forStrings(){return new I(new E)}static forConfigKeys(){return new I(new n)}clear(){this._root=void 0}set(r,o){const w=this._iter.reset(r);let d;for(this._root||(this._root=new v,this._root.segment=w.value()),d=this._root;;){const S=w.cmp(d.segment);if(S>0)d.left||(d.left=new v,d.left.segment=w.value()),d=d.left;else if(S<0)d.right||(d.right=new v,d.right.segment=w.value()),d=d.right;else if(w.hasNext())w.next(),d.mid||(d.mid=new v,d.mid.segment=w.value()),d=d.mid;else break}const g=d.value;return d.value=o,d.key=r,g}fill(r,o){const w=o.slice(0);(0,h.shuffle)(w);for(let d of w)this.set(d,r)}get(r){return this._getNode(r)?.value}_getNode(r){const o=this._iter.reset(r);let w=this._root;for(;w;){const d=o.cmp(w.segment);if(d>0)w=w.left;else if(d<0)w=w.right;else if(o.hasNext())o.next(),w=w.mid;else break}return w}has(r){const o=this._getNode(r);return!(o?.value===void 0&&o?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,o){const w=this._iter.reset(r),d=[];let g=this._root;for(;g;){const S=w.cmp(g.segment);if(S>0)d.push([1,g]),g=g.left;else if(S<0)d.push([-1,g]),g=g.right;else if(w.hasNext())w.next(),d.push([0,g]),g=g.mid;else{for(o?(g.left=void 0,g.mid=void 0,g.right=void 0):g.value=void 0;d.length>0&&g.isEmpty();){let[R,p]=d.pop();switch(R){case 1:p.left=void 0;break;case 0:p.mid=void 0;break;case-1:p.right=void 0;break}g=p}break}}}findSubstr(r){const o=this._iter.reset(r);let w=this._root,d;for(;w;){const g=o.cmp(w.segment);if(g>0)w=w.left;else if(g<0)w=w.right;else if(o.hasNext())o.next(),d=w.value||d,w=w.mid;else break}return w&&w.value||d}findSuperstr(r){const o=this._iter.reset(r);let w=this._root;for(;w;){const d=o.cmp(w.segment);if(d>0)w=w.left;else if(d<0)w=w.right;else if(o.hasNext())o.next(),w=w.mid;else return w.mid?this._entries(w.mid):void 0}}forEach(r){for(const[o,w]of this)r(w,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const o=[r];for(;o.length>0;){const w=o.pop();w&&(w.value&&(yield[w.key,w.value]),w.left&&o.push(w.left),w.mid&&o.push(w.mid),w.right&&o.push(w.right))}}}e.TernarySearchTree=I;class y{constructor(r,o){this[T]="ResourceMap",r instanceof y?(this.map=new Map(r.map),this.toKey=o??y.defaultToKey):(this.map=new Map,this.toKey=r??y.defaultToKey)}set(r,o){return this.map.set(this.toKey(r),o),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,o){typeof o!="undefined"&&(r=r.bind(o));for(let[w,d]of this.map)r(d,b.URI.parse(w),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield b.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[b.URI.parse(r[0]),r[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[b.URI.parse(r[0]),r[1]]}}e.ResourceMap=y,y.defaultToKey=u=>u.toString();var a;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class m{constructor(){this[F]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,o=0){const w=this._map.get(r);if(!!w)return o!==0&&this.touch(w,o),w.value}set(r,o,w=0){let d=this._map.get(r);if(d)d.value=o,w!==0&&this.touch(d,w);else{switch(d={key:r,value:o,next:void 0,previous:void 0},w){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(r,d),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const o=this._map.get(r);if(!!o)return this._map.delete(r),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,o){const w=this._state;let d=this._head;for(;d;){if(o?r.bind(o)(d.value,d.key,this):r(d.value,d.key,this),this._state!==w)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const r=this,o=this._state;let w=this._head;const d={[Symbol.iterator](){return d},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(w){const g={value:w.key,done:!1};return w=w.next,g}else return{value:void 0,done:!0}}};return d}values(){const r=this,o=this._state;let w=this._head;const d={[Symbol.iterator](){return d},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(w){const g={value:w.value,done:!1};return w=w.next,g}else return{value:void 0,done:!0}}};return d}entries(){const r=this,o=this._state;let w=this._head;const d={[Symbol.iterator](){return d},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(w){const g={value:[w.key,w.value],done:!1};return w=w.next,g}else return{value:void 0,done:!0}}};return d}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let o=this._head,w=this.size;for(;o&&w>r;)this._map.delete(o.key),o=o.next,w--;this._head=o,this._size=w,o&&(o.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const o=r.next,w=r.previous;if(!o||!w)throw new Error("Invalid list");o.previous=w,w.next=o}r.next=void 0,r.previous=void 0,this._state++}touch(r,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(r===this._head)return;const w=r.next,d=r.previous;r===this._tail?(d.next=void 0,this._tail=d):(w.previous=d,d.next=w),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(o===2){if(r===this._tail)return;const w=r.next,d=r.previous;r===this._head?(w.previous=void 0,this._head=w):(w.previous=d,d.next=w),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((o,w)=>{r.push([w,o])}),r}fromJSON(r){this.clear();for(const[o,w]of r)this.set(o,w)}}e.LinkedMap=m;class k extends m{constructor(r,o=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,o=2){return super.get(r,o)}peek(r){return super.get(r,0)}set(r,o){return super.set(r,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=k;class i{constructor(r){C.set(this,void 0),Je(this,C,r,"f")}get size(){return Te(this,C,"f").size}forEach(r,o){Te(this,C,"f").forEach(r,o)}get(r){return Te(this,C,"f").get(r)}has(r){return Te(this,C,"f").has(r)}entries(){return Te(this,C,"f").entries()}keys(){return Te(this,C,"f").keys()}values(){return Te(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Te(this,C,"f").entries()}}e.ReadonlyMapView=i}),define(be[106],Ee([0,1,20,9]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...j){return function(oe,fe){for(let Ae=0,xe=j.length;Ae<xe;Ae++){const $e=j[Ae](oe,fe);if($e)return $e}return null}}e.or=b,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(j,oe,fe){if(!fe||fe.length<oe.length)return null;let Ae;return j?Ae=M.startsWithIgnoreCase(fe,oe):Ae=fe.indexOf(oe)===0,Ae?oe.length>0?[{start:0,end:oe.length}]:[]:null}function F(j,oe){const fe=oe.toLowerCase().indexOf(j.toLowerCase());return fe===-1?null:[{start:fe,end:fe+j.length}]}e.matchesContiguousSubString=F;function C(j,oe){return _(j.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=C;function _(j,oe,fe,Ae){if(fe===j.length)return[];if(Ae===oe.length)return null;if(j[fe]===oe[Ae]){let xe=null;return(xe=_(j,oe,fe+1,Ae+1))?I({start:Ae,end:Ae+1},xe):null}return _(j,oe,fe,Ae+1)}function P(j){return 97<=j&&j<=122}function t(j){return 65<=j&&j<=90}e.isUpper=t;function E(j){return 48<=j&&j<=57}function n(j){return j===32||j===9||j===10||j===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(j=>f.add(j.charCodeAt(0)));function l(j){return n(j)||f.has(j)}function s(j,oe){return j===oe||l(j)&&l(oe)}function v(j){return P(j)||t(j)||E(j)}function I(j,oe){return oe.length===0?oe=[j]:j.end===oe[0].start?oe[0].start=j.start:oe.unshift(j),oe}function y(j,oe){for(let fe=oe;fe<j.length;fe++){const Ae=j.charCodeAt(fe);if(t(Ae)||E(Ae)||fe>0&&!v(j.charCodeAt(fe-1)))return fe}return j.length}function a(j,oe,fe,Ae){if(fe===j.length)return[];if(Ae===oe.length)return null;if(j[fe]!==oe[Ae].toLowerCase())return null;{let xe=null,$e=Ae+1;for(xe=a(j,oe,fe+1,Ae+1);!xe&&($e=y(oe,$e))<oe.length;)xe=a(j,oe,fe+1,$e),$e++;return xe===null?null:I({start:Ae,end:Ae+1},xe)}}function m(j){let oe=0,fe=0,Ae=0,xe=0,$e=0;for(let he=0;he<j.length;he++)$e=j.charCodeAt(he),t($e)&&oe++,P($e)&&fe++,v($e)&&Ae++,E($e)&&xe++;const we=oe/j.length,Ze=fe/j.length,V=Ae/j.length,J=xe/j.length;return{upperPercent:we,lowerPercent:Ze,alphaPercent:V,numericPercent:J}}function k(j){const{upperPercent:oe,lowerPercent:fe}=j;return fe===0&&oe>.6}function i(j){const{upperPercent:oe,lowerPercent:fe,alphaPercent:Ae,numericPercent:xe}=j;return fe>.2&&oe<.8&&Ae>.6&&xe<.2}function u(j){let oe=0,fe=0,Ae=0,xe=0;for(let $e=0;$e<j.length;$e++)Ae=j.charCodeAt($e),t(Ae)&&oe++,P(Ae)&&fe++,n(Ae)&&xe++;return(oe===0||fe===0)&&xe===0?j.length<=30:oe<=5}function r(j,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!u(j)||oe.length>60)return null;const fe=m(oe);if(!i(fe)){if(!k(fe))return null;oe=oe.toLowerCase()}let Ae=null,xe=0;for(j=j.toLowerCase();xe<oe.length&&(Ae=a(j,oe,0,xe))===null;)xe=y(oe,xe+1);return Ae}e.matchesCamelCase=r;function o(j,oe,fe=!1){if(!oe||oe.length===0)return null;let Ae=null,xe=0;for(j=j.toLowerCase(),oe=oe.toLowerCase();xe<oe.length&&(Ae=w(j,oe,0,xe,fe))===null;)xe=d(oe,xe+1);return Ae}e.matchesWords=o;function w(j,oe,fe,Ae,xe){if(fe===j.length)return[];if(Ae===oe.length)return null;if(s(j.charCodeAt(fe),oe.charCodeAt(Ae))){let $e=null,we=Ae+1;if($e=w(j,oe,fe+1,Ae+1,xe),!xe)for(;!$e&&(we=d(oe,we))<oe.length;)$e=w(j,oe,fe+1,we,xe),we++;return $e===null?null:I({start:Ae,end:Ae+1},$e)}else return null}function d(j,oe){for(let fe=oe;fe<j.length;fe++)if(l(j.charCodeAt(fe))||fe>0&&l(j.charCodeAt(fe-1)))return fe;return j.length}const g=b(e.matchesPrefix,r,F),S=b(e.matchesPrefix,r,C),R=new h.LRUCache(1e4);function p(j,oe,fe=!1){if(typeof j!="string"||typeof oe!="string")return null;let Ae=R.get(j);Ae||(Ae=new RegExp(M.convertSimple2RegExpPattern(j),"i"),R.set(j,Ae));const xe=Ae.exec(oe);return xe?[{start:xe.index,end:xe.index+xe[0].length}]:fe?S(j,oe):g(j,oe)}e.matchesFuzzy=p;function D(j,oe){const fe=Qe(j,j.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return fe?A(fe):null}e.matchesFuzzy2=D;function c(j,oe,fe,Ae,xe,$e){const we=Math.min(13,j.length);for(;fe<we;fe++){const Ze=Qe(j,oe,fe,Ae,xe,$e,!1);if(Ze)return Ze}return[0,$e]}e.anyScore=c;function A(j){if(typeof j=="undefined")return[];const oe=[],fe=j[1];for(let Ae=j.length-1;Ae>1;Ae--){const xe=j[Ae]+fe,$e=oe[oe.length-1];$e&&$e.end===xe?$e.end=xe+1:oe.push({start:xe,end:xe+1})}return oe}e.createMatches=A;const O=128;function z(){const j=[],oe=[];for(let fe=0;fe<=O;fe++)oe[fe]=0;for(let fe=0;fe<=O;fe++)j.push(oe.slice(0));return j}function K(j){const oe=[];for(let fe=0;fe<=j;fe++)oe[fe]=0;return oe}const $=K(2*O),Q=K(2*O),W=z(),U=z(),H=z(),G=!1;function ue(j,oe,fe,Ae,xe){function $e(Ze,V,J=" "){for(;Ze.length<V;)Ze=J+Ze;return Ze}let we=` |   |${Ae.split("").map(Ze=>$e(Ze,3)).join("|")}
`;for(let Ze=0;Ze<=fe;Ze++)Ze===0?we+=" |":we+=`${oe[Ze-1]}|`,we+=j[Ze].slice(0,xe+1).map(V=>$e(V.toString(),3)).join("|")+`
`;return we}function q(j,oe,fe,Ae){j=j.substr(oe),fe=fe.substr(Ae),console.log(ue(U,j,j.length,fe,fe.length)),console.log(ue(H,j,j.length,fe,fe.length)),console.log(ue(W,j,j.length,fe,fe.length))}function le(j,oe){if(oe<0||oe>=j.length)return!1;const fe=j.codePointAt(oe);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(fe)}}function se(j,oe){if(oe<0||oe>=j.length)return!1;switch(j.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ve(j,oe,fe){return oe[j]!==fe[j]}function Fe(j,oe,fe,Ae,xe,$e,we=!1){for(;oe<fe&&xe<$e;)j[oe]===Ae[xe]&&(we&&($[oe]=xe),oe+=1),xe+=1;return oe===fe}e.isPatternInWord=Fe;var Me;(function(j){j[j.Diag=1]="Diag",j[j.Left=2]="Left",j[j.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var Ne;(function(j){j.Default=[-100,0];function oe(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}j.isDefault=oe})(Ne=e.FuzzyScore||(e.FuzzyScore={}));function Qe(j,oe,fe,Ae,xe,$e,we){const Ze=j.length>O?O:j.length,V=Ae.length>O?O:Ae.length;if(fe>=Ze||$e>=V||Ze-fe>V-$e||!Fe(oe,fe,Ze,xe,$e,V,!0))return;ze(Ze,V,fe,$e,oe,xe);let J=1,he=1,Oe=fe,Ve=$e;const tt=[!1];for(J=1,Oe=fe;Oe<Ze;J++,Oe++){const dt=$[Oe],bt=Q[Oe],ft=Oe+1<Ze?Q[Oe+1]:V;for(he=dt-$e+1,Ve=dt;Ve<ft;he++,Ve++){let Et=Number.MIN_SAFE_INTEGER,Ye=!1;Ve<=bt&&(Et=qe(j,oe,Oe,fe,Ae,xe,Ve,V,$e,W[J-1][he-1]===0,tt));let Ct=0;Et!==Number.MAX_SAFE_INTEGER&&(Ye=!0,Ct=Et+U[J-1][he-1]);const Pe=Ve>dt,ye=Pe?U[J][he-1]+(W[J][he-1]>0?-5:0):0,De=Ve>dt+1&&W[J][he-1]>0,Z=De?U[J][he-2]+(W[J][he-2]>0?-5:0):0;if(De&&(!Pe||Z>=ye)&&(!Ye||Z>=Ct))U[J][he]=Z,H[J][he]=3,W[J][he]=0;else if(Pe&&(!Ye||ye>=Ct))U[J][he]=ye,H[J][he]=2,W[J][he]=0;else if(Ye)U[J][he]=Ct,H[J][he]=1,W[J][he]=W[J-1][he-1]+1;else throw new Error("not possible")}}if(G&&q(j,fe,Ae,$e),!tt[0]&&!we)return;J--,he--;const ut=[U[J][he],$e];let ht=0,St=0;for(;J>=1;){let dt=he;do{const bt=H[J][dt];if(bt===3)dt=dt-2;else if(bt===2)dt=dt-1;else break}while(dt>=1);ht>1&&oe[fe+J-1]===xe[$e+he-1]&&!ve(dt+$e-1,Ae,xe)&&ht+1>W[J][dt]&&(dt=he),dt===he?ht++:ht=1,St||(St=dt),J--,he=dt-1,ut.push(he)}V===Ze&&(ut[0]+=2);const Pt=St-Ze;return ut[0]-=Pt,ut}e.fuzzyScore=Qe;function ze(j,oe,fe,Ae,xe,$e){let we=j-1,Ze=oe-1;for(;we>=fe&&Ze>=Ae;)xe[we]===$e[Ze]&&(Q[we]=Ze,we--),Ze--}function qe(j,oe,fe,Ae,xe,$e,we,Ze,V,J,he){if(oe[fe]!==$e[we])return Number.MIN_SAFE_INTEGER;let Oe=1,Ve=!1;return we===fe-Ae?Oe=j[fe]===xe[we]?7:5:ve(we,xe,$e)&&(we===0||!ve(we-1,xe,$e))?(Oe=j[fe]===xe[we]?7:5,Ve=!0):le($e,we)&&(we===0||!le($e,we-1))?Oe=5:(le($e,we-1)||se($e,we-1))&&(Oe=5,Ve=!0),Oe>1&&fe===Ae&&(he[0]=!0),Ve||(Ve=ve(we,xe,$e)||le($e,we-1)||se($e,we-1)),fe===Ae?we>V&&(Oe-=Ve?3:5):J?Oe+=Ve?2:0:Oe+=Ve?0:1,we+1===Ze&&(Oe-=Ve?3:5),Oe}function x(j,oe,fe,Ae,xe,$e,we){return ee(j,oe,fe,Ae,xe,$e,!0,we)}e.fuzzyScoreGracefulAggressive=x;function Y(j,oe,fe,Ae,xe,$e,we){return ee(j,oe,fe,Ae,xe,$e,!1,we)}e.fuzzyScoreGraceful=Y;function ee(j,oe,fe,Ae,xe,$e,we,Ze){let V=Qe(j,oe,fe,Ae,xe,$e,Ze);if(V&&!we)return V;if(j.length>=3){const J=Math.min(7,j.length-1);for(let he=fe+1;he<J;he++){const Oe=ae(j,he);if(Oe){const Ve=Qe(Oe,Oe.toLowerCase(),fe,Ae,xe,$e,Ze);Ve&&(Ve[0]-=3,(!V||Ve[0]>V[0])&&(V=Ve))}}}return V}function ae(j,oe){if(oe+1>=j.length)return;const fe=j[oe],Ae=j[oe+1];if(fe!==Ae)return j.slice(0,oe)+Ae+fe+j.slice(oe+2)}}),define(be[107],Ee([0,1,34,106,9]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?\\)`,"g"),F=new RegExp(`(\\\\)?${T.source}`,"g");function C(s){return s.replace(F,(v,I)=>I?v:`\\${v}`)}e.escapeIcons=C;const _=new RegExp(`\\\\${T.source}`,"g");function P(s){return s.replace(_,v=>`\\${v}`)}e.markdownEscapeEscapedIcons=P;const t=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function E(s){return s.indexOf(e.iconStartMarker)===-1?s:s.replace(t,(v,I,y,a)=>y?v:I||a||"")}e.stripIcons=E;function n(s){const v=s.indexOf(e.iconStartMarker);return v===-1?{text:s}:f(s,v)}e.parseLabelWithIcons=n;function f(s,v){const I=[];let y="";function a(d){if(d){y+=d;for(const g of d)I.push(i)}}let m=-1,k="",i=0,u,r,o=v;const w=s.length;for(a(s.substr(0,v));o<w;)u=s[o],r=s[o+1],u===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(m=o,a(k),k=e.iconStartMarker,o++):u===")"&&m!==-1?(i+=o-m+1,m=-1,k=""):m!==-1?/^[a-z0-9\-]$/i.test(u)?k+=u:(a(k),m=-1,k=""):a(u),o++;return a(k),{text:y,iconOffsets:I}}function l(s,v,I=!1){const{text:y,iconOffsets:a}=v;if(!a||a.length===0)return(0,M.matchesFuzzy)(s,y,I);const m=(0,b.ltrim)(y," "),k=y.length-m.length,i=(0,M.matchesFuzzy)(s,m,I);if(i)for(const u of i){const r=a[u.start+k]+k;u.start+=r,u.end+=r}return i}e.matchesFuzzyIconAware=l}),define(be[76],Ee([0,1,16,107]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(b=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class T{constructor(f="",l=!1){if(this.value=f,typeof this.value!="string")throw(0,h.illegalArgument)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1,this.supportHtml=l.supportHtml??!1)}appendText(f,l=0){return this.value+=P(this.supportThemeIcons?(0,M.escapeIcons)(f):f).replace(/([ \t]+)/g,(s,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,l){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}}e.MarkdownString=T;function F(n){return C(n)?!n.value:Array.isArray(n)?n.every(F):!0}e.isEmptyMarkdownString=F;function C(n){return n instanceof T?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function _(n,f){return n===f?!0:!n||!f?!1:n.value===f.value&&n.isTrusted===f.isTrusted&&n.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=_;function P(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function E(n){const f=[],l=n.split("|").map(v=>v.trim());n=l[0];const s=l[1];if(s){const v=/height=(\d+)/.exec(s),I=/width=(\d+)/.exec(s),y=v?v[1]:"",a=I?I[1]:"",m=isFinite(parseInt(a)),k=isFinite(parseInt(y));m&&f.push(`width="${a}"`),k&&f.push(`height="${y}"`)}return{href:n,dimensions:f}}e.parseHrefAndDimensions=E}),define(be[54],Ee([0,1,23,9,2]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(t){return JSON.stringify(t,_)}e.stringify=T;function F(t){let E=JSON.parse(t);return E=P(E),E}e.parse=F;var C;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function _(t,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,M.regExpFlags)(E)}:E}function P(t,E=0){if(!t||E>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return b.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof h.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=P(t[n],E+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=P(t[n],E+1))}return t}e.revive=P}),define(be[11],Ee([0,1,26,2]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var b;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(b=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,P,t){this._hosts[_]=P,this._ports[_]=t}setConnectionToken(_,P){this._connectionTokens[_]=P}rewrite(_){if(this._delegate)return this._delegate(_);const P=_.authority;let t=this._hosts[P];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const E=this._ports[P],n=this._connectionTokens[P];let f=`path=${encodeURIComponent(_.path)}`;return typeof n=="string"&&(f+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:h.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${t}:${E}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new T;class F{asBrowserUri(_,P){const t=this.toUri(_,P);return t.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===b.file&&(h.isNative||typeof h.globals.importScripts=="function"&&h.globals.origin===`${b.vscodeFileResource}://${F.FALLBACK_AUTHORITY}`)?t.with({scheme:b.vscodeFileResource,authority:t.authority||F.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(_,P){const t=this.toUri(_,P);return t.scheme===b.vscodeFileResource?t.with({scheme:b.file,authority:t.authority!==F.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(_,P){return M.URI.isUri(_)?_:M.URI.parse(P.toUrl(_))}}F.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new F}),define(be[24],Ee([0,1,41,11,17,26,9,2]),function(ie,e,h,M,b,T,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(f){return(0,C.uriToFsPath)(f,!0)}e.originalFSPath=_;class P{constructor(l){this._ignorePathCasing=l}compare(l,s,v=!1){return l===s?0:(0,F.compare)(this.getComparisonKey(l,v),this.getComparisonKey(s,v))}isEqual(l,s,v=!1){return l===s?!0:!l||!s?!1:this.getComparisonKey(l,v)===this.getComparisonKey(s,v)}getComparisonKey(l,s=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,s,v=!1){if(l.scheme===s.scheme){if(l.scheme===M.Schemas.file)return h.isEqualOrParent(_(l),_(s),this._ignorePathCasing(l))&&l.query===s.query&&(v||l.fragment===s.fragment);if((0,e.isEqualAuthority)(l.authority,s.authority))return h.isEqualOrParent(l.path,s.path,this._ignorePathCasing(l),"/")&&l.query===s.query&&(v||l.fragment===s.fragment)}return!1}joinPath(l,...s){return C.URI.joinPath(l,...s)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return b.posix.basename(l.path)}extname(l){return b.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let s;return l.scheme===M.Schemas.file?s=C.URI.file(b.dirname(_(l))).path:(s=b.posix.dirname(l.path),l.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),s="/")),l.with({path:s})}normalizePath(l){if(!l.path.length)return l;let s;return l.scheme===M.Schemas.file?s=C.URI.file(b.normalize(_(l))).path:s=b.posix.normalize(l.path),l.with({path:s})}relativePath(l,s){if(l.scheme!==s.scheme||!(0,e.isEqualAuthority)(l.authority,s.authority))return;if(l.scheme===M.Schemas.file){const y=b.relative(_(l),_(s));return T.isWindows?h.toSlashes(y):y}let v=l.path||"/",I=s.path||"/";if(this._ignorePathCasing(l)){let y=0;for(const a=Math.min(v.length,I.length);y<a&&!(v.charCodeAt(y)!==I.charCodeAt(y)&&v.charAt(y).toLowerCase()!==I.charAt(y).toLowerCase());y++);v=I.substr(0,y)+v.substr(y)}return b.posix.relative(v,I)}resolvePath(l,s){if(l.scheme===M.Schemas.file){const v=C.URI.file(b.resolve(_(l),s));return l.with({authority:v.authority,path:v.path})}return s=h.toPosixPath(s),l.with({path:b.posix.resolve(l.path,s)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,s){return l===s||(0,F.equalsIgnoreCase)(l,s)}hasTrailingPathSeparator(l,s=b.sep){if(l.scheme===M.Schemas.file){const v=_(l);return v.length>h.getRoot(v).length&&v[v.length-1]===s}else{const v=l.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,s=b.sep){return(0,e.hasTrailingPathSeparator)(l,s)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,s=b.sep){let v=!1;if(l.scheme===M.Schemas.file){const I=_(l);v=I!==void 0&&I.length===h.getRoot(I).length&&I[I.length-1]===s}else{s="/";const I=l.path;v=I.length===1&&I.charCodeAt(I.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(l,s)?l.with({path:l.path+"/"}):l}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(f=>f.scheme===M.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new P(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(f,l){const s=[];for(let v=0;v<f.length;v++){const I=l(f[v]);f.some((y,a)=>a===v?!1:(0,e.isEqualOrParent)(I,l(y)))||s.push(f[v])}return s}e.distinctParents=t;var E;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function l(s){const v=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(a=>{const[m,k]=a.split(":");m&&k&&v.set(m,k)});const y=s.path.substring(0,s.path.indexOf(";"));return y&&v.set(f.META_DATA_MIME,y),v}f.parseMetaData=l})(E=e.DataUri||(e.DataUri={}));function n(f,l,s){if(l){let v=f.path;return v&&v[0]!==b.posix.sep&&(v=b.posix.sep+v),f.with({scheme:s,authority:l,path:v})}return f.with({scheme:s})}e.toLocalResource=n}),define(be[14],Ee([0,1,21,16,3,6,24]),function(ie,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(W){return!!W&&typeof W.then=="function"}e.isThenable=C;function _(W){const U=new h.CancellationTokenSource,H=W(U.token),G=new Promise((ue,q)=>{const le=U.token.onCancellationRequested(()=>{le.dispose(),U.dispose(),q((0,M.canceled)())});Promise.resolve(H).then(se=>{le.dispose(),U.dispose(),ue(se)},se=>{le.dispose(),U.dispose(),q(se)})});return new class{cancel(){U.cancel()}then(ue,q){return G.then(ue,q)}catch(ue){return this.then(void 0,ue)}finally(ue){return G.finally(ue)}}}e.createCancelablePromise=_;function P(W,U,H){return Promise.race([W,new Promise(G=>U.onCancellationRequested(()=>G(H)))])}e.raceCancellation=P;async function t(W){let U=-1;const H=W.map((ue,q)=>ue.then(le=>(U=q,le))),G=await Promise.race(H);return W.forEach((ue,q)=>{q!==U&&ue.cancel()}),G}e.raceCancellablePromises=t;function E(W,U,H){let G;const ue=setTimeout(()=>{G?.(void 0),H?.()},U);return Promise.race([W.finally(()=>clearTimeout(ue)),new Promise(q=>G=q)])}e.raceTimeout=E;function n(W){return new Promise((U,H)=>{const G=W();C(G)?G.then(U,H):U(G)})}e.asPromise=n;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const H=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(H,H).then(G)})}return new Promise((H,G)=>{this.queuedPromise.then(H,G)})}return this.activePromise=U(),new Promise((H,G)=>{this.activePromise.then(ue=>{this.activePromise=null,H(ue)},ue=>{this.activePromise=null,G(ue)})})}}e.Throttler=f;class l{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=l;class s{constructor(){this.promiseMap=new Map}queue(U,H){const ue=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get(U)===ue&&this.promiseMap.delete(U)});return this.promiseMap.set(U,ue),ue}}e.SequencerByKey=s;class v{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,H=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,ue)=>{this.doResolve=G,this.doReject=ue}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},H),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=v;class I{constructor(U){this.delayer=new v(U),this.throttler=new f}trigger(U,H){return this.delayer.trigger(()=>this.throttler.queue(U),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class y{constructor(){this._isOpen=!1,this._promise=new Promise((U,H)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=y;class a extends y{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function m(W,U){return U?new Promise((H,G)=>{const ue=setTimeout(()=>{q.dispose(),H()},W),q=U.onCancellationRequested(()=>{clearTimeout(ue),q.dispose(),G((0,M.canceled)())})}):_(H=>m(W,H))}e.timeout=m;function k(W,U=0){const H=setTimeout(W,U);return(0,T.toDisposable)(()=>clearTimeout(H))}e.disposableTimeout=k;function i(W){const U=[];let H=0;const G=W.length;function ue(){return H<G?W[H++]():null}function q(le){le!=null&&U.push(le);const se=ue();return se?se.then(q):Promise.resolve(U)}return Promise.resolve(null).then(q)}e.sequence=i;function u(W,U=G=>!!G,H=null){let G=0;const ue=W.length,q=()=>{if(G>=ue)return Promise.resolve(H);const le=W[G++];return Promise.resolve(le()).then(ve=>U(ve)?Promise.resolve(ve):q())};return q()}e.first=u;function r(W,U=G=>!!G,H=null){if(W.length===0)return Promise.resolve(H);let G=W.length;const ue=()=>{G=-1;for(const q of W)q.cancel?.()};return new Promise((q,le)=>{for(const se of W)se.then(ve=>{--G>=0&&U(ve)?(ue(),q(ve)):G===0&&q(H)}).catch(ve=>{--G>=0&&(ue(),le(ve))})})}e.firstParallel=r;class o{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new b.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((H,G)=>{this.outstandingPromises.push({factory:U,c:H,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const H=U.factory();H.then(U.c,U.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class w extends o{constructor(){super(1)}}e.Queue=w;class d{constructor(){this.queues=new Map}queueFor(U,H=F.extUri){const G=H.getComparisonKey(U);let ue=this.queues.get(G);return ue||(ue=new w,b.Event.once(ue.onFinished)(()=>{ue?.dispose(),this.queues.delete(G)}),this.queues.set(G,ue)),ue}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=d;class g{constructor(U,H){this._token=-1,typeof U=="function"&&typeof H=="number"&&this.setIfNotSet(U,H)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,H){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},H)}setIfNotSet(U,H){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},H))}}e.TimeoutTimer=g;class S{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,H){this.cancel(),this._token=setInterval(()=>{U()},H)}}e.IntervalTimer=S;class R{constructor(U,H){this.timeoutToken=-1,this.runner=U,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class p{constructor(U,H){H%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=H,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=p;class D extends R{constructor(U,H){super(U,H);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=D;class c extends T.Disposable{constructor(U,H,G,ue){super();this.maxWorkChunkSize=U,this.maxPendingWork=H,this.throttleDelay=G,this.handler=ue,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=c,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const W=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=U=>{const H=setTimeout(()=>U(W));let G=!1;return{dispose(){G||(G=!0,clearTimeout(H))}}}}else e.runWhenIdle=(W,U)=>{const H=requestIdleCallback(W,typeof U=="number"?{timeout:U}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(H))}}}}();class A{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(H){this._error=H}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=A;async function O(W,U,H){let G;for(let ue=0;ue<H;ue++)try{return await W()}catch(q){G=q,await m(U)}throw G}e.retry=O;class z{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,H,G){return this._pending={taskId:U,cancel:()=>G?.(),promise:H},H.then(()=>this.donePending(U),()=>this.donePending(U)),H}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let H,G;const ue=new Promise((q,le)=>{H=q,G=le});this._next={run:U,promise:ue,promiseResolve:H,promiseReject:G}}return this._next.promise}}e.TaskSequentializer=z;class K{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,H)=>{this.completeCallback=U,this.errorCallback=H})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(H=>{this.completeCallback(U),this.resolved=!0,H()})}error(U){return new Promise(H=>{this.errorCallback(U),this.rejected=!0,H()})}cancel(){new Promise(U=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=$;var Q;(function(W){async function U(H){let G;const ue=await Promise.all(H.map(q=>q.then(le=>le,le=>{G||(G=le)})));if(typeof G!="undefined")throw G;return ue}W.settled=U})(Q=e.Promises||(e.Promises={}))}),define(be[108],Ee([0,1,14,17]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new h.IdleValue(()=>{const R=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:R,collatorIsNumeric:R.resolvedOptions().numeric}}),T=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(R,p,D=!1){const c=R||"",A=p||"",O=b.value.collator.compare(c,A);return b.value.collatorIsNumeric&&O===0&&c!==A?c<A?-1:1:O}e.compareFileNames=C;function _(R,p){const D=T.value.collator;return R=R||"",p=p||"",k(D,R,p)}e.compareFileNamesDefault=_;function P(R,p){const D=T.value.collator;return R=R||"",p=p||"",o(R,p)||k(D,R,p)}e.compareFileNamesUpper=P;function t(R,p){const D=T.value.collator;return R=R||"",p=p||"",r(R,p)||k(D,R,p)}e.compareFileNamesLower=t;function E(R,p){return R=R||"",p=p||"",R===p?0:R<p?-1:1}e.compareFileNamesUnicode=E;function n(R,p,D=!1){D||(R=R&&R.toLowerCase(),p=p&&p.toLowerCase());const[c,A]=a(R),[O,z]=a(p);return c!==O?c<O?-1:1:A===z?0:A<z?-1:1}e.noIntlCompareFileNames=n;function f(R,p){const[D,c]=a(R),[A,O]=a(p);let z=b.value.collator.compare(c,O);if(z===0){if(b.value.collatorIsNumeric&&c!==O)return c<O?-1:1;if(z=b.value.collator.compare(D,A),b.value.collatorIsNumeric&&z===0&&D!==A)return D<A?-1:1}return z}e.compareFileExtensions=f;function l(R,p){R=R||"",p=p||"";const D=m(R),c=m(p),A=T.value.collator,O=F.value.collator;return k(O,D,c)||k(A,R,p)}e.compareFileExtensionsDefault=l;function s(R,p){R=R||"",p=p||"";const D=m(R),c=m(p),A=T.value.collator,O=F.value.collator;return k(O,D,c)||o(R,p)||k(A,R,p)}e.compareFileExtensionsUpper=s;function v(R,p){R=R||"",p=p||"";const D=m(R),c=m(p),A=T.value.collator,O=F.value.collator;return k(O,D,c)||r(R,p)||k(A,R,p)}e.compareFileExtensionsLower=v;function I(R,p){R=R||"",p=p||"";const D=m(R).toLowerCase(),c=m(p).toLowerCase();return D!==c?D<c?-1:1:R!==p?R<p?-1:1:0}e.compareFileExtensionsUnicode=I;const y=/^(.*?)(\.([^.]*))?$/;function a(R,p=!1){const D=R?y.exec(R):[];let c=[D&&D[1]||"",D&&D[3]||""];return p&&(!c[0]&&c[1]||c[0]&&c[0].charAt(0)===".")&&(c=[c[0]+"."+c[1],""]),c}function m(R){const p=R?y.exec(R):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function k(R,p,D){let c=R.compare(p,D);return c!==0?c:p.length!==D.length?p.length<D.length?-1:1:0}function i(R){const p=R.charAt(0);return p.toLocaleUpperCase()!==p}function u(R){const p=R.charAt(0);return p.toLocaleLowerCase()!==p}function r(R,p){return i(R)&&u(p)?-1:u(R)&&i(p)?1:0}function o(R,p){return u(R)&&i(p)?-1:i(R)&&u(p)?1:0}function w(R,p,D=!1){return D||(R=R&&R.toLowerCase(),p=p&&p.toLowerCase()),R===p?0:R<p?-1:1}function d(R,p,D=!1){const c=R.split(M.sep),A=p.split(M.sep),O=c.length-1,z=A.length-1;let K,$;for(let Q=0;;Q++){if(K=O===Q,$=z===Q,K&&$)return C(c[Q],A[Q],D);if(K)return-1;if($)return 1;const W=w(c[Q],A[Q],D);if(W!==0)return W}}e.comparePaths=d;function g(R,p,D){const c=R.toLowerCase(),A=p.toLowerCase(),O=S(R,p,D);if(O)return O;const z=c.endsWith(D),K=A.endsWith(D);if(z!==K)return z?-1:1;const $=C(c,A);return $!==0?$:c.localeCompare(A)}e.compareAnything=g;function S(R,p,D){const c=R.toLowerCase(),A=p.toLowerCase(),O=c.startsWith(D),z=A.startsWith(D);if(O!==z)return O?-1:1;if(O&&z){if(c.length<A.length)return-1;if(c.length>A.length)return 1}return 0}e.compareByPrefix=S}),define(be[27],Ee([0,1,14,41,20,17,9]),function(ie,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const _="**",P="/",t="[/\\\\]",E="[^/\\\\]",n=/\//g;function f(G){switch(G){case 0:return"";case 1:return`${E}*?`;default:return`(?:${t}|${E}+${t}|${t}${E}+)*?`}}function l(G,ue){if(!G)return[];const q=[];let le=!1,se=!1,ve="";for(const Fe of G){switch(Fe){case ue:if(!le&&!se){q.push(ve),ve="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":se=!0;break;case"]":se=!1;break}ve+=Fe}return ve&&q.push(ve),q}e.splitGlobAware=l;function s(G){if(!G)return"";let ue="";const q=l(G,P);if(q.every(le=>le===_))ue=".*";else{let le=!1;q.forEach((se,ve)=>{if(se===_){le||(ue+=f(2),le=!0);return}let Fe=!1,Me="",Ne=!1,Qe="";for(const ze of se){if(ze!=="}"&&Fe){Me+=ze;continue}if(Ne&&(ze!=="]"||!Qe)){let qe;ze==="-"?qe=ze:(ze==="^"||ze==="!")&&!Qe?qe="^":ze===P?qe="":qe=F.escapeRegExpCharacters(ze),Qe+=qe;continue}switch(ze){case"{":Fe=!0;continue;case"[":Ne=!0;continue;case"}":ue+=`(?:${l(Me,",").map(Y=>s(Y)).join("|")})`,Fe=!1,Me="";break;case"]":ue+="["+Qe+"]",Ne=!1,Qe="";break;case"?":ue+=E;continue;case"*":ue+=f(1);continue;default:ue+=F.escapeRegExpCharacters(ze)}}ve<q.length-1&&(q[ve+1]!==_||ve+2<q.length)&&(ue+=t),le=!1})}return ue}const v=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new b.LRUCache(1e4),u=function(){return!1},r=function(){return null};function o(G,ue){if(!G)return r;let q;typeof G!="string"?q=G.pattern:q=G,q=q.trim();const le=`${q}_${!!ue.trimForExclusions}`;let se=i.get(le);if(se)return w(se,G);let ve;if(v.test(q)){const Fe=q.substr(4);se=function(Me,Ne){return typeof Me=="string"&&Me.endsWith(Fe)?q:null}}else(ve=I.exec(d(q,ue)))?se=g(ve[1],q):(ue.trimForExclusions?a:y).test(q)?se=S(q,ue):(ve=m.exec(d(q,ue)))?se=R(ve[1].substr(1),q,!0):(ve=k.exec(d(q,ue)))?se=R(ve[1],q,!1):se=p(q);return i.set(le,se),w(se,G)}function w(G,ue){return typeof ue=="string"?G:function(q,le){return M.isEqualOrParent(q,ue.base)?G(T.relative(ue.base,q),le):null}}function d(G,ue){return ue.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function g(G,ue){const q=`/${G}`,le=`\\${G}`,se=function(Fe,Me){return typeof Fe!="string"?null:Me?Me===G?ue:null:Fe===G||Fe.endsWith(q)||Fe.endsWith(le)?ue:null},ve=[G];return se.basenames=ve,se.patterns=[ue],se.allBasenames=ve,se}function S(G,ue){const q=H(G.slice(1,-1).split(",").map(Me=>o(Me,ue)).filter(Me=>Me!==r),G),le=q.length;if(!le)return r;if(le===1)return q[0];const se=function(Me,Ne){for(let Qe=0,ze=q.length;Qe<ze;Qe++)if(q[Qe](Me,Ne))return G;return null},ve=q.find(Me=>!!Me.allBasenames);ve&&(se.allBasenames=ve.allBasenames);const Fe=q.reduce((Me,Ne)=>Ne.allPaths?Me.concat(Ne.allPaths):Me,[]);return Fe.length&&(se.allPaths=Fe),se}function R(G,ue,q){const le=T.sep===T.posix.sep,se=le?G:G.replace(n,T.sep),ve=T.sep+se,Fe=T.posix.sep+G,Me=q?function(Ne,Qe){return typeof Ne=="string"&&(Ne===se||Ne.endsWith(ve)||!le&&(Ne===G||Ne.endsWith(Fe)))?ue:null}:function(Ne,Qe){return typeof Ne=="string"&&(Ne===se||!le&&Ne===G)?ue:null};return Me.allPaths=[(q?"*/":"./")+G],Me}function p(G){try{const ue=new RegExp(`^${s(G)}$`);return function(q){return ue.lastIndex=0,typeof q=="string"&&ue.test(q)?G:null}}catch(ue){return r}}function D(G,ue,q){return!G||typeof ue!="string"?!1:c(G)(ue,void 0,q)}e.match=D;function c(G,ue={}){if(!G)return u;if(typeof G=="string"||K(G)){const q=o(G,ue);if(q===r)return u;const le=function(se,ve){return!!q(se,ve)};return q.allBasenames&&(le.allBasenames=q.allBasenames),q.allPaths&&(le.allPaths=q.allPaths),le}return W(G,ue)}e.parse=c;function A(G){if(!G)return;let ue;return q=>(ue||(ue=(G()||Promise.resolve([])).then(le=>le?z(le):{})),ue.then(le=>!!le[q]))}e.hasSiblingPromiseFn=A;function O(G){if(!G)return;let ue;return q=>{if(!ue){const le=G();ue=le?z(le):{}}return!!ue[q]}}e.hasSiblingFn=O;function z(G){const ue={};for(const q of G)ue[q]=!0;return ue}function K(G){const ue=G;return ue&&typeof ue.base=="string"&&typeof ue.pattern=="string"}e.isRelativePattern=K;function $(G){return G.allBasenames||[]}e.getBasenameTerms=$;function Q(G){return G.allPaths||[]}e.getPathTerms=Q;function W(G,ue){const q=H(Object.getOwnPropertyNames(G).map(Me=>U(Me,G[Me],ue)).filter(Me=>Me!==r)),le=q.length;if(!le)return r;if(!q.some(Me=>!!Me.requiresSiblings)){if(le===1)return q[0];const Me=function(ze,qe){for(let x=0,Y=q.length;x<Y;x++){const ee=q[x](ze,qe);if(ee)return ee}return null},Ne=q.find(ze=>!!ze.allBasenames);Ne&&(Me.allBasenames=Ne.allBasenames);const Qe=q.reduce((ze,qe)=>qe.allPaths?ze.concat(qe.allPaths):ze,[]);return Qe.length&&(Me.allPaths=Qe),Me}const se=function(Me,Ne,Qe){let ze;for(let qe=0,x=q.length;qe<x;qe++){const Y=q[qe];Y.requiresSiblings&&Qe&&(Ne||(Ne=T.basename(Me)),ze||(ze=Ne.substr(0,Ne.length-T.extname(Me).length)));const ee=Y(Me,Ne,ze,Qe);if(ee)return ee}return null},ve=q.find(Me=>!!Me.allBasenames);ve&&(se.allBasenames=ve.allBasenames);const Fe=q.reduce((Me,Ne)=>Ne.allPaths?Me.concat(Ne.allPaths):Me,[]);return Fe.length&&(se.allPaths=Fe),se}function U(G,ue,q){if(ue===!1)return r;const le=o(G,q);if(le===r)return r;if(typeof ue=="boolean")return le;if(ue){const se=ue.when;if(typeof se=="string"){const ve=(Fe,Me,Ne,Qe)=>{if(!Qe||!le(Fe,Me))return null;const ze=se.replace("$(basename)",Ne),qe=Qe(ze);return(0,h.isThenable)(qe)?qe.then(x=>x?G:null):qe?G:null};return ve.requiresSiblings=!0,ve}}return le}function H(G,ue){const q=G.filter(Me=>!!Me.basenames);if(q.length<2)return G;const le=q.reduce((Me,Ne)=>{const Qe=Ne.basenames;return Qe?Me.concat(Qe):Me},[]);let se;if(ue){se=[];for(let Me=0,Ne=le.length;Me<Ne;Me++)se.push(ue)}else se=q.reduce((Me,Ne)=>{const Qe=Ne.patterns;return Qe?Me.concat(Qe):Me},[]);const ve=function(Me,Ne){if(typeof Me!="string")return null;if(!Ne){let ze;for(ze=Me.length;ze>0;ze--){const qe=Me.charCodeAt(ze-1);if(qe===47||qe===92)break}Ne=Me.substr(ze)}const Qe=le.indexOf(Ne);return Qe!==-1?se[Qe]:null};ve.basenames=le,ve.patterns=se,ve.allBasenames=le;const Fe=G.filter(Me=>!Me.basenames);return Fe.push(ve),Fe}}),define(be[77],Ee([0,1,41,11,17,26,24,9,2]),function(ie,e,h,M,b,T,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(o,w,d){if(typeof o=="string"&&(o=_.URI.file(o)),d){const S=d.getWorkspaceFolder(o);if(S){const R=d.getWorkspace().folders.length>1;let p;if((0,F.isEqual)(S.uri,o)?p="":p=(0,F.relativePath)(S.uri,o),R){const D=S.name?S.name:(0,F.basename)(S.uri);p=p?D+" \u2022 "+p:D}return p}}if(o.scheme!==M.Schemas.file&&o.scheme!==M.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,h.hasDriveLetter)(o.fsPath))return(0,b.normalize)(E(o.fsPath));let g=(0,b.normalize)(o.fsPath);return!T.isWindows&&w?.userHome&&(g=f(g,w.userHome.fsPath)),g}e.getPathLabel=P;function t(o){if(!o)return;typeof o=="string"&&(o=_.URI.file(o));const w=(0,F.basename)(o)||(o.scheme===M.Schemas.file?o.fsPath:o.path);return T.isWindows&&(0,h.isRootOrDriveLetter)(w)?E(w):w}e.getBaseLabel=t;function E(o){return(0,h.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=E;let n=Object.create(null);function f(o,w){if(T.isWindows||!o||!w)return o;let d=n.original===w?n.normalized:void 0;return d||(d=`${(0,C.rtrim)(w,b.posix.sep)}${b.posix.sep}`,n={original:w,normalized:d}),(T.isLinux?o.startsWith(d):(0,C.startsWithIgnoreCase)(o,d))&&(o=`~/${o.substr(d.length)}`),o}e.tildify=f;function l(o,w){return o.replace(/^~($|\/|\\)/,`${w}$1`)}e.untildify=l;const s="\u2026",v="\\\\",I="~";function y(o,w=b.sep){const d=new Array(o.length);let g=!1;for(let S=0;S<o.length;S++){let R=o[S];if(R===""){d[S]=`.${w}`;continue}if(!R){d[S]=R;continue}g=!0;let p="";R.indexOf(v)===0?(p=R.substr(0,R.indexOf(v)+v.length),R=R.substr(R.indexOf(v)+v.length)):R.indexOf(w)===0?(p=R.substr(0,R.indexOf(w)+w.length),R=R.substr(R.indexOf(w)+w.length)):R.indexOf(I)===0&&(p=R.substr(0,R.indexOf(I)+I.length),R=R.substr(R.indexOf(I)+I.length));const D=R.split(w);for(let c=1;g&&c<=D.length;c++)for(let A=D.length-c;g&&A>=0;A--){g=!1;let O=D.slice(A,A+c).join(w);for(let z=0;!g&&z<o.length;z++)if(z!==S&&o[z]&&o[z].indexOf(O)>-1){const K=A+c===D.length,$=A>0&&o[z].indexOf(w)>-1?w+O:O,Q=o[z].endsWith($);g=!K||Q}if(!g){let z="";(D[0].endsWith(":")||p!=="")&&(A===1&&(A=0,c++,O=D[0]+w+O),A>0&&(z=D[0]+w),z=p+z),A>0&&(z=z+s+w),z=z+O,A+c<D.length&&(z=z+w+s),d[S]=z}}g&&(d[S]=R)}return d}e.shorten=y;var a;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function m(o,w=Object.create(null)){const d=[];let g=!1,S="";for(const R of o)if(R==="$"||g&&R==="{")S&&d.push({value:S,type:a.TEXT}),S="",g=!0;else if(R==="}"&&g){const p=w[S];if(typeof p=="string")p.length&&d.push({value:p,type:a.VARIABLE});else if(p){const D=d[d.length-1];(!D||D.type!==a.SEPARATOR)&&d.push({value:p.label,type:a.SEPARATOR})}S="",g=!1}else S+=R;return S&&!g&&d.push({value:S,type:a.TEXT}),d.filter((R,p)=>{if(R.type===a.SEPARATOR){const D=d[p-1],c=d[p+1];return[D,c].every(A=>A&&(A.type===a.VARIABLE||A.type===a.TEXT)&&A.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=m;function k(o,w){return T.isMacintosh||w?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):o.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=k;function i(o,w){return T.isMacintosh||w?o.replace(/\(&&\w\)|&&/g,""):T.isWindows?o.replace(/&&|&/g,d=>d==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function u(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=u;function r(o){const w=o.indexOf("/")!==-1?b.posix:b.win32,d=w.basename(o),g=w.dirname(o);return d.length?{name:d,parentPath:g}:{name:g,parentPath:""}}e.splitName=r}),define(be[78],Ee([0,1,27,11,17,24,9]),function(ie,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(o){o.text="text/plain",o.binary="application/octet-stream",o.unknown="application/unknown",o.markdown="text/markdown"})(C=e.Mimes||(e.Mimes={}));let _=[],P=[],t=[];function E(o,w=!1){const d=n(o);_.push(d),d.userConfigured?t.push(d):P.push(d),w&&!d.userConfigured&&_.forEach(g=>{g.mime===d.mime||g.userConfigured||(d.extension&&g.extension===d.extension&&console.warn(`Overwriting extension <<${d.extension}>> to now point to mime <<${d.mime}>>`),d.filename&&g.filename===d.filename&&console.warn(`Overwriting filename <<${d.filename}>> to now point to mime <<${d.mime}>>`),d.filepattern&&g.filepattern===d.filepattern&&console.warn(`Overwriting filepattern <<${d.filepattern}>> to now point to mime <<${d.mime}>>`),d.firstline&&g.firstline===d.firstline&&console.warn(`Overwriting firstline <<${d.firstline}>> to now point to mime <<${d.mime}>>`))})}e.registerTextMime=E;function n(o){return{id:o.id,mime:o.mime,filename:o.filename,extension:o.extension,filepattern:o.filepattern,firstline:o.firstline,userConfigured:o.userConfigured,filenameLowercase:o.filename?o.filename.toLowerCase():void 0,extensionLowercase:o.extension?o.extension.toLowerCase():void 0,filepatternLowercase:o.filepattern?(0,h.parse)(o.filepattern.toLowerCase()):void 0,filepatternOnPath:o.filepattern?o.filepattern.indexOf(b.posix.sep)>=0:!1}}function f(o){o?(_=_.filter(w=>!w.userConfigured),t=[]):(_=[],P=[],t=[])}e.clearTextMimes=f;function l(o,w){let d;if(o)switch(o.scheme){case M.Schemas.file:d=o.fsPath;break;case M.Schemas.data:d=T.DataUri.parseMetaData(o).get(T.DataUri.META_DATA_LABEL);break;default:d=o.path}if(!d)return[C.unknown];d=d.toLowerCase();const g=(0,b.basename)(d),S=s(d,g,t);if(S)return[S,C.text];const R=s(d,g,P);if(R)return[R,C.text];if(w){const p=v(w);if(p)return[p,C.text]}return[C.unknown]}e.guessMimeTypes=l;function s(o,w,d){let g=null,S=null,R=null;for(let p=d.length-1;p>=0;p--){const D=d[p];if(w===D.filenameLowercase){g=D;break}if(D.filepattern&&(!S||D.filepattern.length>S.filepattern.length)){const c=D.filepatternOnPath?o:w;D.filepatternLowercase?.(c)&&(S=D)}D.extension&&(!R||D.extension.length>R.extension.length)&&w.endsWith(D.extensionLowercase)&&(R=D)}return g?g.mime:S?S.mime:R?R.mime:null}function v(o){if((0,F.startsWithUTF8BOM)(o)&&(o=o.substr(1)),o.length>0)for(let w=_.length-1;w>=0;w--){const d=_[w];if(!d.firstline)continue;const g=o.match(d.firstline);if(g&&g.length>0)return d.mime}return null}function I(o){return o?typeof o=="string"?o===C.binary||o===C.text||o===C.unknown:o.length===1&&I(o[0]):!0}e.isUnspecific=I;const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},a={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function m(o){const w=(0,b.extname)(o),d=y[w.toLowerCase()];return d!==void 0?d:k(o)}e.getMediaOrTextMime=m;function k(o){const w=(0,b.extname)(o);return a[w.toLowerCase()]}e.getMediaMime=k;function i(o){for(const w in a)if(a[w]===o)return w}e.getExtensionForMimeType=i;const u=/^(.+)\/(.+?)(;.+)?$/;function r(o,w){const d=u.exec(o);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:w?void 0:o}e.normalizeMimeType=r}),define(be[109],Ee([0,1,2]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class b{constructor(E){this._uriTransformer=E}transformIncoming(E){const n=this._uriTransformer.transformIncoming(E);return n===E?E:M(h.URI.from(n))}transformOutgoing(E){const n=this._uriTransformer.transformOutgoing(E);return n===E?E:M(h.URI.from(n))}transformOutgoingURI(E){const n=this._uriTransformer.transformOutgoing(E);return n===E?E:h.URI.from(n)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function T(t,E,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof h.URI)return E.transformOutgoing(t);for(let f in t)if(Object.hasOwnProperty.call(t,f)){const l=T(t[f],E,n+1);l!==null&&(t[f]=l)}}return null}function F(t,E){const n=T(t,E,0);return n===null?t:n}e.transformOutgoingURIs=F;function C(t,E,n,f){if(!t||f>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?h.URI.revive(E.transformIncoming(t)):E.transformIncoming(t);for(let l in t)if(Object.hasOwnProperty.call(t,l)){const s=C(t[l],E,n,f+1);s!==null&&(t[l]=s)}}return null}function _(t,E){const n=C(t,E,!1,0);return n===null?t:n}e.transformIncomingURIs=_;function P(t,E){const n=C(t,E,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=P}),define(be[36],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const h=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(_){return h.test(_)}e.isUUID=M;const b=new Uint8Array(16),T=[];for(let _=0;_<256;_++)T.push(_.toString(16).padStart(2,"0"));let F;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?F=crypto.getRandomValues.bind(crypto):F=function(_){for(let P=0;P<_.length;P++)_[P]=Math.floor(Math.random()*256);return _};function C(){F(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let _=0,P="";return P+=T[b[_++]],P+=T[b[_++]],P+=T[b[_++]],P+=T[b[_++]],P+="-",P+=T[b[_++]],P+=T[b[_++]],P+="-",P+=T[b[_++]],P+=T[b[_++]],P+="-",P+=T[b[_++]],P+=T[b[_++]],P+="-",P+=T[b[_++]],P+=T[b[_++]],P+=T[b[_++]],P+=T[b[_++]],P+=T[b[_++]],P+=T[b[_++]],P}e.generateUuid=C}),define(be[110],Ee([0,1,227]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(F){F[F.Regular=0]="Regular",F[F.Whitespace=1]="Whitespace",F[F.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class b extends h.CharacterClassifier{constructor(C){super(0);for(let _=0,P=C.length;_<P;_++)this.set(C.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=b;function T(F){let C={};return _=>(C.hasOwnProperty(_)||(C[_]=F(_)),C[_])}e.getMapForWordSeparators=T(F=>new b(F))}),define(be[79],Ee([0,1,22]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var b;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(b=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var F;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(F=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class _{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace),this.bracketPairColorizationOptions=v.bracketPairColorizationOptions}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace&&(0,h.equals)(this.bracketPairColorizationOptions,v.bracketPairColorizationOptions)}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=_;class P{constructor(v,I){this._findMatchBrand=void 0,this.range=v,this.matches=I}}e.FindMatch=P;var t;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var E;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None"})(E=e.PositionAffinity||(e.PositionAffinity={}));var n;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(n=e.ModelConstants||(e.ModelConstants={}));class f{constructor(v,I,y,a,m,k){this.identifier=v,this.range=I,this.text=y,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=m,this._isTracked=k}}e.ValidAnnotatedEditOperation=f;class l{constructor(v,I,y){this.reverseEdits=v,this.changes=I,this.trimAutoWhitespaceLineNumbers=y}}e.ApplyEditsResult=l}),define(be[111],Ee([0,1,9,110,112,42,79]),function(ie,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class _{constructor(a,m,k,i){this.searchString=a,this.isRegex=m,this.matchCase=k,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=P(this.searchString):a=this.searchString.indexOf(`
`)>=0;let m=null;try{m=h.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(i){return null}if(!m)return null;let k=!this.isRegex&&!a;return k&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(k=this.matchCase),new t(m,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,k?this.searchString:null)}}e.SearchParams=_;function P(y){if(!y||y.length===0)return!1;for(let a=0,m=y.length;a<m;a++)if(y.charCodeAt(a)===92){if(a++,a>=m)break;const i=y.charCodeAt(a);if(i===110||i===114||i===87||i===119)return!0}return!1}e.isMultilineRegexSource=P;class t{constructor(a,m,k){this.regex=a,this.wordSeparators=m,this.simpleSearch=k}}e.SearchData=t;function E(y,a,m){if(!m)return new F.FindMatch(y,null);let k=[];for(let i=0,u=a.length;i<u;i++)k[i]=a[i];return new F.FindMatch(y,k)}e.createFindMatch=E;class n{constructor(a){let m=[],k=0;for(let i=0,u=a.length;i<u;i++)a.charCodeAt(i)===10&&(m[k++]=i);this._lineFeedsOffsets=m}findLineFeedCountBeforeOffset(a){const m=this._lineFeedsOffsets;let k=0,i=m.length-1;if(i===-1||a<=m[0])return 0;for(;k<i;){const u=k+((i-k)/2>>0);m[u]>=a?i=u-1:m[u+1]>=a?(k=u,i=u):k=u+1}return k+1}}class f{static findMatches(a,m,k,i,u){const r=m.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(a,k,new I(r.wordSeparators,r.regex),i,u):this._doFindMatchesLineByLine(a,k,r,i,u):[]}static _getMultilineMatchRange(a,m,k,i,u,r){let o,w=0;i?(w=i.findLineFeedCountBeforeOffset(u),o=m+u+w):o=m+u;let d;if(i){let p=i.findLineFeedCountBeforeOffset(u+r.length)-w;d=o+r.length+p}else d=o+r.length;const g=a.getPositionAt(o),S=a.getPositionAt(d);return new T.Range(g.lineNumber,g.column,S.lineNumber,S.column)}static _doFindMatchesMultiline(a,m,k,i,u){const r=a.getOffsetAt(m.getStartPosition()),o=a.getValueInRange(m,1),w=a.getEOL()===`\r
`?new n(o):null,d=[];let g=0,S;for(k.reset(0);S=k.next(o);)if(d[g++]=E(this._getMultilineMatchRange(a,r,o,w,S.index,S[0]),S,i),g>=u)return d;return d}static _doFindMatchesLineByLine(a,m,k,i,u){const r=[];let o=0;if(m.startLineNumber===m.endLineNumber){const d=a.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return o=this._findMatchesInLine(k,d,m.startLineNumber,m.startColumn-1,o,r,i,u),r}const w=a.getLineContent(m.startLineNumber).substring(m.startColumn-1);o=this._findMatchesInLine(k,w,m.startLineNumber,m.startColumn-1,o,r,i,u);for(let d=m.startLineNumber+1;d<m.endLineNumber&&o<u;d++)o=this._findMatchesInLine(k,a.getLineContent(d),d,0,o,r,i,u);if(o<u){const d=a.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);o=this._findMatchesInLine(k,d,m.endLineNumber,0,o,r,i,u)}return r}static _findMatchesInLine(a,m,k,i,u,r,o,w){const d=a.wordSeparators;if(!o&&a.simpleSearch){const R=a.simpleSearch,p=R.length,D=m.length;let c=-p;for(;(c=m.indexOf(R,c+p))!==-1;)if((!d||v(d,m,D,c,p))&&(r[u++]=new F.FindMatch(new T.Range(k,c+1+i,k,c+1+p+i),null),u>=w))return u;return u}const g=new I(a.wordSeparators,a.regex);let S;g.reset(0);do if(S=g.next(m),S&&(r[u++]=E(new T.Range(k,S.index+1+i,k,S.index+1+S[0].length+i),S,o),u>=w))return u;while(S);return u}static findNextMatch(a,m,k,i){const u=m.parseSearchRequest();if(!u)return null;const r=new I(u.wordSeparators,u.regex);return u.regex.multiline?this._doFindNextMatchMultiline(a,k,r,i):this._doFindNextMatchLineByLine(a,k,r,i)}static _doFindNextMatchMultiline(a,m,k,i){const u=new b.Position(m.lineNumber,1),r=a.getOffsetAt(u),o=a.getLineCount(),w=a.getValueInRange(new T.Range(u.lineNumber,u.column,o,a.getLineMaxColumn(o)),1),d=a.getEOL()===`\r
`?new n(w):null;k.reset(m.column-1);let g=k.next(w);return g?E(this._getMultilineMatchRange(a,r,w,d,g.index,g[0]),g,i):m.lineNumber!==1||m.column!==1?this._doFindNextMatchMultiline(a,new b.Position(1,1),k,i):null}static _doFindNextMatchLineByLine(a,m,k,i){const u=a.getLineCount(),r=m.lineNumber,o=a.getLineContent(r),w=this._findFirstMatchInLine(k,o,r,m.column,i);if(w)return w;for(let d=1;d<=u;d++){const g=(r+d-1)%u,S=a.getLineContent(g+1),R=this._findFirstMatchInLine(k,S,g+1,1,i);if(R)return R}return null}static _findFirstMatchInLine(a,m,k,i,u){a.reset(i-1);const r=a.next(m);return r?E(new T.Range(k,r.index+1,k,r.index+1+r[0].length),r,u):null}static findPreviousMatch(a,m,k,i){const u=m.parseSearchRequest();if(!u)return null;const r=new I(u.wordSeparators,u.regex);return u.regex.multiline?this._doFindPreviousMatchMultiline(a,k,r,i):this._doFindPreviousMatchLineByLine(a,k,r,i)}static _doFindPreviousMatchMultiline(a,m,k,i){const u=this._doFindMatchesMultiline(a,new T.Range(1,1,m.lineNumber,m.column),k,i,10*C);if(u.length>0)return u[u.length-1];const r=a.getLineCount();return m.lineNumber!==r||m.column!==a.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(a,new b.Position(r,a.getLineMaxColumn(r)),k,i):null}static _doFindPreviousMatchLineByLine(a,m,k,i){const u=a.getLineCount(),r=m.lineNumber,o=a.getLineContent(r).substring(0,m.column-1),w=this._findLastMatchInLine(k,o,r,i);if(w)return w;for(let d=1;d<=u;d++){const g=(u+r-d-1)%u,S=a.getLineContent(g+1),R=this._findLastMatchInLine(k,S,g+1,i);if(R)return R}return null}static _findLastMatchInLine(a,m,k,i){let u=null,r;for(a.reset(0);r=a.next(m);)u=E(new T.Range(k,r.index+1,k,r.index+1+r[0].length),r,i);return u}}e.TextModelSearch=f;function l(y,a,m,k,i){if(k===0)return!0;const u=a.charCodeAt(k-1);if(y.get(u)!==0||u===13||u===10)return!0;if(i>0){const r=a.charCodeAt(k);if(y.get(r)!==0)return!0}return!1}function s(y,a,m,k,i){if(k+i===m)return!0;const u=a.charCodeAt(k+i);if(y.get(u)!==0||u===13||u===10)return!0;if(i>0){const r=a.charCodeAt(k+i-1);if(y.get(r)!==0)return!0}return!1}function v(y,a,m,k,i){return l(y,a,m,k,i)&&s(y,a,m,k,i)}e.isValidMatch=v;class I{constructor(a,m){this._wordSeparators=a,this._searchRegex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const m=a.length;let k;do{if(this._prevMatchStartIndex+this._prevMatchLength===m||(k=this._searchRegex.exec(a),!k))return null;const i=k.index,u=k[0].length;if(i===this._prevMatchStartIndex&&u===this._prevMatchLength){if(u===0){h.getNextCodePoint(a,m,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=u,!this._wordSeparators||v(this._wordSeparators,a,m,i,u))return k}while(k);return null}}e.Searcher=I}),define(be[113],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var h;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(h=e.IndentAction||(e.IndentAction={}));class M{constructor(C){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let _=0,P=C.notIn.length;_<P;_++)switch(C.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=M;class b{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of C)T(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),T(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),T(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),T(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&T(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=b;function T(F,C,_){F.has(C)?F.get(C).push(_):F.set(C,[_])}}),define(be[55],Ee([0,1,27,17]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b(T,F,C,_){if(Array.isArray(T)){let P=0;for(const t of T){const E=b(t,F,C,_);if(E===10)return E;E>P&&(P=E)}return P}else{if(typeof T=="string")return _?T==="*"?5:T===C?10:0:0;if(T){const{language:P,pattern:t,scheme:E,hasAccessToAllModels:n}=T;if(!_&&!n)return 0;let f=0;if(E)if(E===F.scheme)f=10;else if(E==="*")f=5;else return 0;if(P)if(P===C)f=10;else if(P==="*")f=Math.max(f,5);else return 0;if(t){let l;if(typeof t=="string"?l=t:l={...t,base:(0,M.normalize)(t.base)},l===F.fsPath||(0,h.match)(l,F.fsPath))f=10;else return 0}return f}else return 0}}e.score=b}),define(be[114],Ee([0,1,3,6]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class b{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new h.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(F){this._onDidChange.fire({changedLanguages:F,changedColorMap:!1})}register(F,C){return this._map.set(F,C),this.fire([F]),(0,M.toDisposable)(()=>{this._map.get(F)===C&&(this._map.delete(F),this.fire([F]))})}registerPromise(F,C){let _=null,P=!1;return this._promises.set(F,C.then(t=>{this._promises.delete(F),!(P||!t)&&(_=this.register(F,t))})),(0,M.toDisposable)(()=>{P=!0,_&&_.dispose()})}getPromise(F){const C=this.get(F);if(C)return Promise.resolve(C);const _=this._promises.get(F);return _?_.then(P=>this.get(F)):null}get(F){return this._map.get(F)||null}setColorMap(F){this._colorMap=F,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=b}),define(be[80],Ee([0,1,23,26]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(b||(b={}));function T(E){for(let n=0,f=E.length;n<f;n+=4){const l=E[n+0],s=E[n+1],v=E[n+2],I=E[n+3];E[n+0]=I,E[n+1]=v,E[n+2]=s,E[n+3]=l}}function F(E){const n=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return M.isLittleEndian()||T(n),h.VSBuffer.wrap(n)}function C(E){const n=E.buffer;if(M.isLittleEndian()||T(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const f=new Uint8Array(n.byteLength);return f.set(n),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function _(E){const n=new Uint32Array(P(E));let f=0;if(n[f++]=E.id,E.type==="full")n[f++]=1,n[f++]=E.data.length,n.set(E.data,f),f+=E.data.length;else{n[f++]=2,n[f++]=E.deltas.length;for(const l of E.deltas)n[f++]=l.start,n[f++]=l.deleteCount,l.data?(n[f++]=l.data.length,n.set(l.data,f),f+=l.data.length):n[f++]=0}return F(n)}e.encodeSemanticTokensDto=_;function P(E){let n=0;if(n+=1+1,E.type==="full")n+=1+E.data.length;else{n+=1,n+=(1+1+1)*E.deltas.length;for(const f of E.deltas)f.data&&(n+=f.data.length)}return n}function t(E){const n=C(E);let f=0;const l=n[f++];if(n[f++]===1){const y=n[f++],a=n.subarray(f,f+y);return f+=y,{id:l,type:"full",data:a}}const v=n[f++];let I=[];for(let y=0;y<v;y++){const a=n[f++],m=n[f++],k=n[f++];let i;k>0&&(i=n.subarray(f,f+k),f+=k),I[y]={start:a,deleteCount:m,data:i}}return{id:l,type:"delta",deltas:I}}e.decodeSemanticTokensDto=t}),define(be[115],Ee([18,19]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(be[56],Ee([0,1,13,10,115]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(P,t){return t&&(P.stack||P.stacktrace)?b.localize(0,null,C(P),F(P.stack)||F(P.stacktrace)):C(P)}function F(P){return Array.isArray(P)?P.join(`
`):P}function C(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?b.localize(1,null,P.message):P.message||b.localize(2,null)}function _(P=null,t=!1){if(!P)return b.localize(3,null);if(Array.isArray(P)){const E=h.coalesce(P),n=_(E[0],t);return E.length>1?b.localize(4,null,n,E.length):n}if(M.isString(P))return P;if(P.detail){const E=P.detail;if(E.error)return T(E.error,t);if(E.exception)return T(E.exception,t)}return P.stack?T(P,t):P.message?P.message:b.localize(5,null)}e.toErrorMessage=_}),define(be[116],Ee([18,19]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(be[117],Ee([0,1,116,26,118]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=F;class C{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,he){this._values[J]=he}}e.ValidatedEditorOptions=C;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class P{constructor(J,he,Oe,Ve){this.id=J,this.name=he,this.defaultValue=Oe,this.schema=Ve}compute(J,he,Oe){return Oe}}class t{constructor(J,he=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=he}validate(J){return this.defaultValue}}class E{constructor(J,he,Oe,Ve){this.id=J,this.name=he,this.defaultValue=Oe,this.schema=Ve}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,he,Oe){return Oe}}function n(V,J){return typeof V=="undefined"?J:V==="false"?!1:Boolean(V)}e.boolean=n;class f extends E{constructor(J,he,Oe,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Oe),super(J,he,Oe,Ve)}validate(J){return n(J,this.defaultValue)}}class l extends E{constructor(J,he,Oe,Ve,tt,ut=void 0){typeof ut!="undefined"&&(ut.type="integer",ut.default=Oe,ut.minimum=Ve,ut.maximum=tt),super(J,he,Oe,ut),this.minimum=Ve,this.maximum=tt}static clampedInt(J,he,Oe,Ve){if(typeof J=="undefined")return he;let tt=parseInt(J,10);return isNaN(tt)?he:(tt=Math.max(Oe,tt),tt=Math.min(Ve,tt),tt|0)}validate(J){return l.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class s extends E{constructor(J,he,Oe,Ve,tt){typeof tt!="undefined"&&(tt.type="number",tt.default=Oe),super(J,he,Oe,tt),this.validationFn=Ve}static clamp(J,he,Oe){return J<he?he:J>Oe?Oe:J}static float(J,he){if(typeof J=="number")return J;if(typeof J=="undefined")return he;const Oe=parseFloat(J);return isNaN(Oe)?he:Oe}validate(J){return this.validationFn(s.float(J,this.defaultValue))}}class v extends E{static string(J,he){return typeof J!="string"?he:J}constructor(J,he,Oe,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Oe),super(J,he,Oe,Ve)}validate(J){return v.string(J,this.defaultValue)}}function I(V,J,he){return typeof V!="string"||he.indexOf(V)===-1?J:V}e.stringSet=I;class y extends E{constructor(J,he,Oe,Ve,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.enum=Ve,tt.default=Oe),super(J,he,Oe,tt),this._allowedValues=Ve}validate(J){return I(J,this.defaultValue,this._allowedValues)}}class a extends P{constructor(J,he,Oe,Ve,tt,ut,ht=void 0){typeof ht!="undefined"&&(ht.type="string",ht.enum=tt,ht.default=Ve),super(J,he,Oe,ht),this._allowedValues=tt,this._convert=ut}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function m(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class k extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",description:h.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,he,Oe){return Oe===0?J.accessibilitySupport:Oe}}class i extends P{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:h.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{insertSpace:n(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var u;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(u=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(o=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(V){switch(V){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function d(V){switch(V){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class g extends t{constructor(){super(127,[65,32])}compute(J,he,Oe){const Ve=["monaco-editor"];return he.get(32)&&Ve.push(he.get(32)),J.extraEditorClassName&&Ve.push(J.extraEditorClassName),he.get(65)==="default"?Ve.push("mouse-default"):he.get(65)==="copy"&&Ve.push("mouse-copy"),he.get(100)&&Ve.push("showUnused"),he.get(125)&&Ve.push("showDeprecated"),Ve.join(" ")}}class S extends f{constructor(){super(31,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(J,he,Oe){return Oe&&J.emptySelectionClipboard}}class R extends P{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:h.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:h.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{cursorMoveOnType:n(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":I(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":I(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(he.loop,this.defaultValue.loop)}}}class p extends P{constructor(){super(43,"fontLigatures",p.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?p.OFF:J==="true"?p.ON:J:Boolean(J)?p.ON:p.OFF}}e.EditorFontLigatures=p,p.OFF='"liga" off, "calt" off',p.ON='"liga" on, "calt" on';class D extends t{constructor(){super(42)}compute(J,he,Oe){return J.fontInfo}}class c extends E{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(22,null)})}validate(J){let he=s.float(J,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(he,6,100)}compute(J,he,Oe){return J.fontInfo.fontSize}}class A extends P{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:A.MINIMUM_VALUE,maximum:A.MAXIMUM_VALUE,errorMessage:h.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:A.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(l.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,A.MINIMUM_VALUE,A.MAXIMUM_VALUE))}}A.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],A.MINIMUM_VALUE=1,A.MAXIMUM_VALUE=1e3;class O extends P{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[h.localize(25,null),h.localize(26,null),h.localize(27,null)]},Oe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:h.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:h.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:h.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Oe,description:h.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Oe,description:h.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Oe,description:h.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Oe,description:h.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Oe,description:h.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{multiple:I(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??I(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??I(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??I(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??I(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??I(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends P{constructor(){const J={enabled:!0,delay:300,sticky:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:h.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:h.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:h.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),delay:l.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:n(he.sticky,this.defaultValue.sticky)}}}var K;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(K=e.RenderMinimap||(e.RenderMinimap={}));class $ extends t{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(J,he,Oe){return $.computeLayout(he,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const he=J.height/J.lineHeight,Oe=J.scrollBeyondLastLine?he-1:0,Ve=(J.viewLineCount+Oe)/(J.pixelRatio*J.height),tt=Math.floor(J.viewLineCount/Ve);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Oe,desiredRatio:Ve,minimapLineCount:tt}}static _computeMinimapLayout(J,he){const Oe=J.outerWidth,Ve=J.outerHeight,tt=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const ut=he.stableMinimapLayoutInput,ht=ut&&J.outerHeight===ut.outerHeight&&J.lineHeight===ut.lineHeight&&J.typicalHalfwidthCharacterWidth===ut.typicalHalfwidthCharacterWidth&&J.pixelRatio===ut.pixelRatio&&J.scrollBeyondLastLine===ut.scrollBeyondLastLine&&J.minimap.enabled===ut.minimap.enabled&&J.minimap.side===ut.minimap.side&&J.minimap.size===ut.minimap.size&&J.minimap.showSlider===ut.minimap.showSlider&&J.minimap.renderCharacters===ut.minimap.renderCharacters&&J.minimap.maxColumn===ut.minimap.maxColumn&&J.minimap.scale===ut.minimap.scale&&J.verticalScrollbarWidth===ut.verticalScrollbarWidth&&J.isViewportWrapping===ut.isViewportWrapping,St=J.lineHeight,Pt=J.typicalHalfwidthCharacterWidth,dt=J.scrollBeyondLastLine,bt=J.minimap.renderCharacters;let ft=tt>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Et=J.minimap.maxColumn,Ye=J.minimap.size,Ct=J.minimap.side,Pe=J.verticalScrollbarWidth,ye=J.viewLineCount,De=J.remainingWidth,Z=J.isViewportWrapping,ce=bt?2:3;let ge=Math.floor(tt*Ve);const me=ge/tt;let Ie=!1,Be=!1,Le=ce*ft,je=ft/tt,Xe=1;if(Ye==="fill"||Ye==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeyondLastLine:We,desiredRatio:it,minimapLineCount:mt}=$.computeContainedMinimapLineCount({viewLineCount:ye,scrollBeyondLastLine:dt,height:Ve,lineHeight:St,pixelRatio:tt});if(ye/mt>1)Ie=!0,Be=!0,ft=1,Le=1,je=ft/tt;else{let nt=!1,ot=ft+1;if(Ye==="fit"){const lt=Math.ceil((ye+We)*Le);Z&&ht&&De<=he.stableFitRemainingWidth?(nt=!0,ot=he.stableFitMaxMinimapScale):nt=lt>ge}if(Ye==="fill"||nt){Ie=!0;const lt=ft;Le=Math.min(St*tt,Math.max(1,Math.floor(1/it))),Z&&ht&&De<=he.stableFitRemainingWidth&&(ot=he.stableFitMaxMinimapScale),ft=Math.min(ot,Math.max(1,Math.floor(Le/ce))),ft>lt&&(Xe=Math.min(2,ft/lt)),je=ft/tt/Xe,ge=Math.ceil(Math.max(Ge,ye+We)*Le),Z?(he.stableMinimapLayoutInput=J,he.stableFitRemainingWidth=De,he.stableFitMaxMinimapScale=ft):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const ne=Math.floor(Et*je),pe=Math.min(ne,Math.max(0,Math.floor((De-Pe-2)*je/(Pt+je)))+e.MINIMAP_GUTTER_WIDTH);let re=Math.floor(tt*pe);const B=re/tt;re=Math.floor(re*Xe);const Ce=bt?1:2,Se=Ct==="left"?0:Oe-pe-Pe;return{renderMinimap:Ce,minimapLeft:Se,minimapWidth:pe,minimapHeightIsEditorHeight:Ie,minimapIsSampling:Be,minimapScale:ft,minimapLineHeight:Le,minimapCanvasInnerWidth:re,minimapCanvasInnerHeight:ge,minimapCanvasOuterWidth:B,minimapCanvasOuterHeight:me}}static computeLayout(J,he){const Oe=he.outerWidth|0,Ve=he.outerHeight|0,tt=he.lineHeight|0,ut=he.lineNumbersDigitCount|0,ht=he.typicalHalfwidthCharacterWidth,St=he.maxDigitWidth,Pt=he.pixelRatio,dt=he.viewLineCount,bt=J.get(122),ft=bt==="inherit"?J.get(121):bt,Et=ft==="inherit"?J.get(117):ft,Ye=J.get(120),Ct=J.get(2),Pe=he.isDominatedByLongLines,ye=J.get(48),De=J.get(59).renderType!==0,Z=J.get(60),ce=J.get(94),ge=J.get(64),me=J.get(92),Ie=me.verticalScrollbarSize,Be=me.verticalHasArrows,Le=me.arrowSize,je=me.horizontalScrollbarSize,Xe=J.get(57),ne=J.get(36);let pe;if(typeof Xe=="string"&&/^\d+(\.\d+)?ch$/.test(Xe)){const Ot=parseFloat(Xe.substr(0,Xe.length-2));pe=l.clampedInt(Ot*ht,0,0,1e3)}else pe=l.clampedInt(Xe,0,0,1e3);ne&&(pe+=16);let re=0;if(De){const Ot=Math.max(ut,Z);re=Math.round(Ot*St)}let B=0;ye&&(B=tt);let Ce=0,Se=Ce+B,Ge=Se+re,We=Ge+pe;const it=Oe-B-re-pe;let mt=!1,vt=!1,nt=-1;Ct!==2&&(ft==="inherit"&&Pe?(mt=!0,vt=!0):Et==="on"||Et==="bounded"?vt=!0:Et==="wordWrapColumn"&&(nt=Ye));const ot=$._computeMinimapLayout({outerWidth:Oe,outerHeight:Ve,lineHeight:tt,typicalHalfwidthCharacterWidth:ht,pixelRatio:Pt,scrollBeyondLastLine:ce,minimap:ge,verticalScrollbarWidth:Ie,viewLineCount:dt,remainingWidth:it,isViewportWrapping:vt},he.memory||new _);ot.renderMinimap!==0&&ot.minimapLeft===0&&(Ce+=ot.minimapWidth,Se+=ot.minimapWidth,Ge+=ot.minimapWidth,We+=ot.minimapWidth);const lt=it-ot.minimapWidth,Rt=Math.max(1,Math.floor((lt-Ie-2)/ht)),_t=Be?Le:0;return vt&&(nt=Math.max(1,Rt),Et==="bounded"&&(nt=Math.min(nt,Ye))),{width:Oe,height:Ve,glyphMarginLeft:Ce,glyphMarginWidth:B,lineNumbersLeft:Se,lineNumbersWidth:re,decorationsLeft:Ge,decorationsWidth:pe,contentLeft:We,contentWidth:lt,minimap:ot,viewportColumn:Rt,isWordWrapMinified:mt,isViewportWrapping:vt,wrappingColumn:nt,verticalScrollbarWidth:Ie,horizontalScrollbarHeight:je,overviewRuler:{top:_t,width:Ie,height:Ve-2*_t,right:0}}}}e.EditorLayoutInfoComputer=$;class Q extends P{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:h.localize(42,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class W extends P{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:h.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:h.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:h.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(he.fontFamily,this.defaultValue.fontFamily)}}}class U extends s{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>s.clamp(J,0,150),{markdownDescription:h.localize(46,null)})}compute(J,he,Oe){return J.fontInfo.lineHeight}}class H extends P{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:h.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(48,null),h.localize(49,null),h.localize(50,null)],default:J.size,description:h.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:h.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:h.localize(53,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:h.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:h.localize(56,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),size:I(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:I(he.side,this.defaultValue.side,["right","left"]),showSlider:I(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(he.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(he.scale,1,1,3),maxColumn:l.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function G(V){return V==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ue extends P{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(58,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{top:l.clampedInt(he.top,0,0,1e3),bottom:l.clampedInt(he.bottom,0,0,1e3)}}}class q extends P{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:h.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:h.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),cycle:n(he.cycle,this.defaultValue.cycle)}}}class le extends t{constructor(){super(128)}compute(J,he,Oe){return J.pixelRatio}}class se extends P{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:h.localize(61,null)},comments:{type:"boolean",default:J.comments,description:h.localize(62,null)},other:{type:"boolean",default:J.other,description:h.localize(63,null)}}}],default:J,description:h.localize(64,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const he=J,Oe={other:n(he.other,this.defaultValue.other),comments:n(he.comments,this.defaultValue.comments),strings:n(he.strings,this.defaultValue.strings)};return Oe.other&&Oe.comments&&Oe.strings?!0:!Oe.other&&!Oe.comments&&!Oe.strings?!1:Oe}return this.defaultValue}}var ve;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Fe extends P{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(65,null),h.localize(66,null),h.localize(67,null),h.localize(68,null)],default:"on",description:h.localize(69,null)})}validate(J){let he=this.defaultValue.renderType,Oe=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(he=4,Oe=J):J==="interval"?he=3:J==="relative"?he=2:J==="on"?he=1:he=0),{renderType:he,renderFn:Oe}}}function Me(V){const J=V.get(87);return J==="editable"?V.get(80):J!=="on"}e.filterValidationDecorations=Me;class Ne extends P{constructor(){const J=[],he={type:"number",description:h.localize(70,null)};super(91,"rulers",J,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:h.localize(71,null),format:"color-hex"}}}]},default:J,description:h.localize(72,null)})}validate(J){if(Array.isArray(J)){let he=[];for(let Oe of J)if(typeof Oe=="number")he.push({column:l.clampedInt(Oe,0,0,1e4),color:null});else if(Oe&&typeof Oe=="object"){const Ve=Oe;he.push({column:l.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return he.sort((Oe,Ve)=>Oe.column-Ve.column),he}return this.defaultValue}}function Qe(V,J){if(typeof V!="string")return J;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends P{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(73,null),h.localize(74,null),h.localize(75,null)],default:"auto",description:h.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(77,null),h.localize(78,null),h.localize(79,null)],default:"auto",description:h.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:h.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:h.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:h.localize(83,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J,Oe=l.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=l.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Qe(he.vertical,this.defaultValue.vertical),horizontal:Qe(he.horizontal,this.defaultValue.horizontal),useShadows:n(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Oe,horizontalSliderSize:l.clampedInt(he.horizontalSliderSize,Oe,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:l.clampedInt(he.verticalSliderSize,Ve,0,1e3),scrollByPage:n(he.scrollByPage,this.defaultValue.scrollByPage)}}}class qe extends P{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:h.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[h.localize(85,null),h.localize(86,null),h.localize(87,null)],default:J.mode,description:h.localize(88,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),mode:I(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class x extends P{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:h.localize(89,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class Y extends P{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(90,null),h.localize(91,null)],default:J.insertMode,description:h.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:h.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:h.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:h.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:h.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:h.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:h.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:h.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[h.localize(100,null),h.localize(101,null),h.localize(102,null)],default:J.previewMode,description:h.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:h.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(135,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{insertMode:I(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(he.showIcons,this.defaultValue.showIcons),showStatusBar:n(he.showStatusBar,this.defaultValue.showStatusBar),preview:n(he.preview,this.defaultValue.preview),previewMode:I(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(he.showMethods,this.defaultValue.showMethods),showFunctions:n(he.showFunctions,this.defaultValue.showFunctions),showConstructors:n(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(he.showDeprecated,this.defaultValue.showDeprecated),showFields:n(he.showFields,this.defaultValue.showFields),showVariables:n(he.showVariables,this.defaultValue.showVariables),showClasses:n(he.showClasses,this.defaultValue.showClasses),showStructs:n(he.showStructs,this.defaultValue.showStructs),showInterfaces:n(he.showInterfaces,this.defaultValue.showInterfaces),showModules:n(he.showModules,this.defaultValue.showModules),showProperties:n(he.showProperties,this.defaultValue.showProperties),showEvents:n(he.showEvents,this.defaultValue.showEvents),showOperators:n(he.showOperators,this.defaultValue.showOperators),showUnits:n(he.showUnits,this.defaultValue.showUnits),showValues:n(he.showValues,this.defaultValue.showValues),showConstants:n(he.showConstants,this.defaultValue.showConstants),showEnums:n(he.showEnums,this.defaultValue.showEnums),showEnumMembers:n(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(he.showKeywords,this.defaultValue.showKeywords),showWords:n(he.showWords,this.defaultValue.showWords),showColors:n(he.showColors,this.defaultValue.showColors),showFiles:n(he.showFiles,this.defaultValue.showFiles),showReferences:n(he.showReferences,this.defaultValue.showReferences),showFolders:n(he.showFolders,this.defaultValue.showFolders),showTypeParameters:n(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(he.showSnippets,this.defaultValue.showSnippets),showUsers:n(he.showUsers,this.defaultValue.showUsers),showIssues:n(he.showIssues,this.defaultValue.showIssues)}}}class ee extends P{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(136,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ae extends t{constructor(){super(129,[80])}compute(J,he,Oe){return he.get(80)?!0:J.tabFocusMode}}var j;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(j=e.WrappingIndent||(e.WrappingIndent={}));function oe(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class fe extends t{constructor(){super(131,[130])}compute(J,he,Oe){const Ve=he.get(130);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const Ae="Consolas, 'Courier New', monospace",xe="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?xe:M.isLinux?$e:Ae,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function we(V){return e.editorOptionsRegistry[V.id]=V,V}var Ze;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.bracketPairColorization=12]="bracketPairColorization",V[V.codeLens=13]="codeLens",V[V.codeLensFontFamily=14]="codeLensFontFamily",V[V.codeLensFontSize=15]="codeLensFontSize",V[V.colorDecorators=16]="colorDecorators",V[V.columnSelection=17]="columnSelection",V[V.comments=18]="comments",V[V.contextmenu=19]="contextmenu",V[V.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",V[V.cursorBlinking=21]="cursorBlinking",V[V.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",V[V.cursorStyle=23]="cursorStyle",V[V.cursorSurroundingLines=24]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",V[V.cursorWidth=26]="cursorWidth",V[V.disableLayerHinting=27]="disableLayerHinting",V[V.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",V[V.domReadOnly=29]="domReadOnly",V[V.dragAndDrop=30]="dragAndDrop",V[V.emptySelectionClipboard=31]="emptySelectionClipboard",V[V.extraEditorClassName=32]="extraEditorClassName",V[V.fastScrollSensitivity=33]="fastScrollSensitivity",V[V.find=34]="find",V[V.fixedOverflowWidgets=35]="fixedOverflowWidgets",V[V.folding=36]="folding",V[V.foldingStrategy=37]="foldingStrategy",V[V.foldingHighlight=38]="foldingHighlight",V[V.foldingImportsByDefault=39]="foldingImportsByDefault",V[V.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=41]="fontFamily",V[V.fontInfo=42]="fontInfo",V[V.fontLigatures=43]="fontLigatures",V[V.fontSize=44]="fontSize",V[V.fontWeight=45]="fontWeight",V[V.formatOnPaste=46]="formatOnPaste",V[V.formatOnType=47]="formatOnType",V[V.glyphMargin=48]="glyphMargin",V[V.gotoLocation=49]="gotoLocation",V[V.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",V[V.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",V[V.hover=52]="hover",V[V.inDiffEditor=53]="inDiffEditor",V[V.inlineSuggest=54]="inlineSuggest",V[V.letterSpacing=55]="letterSpacing",V[V.lightbulb=56]="lightbulb",V[V.lineDecorationsWidth=57]="lineDecorationsWidth",V[V.lineHeight=58]="lineHeight",V[V.lineNumbers=59]="lineNumbers",V[V.lineNumbersMinChars=60]="lineNumbersMinChars",V[V.linkedEditing=61]="linkedEditing",V[V.links=62]="links",V[V.matchBrackets=63]="matchBrackets",V[V.minimap=64]="minimap",V[V.mouseStyle=65]="mouseStyle",V[V.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=67]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",V[V.multiCursorModifier=69]="multiCursorModifier",V[V.multiCursorPaste=70]="multiCursorPaste",V[V.occurrencesHighlight=71]="occurrencesHighlight",V[V.overviewRulerBorder=72]="overviewRulerBorder",V[V.overviewRulerLanes=73]="overviewRulerLanes",V[V.padding=74]="padding",V[V.parameterHints=75]="parameterHints",V[V.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",V[V.quickSuggestions=78]="quickSuggestions",V[V.quickSuggestionsDelay=79]="quickSuggestionsDelay",V[V.readOnly=80]="readOnly",V[V.renameOnType=81]="renameOnType",V[V.renderControlCharacters=82]="renderControlCharacters",V[V.renderIndentGuides=83]="renderIndentGuides",V[V.renderFinalNewline=84]="renderFinalNewline",V[V.renderLineHighlight=85]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=87]="renderValidationDecorations",V[V.renderWhitespace=88]="renderWhitespace",V[V.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",V[V.roundedSelection=90]="roundedSelection",V[V.rulers=91]="rulers",V[V.scrollbar=92]="scrollbar",V[V.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=94]="scrollBeyondLastLine",V[V.scrollPredominantAxis=95]="scrollPredominantAxis",V[V.selectionClipboard=96]="selectionClipboard",V[V.selectionHighlight=97]="selectionHighlight",V[V.selectOnLineNumbers=98]="selectOnLineNumbers",V[V.showFoldingControls=99]="showFoldingControls",V[V.showUnused=100]="showUnused",V[V.snippetSuggestions=101]="snippetSuggestions",V[V.smartSelect=102]="smartSelect",V[V.smoothScrolling=103]="smoothScrolling",V[V.stickyTabStops=104]="stickyTabStops",V[V.stopRenderingLineAfter=105]="stopRenderingLineAfter",V[V.suggest=106]="suggest",V[V.suggestFontSize=107]="suggestFontSize",V[V.suggestLineHeight=108]="suggestLineHeight",V[V.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",V[V.suggestSelection=110]="suggestSelection",V[V.tabCompletion=111]="tabCompletion",V[V.tabIndex=112]="tabIndex",V[V.unusualLineTerminators=113]="unusualLineTerminators",V[V.useShadowDOM=114]="useShadowDOM",V[V.useTabStops=115]="useTabStops",V[V.wordSeparators=116]="wordSeparators",V[V.wordWrap=117]="wordWrap",V[V.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=120]="wordWrapColumn",V[V.wordWrapOverride1=121]="wordWrapOverride1",V[V.wordWrapOverride2=122]="wordWrapOverride2",V[V.wrappingIndent=123]="wrappingIndent",V[V.wrappingStrategy=124]="wrappingStrategy",V[V.showDeprecated=125]="showDeprecated",V[V.inlayHints=126]="inlayHints",V[V.editorClassName=127]="editorClassName",V[V.pixelRatio=128]="pixelRatio",V[V.tabFocusMode=129]="tabFocusMode",V[V.layoutInfo=130]="layoutInfo",V[V.wrappingInfo=131]="wrappingInfo"})(Ze=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:we(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(137,null)})),acceptSuggestionOnEnter:we(new y(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(138,null),""],markdownDescription:h.localize(139,null)})),accessibilitySupport:we(new k),accessibilityPageSize:we(new l(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(140,null)})),ariaLabel:we(new v(4,"ariaLabel",h.localize(141,null))),autoClosingBrackets:we(new y(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(142,null),h.localize(143,null),""],description:h.localize(144,null)})),autoClosingDelete:we(new y(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(145,null),""],description:h.localize(146,null)})),autoClosingOvertype:we(new y(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(147,null),""],description:h.localize(148,null)})),autoClosingQuotes:we(new y(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(149,null),h.localize(150,null),""],description:h.localize(151,null)})),autoIndent:we(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],m,{enumDescriptions:[h.localize(152,null),h.localize(153,null),h.localize(154,null),h.localize(155,null),h.localize(156,null)],description:h.localize(157,null)})),automaticLayout:we(new f(10,"automaticLayout",!1)),autoSurround:we(new y(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(158,null),h.localize(159,null),h.localize(160,null),""],description:h.localize(161,null)})),bracketPairColorization:we(new x),stickyTabStops:we(new f(104,"stickyTabStops",!1,{description:h.localize(162,null)})),codeLens:we(new f(13,"codeLens",!0,{description:h.localize(163,null)})),codeLensFontFamily:we(new v(14,"codeLensFontFamily","",{description:h.localize(164,null)})),codeLensFontSize:we(new l(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(165,null)})),colorDecorators:we(new f(16,"colorDecorators",!0,{description:h.localize(166,null)})),columnSelection:we(new f(17,"columnSelection",!1,{description:h.localize(167,null)})),comments:we(new i),contextmenu:we(new f(19,"contextmenu",!0)),copyWithSyntaxHighlighting:we(new f(20,"copyWithSyntaxHighlighting",!0,{description:h.localize(168,null)})),cursorBlinking:we(new a(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:h.localize(169,null)})),cursorSmoothCaretAnimation:we(new f(22,"cursorSmoothCaretAnimation",!1,{description:h.localize(170,null)})),cursorStyle:we(new a(23,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],d,{description:h.localize(171,null)})),cursorSurroundingLines:we(new l(24,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(172,null)})),cursorSurroundingLinesStyle:we(new y(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(173,null),h.localize(174,null)],description:h.localize(175,null)})),cursorWidth:we(new l(26,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(176,null)})),disableLayerHinting:we(new f(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:we(new f(28,"disableMonospaceOptimizations",!1)),domReadOnly:we(new f(29,"domReadOnly",!1)),dragAndDrop:we(new f(30,"dragAndDrop",!0,{description:h.localize(177,null)})),emptySelectionClipboard:we(new S),extraEditorClassName:we(new v(32,"extraEditorClassName","")),fastScrollSensitivity:we(new s(33,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:h.localize(178,null)})),find:we(new R),fixedOverflowWidgets:we(new f(35,"fixedOverflowWidgets",!1)),folding:we(new f(36,"folding",!0,{description:h.localize(179,null)})),foldingStrategy:we(new y(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(180,null),h.localize(181,null)],description:h.localize(182,null)})),foldingHighlight:we(new f(38,"foldingHighlight",!0,{description:h.localize(183,null)})),foldingImportsByDefault:we(new f(39,"foldingImportsByDefault",!1,{description:h.localize(184,null)})),unfoldOnClickAfterEndOfLine:we(new f(40,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(185,null)})),fontFamily:we(new v(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(186,null)})),fontInfo:we(new D),fontLigatures2:we(new p),fontSize:we(new c),fontWeight:we(new A),formatOnPaste:we(new f(46,"formatOnPaste",!1,{description:h.localize(187,null)})),formatOnType:we(new f(47,"formatOnType",!1,{description:h.localize(188,null)})),glyphMargin:we(new f(48,"glyphMargin",!0,{description:h.localize(189,null)})),gotoLocation:we(new O),hideCursorInOverviewRuler:we(new f(50,"hideCursorInOverviewRuler",!1,{description:h.localize(190,null)})),highlightActiveIndentGuide:we(new f(51,"highlightActiveIndentGuide",!0,{description:h.localize(191,null)})),hover:we(new z),inDiffEditor:we(new f(53,"inDiffEditor",!1)),letterSpacing:we(new s(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>s.clamp(V,-5,20),{description:h.localize(192,null)})),lightbulb:we(new Q),lineDecorationsWidth:we(new E(57,"lineDecorationsWidth",10)),lineHeight:we(new U),lineNumbers:we(new Fe),lineNumbersMinChars:we(new l(60,"lineNumbersMinChars",5,1,300)),linkedEditing:we(new f(61,"linkedEditing",!1,{description:h.localize(193,null)})),links:we(new f(62,"links",!0,{description:h.localize(194,null)})),matchBrackets:we(new y(63,"matchBrackets","always",["always","near","never"],{description:h.localize(195,null)})),minimap:we(new H),mouseStyle:we(new y(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:we(new s(66,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:h.localize(196,null)})),mouseWheelZoom:we(new f(67,"mouseWheelZoom",!1,{markdownDescription:h.localize(197,null)})),multiCursorMergeOverlapping:we(new f(68,"multiCursorMergeOverlapping",!0,{description:h.localize(198,null)})),multiCursorModifier:we(new a(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],G,{markdownEnumDescriptions:[h.localize(199,null),h.localize(200,null)],markdownDescription:h.localize(201,null)})),multiCursorPaste:we(new y(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(202,null),h.localize(203,null)],markdownDescription:h.localize(204,null)})),occurrencesHighlight:we(new f(71,"occurrencesHighlight",!0,{description:h.localize(205,null)})),overviewRulerBorder:we(new f(72,"overviewRulerBorder",!0,{description:h.localize(206,null)})),overviewRulerLanes:we(new l(73,"overviewRulerLanes",3,0,3)),padding:we(new ue),parameterHints:we(new q),peekWidgetDefaultFocus:we(new y(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(207,null),h.localize(208,null)],description:h.localize(209,null)})),definitionLinkOpensInPeek:we(new f(77,"definitionLinkOpensInPeek",!1,{description:h.localize(210,null)})),quickSuggestions:we(new se),quickSuggestionsDelay:we(new l(79,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(211,null)})),readOnly:we(new f(80,"readOnly",!1)),renameOnType:we(new f(81,"renameOnType",!1,{description:h.localize(212,null),markdownDeprecationMessage:h.localize(213,null)})),renderControlCharacters:we(new f(82,"renderControlCharacters",!1,{description:h.localize(214,null)})),renderIndentGuides:we(new f(83,"renderIndentGuides",!0,{description:h.localize(215,null)})),renderFinalNewline:we(new f(84,"renderFinalNewline",!0,{description:h.localize(216,null)})),renderLineHighlight:we(new y(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(217,null)],description:h.localize(218,null)})),renderLineHighlightOnlyWhenFocus:we(new f(86,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(219,null)})),renderValidationDecorations:we(new y(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:we(new y(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(220,null),h.localize(221,null),h.localize(222,null),""],description:h.localize(223,null)})),revealHorizontalRightPadding:we(new l(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:we(new f(90,"roundedSelection",!0,{description:h.localize(224,null)})),rulers:we(new Ne),scrollbar:we(new ze),scrollBeyondLastColumn:we(new l(93,"scrollBeyondLastColumn",5,0,1073741824,{description:h.localize(225,null)})),scrollBeyondLastLine:we(new f(94,"scrollBeyondLastLine",!0,{description:h.localize(226,null)})),scrollPredominantAxis:we(new f(95,"scrollPredominantAxis",!0,{description:h.localize(227,null)})),selectionClipboard:we(new f(96,"selectionClipboard",!0,{description:h.localize(228,null),included:M.isLinux})),selectionHighlight:we(new f(97,"selectionHighlight",!0,{description:h.localize(229,null)})),selectOnLineNumbers:we(new f(98,"selectOnLineNumbers",!0)),showFoldingControls:we(new y(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[h.localize(230,null),h.localize(231,null)],description:h.localize(232,null)})),showUnused:we(new f(100,"showUnused",!0,{description:h.localize(233,null)})),showDeprecated:we(new f(125,"showDeprecated",!0,{description:h.localize(234,null)})),inlayHints:we(new W),snippetSuggestions:we(new y(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(235,null),h.localize(236,null),h.localize(237,null),h.localize(238,null)],description:h.localize(239,null)})),smartSelect:we(new ee),smoothScrolling:we(new f(103,"smoothScrolling",!1,{description:h.localize(240,null)})),stopRenderingLineAfter:we(new l(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:we(new Y),inlineSuggest:we(new qe),suggestFontSize:we(new l(107,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(241,null)})),suggestLineHeight:we(new l(108,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(242,null)})),suggestOnTriggerCharacters:we(new f(109,"suggestOnTriggerCharacters",!0,{description:h.localize(243,null)})),suggestSelection:we(new y(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(244,null),h.localize(245,null),h.localize(246,null)],description:h.localize(247,null)})),tabCompletion:we(new y(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(248,null),h.localize(249,null),h.localize(250,null)],description:h.localize(251,null)})),tabIndex:we(new l(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:we(new y(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(252,null),h.localize(253,null),h.localize(254,null)],description:h.localize(255,null)})),useShadowDOM:we(new f(114,"useShadowDOM",!0)),useTabStops:we(new f(115,"useTabStops",!0,{description:h.localize(256,null)})),wordSeparators:we(new v(116,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:h.localize(257,null)})),wordWrap:we(new y(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(258,null),h.localize(259,null),h.localize(260,null),h.localize(261,null)],description:h.localize(262,null)})),wordWrapBreakAfterCharacters:we(new v(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:we(new v(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:we(new l(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(263,null)})),wordWrapOverride1:we(new y(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:we(new y(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:we(new a(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],oe,{enumDescriptions:[h.localize(264,null),h.localize(265,null),h.localize(266,null),h.localize(267,null)],description:h.localize(268,null)})),wrappingStrategy:we(new y(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[h.localize(269,null),h.localize(270,null)],description:h.localize(271,null)})),editorClassName:we(new g),pixelRatio:we(new le),tabFocusMode:we(new ae),layoutInfo:we(new $),wrappingInfo:we(new fe)}}),define(be[119],Ee([18,19]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[120],Ee([18,19]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[121],Ee([18,19]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(be[122],Ee([18,19]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(be[123],Ee([18,19]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(be[124],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[125],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[126],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(be[127],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[128],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[129],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[130],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[131],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(be[132],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(be[133],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[134],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[135],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[136],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[137],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var h;(function(F){F[F.ACTIVATE=1]="ACTIVATE",F[F.RESTORE=2]="RESTORE",F[F.PRESERVE=3]="PRESERVE"})(h=e.EditorActivation||(e.EditorActivation={}));var M;(function(F){F[F.PICK=0]="PICK",F[F.DISABLED=1]="DISABLED",F[F.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var b;(function(F){F[F.API=0]="API",F[F.USER=1]="USER"})(b=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(F){F[F.Center=0]="Center",F[F.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",F[F.NearTop=2]="NearTop",F[F.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[138],Ee([0,1,120]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function T(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=T;function F(n){if(!T(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=n.match(M);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=F;function C(n){if(!n)return null;let f=n.majorBase,l=n.majorMustEqual,s=n.minorBase,v=n.minorMustEqual,I=n.patchBase,y=n.patchMustEqual;n.hasCaret&&(f===0||(v=!1),y=!1);let a=0;if(n.preRelease){const m=b.exec(n.preRelease);if(m){const[,k,i,u]=m;a=Date.UTC(Number(k),Number(i)-1,Number(u))}}return{majorBase:f,majorMustEqual:l,minorBase:s,minorMustEqual:v,patchBase:I,patchMustEqual:y,isMinimum:n.hasGreaterEquals,notBefore:a}}e.normalizeVersion=C;function _(n,f,l){let s;typeof n=="string"?s=C(F(n)):s=n;let v;f instanceof Date?v=f.getTime():typeof f=="string"&&(v=new Date(f).getTime());let I;if(typeof l=="string"?I=C(F(l)):I=l,!s||!I)return!1;let y=s.majorBase,a=s.minorBase,m=s.patchBase,k=I.majorBase,i=I.minorBase,u=I.patchBase,r=I.notBefore,o=I.majorMustEqual,w=I.minorMustEqual,d=I.patchMustEqual;return I.isMinimum?y>k?!0:y<k?!1:a>i?!0:a<i||v&&v<r?!1:m>=u:(y===1&&k===0&&(!o||!w||!d)&&(k=1,i=0,u=0,o=!0,w=!1,d=!1),y<k?!1:y>k?!o:a<i?!1:a>i?!w:m<u?!1:m>u?!d:!(v&&v<r))}e.isValidVersion=_;function P(n,f,l,s){return l.isBuiltin||typeof l.main=="undefined"?!0:E(n,f,l.engines.vscode,s)}e.isValidExtensionVersion=P;function t(n,f,l){return n==="*"||E(f,l,n)}e.isEngineValid=t;function E(n,f,l,s=[]){let v=C(F(l));if(!v)return s.push(h.localize(0,null,l)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return s.push(h.localize(1,null,l)),!1}else if(!v.majorMustEqual)return s.push(h.localize(2,null,l)),!1;return _(n,f,v)?!0:(s.push(h.localize(3,null,n,l)),!1)}}),define(be[81],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class h{constructor(b,T=[],F=!1){this.ctor=b,this.staticArguments=T,this.supportsDelayedInstantiation=F}}e.SyncDescriptor=h}),define(be[57],Ee([0,1,81]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function b(F,C,_){C instanceof h.SyncDescriptor||(C=new h.SyncDescriptor(C,[],_)),M.push([F,C])}e.registerSingleton=b;function T(){return M}e.getSingletonServiceDescriptors=T}),define(be[139],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class h{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=h;class M{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let F of this._nodes.values())F.outgoing.size===0&&T.push(F);return T}insertEdge(T,F){const C=this.lookupOrInsertNode(T),_=this.lookupOrInsertNode(F);C.outgoing.set(this._hashFn(F),_),_.incoming.set(this._hashFn(T),C)}removeNode(T){const F=this._hashFn(T);this._nodes.delete(F);for(let C of this._nodes.values())C.outgoing.delete(F),C.incoming.delete(F)}lookupOrInsertNode(T){const F=this._hashFn(T);let C=this._nodes.get(F);return C||(C=new h(T),this._nodes.set(F,C)),C}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[F,C]of this._nodes)T.push(`${F}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,F]of this._nodes){const C=new Set([T]),_=this._findCycle(F,C);if(_)return _}}_findCycle(T,F){for(let[C,_]of T.outgoing){if(F.has(C))return[...F,C].join(" -> ");F.add(C);const P=this._findCycle(_,F);if(P)return P;F.delete(C)}}}e.Graph=M}),define(be[4],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var h;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function _(P){return P[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=_})(h=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function M(C,_,P,t){_[h.DI_TARGET]===_?_[h.DI_DEPENDENCIES].push({id:C,index:P,optional:t}):(_[h.DI_DEPENDENCIES]=[{id:C,index:P,optional:t}],_[h.DI_TARGET]=_)}function b(C){if(h.serviceIds.has(C))return h.serviceIds.get(C);const _=function(P,t,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(_,P,E,!1)};return _.toString=()=>C,h.serviceIds.set(C,_),_}e.createDecorator=b;function T(C){return C}e.refineServiceDecorator=T;function F(C){return function(_,P,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(C,_,t,!0)}}e.optional=F}),define(be[140],Ee([0,1,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,h.createDecorator)("modelService");function M(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(be[141],Ee([0,1,3,58,6,20,75,55,140]),function(ie,e,h,M,b,T,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(s){return typeof s=="string"?!1:Array.isArray(s)?s.every(P):!!s.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new h.Emitter}get onDidChange(){return this._onDidChange.event}register(v,I){let y={selector:v,provider:I,_score:-1,_time:this._clock++};return this._entries.push(y),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,b.toDisposable)(()=>{if(y){let a=this._entries.indexOf(y);a>=0&&(this._entries.splice(a,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),y=void 0)}})}has(v){return this.all(v).length>0}all(v){if(!v)return[];this._updateScores(v);const I=[];for(let y of this._entries)y._score>0&&I.push(y.provider);return I}ordered(v){const I=[];return this._orderedForEach(v,y=>I.push(y.provider)),I}orderedGroups(v){const I=[];let y,a;return this._orderedForEach(v,m=>{y&&a===m._score?y.push(m.provider):(a=m._score,y=[m.provider],I.push(y))}),I}_orderedForEach(v,I){if(!!v){this._updateScores(v);for(const y of this._entries)y._score>0&&I(y)}}_updateScores(v){let I={uri:v.uri.toString(),language:v.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===I.language&&this._lastCandidate.uri===I.uri)){this._lastCandidate=I;for(let y of this._entries)if(y._score=(0,C.score)(y.selector,v.uri,v.getLanguageIdentifier().language,(0,_.shouldSynchronizeModel)(v)),P(y.selector)&&y._score>0){for(let a of this._entries)a._score=0;y._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(v,I){return v._score<I._score?1:v._score>I._score?-1:v._time<I._time?1:v._time>I._time?-1:0}}e.LanguageFeatureRegistry=t;const E=new WeakMap;let n=0;function f(s){let v=E.get(s);return v===void 0&&(v=++n,E.set(s,v)),v}class l{constructor(v,I,y=Number.MAX_SAFE_INTEGER){this._registry=v,this.min=I,this.max=y,this._cache=new T.LRUCache(50,.7)}_key(v){return v.id+this._registry.all(v).reduce((I,y)=>(0,M.doHash)(f(y),I),0)}_clamp(v){return v===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(v*1.3)))}get(v){const I=this._key(v),y=this._cache.get(I);return this._clamp(y?.value)}update(v,I){const y=this._key(v);let a=this._cache.get(y);return a||(a=new F.MovingAverage,this._cache.set(y,a)),a.update(I),this.get(v)}}e.LanguageFeatureRequestDelays=l}),define(be[59],Ee([0,1,2,42,141,114,34]),function(ie,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class _{constructor(D,c){this.language=D,this.id=c}}e.LanguageIdentifier=_;var P;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var t;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var E;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=4]="RegEx"})(E=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",p[p.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(D){return(D&255)>>>0}static getTokenType(D){return(D&1792)>>>8}static getFontStyle(D){return(D&14336)>>>11}static getForeground(D){return(D&8372224)>>>14}static getBackground(D){return(D&4286578688)>>>23}static getClassNameFromMetadata(D){let c=this.getForeground(D),A="mtk"+c,O=this.getFontStyle(D);return O&1&&(A+=" mtki"),O&2&&(A+=" mtkb"),O&4&&(A+=" mtku"),A}static getInlineStyleFromMetadata(D,c){const A=this.getForeground(D),O=this.getFontStyle(D);let z=`color: ${c[A]};`;return O&1&&(z+="font-style: italic;"),O&2&&(z+="font-weight: bold;"),O&4&&(z+="text-decoration: underline;"),z}}e.TokenMetadata=f;var l;(function(p){p[p.Method=0]="Method",p[p.Function=1]="Function",p[p.Constructor=2]="Constructor",p[p.Field=3]="Field",p[p.Variable=4]="Variable",p[p.Class=5]="Class",p[p.Struct=6]="Struct",p[p.Interface=7]="Interface",p[p.Module=8]="Module",p[p.Property=9]="Property",p[p.Event=10]="Event",p[p.Operator=11]="Operator",p[p.Unit=12]="Unit",p[p.Value=13]="Value",p[p.Constant=14]="Constant",p[p.Enum=15]="Enum",p[p.EnumMember=16]="EnumMember",p[p.Keyword=17]="Keyword",p[p.Text=18]="Text",p[p.Color=19]="Color",p[p.File=20]="File",p[p.Reference=21]="Reference",p[p.Customcolor=22]="Customcolor",p[p.Folder=23]="Folder",p[p.TypeParameter=24]="TypeParameter",p[p.User=25]="User",p[p.Issue=26]="Issue",p[p.Snippet=27]="Snippet"})(l=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let p=Object.create(null);return p[0]="symbol-method",p[1]="symbol-function",p[2]="symbol-constructor",p[3]="symbol-field",p[4]="symbol-variable",p[5]="symbol-class",p[6]="symbol-struct",p[7]="symbol-interface",p[8]="symbol-module",p[9]="symbol-property",p[10]="symbol-event",p[11]="symbol-operator",p[12]="symbol-unit",p[13]="symbol-value",p[14]="symbol-constant",p[15]="symbol-enum",p[16]="symbol-enum-member",p[17]="symbol-keyword",p[27]="symbol-snippet",p[18]="symbol-text",p[19]="symbol-color",p[20]="symbol-file",p[21]="symbol-reference",p[22]="symbol-customcolor",p[23]="symbol-folder",p[24]="symbol-type-parameter",p[25]="account",p[26]="issues",function(D){const c=p[D];let A=c&&F.iconRegistry.get(c);return A||(console.info("No codicon found for CompletionItemKind "+D),A=F.Codicon.symbolProperty),A.classNames}}(),e.completionKindFromString=function(){let p=Object.create(null);return p.method=0,p.function=1,p.constructor=2,p.field=3,p.variable=4,p.class=5,p.struct=6,p.interface=7,p.module=8,p.property=9,p.event=10,p.operator=11,p.unit=12,p.value=13,p.constant=14,p.enum=15,p["enum-member"]=16,p.enumMember=16,p.keyword=17,p.snippet=27,p.text=18,p.color=19,p.file=20,p.reference=21,p.customcolor=22,p.folder=23,p["type-parameter"]=24,p.typeParameter=24,p.account=25,p.issue=26,function(D,c){let A=p[D];return typeof A=="undefined"&&!c&&(A=9),A}}();var s;(function(p){p[p.Deprecated=1]="Deprecated"})(s=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(p){p[p.KeepWhitespace=1]="KeepWhitespace",p[p.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var I;(function(p){p[p.Invoke=0]="Invoke",p[p.TriggerCharacter=1]="TriggerCharacter",p[p.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var y;(function(p){p[p.Automatic=0]="Automatic",p[p.Explicit=1]="Explicit"})(y=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(p){p[p.Invoke=1]="Invoke",p[p.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var m;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(m=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var k;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(k=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(p){return p&&h.URI.isUri(p.uri)&&M.Range.isIRange(p.range)&&(M.Range.isIRange(p.originSelectionRange)||M.Range.isIRange(p.targetSelectionRange))}e.isLocationLink=i;var u;(function(p){p[p.File=0]="File",p[p.Module=1]="Module",p[p.Namespace=2]="Namespace",p[p.Package=3]="Package",p[p.Class=4]="Class",p[p.Method=5]="Method",p[p.Property=6]="Property",p[p.Field=7]="Field",p[p.Constructor=8]="Constructor",p[p.Enum=9]="Enum",p[p.Interface=10]="Interface",p[p.Function=11]="Function",p[p.Variable=12]="Variable",p[p.Constant=13]="Constant",p[p.String=14]="String",p[p.Number=15]="Number",p[p.Boolean=16]="Boolean",p[p.Array=17]="Array",p[p.Object=18]="Object",p[p.Key=19]="Key",p[p.Null=20]="Null",p[p.EnumMember=21]="EnumMember",p[p.Struct=22]="Struct",p[p.Event=23]="Event",p[p.Operator=24]="Operator",p[p.TypeParameter=25]="TypeParameter"})(u=e.SymbolKind||(e.SymbolKind={}));var r;(function(p){p[p.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var o;(function(p){const D=new Map;D.set("file",0),D.set("module",1),D.set("namespace",2),D.set("package",3),D.set("class",4),D.set("method",5),D.set("property",6),D.set("field",7),D.set("constructor",8),D.set("enum",9),D.set("interface",10),D.set("function",11),D.set("variable",12),D.set("constant",13),D.set("string",14),D.set("number",15),D.set("boolean",16),D.set("array",17),D.set("object",18),D.set("key",19),D.set("null",20),D.set("enum-member",21),D.set("struct",22),D.set("event",23),D.set("operator",24),D.set("type-parameter",25);const c=new Map;c.set(0,"file"),c.set(1,"module"),c.set(2,"namespace"),c.set(3,"package"),c.set(4,"class"),c.set(5,"method"),c.set(6,"property"),c.set(7,"field"),c.set(8,"constructor"),c.set(9,"enum"),c.set(10,"interface"),c.set(11,"function"),c.set(12,"variable"),c.set(13,"constant"),c.set(14,"string"),c.set(15,"number"),c.set(16,"boolean"),c.set(17,"array"),c.set(18,"object"),c.set(19,"key"),c.set(20,"null"),c.set(21,"enum-member"),c.set(22,"struct"),c.set(23,"event"),c.set(24,"operator"),c.set(25,"type-parameter");function A(K){return D.get(K)}p.fromString=A;function O(K){return c.get(K)}p.toString=O;function z(K,$){const Q=c.get(K);let W=Q&&F.iconRegistry.get("symbol-"+Q);return W||(console.info("No codicon found for SymbolKind "+K),W=F.Codicon.symbolProperty),`${$?"inline":"block"} ${W.classNames}`}p.toCssClassName=z})(o=e.SymbolKinds||(e.SymbolKinds={}));class w{constructor(D){this.value=D}}e.FoldingRangeKind=w,w.Comment=new w("comment"),w.Imports=new w("imports"),w.Region=new w("region");var d;(function(p){p[p.Collapsed=0]="Collapsed",p[p.Expanded=1]="Expanded"})(d=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var g;(function(p){p[p.Editing=0]="Editing",p[p.Preview=1]="Preview"})(g=e.CommentMode||(e.CommentMode={}));var S;(function(p){p[p.Other=0]="Other",p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(S=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new b.LanguageFeatureRegistry,e.RenameProviderRegistry=new b.LanguageFeatureRegistry,e.CompletionProviderRegistry=new b.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new b.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new b.LanguageFeatureRegistry,e.HoverProviderRegistry=new b.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new b.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new b.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new b.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new b.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new b.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new b.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new b.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new b.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new b.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.LinkProviderRegistry=new b.LanguageFeatureRegistry,e.ColorProviderRegistry=new b.LanguageFeatureRegistry,e.SelectionRangeRegistry=new b.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new b.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var R;(function(p){p[p.None=0]="None",p[p.Option=1]="Option",p[p.Default=2]="Default",p[p.Preferred=3]="Preferred"})(R=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[43],Ee([0,1,26,9,4]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=h.userAgent||"";const F=new Map;F.set("false",!1),F.set("true",!0),F.set("isMac",h.isMacintosh),F.set("isLinux",h.isLinux),F.set("isWindows",h.isWindows),F.set("isWeb",h.isWeb),F.set("isMacNative",h.isMacintosh&&!h.isWeb),F.set("isEdge",T.indexOf("Edg/")>=0),F.set("isFirefox",T.indexOf("Firefox")>=0),F.set("isChrome",T.indexOf("Chrome")>=0),F.set("isSafari",T.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var _;(function(D){D[D.False=0]="False",D[D.True=1]="True",D[D.Defined=2]="Defined",D[D.Not=3]="Not",D[D.Equals=4]="Equals",D[D.NotEquals=5]="NotEquals",D[D.And=6]="And",D[D.Regex=7]="Regex",D[D.NotRegex=8]="NotRegex",D[D.Or=9]="Or",D[D.In=10]="In",D[D.NotIn=11]="NotIn",D[D.Greater=12]="Greater",D[D.GreaterEquals=13]="GreaterEquals",D[D.Smaller=14]="Smaller",D[D.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return E.INSTANCE}static true(){return n.INSTANCE}static has(c){return f.create(c)}static equals(c,A){return l.create(c,A)}static notEquals(c,A){return I.create(c,A)}static regex(c,A){return u.create(c,A)}static in(c,A){return s.create(c,A)}static not(c){return y.create(c)}static and(...c){return o.create(c,null)}static or(...c){return w.create(c,null,!0)}static greater(c,A){return a.create(c,A)}static less(c,A){return k.create(c,A)}static deserialize(c,A=!1){if(!!c)return this._deserializeOrExpression(c,A)}static _deserializeOrExpression(c,A){let O=c.split("||");return w.create(O.map(z=>this._deserializeAndExpression(z,A)),null,!0)}static _deserializeAndExpression(c,A){let O=c.split("&&");return o.create(O.map(z=>this._deserializeOne(z,A)),null)}static _deserializeOne(c,A){if(c=c.trim(),c.indexOf("!=")>=0){let O=c.split("!=");return I.create(O[0].trim(),this._deserializeValue(O[1],A))}if(c.indexOf("==")>=0){let O=c.split("==");return l.create(O[0].trim(),this._deserializeValue(O[1],A))}if(c.indexOf("=~")>=0){let O=c.split("=~");return u.create(O[0].trim(),this._deserializeRegexValue(O[1],A))}if(c.indexOf(" in ")>=0){let O=c.split(" in ");return s.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(c)){const O=c.split(">=");return m.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(c)){const O=c.split(">");return a.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(c)){const O=c.split("<=");return i.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(c)){const O=c.split("<");return k.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(c)?y.create(c.substr(1).trim()):f.create(c)}static _deserializeValue(c,A){if(c=c.trim(),c==="true")return!0;if(c==="false")return!1;let O=/^'([^']*)'$/.exec(c);return O?O[1].trim():c}static _deserializeRegexValue(c,A){if((0,M.isFalsyOrWhitespace)(c)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=c.indexOf("/"),z=c.lastIndexOf("/");if(O===z||O<0){if(A)throw new Error(`bad regexp-value '${c}', missing /-enclosure`);return console.warn(`bad regexp-value '${c}', missing /-enclosure`),null}let K=c.slice(O+1,z),$=c[z+1]==="i"?"i":"";try{return new RegExp(K,$)}catch(Q){if(A)throw new Error(`bad regexp-value '${c}', parse error: ${Q}`);return console.warn(`bad regexp-value '${c}', parse error: ${Q}`),null}}}e.ContextKeyExpr=P;function t(D,c){return D.cmp(c)}class E{constructor(){this.type=0}cmp(c){return this.type-c.type}equals(c){return c.type===this.type}evaluate(c){return!1}serialize(){return"false"}keys(){return[]}map(c){return this}negate(){return n.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class n{constructor(){this.type=1}cmp(c){return this.type-c.type}equals(c){return c.type===this.type}evaluate(c){return!0}serialize(){return"true"}keys(){return[]}map(c){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=n,n.INSTANCE=new n;class f{constructor(c,A){this.key=c,this.negated=A,this.type=2}static create(c,A=null){const O=F.get(c);return typeof O=="boolean"?O?n.INSTANCE:E.INSTANCE:new f(c,A)}cmp(c){return c.type!==this.type?this.type-c.type:g(this.key,c.key)}equals(c){return c.type===this.type?this.key===c.key:!1}evaluate(c){return!!c.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(c){return c.mapDefined(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class l{constructor(c,A,O){this.key=c,this.value=A,this.negated=O,this.type=4}static create(c,A,O=null){if(typeof A=="boolean")return A?f.create(c,O):y.create(c,O);const z=F.get(c);return typeof z=="boolean"?A===(z?"true":"false")?n.INSTANCE:E.INSTANCE:new l(c,A,O)}cmp(c){return c.type!==this.type?this.type-c.type:S(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return c.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(c){return c.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=l;class s{constructor(c,A){this.key=c,this.valueKey=A,this.type=10,this.negated=null}static create(c,A){return new s(c,A)}cmp(c){return c.type!==this.type?this.type-c.type:S(this.key,this.valueKey,c.key,c.valueKey)}equals(c){return c.type===this.type?this.key===c.key&&this.valueKey===c.valueKey:!1}evaluate(c){const A=c.getValue(this.valueKey),O=c.getValue(this.key);return Array.isArray(A)?A.indexOf(O)>=0:typeof O=="string"&&typeof A=="object"&&A!==null?C.call(A,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(c){return c.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=s;class v{constructor(c){this._actual=c,this.type=11}static create(c){return new v(c)}cmp(c){return c.type!==this.type?this.type-c.type:this._actual.cmp(c._actual)}equals(c){return c.type===this.type?this._actual.equals(c._actual):!1}evaluate(c){return!this._actual.evaluate(c)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(c){return new v(this._actual.map(c))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class I{constructor(c,A,O){this.key=c,this.value=A,this.negated=O,this.type=5}static create(c,A,O=null){if(typeof A=="boolean")return A?y.create(c,O):f.create(c,O);const z=F.get(c);return typeof z=="boolean"?A===(z?"true":"false")?E.INSTANCE:n.INSTANCE:new I(c,A,O)}cmp(c){return c.type!==this.type?this.type-c.type:S(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return c.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(c){return c.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=I;class y{constructor(c,A){this.key=c,this.negated=A,this.type=3}static create(c,A=null){const O=F.get(c);return typeof O=="boolean"?O?E.INSTANCE:n.INSTANCE:new y(c,A)}cmp(c){return c.type!==this.type?this.type-c.type:g(this.key,c.key)}equals(c){return c.type===this.type?this.key===c.key:!1}evaluate(c){return!c.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(c){return c.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=y;class a{constructor(c,A,O){this.key=c,this.value=A,this.negated=O,this.type=12}static create(c,A,O=null){return new a(c,A,O)}cmp(c){return c.type!==this.type?this.type-c.type:S(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return parseFloat(c.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(c){return c.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class m{constructor(c,A,O){this.key=c,this.value=A,this.negated=O,this.type=13}static create(c,A,O=null){return new m(c,A,O)}cmp(c){return c.type!==this.type?this.type-c.type:S(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return parseFloat(c.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(c){return c.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=m;class k{constructor(c,A,O){this.key=c,this.value=A,this.negated=O,this.type=14}static create(c,A,O=null){return new k(c,A,O)}cmp(c){return c.type!==this.type?this.type-c.type:S(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return parseFloat(c.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(c){return c.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=k;class i{constructor(c,A,O){this.key=c,this.value=A,this.negated=O,this.type=15}static create(c,A,O=null){return new i(c,A,O)}cmp(c){return c.type!==this.type?this.type-c.type:S(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return parseFloat(c.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(c){return c.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class u{constructor(c,A){this.key=c,this.regexp=A,this.type=7,this.negated=null}static create(c,A){return new u(c,A)}cmp(c){if(c.type!==this.type)return this.type-c.type;if(this.key<c.key)return-1;if(this.key>c.key)return 1;const A=this.regexp?this.regexp.source:"",O=c.regexp?c.regexp.source:"";return A<O?-1:A>O?1:0}equals(c){if(c.type===this.type){const A=this.regexp?this.regexp.source:"",O=c.regexp?c.regexp.source:"";return this.key===c.key&&A===O}return!1}evaluate(c){let A=c.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const c=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${c}`}keys(){return[this.key]}map(c){return c.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=u;class r{constructor(c){this._actual=c,this.type=8}static create(c){return new r(c)}cmp(c){return c.type!==this.type?this.type-c.type:this._actual.cmp(c._actual)}equals(c){return c.type===this.type?this._actual.equals(c._actual):!1}evaluate(c){return!this._actual.evaluate(c)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(c){return new r(this._actual.map(c))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class o{constructor(c,A){this.expr=c,this.negated=A,this.type=6}static create(c,A){return o._normalizeArr(c,A)}cmp(c){if(c.type!==this.type)return this.type-c.type;if(this.expr.length<c.expr.length)return-1;if(this.expr.length>c.expr.length)return 1;for(let A=0,O=this.expr.length;A<O;A++){const z=t(this.expr[A],c.expr[A]);if(z!==0)return z}return 0}equals(c){if(c.type===this.type){if(this.expr.length!==c.expr.length)return!1;for(let A=0,O=this.expr.length;A<O;A++)if(!this.expr[A].equals(c.expr[A]))return!1;return!0}return!1}evaluate(c){for(let A=0,O=this.expr.length;A<O;A++)if(!this.expr[A].evaluate(c))return!1;return!0}static _normalizeArr(c,A){const O=[];let z=!1;for(const K of c)if(!!K){if(K.type===1){z=!0;continue}if(K.type===0)return E.INSTANCE;if(K.type===6){O.push(...K.expr);continue}O.push(K)}if(O.length===0&&z)return n.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];O.sort(t);for(let K=1;K<O.length;K++)O[K-1].equals(O[K])&&(O.splice(K,1),K--);if(O.length===1)return O[0];for(;O.length>1;){const K=O[O.length-1];if(K.type!==9)break;O.pop();const $=O.pop(),Q=O.length===0,W=w.create(K.expr.map(U=>o.create([U,$],null)),null,Q);W&&(O.push(W),O.sort(t))}return O.length===1?O[0]:new o(O,A)}}serialize(){return this.expr.map(c=>c.serialize()).join(" && ")}keys(){const c=[];for(let A of this.expr)c.push(...A.keys());return c}map(c){return new o(this.expr.map(A=>A.map(c)),null)}negate(){if(!this.negated){const c=[];for(let A of this.expr)c.push(A.negate());this.negated=w.create(c,this,!0)}return this.negated}}class w{constructor(c,A){this.expr=c,this.negated=A,this.type=9}static create(c,A,O){return w._normalizeArr(c,A,O)}cmp(c){if(c.type!==this.type)return this.type-c.type;if(this.expr.length<c.expr.length)return-1;if(this.expr.length>c.expr.length)return 1;for(let A=0,O=this.expr.length;A<O;A++){const z=t(this.expr[A],c.expr[A]);if(z!==0)return z}return 0}equals(c){if(c.type===this.type){if(this.expr.length!==c.expr.length)return!1;for(let A=0,O=this.expr.length;A<O;A++)if(!this.expr[A].equals(c.expr[A]))return!1;return!0}return!1}evaluate(c){for(let A=0,O=this.expr.length;A<O;A++)if(this.expr[A].evaluate(c))return!0;return!1}static _normalizeArr(c,A,O){let z=[],K=!1;if(c){for(let $=0,Q=c.length;$<Q;$++){const W=c[$];if(!!W){if(W.type===0){K=!0;continue}if(W.type===1)return n.INSTANCE;if(W.type===9){z=z.concat(W.expr);continue}z.push(W)}}if(z.length===0&&K)return E.INSTANCE;z.sort(t)}if(z.length!==0){if(z.length===1)return z[0];for(let $=1;$<z.length;$++)z[$-1].equals(z[$])&&(z.splice($,1),$--);if(z.length===1)return z[0];if(O){for(let $=0;$<z.length;$++)for(let Q=$+1;Q<z.length;Q++)R(z[$],z[Q])&&(z.splice(Q,1),Q--);if(z.length===1)return z[0]}return new w(z,A)}}serialize(){return this.expr.map(c=>c.serialize()).join(" || ")}keys(){const c=[];for(let A of this.expr)c.push(...A.keys());return c}map(c){return new w(this.expr.map(A=>A.map(c)),null)}negate(){if(!this.negated){let c=[];for(let A of this.expr)c.push(A.negate());for(;c.length>1;){const A=c.shift(),O=c.shift(),z=[];for(const $ of p(A))for(const Q of p(O))z.push(o.create([$,Q],null));const K=c.length===0;c.unshift(w.create(z,null,K))}this.negated=c[0]}return this.negated}}class d extends f{constructor(c,A,O){super(c,null);this._defaultValue=A,typeof O=="object"?d._info.push({...O,key:c}):O!==!0&&d._info.push({key:c,description:O,type:A!=null?typeof A:void 0})}static all(){return d._info.values()}bindTo(c){return c.createKey(this.key,this._defaultValue)}getValue(c){return c.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(c){return l.create(this.key,c)}notEqualsTo(c){return I.create(this.key,c)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(D,c){return D<c?-1:D>c?1:0}function S(D,c,A,O){return D<A?-1:D>A?1:c<O?-1:c>O?1:0}function R(D,c){if(c.type===6&&D.type!==9&&D.type!==6){for(const z of c.expr)if(D.equals(z))return!0}const A=D.negate(),O=p(A).concat(p(c));O.sort(t);for(let z=0;z<O.length;z++){const $=O[z].negate();for(let Q=z+1;Q<O.length;Q++){const W=O[Q];if($.equals(W))return!0}}return!1}e.implies=R;function p(D){return D.type===9?D.expr:[D]}}),define(be[142],Ee([0,1,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,h.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,h.refineServiceDecorator)(e.IEnvironmentService)}),define(be[25],Ee([0,1,9,4]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function b(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=b;function T(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(F=e.ExtensionType||(e.ExtensionType={}));class C{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,n){if(typeof E=="undefined"||E===null)return typeof n=="undefined"||n===null;if(typeof n=="undefined"||n===null)return!1;if(typeof E=="string"||typeof n=="string"){let f=typeof E=="string"?E:E.value,l=typeof n=="string"?n:n.value;return h.equalsIgnoreCase(f,l)}return E._lower===n._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=C;function _(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function P(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[143],Ee([0,1,9,25]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function b(l,s){return l.uuid&&s.uuid?l.uuid===s.uuid:l.id===s.id?!0:(0,h.compareIgnoreCase)(l.id,s.id)===0}e.areSameExtensions=b;class T{constructor(s,v){this.version=v,this.id=s.id,this.uuid=s.uuid}key(){return`${this.id}-${this.version}`}equals(s){return s instanceof T?b(this,s)&&this.version===s.version:!1}}e.ExtensionIdentifierWithVersion=T;function F(l,s){return`${l}.${s}`}e.getExtensionId=F;function C(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function _(l,s){return C(F(l,s))}e.getGalleryExtensionId=_;function P(l,s){const v=[],I=y=>{for(const a of v)if(a.some(m=>b(s(m),s(y))))return a;return null};for(const y of l){const a=I(y);a?a.push(y):v.push([y])}return v}e.groupByExtension=P;function t(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function E(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(l){const s=new Set;for(const v of l)v.malicious&&s.add(v.id.id);return s}e.getMaliciousExtensionsSet=n;function f(l,s){const v=[],I=s.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const y=I.shift();if(y&&v.every(a=>!b(a.identifier,{id:y}))){const a=l.filter(m=>b(m.identifier,{id:y}));a.length===1&&(v.push(a[0]),I.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=f}),define(be[60],Ee([0,1,20,17,9,10,2,121,4]),function(ie,e,h,M,b,T,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function P($){return $.create===!0}e.isFileOpenForWriteOptions=P;var t;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var E;(function($){$[$.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var n;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f($){return!!($.capabilities&2)}e.hasReadWriteCapability=f;function l($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=l;function s($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=s;function v($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=v;var I;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(Q,W){super(Q);this.code=W}}e.FileSystemProviderError=y;function a($,Q){const W=new y($.toString(),Q);return k(W,Q),W}e.createFileSystemProviderError=a;function m($){return $||a((0,C.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=m;function k($,Q){return $.name=Q?`${Q} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=k;function i($){if(!$)return I.Unknown;if($ instanceof y)return $.code;const Q=/^(.+) \(FileSystemError\)$/.exec($.name);if(!Q)return I.Unknown;switch(Q[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=i;function u($){if($ instanceof S)return $.fileOperationResult;switch(i($)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var r;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class o{constructor(Q,W,U){this.resource=Q,this.operation=W,this.target=U}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=o;var w;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(w=e.FileChangeType||(e.FileChangeType={}));class d{constructor(Q,W){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const U of Q)switch(U.type){case 1:this.added||(this.added=h.TernarySearchTree.forUris(()=>W)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=h.TernarySearchTree.forUris(()=>W)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=h.TernarySearchTree.forUris(()=>W)),this.deleted.set(U.resource,U);break}}contains(Q,...W){return this.doContains(Q,{includeChildren:!1},...W)}affects(Q,...W){return this.doContains(Q,{includeChildren:!0},...W)}doContains(Q,W,...U){if(!Q)return!1;const H=U.length>0;return!!((!H||U.includes(1))&&(this.added?.get(Q)||W.includeChildren&&this.added?.findSuperstr(Q))||(!H||U.includes(0))&&(this.updated?.get(Q)||W.includeChildren&&this.updated?.findSuperstr(Q))||(!H||U.includes(2))&&(this.deleted?.findSubstr(Q)||W.includeChildren&&this.deleted?.findSuperstr(Q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function g($,Q,W){return!$||!Q||$===Q||Q.length>$.length?!1:(Q.charAt(Q.length-1)!==M.sep&&(Q+=M.sep),W?(0,b.startsWithIgnoreCase)($,Q):$.indexOf(Q)===0)}e.isParent=g;class S extends Error{constructor(Q,W,U){super(Q);this.fileOperationResult=W,this.options=U}}e.FileOperationError=S;class R extends S{constructor(Q,W,U){super(Q,2,U);this.stat=W}}e.NotModifiedSinceFileOperationError=R;var p;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(p=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var D;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(D=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function c($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=c;async function A($,Q){if(!Q.canHandleResource(F.URI.from({scheme:$.scheme})))return new Promise(W=>{const U=Q.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===$.scheme&&H.added&&(U.dispose(),W())})})}e.whenProviderRegistered=A,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(Q){return(0,T.isNumber)(Q)||(Q=0),Q<O.KB?(0,C.localize)(1,null,Q.toFixed(0)):Q<O.MB?(0,C.localize)(2,null,(Q/O.KB).toFixed(2)):Q<O.GB?(0,C.localize)(3,null,(Q/O.MB).toFixed(2)):Q<O.TB?(0,C.localize)(4,null,(Q/O.GB).toFixed(2)):(0,C.localize)(5,null,(Q/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var z;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function K($){return{maxFileSize:$===0?300*O.MB:16*O.GB,maxHeapSize:$===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=K}),define(be[61],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class h{constructor(...b){this._entries=new Map;for(let[T,F]of b)this.set(T,F)}set(b,T){const F=this._entries.get(b);return this._entries.set(b,T),F}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=h}),define(be[144],Ee([0,1,14,16,81,139,4,61]),function(ie,e,h,M,b,T,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class P extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class t{constructor(l=new C.ServiceCollection,s=!1,v){this._activeInstantiations=new Set,this._services=l,this._strict=s,this._parent=v,this._services.set(F.IInstantiationService,this)}createChild(l){return new t(l,this._strict,this)}invokeFunction(l,...s){let v=n.traceInvocation(l),I=!1;try{return l({get:(a,m)=>{if(I)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const k=this._getOrCreateServiceInstance(a,v);if(!k&&m!==F.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return k}},...s)}finally{I=!0,v.stop()}}createInstance(l,...s){let v,I;return l instanceof b.SyncDescriptor?(v=n.traceCreation(l.ctor),I=this._createInstance(l.ctor,l.staticArguments.concat(s),v)):(v=n.traceCreation(l),I=this._createInstance(l,s,v)),v.stop(),I}_createInstance(l,s=[],v){let I=F._util.getServiceDependencies(l).sort((m,k)=>m.index-k.index),y=[];for(const m of I){let k=this._getOrCreateServiceInstance(m.id,v);if(!k&&this._strict&&!m.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${m.id}.`);y.push(k)}let a=I.length>0?I[0].index:s.length;if(s.length!==a){console.warn(`[createInstance] First service dependency of ${l.name} at position ${a+1} conflicts with ${s.length} static arguments`);let m=a-s.length;m>0?s=s.concat(new Array(m)):s=s.slice(0,a)}return new l(...[...s,...y])}_setServiceInstance(l,s){if(this._services.get(l)instanceof b.SyncDescriptor)this._services.set(l,s);else if(this._parent)this._parent._setServiceInstance(l,s);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let s=this._services.get(l);return!s&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):s}_getOrCreateServiceInstance(l,s){let v=this._getServiceInstanceOrDescriptor(l);return v instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,v,s.branch(l,!0)):(s.branch(l,!1),v)}_safeCreateAndCacheServiceInstance(l,s,v){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,s,v)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,s,v){const I=new T.Graph(m=>m.id.toString());let y=0;const a=[{id:l,desc:s,_trace:v}];for(;a.length;){const m=a.pop();if(I.lookupOrInsertNode(m),y++>1e3)throw new P(I);for(let k of F._util.getServiceDependencies(m.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(k.id);if(!i&&!k.optional&&console.warn(`[createInstance] ${l} depends on ${k.id} which is NOT registered.`),i instanceof b.SyncDescriptor){const u={id:k.id,desc:i,_trace:m._trace.branch(k.id,!0)};I.insertEdge(m,u),a.push(u)}}}for(;;){const m=I.roots();if(m.length===0){if(!I.isEmpty())throw new P(I);break}for(const{data:k}of m){if(this._getServiceInstanceOrDescriptor(k.id)instanceof b.SyncDescriptor){const u=this._createServiceInstanceWithOwner(k.id,k.desc.ctor,k.desc.staticArguments,k.desc.supportsDelayedInstantiation,k._trace);this._setServiceInstance(k.id,u)}I.removeNode(k)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,s,v=[],I,y){if(this._services.get(l)instanceof b.SyncDescriptor)return this._createServiceInstance(s,v,I,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,s,v,I,y);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}_createServiceInstance(l,s=[],v,I){if(v){const y=new h.IdleValue(()=>this._createInstance(l,s,I));return new Proxy(Object.create(null),{get(a,m){if(m in a)return a[m];let k=y.value,i=k[m];return typeof i!="function"||(i=i.bind(k),a[m]=i),i},set(a,m,k){return y.value[m]=k,!0}})}else return this._createInstance(l,s,I)}}e.InstantiationService=t;var E;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(E||(E={}));class n{constructor(l,s){this.type=l,this.name=s,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return _?new n(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(l){return _?new n(0,l.name):n._None}branch(l,s){let v=new n(2,l.toString());return this._dep.push([l,s,v]),v}stop(){let l=Date.now()-this._start;n._totals+=l;let s=!1;function v(y,a){let m=[],k=new Array(y+1).join("	");for(const[i,u,r]of a._dep)if(u&&r){s=!0,m.push(`${k}CREATES -> ${i}`);let o=v(y+1,r);o&&m.push(o)}else m.push(`${k}uses -> ${i}`);return m.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(l>2||s)&&console.log(I.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(be[15],Ee([0,1,56,3,6,26,4]),function(ie,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,F.createDecorator)("logService"),e.ILoggerService=(0,F.createDecorator)("loggerService");function C(){return new Date().toISOString()}var _;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class P extends b.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class t extends P{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...u){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([i,...u]))}debug(i,...u){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([i,...u]))}info(i,...u){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([i,...u]))}warn(i,...u){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([i,...u]))}error(i,...u){if(this.checkLogLevel(_.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(_.Error,this.format(r))}else this.log(_.Error,this.format([i,...u]))}critical(i,...u){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([i,...u]))}flush(){}format(i){let u="";for(let r=0;r<i.length;r++){let o=i[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch(w){}u+=(r>0?" ":"")+o}return u}}e.AbstractMessageLogger=t;class E extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!T.isWindows}trace(i,...u){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...u):console.log(`[main ${C()}]`,i,...u))}debug(i,...u){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...u):console.log(`[main ${C()}]`,i,...u))}info(i,...u){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...u):console.log(`[main ${C()}]`,i,...u))}warn(i,...u){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,i,...u):console.warn(`[main ${C()}]`,i,...u))}error(i,...u){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,i,...u):console.error(`[main ${C()}]`,i,...u))}critical(i,...u){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,i,...u):console.error(`[main ${C()}]`,i,...u))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class n extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...u){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",i,...u)}debug(i,...u){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...u)}info(i,...u){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",i,...u)}warn(i,...u){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",i,...u)}error(i,...u){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",i,...u)}critical(i,...u){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...u)}dispose(){}flush(){}}e.ConsoleLogger=n;class f extends P{constructor(i,u=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(u)}trace(i,...u){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(i),...u])}debug(i,...u){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(i),...u])}info(i,...u){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(i),...u])}warn(i,...u){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(i),...u])}error(i,...u){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(i),...u])}critical(i,...u){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(i),...u])}extractMessage(i){return typeof i=="string"?i:(0,h.toErrorMessage)(i,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class l extends P{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const u of this.logServices)u.setLevel(i);super.setLevel(i)}trace(i,...u){for(const r of this.logServices)r.trace(i,...u)}debug(i,...u){for(const r of this.logServices)r.debug(i,...u)}info(i,...u){for(const r of this.logServices)r.info(i,...u)}warn(i,...u){for(const r of this.logServices)r.warn(i,...u)}error(i,...u){for(const r of this.logServices)r.error(i,...u)}critical(i,...u){for(const r of this.logServices)r.critical(i,...u)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=l;class s extends b.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...u){this.logger.trace(i,...u)}debug(i,...u){this.logger.debug(i,...u)}info(i,...u){this.logger.info(i,...u)}warn(i,...u){this.logger.warn(i,...u)}error(i,...u){this.logger.error(i,...u)}critical(i,...u){this.logger.critical(i,...u)}flush(){this.logger.flush()}}e.LogService=s;class v extends b.Disposable{constructor(i,u){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(u(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,u){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,u?.always?_.Trace:this.logLevel,u),this.loggers.set(i.toString(),r),u?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class I{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return _.Info}trace(i,...u){}debug(i,...u){}info(i,...u){}warn(i,...u){}error(i,...u){}critical(i,...u){}dispose(){}flush(){}}e.NullLogService=I;function y(k){if(k.verbose)return _.Trace;if(typeof k.logLevel=="string"){const i=a(k.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=y;function a(k){switch(k){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=a;function m(k){switch(k){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=m}),define(be[82],Ee([0,1,35,122,4]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var F;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(F=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function P(l,s){return s-l}_.compare=P;const t=Object.create(null);t[_.Error]=(0,M.localize)(0,null),t[_.Warning]=(0,M.localize)(1,null),t[_.Info]=(0,M.localize)(2,null);function E(l){return t[l]||""}_.toString=E;function n(l){switch(l){case h.default.Error:return _.Error;case h.default.Warning:return _.Warning;case h.default.Info:return _.Info;case h.default.Ignore:return _.Hint}}_.fromSeverity=n;function f(l){switch(l){case _.Error:return h.default.Error;case _.Warning:return h.default.Warning;case _.Info:return h.default.Info;case _.Hint:return h.default.Ignore}}_.toSeverity=f}(F=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(_){const P="";function t(n){return E(n,!0)}_.makeKey=t;function E(n,f){let l=[P];return n.source?l.push(n.source.replace("\xA6","\\\xA6")):l.push(P),n.code?typeof n.code=="string"?l.push(n.code.replace("\xA6","\\\xA6")):l.push(n.code.value.replace("\xA6","\\\xA6")):l.push(P),n.severity!==void 0&&n.severity!==null?l.push(F.toString(n.severity)):l.push(P),n.message&&f?l.push(n.message.replace("\xA6","\\\xA6")):l.push(P),n.startLineNumber!==void 0&&n.startLineNumber!==null?l.push(n.startLineNumber.toString()):l.push(P),n.startColumn!==void 0&&n.startColumn!==null?l.push(n.startColumn.toString()):l.push(P),n.endLineNumber!==void 0&&n.endLineNumber!==null?l.push(n.endLineNumber.toString()):l.push(P),n.endColumn!==void 0&&n.endColumn!==null?l.push(n.endColumn.toString()):l.push(P),l.push(P),l.join("\xA6")}_.makeKeyOptionalMessage=E})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(be[145],Ee([0,1,3,35,4]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,b.createDecorator)("notificationService");var T;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var F;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(F=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new _,this.onDidClose=h.Event.None,this.onDidChangeVisibility=h.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=C;class _{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=_}),define(be[146],Ee([0,1,6,9,2,4]),function(ie,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return h.Disposable.None},registerValidator(){return h.Disposable.None},registerExternalUriResolver(){return h.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return h.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function F(C,_){return b.URI.isUri(C)?(0,M.equalsIgnoreCase)(C.scheme,_):(0,M.startsWithIgnoreCase)(C,_+":")}e.matchesScheme=F});var Ue=this&&this.__decorate||function(ie,e,h,M){var b=arguments.length,T=b<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,h):M,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(ie,e,h,M);else for(var C=ie.length-1;C>=0;C--)(F=ie[C])&&(T=(b<3?F(T):b>3?F(e,h,T):F(e,h))||T);return b>3&&T&&Object.defineProperty(e,h,T),T},He=this&&this.__param||function(ie,e){return function(h,M){e(h,M,ie)}};define(be[147],Ee([0,1,14,21,6,4]),function(ie,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var F;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(F=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(E){this.callback=E}get value(){return this._value}report(E){this._value=E,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let _=class extends b.Disposable{constructor(E,n){super();this.deferred=new h.DeferredPromise,n.withProgress(E,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(E){this.reporter?this.reporter.report(E):this.lastStep=E}};_=Ue([He(1,e.IProgressService)],_),e.UnmanagedProgress=_;class P extends b.Disposable{constructor(E){super();this.progressIndicator=E,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(E){this.stop();const n=++this.currentOperationId,f=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},E),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:f.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(E){this.currentOperationId===E&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,40,10]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(F,C){h.ok(M.isString(F)),h.ok(M.isObject(C)),h.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,C)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}e.Registry=new b}),define(be[83],Ee([0,1,3,28]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class T{constructor(){this._onDidChangeSchema=new h.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,P){this.schemasById[b(_)]=P,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new T;M.Registry.add(e.Extensions.JSONContribution,F)}),define(be[62],Ee([0,1,3,10,119,83,28]),function(ie,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var _;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(_=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const P=F.Registry.as(T.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new h.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new h.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(y,a=!0){this.registerConfigurations([y],a)}registerConfigurations(y,a=!0){const m=[];y.forEach(k=>{m.push(...this.validateAndRegisterProperties(k,a,k.extensionInfo)),this.configurationContributors.push(k),this.registerJSONConfiguration(k)}),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(y){const a=[],m=k=>{if(k.properties)for(const i in k.properties)a.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,k.properties[i]);k.allOf&&k.allOf.forEach(i=>m(i))};for(const k of y){m(k);const i=this.configurationContributors.indexOf(k);i!==-1&&this.configurationContributors.splice(i,1)}P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}registerDefaultConfigurations(y){const a=[],m=[];for(const k of y)for(const i in k)if(a.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...k[i]};const u={type:"object",default:this.defaultValues[i],description:b.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};m.push(n(i)),this.configurationProperties[i]=u,this.defaultLanguageConfigurationOverridesNode.properties[i]=u}else{this.defaultValues[i]=k[i];const u=this.configurationProperties[i];u&&(this.updatePropertyDefaultValue(i,u),this.updateSchema(i,u))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(y){const a=[];for(const m of y)for(const k in m)if(a.push(k),delete this.defaultValues[k],e.OVERRIDE_PROPERTY_PATTERN.test(k))delete this.configurationProperties[k],delete this.defaultLanguageConfigurationOverridesNode.properties[k];else{const i=this.configurationProperties[k];i&&(this.updatePropertyDefaultValue(k,i),this.updateSchema(k,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...y){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(y){for(const a of y)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(y,a=!0,m,k=3){k=M.isUndefinedOrNull(y.scope)?k:y.scope;let i=[],u=y.properties;if(u)for(let o in u){if(a&&s(o)){delete u[o];continue}const w=u[o];if(this.updatePropertyDefaultValue(o,w),e.OVERRIDE_PROPERTY_PATTERN.test(o)?w.scope=void 0:(w.scope=M.isUndefinedOrNull(w.scope)?k:w.scope,w.restricted=M.isUndefinedOrNull(w.restricted)?!!m?.restrictedConfigurations?.includes(o):w.restricted),u[o].hasOwnProperty("included")&&!u[o].included){this.excludedConfigurationProperties[o]=u[o],delete u[o];continue}else this.configurationProperties[o]=u[o];!u[o].deprecationMessage&&u[o].markdownDeprecationMessage&&(u[o].deprecationMessage=u[o].markdownDeprecationMessage),i.push(o)}let r=y.allOf;if(r)for(let o of r)i.push(...this.validateAndRegisterProperties(o,a,m,k));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(y){const a=m=>{let k=m.properties;if(k)for(const u in k)this.updateSchema(u,k[u]);let i=m.allOf;i&&i.forEach(a)};a(y)}updateSchema(y,a){switch(e.allSettings.properties[y]=a,a.scope){case 1:e.applicationSettings.properties[y]=a;break;case 2:e.machineSettings.properties[y]=a;break;case 6:e.machineOverridableSettings.properties[y]=a;break;case 3:e.windowSettings.properties[y]=a;break;case 4:e.resourceSettings.properties[y]=a;break;case 5:e.resourceSettings.properties[y]=a,this.resourceLanguageSettingsSchema.properties[y]=a;break}}removeFromSchema(y,a){switch(delete e.allSettings.properties[y],a.scope){case 1:delete e.applicationSettings.properties[y];break;case 2:delete e.machineSettings.properties[y];break;case 6:delete e.machineOverridableSettings.properties[y];break;case 3:delete e.windowSettings.properties[y];break;case 4:case 5:delete e.resourceSettings.properties[y];break}}updateOverridePropertyPatternKey(){for(const y of this.overrideIdentifiers.values()){const a=`[${y}]`,m={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,m),e.allSettings.properties[a]=m,e.applicationSettings.properties[a]=m,e.machineSettings.properties[a]=m,e.machineOverridableSettings.properties[a]=m,e.windowSettings.properties[a]=m,e.resourceSettings.properties[a]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(y,a){let m=this.defaultValues[y];M.isUndefined(m)&&(m=a.default),M.isUndefined(m)&&(m=f(a.type)),a.default=m}}const E="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(E);function n(I){return I.substring(1,I.length-1)}e.overrideIdentifierFromKey=n;function f(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const l=new t;F.Registry.add(e.Extensions.Configuration,l);function s(I){return I.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(I)?b.localize(5,null,I):l.getConfigurationProperties()[I]!==void 0?b.localize(6,null,I):null:b.localize(4,null)}e.validateProperty=s;function v(){const I=[],y=l.getConfigurationProperties();for(const a of Object.keys(y))I.push([a,y[a].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=v}),define(be[84],Ee([0,1,22,10,2,62,4,28]),function(ie,e,h,M,b,T,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,F.createDecorator)("configurationService");function _(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof b.URI)}e.isConfigurationOverrides=_;var P;(function(u){u[u.USER=1]="USER",u[u.USER_LOCAL=2]="USER_LOCAL",u[u.USER_REMOTE=3]="USER_REMOTE",u[u.WORKSPACE=4]="WORKSPACE",u[u.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",u[u.DEFAULT=6]="DEFAULT",u[u.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(u){switch(u){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function E(u,r){const o=r?u?r.keys.filter(D=>u.keys.indexOf(D)===-1):[...r.keys]:[],w=u?r?u.keys.filter(D=>r.keys.indexOf(D)===-1):[...u.keys]:[],d=[];if(r&&u){for(const D of u.keys)if(r.keys.indexOf(D)!==-1){const c=I(u.contents,D),A=I(r.contents,D);h.equals(c,A)||d.push(D)}}const g=[],S=D=>{const c={};for(const A of D)for(const O of A.identifiers)c[k(O)]=A;return c},R=r?S(r.overrides):{},p=u?S(u.overrides):{};if(Object.keys(R).length)for(const D of o){const c=R[D];c&&g.push([(0,T.overrideIdentifierFromKey)(D),c.keys])}if(Object.keys(p).length)for(const D of w){const c=p[D];c&&g.push([(0,T.overrideIdentifierFromKey)(D),c.keys])}if(Object.keys(R).length&&Object.keys(p).length)for(const D of d){const c=p[D],A=R[D];if(c&&A){const O=E({contents:c.contents,keys:c.keys,overrides:[]},{contents:A.contents,keys:A.keys,overrides:[]});g.push([(0,T.overrideIdentifierFromKey)(D),[...O.added,...O.removed,...O.updated]])}}return{added:o,removed:w,updated:d,overrides:g}}e.compare=E;function n(u,r){const o=[];for(const w of Object.keys(u))if(T.OVERRIDE_PROPERTY_PATTERN.test(w)){const d={};for(const g in u[w])d[g]=u[w][g];o.push({identifiers:[(0,T.overrideIdentifierFromKey)(w).trim()],keys:Object.keys(d),contents:f(d,r)})}return o}e.toOverrides=n;function f(u,r){const o=Object.create(null);for(let w in u)l(o,w,u[w],r);return o}e.toValuesTree=f;function l(u,r,o,w){const d=r.split("."),g=d.pop();let S=u;for(let R=0;R<d.length;R++){let p=d[R],D=S[p];switch(typeof D){case"undefined":D=S[p]=Object.create(null);break;case"object":break;default:w(`Ignoring ${r} as ${d.slice(0,R+1).join(".")} is ${JSON.stringify(D)}`);return}S=D}if(typeof S=="object"&&S!==null)try{S[g]=o}catch(R){w(`Ignoring ${r} as ${d.join(".")} is ${JSON.stringify(S)}`)}else w(`Ignoring ${r} as ${d.join(".")} is ${JSON.stringify(S)}`)}e.addToValueTree=l;function s(u,r){const o=r.split(".");v(u,o)}e.removeFromValueTree=s;function v(u,r){const o=r.shift();if(r.length===0){delete u[o];return}if(Object.keys(u).indexOf(o)!==-1){const w=u[o];typeof w=="object"&&!Array.isArray(w)&&(v(w,r),Object.keys(w).length===0&&delete u[o])}}function I(u,r,o){function w(S,R){let p=S;for(const D of R){if(typeof p!="object"||p===null)return;p=p[D]}return p}const d=r.split("."),g=w(u,d);return typeof g=="undefined"?o:g}e.getConfigurationValue=I;function y(u,r,o){Object.keys(r).forEach(w=>{w!=="__proto__"&&(w in u?M.isObject(u[w])&&M.isObject(r[w])?y(u[w],r[w],o):o&&(u[w]=r[w]):u[w]=r[w])})}e.merge=y;function a(){const u=C.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(u)}e.getConfigurationKeys=a;function m(){const u=Object.create(null),r=C.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let o in r){let w=r[o].default;l(u,o,w,d=>console.error(`Conflict in default settings: ${d}`))}return u}e.getDefaultValues=m;function k(u){return`[${u}]`}e.keyFromOverrideIdentifier=k;function i(u,r,o){const w=u.inspect(r),d=u.inspect(o);return typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:w.defaultValue}e.getMigratedSettingValue=i}),define(be[148],Ee([0,1,13,3,102,6,20,22,10,2,84,62,28]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(i={},u=[],r=[]){this._contents=i,this._keys=u,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,u){const r=this.getContentsForOverrideIdentifer(u);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const u of this.overrides)if(u.identifiers.indexOf(i)!==-1)return u.keys;return[]}override(i){const u=this.getContentsForOverrideIdentifer(i);if(!u||typeof u!="object"||!Object.keys(u).length)return this;let r={};for(const o of h.distinct([...Object.keys(this.contents),...Object.keys(u)])){let w=this.contents[o],d=u[o];d&&(typeof w=="object"&&typeof d=="object"?(w=C.deepClone(w),this.mergeContents(w,d)):w=d),r[o]=w}return new f(r,this.keys,this.overrides)}merge(...i){const u=C.deepClone(this.contents),r=C.deepClone(this.overrides),o=[...this.keys];for(const w of i){this.mergeContents(u,w.contents);for(const d of w.overrides){const[g]=r.filter(S=>h.equals(S.identifiers,d.identifiers));g?this.mergeContents(g.contents,d.contents):r.push(C.deepClone(d))}for(const d of w.keys)o.indexOf(d)===-1&&o.push(d)}return new f(u,o,r)}freeze(){return this.isFrozen=!0,this}mergeContents(i,u){for(const r of Object.keys(u)){if(r in i&&_.isObject(i[r])&&_.isObject(u[r])){this.mergeContents(i[r],u[r]);continue}i[r]=C.deepClone(u[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?C.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const u of this.overrides)if(u.identifiers.indexOf(i)!==-1)return u.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,u){this.addKey(i),(0,t.addToValueTree)(this.contents,i,u,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let u=this.keys.length;for(let r=0;r<u;r++)i.indexOf(this.keys[r])===0&&(u=r);this.keys.splice(u,1,i)}removeKey(i){let u=this.keys.indexOf(i);return u!==-1?(this.keys.splice(u,1),!0):!1}}e.ConfigurationModel=f;class l extends f{constructor(){const i=(0,t.getDefaultValues)(),u=(0,t.getConfigurationKeys)(),r=[];for(const o of Object.keys(i))E.OVERRIDE_PROPERTY_PATTERN.test(o)&&r.push({identifiers:[(0,E.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(i[o]),contents:(0,t.toValuesTree)(i[o],w=>console.error(`Conflict in default settings file: ${w}`))});super(i,u,r)}}e.DefaultConfigurationModel=l;class s{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,u){if(!_.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,u)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,u){this._raw=i;const{contents:r,keys:o,overrides:w,restricted:d}=this.doParseRaw(i,u);this._configurationModel=new f(r,o,w),this._restrictedConfigurations=d||[]}doParseContent(i){let u={},r=null,o=[],w=[],d=[];function g(R){Array.isArray(o)?o.push(R):r!==null&&(o[r]=R)}let S={onObjectBegin:()=>{let R={};g(R),w.push(o),o=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{o=w.pop()},onArrayBegin:()=>{let R=[];g(R),w.push(o),o=R,r=null},onArrayEnd:()=>{o=w.pop()},onLiteralValue:g,onError:(R,p,D)=>{d.push({error:R,offset:p,length:D})}};if(i)try{b.visit(i,S),u=o[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return u}doParseRaw(i,u){const r=n.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,r,!0,u);i=o.raw;const w=(0,t.toValuesTree)(i,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),d=Object.keys(i),g=(0,t.toOverrides)(i,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:w,keys:d,overrides:g,restricted:o.restricted}}filter(i,u,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const w={},d=[];for(let g in i)if(E.OVERRIDE_PROPERTY_PATTERN.test(g)&&r){const S=this.filter(i[g],u,!1,o);w[g]=S.raw,d.push(...S.restricted)}else{const S=u[g],R=S?typeof S.scope!="undefined"?S.scope:3:void 0;S?.restricted&&d.push(g),(R===void 0||o.scopes===void 0||o.scopes.includes(R))&&(o.skipRestricted&&S?.restricted||(w[g]=i[g]))}return{raw:w,restricted:d}}}e.ConfigurationModelParser=s;class v extends T.Disposable{constructor(i,u,r,o){super();this.userSettingsResource=i,this.scopes=u,this.fileService=o,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new s(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,w=>w.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class I{constructor(i,u,r=new f,o=new f,w=new F.ResourceMap,d=new f,g=new F.ResourceMap,S=!0){this._defaultConfiguration=i,this._localUserConfiguration=u,this._remoteUserConfiguration=r,this._workspaceConfiguration=o,this._folderConfigurations=w,this._memoryConfiguration=d,this._memoryConfigurationByResource=g,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(i,u,r){return this.getConsolidateConfigurationModel(u,r).getValue(i)}updateValue(i,u,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new f,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,u===void 0?o.removeValue(i):o.setValue(i,u),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,u,r){const o=this.getConsolidateConfigurationModel(u,r),w=this.getFolderConfigurationModelForResource(u.resource,r),d=u.resource?this._memoryConfigurationByResource.get(u.resource)||this._memoryConfiguration:this._memoryConfiguration,g=u.overrideIdentifier?this._defaultConfiguration.freeze().override(u.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),S=u.overrideIdentifier?this.userConfiguration.freeze().override(u.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),R=u.overrideIdentifier?this.localUserConfiguration.freeze().override(u.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),p=u.overrideIdentifier?this.remoteUserConfiguration.freeze().override(u.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),D=r?u.overrideIdentifier?this._workspaceConfiguration.freeze().override(u.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,c=w?u.overrideIdentifier?w.freeze().override(u.overrideIdentifier).getValue(i):w.freeze().getValue(i):void 0,A=u.overrideIdentifier?d.override(u.overrideIdentifier).getValue(i):d.getValue(i),O=o.getValue(i),z=h.distinct(h.flatten(o.overrides.map(K=>K.identifiers))).filter(K=>o.getOverrideValue(i,K)!==void 0);return{defaultValue:g,userValue:S,userLocalValue:R,userRemoteValue:p,workspaceValue:D,workspaceFolderValue:c,memoryValue:A,value:O,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:u.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:u.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:u.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,userRemote:p!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:u.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,workspace:D!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:u.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,workspaceFolder:c!==void 0?{value:w?.freeze().getValue(i),override:u.overrideIdentifier?w?.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,memory:A!==void 0?{value:d.getValue(i),override:u.overrideIdentifier?d.getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(i){const u=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:u?u.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,u){this._folderConfigurations.set(i,u),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,u){const r=u.filter(o=>E.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const w=(0,E.overrideIdentifierFromKey)(o),d=this._defaultConfiguration.getKeysForOverrideIdentifier(w),g=i.getKeysForOverrideIdentifier(w),S=[...g.filter(R=>d.indexOf(R)===-1),...d.filter(R=>g.indexOf(R)===-1),...d.filter(R=>!C.equals(this._defaultConfiguration.override(w).getValue(R),i.override(w).getValue(R)))];return[w,S]});return this.updateDefaultConfiguration(i),{keys:u,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:u,updated:r,removed:o,overrides:w}=(0,t.compare)(this.localUserConfiguration,i),d=[...u,...r,...o];return d.length&&this.updateLocalUserConfiguration(i),{keys:d,overrides:w}}compareAndUpdateRemoteUserConfiguration(i){const{added:u,updated:r,removed:o,overrides:w}=(0,t.compare)(this.remoteUserConfiguration,i);let d=[...u,...r,...o];return d.length&&this.updateRemoteUserConfiguration(i),{keys:d,overrides:w}}compareAndUpdateWorkspaceConfiguration(i){const{added:u,updated:r,removed:o,overrides:w}=(0,t.compare)(this.workspaceConfiguration,i);let d=[...u,...r,...o];return d.length&&this.updateWorkspaceConfiguration(i),{keys:d,overrides:w}}compareAndUpdateFolderConfiguration(i,u){const r=this.folderConfigurations.get(i),{added:o,updated:w,removed:d,overrides:g}=(0,t.compare)(r,u);let S=[...o,...w,...d];return(S.length||!r)&&this.updateFolderConfiguration(i,u),{keys:S,overrides:g}}compareAndDeleteFolderConfiguration(i){const u=this.folderConfigurations.get(i);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:o,removed:w,overrides:d}=(0,t.compare)(u,void 0);return{keys:[...r,...o,...w],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,u){let r=this.getConsolidatedConfigurationModelForResource(i,u);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},u){let r=this.getWorkspaceConsolidatedConfiguration();if(u&&i){const o=u.getFolder(i);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const w=this._memoryConfigurationByResource.get(i);w&&(r=r.merge(w))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let u=this._foldersConsolidatedConfigurations.get(i);if(!u){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(u=r.merge(o),this._freeze&&(u=u.freeze()),this._foldersConsolidatedConfigurations.set(i,u)):u=r}return u}getFolderConfigurationModelForResource(i,u){if(u&&i){const r=u.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,u)=>{const{contents:r,overrides:o,keys:w}=this._folderConfigurations.get(u);return i.push([u,{contents:r,overrides:o,keys:w}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(u=>i.add(u)),this.userConfiguration.freeze().keys.forEach(u=>i.add(u)),this._workspaceConfiguration.freeze().keys.forEach(u=>i.add(u)),this._folderConfigurations.forEach(u=>u.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const u=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>u.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>u.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>u.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(o=>u.add(o))),[...u.values()]}static parse(i){const u=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),w=i.folders.reduce((d,g)=>(d.set(P.URI.revive(g[0]),this.parseConfigurationModel(g[1])),d),new F.ResourceMap);return new I(u,r,new f,o,w,new f,new F.ResourceMap,!1)}static parseConfigurationModel(i){return new f(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=I;function y(...k){if(k.length===0)return{keys:[],overrides:[]};if(k.length===1)return k[0];const i=new Set,u=new Map;for(const o of k)o.keys.forEach(w=>i.add(w)),o.overrides.forEach(([w,d])=>{const g=(0,F.getOrSet)(u,w,new Set);d.forEach(S=>g.add(S))});const r=[];return u.forEach((o,w)=>r.push([w,[...o.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=y;class a{constructor(i,u,r,o){this.change=i,this.previous=u,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const w=new Set;i.keys.forEach(g=>w.add(g)),i.overrides.forEach(([,g])=>g.forEach(S=>w.add(S))),this.affectedKeys=[...w.values()];const d=new f;this.affectedKeys.forEach(g=>d.setValue(g,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,u){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(u){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,u,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,u,this.currentWorkspace);return!C.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(i,u){let r=(0,t.toValuesTree)({[u]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(i=i[o],!i)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=a;class m extends a{constructor(i,u,r,o){super({keys:i.allKeys(),overrides:[]},void 0,i,u);this.source=r,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=m}),define(be[85],Ee([0,1,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,h.createDecorator)("remoteAuthorityResolverService");var M;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class b extends Error{constructor(F,C=M.Unknown,_){super(F);this._message=F,this._code=C,this._detail=_,this.isHandled=C===M.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype)}static isTemporarilyNotAvailable(F){return F instanceof b&&F._code===M.TemporarilyNotAvailable}static isNoResolverFound(F){return F instanceof b&&F._code===M.NoResolverFound}static isHandled(F){return F instanceof b&&F.isHandled}}e.RemoteAuthorityResolverError=b}),define(be[86],Ee([0,1,11]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(P){return P.scheme===h.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=M;function b(P){if(!P)return;const t=P.indexOf("+");return t<0?P:P.substr(0,t)}e.getRemoteName=b;function T(P){return P.scheme!==h.Schemas.file&&P.scheme!==h.Schemas.vscodeRemote}e.isVirtualResource=T;function F(P){if(P.folders.length)return P.folders.every(t=>T(t.uri))?P.folders[0].uri:void 0;if(P.configuration&&T(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=F;function C(P){return F(P)?.scheme}e.getVirtualWorkspaceScheme=C;function _(P){return F(P)!==void 0}e.isVirtualWorkspace=_}),define(be[149],Ee([0,1,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.TerminalPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var M;(function(s){s.Shell="terminal.integrated.shell.",s.ShellArgs="terminal.integrated.shellArgs.",s.DefaultProfile="terminal.integrated.defaultProfile.",s.Profiles="terminal.integrated.profiles."})(M=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var b;(function(s){s.ShellLinux="terminal.integrated.shell.linux",s.ShellMacOs="terminal.integrated.shell.osx",s.ShellWindows="terminal.integrated.shell.windows",s.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",s.AutomationShellLinux="terminal.integrated.automationShell.linux",s.AutomationShellMacOs="terminal.integrated.automationShell.osx",s.AutomationShellWindows="terminal.integrated.automationShell.windows",s.ShellArgsLinux="terminal.integrated.shellArgs.linux",s.ShellArgsMacOs="terminal.integrated.shellArgs.osx",s.ShellArgsWindows="terminal.integrated.shellArgs.windows",s.ProfilesWindows="terminal.integrated.profiles.windows",s.ProfilesMacOs="terminal.integrated.profiles.osx",s.ProfilesLinux="terminal.integrated.profiles.linux",s.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",s.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",s.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",s.UseWslProfiles="terminal.integrated.useWslProfiles",s.TabsEnabled="terminal.integrated.tabs.enabled",s.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",s.TabsHideCondition="terminal.integrated.tabs.hideCondition",s.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",s.TabsShowActions="terminal.integrated.tabs.showActions",s.TabsLocation="terminal.integrated.tabs.location",s.TabsFocusMode="terminal.integrated.tabs.focusMode",s.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",s.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",s.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",s.CopyOnSelection="terminal.integrated.copyOnSelection",s.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",s.FontFamily="terminal.integrated.fontFamily",s.FontSize="terminal.integrated.fontSize",s.LetterSpacing="terminal.integrated.letterSpacing",s.LineHeight="terminal.integrated.lineHeight",s.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",s.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",s.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",s.BellDuration="terminal.integrated.bellDuration",s.FontWeight="terminal.integrated.fontWeight",s.FontWeightBold="terminal.integrated.fontWeightBold",s.CursorBlinking="terminal.integrated.cursorBlinking",s.CursorStyle="terminal.integrated.cursorStyle",s.CursorWidth="terminal.integrated.cursorWidth",s.Scrollback="terminal.integrated.scrollback",s.DetectLocale="terminal.integrated.detectLocale",s.DefaultLocation="terminal.integrated.defaultLocation",s.GpuAcceleration="terminal.integrated.gpuAcceleration",s.TerminalTitleSeparator="terminal.integrated.tabs.separator",s.TerminalTitle="terminal.integrated.tabs.title",s.TerminalDescription="terminal.integrated.tabs.description",s.RightClickBehavior="terminal.integrated.rightClickBehavior",s.Cwd="terminal.integrated.cwd",s.ConfirmOnExit="terminal.integrated.confirmOnExit",s.ConfirmOnKill="terminal.integrated.confirmOnKill",s.EnableBell="terminal.integrated.enableBell",s.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",s.AllowChords="terminal.integrated.allowChords",s.AllowMnemonics="terminal.integrated.allowMnemonics",s.EnvMacOs="terminal.integrated.env.osx",s.EnvLinux="terminal.integrated.env.linux",s.EnvWindows="terminal.integrated.env.windows",s.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",s.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",s.ShowExitAlert="terminal.integrated.showExitAlert",s.SplitCwd="terminal.integrated.splitCwd",s.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",s.WordSeparators="terminal.integrated.wordSeparators",s.TitleMode="terminal.integrated.titleMode",s.EnableFileLinks="terminal.integrated.enableFileLinks",s.UnicodeVersion="terminal.integrated.unicodeVersion",s.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",s.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",s.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",s.LocalEchoStyle="terminal.integrated.localEchoStyle",s.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",s.CustomGlyphs="terminal.integrated.customGlyphs",s.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",s.PersistentSessionExperimentalSerializer="terminal.integrated.persistentSessionExperimentalSerializer",s.InheritEnv="terminal.integrated.inheritEnv",s.ShowLinkHover="terminal.integrated.showLinkHover"})(b=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(s){s.CommandPrompt="cmd",s.PowerShell="pwsh",s.Wsl="wsl",s.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var F;(function(s){s[s.Api=0]="Api",s[s.Process=1]="Process",s[s.Sequence=2]="Sequence",s[s.Config=3]="Config"})(F=e.TitleEventSource||(e.TitleEventSource={}));var C;(function(s){s.LocalPty="localPty",s.PtyHost="ptyHost",s.Log="log",s.Heartbeat="heartbeat"})(C=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,h.createDecorator)("ptyService");var _;(function(s){s[s.Cwd=0]="Cwd",s[s.InitialCwd=1]="InitialCwd"})(_=e.TerminalPropertyType||(e.TerminalPropertyType={}));var P;(function(s){s[s.BeatInterval=5e3]="BeatInterval",s[s.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",s[s.SecondWaitMultiplier=1]="SecondWaitMultiplier",s[s.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(P=e.HeartbeatConstants||(e.HeartbeatConstants={}));var t;(function(s){s[s.Panel=1]="Panel",s[s.Editor=2]="Editor"})(t=e.TerminalLocation||(e.TerminalLocation={}));var E;(function(s){s.TerminalView="view",s.Editor="editor"})(E=e.TerminalLocationString||(e.TerminalLocationString={}));var n;(function(s){s[s.GraceTime=6e4]="GraceTime",s[s.ShortGraceTime=6e3]="ShortGraceTime"})(n=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var f;(function(s){s[s.HighWatermarkChars=1e5]="HighWatermarkChars",s[s.LowWatermarkChars=5e3]="LowWatermarkChars",s[s.CharCountAckSize=5e3]="CharCountAckSize"})(f=e.FlowControlConstants||(e.FlowControlConstants={}));var l;(function(s){s.GitBash="Git Bash",s.Pwsh="PowerShell"})(l=e.ProfileSource||(e.ProfileSource={}))}),define(be[150],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class h{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,T,F=5){let C;return C=T(_=>{const P=typeof _=="string"?_:_.data;let t=this._terminalBufferMap.get(b);if(t){t.data.push(P);return}const E=setTimeout(()=>this.flushBuffer(b),F);t={data:[P],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(b),C.dispose()}},this._terminalBufferMap.set(b,t)}),C}stopBuffering(b){const T=this._terminalBufferMap.get(b);T&&T.dispose()}flushBuffer(b){const T=this._terminalBufferMap.get(b);T&&(this._terminalBufferMap.delete(b),this._callback(b,T.data.join("")))}}e.TerminalDataBufferer=h}),define(be[151],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var h;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(h=e.ColorScheme||(e.ColorScheme={}))}),define(be[44],Ee([0,1,34,3,6,4,28,151]),function(ie,e,h,M,b,T,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var _;(function(v){function I(y){return y&&typeof y=="object"&&typeof y.id=="string"}v.isThemeColor=I})(_=e.ThemeColor||(e.ThemeColor={}));function P(v){return{id:v}}e.themeColorFromId=P;var t;(function(v){function I(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color=="undefined"||_.isThemeColor(u.color))}v.isThemeIcon=I;const y=new RegExp(`^\\$\\((${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?)\\)$`);function a(u){const r=y.exec(u);if(!r)return;let[,o]=r;return{id:o}}v.fromString=a;function m(u,r){let o=u.id;const w=o.lastIndexOf("~");return w!==-1&&(o=o.substring(0,w)),r&&(o=`${o}~${r}`),{id:o}}v.modify=m;function k(u,r){return u.id===r.id&&u.color?.id===r.color?.id}v.isEqual=k;function i(u,r){return{id:u.id,color:r?P(r):void 0}}v.asThemeIcon=i,v.asClassNameArray=h.CSSIcon.asClassNameArray,v.asClassName=h.CSSIcon.asClassName,v.asCSSSelector=h.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=h.Codicon.file,e.FolderThemeIcon=h.Codicon.folder;function E(v){switch(v){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,b.toDisposable)(()=>{const y=this.themingParticipants.indexOf(I);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new n;F.Registry.add(e.Extensions.ThemingContribution,f);function l(v){return f.onColorThemeChange(v)}e.registerThemingParticipant=l;class s extends b.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,y){let a=this.theme.getColor(I);return a&&y&&(a=y(a,this.theme)),a?a.toString():null}}e.Themable=s}),define(be[152],Ee([0,1,14,34,3,123,83,28,44]),function(ie,e,h,M,b,T,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(I,y,a,m){const k=this.iconsById[I];if(k){if(a&&!k.description){k.description=a,this.iconSchema.properties[I].markdownDescription=`${a} $(${I})`;const r=this.iconReferenceSchema.enum.indexOf(I);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=a),this._onDidChange.fire()}return k}let i={id:I,description:a,defaults:y,deprecationMessage:m};this.iconsById[I]=i;let u={$ref:"#/definitions/icons"};return m&&(u.deprecationMessage=m),a&&(u.markdownDescription=`${a}: $(${I})`),this.iconSchema.properties[I]=u,this.iconReferenceSchema.enum.push(I),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:I}}deregisterIcon(I){delete this.iconsById[I],delete this.iconSchema.properties[I];const y=this.iconReferenceSchema.enum.indexOf(I);y!==-1&&(this.iconReferenceSchema.enum.splice(y,1),this.iconReferenceSchema.enumDescriptions.splice(y,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(I=>this.iconsById[I])}getIcon(I){return this.iconsById[I]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(I,y){const a=this.iconFontsById[I];if(a)return a;let m={id:I,definition:y};return this.iconFontsById[I]=m,this._onDidChange.fire(),m}deregisterIconFont(I){delete this.iconFontsById[I]}getIconFonts(){return Object.keys(this.iconFontsById).map(I=>this.iconFontsById[I])}getIconFont(I){return this.iconFontsById[I]}toString(){const I=(k,i)=>k.id.localeCompare(i.id),y=k=>{for(;_.ThemeIcon.isThemeIcon(k.defaults);)k=this.iconsById[k.defaults.id];return`codicon codicon-${k?k.id:""}`};let a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.iconsById).map(k=>this.iconsById[k]);for(const k of m.filter(i=>!!i.description).sort(I))a.push(`|<i class="${y(k)}"></i>|${k.id}|${_.ThemeIcon.isThemeIcon(k.defaults)?k.defaults.id:k.id}|${k.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const k of m.filter(i=>!_.ThemeIcon.isThemeIcon(i.defaults)).sort(I))a.push(`|<i class="${y(k)}"></i>|${k.id}|`);return a.join(`
`)}}const t=new P;C.Registry.add(e.Extensions.IconContribution,t);function E(v,I,y,a){return t.registerIcon(v,I,y,a)}e.registerIcon=E;function n(){return t}e.getIconRegistry=n;function f(){for(const v of M.iconRegistry.all)t.registerIcon(v.id,v.definition,v.description);M.iconRegistry.onDidRegister(v=>t.registerIcon(v.id,v.definition,v.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let l=C.Registry.as(F.Extensions.JSONContribution);l.registerSchema(e.iconsSchemaId,t.getIconSchema());const s=new h.RunOnceScheduler(()=>l.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.widgetClose=E("widget-close",M.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=E("goto-previous-location",M.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=E("goto-next-location",M.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=_.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(be[45],Ee([0,1,20,24,2,4]),function(ie,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var F;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(F=e.WorkbenchState||(e.WorkbenchState={}));function C(n){const f=n;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=C;function _(n){const f=n;return!!(f&&typeof f=="object"&&b.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=_;class P{constructor(f,l,s,v){this._id=f,this._configuration=s,this._ignorePathCasing=v,this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class t{constructor(f,l){this.raw=l,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,M.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function E(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=E}),define(be[63],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class h{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const T=this._idPool++;return this._data.set(T,b),this.logDebugInfo(),T}get(b,T){return this._data.has(b)?this._data.get(b)[T]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!h.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=h,h.enableDebugLogging=!1}),define(be[37],Ee([0,1,11,24,4]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(h.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(C=>{const _=this._providerInfo.get(C.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(C,_){_===null?this._providerInfo.delete(C):this._providerInfo.set(C,_)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,h.createDecorator)("IExtHostInitDataService")}),define(be[153],Ee([0,1,14]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(F,C,_){this._deferredPromises=new Map,this._id=F,this._shared=C,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new h.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of P.values())t.complete()}catch(t){for(const E of P.values())E.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this._init}get(F,C){let _=this._value[F];return typeof _=="undefined"&&(_=C),_}update(F,C){this._value[F]=C;let _=this._deferredPromises.get(F);if(_!==void 0)return _.p;const P=new h.DeferredPromise;return this._deferredPromises.set(F,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class b extends M{constructor(F,C){super(F.identifier.value,!0,C);this._extension=F}setKeysForSync(F){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},F)}}e.ExtensionGlobalMemento=b}),define(be[154],Ee([0,1,3,2,15]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(C,_){this._logService=C,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new h.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new h.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(C,_,P){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C)).acceptModelChanged(_.value,P)}$acceptDirtyStateChanged(C,_){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C)).acceptDirty(_)}$acceptModelSaved(C){const _=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(C,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",C.path,_);const P=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C));P.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};T=Ue([He(0,b.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(be[12],Ee([0,1,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,h.createDecorator)("IExtHostRpcService");class M{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=M});var Je=this&&this.__classPrivateFieldSet||function(ie,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ie,h):b?b.value=h:e.set(ie,h),h},Te=this&&this.__classPrivateFieldGet||function(ie,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[155],Ee([0,1,25,3]),function(ie,e,h,M){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(C,_){b.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=h.ExtensionIdentifier.toKey(C.identifier),Je(this,b,_,"f"),Te(this,b,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(C){return Te(this,b,"f").get(this._id,C)}store(C,_){return Te(this,b,"f").store(this._id,C,_)}delete(C){return Te(this,b,"f").delete(this._id,C)}}e.ExtensionSecrets=T,b=new WeakMap}),define(be[87],Ee([0,1,4,3]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class b{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(F){this._enabled=F}$onDidChangeTelemetryEnabled(F){this._enabled=F,this._onDidChangeTelemetryEnabled.fire(F)}}e.ExtHostTelemetry=b,e.IExtHostTelemetry=(0,h.createDecorator)("IExtHostTelemetry")}),define(be[46],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var h;(function(y){y[y.Upsert=0]="Upsert",y[y.RemoveChild=1]="RemoveChild",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp",y[y.Bulk=4]="Bulk"})(h=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,b=(y,a)=>{const m={controllerId:a};return M.set(y,m),m};e.createPrivateApiFor=b;const T=y=>M.get(y);e.getPrivateApiFor=T;const F=(y,a,m,k)=>{let i=m;return{enumerable:!0,configurable:!1,get(){return i},set(u){if(!k(i,u)){const r=i;i=u,y.listener?.({op:3,key:a,value:u,previous:r})}}}},C=(y,a)=>y===a,_={range:(y,a)=>y===a?!0:!y||!a?!1:y.isEqual(a),label:C,description:C,busy:C,error:C,canResolveChildren:C,tags:(y,a)=>!(y.length!==a.length||y.some(m=>!a.find(k=>m.id===k.id)))},P=Object.keys(_),t=(y,a)=>({range:F(y,"range",void 0,_.range),label:F(y,"label",a,_.label),description:F(y,"description",void 0,_.description),canResolveChildren:F(y,"canResolveChildren",!1,_.canResolveChildren),busy:F(y,"busy",!1,_.busy),error:F(y,"error",void 0,_.error),tags:F(y,"tags",[],_.tags)}),E=(y,a)=>{const m=new Map;for(const k of P)_[k](y[k],a[k])||m.set(k,a[k]);return m};e.diffTestItems=E;class n extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=n;class f extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class l extends Error{constructor(a,m,k){super(`TestItem with ID "${a}" is from controller "${m}" and cannot be added as a child of an item from controller "${k}".`)}}e.MixedTestItemController=l;const s=y=>{const a=(0,e.getPrivateApiFor)(y);let m=new Map;return{get size(){return m.size},forEach(k,i){for(const u of m.values())k.call(i,u,this)},replace(k){const i=new Map,u=new Set(m.keys()),r={op:4,ops:[]};for(const o of k){if(!(o instanceof v))throw new f(o.id);const w=(0,e.getPrivateApiFor)(o).controllerId;if(w!==a.controllerId)throw new l(o.id,w,a.controllerId);if(i.has(o.id))throw new n(o.id);i.set(o.id,o),u.delete(o.id),r.ops.push({op:0,item:o})}for(const o of u.keys())r.ops.push({op:1,id:o});a.listener?.(r),m=i},add(k){if(!(k instanceof v))throw new f(k.id);m.set(k.id,k),a.listener?.({op:0,item:k})},delete(k){m.delete(k)&&a.listener?.({op:1,id:k})},get(k){return m.get(k)},toJSON(){return Array.from(m.values())},[Symbol.iterator](){return m.values()}}};class v{constructor(a,m,k,i){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const u=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof I?void 0:u.parent}},children:{value:s(this),enumerable:!0,writable:!1},...t(u,k)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class I extends v{constructor(a,m){super(a,a,m,void 0)}}e.TestItemRootImpl=I}),define(be[64],Ee([0,1,4,3,12]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(C){function _(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,protocol:t.protocol}}C.fromApiTunnel=_;function P(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.public,protocol:t.protocol}}C.fromServiceTunnel=P})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,h.createDecorator)("IExtHostTunnelService");let F=class{constructor(_){this.onDidChangeTunnels=new M.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,P){return{dispose:()=>{}}}async $providePortAttributes(_,P,t,E,n){return[]}async $forwardPort(_,P){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};F=Ue([He(0,b.IExtHostRpcService)],F),e.ExtHostTunnelService=F});var Je=this&&this.__classPrivateFieldSet||function(ie,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ie,h):b?b.value=h:e.set(ie,h),h},Te=this&&this.__classPrivateFieldGet||function(ie,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[7],Ee([0,1,13,16,76,20,78,10,2,36,60,85]),function(ie,e,h,M,b,T,F,C,_,P,t,E){"use strict";var n,f,l,s,v,I,y,a,m,k,i,u,r,o,w,d,g,S,R,p;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function D(N){function L(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(L,N),Object.setPrototypeOf(L.prototype,N.prototype),L}let c=v=class{constructor(L){n.set(this,void 0),Je(this,n,L,"f")}static from(...L){let te=L;return new v(function(){if(te){for(const _e of te)_e&&typeof _e.dispose=="function"&&_e.dispose();te=void 0}})}dispose(){typeof Te(this,n,"f")=="function"&&(Te(this,n,"f").call(this),Je(this,n,void 0,"f"))}};n=new WeakMap,c=v=Ue([D],c),e.Disposable=c;let A=I=class{constructor(L,te){if(L<0)throw(0,M.illegalArgument)("line must be non-negative");if(te<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=L,this._character=te}static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let _e=1;_e<L.length;_e++){const Ke=L[_e];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let _e=1;_e<L.length;_e++){const Ke=L[_e];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(L){if(!L)return!1;if(L instanceof I)return!0;let{line:te,character:_e}=L;return typeof te=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,te=0){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return typeof L=="undefined"?_e=0:typeof L=="number"?_e=L:(_e=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),_e===0&&te===0?this:new I(this.line+_e,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return typeof L=="undefined"?_e=this.line:typeof L=="number"?_e=L:(_e=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),_e===this.line&&te===this.character?this:new I(_e,te)}toJSON(){return{line:this.line,character:this.character}}};A=I=Ue([D],A),e.Position=A;let O=y=class{constructor(L,te,_e,Ke){let et,st;if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ke=="number"?(et=new A(L,te),st=new A(_e,Ke)):L instanceof A&&te instanceof A&&(et=L,st=te),!et||!st)throw new Error("Invalid arguments");et.isBefore(st)?(this._start=et,this._end=st):(this._start=st,this._end=et)}static isRange(L){return L instanceof y?!0:L?A.isPosition(L.start)&&A.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof y?this.contains(L._start)&&this.contains(L._end):L instanceof A?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const te=A.Max(L.start,this._start),_e=A.Min(L.end,this._end);if(!te.isAfter(_e))return new y(te,_e)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=A.Min(L.start,this._start),_e=A.Max(L.end,this.end);return new y(te,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,te=this.end){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return L?A.isPosition(L)?_e=L:(_e=L.start||this.start,te=L.end||this.end):_e=this.start,_e.isEqual(this._start)&&te.isEqual(this.end)?this:new y(_e,te)}toJSON(){return[this.start,this.end]}};O=y=Ue([D],O),e.Range=O;let z=a=class extends O{constructor(L,te,_e,Ke){let et,st;if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ke=="number"?(et=new A(L,te),st=new A(_e,Ke)):L instanceof A&&te instanceof A&&(et=L,st=te),!et||!st)throw new Error("Invalid arguments");super(et,st);this._anchor=et,this._active=st}static isSelection(L){return L instanceof a?!0:L?O.isRange(L)&&A.isPosition(L.anchor)&&A.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};z=a=Ue([D],z),e.Selection=z;class K{constructor(L,te,_e){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(te),this.connectionToken=_e}}e.ResolvedAuthority=K;class $ extends Error{constructor(L,te=E.RemoteAuthorityResolverErrorCode.Unknown,_e){super(L);this._message=L,this._code=te,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,$.prototype)}static NotAvailable(L,te){return new $(L,E.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new $(L,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=$;var Q;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(Q=e.EndOfLine||(e.EndOfLine={}));var W;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let U=m=class{constructor(L,te){this._range=L,this._newText=te}static isTextEdit(L){return L instanceof m?!0:L?O.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new m(L,te)}static insert(L,te){return m.replace(new O(L,L),te)}static delete(L){return m.replace(L,"")}static setEndOfLine(L){const te=new m(new O(new A(0,0),new A(0,0)),"");return te.newEol=L,te}get range(){return this._range}set range(L){if(L&&!O.isRange(L))throw(0,M.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,M.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,M.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};U=m=Ue([D],U),e.TextEdit=U;var H;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(H=e.FileEditType||(e.FileEditType={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,te,_e,Ke){this._edits.push({_type:1,from:L,to:te,options:_e,metadata:Ke})}createFile(L,te,_e){this._edits.push({_type:1,from:void 0,to:L,options:te,metadata:_e})}deleteFile(L,te,_e){this._edits.push({_type:1,from:L,to:void 0,options:te,metadata:_e})}replaceNotebookMetadata(L,te,_e){this._edits.push({_type:3,metadata:_e,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(L,te,_e,Ke,et){let st,at,yt=[],At;if(zt.isNotebookRange(te)&&Mt.isNotebookCellDataArray(_e)&&!Mt.isNotebookCellDataArray(Ke)?(st=te.start,at=te.end,yt=_e,At=Ke):typeof te=="number"&&typeof _e=="number"&&Mt.isNotebookCellDataArray(Ke)&&(st=te,at=_e,yt=Ke,At=et),st===void 0||at===void 0)throw new Error("Invalid arguments");(st!==at||yt.length>0)&&this._edits.push({_type:5,uri:L,index:st,count:at-st,cells:yt,metadata:At})}replaceNotebookCellMetadata(L,te,_e,Ke){this._edits.push({_type:3,metadata:Ke,uri:L,edit:{editType:8,index:te,metadata:_e}})}replace(L,te,_e,Ke){this._edits.push({_type:2,uri:L,edit:new U(te,_e),metadata:Ke})}insert(L,te,_e,Ke){this.replace(L,new O(te,te),_e,Ke)}delete(L,te,_e){this.replace(L,te,"",_e)}has(L){return this._edits.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const _e of te)_e&&this._edits.push({_type:2,uri:L,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ke=this._edits[_e];Ke._type===2&&Ke.uri.toString()===L.toString()&&(this._edits[_e]=void 0)}(0,h.coalesceInPlace)(this._edits)}}get(L){const te=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===L.toString()&&te.push(_e.edit);return te}entries(){const L=new T.ResourceMap;for(let te of this._edits)if(te._type===2){let _e=L.get(te.uri);_e||(_e=[te.uri,[]],L.set(te.uri,_e)),_e[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};G=Ue([D],G),e.WorkspaceEdit=G;let ue=k=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof k?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=k._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this._tabstop++){if(typeof L=="function"){const _e=new k;_e._tabstop=this._tabstop,L(_e),this._tabstop=_e._tabstop,L=_e.value}else L=k._escape(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this._tabstop++){const _e=L.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const _e=new k;_e._tabstop=this._tabstop,te(_e),this._tabstop=_e._tabstop,te=_e.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};ue=k=Ue([D],ue),e.SnippetString=ue;var q;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(q=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let se=i=class{constructor(L,te){if(this.uri=L,te)if(te instanceof O)this.range=te;else if(te instanceof A)this.range=new O(te,te);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof i?!0:L?O.isRange(L.range)&&_.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};se=i=Ue([D],se),e.Location=se;let ve=class{constructor(L,te){this.location=L,this.message=te}static is(L){return L?typeof L.message=="string"&&L.location&&O.isRange(L.location.range)&&_.URI.isUri(L.location.uri):!1}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};ve=Ue([D],ve),e.DiagnosticRelatedInformation=ve;let Fe=class{constructor(L,te,_e=le.Error){if(!O.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=_e}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,h.equals)(L.tags,te.tags)&&(0,h.equals)(L.relatedInformation,te.relatedInformation,ve.isEqual)}};Fe=Ue([D],Fe),e.Diagnostic=Fe;let Me=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};Me=Ue([D],Me),e.Hover=Me;var Ne;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Ne=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Qe=class{constructor(L,te=Ne.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:Ne[this.kind]}}};Qe=Ue([D],Qe),e.DocumentHighlight=Qe;var ze;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(ze=e.SymbolKind||(e.SymbolKind={}));var qe;(function(N){N[N.Deprecated=1]="Deprecated"})(qe=e.SymbolTag||(e.SymbolTag={}));let x=u=class{constructor(L,te,_e,Ke,et){this.name=L,this.kind=te,this.containerName=et,typeof _e=="string"&&(this.containerName=_e),Ke instanceof se?this.location=Ke:_e instanceof O&&(this.location=new se(Ke,_e)),u.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ze[this.kind],location:this.location,containerName:this.containerName}}};x=u=Ue([D],x),e.SymbolInformation=x;let Y=r=class{constructor(L,te,_e,Ke,et){this.name=L,this.detail=te,this.kind=_e,this.range=Ke,this.selectionRange=et,this.children=[],r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(r.validate)}};Y=r=Ue([D],Y),e.DocumentSymbol=Y;var ee;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(L,te){this.title=L,this.kind=te}};ae=Ue([D],ae),e.CodeAction=ae;let j=o=class{constructor(L){this.value=L}append(L){return new o(this.value?this.value+o.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+o.sep)}};j.sep=".",j=o=Ue([D],j),e.CodeActionKind=j,j.Empty=new j(""),j.QuickFix=j.Empty.append("quickfix"),j.Refactor=j.Empty.append("refactor"),j.RefactorExtract=j.Refactor.append("extract"),j.RefactorInline=j.Refactor.append("inline"),j.RefactorRewrite=j.Refactor.append("rewrite"),j.Source=j.Empty.append("source"),j.SourceOrganizeImports=j.Source.append("organizeImports"),j.SourceFixAll=j.Source.append("fixAll");let oe=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=Ue([D],oe),e.SelectionRange=oe;class fe{constructor(L,te,_e,Ke,et,st){this.kind=L,this.name=te,this.detail=_e,this.uri=Ke,this.range=et,this.selectionRange=st}}e.CallHierarchyItem=fe;class Ae{constructor(L,te){this.fromRanges=te,this.from=L}}e.CallHierarchyIncomingCall=Ae;class xe{constructor(L,te){this.fromRanges=te,this.to=L}}e.CallHierarchyOutgoingCall=xe;var $e;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})($e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let we=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};we=Ue([D],we),e.CodeLens=we;let Ze=w=class{constructor(L,te=!1){f.set(this,void 0),Je(this,f,new b.MarkdownString(L,{supportThemeIcons:te}),"f")}static isMarkdownString(L){return L instanceof w?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Te(this,f,"f").value}set value(L){Te(this,f,"f").value=L}get isTrusted(){return Te(this,f,"f").isTrusted}set isTrusted(L){Te(this,f,"f").isTrusted=L}get supportThemeIcons(){return Te(this,f,"f").supportThemeIcons}set supportThemeIcons(L){Te(this,f,"f").supportThemeIcons=L}get supportHtml(){return Te(this,f,"f").supportHtml}set supportHtml(L){Te(this,f,"f").supportHtml=L}appendText(L){return Te(this,f,"f").appendText(L),this}appendMarkdown(L){return Te(this,f,"f").appendMarkdown(L),this}appendCodeblock(L,te){return Te(this,f,"f").appendCodeblock(te??"",L),this}};f=new WeakMap,Ze=w=Ue([D],Ze),e.MarkdownString=Ze;let V=class{constructor(L,te){this.label=L,this.documentation=te}};V=Ue([D],V),e.ParameterInformation=V;let J=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};J=Ue([D],J),e.SignatureInformation=J;let he=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};he=Ue([D],he),e.SignatureHelp=he;var Oe;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(Oe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ve;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Ve=e.InlayHintKind||(e.InlayHintKind={}));let tt=class{constructor(L,te,_e){this.text=L,this.position=te,this.kind=_e}};tt=Ue([D],tt),e.InlayHint=tt;var ut;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ut=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ht;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(ht=e.CompletionItemKind||(e.CompletionItemKind={}));var St;(function(N){N[N.Deprecated=1]="Deprecated"})(St=e.CompletionItemTag||(e.CompletionItemTag={}));let Pt=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ht[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Pt=Ue([D],Pt),e.CompletionItem=Pt;let dt=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};dt=Ue([D],dt),e.CompletionList=dt;let bt=class{constructor(L,te,_e){this.text=L,this.range=te,this.command=_e}};bt=Ue([D],bt),e.InlineSuggestion=bt;let ft=class{constructor(L){this.items=L}};ft=Ue([D],ft),e.InlineSuggestions=ft;var Et;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var Ye;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Ye=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ct;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Ct=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var De;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Z;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(Z=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ce;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ce=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function L(te){switch(te){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=L}(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(L,te){if(te&&!_.URI.isUri(te))throw(0,M.illegalArgument)("target");if(!O.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.target=te}};ge=Ue([D],ge),e.DocumentLink=ge;let me=class{constructor(L,te,_e,Ke){this.red=L,this.green=te,this.blue=_e,this.alpha=Ke}};me=Ue([D],me),e.Color=me;let Ie=class{constructor(L,te){if(te&&!(te instanceof me))throw(0,M.illegalArgument)("color");if(!O.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.color=te}};Ie=Ue([D],Ie),e.ColorInformation=Ie;let Be=class{constructor(L){if(!L||typeof L!="string")throw(0,M.illegalArgument)("label");this.label=L}};Be=Ue([D],Be),e.ColorPresentation=Be;var Le;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Le=e.ColorFormat||(e.ColorFormat={}));var je;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(je=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Xe{constructor(L,te,_e){if(this.startIndex=L,this.length=te,this.tooltip=_e,typeof L!="number"||L<0)throw(0,M.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=Xe;var ne;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(ne=e.TerminalLocation||(e.TerminalLocation={}));class pe{constructor(L){this.options=L,typeof L!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=pe;var re;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(re=e.TaskRevealKind||(e.TaskRevealKind={}));var B;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(B=e.TaskPanelKind||(e.TaskPanelKind={}));let Ce=d=class{constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,M.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}get id(){return this._id}};Ce.Clean=new d("clean","Clean"),Ce.Build=new d("build","Build"),Ce.Rebuild=new d("rebuild","Rebuild"),Ce.Test=new d("test","Test"),Ce=d=Ue([D],Ce),e.TaskGroup=Ce;function Se(N){let L="";for(let te=0;te<N.length;te++)L+=N[te].replace(/,/g,",,")+",";return L}let Ge=class{constructor(L,te,_e){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=L,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=_e):this._options=te)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let te of this._args)L.push(te);return Se(L)}};Ge=Ue([D],Ge),e.ProcessExecution=Ge;let We=class{constructor(L,te,_e){if(this._args=[],Array.isArray(te)){if(!L)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L,this._args=te,this._options=_e}else{if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L,this._options=te}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)L.push(typeof te=="string"?te:te.value);return Se(L)}};We=Ue([D],We),e.ShellExecution=We;var it;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(it=e.ShellQuoting||(e.ShellQuoting={}));var mt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(mt=e.TaskScope||(e.TaskScope={}));class vt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=vt;let nt=g=class{constructor(L,te,_e,Ke,et,st){this.__deprecated=!1,this._definition=this.definition=L;let at;typeof te=="string"?(this._name=this.name=te,this._source=this.source=_e,this.execution=Ke,at=et,this.__deprecated=!0):te===mt.Global||te===mt.Workspace?(this.target=te,this._name=this.name=_e,this._source=this.source=Ke,this.execution=et,at=st):(this.target=te,this._name=this.name=_e,this._source=this.source=Ke,this.execution=et,at=st),typeof at=="string"?(this._problemMatchers=[at],this._hasDefinedMatchers=!0):Array.isArray(at)?(this._problemMatchers=at,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ge?this._definition={type:g.ProcessType,id:this._execution.computeId()}:this._execution instanceof We?this._definition={type:g.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:g.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:g.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const te=this._definition.type;(g.EmptyType===te||g.ProcessType===te||g.ShellType===te||g.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};nt.ExtensionCallbackType="customExecution",nt.ProcessType="process",nt.ShellType="shell",nt.EmptyType="$empty",nt=g=Ue([D],nt),e.Task=nt;var ot;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(ot=e.ProgressLocation||(e.ProgressLocation={}));let lt=class{constructor(L,te=Rt.None){this.collapsibleState=te,_.URI.isUri(L)?this.resourceUri=L:this.label=L}};lt=Ue([D],lt),e.TreeItem=lt;var Rt;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(Rt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let _t=class{constructor(L,te){this.id=L,this.color=te}};_t=Ue([D],_t),e.ThemeIcon=_t,_t.File=new _t("file"),_t.Folder=new _t("folder");let Ot=class{constructor(L){this.id=L}};Ot=Ue([D],Ot),e.ThemeColor=Ot;var di;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(di=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(L,te){if(typeof L!="string"&&(!L||!_.URI.isUri(L)&&!_.URI.isUri(L.uri)))throw(0,M.illegalArgument)("base");if(typeof te!="string")throw(0,M.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=_.URI.file(L),this.base=L):_.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=te}};kt=Ue([D],kt),e.RelativePattern=kt;let $t=class{constructor(L,te,_e,Ke){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof _e=="string"&&(this.hitCondition=_e),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};$t=Ue([D],$t),e.Breakpoint=$t;let Zt=class extends $t{constructor(L,te,_e,Ke,et){super(te,_e,Ke,et);if(L===null)throw(0,M.illegalArgument)("location");this.location=L}};Zt=Ue([D],Zt),e.SourceBreakpoint=Zt;let gt=class extends $t{constructor(L,te,_e,Ke,et){super(te,_e,Ke,et);this.functionName=L}};gt=Ue([D],gt),e.FunctionBreakpoint=gt;let Kt=class extends $t{constructor(L,te,_e,Ke,et,st,at){super(Ke,et,st,at);if(!te)throw(0,M.illegalArgument)("dataId");this.label=L,this.dataId=te,this.canPersist=_e}};Kt=Ue([D],Kt),e.DataBreakpoint=Kt;let Vt=class{constructor(L,te,_e){this.command=L,this.args=te||[],this.options=_e}};Vt=Ue([D],Vt),e.DebugAdapterExecutable=Vt;let ei=class{constructor(L,te){this.port=L,this.host=te}};ei=Ue([D],ei),e.DebugAdapterServer=ei;let ti=class{constructor(L){this.path=L}};ti=Ue([D],ti),e.DebugAdapterNamedPipeServer=ti;let It=class{constructor(L){this.implementation=L}};It=Ue([D],It),e.DebugAdapterInlineImplementation=It;let Qt=class{constructor(L,te){this.range=L,this.expression=te}};Qt=Ue([D],Qt),e.EvaluatableExpression=Qt;var wi;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(L,te){this.range=L,this.text=te}};Wt=Ue([D],Wt),e.InlineValueText=Wt;let Ht=class{constructor(L,te,_e=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=_e}};Ht=Ue([D],Ht),e.InlineValueVariableLookup=Ht;let ct=class{constructor(L,te){this.range=L,this.expression=te}};ct=Ue([D],ct),e.InlineValueEvaluatableExpression=ct;let ii=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};ii=Ue([D],ii),e.InlineValueContext=ii;var Nt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let xt=S=class extends Error{constructor(L,te=t.FileSystemProviderErrorCode.Unknown,_e){super(_.URI.isUri(L)?L.toString(!0):L);this.code=_e?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(L){return new S(L,t.FileSystemProviderErrorCode.FileExists,S.FileExists)}static FileNotFound(L){return new S(L,t.FileSystemProviderErrorCode.FileNotFound,S.FileNotFound)}static FileNotADirectory(L){return new S(L,t.FileSystemProviderErrorCode.FileNotADirectory,S.FileNotADirectory)}static FileIsADirectory(L){return new S(L,t.FileSystemProviderErrorCode.FileIsADirectory,S.FileIsADirectory)}static NoPermissions(L){return new S(L,t.FileSystemProviderErrorCode.NoPermissions,S.NoPermissions)}static Unavailable(L){return new S(L,t.FileSystemProviderErrorCode.Unavailable,S.Unavailable)}};xt=S=Ue([D],xt),e.FileSystemError=xt;let Yt=class{constructor(L,te,_e){this.start=L,this.end=te,this.kind=_e}};Yt=Ue([D],Yt),e.FoldingRange=Yt;var bi;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hi;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ei;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(Ei=e.CommentMode||(e.CommentMode={}));class fi{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.SemanticTokensLegend=fi;function ni(N){return typeof N=="undefined"||(0,C.isStringArray)(N)}class ri{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let te=0,_e=L.tokenTypes.length;te<_e;te++)this._tokenTypeStrToInt.set(L.tokenTypes[te],te);for(let te=0,_e=L.tokenModifiers.length;te<_e;te++)this._tokenModifierStrToInt.set(L.tokenModifiers[te],te)}}push(L,te,_e,Ke,et){if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(L,te,_e,Ke,et);if(O.isRange(L)&&typeof te=="string"&&ni(_e))return this._push(L,te,_e);throw(0,M.illegalArgument)()}_push(L,te,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=L.start.line,et=L.start.character,st=L.end.character-L.start.character,at=this._tokenTypeStrToInt.get(te);let yt=0;if(_e)for(const At of _e){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(At);yt|=1<<Ft>>>0}this._pushEncoded(Ke,et,st,at,yt)}_pushEncoded(L,te,_e,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let At=0,Ft=0;for(let Lt=0;Lt<yt;Lt++){let Bt=this._data[5*Lt],ui=this._data[5*Lt+1];Bt===0?(Bt=At,ui+=Ft):Bt+=At,this._data[5*Lt]=Bt,this._data[5*Lt+1]=ui,At=Bt,Ft=ui}}let st=L,at=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(at-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=at,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=L,this._prevChar=te}static _sortAndDeltaEncode(L){let te=[];const _e=L.length/5|0;for(let at=0;at<_e;at++)te[at]=at;te.sort((at,yt)=>{const At=L[5*at],Ft=L[5*yt];if(At===Ft){const Lt=L[5*at+1],Bt=L[5*yt+1];return Lt-Bt}return At-Ft});const Ke=new Uint32Array(L.length);let et=0,st=0;for(let at=0;at<_e;at++){const yt=5*te[at],At=L[yt+0],Ft=L[yt+1],Lt=L[yt+2],Bt=L[yt+3],ui=L[yt+4],xi=At-et,qi=xi===0?Ft-st:Ft,ci=5*at;Ke[ci+0]=xi,Ke[ci+1]=qi,Ke[ci+2]=Lt,Ke[ci+3]=Bt,Ke[ci+4]=ui,et=At,st=Ft}return Ke}build(L){return this._dataIsSortedAndDeltaEncoded?new jt(new Uint32Array(this._data),L):new jt(ri._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=ri;class jt{constructor(L,te){this.resultId=te,this.data=L}}e.SemanticTokens=jt;class si{constructor(L,te,_e){this.start=L,this.deleteCount=te,this.data=_e}}e.SemanticTokensEdit=si;class _i{constructor(L,te){this.resultId=te,this.edits=L}}e.SemanticTokensEdits=_i;var yi;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var qt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(qt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new _t("arrow-left")},Jt=Ue([D],Jt),e.QuickInputButtons=Jt;var Si;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(L,te,_e){this.badge=L,this.tooltip=te,this.color=_e}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Di;let oi=class{constructor(L){this.kind=L}};oi=Ue([D],oi),e.ColorTheme=oi;var ai;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(ai=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(L,te){if(L<0)throw(0,M.illegalArgument)("start must be positive");if(te<0)throw(0,M.illegalArgument)("end must be positive");L<=te?(this._start=L,this._end=te):(this._start=te,this._end=L)}static isNotebookRange(L){return L instanceof zt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let te=this._start,_e=this._end;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(_e=L.end),te===this._start&&_e===this._end?this:new zt(te,_e)}}e.NotebookRange=zt;class Mt{constructor(L,te,_e,Ke,et,st,at){this.kind=L,this.value=te,this.languageId=_e,this.mime=Ke,this.outputs=et??[],this.metadata=st,this.executionSummary=at,Mt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>Mt.isNotebookCellData(te))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Mt;class Re{constructor(L){this.cells=L}}e.NotebookData=Re;class Tt{constructor(L,te){this.data=L,this.mime=te;const _e=(0,F.normalizeMimeType)(te,!0);if(!_e)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(L){return L instanceof Tt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return Tt.json(te,"application/vnd.code.notebook.error")}static stdout(L){return Tt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Tt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new Tt(L,te)}static text(L,te=F.Mimes.text){const _e=Te(Tt,l,"f",s).encode(String(L));return new Tt(_e,te)}static json(L,te="application/json"){const _e=JSON.stringify(L,void 0,"	");return Tt.text(_e,te)}}e.NotebookCellOutputItem=Tt,l=Tt,s={value:new TextEncoder};class Gt{constructor(L,te,_e){this.items=Gt.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=_e):(this.id=(0,P.generateUuid)(),this.metadata=te??_e)}static isNotebookCellOutput(L){return L instanceof Gt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,C.isArray)(L.items)}static ensureUniqueMimeTypes(L,te=!1){const _e=new Set,Ke=new Set;for(let et=0;et<L.length;et++){const st=L[et],at=(0,F.normalizeMimeType)(st.mime);if(!_e.has(at)){_e.add(at);continue}Ke.add(et),te&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ke.size===0?L:L.filter((et,st)=>!Ke.has(st))}}e.NotebookCellOutput=Gt;var pt;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(pt=e.NotebookCellKind||(e.NotebookCellKind={}));var Ci;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Ci=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mi;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(mi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gi{constructor(L,te){this.text=L,this.alignment=te}}e.NotebookCellStatusBarItem=gi;var Ii;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Ii=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(L,te=[]){this.uri=L,this.provides=(0,h.asArray)(te)}}e.NotebookRendererScript=Pi;let li=class{constructor(L,te){this.label=L,this.timestamp=te}};li=Ue([D],li),e.TimelineItem=li;var Ai;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Ai=e.ExtensionMode||(e.ExtensionMode={}));var pi;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(pi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ti;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Ti=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.LinkedEditingRanges=Ri;class Fi{constructor(L,te){this._port=L,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let X=class{constructor(L,te,_e){this.include=L,this.exclude=te,this.profile=_e}};X=Ue([D],X),e.TestRunRequest=X;let de=R=class{constructor(L){this.message=L}static diff(L,te,_e){const Ke=new R(L);return Ke.expectedOutput=te,Ke.actualOutput=_e,Ke}};de=R=Ue([D],de),e.TestMessage=de;let ke=class{constructor(L){this.id=L}};ke=Ue([D],ke),e.TestTag=ke;let rt=class{constructor(L,te){this.covered=L,this.total=te}};rt=Ue([D],rt),e.CoveredCount=rt;let wt=p=class{constructor(L,te,_e,Ke){this.uri=L,this.statementCoverage=te,this.branchCoverage=_e,this.functionCoverage=Ke}static fromDetails(L,te){const _e=new rt(0,0),Ke=new rt(0,0),et=new rt(0,0);for(const at of te)if("branches"in at){_e.total+=1,_e.covered+=at.executionCount>0?1:0;for(const yt of at.branches)Ke.total+=1,Ke.covered+=yt.executionCount>0?1:0}else et.total+=1,et.covered+=at.executionCount>0?1:0;const st=new p(L,_e,Ke.total>0?Ke:void 0,et.total>0?et:void 0);return st.detailedCoverage=te,st}};wt=p=Ue([D],wt),e.FileCoverage=wt;let Dt=class{constructor(L,te,_e=[]){this.executionCount=L,this.location=te,this.branches=_e}};Dt=Ue([D],Dt),e.StatementCoverage=Dt;let Oi=class{constructor(L,te){this.executionCount=L,this.location=te}};Oi=Ue([D],Oi),e.BranchCoverage=Oi;let Ni=class{constructor(L,te){this.executionCount=L,this.location=te}};Ni=Ue([D],Ni),e.FunctionCoverage=Ni;var Hi;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zi;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(zi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vi;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(L,te,_e,Ke,et,st){this.kind=L,this.name=te,this.detail=_e,this.uri=Ke,this.range=et,this.selectionRange=st}}e.TypeHierarchyItem=ji}),define(be[88],Ee([0,1,40,11,9,228,118,7,13]),function(ie,e,h,M,b,T,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function t(l,s){s?P.set(l,s):P.delete(l)}e.setWordDefinitionFor=t;function E(l){return P.get(l)}e.getWordDefinitionFor=E;class n extends T.MirrorTextModel{constructor(s,v,I,y,a,m,k,i){super(v,I,y,a);this._proxy=s,this._languageId=m,this._isDirty=k,this._notebook=i,this._isDisposed=!1}dispose(){(0,h.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(s){return(0,_.equals)(this._lines,s)}get document(){if(!this._document){const s=this;this._document={get uri(){return s._uri},get fileName(){return s._uri.fsPath},get isUntitled(){return s._uri.scheme===M.Schemas.untitled},get languageId(){return s._languageId},get version(){return s._versionId},get isClosed(){return s._isDisposed},get isDirty(){return s._isDirty},get notebook(){return s._notebook},save(){return s._save()},getText(v){return v?s._getTextInRange(v):s.getText()},get eol(){return s._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return s._lines.length},lineAt(v){return s._lineAt(v)},offsetAt(v){return s._offsetAt(v)},positionAt(v){return s._positionAt(v)},validateRange(v){return s._validateRange(v)},validatePosition(v){return s._validatePosition(v)},getWordRangeAtPosition(v,I){return s._getWordRangeAtPosition(v,I)}}}return Object.freeze(this._document)}_acceptLanguageId(s){(0,h.ok)(!this._isDisposed),this._languageId=s}_acceptIsDirty(s){(0,h.ok)(!this._isDisposed),this._isDirty=s}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(s){const v=this._validateRange(s);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const I=this._eol,y=v.start.line,a=v.end.line,m=[];m.push(this._lines[y].substring(v.start.character));for(let k=y+1;k<a;k++)m.push(this._lines[k]);return m.push(this._lines[a].substring(0,v.end.character)),m.join(I)}_lineAt(s){let v;if(s instanceof C.Position?v=s.line:typeof s=="number"&&(v=s),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new f(v,this._lines[v],v===this._lines.length-1)}_offsetAt(s){return s=this._validatePosition(s),this._ensureLineStarts(),this._lineStarts.getPrefixSum(s.line-1)+s.character}_positionAt(s){s=Math.floor(s),s=Math.max(0,s),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(s),I=this._lines[v.index].length;return new C.Position(v.index,Math.min(v.remainder,I))}_validateRange(s){if(!(s instanceof C.Range))throw new Error("Invalid argument");const v=this._validatePosition(s.start),I=this._validatePosition(s.end);return v===s.start&&I===s.end?s:new C.Range(v.line,v.character,I.line,I.character)}_validatePosition(s){if(!(s instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return s.with(0,0);let{line:v,character:I}=s,y=!1;if(v<0)v=0,I=0,y=!0;else if(v>=this._lines.length)v=this._lines.length-1,I=this._lines[v].length,y=!0;else{const a=this._lines[v].length;I<0?(I=0,y=!0):I>a&&(I=a,y=!0)}return y?new C.Position(v,I):s}_getWordRangeAtPosition(s,v){const I=this._validatePosition(s);if(!v)v=E(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const y=(0,F.getWordAtText)(I.character+1,(0,F.ensureValidWordDefinition)(v),this._lines[I.line],0);if(y)return new C.Range(I.line,y.startColumn-1,I.line,y.endColumn-1)}}e.ExtHostDocumentData=n;class f{constructor(s,v,I){this._line=s,this._text=v,this._isLastLine=I}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(be[156],Ee([0,1,7,3,229,6,55,20,2,36]),function(ie,e,h,M,b,T,F,C,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,f,l,s){this._notebook=l,this._selector=s,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(I=>{const y=this._cellUris.get(I.document.uri);y!==void 0&&(this._cellLengths.changeValue(y,this._cells[y].document.getText().length+1),this._cellLines.changeValue(y,this._cells[y].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=I=>{I===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(I=>v(I.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const n=[],f=[];for(const l of this._notebook.getCells())l.kind===h.NotebookCellKind.Code&&(!this._selector||(0,F.score)(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),n.push(l.document.getText().length+1),f.push(l.document.lineCount));this._cellLengths=new b.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new b.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(n){if(!n){let y="";for(const a of this._cells)y+=a.document.getText()+`
`;return y=y.slice(0,-1),y}if(n.isEmpty)return"";const f=this.locationAt(n.start),l=this.locationAt(n.end),s=this._cellUris.get(f.uri),v=this._cellUris.get(l.uri);if(s===void 0||v===void 0)return"";if(s===v)return this._cells[s].document.getText(new h.Range(f.range.start,l.range.end));const I=[this._cells[s].document.getText(new h.Range(f.range.start,new h.Position(this._cells[s].document.lineCount,0)))];for(let y=s+1;y<v;y++)I.push(this._cells[y].document.getText());return I.push(this._cells[v].document.getText(new h.Range(new h.Position(0,0),l.range.end))),I.join(`
`)}offsetAt(n){const f=this._cellLines.getIndexOf(n.line),l=this._cellLengths.getPrefixSum(f.index-1),s=this._cells[f.index].document.offsetAt(n.with(f.remainder));return l+s}positionAt(n){if(typeof n=="number"){const l=this._cellLengths.getIndexOf(n),s=this._cellLines.getPrefixSum(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(s)}const f=this._cellUris.get(n.uri);if(f!==void 0){const l=this._cellLines.getPrefixSum(f-1);return new h.Position(l+n.range.start.line,n.range.start.character)}return new h.Position(0,0)}locationAt(n){h.Range.isRange(n)||(n=new h.Range(n,n));const f=this._cellLines.getIndexOf(n.start.line);let l=f;n.isEmpty||(l=this._cellLines.getIndexOf(n.end.line));const s=new h.Position(f.remainder,n.start.character),v=new h.Position(l.remainder,n.end.character),I=new h.Range(s,v),y=this._cells[f.index];return new h.Location(y.document.uri,y.document.validateRange(I))}contains(n){return this._cellUris.has(n)}validateRange(n){const f=this.validatePosition(n.start),l=this.validatePosition(n.end);return n.with(f,l)}validatePosition(n){const f=this._cellLines.getIndexOf(n.line),l=new h.Position(f.remainder,n.character),s=this._cells[f.index].document.validatePosition(l),v=this._cellLines.getPrefixSum(f.index-1);return new h.Position(v+s.line,s.character)}}e.ExtHostNotebookConcatDocument=t}),define(be[157],Ee([0,1,7,12,3]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(C){this._actual=new h.ColorTheme(h.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let _=C==="light"?h.ColorThemeKind.Light:C==="dark"?h.ColorThemeKind.Dark:h.ColorThemeKind.HighContrast;this._actual=new h.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Ue([He(0,M.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(be[65],Ee([0,1,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,h.createDecorator)("IURITransformerService");class M{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.URITransformerService=M}),define(be[158],Ee([0,1,23]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(_){let P=this.buffers.indexOf(_);return P<0&&(P=this.buffers.length,this.buffers.push(_)),P}}function b(C,_){if(_.serializeBuffersForPostMessage){const P=new M,t=(f,l)=>{if(l instanceof ArrayBuffer){const s=P.add(l);return{$$vscode_array_buffer_reference$$:!0,index:s}}else if(ArrayBuffer.isView(l)){const s=T(l);if(s){const v=P.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:s,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},E=JSON.stringify(C,t),n=P.buffers.map(f=>{const l=new Uint8Array(f);return h.VSBuffer.wrap(l)});return{message:E,buffers:n}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=b;function T(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(C,_){const P=_.map(n=>{const f=new ArrayBuffer(n.byteLength);return new Uint8Array(f).set(n.buffer),f}),t=_.length?(n,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const l=f,{index:s}=l,v=P[s];if(l.view)switch(l.view.type){case 1:return new Int8Array(v,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return f}:void 0;return{message:JSON.parse(C,t),arrayBuffers:P}}e.deserializeWebviewMessage=F}),define(be[159],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var h;(function(M){function b(F){const C={items:new Map};return F.types.forEach((_,P)=>{C.items.set(_,{asString:async()=>F.items[P].asString})}),C}M.toITreeDataTransfer=b;async function T(F){const C={types:[],items:[]},_=Array.from(F.items.entries());for(const P of _)C.types.push(P[0]),C.items.push({asString:await P[1].asString()});return C}M.toTreeDataTransferDTO=T})(h=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[66],Ee([0,1,11,2]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function b(C,_){return C.scheme===h.Schemas.http||C.scheme===h.Schemas.https?C:(_&&_.authority&&_.isRemote&&C.scheme===h.Schemas.file&&(C=M.URI.from({scheme:h.Schemas.vscodeRemote,authority:_.authority,path:C.path})),M.URI.from({scheme:h.Schemas.https,authority:`${C.scheme}+${T(C.authority)}.${e.webviewRootResourceAuthority}`,path:C.path,fragment:C.fragment,query:C.query}))}e.asWebviewUri=b;function T(C){return C.replace(/./g,_=>{const P=_.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?_:"-"+P.toString(16).padStart(4,"0")})}function F(C){return C.replace(/-([0-9a-f]{4})/g,(_,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=F}),define(be[160],Ee([0,1,3,6,66]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(C,_,P){this._proxy=C,this._editors=_,this._initData=P,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const t=_.getVisibleTextEditors();for(const E of this._insets.values())t.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,_,P,t,E){let n;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===C){n=a;break}if(!n)throw new Error("not a visible editor");const f=this,l=this._handlePool++,s=new h.Emitter,v=new h.Emitter,I=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,b.asWebviewUri)(a,f._initData.remote)}get cspSource(){return b.webviewGenericCspSource}set options(a){this._options=a,f._proxy.$setOptions(l,a)}get options(){return this._options}set html(a){this._html=a,f._proxy.$setHtml(l,a)}get html(){return this._html}get onDidReceiveMessage(){return s.event}postMessage(a){return f._proxy.$postMessage(l,a)}},y=new class{constructor(){this.editor=C,this.line=_,this.height=P,this.webview=I,this.onDidDispose=v.event}dispose(){f._insets.has(l)&&(f._insets.delete(l),f._proxy.$disposeEditorInset(l),v.fire(),v.dispose(),s.dispose())}};return this._proxy.$createEditorInset(l,n.id,n.value.document.uri,_+1,P,t||{},E.identifier,E.extensionLocation),this._insets.set(l,{editor:C,inset:y,onDidReceiveMessage:s}),y}$onDidDispose(C){const _=this._insets.get(C);_&&_.inset.dispose()}$onDidReceiveMessage(C,_){const P=this._insets.get(C);P&&P.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=T}),define(be[161],Ee([0,1,131,10,2,6,4,43,28,13,11]),function(ie,e,h,M,b,T,F,C,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,h.localize)(0,null),providerDisplayName:(0,h.localize)(1,null)},e.ActiveEditorDirtyContext=new C.RawContextKey("activeEditorIsDirty",!1,(0,h.localize)(2,null)),e.ActiveEditorPinnedContext=new C.RawContextKey("activeEditorIsNotPreview",!1,(0,h.localize)(3,null)),e.ActiveEditorStickyContext=new C.RawContextKey("activeEditorIsPinned",!1,(0,h.localize)(4,null)),e.ActiveEditorReadonlyContext=new C.RawContextKey("activeEditorIsReadonly",!1,(0,h.localize)(5,null)),e.ActiveEditorCanRevertContext=new C.RawContextKey("activeEditorCanRevert",!1,(0,h.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new C.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new C.RawContextKey("activeEditor",null,{type:"string",description:(0,h.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new C.RawContextKey("activeEditorAvailableEditorIds","",(0,h.localize)(8,null)),e.TextCompareEditorVisibleContext=new C.RawContextKey("textCompareEditorVisible",!1,(0,h.localize)(9,null)),e.TextCompareEditorActiveContext=new C.RawContextKey("textCompareEditorActive",!1,(0,h.localize)(10,null)),e.SideBySideEditorActiveContext=new C.RawContextKey("sideBySideEditorActive",!1,(0,h.localize)(11,null)),e.EditorGroupEditorsCountContext=new C.RawContextKey("groupEditorsCount",0,(0,h.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new C.RawContextKey("activeEditorGroupEmpty",!1,(0,h.localize)(13,null)),e.ActiveEditorGroupIndexContext=new C.RawContextKey("activeEditorGroupIndex",0,(0,h.localize)(14,null)),e.ActiveEditorGroupLastContext=new C.RawContextKey("activeEditorGroupLast",!1,(0,h.localize)(15,null)),e.ActiveEditorGroupLockedContext=new C.RawContextKey("activeEditorGroupLocked",!1,(0,h.localize)(16,null)),e.MultipleEditorGroupsContext=new C.RawContextKey("multipleEditorGroups",!1,(0,h.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new C.RawContextKey("editorIsOpen",!1,(0,h.localize)(18,null)),e.InEditorZenModeContext=new C.RawContextKey("inZenMode",!1,(0,h.localize)(19,null)),e.IsCenteredLayoutContext=new C.RawContextKey("isCenteredLayout",!1,(0,h.localize)(20,null)),e.SplitEditorsVertically=new C.RawContextKey("splitEditorsVertically",!1,(0,h.localize)(21,null)),e.EditorAreaVisibleContext=new C.RawContextKey("editorAreaVisible",!0,(0,h.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function E(c,A,O){for(const z of O.visibleEditorPanes)if(z.group.id===A&&c.matches(z.input))return z.getViewState()}e.findViewStateForEditor=E;function n(c){if(m(c))return!1;const A=c;return b.URI.isUri(A?.resource)}e.isResourceEditorInput=n;function f(c){if(m(c))return!1;const A=c;return A?.original!==void 0&&A.modified!==void 0}e.isResourceDiffEditorInput=f;function l(c){if(m(c)||f(c))return!1;const A=c;return A?.primary!==void 0&&A.secondary!==void 0}e.isResourceSideBySideEditorInput=l;function s(c){if(m(c))return!1;const A=c;return A?A.resource===void 0||A.resource.scheme===t.Schemas.untitled||A.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=s;var v;(function(c){c[c.SHORT=0]="SHORT",c[c.MEDIUM=1]="MEDIUM",c[c.LONG=2]="LONG"})(v=e.Verbosity||(e.Verbosity={}));var I;(function(c){c[c.EXPLICIT=1]="EXPLICIT",c[c.AUTO=2]="AUTO",c[c.FOCUS_CHANGE=3]="FOCUS_CHANGE",c[c.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(I=e.SaveReason||(e.SaveReason={}));var y;(function(c){c[c.None=0]="None",c[c.Readonly=2]="Readonly",c[c.Untitled=4]="Untitled",c[c.Singleton=8]="Singleton",c[c.RequiresTrust=16]="RequiresTrust",c[c.CanSplitInGroup=32]="CanSplitInGroup"})(y=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends T.Disposable{}e.AbstractEditorInput=a;function m(c){return c instanceof a}e.isEditorInput=m;function k(c){const A=c;return b.URI.isUri(A?.preferredResource)}function i(c){const A=c;return m(A?.primary)&&m(A?.secondary)}e.isSideBySideEditorInput=i;function u(c){const A=c;return m(A?.modified)&&m(A?.original)}e.isDiffEditorInput=u;function r(c){return m(c?.editor)}e.isEditorInputWithOptions=r;function o(c){const A=c;return r(c)&&A?.group!==void 0}e.isEditorInputWithOptionsAndGroup=o;function w(c){const A=c;return typeof A?.groupId=="number"&&m(A.editor)}e.isEditorIdentifier=w;var d;(function(c){c[c.PRIMARY=1]="PRIMARY",c[c.SECONDARY=2]="SECONDARY",c[c.BOTH=3]="BOTH",c[c.ANY=4]="ANY"})(d=e.SideBySideEditor||(e.SideBySideEditor={}));class g{getOriginalUri(A,O){if(!A)return;if(O?.supportSideBySide){const{primary:K,secondary:$}=this.getSideEditors(A);if(K&&$){if(O?.supportSideBySide===d.BOTH)return{primary:this.getOriginalUri(K,{filterByScheme:O.filterByScheme}),secondary:this.getOriginalUri($,{filterByScheme:O.filterByScheme})};if(O?.supportSideBySide===d.ANY)return this.getOriginalUri(K,{filterByScheme:O.filterByScheme})??this.getOriginalUri($,{filterByScheme:O.filterByScheme});A=O.supportSideBySide===d.PRIMARY?K:$}}if(f(A)||l(A))return;const z=k(A)?A.preferredResource:A.resource;return!z||!O||!O.filterByScheme?z:this.filterUri(z,O.filterByScheme)}getSideEditors(A){return i(A)||l(A)?{primary:A.primary,secondary:A.secondary}:u(A)||f(A)?{primary:A.modified,secondary:A.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(A,O){if(!A)return;if(O?.supportSideBySide){const{primary:K,secondary:$}=this.getSideEditors(A);if(K&&$){if(O?.supportSideBySide===d.BOTH)return{primary:this.getCanonicalUri(K,{filterByScheme:O.filterByScheme}),secondary:this.getCanonicalUri($,{filterByScheme:O.filterByScheme})};if(O?.supportSideBySide===d.ANY)return this.getCanonicalUri(K,{filterByScheme:O.filterByScheme})??this.getCanonicalUri($,{filterByScheme:O.filterByScheme});A=O.supportSideBySide===d.PRIMARY?K:$}}if(f(A)||l(A))return;const z=A.resource;return!z||!O||!O.filterByScheme?z:this.filterUri(z,O.filterByScheme)}filterUri(A,O){if(Array.isArray(O)){if(O.some(z=>A.scheme===z))return A}else if(O===A.scheme)return A}}e.EditorResourceAccessor=new g;var S;(function(c){c[c.LEFT=0]="LEFT",c[c.RIGHT=1]="RIGHT"})(S=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(A){const O=this.instantiationService=A.get(F.IInstantiationService);for(const[z,K]of this.editorSerializerConstructors)this.createEditorSerializer(z,K,O);this.editorSerializerConstructors.clear()}createEditorSerializer(A,O,z){const K=z.createInstance(O);this.editorSerializerInstances.set(A,K)}registerFileEditorFactory(A){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=A}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(A,O){if(this.editorSerializerConstructors.has(A)||this.editorSerializerInstances.has(A))throw new Error(`A editor serializer with type ID '${A}' was already registered.`);return this.instantiationService?this.createEditorSerializer(A,O,this.instantiationService):this.editorSerializerConstructors.set(A,O),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(A),this.editorSerializerInstances.delete(A)})}getEditorSerializer(A){return this.editorSerializerInstances.get(typeof A=="string"?A:A.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new R);async function p(c,A){if(!c||!c.length)return[];const O=await Promise.all(c.map(async z=>{const K=b.URI.revive(z.fileUri);if(!K||(await A.activateProvider(K.scheme),!A.canHandleResource(K)))return;const $=typeof z.exists=="boolean"?z.exists:await A.exists(K);if(!$&&z.openOnlyIfExists)return;const Q={selection:$?z.selection:void 0,pinned:!0,override:z.editorOverrideId};let W;return $?W={resource:K,options:Q}:W={resource:K,options:Q,forceUntitled:!0},W}));return(0,P.coalesce)(O)}e.pathsToEditors=p;var D;(function(c){c[c.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",c[c.SEQUENTIAL=1]="SEQUENTIAL"})(D=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[162],Ee([0,1,3,43,132,4,6,20,28,13,51,22,34,152]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",n.Codicon.window,(0,b.localize)(0,null));var l;(function(w){w.ViewContainersRegistry="workbench.registry.view.containers",w.ViewsRegistry="workbench.registry.view"})(l=e.Extensions||(e.Extensions={}));var s;(function(w){w[w.Sidebar=0]="Sidebar",w[w.Panel=1]="Panel"})(s=e.ViewContainerLocation||(e.ViewContainerLocation={}));function v(w){switch(w){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=v;function I(w){return`viewContainer.${w}.enabled`}e.getEnabledViewContainerContextKey=I;class y extends F.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new h.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new h.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(d,g,S){const R=this.get(d.id);if(R)return R;const p=d;return p.openCommandActionDescriptor=S?.donotRegisterOpenCommand?void 0:p.openCommandActionDescriptor??{id:p.id},(0,C.getOrSet)(this.viewContainers,g,[]).push(p),S?.isDefault&&this.defaultViewContainers.push(p),this._onDidRegister.fire({viewContainer:p,viewContainerLocation:g}),p}deregisterViewContainer(d){for(const g of this.viewContainers.keys()){const S=this.viewContainers.get(g),R=S?.indexOf(d);if(R!==-1){S?.splice(R,1),S.length===0&&this.viewContainers.delete(g),this._onDidDeregister.fire({viewContainer:d,viewContainerLocation:g});return}}}get(d){return this.all.filter(g=>g.id===d)[0]}getViewContainers(d){return[...this.viewContainers.get(d)||[]]}getViewContainerLocation(d){return[...this.viewContainers.keys()].filter(g=>this.getViewContainers(g).filter(S=>S?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.defaultViewContainers.find(g=>this.getViewContainerLocation(g)===d)}}_.Registry.add(l.ViewContainersRegistry,new y);var a;(function(w){w.Open="2_open",w.Debug="4_debug",w.SCM="5_scm",w.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function m(w,d){const g=w.group??a.More,S=d.group??a.More;return g!==S?g.localeCompare(S):(w.order??5)-(d.order??5)}class k extends F.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new h.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new h.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new h.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new h.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(d,g){this.registerViews2([{views:d,viewContainer:g}])}registerViews2(d){d.forEach(({views:g,viewContainer:S})=>this.addViews(g,S)),this._onViewsRegistered.fire(d)}deregisterViews(d,g){const S=this.removeViews(d,g);S.length&&this._onViewsDeregistered.fire({views:S,viewContainer:g})}moveViews(d,g){for(const S of this._views.keys())if(S!==g){const R=this.removeViews(d,S);R.length&&(this.addViews(R,g),this._onDidChangeContainer.fire({views:R,from:S,to:g}))}}getViews(d){return this._views.get(d)||[]}getView(d){for(const g of this._viewContainers){const S=(this._views.get(g)||[]).filter(R=>R.id===d)[0];if(S)return S}return null}getViewContainer(d){for(const g of this._viewContainers)if((this._views.get(g)||[]).filter(R=>R.id===d)[0])return g;return null}registerViewWelcomeContent(d,g){return this._viewWelcomeContents.add(d,g),this._onDidChangeViewWelcomeContent.fire(d),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(d,g),this._onDidChangeViewWelcomeContent.fire(d)})}registerViewWelcomeContent2(d,g){const S=new Map;for(const[R,p]of g)this._viewWelcomeContents.add(d,p),S.set(R,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(d,p),this._onDidChangeViewWelcomeContent.fire(d)}));return this._onDidChangeViewWelcomeContent.fire(d),S}getViewWelcomeContent(d){const g=[];return this._viewWelcomeContents.forEach(d,S=>g.push(S)),g.sort(m)}addViews(d,g){let S=this._views.get(g);S||(S=[],this._views.set(g,S),this._viewContainers.push(g));for(const R of d){if(this.getView(R.id)!==null)throw new Error((0,b.localize)(1,null,R.id));S.push(R)}}removeViews(d,g){const S=this._views.get(g);if(!S)return[];const R=[],p=[];for(const D of S)d.includes(D)?R.push(D):p.push(D);return R.length&&(p.length?this._views.set(g,p):(this._views.delete(g),this._viewContainers.splice(this._viewContainers.indexOf(g),1))),R}}_.Registry.add(l.ViewsRegistry,new k),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,b.localize)(2,null));function i(w){return`view.${w}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var u;(function(w){w[w.Default=0]="Default",w[w.Expand=1]="Expand"})(u=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(w){w[w.None=0]="None",w[w.Collapsed=1]="Collapsed",w[w.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class o{constructor(d,g){this.resolved=!1,this._hasResolve=!1,(0,E.mixin)(this,d),this._hasResolve=!!g,this.resolve=async S=>{if(g&&!this.resolved){const R=await g(S);R&&(this.tooltip=this.tooltip??R.tooltip,this.command=this.command??R.command)}S.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[163],Ee([0,1,3,14,133]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new h.Emitter,this._onExit=new h.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,_,P,t){const E={command:C};if(_&&Object.keys(_).length>0&&(E.arguments=_),this.internalSend("request",E),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const f=this.pendingRequests.get(E.seq);if(f){this.pendingRequests.delete(E.seq);const l={type:"response",seq:0,request_seq:E.seq,success:!1,command:C,message:(0,b.localize)(0,null,t,C)};f(l)}},t)}return P&&this.pendingRequests.set(E.seq,P),E.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,_){return C.type!=="event"||_.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,M.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const _=C,P=this.pendingRequests.get(_.request_seq);P&&(this.pendingRequests.delete(_.request_seq),P(_));break}}}internalSend(C,_){_.type=C,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((_,P)=>C.set(P,_)),await(0,M.timeout)(500),C.forEach((_,P)=>{_({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(be[164],Ee([0,1,9,2,17,22,11]),function(ie,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function _(r,o,w){return r.replace(C,function(d,g){return o&&g.length>0&&g[0]!=="_"?d:w&&w.hasOwnProperty(g)?w[g]:d})}e.formatPII=_;function P(r){const o={};for(const w of Object.keys(r))w.startsWith("!")||(o[w]=r[w]);return o}e.filterExceptionsFromTelemetry=P;function t(r){return r.configuration.request==="attach"&&!E(r)&&(!r.parentSession||t(r.parentSession))}e.isSessionAttach=t;function E(r){let o=r.configuration.type;if(!!o)return o==="vslsShare"&&(o=r.configuration.adapterProxy.configuration.type),(0,h.equalsIgnoreCase)(o,"extensionhost")||(0,h.equalsIgnoreCase)(o,"pwa-extensionhost")?r:r.parentSession?E(r.parentSession):void 0}e.getExtensionHostDebugSession=E;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function f(r,o,w){let d,g=0,S=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,R=null;for(;R=S.exec(r);){let p=R.index+1,D=p+R[0].length;if(p<=o&&D>=w){d=R[0],g=p;break}}if(d){let p=/\w+/g,D=null;for(;(D=p.exec(d))&&!(D.index+1+g+D[0].length>=w););D&&(d=d.substring(0,p.lastIndex))}return d?{start:g,end:g+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(r){return!!(r&&r.match(l))}e.isUri=s;function v(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(s(r.path))return M.URI.parse(r.path);if((0,b.isAbsolute)(r.path))return M.URI.file(r.path)}return r.path}function I(r){if(typeof r.path=="object"){const o=M.URI.revive(r.path);if(o)return o.scheme===F.Schemas.file?o.fsPath:o.toString()}return r.path}function y(r,o){const w=o?v:I,d=(0,T.deepClone)(r);return m(d,(g,S)=>{g&&S&&(S.path=w(S))}),d}e.convertToDAPaths=y;function a(r,o){const w=o?v:I,d=(0,T.deepClone)(r);return m(d,(g,S)=>{!g&&S&&(S.path=w(S))}),d}e.convertToVSCPaths=a;function m(r,o){switch(r.type){case"event":const w=r;switch(w.event){case"output":o(!1,w.body.source);break;case"loadedSource":o(!1,w.body.source);break;case"breakpoint":o(!1,w.body.breakpoint.source);break;default:break}break;case"request":const d=r;switch(d.command){case"setBreakpoints":o(!0,d.arguments.source);break;case"breakpointLocations":o(!0,d.arguments.source);break;case"source":o(!0,d.arguments.source);break;case"gotoTargets":o(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(S=>o(!1,S));break;default:break}break;case"response":const g=r;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(S=>o(!1,S.source));break;case"loadedSources":g.body.sources.forEach(S=>o(!1,S));break;case"scopes":g.body.scopes.forEach(S=>o(!1,S.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(S=>o(!1,S.source));break;case"setBreakpoints":g.body.breakpoints.forEach(S=>o(!1,S.source));break;default:break}break}}function k(r){return r.filter(o=>!o.presentation?.hidden).sort((o,w)=>o.presentation?w.presentation?o.presentation.group?w.presentation.group?o.presentation.group!==w.presentation.group?o.presentation.group.localeCompare(w.presentation.group):i(o.presentation.order,w.presentation.order):-1:w.presentation.group?1:i(o.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.getVisibleAndSorted=k;function i(r,o){return typeof r!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:r-o}async function u(r,o){const w=r.getValue("debug.saveBeforeStart",{overrideIdentifier:o.activeTextEditorMode});if(w!=="none"&&(await o.saveAll(),w==="allEditorsInActiveGroup")){const d=o.activeEditorPane;d&&await o.save({editor:d.input,groupId:d.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(be[89],Ee([0,1,27,78,11,17,26,43]),function(ie,e,h,M,b,T,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(p){p[p.Markup=1]="Markup",p[p.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(p){p[p.Running=1]="Running",p[p.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(p){p[p.Pending=2]="Pending",p[p.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var E;(function(p){p[p.WithHardKernelDependency=0]="WithHardKernelDependency",p[p.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",p[p.Pure=2]="Pure",p[p.Never=3]="Never"})(E=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var n;(function(p){p.Always="always",p.Never="never",p.Optional="optional"})(n=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(p){p[p.ModelChange=1]="ModelChange",p[p.Move=2]="Move",p[p.ChangeLanguage=5]="ChangeLanguage",p[p.Initialize=6]="Initialize",p[p.ChangeCellMetadata=7]="ChangeCellMetadata",p[p.Output=8]="Output",p[p.OutputItem=9]="OutputItem",p[p.ChangeCellContent=10]="ChangeCellContent",p[p.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",p[p.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",p[p.ChangeCellMime=13]="ChangeCellMime",p[p.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var l;(function(p){p[p.Handle=0]="Handle",p[p.Index=1]="Index"})(l=e.SelectionStateType||(e.SelectionStateType={}));var s;(function(p){p[p.Replace=1]="Replace",p[p.Output=2]="Output",p[p.Metadata=3]="Metadata",p[p.CellLanguage=4]="CellLanguage",p[p.DocumentMetadata=5]="DocumentMetadata",p[p.Move=6]="Move",p[p.OutputItems=7]="OutputItems",p[p.PartialMetadata=8]="PartialMetadata",p[p.PartialInternalMetadata=9]="PartialInternalMetadata"})(s=e.CellEditType||(e.CellEditType={}));var v;(function(p){p.scheme=b.Schemas.vscodeNotebookCell;const D=/^ch(\d{7,})/;function c($,Q){return $.with({scheme:p.scheme,fragment:`ch${Q.toString().padStart(7,"0")}${$.scheme!==b.Schemas.file?$.scheme:""}`})}p.generate=c;function A($){if($.scheme!==p.scheme)return;const Q=D.exec($.fragment);return Q?{handle:Number(Q[1]),notebook:$.with({scheme:$.fragment.substr(Q[0].length)||b.Schemas.file,fragment:null})}:void 0}p.parse=A;function O($){if($.scheme!==b.Schemas.vscodeNotebookCellMetadata)return;const Q=D.exec($.fragment);return Q?{handle:Number(Q[1]),notebook:$.with({scheme:$.fragment.substr(Q[0].length)||b.Schemas.file,fragment:null})}:void 0}p.parseCellMetadataUri=O;function z($,Q,W){return $.with({scheme:W,fragment:`ch${Q.toString().padStart(7,"0")}${$.scheme!==b.Schemas.file?$.scheme:""}`})}p.generateCellUri=z;function K($,Q){if($.scheme!==Q)return;const W=D.exec($.fragment);return W?{handle:Number(W[1]),notebook:$.with({scheme:$.fragment.substr(W[0].length)||b.Schemas.file,fragment:null})}:void 0}p.parseCellUri=K})(v=e.CellUri||(e.CellUri={}));const I=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function y(p){return I.get(p)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=y;function a(p){return I.get(p)?.supportedByCore??!1}e.mimeTypeSupportedByCore=a;function m(p){return I.get(p)?.mergeable??!1}e.mimeTypeIsMergeable=m;function k(p,D){return F.isWindows&&(p=p.replace(/\//g,"\\"),D=D.replace(/\//g,"\\")),h.match(p,D)}function i(p,D,c){let A=0;for(let O=0;O<D.length;O++){if(k(D[O],p))return A;A++}for(let O=0;O<c.length;O++){if(k(c[O],p))return A;A++}return A}function u(p,D,c){return p.sort((A,O)=>i(A,D,c)-i(O,D,c))}e.sortMimeTypes=u;function r(p,D,c,A=(O,z)=>O===z){const O=[];function z(Q,W,U){if(W===0&&U.length===0)return;const H=O[O.length-1];H&&H.start+H.deleteCount===Q?(H.deleteCount+=W,H.toInsert.push(...U)):O.push({start:Q,deleteCount:W,toInsert:U})}let K=0,$=0;for(;;){if(K===p.length){z(K,0,D.slice($));break}if($===D.length){z(K,p.length-K,[]);break}const Q=p[K],W=D[$];if(A(Q,W)){K+=1,$+=1;continue}c(W)?(z(K,1,[]),K+=1):(z(K,0,[W]),$+=1)}return O}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var o;(function(p){p.default="default",p.option="option"})(o=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function w(p){const D=p;return!!((typeof D.include=="string"||h.isRelativePattern(D.include))&&(typeof D.exclude=="string"||h.isRelativePattern(D.exclude)))}e.isDocumentExcludePattern=w;function d(p,D,c){if(Array.isArray(p.viewType)&&p.viewType.indexOf(D)>=0||p.viewType===D)return!0;if(p.filenamePattern){let A=w(p.filenamePattern)?p.filenamePattern.include:p.filenamePattern,O=w(p.filenamePattern)?p.filenamePattern.exclude:void 0;if(h.match(A,(0,T.basename)(c.fsPath).toLowerCase()))return!(O&&h.match(O,(0,T.basename)(c.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class g{constructor(D){this.textModel=D}getElements(){const D=new Int32Array(this.textModel.cells.length);for(let c=0;c<this.textModel.cells.length;c++)D[c]=this.textModel.cells[c].getHashValue();return D}}e.CellSequence=g,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var S;(function(p){p[p.Left=1]="Left",p[p.Right=2]="Right"})(S=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class R{static create(D){return`${R._prefix}${D}`}static parse(D){if(D.startsWith(R._prefix))return D.substr(R._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=R,R._prefix="notebook/"}),define(be[165],Ee([0,1,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState",b[b.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,h.createDecorator)("INotebookExecutionService")}),define(be[166],Ee([0,1,135,4,43]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new b.RawContextKey("customExecutionSupported",!0,h.localize(0,null)),e.ShellExecutionSupportedContext=new b.RawContextKey("shellExecutionSupported",!1,h.localize(1,null)),e.ProcessExecutionSupportedContext=new b.RawContextKey("processExecutionSupported",!1,h.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[167],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function h(b){return[...b.entries()]}e.serializeEnvironmentVariableCollection=h;function M(b){return new Map(b)}e.deserializeEnvironmentVariableCollection=M}),define(be[90],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var h;(function(E){E[E.Unset=0]="Unset",E[E.Queued=1]="Queued",E[E.Running=2]="Running",E[E.Passed=3]="Passed",E[E.Failed=4]="Failed",E[E.Skipped=5]="Skipped",E[E.Errored=6]="Errored"})(h=e.TestResultState||(e.TestResultState={}));var M;(function(E){E[E.Run=2]="Run",E[E.Debug=4]="Debug",E[E.Coverage=8]="Coverage",E[E.HasNonDefaultProfile=16]="HasNonDefaultProfile",E[E.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var b;(function(E){E[E.Error=0]="Error",E[E.Info=1]="Info"})(b=e.TestMessageType||(e.TestMessageType={}));var T;(function(E){E[E.NotExpandable=0]="NotExpandable",E[E.Expandable=1]="Expandable",E[E.BusyExpanding=2]="BusyExpanding",E[E.Expanded=3]="Expanded"})(T=e.TestItemExpandState||(e.TestItemExpandState={}));const F=(E,n)=>{n.expand!==void 0&&(E.expand=n.expand),n.item!==void 0&&(E.item=E.item?Object.assign(E.item,n.item):n.item)};e.applyTestItemUpdate=F;var C;(function(E){E[E.Function=0]="Function",E[E.Statement=1]="Statement"})(C=e.DetailType||(e.DetailType={}));var _;(function(E){E[E.Add=0]="Add",E[E.Update=1]="Update",E[E.Remove=2]="Remove",E[E.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",E[E.Retire=4]="Retire",E[E.AddTag=5]="AddTag",E[E.RemoveTag=6]="RemoveTag"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(n){}update(n){}remove(n,f){}complete(){}}e.IncrementalChangeCollector=P;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const f=this.createChangeCollector();for(const l of n)switch(l[0]){case 0:{const s=l[1];if(s.parent){if(this.items.has(s.parent)){const v=this.items.get(s.parent);v.children.add(s.item.extId);const I=this.createItem(s,v);this.items.set(s.item.extId,I),f.add(I)}}else{const v=this.createItem(s);this.roots.add(v),this.items.set(s.item.extId,v),f.add(v)}s.expand===2&&this.busyControllerCount++;break}case 1:{const s=l[1],v=this.items.get(s.extId);if(!v)break;s.expand!==void 0&&(v.expand===2&&this.busyControllerCount--,s.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(v,s),f.update(v);break}case 2:{const s=this.items.get(l[1]);if(!s)break;s.parent?this.items.get(s.parent).children.delete(s.item.extId):this.roots.delete(s);const v=[[l[1]]];for(;v.length;)for(const I of v.pop()){const y=this.items.get(I);y&&(v.push(y.children),this.items.delete(I),f.remove(y,y!==s),y.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(l[1]);break;case 3:this.updatePendingRoots(l[1]);break;case 5:this._tags.set(l[1].id,l[1]);break;case 6:this._tags.delete(l[1]);break}f.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=t}),define(be[67],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var h;(function(T){T.Delimiter="\0"})(h=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class b{constructor(F,C=F.length){if(this.path=F,this.viewEnd=C,F.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(F,C,_=F.parent){if(F.id===C)return new b([C]);let P=[F.id];for(let t=_;t&&t.id!==C;t=t.parent)P.push(t.id);return P.push(C),new b(P.reverse())}static isRoot(F){return!F.includes("\0")}static fromString(F){return new b(F.split("\0"))}static join(F,C){return new b([...F.path,C])}static joinToString(F,C){return F.toString()+"\0"+C}static compare(F,C){return F===C?0:C.startsWith(F+"\0")?2:F.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let F=1;F<=this.viewEnd;F++)yield new b(this.path,F)}compare(F){if(typeof F=="string")return b.compare(this.toString(),F);for(let C=0;C<F.viewEnd&&C<this.viewEnd;C++)if(F.path[C]!==this.path[C])return 1;return F.viewEnd>this.viewEnd?2:F.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let F=1;F<this.viewEnd;F++)this.stringifed+="\0",this.stringifed+=this.path[F]}return this.stringifed}}e.TestId=b}),define(be[168],Ee([0,1,17,91,10,22,26,77,136]),function(ie,e,h,M,b,T,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(E,n,f){this._contributedVariables=new Map,this._context=E,this._labelService=n,f&&(this._envVariablesPromise=f.then(l=>this.prepareEnv(l)))}prepareEnv(E){if(F.isWindows){const n=Object.create(null);return Object.keys(E).forEach(f=>{n[f.toLowerCase()]=E[f]}),n}return E}resolveWithEnvironment(E,n,f){return this.recursiveResolve(this.prepareEnv(E),n?n.uri:void 0,f)}async resolveAsync(E,n){return this.recursiveResolve(await this._envVariablesPromise,E?E.uri:void 0,n)}async resolveAnyBase(E,n,f,l){const s=T.deepClone(n);return F.isWindows&&s.windows?Object.keys(s.windows).forEach(v=>s[v]=s.windows[v]):F.isMacintosh&&s.osx?Object.keys(s.osx).forEach(v=>s[v]=s.osx[v]):F.isLinux&&s.linux&&Object.keys(s.linux).forEach(v=>s[v]=s.linux[v]),delete s.windows,delete s.osx,delete s.linux,this.recursiveResolve(await this._envVariablesPromise,E?E.uri:void 0,s,f,l)}async resolveAnyAsync(E,n,f){return this.resolveAnyBase(E,n,f)}async resolveAnyMap(E,n,f){const l=new Map;return{newConfig:await this.resolveAnyBase(E,n,f,l),resolvedVariables:l}}resolveWithInteractionReplace(E,n,f,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,n,f,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,n){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,n)}recursiveResolve(E,n,f,l,s){if(b.isString(f))return this.resolveString(E,n,f,l,s);if(b.isArray(f))return f.map(v=>this.recursiveResolve(E,n,v,l,s));if(b.isObject(f)){let v=Object.create(null);return Object.keys(f).forEach(I=>{const y=this.resolveString(E,n,I,l,s);v[y]=this.recursiveResolve(E,n,f[I],l,s)}),v}return f}resolveString(E,n,f,l,s){return f.replace(P.VARIABLE_REGEXP,(I,y)=>{if(y.includes(P.VARIABLE_LHS))return I;let a=this.evaluateSingleVariable(E,I,y,n,l);return s&&s.set(y,a),a!==I&&b.isString(a)&&a.match(P.VARIABLE_REGEXP)&&(a=this.resolveString(E,n,a,l,s)),a})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}evaluateSingleVariable(E,n,f,l,s){let v;const I=f.split(":");I.length>1&&(f=I[0],v=I[1]);const y=()=>{const k=this._context.getFilePath();if(k)return k;throw new Error((0,_.localize)(0,null,n))},a=()=>{const k=y();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,_.localize)(1,null,n,h.basename(k)))},m=()=>{if(v){const k=this._context.getFolderUri(v);if(k)return k;throw new Error((0,_.localize)(2,null,n,v))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,n)):new Error((0,_.localize)(4,null,n))};switch(f){case"env":if(v){if(E){const k=E[F.isWindows?v.toLowerCase():v];if(b.isString(k))return k}return""}throw new Error((0,_.localize)(5,null,n));case"config":if(v){const k=this._context.getConfigurationValue(l,v);if(b.isUndefinedOrNull(k))throw new Error((0,_.localize)(6,null,n,v));if(b.isObject(k))throw new Error((0,_.localize)(7,null,n,v));return k}throw new Error((0,_.localize)(8,null,n));case"command":return this.resolveFromMap(n,v,s,"command");case"input":return this.resolveFromMap(n,v,s,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(m()));case"cwd":return l||v?(0,C.normalizeDriveLetter)(this.fsPath(m())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return h.basename(this.fsPath(m()));case"lineNumber":const k=this._context.getLineNumber();if(k)return k;throw new Error((0,_.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,_.localize)(10,null,n));case"file":return y();case"fileWorkspaceFolder":return a();case"relativeFile":return l||v?h.relative(this.fsPath(m()),y()):y();case"relativeFileDirname":const u=h.dirname(y());if(l||v){const d=h.relative(this.fsPath(m()),u);return d.length===0?".":d}return u;case"fileDirname":return h.dirname(y());case"fileExtname":return h.extname(y());case"fileBasename":return h.basename(y());case"fileBasenameNoExtension":const r=h.basename(y());return r.slice(0,r.length-h.extname(r).length);case"fileDirnameBasename":return h.basename(h.dirname(y()));case"execPath":const o=this._context.getExecPath();return o||n;case"execInstallFolder":const w=this._context.getAppRoot();return w||n;case"pathSeparator":return h.sep;default:try{const d=v?`${f}:${v}`:f;return this.resolveFromMap(n,d,s,void 0)}catch(d){return n}}}}resolveFromMap(E,n,f,l){if(n&&f){const s=l===void 0?f[n]:f[l+":"+n];if(typeof s=="string")return s;throw new Error((0,_.localize)(11,null,E))}return E}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[92],Ee([0,1,4,161]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,h.createDecorator)("editorGroupsService");var b;(function(s){s[s.UP=0]="UP",s[s.DOWN=1]="DOWN",s[s.LEFT=2]="LEFT",s[s.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var T;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var F;(function(s){s[s.FIRST=0]="FIRST",s[s.LAST=1]="LAST",s[s.NEXT=2]="NEXT",s[s.PREVIOUS=3]="PREVIOUS"})(F=e.GroupLocation||(e.GroupLocation={}));var C;(function(s){s[s.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",s[s.EVEN=1]="EVEN",s[s.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(s){s[s.COPY_EDITORS=0]="COPY_EDITORS",s[s.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function P(s){const v=s;return(0,M.isEditorInput)(v?.editor)&&(0,M.isEditorInput)(v?.replacement)}e.isEditorReplacement=P;var t;(function(s){s[s.CREATION_TIME=0]="CREATION_TIME",s[s.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",s[s.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var E;(function(s){s[s.GROUP_ACTIVE=0]="GROUP_ACTIVE",s[s.GROUP_INDEX=1]="GROUP_INDEX",s[s.GROUP_LOCKED=2]="GROUP_LOCKED",s[s.EDITOR_OPEN=3]="EDITOR_OPEN",s[s.EDITOR_CLOSE=4]="EDITOR_CLOSE",s[s.EDITOR_MOVE=5]="EDITOR_MOVE",s[s.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",s[s.EDITOR_LABEL=7]="EDITOR_LABEL",s[s.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",s[s.EDITOR_PIN=9]="EDITOR_PIN",s[s.EDITOR_STICKY=10]="EDITOR_STICKY",s[s.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(E=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(s){s[s.NEW_EDITOR=1]="NEW_EDITOR",s[s.MOVE_EDITOR=2]="MOVE_EDITOR",s[s.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function f(s){const v=s;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.isEditorGroup=f;function l(s){return s.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=l}),define(be[169],Ee([0,1,4,92]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,h.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(T){const F=T;return typeof T=="number"||(0,M.isEditorGroup)(F)}e.isPreferredGroup=b}),define(be[8],Ee([0,1,13,23,76,230,54,22,10,2,42,59,137,82,46,89,67,169,7]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l,s,v,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(ne){function pe(B){const{selectionStartLineNumber:Ce,selectionStartColumn:Se,positionLineNumber:Ge,positionColumn:We}=B,it=new y.Position(Ce-1,Se-1),mt=new y.Position(Ge-1,We-1);return new y.Selection(it,mt)}ne.to=pe;function re(B){const{anchor:Ce,active:Se}=B;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Se.line+1,positionColumn:Se.character+1}}ne.from=re})(a=e.Selection||(e.Selection={}));var m;(function(ne){function pe(B){if(!B)return;const{start:Ce,end:Se}=B;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Se.line+1,endColumn:Se.character+1}}ne.from=pe;function re(B){if(!B)return;const{startLineNumber:Ce,startColumn:Se,endLineNumber:Ge,endColumn:We}=B;return new y.Range(Ce-1,Se-1,Ge-1,We-1)}ne.to=re})(m=e.Range||(e.Range={}));var k;(function(ne){function pe(re){switch(re){case 1:return y.StandardTokenType.Comment;case 0:return y.StandardTokenType.Other;case 4:return y.StandardTokenType.RegEx;case 2:return y.StandardTokenType.String}}ne.to=pe})(k=e.TokenType||(e.TokenType={}));var i;(function(ne){function pe(B){return new y.Position(B.lineNumber-1,B.column-1)}ne.to=pe;function re(B){return{lineNumber:B.line+1,column:B.character+1}}ne.from=re})(i=e.Position||(e.Position={}));var u;(function(ne){function pe(B){switch(B){case y.DiagnosticTag.Unnecessary:return 1;case y.DiagnosticTag.Deprecated:return 2}}ne.from=pe;function re(B){switch(B){case 1:return y.DiagnosticTag.Unnecessary;case 2:return y.DiagnosticTag.Deprecated;default:return}}ne.to=re})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(ne){function pe(B){let Ce;return B.code&&((0,_.isString)(B.code)||(0,_.isNumber)(B.code)?Ce=String(B.code):Ce={value:String(B.code.value),target:B.code.target}),{...m.from(B.range),message:B.message,source:B.source,code:Ce,severity:w.from(B.severity),relatedInformation:B.relatedInformation&&B.relatedInformation.map(o.from),tags:Array.isArray(B.tags)?(0,h.coalesce)(B.tags.map(u.from)):void 0}}ne.from=pe;function re(B){const Ce=new y.Diagnostic(m.to(B),B.message,w.to(B.severity));return Ce.source=B.source,Ce.code=(0,_.isString)(B.code)?B.code:B.code?.value,Ce.relatedInformation=B.relatedInformation&&B.relatedInformation.map(o.to),Ce.tags=B.tags&&(0,h.coalesce)(B.tags.map(u.to)),Ce}ne.to=re})(r=e.Diagnostic||(e.Diagnostic={}));var o;(function(ne){function pe(B){return{...m.from(B.location.range),message:B.message,resource:B.location.uri}}ne.from=pe;function re(B){return new y.DiagnosticRelatedInformation(new y.Location(B.resource,m.to(B)),B.message)}ne.to=re})(o=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var w;(function(ne){function pe(B){switch(B){case y.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case y.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case y.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case y.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}ne.from=pe;function re(B){switch(B){case f.MarkerSeverity.Info:return y.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return y.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return y.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return y.DiagnosticSeverity.Hint;default:return y.DiagnosticSeverity.Error}}ne.to=re})(w=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var d;(function(ne){function pe(B){return typeof B=="number"&&B>=y.ViewColumn.One?B-1:B===y.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}ne.from=pe;function re(B){if(typeof B=="number"&&B>=0)return B+1;throw new Error("invalid 'EditorGroupColumn'")}ne.to=re})(d=e.ViewColumn||(e.ViewColumn={}));function g(ne){return typeof ne.range!="undefined"}function S(ne){return ne.length===0?!0:!!g(ne[0])}e.isDecorationOptionsArr=S;var R;(function(ne){function pe(We){return We.map(ne.from)}ne.fromMany=pe;function re(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function B(We){let it;if(re(We)){const{language:ot,value:lt}=We;it={value:"```"+ot+`
`+lt+"\n```\n"}}else y.MarkdownString.isMarkdownString(We)?it={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml}:typeof We=="string"?it={value:We}:it={value:""};const mt=Object.create(null);it.uris=mt;const vt=ot=>{try{let lt=P.URI.parse(ot,!0);lt=lt.with({query:Ce(lt.query,mt)}),mt[ot]=lt}catch(lt){}return""},nt=new T.Renderer;return nt.link=vt,nt.image=ot=>vt(b.parseHrefAndDimensions(ot).href),T(it.value,{renderer:nt}),it}ne.from=B;function Ce(We,it){if(!We)return We;let mt;try{mt=(0,F.parse)(We)}catch(nt){}if(!mt)return We;let vt=!1;return mt=(0,C.cloneAndChange)(mt,nt=>{if(P.URI.isUri(nt)){const ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ot]=nt,vt=!0,ot}else return}),vt?JSON.stringify(mt):We}function Se(We){const it=new y.MarkdownString(We.value,We.supportThemeIcons);return it.isTrusted=We.isTrusted,it.supportHtml=We.supportHtml,it}ne.to=Se;function Ge(We){if(!!We)return typeof We=="string"?We:ne.from(We)}ne.fromStrict=Ge})(R=e.MarkdownString||(e.MarkdownString={}));function p(ne){return S(ne)?ne.map(pe=>({range:m.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?R.fromMany(pe.hoverMessage):pe.hoverMessage?R.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):ne.map(pe=>({range:m.from(pe)}))}e.fromRangeOrRangeWithMessage=p;function D(ne){return typeof ne=="undefined"?ne:typeof ne=="string"?P.URI.file(ne):ne}e.pathOrURIToURI=D;var c;(function(ne){function pe(re){return typeof re=="undefined"?re:{contentText:re.contentText,contentIconPath:re.contentIconPath?D(re.contentIconPath):void 0,border:re.border,borderColor:re.borderColor,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,color:re.color,backgroundColor:re.backgroundColor,margin:re.margin,width:re.width,height:re.height}}ne.from=pe})(c=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var A;(function(ne){function pe(re){return typeof re=="undefined"?re:{backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?D(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?c.from(re.before):void 0,after:re.after?c.from(re.after):void 0}}ne.from=pe})(A=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var O;(function(ne){function pe(re){if(typeof re=="undefined")return re;switch(re){case y.DecorationRangeBehavior.OpenOpen:return 0;case y.DecorationRangeBehavior.ClosedClosed:return 1;case y.DecorationRangeBehavior.OpenClosed:return 2;case y.DecorationRangeBehavior.ClosedOpen:return 3}}ne.from=pe})(O=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var z;(function(ne){function pe(re){return{isWholeLine:re.isWholeLine,rangeBehavior:re.rangeBehavior?O.from(re.rangeBehavior):void 0,overviewRulerLane:re.overviewRulerLane,light:re.light?A.from(re.light):void 0,dark:re.dark?A.from(re.dark):void 0,backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?D(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?c.from(re.before):void 0,after:re.after?c.from(re.after):void 0}}ne.from=pe})(z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(ne){function pe(B){return{text:B.newText,eol:B.newEol&&he.from(B.newEol),range:m.from(B.range)}}ne.from=pe;function re(B){const Ce=new y.TextEdit(m.to(B.range),B.text);return Ce.newEol=typeof B.eol=="undefined"?void 0:he.to(B.eol),Ce}ne.to=re})(K=e.TextEdit||(e.TextEdit={}));var $;(function(ne){function pe(B,Ce,Se){const Ge={edits:[]};if(B instanceof y.WorkspaceEdit)for(let We of B._allEntries())if(We._type===1)Ge.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata});else if(We._type===2){const it=Ce?.getDocument(We.uri);Ge.edits.push({_type:2,resource:We.uri,edit:K.from(We.edit),modelVersionId:it?.version,metadata:We.metadata})}else We._type===3?Ge.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version}):We._type===5&&Ge.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version,edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(Et.from)}});return Ge}ne.from=pe;function re(B){const Ce=new y.WorkspaceEdit;for(const Se of B.edits)Se.edit?Ce.replace(P.URI.revive(Se.resource),m.to(Se.edit.range),Se.edit.text):Ce.renameFile(P.URI.revive(Se.oldUri),P.URI.revive(Se.newUri),Se.options);return Ce}ne.to=re})($=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Q;(function(ne){const pe=Object.create(null);pe[y.SymbolKind.File]=0,pe[y.SymbolKind.Module]=1,pe[y.SymbolKind.Namespace]=2,pe[y.SymbolKind.Package]=3,pe[y.SymbolKind.Class]=4,pe[y.SymbolKind.Method]=5,pe[y.SymbolKind.Property]=6,pe[y.SymbolKind.Field]=7,pe[y.SymbolKind.Constructor]=8,pe[y.SymbolKind.Enum]=9,pe[y.SymbolKind.Interface]=10,pe[y.SymbolKind.Function]=11,pe[y.SymbolKind.Variable]=12,pe[y.SymbolKind.Constant]=13,pe[y.SymbolKind.String]=14,pe[y.SymbolKind.Number]=15,pe[y.SymbolKind.Boolean]=16,pe[y.SymbolKind.Array]=17,pe[y.SymbolKind.Object]=18,pe[y.SymbolKind.Key]=19,pe[y.SymbolKind.Null]=20,pe[y.SymbolKind.EnumMember]=21,pe[y.SymbolKind.Struct]=22,pe[y.SymbolKind.Event]=23,pe[y.SymbolKind.Operator]=24,pe[y.SymbolKind.TypeParameter]=25;function re(Ce){return typeof pe[Ce]=="number"?pe[Ce]:6}ne.from=re;function B(Ce){for(const Se in pe)if(pe[Se]===Ce)return Number(Se);return y.SymbolKind.Property}ne.to=B})(Q=e.SymbolKind||(e.SymbolKind={}));var W;(function(ne){function pe(B){switch(B){case y.SymbolTag.Deprecated:return 1}}ne.from=pe;function re(B){switch(B){case 1:return y.SymbolTag.Deprecated}}ne.to=re})(W=e.SymbolTag||(e.SymbolTag={}));var U;(function(ne){function pe(B){return{name:B.name,kind:Q.from(B.kind),tags:B.tags&&B.tags.map(W.from),containerName:B.containerName,location:le.from(B.location)}}ne.from=pe;function re(B){const Ce=new y.SymbolInformation(B.name,Q.to(B.kind),B.containerName,le.to(B.location));return Ce.tags=B.tags&&B.tags.map(W.to),Ce}ne.to=re})(U=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var H;(function(ne){function pe(B){const Ce={name:B.name||"!!MISSING: name!!",detail:B.detail,range:m.from(B.range),selectionRange:m.from(B.selectionRange),kind:Q.from(B.kind),tags:B.tags?.map(W.from)??[]};return B.children&&(Ce.children=B.children.map(pe)),Ce}ne.from=pe;function re(B){const Ce=new y.DocumentSymbol(B.name,B.detail,Q.to(B.kind),m.to(B.range),m.to(B.selectionRange));return(0,h.isNonEmptyArray)(B.tags)&&(Ce.tags=B.tags.map(W.to)),B.children&&(Ce.children=B.children.map(re)),Ce}ne.to=re})(H=e.DocumentSymbol||(e.DocumentSymbol={}));var G;(function(ne){function pe(B){const Ce=new y.CallHierarchyItem(Q.to(B.kind),B.name,B.detail||"",P.URI.revive(B.uri),m.to(B.range),m.to(B.selectionRange));return Ce._sessionId=B._sessionId,Ce._itemId=B._itemId,Ce}ne.to=pe;function re(B,Ce,Se){if(Ce=Ce??B._sessionId,Se=Se??B._itemId,Ce===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Se,name:B.name,detail:B.detail,kind:Q.from(B.kind),uri:B.uri,range:m.from(B.range),selectionRange:m.from(B.selectionRange),tags:B.tags?.map(W.from)}}ne.from=re})(G=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ue;(function(ne){function pe(re){return new y.CallHierarchyIncomingCall(G.to(re.from),re.fromRanges.map(B=>m.to(B)))}ne.to=pe})(ue=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var q;(function(ne){function pe(re){return new y.CallHierarchyOutgoingCall(G.to(re.to),re.fromRanges.map(B=>m.to(B)))}ne.to=pe})(q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var le;(function(ne){function pe(B){return{range:B.range&&m.from(B.range),uri:B.uri}}ne.from=pe;function re(B){return new y.Location(P.URI.revive(B.uri),m.to(B.range))}ne.to=re})(le=e.location||(e.location={}));var se;(function(ne){function pe(B){const Ce=B,Se=B;return{originSelectionRange:Ce.originSelectionRange?m.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Se.uri,range:m.from(Ce.targetRange?Ce.targetRange:Se.range),targetSelectionRange:Ce.targetSelectionRange?m.from(Ce.targetSelectionRange):void 0}}ne.from=pe;function re(B){return{targetUri:P.URI.revive(B.uri),targetRange:m.to(B.range),targetSelectionRange:B.targetSelectionRange?m.to(B.targetSelectionRange):void 0,originSelectionRange:B.originSelectionRange?m.to(B.originSelectionRange):void 0}}ne.to=re})(se=e.DefinitionLink||(e.DefinitionLink={}));var ve;(function(ne){function pe(B){return{range:m.from(B.range),contents:R.fromMany(B.contents)}}ne.from=pe;function re(B){return new y.Hover(B.contents.map(R.to),m.to(B.range))}ne.to=re})(ve=e.Hover||(e.Hover={}));var Fe;(function(ne){function pe(B){return{range:m.from(B.range),expression:B.expression}}ne.from=pe;function re(B){return new y.EvaluatableExpression(m.to(B.range),B.expression)}ne.to=re})(Fe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Me;(function(ne){function pe(B){if(B instanceof y.InlineValueText)return{type:"text",range:m.from(B.range),text:B.text};if(B instanceof y.InlineValueVariableLookup)return{type:"variable",range:m.from(B.range),variableName:B.variableName,caseSensitiveLookup:B.caseSensitiveLookup};if(B instanceof y.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(B.range),expression:B.expression};throw new Error("Unknown 'InlineValue' type")}ne.from=pe;function re(B){switch(B.type){case"text":return{range:m.to(B.range),text:B.text};case"variable":return{range:m.to(B.range),variableName:B.variableName,caseSensitiveLookup:B.caseSensitiveLookup};case"expression":return{range:m.to(B.range),expression:B.expression}}}ne.to=re})(Me=e.InlineValue||(e.InlineValue={}));var Ne;(function(ne){function pe(B){return{frameId:B.frameId,stoppedLocation:m.from(B.stoppedLocation)}}ne.from=pe;function re(B){return new y.InlineValueContext(B.frameId,m.to(B.stoppedLocation))}ne.to=re})(Ne=e.InlineValueContext||(e.InlineValueContext={}));var Qe;(function(ne){function pe(B){return{range:m.from(B.range),kind:B.kind}}ne.from=pe;function re(B){return new y.DocumentHighlight(m.to(B.range),B.kind)}ne.to=re})(Qe=e.DocumentHighlight||(e.DocumentHighlight={}));var ze;(function(ne){function pe(re){switch(re){case 1:return y.CompletionTriggerKind.TriggerCharacter;case 2:return y.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return y.CompletionTriggerKind.Invoke}}ne.to=pe})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function(ne){function pe(re){return{triggerKind:ze.to(re.triggerKind),triggerCharacter:re.triggerCharacter}}ne.to=pe})(qe=e.CompletionContext||(e.CompletionContext={}));var x;(function(ne){function pe(B){switch(B){case y.CompletionItemTag.Deprecated:return 1}}ne.from=pe;function re(B){switch(B){case 1:return y.CompletionItemTag.Deprecated}}ne.to=re})(x=e.CompletionItemTag||(e.CompletionItemTag={}));var Y;(function(ne){const pe=new Map([[y.CompletionItemKind.Method,0],[y.CompletionItemKind.Function,1],[y.CompletionItemKind.Constructor,2],[y.CompletionItemKind.Field,3],[y.CompletionItemKind.Variable,4],[y.CompletionItemKind.Class,5],[y.CompletionItemKind.Interface,7],[y.CompletionItemKind.Struct,6],[y.CompletionItemKind.Module,8],[y.CompletionItemKind.Property,9],[y.CompletionItemKind.Unit,12],[y.CompletionItemKind.Value,13],[y.CompletionItemKind.Constant,14],[y.CompletionItemKind.Enum,15],[y.CompletionItemKind.EnumMember,16],[y.CompletionItemKind.Keyword,17],[y.CompletionItemKind.Snippet,27],[y.CompletionItemKind.Text,18],[y.CompletionItemKind.Color,19],[y.CompletionItemKind.File,20],[y.CompletionItemKind.Reference,21],[y.CompletionItemKind.Folder,23],[y.CompletionItemKind.Event,10],[y.CompletionItemKind.Operator,11],[y.CompletionItemKind.TypeParameter,24],[y.CompletionItemKind.Issue,26],[y.CompletionItemKind.User,25]]);function re(Se){return pe.get(Se)??9}ne.from=re;const B=new Map([[0,y.CompletionItemKind.Method],[1,y.CompletionItemKind.Function],[2,y.CompletionItemKind.Constructor],[3,y.CompletionItemKind.Field],[4,y.CompletionItemKind.Variable],[5,y.CompletionItemKind.Class],[7,y.CompletionItemKind.Interface],[6,y.CompletionItemKind.Struct],[8,y.CompletionItemKind.Module],[9,y.CompletionItemKind.Property],[12,y.CompletionItemKind.Unit],[13,y.CompletionItemKind.Value],[14,y.CompletionItemKind.Constant],[15,y.CompletionItemKind.Enum],[16,y.CompletionItemKind.EnumMember],[17,y.CompletionItemKind.Keyword],[27,y.CompletionItemKind.Snippet],[18,y.CompletionItemKind.Text],[19,y.CompletionItemKind.Color],[20,y.CompletionItemKind.File],[21,y.CompletionItemKind.Reference],[23,y.CompletionItemKind.Folder],[10,y.CompletionItemKind.Event],[11,y.CompletionItemKind.Operator],[24,y.CompletionItemKind.TypeParameter],[25,y.CompletionItemKind.User],[26,y.CompletionItemKind.Issue]]);function Ce(Se){return B.get(Se)??y.CompletionItemKind.Property}ne.to=Ce})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(ne){function pe(re,B){const Ce=new y.CompletionItem(re.label);return Ce.insertText=re.insertText,Ce.kind=Y.to(re.kind),Ce.tags=re.tags?.map(x.to),Ce.detail=re.detail,Ce.documentation=b.isMarkdownString(re.documentation)?R.to(re.documentation):re.documentation,Ce.sortText=re.sortText,Ce.filterText=re.filterText,Ce.preselect=re.preselect,Ce.commitCharacters=re.commitCharacters,t.Range.isIRange(re.range)?Ce.range=m.to(re.range):typeof re.range=="object"&&(Ce.range={inserting:m.to(re.range.insert),replacing:m.to(re.range.replace)}),Ce.keepWhitespace=typeof re.insertTextRules=="undefined"?!1:Boolean(re.insertTextRules&1),typeof re.insertTextRules!="undefined"&&re.insertTextRules&4?Ce.insertText=new y.SnippetString(re.insertText):(Ce.insertText=re.insertText,Ce.textEdit=Ce.range instanceof y.Range?new y.TextEdit(Ce.range,Ce.insertText):void 0),re.additionalTextEdits&&re.additionalTextEdits.length>0&&(Ce.additionalTextEdits=re.additionalTextEdits.map(Se=>K.to(Se))),Ce.command=B&&re.command?B.fromInternal(re.command):void 0,Ce}ne.to=pe})(ee=e.CompletionItem||(e.CompletionItem={}));var ae;(function(ne){function pe(B){return{label:B.label,documentation:B.documentation?R.fromStrict(B.documentation):void 0}}ne.from=pe;function re(B){return{label:B.label,documentation:b.isMarkdownString(B.documentation)?R.to(B.documentation):B.documentation}}ne.to=re})(ae=e.ParameterInformation||(e.ParameterInformation={}));var j;(function(ne){function pe(B){return{label:B.label,documentation:B.documentation?R.fromStrict(B.documentation):void 0,parameters:Array.isArray(B.parameters)?B.parameters.map(ae.from):[],activeParameter:B.activeParameter}}ne.from=pe;function re(B){return{label:B.label,documentation:b.isMarkdownString(B.documentation)?R.to(B.documentation):B.documentation,parameters:Array.isArray(B.parameters)?B.parameters.map(ae.to):[],activeParameter:B.activeParameter}}ne.to=re})(j=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(ne){function pe(B){return{activeSignature:B.activeSignature,activeParameter:B.activeParameter,signatures:Array.isArray(B.signatures)?B.signatures.map(j.from):[]}}ne.from=pe;function re(B){return{activeSignature:B.activeSignature,activeParameter:B.activeParameter,signatures:Array.isArray(B.signatures)?B.signatures.map(j.to):[]}}ne.to=re})(oe=e.SignatureHelp||(e.SignatureHelp={}));var fe;(function(ne){function pe(B){return{text:B.text,position:i.from(B.position),kind:Ae.from(B.kind??y.InlayHintKind.Other),whitespaceBefore:B.whitespaceBefore,whitespaceAfter:B.whitespaceAfter}}ne.from=pe;function re(B){const Ce=new y.InlayHint(B.text,i.to(B.position),Ae.to(B.kind));return Ce.whitespaceAfter=B.whitespaceAfter,Ce.whitespaceBefore=B.whitespaceBefore,Ce}ne.to=re})(fe=e.InlayHint||(e.InlayHint={}));var Ae;(function(ne){function pe(B){return B}ne.from=pe;function re(B){return B}ne.to=re})(Ae=e.InlayHintKind||(e.InlayHintKind={}));var xe;(function(ne){function pe(B){return{range:m.from(B.range),url:B.target,tooltip:B.tooltip}}ne.from=pe;function re(B){let Ce;if(B.url)try{Ce=typeof B.url=="string"?P.URI.parse(B.url,!0):P.URI.revive(B.url)}catch(Se){}return new y.DocumentLink(m.to(B.range),Ce)}ne.to=re})(xe=e.DocumentLink||(e.DocumentLink={}));var $e;(function(ne){function pe(B){const Ce=new y.ColorPresentation(B.label);return B.textEdit&&(Ce.textEdit=K.to(B.textEdit)),B.additionalTextEdits&&(Ce.additionalTextEdits=B.additionalTextEdits.map(Se=>K.to(Se))),Ce}ne.to=pe;function re(B){return{label:B.label,textEdit:B.textEdit?K.from(B.textEdit):void 0,additionalTextEdits:B.additionalTextEdits?B.additionalTextEdits.map(Ce=>K.from(Ce)):void 0}}ne.from=re})($e=e.ColorPresentation||(e.ColorPresentation={}));var we;(function(ne){function pe(B){return new y.Color(B[0],B[1],B[2],B[3])}ne.to=pe;function re(B){return[B.red,B.green,B.blue,B.alpha]}ne.from=re})(we=e.Color||(e.Color={}));var Ze;(function(ne){function pe(B){return{range:m.from(B.range)}}ne.from=pe;function re(B){return new y.SelectionRange(m.to(B.range))}ne.to=re})(Ze=e.SelectionRange||(e.SelectionRange={}));var V;(function(ne){function pe(re){switch(re){case 2:return y.TextDocumentSaveReason.AfterDelay;case 1:return y.TextDocumentSaveReason.Manual;case 3:case 4:return y.TextDocumentSaveReason.FocusOut}}ne.to=pe})(V=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var J;(function(ne){function pe(B){switch(B){case y.TextEditorLineNumbersStyle.Off:return 0;case y.TextEditorLineNumbersStyle.Relative:return 2;case y.TextEditorLineNumbersStyle.On:default:return 1}}ne.from=pe;function re(B){switch(B){case 0:return y.TextEditorLineNumbersStyle.Off;case 2:return y.TextEditorLineNumbersStyle.Relative;case 1:default:return y.TextEditorLineNumbersStyle.On}}ne.to=re})(J=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var he;(function(ne){function pe(B){if(B===y.EndOfLine.CRLF)return 1;if(B===y.EndOfLine.LF)return 0}ne.from=pe;function re(B){if(B===1)return y.EndOfLine.CRLF;if(B===0)return y.EndOfLine.LF}ne.to=re})(he=e.EndOfLine||(e.EndOfLine={}));var Oe;(function(ne){function pe(re){if(typeof re=="object")return re.viewId;switch(re){case y.ProgressLocation.SourceControl:return 3;case y.ProgressLocation.Window:return 10;case y.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ne.from=pe})(Oe=e.ProgressLocation||(e.ProgressLocation={}));var Ve;(function(ne){function pe(re){const B={start:re.start+1,end:re.end+1};return re.kind&&(B.kind=tt.from(re.kind)),B}ne.from=pe})(Ve=e.FoldingRange||(e.FoldingRange={}));var tt;(function(ne){function pe(re){if(re)switch(re){case y.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case y.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case y.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}ne.from=pe})(tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ut;(function(ne){function pe(re){if(re)return{pinned:typeof re.preview=="boolean"?!re.preview:void 0,inactive:re.background,preserveFocus:re.preserveFocus,selection:typeof re.selection=="object"?m.from(re.selection):void 0,override:typeof re.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ne.from=pe})(ut=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ht;(function(ne){function pe(B){return B instanceof y.RelativePattern||typeof B=="string"?B:re(B)?new y.RelativePattern(B.base,B.pattern):B}ne.from=pe;function re(B){const Ce=B;return Ce&&typeof Ce.base=="string"&&typeof Ce.pattern=="string"}})(ht=e.GlobPattern||(e.GlobPattern={}));var St;(function(ne){function pe(re){if(re){if(Array.isArray(re))return re.map(pe);if(typeof re=="string")return re;{const B=re;return{language:B.language,scheme:B.scheme,pattern:typeof B.pattern=="undefined"?void 0:ht.from(B.pattern),exclusive:B.exclusive}}}else return}ne.from=pe})(St=e.LanguageSelector||(e.LanguageSelector={}));var Pt;(function(ne){function pe(B){return{start:B.start,end:B.end}}ne.from=pe;function re(B){return new y.NotebookRange(B.start,B.end)}ne.to=re})(Pt=e.NotebookRange||(e.NotebookRange={}));var dt;(function(ne){function pe(B){return{timing:typeof B.runStartTime=="number"&&typeof B.runEndTime=="number"?{startTime:B.runStartTime,endTime:B.runEndTime}:void 0,executionOrder:B.executionOrder,success:B.lastRunSuccess}}ne.to=pe;function re(B){return{lastRunSuccess:B.success,runStartTime:B.timing?.startTime,runEndTime:B.timing?.endTime,executionOrder:B.executionOrder}}ne.from=re})(dt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var bt;(function(ne){function pe(B){switch(B){case y.NotebookCellKind.Markup:return s.CellKind.Markup;case y.NotebookCellKind.Code:default:return s.CellKind.Code}}ne.from=pe;function re(B){switch(B){case s.CellKind.Markup:return y.NotebookCellKind.Markup;case s.CellKind.Code:default:return y.NotebookCellKind.Code}}ne.to=re})(bt=e.NotebookCellKind||(e.NotebookCellKind={}));var ft;(function(ne){function pe(B){const Ce={metadata:B.metadata??Object.create(null),cells:[]};for(let Se of B.cells)y.NotebookCellData.validate(Se),Ce.cells.push(Et.from(Se));return Ce}ne.from=pe;function re(B){const Ce=new y.NotebookData(B.cells.map(Et.to));return(0,_.isEmptyObject)(B.metadata)||(Ce.metadata=B.metadata),Ce}ne.to=re})(ft=e.NotebookData||(e.NotebookData={}));var Et;(function(ne){function pe(B){return{cellKind:bt.from(B.kind),language:B.languageId,mime:B.mime,source:B.value,metadata:B.metadata,internalMetadata:dt.from(B.executionSummary??{}),outputs:B.outputs?B.outputs.map(Ct.from):[]}}ne.from=pe;function re(B){return new y.NotebookCellData(bt.to(B.cellKind),B.source,B.language,B.mime,B.outputs?B.outputs.map(Ct.to):void 0,B.metadata,B.internalMetadata?dt.to(B.internalMetadata):void 0)}ne.to=re})(Et=e.NotebookCellData||(e.NotebookCellData={}));var Ye;(function(ne){function pe(B){return{mime:B.mime,valueBytes:M.VSBuffer.wrap(B.data)}}ne.from=pe;function re(B){return new y.NotebookCellOutputItem(B.valueBytes.buffer,B.mime)}ne.to=re})(Ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(ne){function pe(B){return{outputId:B.id,items:B.items.map(Ye.from),metadata:B.metadata}}ne.from=pe;function re(B){const Ce=B.items.map(Ye.to);return new y.NotebookCellOutput(Ce,B.outputId,B.metadata)}ne.to=re})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pe;(function(ne){function pe(Se){if(Se!=null){if(Se instanceof y.RelativePattern||typeof Se=="string")return Se;if(Ce(Se))return new y.RelativePattern(Se.base,Se.pattern);if(B(Se))return{include:ht.from(Se.include)||void 0,exclude:ht.from(Se.exclude)||void 0}}}ne.from=pe;function re(Se){return typeof Se=="string"?Se:Ce(Se)?{base:Se.base,pattern:Se.pattern}:{include:Se.include,exclude:Se.exclude}}ne.to=re;function B(Se){const Ge=Se,We=ht.from(Ge.include);if(!(We&&We instanceof y.RelativePattern||typeof We=="string"))return!1;const it=ht.from(Ge.exclude);return!!(it&&it instanceof y.RelativePattern||typeof it=="string")}function Ce(Se){const Ge=Se;return Ge&&typeof Ge.base=="string"&&typeof Ge.pattern=="string"}})(Pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(ne){function pe(re){return{backgroundColor:re.backgroundColor,borderColor:re.borderColor,top:re.top?c.from(re.top):void 0}}ne.from=pe})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var De;(function(ne){function pe(re,B,Ce){const Se=typeof re.command=="string"?{title:"",command:re.command}:re.command;return{alignment:re.alignment===y.NotebookCellStatusBarAlignment.Left?1:2,command:B.toInternal(Se,Ce),text:re.text,tooltip:re.tooltip,accessibilityInformation:re.accessibilityInformation,priority:re.priority}}ne.from=pe})(De=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Z;(function(ne){function pe(re){return{transientOutputs:re?.transientOutputs??!1,transientCellMetadata:re?.transientCellMetadata??{},transientDocumentMetadata:re?.transientDocumentMetadata??{}}}ne.from=pe})(Z=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ce;(function(ne){function pe(B){return{uri:B.uri,provides:B.provides}}ne.from=pe;function re(B){return new y.NotebookRendererScript(P.URI.revive(B.uri),B.provides)}ne.to=re})(ce=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ge;(function(ne){function pe(B){return{message:R.fromStrict(B.message)||"",type:0,expected:B.expectedOutput,actual:B.actualOutput,location:B.location?le.from(B.location):void 0}}ne.from=pe;function re(B){const Ce=new y.TestMessage(typeof B.message=="string"?B.message:R.to(B.message));return Ce.actualOutput=B.actual,Ce.expectedOutput=B.expected,Ce.location=B.location?le.to(B.location):void 0,Ce}ne.to=re})(ge=e.TestMessage||(e.TestMessage={}));var me;(function(ne){let pe;(function(re){re.Delimiter="\0"})(pe||(pe={})),ne.namespace=(re,B)=>re+"\0"+B,ne.denamespace=re=>{const B=re.indexOf("\0");return{ctrlId:re.slice(0,B),tagId:re.slice(B+1)}}})(me=e.TestTag||(e.TestTag={}));var Ie;(function(ne){function pe(Se){const Ge=(0,l.getPrivateApiFor)(Se).controllerId;return{extId:v.TestId.fromExtHostTestItem(Se,Ge).toString(),label:Se.label,uri:Se.uri,tags:Se.tags.map(We=>me.namespace(Ge,We.id)),range:m.from(Se.range)||null,description:Se.description||null,error:Se.error&&R.fromStrict(Se.error)||null}}ne.from=pe;function re(Se){return{id:v.TestId.fromString(Se.extId).localId,label:Se.label,uri:P.URI.revive(Se.uri),tags:(Se.tags||[]).map(Ge=>{const{tagId:We}=me.denamespace(Ge);return new y.TestTag(We)}),range:m.to(Se.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Se.description||void 0}}ne.toPlain=re;function B(Se){const Ge=v.TestId.fromString(Se.extId),We=new l.TestItemImpl(Ge.controllerId,Ge.localId,Se.label,P.URI.revive(Se.uri));return We.range=m.to(Se.range||void 0),We.description=Se.description||void 0,We}function Ce(Se){let Ge;for(const We of Se.tests){const it=B(We.item);(0,l.getPrivateApiFor)(it).parent=Ge,Ge=it}return Ge}ne.toItemFromContext=Ce})(Ie=e.TestItem||(e.TestItem={})),function(ne){function pe(B){return{id:B.id}}ne.from=pe;function re(B){return new y.TestTag(B.id)}ne.to=re}(me=e.TestTag||(e.TestTag={}));var Be;(function(ne){const pe=(B,Ce)=>{const Se={...Ie.toPlain(B.item),parent:void 0,taskStates:B.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(We=>We.type===0).map(ge.to)})),children:B.children.map(Ge=>Ce.get(Ge)).filter(_.isDefined).map(Ge=>pe(Ge,Ce))};for(const Ge of Se.children)Ge.parent=Se;return Se};function re(B){const Ce=[],Se=new Map;for(const Ge of B.items)Se.set(Ge.item.extId,Ge),B.request.targets.some(We=>We.controllerId===Ge.controllerId&&We.testIds.includes(Ge.item.extId))&&Ce.push(Ge);return{completedAt:B.completedAt,results:Ce.map(Ge=>pe(Ge,Se))}}ne.to=re})(Be=e.TestResults||(e.TestResults={}));var Le;(function(ne){function pe(Se){return{covered:Se.covered,total:Se.covered}}function re(Se){return"line"in Se?i.from(Se):m.from(Se)}function B(Se){return"branches"in Se?{count:Se.executionCount,location:re(Se.location),type:1,branches:Se.branches.length?Se.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&re(Ge.location)})):void 0}:{type:0,count:Se.executionCount,location:re(Se.location)}}ne.fromDetailed=B;function Ce(Se){return{uri:Se.uri,statement:pe(Se.statementCoverage),branch:Se.branchCoverage&&pe(Se.branchCoverage),function:Se.functionCoverage&&pe(Se.functionCoverage),details:Se.detailedCoverage?.map(B)}}ne.fromFile=Ce})(Le=e.TestCoverage||(e.TestCoverage={}));var je;(function(ne){function pe(re){switch(re){case 1:return y.CodeActionTriggerKind.Invoke;case 2:return y.CodeActionTriggerKind.Automatic}}ne.to=pe})(je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Xe;(function(ne){function pe(B){const Ce=new y.TypeHierarchyItem(Q.to(B.kind),B.name,B.detail||"",P.URI.revive(B.uri),m.to(B.range),m.to(B.selectionRange));return Ce._sessionId=B._sessionId,Ce._itemId=B._itemId,Ce}ne.to=pe;function re(B,Ce,Se){if(Ce=Ce??B._sessionId,Se=Se??B._itemId,Ce===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Se,kind:Q.from(B.kind),name:B.name,detail:B.detail??"",uri:B.uri,range:m.from(B.range),selectionRange:m.from(B.selectionRange),tags:B.tags?.map(W.from)}}ne.from=re})(Xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[170],Ee([0,1,2,16,7,8,231]),function(ie,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(P,t,E,n={timeout:1500,errors:3}){this._logService=P,this._documents=t,this._mainThreadBulkEdits=E,this._thresholds=n,this._callbacks=new F.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(t,E,n)=>{const l={dispose:this._callbacks.push([t,E,P])};return Array.isArray(n)&&n.push(l),l}}async $participateInSave(P,t){const E=h.URI.revive(P);let n=!1;const f=setTimeout(()=>n=!0,this._thresholds.timeout),l=[];try{for(let s of[...this._callbacks]){if(n)break;const v=this._documents.getDocument(E),I=await this._deliverEventAsyncAndBlameBadListeners(s,{document:v,reason:T.TextDocumentSaveReason.to(t)});l.push(I)}}finally{clearTimeout(f)}return l}_deliverEventAsyncAndBlameBadListeners([P,t,E],n){const f=this._badListeners.get(P);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(E,P,t,n).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const s=this._badListeners.get(P);this._badListeners.set(P,s?s+1:1),typeof s=="number"&&s>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,t,E,n){const f=[],l=Date.now(),{document:s,reason:v}=n,{version:I}=s,y=Object.freeze({document:s,reason:v,waitUntil(a){if(Object.isFrozen(f))throw(0,M.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(a))}});try{t.apply(E,[y])}catch(a){return Promise.reject(a)}return Object.freeze(f),new Promise((a,m)=>{const k=setTimeout(()=>m(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(k),a(i)}).catch(i=>{clearTimeout(k),m(i)})}).then(a=>{const m={edits:[]};for(const k of a)if(Array.isArray(k)&&k.every(i=>i instanceof b.TextEdit))for(const{newText:i,newEol:u,range:r}of k)m.edits.push({_type:2,resource:s.uri,edit:{range:r&&T.Range.from(r),text:i,eol:u&&T.EndOfLine.from(u)}});if(m.edits.length!==0)return I===s.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(m):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(be[68],Ee([0,1,8,2,3,4]),function(ie,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");class F{constructor(){this._onDidChangeTabs=new b.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new b.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[]}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let P=-1;this._tabs=_.map((E,n)=>(E.isActive&&(P=n),Object.freeze({label:E.label,viewColumn:h.ViewColumn.to(E.viewColumn),resource:M.URI.revive(E.resource),viewId:E.editorId,isActive:E.isActive})));const t=this._activeTab;this._activeTab=P===-1?void 0:this._tabs[P],this._activeTab!==t&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}}e.ExtHostEditorTabs=F}),define(be[171],Ee([0,1,3,27,2,8,7]),function(ie,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(t,E,n,f,l){this._onDidCreate=new h.Emitter,this._onDidChange=new h.Emitter,this._onDidDelete=new h.Emitter,this._config=0,n&&(this._config+=1),f&&(this._config+=2),l&&(this._config+=4);const s=(0,M.parse)(E),v=t(I=>{if(!n)for(let y of I.created){const a=b.URI.revive(y);s(a.fsPath)&&this._onDidCreate.fire(a)}if(!f)for(let y of I.changed){const a=b.URI.revive(y);s(a.fsPath)&&this._onDidChange.fire(a)}if(!l)for(let y of I.deleted){const a=b.URI.revive(y);s(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=F.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(t,E,n){this._logService=E,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new h.Emitter,this._onDidRenameFile=new h.Emitter,this._onDidCreateFile=new h.Emitter,this._onDidDeleteFile=new h.Emitter,this._onWillRenameFile=new h.AsyncEmitter,this._onWillCreateFile=new h.AsyncEmitter,this._onWillDeleteFile=new h.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,E,n,f){return new C(this._onFileSystemEvent.event,t,E,n,f)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,E){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:E.map(n=>({oldUri:b.URI.revive(n.source),newUri:b.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:E.map(n=>b.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:E.map(n=>b.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,E){return(n,f,l)=>{const s=function(I){n.call(f,I)};return s.extension=t,E.event(s,void 0,l)}}async $onWillRunFileOperation(t,E,n,f){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:E.map(l=>({oldUri:b.URI.revive(l.source),newUri:b.URI.revive(l.target)}))},n,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:E.map(l=>b.URI.revive(l.target))},n,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:E.map(l=>b.URI.revive(l.target))},n,f)}}async _fireWillEvent(t,E,n,f){const l=new Set,s=[];if(await t.fireAsync(E,f,async(I,y)=>{const a=Date.now(),m=await Promise.resolve(I);m instanceof F.WorkspaceEdit&&(s.push(m),l.add(y.extension.displayName??y.extension.identifier.value)),Date.now()-a>n&&this._logService.warn("SLOW file-participant",y.extension.identifier)}),f.isCancellationRequested||s.length===0)return;const v={edits:[]};for(let I of s){let{edits:y}=T.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(y)}return{edit:v,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=_}),define(be[172],Ee([0,1,11,22,2,8,7,89]),function(ie,e,h,M,b,T,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(n,f,l,s){this.start=n,this.deletedCount=f,this.deletedItems=l,this.items=s}static asApiEvents(n){return n.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(l=>l.apiCell)}))}}class P{constructor(n,f,l){this.notebook=n,this._extHostDocument=f,this._cellData=l,this.handle=l.handle,this.uri=b.URI.revive(l.uri),this.cellKind=l.cellKind,this._outputs=l.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=l.internalMetadata??{},this._metadata=Object.freeze(l.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(l.internalMetadata??{}))}static asModelAddData(n,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return n._mime},set mime(l){n._mime=l},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(T.NotebookCellOutput.to)}setOutputItems(n,f,l){const s=l.map(T.NotebookCellOutputItem.to),v=this._outputs.find(I=>I.id===n);v&&(f||(v.items.length=0),v.items.push(...s))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=P;class t{constructor(n,f,l,s,v,I){this._proxy=n,this._textDocumentsAndEditors=f,this._textDocuments=l,this._emitter=s,this.uri=v,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=I.viewType,this._metadata=Object.freeze(I.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,I.cells]],!0),this._versionId=I.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===h.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(f){return f=n._validateIndex(f),n._cells[f].apiCell},getCells(f){return(f?n._getCells(f):n._cells).map(s=>s.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,f){this._versionId=n.versionId,this._isDirty=f;for(const l of n.rawEvents)l.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1):l.kind===C.NotebookCellsChangeType.Move?this._moveCell(l.index,l.newIdx):l.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(l.index,l.outputs):l.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems):l.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(l.index,l.language):l.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(l.index,l.mime):l.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(l.index,l.metadata):l.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(l.index,l.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let f=n.start|0,l=n.end|0;return f<0&&(f=0),l>this._cells.length&&(l=this._cells.length),n.with({start:f,end:l})}_getCells(n){n=this._validateRange(n);const f=[];for(let l=n.start;l<n.end;l++)f.push(this._cells[l]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,f){if(this._disposed)return;const l=[],s=[],v=[];n.reverse().forEach(I=>{const a=I[2].map(i=>{const u=new P(this,this._textDocumentsAndEditors,i);return f||s.push(P.asModelAddData(this.apiNotebook,i)),u}),m=new _(I[0],I[1],[],a),k=this._cells.splice(I[0],I[1],...a);for(const i of k)v.push(i.uri),m.deletedItems.push(i.apiCell);l.push(m)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:v}),f||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(l)}))}_moveCell(n,f){const l=this._cells.splice(n,1);this._cells.splice(f,0,...l);const s=[new _(n,1,l.map(v=>v.apiCell),[]),new _(f,0,[],l)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(s)}))}_setCellOutputs(n,f){const l=this._cells[n];l.setOutputs(f),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[l.apiCell]}))}_setCellOutputItems(n,f,l,s){const v=this._cells[n];v.setOutputItems(f,l,s),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(n,f){const l=this._cells[n];l.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(l.uri,f)}_changeCellMime(n,f){const l=this._cells[n];l.apiCell.mime=f}_changeCellMetadata(n,f){const l=this._cells[n],s=l.apiCell.metadata;l.setMetadata(f);const v=l.apiCell.metadata;(0,M.equals)(s,v)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:l.apiCell}))}_changeCellInternalMetadata(n,f){const l=this._cells[n],s=l.internalMetadata;if(l.setInternalMetadata(f),s.runState!==f.runState){const v=f.runState??F.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:l.apiCell,state:v}))}}getCellFromApiCell(n){return this._cells.find(f=>f.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(f=>f.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(be[93],Ee([0,1,7,8,16]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:P})}replaceCells(_,P,t){this._throwIfFinalized(),!(_===P&&t.length===0)&&this._collectedEdits.push({editType:1,index:_,count:P-_,cells:t.map(M.NotebookCellData.from)})}}class F{constructor(_,P,t,E,n,f){this.id=_,this._proxy=P,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=E,this._viewColumn=f}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(P){if(!Array.isArray(P)||!P.every(h.NotebookRange.isNotebookRange))throw(0,b.illegalArgument)("selections");_._selections=P,_._trySetSelections(P)},get visibleRanges(){return _._visibleRanges},revealRange(P,t){_._proxy.$tryRevealRange(_.id,M.NotebookRange.from(P),t??h.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(P){const t=new T(this.document.version);return P(t),_._applyEdit(t.finalize())},setDecorations(P,t){return _.setDecorations(P,t)}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(M.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const P=[];let t=-1;for(let E=0;E<_.cellEdits.length;E++){if(t<0){P.push(_.cellEdits[E]),t++;continue}const f=P[t],l=_.cellEdits[E];if(f.editType===1&&l.editType===1&&f.index===l.index){f.cells.push(..._.cellEdits[E].cells),f.count+=_.cellEdits[E].count;continue}P.push(_.cellEdits[E]),t++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,P)}setDecorations(_,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return P.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(P),_.key)}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(be[173],Ee([0,1,8,147,126,21,52]),function(ie,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(E){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=E}withProgress(E,n,f){const l=this._handles++,{title:s,location:v,cancellable:I}=n,y={label:(0,b.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this._proxy.$startProgress(l,{location:h.ProgressLocation.from(v),title:s,source:y,cancellable:I},E),this._withProgress(l,f,!!I)}_withProgress(E,n,f){let l;f&&(l=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(E,l));const s=I=>{this._proxy.$progressEnd(I),this._mapHandleToCancellationSource.delete(I),l&&l.dispose()};let v;try{v=n(new P(this._proxy,E),f&&l?l.token:T.CancellationToken.None)}catch(I){throw s(E),I}return v.then(I=>s(E),I=>s(E)),v}$acceptProgressCanceled(E){const n=this._mapHandleToCancellationSource.get(E);n&&(n.cancel(),this._mapHandleToCancellationSource.delete(E))}}e.ExtHostProgress=C;function _(t,E){return t.message=E.message,typeof E.increment=="number"&&(typeof t.increment=="number"?t.increment+=E.increment:t.increment=E.increment),t}class P extends M.Progress{constructor(E,n){super(f=>this.throttledReport(f));this._proxy=E,this._handle=n}throttledReport(E){this._proxy.$progressReport(this._handle,E)}}Ue([(0,F.throttle)(100,(t,E)=>_(t,E),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(be[94],Ee([0,1,40,16,53,8,7]),function(ie,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(n,f,l){const s=C._Keys.nextId();n.$registerTextEditorDecorationType(f.identifier,s,T.DecorationRenderOptions.from(l)),this.value=Object.freeze({key:s,dispose(){n.$removeTextEditorDecorationType(s)}})}}e.TextEditorDecorationType=C,C._Keys=new b.IdGenerator("TextEditorDecorationType");class _{constructor(n,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,f){this._throwIfFinalized();let l=null;if(n instanceof F.Position)l=new F.Range(n,n);else if(n instanceof F.Range)l=n;else throw new Error("Unrecognized location");this._pushEdit(l,f,!1)}insert(n,f){this._throwIfFinalized(),this._pushEdit(new F.Range(n,n),f,!0)}delete(n){this._throwIfFinalized();let f=null;if(n instanceof F.Range)f=n;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(n,f,l){const s=this._document.validateRange(n);this._collectedEdits.push({range:s,text:f,forceMoveMarkers:l})}setEndOfLine(n){if(this._throwIfFinalized(),n!==F.EndOfLine.LF&&n!==F.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=_;class P{constructor(n,f,l,s){this._proxy=n,this._id=f,this._accept(l),this._logService=s;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(I){v._setTabSize(I)},get insertSpaces(){return v._insertSpaces},set insertSpaces(I){v._setInsertSpaces(I)},get cursorStyle(){return v._cursorStyle},set cursorStyle(I){v._setCursorStyle(I)},get lineNumbers(){return v._lineNumbers},set lineNumbers(I){v._setLineNumbers(I)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const f=Math.floor(n);return f>0?f:null}if(typeof n=="string"){const f=parseInt(n,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(n){const f=this._validateTabSize(n);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const f=this._validateInsertSpaces(n);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(n)})))}assign(n){const f={};let l=!1;if(typeof n.tabSize!="undefined"){const s=this._validateTabSize(n.tabSize);s==="auto"?(l=!0,f.tabSize=s):typeof s=="number"&&this._tabSize!==s&&(this._tabSize=s,l=!0,f.tabSize=s)}if(typeof n.insertSpaces!="undefined"){const s=this._validateInsertSpaces(n.insertSpaces);s==="auto"?(l=!0,f.insertSpaces=s):this._insertSpaces!==s&&(this._insertSpaces=s,l=!0,f.insertSpaces=s)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,l=!0,f.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,l=!0,f.lineNumbers=T.TextEditorLineNumbersStyle.from(n.lineNumbers)),l&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(n){n.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=P;class t{constructor(n,f,l,s,v,I,y,a){this.id=n,this._proxy=f,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new P(this._proxy,this.id,I,l),this._visibleRanges=y,this._viewColumn=a;const m=this;this.value=Object.freeze({get document(){return s.getValue()},set document(k){throw(0,M.readonly)("document")},get selection(){return m._selections&&m._selections[0]},set selection(k){if(!(k instanceof F.Selection))throw(0,M.illegalArgument)("selection");m._selections=[k],m._trySetSelection()},get selections(){return m._selections},set selections(k){if(!Array.isArray(k)||k.some(i=>!(i instanceof F.Selection)))throw(0,M.illegalArgument)("selections");m._selections=k,m._trySetSelection()},get visibleRanges(){return m._visibleRanges},set visibleRanges(k){throw(0,M.readonly)("visibleRanges")},get options(){return m._options.value},set options(k){m._disposed||m._options.assign(k)},get viewColumn(){return m._viewColumn},set viewColumn(k){throw(0,M.readonly)("viewColumn")},edit(k,i={undoStopBefore:!0,undoStopAfter:!0}){if(m._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new _(s.getValue(),i);return k(u),m._applyEdit(u)},insertSnippet(k,i,u={undoStopBefore:!0,undoStopAfter:!0}){if(m._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=m._selections.map(o=>T.Range.from(o));else if(i instanceof F.Position){const{lineNumber:o,column:w}=T.Position.from(i);r=[{startLineNumber:o,startColumn:w,endLineNumber:o,endColumn:w}]}else if(i instanceof F.Range)r=[T.Range.from(i)];else{r=[];for(const o of i)if(o instanceof F.Range)r.push(T.Range.from(o));else{const{lineNumber:w,column:d}=T.Position.from(o);r.push({startLineNumber:w,startColumn:d,endLineNumber:w,endColumn:d})}}return f.$tryInsertSnippet(n,k.value,r,u)},setDecorations(k,i){const u=i.length===0;u&&!m._hasDecorationsForKey.has(k.key)||(u?m._hasDecorationsForKey.delete(k.key):m._hasDecorationsForKey.add(k.key),m._runOnProxy(()=>{if(T.isDecorationOptionsArr(i))return f.$trySetDecorations(n,k.key,T.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let o=0,w=i.length;o<w;o++){const d=i[o];r[4*o]=d.start.line+1,r[4*o+1]=d.start.character+1,r[4*o+2]=d.end.line+1,r[4*o+3]=d.end.character+1}return f.$trySetDecorationsFast(n,k.key,r)}}))},revealRange(k,i){m._runOnProxy(()=>f.$tryRevealRange(n,T.Range.from(k),i||F.TextEditorRevealType.Default))},show(k){f.$tryShowEditor(n,T.ViewColumn.from(k))},hide(){f.$tryHideEditor(n)}})}dispose(){(0,h.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,h.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,h.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,h.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,h.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const f=n.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const l=f.edits.map(v=>v.range);l.sort((v,I)=>v.end.line===I.end.line?v.end.character===I.end.character?v.start.line===I.start.line?v.start.character-I.start.character:v.start.line-I.start.line:v.end.character-I.end.character:v.end.line-I.end.line);for(let v=0,I=l.length-1;v<I;v++){const y=l[v].end;if(l[v+1].start.isBefore(y))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=f.edits.map(v=>({range:T.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,s,{setEndOfLine:typeof f.setEndOfLine=="number"?T.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=t}),define(be[174],Ee([0,1,129,24,2,3,6,162,14,7,10,13,8,21,159]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function s(y,a){if((0,t.isString)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let m;return Array.isArray(y.highlights)&&(m=y.highlights.filter(k=>k.length===2&&typeof k[0]=="number"&&typeof k[1]=="number"),m=m.length?m:void 0),{label:y.label,highlights:m}}}class v{constructor(a,m,k){this._proxy=a,this.commands=m,this.logService=k,this.treeViews=new Map;function i(u){return u&&u.$treeViewId&&u.$treeItemHandle}m.registerArgumentProcessor({processArgument:u=>i(u)?this.convertArgument(u):Array.isArray(u)&&u.length>0?u.map(r=>i(r)?this.convertArgument(r):r):u})}registerTreeDataProvider(a,m,k){const i=this.createTreeView(a,{treeDataProvider:m},k);return{dispose:()=>i.dispose()}}createTreeView(a,m,k){if(!m||!m.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=m.dragAndDropController!==void 0,u=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!m.showCollapseAll,canSelectMany:!!m.canSelectMany,canDragAndDrop:i}),r=this.createExtHostTreeView(a,m,k);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(o){r.message=o},get title(){return r.title},set title(o){r.title=o},get description(){return r.description},set description(o){r.description=o},reveal:(o,w)=>r.reveal(o,w),dispose:async()=>{await u,this.treeViews.delete(a),r.dispose()}}}$getChildren(a,m){const k=this.treeViews.get(a);return k?k.getChildren(m):Promise.reject(new Error((0,h.localize)(0,null,a)))}async $onDrop(a,m,k){const i=this.treeViews.get(a);if(!i)return Promise.reject(new Error((0,h.localize)(1,null,a)));const u=l.TreeDataTransferConverter.toITreeDataTransfer(m);if(u.items.has(C.TREE_ITEM_DATA_TRANSFER_TYPE)){const o=JSON.parse(await u.items.get(C.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(w=>i.getExtensionElement(w)).filter(w=>!!w);o.length>0?u.items.set(C.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(o)}):u.items.delete(C.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(u,k)}async $hasResolve(a){const m=this.treeViews.get(a);if(!m)throw new Error((0,h.localize)(2,null,a));return m.hasResolve}$resolve(a,m,k){const i=this.treeViews.get(a);if(!i)throw new Error((0,h.localize)(3,null,a));return i.resolveTreeItem(m,k)}$setExpanded(a,m,k){const i=this.treeViews.get(a);if(!i)throw new Error((0,h.localize)(4,null,a));i.setExpanded(m,k)}$setSelection(a,m){const k=this.treeViews.get(a);if(!k)throw new Error((0,h.localize)(5,null,a));k.setSelection(m)}$setVisible(a,m){const k=this.treeViews.get(a);if(!k)throw new Error((0,h.localize)(6,null,a));k.setVisible(m)}createExtHostTreeView(a,m,k){const i=new I(a,m,this._proxy,this.commands.converter,this.logService,k);return this.treeViews.set(a,i),i}convertArgument(a){const m=this.treeViews.get(a.$treeViewId);return m?m.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=v;class I extends F.Disposable{constructor(a,m,k,i,u,r){super();if(this.viewId=a,this.proxy=k,this.commands=i,this.logService=u,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,r.contributes&&r.contributes.views)for(const d in r.contributes.views)for(const g of r.contributes.views[d])g.id===a&&(this._title=g.name);this.dataProvider=m.treeDataProvider,this.dndController=m.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(d=>this._onDidChangeData.fire({message:!1,element:d}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(d=>this._onDidChangeData.fire({message:!1,element:d})));let o,w;this._register(T.Event.debounce(this._onDidChangeData.event,(d,g)=>(d||(d={message:!1,elements:[]}),g.element!==!1&&(o||(o=new Promise(S=>w=S),this.refreshPromise=this.refreshPromise.then(()=>o)),Array.isArray(g.element)?d.elements.push(...g.element):d.elements.push(g.element)),g.message&&(d.message=!0),d),200,!0)(({message:d,elements:g})=>{g.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const S=w;return o=null,this.refresh(g).then(()=>S())})),d&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,t.isUndefinedOrNull)(a))}async getChildren(a){const m=a?this.getExtensionElement(a):void 0;if(a&&!m)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let k=this.getChildrenNodes(a);return k||(k=await this.fetchChildrenNodes(m)),k?k.map(i=>i.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,m){m=m||{select:!0,focus:!1};const k=(0,t.isUndefinedOrNull)(m.select)?!0:m.select,i=(0,t.isUndefinedOrNull)(m.focus)?!1:m.focus,u=(0,t.isUndefinedOrNull)(m.expand)?!1:m.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(r=>this.resolveTreeNode(a,r[r.length-1]).then(o=>this.proxy.$reveal(this.viewId,{item:o.item,parentChain:r.map(w=>w.item)},{select:k,focus:i,expand:u})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:k,focus:i,expand:u})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,m){const k=this.getExtensionElement(a);k&&(m?this._onDidExpandElement.fire(Object.freeze({element:k})):this._onDidCollapseElement.fire(Object.freeze({element:k})))}setSelection(a){(0,E.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(a,m){const k=this.getExtensionElement(m);if(!!k)return(0,_.asPromise)(()=>this.dndController?.onDrop(a,k))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,m){if(!this.dataProvider.resolveTreeItem)return;const k=this.elements.get(a);if(k){const i=this.nodes.get(k);if(i){const u=await this.dataProvider.resolveTreeItem(i.extensionItem,k,m)??i.extensionItem;return i.item.tooltip=this.getTooltip(u.tooltip),i.item.command=this.getCommand(i.disposableStore,u.command),i.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(m=>m?this.resolveUnknownParentChain(m).then(k=>this.resolveTreeNode(m,k[k.length-1]).then(i=>(k.push(i),k))):Promise.resolve([]))}resolveParent(a){const m=this.nodes.get(a);return m?Promise.resolve(m.parent?this.elements.get(m.parent.item.handle):void 0):(0,_.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,m){const k=this.nodes.get(a);return k?Promise.resolve(k):(0,_.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(i=>this.createHandle(a,i,m,!0)).then(i=>this.getChildren(m?m.item.handle:void 0).then(()=>{const u=this.getExtensionElement(i);if(u){const r=this.nodes.get(u);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(a){if(a){let m;if(typeof a=="string"){const k=this.getExtensionElement(a);m=k?this.nodes.get(k):void 0}else m=a;return m&&m.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const m=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const k=a?this.nodes.get(a):void 0,i=await this.dataProvider.getChildren(a);if(m.token.isCancellationRequested)return;const u=await Promise.all((0,E.coalesce)(i||[]).map(async r=>{const o=await this.dataProvider.getTreeItem(r);return o&&!m.token.isCancellationRequested?this.createAndRegisterTreeNode(r,o,k):null}));return m.token.isCancellationRequested?void 0:(0,E.coalesce)(u)}finally{m.dispose()}}refresh(a){if(a.some(k=>!k))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const k=this.getHandlesToRefresh(a);if(k.length)return this.refreshHandles(k)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const m=new Set,k=a.map(u=>this.nodes.get(u));for(const u of k)if(u&&!m.has(u.item.handle)){let r=u;for(;r&&r.parent&&k.findIndex(o=>r&&r.parent&&o&&o.item.handle===r.parent.item.handle)===-1;){const o=this.elements.get(r.parent.item.handle);r=o?this.nodes.get(o):void 0}r&&!r.parent&&m.add(u.item.handle)}const i=[];return m.forEach(u=>{const r=this.elements.get(u);if(r){const o=this.nodes.get(r);o&&(!o.parent||!m.has(o.parent.item.handle))&&i.push(u)}}),i}refreshHandles(a){const m={};return Promise.all(a.map(k=>this.refreshNode(k).then(i=>{i&&(m[k]=i.item)}))).then(()=>Object.keys(m).length?this.proxy.$refresh(this.viewId,m):void 0)}refreshNode(a){const m=this.getExtensionElement(a);if(m){const k=this.nodes.get(m);if(k)return this.clearChildren(m),(0,_.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(i=>{if(i){const u=this.createTreeNode(m,i,k.parent);return this.updateNodeCache(m,u,k,k.parent),k.dispose(),u}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,m,k){const i=this.createTreeNode(a,m,k);if(m.id&&this.elements.has(i.item.handle))throw new Error((0,h.localize)(7,null,m.id));return this.addNodeToCache(a,i),this.addNodeToParentCache(i,k),i}getTooltip(a){return P.MarkdownString.isMarkdownString(a)?n.MarkdownString.from(a):a}getCommand(a,m){return m?this.commands.toInternal(m,a):void 0}createTreeNode(a,m,k){const i=new F.DisposableStore,u=this.createHandle(a,m,k),r=this.getLightIconPath(m);return{item:{handle:u,parentHandle:k?k.item.handle:void 0,label:s(m.label,this.extension),description:m.description,resourceUri:m.resourceUri,tooltip:this.getTooltip(m.tooltip),command:this.getCommand(i,m.command),contextValue:m.contextValue,icon:r,iconDark:this.getDarkIconPath(m)||r,themeIcon:this.getThemeIcon(m),collapsibleState:(0,t.isUndefinedOrNull)(m.collapsibleState)?P.TreeItemCollapsibleState.None:m.collapsibleState,accessibilityInformation:m.accessibilityInformation},extensionItem:m,parent:k,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(a){return a.iconPath instanceof P.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:m,label:k,resourceUri:i},u,r){if(m)return`${I.ID_HANDLE_PREFIX}/${m}`;const o=s(k,this.extension),w=u?u.item.handle:I.LABEL_HANDLE_PREFIX;let d=o?o.label:i?(0,M.basename)(i):"";d=d.indexOf("/")!==-1?d.replace("/","//"):d;const g=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,S=this.getChildrenNodes(u)||[];let R,p=0;do{if(R=`${w}/${p}:${d}`,r||!this.elements.has(R)||g===R)break;p++}while(p<=S.length);return R}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon))return typeof a.iconPath=="string"||b.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return b.URI.isUri(a)?a:b.URI.file(a)}addNodeToCache(a,m){this.elements.set(m.item.handle,a),this.nodes.set(a,m)}updateNodeCache(a,m,k,i){this.elements.delete(m.item.handle),this.nodes.delete(a),m.item.handle!==k.item.handle&&this.elements.delete(k.item.handle),this.addNodeToCache(a,m);const u=this.getChildrenNodes(i)||[],r=u.filter(o=>o.item.handle===k.item.handle)[0];r&&u.splice(u.indexOf(r),1,m)}addNodeToParentCache(a,m){m?(m.children||(m.children=[]),m.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const m=this.nodes.get(a);if(m){if(m.children)for(const k of m.children){const i=this.elements.get(k.item.handle);i&&this.clear(i)}m.children=void 0}}else this.clearAll()}clear(a){const m=this.nodes.get(a);if(m){if(m.children)for(const k of m.children){const i=this.elements.get(k.item.handle);i&&this.clear(i)}this.nodes.delete(a),this.elements.delete(m.item.handle),m.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}I.LABEL_HANDLE_PREFIX="0",I.ID_HANDLE_PREFIX="1"}),define(be[175],Ee([0,1,14,3,6,10,46,8,90,67]),function(ie,e,h,M,b,T,F,C,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends b.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new h.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new F.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const f=this.diff[this.diff.length-1];if(f&&n[0]===1){if(f[0]===1&&f[1].extId===n[1].extId){(0,_.applyTestItemUpdate)(f[1],n[1]);return}if(f[0]===0&&f[1].item.extId===n[1].extId){(0,_.applyTestItemUpdate)(f[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,f){const l=this.tree.get(n);if(!!l){if((l.expandLevels===void 0||f>l.expandLevels)&&(l.expandLevels=f),l.expand===1){const s=this.resolveChildren(l);return s.isOpen()?this.expandChildren(l,f-1):s.wait().then(()=>this.expandChildren(l,f-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,f-1)):this.expandChildren(l,f-1)}}dispose(){for(const n of this.tree.values())(0,F.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,f){switch(f.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(n.fullId,f.id));break;case 0:this.upsertItem(f.item,n);break;case 4:for(const y of f.ops)this.onTestItemEvent(n,y);break;case 3:const{key:l,value:s,previous:v}=f,I=n.fullId.toString();switch(l){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(s,v,I);break;case"range":this.pushDiff([1,{extId:I,item:{range:C.Range.from(s)}}]);break;case"error":this.pushDiff([1,{extId:I,item:{error:C.MarkdownString.fromStrict(s)||null}}]);break;default:this.pushDiff([1,{extId:I,item:{[l]:s??null}}]);break}break;default:(0,T.assertNever)(f)}}upsertItem(n,f){if(!(n instanceof F.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const l=P.TestId.fromExtHostTestItem(n,this.root.id,f?.actual),s=(0,F.getPrivateApiFor)(n);s.parent&&s.parent!==f?.actual&&s.parent.children.delete(n.id);let v=this.tree.get(l.toString());if(!v){v={fullId:l,actual:n,parent:f?l.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(v.fullId.toString(),v),this.setItemParent(n,f),this.pushDiff([0,{parent:v.parent&&v.parent.toString(),controllerId:this.controllerId,expand:v.expand,item:C.TestItem.from(n)}]),this.connectItemAndChildren(n,v,f);return}if(v.actual===n){this.connectItem(n,v,f);return}const I=v.actual.children,y=v.actual,a=(0,F.diffTestItems)(y,n);(0,F.getPrivateApiFor)(y).listener=void 0,v.actual=n,v.expand=0;for(const[m,k]of a)this.onTestItemEvent(v,{op:3,key:m,value:k,previous:y[m]});this.connectItemAndChildren(n,v,f);for(const m of I)n.children.get(m.id)||this.removeItem(P.TestId.joinToString(l,m.id))}diffTagRefs(n,f,l){const s=new Set(f.map(v=>v.id));for(const v of n)s.delete(v.id)||this.incrementTagRefs(v);this.pushDiff([1,{extId:l,item:{tags:n.map(v=>C.TestTag.namespace(this.controllerId,v.id))}}]),s.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const f=this.tags.get(n.id);f?f.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:C.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const f=this.tags.get(n);f&&!--f.refCount&&(this.tags.delete(n),this.pushDiff([6,C.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,f){(0,F.getPrivateApiFor)(n).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(n,f,l){this.setItemParent(n,l);const s=(0,F.getPrivateApiFor)(n);s.parent=l?.actual,s.listener=v=>this.onTestItemEvent(f,v),this.updateExpandability(f)}connectItemAndChildren(n,f,l){this.connectItem(n,f,l);for(const s of n.children)this.upsertItem(s,f)}updateExpandability(n){let f;this._resolveHandler?n.resolveBarrier?f=n.resolveBarrier.isOpen()?3:2:f=n.actual.canResolveChildren?1:0:f=0,f!==n.expand&&(n.expand=f,this.pushDiff([1,{extId:n.fullId.toString(),expand:f}]),f===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,f){if(f<0)return;const l=[];for(const s of n.actual.children){const v=this.expand(P.TestId.joinToString(n.fullId,s.id),f);(0,h.isThenable)(v)&&l.push(v)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const v=new h.Barrier;return v.open(),v}n.expand=2,this.pushExpandStateUpdate(n);const f=n.resolveBarrier=new h.Barrier,l=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=v.stack||v.message||String(v))};let s;try{s=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(v){l(v)}return(0,h.isThenable)(s)?s.catch(l).then(()=>{f.open(),this.updateExpandability(n)}):(f.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const f=this.tree.get(n);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const l=[f];for(;l.length;){const s=l.pop();if(!!s){(0,F.getPrivateApiFor)(s.actual).listener=void 0;for(const v of s.actual.tags)this.decrementTagRefs(v.id);this.tree.delete(s.fullId.toString());for(const v of s.actual.children)l.push(this.tree.get(P.TestId.joinToString(s.fullId,v.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(be[176],Ee([0,1,4,142]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,h.refineServiceDecorator)(M.IEnvironmentService)}),define(be[177],Ee([0,1,25,3,17]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=T;class F{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(h.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(h.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let E of t.activationEvents)E==="onUri"&&(E=`onUri:${h.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(E)||this._activationMap.set(E,[]),this._activationMap.get(E).push(t)}}keepOnly(t){const E=new Set;t.forEach(n=>E.add(h.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>E.has(h.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,E){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=F._findLoopingExtensions(this._extensionDescriptions);if(E=E.concat(n.map(f=>f.identifier)),E.length>0){const f=new Set;E.forEach(l=>f.add(h.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!f.has(h.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(n)}static _findLoopingExtensions(t){const E=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,I){this.addNode(v),this.addNode(I),this._arcs.has(v)?this._arcs.get(v).push(I):this._arcs.set(v,[I])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,I){const y=E.getArcs(v);for(let a=0;a<y.length;a++)if(!I.has(y[a]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let v of t){const I=h.ExtensionIdentifier.toKey(v.identifier);if(n.set(I,v),v.extensionDependencies)for(let y of v.extensionDependencies){const a=h.ExtensionIdentifier.toKey(y);E.addArc(I,a)}}let f=new Set;E.getNodes().filter(v=>E.getArcs(v).length===0).forEach(v=>f.add(v));let l=E.getNodes().filter(v=>!f.has(v)),s;do{s=!1;for(let v=0;v<l.length;v++){const I=l[v];E.hasOnlyGoodArcs(I,f)&&(l.splice(v,1),v--,f.add(I),s=!0)}}while(s);return l.map(v=>n.get(v))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(h.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const E=this._activationMap.get(t);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const E=this._extensionsMap.get(h.ExtensionIdentifier.toKey(t));return E||void 0}}e.ExtensionDescriptionRegistry=F;var C;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(C||(C={}));function _(P,t){const E=P.isBuiltin?0:P.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(E!==n)return E-n;const f=b.posix.basename(P.extensionLocation.path),l=b.posix.basename(t.extensionLocation.path);return f<l?-1:f>l?1:0}}),define(be[178],Ee([0,1,23]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var b;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(b=e.MessageType||(e.MessageType={}));function T(C){const _=h.VSBuffer.alloc(1);switch(C){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=T;function F(C,_){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=F}),define(be[30],Ee([0,1,3,2,4,25,143]),function(ie,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");var C;(function(a){a[a.None=0]="None",a[a.LocalProcess=1]="LocalProcess",a[a.LocalWebWorker=2]="LocalWebWorker",a[a.Remote=3]="Remote"})(C=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class _{constructor(m){this.dependency=m}}e.MissingExtensionDependency=_;var P;(function(a){a[a.LocalProcess=0]="LocalProcess",a[a.LocalWebWorker=1]="LocalWebWorker",a[a.Remote=2]="Remote"})(P=e.ExtensionHostKind||(e.ExtensionHostKind={}));function t(a){switch(a){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=t;class E{constructor(m,k,i,u){this.codeLoadingTime=m,this.activateCallTime=k,this.activateResolvedTime=i,this.activationReason=u}}e.ActivationTimes=E;class n{constructor(m,k){this.description=m,this.value=k}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var f;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(f=e.ActivationKind||(e.ActivationKind={}));function l(a){a.enableProposedApi||s(a)}e.checkProposedApiEnabled=l;function s(a){throw new Error(`[${a.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.throwProposedApiError=s;function v(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,F.getGalleryExtensionId)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation}}e.toExtension=v;function I(a,m){return{identifier:new T.ExtensionIdentifier(a.identifier.id),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!m,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid}}e.toExtensionDescription=I;class y{constructor(){this.onDidRegisterExtensions=h.Event.None,this.onDidChangeExtensionsStatus=h.Event.None,this.onDidChangeExtensions=h.Event.None,this.onWillActivateByEvent=h.Event.None,this.onDidChangeResponsiveChange=h.Event.None}activateByEvent(m){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(m){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(m,k){return Promise.resolve()}_onWillActivateExtension(m){}_onDidActivateExtension(m,k,i,u,r){}_onDidActivateExtensionError(m,k){}_onExtensionRuntimeError(m,k){}_onExtensionHostExit(m){}}e.NullExtensionService=y}),define(be[179],Ee([0,1,25,30,15]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class F{constructor(l,s,v,I){this.startup=l,this.codeLoadingTime=s,this.activateCallTime=v,this.activateResolvedTime=I}}e.ExtensionActivationTimes=F,F.NONE=new F(!1,-1,-1,-1);class C{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,s){return l===-1||s===-1?-1:s-l}build(){return new F(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class _{constructor(l,s,v,I,y,a){this.activationFailed=l,this.activationFailedError=s,this.activationTimes=v,this.module=I,this.exports=y,this.subscriptions=a}}e.ActivatedExtension=_;class P extends _{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class t extends _{constructor(){super(!1,null,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class E extends _{constructor(l){super(!0,l,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=E;let n=class{constructor(l,s,v,I,y){this._logService=y,this._registry=l,this._resolvedExtensionsSet=new Set,s.forEach(a=>this._resolvedExtensionsSet.add(h.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,v.forEach(a=>this._hostExtensionsMap.set(h.ExtensionIdentifier.toKey(a),a)),this._host=I,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(l){const s=h.ExtensionIdentifier.toKey(l);return this._activatedExtensions.has(s)}getActivatedExtension(l){const s=h.ExtensionIdentifier.toKey(l),v=this._activatedExtensions.get(s);if(!v)throw new Error("Extension `"+l.value+"` is not known or not activated");return v}activateByEvent(l,s){if(this._alreadyActivatedEvents[l])return T;const v=this._registry.getExtensionDescriptionsForActivationEvent(l);return this._activateExtensions(v.map(I=>({id:I.identifier,reason:{startup:s,extensionId:I.identifier,activationEvent:l}}))).then(()=>{this._alreadyActivatedEvents[l]=!0})}activateById(l,s){const v=this._registry.getExtensionDescription(l);if(!v)throw new Error("Extension `"+l+"` is not known");return this._activateExtensions([{id:v.identifier,reason:s}])}_handleActivateRequest(l,s,v){if(this._hostExtensionsMap.has(h.ExtensionIdentifier.toKey(l.id))){s[h.ExtensionIdentifier.toKey(l.id)]=l;return}const I=this._registry.getExtensionDescription(l.id);if(!I){const m=new Error(`Cannot activate unknown extension '${l.id.value}'`);this._host.onExtensionActivationError(l.id,m,new M.MissingExtensionDependency(l.id.value)),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(l.id),new E(m));return}const y=typeof I.extensionDependencies=="undefined"?[]:I.extensionDependencies;let a=!0;for(let m=0,k=y.length;m<k;m++){const i=y[m];if(this._resolvedExtensionsSet.has(h.ExtensionIdentifier.toKey(i)))continue;const u=this._activatedExtensions.get(h.ExtensionIdentifier.toKey(i));if(u&&!u.activationFailed)continue;if(u&&u.activationFailed){const d=I.displayName||I.identifier.value,g=this._registry.getExtensionDescription(i),S=g&&g.displayName||i,R=new Error(`Cannot activate the '${d}' extension because its dependency '${S}' failed to activate`);R.detail=u.activationFailedError,this._host.onExtensionActivationError(I.identifier,R,null),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(I.identifier),new E(R));return}if(this._hostExtensionsMap.has(h.ExtensionIdentifier.toKey(i))){a=!1,s[h.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(h.ExtensionIdentifier.toKey(i)),reason:l.reason};continue}const r=this._registry.getExtensionDescription(i);if(r){a=!1,s[h.ExtensionIdentifier.toKey(i)]={id:r.identifier,reason:l.reason};continue}const o=I.displayName||I.identifier.value,w=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(I.identifier,w,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(I.identifier),new E(w));return}a?s[h.ExtensionIdentifier.toKey(I.identifier)]=l:v.push(l)}_activateExtensions(l){if(l.length===0||(l=l.filter(y=>!this._activatedExtensions.has(h.ExtensionIdentifier.toKey(y.id))),l.length===0))return Promise.resolve(void 0);const s=Object.create(null),v=[];for(let y=0,a=l.length;y<a;y++)this._handleActivateRequest(l[y],s,v);for(let y=0,a=v.length;y<a;y++){const m=h.ExtensionIdentifier.toKey(v[y].id);s[m]&&delete s[m]}const I=Object.keys(s).map(y=>s[y]);return v.length===0?Promise.all(I.map(y=>this._activateExtension(y.id,y.reason))).then(y=>{}):this._activateExtensions(I).then(y=>this._activateExtensions(v))}_activateExtension(l,s){const v=h.ExtensionIdentifier.toKey(l);if(this._activatedExtensions.has(v))return Promise.resolve(void 0);const I=this._activatingExtensions.get(v);if(I)return I;const y=this._host.actualActivateExtension(l,s).then(void 0,a=>{const m=new Error;return a&&a.name&&(m.name=a.name),a&&a.message?m.message=`Activating extension '${l.value}' failed: ${a.message}.`:m.message=`Activating extension '${l.value}' failed: ${a}.`,a&&a.stack&&(m.stack=a.stack),this._host.onExtensionActivationError(l,m,null),this._logService.error(`Activating extension ${l.value} failed due to an error:`),this._logService.error(a),new E(a)}).then(a=>{this._activatedExtensions.set(v,a),this._activatingExtensions.delete(v)});return this._activatingExtensions.set(v,y),y}};n=Ue([He(4,b.ILogService)],n),e.ExtensionsActivator=n}),define(be[180],Ee([0,1,16]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,F)=>{this._actualOk=T,this._actualErr=F,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,h.onUnexpectedError)(T))}then(T,F){return this._ensureActual().then(T,F)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=M}),define(be[47],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class h{constructor(P,t){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=t,this.nid=++h.count}}e.ProxyIdentifier=h,h.count=0;const M=[];function b(_){const P=new h(!0,_);return M[P.nid]=P,P}e.createMainContextProxyIdentifier=b;function T(_){const P=new h(!1,_);return M[P.nid]=P,P}e.createExtHostContextProxyIdentifier=T;function F(_){return M[_].sid}e.getStringIdentifierForProxy=F;class C{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=C}),define(be[5],Ee([0,1,54,2,47]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var F;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(F=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var E;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(E=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(a){a.name="$ident";function m(i,u){return Object.defineProperty(i,a.name,{value:u,enumerable:!0}),i}a.mixin=m;function k(i){return i[a.name]}a.of=k})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(m){return m._id=f._n++,m}}e.IdObject=f,f._n=0;var l;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var s;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(s=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function I(a){if(a&&a.edits)for(const m of a.edits)typeof m.resource=="object"?m.resource=M.URI.revive(m.resource):(m.newUri=M.URI.revive(m.newUri),m.oldUri=M.URI.revive(m.oldUri)),m.metadata&&m.metadata.iconPath&&(m.metadata=(0,h.revive)(m.metadata));return a}e.reviveWorkspaceEditDto=I;var y;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,b.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,b.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,b.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,b.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,b.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,b.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,b.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,b.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,b.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,b.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,b.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,b.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,b.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,b.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,b.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,b.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,b.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,b.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,b.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,b.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,b.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,b.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,b.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,b.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,b.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,b.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,b.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,b.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,b.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,b.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,b.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,b.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,b.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,b.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,b.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,b.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,b.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,b.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,b.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,b.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,b.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,b.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,b.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,b.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,b.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,b.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,b.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,b.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,b.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,b.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,b.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,b.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,b.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,b.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,b.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,b.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,b.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,b.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,b.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,b.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,b.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,b.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,b.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,b.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,b.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,b.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,b.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,b.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,b.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,b.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,b.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,b.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,b.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,b.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,b.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,b.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,b.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,b.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,b.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,b.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,b.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,b.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,b.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,b.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,b.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[69],Ee([0,1,5,3,4]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(C){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(h.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,_){return this._proxy.$getPassword(C,_)}store(C,_,P){return this._proxy.$setPassword(C,_,P)}delete(C,_){return this._proxy.$deletePassword(C,_)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")}),define(be[70],Ee([0,1,4,15,5,12]),function(ie,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,h.createDecorator)("IExtHostApiDeprecationService");let F=class{constructor(_,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(b.MainContext.MainThreadTelemetry)}report(_,P,t){const E=this.getUsageKey(_,P);this._reportedUsages.has(E)||(this._reportedUsages.add(E),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:_}))}getUsageKey(_,P){return`${_}-${P.identifier.value}`}};F=Ue([He(0,T.IExtHostRpcService),He(1,M.ILogService)],F),e.ExtHostApiDeprecationService=F,e.NullApiDeprecationService=Object.freeze(new class{report(C,_,P){}})}),define(be[181],Ee([0,1,3,5,7,25]),function(ie,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class F{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new h.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,P,t,E={}){const n=T.ExtensionIdentifier.toKey(_.identifier),f=this._inFlightRequests.get(n)||[],l=[...t].sort().join(" ");let s=f.find(v=>v.scopes===l);if(s)return s.result;{const v=this._getSession(_,n,P,t,E);s={scopes:l,result:v},f.push(s),this._inFlightRequests.set(n,f);try{await v}finally{const I=f.findIndex(y=>y.scopes===l);I>-1&&(f.splice(I),this._inFlightRequests.set(n,f))}return v}}async _getSession(_,P,t,E,n={}){await this._proxy.$ensureProvider(t);const f=_.displayName||_.name;return this._proxy.$getSession(t,E,P,f,n)}async removeSession(_,P){const t=this._authenticationProviders.get(_);return t?t.provider.removeSession(P):this._proxy.$removeSession(_,P)}registerAuthenticationProvider(_,P,t,E){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:P,provider:t,options:E??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===_)||this._providers.push({id:_,label:P});const n=t.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(_,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,P,E?.supportsMultipleAccounts??!1),new b.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(_);const f=this._providers.findIndex(l=>l.id===_);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,P){const t=this._authenticationProviders.get(_);if(t)return Promise.resolve(t.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,P){const t=this._authenticationProviders.get(_);if(t)return Promise.resolve(t.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,P){const t=this._authenticationProviders.get(_);if(t)return Promise.resolve(t.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,P){return this._onDidChangeSessions.fire({provider:{id:_,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=F}),define(be[182],Ee([0,1,5,12,8]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(C,_){this._extHostDocumentsAndEditors=_,this._proxy=C.getProxy(h.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const _=b.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};T=Ue([He(0,M.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(be[183],Ee([0,1,5]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(T){const F=T.getProxy(h.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(C){return F.$writeText(C)}})}}e.ExtHostClipboard=M}),define(be[48],Ee([0,1,10,7,8,22,5,13,15,54,42,112,2,6,4,12,46]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l,s,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let I=class{constructor(u,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=u.getProxy(F.MainContext.MainThreadCommands),this._logService=r,this.converter=new y(this,o=>{const w=this._apiCommands.get(o);return w?.result===m.Void?w:void 0},r),this._argumentProcessors=[{processArgument(o){return(0,P.revive)(o)}},{processArgument(o){return(0,T.cloneAndChange)(o,function(w){if(t.Range.isIRange(w))return b.Range.to(w);if(E.Position.isIPosition(w))return b.Position.to(w);if(t.Range.isIRange(w.range)&&n.URI.isUri(w.uri))return b.location.to(w);if(!Array.isArray(w))return w})}}]}registerArgumentProcessor(u){this._argumentProcessors.push(u)}registerApiCommand(u){const r=this.registerCommand(!1,u.id,async(...o)=>{const w=u.args.map((g,S)=>{if(!g.validate(o[S]))throw new Error(`Invalid argument '${g.name}' when running '${u.id}', received: ${o[S]}`);return g.convert(o[S])}),d=await this.executeCommand(u.internalId,...w);return u.result.convert(d,o,this.converter)},void 0,{description:u.description,args:u.args,returns:u.result.description});return this._apiCommands.set(u.id,u),new M.Disposable(()=>{r.dispose(),this._apiCommands.delete(u.id)})}registerCommand(u,r,o,w,d){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:o,thisArg:w,description:d}),u&&this._proxy.$registerCommand(r),new M.Disposable(()=>{this._commands.delete(r)&&u&&this._proxy.$unregisterCommand(r)})}executeCommand(u,...r){return this._logService.trace("ExtHostCommands#executeCommand",u),this._doExecuteCommand(u,r,!0)}async _doExecuteCommand(u,r,o){if(this._commands.has(u))return this._executeContributedCommand(u,r);{const w=(0,T.cloneAndChange)(r,function(d){if(d instanceof M.Position)return b.Position.from(d);if(d instanceof M.Range)return b.Range.from(d);if(d instanceof M.Location)return b.location.from(d);if(M.NotebookRange.isNotebookRange(d))return b.NotebookRange.from(d);if(!Array.isArray(d))return d});try{const d=await this._proxy.$executeCommand(u,w,o);return(0,P.revive)(d)}catch(d){if(d instanceof Error&&d.message==="$executeCommand:retry")return this._doExecuteCommand(u,r,!1);throw d}}}async _executeContributedCommand(u,r){const o=this._commands.get(u);if(!o)throw new Error("Unknown command");let{callback:w,thisArg:d,description:g}=o;if(g)for(let S=0;S<g.args.length;S++)try{(0,h.validateConstraint)(r[S],g.args[S].constraint)}catch(R){throw new Error(`Running the contributed command: '${u}' failed. Illegal argument '${g.args[S].name}' - ${g.args[S].description}`)}try{return await w.apply(d,r)}catch(S){if(u===this.converter.delegatingCommandId){const R=this.converter.getActualCommand(...r);R&&(u=R.command)}throw this._logService.error(S,u),new Error(`Running the contributed command: '${u}' failed.`)}}$executeContributedCommand(u,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",u),this._commands.has(u)?(r=r.map(o=>this._argumentProcessors.reduce((w,d)=>d.processArgument(w),o)),this._executeContributedCommand(u,r)):Promise.reject(new Error(`Contributed command '${u}' does not exist.`))}getCommands(u=!1){return this._logService.trace("ExtHostCommands#getCommands",u),this._proxy.$getCommands().then(r=>(u&&(r=r.filter(o=>o[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const u=Object.create(null);for(let[r,o]of this._commands){let{description:w}=o;w&&(u[r]=w)}return Promise.resolve(u)}};I=Ue([He(0,s.IExtHostRpcService),He(1,_.ILogService)],I),e.ExtHostCommands=I,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class y{constructor(u,r,o){this._commands=u,this._lookupApiCommand=r,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(u,r){if(!u)return;const o={$ident:void 0,id:u.command,title:u.title,tooltip:u.tooltip};if(!u.command)return o;const w=this._lookupApiCommand(u.command);if(w)o.id=w.internalId,o.arguments=w.args.map((d,g)=>d.convert(u.arguments&&u.arguments[g]));else if((0,C.isNonEmptyArray)(u.arguments)){const d=++this._cachIdPool;this._cache.set(d,u),r.add((0,f.toDisposable)(()=>{this._cache.delete(d),this._logService.trace("CommandsConverter#DISPOSE",d)})),o.$ident=d,o.id=this.delegatingCommandId,o.arguments=[d],this._logService.trace("CommandsConverter#CREATE",u.command,d)}return o}fromInternal(u){const r=F.ObjectIdentifier.of(u);return typeof r=="number"?this._cache.get(r):{command:u.id,title:u.title,arguments:u.arguments}}getActualCommand(...u){return this._cache.get(u[0])}_executeConvertedCommand(...u){const r=this.getActualCommand(...u);return this._logService.trace("CommandsConverter#EXECUTE",u[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=y;class a{constructor(u,r,o,w){this.name=u,this.description=r,this.validate=o,this.convert=w}optional(){return new a(this.name,`(optional) ${this.description}`,u=>u==null||this.validate(u),u=>u===void 0?void 0:u===null?null:this.convert(u))}with(u,r){return new a(u??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=a,a.Uri=new a("uri","Uri of a text document",i=>n.URI.isUri(i),i=>i),a.Position=new a("position","A position in a text document",i=>M.Position.isPosition(i),b.Position.from),a.Range=new a("range","A range in a text document",i=>M.Range.isRange(i),b.Range.from),a.Selection=new a("selection","A selection in a text document",i=>M.Selection.isSelection(i),b.Selection.from),a.Number=new a("number","",i=>typeof i=="number",i=>i),a.String=new a("string","",i=>typeof i=="string",i=>i),a.CallHierarchyItem=new a("item","A call hierarchy item",i=>i instanceof M.CallHierarchyItem,b.CallHierarchyItem.from),a.TypeHierarchyItem=new a("item","A type hierarchy item",i=>i instanceof M.TypeHierarchyItem,b.TypeHierarchyItem.from),a.TestItem=new a("testItem","A VS Code TestItem",i=>i instanceof v.TestItemImpl,b.TestItem.from);class m{constructor(u,r){this.description=u,this.convert=r}}e.ApiCommandResult=m,m.Void=new m("no result",i=>i);class k{constructor(u,r,o,w,d){this.id=u,this.internalId=r,this.description=o,this.args=w,this.result=d}}e.ApiCommand=k}),define(be[184],Ee([0,1,8,7,59,48,13,80]),function(ie,e,h,M,b,T,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new T.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(h.DocumentHighlight.to))),new T.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,f)=>{if((0,F.isFalsyOrEmpty)(n))return;class l extends M.SymbolInformation{static to(v){const I=new l(v.name,h.SymbolKind.to(v.kind),v.containerName||"",new M.Location(f[0],h.Range.to(v.range)));return I.detail=v.detail,I.range=I.location.range,I.selectionRange=h.Range.to(v.selectionRange),I.children=v.children?v.children.map(l.to):[],I}}return n.map(l.to)})),new T.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(h.TextEdit.to))),new T.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(h.TextEdit.to))),new T.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,new T.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(h.TextEdit.to))),new T.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new T.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new T.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new T.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new T.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(h.location.to))),new T.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(h.Hover.to))),new T.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(f=>M.Position.isPosition(f)),n=>n.map(h.Position.from))],new T.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(f=>{let l;for(const s of f.reverse())l=new M.SelectionRange(h.Range.to(s),l);return l}))),new T.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[T.ApiCommandArgument.String.with("query","Search string")],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const f=[];if(Array.isArray(n))for(let l of n)f.push(...l[1].map(h.WorkspaceSymbol.to));return f})),new T.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(h.CallHierarchyItem.to))),new T.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(h.CallHierarchyIncomingCall.to))),new T.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(h.CallHierarchyOutgoingCall.to))),new T.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("newName","The new symbol name")],new T.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return h.WorkspaceEdit.to(n)}})),new T.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new T.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(h.DocumentLink.to))),new T.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,C.decodeSemanticTokensDto)(n);if(f.type==="full")return new M.SemanticTokens(f.data,void 0)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,C.decodeSemanticTokensDto)(n);if(f.type==="full")return new M.SemanticTokens(f.data,void 0)})),new T.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new T.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,f,l)=>{if(!n)return new M.CompletionList([]);const s=n.suggestions.map(v=>h.CompletionItem.to(v,l));return new M.CompletionList(s,n.incomplete)})),new T.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new T.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return h.SignatureHelp.to(n)})),new T.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new T.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,f,l)=>t(s=>new M.CodeLens(h.Range.to(s.range),s.command&&l.fromInternal(s.command)))(n))),new T.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?h.Selection.from(n):h.Range.from(n)),T.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new T.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,f,l)=>t(s=>{if(s._isSynthetic){if(!s.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(s.command)}else{const v=new M.CodeAction(s.title,s.kind?new M.CodeActionKind(s.kind):void 0);return s.edit&&(v.edit=h.WorkspaceEdit.to(s.edit)),s.command&&(v.command=l.fromInternal(s.command)),v.isPreferred=s.isPreferred,v}})(n))),new T.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(f=>new M.ColorInformation(h.Range.to(f.range),h.Color.to(f.color))):[])),new T.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new T.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,h.Color.from),new T.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:h.Range.from(n.range)}))],new T.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(h.ColorPresentation.to):[])),new T.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(h.InlayHint.to))),new T.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new T.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(f=>h.NotebookExclusiveDocumentPattern.to(f))})))),new T.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(h.InlineValue.to))),new T.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[h.ViewColumn.from(n.viewColumn),h.TextEditorOpenOptions.from(n)])).optional(),T.ApiCommandArgument.String.with("label","").optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[T.ApiCommandArgument.Uri.with("resource","Resource to open"),T.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[h.ViewColumn.from(n.viewColumn),h.TextEditorOpenOptions.from(n)])).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[T.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),T.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),T.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[h.ViewColumn.from(n.viewColumn),h.TextEditorOpenOptions.from(n)]).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(h.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(h.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(h.TypeHierarchyItem.to))),new T.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[T.ApiCommandArgument.TestItem],T.ApiCommandResult.Void)];class P{static register(f){_.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=P;function t(n){return f=>{if(Array.isArray(f))return f.map(n)}}function E(n){if(!Array.isArray(n))return;const f=[];for(const l of n)b.isLocationLink(l)?f.push(h.DefinitionLink.to(l)):f.push(h.location.to(l));return f}}),define(be[185],Ee([0,1,14,52,3,6,2,59,25,8,7,5]),function(ie,e,h,M,b,T,F,C,_,P,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(f,l,s){const v=f.getProxy(E.MainContext.MainThreadComments);class I{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,l.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===6){const w=this._commentControllers.get(o.handle);return w||o}else if(o&&o.$mid===7){const w=this._commentControllers.get(o.commentControlHandle);if(!w)return o;const d=w.getCommentThread(o.commentThreadHandle);return d||o}else if(o&&o.$mid===8){const w=this._commentControllers.get(o.thread.commentControlHandle);if(!w)return o;const d=w.getCommentThread(o.thread.commentThreadHandle);return d?{thread:d,text:o.text}:o}else if(o&&o.$mid===9){const w=this._commentControllers.get(o.thread.commentControlHandle);if(!w)return o;const d=w.getCommentThread(o.thread.commentThreadHandle);if(!d)return o;let g=o.commentUniqueId,S=d.getCommentByUniqueId(g);return S||o}else if(o&&o.$mid===10){const w=this._commentControllers.get(o.thread.commentControlHandle);if(!w)return o;const d=w.getCommentThread(o.thread.commentThreadHandle);if(!d)return o;let g=o.text,S=o.commentUniqueId,R=d.getCommentByUniqueId(S);return R?(R.body=g,R):o}return o}})}createCommentController(o,w,d){const g=I.handlePool++,S=new a(o,g,w,d);this._commentControllers.set(S.handle,S);const R=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(o.identifier))||[];return R.push(S),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(o.identifier),R),S.value}$createCommentThreadTemplate(o,w,d){const g=this._commentControllers.get(o);!g||g.$createCommentThreadTemplate(w,d)}async $updateCommentThreadTemplate(o,w,d){const g=this._commentControllers.get(o);!g||g.$updateCommentThreadTemplate(w,d)}$deleteCommentThread(o,w){const d=this._commentControllers.get(o);d&&d.$deleteCommentThread(w)}$provideCommentingRanges(o,w,d){const g=this._commentControllers.get(o);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const S=s.getDocument(F.URI.revive(w));return(0,h.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(S,d)).then(R=>R?R.map(p=>P.Range.from(p)):void 0)}$toggleReaction(o,w,d,g,S){const R=this._commentControllers.get(o);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,h.asPromise)(()=>{const p=R.getCommentThread(w);if(p){const D=p.getCommentByUniqueId(g.uniqueIdInThread);if(R!==void 0&&D&&R.reactionHandler)return R.reactionHandler(D,i(S))}return Promise.resolve(void 0)})}dispose(){}}I.handlePool=0;class y{constructor(o,w,d,g,S,R,p){this._commentControllerHandle=w,this._id=d,this._uri=g,this._range=S,this._comments=R,this.handle=y._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${o}.${this.handle}`),v.$createCommentThread(w,this.handle,this._id,this._uri,P.Range.from(this._range),p),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{v.$deleteCommentThread(w,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(c){D.range=c},get comments(){return D.comments},set comments(c){D.comments=c},get collapsibleState(){return D.collapsibleState},set collapsibleState(c){D.collapsibleState=c},get canReply(){return D.canReply},set canReply(c){D.canReply=c},get contextValue(){return D.contextValue},set contextValue(c){D.contextValue=c},get label(){return D.label},set label(c){D.label=c},dispose:()=>{D.dispose()}}}set threadId(o){this._id=o}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(o){o.isEqual(this._range)||(this._range=o,this.modifications.range=o,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(o){this._canReply!==o&&(this._canReply=o,this.modifications.canReply=o,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(o){this._label=o,this.modifications.label=o,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(o){this._contextValue=o,this.modifications.contextValue=o,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(o){this._comments=o,this.modifications.comments=o,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(o){this._collapseState=o,this.modifications.collapsibleState=o,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const o=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),w={};o("range")&&(w.range=P.Range.from(this._range)),o("label")&&(w.label=this.label),o("contextValue")&&(w.contextValue=this.contextValue),o("comments")&&(w.comments=this._comments.map(d=>m(this,d,this._commentsMap))),o("collapsibleState")&&(w.collapseState=u(this._collapseState)),o("canReply")&&(w.canReply=this.canReply),this.modifications={},v.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,w)}getCommentByUniqueId(o){for(let w of this._commentsMap){let d=w[0],g=w[1];if(o===g)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(o=>o.dispose())}}y._handlePool=0,Ue([(0,M.debounce)(100)],y.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(o,w,d,g){this._extension=o,this._handle=w,this._id=d,this._label=g,this._threads=new Map,v.$registerCommentController(this.handle,d,g);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(R){S.options=R},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(R){S.commentingRangeProvider=R},get reactionHandler(){return S.reactionHandler},set reactionHandler(R){S.reactionHandler=R},createCommentThread(R,p,D){return S.createCommentThread(R,p,D).value},dispose:()=>{S.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{v.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(o){this._reactionHandler=o,v.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!o})}get options(){return this._options}set options(o){this._options=o,v.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(o,w,d,g){if(typeof o=="string"){const S=new y(this.id,this.handle,o,w,d,g,this._extension.identifier);return this._threads.set(S.handle,S),S}else{const S=new y(this.id,this.handle,void 0,o,w,d,this._extension.identifier);return this._threads.set(S.handle,S),S}}$createCommentThreadTemplate(o,w){const d=new y(this.id,this.handle,void 0,F.URI.revive(o),P.Range.to(w),[],this._extension.identifier);return d.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(o,w){let d=this._threads.get(o);d&&(d.range=P.Range.to(w))}$deleteCommentThread(o){let w=this._threads.get(o);w&&w.dispose(),this._threads.delete(o)}getCommentThread(o){return this._threads.get(o)}dispose(){this._threads.forEach(o=>{o.dispose()}),this._localDisposables.forEach(o=>o.dispose())}}function m(r,o,w){let d=w.get(o);d||(d=++r.commentHandle,w.set(o,d));const g=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:d,body:P.MarkdownString.from(o.body),userName:o.author.name,userIconPath:g,label:o.label,commentReactions:o.reactions?o.reactions.map(S=>k(S)):void 0}}function k(r){return{label:r.label,iconPath:r.iconPath?P.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?F.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function u(r){if(r!==void 0)switch(r){case t.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}return new I}e.createExtHostComments=n}),define(be[95],Ee([0,1,2,5,7,4,12,15,13,9,17]),function(ie,e,h,M,b,T,F,C,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class vi{constructor(f,l){this._logService=l,this._provider=new Map,this._proxy=f.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,l){const s=vi._handlePool++;this._provider.set(s,{provider:f,extensionId:l}),this._proxy.$registerDecorationProvider(s,l.value);const v=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(I=>{if(!I){this._proxy.$onDidChange(s,null);return}let y=(0,_.asArray)(I);if(y.length<=vi._maxEventSize){this._proxy.$onDidChange(s,y);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,y.length);const a=y.map(i=>({uri:i,rank:(0,P.count)(i.path,"/")})),m=(0,_.groupBy)(a,(i,u)=>i.rank-u.rank||(0,P.compare)(i.uri.path,u.uri.path));let k=[];e:for(let i of m){let u;for(let r of i){let o=(0,t.dirname)(r.uri.path);if(u!==o&&(u=o,k.push(r.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(s,k)});return new b.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(s),this._provider.delete(s)})}async $provideDecorations(f,l,s){if(!this._provider.has(f))return Object.create(null);const v=Object.create(null),{provider:I,extensionId:y}=this._provider.get(f);return await Promise.all(l.map(async a=>{try{const{uri:m,id:k}=a,i=await Promise.resolve(I.provideFileDecoration(h.URI.revive(m),s));if(!i)return;try{b.FileDecoration.validate(i),v[k]=[i.propagate,i.tooltip,i.badge,i.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${y.value}': ${u}`)}}catch(m){this._logService.error(m)}})),v}};E._handlePool=0,E._maxEventSize=250,E=Ue([He(0,F.IExtHostRpcService),He(1,C.ILogService)],E),e.ExtHostDecorations=E,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ie,h):b?b.value=h:e.set(ie,h),h},Te=this&&this.__classPrivateFieldGet||function(ie,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[186],Ee([0,1,124,82,2,5,7,8,3,15,20,37,104]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n){"use strict";var f,l,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(a,m,k,i,u,r){this._name=a,this._owner=m,this._maxDiagnosticsPerFile=k,f.set(this,void 0),l.set(this,void 0),s.set(this,void 0),this._isDisposed=!1,Je(this,s,new n.SkipList((o,w)=>i.compare(o,w)),"f"),Je(this,f,u,"f"),Je(this,l,r,"f")}dispose(){this._isDisposed||(Te(this,l,"f").fire([...Te(this,s,"f").keys()]),Te(this,f,"f")&&Te(this,f,"f").$clear(this._owner),Te(this,s,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,m){if(!a){this.clear();return}this._checkDisposed();let k=[];if(b.URI.isUri(a)){if(!m){this.delete(a);return}Te(this,s,"f").set(a,m.slice()),k=[a]}else if(Array.isArray(a)){k=[];let u;a=[...a].sort(v._compareIndexedTuplesByUri);for(const r of a){const[o,w]=r;if((!u||o.toString()!==u.toString())&&(u&&Te(this,s,"f").get(u).length===0&&Te(this,s,"f").delete(u),u=o,k.push(o),Te(this,s,"f").set(o,[])),w){const d=Te(this,s,"f").get(o);d&&d.push(...w)}else{const d=Te(this,s,"f").get(o);d&&(d.length=0)}}}if(Te(this,l,"f").fire(k),!Te(this,f,"f"))return;const i=[];for(let u of k){let r=[];const o=Te(this,s,"f").get(u);if(o)if(o.length>this._maxDiagnosticsPerFile){r=[];const w=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(let g of o)if(g.severity===w[d]&&r.push(C.Diagnostic.from(g))===this._maxDiagnosticsPerFile)break e;r.push({severity:M.MarkerSeverity.Info,message:(0,h.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=o.map(w=>C.Diagnostic.from(w));i.push([u,r])}Te(this,f,"f").$changeMany(this._owner,i)}delete(a){this._checkDisposed(),Te(this,l,"f").fire([a]),Te(this,s,"f").delete(a),Te(this,f,"f")&&Te(this,f,"f").$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),Te(this,l,"f").fire([...Te(this,s,"f").keys()]),Te(this,s,"f").clear(),Te(this,f,"f")&&Te(this,f,"f").$clear(this._owner)}forEach(a,m){this._checkDisposed();for(let k of Te(this,s,"f").keys())a.apply(m,[k,this.get(k),this])}get(a){this._checkDisposed();const m=Te(this,s,"f").get(a);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(Te(this,s,"f").get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,m){return a[0].toString()<m[0].toString()?-1:a[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=v,f=new WeakMap,l=new WeakMap,s=new WeakMap;let I=class Xt{constructor(a,m,k){this._logService=m,this._fileSystemInfoService=k,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,Xt._mapper),this._proxy=a.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(a){const m=new t.ResourceMap;for(const k of a)m.set(k,k);return{uris:Object.freeze(Array.from(m.values()))}}createDiagnosticCollection(a,m){const{_collections:k,_proxy:i,_onDidChangeDiagnostics:u,_logService:r,_fileSystemInfoService:o}=this,w=new class{$changeMany(S,R){i.$changeMany(S,R),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,S,R.length===0?"CLEARING":R)}$clear(S){i.$clear(S),r.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,S)}dispose(){i.dispose()}};let d;if(!m)m="_generated_diagnostic_collection_name_#"+Xt._idPool++,d=m;else if(!k.has(m))d=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do d=m+Xt._idPool++;while(k.has(d))}return new class extends v{constructor(){super(m,d,Xt._maxDiagnosticsPerFile,o.extUri,w,u);k.set(d,this)}dispose(){super.dispose(),k.delete(d)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const m=new Map,k=[];for(const i of this._collections.values())i.forEach((u,r)=>{let o=m.get(u.toString());typeof o=="undefined"&&(o=k.length,m.set(u.toString(),o),k.push([u,[]])),k[o][1]=k[o][1].concat(...r)});return k}}_getDiagnostics(a){let m=[];for(let k of this._collections.values())k.has(a)&&(m=m.concat(k.get(a)));return m}$acceptMarkersChange(a){if(!this._mirrorCollection){const m="_generated_mirror",k=new v(m,m,Xt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(m,k),this._mirrorCollection=k}for(const[m,k]of a)this._mirrorCollection.set(b.URI.revive(m),k.map(C.Diagnostic.to))}};I._idPool=0,I._maxDiagnosticsPerFile=1e3,I=Ue([He(1,P.ILogService),He(2,E.IExtHostFileSystemInfo)],I),e.ExtHostDiagnostics=I}),define(be[187],Ee([0,1,2,5]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(F){this._proxy=F.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(F){return this._proxy.$showOpenDialog(F).then(C=>C?C.map(_=>h.URI.revive(_)):void 0)}showSaveDialog(F){return this._proxy.$showSaveDialog(F).then(C=>C?h.URI.revive(C):void 0)}}e.ExtHostDialogs=b}),define(be[188],Ee([0,1,16,2,7,5,11,21,9]),function(ie,e,h,M,b,T,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(E,n,f){this._documentsAndEditors=n,this._logService=f,this._documentContentProviders=new Map,this._proxy=E.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,n){if(Object.keys(F.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const f=P._handlePool++;this._documentContentProviders.set(f,n),this._proxy.$registerTextContentProvider(f,E);let l;return typeof n.onDidChange=="function"&&(l=n.onDidChange(s=>{if(s.scheme!==E){this._logService.warn(`Provider for scheme '${E}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(s)&&this.$provideTextDocumentContent(f,s).then(v=>{if(!v&&typeof v!="string")return;const I=this._documentsAndEditors.getDocument(s);if(!I)return;const y=(0,_.splitLines)(v);if(!I.equalLines(y))return this._proxy.$onVirtualDocumentChange(s,v)},h.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(E,n){const f=this._documentContentProviders.get(E);return f?Promise.resolve(f.provideTextDocumentContent(M.URI.revive(n),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(be[189],Ee([0,1,3,6,2,5,88,8,10,22,7]),function(ie,e,h,M,b,T,F,C,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class E{constructor(f,l){this._onDidAddDocument=new h.Emitter,this._onDidRemoveDocument=new h.Emitter,this._onDidChangeDocument=new h.Emitter,this._onDidSaveDocument=new h.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=l,this._documentsAndEditors.onDidRemoveDocuments(s=>{for(const v of s)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(s=>{for(const v of s)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const l=this._documentsAndEditors.getDocument(f);if(l)return l}getDocument(f){const l=this.getDocumentData(f);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return l.document}ensureDocumentData(f){const l=this._documentsAndEditors.getDocument(f);if(l)return Promise.resolve(l);let s=this._documentLoader.get(f.toString());return s||(s=this._proxy.$tryOpenDocument(f).then(v=>{this._documentLoader.delete(f.toString());const I=b.URI.revive(v);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(I))},v=>(this._documentLoader.delete(f.toString()),Promise.reject(v))),this._documentLoader.set(f.toString(),s)),s}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(l=>b.URI.revive(l))}$acceptModelModeChanged(f,l){const s=b.URI.revive(f),v=this._documentsAndEditors.getDocument(s);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(l),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(f){const l=b.URI.revive(f),s=this._documentsAndEditors.getDocument(l);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(s.document)}$acceptDirtyStateChanged(f,l){const s=b.URI.revive(f),v=this._documentsAndEditors.getDocument(s);if(!v)throw new Error("unknown document");v._acceptIsDirty(l),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,l,s){const v=b.URI.revive(f),I=this._documentsAndEditors.getDocument(v);if(!I)throw new Error("unknown document");I._acceptIsDirty(s),I.onEvents(l);let y;l.isUndoing?y=t.TextDocumentChangeReason.Undo:l.isRedoing&&(y=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:I.document,contentChanges:l.changes.map(a=>({range:C.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:y}))}setWordDefinitionFor(f,l){(0,F.setWordDefinitionFor)(f,l)}}e.ExtHostDocuments=E}),define(be[49],Ee([0,1,40,3,6,2,4,5,88,12,94,8,15,20,11,232,103]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l,s,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class I{constructor(m){this.value=m,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let y=class{constructor(m,k){this._extHostRpc=m,this._logService=k,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(m){this.acceptDocumentsAndEditorsDelta(m)}acceptDocumentsAndEditorsDelta(m){const k=[],i=[],u=[];if(m.removedDocuments)for(const r of m.removedDocuments){const o=T.URI.revive(r),w=this._documents.get(o);w?.unref()&&(this._documents.delete(o),k.push(w.value))}if(m.addedDocuments)for(const r of m.addedDocuments){const o=T.URI.revive(r.uri);let w=this._documents.get(o);if(w&&o.scheme!==l.Schemas.vscodeNotebookCell&&o.scheme!==l.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);w||(w=new I(new _.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),o,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(o,w),i.push(w.value)),w.ref()}if(m.removedEditors)for(const r of m.removedEditors){const o=this._editors.get(r);this._editors.delete(r),o&&u.push(o)}if(m.addedEditors)for(const r of m.addedEditors){const o=T.URI.revive(r.documentUri);h.ok(this._documents.has(o),`document '${o}' does not exist`),h.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const w=this._documents.get(o).value,d=new t.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>w.document),r.selections.map(E.Selection.to),r.options,r.visibleRanges.map(g=>E.Range.to(g)),typeof r.editorPosition=="number"?E.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,d)}m.newActiveEditor!==void 0&&(h.ok(m.newActiveEditor===null||this._editors.has(m.newActiveEditor),`active editor '${m.newActiveEditor}' does not exist`),this._activeEditorId=m.newActiveEditor),(0,b.dispose)(k),(0,b.dispose)(u),m.removedDocuments&&this._onDidRemoveDocuments.fire(k),m.addedDocuments&&this._onDidAddDocuments.fire(i),(m.removedEditors||m.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),m.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(m){return this._documents.get(m)?.value}allDocuments(){return s.Iterable.map(this._documents.values(),m=>m.value)}getEditor(m){return this._editors.get(m)}activeEditor(m){if(!this._activeEditorId)return;const k=this._editors.get(this._activeEditorId);return m?k:k?.value}allEditors(){return[...this._editors.values()]}};y=Ue([He(0,P.IExtHostRpcService),He(1,n.ILogService)],y),e.ExtHostDocumentsAndEditors=y,e.IExtHostDocumentsAndEditors=(0,F.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[190],Ee([0,1,2,5,6,7,8,233,9,23]),function(ie,e,h,M,b,T,F,C,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const l=this._schemes.indexOf(f);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),l=[];let s,v,I=14,y=14;for(const a of f){let m=s?(0,_.commonPrefixLength)(s,a):0;for(m===0?v=1:v=y;m<a.length;m++)m+1===a.length?(I=y,y=9):y+=1,l.push([v,a.toUpperCase().charCodeAt(m),y]),l.push([v,a.toLowerCase().charCodeAt(m),y]),v=y;s=a,y=I}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new C.StateMachine(l)}}provideDocumentLinks(f){this._initStateMachine();const l=[],s=C.LinkComputer.computeLinks({getLineContent(v){return f.lineAt(v-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const v of s){const I=F.DocumentLink.to(v);I.target&&l.push(I)}return l}}class E{constructor(f,l){this._extHostLanguageFeatures=l,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,l,s,v={}){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const I=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(I,s);let y=2;v.isCaseSensitive&&(y+=1024),v.isReadonly&&(y+=2048),typeof s.copy=="function"&&(y+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&(y+=4),this._proxy.$registerFileSystemProvider(I,l,y).catch(m=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${l}`),console.error(m)});const a=s.onDidChangeFile(m=>{const k=[];for(const i of m){let{uri:u,type:r}=i;if(u.scheme!==l)continue;let o;switch(r){case T.FileChangeType.Changed:o=0;break;case T.FileChangeType.Created:o=1;break;case T.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}k.push({resource:u,type:o})}this._proxy.$onFileSystemChange(I,k)});return(0,b.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(I),this._proxy.$unregisterProvider(I)})}static _asIStat(f){const{type:l,ctime:s,mtime:v,size:I,permissions:y}=f;return{type:l,ctime:s,mtime:v,size:I,permissions:y}}$stat(f,l){return Promise.resolve(this._getFsProvider(f).stat(h.URI.revive(l))).then(s=>E._asIStat(s))}$readdir(f,l){return Promise.resolve(this._getFsProvider(f).readDirectory(h.URI.revive(l)))}$readFile(f,l){return Promise.resolve(this._getFsProvider(f).readFile(h.URI.revive(l))).then(s=>P.VSBuffer.wrap(s))}$writeFile(f,l,s,v){return Promise.resolve(this._getFsProvider(f).writeFile(h.URI.revive(l),s.buffer,v))}$delete(f,l,s){return Promise.resolve(this._getFsProvider(f).delete(h.URI.revive(l),s))}$rename(f,l,s,v){return Promise.resolve(this._getFsProvider(f).rename(h.URI.revive(l),h.URI.revive(s),v))}$copy(f,l,s,v){const I=this._getFsProvider(f);if(!I.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(I.copy(h.URI.revive(l),h.URI.revive(s),v))}$mkdir(f,l){return Promise.resolve(this._getFsProvider(f).createDirectory(h.URI.revive(l)))}$watch(f,l,s,v){const I=this._getFsProvider(f).watch(h.URI.revive(s),v);this._watches.set(l,I)}$unwatch(f,l){const s=this._watches.get(l);s&&(s.dispose(),this._watches.delete(l))}$open(f,l,s){const v=this._getFsProvider(f);if(!v.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(v.open(h.URI.revive(l),s))}$close(f,l){const s=this._getFsProvider(f);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(l))}$read(f,l,s,v){const I=this._getFsProvider(f);if(!I.read)throw new Error('FileSystemProvider does not implement "read"');const y=P.VSBuffer.alloc(v);return Promise.resolve(I.read(l,s,y.buffer,0,v)).then(a=>y.slice(0,a))}$write(f,l,s,v){const I=this._getFsProvider(f);if(!I.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(I.write(l,s,v.buffer,0,v.byteLength))}_getFsProvider(f){const l=this._fsProvider.get(f);if(!l){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return l}}e.ExtHostFileSystem=E}),define(be[71],Ee([0,1,5,60,7,23,4,12,37]),function(ie,e,h,M,b,T,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Ut{constructor(E,n){const f=E.getProxy(h.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(l){return f.$stat(l).catch(Ut._handleError)},readDirectory(l){return f.$readdir(l).catch(Ut._handleError)},createDirectory(l){return f.$mkdir(l).catch(Ut._handleError)},async readFile(l){return f.$readFile(l).then(s=>s.buffer).catch(Ut._handleError)},writeFile(l,s){return f.$writeFile(l,T.VSBuffer.wrap(s)).catch(Ut._handleError)},delete(l,s){return f.$delete(l,{recursive:!1,useTrash:!1,...s}).catch(Ut._handleError)},rename(l,s,v){return f.$rename(l,s,{overwrite:!1,...v}).catch(Ut._handleError)},copy(l,s,v){return f.$copy(l,s,{overwrite:!1,...v}).catch(Ut._handleError)},isWritableFileSystem(l){const s=n.getCapabilities(l);if(typeof s=="number")return!(s&2048)}})}static _handleError(E){if(!(E instanceof Error))throw new b.FileSystemError(String(E));if(E.name==="ENOPRO")throw b.FileSystemError.Unavailable(E.message);switch(E.name){case M.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(E.message);case M.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(E.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(E.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(E.message);case M.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(E.message);case M.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(E.message);default:throw new b.FileSystemError(E.message,E.name)}}};P=Ue([He(0,C.IExtHostRpcService),He(1,_.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,F.createDecorator)("IExtHostConsumerFileSystem")}),define(be[191],Ee([0,1,2,48]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(F,C,_,P){this._extHostNotebooks=C,this._textDocumentsAndEditors=_,this._commands=P;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new M.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new M.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new M.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new M.ApiCommandResult("Notebook and input URI",E=>{if(E.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(E.notebookEditorId);return{notebookUri:h.URI.revive(E.notebookUri),inputUri:h.URI.revive(E.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:h.URI.revive(E.notebookUri),inputUri:h.URI.revive(E.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(F,C,_,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],modeId:_,uri:F,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(h.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.ExtHostInteractive=b}),define(be[192],Ee([0,1,6,5]),function(ie,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(F){this._handlePool=0,this._proxy=F.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(F){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,F),(0,h.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=b}),define(be[193],Ee([0,1,2,22,8,7,5,9,42,13,10,234,6,80,53,63,194,16,3]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l,s,v,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentSymbols(x,Y){const ee=this._documents.getDocument(x),ae=await this._provider.provideDocumentSymbols(ee,Y);if(!(0,P.isFalsyOrEmpty)(ae))return ae[0]instanceof T.DocumentSymbol?ae.map(b.DocumentSymbol.from):a._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(x){x=x.slice(0).sort((ae,j)=>{let oe=ae.location.range.start.compareTo(j.location.range.start);return oe===0&&(oe=j.location.range.end.compareTo(ae.location.range.end)),oe});const Y=[],ee=[];for(const ae of x){const j={name:ae.name||"!!MISSING: name!!",kind:b.SymbolKind.from(ae.kind),tags:ae.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:b.Range.from(ae.location.range),selectionRange:b.Range.from(ae.location.range),children:[]};for(;;){if(ee.length===0){ee.push(j),Y.push(j);break}const oe=ee[ee.length-1];if(_.Range.containsRange(oe.range,j.range)&&!_.Range.equalsRange(oe.range,j.range)){oe.children&&oe.children.push(j),ee.push(j);break}ee.pop()}}return Y}}class m{constructor(x,Y,ee){this._documents=x,this._commands=Y,this._provider=ee,this._cache=new s.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,Y){const ee=this._documents.getDocument(x),ae=await this._provider.provideCodeLenses(ee,Y);if(!ae||Y.isCancellationRequested)return;const j=this._cache.add(ae),oe=new n.DisposableStore;this._disposables.set(j,oe);const fe={cacheId:j,lenses:[]};for(let Ae=0;Ae<ae.length;Ae++)fe.lenses.push({cacheId:[j,Ae],range:b.Range.from(ae[Ae].range),command:this._commands.toInternal(ae[Ae].command,oe)});return fe}async resolveCodeLens(x,Y){const ee=x.cacheId&&this._cache.get(...x.cacheId);if(!ee)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||ee.isResolved?ae=ee:ae=await this._provider.resolveCodeLens(ee,Y),ae||(ae=ee),Y.isCancellationRequested)return;const j=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!j)return x.command=this._commands.toInternal(ae.command??m._badCmd,j),x}releaseCodeLenses(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}}m._badCmd={command:"missing",title:"!!MISSING: command!!"};function k(qe){return Array.isArray(qe)?qe.map(b.DefinitionLink.from):qe?[b.DefinitionLink.from(qe)]:[]}class i{constructor(x,Y){this._documents=x,this._provider=Y}async provideDefinition(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.provideDefinition(ae,j,ee);return k(oe)}}class u{constructor(x,Y){this._documents=x,this._provider=Y}async provideDeclaration(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.provideDeclaration(ae,j,ee);return k(oe)}}class r{constructor(x,Y){this._documents=x,this._provider=Y}async provideImplementation(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.provideImplementation(ae,j,ee);return k(oe)}}class o{constructor(x,Y){this._documents=x,this._provider=Y}async provideTypeDefinition(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.provideTypeDefinition(ae,j,ee);return k(oe)}}class w{constructor(x,Y){this._documents=x,this._provider=Y}async provideHover(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.provideHover(ae,j,ee);if(!(!oe||(0,P.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=ae.getWordRangeAtPosition(j)),oe.range||(oe.range=new T.Range(j,j)),b.Hover.from(oe)}}class d{constructor(x,Y){this._documents=x,this._provider=Y}async provideEvaluatableExpression(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.provideEvaluatableExpression(ae,j,ee);if(oe)return b.EvaluatableExpression.from(oe)}}class g{constructor(x,Y){this._documents=x,this._provider=Y}async provideInlineValues(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=await this._provider.provideInlineValues(j,b.Range.to(Y),b.InlineValueContext.to(ee),ae);if(Array.isArray(oe))return oe.map(fe=>b.InlineValue.from(fe))}}class S{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentHighlights(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.provideDocumentHighlights(ae,j,ee);if(Array.isArray(oe))return oe.map(b.DocumentHighlight.from)}}class R{constructor(x,Y){this._documents=x,this._provider=Y}async provideLinkedEditingRanges(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.provideLinkedEditingRanges(ae,j,ee);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,P.coalesce)(oe.ranges.map(b.Range.from)),wordPattern:oe.wordPattern}}}class p{constructor(x,Y){this._documents=x,this._provider=Y}async provideReferences(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=b.Position.to(Y),fe=await this._provider.provideReferences(j,oe,ee,ae);if(Array.isArray(fe))return fe.map(b.location.from)}}class D{constructor(x,Y,ee,ae,j,oe,fe){this._documents=x,this._commands=Y,this._diagnostics=ee,this._provider=ae,this._logService=j,this._extension=oe,this._apiDeprecation=fe,this._cache=new s.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=E.Selection.isISelection(Y)?b.Selection.to(Y):b.Range.to(Y),fe=[];for(const V of this._diagnostics.getDiagnostics(x))if(oe.intersection(V.range)&&fe.push(V)>D._maxCodeActionsPerFile)break;const Ae={diagnostics:fe,only:ee.only?new T.CodeActionKind(ee.only):void 0,triggerKind:b.CodeActionTriggerKind.to(ee.trigger)},xe=await this._provider.provideCodeActions(j,oe,Ae,ae);if(!(0,P.isNonEmptyArray)(xe)||ae.isCancellationRequested)return;const $e=this._cache.add(xe),we=new n.DisposableStore;this._disposables.set($e,we);const Ze=[];for(let V=0;V<xe.length;V++){const J=xe[V];!J||(D._isCommand(J)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:J.title,command:this._commands.toInternal(J,we)})):(Ae.only&&(J.kind?Ae.only.contains(J.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${J.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[$e,V],title:J.title,command:J.command&&this._commands.toInternal(J.command,we),diagnostics:J.diagnostics&&J.diagnostics.map(b.Diagnostic.from),edit:J.edit&&b.WorkspaceEdit.from(J.edit),kind:J.kind&&J.kind.value,isPreferred:J.isPreferred,disabled:J.disabled?.reason})))}return{cacheId:$e,actions:Ze}}async resolveCodeAction(x,Y){const[ee,ae]=x,j=this._cache.get(ee,ae);if(!j||D._isCommand(j)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(j,Y)??j;return oe?.edit?b.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}D._maxCodeActionsPerFile=1e3;class c{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentFormattingEdits(x,Y,ee){const ae=this._documents.getDocument(x),j=await this._provider.provideDocumentFormattingEdits(ae,Y,ee);if(Array.isArray(j))return j.map(b.TextEdit.from)}}class A{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentRangeFormattingEdits(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=b.Range.to(Y),fe=await this._provider.provideDocumentRangeFormattingEdits(j,oe,ee,ae);if(Array.isArray(fe))return fe.map(b.TextEdit.from)}}class O{constructor(x,Y){this._documents=x,this._provider=Y,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(x,Y,ee,ae,j){const oe=this._documents.getDocument(x),fe=b.Position.to(Y),Ae=await this._provider.provideOnTypeFormattingEdits(oe,fe,ee,ae,j);if(Array.isArray(Ae))return Ae.map(b.TextEdit.from)}}class z{constructor(x,Y){this._provider=x,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(x,Y){const ee=F.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(x,Y);if((0,P.isNonEmptyArray)(ae))for(const j of ae){if(!j)continue;if(!j.name){this._logService.warn("INVALID SymbolInformation, lacks name",j);continue}const oe=F.IdObject.mixin(b.WorkspaceSymbol.from(j));this._symbolCache.set(oe._id,j),ee.symbols.push(oe)}return ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee}async resolveWorkspaceSymbol(x,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const ee=this._symbolCache.get(x._id);if(ee){const ae=await this._provider.resolveWorkspaceSymbol(ee,Y);return ae&&(0,M.mixin)(x,b.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(x){const Y=this._resultCache.get(x);if(Y){for(let[ee,ae]=Y;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete(x)}}}class K{constructor(x,Y,ee){this._documents=x,this._provider=Y,this._logService=ee}static supportsResolving(x){return typeof x.prepareRename=="function"}async provideRenameEdits(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=b.Position.to(Y);try{const fe=await this._provider.provideRenameEdits(j,oe,ee,ae);return fe?b.WorkspaceEdit.from(fe):void 0}catch(fe){const Ae=K._asMessage(fe);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(fe)}}async resolveRenameLocation(x,Y,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(x),j=b.Position.to(Y);try{const oe=await this._provider.prepareRename(ae,j,ee);let fe,Ae;if(T.Range.isRange(oe)?(fe=oe,Ae=ae.getText(oe)):(0,t.isObject)(oe)&&(fe=oe.range,Ae=oe.placeholder),!fe||!Ae)return;if(fe.start.line>j.line||fe.end.line<j.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(fe),text:Ae}}catch(oe){const fe=K._asMessage(oe);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class ${constructor(x,Y){this.resultId=x,this.tokens=Y}}class Q{constructor(x,Y){this._documents=x,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(x,Y,ee){const ae=this._documents.getDocument(x),j=Y!==0?this._previousResults.get(Y):null;let oe=typeof j?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,j.resultId,ee):await this._provider.provideDocumentSemanticTokens(ae,ee);return j&&this._previousResults.delete(Y),oe?(oe=Q._fixProvidedSemanticTokens(oe),this._send(Q._convertToEdits(j,oe),oe)):null}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return Q._isSemanticTokens(x)?Q._isCorrectSemanticTokens(x)?x:new T.SemanticTokens(new Uint32Array(x.data),x.resultId):Q._isSemanticTokensEdits(x)?Q._isCorrectSemanticTokensEdits(x)?x:new T.SemanticTokensEdits(x.edits.map(Y=>new T.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const Y of x.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,Y){if(!Q._isSemanticTokens(Y)||!x||!x.tokens)return Y;const ee=x.tokens,ae=ee.length,j=Y.data,oe=j.length;let fe=0;const Ae=Math.min(ae,oe);for(;fe<Ae&&ee[fe]===j[fe];)fe++;if(fe===ae&&fe===oe)return new T.SemanticTokensEdits([],Y.resultId);let xe=0;const $e=Ae-fe;for(;xe<$e&&ee[ae-xe-1]===j[oe-xe-1];)xe++;return new T.SemanticTokensEdits([{start:fe,deleteCount:ae-fe-xe,data:j.subarray(fe,oe-xe)}],Y.resultId)}_send(x,Y){if(Q._isSemanticTokens(x)){const ee=this._nextResultId++;return this._previousResults.set(ee,new $(x.resultId,x.data)),(0,f.encodeSemanticTokensDto)({id:ee,type:"full",data:x.data})}if(Q._isSemanticTokensEdits(x)){const ee=this._nextResultId++;return Q._isSemanticTokens(Y)?this._previousResults.set(ee,new $(Y.resultId,Y.data)):this._previousResults.set(ee,new $(x.resultId)),(0,f.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(x.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=Q;class W{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentRangeSemanticTokens(x,Y,ee){const ae=this._documents.getDocument(x),j=await this._provider.provideDocumentRangeSemanticTokens(ae,b.Range.to(Y),ee);return j?this._send(j):null}_send(x){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=W;class U{constructor(x,Y,ee,ae,j){this._documents=x,this._commands=Y,this._provider=ee,this._apiDeprecation=ae,this._extension=j,this._cache=new s.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=b.Position.to(Y),fe=j.getWordRangeAtPosition(oe)||new T.Range(oe,oe),Ae=fe.with({end:oe}),xe=new v.StopWatch(!0),$e=await this._provider.provideCompletionItems(j,oe,ae,b.CompletionContext.to(ee));if(!$e||ae.isCancellationRequested)return;const we=Array.isArray($e)?new T.CompletionList($e):$e,Ze=U.supportsResolving(this._provider)?this._cache.add(we.items):this._cache.add([]),V=new n.DisposableStore;this._disposables.set(Ze,V);const J=[],he={x:Ze,b:J,a:{replace:b.Range.from(fe),insert:b.Range.from(Ae)},c:we.isIncomplete||void 0,d:xe.elapsed()};for(let Oe=0;Oe<we.items.length;Oe++){const Ve=we.items[Oe],tt=this._convertCompletionItem(Ve,[Ze,Oe],Ae,fe);J.push(tt)}return he}async resolveCompletionItem(x,Y){if(typeof this._provider.resolveCompletionItem!="function")return;const ee=this._cache.get(...x);if(!ee)return;const ae=await this._provider.resolveCompletionItem(ee,Y);if(!!ae)return this._convertCompletionItem(ae,x)}releaseCompletionItems(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,Y,ee,ae){const j=this._disposables.get(Y[0]);if(!j)throw Error("DisposableStore is missing...");const oe={x:Y,a:x.label,b:x.kind!==void 0?b.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(b.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:b.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(x.command,j)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=x.textEdit.newText):typeof x.insertText=="string"?oe.h=x.insertText:x.insertText instanceof T.SnippetString&&(oe.h=x.insertText.value,oe.i|=4);let fe;return x.textEdit?fe=x.textEdit.range:x.range&&(fe=x.range),T.Range.isRange(fe)?oe.j=b.Range.from(fe):fe&&(!ee?.isEqual(fe.inserting)||!ae?.isEqual(fe.replacing))&&(oe.j={insert:b.Range.from(fe.inserting),replace:b.Range.from(fe.replacing)}),oe}}class H{constructor(x,Y,ee){this._documents=x,this._provider=Y,this._commands=ee,this._cache=new s.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=b.Position.to(Y),fe=await this._provider.provideInlineCompletionItems(j,oe,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:b.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:ee.triggerKind},ae);if(!fe||ae.isCancellationRequested)return;const Ae=(0,t.isArray)(fe)?{items:fe}:fe,xe=this._cache.add(Ae.items);let $e;return{pid:xe,items:Ae.items.map((we,Ze)=>{let V;return we.command&&($e||($e=new n.DisposableStore,this._disposables.set(xe,$e)),V=this._commands.toInternal(we.command,$e)),{text:we.text,range:we.range?b.Range.from(we.range):void 0,command:V,idx:Ze}})}}disposeCompletions(x){this._cache.delete(x);const Y=this._disposables.get(x);Y&&Y.clear(),this._disposables.delete(x)}handleDidShowCompletionItem(x,Y){const ee=this._cache.get(x,Y);ee&&G.get(this._provider).fireOnDidShowCompletionItem({completionItem:ee})}}class G{constructor(){this._onDidShowCompletionItemEmitter=new y.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(x){let Y=G.map.get(x);return Y||(Y=new G,G.map.set(x,Y)),Y}fireOnDidShowCompletionItem(x){this._onDidShowCompletionItemEmitter.fire(x)}}e.InlineCompletionController=G,G.map=new WeakMap;class ue{constructor(x,Y){this._documents=x,this._provider=Y,this._cache=new s.Cache("SignatureHelp")}async provideSignatureHelp(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=b.Position.to(Y),fe=this.reviveContext(ee),Ae=await this._provider.provideSignatureHelp(j,oe,ae,fe);if(Ae){const xe=this._cache.add([Ae]);return{...b.SignatureHelp.from(Ae),id:xe}}}reviveContext(x){let Y;if(x.activeSignatureHelp){const ee=b.SignatureHelp.to(x.activeSignatureHelp),ae=this._cache.get(x.activeSignatureHelp.id,0);ae?(Y=ae,Y.activeSignature=ee.activeSignature,Y.activeParameter=ee.activeParameter):Y=ee}return{...x,activeSignatureHelp:Y}}releaseSignatureHelp(x){this._cache.delete(x)}}class q{constructor(x,Y){this._documents=x,this._provider=Y}async provideInlayHints(x,Y,ee){const ae=this._documents.getDocument(x),j=await this._provider.provideInlayHints(ae,b.Range.to(Y),ee);return j?{hints:j.map(b.InlayHint.from)}:void 0}}class le{constructor(x,Y){this._documents=x,this._provider=Y,this._cache=new s.Cache("DocumentLink")}async provideLinks(x,Y){const ee=this._documents.getDocument(x),ae=await this._provider.provideDocumentLinks(ee,Y);if(!(!Array.isArray(ae)||ae.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(le._validateLink).map(b.DocumentLink.from)};{const j=this._cache.add(ae),oe={links:[],id:j};for(let fe=0;fe<ae.length;fe++){if(!le._validateLink(ae[fe]))continue;const Ae=b.DocumentLink.from(ae[fe]);Ae.cacheId=[j,fe],oe.links.push(Ae)}return oe}}}static _validateLink(x){return x.target&&x.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(x,Y){if(typeof this._provider.resolveDocumentLink!="function")return;const ee=this._cache.get(...x);if(!ee)return;const ae=await this._provider.resolveDocumentLink(ee,Y);if(!(!ae||!le._validateLink(ae)))return b.DocumentLink.from(ae)}releaseLinks(x){this._cache.delete(x)}}class se{constructor(x,Y){this._documents=x,this._provider=Y}async provideColors(x,Y){const ee=this._documents.getDocument(x),ae=await this._provider.provideDocumentColors(ee,Y);return Array.isArray(ae)?ae.map(oe=>({color:b.Color.from(oe.color),range:b.Range.from(oe.range)})):[]}async provideColorPresentations(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Range.to(Y.range),oe=b.Color.to(Y.color),fe=await this._provider.provideColorPresentations(oe,{document:ae,range:j},ee);if(!!Array.isArray(fe))return fe.map(b.ColorPresentation.from)}}class ve{constructor(x,Y){this._documents=x,this._provider=Y}async provideFoldingRanges(x,Y,ee){const ae=this._documents.getDocument(x),j=await this._provider.provideFoldingRanges(ae,Y,ee);if(!!Array.isArray(j))return j.map(b.FoldingRange.from)}}class Fe{constructor(x,Y,ee){this._documents=x,this._provider=Y,this._logService=ee}async provideSelectionRanges(x,Y,ee){const ae=this._documents.getDocument(x),j=Y.map(b.Position.to),oe=await this._provider.provideSelectionRanges(ae,j,ee);if(!(0,P.isNonEmptyArray)(oe))return[];if(oe.length!==j.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let Ae=0;Ae<j.length;Ae++){const xe=[];fe.push(xe);let $e=j[Ae],we=oe[Ae];for(;;){if(!we.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(b.SelectionRange.from(we)),!we.parent)break;$e=we.range,we=we.parent}}return fe}}class Me{constructor(x,Y){this._documents=x,this._provider=Y,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.prepareCallHierarchy(ae,j,ee);if(!oe)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(oe)?oe.map(Ae=>this._cacheAndConvertItem(fe,Ae)):[this._cacheAndConvertItem(fe,oe)]}async provideCallsTo(x,Y,ee){const ae=this._itemFromCache(x,Y);if(!ae)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!j)return j.map(oe=>({from:this._cacheAndConvertItem(x,oe.from),fromRanges:oe.fromRanges.map(fe=>b.Range.from(fe))}))}async provideCallsFrom(x,Y,ee){const ae=this._itemFromCache(x,Y);if(!ae)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!j)return j.map(oe=>({to:this._cacheAndConvertItem(x,oe.to),fromRanges:oe.fromRanges.map(fe=>b.Range.from(fe))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Y){const ee=this._cache.get(x),ae=b.CallHierarchyItem.from(Y,x,ee.size.toString(36));return ee.set(ae._itemId,Y),ae}_itemFromCache(x,Y){return this._cache.get(x)?.get(Y)}}class Ne{constructor(x,Y){this._documents=x,this._provider=Y,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.prepareTypeHierarchy(ae,j,ee);if(!oe)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(oe)?oe.map(Ae=>this._cacheAndConvertItem(fe,Ae)):[this._cacheAndConvertItem(fe,oe)]}async provideSupertypes(x,Y,ee){const ae=this._itemFromCache(x,Y);if(!ae)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySupertypes(ae,ee);if(!!j)return j.map(oe=>this._cacheAndConvertItem(x,oe))}async provideSubtypes(x,Y,ee){const ae=this._itemFromCache(x,Y);if(!ae)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySubtypes(ae,ee);if(!!j)return j.map(oe=>this._cacheAndConvertItem(x,oe))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Y){const ee=this._cache.get(x),ae=b.TypeHierarchyItem.from(Y,x,ee.size.toString(36));return ee.set(ae._itemId,Y),ae}_itemFromCache(x,Y){return this._cache.get(x)?.get(Y)}}class Qe{constructor(x,Y){this.adapter=x,this.extension=Y}}class ze{constructor(x,Y,ee,ae,j,oe,fe){this._adapter=new Map,this._uriTransformer=Y,this._proxy=x.getProxy(F.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=j,this._logService=oe,this._apiDeprecation=fe}_transformDocumentSelector(x){return(0,P.coalesce)((0,P.asArray)(x).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(x){if(typeof x=="string")return{$serialized:!0,language:x};if(x)return{$serialized:!0,language:x.language,scheme:this._transformScheme(x.scheme),pattern:typeof x.pattern=="undefined"?void 0:b.GlobPattern.from(x.pattern),exclusive:x.exclusive}}_transformScheme(x){return this._uriTransformer&&typeof x=="string"?this._uriTransformer.transformOutgoingScheme(x):x}_createDisposable(x){return new T.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return ze._handlePool++}_withAdapter(x,Y,ee,ae,j=!1){const oe=this._adapter.get(x);if(!oe)return Promise.resolve(ae);if(oe.adapter instanceof Y){let fe;oe.extension&&(fe=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${Y.name}'`));const Ae=ee(oe.adapter,oe.extension),xe=oe.extension;return xe&&Promise.resolve(Ae).then(()=>this._logService.trace(`[${xe.identifier.value}] provider DONE after ${Date.now()-fe}ms`),$e=>{j&&$e instanceof I.CancellationError||(this._logService.error(`[${xe.identifier.value}] provider FAILED`),this._logService.error($e))}),Ae}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,Y){const ee=this._nextHandle();return this._adapter.set(ee,new Qe(x,Y)),ee}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,Y,ee,ae){const j=this._addNewAdapter(new a(this._documents,ee),x),oe=ae&&ae.label||ze._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(j,this._transformDocumentSelector(Y),oe),this._createDisposable(j)}$provideDocumentSymbols(x,Y,ee){return this._withAdapter(x,a,ae=>ae.provideDocumentSymbols(h.URI.revive(Y),ee),void 0)}registerCodeLensProvider(x,Y,ee){const ae=this._nextHandle(),j=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new m(this._documents,this._commands.converter,ee),x)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Y),j);let oe=this._createDisposable(ae);if(j!==void 0){const fe=ee.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(j));oe=T.Disposable.from(oe,fe)}return oe}$provideCodeLenses(x,Y,ee){return this._withAdapter(x,m,ae=>ae.provideCodeLenses(h.URI.revive(Y),ee),void 0)}$resolveCodeLens(x,Y,ee){return this._withAdapter(x,m,ae=>ae.resolveCodeLens(Y,ee),void 0)}$releaseCodeLenses(x,Y){this._withAdapter(x,m,ee=>Promise.resolve(ee.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(x,Y,ee){const ae=this._addNewAdapter(new i(this._documents,ee),x);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDefinition(x,Y,ee,ae){return this._withAdapter(x,i,j=>j.provideDefinition(h.URI.revive(Y),ee,ae),[])}registerDeclarationProvider(x,Y,ee){const ae=this._addNewAdapter(new u(this._documents,ee),x);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDeclaration(x,Y,ee,ae){return this._withAdapter(x,u,j=>j.provideDeclaration(h.URI.revive(Y),ee,ae),[])}registerImplementationProvider(x,Y,ee){const ae=this._addNewAdapter(new r(this._documents,ee),x);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideImplementation(x,Y,ee,ae){return this._withAdapter(x,r,j=>j.provideImplementation(h.URI.revive(Y),ee,ae),[])}registerTypeDefinitionProvider(x,Y,ee){const ae=this._addNewAdapter(new o(this._documents,ee),x);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideTypeDefinition(x,Y,ee,ae){return this._withAdapter(x,o,j=>j.provideTypeDefinition(h.URI.revive(Y),ee,ae),[])}registerHoverProvider(x,Y,ee,ae){const j=this._addNewAdapter(new w(this._documents,ee),x);return this._proxy.$registerHoverProvider(j,this._transformDocumentSelector(Y)),this._createDisposable(j)}$provideHover(x,Y,ee,ae){return this._withAdapter(x,w,j=>j.provideHover(h.URI.revive(Y),ee,ae),void 0)}registerEvaluatableExpressionProvider(x,Y,ee,ae){const j=this._addNewAdapter(new d(this._documents,ee),x);return this._proxy.$registerEvaluatableExpressionProvider(j,this._transformDocumentSelector(Y)),this._createDisposable(j)}$provideEvaluatableExpression(x,Y,ee,ae){return this._withAdapter(x,d,j=>j.provideEvaluatableExpression(h.URI.revive(Y),ee,ae),void 0)}registerInlineValuesProvider(x,Y,ee,ae){const j=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new g(this._documents,ee),x);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(Y),j);let fe=this._createDisposable(oe);if(j!==void 0){const Ae=ee.onDidChangeInlineValues(xe=>this._proxy.$emitInlineValuesEvent(j));fe=T.Disposable.from(fe,Ae)}return fe}$provideInlineValues(x,Y,ee,ae,j){return this._withAdapter(x,g,oe=>oe.provideInlineValues(h.URI.revive(Y),ee,ae,j),void 0)}registerDocumentHighlightProvider(x,Y,ee){const ae=this._addNewAdapter(new S(this._documents,ee),x);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentHighlights(x,Y,ee,ae){return this._withAdapter(x,S,j=>j.provideDocumentHighlights(h.URI.revive(Y),ee,ae),void 0)}registerLinkedEditingRangeProvider(x,Y,ee){const ae=this._addNewAdapter(new R(this._documents,ee),x);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideLinkedEditingRanges(x,Y,ee,ae){return this._withAdapter(x,R,async j=>{const oe=await j.provideLinkedEditingRanges(h.URI.revive(Y),ee,ae);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?ze._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(x,Y,ee){const ae=this._addNewAdapter(new p(this._documents,ee),x);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideReferences(x,Y,ee,ae,j){return this._withAdapter(x,p,oe=>oe.provideReferences(h.URI.revive(Y),ee,ae,j),void 0)}registerCodeActionProvider(x,Y,ee,ae){const j=new n.DisposableStore,oe=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(Y),{providedKinds:ae?.providedCodeActionKinds?.map(fe=>fe.value),documentation:ae?.documentation?.map(fe=>({kind:fe.kind.value,command:this._commands.converter.toInternal(fe.command,j)}))},ze._extLabel(x),Boolean(ee.resolveCodeAction)),j.add(this._createDisposable(oe)),j}$provideCodeActions(x,Y,ee,ae,j){return this._withAdapter(x,D,oe=>oe.provideCodeActions(h.URI.revive(Y),ee,ae,j),void 0)}$resolveCodeAction(x,Y,ee){return this._withAdapter(x,D,ae=>ae.resolveCodeAction(Y,ee),void 0)}$releaseCodeActions(x,Y){this._withAdapter(x,D,ee=>Promise.resolve(ee.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(x,Y,ee){const ae=this._addNewAdapter(new c(this._documents,ee),x);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Y),x.identifier,x.displayName||x.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(x,Y,ee,ae){return this._withAdapter(x,c,j=>j.provideDocumentFormattingEdits(h.URI.revive(Y),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider(x,Y,ee){const ae=this._addNewAdapter(new A(this._documents,ee),x);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Y),x.identifier,x.displayName||x.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(x,Y,ee,ae,j){return this._withAdapter(x,A,oe=>oe.provideDocumentRangeFormattingEdits(h.URI.revive(Y),ee,ae,j),void 0)}registerOnTypeFormattingEditProvider(x,Y,ee,ae){const j=this._addNewAdapter(new O(this._documents,ee),x);return this._proxy.$registerOnTypeFormattingSupport(j,this._transformDocumentSelector(Y),ae,x.identifier),this._createDisposable(j)}$provideOnTypeFormattingEdits(x,Y,ee,ae,j,oe){return this._withAdapter(x,O,fe=>fe.provideOnTypeFormattingEdits(h.URI.revive(Y),ee,ae,j,oe),void 0)}registerWorkspaceSymbolProvider(x,Y){const ee=this._addNewAdapter(new z(Y,this._logService),x);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(x,Y,ee){return this._withAdapter(x,z,ae=>ae.provideWorkspaceSymbols(Y,ee),{symbols:[]})}$resolveWorkspaceSymbol(x,Y,ee){return this._withAdapter(x,z,ae=>ae.resolveWorkspaceSymbol(Y,ee),void 0)}$releaseWorkspaceSymbols(x,Y){this._withAdapter(x,z,ee=>ee.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(x,Y,ee){const ae=this._addNewAdapter(new K(this._documents,ee,this._logService),x);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Y),K.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits(x,Y,ee,ae,j){return this._withAdapter(x,K,oe=>oe.provideRenameEdits(h.URI.revive(Y),ee,ae,j),void 0)}$resolveRenameLocation(x,Y,ee,ae){return this._withAdapter(x,K,j=>j.resolveRenameLocation(h.URI.revive(Y),ee,ae),void 0)}registerDocumentSemanticTokensProvider(x,Y,ee,ae){const j=this._nextHandle(),oe=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(j,new Qe(new Q(this._documents,ee),x)),this._proxy.$registerDocumentSemanticTokensProvider(j,this._transformDocumentSelector(Y),ae,oe);let fe=this._createDisposable(j);if(oe){const Ae=ee.onDidChangeSemanticTokens(xe=>this._proxy.$emitDocumentSemanticTokensEvent(oe));fe=T.Disposable.from(fe,Ae)}return fe}$provideDocumentSemanticTokens(x,Y,ee,ae){return this._withAdapter(x,Q,j=>j.provideDocumentSemanticTokens(h.URI.revive(Y),ee,ae),null,!0)}$releaseDocumentSemanticTokens(x,Y){this._withAdapter(x,Q,ee=>ee.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(x,Y,ee,ae){const j=this._addNewAdapter(new W(this._documents,ee),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(j,this._transformDocumentSelector(Y),ae),this._createDisposable(j)}$provideDocumentRangeSemanticTokens(x,Y,ee,ae){return this._withAdapter(x,W,j=>j.provideDocumentRangeSemanticTokens(h.URI.revive(Y),ee,ae),null,!0)}registerCompletionItemProvider(x,Y,ee,ae){const j=this._addNewAdapter(new U(this._documents,this._commands.converter,ee,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(j,this._transformDocumentSelector(Y),ae,U.supportsResolving(ee),`${x.identifier.value}(${ae.join("")})`),this._createDisposable(j)}$provideCompletionItems(x,Y,ee,ae,j){return this._withAdapter(x,U,oe=>oe.provideCompletionItems(h.URI.revive(Y),ee,ae,j),void 0)}$resolveCompletionItem(x,Y,ee){return this._withAdapter(x,U,ae=>ae.resolveCompletionItem(Y,ee),void 0)}$releaseCompletionItems(x,Y){this._withAdapter(x,U,ee=>ee.releaseCompletionItems(Y),void 0)}registerInlineCompletionsProvider(x,Y,ee){const ae=this._addNewAdapter(new H(this._documents,ee,this._commands.converter),x);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideInlineCompletions(x,Y,ee,ae,j){return this._withAdapter(x,H,oe=>oe.provideInlineCompletions(h.URI.revive(Y),ee,ae,j),void 0)}$handleInlineCompletionDidShow(x,Y,ee){this._withAdapter(x,H,async ae=>{ae.handleDidShowCompletionItem(Y,ee)},void 0)}$freeInlineCompletionsList(x,Y){this._withAdapter(x,H,async ee=>{ee.disposeCompletions(Y)},void 0)}registerSignatureHelpProvider(x,Y,ee,ae){const j=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,oe=this._addNewAdapter(new ue(this._documents,ee),x);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(Y),j),this._createDisposable(oe)}$provideSignatureHelp(x,Y,ee,ae,j){return this._withAdapter(x,ue,oe=>oe.provideSignatureHelp(h.URI.revive(Y),ee,ae,j),void 0)}$releaseSignatureHelp(x,Y){this._withAdapter(x,ue,ee=>ee.releaseSignatureHelp(Y),void 0)}registerInlayHintsProvider(x,Y,ee){const ae=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,j=this._addNewAdapter(new q(this._documents,ee),x);this._proxy.$registerInlayHintsProvider(j,this._transformDocumentSelector(Y),ae);let oe=this._createDisposable(j);if(ae!==void 0){const fe=ee.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(ae));oe=T.Disposable.from(oe,fe)}return oe}$provideInlayHints(x,Y,ee,ae){return this._withAdapter(x,q,j=>j.provideInlayHints(h.URI.revive(Y),ee,ae),void 0)}registerDocumentLinkProvider(x,Y,ee){const ae=this._addNewAdapter(new le(this._documents,ee),x);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Y),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(x,Y,ee){return this._withAdapter(x,le,ae=>ae.provideLinks(h.URI.revive(Y),ee),void 0)}$resolveDocumentLink(x,Y,ee){return this._withAdapter(x,le,ae=>ae.resolveLink(Y,ee),void 0)}$releaseDocumentLinks(x,Y){this._withAdapter(x,le,ee=>ee.releaseLinks(Y),void 0)}registerColorProvider(x,Y,ee){const ae=this._addNewAdapter(new se(this._documents,ee),x);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentColors(x,Y,ee){return this._withAdapter(x,se,ae=>ae.provideColors(h.URI.revive(Y),ee),[])}$provideColorPresentations(x,Y,ee,ae){return this._withAdapter(x,se,j=>j.provideColorPresentations(h.URI.revive(Y),ee,ae),void 0)}registerFoldingRangeProvider(x,Y,ee){const ae=this._nextHandle(),j=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new ve(this._documents,ee),x)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Y),j);let oe=this._createDisposable(ae);if(j!==void 0){const fe=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(j));oe=T.Disposable.from(oe,fe)}return oe}$provideFoldingRanges(x,Y,ee,ae){return this._withAdapter(x,ve,j=>j.provideFoldingRanges(h.URI.revive(Y),ee,ae),void 0)}registerSelectionRangeProvider(x,Y,ee){const ae=this._addNewAdapter(new Fe(this._documents,ee,this._logService),x);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideSelectionRanges(x,Y,ee,ae){return this._withAdapter(x,Fe,j=>j.provideSelectionRanges(h.URI.revive(Y),ee,ae),[])}registerCallHierarchyProvider(x,Y,ee){const ae=this._addNewAdapter(new Me(this._documents,ee),x);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$prepareCallHierarchy(x,Y,ee,ae){return this._withAdapter(x,Me,j=>Promise.resolve(j.prepareSession(h.URI.revive(Y),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls(x,Y,ee,ae){return this._withAdapter(x,Me,j=>j.provideCallsTo(Y,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls(x,Y,ee,ae){return this._withAdapter(x,Me,j=>j.provideCallsFrom(Y,ee,ae),void 0)}$releaseCallHierarchy(x,Y){this._withAdapter(x,Me,ee=>Promise.resolve(ee.releaseSession(Y)),void 0)}registerTypeHierarchyProvider(x,Y,ee){const ae=this._addNewAdapter(new Ne(this._documents,ee),x);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$prepareTypeHierarchy(x,Y,ee,ae){return this._withAdapter(x,Ne,j=>Promise.resolve(j.prepareSession(h.URI.revive(Y),ee,ae)),void 0)}$provideTypeHierarchySupertypes(x,Y,ee,ae){return this._withAdapter(x,Ne,j=>j.provideSupertypes(Y,ee,ae),void 0)}$provideTypeHierarchySubtypes(x,Y,ee,ae){return this._withAdapter(x,Ne,j=>j.provideSubtypes(Y,ee,ae),void 0)}$releaseTypeHierarchy(x,Y){this._withAdapter(x,Ne,ee=>Promise.resolve(ee.releaseSession(Y)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,C.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:ze._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?ze._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?ze._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:ze._serializeRegExp(x.beforeText),afterText:x.afterText?ze._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?ze._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(ze._serializeOnEnterRule)}setLanguageConfiguration(x,Y,ee){let{wordPattern:ae}=ee;if(ae&&(0,C.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Y,ae):this._documents.setWordDefinitionFor(Y,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const j=this._nextHandle(),oe={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?ze._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?ze._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?ze._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(j,Y,oe),this._createDisposable(j)}$setWordDefinitions(x){for(const Y of x)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(be[195],Ee([0,1,5,8,7,35,14,6]),function(ie,e,h,M,b,T,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(t,E,n){this._documents=E,this._commands=n,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(h.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,E){await this._proxy.$changeLanguage(t,E);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,E){const n=t.version,f=M.Position.from(E),l=await this._proxy.$tokensAtPosition(t.uri,f),s={type:b.StandardTokenType.Other,range:t.getWordRangeAtPosition(E)??new b.Range(E.line,E.character,E.line,E.character)};if(!l)return s;const v={range:M.Range.to(l.range),type:M.TokenType.to(l.type)};return!v.range.contains(E)||n!==t.version?s:v}createLanguageStatusItem(t,E,n){const f=this._handlePool++,l=this._proxy,s=this._ids,v=`${t.identifier.value}/${E}`;if(s.has(v))throw new Error(`LanguageStatusItem with id '${E}' ALREADY exists`);s.add(v);const I={selector:n,id:E,name:t.displayName??t.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let y,a=new C.DisposableStore;const m=()=>{y?.dispose(),y=(0,F.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(f,{id:v,name:I.name??t.displayName??t.name,source:t.displayName??t.name,selector:I.selector,label:I.text,detail:I.detail??"",severity:I.severity===b.LanguageStatusSeverity.Error?T.default.Error:I.severity===b.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:I.command&&this._commands.toInternal(I.command,a),accessibilityInfo:I.accessibilityInformation})},0)},k={dispose(){a.dispose(),y?.dispose(),l.$removeLanguageStatus(f),s.delete(v)},get id(){return I.id},get name(){return I.name},set name(i){I.name=i,m()},get selector(){return I.selector},set selector(i){I.selector=i,m()},get text(){return I.text},set text(i){I.text=i,m()},get detail(){return I.detail},set detail(i){I.detail=i,m()},get severity(){return I.severity},set severity(i){I.severity=i,m()},get accessibilityInformation(){return I.accessibilityInformation},set accessibilityInformation(i){I.accessibilityInformation=i,m()},get command(){return I.command},set command(i){I.command=i,m()}};return m(),k}}e.ExtHostLanguages=_}),define(be[196],Ee([0,1,5,15,30]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(C){return C&&C.title}let F=class{constructor(_,P){this._logService=P,this._proxy=_.getProxy(h.MainContext.MainThreadMessageService)}showMessage(_,P,t,E,n){const f={extension:_};let l;typeof E=="string"||T(E)?l=[E,...n]:(f.modal=E?.modal,f.useCustom=E?.useCustom,f.detail=E?.detail,l=n),f.useCustom&&(0,b.checkProposedApiEnabled)(_);const s=[];for(let v=0;v<l.length;v++){const I=l[v];if(typeof I=="string")s.push({title:I,handle:v,isCloseAffordance:!1});else if(typeof I=="object"){let{title:y,isCloseAffordance:a}=I;s.push({title:y,isCloseAffordance:!!a,handle:v})}else this._logService.warn("Invalid message item:",I)}return this._proxy.$showMessage(P,t,f,s).then(v=>{if(typeof v=="number")return l[v]})}};F=Ue([He(1,M.ILogService)],F),e.ExtHostMessageService=F}),define(be[197],Ee([0,1,23,3,58,6,20,9,10,2,63,5,8,7,47,172,93]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l,s,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class I{constructor(a,m,k,i,u){this._textDocumentsAndEditors=k,this._textDocuments=i,this._extensionStoragePaths=u,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(E.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(E.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(E.MainContext.MainThreadNotebookEditors),this._commandsConverter=m.converter,m.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const o=r.notebookEditor?.notebookUri,w=r.cell.handle,g=this._documents.get(o)?.getCell(w);if(g)return g.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const m=this._editors.get(a);if(!m)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return m}getIdByEditor(a){for(const[m,k]of this._editors)if(k.apiEditor===a)return m}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,m){const k=this._documents.get(a);if(!k&&!m)throw new Error(`NO notebook document for '${a}'`);return k}_getProviderData(a){const m=this._notebookContentProviders.get(a);if(!m)throw new Error(`NO provider for '${a}'`);return m}registerNotebookContentProvider(a,m,k,i,u){if((0,C.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(m))throw new Error(`Notebook provider for '${m}' already registered`);this._notebookContentProviders.set(m,{extension:a,provider:k});let r;return k.onDidChangeNotebookContentOptions&&(r=k.onDidChangeNotebookContentOptions(()=>{const o=n.NotebookDocumentContentOptions.from(k.options);this._notebookProxy.$updateNotebookProviderOptions(m,o)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},m,n.NotebookDocumentContentOptions.from(i),I._convertNotebookRegistrationData(a,u)),new f.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(m),this._notebookProxy.$unregisterNotebookProvider(m)})}static _convertNotebookRegistrationData(a,m){if(!m)return;const k=m.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(m.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${m.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:m.displayName,filenamePattern:k,exclusive:m.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,m,k){const i=I._notebookStatusBarItemProviderHandlePool++,u=typeof k.onDidChangeCellStatusBarItems=="function"?I._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,k),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,u,m);let r;return u!==void 0&&(r=k.onDidChangeCellStatusBarItems(o=>this._notebookProxy.$emitCellStatusBarEvent(u))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,u),r&&r.dispose()})}async createNotebookDocument(a){const m=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&n.NotebookData.from(a.content)});return P.URI.revive(m)}async openNotebookDocument(a){const m=this._documents.get(a);if(m)return m.apiNotebook;const k=await this._notebookDocumentsProxy.$tryOpenNotebook(a),i=this._documents.get(P.URI.revive(k));return(0,_.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(a,m){P.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let k;typeof m=="object"?k={position:n.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selections:m.selections&&m.selections.map(n.NotebookRange.from),pinned:typeof m.preview=="boolean"?!m.preview:void 0}:k={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,k),u=i&&this._editors.get(i)?.apiEditor;if(u)return u;throw i?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,m,k,i){const u=this._notebookStatusBarItemProviders.get(a),r=P.URI.revive(m),o=this._documents.get(r);if(!o||!u)return;const w=o.getCellFromIndex(k);if(!w)return;const d=await u.provideCellStatusBarItems(w.apiCell,i);if(!d)return;const g=new T.DisposableStore,S=this._statusBarCache.add([g]),p=(Array.isArray(d)?d:[d]).map(D=>n.NotebookStatusBarItem.from(D,this._commandsConverter,g));return{cacheId:S,items:p}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,m,k,i,u){if((0,C.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,k),this._notebookProxy.$registerNotebookSerializer(r,{id:a.identifier,location:a.extensionLocation},m,n.NotebookDocumentContentOptions.from(i),I._convertNotebookRegistrationData(a,u)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(a,m,k){const i=this._notebookSerializer.get(a);if(!i)throw new Error("NO serializer found");const u=await i.deserializeNotebook(m.buffer,k);return new l.SerializableObjectWithBuffers(n.NotebookData.from(u))}async $notebookToData(a,m,k){const i=this._notebookSerializer.get(a);if(!i)throw new Error("NO serializer found");const u=await i.serializeNotebook(n.NotebookData.to(m.value),k);return h.VSBuffer.wrap(u)}async $openNotebook(a,m,k,i,u){const{provider:r}=this._getProviderData(a),o=await r.openNotebook(P.URI.revive(m),{backupId:k,untitledDocumentData:i?.buffer},u);return new l.SerializableObjectWithBuffers({metadata:o.metadata??Object.create(null),cells:o.cells.map(n.NotebookCellData.from)})}async $saveNotebook(a,m,k){const i=this.getNotebookDocument(P.URI.revive(m)),{provider:u}=this._getProviderData(a);return await u.saveNotebook(i.apiNotebook,k),!0}async $saveNotebookAs(a,m,k,i){const u=this.getNotebookDocument(P.URI.revive(m)),{provider:r}=this._getProviderData(a);return await r.saveNotebookAs(P.URI.revive(k),u.apiNotebook,i),!0}async $backupNotebook(a,m,k){const i=this.getNotebookDocument(P.URI.revive(m)),u=this._getProviderData(a),r=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension),o=String((0,b.hash)([i.uri.toString(),this._backupIdPool++])),w=P.URI.joinPath(r,o),d=await u.provider.backupNotebook(i.apiNotebook,{destination:w},k);return i.updateBackup(d),d.id}_createExtHostEditor(a,m,k){if(this._editors.has(m))throw new Error(`editor with id ALREADY EXSIST: ${m}`);const i=new v.ExtHostNotebookEditor(m,this._notebookEditorsProxy,a,k.visibleRanges.map(n.NotebookRange.to),k.selections.map(n.NotebookRange.to),typeof k.viewColumn=="number"?n.ViewColumn.to(k.viewColumn):void 0);this._editors.set(m,i)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const k of a.value.removedDocuments){const i=P.URI.revive(k),u=this._documents.get(i);u&&(u.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:u.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(u.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===i.toString()&&this._editors.delete(r.id)}if(a.value.addedDocuments){const k=[];for(const i of a.value.addedDocuments){const u=P.URI.revive(i.uri);if(this._documents.has(u))throw new Error(`adding EXISTING notebook ${u} `);const r=this,o=new s.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(w){r._onDidChangeNotebookCells.fire(w)},emitCellOutputsChange(w){r._onDidChangeCellOutputs.fire(w)},emitCellMetadataChange(w){r._onDidChangeCellMetadata.fire(w)},emitCellExecutionStateChange(w){r._onDidChangeCellExecutionState.fire(w)}},u,i);k.push(...i.cells.map(w=>s.ExtHostCell.asModelAddData(o.apiNotebook,w))),this._documents.get(u)?.dispose(),this._documents.set(u,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(a.value.addedEditors)for(const k of a.value.addedEditors){if(this._editors.has(k.id))return;const i=P.URI.revive(k.documentUri),u=this._documents.get(i);u&&this._createExtHostEditor(u,k.id,k)}const m=[];if(a.value.removedEditors)for(const k of a.value.removedEditors){const i=this._editors.get(k);i&&(this._editors.delete(k),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),m.push(i))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const k=new Set;this._visibleNotebookEditors.forEach(i=>k.add(i.id));for(const i of this._editors.values()){const u=k.has(i.id);i._acceptVisibility(u)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=I,I._notebookStatusBarItemProviderHandlePool=0}),define(be[198],Ee([0,1,3,53,15,5,12,8]),function(ie,e,h,M,b,T,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(E,n){const f=_._Keys.nextId();E.$registerNotebookEditorDecorationType(f,C.NotebookDecorationRenderOptions.from(n)),this.value={key:f,dispose(){E.$removeNotebookEditorDecorationType(f)}}}}_._Keys=new M.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(E,n,f){this._logService=E,this._extHostRpc=n,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new h.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new h.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(E){return new _(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),E).value}$acceptEditorPropertiesChanged(E,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,n);const f=this._notebooksAndEditors.getEditorById(E);n.visibleRanges&&f._acceptVisibleRanges(n.visibleRanges.ranges.map(C.NotebookRange.to)),n.selections&&f._acceptSelections(n.selections.selections.map(C.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const n in E)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(C.ViewColumn.to(E[n]))}};P=Ue([He(0,b.ILogService),He(1,F.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(be[199],Ee([0,1,13,14,21,3,6,20,2,25,15,5,8,7,66,165,30,47]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l,s,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let y=class{constructor(u,r,o,w){this._initData=r,this._extHostNotebook=o,this._logService=w,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=u.getProxy(E.MainContext.MainThreadNotebookKernels)}createNotebookController(u,r,o,w,d,g){for(let G of this._kernelData.values())if(G.controller.id===r&&P.ExtensionIdentifier.equals(u.identifier,G.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const S=this._handlePool++,R=this;this._logService.trace(`NotebookController[${S}], CREATED by ${u.identifier.value}, ${r}`);const p=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${u.identifier}'`);let D=!1;const c=new F.DisposableStore,A=new T.Emitter,O=new T.Emitter,z={id:`${u.identifier.value}/${r}`,notebookType:o,extensionId:u.identifier,extensionLocation:u.extensionLocation,label:w||u.identifier.value,preloads:g?g.map(n.NotebookRendererScript.from):[]};let K=d??p,$;this._proxy.$addKernel(S,z).catch(G=>{console.log(G),D=!0});let Q=0;const W=()=>{if(D)return;const G=++Q;Promise.resolve().then(()=>{G===Q&&this._proxy.$updateKernel(S,z)})},U=new C.ResourceMap,H={get id(){return r},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return z.label},set label(G){z.label=G??u.displayName??u.name,W()},get detail(){return z.detail??""},set detail(G){z.detail=G,W()},get description(){return z.description??""},set description(G){z.description=G,W()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(G){z.supportedLanguages=G,W()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(G){z.supportsExecutionOrder=G,W()},get rendererScripts(){return z.preloads?z.preloads.map(n.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(G){K=G??p},get interruptHandler(){return $},set interruptHandler(G){$=G,z.supportsInterrupt=Boolean(G),W()},createNotebookCellExecution(G){if(D)throw new Error("notebook controller is DISPOSED");if(!U.has(G.notebook.uri))throw R._logService.trace(`NotebookController[${S}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(U.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${G.notebook.uri.toString()}`);return R._createNotebookCellExecution(G)},dispose:()=>{D||(this._logService.trace(`NotebookController[${S}], DISPOSED`),D=!0,this._kernelData.delete(S),c.dispose(),A.dispose(),O.dispose(),this._proxy.$removeKernel(S))},updateNotebookAffinity(G,ue){R._proxy.$updateNotebookPriority(S,G.uri,ue)},onDidReceiveMessage:O.event,postMessage(G,ue){return(0,v.checkProposedApiEnabled)(u),R._proxy.$postMessage(S,ue&&R._extHostNotebook.getIdByEditor(ue),G)},asWebviewUri(G){return(0,v.checkProposedApiEnabled)(u),(0,l.asWebviewUri)(G,R._initData.remote)}};return this._kernelData.set(S,{extensionId:u.identifier,controller:H,onDidReceiveMessage:O,onDidChangeSelection:A,associatedNotebooks:U}),H}$acceptNotebookAssociation(u,r,o){const w=this._kernelData.get(u);if(w){const d=this._extHostNotebook.getNotebookDocument(_.URI.revive(r));o?w.associatedNotebooks.set(d.uri,!0):w.associatedNotebooks.delete(d.uri),this._logService.trace(`NotebookController[${u}] ASSOCIATE notebook`,d.uri.toString(),o),w.onDidChangeSelection.fire({selected:o,notebook:d.apiNotebook})}}async $executeCells(u,r,o){const w=this._kernelData.get(u);if(!w)return;const d=this._extHostNotebook.getNotebookDocument(_.URI.revive(r)),g=[];for(let S of o){const R=d.getCell(S);R&&g.push(R.apiCell)}try{this._logService.trace(`NotebookController[${u}] EXECUTE cells`,d.uri.toString(),g.length),await w.controller.executeHandler.call(w.controller,g,d.apiNotebook,w.controller)}catch(S){this._logService.error(`NotebookController[${u}] execute cells FAILED`,S),console.error(S)}}async $cancelCells(u,r,o){const w=this._kernelData.get(u);if(!w)return;const d=this._extHostNotebook.getNotebookDocument(_.URI.revive(r));if(w.controller.interruptHandler)await w.controller.interruptHandler.call(w.controller,d.apiNotebook);else for(let g of o){const S=d.getCell(g);S&&this._activeExecutions.get(S.uri)?.cancel()}}$acceptKernelMessageFromRenderer(u,r,o){const w=this._kernelData.get(u);if(!w)return;const d=this._extHostNotebook.getEditorById(r);w.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:o}))}_createNotebookCellExecution(u){if(u.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(u.notebook.uri).getCellFromApiCell(u);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const w=new m(o.notebook,o,this._proxy);this._activeExecutions.set(o.uri,w);const d=w.onDidChangeState(()=>{w.state===a.Resolved&&(w.dispose(),d.dispose(),this._activeExecutions.delete(o.uri))});return w.asApiObject()}};y=Ue([He(3,t.ILogService)],y),e.ExtHostNotebookKernels=y;var a;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(a||(a={}));class m extends F.Disposable{constructor(u,r,o){super();this._document=u,this._cell=r,this._proxy=o,this._handle=m.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new k(10,w=>this.update(w)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(u){await this._collector.addItem(u)}async update(u){const r=Array.isArray(u)?u:[u];return this._proxy.$updateExecutions(new I.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(u){let r=this._cell;if(u&&(r=this._document.getCellFromApiCell(u)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(u){return u.map(r=>{const o=f.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return o===r.items?n.NotebookCellOutput.from(r):n.NotebookCellOutput.from({items:o,id:r.id,metadata:r.metadata})})}async updateOutputs(u,r,o){const w=this.cellIndexToHandle(r),d=this.validateAndConvertOutputs((0,h.asArray)(u));return this.updateSoon({editType:s.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:w,append:o,outputs:d})}async updateOutputItems(u,r,o){return u=f.NotebookCellOutput.ensureUniqueMimeTypes((0,h.asArray)(u),!0),this.updateSoon({editType:s.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:u.map(n.NotebookCellOutputItem.from),outputId:r.id,append:o})}asApiObject(){const u=this;return Object.freeze({get token(){return u._tokenSource.token},get cell(){return u._cell.apiCell},get executionOrder(){return u._executionOrder},set executionOrder(o){u._executionOrder=o,u.update([{editType:s.CellExecutionUpdateType.ExecutionState,executionHandle:u._handle,executionOrder:u._executionOrder}])},start(o){if(u._state===a.Resolved||u._state===a.Started)throw new Error("Cannot call start again");u._state=a.Started,u._onDidChangeState.fire(),u.update({editType:s.CellExecutionUpdateType.ExecutionState,executionHandle:u._handle,runStartTime:o})},end(o,w){if(u._state===a.Resolved)throw new Error("Cannot call resolve twice");u._state=a.Resolved,u._onDidChangeState.fire(),u.updateSoon({editType:s.CellExecutionUpdateType.Complete,executionHandle:u._handle,runEndTime:w,lastRunSuccess:o}),u._collector.flush(),u._proxy.$removeExecution(u._handle)},clearOutput(o){return u.verifyStateForOutput(),u.updateOutputs([],o,!1)},appendOutput(o,w){return u.verifyStateForOutput(),u.updateOutputs(o,w,!0)},replaceOutput(o,w){return u.verifyStateForOutput(),u.updateOutputs(o,w,!1)},appendOutputItems(o,w){return u.verifyStateForOutput(),u.updateOutputItems(o,w,!0)},replaceOutputItems(o,w){return u.verifyStateForOutput(),u.updateOutputItems(o,w,!1)}})}}m.HANDLE=0;class k{constructor(u,r){this.delay=u,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(u){return this.batch.push(u),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const u=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>u.complete())}}}),define(be[200],Ee([0,1,3,5,93]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(C,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,_,P){const t=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(_)?.fire({editor:t.apiEditor,message:P})}createRendererMessaging(C,_){if(!C.contributes?.notebookRenderer?.some(n=>n.id===_))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${_})`);const P=!!C.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,f,l)=>{const s=P?n:v=>{const I={};t.set(I,v.editor),n({editor:I,message:v.message})};return this.getOrCreateEmitterFor(_).event(s,f,l)},postMessage:(n,f)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,f]=[f,n]);const l=P?f:t.get(f),s=l&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(l);return this.proxy.$postMessage(s?.id,_,n)}}}getOrCreateEmitterFor(C){let _=this._rendererMessageEmitters.get(C);return _||(_=new h.Emitter({onLastListenerRemove:()=>{_?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,_),_)}}e.ExtHostNotebookRenderers=T}),define(be[96],Ee([0,1,5,3,6,23,4,12]),function(ie,e,h,M,b,T,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends b.Disposable{constructor(l,s,v,I,y){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=l,this._proxy=y,this._id=y.$register(this.name,s,v,I),this._disposed=!1,this._offset=0}get name(){return this._name}append(l){this.validate(),this._offset+=l?T.VSBuffer.fromString(l).byteLength:0}update(){this._id.then(l=>this._proxy.$update(l))}appendLine(l){this.validate(),this.append(l+`
`)}clear(){this.validate();const l=this._offset;this._id.then(s=>this._proxy.$clear(s,l))}show(l,s){this.validate(),this._id.then(v=>this._proxy.$reveal(v,!!(typeof l=="boolean"?l:s)))}hide(){this.validate(),this._id.then(l=>this._proxy.$close(l))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(l=>this._proxy.$dispose(l)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class P extends _{constructor(l,s,v){super(l,!1,void 0,s,v)}append(l){super.append(l),this._id.then(s=>this._proxy.$append(s,l)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class t extends _{constructor(l,s,v){super(l,!0,s,void 0,v)}append(l){throw new Error("Not supported")}}class E{constructor(l,s){this.name=l,this._channel=s}append(l){this._channel.then(s=>s.append(l))}appendLine(l){this._channel.then(s=>s.appendLine(l))}clear(){this._channel.then(l=>l.clear())}show(l,s){this._channel.then(v=>v.show(l,s))}hide(){this._channel.then(l=>l.hide())}dispose(){this._channel.then(l=>l.dispose())}}e.LazyOutputChannel=E;let n=class{constructor(l){this._proxy=l.getProxy(h.MainContext.MainThreadOutputService)}$setVisibleChannel(l){}createOutputChannel(l,s){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");return new P(l,s.identifier.value,this._proxy)}createOutputChannelFromLogFile(l,s){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");if(!s)throw new Error("illegal argument `file`. must not be falsy");return new t(l,s,this._proxy)}};n=Ue([He(0,C.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(be[201],Ee([0,1,14,21,3,6,5,2,7,16,13,35,44]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(l,s,v){const I=l.getProxy(F.MainContext.MainThreadQuickOpen);class y{constructor(d,g){this._sessions=new Map,this._instances=0,this._workspace=d,this._commands=g}showQuickPick(d,g,S,R=M.CancellationToken.None){this._onDidSelectItem=void 0;const p=Promise.resolve(d),D=++this._instances,c=I.$show(D,{title:S?.title,placeHolder:S?.placeHolder,matchOnDescription:S?.matchOnDescription,matchOnDetail:S?.matchOnDetail,ignoreFocusLost:S?.ignoreFocusOut,canPickMany:S?.canPickMany},R),A={},O=c.then(()=>A);return Promise.race([O,p]).then(z=>{if(z!==A)return p.then(K=>{const $=[];for(let Q=0;Q<K.length;Q++){const W=K[Q];let U,H,G,ue,q;typeof W=="string"?U=W:(U=W.label,H=W.description,G=W.detail,ue=W.picked,q=W.alwaysShow),$.push({label:U,description:H,handle:Q,detail:G,picked:ue,alwaysShow:q})}return S&&typeof S.onDidSelectItem=="function"&&(this._onDidSelectItem=Q=>{S.onDidSelectItem(K[Q])}),I.$setItems(D,$),c.then(Q=>{if(typeof Q=="number")return K[Q];if(Array.isArray(Q))return Q.map(W=>K[W])})})}).then(void 0,z=>{if(!(0,P.isPromiseCanceledError)(z))return I.$setError(D,z),Promise.reject(z)})}$onItemSelected(d){this._onDidSelectItem&&this._onDidSelectItem(d)}showInput(d,g=M.CancellationToken.None){return this._validateInput=d?d.validateInput:void 0,I.$input(d,typeof this._validateInput=="function",g).then(void 0,S=>{if(!(0,P.isPromiseCanceledError)(S))return Promise.reject(S)})}$validateInput(d){return this._validateInput?(0,h.asPromise)(()=>this._validateInput(d)):Promise.resolve(void 0)}async showWorkspaceFolderPick(d,g=M.CancellationToken.None){const S=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[d]);if(!S)return;const R=await this._workspace.getWorkspaceFolders2();if(!!R)return R.find(p=>p.uri.toString()===S.uri.toString())}createQuickPick(d,g){const S=new r(d,g,()=>this._sessions.delete(S._id));return this._sessions.set(S._id,S),S}createInputBox(d){const g=new o(d,()=>this._sessions.delete(g._id));return this._sessions.set(g._id,g),g}$onDidChangeValue(d,g){const S=this._sessions.get(d);S&&S._fireDidChangeValue(g)}$onDidAccept(d){const g=this._sessions.get(d);g&&g._fireDidAccept()}$onDidChangeActive(d,g){const S=this._sessions.get(d);S instanceof r&&S._fireDidChangeActive(g)}$onDidChangeSelection(d,g){const S=this._sessions.get(d);S instanceof r&&S._fireDidChangeSelection(g)}$onDidTriggerButton(d,g){const S=this._sessions.get(d);S&&S._fireDidTriggerButton(g)}$onDidTriggerItemButton(d,g,S){const R=this._sessions.get(d);R instanceof r&&R._fireDidTriggerItemButton(g,S)}$onDidHide(d){const g=this._sessions.get(d);g&&g._fireDidHide()}}class a{constructor(d,g){this._extensionId=d,this._onDidDispose=g,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new b.Emitter,this._onDidChangeValueEmitter=new b.Emitter,this._onDidTriggerButtonEmitter=new b.Emitter,this._onDidHideEmitter=new b.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(d){this._title=d,this.update({title:d})}get step(){return this._steps}set step(d){this._steps=d,this.update({step:d})}get totalSteps(){return this._totalSteps}set totalSteps(d){this._totalSteps=d,this.update({totalSteps:d})}get enabled(){return this._enabled}set enabled(d){this._enabled=d,this.update({enabled:d})}get busy(){return this._busy}set busy(d){this._busy=d,this.update({busy:d})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(d){this._ignoreFocusOut=d,this.update({ignoreFocusOut:d})}get value(){return this._value}set value(d){this._value=d,this.update({value:d})}get placeholder(){return this._placeholder}set placeholder(d){this._placeholder=d,this.update({placeholder:d})}get buttons(){return this._buttons}set buttons(d){this._buttons=d.slice(),this._handlesToButtons.clear(),d.forEach((g,S)=>{const R=g===_.QuickInputButtons.Back?-1:S;this._handlesToButtons.set(R,g)}),this.update({buttons:d.map((g,S)=>({...u(g),tooltip:g.tooltip,handle:g===_.QuickInputButtons.Back?-1:S}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(d){this._value=d,this._onDidChangeValueEmitter.fire(d)}_fireDidTriggerButton(d){const g=this._handlesToButtons.get(d);g&&this._onDidTriggerButtonEmitter.fire(g)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),I.$dispose(this._id))}update(d){if(!this._disposed){for(const g of Object.keys(d)){const S=d[g];this._pendingUpdate[g]=S===void 0?null:S}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){I.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}a._nextId=1;function m(w){if(w instanceof _.ThemeIcon)return{id:w.id};const d=i(w),g=k(w);return{dark:typeof d=="string"?C.URI.file(d):d,light:typeof g=="string"?C.URI.file(g):g}}function k(w){return typeof w=="object"&&"light"in w?w.light:w}function i(w){return typeof w=="object"&&"dark"in w?w.dark:w}function u(w){const d=m(w.iconPath);let g,S;return"id"in d?S=n.ThemeIcon.asClassName(d):g=d,{iconPath:g,iconClass:S}}class r extends a{constructor(d,g,S){super(d,S);this.enableProposedApi=g,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new b.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new b.Emitter,this._onDidTriggerItemButtonEmitter=new b.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(d){this._items=d.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),d.forEach((g,S)=>{this._handlesToItems.set(S,g),this._itemsToHandles.set(g,S)}),this.update({items:d.map((g,S)=>({label:g.label,description:g.description,handle:S,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,buttons:g.buttons&&this.enableProposedApi?g.buttons.map((R,p)=>({...u(R),tooltip:R.tooltip,handle:p})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(d){this._canSelectMany=d,this.update({canSelectMany:d})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(d){this._matchOnDescription=d,this.update({matchOnDescription:d})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(d){this._matchOnDetail=d,this.update({matchOnDetail:d})}get sortByLabel(){return this._sortByLabel}set sortByLabel(d){this._sortByLabel=d,this.update({sortByLabel:d})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(d){this._keepScrollPosition=d,this.update({keepScrollPosition:d})}get activeItems(){return this._activeItems}set activeItems(d){this._activeItems=d.filter(g=>this._itemsToHandles.has(g)),this.update({activeItems:this._activeItems.map(g=>this._itemsToHandles.get(g))})}get selectedItems(){return this._selectedItems}set selectedItems(d){this._selectedItems=d.filter(g=>this._itemsToHandles.has(g)),this.update({selectedItems:this._selectedItems.map(g=>this._itemsToHandles.get(g))})}_fireDidChangeActive(d){const g=(0,t.coalesce)(d.map(S=>this._handlesToItems.get(S)));this._activeItems=g,this._onDidChangeActiveEmitter.fire(g)}_fireDidChangeSelection(d){const g=(0,t.coalesce)(d.map(S=>this._handlesToItems.get(S)));this._selectedItems=g,this._onDidChangeSelectionEmitter.fire(g)}_fireDidTriggerItemButton(d,g){const S=this._handlesToItems.get(d);if(!S||!S.buttons||!S.buttons.length)return;const R=S.buttons[g];R&&this._onDidTriggerItemButtonEmitter.fire({button:R,item:S})}}class o extends a{constructor(d,g){super(d,g);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(d){this._password=d,this.update({password:d})}get prompt(){return this._prompt}set prompt(d){this._prompt=d,this.update({prompt:d})}get validationMessage(){return this._validationMessage}set validationMessage(d){this._validationMessage=d,this.update({validationMessage:d,severity:d?E.default.Error:E.default.Ignore})}}return new y(s,v)}e.createExtHostQuickOpen=f}),define(be[202],Ee([0,1,2,3,52,6,14,5,13,108,15,25,30,44,8]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function s(d){if(d)return typeof d.iconPath=="string"?h.URI.file(d.iconPath):h.URI.isUri(d.iconPath)||f.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function v(d,g){if(!d.iconPath&&!g.iconPath)return 0;if(d.iconPath){if(!g.iconPath)return 1}else return-1;const S=typeof d.iconPath=="string"?d.iconPath:h.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,R=typeof g.iconPath=="string"?g.iconPath:h.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,P.comparePaths)(S,R)}function I(d,g){let S=0;if(d.strikeThrough!==g.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==g.faded)return d.faded?1:-1;if(d.tooltip!==g.tooltip)return(d.tooltip||"").localeCompare(g.tooltip||"");if(S=v(d,g),S!==0)return S;if(d.light&&g.light)S=v(d.light,g.light);else{if(d.light)return 1;if(g.light)return-1}if(S!==0)return S;if(d.dark&&g.dark)S=v(d.dark,g.dark);else{if(d.dark)return 1;if(g.dark)return-1}return S}function y(d,g){if(d.command!==g.command)return d.command<g.command?-1:1;if(d.title!==g.title)return d.title<g.title?-1:1;if(d.tooltip!==g.tooltip){if(d.tooltip!==void 0&&g.tooltip!==void 0)return d.tooltip<g.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(d.arguments===g.arguments)return 0;if(d.arguments)if(g.arguments){if(d.arguments.length!==g.arguments.length)return d.arguments.length-g.arguments.length}else return 1;else return-1;for(let S=0;S<d.arguments.length;S++){const R=d.arguments[S],p=g.arguments[S];if(R!==p)return R<p?-1:1}return 0}function a(d,g){let S=(0,P.comparePaths)(d.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(S!==0)return S;if(d.command&&g.command)S=y(d.command,g.command);else{if(d.command)return 1;if(g.command)return-1}if(S!==0)return S;if(d.decorations&&g.decorations)S=I(d.decorations,g.decorations);else{if(d.decorations)return 1;if(g.decorations)return-1}return S}function m(d,g){for(let S=0;S<d.length;S++)if(d[S]!==g[S])return!1;return!0}function k(d,g){return d.command===g.command&&d.title===g.title&&d.tooltip===g.tooltip&&(d.arguments&&g.arguments?m(d.arguments,g.arguments):d.arguments===g.arguments)}function i(d,g){return(0,_.equals)(d,g,k)}class u{constructor(g,S,R){this._extension=g,this._proxy=S,this._sourceControlHandle=R,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(g){this._proxy.$setInputBoxValue(this._sourceControlHandle,g),this.updateValue(g)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(g){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,g),this._placeholder=g}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(g){if((0,n.checkProposedApiEnabled)(this._extension),g&&typeof g!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=g,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!g)}get visible(){return this._visible}set visible(g){g=!!g,this._visible!==g&&(this._visible=g,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,g))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(g,S){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,g,S)}$onInputBoxValueChange(g){this.updateValue(g)}updateValue(g){this._value=g,this._onDidChange.fire(g)}}e.ExtHostSCMInputBox=u;class r{constructor(g,S,R,p,D){this._proxy=g,this._commands=S,this._sourceControlHandle=R,this._id=p,this._label=D,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(g){this._label=g,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,g)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(g){this._hideWhenEmpty=g,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(g){this._resourceStates=[...g],this._onDidUpdateResourceStates.fire()}getResourceState(g){return this._resourceStatesMap.get(g)}$executeResourceCommand(g,S){const R=this._resourceStatesCommandsMap.get(g);return R?(0,F.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],S)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this._resourceStates].sort(a),R=(0,_.sortedDiff)(this._resourceSnapshot,g,a).map(c=>{const A=c.toInsert.map(O=>{const z=this._resourceHandlePool++;this._resourceStatesMap.set(z,O);const K=O.resourceUri;let $;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const ve=new T.DisposableStore;$=this._commands.converter.toInternal(O.command,ve),this._resourceStatesDisposablesMap.set(z,ve)}else this._resourceStatesCommandsMap.set(z,O.command);const Q=s(O.decorations),W=O.decorations&&s(O.decorations.light)||Q,U=O.decorations&&s(O.decorations.dark)||Q,H=[W,U],G=O.decorations&&O.decorations.tooltip||"",ue=O.decorations&&!!O.decorations.strikeThrough,q=O.decorations&&!!O.decorations.faded,le=O.contextValue||"";return{rawResource:[z,K,H,G,ue,q,le,$],handle:z}});return{start:c.start,deleteCount:c.deleteCount,toInsert:A}}),p=R.map(({start:c,deleteCount:A,toInsert:O})=>[c,A,O.map(z=>z.rawResource)]),D=R.reverse();for(const{start:c,deleteCount:A,toInsert:O}of D){const z=O.map($=>$.handle),K=this._handlesSnapshot.splice(c,A,...z);for(const $ of K)this._resourceStatesMap.delete($),this._resourceStatesCommandsMap.delete($),this._resourceStatesDisposablesMap.get($)?.dispose(),this._resourceStatesDisposablesMap.delete($)}return this._resourceSnapshot=g,p}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class o{constructor(g,S,R,p,D,c){this._proxy=S,this._commands=R,this._id=p,this._label=D,this._rootUri=c,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=o._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new u(g,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,p,D,c)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(g){this._count!==g&&(this._count=g,this._proxy.$updateSourceControl(this.handle,{count:g}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(g){this._quickDiffProvider=g,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this._commitTemplate}set commitTemplate(g){g!==this._commitTemplate&&(this._commitTemplate=g,this._proxy.$updateSourceControl(this.handle,{commitTemplate:g}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(g){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=g;const S=this._commands.converter.toInternal(g,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:S})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(g){if(this._statusBarCommands&&g&&i(this._statusBarCommands,g))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=g;const S=(g||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:S})}get selected(){return this._selected}createResourceGroup(g,S){const R=new r(this._proxy,this._commands,this.handle,g,S),p=M.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,p),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const g=[],S=[];for(const[R,p]of this.createdResourceGroups){p.dispose();const D=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});M.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),D.dispose(),this._groups.delete(R.handle),this._proxy.$unregisterGroup(this.handle,R.handle)}),g.push([R.handle,R.id,R.label,R.features]);const c=R._takeResourceStateSnapshot();c.length>0&&S.push([R.handle,c]),this._groups.set(R.handle,R)}this._proxy.$registerGroups(this.handle,g,S),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const g=[];this.updatedResourceGroups.forEach(S=>{const R=S._takeResourceStateSnapshot();R.length!==0&&g.push([S.handle,R])}),g.length>0&&this._proxy.$spliceResourceStates(this.handle,g),this.updatedResourceGroups.clear()}getResourceGroup(g){return this._groups.get(g)}setSelectionState(g){this._selected=g,this._onDidChangeSelection.fire(g)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(g=>g.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}o._handlePool=0,Ue([(0,b.debounce)(100)],o.prototype,"eventuallyAddResourceGroups",null),Ue([(0,b.debounce)(100)],o.prototype,"eventuallyUpdateResourceStates",null);let w=class Bi{constructor(g,S,R){this._commands=S,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=g.getProxy(C.MainContext.MainThreadSCM),this._telemetry=g.getProxy(C.MainContext.MainThreadTelemetry),S.registerArgumentProcessor({processArgument:p=>{if(p&&p.$mid===3){const D=this._sourceControls.get(p.sourceControlHandle);if(!D)return p;const c=D.getResourceGroup(p.groupHandle);return c?c.getResourceState(p.handle):p}else if(p&&p.$mid===4){const D=this._sourceControls.get(p.sourceControlHandle);return D?D.getResourceGroup(p.groupHandle):p}else if(p&&p.$mid===5){const D=this._sourceControls.get(p.handle);return D||p}return p}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(g,S,R,p){this.logService.trace("ExtHostSCM#createSourceControl",g.identifier.value,S,R,p),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const D=Bi._handlePool++,c=new o(g,this._proxy,this._commands,S,R,p);this._sourceControls.set(D,c);const A=this._sourceControlsByExtension.get(E.ExtensionIdentifier.toKey(g.identifier))||[];return A.push(c),this._sourceControlsByExtension.set(E.ExtensionIdentifier.toKey(g.identifier),A),c}getLastInputBox(g){this.logService.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const S=this._sourceControlsByExtension.get(E.ExtensionIdentifier.toKey(g.identifier)),R=S&&S[S.length-1];return R&&R.inputBox}$provideOriginalResource(g,S,R){const p=h.URI.revive(S);this.logService.trace("ExtHostSCM#$provideOriginalResource",g,p.toString());const D=this._sourceControls.get(g);return!D||!D.quickDiffProvider||!D.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.asPromise)(()=>D.quickDiffProvider.provideOriginalResource(p,R)).then(c=>c||null)}$onInputBoxValueChange(g,S){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",g);const R=this._sourceControls.get(g);return R&&R.inputBox.$onInputBoxValueChange(S),Promise.resolve(void 0)}$executeResourceCommand(g,S,R,p){this.logService.trace("ExtHostSCM#$executeResourceCommand",g,S,R);const D=this._sourceControls.get(g);if(!D)return Promise.resolve(void 0);const c=D.getResourceGroup(S);return c?c.$executeResourceCommand(R,p):Promise.resolve(void 0)}$validateInput(g,S,R){this.logService.trace("ExtHostSCM#$validateInput",g);const p=this._sourceControls.get(g);return!p||!p.inputBox.validateInput?Promise.resolve(void 0):(0,F.asPromise)(()=>p.inputBox.validateInput(S,R)).then(D=>{if(!D)return Promise.resolve(void 0);const c=l.MarkdownString.fromStrict(D.message);return c?Promise.resolve([c,D.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this._sourceControls.get(g)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=g,Promise.resolve(void 0)}};w._handlePool=0,w=Ue([He(2,t.ILogService)],w),e.ExtHostSCM=w});var Je=this&&this.__classPrivateFieldSet||function(ie,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ie,h):b?b.value=h:e.set(ie,h),h},Te=this&&this.__classPrivateFieldGet||function(ie,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[203],Ee([0,1,7,5,127,6,8]),function(ie,e,h,M,b,T,F){"use strict";var C,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class P{constructor(f,l,s,v,I=h.StatusBarAlignment.Left,y){C.set(this,void 0),_.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Je(this,C,f,"f"),Je(this,_,l,"f"),this._entryId=P.ID_GEN++,this._extension=s,this._id=v,this._alignment=I,this._priority=y}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!P.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Te(this,_,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Te(this,_,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Te(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let l;this._name?l=this._name:l=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let s=this._color;this._backgroundColor&&(s=P.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const v=this._tooltip?F.MarkdownString.fromStrict(this._tooltip):void 0;Te(this,C,"f").$setEntry(this._entryId,f,l,this._text,v,this._command?.internal,s,this._backgroundColor,this._alignment===h.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=P,C=new WeakMap,_=new WeakMap,P.ID_GEN=0,P.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new h.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new h.ThemeColor("statusBarItem.warningForeground")]]);class t{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",h.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const l={message:f};return this._messages.unshift(l),this._update(),new h.Disposable(()=>{const s=this._messages.indexOf(l);s>=0&&(this._messages.splice(s,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class E{constructor(f,l){this._proxy=f.getProxy(M.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new t(this)}createStatusBarEntry(f,l,s,v){return new P(this._proxy,this._commands,f,l,s,v)}setStatusBarMessage(f,l){const s=this._statusMessage.setMessage(f);let v;return typeof l=="number"?v=setTimeout(()=>s.dispose(),l):typeof l!="undefined"&&l.then(()=>s.dispose(),()=>s.dispose()),new h.Disposable(()=>{s.dispose(),clearTimeout(v)})}}e.ExtHostStatusBar=E}),define(be[72],Ee([0,1,5,3,4]),function(ie,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(C){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(h.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,_){this._proxy.$registerExtensionStorageKeysToSync(C,_)}getValue(C,_,P){return this._proxy.$getValue(C,_).then(t=>t||P)}setValue(C,_,P){return this._proxy.$setValue(C,_,P)}$acceptValue(C,_,P){this._onDidChangeStorage.fire({shared:C,key:_,value:P})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(be[73],Ee([0,1,4,29,15,71,2]),function(ie,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,h.createDecorator)("IExtensionStoragePaths");let C=class{constructor(P,t,E){this._logService=t,this._extHostFileSystem=E,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(P){return F.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,t=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(F.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:F.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(E){this._logService.error("[ExtHostStorage]",E);return}}workspaceValue(P){if(this._value)return F.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return F.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=Ue([He(0,M.IExtHostInitDataService),He(1,b.ILogService),He(2,T.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(be[38],Ee([0,1,3,5,4,2,12,6,7,128,16,167,21,36,149,150,44,10]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l,s,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class y{constructor(d,g,S,R){this._proxy=d,this._id=g,this._creationOptions=S,this._name=R,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(D=>this._pidPromiseComplete=D);const p=this;this.value={get name(){return p._name||""},get processId(){return p._pidPromise},get creationOptions(){return p._creationOptions},get exitStatus(){return p._exitStatus},get state(){return p._state},sendText(D,c=!0){p._checkDisposed(),p._proxy.$sendText(p._id,D,c)},show(D){p._checkDisposed(),p._proxy.$show(p._id,D)},hide(){p._checkDisposed(),p._proxy.$hide(p._id)},dispose(){p._disposed||(p._disposed=!0,p._proxy.$dispose(p._id))},get dimensions(){if(!(p._cols===void 0||p._rows===void 0))return{columns:p._cols,rows:p._rows}}}}async create(d,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:d.name,shellPath:(0,I.withNullAsUndefined)(d.shellPath),shellArgs:(0,I.withNullAsUndefined)(d.shellArgs),cwd:(0,I.withNullAsUndefined)(d.cwd),env:(0,I.withNullAsUndefined)(d.env),icon:(0,I.withNullAsUndefined)(r(d.iconPath)),color:v.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:(0,I.withNullAsUndefined)(d.message),strictEnv:(0,I.withNullAsUndefined)(d.strictEnv),hideFromUser:(0,I.withNullAsUndefined)(d.hideFromUser),isFeatureTerminal:(0,I.withNullAsUndefined)(g?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,I.withNullAsUndefined)(g?.useShellEnvironment),location:g?.location||this._serializeParentTerminal(d.location,g?.resolvedExtHostIdentifier,g?.location)})}async createExtensionTerminal(d,g,S,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:S,color:v.ThemeColor.isThemeColor(R)?R.id:void 0,location:this._serializeParentTerminal(d,g)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(d,g,S){return typeof d=="object"&&"parentTerminal"in d?g?{parentTerminal:g}:void 0:(S&&(d=S),d)}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(d){this._name=d}setExitCode(d){this._exitStatus=Object.freeze({code:d})}setDimensions(d,g){return d===this._cols&&g===this._rows||d===0||g===0?!1:(this._cols=d,this._rows=g,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(d){this._pidPromiseComplete?(this._pidPromiseComplete(d),this._pidPromiseComplete=void 0):this._pidPromise.then(g=>{g!==d&&(this._pidPromise=Promise.resolve(d))})}}e.ExtHostTerminal=y;class a{constructor(d){this._pty=d,this.id=0,this.shouldPersist=!1,this._onProcessData=new h.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new h.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new h.Emitter,this._onProcessTitleChanged=new h.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new h.Emitter,this._onProcessShellTypeChanged=new h.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new h.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(d){this._pty.handleInput&&this._pty.handleInput(d)}resize(d,g){this._pty.setDimensions&&this._pty.setDimensions({columns:d,rows:g})}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(d){this._pty.onDidWrite(g=>this._onProcessData.fire(g)),this._pty.onDidClose&&this._pty.onDidClose((g=void 0)=>{this._onProcessExit.fire(g===void 0?void 0:g)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(g=>this._onProcessOverrideDimensions.fire(g&&{cols:g.columns,rows:g.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(g=>this._onProcessTitleChanged.fire(g)),this._pty.open(d||void 0),this._pty.setDimensions&&d&&this._pty.setDimensions(d),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=a;let m=1,k=class extends C.Disposable{constructor(d,g){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new h.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new h.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new h.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new h.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new h.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=g.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new h.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(d),this._register({dispose:()=>{for(const[S,R]of this._terminalProcesses)R.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(d=>d.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(d,g){const S=new y(this._proxy,(0,f.generateUuid)(),d,d.name),R=new a(d.pty);return S.createExtensionTerminal(this._resolveLocation(d.location),g?.resolvedExtHostIdentifier,r(d.iconPath),o(d.color)).then(p=>{const D=this._setupExtHostProcessListeners(p,R);this._terminalProcessDisposables[p]=D}),this._terminals.push(S),S.value}_resolveLocation(d){return typeof d=="object"&&"viewColumn"in d&&d.viewColumn!==void 0?{viewColumn:d.viewColumn,preserveFocus:d.preserveFocus}:typeof d=="object"&&"parentTerminal"in d?void 0:(d===l.TerminalLocation.Editor||d===l.TerminalLocation.Panel,d)}attachPtyToTerminal(d,g){if(!this._getTerminalById(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const R=new a(g),p=this._setupExtHostProcessListeners(d,R);this._terminalProcessDisposables[d]=p}async $acceptActiveTerminalChanged(d){const g=this._activeTerminal;if(d===null){this._activeTerminal=void 0,g!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const S=this._getTerminalById(d);S&&(this._activeTerminal=S,g!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(d,g){const S=this._getTerminalById(d);S&&this._onDidWriteTerminalData.fire({terminal:S.value,data:g})}async $acceptTerminalDimensions(d,g,S){const R=this._getTerminalById(d);R&&R.setDimensions(g,S)&&this._onDidChangeTerminalDimensions.fire({terminal:R.value,dimensions:R.value.dimensions})}async $acceptTerminalMaximumDimensions(d,g,S){this._terminalProcesses.get(d)?.resize(g,S)}async $acceptTerminalTitleChange(d,g){const S=this._getTerminalById(d);S&&(S.name=g)}async $acceptTerminalClosed(d,g){const S=this._getTerminalObjectIndexById(this._terminals,d);if(S!==null){const R=this._terminals.splice(S,1)[0];R.setExitCode(g),this._onDidCloseTerminal.fire(R.value)}}$acceptTerminalOpened(d,g,S,R){if(g){const c=this._getTerminalObjectIndexById(this._terminals,g);if(c!==null){this._terminals[c]._id=d,this._onDidOpenTerminal.fire(this.terminals[c]),this._terminals[c].isOpen=!0;return}}const p={name:R.name,shellPath:R.executable,shellArgs:R.args,cwd:typeof R.cwd=="string"?R.cwd:T.URI.revive(R.cwd),env:R.env,hideFromUser:R.hideFromUser},D=new y(this._proxy,d,p,S);this._terminals.push(D),this._onDidOpenTerminal.fire(D.value),D.isOpen=!0}async $acceptTerminalProcessId(d,g){const S=this._getTerminalById(d);S&&S._setProcessId(g)}async $startExtensionTerminal(d,g){const S=this._getTerminalById(d);if(!S)return{message:(0,P.localize)(0,null,d)};S.isOpen||await new Promise(p=>{const D=this.onDidOpenTerminal(async c=>{c===S.value&&(D.dispose(),p())})});const R=this._terminalProcesses.get(d);R?R.startSendingEvents(g):this._extensionTerminalAwaitingStart[d]={initialDimensions:g}}_setupExtHostProcessListeners(d,g){const S=new C.DisposableStore;S.add(g.onProcessReady(p=>this._proxy.$sendProcessReady(d,p.pid,p.cwd))),S.add(g.onProcessTitleChanged(p=>this._proxy.$sendProcessTitle(d,p))),this._bufferer.startBuffering(d,g.onProcessData),S.add(g.onProcessExit(p=>this._onProcessExit(d,p))),g.onProcessOverrideDimensions&&S.add(g.onProcessOverrideDimensions(p=>this._proxy.$sendOverrideDimensions(d,p))),this._terminalProcesses.set(d,g);const R=this._extensionTerminalAwaitingStart[d];return R&&g instanceof a&&(g.startSendingEvents(R.initialDimensions),delete this._extensionTerminalAwaitingStart[d]),S}$acceptProcessAckDataEvent(d,g){this._terminalProcesses.get(d)?.acknowledgeDataEvent(g)}$acceptProcessInput(d,g){this._terminalProcesses.get(d)?.input(g)}$acceptTerminalInteraction(d){const g=this._getTerminalById(d);g?.setInteractedWith()&&this._onDidChangeTerminalState.fire(g.value)}$acceptProcessResize(d,g,S){try{this._terminalProcesses.get(d)?.resize(g,S)}catch(R){if(R.code!=="EPIPE"&&R.code!=="ERR_IPC_CHANNEL_CLOSED")throw R}}$acceptProcessShutdown(d,g){this._terminalProcesses.get(d)?.shutdown(g)}$acceptProcessRequestInitialCwd(d){this._terminalProcesses.get(d)?.getInitialCwd().then(g=>this._proxy.$sendProcessInitialCwd(d,g))}$acceptProcessRequestCwd(d){this._terminalProcesses.get(d)?.getCwd().then(g=>this._proxy.$sendProcessCwd(d,g))}$acceptProcessRequestLatency(d){return d}registerLinkProvider(d){return this._linkProviders.add(d),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(d),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(d,g,S){if(this._profileProviders.has(g))throw new Error(`Terminal profile provider "${g}" already registered`);return this._profileProviders.set(g,S),this._proxy.$registerProfileProvider(g,d.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(g),this._proxy.$unregisterProfileProvider(g)})}async $createContributedProfileTerminal(d,g){const S=new n.CancellationTokenSource().token,R=await this._profileProviders.get(d)?.provideTerminalProfile(S);if(!S.isCancellationRequested){if(!R||!("options"in R))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in R.options){this.createExtensionTerminal(R.options,g);return}this.createTerminalFromOptions(R.options,g)}}async $provideLinks(d,g){const S=this._getTerminalById(d);if(!S)return[];this._terminalLinkCache.delete(d);const R=this._terminalLinkCancellationSource.get(d);R&&R.dispose(!0);const p=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(d,p);const D=[],c={terminal:S.value,line:g},A=[];for(const K of this._linkProviders)A.push(new Promise(async $=>{p.token.onCancellationRequested(()=>$({provider:K,links:[]}));const Q=await K.provideTerminalLinks(c,p.token)||[];p.token.isCancellationRequested||$({provider:K,links:Q})}));const O=await Promise.all(A);if(p.token.isCancellationRequested)return[];const z=new Map;for(const K of O)K&&K.links.length>0&&D.push(...K.links.map($=>{const Q={id:m++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return z.set(Q.id,{provider:K.provider,link:$}),Q}));return this._terminalLinkCache.set(d,z),D}$activateLink(d,g){const S=this._terminalLinkCache.get(d)?.get(g);!S||S.provider.handleTerminalLink(S.link)}_onProcessExit(d,g){this._bufferer.stopBuffering(d),this._terminalProcesses.delete(d),delete this._extensionTerminalAwaitingStart[d];const S=this._terminalProcessDisposables[d];S&&(S.dispose(),delete this._terminalProcessDisposables[d]),this._proxy.$sendProcessExit(d,g)}_getTerminalById(d){return this._getTerminalObjectById(this._terminals,d)}_getTerminalObjectById(d,g){const S=this._getTerminalObjectIndexById(d,g);return S!==null?d[S]:null}_getTerminalObjectIndexById(d,g){let S=null;return d.some((R,p)=>R._id===g?(S=p,!0):!1),S}getEnvironmentVariableCollection(d){let g=this._environmentVariableCollections.get(d.identifier.value);return g||(g=new i,this._setEnvironmentVariableCollection(d.identifier.value,g)),g}_syncEnvironmentVariableCollection(d,g){const S=(0,E.serializeEnvironmentVariableCollection)(g.map);this._proxy.$setEnvironmentVariableCollection(d,g.persistent,S.length===0?void 0:S)}$initEnvironmentVariableCollections(d){d.forEach(g=>{const S=g[0],R=new i(g[1]);this._setEnvironmentVariableCollection(S,R)})}$acceptDefaultProfile(d,g){this._defaultProfile=d,this._defaultAutomationProfile=g}_setEnvironmentVariableCollection(d,g){this._environmentVariableCollections.set(d,g),g.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(d,g)})}};k=Ue([He(1,F.IExtHostRpcService)],k),e.BaseExtHostTerminalService=k;class i{constructor(d){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new h.Emitter,this.map=new Map(d)}get persistent(){return this._persistent}set persistent(d){this._persistent=d,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(d,g){this._setIfDiffers(d,{value:g,type:_.EnvironmentVariableMutatorType.Replace})}append(d,g){this._setIfDiffers(d,{value:g,type:_.EnvironmentVariableMutatorType.Append})}prepend(d,g){this._setIfDiffers(d,{value:g,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(d,g){const S=this.map.get(d);(!S||S.value!==g.value||S.type!==g.type)&&(this.map.set(d,g),this._onDidChangeCollection.fire())}get(d){return this.map.get(d)}forEach(d,g){this.map.forEach((S,R)=>d.call(g,R,S,this))}delete(d){this.map.delete(d),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=i;let u=class extends k{constructor(d){super(!1,d)}createTerminal(d,g,S){throw new t.NotSupportedError}createTerminalFromOptions(d,g){throw new t.NotSupportedError}};u=Ue([He(0,F.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u;function r(w){if(!(!w||typeof w=="string"))return"id"in w?{id:w.id,color:w.color}:w}function o(w){return v.ThemeColor.isThemeColor(w)?w:void 0}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ie,h):b?b.value=h:e.set(ie,h),h},Te=this&&this.__classPrivateFieldGet||function(ie,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[204],Ee([0,1,13,23,21,3,235,58,6,22,10,36,5,12,46,8,7,175,90,67]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l,s,v,I,y,a){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let k=class{constructor(c,A){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=c.getProxy(n.MainContext.MainThreadTesting),this.observer=new S(this.proxy),this.runTracker=new u(this.proxy),A.registerArgumentProcessor({processArgument:O=>O?.$mid===13?s.TestItem.toItemFromContext(O):O})}createTestController(c,A){if(this.controllers.has(c))throw new Error(`Attempt to insert a duplicate controller with ID "${c}"`);const O=new _.DisposableStore,z=O.add(new I.SingleUseTestCollection(c));z.root.label=A;const K=new Map,$=this.proxy,Q={items:z.root.children,get label(){return A},set label(U){A=U,z.root.label=U,$.$updateControllerLabel(c,A)},get id(){return c},createRunProfile:(U,H,G,ue,q)=>{let le=(0,C.hash)(U);for(;K.has(le);)le++;const se=new R(this.proxy,c,le,U,H,G,ue,q);return K.set(le,se),se},createTestItem(U,H,G){return new l.TestItemImpl(c,U,H,G)},createTestRun:(U,H,G=!0)=>this.runTracker.createTestRun(c,z,U,H,G),set resolveHandler(U){z.resolveHandler=U},get resolveHandler(){return z.resolveHandler},dispose:()=>{O.dispose()}};Q.createRunConfiguration=Q.createRunProfile,$.$registerTestController(c,A),O.add((0,_.toDisposable)(()=>$.$unregisterTestController(c)));const W={controller:Q,collection:z,profiles:K};return this.controllers.set(c,W),O.add((0,_.toDisposable)(()=>this.controllers.delete(c))),O.add(z.onDidGenerateDiff(U=>$.$publishDiff(c,U))),Q}createTestObserver(){return this.observer.checkout()}async runTests(c,A=b.CancellationToken.None){const O=r(c);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.controllers.get(O.controllerId);if(!z)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:c.include?.map(K=>K.id)??[z.collection.root.id],profileGroup:p[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:c.exclude?.map(K=>K.id)},A)}$provideFileCoverage(c,A,O){return(0,h.mapFind)(this.runTracker.trackers,K=>K.id===c?K.getCoverage(A):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(c,A,O,z){return(0,h.mapFind)(this.runTracker.trackers,$=>$.id===c?$.getCoverage(A):void 0)?.resolveFileCoverage(O,z)??Promise.resolve([])}$configureRunProfile(c,A){this.controllers.get(c)?.profiles.get(A)?.configureHandler?.()}$publishTestResults(c){this.results=Object.freeze(c.map(A=>(0,P.deepFreeze)(s.TestResults.to(A))).concat(this.results).sort((A,O)=>O.completedAt-A.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(c,A){const O=this.controllers.get(a.TestId.fromString(c).controllerId)?.collection;O&&(await O.expand(c,A<0?Infinity:A),O.flushDiff())}$acceptDiff(c){this.observer.applyDiff(c)}async $runControllerTests(c,A){const O=this.controllers.get(c.controllerId);if(!O)return;const{collection:z,profiles:K}=O,$=K.get(c.profileId);if(!$)return;const Q=c.testIds.map(G=>z.tree.get(G)).filter(t.isDefined),W=c.excludeExtIds.map(G=>O.collection.tree.get(G)).filter(t.isDefined).filter(G=>Q.some(ue=>ue.fullId.compare(G.fullId)===2));if(!Q.length)return;const U=new v.TestRunRequest(Q.some(G=>G.actual instanceof l.TestItemRootImpl)?void 0:Q.map(G=>G.actual),W.map(G=>G.actual),$),H=this.runTracker.prepareForMainThreadTestRun(U,o.fromInternal(c,O.collection),A);try{await $.runHandler(U,A)}finally{H.isRunning&&!A.isCancellationRequested&&await T.Event.toPromise(H.onEnd),H.dispose()}}$cancelExtensionTestRun(c){c===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(c)}};k=Ue([He(0,f.IExtHostRpcService)],k),e.ExtHostTesting=k;class i extends _.Disposable{constructor(c,A,O){super();this.dto=c,this.proxy=A,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(O)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:z}of this.tasks.values())z.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(c){return this.tasks.get(c)?.coverage}createRun(c){const A=this.dto.id,O=this.dto.controllerId,z=(0,E.generateUuid)(),K=new w(this.proxy,A,z),$=H=>(G,...ue)=>{if(W){console.warn(`Setting the state of test "${G.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(G)||(this.ensureTestIsKnown(G),H(G,...ue))},Q=(H,G)=>{const ue=G instanceof Array?G.map(s.TestMessage.from):[s.TestMessage.from(G)];if(H.uri&&H.range){const q={range:s.Range.from(H.range),uri:H.uri};for(const le of ue)le.location=le.location||q}this.proxy.$appendTestMessagesInRun(A,z,a.TestId.fromExtHostTestItem(H,O).toString(),ue)};let W=!1;const U={isPersisted:this.dto.isPersisted,token:this.cts.token,name:c,get coverageProvider(){return K.coverageProvider},set coverageProvider(H){K.coverageProvider=H},enqueued:$(H=>{this.proxy.$updateTestStateInRun(A,z,a.TestId.fromExtHostTestItem(H,O).toString(),1)}),skipped:$(H=>{this.proxy.$updateTestStateInRun(A,z,a.TestId.fromExtHostTestItem(H,O).toString(),5)}),started:$(H=>{this.proxy.$updateTestStateInRun(A,z,a.TestId.fromExtHostTestItem(H,O).toString(),2)}),errored:$((H,G,ue)=>{Q(H,G),this.proxy.$updateTestStateInRun(A,z,a.TestId.fromExtHostTestItem(H,O).toString(),6,ue)}),failed:$((H,G,ue)=>{Q(H,G),this.proxy.$updateTestStateInRun(A,z,a.TestId.fromExtHostTestItem(H,O).toString(),4,ue)}),passed:$((H,G)=>{this.proxy.$updateTestStateInRun(A,z,a.TestId.fromExtHostTestItem(H,this.dto.controllerId).toString(),3,G)}),appendOutput:(H,G,ue)=>{W||(ue&&(this.dto.isIncluded(ue)?this.ensureTestIsKnown(ue):ue=void 0),this.proxy.$appendOutputToRun(A,z,M.VSBuffer.fromString(H),G&&s.location.from(G),ue&&a.TestId.fromExtHostTestItem(ue,O).toString()))},end:()=>{W||(W=!0,this.proxy.$finishedTestRunTask(A,z),this.tasks.delete(z),this.isRunning||this.dispose())}};return this.tasks.set(z,{run:U,coverage:K}),this.proxy.$startedTestRunTask(A,{id:z,name:c,running:!0}),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(c){if(!(c instanceof l.TestItemImpl))throw new l.InvalidTestItemError(c.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(c,this.dto.controllerId).toString()))return;const A=[],O=this.dto.colllection.root;for(;;){const z=s.TestItem.from(c);if(A.unshift(z),this.sharedTestIds.has(z.extId)||(this.sharedTestIds.add(z.extId),c===O))break;c=c.parent||O}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,A)}}class u{constructor(c){this.proxy=c,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(c,A,O){return this.getTracker(c,A,O)}cancelRunById(c){for(const A of this.tracked.values())if(A.id===c){A.dispose();return}}cancelAllRuns(){for(const c of this.tracked.values())c.dispose()}createTestRun(c,A,O,z,K){const $=this.tracked.get(O);if($)return $.createRun(z);const Q=o.fromPublic(c,A,O,K),W=r(O);this.proxy.$startedExtensionTestRun({controllerId:c,profile:W&&{group:p[W.kind],id:W.profileId},exclude:O.exclude?.map(H=>H.id)??[],id:Q.id,include:O.include?.map(H=>H.id)??[A.root.id],persist:K});const U=this.getTracker(O,Q);return U.onEnd(()=>this.proxy.$finishedExtensionTestRun(Q.id)),U.createRun(z)}getTracker(c,A,O){const z=new i(A,this.proxy,O);return this.tracked.set(c,z),z.onEnd(()=>this.tracked.delete(c)),z}}e.TestRunCoordinator=u;const r=D=>{if(!!D.profile){if(!(D.profile instanceof R))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return D.profile}};class o{constructor(c,A,O,z,K,$){this.controllerId=c,this.id=A,this.isPersisted=K,this.colllection=$,this.includePrefix=O.map(Q=>Q+"\0"),this.excludePrefix=z.map(Q=>Q+"\0")}static fromPublic(c,A,O,z){return new o(c,(0,E.generateUuid)(),O.include?.map(K=>a.TestId.fromExtHostTestItem(K,c).toString())??[c],O.exclude?.map(K=>a.TestId.fromExtHostTestItem(K,c).toString())??[],z,A)}static fromInternal(c,A){return new o(c.controllerId,c.runId,c.testIds,c.excludeExtIds,!0,A)}isIncluded(c){const A=a.TestId.fromExtHostTestItem(c,this.controllerId).toString()+"\0";for(const O of this.excludePrefix)if(A===O||A.startsWith(O))return!1;for(const O of this.includePrefix)if(A===O||A.startsWith(O))return!0;return!1}}e.TestRunDto=o;class w{constructor(c,A,O){this.proxy=c,this.runId=A,this.taskId=O}set coverageProvider(c){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!c||(this._coverageProvider=c,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(c){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(c))());try{return(await this.fileCoverage)?.map(s.TestCoverage.fromFile)??[]}catch(A){throw this.fileCoverage=void 0,A}}async resolveFileCoverage(c,A){const O=await this.fileCoverage;let z=O?.[c];return!this._coverageProvider||!O||!z?[]:(z.detailedCoverage||(z=O[c]=await this._coverageProvider.resolveFileCoverage?.(z,A)??z),z.detailedCoverage?.map(s.TestCoverage.fromDetailed)??[])}}class d extends y.IncrementalChangeCollector{constructor(c){super();this.emitter=c,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(c){this.added.add(c)}update(c){Object.assign(c.revived,s.TestItem.toPlain(c.item)),this.added.has(c)||this.updated.add(c)}remove(c){if(this.added.has(c)){this.added.delete(c);return}if(this.updated.delete(c),c.parent&&this.alreadyRemoved.has(c.parent)){this.alreadyRemoved.add(c.item.extId);return}this.removed.add(c)}getChangeEvent(){const{added:c,updated:A,removed:O}=this;return{get added(){return[...c].map(z=>z.revived)},get updated(){return[...A].map(z=>z.revived)},get removed(){return[...O].map(z=>z.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class g extends y.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(c){return this.items.get(c)}getMirroredTestDataByReference(c){return this.items.get(c.id)}createItem(c,A){return{...c,revived:s.TestItem.toPlain(c.item),depth:A?A.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=g;class S{constructor(c){this.proxy=c}checkout(){this.current||(this.current=this.createObserverData());const c=this.current;return c.observers++,{onDidChangeTest:c.tests.onDidChangeTests,get tests(){return[...c.tests.rootTests].map(A=>A.revived)},dispose:(0,F.once)(()=>{--c.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(c){return this.current?.tests.getMirroredTestDataByReference(c)}applyDiff(c){this.current?.tests.apply(c)}createObserverData(){const c=new g;return this.proxy.$subscribeToDiffs(),{observers:0,tests:c}}}class R{constructor(c,A,O,z,K,$,Q=!1,W=void 0){this.controllerId=A,this.profileId=O,this._label=z,this.kind=K,this.runHandler=$,this._isDefault=Q,this._tag=W,m.set(this,void 0),Je(this,m,c,"f");const U=p[K];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Te(this,m,"f").$publishTestRunProfile({profileId:O,controllerId:A,tag:W?s.TestTag.namespace(this.controllerId,W.id):null,label:z,group:U,isDefault:Q,hasConfigurationHandler:!1})}get label(){return this._label}set label(c){c!==this._label&&(this._label=c,Te(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:c}))}get isDefault(){return this._isDefault}set isDefault(c){c!==this._isDefault&&(this._isDefault=c,Te(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:c}))}get tag(){return this._tag}set tag(c){c?.id!==this._tag?.id&&(this._tag=c,Te(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:c?s.TestTag.namespace(this.controllerId,c.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(c){c!==this._configureHandler&&(this._configureHandler=c,Te(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!c}))}dispose(){Te(this,m,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=R,m=new WeakMap;const p={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(be[205],Ee([0,1,3,13,5,94,8,7]),function(ie,e,h,M,b,T,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(t,E){this._extHostDocumentsAndEditors=E,this._onDidChangeTextEditorSelection=new h.Emitter,this._onDidChangeTextEditorOptions=new h.Emitter,this._onDidChangeTextEditorVisibleRanges=new h.Emitter,this._onDidChangeTextEditorViewColumn=new h.Emitter,this._onDidChangeActiveTextEditor=new h.Emitter,this._onDidChangeVisibleTextEditors=new h.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const E=this._extHostDocumentsAndEditors.allEditors();return t?E:E.map(n=>n.value)}async showTextDocument(t,E,n){let f;typeof E=="number"?f={position:F.ViewColumn.from(E),preserveFocus:n}:typeof E=="object"?f={position:F.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?F.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:f={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(t.uri,f),s=l&&this._extHostDocumentsAndEditors.getEditor(l);if(s)return s.value;throw l?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,E){return new T.TextEditorDecorationType(this._proxy,t,E).value}$acceptEditorPropertiesChanged(t,E){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(E.options&&n._acceptOptions(E.options),E.selections){const f=E.selections.selections.map(F.Selection.to);n._acceptSelections(f)}if(E.visibleRanges){const f=M.coalesce(E.visibleRanges.map(F.Range.to));n._acceptVisibleRanges(f)}if(E.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...E.options,lineNumbers:F.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const f=C.TextEditorSelectionChangeKind.fromValue(E.selections.source),l=E.selections.selections.map(F.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:l,kind:f})}if(E.visibleRanges){const f=M.coalesce(E.visibleRanges.map(F.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:f})}}$acceptEditorPositionData(t){for(const E in t){const n=this._extHostDocumentsAndEditors.getEditor(E);if(!n)throw new Error("Unknown text editor");const f=F.ViewColumn.to(t[E]);n.value.viewColumn!==f&&(n._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:f}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=_}),define(be[206],Ee([0,1,2,4,5,6,7]),function(ie,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class C{constructor(t,E){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(b.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const f=n.uri===void 0?void 0:h.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(_(f))?.get(n.handle)}return n}})}async $getTimeline(t,E,n,f,l){return this._providers.get(t)?.provideTimeline(h.URI.revive(E),n,f,l)}registerTimelineProvider(t,E,n,f){const l=new T.DisposableStore,s=this.convertTimelineItem(E.id,f,l).bind(this);let v;E.onDidChange&&(v=E.onDidChange(y=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...y,id:E.id}),this));const I=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...E,scheme:t,onDidChange:void 0,async provideTimeline(y,a,m,k){k?.resetCache&&(l.clear(),I.get(E.id)?.clear());const i=await E.provideTimeline(y,a,m);if(i==null)return;const u=s(y,k);return{...i,source:E.id,items:i.items.map(u)}},dispose(){for(const y of I.values())y.get(E.id)?.clear();v?.dispose(),l.dispose()}})}convertTimelineItem(t,E,n){return(f,l)=>{let s;if(l?.cacheResults){let v=this._itemsBySourceAndUriMap.get(t);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(t,v));const I=_(f);s=v.get(I),s===void 0&&(s=new Map,v.set(I,s))}return v=>{const{iconPath:I,...y}=v,a=`${t}|${v.id??v.timestamp}`;s?.set(a,v);let m,k,i;return v.iconPath&&(I instanceof F.ThemeIcon?i={id:I.id,color:I.color}:h.URI.isUri(I)?(m=I,k=I):{light:m,dark:k}=I),{...y,id:y.id??void 0,handle:a,source:t,command:v.command?E.toInternal(v.command,n):void 0,icon:m,iconDark:k,themeIcon:i,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,T.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=C;function _(P){return P?.toString()}}),define(be[207],Ee([0,1,6,11,2,5]),function(ie,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class F{constructor(_){this._openers=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,P,t,E){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const n=E.schemes.find(f=>!F.supportedSchemes.has(f));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,t),this._proxy.$registerUriOpener(P,E.schemes,_,E.label),(0,h.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(_,P,t){const E=this._openers.get(_);if(!E)throw new Error(`Unknown opener with id: ${_}`);const n=b.URI.revive(P);return E.canOpenExternalUri(n,t)}async $openUri(_,P,t){const E=this._openers.get(_);if(!E)throw new Error(`Unknown opener id: '${_}'`);return E.openExternalUri(b.URI.revive(P.resolvedUri),{sourceUri:b.URI.revive(P.sourceUri)},t)}}e.ExtHostUriOpeners=F,F.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(be[208],Ee([0,1,5,2,6,16,25]),function(ie,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(h.MainContext.MainThreadUrls)}registerUriHandler(P,t){if(this.handles.has(F.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const E=C.HandlePool++;return this.handles.add(F.ExtensionIdentifier.toKey(P)),this.handlers.set(E,t),this._proxy.$registerUriHandler(E,P),(0,b.toDisposable)(()=>{this.handles.delete(F.ExtensionIdentifier.toKey(P)),this.handlers.delete(E),this._proxy.$unregisterUriHandler(E)})}$handleExternalUri(P,t){const E=this.handlers.get(P);if(!E)return Promise.resolve(void 0);try{E.handleUri(M.URI.revive(t))}catch(n){(0,T.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(P){return M.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=C,C.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(ie,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ie,h):b?b.value=h:e.set(ie,h),h},Te=this&&this.__classPrivateFieldGet||function(ie,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[50],Ee([0,1,3,2,138,158,66,5]),function(ie,e,h,M,b,T,F,C){"use strict";var _,P,t,E,n,f,l,s,v,I,y,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(g,S,R,p,D,c,A){_.set(this,void 0),P.set(this,void 0),t.set(this,void 0),E.set(this,void 0),n.set(this,void 0),f.set(this,void 0),l.set(this,""),s.set(this,void 0),v.set(this,!1),I.set(this,!1),y.set(this,!1),this._onMessageEmitter=new h.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new h.Emitter),this._onDidDispose=Te(this,a,"f").event,Je(this,_,g,"f"),Je(this,P,S,"f"),Je(this,s,R,"f"),Je(this,E,p,"f"),Je(this,n,D,"f"),Je(this,f,c,"f"),Je(this,y,k(c),"f"),Je(this,t,A,"f")}dispose(){Je(this,v,!0,"f"),Te(this,a,"f").fire(),Te(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return Je(this,I,!0,"f"),(0,F.asWebviewUri)(g,Te(this,E,"f").remote)}get cspSource(){return F.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Te(this,l,"f")}set html(g){this.assertNotDisposed(),Te(this,l,"f")!==g&&(Je(this,l,g,"f"),!Te(this,I,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(Je(this,I,!0,"f"),Te(this,t,"f").report("Webview vscode-resource: uris",Te(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,P,"f").$setHtml(Te(this,_,"f"),g))}get options(){return this.assertNotDisposed(),Te(this,s,"f")}set options(g){this.assertNotDisposed(),Te(this,P,"f").$setOptions(Te(this,_,"f"),r(Te(this,f,"f"),Te(this,n,"f"),g)),Je(this,s,g,"f")}async postMessage(g){if(Te(this,v,"f"))return!1;const S=(0,T.serializeWebviewMessage)(g,{serializeBuffersForPostMessage:Te(this,y,"f")});return Te(this,P,"f").$postMessage(Te(this,_,"f"),S.message,...S.buffers)}assertNotDisposed(){if(Te(this,v,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,_=new WeakMap,P=new WeakMap,t=new WeakMap,E=new WeakMap,n=new WeakMap,f=new WeakMap,l=new WeakMap,s=new WeakMap,v=new WeakMap,I=new WeakMap,y=new WeakMap,a=new WeakMap;function k(d){try{const g=(0,b.normalizeVersion)((0,b.parseVersion)(d.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=k;class i{constructor(g,S,R,p,D){this.initData=S,this.workspace=R,this._logService=p,this._deprecationService=D,this._webviews=new Map,this._webviewProxy=g.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(g,S,...R){const p=this.getWebview(g);if(p){const{message:D}=(0,T.deserializeWebviewMessage)(S,R);p._onMessageEmitter.fire(D)}}$onMissingCsp(g,S){this._logService.warn(`${S} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,S,R){const p=new m(g,this._webviewProxy,o(S),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(g,p),p._onDidDispose(()=>{this._webviews.delete(g)}),p}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=i;function u(d){return{id:d.identifier,location:d.extensionLocation}}e.toExtensionData=u;function r(d,g,S){return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,enableForms:S.enableForms,portMapping:S.portMapping,localResourceRoots:S.localResourceRoots||w(d,g)}}e.serializeWebviewOptions=r;function o(d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots?.map(g=>M.URI.from(g))}}e.reviveOptions=o;function w(d,g){return[...(g?.getWorkspaceFolders()||[]).map(S=>S.uri),d.extensionLocation]}}),define(be[209],Ee([0,1,21,58,6,11,24,2,8,50,63,5,7]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(i,u){this.document=i,this._storagePath=u,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,u){await this.getEdit(i).undo(),u||this.disposeBackup()}async redo(i,u){await this.getEdit(i).redo(),u||this.disposeBackup()}disposeEdits(i){for(const u of i)this._edits.delete(u)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=m(this.document.uri)+this._backupCounter++;return(0,F.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const u=this._edits.get(i,0);if(!u)throw new Error("No edit found");return u}}class l{constructor(){this._documents=new Map}get(i,u){return this._documents.get(this.key(i,u))}add(i,u,r){const o=this.key(i,u.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${i} resource:${u.uri}`);const w=new f(u,r);return this._documents.set(o,w),w}delete(i,u){const r=this.key(i,u.uri);this._documents.delete(r)}key(i,u){return`${i}@@@${u}`}}var s;(function(k){k[k.Text=0]="Text",k[k.Custom=1]="Custom"})(s||(s={}));class v{constructor(){this._providers=new Map}addTextProvider(i,u,r){return this.add(0,i,u,r)}addCustomProvider(i,u,r){return this.add(1,i,u,r)}get(i){return this._providers.get(i)}add(i,u,r,o){if(this._providers.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this._providers.set(u,{type:i,extension:r,provider:o}),new n.Disposable(()=>this._providers.delete(u))}}class I{constructor(i,u,r,o,w){this._extHostDocuments=u,this._extensionStoragePaths=r,this._extHostWebview=o,this._extHostWebviewPanels=w,this._editorProviders=new v,this._documents=new l,this._proxy=i.getProxy(E.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,u,r,o){const w=new b.DisposableStore;return y(r)?(w.add(this._editorProviders.addTextProvider(u,i,r)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(i),u,o.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(i))):(w.add(this._editorProviders.addCustomProvider(u,i,r)),this.supportEditing(r)&&w.add(r.onDidChangeCustomDocument(d=>{const g=this.getCustomDocumentEntry(u,d.document.uri);if(a(d)){const S=g.addEdit(d);this._proxy.$onDidEdit(d.document.uri,u,S,d.label)}else this._proxy.$onContentChange(d.document.uri,u)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(i),u,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(w,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(u)}))}async $createCustomDocument(i,u,r,o,w){const d=this._editorProviders.get(u);if(!d)throw new Error(`No provider found for '${u}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${u}'`);const g=C.URI.revive(i),S=await d.provider.openCustomDocument(g,{backupId:r,untitledDocumentData:o?.buffer},w);let R;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(R=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(u,S,R),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(i,u){const r=this._editorProviders.get(u);if(!r)throw new Error(`No provider found for '${u}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${u}'`);const o=C.URI.revive(i),{document:w}=this.getCustomDocumentEntry(u,o);this._documents.delete(u,w),w.dispose()}async $resolveWebviewEditor(i,u,r,o,w,d){const g=this._editorProviders.get(r);if(!g)throw new Error(`No provider found for '${r}'`);const S=_.ViewColumn.to(w),R=this._extHostWebview.createNewWebview(u,o.webviewOptions,g.extension),p=this._extHostWebviewPanels.createNewWebviewPanel(u,r,o.title,S,o.panelOptions,R),D=C.URI.revive(i);switch(g.type){case 1:{const{document:c}=this.getCustomDocumentEntry(r,D);return g.provider.resolveCustomEditor(c,p,d)}case 0:{const c=this._extHostDocuments.getDocument(D);return g.provider.resolveCustomTextEditor(c,p,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,u,r){this.getCustomDocumentEntry(u,i).disposeEdits(r)}async $onMoveCustomEditor(i,u,r){const o=this._editorProviders.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const w=this._extHostWebviewPanels.getWebviewPanel(i);if(!w)throw new Error("No webview found");const d=C.URI.revive(u),g=this._extHostDocuments.getDocument(d);await o.provider.moveCustomTextEditor(g,w,h.CancellationToken.None)}async $undo(i,u,r,o){return this.getCustomDocumentEntry(u,i).undo(r,o)}async $redo(i,u,r,o){return this.getCustomDocumentEntry(u,i).redo(r,o)}async $revert(i,u,r){const o=this.getCustomDocumentEntry(u,i);await this.getCustomEditorProvider(u).revertCustomDocument(o.document,r),o.disposeBackup()}async $onSave(i,u,r){const o=this.getCustomDocumentEntry(u,i);await this.getCustomEditorProvider(u).saveCustomDocument(o.document,r),o.disposeBackup()}async $onSaveAs(i,u,r,o){const w=this.getCustomDocumentEntry(u,i);return this.getCustomEditorProvider(u).saveCustomDocumentAs(w.document,C.URI.revive(r),o)}async $backup(i,u,r){const o=this.getCustomDocumentEntry(u,i),d=await this.getCustomEditorProvider(u).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},r);return o.updateBackup(d),d.id}getCustomDocumentEntry(i,u){const r=this._documents.get(i,C.URI.revive(u));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(i){const r=this._editorProviders.get(i)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=I;function y(k){return typeof k.resolveCustomTextEditor=="function"}function a(k){return typeof k.undo=="function"&&typeof k.redo=="function"}function m(k){const i=k.scheme===T.Schemas.file||k.scheme===T.Schemas.untitled?k.fsPath:k.toString();return(0,M.hash)(i)+""}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ie,h):b?b.value=h:e.set(ie,h),h},Te=this&&this.__classPrivateFieldGet||function(ie,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[210],Ee([0,1,3,6,2,36,8,50,5,7]),function(ie,e,h,M,b,T,F,C,_,P){"use strict";var t,E,n,f,l,s,v,I,y,a,m,k,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends M.Disposable{constructor(d,g,S,R,p,D,c){super();t.set(this,void 0),E.set(this,void 0),n.set(this,void 0),f.set(this,void 0),l.set(this,void 0),s.set(this,void 0),v.set(this,void 0),I.set(this,void 0),y.set(this,!0),a.set(this,!0),m.set(this,!1),k.set(this,this._register(new h.Emitter)),this.onDidDispose=Te(this,k,"f").event,i.set(this,this._register(new h.Emitter)),this.onDidChangeViewState=Te(this,i,"f").event,Je(this,t,d,"f"),Je(this,E,g,"f"),Je(this,n,S,"f"),Je(this,l,D,"f"),Je(this,I,p,"f"),Je(this,s,R,"f"),Je(this,f,c,"f")}dispose(){Te(this,m,"f")||(Je(this,m,!0,"f"),Te(this,k,"f").fire(),Te(this,E,"f").$disposeWebview(Te(this,t,"f")),Te(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Te(this,f,"f")}get viewType(){return this.assertNotDisposed(),Te(this,n,"f")}get title(){return this.assertNotDisposed(),Te(this,s,"f")}set title(d){this.assertNotDisposed(),Te(this,s,"f")!==d&&(Je(this,s,d,"f"),Te(this,E,"f").$setTitle(Te(this,t,"f"),d))}get iconPath(){return this.assertNotDisposed(),Te(this,v,"f")}set iconPath(d){this.assertNotDisposed(),Te(this,v,"f")!==d&&(Je(this,v,d,"f"),Te(this,E,"f").$setIconPath(Te(this,t,"f"),b.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Te(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Te(this,I,"f")=="number"&&Te(this,I,"f")<0))return Te(this,I,"f")}get active(){return this.assertNotDisposed(),Te(this,a,"f")}get visible(){return this.assertNotDisposed(),Te(this,y,"f")}_updateViewState(d){Te(this,m,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(Je(this,a,d.active,"f"),Je(this,y,d.visible,"f"),Je(this,I,d.viewColumn,"f"),Te(this,i,"f").fire({webviewPanel:this}))}reveal(d,g){this.assertNotDisposed(),Te(this,E,"f").$reveal(Te(this,t,"f"),{viewColumn:d?F.ViewColumn.from(d):void 0,preserveFocus:!!g})}assertNotDisposed(){if(Te(this,m,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,E=new WeakMap,n=new WeakMap,f=new WeakMap,l=new WeakMap,s=new WeakMap,v=new WeakMap,I=new WeakMap,y=new WeakMap,a=new WeakMap,m=new WeakMap,k=new WeakMap,i=new WeakMap;class r{constructor(d,g,S){this.webviews=g,this.workspace=S,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(d,g,S,R,p={}){const D=typeof R=="object"?R.viewColumn:R,c={viewColumn:F.ViewColumn.from(D),preserveFocus:typeof R=="object"&&!!R.preserveFocus},A=(0,C.shouldSerializeBuffersForPostMessage)(d),O=r.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(d),O,g,{title:S,panelOptions:o(p),webviewOptions:(0,C.serializeWebviewOptions)(d,this.workspace,p),serializeBuffersForPostMessage:A},c);const z=this.webviews.createNewWebview(O,p,d);return this.createNewWebviewPanel(O,g,S,D,p,z)}$onDidChangeWebviewPanelViewStates(d){const g=Object.keys(d);g.sort((S,R)=>{const p=d[S],D=d[R];return p.active?1:D.active?-1:+p.visible-+D.visible});for(const S of g){const R=this.getWebviewPanel(S);if(!R)continue;const p=d[S];R._updateViewState({active:p.active,visible:p.visible,viewColumn:F.ViewColumn.to(p.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,g,S){if(this._serializers.has(g))throw new Error(`Serializer for '${g}' already registered`);return this._serializers.set(g,{serializer:S,extension:d}),this._proxy.$registerSerializer(g,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(d)}),new P.Disposable(()=>{this._serializers.delete(g),this._proxy.$unregisterSerializer(g)})}async $deserializeWebviewPanel(d,g,S,R){const p=this._serializers.get(g);if(!p)throw new Error(`No serializer found for '${g}'`);const{serializer:D,extension:c}=p,A=this.webviews.createNewWebview(d,S.webviewOptions,c),O=this.createNewWebviewPanel(d,g,S.title,R,S.panelOptions,A);await D.deserializeWebviewPanel(O,S.state)}createNewWebviewPanel(d,g,S,R,p,D){const c=new u(d,this._proxy,g,S,R,p,D);return this._webviewPanels.set(d,c),c}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=r;function o(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ie,h):b?b.value=h:e.set(ie,h),h},Te=this&&this.__classPrivateFieldGet||function(ie,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[211],Ee([0,1,3,6,50,5,7]),function(ie,e,h,M,b,T,F){"use strict";var C,_,P,t,E,n,f,l,s,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class I extends M.Disposable{constructor(m,k,i,u,r,o){super();C.set(this,void 0),_.set(this,void 0),P.set(this,void 0),t.set(this,void 0),E.set(this,!1),n.set(this,void 0),f.set(this,void 0),l.set(this,void 0),s.set(this,this._register(new h.Emitter)),this.onDidChangeVisibility=Te(this,s,"f").event,v.set(this,this._register(new h.Emitter)),this.onDidDispose=Te(this,v,"f").event,Je(this,P,i,"f"),Je(this,f,u,"f"),Je(this,C,m,"f"),Je(this,_,k,"f"),Je(this,t,r,"f"),Je(this,n,o,"f")}dispose(){Te(this,E,"f")||(Je(this,E,!0,"f"),Te(this,v,"f").fire(),Te(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Te(this,f,"f")}set title(m){this.assertNotDisposed(),Te(this,f,"f")!==m&&(Je(this,f,m,"f"),Te(this,_,"f").$setWebviewViewTitle(Te(this,C,"f"),m))}get description(){return this.assertNotDisposed(),Te(this,l,"f")}set description(m){this.assertNotDisposed(),Te(this,l,"f")!==m&&(Je(this,l,m,"f"),Te(this,_,"f").$setWebviewViewDescription(Te(this,C,"f"),m))}get visible(){return Te(this,n,"f")}get webview(){return Te(this,t,"f")}get viewType(){return Te(this,P,"f")}_setVisible(m){m===Te(this,n,"f")||Te(this,E,"f")||(Je(this,n,m,"f"),Te(this,s,"f").fire())}show(m){this.assertNotDisposed(),Te(this,_,"f").$show(Te(this,C,"f"),!!m)}assertNotDisposed(){if(Te(this,E,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,_=new WeakMap,P=new WeakMap,t=new WeakMap,E=new WeakMap,n=new WeakMap,f=new WeakMap,l=new WeakMap,s=new WeakMap,v=new WeakMap;class y{constructor(m,k){this._extHostWebview=k,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=m.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(m,k,i,u){if(this._viewProviders.has(k))throw new Error(`View provider for '${k}' already registered`);return this._viewProviders.set(k,{provider:i,extension:m}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(m),k,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new F.Disposable(()=>{this._viewProviders.delete(k),this._proxy.$unregisterWebviewViewProvider(k)})}async $resolveWebviewView(m,k,i,u,r){const o=this._viewProviders.get(k);if(!o)throw new Error(`No view provider found for '${k}'`);const{provider:w,extension:d}=o,g=this._extHostWebview.createNewWebview(m,{},d),S=new I(m,this._proxy,k,i,g,!0);this._webviewViews.set(m,S),await w.resolveWebviewView(S,{state:u},r)}async $onDidChangeWebviewViewVisibility(m,k){this.getWebviewView(m)._setVisible(k)}async $disposeWebviewView(m){const k=this.getWebviewView(m);this._webviewViews.delete(m),k.dispose(),this._extHostWebview.deleteWebview(m)}getWebviewView(m){const k=this._webviewViews.get(m);if(!k)throw new Error("No webview found");return k}}e.ExtHostWebviewViews=y}),define(be[97],Ee([0,1,3,5,2,11,9,4,12]),function(ie,e,h,M,b,T,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Ui{constructor(E){this._onDidChangeWindowState=new h.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=E.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(E){E!==this._state.focused&&(this._state={...this._state,focused:E},this._onDidChangeWindowState.fire(this._state))}openUri(E,n){let f;if(typeof E=="string"){f=E;try{E=b.URI.parse(E)}catch(l){return Promise.reject(`Invalid uri - '${E}'`)}}return(0,F.isFalsyOrWhitespace)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this._proxy.$openUri(E,f,n)}async asExternalUri(E,n){if((0,F.isFalsyOrWhitespace)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(E,n);return b.URI.from(f)}};P.InitialState={focused:!0},P=Ue([He(0,_.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(be[212],Ee([0,1,15,5,29,12]),function(ie,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=class extends h.AbstractLogger{constructor(_,P){super();this._proxy=_.getProxy(M.MainContext.MainThreadLog),this._logFile=P.logFile.toJSON(),this.setLevel(P.logLevel)}$setLevel(_){this.setLevel(_)}trace(_,...P){this.getLevel()<=h.LogLevel.Trace&&this._proxy.$log(this._logFile,h.LogLevel.Trace,Array.from(arguments))}debug(_,...P){this.getLevel()<=h.LogLevel.Debug&&this._proxy.$log(this._logFile,h.LogLevel.Debug,Array.from(arguments))}info(_,...P){this.getLevel()<=h.LogLevel.Info&&this._proxy.$log(this._logFile,h.LogLevel.Info,Array.from(arguments))}warn(_,...P){this.getLevel()<=h.LogLevel.Warning&&this._proxy.$log(this._logFile,h.LogLevel.Warning,Array.from(arguments))}error(_,...P){this.getLevel()<=h.LogLevel.Error&&this._proxy.$log(this._logFile,h.LogLevel.Error,Array.from(arguments))}critical(_,...P){this.getLevel()<=h.LogLevel.Critical&&this._proxy.$log(this._logFile,h.LogLevel.Critical,Array.from(arguments))}flush(){}};F=Ue([He(0,T.IExtHostRpcService),He(1,b.IExtHostInitDataService)],F),e.ExtHostLogService=F}),define(be[213],Ee([0,1,14,23,21,16,3,6,109,180,47]),function(ie,e,h,M,b,T,F,C,_,P,t){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(p,D){try{return JSON.stringify(p,D)}catch(c){return"null"}}const f="$$ref$$",l={[f]:-1};class s{constructor(D,c){this.jsonString=D,this.referencedBuffers=c}}function v(p,D=null,c=!1){const A=[];return{jsonString:(c?n:JSON.stringify)(p,(z,K)=>{if(typeof K=="undefined")return l;if(typeof K=="object"){if(K instanceof M.VSBuffer){const $=A.push(K)-1;return{[f]:$}}if(D)return D(z,K)}return K}),referencedBuffers:A}}e.stringifyJsonWithBufferRefs=v;function I(p,D,c){return JSON.parse(p,(A,O)=>{if(O){const z=O[f];if(typeof z=="number")return D[z];if(c&&O.$mid===1)return c.transformIncoming(O)}return O})}e.parseJsonAndRestoreBufferRefs=I;function y(p,D){return JSON.stringify(p,D)}function a(p){return p?(D,c)=>c&&c.$mid===1?p.transformOutgoing(c):c:null}var m;(function(p){p[p.LocalSide=0]="LocalSide",p[p.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));var k;(function(p){p[p.Responsive=0]="Responsive",p[p.Unresponsive=1]="Unresponsive"})(k=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},u=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class o extends C.Disposable{constructor(D,c=null,A=null){super();this[E]=!0,this._onDidChangeResponsiveState=this._register(new F.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=D,this._logger=c,this._uriTransformer=A,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let O=0,z=t.ProxyIdentifier.count;O<z;O++)this._locals[O]=null,this._proxies[O]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new h.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(O=>this._receiveOneMessage(O))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(D=>{this._pendingRPCReplies[D].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(D){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(D){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(D){this._responsiveState!==D&&(this._responsiveState=D,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(D){return this._uriTransformer?(0,_.transformIncomingURIs)(D,this._uriTransformer):D}getProxy(D){const{nid:c,sid:A}=D;return this._proxies[c]||(this._proxies[c]=this._createProxy(c,A)),this._proxies[c]}_createProxy(D,c){let A={get:(O,z)=>(typeof z=="string"&&!O[z]&&z.charCodeAt(0)===36&&(O[z]=(...K)=>this._remoteCall(D,z,K)),z===r?c:O[z])};return new Proxy(Object.create(null),A)}set(D,c){return this._locals[D.nid]=c,c}assertRegistered(D){for(let c=0,A=D.length;c<A;c++){const O=D[c];if(!this._locals[O.nid])throw new Error(`Missing actor ${O.sid} (isMain: ${O.isMain})`)}}_receiveOneMessage(D){if(this._isDisposed)return;const c=D.byteLength,A=w.read(D,0),O=A.readUInt8(),z=A.readUInt32();switch(O){case 1:case 2:{let{rpcId:K,method:$,args:Q}=g.deserializeRequestJSONArgs(A);this._uriTransformer&&(Q=(0,_.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveRequest(c,z,K,$,Q,O===2);break}case 3:case 4:{let{rpcId:K,method:$,args:Q}=g.deserializeRequestMixedArgs(A);this._uriTransformer&&(Q=(0,_.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveRequest(c,z,K,$,Q,O===4);break}case 5:{this._logger&&this._logger.logIncoming(c,z,0,"ack"),this._onDidReceiveAcknowledge(z);break}case 6:{this._receiveCancel(c,z);break}case 7:{this._receiveReply(c,z,void 0);break}case 9:{let K=g.deserializeReplyOKJSON(A);this._uriTransformer&&(K=(0,_.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReply(c,z,K);break}case 10:{const K=g.deserializeReplyOKJSONWithBuffers(A,this._uriTransformer);this._receiveReply(c,z,K);break}case 8:{let K=g.deserializeReplyOKVSBuffer(A);this._receiveReply(c,z,K);break}case 11:{let K=g.deserializeReplyErrError(A);this._uriTransformer&&(K=(0,_.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReplyErr(c,z,K);break}case 12:{this._receiveReplyErr(c,z,void 0);break}default:console.error("received unexpected message"),console.error(D)}}_receiveRequest(D,c,A,O,z,K){this._logger&&this._logger.logIncoming(D,c,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(A)}.${O}(`,z);const $=String(c);let Q,W;if(K){const H=new b.CancellationTokenSource;z.push(H.token),Q=this._invokeHandler(A,O,z),W=()=>H.cancel()}else Q=this._invokeHandler(A,O,z),W=i;this._cancelInvokedHandlers[$]=W;const U=g.serializeAcknowledged(c);this._logger&&this._logger.logOutgoing(U.byteLength,c,1,"ack"),this._protocol.send(U),Q.then(H=>{delete this._cancelInvokedHandlers[$];const G=g.serializeReplyOK(c,H,this._uriReplacer);this._logger&&this._logger.logOutgoing(G.byteLength,c,1,"reply:",H),this._protocol.send(G)},H=>{delete this._cancelInvokedHandlers[$];const G=g.serializeReplyErr(c,H);this._logger&&this._logger.logOutgoing(G.byteLength,c,1,"replyErr:",H),this._protocol.send(G)})}_receiveCancel(D,c){this._logger&&this._logger.logIncoming(D,c,1,"receiveCancel");const A=String(c);this._cancelInvokedHandlers[A]&&this._cancelInvokedHandlers[A]()}_receiveReply(D,c,A){this._logger&&this._logger.logIncoming(D,c,0,"receiveReply:",A);const O=String(c);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const z=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],z.resolveOk(A)}_receiveReplyErr(D,c,A){this._logger&&this._logger.logIncoming(D,c,0,"receiveReplyErr:",A);const O=String(c);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const z=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O];let K;A&&(A.$isError?(K=new Error,K.name=A.name,K.message=A.message,K.stack=A.stack):K=A),z.resolveErr(K)}_invokeHandler(D,c,A){try{return Promise.resolve(this._doInvokeHandler(D,c,A))}catch(O){return Promise.reject(O)}}_doInvokeHandler(D,c,A){const O=this._locals[D];if(!O)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(D));let z=O[c];if(typeof z!="function")throw new Error("Unknown method "+c+" on actor "+(0,t.getStringIdentifierForProxy)(D));return z.apply(O,A)}_remoteCall(D,c,A){if(this._isDisposed)return Promise.reject(T.canceled());let O=null;if(A.length>0&&b.CancellationToken.isCancellationToken(A[A.length-1])&&(O=A.pop()),O&&O.isCancellationRequested)return Promise.reject(T.canceled());const z=g.serializeRequestArguments(A,this._uriReplacer),K=++this._lastMessageId,$=String(K),Q=new P.LazyPromise;O&&O.onCancellationRequested(()=>{const U=g.serializeCancel(K);this._logger&&this._logger.logOutgoing(U.byteLength,K,0,"cancel"),this._protocol.send(g.serializeCancel(K))}),this._pendingRPCReplies[$]=Q,this._onWillSendRequest(K);const W=g.serializeRequest(K,D,c,z,!!O);return this._logger&&this._logger.logOutgoing(W.byteLength,K,0,`request: ${(0,t.getStringIdentifierForProxy)(D)}.${c}(`,A),this._protocol.send(W),Q}}e.RPCProtocol=o,E=u,o.UNRESPONSIVE_TIME=3*1e3;class w{constructor(D,c){this._buff=D,this._offset=c}static alloc(D,c,A){let O=new w(M.VSBuffer.alloc(A+1+4),0);return O.writeUInt8(D),O.writeUInt32(c),O}static read(D,c){return new w(D,c)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(D){this._buff.writeUInt8(D,this._offset),this._offset+=1}readUInt8(){const D=this._buff.readUInt8(this._offset);return this._offset+=1,D}writeUInt32(D){this._buff.writeUInt32BE(D,this._offset),this._offset+=4}readUInt32(){const D=this._buff.readUInt32BE(this._offset);return this._offset+=4,D}static sizeShortString(D){return 1+D.byteLength}writeShortString(D){this._buff.writeUInt8(D.byteLength,this._offset),this._offset+=1,this._buff.set(D,this._offset),this._offset+=D.byteLength}readShortString(){const D=this._buff.readUInt8(this._offset);this._offset+=1;const A=this._buff.slice(this._offset,this._offset+D).toString();return this._offset+=D,A}static sizeLongString(D){return 4+D.byteLength}writeLongString(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}readLongString(){const D=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+D).toString();return this._offset+=D,A}writeBuffer(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}static sizeVSBuffer(D){return 4+D.byteLength}writeVSBuffer(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}readVSBuffer(){const D=this._buff.readUInt32BE(this._offset);this._offset+=4;const c=this._buff.slice(this._offset,this._offset+D);return this._offset+=D,c}static sizeMixedArray(D){let c=0;c+=1;for(let A=0,O=D.length;A<O;A++){const z=D[A];switch(c+=1,z.type){case 1:c+=this.sizeLongString(z.value);break;case 2:c+=this.sizeVSBuffer(z.value);break;case 3:c+=this.sizeUInt32,c+=this.sizeLongString(z.value);for(let K=0;K<z.buffers.length;++K)c+=this.sizeVSBuffer(z.buffers[K]);break;case 4:break}}return c}writeMixedArray(D){this._buff.writeUInt8(D.length,this._offset),this._offset+=1;for(let c=0,A=D.length;c<A;c++){const O=D[c];switch(O.type){case 1:this.writeUInt8(1),this.writeLongString(O.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(O.value);break;case 3:this.writeUInt8(3),this.writeUInt32(O.buffers.length),this.writeLongString(O.value);for(let z=0;z<O.buffers.length;++z)this.writeBuffer(O.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const D=this._buff.readUInt8(this._offset);this._offset+=1;let c=new Array(D);for(let A=0;A<D;A++)switch(this.readUInt8()){case 1:c[A]=this.readLongString();break;case 2:c[A]=this.readVSBuffer();break;case 3:const z=this.readUInt32(),K=this.readLongString(),$=[];for(let Q=0;Q<z;++Q)$.push(this.readVSBuffer());c[A]=new t.SerializableObjectWithBuffers(I(K,$,null));break;case 4:c[A]=void 0;break}return c}}w.sizeUInt32=4;var d;(function(p){p[p.Simple=0]="Simple",p[p.Mixed=1]="Mixed"})(d||(d={}));class g{static _useMixedArgSerialization(D){for(let c=0,A=D.length;c<A;c++)if(D[c]instanceof M.VSBuffer||D[c]instanceof t.SerializableObjectWithBuffers||typeof D[c]=="undefined")return!0;return!1}static serializeRequestArguments(D,c){if(this._useMixedArgSerialization(D)){const A=[];for(let O=0,z=D.length;O<z;O++){const K=D[O];if(K instanceof M.VSBuffer)A[O]={type:2,value:K};else if(typeof K=="undefined")A[O]={type:4};else if(K instanceof t.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:Q}=v(K.value,c);A[O]={type:3,value:M.VSBuffer.fromString($),buffers:Q}}else A[O]={type:1,value:M.VSBuffer.fromString(y(K,c))}}return{type:1,args:A}}return{type:0,args:y(D,c)}}static serializeRequest(D,c,A,O,z){switch(O.type){case 0:return this._requestJSONArgs(D,c,A,O.args,z);case 1:return this._requestMixedArgs(D,c,A,O.args,z)}}static _requestJSONArgs(D,c,A,O,z){const K=M.VSBuffer.fromString(A),$=M.VSBuffer.fromString(O);let Q=0;Q+=w.sizeUInt8(),Q+=w.sizeShortString(K),Q+=w.sizeLongString($);let W=w.alloc(z?2:1,D,Q);return W.writeUInt8(c),W.writeShortString(K),W.writeLongString($),W.buffer}static deserializeRequestJSONArgs(D){const c=D.readUInt8(),A=D.readShortString(),O=D.readLongString();return{rpcId:c,method:A,args:JSON.parse(O)}}static _requestMixedArgs(D,c,A,O,z){const K=M.VSBuffer.fromString(A);let $=0;$+=w.sizeUInt8(),$+=w.sizeShortString(K),$+=w.sizeMixedArray(O);let Q=w.alloc(z?4:3,D,$);return Q.writeUInt8(c),Q.writeShortString(K),Q.writeMixedArray(O),Q.buffer}static deserializeRequestMixedArgs(D){const c=D.readUInt8(),A=D.readShortString(),O=D.readMixedArray(),z=new Array(O.length);for(let K=0,$=O.length;K<$;K++){const Q=O[K];typeof Q=="string"?z[K]=JSON.parse(Q):z[K]=Q}return{rpcId:c,method:A,args:z}}static serializeAcknowledged(D){return w.alloc(5,D,0).buffer}static serializeCancel(D){return w.alloc(6,D,0).buffer}static serializeReplyOK(D,c,A){if(typeof c=="undefined")return this._serializeReplyOKEmpty(D);if(c instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(D,c);if(c instanceof t.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:z}=v(c.value,A,!0);return this._serializeReplyOKJSONWithBuffers(D,O,z)}else return this._serializeReplyOKJSON(D,n(c,A))}static _serializeReplyOKEmpty(D){return w.alloc(7,D,0).buffer}static _serializeReplyOKVSBuffer(D,c){let A=0;A+=w.sizeVSBuffer(c);let O=w.alloc(8,D,A);return O.writeVSBuffer(c),O.buffer}static deserializeReplyOKVSBuffer(D){return D.readVSBuffer()}static _serializeReplyOKJSON(D,c){const A=M.VSBuffer.fromString(c);let O=0;O+=w.sizeLongString(A);let z=w.alloc(9,D,O);return z.writeLongString(A),z.buffer}static _serializeReplyOKJSONWithBuffers(D,c,A){const O=M.VSBuffer.fromString(c);let z=0;z+=w.sizeUInt32,z+=w.sizeLongString(O);for(const $ of A)z+=w.sizeVSBuffer($);let K=w.alloc(10,D,z);K.writeUInt32(A.length),K.writeLongString(O);for(const $ of A)K.writeBuffer($);return K.buffer}static deserializeReplyOKJSON(D){const c=D.readLongString();return JSON.parse(c)}static deserializeReplyOKJSONWithBuffers(D,c){const A=D.readUInt32(),O=D.readLongString(),z=[];for(let K=0;K<A;++K)z.push(D.readVSBuffer());return new t.SerializableObjectWithBuffers(I(O,z,c))}static serializeReplyErr(D,c){return c?this._serializeReplyErrEror(D,c):this._serializeReplyErrEmpty(D)}static _serializeReplyErrEror(D,c){const A=M.VSBuffer.fromString(n(T.transformErrorForSerialization(c),null));let O=0;O+=w.sizeLongString(A);let z=w.alloc(11,D,O);return z.writeLongString(A),z.buffer}static deserializeReplyErrError(D){const c=D.readLongString();return JSON.parse(c)}static _serializeReplyErrEmpty(D){return w.alloc(12,D,0).buffer}}var S;(function(p){p[p.RequestJSONArgs=1]="RequestJSONArgs",p[p.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",p[p.RequestMixedArgs=3]="RequestMixedArgs",p[p.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",p[p.Acknowledged=5]="Acknowledged",p[p.Cancel=6]="Cancel",p[p.ReplyOKEmpty=7]="ReplyOKEmpty",p[p.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",p[p.ReplyOKJSON=9]="ReplyOKJSON",p[p.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",p[p.ReplyErrError=11]="ReplyErrError",p[p.ReplyErrEmpty=12]="ReplyErrEmpty"})(S||(S={}));var R;(function(p){p[p.String=1]="String",p[p.VSBuffer=2]="VSBuffer",p[p.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",p[p.Undefined=4]="Undefined"})(R||(R={}))}),define(be[214],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const h=function(T){const F=C=>{self.removeEventListener("message",F);const _=C.data;Object.defineProperties(self,{postMessage:{value(P,t){_.postMessage(P,t)}},onmessage:{get(){return _.onmessage},set(P){_.onmessage=P}}}),_.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",F)}.toString();class M extends EventTarget{constructor(T,F,C){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${h})('${F}'))`,P=new Blob([_],{type:"application/javascript"}),t=URL.createObjectURL(P),E=new MessageChannel,n=t,f={type:"_newWorker",id:n,port:E.port2,url:t,options:C};T(f,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{const l={type:"_terminateWorker",id:n};E.port1.postMessage(l),URL.revokeObjectURL(t),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(l){E.port1.onmessage=l}},onmessageerror:{get(){return E.port1.onmessageerror},set(l){E.port1.onmessageerror=l}}}),E.port1.addEventListener("messageerror",l=>{const s=new MessageEvent("messageerror",{data:l.data});this.dispatchEvent(s)}),E.port1.addEventListener("message",l=>{const s=new MessageEvent("message",{data:l.data});this.dispatchEvent(s)}),E.port1.start()}}e.NestedWorker=M}),define(be[215],Ee([0,1,4]),function(ie,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,h.createDecorator)("remoteAgentService")}),define(be[216],Ee([0,1,11,17,26,2,4,86,45,176,215]),function(ie,e,h,M,b,T,F,C,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,F.createDecorator)("pathService");let E=class $i{constructor(f,l,s,v){this.localUserHome=f,this.remoteAgentService=l,this.environmentService=s,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||b.OS)(),this.resolveUserHome=(async()=>{const I=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=I?.userHome||f})()}get defaultUriScheme(){return $i.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,l){if(f.remoteAuthority)return h.Schemas.vscodeRemote;const s=(0,C.getVirtualWorkspaceScheme)(l.getWorkspace());if(s)return s;const v=l.getWorkspace().folders[0];if(v)return v.uri.scheme;const I=l.getWorkspace().configuration;return I?I.scheme:h.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?M.win32:M.posix)}async fileURI(f){let l="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const v=f.indexOf("/",2);v===-1?(l=f.substring(2),f="/"):(l=f.substring(2,v),f=f.substring(v)||"/")}return T.URI.from({scheme:h.Schemas.file,authority:l,path:f,query:"",fragment:""})}};E=Ue([He(1,t.IRemoteAgentService),He(2,P.IWorkbenchEnvironmentService),He(3,_.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(be[98],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class h{constructor(F,C){this.line=F,this.character=C}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,C){return new h(0,0)}with(F){return new h(0,0)}}e.Position=h;class M{constructor(F,C,_,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(F,C),this.end=new h(_,P)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new M(0,0,0,0)}with(F){return new M(0,0,0,0)}}e.Range=M;var b;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[39],Ee([0,1,13,27,22,41,9,4,17,16,98,10]),function(ie,e,h,M,b,T,F,C,_,P,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",f=" characters skipped \u27EB",l=(n.length+f.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var s;(function(U){U[U.file=0]="file",U[U.text=1]="text"})(s=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(U){U[U.File=1]="File",U[U.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function I(U){return!!U.preview}e.resultIsMatch=I;function y(U){return!!U.resource}e.isFileMatch=y;function a(U){return!!U.message}e.isProgressMessage=a;var m;(function(U){U[U.Normal=0]="Normal",U[U.NewSearchStarted=1]="NewSearchStarted"})(m=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class k{constructor(H){this.resource=H,this.results=[]}}e.FileMatch=k;class i{constructor(H,G,ue){this.ranges=G;const q=Array.isArray(G)?G:[G];if(ue&&ue.matchLines===1&&u(q)){H=(0,F.getNLines)(H,ue.matchLines);let le="",se=0,ve=0;const Fe=Math.floor(ue.charsPerLine/5),Me=[];for(const Ne of q){const Qe=Math.max(Ne.startColumn-Fe,0),ze=Ne.startColumn+ue.charsPerLine;if(Qe>ve+Fe+l){const qe=n+(Qe-ve)+f;le+=qe+H.slice(Qe,ze),se+=Qe-(ve+qe.length)}else le+=H.slice(ve,ze);Me.push(new o(0,Ne.startColumn-se,Ne.endColumn-se)),ve=ze}this.preview={text:le,matches:Array.isArray(this.ranges)?Me:Me[0]}}else{const le=Array.isArray(G)?G[0].startLineNumber:G.startLineNumber;this.preview={text:H,matches:(0,h.mapArrayOrNot)(G,se=>new r(se.startLineNumber-le,se.startColumn,se.endLineNumber-le,se.endColumn))}}}}e.TextSearchMatch=i;function u(U){const H=U[0].startLineNumber;for(const G of U)if(G.startLineNumber!==H||G.endLineNumber!==H)return!1;return!0}class r{constructor(H,G,ue,q){this.startLineNumber=H,this.startColumn=G,this.endLineNumber=ue,this.endColumn=q}}e.SearchRange=r;class o extends r{constructor(H,G,ue){super(H,G,H,ue)}}e.OneLineRange=o;var w;(function(U){U.Default="default",U.FileNames="fileNames",U.Type="type",U.Modified="modified",U.CountDescending="countDescending",U.CountAscending="countAscending"})(w=e.SearchSortOrder||(e.SearchSortOrder={}));function d(U,H=!0){const G=U&&U.files&&U.files.exclude,ue=H&&U&&U.search&&U.search.exclude;if(!G&&!ue)return;if(!G||!ue)return G||ue;let q=Object.create(null);return q=b.mixin(q,b.deepClone(G)),q=b.mixin(q,b.deepClone(ue),!0),q}e.getExcludes=d;function g(U,H){return U.excludePattern&&M.match(U.excludePattern,H)?!1:U.includePattern||U.usingSearchPaths?U.includePattern&&M.match(U.includePattern,H)?!0:U.usingSearchPaths?!!U.folderQueries&&U.folderQueries.some(G=>{const ue=G.folder.fsPath;if(T.isEqualOrParent(H,ue)){const q=_.relative(ue,H);return!G.includePattern||!!M.match(G.includePattern,q)}else return!1}):!1:!0}e.pathIncludedInQuery=g;var S;(function(U){U[U.unknownEncoding=1]="unknownEncoding",U[U.regexParseError=2]="regexParseError",U[U.globParseError=3]="globParseError",U[U.invalidLiteral=4]="invalidLiteral",U[U.rgProcessError=5]="rgProcessError",U[U.other=6]="other",U[U.canceled=7]="canceled"})(S=e.SearchErrorCode||(e.SearchErrorCode={}));class R extends Error{constructor(H,G){super(H);this.code=G}}e.SearchError=R;function p(U){const H=U.message;if((0,P.isPromiseCanceledError)(U))return new R(H,S.canceled);try{const G=JSON.parse(H);return new R(G.message,G.code)}catch(G){return new R(H,S.other)}}e.deserializeSearchError=p;function D(U){const H={message:U.message,code:U.code};return new Error(JSON.stringify(H))}e.serializeSearchError=D;function c(U){return U.type==="error"?!0:U.type==="success"}e.isSerializedSearchComplete=c;function A(U){return U.type==="success"}e.isSerializedSearchSuccess=A;function O(U){return!!U.path}e.isSerializedFileMatch=O;function z(U,H){const G=U.searchPath?U.searchPath:U.relativePath;return(0,F.fuzzyContains)(G,H)}e.isFilePatternMatch=z;class K{constructor(H){this.path=H,this.results=[]}addMatch(H){this.results.push(H)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=K;function $(U,H){const G={...U||{},...H||{}};return Object.keys(G).filter(ue=>{const q=G[ue];return typeof q=="boolean"&&q})}e.resolvePatternsForProvider=$;class Q{constructor(H,G){this._parsedIncludeExpression=null,this._excludeExpression={...H.excludePattern||{},...G.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let ue=H.includePattern;G.includePattern&&(ue?ue={...ue,...G.includePattern}:ue=G.includePattern),ue&&(this._parsedIncludeExpression=M.parse(ue))}includedInQuerySync(H,G,ue){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(H,G,ue)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(H,G,ue))}includedInQuery(H,G,ue){const q=this._parsedExcludeExpression(H,G,ue),le=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(H,G,ue):!0;return(0,E.isPromise)(q)?q.then(se=>se?!1:le()):le()}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=Q;function W(U){for(const H in U)if(typeof U[H]!="boolean")return!0;return!1}}),define(be[31],Ee([0,1,13,14,21,3,20,11,75,24,9,10,2,130,4,15,145,45,37,29,12,7,39,5]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l,s,v,I,y,a,m,k,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(D,c,A){return new P.ExtUri(O=>g(O,A)).isEqual(D,c)}function o(D,c,A){return r(D.uri,c.uri,A)?0:(0,t.compare)(D.uri.toString(),c.uri.toString())}function w(D,c,A){return D.index!==c.index?D.index<c.index?-1:1:r(D.uri,c.uri,A)?(0,t.compare)(D.name,c.name):(0,t.compare)(D.uri.toString(),c.uri.toString())}function d(D,c,A,O){const z=D.slice(0).sort(($,Q)=>A($,Q,O)),K=c.slice(0).sort(($,Q)=>A($,Q,O));return(0,h.delta)(z,K,($,Q)=>A($,Q,O))}function g(D,c){const A=c.getCapabilities(D.scheme);return!(A&&A&1024)}class S extends I.Workspace{constructor(c,A,O,z,K,$){super(c,O.map(Q=>new I.WorkspaceFolder(Q)),z,$);this._name=A,this._isUntitled=K,this._workspaceFolders=[],this._structure=F.TernarySearchTree.forUris($),O.forEach(Q=>{this._workspaceFolders.push(Q),this._structure.set(Q.uri,Q)})}static toExtHostWorkspace(c,A,O,z){if(!c)return{workspace:null,added:[],removed:[]};const{id:K,name:$,folders:Q,configuration:W,isUntitled:U}=c,H=[],G=A;A?Q.forEach((se,ve)=>{const Fe=n.URI.revive(se.uri),Me=S._findFolder(O||A,Fe,z);Me?(Me.name=se.name,Me.index=se.index,H.push(Me)):H.push({uri:Fe,name:se.name,index:ve})}):H.push(...Q.map(({uri:se,name:ve,index:Fe})=>({uri:n.URI.revive(se),name:ve,index:Fe}))),H.sort((se,ve)=>se.index<ve.index?-1:1);const ue=new S(K,$,H,W?n.URI.revive(W):null,!!U,se=>g(se,z)),{added:q,removed:le}=d(G?G.workspaceFolders:[],ue.workspaceFolders,o,z);return{workspace:ue,added:q,removed:le}}static _findFolder(c,A,O){for(let z=0;z<c.folders.length;z++){const K=c.workspaceFolders[z];if(r(K.uri,A,O))return K}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(c,A){return A&&this._structure.get(c)&&(c=(0,P.dirname)(c)),this._structure.findSubstr(c)}resolveWorkspaceFolder(c){return this._structure.get(c)}}let R=class{constructor(c,A,O,z){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=z,this._extHostFileSystemInfo=O,this._requestIdProvider=new _.Counter,this._barrier=new M.Barrier,this._proxy=c.getProxy(u.MainContext.MainThreadWorkspace),this._messageService=c.getProxy(u.MainContext.MainThreadMessageService);const K=A.workspace;this._confirmedWorkspace=K?new S(K.id,K.name,[],K.configuration?n.URI.revive(K.configuration):null,!!K.isUntitled,$=>g($,O)):void 0}$initializeWorkspace(c,A){this._trusted=A,this.$acceptWorkspaceData(c),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:C.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(c,A,O,...z){const K=[];if(Array.isArray(z)&&z.forEach(H=>{n.URI.isUri(H.uri)&&!K.some(G=>r(G.uri,H.uri,this._extHostFileSystemInfo))&&K.push({uri:H.uri,name:H.name||(0,P.basenameOrAuthority)(H.uri)})}),this._unconfirmedWorkspace||[A,O].some(H=>typeof H!="number"||H<0)||O===0&&K.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(A+O>$.length)return!1;const Q=$.slice(0);Q.splice(A,O,...K.map(H=>({uri:H.uri,name:H.name||(0,P.basenameOrAuthority)(H.uri),index:void 0})));for(let H=0;H<Q.length;H++){const G=Q[H];if(Q.some((ue,q)=>q!==H&&r(G.uri,ue.uri,this._extHostFileSystemInfo)))return!1}Q.forEach((H,G)=>H.index=G);const{added:W,removed:U}=d($,Q,w,this._extHostFileSystemInfo);if(W.length===0&&U.length===0)return!1;if(this._proxy){const H=c.displayName||c.name;this._proxy.$updateWorkspaceFolders(H,A,O,K).then(void 0,G=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,f.localize)(0,null,H,G.toString()),{extension:c},[])})}return this.trySetWorkspaceFolders(Q),!0}getWorkspaceFolder(c,A){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(c,A)}async getWorkspaceFolder2(c,A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(c,A)}async resolveWorkspaceFolder(c){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(c)}getPath(){if(!this._actualWorkspace)return;const{folders:c}=this._actualWorkspace;if(c.length!==0)return c[0].uri.fsPath}getRelativePath(c,A){let O,z="";if(typeof c=="string"?(O=n.URI.file(c),z=c):typeof c!="undefined"&&(O=c,z=c.fsPath),!O)return z;const K=this.getWorkspaceFolder(O,!0);if(!K)return z;typeof A=="undefined"&&this._actualWorkspace&&(A=this._actualWorkspace.folders.length>1);let $=(0,P.relativePath)(K.uri,O);return A&&K.name&&($=`${K.name}/${$}`),$}trySetWorkspaceFolders(c){this._actualWorkspace&&(this._unconfirmedWorkspace=S.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:c,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(c){const{workspace:A,added:O,removed:z}=S.toExtHostWorkspace(c,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=A||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:z}))}findFiles(c,A,O,z,K=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let $;if(A===null?$=!1:A&&(typeof A=="string"?$=A:$=A.pattern),K&&K.isCancellationRequested)return Promise.resolve([]);const{includePattern:Q,folder:W}=p(c);return this._proxy.$startFileSearch((0,E.withUndefinedAsNull)(Q),(0,E.withUndefinedAsNull)(W),(0,E.withUndefinedAsNull)($),(0,E.withUndefinedAsNull)(O),K).then(U=>Array.isArray(U)?U.map(H=>n.URI.revive(H)):[])}async findTextInFiles(c,A,O,z,K=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),Q=typeof A.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:A.previewOptions,{includePattern:W,folder:U}=p(A.include),H=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,G={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!0,fileEncoding:A.encoding,maxResults:A.maxResults,previewOptions:Q,afterContext:A.afterContext,beforeContext:A.beforeContext,includePattern:W,excludePattern:H},ue=!1;if(this._activeSearchCallbacks[$]=q=>{if(ue)return;const le=n.URI.revive(q.resource);q.results.forEach(se=>{(0,i.resultIsMatch)(se)?O({uri:le,preview:{text:se.preview.text,matches:(0,h.mapArrayOrNot)(se.preview.matches,ve=>new k.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,h.mapArrayOrNot)(se.ranges,ve=>new k.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):O({uri:le,text:se.text,lineNumber:se.lineNumber})})},K.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(c,(0,E.withUndefinedAsNull)(U),G,$,K);return delete this._activeSearchCallbacks[$],q||{}}catch(q){throw delete this._activeSearchCallbacks[$],q}}$handleTextSearchResult(c,A){this._activeSearchCallbacks[A]&&this._activeSearchCallbacks[A](c)}saveAll(c){return this._proxy.$saveAll(c)}resolveProxy(c){return this._proxy.$resolveProxy(c)}get trusted(){return this._trusted}requestWorkspaceTrust(c){return this._proxy.$requestWorkspaceTrust(c)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};R=Ue([He(0,m.IExtHostRpcService),He(1,a.IExtHostInitDataService),He(2,y.IExtHostFileSystemInfo),He(3,s.ILogService)],R),e.ExtHostWorkspace=R,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function p(D){let c,A;return D&&(typeof D=="string"?c=D:(c=D.pattern,A=D.baseFolder||n.URI.file(D.base))),{includePattern:c,folder:A}}}),define(be[32],Ee([0,1,22,3,31,5,7,148,62,10,14,4,12,15,2]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function s(u,r){if(r){const o=r.split(".");let w=u;for(let d=0;w&&d<o.length;d++)w=w[o[d]];return w}}function v(u){return u instanceof l.URI}function I(u){return u&&u.uri instanceof l.URI&&u.languageId&&typeof u.languageId=="string"}function y(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function a(u){return u&&u.uri instanceof l.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function m(u){if(v(u))return{resource:u};if(I(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(y(u))return{overrideIdentifier:u.languageId};if(a(u))return{resource:u.uri};if(u===null)return{resource:null}}let k=class{constructor(r,o,w){this._proxy=r.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=w,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new i(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,o){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(r,o))}};k=Ue([He(0,n.IExtHostRpcService),He(1,b.IExtHostWorkspace),He(2,f.ILogService)],k),e.ExtHostConfiguration=k;class i{constructor(r,o,w,d){this._onDidChangeConfiguration=new M.Emitter,this._proxy=r,this._logService=d,this._extHostWorkspace=o,this._configuration=C.Configuration.parse(w),this._configurationScopes=this._toMap(w.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,o){const w={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,w))}getConfiguration(r,o,w){const d=m(o)||{},g=this._toReadonlyValue(r?s(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,d,w?.identifier);function S(p){if(p==null)return null;if(typeof p=="boolean")return p?1:4;switch(p){case F.ConfigurationTarget.Global:return 1;case F.ConfigurationTarget.Workspace:return 4;case F.ConfigurationTarget.WorkspaceFolder:return 5}}const R={has(p){return typeof s(g,p)!="undefined"},get:(p,D)=>{this._validateConfigurationAccess(r?`${r}.${p}`:p,d,w?.identifier);let c=s(g,p);if(typeof c=="undefined")c=D;else{let A;const O=(z,K)=>{let $;const Q=()=>{A=A||(0,h.deepClone)(g),$=$||s(A,K)};return(0,P.isObject)(z)?new Proxy(z,{get:(W,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return Q(),()=>$;if(A)return $=$||s(A,K),$[U];const H=W[U];return typeof U=="string"?O(H,`${K}.${U}`):H},set:(W,U,H)=>(Q(),$&&($[U]=H),!0),deleteProperty:(W,U)=>(Q(),$&&delete $[U],!0),defineProperty:(W,U,H)=>(Q(),$&&Object.defineProperty($,U,H),!0)}):z};c=O(c,p)}return c},update:(p,D,c,A)=>{p=r?`${r}.${p}`:p;const O=S(c);return D!==void 0?this._proxy.$updateConfigurationOption(O,p,D,d,A):this._proxy.$removeConfigurationOption(O,p,d,A)},inspect:p=>{p=r?`${r}.${p}`:p;const D=(0,h.deepClone)(this._configuration.inspect(p,d,this._extHostWorkspace.workspace));if(D)return{key:p,defaultValue:D.default?.value,globalValue:D.user?.value,workspaceValue:D.workspace?.value,workspaceFolderValue:D.workspaceFolder?.value,defaultLanguageValue:D.default?.override,globalLanguageValue:D.user?.override,workspaceLanguageValue:D.workspace?.override,workspaceFolderLanguageValue:D.workspaceFolder?.override,languageIds:D.overrideIdentifiers}}};return typeof g=="object"&&(0,h.mixin)(R,g,!1),Object.freeze(R)}_toReadonlyValue(r){const o=w=>(0,P.isObject)(w)?new Proxy(w,{get:(d,g)=>o(d[g]),set:(d,g,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(d,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(d,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return o(r)}_validateConfigurationAccess(r,o,w){const d=_.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),g=w?`[${w.value}] `:"";if(d===4){typeof o?.resource=="undefined"&&this._logService.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){o?.resource&&this._logService.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,o){const w=new C.ConfigurationChangeEvent(r,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,g)=>w.affectsConfiguration(d,m(g))})}_toMap(r){return r.reduce((o,w)=>(o.set(w[0],w[1]),o),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,E.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ie,h):b?b.value=h:e.set(ie,h),h},Te=this&&this.__classPrivateFieldGet||function(ie,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[99],Ee([0,1,2,14,3,5,7,31,49,32,21,38,12,29,4,11,26,15,70,166,16]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l,s,v,I,y,a,m){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(K){function $(W){if(W!=null)return W}K.from=$;function Q(W){if(W!=null)return W}K.to=Q})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function(K){function $(W){if(W!=null)return W}K.from=$;function Q(W){if(W!=null)return W}K.to=Q})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(K){function $(W){if(W!=null)return W}K.from=$;function Q(W){if(W!=null)return W}K.to=Q})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function(K){function $(U){if(U){const H=U;return H&&!!H.process}else return!1}K.is=$;function Q(U){if(U==null)return;const H={process:U.process,args:U.args};return U.options&&(H.options=r.from(U.options)),H}K.from=Q;function W(U){if(U!=null)return new F.ProcessExecution(U.process,U.args,U.options)}K.to=W})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var w;(function(K){function $(W){if(W!=null)return W}K.from=$;function Q(W){if(W!=null)return W}K.to=Q})(w=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(K){function $(U){if(U){const H=U;return H&&(!!H.commandLine||!!H.command)}else return!1}K.is=$;function Q(U){if(U==null)return;const H={};return U.commandLine!==void 0?H.commandLine=U.commandLine:(H.command=U.command,H.args=U.args),U.options&&(H.options=w.from(U.options)),H}K.from=Q;function W(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new F.ShellExecution(U.commandLine,U.options):new F.ShellExecution(U.command,U.args?U.args:[],U.options)}K.to=W})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var g;(function(K){function $(U){if(U){let H=U;return H&&H.customExecution==="customExecution"}else return!1}K.is=$;function Q(U){return{customExecution:"customExecution"}}K.from=Q;function W(U,H){return H.get(U)}K.to=W})(g=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var S;(function(K){function $(Q,W){let U;return Q.scope!==void 0&&typeof Q.scope!="number"?U=Q.scope.uri:Q.scope!==void 0&&typeof Q.scope=="number"&&(Q.scope===F.TaskScope.Workspace&&W&&W.workspaceFile?U=W.workspaceFile:U=a.USER_TASKS_GROUP_KEY),{id:Q._id,workspaceFolder:U}}K.from=$})(S=e.TaskHandleDTO||(e.TaskHandleDTO={}));var R;(function(K){function $(Q){if(Q!=null)return{_id:Q.id,isDefault:Q.isDefault}}K.from=$})(R=e.TaskGroupDTO||(e.TaskGroupDTO={}));var p;(function(K){function $(U,H){if(U==null)return[];const G=[];for(let ue of U){const q=Q(ue,H);q&&G.push(q)}return G}K.fromMany=$;function Q(U,H){if(U==null)return;let G;U.execution instanceof F.ProcessExecution?G=o.from(U.execution):U.execution instanceof F.ShellExecution?G=d.from(U.execution):U.execution&&U.execution instanceof F.CustomExecution&&(G=g.from(U.execution));const ue=i.from(U.definition);let q;return U.scope?typeof U.scope=="number"?q=U.scope:q=U.scope.uri:q=F.TaskScope.Workspace,!ue||!q?void 0:{_id:U._id,definition:ue,name:U.name,source:{extensionId:H.identifier.value,label:U.source,scope:q},execution:G,isBackground:U.isBackground,group:R.from(U.group),presentationOptions:u.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}K.from=Q;async function W(U,H,G){if(U==null)return;let ue;o.is(U.execution)?ue=o.to(U.execution):d.is(U.execution)?ue=d.to(U.execution):g.is(U.execution)&&(ue=g.to(U._id,G));const q=i.to(U.definition);let le;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?le=U.source.scope:le=await H.resolveWorkspaceFolder(h.URI.revive(U.source.scope)):le=F.TaskScope.Workspace),!q||!le)return;const se=new F.Task(q,le,U.name,U.source.label,ue,U.problemMatchers);return U.isBackground!==void 0&&(se.isBackground=U.isBackground),U.group!==void 0&&(se.group=F.TaskGroup.from(U.group._id),se.group&&(se.group=new F.TaskGroup(se.group.id,se.group.label),U.group.isDefault&&(se.group.isDefault=U.group.isDefault))),U.presentationOptions&&(se.presentationOptions=u.to(U.presentationOptions)),U._id&&(se._id=U._id),U.detail&&(se.detail=U.detail),se}K.to=W})(p=e.TaskDTO||(e.TaskDTO={}));var D;(function(K){function $(W){return W}K.from=$;function Q(W){if(!!W)return Object.assign(Object.create(null),W)}K.to=Q})(D=e.TaskFilterDTO||(e.TaskFilterDTO={}));class c{constructor($,Q,W){this._id=Q,this._task=W,k.set(this,void 0),Je(this,k,$,"f")}get task(){return this._task}terminate(){Te(this,k,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}k=new WeakMap;var A;(function(K){function $(Q){return{id:Q._id,task:void 0}}K.from=$})(A=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let O=class{constructor($,Q,W,U,H,G,ue,q){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=$.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=U,this._configurationService=H,this._terminalService=G,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ue,this._deprecationService=q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider($,Q,W){if(!W)return new F.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:Q,provider:W,extension:$}),this._proxy.$registerTaskProvider(U,Q),new F.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem($,Q){this._proxy.$registerTaskSystem($,Q)}fetchTasks($){return this._proxy.$fetchTasks(D.from($)).then(async Q=>{const W=[];for(let U of Q){const H=await p.to(U,this._workspaceProvider,this._providedCustomExecutions2);H&&W.push(H)}return W})}get taskExecutions(){const $=[];return this._taskExecutions.forEach(Q=>$.push(Q)),$}terminateTask($){if(!($ instanceof c))throw new Error("No valid task execution provided");return this._proxy.$terminateTask($._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask($,Q,W){const U=this._providedCustomExecutions2.get($.id);if(U){if(this._activeCustomExecutions2.get($.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set($.id,U),this._terminalService.attachPtyToTerminal(Q,await U.callback(W))}this._lastStartedTask=$.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution($)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask($){const Q=await this.getTaskExecution($);this._taskExecutionPromises.delete($.id),this._taskExecutions.delete($.id),this.customExecutionComplete($),this._onDidTerminateTask.fire({execution:Q})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess($){const Q=await this.getTaskExecution($.id);this._onDidTaskProcessStarted.fire({execution:Q,processId:$.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess($){const Q=await this.getTaskExecution($.id);this._onDidTaskProcessEnded.fire({execution:Q,exitCode:$.exitCode})}$provideTasks($,Q){const W=this._handlers.get($);if(!W)return Promise.reject(new Error("no handler found"));const U=[],H=(0,M.asPromise)(()=>W.provider.provideTasks(t.CancellationToken.None)).then(G=>this.provideTasksInternal(Q,U,W,G));return new Promise(G=>{H.then(ue=>{Promise.all(U).then(()=>{G(ue)})})})}async $resolveTask($,Q){const W=this._handlers.get($);if(!W)return Promise.reject(new Error("no handler found"));if(Q.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${Q.definition.type}] cannot be resolved by provider of type [${W.type}].`);const U=await p.to(Q,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const H=await W.provider.resolveTask(U,t.CancellationToken.None);if(!H)return;this.checkDeprecation(H,W);const G=p.from(H,W.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(G.execution)&&await this.addCustomExecution(G,H,!0),await this.resolveTaskInternal(G)}nextHandle(){return this._handleCounter++}async addCustomExecution($,Q,W){const U=await this._proxy.$createTaskId($);!W&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,Q.execution)}async getTaskExecution($,Q){if(typeof $=="string"){const H=this._taskExecutionPromises.get($);if(!H)throw new Error("Unexpected: The specified task is missing an execution");return H}let W=this._taskExecutionPromises.get($.id);if(W)return W;const U=new Promise(async(H,G)=>{const ue=Q||await p.to($.task,this._workspaceProvider,this._providedCustomExecutions2);ue?H(new c(this,$.id,ue)):G("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set($.id,U),U.then(H=>(this._taskExecutions.set($.id,H),H),H=>Promise.reject(H))}checkDeprecation($,Q){$._deprecated&&this._deprecationService.report("Task.constructor",Q.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete($){this._activeCustomExecutions2.get($.id)&&this._activeCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.has($.id)&&this._lastStartedTask!==$.id&&(this._providedCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.delete($.id));let W=this._notProvidedCustomExecutions.values(),U=W.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=W.next()}};O=Ue([He(0,n.IExtHostRpcService),He(1,f.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,_.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,E.IExtHostTerminalService),He(6,I.ILogService),He(7,y.IExtHostApiDeprecationService)],O),e.ExtHostTaskBase=O;let z=class extends O{constructor($,Q,W,U,H,G,ue,q){super($,Q,W,U,H,G,ue,q);this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask($,Q){if(!Q.execution)throw new Error("Tasks to execute must include an execution");const W=p.from(Q,$);if(W===void 0)throw new Error("Task is not valid");if(g.is(W.execution))await this.addCustomExecution(W,Q,!1);else throw new m.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),Q);return this._proxy.$executeTask(W).catch(H=>{throw new Error(H)}),U}provideTasksInternal($,Q,W,U){const H=[];if(U)for(let G of U){this.checkDeprecation(G,W),(!G.definition||!$[G.definition.type])&&this._logService.warn(`The task [${G.source}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`);const ue=p.from(G,W.extension);ue&&g.is(ue.execution)?(H.push(ue),Q.push(this.addCustomExecution(ue,G,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:H,extension:W.extension}}async resolveTaskInternal($){if(g.is($.execution))return $;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables($,Q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,Q,W){}};z=Ue([He(0,n.IExtHostRpcService),He(1,f.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,_.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,E.IExtHostTerminalService),He(6,I.ILogService),He(7,y.IExtHostApiDeprecationService)],z),e.WorkerExtHostTask=z,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")}),define(be[217],Ee([0,1,13,51,27,77,20,11,17,24,9,10,2,111,134,84,45,92,216,39]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l,s,v,I,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(S,R,p,D){this.configurationService=S,this.workspaceContextService=R,this.editorGroupsService=p,this.pathService=D}text(S,R,p={}){S=this.getContentPattern(S,p);const D=this.configurationService.getValue(),c=R&&R.some(O=>!this.configurationService.getValue({resource:O}).search.useRipgrep);return{...this.commonQuery(R?.map(v.toWorkspaceFolder),p),type:2,contentPattern:S,previewOptions:p.previewOptions,maxFileSize:p.maxFileSize,usePCRE2:D.search.usePCRE2||c||!1,beforeContext:p.beforeContext,afterContext:p.afterContext,userDisabledExcludesAndIgnoreFiles:p.disregardExcludeSettings&&p.disregardIgnoreFiles}}getContentPattern(S,R){const p=this.configurationService.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const D={...S,wordSeparators:p.editor.wordSeparators};return this.isCaseSensitive(S,R)&&(D.isCaseSensitive=!0),this.isMultiline(S)&&(D.isMultiline=!0),D}file(S,R={}){return{...this.commonQuery(S,R),type:1,filePattern:R.filePattern?R.filePattern.trim():R.filePattern,exists:R.exists,sortByScore:R.sortByScore,cacheKey:R.cacheKey}}handleIncludeExclude(S,R){return S?(S=Array.isArray(S)?S.map(o):o(S),R?this.parseSearchPaths(S):{pattern:i(...Array.isArray(S)?S:[S])}):{}}commonQuery(S=[],R={}){const p=this.handleIncludeExclude(R.includePattern,R.expandPatterns),D=this.handleIncludeExclude(R.excludePattern,R.expandPatterns),c=S.length>1,A=(p.searchPaths&&p.searchPaths.length?p.searchPaths.map(K=>this.getFolderQueryForSearchPath(K,R,D)):S.map(K=>this.getFolderQueryForRoot(K,R,D,c))).filter(K=>!!K),O={_reason:R._reason,folderQueries:A,usingSearchPaths:!!(p.searchPaths&&p.searchPaths.length),extraFileResources:R.extraFileResources,excludePattern:D.pattern,includePattern:p.pattern,onlyOpenEditors:R.onlyOpenEditors,maxResults:R.maxResults};if(R.onlyOpenEditors){const $=h.coalesce(h.flatten(this.editorGroupsService.groups.map(W=>W.editors.map(U=>U.resource)))).filter(W=>(0,a.pathIncludedInQuery)(O,W.fsPath)),Q=this.commonQueryFromFileList($);return{...O,...Q}}const z=R.extraFileResources&&R.extraFileResources.filter(K=>(0,a.pathIncludedInQuery)(O,K.fsPath));return O.extraFileResources=z&&z.length?z:void 0,O}commonQueryFromFileList(S){const R=[],p=new F.ResourceMap,D={};let c=!1;return S.forEach(A=>{if(A.scheme===C.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(A)){const z=this.workspaceContextService.getWorkspaceFolder(A)?.uri??A.with({path:_.dirname(A.fsPath)});let K=p.get(z);K||(c=!0,K={folder:z,includePattern:{}},R.push(K),p.set(z,K));const $=_.relative(z.fsPath,A.fsPath);(0,E.assertIsDefined)(K.includePattern)[$.replace(/\\/g,"/")]=!0}else A.fsPath&&(c=!0,D[A.fsPath]=!0)}),{folderQueries:R,includePattern:D,usingSearchPaths:!0,excludePattern:c?void 0:{"**/*":!0}}}isCaseSensitive(S,R){if(R.isSmartCase){if(S.isRegExp){if(t.containsUppercaseCharacter(S.pattern,!0))return!0}else if(t.containsUppercaseCharacter(S.pattern))return!0}return!!S.isCaseSensitive}isMultiline(S){return S.isMultiline||S.isRegExp&&(0,f.isMultilineRegexSource)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const R=Q=>_.isAbsolute(Q)||/^\.\.?([\/\\]|$)/.test(Q),D=(Array.isArray(S)?S:u(S)).map(Q=>{const W=this.pathService.resolvedUserHome;return W?(0,T.untildify)(Q,W.scheme===C.Schemas.file?W.fsPath:W.path):Q}),c=M.groupBy(D,Q=>R(Q)?"searchPaths":"exprSegments"),A=(c.exprSegments||[]).map(Q=>t.rtrim(Q,"/")).map(Q=>t.rtrim(Q,"\\")).map(Q=>(Q[0]==="."&&(Q="*"+Q),r(Q))),O={},z=this.expandSearchPathPatterns(c.searchPaths||[]);z&&z.length&&(O.searchPaths=z);const K=h.flatten(A),$=i(...K);return $&&(O.pattern=$),O}getExcludesForFolder(S,R){return R.disregardExcludeSettings?void 0:(0,a.getExcludes)(S,!R.disregardSearchExcludeSettings)}expandSearchPathPatterns(S){if(!S||!S.length)return[];const R=h.flatten(S.map(D=>{let{pathPortion:c,globPortion:A}=k(D);A&&(A=w(A));const O=this.expandOneSearchPath(c);return h.flatten(O.map(z=>this.resolveOneSearchPathPattern(z,A)))})),p=new Map;return R.forEach(D=>{const c=D.searchPath.toString(),A=p.get(c);A?D.pattern&&(A.pattern=A.pattern||{},A.pattern[D.pattern]=!0):p.set(c,{searchPath:D.searchPath,pattern:D.pattern?i(D.pattern):void 0})}),Array.from(p.values())}expandOneSearchPath(S){if(_.isAbsolute(S)){const R=this.workspaceContextService.getWorkspace().folders;return R[0]&&R[0].uri.scheme!==C.Schemas.file?[{searchPath:R[0].uri.with({path:S})}]:[{searchPath:n.URI.file(_.normalize(S))}]}if(this.workspaceContextService.getWorkbenchState()===2){const R=this.workspaceContextService.getWorkspace().folders[0].uri;if(S=o(S),S.startsWith("../")||S===".."){const D=_.posix.resolve(R.path,S);return[{searchPath:R.with({path:D})}]}const p=w(S);return[{searchPath:R,pattern:p}]}else{if(S==="./"||S===".\\")return[];{const R=S.replace(/^\.[\/\\]/,""),D=this.workspaceContextService.getWorkspace().folders.map(c=>{const A=R.match(new RegExp(`^${t.escapeRegExpCharacters(c.name)}(?:/(.*)|$)`));return A?{match:A,folder:c}:null}).filter(E.isDefined);if(D.length)return D.map(c=>{const A=c.match[1];return{searchPath:c.folder.uri,pattern:A&&w(A)}});{const c=S.match(/\.[\/\\](.+)[\/\\]?/),A=c?c[1]:S,O=l.localize(0,null,A);throw new Error(O)}}}}resolveOneSearchPathPattern(S,R){const p=S.pattern&&R?`${S.pattern}/${R}`:S.pattern||R,D=[{searchPath:S.searchPath,pattern:p}];return p&&!p.endsWith("**")&&D.push({searchPath:S.searchPath,pattern:p+"/**"}),D}getFolderQueryForSearchPath(S,R,p){const D=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(S.searchPath),R,p,!1);return D?{...D,includePattern:S.pattern}:null}getFolderQueryForRoot(S,R,p,D){let c;const A=n.URI.isUri(S)?S:S.uri;if(p.searchPaths){const Q=p.searchPaths.filter(W=>(0,P.isEqual)(W.searchPath,A))[0];if(Q&&!Q.pattern)return null;Q&&(c=Q.pattern)}const O=this.configurationService.getValue({resource:A}),K={...this.getExcludesForFolder(O,R)||{},...c||{}},$=n.URI.isUri(S)?(0,P.basename)(S):S.name;return{folder:A,folderName:D?$:void 0,excludePattern:Object.keys(K).length>0?K:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof R.disregardIgnoreFiles=="boolean"?R.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof R.disregardGlobalIgnoreFiles=="boolean"?R.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof R.ignoreSymlinks=="boolean"?R.ignoreSymlinks:!O.search.followSymlinks}}};m=Ue([He(0,s.IConfigurationService),He(1,v.IWorkspaceContextService),He(2,I.IEditorGroupsService),He(3,y.IPathService)],m),e.QueryBuilder=m;function k(g){const S=g.match(/[\*\{\}\(\)\[\]\?]/);if(S){const R=S.index,p=g.substr(0,R).match(/[/|\\][^/\\]*$/);if(p){let D=g.substr(0,p.index);return D.match(/[/\\]/)||(D+="/"),{pathPortion:D,globPortion:g.substr((p.index||0)+1)}}}return{pathPortion:g}}function i(...g){return g.length?g.reduce((S,R)=>(S[R]=!0,S),Object.create(null)):void 0}function u(g){return b.splitGlobAware(g,",").map(S=>S.trim()).filter(S=>!!S.length)}function r(g){return[`**/${g}/**`,`**/${g}`].map(R=>R.replace(/\*\*\/\*\*/g,"**"))}function o(g){return g.replace(/\\/g,"/")}function w(g){return o(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(g,S){g=h.distinct(g,D=>D.toString());const R=[],p=S.getWorkspace();return g&&g.forEach(D=>{let c;if(S.getWorkbenchState()===2)c=(0,P.relativePath)(p.folders[0].uri,D),c&&c!=="."&&(c="./"+c);else{const A=S.getWorkspaceFolder(D);if(A){const O=A.name;if(p.folders.filter(K=>K.name===O).length===1){const K=(0,P.relativePath)(A.uri,D);K===""?c=`./${A.name}`:c=`./${A.name}/${K}`}else c=D.fsPath}}c&&R.push(c)}),R}e.resolveResourcesForSearchIncludes=d}),define(be[218],Ee([0,1,24,2,21,16,4,217,39,45]),function(ie,e,h,M,b,T,F,C,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function E(s,v){const I=v.activationEvents;if(!I)return Promise.resolve(void 0);const y=[],a=[];for(const o of I)if(/^workspaceContains:/.test(o)){const w=o.substr("workspaceContains:".length);w.indexOf("*")>=0||w.indexOf("?")>=0||s.forceUsingSearch?a.push(w):y.push(w)}if(y.length===0&&a.length===0)return Promise.resolve(void 0);let m;const k=new Promise((o,w)=>{m=o}),i=o=>m({activationEvent:o}),u=Promise.all(y.map(o=>n(s,o,i))).then(()=>{}),r=f(s,v.identifier,a,i);return Promise.all([u,r]).then(()=>{m(void 0)}),k}e.checkActivateWorkspaceContainsExtension=E;async function n(s,v,I){for(const y of s.folders)if(await s.exists(h.joinPath(M.URI.revive(y),v))){I(`workspaceContains:${v}`);return}}async function f(s,v,I,y){if(I.length===0)return Promise.resolve(void 0);const a=new b.CancellationTokenSource,m=s.checkExists(s.folders,I,a.token),k=setTimeout(async()=>{a.cancel(),y(`workspaceContainsTimeout:${I.join(",")}`)},t);let i=!1;try{i=await m}catch(u){T.isPromiseCanceledError(u)||T.onUnexpectedError(u)}a.dispose(),clearTimeout(k),i&&y(`workspaceContains:${I.join(",")}`)}function l(s,v,I,y){const a=s.get(F.IInstantiationService),m=s.get(_.ISearchService),i=a.createInstance(C.QueryBuilder).file(v.map(u=>(0,P.toWorkspaceFolder)(M.URI.revive(u))),{_reason:"checkExists",includePattern:I,exists:!0});return m.fileSearch(i,y).then(u=>!!u.limitHit,u=>T.isPromiseCanceledError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=l});var Je=this&&this.__classPrivateFieldSet||function(ie,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ie,h):b?b.value=h:e.set(ie,h),h},Te=this&&this.__classPrivateFieldGet||function(ie,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[33],Ee([0,1,125,17,74,24,14,6,20,2,15,5,32,179,72,31,30,177,16,25,23,153,7,85,4,29,73,12,61,64,38,3,218,69,155]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l,s,v,I,y,a,m,k,i,u,r,o,w,d,g,S,R,p,D,c,A){"use strict";var O,z,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let $=class Wi extends C.Disposable{constructor(H,G,ue,q,le,se,ve,Fe,Me,Ne){super();this._onDidChangeRemoteConnectionData=this._register(new p.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=G,this._extHostContext=ue,this._initData=ve,this._extHostWorkspace=q,this._extHostConfiguration=le,this._logService=se,this._extHostTunnelService=Me,this._extHostTerminalService=Ne,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(E.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(E.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(E.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new F.Barrier,this._readyToStartExtensionHost=new F.Barrier,this._readyToRunExtensions=new F.Barrier,this._eagerExtensionsActivated=new F.Barrier,this._registry=new I.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new c.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=H.createChild(new g.ServiceCollection([l.IExtHostStorage,this._storage],[c.IExtHostSecretState,this._secretState]));const Qe=new Set;this._initData.hostExtensions.forEach(ze=>Qe.add(a.ExtensionIdentifier.toKey(ze))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,qe,x)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,y.transformErrorForSerialization(qe),x)},actualActivateExtension:async(ze,qe)=>{if(Qe.has(a.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,qe),new f.HostExtension;const x=this._registry.getExtensionDescription(ze);return this._activateExtension(x,qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(H){y.onUnexpectedError(H)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let H=[];try{H=this._registry.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this._deactivate(le))}catch(G){}await Promise.all(H)}isActivated(H){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(H):!1}_activateByEvent(H,G){return this._activator.activateByEvent(H,G)}_activateById(H,G){return this._activator.activateById(H,G)}activateByIdWithErrors(H,G){return this._activateById(H,G).then(()=>{const ue=this._activator.getActivatedExtension(H);if(ue.activationFailed)return Promise.reject(ue.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(H=>this._registry)}getExtensionExports(H){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(H).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const H=_.TernarySearchTree.forPaths(),G=this._registry.getAllExtensionDescriptions().map(ue=>{if(!!this._getEntryPoint(ue))return this._hostUtils.realpath(ue.extensionLocation.fsPath).then(q=>H.set(P.URI.file(q).fsPath,ue))});this._extensionPathIndex=Promise.all(G).then(()=>H)}return this._extensionPathIndex}_deactivate(H){let G=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(H))return G;const ue=this._activator.getActivatedExtension(H);if(!ue)return G;try{typeof ue.module.deactivate=="function"&&(G=Promise.resolve(ue.module.deactivate()).then(void 0,q=>(this._logService.error(q),Promise.resolve(void 0))))}catch(q){this._logService.error(q)}try{(0,C.dispose)(ue.subscriptions)}catch(q){this._logService.error(q)}return G}async _activateExtension(H,G){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(H.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(H.identifier),this._doActivateExtension(H,G).then(ue=>{const q=ue.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(H.identifier,q.codeLoadingTime,q.activateCallTime,q.activateResolvedTime,G),this._logExtensionActivationTimes(H,G,"success",q),ue},ue=>{throw this._logExtensionActivationTimes(H,G,"failure"),ue})}_logExtensionActivationTimes(H,G,ue,q){const le=Q(H,G);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...le,...q||{},outcome:ue})}_doActivateExtension(H,G){const ue=Q(H,G);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ue);const q=this._getEntryPoint(H);if(!q)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${H.identifier.value} ${JSON.stringify(G)}`),this._logService.flush();const le=new f.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this._loadCommonJSModule(H.identifier,(0,T.joinPath)(H.extensionLocation,q),le),this._loadExtensionContext(H)]).then(se=>(b.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),Wi._callActivate(this._logService,H.identifier,se[0],se[1],le))).then(se=>(b.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),se))}_loadExtensionContext(H){const G=new k.ExtensionGlobalMemento(H,this._storage),ue=new k.ExtensionMemento(H.identifier.value,!1,this._storage),q=new A.ExtensionSecrets(H,this._secretState),le=H.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,se=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([G.whenReady,ue.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Fe;return Object.freeze({globalState:G,workspaceState:ue,secrets:q,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(Me){return M.join(H.extensionLocation.fsPath,Me)},get storagePath(){return ve._storagePath.workspaceValue(H)?.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(H).fsPath},get logPath(){return M.join(ve._initData.logsLocation.fsPath,H.identifier.value)},get logUri(){return P.URI.joinPath(ve._initData.logsLocation,H.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(H)},get globalStorageUri(){return ve._storagePath.globalValue(H)},get extensionMode(){return le},get extension(){return Fe===void 0&&(Fe=new W(ve,H.identifier,H,se)),Fe},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(H),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(H)}})})}static _callActivate(H,G,ue,q,le){return ue=ue||{activate:void 0,deactivate:void 0},this._callActivateOptional(H,G,ue,q,le).then(se=>new f.ActivatedExtension(!1,null,le.build(),ue,se,q.subscriptions))}static _callActivateOptional(H,G,ue,q,le){if(typeof ue.activate=="function")try{le.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${G.value}`);const se=typeof global=="object"?global:self,ve=ue.activate.apply(se,[q]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(ve).then(Fe=>(le.activateResolveStop(),Fe))}catch(se){return Promise.reject(se)}else return Promise.resolve(ue)}_activateOneStartupFinished(H,G){this._activateById(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:G}).then(void 0,ue=>{this._logService.error(ue)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const H of this._registry.getAllExtensionDescriptions())if(H.activationEvents)for(const G of H.activationEvents)G==="onStartupFinished"&&this._activateOneStartupFinished(H,G)}_handleEagerExtensions(){const H=this._activateByEvent("*",!0).then(void 0,le=>{this._logService.error(le)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(le=>this._handleWorkspaceContainsEagerExtensions(le.added)));const G=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ue=this._handleWorkspaceContainsEagerExtensions(G),q=Promise.all([H,ue]).then(()=>{});return Promise.race([q,(0,F.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),q}_handleWorkspaceContainsEagerExtensions(H){return H.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(G=>this._handleWorkspaceContainsEagerExtension(H,G))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(H,G){if(this.isActivated(G.identifier))return;const ue=!this._initData.remote.isRemote&&!!this._initData.remote.authority,q={folders:H.map(se=>se.uri),forceUsingSearch:ue,exists:se=>this._hostUtils.exists(se.fsPath),checkExists:(se,ve,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(se,ve,Fe)},le=await(0,D.checkActivateWorkspaceContainsExtension)(q,G);if(!!le)return this._activateById(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:le.activationEvent}).then(void 0,se=>this._logService.error(se))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(H){throw console.error(H),H}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:G}=this._initData.environment;if(!H||!G)throw new Error(h.localize(0,null));const ue=await this._loadCommonJSModule(null,G,new f.ExtensionActivationTimesBuilder(!1));if(!ue||typeof ue.run!="function")throw new Error(h.localize(1,null,G.toString()));return new Promise((q,le)=>{const se=(Me,Ne)=>{Me?le(Me):q(typeof Ne=="number"&&Ne>0?1:0)},ve=(0,T.originalFSPath)(G),Fe=ue.run(ve,se);Fe&&Fe.then&&Fe.then(()=>{q(0)}).catch(Me=>{le(Me.toString())})})}async $extensionTestsExit(H){this._logService.info(`extension host terminating: test runner requested exit with code ${H}`),this._logService.info(`exiting with code ${H}`),this._logService.flush(),this._hostUtils.exit(H)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(H,G){return this._resolvers[H]=G,(0,C.toDisposable)(()=>{delete this._resolvers[H]})}async _activateAndGetResolver(H){const G=H.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const ue=H.substr(0,G);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ue}`,!1),{authorityPrefix:ue,resolver:this._resolvers[ue]}}async $resolveAuthority(H,G){const{authorityPrefix:ue,resolver:q}=await this._activateAndGetResolver(H);if(!q)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ue}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(q)),b.mark(`code/extHost/willResolveAuthority/${ue}`);const le=await q.resolve(H,{resolveAttempt:G});b.mark(`code/extHost/didResolveAuthorityOK/${ue}`);const se={authority:H,host:le.host,port:le.port,connectionToken:le.connectionToken},ve={extensionHostEnv:le.extensionHostEnv,isTrusted:le.isTrusted};return{type:"ok",value:{authority:se,options:ve,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(b.mark(`code/extHost/didResolveAuthorityError/${ue}`),le instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}async $getCanonicalURI(H,G){const{authorityPrefix:ue,resolver:q}=await this._activateAndGetResolver(H);if(!q)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ue}`);const le=P.URI.revive(G);if(typeof q.getCanonicalURI=="undefined")return le;const se=await(0,F.asPromise)(()=>q.getCanonicalURI(le));return se||le}$startExtensionHost(H){return this._registry.keepOnly(H),this._startExtensionHost()}$activateByEvent(H,G){return G===1?this._activateByEvent(H,!1):this._readyToRunExtensions.wait().then(ue=>this._activateByEvent(H,!1))}async $activate(H,G){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(H)?(await this._activateById(H,G),!0):!1}async $deltaExtensions(H,G){H.forEach(q=>q.extensionLocation=P.URI.revive(q.extensionLocation));const ue=await this.getExtensionPathIndex();return await Promise.all(G.map(async q=>{const le=this._registry.getExtensionDescription(q);if(!le)return;const se=await this._hostUtils.realpath(le.extensionLocation.fsPath);ue.delete(P.URI.file(se).fsPath)})),await Promise.all(H.map(async q=>{const le=await this._hostUtils.realpath(q.extensionLocation.fsPath);ue.set(P.URI.file(le).fsPath,q)})),this._registry.deltaExtensions(H,G),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){let G=m.VSBuffer.alloc(H),ue=Math.random()%256;for(let q=0;q<H;q++)G.writeUInt8(ue,q);return G}async $updateRemoteConnectionData(H){this._remoteConnectionData=H,this._onDidChangeRemoteConnectionData.fire()}};$=Ue([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,d.IExtHostRpcService),He(3,s.IExtHostWorkspace),He(4,n.IExtHostConfiguration),He(5,t.ILogService),He(6,o.IExtHostInitDataService),He(7,w.IExtensionStoragePaths),He(8,S.IExtHostTunnelService),He(9,R.IExtHostTerminalService)],$),e.AbstractExtHostExtensionService=$;function Q(U,H){return{id:U.identifier.value,name:U.name,extensionVersion:U.version,publisherDisplayName:U.publisher,activationEvents:U.activationEvents?U.activationEvents.join(","):null,isBuiltin:U.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class W{constructor(H,G,ue,q){O.set(this,void 0),z.set(this,void 0),K.set(this,void 0),Je(this,O,H,"f"),Je(this,z,G,"f"),Je(this,K,ue.identifier,"f"),this.id=ue.identifier.value,this.extensionUri=ue.extensionLocation,this.extensionPath=M.normalize((0,T.originalFSPath)(ue.extensionLocation)),this.packageJSON=ue,this.extensionKind=q}get isActive(){return Te(this,O,"f").isActivated(Te(this,K,"f"))}get exports(){if(this.packageJSON.api!=="none")return Te(this,O,"f").getExtensionExports(Te(this,K,"f"))}activate(){return Te(this,O,"f").activateByIdWithErrors(Te(this,K,"f"),{startup:!1,extensionId:Te(this,z,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,O=new WeakMap,z=new WeakMap,K=new WeakMap}),define(be[100],Ee([0,1,17,2,3,14,5,7,163,31,33,49,168,32,164,12,4,10,91,68]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l,s,v,I,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let m=class{constructor(g,S,R,p,D,c){this._workspaceService=S,this._extensionService=R,this._editorsService=p,this._configurationService=D,this._editorTabs=c,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new b.Emitter,this._onDidTerminateDebugSession=new b.Emitter,this._onDidChangeActiveDebugSession=new b.Emitter,this._onDidReceiveDebugSessionCustomEvent=new b.Emitter,this._debugServiceProxy=g.getProxy(F.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new b.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(A=>{A.onDidChange(O=>{this.registerAllDebugTypes(A)}),this.registerAllDebugTypes(A)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(g,S){const R=g;if(typeof R.sourceReference=="number"&&R.sourceReference>0){let p=`debug:${encodeURIComponent(R.path||"")}`,D="?";return S&&(p+=`${D}session=${encodeURIComponent(S.id)}`,D="&"),p+=`${D}ref=${R.sourceReference}`,M.URI.parse(p)}else{if(R.path)return M.URI.file(R.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(g){const S=[];for(const R of g.getAllExtensionDescriptions())if(R.contributes){const p=R.contributes.debuggers;if(p&&p.length>0)for(const D of p)(0,l.isDebuggerMainContribution)(D)&&S.push(D.type)}this._debugServiceProxy.$registerDebugTypes(S)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const g=[];return this._breakpoints.forEach(S=>g.push(S)),g}addBreakpoints(g){this.startBreakpoints();const S=g.filter(D=>{const c=D.id;return this._breakpoints.has(c)?!1:(this._breakpoints.set(c,D),!0)});this.fireBreakpointChanges(S,[],[]);const R=[],p=new Map;for(const D of S)if(D instanceof C.SourceBreakpoint){let c=p.get(D.location.uri.toString());c||(c={type:"sourceMulti",uri:D.location.uri,lines:[]},p.set(D.location.uri.toString(),c),R.push(c)),c.lines.push({id:D.id,enabled:D.enabled,condition:D.condition,hitCondition:D.hitCondition,logMessage:D.logMessage,line:D.location.range.start.line,character:D.location.range.start.character})}else D instanceof C.FunctionBreakpoint&&R.push({type:"function",id:D.id,enabled:D.enabled,hitCondition:D.hitCondition,logMessage:D.logMessage,condition:D.condition,functionName:D.functionName});return this._debugServiceProxy.$registerBreakpoints(R)}removeBreakpoints(g){this.startBreakpoints();const S=g.filter(c=>this._breakpoints.delete(c.id));this.fireBreakpointChanges([],S,[]);const R=S.filter(c=>c instanceof C.SourceBreakpoint).map(c=>c.id),p=S.filter(c=>c instanceof C.FunctionBreakpoint).map(c=>c.id),D=S.filter(c=>c instanceof C.DataBreakpoint).map(c=>c.id);return this._debugServiceProxy.$unregisterBreakpoints(R,p,D)}startDebugging(g,S,R){return this._debugServiceProxy.$startDebugging(g?g.uri:void 0,S,{parentSessionID:R.parentSession?R.parentSession.id:void 0,lifecycleManagedByParent:R.lifecycleManagedByParent,repl:R.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:R.noDebug,compact:R.compact,debugUI:R.debugUI,suppressSaveBeforeStart:R.suppressSaveBeforeStart})}stopDebugging(g){return this._debugServiceProxy.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,S,R){if(!S)return new C.Disposable(()=>{});const p=this._configProviderHandleCounter++;return this._configProviders.push({type:g,handle:p,provider:S}),this._debugServiceProxy.$registerDebugConfigurationProvider(g,R,!!S.provideDebugConfigurations,!!S.resolveDebugConfiguration,!!S.resolveDebugConfigurationWithSubstitutedVariables,p),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(D=>D.provider!==S),this._debugServiceProxy.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(g,S,R){if(!R)return new C.Disposable(()=>{});if(!this.definesDebugType(g,S))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${S}' debugger.`);if(this.getAdapterDescriptorFactoryByType(S))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:S,handle:p,factory:R}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(S,p),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(D=>D.factory!==R),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(g,S){if(!S)return new C.Disposable(()=>{});const R=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:g,handle:R,factory:S}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(p=>p.factory!==S)})}async $runInTerminal(g,S){return Promise.resolve(void 0)}async $substituteVariables(g,S){if(!this._variableResolver){const[D,c]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(D||[],this._editorsService,c)}let R;const p=await this.getFolder(g);return p&&(R={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(R,S)}createDebugAdapter(g,S){if(g.type==="implementation")return new o(g.implementation)}createSignService(){}async $startDASession(g,S){const R=this,p=await this.getSession(S);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(p.type),p).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const c=this.convertToDto(D),A=this.createDebugAdapter(c,p);if(!A)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const O=A;return this._debugAdapters.set(g,O),this.getDebugAdapterTrackers(p).then(z=>(z&&this._debugAdaptersTrackers.set(g,z),O.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const $=K,Q={type:"response",seq:0,command:$.command,request_seq:$.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const W=await this._signService.sign($.arguments.value);Q.body={signature:W},O.sendResponse(Q)}else throw new Error("no signer")}catch(W){Q.success=!1,Q.message=W.message,O.sendResponse(Q)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(K),K=(0,l.convertToVSCPaths)(K,!0),R._debugServiceProxy.$acceptDAMessage(g,K)}),O.onError(K=>{z&&z.onError&&z.onError(K),this._debugServiceProxy.$acceptDAError(g,K.name,K.message,K.stack)}),O.onExit(K=>{z&&z.onExit&&z.onExit((0,I.withNullAsUndefined)(K),void 0),this._debugServiceProxy.$acceptDAExit(g,(0,I.withNullAsUndefined)(K),void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),O.startSession()))})}$sendDAMessage(g,S){S=(0,l.convertToDAPaths)(S,!1);const R=this._debugAdaptersTrackers.get(g);R&&R.onWillReceiveMessage&&R.onWillReceiveMessage(S);const p=this._debugAdapters.get(g);p&&p.sendMessage(S)}$stopDASession(g){const S=this._debugAdaptersTrackers.get(g);this._debugAdaptersTrackers.delete(g),S&&S.onWillStopSession&&S.onWillStopSession();const R=this._debugAdapters.get(g);return this._debugAdapters.delete(g),R?R.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const S=[],R=[],p=[];if(g.added)for(const D of g.added){const c=D.id;if(c&&!this._breakpoints.has(c)){let A;if(D.type==="function")A=new C.FunctionBreakpoint(D.functionName,D.enabled,D.condition,D.hitCondition,D.logMessage);else if(D.type==="data")A=new C.DataBreakpoint(D.label,D.dataId,D.canPersist,D.enabled,D.hitCondition,D.condition,D.logMessage);else{const O=M.URI.revive(D.uri);A=new C.SourceBreakpoint(new C.Location(O,new C.Position(D.line,D.character)),D.enabled,D.condition,D.hitCondition,D.logMessage)}A._id=c,this._breakpoints.set(c,A),S.push(A)}}if(g.removed)for(const D of g.removed){const c=this._breakpoints.get(D);c&&(this._breakpoints.delete(D),R.push(c))}if(g.changed){for(const D of g.changed)if(D.id){const c=this._breakpoints.get(D.id);if(c){if(c instanceof C.FunctionBreakpoint&&D.type==="function"){const A=c;A.enabled=D.enabled,A.condition=D.condition,A.hitCondition=D.hitCondition,A.logMessage=D.logMessage,A.functionName=D.functionName}else if(c instanceof C.SourceBreakpoint&&D.type==="source"){const A=c;A.enabled=D.enabled,A.condition=D.condition,A.hitCondition=D.hitCondition,A.logMessage=D.logMessage,A.location=new C.Location(M.URI.revive(D.uri),new C.Position(D.line,D.character))}p.push(c)}}}this.fireBreakpointChanges(S,R,p)}$provideDebugConfigurations(g,S,R){return(0,T.asPromise)(async()=>{const p=this.getConfigProviderByHandle(g);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const D=await this.getFolder(S);return p.provideDebugConfigurations(D,R)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(g,S,R,p){return(0,T.asPromise)(async()=>{const D=this.getConfigProviderByHandle(g);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const c=await this.getFolder(S);return D.resolveDebugConfiguration(c,R,p)})}$resolveDebugConfigurationWithSubstitutedVariables(g,S,R,p){return(0,T.asPromise)(async()=>{const D=this.getConfigProviderByHandle(g);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const c=await this.getFolder(S);return D.resolveDebugConfigurationWithSubstitutedVariables(c,R,p)})}async $provideDebugAdapter(g,S){const R=this.getAdapterDescriptorFactoryByHandle(g);if(!R)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.getSession(S);return this.getAdapterDescriptor(R,p).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.convertToDto(D)})}async $acceptDebugSessionStarted(g){const S=await this.getSession(g);this._onDidStartDebugSession.fire(S)}async $acceptDebugSessionTerminated(g){const S=await this.getSession(g);S&&(this._onDidTerminateDebugSession.fire(S),this._debugSessions.delete(S.id))}async $acceptDebugSessionActiveChanged(g){this._activeDebugSession=g?await this.getSession(g):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(g,S){const R=await this.getSession(g);R&&R._acceptNameChanged(S)}async $acceptDebugSessionCustomEvent(g,S){const p={session:await this.getSession(g),event:S.event,body:S.body};this._onDidReceiveDebugSessionCustomEvent.fire(p)}convertToDto(g){if(g instanceof C.DebugAdapterExecutable)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof C.DebugAdapterServer)return{type:"server",port:g.port,host:g.host};if(g instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:g.path};if(g instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(g){const S=this._adapterFactories.filter(R=>R.type===g);if(S.length>0)return S[0].factory}getAdapterDescriptorFactoryByHandle(g){const S=this._adapterFactories.filter(R=>R.handle===g);if(S.length>0)return S[0].factory}getConfigProviderByHandle(g){const S=this._configProviders.filter(R=>R.handle===g);if(S.length>0)return S[0].provider}definesDebugType(g,S){if(g.contributes){const R=g.contributes.debuggers;if(R&&R.length>0){for(const p of R)if(p.label&&p.type&&p.type===S)return!0}}return!1}getDebugAdapterTrackers(g){const R=g.configuration.type,p=this._trackerFactories.filter(D=>D.type===R||D.type==="*").map(D=>(0,T.asPromise)(()=>D.factory.createDebugAdapterTracker(g)).then(c=>c,c=>null));return Promise.race([Promise.all(p).then(D=>{const c=D.filter(A=>!!A);if(c.length>0)return new r(c)}),new Promise((D,c)=>{const A=setTimeout(()=>{clearTimeout(A),c(new Error("timeout"))},1e3)})]).catch(D=>{})}async getAdapterDescriptor(g,S){const R=S.configuration.debugServer;if(typeof R=="number")return Promise.resolve(new C.DebugAdapterServer(R));if(g){const D=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>g.createDebugAdapterDescriptor(S,this.daExecutableFromPackage(S,D))).then(c=>{if(c)return c})}const p=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(S,p))}daExecutableFromPackage(g,S){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(g,S,R){(g.length>0||S.length>0||R.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:g,removed:S,changed:R}))}async getSession(g){if(g)if(typeof g=="string"){const S=this._debugSessions.get(g);if(S)return S}else{let S=this._debugSessions.get(g.id);if(!S){const R=await this.getFolder(g.folderUri),p=g.parent?this._debugSessions.get(g.parent):void 0;S=new k(this._debugServiceProxy,g.id,g.type,g.name,R,g.configuration,p),this._debugSessions.set(S.id,S),this._debugServiceProxy.$sessionCached(S.id)}return S}throw new Error("cannot find session")}getFolder(g){if(g){const S=M.URI.revive(g);return this._workspaceService.resolveWorkspaceFolder(S)}return Promise.resolve(void 0)}};m=Ue([He(0,s.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,t.IExtHostExtensionService),He(3,E.IExtHostDocumentsAndEditors),He(4,f.IExtHostConfiguration),He(5,a.IExtHostEditorTabs)],m),e.ExtHostDebugServiceBase=m;class k{constructor(g,S,R,p,D,c,A){this._debugServiceProxy=g,this._id=S,this._type=R,this._name=p,this._workspaceFolder=D,this._configuration=c,this._parentSession=A}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(g){this._name=g,this._debugServiceProxy.$setDebugSessionName(this._id,g)}get parentSession(){return this._parentSession}_acceptNameChanged(g){this._name=g}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(g,S){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,g,S)}getDebugProtocolBreakpoint(g){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,g.id)}}e.ExtHostDebugSession=k;class i{constructor(g){this.value=Object.freeze({append(S){g.$appendDebugConsole(S)},appendLine(S){this.append(S+`
`)}})}}e.ExtHostDebugConsole=i;class u extends n.AbstractVariableResolverService{constructor(g,S,R,p,D){function c(){if(S){const A=S.activeEditor();if(A)return A.document.uri;const O=p.tabs.filter(z=>z.isActive);if(O.length>0){const z=O[0].resource;return z&&(z.primary||z.secondary)?z.primary??z.secondary:O[0].resource}}}super({getFolderUri:A=>{const O=g.filter(z=>z.name===A);if(O&&O.length>0)return O[0].uri},getWorkspaceFolderCount:()=>g.length,getConfigurationValue:(A,O)=>R.getConfiguration(void 0,A).get(O),getAppRoot:()=>y.cwd(),getExecPath:()=>y.env.VSCODE_EXEC_PATH,getFilePath:()=>{const A=c();if(A)return h.normalize(A.fsPath)},getWorkspaceFolderPathForFile:()=>{if(D){const A=c();if(A){const O=D.getWorkspaceFolder(A);if(O)return h.normalize(O.uri.fsPath)}}},getSelectedText:()=>{if(S){const A=S.activeEditor();if(A&&!A.selection.isEmpty)return A.document.getText(A.selection)}},getLineNumber:()=>{if(S){const A=S.activeEditor();if(A)return String(A.selection.end.line+1)}}},void 0,Promise.resolve(y.env))}}e.ExtHostVariableResolverService=u;class r{constructor(g){this.trackers=g}onWillStartSession(){this.trackers.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.trackers.forEach(S=>S.onWillReceiveMessage?S.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.trackers.forEach(S=>S.onDidSendMessage?S.onDidSendMessage(g):void 0)}onWillStopSession(){this.trackers.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.trackers.forEach(S=>S.onError?S.onError(g):void 0)}onExit(g,S){this.trackers.forEach(R=>R.onExit?R.onExit(g,S):void 0)}}class o extends _.AbstractDebugAdapter{constructor(g){super();this.implementation=g,g.onDidSendMessage(S=>{this.acceptMessage(S)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.implementation.handleMessage(g)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let w=class extends m{constructor(g,S,R,p,D,c){super(g,S,R,p,D,c)}createVariableResolver(g,S,R){return new u(g,S,R,this._editorTabs)}};w=Ue([He(0,s.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,t.IExtHostExtensionService),He(3,E.IExtHostDocumentsAndEditors),He(4,f.IExtHostConfiguration),He(5,a.IExtHostEditorTabs)],w),e.WorkerExtHostDebugService=w}),define(be[219],Ee([0,1,74,2,5,32,30,25,12,29,4,33,91,15]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(a,m,k,i,u,r,o){this._apiFactory=a,this._extensionRegistry=m,this._instaService=k,this._extHostConfiguration=i,this._extHostExtensionService=u,this._initData=r,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),h.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();h.mark("code/extHost/didWaitForConfig");const m=await this._extHostExtensionService.getExtensionPathIndex();this.register(new s(this._apiFactory,m,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(I,m,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let m of a.nodeModuleName)this._factories.set(m,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(m=>a.alternativeModuleName(m))}};l=Ue([He(2,t.IInstantiationService),He(3,T.IExtHostConfiguration),He(4,E.IExtHostExtensionService),He(5,P.IExtHostInitDataService),He(6,f.ILogService)],l),e.RequireInterceptor=l;class s{constructor(a,m,k,i,u){this._apiFactory=a,this._extensionPaths=m,this._extensionRegistry=k,this._configProvider=i,this._logService=u,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,m){const k=this._extensionPaths.findSubstr(m.fsPath);if(k){let i=this._extApiImpl.get(C.ExtensionIdentifier.toKey(k.identifier));return i||(i=this._apiFactory(k,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(k.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((u,r)=>i+=`	${r} -> ${u.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${m.fsPath}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(F.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(a,m){this.nodeModuleName="keytar";const{environment:k}=m,i=a.getProxy(b.MainContext.MainThreadKeytar);if(k.appRoot){let u=k.appRoot.fsPath;n.platform==="win32"&&(u=u.replace(/\\/g,"/")),u[u.length-1]==="/"&&(u=u.substr(0,u.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${u}/node_modules.asar/keytar`),this.alternativeNames.add(`${u}/node_modules/keytar`)}this._impl={getPassword:(u,r)=>i.$getPassword(u,r),setPassword:(u,r,o)=>i.$setPassword(u,r,o),deletePassword:(u,r)=>i.$deletePassword(u,r),findPassword:u=>i.$findPassword(u),findCredentials(u){return i.$findCredentials(u)}}}load(a,m){return this._impl}alternativeModuleName(a){const m=a.length;if(m<=7||!this.alternativeNames)return;const k=m-7;if((a.charAt(k)==="/"||a.charAt(k)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};v=Ue([He(0,_.IExtHostRpcService),He(1,P.IExtHostInitDataService)],v);let I=class{constructor(a,m,k){this._extensionPaths=a,this._appUriScheme=m,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=k.getProxy(b.MainContext.MainThreadTelemetry);const i=k.getProxy(b.MainContext.MainThreadWindow);this._impl=(u,r)=>{const o=M.URI.parse(u);return r?this.callOriginal(u,r):o.scheme==="http"||o.scheme==="https"?i.$openUri(o,u,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?i.$openUri(o,u,{}):this.callOriginal(u,r)}}load(a,m,k){const i=this._extensionPaths.findSubstr(m.fsPath);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=k(a),this._impl}callOriginal(a,m){return this.sendNoForwardTelemetry(),this._original(a,m)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};I=Ue([He(2,_.IExtHostRpcService)],I)}),define(be[220],Ee([0,1,14,16,74,6,2,5,213,15,57,61,29,144,12,65,33,38]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l,s,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class y{constructor(m,k,i,u){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new _.RPCProtocol(m,null,u),k=y._transform(k,this._rpcProtocol);const r=new E.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...k}),r.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),r.set(s.IURITransformerService,new s.URITransformerService(u)),r.set(v.IHostUtils,i);const o=new f.InstantiationService(r,!0),w=o.invokeFunction(R=>R.get(I.IExtHostTerminalService));this._disposables.add(w),this._logService=o.invokeFunction(R=>R.get(P.ILogService)),b.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",k),this._extensionService=o.invokeFunction(R=>R.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const d=new WeakMap;this._extensionService.getExtensionPathIndex().then(R=>{Error.prepareStackTrace=(p,D)=>{let c="",A,O;for(const z of D)c+=`
	at ${z.toString()}`,O=z.getFileName(),!A&&O&&(A=R.findSubstr(O));return d.set(p,A),`${p.name||"Error"}: ${p.message||""}${c}`}});const g=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),S=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(R=>{const p=M.transformErrorForSerialization(R),D=d.get(R);D?g.$onExtensionRuntimeError(D.identifier,p):S.$onUnexpectedError(p)})}terminate(m){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${m}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const k=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,h.timeout)(4e3),k]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(m,k){m.extensions.forEach(u=>u.extensionLocation=F.URI.revive(k.transformIncomingURIs(u.extensionLocation))),m.environment.appRoot=F.URI.revive(k.transformIncomingURIs(m.environment.appRoot));const i=m.environment.extensionDevelopmentLocationURI;return i&&(m.environment.extensionDevelopmentLocationURI=i.map(u=>F.URI.revive(k.transformIncomingURIs(u)))),m.environment.extensionTestsLocationURI=F.URI.revive(k.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=F.URI.revive(k.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=F.URI.revive(k.transformIncomingURIs(m.environment.workspaceStorageHome)),m.logsLocation=F.URI.revive(k.transformIncomingURIs(m.logsLocation)),m.logFile=F.URI.revive(k.transformIncomingURIs(m.logFile)),m.workspace=k.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=y}),define(be[221],Ee([0,1,17,21,56,27,24,194,39]),function(ie,e,h,M,b,T,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(n,f,l){this.config=n,this.provider=f,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&T.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&T.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const f=this.config.folderQueries||[];return new Promise((l,s)=>{const v=I=>{this.resultCount++,n(I)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(I=>{const y=I.toString(),a=h.basename(y);this.globalExcludePattern&&this.globalExcludePattern(y,a)||this.matchFile(v,{base:I,basename:a})}),Promise.all(f.map(I=>this.searchInFolder(I,v))).then(I=>{l({limitHit:this.isLimitHit,stats:I[0]||void 0})},I=>{s(new Error((0,b.toErrorMessage)(I)))})})}async searchInFolder(n,f){const l=new M.CancellationTokenSource,s=this.getSearchOptionsForFolder(n),v=this.initDirectoryTree(),I=new _.QueryGlobTester(this.config,n),y=!I.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(l),a=C.StopWatch.create();const m=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},s,l.token),k=a.elapsed(),i=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(m&&m.forEach(u=>{const r=h.posix.relative(n.folder.path,u.path);if(y){const o=h.basename(u.path);this.matchFile(f,{base:n.folder,relativePath:r,basename:o});return}this.addDirectoryEntries(v,n.folder,r,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,I,f),{providerTime:k,postProcessTime:i.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(n){const f=(0,_.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),l=(0,_.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:l,includes:f,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},f,l,s){if(l===this.filePattern){const I=h.basename(this.filePattern);this.matchFile(s,{base:f,relativePath:this.filePattern,basename:I})}function v(I){const y=h.basename(I),a=h.dirname(I);let m=n[a];m||(m=n[a]=[],v(a)),m.push({base:f,relativePath:I,basename:y})}v(l)}matchDirectoryTree({rootEntries:n,pathToEntries:f},l,s){const v=this,I=this.filePattern;function y(a){const m=T.hasSiblingFn(()=>a.map(k=>k.basename));for(let k=0,i=a.length;k<i;k++){const u=a[k],{relativePath:r,basename:o}=u;if(!l.includedInQuerySync(r,o,I!==o?m:void 0))continue;const w=f[r];if(w)y(w);else{if(r===I)continue;v.matchFile(s,u)}if(v.isLimitHit)break}}y(n)}matchFile(n,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(f))}}class t{constructor(){this.sessions=new Map}fileSearch(n,f,l,s){const v=this.getSessionTokenSource(n.cacheKey),I=new P(n,f,v&&v.token);let y=0;const a=m=>{y+=m.length,l(m.map(k=>this.rawMatchToSearchItem(k)))};return this.doSearch(I,t.BATCH_SIZE,a,s).then(m=>({limitHit:m.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:y,detailStats:m.stats}}))}clearCache(n){const f=this.getSessionTokenSource(n);f&&f.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:F.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,f,l,s){s.onCancellationRequested(()=>{n.cancel()});const v=y=>{y&&(I.push(y),f>0&&I.length>=f&&(l(I),I=[]))};let I=[];return n.search(v).then(y=>(I.length&&l(I),y),y=>(I.length&&l(I),Promise.reject(y)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(be[222],Ee([0,1,13,21,56,27,11,17,24,10,2,39]),function(ie,e,h,M,b,T,F,C,_,P,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(a,m,k,i){this.query=a,this.provider=m,this.fileUtils=k,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,m){const k=this.query.folderQueries||[],i=new M.CancellationTokenSource;return m.onCancellationRequested(()=>i.cancel()),new Promise((u,r)=>{this.collector=new l(a);let o=!1;const w=(d,g)=>{if(!o&&!this.isLimitHit){const S=this.resultSize(d);v(d)&&typeof this.query.maxResults=="number"&&this.resultCount+S>this.query.maxResults&&(this.isLimitHit=!0,o=!0,i.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const R=this.resultSize(d);this.resultCount+=R,(R>0||!v(d))&&this.collector.add(d,g)}};Promise.all(k.map((d,g)=>this.searchInFolder(d,S=>w(S,g),i.token))).then(d=>{i.dispose(),this.collector.flush();const g=d.some(S=>!!S&&!!S.limitHit);u({limitHit:this.isLimitHit||g,messages:(0,h.flatten)(d.map(S=>S?.message?(0,P.isArray)(S.message)?S.message:[S.message]:[])),stats:{type:this.processType}})},d=>{i.dispose();const g=(0,b.toErrorMessage)(d);r(new Error(g))})})}resultSize(a){return v(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,m){const k=Array.isArray(a.ranges)?a.ranges:[a.ranges],i=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:k.slice(0,m),preview:{matches:i.slice(0,m),text:a.preview.text},uri:a.uri}}async searchInFolder(a,m,k){const i=new E.QueryGlobTester(this.query,a),u=[],r={report:d=>{if(!this.validateProviderResult(d))return;const g=a.folder.scheme===F.Schemas.file?T.hasSiblingPromiseFn(()=>this.fileUtils.readdir(_.dirname(d.uri))):void 0,S=_.relativePath(a.folder,d.uri);if(S){const R=i.includedInQuery(S,C.basename(S),g);(0,P.isPromise)(R)?u.push(R.then(p=>{p&&m(d)})):R&&m(d)}}},o=this.getSearchOptionsForFolder(a),w=await this.provider.provideTextSearchResults(f(this.query.contentPattern),o,r,k);return u.length&&await Promise.all(u),w}validateProviderResult(a){if(v(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const m=(0,E.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),k=(0,E.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),i={folder:t.URI.from(a.folder),excludes:k,includes:m,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function f(y){return{isCaseSensitive:y.isCaseSensitive||!1,isRegExp:y.isRegExp||!1,isWordMatch:y.isWordMatch||!1,isMultiline:y.isMultiline||!1,pattern:y.pattern}}class l{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new I(512,m=>this.sendItems(m))}add(a,m){this._currentFileMatch&&(this._currentFolderIdx!==m||!_.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=m,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(s(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=l;function s(y){return v(y)?{preview:{matches:(0,h.mapArrayOrNot)(y.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:y.preview.text},ranges:(0,h.mapArrayOrNot)(y.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:y.text,lineNumber:y.lineNumber}}function v(y){return!!y.preview}e.extensionResultIsMatch=v;class I{constructor(a,m){this.maxBatchSize=a,this.cb=m,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,m){!a||this.addItemToBatch(a,m)}addItems(a,m){!a||this.addItemsToBatch(a,m)}addItemToBatch(a,m){this.batch.push(a),this.batchSize+=m,this.onUpdate()}addItemsToBatch(a,m){this.batch=this.batch.concat(a),this.batchSize+=m,this.onUpdate()}onUpdate(){this.totalNumberCompleted<I.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},I.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=I,I.TIMEOUT=4e3,I.START_BATCH_AFTER_COUNT=50}),define(be[101],Ee([0,1,6,5,4,221,12,65,15,2,222]),function(ie,e,h,M,b,T,F,C,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let E=class{constructor(s,v,I){this.extHostRpc=s,this._uriTransformer=v,this._logService=I,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(s){return this._uriTransformer.transformOutgoingScheme(s)}registerTextSearchProvider(s,v){if(this._textSearchUsedSchemes.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this._textSearchUsedSchemes.add(s);const I=this._handlePool++;return this._textSearchProvider.set(I,v),this._proxy.$registerTextSearchProvider(I,this._transformScheme(s)),(0,h.toDisposable)(()=>{this._textSearchUsedSchemes.delete(s),this._textSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}registerFileSearchProvider(s,v){if(this._fileSearchUsedSchemes.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this._fileSearchUsedSchemes.add(s);const I=this._handlePool++;return this._fileSearchProvider.set(I,v),this._proxy.$registerFileSearchProvider(I,this._transformScheme(s)),(0,h.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(s),this._fileSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}$provideFileSearchResults(s,v,I,y){const a=n(I),m=this._fileSearchProvider.get(s);if(m)return this._fileSearchManager.fileSearch(a,m,k=>{this._proxy.$handleFileMatch(s,v,k.map(i=>i.resource))},y);throw new Error("unknown provider: "+s)}$clearCache(s){return this._fileSearchManager.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,v,I,y){const a=this._textSearchProvider.get(s);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const m=n(I);return this.createTextSearchManager(m,a).search(i=>this._proxy.$handleTextMatch(s,v,i),y)}$enableExtensionHostSearch(){}createTextSearchManager(s,v){return new t.TextSearchManager(s,v,{readdir:I=>Promise.resolve([]),toCanonicalName:I=>I},"textSearchProvider")}};E=Ue([He(0,F.IExtHostRpcService),He(1,C.IURITransformerService),He(2,_.ILogService)],E),e.ExtHostSearch=E;function n(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(f),extraFileResources:l.extraFileResources&&l.extraFileResources.map(s=>P.URI.revive(s))}}e.reviveQuery=n;function f(l){return{...l,folder:P.URI.revive(l.folder)}}}),define(be[223],Ee([0,1,21,16,3,35,2,117,79,113,55,60,5,184,183,48,185,32,186,187,188,170,189,49,33,190,171,193,195,196,96,173,201,202,203,72,38,205,174,8,7,208,50,97,31,30,51,160,192,86,95,99,100,101,15,65,12,29,197,157,64,70,181,206,156,73,71,211,209,210,182,37,204,207,69,68,87,199,98,200,11,146,198,154,191]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l,s,v,I,y,a,m,k,i,u,r,o,w,d,g,S,R,p,D,c,A,O,z,K,$,Q,W,U,H,G,ue,q,le,se,ve,Fe,Me,Ne,Qe,ze,qe,x,Y,ee,ae,j,oe,fe,Ae,xe,$e,we,Ze,V,J,he,Oe,Ve,tt,ut,ht,St,Pt,dt,bt,ft,Et,Ye,Ct,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function De(Z){const ce=Z.get(ee.IExtHostInitDataService),ge=Z.get(Ve.IExtHostFileSystemInfo),me=Z.get(Ze.IExtHostConsumerFileSystem),Ie=Z.get(r.IExtHostExtensionService),Be=Z.get(ue.IExtHostWorkspace),Le=Z.get(Pt.IExtHostTelemetry),je=Z.get(I.IExtHostConfiguration),Xe=Z.get(x.IURITransformerService),ne=Z.get(Y.IExtHostRpcService),pe=Z.get(O.IExtHostStorage),re=Z.get(we.IExtensionStoragePaths),B=Z.get(qe.ILogService),Ce=Z.get(oe.IExtHostTunnelService),Se=Z.get(fe.IExtHostApiDeprecationService),Ge=Z.get(G.IExtHostWindow),We=Z.get(ht.IExtHostSecretState),it=Z.get(St.IExtHostEditorTabs);ne.set(n.ExtHostContext.ExtHostFileSystemInfo,ge),ne.set(n.ExtHostContext.ExtHostLogService,B),ne.set(n.ExtHostContext.ExtHostWorkspace,Be),ne.set(n.ExtHostContext.ExtHostConfiguration,je),ne.set(n.ExtHostContext.ExtHostExtensionService,Ie),ne.set(n.ExtHostContext.ExtHostStorage,pe),ne.set(n.ExtHostContext.ExtHostTunnelService,Ce),ne.set(n.ExtHostContext.ExtHostWindow,Ge),ne.set(n.ExtHostContext.ExtHostSecretState,We),ne.set(n.ExtHostContext.ExtHostTelemetry,Le),ne.set(n.ExtHostContext.ExtHostEditorTabs,it);const mt=ne.set(n.ExtHostContext.ExtHostDecorations,Z.get(Me.IExtHostDecorations)),vt=ne.set(n.ExtHostContext.ExtHostDocumentsAndEditors,Z.get(u.IExtHostDocumentsAndEditors)),nt=ne.set(n.ExtHostContext.ExtHostCommands,Z.get(s.IExtHostCommands)),ot=ne.set(n.ExtHostContext.ExtHostTerminalService,Z.get(z.IExtHostTerminalService)),lt=ne.set(n.ExtHostContext.ExtHostDebugService,Z.get(Qe.IExtHostDebugService)),Rt=ne.set(n.ExtHostContext.ExtHostSearch,Z.get(ze.IExtHostSearch)),_t=ne.set(n.ExtHostContext.ExtHostTask,Z.get(Ne.IExtHostTask)),Ot=ne.set(n.ExtHostContext.ExtHostOutputService,Z.get(R.IExtHostOutputService)),di=ne.set(n.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(ne)),kt=ne.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(ne,vt)),$t=ne.set(n.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(ne,vt,B)),Zt=ne.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new k.ExtHostDocumentSaveParticipant(B,kt,ne.getProxy(n.MainContext.MainThreadBulkEdits))),gt=ne.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(ne,nt,vt,kt,re)),Kt=ne.set(n.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(B,gt)),Vt=ne.set(n.ExtHostContext.ExtHostNotebookEditors,new Ct.ExtHostNotebookEditors(B,ne,gt)),ei=ne.set(n.ExtHostContext.ExtHostNotebookKernels,new dt.ExtHostNotebookKernels(ne,ce,gt,B)),ti=ne.set(n.ExtHostContext.ExtHostNotebookRenderers,new ft.ExtHostNotebookRenderers(ne,gt)),It=ne.set(n.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(ne,vt)),Qt=ne.set(n.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(ne.getProxy(n.MainContext.MainThreadTreeViews),nt,B)),wi=ne.set(n.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(ne.getProxy(n.MainContext.MainThreadEditorInsets),It,ce)),Wt=ne.set(n.ExtHostContext.ExtHostDiagnostics,new y.ExtHostDiagnostics(ne,B,ge)),Ht=ne.set(n.ExtHostContext.ExtHostLanguages,new g.ExtHostLanguages(ne,kt,nt.converter)),ct=ne.set(n.ExtHostContext.ExtHostLanguageFeatures,new d.ExtHostLanguageFeatures(ne,Xe,kt,nt,Wt,B,Se)),ii=ne.set(n.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(ne,ct)),Nt=ne.set(n.ExtHostContext.ExtHostFileSystemEventService,new w.ExtHostFileSystemEventService(ne,B,vt)),xt=ne.set(n.ExtHostContext.ExtHostQuickOpen,(0,D.createExtHostQuickOpen)(ne,Be,nt)),Yt=ne.set(n.ExtHostContext.ExtHostSCM,new c.ExtHostSCM(ne,nt,B)),bi=ne.set(n.ExtHostContext.ExtHostComments,(0,v.createExtHostComments)(ne,nt,kt)),hi=ne.set(n.ExtHostContext.ExtHostProgress,new p.ExtHostProgress(ne.getProxy(n.MainContext.MainThreadProgress))),Ei=ne.set(n.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(ne)),fi=ne.set(n.ExtHostContext.ExtHostTheming,new j.ExtHostTheming(ne)),ni=ne.set(n.ExtHostContext.ExtHostAuthentication,new Ae.ExtHostAuthentication(ne)),ri=ne.set(n.ExtHostContext.ExtHostTimeline,new xe.ExtHostTimeline(ne,nt)),jt=ne.set(n.ExtHostContext.ExtHostWebviews,new H.ExtHostWebviews(ne,{remote:ce.remote},Be,B,Se)),si=ne.set(n.ExtHostContext.ExtHostWebviewPanels,new he.ExtHostWebviewPanels(ne,jt,Be)),_i=ne.set(n.ExtHostContext.ExtHostCustomEditors,new J.ExtHostCustomEditors(ne,kt,re,jt,si)),yi=ne.set(n.ExtHostContext.ExtHostWebviewViews,new V.ExtHostWebviewViews(ne,jt)),qt=ne.set(n.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(ne,nt)),Jt=ne.set(n.ExtHostContext.ExtHostUriOpeners,new ut.ExtHostUriOpeners(ne));ne.set(n.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(ne,gt,vt,nt));const Si=(0,le.values)(n.ExtHostContext);ne.assertRegistered(Si);const Di=new Oe.ExtHostBulkEdits(ne,vt),oi=new l.ExtHostClipboard(ne),ai=new S.ExtHostMessageService(ne,B),zt=new a.ExtHostDialogs(ne),Mt=new A.ExtHostStatusBar(ne,nt.converter);return f.ExtHostApiCommands.register(nt),function(Re,Tt,Gt){const pt=function(){let X=!Re.isUnderDevelopment;function de(ke){X||(B.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function ke(rt){if(Array.isArray(rt))rt.forEach(ke);else if(typeof rt=="string")de(rt);else{const wt=rt;typeof wt.scheme=="undefined"&&de(rt),!Re.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,q.throwProposedApiError)(Re)}return rt}}(),Ci={getSession(X,de,ke){return ke?.forceNewSession&&(0,q.checkProposedApiEnabled)(Re),ni.getSession(Re,X,de,ke)},get onDidChangeSessions(){return ni.onDidChangeSessions},registerAuthenticationProvider(X,de,ke,rt){return ni.registerAuthenticationProvider(X,de,ke,rt)}},ki={registerCommand(X,de,ke){return nt.registerCommand(!0,X,de,ke)},registerTextEditorCommand(X,de,ke){return nt.registerCommand(!0,X,(...rt)=>{const wt=It.getActiveTextEditor();if(!wt){B.warn("Cannot execute "+X+" because there is no active text editor.");return}return wt.edit(Dt=>{de.apply(ke,[wt,Dt,...rt])}).then(Dt=>{Dt||B.warn("Edits from command "+X+" were not applied.")},Dt=>{B.warn("An error occurred while running command "+X,Dt)})})},registerDiffInformationCommand:(X,de,ke)=>((0,q.checkProposedApiEnabled)(Re),nt.registerCommand(!0,X,async(...rt)=>{const wt=vt.activeEditor(!0);if(!wt){B.warn("Cannot execute "+X+" because there is no active text editor.");return}const Dt=await It.getDiffInformation(wt.id);de.apply(ke,[Dt,...rt])})),executeCommand(X,...de){return nt.executeCommand(X,...de)},getCommands(X=!1){return nt.getCommands(X)}},mi={get machineId(){return ce.telemetryInfo.machineId},get sessionId(){return ce.telemetryInfo.sessionId},get language(){return ce.environment.appLanguage},get appName(){return ce.environment.appName},get appRoot(){return ce.environment.appRoot?.fsPath??""},get appHost(){return ce.environment.appHost},get uriScheme(){return ce.environment.appUriScheme},get clipboard(){return oi.value},get shell(){return ot.getDefaultShell(!1)},get isTelemetryEnabled(){return Le.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Le.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(ce.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,de){return Ge.openUri(X,{allowTunneling:!!ce.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===ce.environment.appUriScheme)return di.createAppUri(X);try{return await Ge.asExternalUri(X,{allowTunneling:!!ce.remote.authority})}catch(de){if((0,Ye.matchesScheme)(X,Et.Schemas.http)||(0,Ye.matchesScheme)(X,Et.Schemas.https))return X;throw de}},get remoteName(){return(0,Fe.getRemoteName)(ce.remote.authority)},get remoteAuthority(){return ce.remote.authority},get uiKind(){return ce.uiKind}};ce.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=ce.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,Ii={createTestController(X,de){return qt.createTestController(X,de)},createTestObserver(){return(0,q.checkProposedApiEnabled)(Re),qt.createTestObserver()},runTests(X){return(0,q.checkProposedApiEnabled)(Re),qt.runTests(X)},get onDidChangeTestResults(){return(0,q.checkProposedApiEnabled)(Re),qt.onResultsChanged},get testResults(){return(0,q.checkProposedApiEnabled)(Re),qt.results}},Pi={getExtension(X){const de=Tt.getExtensionDescription(X);if(de)return new r.Extension(Ie,Re.identifier,de,gi)},get all(){return Tt.getAllExtensionDescriptions().map(X=>new r.Extension(Ie,Re.identifier,X,gi))},get onDidChange(){return Tt.onDidChange}},li={createDiagnosticCollection(X){return Wt.createDiagnosticCollection(Re.identifier,X)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:X=>Wt.getDiagnostics(X),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(X,de){return Ht.changeLanguage(X.uri,de)},match(X,de){return(0,t.score)(Q.LanguageSelector.from(X),de.uri,de.languageId,!0)},registerCodeActionsProvider(X,de,ke){return ct.registerCodeActionProvider(Re,pt(X),de,ke)},registerCodeLensProvider(X,de){return ct.registerCodeLensProvider(Re,pt(X),de)},registerDefinitionProvider(X,de){return ct.registerDefinitionProvider(Re,pt(X),de)},registerDeclarationProvider(X,de){return ct.registerDeclarationProvider(Re,pt(X),de)},registerImplementationProvider(X,de){return ct.registerImplementationProvider(Re,pt(X),de)},registerTypeDefinitionProvider(X,de){return ct.registerTypeDefinitionProvider(Re,pt(X),de)},registerHoverProvider(X,de){return ct.registerHoverProvider(Re,pt(X),de,Re.identifier)},registerEvaluatableExpressionProvider(X,de){return ct.registerEvaluatableExpressionProvider(Re,pt(X),de,Re.identifier)},registerInlineValuesProvider(X,de){return ct.registerInlineValuesProvider(Re,pt(X),de,Re.identifier)},registerDocumentHighlightProvider(X,de){return ct.registerDocumentHighlightProvider(Re,pt(X),de)},registerLinkedEditingRangeProvider(X,de){return ct.registerLinkedEditingRangeProvider(Re,pt(X),de)},registerReferenceProvider(X,de){return ct.registerReferenceProvider(Re,pt(X),de)},registerRenameProvider(X,de){return ct.registerRenameProvider(Re,pt(X),de)},registerDocumentSymbolProvider(X,de,ke){return ct.registerDocumentSymbolProvider(Re,pt(X),de,ke)},registerWorkspaceSymbolProvider(X){return ct.registerWorkspaceSymbolProvider(Re,X)},registerDocumentFormattingEditProvider(X,de){return ct.registerDocumentFormattingEditProvider(Re,pt(X),de)},registerDocumentRangeFormattingEditProvider(X,de){return ct.registerDocumentRangeFormattingEditProvider(Re,pt(X),de)},registerOnTypeFormattingEditProvider(X,de,ke,...rt){return ct.registerOnTypeFormattingEditProvider(Re,pt(X),de,[ke].concat(rt))},registerDocumentSemanticTokensProvider(X,de,ke){return ct.registerDocumentSemanticTokensProvider(Re,pt(X),de,ke)},registerDocumentRangeSemanticTokensProvider(X,de,ke){return ct.registerDocumentRangeSemanticTokensProvider(Re,pt(X),de,ke)},registerSignatureHelpProvider(X,de,ke,...rt){return typeof ke=="object"?ct.registerSignatureHelpProvider(Re,pt(X),de,ke):ct.registerSignatureHelpProvider(Re,pt(X),de,typeof ke=="undefined"?[]:[ke,...rt])},registerCompletionItemProvider(X,de,...ke){return ct.registerCompletionItemProvider(Re,pt(X),de,ke)},registerInlineCompletionItemProvider(X,de){return(0,q.checkProposedApiEnabled)(Re),ct.registerInlineCompletionsProvider(Re,pt(X),de)},registerDocumentLinkProvider(X,de){return ct.registerDocumentLinkProvider(Re,pt(X),de)},registerColorProvider(X,de){return ct.registerColorProvider(Re,pt(X),de)},registerFoldingRangeProvider(X,de){return ct.registerFoldingRangeProvider(Re,pt(X),de)},registerSelectionRangeProvider(X,de){return ct.registerSelectionRangeProvider(Re,X,de)},registerCallHierarchyProvider(X,de){return ct.registerCallHierarchyProvider(Re,X,de)},setLanguageConfiguration:(X,de)=>ct.setLanguageConfiguration(Re,X,de),getTokenInformationAtPosition(X,de){return(0,q.checkProposedApiEnabled)(Re),Ht.tokenAtPosition(X,de)},registerInlayHintsProvider(X,de){return(0,q.checkProposedApiEnabled)(Re),ct.registerInlayHintsProvider(Re,X,de)},registerTypeHierarchyProvider(X,de){return(0,q.checkProposedApiEnabled)(Re),ct.registerTypeHierarchyProvider(Re,X,de)},createLanguageStatusItem(X,de){return(0,q.checkProposedApiEnabled)(Re),Ht.createLanguageStatusItem(Re,X,de)}},Ai={get activeTextEditor(){return It.getActiveTextEditor()},get visibleTextEditors(){return It.getVisibleTextEditors()},get activeTerminal(){return ot.activeTerminal},get terminals(){return ot.terminals},async showTextDocument(X,de,ke){const rt=await(F.URI.isUri(X)?Promise.resolve(pi.openTextDocument(X)):Promise.resolve(X));return It.showTextDocument(rt,de,ke)},createTextEditorDecorationType(X){return It.createTextEditorDecorationType(Re,X)},onDidChangeActiveTextEditor(X,de,ke){return It.onDidChangeActiveTextEditor(X,de,ke)},onDidChangeVisibleTextEditors(X,de,ke){return It.onDidChangeVisibleTextEditors(X,de,ke)},onDidChangeTextEditorSelection(X,de,ke){return It.onDidChangeTextEditorSelection(X,de,ke)},onDidChangeTextEditorOptions(X,de,ke){return It.onDidChangeTextEditorOptions(X,de,ke)},onDidChangeTextEditorVisibleRanges(X,de,ke){return It.onDidChangeTextEditorVisibleRanges(X,de,ke)},onDidChangeTextEditorViewColumn(X,de,ke){return It.onDidChangeTextEditorViewColumn(X,de,ke)},onDidCloseTerminal(X,de,ke){return ot.onDidCloseTerminal(X,de,ke)},onDidOpenTerminal(X,de,ke){return ot.onDidOpenTerminal(X,de,ke)},onDidChangeActiveTerminal(X,de,ke){return ot.onDidChangeActiveTerminal(X,de,ke)},onDidChangeTerminalDimensions(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),ot.onDidChangeTerminalDimensions(X,de,ke)},onDidChangeTerminalState(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),ot.onDidChangeTerminalState(X,de,ke)},onDidWriteTerminalData(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),ot.onDidWriteTerminalData(X,de,ke)},get state(){return Ge.state},onDidChangeWindowState(X,de,ke){return Ge.onDidChangeWindowState(X,de,ke)},showInformationMessage(X,...de){return ai.showMessage(Re,T.default.Info,X,de[0],de.slice(1))},showWarningMessage(X,...de){return ai.showMessage(Re,T.default.Warning,X,de[0],de.slice(1))},showErrorMessage(X,...de){return ai.showMessage(Re,T.default.Error,X,de[0],de.slice(1))},showQuickPick(X,de,ke){return xt.showQuickPick(X,!!Re.enableProposedApi,de,ke)},showWorkspaceFolderPick(X){return xt.showWorkspaceFolderPick(X)},showInputBox(X,de){return xt.showInput(X,de)},showOpenDialog(X){return zt.showOpenDialog(X)},showSaveDialog(X){return zt.showSaveDialog(X)},createStatusBarItem(X,de,ke){let rt,wt,Dt;return typeof X=="string"?(rt=X,wt=de,Dt=ke):(wt=X,Dt=de),Mt.createStatusBarEntry(Re,rt,wt,Dt)},setStatusBarMessage(X,de){return Mt.setStatusBarMessage(X,de)},withScmProgress(X){return Se.report("window.withScmProgress",Re,"Use 'withProgress' instead."),hi.withProgress(Re,{location:W.ProgressLocation.SourceControl},(de,ke)=>X({report(rt){}}))},withProgress(X,de){return hi.withProgress(Re,X,de)},createOutputChannel(X){return Ot.createOutputChannel(X,Re)},createWebviewPanel(X,de,ke,rt){return si.createWebviewPanel(Re,X,de,ke,rt)},createWebviewTextEditorInset(X,de,ke,rt){return(0,q.checkProposedApiEnabled)(Re),wi.createWebviewEditorInset(X,de,ke,rt,Re)},createTerminal(X,de,ke){return typeof X=="object"?("location"in X&&(0,q.checkProposedApiEnabled)(Re),"pty"in X?ot.createExtensionTerminal(X):ot.createTerminalFromOptions(X)):ot.createTerminal(X,de,ke)},registerTerminalLinkProvider(X){return ot.registerLinkProvider(X)},registerTerminalProfileProvider(X,de){return ot.registerProfileProvider(Re,X,de)},registerTreeDataProvider(X,de){return Qt.registerTreeDataProvider(X,de,Re)},createTreeView(X,de){return Qt.createTreeView(X,de,Re)},registerWebviewPanelSerializer:(X,de)=>si.registerWebviewPanelSerializer(Re,X,de),registerCustomEditorProvider:(X,de,ke={})=>_i.registerCustomEditorProvider(Re,X,de,ke),registerFileDecorationProvider(X){return mt.registerFileDecorationProvider(X,Re.identifier)},registerUriHandler(X){return di.registerUriHandler(Re.identifier,X)},createQuickPick(){return xt.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return xt.createInputBox(Re.identifier)},get activeColorTheme(){return fi.activeColorTheme},onDidChangeActiveColorTheme(X,de,ke){return fi.onDidChangeActiveColorTheme(X,de,ke)},registerWebviewViewProvider(X,de,ke){return yi.registerWebviewViewProvider(Re,X,de,ke?.webviewOptions)},get activeNotebookEditor(){return(0,q.checkProposedApiEnabled)(Re),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeActiveNotebookEditor(X,de,ke)},get visibleNotebookEditors(){return(0,q.checkProposedApiEnabled)(Re),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),Vt.onDidChangeNotebookEditorSelection(X,de,ke)},onDidChangeNotebookEditorVisibleRanges(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),Vt.onDidChangeNotebookEditorVisibleRanges(X,de,ke)},showNotebookDocument(X,de){return(0,q.checkProposedApiEnabled)(Re),gt.showNotebookDocument(X,de)},registerExternalUriOpener(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),Jt.registerExternalUriOpener(Re.identifier,X,de,ke)},get tabs(){return(0,q.checkProposedApiEnabled)(Re),it.tabs},get activeTab(){return(0,q.checkProposedApiEnabled)(Re),it.activeTab},get onDidChangeTabs(){return(0,q.checkProposedApiEnabled)(Re),it.onDidChangeTabs},get onDidChangeActiveTab(){return(0,q.checkProposedApiEnabled)(Re),it.onDidChangeActiveTab},getInlineCompletionItemController(X){return(0,q.checkProposedApiEnabled)(Re),d.InlineCompletionController.get(X)}},pi={get rootPath(){return Se.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Be.getPath()},set rootPath(X){throw M.readonly()},getWorkspaceFolder(X){return Be.getWorkspaceFolder(X)},get workspaceFolders(){return Be.getWorkspaceFolders()},get name(){return Be.name},set name(X){throw M.readonly()},get workspaceFile(){return Be.workspaceFile},set workspaceFile(X){throw M.readonly()},updateWorkspaceFolders:(X,de,...ke)=>Be.updateWorkspaceFolders(Re,X,de||0,...ke),onDidChangeWorkspaceFolders:function(X,de,ke){return Be.onDidChangeWorkspace(X,de,ke)},asRelativePath:(X,de)=>Be.getRelativePath(X,de),findFiles:(X,de,ke,rt)=>Be.findFiles(Q.GlobPattern.from(X),Q.GlobPattern.from(de),ke,Re.identifier,rt),findTextInFiles:(X,de,ke,rt)=>{let wt,Dt;return typeof de=="object"?(wt=de,Dt=ke):(wt={},Dt=de,rt=ke),Be.findTextInFiles(X,wt||{},Dt,Re.identifier,rt)},saveAll:X=>Be.saveAll(X),applyEdit(X){return Di.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,de,ke,rt)=>Nt.createFileSystemWatcher(Q.GlobPattern.from(X),de,ke,rt),get textDocuments(){return kt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw M.readonly()},openTextDocument(X){let de;const ke=X;if(typeof X=="string")de=Promise.resolve(F.URI.file(X));else if(F.URI.isUri(X))de=Promise.resolve(X);else if(!ke||typeof ke=="object")de=kt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(rt=>kt.ensureDocumentData(rt).then(wt=>wt.document))},onDidOpenTextDocument:(X,de,ke)=>kt.onDidAddDocument(X,de,ke),onDidCloseTextDocument:(X,de,ke)=>kt.onDidRemoveDocument(X,de,ke),onDidChangeTextDocument:(X,de,ke)=>kt.onDidChangeDocument(X,de,ke),onDidSaveTextDocument:(X,de,ke)=>kt.onDidSaveDocument(X,de,ke),onWillSaveTextDocument:(X,de,ke)=>Zt.getOnWillSaveTextDocumentEvent(Re)(X,de,ke),get notebookDocuments(){return gt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,de){let ke;if(F.URI.isUri(X))ke=X,await gt.openNotebookDocument(X);else if(typeof X=="string")ke=F.URI.revive(await gt.createNotebookDocument({viewType:X,content:de}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(X,de,ke,rt){return gt.registerNotebookSerializer(Re,X,de,ke,Re.enableProposedApi?rt:void 0)},registerNotebookContentProvider:(X,de,ke,rt)=>((0,q.checkProposedApiEnabled)(Re),gt.registerNotebookContentProvider(Re,X,de,ke,Re.enableProposedApi?rt:void 0)),onDidChangeConfiguration:(X,de,ke)=>Gt.onDidChangeConfiguration(X,de,ke),getConfiguration(X,de){return de=arguments.length===1?void 0:de,Gt.getConfiguration(X,de,Re)},registerTextDocumentContentProvider(X,de){return $t.registerTextDocumentContentProvider(X,de)},registerTaskProvider:(X,de)=>(Se.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(Re,X,de)),registerFileSystemProvider(X,de,ke){return ii.registerFileSystemProvider(Re.identifier,X,de,ke)},get fs(){return me.value},registerFileSearchProvider:(X,de)=>((0,q.checkProposedApiEnabled)(Re),Rt.registerFileSearchProvider(X,de)),registerTextSearchProvider:(X,de)=>((0,q.checkProposedApiEnabled)(Re),Rt.registerTextSearchProvider(X,de)),registerRemoteAuthorityResolver:(X,de)=>((0,q.checkProposedApiEnabled)(Re),Ie.registerRemoteAuthorityResolver(X,de)),registerResourceLabelFormatter:X=>((0,q.checkProposedApiEnabled)(Re),Ei.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,de,ke)=>Nt.onDidCreateFile(X,de,ke),onDidDeleteFiles:(X,de,ke)=>Nt.onDidDeleteFile(X,de,ke),onDidRenameFiles:(X,de,ke)=>Nt.onDidRenameFile(X,de,ke),onWillCreateFiles:(X,de,ke)=>Nt.getOnWillCreateFileEvent(Re)(X,de,ke),onWillDeleteFiles:(X,de,ke)=>Nt.getOnWillDeleteFileEvent(Re)(X,de,ke),onWillRenameFiles:(X,de,ke)=>Nt.getOnWillRenameFileEvent(Re)(X,de,ke),openTunnel:X=>((0,q.checkProposedApiEnabled)(Re),Ce.openTunnel(Re,X).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,q.checkProposedApiEnabled)(Re),Ce.getTunnels()},onDidChangeTunnels:(X,de,ke)=>((0,q.checkProposedApiEnabled)(Re),Ce.onDidChangeTunnels(X,de,ke)),registerPortAttributesProvider:(X,de)=>((0,q.checkProposedApiEnabled)(Re),Ce.registerPortsAttributesProvider(X,de)),registerTimelineProvider:(X,de)=>((0,q.checkProposedApiEnabled)(Re),ri.registerTimelineProvider(X,de,Re.identifier,nt.converter)),get isTrusted(){return Be.trusted},requestWorkspaceTrust:X=>((0,q.checkProposedApiEnabled)(Re),Be.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,de,ke)=>Be.onDidGrantWorkspaceTrust(X,de,ke)},Ti={get inputBox(){return Se.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Re)},createSourceControl(X,de,ke){return Yt.createSourceControl(Re,X,de,ke)}},Ri={createCommentController(X,de){return bi.createCommentController(Re,X,de)}},Fi={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(X,de,ke){return lt.onDidStartDebugSession(X,de,ke)},onDidTerminateDebugSession(X,de,ke){return lt.onDidTerminateDebugSession(X,de,ke)},onDidChangeActiveDebugSession(X,de,ke){return lt.onDidChangeActiveDebugSession(X,de,ke)},onDidReceiveDebugSessionCustomEvent(X,de,ke){return lt.onDidReceiveDebugSessionCustomEvent(X,de,ke)},onDidChangeBreakpoints(X,de,ke){return lt.onDidChangeBreakpoints(X,de,ke)},registerDebugConfigurationProvider(X,de,ke){return lt.registerDebugConfigurationProvider(X,de,ke||W.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,de){return lt.registerDebugAdapterDescriptorFactory(Re,X,de)},registerDebugAdapterTrackerFactory(X,de){return lt.registerDebugAdapterTrackerFactory(X,de)},startDebugging(X,de,ke){return!ke||typeof ke=="object"&&"configuration"in ke?lt.startDebugging(X,de,{parentSession:ke}):lt.startDebugging(X,de,ke||{})},stopDebugging(X){return lt.stopDebugging(X)},addBreakpoints(X){return lt.addBreakpoints(X)},removeBreakpoints(X){return lt.removeBreakpoints(X)},asDebugSourceUri(X,de){return lt.asDebugSourceUri(X,de)}},Mi={registerTaskProvider:(X,de)=>_t.registerTaskProvider(Re,X,de),fetchTasks:X=>_t.fetchTasks(X),executeTask:X=>_t.executeTask(Re,X),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(X,de,ke)=>_t.onDidStartTask(X,de,ke),onDidEndTask:(X,de,ke)=>_t.onDidEndTask(X,de,ke),onDidStartTaskProcess:(X,de,ke)=>_t.onDidStartTaskProcess(X,de,ke),onDidEndTaskProcess:(X,de,ke)=>_t.onDidEndTaskProcess(X,de,ke)},Li={createNotebookController(X,de,ke,rt,wt){return ei.createNotebookController(Re,X,de,ke,rt,Re.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(X,de)=>gt.registerNotebookCellStatusBarItemProvider(Re,X,de),get onDidSaveNotebookDocument(){return(0,q.checkProposedApiEnabled)(Re),Kt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,q.checkProposedApiEnabled)(Re),Vt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return ti.createRendererMessaging(Re,X)},onDidChangeNotebookDocumentMetadata(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),Kt.onDidChangeNotebookDocumentMetadata(X,de,ke)},onDidChangeNotebookCells(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeNotebookCells(X,de,ke)},onDidChangeNotebookCellExecutionState(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeNotebookCellExecutionState(X,de,ke)},onDidChangeCellOutputs(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeCellOutputs(X,de,ke)},onDidChangeCellMetadata(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeCellMetadata(X,de,ke)},createConcatTextDocument(X,de){return(0,q.checkProposedApiEnabled)(Re),new $e.ExtHostNotebookConcatDocument(gt,kt,X,de)}};return{version:ce.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:li,notebooks:Li,scm:Ti,tasks:Mi,tests:Ii,window:Ai,workspace:pi,Breakpoint:W.Breakpoint,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:h.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:W.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:b.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,InlineCompletionItem:W.InlineSuggestion,InlineCompletionList:W.InlineSuggestions,Hover:W.Hover,IndentAction:P.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.TerminalLink,TerminalLocation:W.TerminalLocation,TerminalProfile:W.TerminalProfile,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.TypeHierarchyItem,UIKind:n.UIKind,Uri:F.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,InlayHint:W.InlayHint,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookRange:W.NotebookRange,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookRendererScript:W.NotebookRendererScript,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,NotebookCellStatusBarItem:W.NotebookCellStatusBarItem,NotebookControllerAffinity:W.NotebookControllerAffinity,PortAttributes:W.PortAttributes,LinkedEditingRanges:W.LinkedEditingRanges,TestResultState:W.TestResultState,TestRunRequest:W.TestRunRequest,TestMessage:W.TestMessage,TestTag:W.TestTag,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:bt.TextSearchCompleteMessageType,CoveredCount:W.CoveredCount,FileCoverage:W.FileCoverage,StatementCoverage:W.StatementCoverage,BranchCoverage:W.BranchCoverage,FunctionCoverage:W.FunctionCoverage,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=De}),define(be[224],Ee([0,1,57,96,31,95,32,48,49,38,99,100,101,72,64,70,97,71,37,69,87,68]),function(ie,e,h,M,b,T,F,C,_,P,t,E,n,f,l,s,v,I,y,a,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(s.IExtHostApiDeprecationService,s.ExtHostApiDeprecationService),(0,h.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,h.registerSingleton)(F.IExtHostConfiguration,F.ExtHostConfiguration),(0,h.registerSingleton)(I.IExtHostConsumerFileSystem,I.ExtHostConsumerFileSystem),(0,h.registerSingleton)(E.IExtHostDebugService,E.WorkerExtHostDebugService),(0,h.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,h.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,h.registerSingleton)(y.IExtHostFileSystemInfo,y.ExtHostFileSystemInfo),(0,h.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,h.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,h.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,h.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,h.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,h.registerSingleton)(l.IExtHostTunnelService,l.ExtHostTunnelService),(0,h.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,h.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace),(0,h.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,h.registerSingleton)(m.IExtHostTelemetry,m.ExtHostTelemetry),(0,h.registerSingleton)(k.IExtHostEditorTabs,k.ExtHostEditorTabs)}),define(be[225],Ee([0,1,223,33,219,7,14,5,11]),function(ie,e,h,M,b,T,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var P;(function(l){const s=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(I,...y)=>{y.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const a=y.slice(0,-1).join(","),m=y.pop().toString();return`(function anonymous(${a}) {
${m}
})`}});function v(...I){return s?self.eval(s.createScript("",...I)):new Function(...I)}l.create=v})(P||(P={}));class t extends b.RequireInterceptor{_installInterceptor(){}getModule(s,v){for(let I of this._alternatives){let y=I(s);if(y){s=y;break}}if(this._factories.has(s))return this._factories.get(s).load(s,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class E extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const s=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);f(s,this._initData.environment.isExtensionDevelopmentDebug);const v=this._instaService.invokeFunction(h.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,v,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(s){return s.browser}async _loadCommonJSModule(s,v,I){v=v.with({path:n(v.path,".js")}),s&&performance.mark(`code/extHost/willFetchExtensionCode/${s.value}`);const y=await fetch(_.FileAccess.asBrowserUri(v).toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s.value}`),y.status!==200)throw new Error(y.statusText);const a=await y.text(),m=`${v.toString(!0)}#vscode-extension`,k=`${a}
//# sourceURL=${m}`;let i;try{i=P.create(E._ttpExtensionScripts?.createScript("module")??"module",E._ttpExtensionScripts?.createScript("exports")??"exports",E._ttpExtensionScripts?.createScript("require")??"require",E._ttpExtensionScripts?.createScript(k)??k)}catch(w){throw console.error(s?`Loading code for extension ${s.value} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${v.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}const u={},r={exports:u},o=w=>{const d=this._fakeModules.getModule(w,v);if(d===void 0)throw new Error(`Cannot load module '${w}'`);return d};try{return I.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s.value}`),i(r,u,o),r.exports!==u?r.exports:u}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s.value}`),I.codeLoadingStop()}}async $setRemoteEnvironment(s){}async _waitForDebuggerAttachment(s=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+s;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,F.timeout)(10)}}e.ExtHostExtensionService=E,E._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:l=>l});function n(l,s){return l.endsWith(s)?l:l+s}function f(l,s){v("info","log"),v("log","log"),v("warn","warn"),v("error","error");function v(a,m){const k=console[a];console[a]=function(){l.$logExtensionHostMessage({type:"__$console",severity:m,arguments:y(arguments)}),s&&k.apply(console,arguments)}}const I=1e5;function y(a){const m=[],k=[];if(a.length)for(let i=0;i<a.length;i++){if(typeof a[i]=="undefined")a[i]="undefined";else if(a[i]instanceof Error){const u=a[i];u.stack?a[i]=u.stack:a[i]=u.toString()}k.push(a[i])}try{const i=JSON.stringify(k,function(u,r){if(r&&typeof r=="object"){if(m.indexOf(r)!==-1)return"[Circular]";m.push(r)}return r});return i.length>I?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(be[226],Ee([0,1,57,15,33,73,225,212]),function(ie,e,h,M,b,T,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(b.IExtHostExtensionService,F.ExtHostExtensionService),(0,h.registerSingleton)(M.ILogService,C.ExtHostLogService),(0,h.registerSingleton)(T.IExtensionStoragePaths,T.ExtensionStoragePaths)}),define(be[236],Ee([0,1,23,3,178,220,214,17,74,11,2,224,226]),function(ie,e,h,M,b,T,F,C,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const f=fetch.bind(self);if(self.fetch=function(a,m){return a instanceof Request||/^file:/i.test(String(a))&&(a=P.FileAccess.asBrowserUri(t.URI.parse(String(a))).toString(!0)),f(a,m)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,m,k,i,u){return/^file:/i.test(m.toString())&&(m=P.FileAccess.asBrowserUri(t.URI.parse(m.toString())).toString(!0)),super.open(a,m,k??!0,i,u)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const a=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:k=>k}),m=self.Worker;Worker=function(k,i){/^file:/i.test(k.toString())&&(k=P.FileAccess.asBrowserUri(t.URI.parse(k.toString())).toString(!0));const r=`(${function(g){function S(c){return typeof c=="string"||c instanceof URL?String(c).replace(/^file:\/\//i,"vscode-file://vscode-app"):c}const R=fetch.bind(self);self.fetch=function(c,A){return c instanceof Request?R(c,A):R(S(c),A)},self.XMLHttpRequest=class extends XMLHttpRequest{open(c,A,O,z,K){return super.open(c,S(A),O??!0,z,K)}};const p=importScripts.bind(self);self.importScripts=(...c)=>{p(...c.map(S))};const D=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:c=>c}):void 0;p(D?D.createScriptURL(g):g)}.toString()}('${k}'))`;i=i||{},i.name=i.name||C.basename(k.toString());const o=new Blob([r],{type:"application/javascript"}),w=URL.createObjectURL(o);return new m(a?a.createScriptURL(w):w,i)}}else self.Worker=class extends F.NestedWorker{constructor(a,m){super(n,a,{name:C.basename(a.toString()),...m})}};const l=new class{exit(a){E()}async exists(a){return!0}async realpath(a){return a}};class s{constructor(){const m=new MessageChannel,k=new M.Emitter;let i=!1;n(m.port2,[m.port2]),m.port1.onmessage=u=>{const{data:r}=u;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const o=h.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,b.isMessageOfType)(o,2)){i=!0,I("received terminate message from renderer");return}k.fire(o)},this.protocol={onMessage:k.event,send:u=>{if(!i){const r=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);m.port1.postMessage(r,[r])}}}}}function v(a){return new Promise(m=>{const k=a.onMessage(i=>{k.dispose();const u=JSON.parse(i.toString());a.send((0,b.createMessageOfType)(0)),m({protocol:a,initData:u})});a.send((0,b.createMessageOfType)(1))})}let I=a=>E();function y(){const a=new s;_.mark("code/extHost/willConnectToRenderer"),v(a.protocol).then(m=>{_.mark("code/extHost/didWaitForInitData");const k=new T.ExtensionHostMain(m.protocol,m.initData,l,null);I=i=>k.terminate(i)})}e.create=y})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ec40cbe164c59f3d13b6eff5fc7b0231ec0ab7aa/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
